#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 5231
#define SYMBOL_COUNT 298
#define ALIAS_COUNT 8
#define TOKEN_COUNT 140
#define EXTERNAL_TOKEN_COUNT 2
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_in = 25,
  anon_sym_await = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  anon_sym_DOT = 48,
  anon_sym_class = 49,
  anon_sym_async = 50,
  anon_sym_function = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_new = 53,
  anon_sym_PLUS_EQ = 54,
  anon_sym_DASH_EQ = 55,
  anon_sym_STAR_EQ = 56,
  anon_sym_SLASH_EQ = 57,
  anon_sym_PERCENT_EQ = 58,
  anon_sym_CARET_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PIPE_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_GT_GT_GT_EQ = 63,
  anon_sym_LT_LT_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_DOT_DOT_DOT = 66,
  anon_sym_QMARK = 67,
  anon_sym_AMP_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_GT_GT = 70,
  anon_sym_GT_GT_GT = 71,
  anon_sym_LT_LT = 72,
  anon_sym_AMP = 73,
  anon_sym_CARET = 74,
  anon_sym_PIPE = 75,
  anon_sym_PLUS = 76,
  anon_sym_DASH = 77,
  anon_sym_PERCENT = 78,
  anon_sym_STAR_STAR = 79,
  anon_sym_LT_EQ = 80,
  anon_sym_EQ_EQ = 81,
  anon_sym_EQ_EQ_EQ = 82,
  anon_sym_BANG_EQ = 83,
  anon_sym_BANG_EQ_EQ = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_instanceof = 86,
  anon_sym_BANG = 87,
  anon_sym_TILDE = 88,
  anon_sym_void = 89,
  anon_sym_delete = 90,
  anon_sym_PLUS_PLUS = 91,
  anon_sym_DASH_DASH = 92,
  anon_sym_DQUOTE = 93,
  aux_sym_string_token1 = 94,
  anon_sym_SQUOTE = 95,
  aux_sym_string_token2 = 96,
  sym_escape_sequence = 97,
  sym_comment = 98,
  anon_sym_BQUOTE = 99,
  anon_sym_DOLLAR_LBRACE = 100,
  anon_sym_SLASH2 = 101,
  sym_regex_pattern = 102,
  sym_regex_flags = 103,
  sym_number = 104,
  anon_sym_target = 105,
  anon_sym_this = 106,
  sym_super = 107,
  sym_true = 108,
  sym_false = 109,
  sym_null = 110,
  sym_undefined = 111,
  anon_sym_AT = 112,
  anon_sym_static = 113,
  anon_sym_abstract = 114,
  anon_sym_get = 115,
  anon_sym_set = 116,
  anon_sym_declare = 117,
  anon_sym_public = 118,
  anon_sym_private = 119,
  anon_sym_protected = 120,
  anon_sym_module = 121,
  anon_sym_any = 122,
  anon_sym_number = 123,
  anon_sym_boolean = 124,
  anon_sym_string = 125,
  anon_sym_symbol = 126,
  anon_sym_require = 127,
  anon_sym_implements = 128,
  anon_sym_global = 129,
  anon_sym_interface = 130,
  anon_sym_extends = 131,
  anon_sym_enum = 132,
  sym_readonly = 133,
  anon_sym_is = 134,
  anon_sym_keyof = 135,
  anon_sym_LBRACE_PIPE = 136,
  anon_sym_PIPE_RBRACE = 137,
  sym__automatic_semicolon = 138,
  sym__template_chars = 139,
  sym_program = 140,
  sym_export_statement = 141,
  sym_export_clause = 142,
  sym__import_export_specifier = 143,
  sym__declaration = 144,
  sym_import_statement = 145,
  sym_import_clause = 146,
  sym__from_clause = 147,
  sym_namespace_import = 148,
  sym_named_imports = 149,
  sym_expression_statement = 150,
  sym_variable_declaration = 151,
  sym_lexical_declaration = 152,
  sym_variable_declarator = 153,
  sym_statement_block = 154,
  sym_if_statement = 155,
  sym_switch_statement = 156,
  sym_for_statement = 157,
  sym_for_in_statement = 158,
  sym_for_of_statement = 159,
  sym_while_statement = 160,
  sym_do_statement = 161,
  sym_try_statement = 162,
  sym_with_statement = 163,
  sym_break_statement = 164,
  sym_continue_statement = 165,
  sym_debugger_statement = 166,
  sym_return_statement = 167,
  sym_throw_statement = 168,
  sym_empty_statement = 169,
  sym_labeled_statement = 170,
  sym_switch_body = 171,
  sym_switch_case = 172,
  sym_switch_default = 173,
  sym_catch_clause = 174,
  sym_finally_clause = 175,
  sym_parenthesized_expression = 176,
  sym__expression = 177,
  sym_yield_expression = 178,
  sym_object = 179,
  sym_assignment_pattern = 180,
  sym_array = 181,
  sym_nested_identifier = 182,
  sym_anonymous_class = 183,
  sym_class = 184,
  sym_class_heritage = 185,
  sym_function = 186,
  sym_arrow_function = 187,
  sym_generator_function = 188,
  sym_call_expression = 189,
  sym_new_expression = 190,
  sym_await_expression = 191,
  sym_member_expression = 192,
  sym_subscript_expression = 193,
  sym_assignment_expression = 194,
  sym_augmented_assignment_expression = 195,
  sym__initializer = 196,
  sym_spread_element = 197,
  sym_ternary_expression = 198,
  sym_binary_expression = 199,
  sym_unary_expression = 200,
  sym_update_expression = 201,
  sym_sequence_expression = 202,
  sym_string = 203,
  sym_template_string = 204,
  sym_template_substitution = 205,
  sym_regex = 206,
  sym_meta_property = 207,
  sym_this = 208,
  sym_arguments = 209,
  sym_decorator = 210,
  sym__identifier_reference = 211,
  sym_decorator_member_expression = 212,
  sym_decorator_call_expression = 213,
  sym_class_body = 214,
  sym_public_field_definition = 215,
  sym_formal_parameters = 216,
  sym_rest_parameter = 217,
  sym_method_definition = 218,
  sym_pair = 219,
  sym__property_name = 220,
  sym_computed_property_name = 221,
  sym_non_null_expression = 222,
  sym_method_signature = 223,
  sym_abstract_method_signature = 224,
  sym_function_signature = 225,
  sym_type_assertion = 226,
  sym_as_expression = 227,
  sym_import_require_clause = 228,
  sym_implements_clause = 229,
  sym_ambient_declaration = 230,
  sym_abstract_class = 231,
  sym_module = 232,
  sym_internal_module = 233,
  sym__module = 234,
  sym_import_alias = 235,
  sym_nested_type_identifier = 236,
  sym_interface_declaration = 237,
  sym__type_reference = 238,
  sym_extends_clause = 239,
  sym_enum_declaration = 240,
  sym_enum_body = 241,
  sym__enum_member = 242,
  sym_enum_assignment = 243,
  sym_type_alias_declaration = 244,
  sym_accessibility_modifier = 245,
  sym_required_parameter = 246,
  sym_optional_parameter = 247,
  sym_type_annotation = 248,
  sym__type = 249,
  sym_constructor_type = 250,
  sym__primary_type = 251,
  sym_generic_type = 252,
  sym_type_predicate = 253,
  sym_type_query = 254,
  sym_index_type_query = 255,
  sym_lookup_type = 256,
  sym_mapped_type = 257,
  sym_literal_type = 258,
  sym__number = 259,
  sym_existential_type = 260,
  sym_this_type = 261,
  sym_flow_maybe_type = 262,
  sym_parenthesized_type = 263,
  sym_predefined_type = 264,
  sym_type_arguments = 265,
  sym_object_type = 266,
  sym_property_signature = 267,
  sym_call_signature = 268,
  sym_type_parameters = 269,
  sym_type_parameter = 270,
  sym_default_type = 271,
  sym_constraint = 272,
  sym_construct_signature = 273,
  sym_index_signature = 274,
  sym_array_type = 275,
  sym_tuple_type = 276,
  sym_union_type = 277,
  sym_intersection_type = 278,
  sym_function_type = 279,
  aux_sym_program_repeat1 = 280,
  aux_sym_export_statement_repeat1 = 281,
  aux_sym_export_clause_repeat1 = 282,
  aux_sym_named_imports_repeat1 = 283,
  aux_sym_variable_declaration_repeat1 = 284,
  aux_sym_switch_body_repeat1 = 285,
  aux_sym_object_repeat1 = 286,
  aux_sym_array_repeat1 = 287,
  aux_sym_string_repeat1 = 288,
  aux_sym_string_repeat2 = 289,
  aux_sym_template_string_repeat1 = 290,
  aux_sym_class_body_repeat1 = 291,
  aux_sym_formal_parameters_repeat1 = 292,
  aux_sym_implements_clause_repeat1 = 293,
  aux_sym_extends_clause_repeat1 = 294,
  aux_sym_enum_body_repeat1 = 295,
  aux_sym_object_type_repeat1 = 296,
  aux_sym_type_parameters_repeat1 = 297,
  alias_sym_type_identifier = 298,
  alias_sym_array_pattern = 299,
  alias_sym_shorthand_property_identifier = 300,
  alias_sym_property_identifier = 301,
  alias_sym_object_pattern = 302,
  alias_sym_import_specifier = 303,
  alias_sym_export_specifier = 304,
  alias_sym_statement_identifier = 305,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_in] = "in",
  [anon_sym_await] = "await",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [anon_sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym_for_of_statement] = "for_of_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_nested_identifier] = "nested_identifier",
  [sym_anonymous_class] = "anonymous_class",
  [sym_class] = "class",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_arrow_function] = "arrow_function",
  [sym_generator_function] = "generator_function",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_this] = "this",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym__identifier_reference] = "_identifier_reference",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class] = "abstract_class",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym__type_reference] = "_type_reference",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym__enum_member] = "_enum_member",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type] = "mapped_type",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_this_type] = "this_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_property_signature] = "property_signature",
  [sym_call_signature] = "call_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_statement_identifier] = "statement_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_of_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_reference] = {
    .visible = false,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__type_reference] = {
    .visible = false,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_member] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[27][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = alias_sym_property_identifier,
  },
  [3] = {
    [0] = alias_sym_object_pattern,
  },
  [4] = {
    [0] = alias_sym_array_pattern,
  },
  [5] = {
    [0] = alias_sym_type_identifier,
  },
  [6] = {
    [1] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_statement_identifier,
  },
  [8] = {
    [2] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [10] = {
    [1] = alias_sym_statement_identifier,
  },
  [11] = {
    [1] = alias_sym_type_identifier,
  },
  [12] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [13] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [14] = {
    [1] = alias_sym_array_pattern,
  },
  [15] = {
    [1] = alias_sym_object_pattern,
  },
  [16] = {
    [2] = alias_sym_type_identifier,
  },
  [17] = {
    [1] = alias_sym_import_specifier,
  },
  [18] = {
    [2] = sym_identifier,
  },
  [19] = {
    [2] = alias_sym_array_pattern,
  },
  [20] = {
    [2] = alias_sym_object_pattern,
  },
  [21] = {
    [1] = alias_sym_export_specifier,
  },
  [22] = {
    [3] = alias_sym_property_identifier,
  },
  [23] = {
    [3] = alias_sym_array_pattern,
  },
  [24] = {
    [3] = alias_sym_object_pattern,
  },
  [25] = {
    [4] = alias_sym_array_pattern,
  },
  [26] = {
    [4] = alias_sym_object_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(16);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(34);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0)
        ADVANCE(36);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(37);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      if (lookahead == '!')
        ADVANCE(38);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '{')
        ADVANCE(39);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(36);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(40);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(41);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(43);
      if (lookahead == '=')
        ADVANCE(44);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(45);
      if (lookahead == '=')
        ADVANCE(46);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(48);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.')
        ADVANCE(50);
      if (lookahead == '0')
        ADVANCE(53);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(54);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(55);
      if (lookahead == 'O' ||
          lookahead == 'o')
        ADVANCE(56);
      if (lookahead == 'X' ||
          lookahead == 'x')
        ADVANCE(57);
      if (lookahead == 'n')
        ADVANCE(58);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(61);
      if (lookahead == '>')
        ADVANCE(62);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(64);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 26:
      if (lookahead == 'u')
        ADVANCE(65);
      if (lookahead == 'x')
        ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(67);
      if (lookahead != 0)
        ADVANCE(68);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(69);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|')
        ADVANCE(70);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '}')
        ADVANCE(73);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 34:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(34);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\\')
        ADVANCE(36);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.')
        ADVANCE(50);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(55);
      if (lookahead == 'n')
        ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(36);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=')
        ADVANCE(75);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(38);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=')
        ADVANCE(76);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 49:
      if (lookahead == '.')
        ADVANCE(77);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 51:
      if (lookahead == '*')
        ADVANCE(78);
      if (lookahead != 0)
        ADVANCE(51);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(52);
      END_STATE();
    case 53:
      if (lookahead == 'n')
        ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(53);
      END_STATE();
    case 54:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(79);
      END_STATE();
    case 55:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(82);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(83);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(84);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=')
        ADVANCE(85);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(86);
      if (lookahead == '>')
        ADVANCE(87);
      END_STATE();
    case 65:
      if (lookahead == '{')
        ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(89);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(90);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(91);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 78:
      if (lookahead == '*')
        ADVANCE(78);
      if (lookahead == '/')
        ADVANCE(92);
      if (lookahead != 0)
        ADVANCE(51);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(79);
      END_STATE();
    case 80:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(82);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=')
        ADVANCE(93);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(94);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(66);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(68);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(68);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 94:
      if (lookahead == '}')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(94);
      END_STATE();
    case 95:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(99);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(95);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(45);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(47);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 102:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(102);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != ')' &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      if (lookahead == '=')
        ADVANCE(105);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 106:
      if (lookahead == '$')
        ADVANCE(107);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(109);
      END_STATE();
    case 107:
      if (lookahead == '{')
        ADVANCE(39);
      END_STATE();
    case 108:
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      END_STATE();
    case 109:
      if (lookahead == '$')
        ADVANCE(107);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(109);
      END_STATE();
    case 110:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(110);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(41);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(118);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(119);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(120);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(72);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>')
        ADVANCE(121);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 122:
      if (lookahead == '\n')
        SKIP(123);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '/')
        ADVANCE(124);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(125);
      if (lookahead != 0)
        ADVANCE(126);
      END_STATE();
    case 123:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '/')
        ADVANCE(126);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(126);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(125);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(126);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*')
        ADVANCE(128);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*')
        ADVANCE(128);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(127);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(126);
      END_STATE();
    case 130:
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(130);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 134:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(136);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(134);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '%' &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>')
        ADVANCE(62);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 137:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(138);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(137);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}')
        ADVANCE(73);
      END_STATE();
    case 139:
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(139);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 140:
      if (lookahead == '\n')
        SKIP(141);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '/')
        ADVANCE(142);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(143);
      if (lookahead != 0)
        ADVANCE(144);
      END_STATE();
    case 141:
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(141);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*')
        ADVANCE(145);
      if (lookahead == '/')
        ADVANCE(144);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(144);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(143);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(144);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*')
        ADVANCE(146);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(145);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*')
        ADVANCE(146);
      if (lookahead == '/')
        ADVANCE(147);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(145);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(144);
      END_STATE();
    case 148:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(149);
      if (lookahead == '-')
        ADVANCE(150);
      if (lookahead == '.')
        ADVANCE(151);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(148);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 151:
      if (lookahead == '.')
        ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 152:
      if (lookahead == '\n')
        SKIP(153);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '[')
        ADVANCE(154);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(156);
      if (lookahead != 0)
        ADVANCE(157);
      END_STATE();
    case 153:
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(153);
      END_STATE();
    case 154:
      if (lookahead == '\\')
        ADVANCE(158);
      if (lookahead == ']')
        ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(154);
      END_STATE();
    case 155:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(157);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '[')
        ADVANCE(154);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[')
        ADVANCE(154);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/')
        ADVANCE(157);
      END_STATE();
    case 158:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(154);
      END_STATE();
    case 159:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(160);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(161);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(159);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ':' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '}')
        ADVANCE(73);
      END_STATE();
    case 162:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(163);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(161);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(162);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 163:
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 164:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(165);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(164);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(72);
      END_STATE();
    case 166:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(166);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 168:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(160);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(168);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 169:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(165);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(169);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 170:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(170);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 171:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(136);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(171);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '*' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 172:
      if (lookahead == '/')
        ADVANCE(16);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(153);
      END_STATE();
    case 173:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(160);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '|')
        ADVANCE(165);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(173);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 174:
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(175);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(138);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(174);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 176:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(149);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(150);
      if (lookahead == '.')
        ADVANCE(99);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '>')
        ADVANCE(136);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(176);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 177:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(160);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(165);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(177);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 178:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(136);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(178);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 179:
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(175);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(179);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 180:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(163);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(181);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 181:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(163);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(181);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_regex_flags);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(36);
      END_STATE();
    case 183:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(184);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(163);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(183);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || ';' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(49);
      END_STATE();
    case 185:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(163);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(186);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 186:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(163);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(186);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 187:
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(187);
      END_STATE();
    case 188:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(160);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(188);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 189:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(160);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '|')
        ADVANCE(165);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(189);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a')
        ADVANCE(1);
      if (lookahead == 'b')
        ADVANCE(2);
      if (lookahead == 'c')
        ADVANCE(3);
      if (lookahead == 'd')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(5);
      if (lookahead == 'f')
        ADVANCE(6);
      if (lookahead == 'g')
        ADVANCE(7);
      if (lookahead == 'i')
        ADVANCE(8);
      if (lookahead == 'k')
        ADVANCE(9);
      if (lookahead == 'l')
        ADVANCE(10);
      if (lookahead == 'm')
        ADVANCE(11);
      if (lookahead == 'n')
        ADVANCE(12);
      if (lookahead == 'o')
        ADVANCE(13);
      if (lookahead == 'p')
        ADVANCE(14);
      if (lookahead == 'r')
        ADVANCE(15);
      if (lookahead == 's')
        ADVANCE(16);
      if (lookahead == 't')
        ADVANCE(17);
      if (lookahead == 'u')
        ADVANCE(18);
      if (lookahead == 'v')
        ADVANCE(19);
      if (lookahead == 'w')
        ADVANCE(20);
      if (lookahead == 'y')
        ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'b')
        ADVANCE(22);
      if (lookahead == 'n')
        ADVANCE(23);
      if (lookahead == 's')
        ADVANCE(24);
      if (lookahead == 'w')
        ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o')
        ADVANCE(26);
      if (lookahead == 'r')
        ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a')
        ADVANCE(28);
      if (lookahead == 'l')
        ADVANCE(29);
      if (lookahead == 'o')
        ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e')
        ADVANCE(31);
      if (lookahead == 'o')
        ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l')
        ADVANCE(33);
      if (lookahead == 'n')
        ADVANCE(34);
      if (lookahead == 'x')
        ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a')
        ADVANCE(36);
      if (lookahead == 'i')
        ADVANCE(37);
      if (lookahead == 'o')
        ADVANCE(38);
      if (lookahead == 'r')
        ADVANCE(39);
      if (lookahead == 'u')
        ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e')
        ADVANCE(41);
      if (lookahead == 'l')
        ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f')
        ADVANCE(43);
      if (lookahead == 'm')
        ADVANCE(44);
      if (lookahead == 'n')
        ADVANCE(45);
      if (lookahead == 's')
        ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e')
        ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e')
        ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o')
        ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a')
        ADVANCE(50);
      if (lookahead == 'e')
        ADVANCE(51);
      if (lookahead == 'u')
        ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f')
        ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r')
        ADVANCE(54);
      if (lookahead == 'u')
        ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e')
        ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e')
        ADVANCE(57);
      if (lookahead == 't')
        ADVANCE(58);
      if (lookahead == 'u')
        ADVANCE(59);
      if (lookahead == 'w')
        ADVANCE(60);
      if (lookahead == 'y')
        ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a')
        ADVANCE(62);
      if (lookahead == 'h')
        ADVANCE(63);
      if (lookahead == 'r')
        ADVANCE(64);
      if (lookahead == 'y')
        ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n')
        ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a')
        ADVANCE(67);
      if (lookahead == 'o')
        ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h')
        ADVANCE(69);
      if (lookahead == 'i')
        ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i')
        ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's')
        ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y')
        ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y')
        ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a')
        ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o')
        ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e')
        ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's')
        ADVANCE(78);
      if (lookahead == 't')
        ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a')
        ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n')
        ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b')
        ADVANCE(82);
      if (lookahead == 'c')
        ADVANCE(83);
      if (lookahead == 'f')
        ADVANCE(84);
      if (lookahead == 'l')
        ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's')
        ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u')
        ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p')
        ADVANCE(88);
      if (lookahead == 't')
        ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l')
        ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n')
        ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r')
        ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o')
        ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n')
        ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't')
        ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o')
        ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p')
        ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's')
        ADVANCE(98);
      if (lookahead == 't')
        ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y')
        ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't')
        ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd')
        ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm')
        ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w')
        ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l')
        ADVANCE(105);
      if (lookahead == 'm')
        ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i')
        ADVANCE(107);
      if (lookahead == 'o')
        ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b')
        ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a')
        ADVANCE(110);
      if (lookahead == 'q')
        ADVANCE(111);
      if (lookahead == 't')
        ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't')
        ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a')
        ADVANCE(114);
      if (lookahead == 'r')
        ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p')
        ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i')
        ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm')
        ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r')
        ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i')
        ADVANCE(120);
      if (lookahead == 'r')
        ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u')
        ADVANCE(122);
      if (lookahead == 'y')
        ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p')
        ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd')
        ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r')
        ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i')
        ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i')
        ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't')
        ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e')
        ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't')
        ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n')
        ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i')
        ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l')
        ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a')
        ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e')
        ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c')
        ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's')
        ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's')
        ADVANCE(139);
      if (lookahead == 't')
        ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u')
        ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l')
        ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a')
        ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e')
        ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e')
        ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm')
        ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o')
        ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e')
        ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's')
        ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a')
        ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm')
        ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c')
        ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b')
        ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l')
        ADVANCE(154);
      if (lookahead == 'o')
        ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't')
        ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e')
        ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o')
        ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u')
        ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e')
        ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l')
        ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b')
        ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v')
        ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't')
        ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l')
        ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd')
        ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u')
        ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u')
        ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't')
        ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i')
        ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e')
        ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't')
        ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b')
        ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g')
        ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's')
        ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o')
        ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e')
        ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e')
        ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e')
        ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd')
        ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l')
        ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h')
        ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l')
        ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r')
        ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c')
        ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't')
        ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e')
        ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k')
        ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h')
        ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's')
        ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't')
        ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i')
        ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g')
        ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a')
        ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u')
        ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't')
        ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r')
        ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n')
        ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e')
        ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l')
        ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't')
        ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a')
        ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e')
        ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r')
        ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a')
        ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r')
        ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f')
        ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l')
        ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's')
        ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e')
        ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a')
        ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e')
        ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i')
        ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o')
        ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i')
        ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r')
        ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i')
        ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n')
        ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r')
        ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c')
        ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o')
        ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e')
        ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w')
        ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o')
        ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f')
        ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e')
        ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd')
        ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a')
        ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a')
        ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n')
        ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g')
        ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r')
        ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l')
        ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e')
        ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't')
        ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd')
        ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l')
        ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i')
        ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l')
        ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm')
        ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't')
        ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n')
        ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f')
        ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e')
        ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p')
        ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r')
        ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't')
        ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c')
        ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c')
        ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n')
        ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r')
        ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n')
        ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c')
        ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g')
        ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h')
        ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l')
        ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't')
        ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f')
        ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i')
        ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c')
        ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n')
        ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u')
        ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e')
        ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e')
        ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't')
        ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's')
        ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y')
        ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o')
        ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e')
        ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c')
        ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a')
        ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a')
        ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e')
        ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't')
        ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l')
        ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e')
        ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n')
        ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't')
        ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e')
        ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r')
        ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n')
        ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n')
        ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e')
        ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c')
        ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c')
        ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e')
        ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y')
        ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e')
        ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't')
        ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o')
        ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e')
        ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e')
        ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd')
        ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd')
        ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's')
        ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f')
        ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 95},
  [2] = {.lex_state = 102, .external_lex_state = 2},
  [3] = {.lex_state = 106, .external_lex_state = 3},
  [4] = {.lex_state = 95, .external_lex_state = 2},
  [5] = {.lex_state = 102, .external_lex_state = 2},
  [6] = {.lex_state = 95},
  [7] = {.lex_state = 95},
  [8] = {.lex_state = 102, .external_lex_state = 2},
  [9] = {.lex_state = 95, .external_lex_state = 2},
  [10] = {.lex_state = 95},
  [11] = {.lex_state = 110, .external_lex_state = 2},
  [12] = {.lex_state = 95, .external_lex_state = 2},
  [13] = {.lex_state = 95},
  [14] = {.lex_state = 95},
  [15] = {.lex_state = 95},
  [16] = {.lex_state = 95, .external_lex_state = 2},
  [17] = {.lex_state = 95},
  [18] = {.lex_state = 95},
  [19] = {.lex_state = 110, .external_lex_state = 2},
  [20] = {.lex_state = 110, .external_lex_state = 2},
  [21] = {.lex_state = 95},
  [22] = {.lex_state = 95},
  [23] = {.lex_state = 102, .external_lex_state = 2},
  [24] = {.lex_state = 102, .external_lex_state = 2},
  [25] = {.lex_state = 102, .external_lex_state = 2},
  [26] = {.lex_state = 95},
  [27] = {.lex_state = 122},
  [28] = {.lex_state = 95},
  [29] = {.lex_state = 130},
  [30] = {.lex_state = 134},
  [31] = {.lex_state = 102, .external_lex_state = 2},
  [32] = {.lex_state = 95},
  [33] = {.lex_state = 102, .external_lex_state = 2},
  [34] = {.lex_state = 137},
  [35] = {.lex_state = 95},
  [36] = {.lex_state = 139},
  [37] = {.lex_state = 102, .external_lex_state = 2},
  [38] = {.lex_state = 95},
  [39] = {.lex_state = 95},
  [40] = {.lex_state = 95},
  [41] = {.lex_state = 140},
  [42] = {.lex_state = 95},
  [43] = {.lex_state = 148},
  [44] = {.lex_state = 152},
  [45] = {.lex_state = 130},
  [46] = {.lex_state = 130},
  [47] = {.lex_state = 95},
  [48] = {.lex_state = 102, .external_lex_state = 2},
  [49] = {.lex_state = 95},
  [50] = {.lex_state = 95},
  [51] = {.lex_state = 102},
  [52] = {.lex_state = 159, .external_lex_state = 2},
  [53] = {.lex_state = 102, .external_lex_state = 2},
  [54] = {.lex_state = 95},
  [55] = {.lex_state = 95},
  [56] = {.lex_state = 110, .external_lex_state = 2},
  [57] = {.lex_state = 102},
  [58] = {.lex_state = 110, .external_lex_state = 2},
  [59] = {.lex_state = 159, .external_lex_state = 2},
  [60] = {.lex_state = 0},
  [61] = {.lex_state = 95, .external_lex_state = 2},
  [62] = {.lex_state = 95},
  [63] = {.lex_state = 95},
  [64] = {.lex_state = 110, .external_lex_state = 2},
  [65] = {.lex_state = 95},
  [66] = {.lex_state = 95},
  [67] = {.lex_state = 95},
  [68] = {.lex_state = 95},
  [69] = {.lex_state = 95},
  [70] = {.lex_state = 95},
  [71] = {.lex_state = 110, .external_lex_state = 2},
  [72] = {.lex_state = 95},
  [73] = {.lex_state = 110, .external_lex_state = 2},
  [74] = {.lex_state = 106, .external_lex_state = 3},
  [75] = {.lex_state = 137},
  [76] = {.lex_state = 95},
  [77] = {.lex_state = 95},
  [78] = {.lex_state = 95},
  [79] = {.lex_state = 110, .external_lex_state = 2},
  [80] = {.lex_state = 137},
  [81] = {.lex_state = 130},
  [82] = {.lex_state = 137},
  [83] = {.lex_state = 102, .external_lex_state = 2},
  [84] = {.lex_state = 137},
  [85] = {.lex_state = 102, .external_lex_state = 2},
  [86] = {.lex_state = 130},
  [87] = {.lex_state = 110, .external_lex_state = 2},
  [88] = {.lex_state = 110, .external_lex_state = 2},
  [89] = {.lex_state = 95},
  [90] = {.lex_state = 110, .external_lex_state = 2},
  [91] = {.lex_state = 137},
  [92] = {.lex_state = 95, .external_lex_state = 2},
  [93] = {.lex_state = 102, .external_lex_state = 2},
  [94] = {.lex_state = 130},
  [95] = {.lex_state = 95},
  [96] = {.lex_state = 137},
  [97] = {.lex_state = 102, .external_lex_state = 2},
  [98] = {.lex_state = 102},
  [99] = {.lex_state = 102},
  [100] = {.lex_state = 95},
  [101] = {.lex_state = 148},
  [102] = {.lex_state = 139},
  [103] = {.lex_state = 110, .external_lex_state = 2},
  [104] = {.lex_state = 95},
  [105] = {.lex_state = 137},
  [106] = {.lex_state = 110, .external_lex_state = 2},
  [107] = {.lex_state = 95, .external_lex_state = 2},
  [108] = {.lex_state = 130},
  [109] = {.lex_state = 95},
  [110] = {.lex_state = 137},
  [111] = {.lex_state = 95, .external_lex_state = 2},
  [112] = {.lex_state = 110, .external_lex_state = 2},
  [113] = {.lex_state = 95},
  [114] = {.lex_state = 95},
  [115] = {.lex_state = 110, .external_lex_state = 2},
  [116] = {.lex_state = 110, .external_lex_state = 2},
  [117] = {.lex_state = 95, .external_lex_state = 2},
  [118] = {.lex_state = 95},
  [119] = {.lex_state = 134},
  [120] = {.lex_state = 102},
  [121] = {.lex_state = 130},
  [122] = {.lex_state = 95},
  [123] = {.lex_state = 102},
  [124] = {.lex_state = 95, .external_lex_state = 2},
  [125] = {.lex_state = 95},
  [126] = {.lex_state = 95},
  [127] = {.lex_state = 162, .external_lex_state = 2},
  [128] = {.lex_state = 162, .external_lex_state = 2},
  [129] = {.lex_state = 162, .external_lex_state = 2},
  [130] = {.lex_state = 110, .external_lex_state = 2},
  [131] = {.lex_state = 162, .external_lex_state = 2},
  [132] = {.lex_state = 122},
  [133] = {.lex_state = 95},
  [134] = {.lex_state = 95},
  [135] = {.lex_state = 122},
  [136] = {.lex_state = 164},
  [137] = {.lex_state = 106, .external_lex_state = 3},
  [138] = {.lex_state = 164},
  [139] = {.lex_state = 95},
  [140] = {.lex_state = 95},
  [141] = {.lex_state = 95},
  [142] = {.lex_state = 95},
  [143] = {.lex_state = 130},
  [144] = {.lex_state = 164},
  [145] = {.lex_state = 139},
  [146] = {.lex_state = 110, .external_lex_state = 2},
  [147] = {.lex_state = 166},
  [148] = {.lex_state = 164},
  [149] = {.lex_state = 140},
  [150] = {.lex_state = 95},
  [151] = {.lex_state = 166},
  [152] = {.lex_state = 168},
  [153] = {.lex_state = 152},
  [154] = {.lex_state = 130},
  [155] = {.lex_state = 130},
  [156] = {.lex_state = 164},
  [157] = {.lex_state = 95},
  [158] = {.lex_state = 102},
  [159] = {.lex_state = 168},
  [160] = {.lex_state = 166},
  [161] = {.lex_state = 164},
  [162] = {.lex_state = 130},
  [163] = {.lex_state = 95},
  [164] = {.lex_state = 168},
  [165] = {.lex_state = 130},
  [166] = {.lex_state = 95},
  [167] = {.lex_state = 168},
  [168] = {.lex_state = 137},
  [169] = {.lex_state = 140},
  [170] = {.lex_state = 122},
  [171] = {.lex_state = 137},
  [172] = {.lex_state = 137},
  [173] = {.lex_state = 95},
  [174] = {.lex_state = 148},
  [175] = {.lex_state = 95},
  [176] = {.lex_state = 137},
  [177] = {.lex_state = 95},
  [178] = {.lex_state = 95},
  [179] = {.lex_state = 95},
  [180] = {.lex_state = 110, .external_lex_state = 2},
  [181] = {.lex_state = 102},
  [182] = {.lex_state = 95},
  [183] = {.lex_state = 95},
  [184] = {.lex_state = 95},
  [185] = {.lex_state = 95},
  [186] = {.lex_state = 130},
  [187] = {.lex_state = 95},
  [188] = {.lex_state = 95},
  [189] = {.lex_state = 134},
  [190] = {.lex_state = 95},
  [191] = {.lex_state = 95},
  [192] = {.lex_state = 137},
  [193] = {.lex_state = 102, .external_lex_state = 2},
  [194] = {.lex_state = 102, .external_lex_state = 2},
  [195] = {.lex_state = 95},
  [196] = {.lex_state = 137},
  [197] = {.lex_state = 95},
  [198] = {.lex_state = 102, .external_lex_state = 2},
  [199] = {.lex_state = 102, .external_lex_state = 2},
  [200] = {.lex_state = 130},
  [201] = {.lex_state = 102, .external_lex_state = 2},
  [202] = {.lex_state = 159, .external_lex_state = 2},
  [203] = {.lex_state = 95},
  [204] = {.lex_state = 102, .external_lex_state = 2},
  [205] = {.lex_state = 102, .external_lex_state = 2},
  [206] = {.lex_state = 102, .external_lex_state = 2},
  [207] = {.lex_state = 130},
  [208] = {.lex_state = 95},
  [209] = {.lex_state = 130},
  [210] = {.lex_state = 102, .external_lex_state = 2},
  [211] = {.lex_state = 102, .external_lex_state = 2},
  [212] = {.lex_state = 95},
  [213] = {.lex_state = 102, .external_lex_state = 2},
  [214] = {.lex_state = 95},
  [215] = {.lex_state = 110, .external_lex_state = 2},
  [216] = {.lex_state = 102, .external_lex_state = 2},
  [217] = {.lex_state = 95},
  [218] = {.lex_state = 130},
  [219] = {.lex_state = 102},
  [220] = {.lex_state = 137},
  [221] = {.lex_state = 134},
  [222] = {.lex_state = 110, .external_lex_state = 2},
  [223] = {.lex_state = 102},
  [224] = {.lex_state = 130},
  [225] = {.lex_state = 110, .external_lex_state = 2},
  [226] = {.lex_state = 95},
  [227] = {.lex_state = 169},
  [228] = {.lex_state = 95},
  [229] = {.lex_state = 169},
  [230] = {.lex_state = 95},
  [231] = {.lex_state = 95},
  [232] = {.lex_state = 95},
  [233] = {.lex_state = 169},
  [234] = {.lex_state = 169},
  [235] = {.lex_state = 169},
  [236] = {.lex_state = 95},
  [237] = {.lex_state = 102},
  [238] = {.lex_state = 170},
  [239] = {.lex_state = 130},
  [240] = {.lex_state = 169},
  [241] = {.lex_state = 95},
  [242] = {.lex_state = 102},
  [243] = {.lex_state = 139},
  [244] = {.lex_state = 170},
  [245] = {.lex_state = 169},
  [246] = {.lex_state = 95},
  [247] = {.lex_state = 139},
  [248] = {.lex_state = 170},
  [249] = {.lex_state = 130},
  [250] = {.lex_state = 170},
  [251] = {.lex_state = 95},
  [252] = {.lex_state = 170},
  [253] = {.lex_state = 102},
  [254] = {.lex_state = 102},
  [255] = {.lex_state = 139},
  [256] = {.lex_state = 95},
  [257] = {.lex_state = 95},
  [258] = {.lex_state = 102, .external_lex_state = 2},
  [259] = {.lex_state = 95},
  [260] = {.lex_state = 95},
  [261] = {.lex_state = 140},
  [262] = {.lex_state = 137},
  [263] = {.lex_state = 137},
  [264] = {.lex_state = 134},
  [265] = {.lex_state = 171},
  [266] = {.lex_state = 148},
  [267] = {.lex_state = 137},
  [268] = {.lex_state = 148},
  [269] = {.lex_state = 148},
  [270] = {.lex_state = 171},
  [271] = {.lex_state = 171},
  [272] = {.lex_state = 95},
  [273] = {.lex_state = 95},
  [274] = {.lex_state = 171},
  [275] = {.lex_state = 95},
  [276] = {.lex_state = 95},
  [277] = {.lex_state = 148},
  [278] = {.lex_state = 148},
  [279] = {.lex_state = 134},
  [280] = {.lex_state = 95},
  [281] = {.lex_state = 134},
  [282] = {.lex_state = 102},
  [283] = {.lex_state = 102},
  [284] = {.lex_state = 171},
  [285] = {.lex_state = 102},
  [286] = {.lex_state = 172},
  [287] = {.lex_state = 95},
  [288] = {.lex_state = 95},
  [289] = {.lex_state = 95},
  [290] = {.lex_state = 102},
  [291] = {.lex_state = 95},
  [292] = {.lex_state = 102, .external_lex_state = 2},
  [293] = {.lex_state = 110, .external_lex_state = 2},
  [294] = {.lex_state = 95},
  [295] = {.lex_state = 102, .external_lex_state = 2},
  [296] = {.lex_state = 95},
  [297] = {.lex_state = 95},
  [298] = {.lex_state = 102, .external_lex_state = 2},
  [299] = {.lex_state = 110},
  [300] = {.lex_state = 102, .external_lex_state = 2},
  [301] = {.lex_state = 95},
  [302] = {.lex_state = 110},
  [303] = {.lex_state = 102, .external_lex_state = 2},
  [304] = {.lex_state = 95},
  [305] = {.lex_state = 110},
  [306] = {.lex_state = 110, .external_lex_state = 2},
  [307] = {.lex_state = 173, .external_lex_state = 2},
  [308] = {.lex_state = 110, .external_lex_state = 2},
  [309] = {.lex_state = 95},
  [310] = {.lex_state = 110, .external_lex_state = 2},
  [311] = {.lex_state = 95},
  [312] = {.lex_state = 95},
  [313] = {.lex_state = 102},
  [314] = {.lex_state = 95},
  [315] = {.lex_state = 95},
  [316] = {.lex_state = 95},
  [317] = {.lex_state = 137},
  [318] = {.lex_state = 95, .external_lex_state = 2},
  [319] = {.lex_state = 102, .external_lex_state = 2},
  [320] = {.lex_state = 95},
  [321] = {.lex_state = 95},
  [322] = {.lex_state = 95},
  [323] = {.lex_state = 102, .external_lex_state = 2},
  [324] = {.lex_state = 102, .external_lex_state = 2},
  [325] = {.lex_state = 95},
  [326] = {.lex_state = 102, .external_lex_state = 2},
  [327] = {.lex_state = 95},
  [328] = {.lex_state = 95},
  [329] = {.lex_state = 110, .external_lex_state = 2},
  [330] = {.lex_state = 110, .external_lex_state = 2},
  [331] = {.lex_state = 95},
  [332] = {.lex_state = 95},
  [333] = {.lex_state = 102},
  [334] = {.lex_state = 95},
  [335] = {.lex_state = 110, .external_lex_state = 2},
  [336] = {.lex_state = 148},
  [337] = {.lex_state = 102},
  [338] = {.lex_state = 134},
  [339] = {.lex_state = 110, .external_lex_state = 2},
  [340] = {.lex_state = 95},
  [341] = {.lex_state = 95},
  [342] = {.lex_state = 95},
  [343] = {.lex_state = 95},
  [344] = {.lex_state = 95},
  [345] = {.lex_state = 95},
  [346] = {.lex_state = 148},
  [347] = {.lex_state = 110, .external_lex_state = 2},
  [348] = {.lex_state = 130},
  [349] = {.lex_state = 95},
  [350] = {.lex_state = 95},
  [351] = {.lex_state = 95},
  [352] = {.lex_state = 95},
  [353] = {.lex_state = 110, .external_lex_state = 2},
  [354] = {.lex_state = 110, .external_lex_state = 2},
  [355] = {.lex_state = 137},
  [356] = {.lex_state = 110, .external_lex_state = 2},
  [357] = {.lex_state = 110, .external_lex_state = 2},
  [358] = {.lex_state = 110, .external_lex_state = 2},
  [359] = {.lex_state = 110, .external_lex_state = 2},
  [360] = {.lex_state = 110, .external_lex_state = 2},
  [361] = {.lex_state = 137},
  [362] = {.lex_state = 173, .external_lex_state = 2},
  [363] = {.lex_state = 102},
  [364] = {.lex_state = 102},
  [365] = {.lex_state = 95},
  [366] = {.lex_state = 95},
  [367] = {.lex_state = 102},
  [368] = {.lex_state = 102},
  [369] = {.lex_state = 95},
  [370] = {.lex_state = 159},
  [371] = {.lex_state = 130},
  [372] = {.lex_state = 102},
  [373] = {.lex_state = 95},
  [374] = {.lex_state = 102},
  [375] = {.lex_state = 159},
  [376] = {.lex_state = 102},
  [377] = {.lex_state = 102},
  [378] = {.lex_state = 159},
  [379] = {.lex_state = 95},
  [380] = {.lex_state = 159},
  [381] = {.lex_state = 110, .external_lex_state = 2},
  [382] = {.lex_state = 106, .external_lex_state = 3},
  [383] = {.lex_state = 110, .external_lex_state = 2},
  [384] = {.lex_state = 110, .external_lex_state = 2},
  [385] = {.lex_state = 110, .external_lex_state = 2},
  [386] = {.lex_state = 173, .external_lex_state = 2},
  [387] = {.lex_state = 95},
  [388] = {.lex_state = 139},
  [389] = {.lex_state = 137},
  [390] = {.lex_state = 174},
  [391] = {.lex_state = 130},
  [392] = {.lex_state = 174},
  [393] = {.lex_state = 174},
  [394] = {.lex_state = 174},
  [395] = {.lex_state = 174},
  [396] = {.lex_state = 110, .external_lex_state = 2},
  [397] = {.lex_state = 102},
  [398] = {.lex_state = 130},
  [399] = {.lex_state = 102},
  [400] = {.lex_state = 95},
  [401] = {.lex_state = 95},
  [402] = {.lex_state = 95},
  [403] = {.lex_state = 137},
  [404] = {.lex_state = 148},
  [405] = {.lex_state = 102, .external_lex_state = 2},
  [406] = {.lex_state = 102, .external_lex_state = 2},
  [407] = {.lex_state = 166},
  [408] = {.lex_state = 168},
  [409] = {.lex_state = 130},
  [410] = {.lex_state = 130},
  [411] = {.lex_state = 95},
  [412] = {.lex_state = 174},
  [413] = {.lex_state = 174},
  [414] = {.lex_state = 174},
  [415] = {.lex_state = 174},
  [416] = {.lex_state = 174},
  [417] = {.lex_state = 166},
  [418] = {.lex_state = 102},
  [419] = {.lex_state = 130},
  [420] = {.lex_state = 102},
  [421] = {.lex_state = 95},
  [422] = {.lex_state = 137},
  [423] = {.lex_state = 102, .external_lex_state = 2},
  [424] = {.lex_state = 148},
  [425] = {.lex_state = 102, .external_lex_state = 2},
  [426] = {.lex_state = 102},
  [427] = {.lex_state = 102, .external_lex_state = 2},
  [428] = {.lex_state = 102},
  [429] = {.lex_state = 168},
  [430] = {.lex_state = 130},
  [431] = {.lex_state = 134},
  [432] = {.lex_state = 169},
  [433] = {.lex_state = 169},
  [434] = {.lex_state = 95},
  [435] = {.lex_state = 95},
  [436] = {.lex_state = 95},
  [437] = {.lex_state = 139},
  [438] = {.lex_state = 169},
  [439] = {.lex_state = 169},
  [440] = {.lex_state = 95},
  [441] = {.lex_state = 110, .external_lex_state = 2},
  [442] = {.lex_state = 170},
  [443] = {.lex_state = 130},
  [444] = {.lex_state = 169},
  [445] = {.lex_state = 95},
  [446] = {.lex_state = 102},
  [447] = {.lex_state = 170},
  [448] = {.lex_state = 169},
  [449] = {.lex_state = 139},
  [450] = {.lex_state = 170},
  [451] = {.lex_state = 139},
  [452] = {.lex_state = 95},
  [453] = {.lex_state = 170},
  [454] = {.lex_state = 110, .external_lex_state = 2},
  [455] = {.lex_state = 137},
  [456] = {.lex_state = 95},
  [457] = {.lex_state = 130},
  [458] = {.lex_state = 137},
  [459] = {.lex_state = 130},
  [460] = {.lex_state = 102},
  [461] = {.lex_state = 137},
  [462] = {.lex_state = 137},
  [463] = {.lex_state = 169},
  [464] = {.lex_state = 169},
  [465] = {.lex_state = 169},
  [466] = {.lex_state = 169},
  [467] = {.lex_state = 169},
  [468] = {.lex_state = 170},
  [469] = {.lex_state = 139},
  [470] = {.lex_state = 170},
  [471] = {.lex_state = 170},
  [472] = {.lex_state = 102, .external_lex_state = 2},
  [473] = {.lex_state = 95},
  [474] = {.lex_state = 95},
  [475] = {.lex_state = 102, .external_lex_state = 2},
  [476] = {.lex_state = 95},
  [477] = {.lex_state = 102, .external_lex_state = 2},
  [478] = {.lex_state = 95},
  [479] = {.lex_state = 95},
  [480] = {.lex_state = 95},
  [481] = {.lex_state = 137},
  [482] = {.lex_state = 95},
  [483] = {.lex_state = 148},
  [484] = {.lex_state = 102},
  [485] = {.lex_state = 130},
  [486] = {.lex_state = 95},
  [487] = {.lex_state = 102},
  [488] = {.lex_state = 95, .external_lex_state = 2},
  [489] = {.lex_state = 95},
  [490] = {.lex_state = 95},
  [491] = {.lex_state = 102},
  [492] = {.lex_state = 95},
  [493] = {.lex_state = 95},
  [494] = {.lex_state = 102},
  [495] = {.lex_state = 102},
  [496] = {.lex_state = 137},
  [497] = {.lex_state = 95},
  [498] = {.lex_state = 95},
  [499] = {.lex_state = 137},
  [500] = {.lex_state = 162, .external_lex_state = 2},
  [501] = {.lex_state = 162, .external_lex_state = 2},
  [502] = {.lex_state = 122},
  [503] = {.lex_state = 95},
  [504] = {.lex_state = 102, .external_lex_state = 2},
  [505] = {.lex_state = 95},
  [506] = {.lex_state = 95},
  [507] = {.lex_state = 95},
  [508] = {.lex_state = 110, .external_lex_state = 2},
  [509] = {.lex_state = 110, .external_lex_state = 2},
  [510] = {.lex_state = 166},
  [511] = {.lex_state = 122},
  [512] = {.lex_state = 95},
  [513] = {.lex_state = 95},
  [514] = {.lex_state = 95},
  [515] = {.lex_state = 95},
  [516] = {.lex_state = 95},
  [517] = {.lex_state = 166},
  [518] = {.lex_state = 166},
  [519] = {.lex_state = 106, .external_lex_state = 3},
  [520] = {.lex_state = 95},
  [521] = {.lex_state = 95},
  [522] = {.lex_state = 95},
  [523] = {.lex_state = 166},
  [524] = {.lex_state = 95},
  [525] = {.lex_state = 137},
  [526] = {.lex_state = 95},
  [527] = {.lex_state = 166},
  [528] = {.lex_state = 168},
  [529] = {.lex_state = 168},
  [530] = {.lex_state = 168},
  [531] = {.lex_state = 168},
  [532] = {.lex_state = 176},
  [533] = {.lex_state = 170},
  [534] = {.lex_state = 139},
  [535] = {.lex_state = 95},
  [536] = {.lex_state = 166},
  [537] = {.lex_state = 95},
  [538] = {.lex_state = 102},
  [539] = {.lex_state = 102},
  [540] = {.lex_state = 95},
  [541] = {.lex_state = 140},
  [542] = {.lex_state = 168},
  [543] = {.lex_state = 168},
  [544] = {.lex_state = 172},
  [545] = {.lex_state = 95},
  [546] = {.lex_state = 95},
  [547] = {.lex_state = 95},
  [548] = {.lex_state = 164},
  [549] = {.lex_state = 166},
  [550] = {.lex_state = 95},
  [551] = {.lex_state = 164},
  [552] = {.lex_state = 164},
  [553] = {.lex_state = 164},
  [554] = {.lex_state = 164},
  [555] = {.lex_state = 110},
  [556] = {.lex_state = 166},
  [557] = {.lex_state = 177},
  [558] = {.lex_state = 166},
  [559] = {.lex_state = 166},
  [560] = {.lex_state = 166},
  [561] = {.lex_state = 166},
  [562] = {.lex_state = 166},
  [563] = {.lex_state = 168},
  [564] = {.lex_state = 166},
  [565] = {.lex_state = 95},
  [566] = {.lex_state = 95},
  [567] = {.lex_state = 95},
  [568] = {.lex_state = 95},
  [569] = {.lex_state = 110, .external_lex_state = 2},
  [570] = {.lex_state = 95},
  [571] = {.lex_state = 148},
  [572] = {.lex_state = 166},
  [573] = {.lex_state = 130},
  [574] = {.lex_state = 95},
  [575] = {.lex_state = 130},
  [576] = {.lex_state = 95},
  [577] = {.lex_state = 166},
  [578] = {.lex_state = 130},
  [579] = {.lex_state = 166},
  [580] = {.lex_state = 166},
  [581] = {.lex_state = 95},
  [582] = {.lex_state = 137},
  [583] = {.lex_state = 171},
  [584] = {.lex_state = 140},
  [585] = {.lex_state = 122},
  [586] = {.lex_state = 102},
  [587] = {.lex_state = 102},
  [588] = {.lex_state = 95},
  [589] = {.lex_state = 95},
  [590] = {.lex_state = 102},
  [591] = {.lex_state = 102},
  [592] = {.lex_state = 95},
  [593] = {.lex_state = 110},
  [594] = {.lex_state = 152},
  [595] = {.lex_state = 130},
  [596] = {.lex_state = 102},
  [597] = {.lex_state = 95},
  [598] = {.lex_state = 102},
  [599] = {.lex_state = 110},
  [600] = {.lex_state = 102},
  [601] = {.lex_state = 110},
  [602] = {.lex_state = 130},
  [603] = {.lex_state = 95},
  [604] = {.lex_state = 110},
  [605] = {.lex_state = 102},
  [606] = {.lex_state = 130},
  [607] = {.lex_state = 148},
  [608] = {.lex_state = 148},
  [609] = {.lex_state = 95},
  [610] = {.lex_state = 148},
  [611] = {.lex_state = 130},
  [612] = {.lex_state = 95},
  [613] = {.lex_state = 130},
  [614] = {.lex_state = 102},
  [615] = {.lex_state = 95},
  [616] = {.lex_state = 95},
  [617] = {.lex_state = 162, .external_lex_state = 2},
  [618] = {.lex_state = 174, .external_lex_state = 2},
  [619] = {.lex_state = 95},
  [620] = {.lex_state = 95},
  [621] = {.lex_state = 174, .external_lex_state = 2},
  [622] = {.lex_state = 134, .external_lex_state = 2},
  [623] = {.lex_state = 134, .external_lex_state = 2},
  [624] = {.lex_state = 130},
  [625] = {.lex_state = 162, .external_lex_state = 2},
  [626] = {.lex_state = 140},
  [627] = {.lex_state = 130},
  [628] = {.lex_state = 130},
  [629] = {.lex_state = 122},
  [630] = {.lex_state = 102, .external_lex_state = 2},
  [631] = {.lex_state = 134, .external_lex_state = 2},
  [632] = {.lex_state = 130},
  [633] = {.lex_state = 137},
  [634] = {.lex_state = 137, .external_lex_state = 2},
  [635] = {.lex_state = 110, .external_lex_state = 2},
  [636] = {.lex_state = 95},
  [637] = {.lex_state = 95},
  [638] = {.lex_state = 95},
  [639] = {.lex_state = 137},
  [640] = {.lex_state = 95},
  [641] = {.lex_state = 95},
  [642] = {.lex_state = 95},
  [643] = {.lex_state = 95},
  [644] = {.lex_state = 102},
  [645] = {.lex_state = 95},
  [646] = {.lex_state = 137},
  [647] = {.lex_state = 95},
  [648] = {.lex_state = 110, .external_lex_state = 2},
  [649] = {.lex_state = 95},
  [650] = {.lex_state = 95},
  [651] = {.lex_state = 159, .external_lex_state = 2},
  [652] = {.lex_state = 102},
  [653] = {.lex_state = 137},
  [654] = {.lex_state = 174},
  [655] = {.lex_state = 174},
  [656] = {.lex_state = 174},
  [657] = {.lex_state = 174},
  [658] = {.lex_state = 174},
  [659] = {.lex_state = 102},
  [660] = {.lex_state = 130},
  [661] = {.lex_state = 174},
  [662] = {.lex_state = 95},
  [663] = {.lex_state = 130},
  [664] = {.lex_state = 130},
  [665] = {.lex_state = 130},
  [666] = {.lex_state = 95},
  [667] = {.lex_state = 130},
  [668] = {.lex_state = 95},
  [669] = {.lex_state = 95},
  [670] = {.lex_state = 95},
  [671] = {.lex_state = 168},
  [672] = {.lex_state = 102},
  [673] = {.lex_state = 95},
  [674] = {.lex_state = 134},
  [675] = {.lex_state = 95},
  [676] = {.lex_state = 159},
  [677] = {.lex_state = 134},
  [678] = {.lex_state = 134},
  [679] = {.lex_state = 134},
  [680] = {.lex_state = 95},
  [681] = {.lex_state = 95},
  [682] = {.lex_state = 130},
  [683] = {.lex_state = 110, .external_lex_state = 2},
  [684] = {.lex_state = 102},
  [685] = {.lex_state = 102, .external_lex_state = 2},
  [686] = {.lex_state = 137},
  [687] = {.lex_state = 102, .external_lex_state = 2},
  [688] = {.lex_state = 102, .external_lex_state = 2},
  [689] = {.lex_state = 137},
  [690] = {.lex_state = 95},
  [691] = {.lex_state = 95},
  [692] = {.lex_state = 95},
  [693] = {.lex_state = 95},
  [694] = {.lex_state = 159, .external_lex_state = 2},
  [695] = {.lex_state = 102},
  [696] = {.lex_state = 130},
  [697] = {.lex_state = 130},
  [698] = {.lex_state = 130},
  [699] = {.lex_state = 130},
  [700] = {.lex_state = 102},
  [701] = {.lex_state = 130},
  [702] = {.lex_state = 130},
  [703] = {.lex_state = 159, .external_lex_state = 2},
  [704] = {.lex_state = 102},
  [705] = {.lex_state = 137},
  [706] = {.lex_state = 95},
  [707] = {.lex_state = 95},
  [708] = {.lex_state = 169},
  [709] = {.lex_state = 95},
  [710] = {.lex_state = 95},
  [711] = {.lex_state = 148},
  [712] = {.lex_state = 170},
  [713] = {.lex_state = 169},
  [714] = {.lex_state = 169},
  [715] = {.lex_state = 169},
  [716] = {.lex_state = 169},
  [717] = {.lex_state = 169},
  [718] = {.lex_state = 169},
  [719] = {.lex_state = 95},
  [720] = {.lex_state = 169},
  [721] = {.lex_state = 95},
  [722] = {.lex_state = 170},
  [723] = {.lex_state = 169},
  [724] = {.lex_state = 170},
  [725] = {.lex_state = 170},
  [726] = {.lex_state = 169},
  [727] = {.lex_state = 102},
  [728] = {.lex_state = 102},
  [729] = {.lex_state = 170},
  [730] = {.lex_state = 170},
  [731] = {.lex_state = 169},
  [732] = {.lex_state = 169},
  [733] = {.lex_state = 169},
  [734] = {.lex_state = 169},
  [735] = {.lex_state = 169},
  [736] = {.lex_state = 170},
  [737] = {.lex_state = 139},
  [738] = {.lex_state = 102},
  [739] = {.lex_state = 139},
  [740] = {.lex_state = 95},
  [741] = {.lex_state = 95},
  [742] = {.lex_state = 95},
  [743] = {.lex_state = 95},
  [744] = {.lex_state = 95},
  [745] = {.lex_state = 95},
  [746] = {.lex_state = 148},
  [747] = {.lex_state = 130},
  [748] = {.lex_state = 110, .external_lex_state = 2},
  [749] = {.lex_state = 148},
  [750] = {.lex_state = 95},
  [751] = {.lex_state = 139},
  [752] = {.lex_state = 95},
  [753] = {.lex_state = 95},
  [754] = {.lex_state = 139},
  [755] = {.lex_state = 169},
  [756] = {.lex_state = 169},
  [757] = {.lex_state = 169},
  [758] = {.lex_state = 130},
  [759] = {.lex_state = 169},
  [760] = {.lex_state = 139},
  [761] = {.lex_state = 169},
  [762] = {.lex_state = 169},
  [763] = {.lex_state = 169},
  [764] = {.lex_state = 170},
  [765] = {.lex_state = 169},
  [766] = {.lex_state = 169},
  [767] = {.lex_state = 170},
  [768] = {.lex_state = 169},
  [769] = {.lex_state = 95},
  [770] = {.lex_state = 95},
  [771] = {.lex_state = 130},
  [772] = {.lex_state = 102},
  [773] = {.lex_state = 95},
  [774] = {.lex_state = 95},
  [775] = {.lex_state = 137},
  [776] = {.lex_state = 102, .external_lex_state = 2},
  [777] = {.lex_state = 137},
  [778] = {.lex_state = 140},
  [779] = {.lex_state = 137},
  [780] = {.lex_state = 95},
  [781] = {.lex_state = 95},
  [782] = {.lex_state = 137},
  [783] = {.lex_state = 137},
  [784] = {.lex_state = 148},
  [785] = {.lex_state = 148},
  [786] = {.lex_state = 148},
  [787] = {.lex_state = 95},
  [788] = {.lex_state = 148},
  [789] = {.lex_state = 148},
  [790] = {.lex_state = 102},
  [791] = {.lex_state = 178},
  [792] = {.lex_state = 102},
  [793] = {.lex_state = 148},
  [794] = {.lex_state = 171},
  [795] = {.lex_state = 95},
  [796] = {.lex_state = 130},
  [797] = {.lex_state = 95},
  [798] = {.lex_state = 139},
  [799] = {.lex_state = 130},
  [800] = {.lex_state = 174, .external_lex_state = 2},
  [801] = {.lex_state = 174, .external_lex_state = 2},
  [802] = {.lex_state = 171},
  [803] = {.lex_state = 95},
  [804] = {.lex_state = 174, .external_lex_state = 2},
  [805] = {.lex_state = 130},
  [806] = {.lex_state = 95},
  [807] = {.lex_state = 174, .external_lex_state = 2},
  [808] = {.lex_state = 130},
  [809] = {.lex_state = 102, .external_lex_state = 2},
  [810] = {.lex_state = 102, .external_lex_state = 2},
  [811] = {.lex_state = 95},
  [812] = {.lex_state = 130},
  [813] = {.lex_state = 148},
  [814] = {.lex_state = 148},
  [815] = {.lex_state = 95},
  [816] = {.lex_state = 148},
  [817] = {.lex_state = 130},
  [818] = {.lex_state = 95},
  [819] = {.lex_state = 130},
  [820] = {.lex_state = 102},
  [821] = {.lex_state = 171},
  [822] = {.lex_state = 171},
  [823] = {.lex_state = 171},
  [824] = {.lex_state = 171},
  [825] = {.lex_state = 171},
  [826] = {.lex_state = 102},
  [827] = {.lex_state = 95},
  [828] = {.lex_state = 130},
  [829] = {.lex_state = 179},
  [830] = {.lex_state = 179},
  [831] = {.lex_state = 137},
  [832] = {.lex_state = 148},
  [833] = {.lex_state = 148},
  [834] = {.lex_state = 148},
  [835] = {.lex_state = 179},
  [836] = {.lex_state = 95},
  [837] = {.lex_state = 139},
  [838] = {.lex_state = 95},
  [839] = {.lex_state = 139},
  [840] = {.lex_state = 102},
  [841] = {.lex_state = 171},
  [842] = {.lex_state = 178},
  [843] = {.lex_state = 148},
  [844] = {.lex_state = 148},
  [845] = {.lex_state = 176},
  [846] = {.lex_state = 102},
  [847] = {.lex_state = 102},
  [848] = {.lex_state = 148},
  [849] = {.lex_state = 148},
  [850] = {.lex_state = 178},
  [851] = {.lex_state = 102},
  [852] = {.lex_state = 164},
  [853] = {.lex_state = 102},
  [854] = {.lex_state = 130},
  [855] = {.lex_state = 148},
  [856] = {.lex_state = 180, .external_lex_state = 2},
  [857] = {.lex_state = 95, .external_lex_state = 2},
  [858] = {.lex_state = 102, .external_lex_state = 2},
  [859] = {.lex_state = 95},
  [860] = {.lex_state = 95},
  [861] = {.lex_state = 95},
  [862] = {.lex_state = 162, .external_lex_state = 2},
  [863] = {.lex_state = 148},
  [864] = {.lex_state = 102},
  [865] = {.lex_state = 95},
  [866] = {.lex_state = 95},
  [867] = {.lex_state = 95},
  [868] = {.lex_state = 110, .external_lex_state = 2},
  [869] = {.lex_state = 110, .external_lex_state = 2},
  [870] = {.lex_state = 110, .external_lex_state = 2},
  [871] = {.lex_state = 102},
  [872] = {.lex_state = 102},
  [873] = {.lex_state = 102},
  [874] = {.lex_state = 102},
  [875] = {.lex_state = 130},
  [876] = {.lex_state = 102},
  [877] = {.lex_state = 102},
  [878] = {.lex_state = 110},
  [879] = {.lex_state = 102},
  [880] = {.lex_state = 110},
  [881] = {.lex_state = 110},
  [882] = {.lex_state = 110},
  [883] = {.lex_state = 110},
  [884] = {.lex_state = 95},
  [885] = {.lex_state = 95},
  [886] = {.lex_state = 95},
  [887] = {.lex_state = 95},
  [888] = {.lex_state = 95},
  [889] = {.lex_state = 148},
  [890] = {.lex_state = 130},
  [891] = {.lex_state = 95},
  [892] = {.lex_state = 95, .external_lex_state = 2},
  [893] = {.lex_state = 95, .external_lex_state = 2},
  [894] = {.lex_state = 102},
  [895] = {.lex_state = 102},
  [896] = {.lex_state = 102, .external_lex_state = 2},
  [897] = {.lex_state = 102, .external_lex_state = 2},
  [898] = {.lex_state = 102, .external_lex_state = 2},
  [899] = {.lex_state = 95},
  [900] = {.lex_state = 95},
  [901] = {.lex_state = 102, .external_lex_state = 2},
  [902] = {.lex_state = 102, .external_lex_state = 2},
  [903] = {.lex_state = 95},
  [904] = {.lex_state = 110, .external_lex_state = 2},
  [905] = {.lex_state = 130},
  [906] = {.lex_state = 102, .external_lex_state = 2},
  [907] = {.lex_state = 95},
  [908] = {.lex_state = 102},
  [909] = {.lex_state = 110, .external_lex_state = 2},
  [910] = {.lex_state = 102, .external_lex_state = 2},
  [911] = {.lex_state = 110, .external_lex_state = 2},
  [912] = {.lex_state = 95},
  [913] = {.lex_state = 110, .external_lex_state = 2},
  [914] = {.lex_state = 95},
  [915] = {.lex_state = 137},
  [916] = {.lex_state = 95},
  [917] = {.lex_state = 95},
  [918] = {.lex_state = 95},
  [919] = {.lex_state = 95},
  [920] = {.lex_state = 95},
  [921] = {.lex_state = 102},
  [922] = {.lex_state = 95},
  [923] = {.lex_state = 95},
  [924] = {.lex_state = 95},
  [925] = {.lex_state = 130},
  [926] = {.lex_state = 134},
  [927] = {.lex_state = 95},
  [928] = {.lex_state = 95},
  [929] = {.lex_state = 95},
  [930] = {.lex_state = 95},
  [931] = {.lex_state = 95},
  [932] = {.lex_state = 95},
  [933] = {.lex_state = 95},
  [934] = {.lex_state = 137},
  [935] = {.lex_state = 102},
  [936] = {.lex_state = 134},
  [937] = {.lex_state = 148},
  [938] = {.lex_state = 148},
  [939] = {.lex_state = 95},
  [940] = {.lex_state = 148},
  [941] = {.lex_state = 134},
  [942] = {.lex_state = 95},
  [943] = {.lex_state = 134},
  [944] = {.lex_state = 102},
  [945] = {.lex_state = 110, .external_lex_state = 2},
  [946] = {.lex_state = 110, .external_lex_state = 2},
  [947] = {.lex_state = 110, .external_lex_state = 2},
  [948] = {.lex_state = 110, .external_lex_state = 2},
  [949] = {.lex_state = 110, .external_lex_state = 2},
  [950] = {.lex_state = 95, .external_lex_state = 2},
  [951] = {.lex_state = 102},
  [952] = {.lex_state = 102},
  [953] = {.lex_state = 95},
  [954] = {.lex_state = 95},
  [955] = {.lex_state = 102},
  [956] = {.lex_state = 102},
  [957] = {.lex_state = 95},
  [958] = {.lex_state = 110},
  [959] = {.lex_state = 130},
  [960] = {.lex_state = 102},
  [961] = {.lex_state = 95},
  [962] = {.lex_state = 102},
  [963] = {.lex_state = 110},
  [964] = {.lex_state = 102},
  [965] = {.lex_state = 110},
  [966] = {.lex_state = 95},
  [967] = {.lex_state = 110},
  [968] = {.lex_state = 110, .external_lex_state = 2},
  [969] = {.lex_state = 110, .external_lex_state = 2},
  [970] = {.lex_state = 148},
  [971] = {.lex_state = 137},
  [972] = {.lex_state = 148},
  [973] = {.lex_state = 110, .external_lex_state = 2},
  [974] = {.lex_state = 148},
  [975] = {.lex_state = 95},
  [976] = {.lex_state = 95},
  [977] = {.lex_state = 95},
  [978] = {.lex_state = 110, .external_lex_state = 2},
  [979] = {.lex_state = 110, .external_lex_state = 2},
  [980] = {.lex_state = 95},
  [981] = {.lex_state = 148},
  [982] = {.lex_state = 148},
  [983] = {.lex_state = 110, .external_lex_state = 2},
  [984] = {.lex_state = 95},
  [985] = {.lex_state = 110, .external_lex_state = 2},
  [986] = {.lex_state = 102},
  [987] = {.lex_state = 110, .external_lex_state = 2},
  [988] = {.lex_state = 110, .external_lex_state = 2},
  [989] = {.lex_state = 102},
  [990] = {.lex_state = 102, .external_lex_state = 2},
  [991] = {.lex_state = 110, .external_lex_state = 2},
  [992] = {.lex_state = 130},
  [993] = {.lex_state = 102, .external_lex_state = 2},
  [994] = {.lex_state = 95},
  [995] = {.lex_state = 95},
  [996] = {.lex_state = 137},
  [997] = {.lex_state = 102, .external_lex_state = 2},
  [998] = {.lex_state = 139},
  [999] = {.lex_state = 110, .external_lex_state = 2},
  [1000] = {.lex_state = 130},
  [1001] = {.lex_state = 95},
  [1002] = {.lex_state = 102},
  [1003] = {.lex_state = 110, .external_lex_state = 2},
  [1004] = {.lex_state = 95},
  [1005] = {.lex_state = 95},
  [1006] = {.lex_state = 95},
  [1007] = {.lex_state = 137},
  [1008] = {.lex_state = 95},
  [1009] = {.lex_state = 95},
  [1010] = {.lex_state = 95},
  [1011] = {.lex_state = 95},
  [1012] = {.lex_state = 95},
  [1013] = {.lex_state = 95},
  [1014] = {.lex_state = 159},
  [1015] = {.lex_state = 159},
  [1016] = {.lex_state = 102},
  [1017] = {.lex_state = 102},
  [1018] = {.lex_state = 159},
  [1019] = {.lex_state = 159},
  [1020] = {.lex_state = 102},
  [1021] = {.lex_state = 102},
  [1022] = {.lex_state = 102},
  [1023] = {.lex_state = 102},
  [1024] = {.lex_state = 102},
  [1025] = {.lex_state = 159},
  [1026] = {.lex_state = 95},
  [1027] = {.lex_state = 95},
  [1028] = {.lex_state = 95},
  [1029] = {.lex_state = 95},
  [1030] = {.lex_state = 95},
  [1031] = {.lex_state = 95},
  [1032] = {.lex_state = 106, .external_lex_state = 3},
  [1033] = {.lex_state = 148},
  [1034] = {.lex_state = 130},
  [1035] = {.lex_state = 95},
  [1036] = {.lex_state = 137},
  [1037] = {.lex_state = 183},
  [1038] = {.lex_state = 170},
  [1039] = {.lex_state = 139},
  [1040] = {.lex_state = 139},
  [1041] = {.lex_state = 102},
  [1042] = {.lex_state = 168},
  [1043] = {.lex_state = 102},
  [1044] = {.lex_state = 130},
  [1045] = {.lex_state = 102},
  [1046] = {.lex_state = 95},
  [1047] = {.lex_state = 134, .external_lex_state = 2},
  [1048] = {.lex_state = 174, .external_lex_state = 2},
  [1049] = {.lex_state = 148},
  [1050] = {.lex_state = 137},
  [1051] = {.lex_state = 148},
  [1052] = {.lex_state = 148},
  [1053] = {.lex_state = 174, .external_lex_state = 2},
  [1054] = {.lex_state = 174, .external_lex_state = 2},
  [1055] = {.lex_state = 95},
  [1056] = {.lex_state = 95},
  [1057] = {.lex_state = 174, .external_lex_state = 2},
  [1058] = {.lex_state = 95},
  [1059] = {.lex_state = 95},
  [1060] = {.lex_state = 148},
  [1061] = {.lex_state = 148},
  [1062] = {.lex_state = 134, .external_lex_state = 2},
  [1063] = {.lex_state = 95},
  [1064] = {.lex_state = 134, .external_lex_state = 2},
  [1065] = {.lex_state = 102},
  [1066] = {.lex_state = 174, .external_lex_state = 2},
  [1067] = {.lex_state = 102},
  [1068] = {.lex_state = 102, .external_lex_state = 2},
  [1069] = {.lex_state = 166},
  [1070] = {.lex_state = 130},
  [1071] = {.lex_state = 137},
  [1072] = {.lex_state = 166},
  [1073] = {.lex_state = 102},
  [1074] = {.lex_state = 166},
  [1075] = {.lex_state = 102},
  [1076] = {.lex_state = 102},
  [1077] = {.lex_state = 102, .external_lex_state = 2},
  [1078] = {.lex_state = 137},
  [1079] = {.lex_state = 102, .external_lex_state = 2},
  [1080] = {.lex_state = 134},
  [1081] = {.lex_state = 148},
  [1082] = {.lex_state = 148},
  [1083] = {.lex_state = 95},
  [1084] = {.lex_state = 148},
  [1085] = {.lex_state = 134},
  [1086] = {.lex_state = 95},
  [1087] = {.lex_state = 134},
  [1088] = {.lex_state = 102},
  [1089] = {.lex_state = 102, .external_lex_state = 2},
  [1090] = {.lex_state = 102, .external_lex_state = 2},
  [1091] = {.lex_state = 95},
  [1092] = {.lex_state = 173, .external_lex_state = 2},
  [1093] = {.lex_state = 95},
  [1094] = {.lex_state = 95},
  [1095] = {.lex_state = 95},
  [1096] = {.lex_state = 95},
  [1097] = {.lex_state = 95},
  [1098] = {.lex_state = 170},
  [1099] = {.lex_state = 170},
  [1100] = {.lex_state = 170},
  [1101] = {.lex_state = 170},
  [1102] = {.lex_state = 102},
  [1103] = {.lex_state = 102},
  [1104] = {.lex_state = 170},
  [1105] = {.lex_state = 170},
  [1106] = {.lex_state = 169},
  [1107] = {.lex_state = 169},
  [1108] = {.lex_state = 169},
  [1109] = {.lex_state = 169},
  [1110] = {.lex_state = 169},
  [1111] = {.lex_state = 170},
  [1112] = {.lex_state = 95},
  [1113] = {.lex_state = 95},
  [1114] = {.lex_state = 95},
  [1115] = {.lex_state = 95},
  [1116] = {.lex_state = 95},
  [1117] = {.lex_state = 148},
  [1118] = {.lex_state = 130},
  [1119] = {.lex_state = 110, .external_lex_state = 2},
  [1120] = {.lex_state = 95},
  [1121] = {.lex_state = 139},
  [1122] = {.lex_state = 139},
  [1123] = {.lex_state = 164},
  [1124] = {.lex_state = 164},
  [1125] = {.lex_state = 95},
  [1126] = {.lex_state = 95},
  [1127] = {.lex_state = 164},
  [1128] = {.lex_state = 164},
  [1129] = {.lex_state = 95},
  [1130] = {.lex_state = 168},
  [1131] = {.lex_state = 130},
  [1132] = {.lex_state = 164},
  [1133] = {.lex_state = 95},
  [1134] = {.lex_state = 102},
  [1135] = {.lex_state = 168},
  [1136] = {.lex_state = 164},
  [1137] = {.lex_state = 168},
  [1138] = {.lex_state = 95},
  [1139] = {.lex_state = 168},
  [1140] = {.lex_state = 130},
  [1141] = {.lex_state = 137},
  [1142] = {.lex_state = 130},
  [1143] = {.lex_state = 137},
  [1144] = {.lex_state = 102},
  [1145] = {.lex_state = 102},
  [1146] = {.lex_state = 95},
  [1147] = {.lex_state = 139},
  [1148] = {.lex_state = 95},
  [1149] = {.lex_state = 95},
  [1150] = {.lex_state = 95},
  [1151] = {.lex_state = 95},
  [1152] = {.lex_state = 102},
  [1153] = {.lex_state = 95},
  [1154] = {.lex_state = 134},
  [1155] = {.lex_state = 95},
  [1156] = {.lex_state = 95},
  [1157] = {.lex_state = 95},
  [1158] = {.lex_state = 95},
  [1159] = {.lex_state = 95},
  [1160] = {.lex_state = 137},
  [1161] = {.lex_state = 95},
  [1162] = {.lex_state = 95},
  [1163] = {.lex_state = 137},
  [1164] = {.lex_state = 134, .external_lex_state = 2},
  [1165] = {.lex_state = 148},
  [1166] = {.lex_state = 148},
  [1167] = {.lex_state = 95},
  [1168] = {.lex_state = 148},
  [1169] = {.lex_state = 134, .external_lex_state = 2},
  [1170] = {.lex_state = 95},
  [1171] = {.lex_state = 134, .external_lex_state = 2},
  [1172] = {.lex_state = 102},
  [1173] = {.lex_state = 148},
  [1174] = {.lex_state = 95},
  [1175] = {.lex_state = 95},
  [1176] = {.lex_state = 102, .external_lex_state = 2},
  [1177] = {.lex_state = 95},
  [1178] = {.lex_state = 137},
  [1179] = {.lex_state = 95, .external_lex_state = 2},
  [1180] = {.lex_state = 95},
  [1181] = {.lex_state = 95},
  [1182] = {.lex_state = 102},
  [1183] = {.lex_state = 95},
  [1184] = {.lex_state = 102},
  [1185] = {.lex_state = 95},
  [1186] = {.lex_state = 102},
  [1187] = {.lex_state = 95, .external_lex_state = 2},
  [1188] = {.lex_state = 162, .external_lex_state = 2},
  [1189] = {.lex_state = 162, .external_lex_state = 2},
  [1190] = {.lex_state = 95},
  [1191] = {.lex_state = 95},
  [1192] = {.lex_state = 95},
  [1193] = {.lex_state = 95},
  [1194] = {.lex_state = 95},
  [1195] = {.lex_state = 95},
  [1196] = {.lex_state = 102, .external_lex_state = 2},
  [1197] = {.lex_state = 102},
  [1198] = {.lex_state = 102},
  [1199] = {.lex_state = 139},
  [1200] = {.lex_state = 95},
  [1201] = {.lex_state = 95},
  [1202] = {.lex_state = 95},
  [1203] = {.lex_state = 95},
  [1204] = {.lex_state = 166},
  [1205] = {.lex_state = 137},
  [1206] = {.lex_state = 166},
  [1207] = {.lex_state = 168},
  [1208] = {.lex_state = 168},
  [1209] = {.lex_state = 168},
  [1210] = {.lex_state = 168},
  [1211] = {.lex_state = 177},
  [1212] = {.lex_state = 166},
  [1213] = {.lex_state = 166},
  [1214] = {.lex_state = 168},
  [1215] = {.lex_state = 168},
  [1216] = {.lex_state = 177},
  [1217] = {.lex_state = 95},
  [1218] = {.lex_state = 95},
  [1219] = {.lex_state = 166},
  [1220] = {.lex_state = 166},
  [1221] = {.lex_state = 137},
  [1222] = {.lex_state = 166},
  [1223] = {.lex_state = 166},
  [1224] = {.lex_state = 139},
  [1225] = {.lex_state = 168},
  [1226] = {.lex_state = 130},
  [1227] = {.lex_state = 166},
  [1228] = {.lex_state = 95},
  [1229] = {.lex_state = 95},
  [1230] = {.lex_state = 95},
  [1231] = {.lex_state = 95},
  [1232] = {.lex_state = 185},
  [1233] = {.lex_state = 95},
  [1234] = {.lex_state = 95},
  [1235] = {.lex_state = 137},
  [1236] = {.lex_state = 166},
  [1237] = {.lex_state = 166},
  [1238] = {.lex_state = 166},
  [1239] = {.lex_state = 166},
  [1240] = {.lex_state = 95},
  [1241] = {.lex_state = 166},
  [1242] = {.lex_state = 168},
  [1243] = {.lex_state = 168},
  [1244] = {.lex_state = 168},
  [1245] = {.lex_state = 168},
  [1246] = {.lex_state = 110},
  [1247] = {.lex_state = 168},
  [1248] = {.lex_state = 166},
  [1249] = {.lex_state = 148},
  [1250] = {.lex_state = 137},
  [1251] = {.lex_state = 148},
  [1252] = {.lex_state = 166},
  [1253] = {.lex_state = 148},
  [1254] = {.lex_state = 95},
  [1255] = {.lex_state = 95},
  [1256] = {.lex_state = 95},
  [1257] = {.lex_state = 166},
  [1258] = {.lex_state = 166},
  [1259] = {.lex_state = 95},
  [1260] = {.lex_state = 148},
  [1261] = {.lex_state = 148},
  [1262] = {.lex_state = 166},
  [1263] = {.lex_state = 95},
  [1264] = {.lex_state = 168},
  [1265] = {.lex_state = 102},
  [1266] = {.lex_state = 166},
  [1267] = {.lex_state = 166},
  [1268] = {.lex_state = 102},
  [1269] = {.lex_state = 164},
  [1270] = {.lex_state = 166},
  [1271] = {.lex_state = 164},
  [1272] = {.lex_state = 95},
  [1273] = {.lex_state = 95},
  [1274] = {.lex_state = 137},
  [1275] = {.lex_state = 164},
  [1276] = {.lex_state = 139},
  [1277] = {.lex_state = 166},
  [1278] = {.lex_state = 130},
  [1279] = {.lex_state = 168},
  [1280] = {.lex_state = 110, .external_lex_state = 2},
  [1281] = {.lex_state = 95},
  [1282] = {.lex_state = 95},
  [1283] = {.lex_state = 171},
  [1284] = {.lex_state = 171},
  [1285] = {.lex_state = 95},
  [1286] = {.lex_state = 95},
  [1287] = {.lex_state = 95},
  [1288] = {.lex_state = 95},
  [1289] = {.lex_state = 95},
  [1290] = {.lex_state = 95},
  [1291] = {.lex_state = 95},
  [1292] = {.lex_state = 102},
  [1293] = {.lex_state = 110},
  [1294] = {.lex_state = 110},
  [1295] = {.lex_state = 102},
  [1296] = {.lex_state = 102},
  [1297] = {.lex_state = 110},
  [1298] = {.lex_state = 110},
  [1299] = {.lex_state = 172},
  [1300] = {.lex_state = 102},
  [1301] = {.lex_state = 102},
  [1302] = {.lex_state = 102},
  [1303] = {.lex_state = 102},
  [1304] = {.lex_state = 102},
  [1305] = {.lex_state = 110},
  [1306] = {.lex_state = 95},
  [1307] = {.lex_state = 95},
  [1308] = {.lex_state = 95},
  [1309] = {.lex_state = 95},
  [1310] = {.lex_state = 95},
  [1311] = {.lex_state = 95},
  [1312] = {.lex_state = 148},
  [1313] = {.lex_state = 130},
  [1314] = {.lex_state = 95},
  [1315] = {.lex_state = 102},
  [1316] = {.lex_state = 148},
  [1317] = {.lex_state = 148},
  [1318] = {.lex_state = 102},
  [1319] = {.lex_state = 95},
  [1320] = {.lex_state = 148},
  [1321] = {.lex_state = 148},
  [1322] = {.lex_state = 148},
  [1323] = {.lex_state = 102},
  [1324] = {.lex_state = 102},
  [1325] = {.lex_state = 148},
  [1326] = {.lex_state = 148},
  [1327] = {.lex_state = 162, .external_lex_state = 2},
  [1328] = {.lex_state = 95},
  [1329] = {.lex_state = 164},
  [1330] = {.lex_state = 164},
  [1331] = {.lex_state = 95},
  [1332] = {.lex_state = 95},
  [1333] = {.lex_state = 164},
  [1334] = {.lex_state = 164},
  [1335] = {.lex_state = 95},
  [1336] = {.lex_state = 168},
  [1337] = {.lex_state = 130},
  [1338] = {.lex_state = 164},
  [1339] = {.lex_state = 95},
  [1340] = {.lex_state = 102},
  [1341] = {.lex_state = 168},
  [1342] = {.lex_state = 164},
  [1343] = {.lex_state = 130},
  [1344] = {.lex_state = 168},
  [1345] = {.lex_state = 95},
  [1346] = {.lex_state = 95},
  [1347] = {.lex_state = 168},
  [1348] = {.lex_state = 130},
  [1349] = {.lex_state = 130},
  [1350] = {.lex_state = 95},
  [1351] = {.lex_state = 134, .external_lex_state = 2},
  [1352] = {.lex_state = 95},
  [1353] = {.lex_state = 130},
  [1354] = {.lex_state = 134, .external_lex_state = 2},
  [1355] = {.lex_state = 134, .external_lex_state = 2},
  [1356] = {.lex_state = 174, .external_lex_state = 2},
  [1357] = {.lex_state = 140},
  [1358] = {.lex_state = 134, .external_lex_state = 2},
  [1359] = {.lex_state = 95},
  [1360] = {.lex_state = 95},
  [1361] = {.lex_state = 134, .external_lex_state = 2},
  [1362] = {.lex_state = 122},
  [1363] = {.lex_state = 137},
  [1364] = {.lex_state = 134, .external_lex_state = 2},
  [1365] = {.lex_state = 102, .external_lex_state = 2},
  [1366] = {.lex_state = 102, .external_lex_state = 2},
  [1367] = {.lex_state = 102, .external_lex_state = 2},
  [1368] = {.lex_state = 102, .external_lex_state = 2},
  [1369] = {.lex_state = 95},
  [1370] = {.lex_state = 102, .external_lex_state = 2},
  [1371] = {.lex_state = 130},
  [1372] = {.lex_state = 130},
  [1373] = {.lex_state = 130},
  [1374] = {.lex_state = 162, .external_lex_state = 2},
  [1375] = {.lex_state = 137},
  [1376] = {.lex_state = 102},
  [1377] = {.lex_state = 95},
  [1378] = {.lex_state = 95},
  [1379] = {.lex_state = 137},
  [1380] = {.lex_state = 95},
  [1381] = {.lex_state = 95},
  [1382] = {.lex_state = 95, .external_lex_state = 2},
  [1383] = {.lex_state = 95},
  [1384] = {.lex_state = 95},
  [1385] = {.lex_state = 137},
  [1386] = {.lex_state = 95},
  [1387] = {.lex_state = 95},
  [1388] = {.lex_state = 102, .external_lex_state = 2},
  [1389] = {.lex_state = 102, .external_lex_state = 2},
  [1390] = {.lex_state = 95},
  [1391] = {.lex_state = 95},
  [1392] = {.lex_state = 102, .external_lex_state = 2},
  [1393] = {.lex_state = 102, .external_lex_state = 2},
  [1394] = {.lex_state = 95},
  [1395] = {.lex_state = 159, .external_lex_state = 2},
  [1396] = {.lex_state = 130},
  [1397] = {.lex_state = 102, .external_lex_state = 2},
  [1398] = {.lex_state = 95},
  [1399] = {.lex_state = 102},
  [1400] = {.lex_state = 159, .external_lex_state = 2},
  [1401] = {.lex_state = 102, .external_lex_state = 2},
  [1402] = {.lex_state = 159, .external_lex_state = 2},
  [1403] = {.lex_state = 95},
  [1404] = {.lex_state = 159, .external_lex_state = 2},
  [1405] = {.lex_state = 110, .external_lex_state = 2},
  [1406] = {.lex_state = 139},
  [1407] = {.lex_state = 102},
  [1408] = {.lex_state = 164},
  [1409] = {.lex_state = 164},
  [1410] = {.lex_state = 164},
  [1411] = {.lex_state = 164},
  [1412] = {.lex_state = 164},
  [1413] = {.lex_state = 168},
  [1414] = {.lex_state = 95},
  [1415] = {.lex_state = 95},
  [1416] = {.lex_state = 130},
  [1417] = {.lex_state = 130},
  [1418] = {.lex_state = 95},
  [1419] = {.lex_state = 130},
  [1420] = {.lex_state = 102, .external_lex_state = 2},
  [1421] = {.lex_state = 95},
  [1422] = {.lex_state = 95},
  [1423] = {.lex_state = 102, .external_lex_state = 2},
  [1424] = {.lex_state = 95},
  [1425] = {.lex_state = 102, .external_lex_state = 2},
  [1426] = {.lex_state = 95},
  [1427] = {.lex_state = 137},
  [1428] = {.lex_state = 95},
  [1429] = {.lex_state = 95},
  [1430] = {.lex_state = 102, .external_lex_state = 2},
  [1431] = {.lex_state = 95},
  [1432] = {.lex_state = 95},
  [1433] = {.lex_state = 95},
  [1434] = {.lex_state = 110, .external_lex_state = 2},
  [1435] = {.lex_state = 110, .external_lex_state = 2},
  [1436] = {.lex_state = 110, .external_lex_state = 2},
  [1437] = {.lex_state = 95},
  [1438] = {.lex_state = 95},
  [1439] = {.lex_state = 130},
  [1440] = {.lex_state = 110, .external_lex_state = 2},
  [1441] = {.lex_state = 159},
  [1442] = {.lex_state = 102},
  [1443] = {.lex_state = 102},
  [1444] = {.lex_state = 95},
  [1445] = {.lex_state = 137},
  [1446] = {.lex_state = 102},
  [1447] = {.lex_state = 102},
  [1448] = {.lex_state = 170},
  [1449] = {.lex_state = 170},
  [1450] = {.lex_state = 139},
  [1451] = {.lex_state = 169},
  [1452] = {.lex_state = 170},
  [1453] = {.lex_state = 170},
  [1454] = {.lex_state = 179},
  [1455] = {.lex_state = 148},
  [1456] = {.lex_state = 148},
  [1457] = {.lex_state = 95},
  [1458] = {.lex_state = 148},
  [1459] = {.lex_state = 179},
  [1460] = {.lex_state = 95},
  [1461] = {.lex_state = 179},
  [1462] = {.lex_state = 102},
  [1463] = {.lex_state = 139},
  [1464] = {.lex_state = 169},
  [1465] = {.lex_state = 139},
  [1466] = {.lex_state = 169},
  [1467] = {.lex_state = 169},
  [1468] = {.lex_state = 169},
  [1469] = {.lex_state = 169},
  [1470] = {.lex_state = 139},
  [1471] = {.lex_state = 169},
  [1472] = {.lex_state = 169},
  [1473] = {.lex_state = 139},
  [1474] = {.lex_state = 169},
  [1475] = {.lex_state = 170},
  [1476] = {.lex_state = 139},
  [1477] = {.lex_state = 169},
  [1478] = {.lex_state = 170},
  [1479] = {.lex_state = 139},
  [1480] = {.lex_state = 148},
  [1481] = {.lex_state = 139},
  [1482] = {.lex_state = 95},
  [1483] = {.lex_state = 95},
  [1484] = {.lex_state = 102},
  [1485] = {.lex_state = 130},
  [1486] = {.lex_state = 139},
  [1487] = {.lex_state = 139},
  [1488] = {.lex_state = 139},
  [1489] = {.lex_state = 170},
  [1490] = {.lex_state = 170},
  [1491] = {.lex_state = 170},
  [1492] = {.lex_state = 170},
  [1493] = {.lex_state = 170},
  [1494] = {.lex_state = 187},
  [1495] = {.lex_state = 110},
  [1496] = {.lex_state = 170},
  [1497] = {.lex_state = 148},
  [1498] = {.lex_state = 148},
  [1499] = {.lex_state = 95},
  [1500] = {.lex_state = 148},
  [1501] = {.lex_state = 95},
  [1502] = {.lex_state = 170},
  [1503] = {.lex_state = 102},
  [1504] = {.lex_state = 169},
  [1505] = {.lex_state = 169},
  [1506] = {.lex_state = 95},
  [1507] = {.lex_state = 95},
  [1508] = {.lex_state = 169},
  [1509] = {.lex_state = 130},
  [1510] = {.lex_state = 139},
  [1511] = {.lex_state = 139},
  [1512] = {.lex_state = 170},
  [1513] = {.lex_state = 110, .external_lex_state = 2},
  [1514] = {.lex_state = 169},
  [1515] = {.lex_state = 169},
  [1516] = {.lex_state = 169},
  [1517] = {.lex_state = 169},
  [1518] = {.lex_state = 169},
  [1519] = {.lex_state = 170},
  [1520] = {.lex_state = 139},
  [1521] = {.lex_state = 139},
  [1522] = {.lex_state = 139},
  [1523] = {.lex_state = 139},
  [1524] = {.lex_state = 139},
  [1525] = {.lex_state = 169},
  [1526] = {.lex_state = 139},
  [1527] = {.lex_state = 139},
  [1528] = {.lex_state = 169},
  [1529] = {.lex_state = 139},
  [1530] = {.lex_state = 110, .external_lex_state = 2},
  [1531] = {.lex_state = 110, .external_lex_state = 2},
  [1532] = {.lex_state = 110, .external_lex_state = 2},
  [1533] = {.lex_state = 110, .external_lex_state = 2},
  [1534] = {.lex_state = 130},
  [1535] = {.lex_state = 95, .external_lex_state = 2},
  [1536] = {.lex_state = 162, .external_lex_state = 2},
  [1537] = {.lex_state = 137},
  [1538] = {.lex_state = 95},
  [1539] = {.lex_state = 137},
  [1540] = {.lex_state = 137},
  [1541] = {.lex_state = 137},
  [1542] = {.lex_state = 134},
  [1543] = {.lex_state = 134},
  [1544] = {.lex_state = 148},
  [1545] = {.lex_state = 148},
  [1546] = {.lex_state = 95},
  [1547] = {.lex_state = 148},
  [1548] = {.lex_state = 134},
  [1549] = {.lex_state = 95},
  [1550] = {.lex_state = 134},
  [1551] = {.lex_state = 102},
  [1552] = {.lex_state = 130},
  [1553] = {.lex_state = 148},
  [1554] = {.lex_state = 148},
  [1555] = {.lex_state = 95},
  [1556] = {.lex_state = 148},
  [1557] = {.lex_state = 130},
  [1558] = {.lex_state = 95},
  [1559] = {.lex_state = 130},
  [1560] = {.lex_state = 102},
  [1561] = {.lex_state = 178},
  [1562] = {.lex_state = 148},
  [1563] = {.lex_state = 95},
  [1564] = {.lex_state = 148},
  [1565] = {.lex_state = 134},
  [1566] = {.lex_state = 95},
  [1567] = {.lex_state = 102},
  [1568] = {.lex_state = 134},
  [1569] = {.lex_state = 102},
  [1570] = {.lex_state = 164},
  [1571] = {.lex_state = 164},
  [1572] = {.lex_state = 164},
  [1573] = {.lex_state = 164},
  [1574] = {.lex_state = 164},
  [1575] = {.lex_state = 130},
  [1576] = {.lex_state = 102, .external_lex_state = 2},
  [1577] = {.lex_state = 130},
  [1578] = {.lex_state = 102, .external_lex_state = 2},
  [1579] = {.lex_state = 130},
  [1580] = {.lex_state = 139},
  [1581] = {.lex_state = 174, .external_lex_state = 2},
  [1582] = {.lex_state = 130},
  [1583] = {.lex_state = 95},
  [1584] = {.lex_state = 174, .external_lex_state = 2},
  [1585] = {.lex_state = 174, .external_lex_state = 2},
  [1586] = {.lex_state = 130},
  [1587] = {.lex_state = 102, .external_lex_state = 2},
  [1588] = {.lex_state = 95},
  [1589] = {.lex_state = 95},
  [1590] = {.lex_state = 95},
  [1591] = {.lex_state = 95},
  [1592] = {.lex_state = 95},
  [1593] = {.lex_state = 95},
  [1594] = {.lex_state = 95},
  [1595] = {.lex_state = 95},
  [1596] = {.lex_state = 95},
  [1597] = {.lex_state = 95},
  [1598] = {.lex_state = 95},
  [1599] = {.lex_state = 130},
  [1600] = {.lex_state = 95},
  [1601] = {.lex_state = 95},
  [1602] = {.lex_state = 95},
  [1603] = {.lex_state = 95},
  [1604] = {.lex_state = 95},
  [1605] = {.lex_state = 134},
  [1606] = {.lex_state = 95},
  [1607] = {.lex_state = 95},
  [1608] = {.lex_state = 95},
  [1609] = {.lex_state = 102, .external_lex_state = 2},
  [1610] = {.lex_state = 95, .external_lex_state = 2},
  [1611] = {.lex_state = 95},
  [1612] = {.lex_state = 95},
  [1613] = {.lex_state = 148},
  [1614] = {.lex_state = 174, .external_lex_state = 2},
  [1615] = {.lex_state = 102, .external_lex_state = 2},
  [1616] = {.lex_state = 102, .external_lex_state = 2},
  [1617] = {.lex_state = 130},
  [1618] = {.lex_state = 102, .external_lex_state = 2},
  [1619] = {.lex_state = 137},
  [1620] = {.lex_state = 171},
  [1621] = {.lex_state = 102, .external_lex_state = 2},
  [1622] = {.lex_state = 102, .external_lex_state = 2},
  [1623] = {.lex_state = 148},
  [1624] = {.lex_state = 148},
  [1625] = {.lex_state = 102},
  [1626] = {.lex_state = 95},
  [1627] = {.lex_state = 148},
  [1628] = {.lex_state = 148},
  [1629] = {.lex_state = 148},
  [1630] = {.lex_state = 171},
  [1631] = {.lex_state = 130},
  [1632] = {.lex_state = 102},
  [1633] = {.lex_state = 148},
  [1634] = {.lex_state = 148},
  [1635] = {.lex_state = 148},
  [1636] = {.lex_state = 102},
  [1637] = {.lex_state = 164},
  [1638] = {.lex_state = 164},
  [1639] = {.lex_state = 95},
  [1640] = {.lex_state = 164},
  [1641] = {.lex_state = 168},
  [1642] = {.lex_state = 168},
  [1643] = {.lex_state = 95},
  [1644] = {.lex_state = 130},
  [1645] = {.lex_state = 95},
  [1646] = {.lex_state = 102},
  [1647] = {.lex_state = 148},
  [1648] = {.lex_state = 148},
  [1649] = {.lex_state = 174, .external_lex_state = 2},
  [1650] = {.lex_state = 130},
  [1651] = {.lex_state = 174, .external_lex_state = 2},
  [1652] = {.lex_state = 137},
  [1653] = {.lex_state = 95},
  [1654] = {.lex_state = 174, .external_lex_state = 2},
  [1655] = {.lex_state = 174, .external_lex_state = 2},
  [1656] = {.lex_state = 174, .external_lex_state = 2},
  [1657] = {.lex_state = 130},
  [1658] = {.lex_state = 179},
  [1659] = {.lex_state = 174, .external_lex_state = 2},
  [1660] = {.lex_state = 130},
  [1661] = {.lex_state = 130},
  [1662] = {.lex_state = 174, .external_lex_state = 2},
  [1663] = {.lex_state = 130},
  [1664] = {.lex_state = 102},
  [1665] = {.lex_state = 95},
  [1666] = {.lex_state = 148},
  [1667] = {.lex_state = 171},
  [1668] = {.lex_state = 148},
  [1669] = {.lex_state = 102},
  [1670] = {.lex_state = 148},
  [1671] = {.lex_state = 148},
  [1672] = {.lex_state = 171},
  [1673] = {.lex_state = 171},
  [1674] = {.lex_state = 178},
  [1675] = {.lex_state = 134},
  [1676] = {.lex_state = 176},
  [1677] = {.lex_state = 102},
  [1678] = {.lex_state = 148},
  [1679] = {.lex_state = 134},
  [1680] = {.lex_state = 130},
  [1681] = {.lex_state = 164},
  [1682] = {.lex_state = 102},
  [1683] = {.lex_state = 102},
  [1684] = {.lex_state = 102},
  [1685] = {.lex_state = 171},
  [1686] = {.lex_state = 134},
  [1687] = {.lex_state = 110, .external_lex_state = 2},
  [1688] = {.lex_state = 137},
  [1689] = {.lex_state = 148},
  [1690] = {.lex_state = 102, .external_lex_state = 2},
  [1691] = {.lex_state = 95},
  [1692] = {.lex_state = 162, .external_lex_state = 2},
  [1693] = {.lex_state = 130},
  [1694] = {.lex_state = 148},
  [1695] = {.lex_state = 148},
  [1696] = {.lex_state = 95},
  [1697] = {.lex_state = 148},
  [1698] = {.lex_state = 130},
  [1699] = {.lex_state = 95},
  [1700] = {.lex_state = 130},
  [1701] = {.lex_state = 102},
  [1702] = {.lex_state = 110},
  [1703] = {.lex_state = 95},
  [1704] = {.lex_state = 95},
  [1705] = {.lex_state = 102},
  [1706] = {.lex_state = 102},
  [1707] = {.lex_state = 102},
  [1708] = {.lex_state = 102},
  [1709] = {.lex_state = 102},
  [1710] = {.lex_state = 102},
  [1711] = {.lex_state = 102},
  [1712] = {.lex_state = 95},
  [1713] = {.lex_state = 110, .external_lex_state = 2},
  [1714] = {.lex_state = 170},
  [1715] = {.lex_state = 169},
  [1716] = {.lex_state = 169},
  [1717] = {.lex_state = 169},
  [1718] = {.lex_state = 169},
  [1719] = {.lex_state = 169},
  [1720] = {.lex_state = 169},
  [1721] = {.lex_state = 170},
  [1722] = {.lex_state = 170},
  [1723] = {.lex_state = 170},
  [1724] = {.lex_state = 110},
  [1725] = {.lex_state = 110},
  [1726] = {.lex_state = 110},
  [1727] = {.lex_state = 110},
  [1728] = {.lex_state = 110},
  [1729] = {.lex_state = 110},
  [1730] = {.lex_state = 148},
  [1731] = {.lex_state = 148},
  [1732] = {.lex_state = 95},
  [1733] = {.lex_state = 148},
  [1734] = {.lex_state = 95},
  [1735] = {.lex_state = 110},
  [1736] = {.lex_state = 102},
  [1737] = {.lex_state = 102},
  [1738] = {.lex_state = 188},
  [1739] = {.lex_state = 102},
  [1740] = {.lex_state = 95},
  [1741] = {.lex_state = 95},
  [1742] = {.lex_state = 137},
  [1743] = {.lex_state = 102},
  [1744] = {.lex_state = 188},
  [1745] = {.lex_state = 130},
  [1746] = {.lex_state = 110},
  [1747] = {.lex_state = 137},
  [1748] = {.lex_state = 95, .external_lex_state = 2},
  [1749] = {.lex_state = 102},
  [1750] = {.lex_state = 95, .external_lex_state = 2},
  [1751] = {.lex_state = 102},
  [1752] = {.lex_state = 95},
  [1753] = {.lex_state = 95},
  [1754] = {.lex_state = 95},
  [1755] = {.lex_state = 95},
  [1756] = {.lex_state = 95},
  [1757] = {.lex_state = 95},
  [1758] = {.lex_state = 110, .external_lex_state = 2},
  [1759] = {.lex_state = 110, .external_lex_state = 2},
  [1760] = {.lex_state = 102},
  [1761] = {.lex_state = 102},
  [1762] = {.lex_state = 110, .external_lex_state = 2},
  [1763] = {.lex_state = 110, .external_lex_state = 2},
  [1764] = {.lex_state = 102, .external_lex_state = 2},
  [1765] = {.lex_state = 102, .external_lex_state = 2},
  [1766] = {.lex_state = 102, .external_lex_state = 2},
  [1767] = {.lex_state = 102, .external_lex_state = 2},
  [1768] = {.lex_state = 102, .external_lex_state = 2},
  [1769] = {.lex_state = 110, .external_lex_state = 2},
  [1770] = {.lex_state = 95},
  [1771] = {.lex_state = 95},
  [1772] = {.lex_state = 95},
  [1773] = {.lex_state = 95},
  [1774] = {.lex_state = 95},
  [1775] = {.lex_state = 148},
  [1776] = {.lex_state = 130},
  [1777] = {.lex_state = 95},
  [1778] = {.lex_state = 95, .external_lex_state = 2},
  [1779] = {.lex_state = 102, .external_lex_state = 2},
  [1780] = {.lex_state = 95},
  [1781] = {.lex_state = 95},
  [1782] = {.lex_state = 102, .external_lex_state = 2},
  [1783] = {.lex_state = 95},
  [1784] = {.lex_state = 102, .external_lex_state = 2},
  [1785] = {.lex_state = 95},
  [1786] = {.lex_state = 95},
  [1787] = {.lex_state = 95},
  [1788] = {.lex_state = 95},
  [1789] = {.lex_state = 95},
  [1790] = {.lex_state = 102, .external_lex_state = 2},
  [1791] = {.lex_state = 95},
  [1792] = {.lex_state = 95},
  [1793] = {.lex_state = 95},
  [1794] = {.lex_state = 110, .external_lex_state = 2},
  [1795] = {.lex_state = 110, .external_lex_state = 2},
  [1796] = {.lex_state = 95},
  [1797] = {.lex_state = 95},
  [1798] = {.lex_state = 95},
  [1799] = {.lex_state = 95},
  [1800] = {.lex_state = 95},
  [1801] = {.lex_state = 95},
  [1802] = {.lex_state = 95},
  [1803] = {.lex_state = 95, .external_lex_state = 2},
  [1804] = {.lex_state = 148},
  [1805] = {.lex_state = 148},
  [1806] = {.lex_state = 102},
  [1807] = {.lex_state = 95},
  [1808] = {.lex_state = 148},
  [1809] = {.lex_state = 148},
  [1810] = {.lex_state = 102},
  [1811] = {.lex_state = 148},
  [1812] = {.lex_state = 148},
  [1813] = {.lex_state = 95},
  [1814] = {.lex_state = 95},
  [1815] = {.lex_state = 95},
  [1816] = {.lex_state = 95},
  [1817] = {.lex_state = 95},
  [1818] = {.lex_state = 95},
  [1819] = {.lex_state = 110},
  [1820] = {.lex_state = 110},
  [1821] = {.lex_state = 102},
  [1822] = {.lex_state = 102},
  [1823] = {.lex_state = 110},
  [1824] = {.lex_state = 110},
  [1825] = {.lex_state = 102},
  [1826] = {.lex_state = 102},
  [1827] = {.lex_state = 102},
  [1828] = {.lex_state = 102},
  [1829] = {.lex_state = 102},
  [1830] = {.lex_state = 110},
  [1831] = {.lex_state = 95},
  [1832] = {.lex_state = 95},
  [1833] = {.lex_state = 95},
  [1834] = {.lex_state = 95},
  [1835] = {.lex_state = 95},
  [1836] = {.lex_state = 148},
  [1837] = {.lex_state = 130},
  [1838] = {.lex_state = 95},
  [1839] = {.lex_state = 95},
  [1840] = {.lex_state = 148},
  [1841] = {.lex_state = 148},
  [1842] = {.lex_state = 148},
  [1843] = {.lex_state = 95},
  [1844] = {.lex_state = 148},
  [1845] = {.lex_state = 110, .external_lex_state = 2},
  [1846] = {.lex_state = 148},
  [1847] = {.lex_state = 110, .external_lex_state = 2},
  [1848] = {.lex_state = 130},
  [1849] = {.lex_state = 162, .external_lex_state = 2},
  [1850] = {.lex_state = 102, .external_lex_state = 2},
  [1851] = {.lex_state = 130},
  [1852] = {.lex_state = 110, .external_lex_state = 2},
  [1853] = {.lex_state = 110, .external_lex_state = 2},
  [1854] = {.lex_state = 110, .external_lex_state = 2},
  [1855] = {.lex_state = 110, .external_lex_state = 2},
  [1856] = {.lex_state = 110, .external_lex_state = 2},
  [1857] = {.lex_state = 102},
  [1858] = {.lex_state = 95},
  [1859] = {.lex_state = 139},
  [1860] = {.lex_state = 110, .external_lex_state = 2},
  [1861] = {.lex_state = 148},
  [1862] = {.lex_state = 148},
  [1863] = {.lex_state = 102},
  [1864] = {.lex_state = 148},
  [1865] = {.lex_state = 148},
  [1866] = {.lex_state = 110, .external_lex_state = 2},
  [1867] = {.lex_state = 130},
  [1868] = {.lex_state = 148},
  [1869] = {.lex_state = 130},
  [1870] = {.lex_state = 95},
  [1871] = {.lex_state = 102, .external_lex_state = 2},
  [1872] = {.lex_state = 110, .external_lex_state = 2},
  [1873] = {.lex_state = 174, .external_lex_state = 2},
  [1874] = {.lex_state = 174, .external_lex_state = 2},
  [1875] = {.lex_state = 174, .external_lex_state = 2},
  [1876] = {.lex_state = 174, .external_lex_state = 2},
  [1877] = {.lex_state = 174, .external_lex_state = 2},
  [1878] = {.lex_state = 174, .external_lex_state = 2},
  [1879] = {.lex_state = 130},
  [1880] = {.lex_state = 169},
  [1881] = {.lex_state = 169},
  [1882] = {.lex_state = 95},
  [1883] = {.lex_state = 169},
  [1884] = {.lex_state = 188},
  [1885] = {.lex_state = 188},
  [1886] = {.lex_state = 95},
  [1887] = {.lex_state = 130},
  [1888] = {.lex_state = 95},
  [1889] = {.lex_state = 102},
  [1890] = {.lex_state = 95},
  [1891] = {.lex_state = 102},
  [1892] = {.lex_state = 102},
  [1893] = {.lex_state = 110, .external_lex_state = 2},
  [1894] = {.lex_state = 95},
  [1895] = {.lex_state = 95},
  [1896] = {.lex_state = 162, .external_lex_state = 2},
  [1897] = {.lex_state = 110, .external_lex_state = 2},
  [1898] = {.lex_state = 162, .external_lex_state = 2},
  [1899] = {.lex_state = 159},
  [1900] = {.lex_state = 159},
  [1901] = {.lex_state = 159},
  [1902] = {.lex_state = 159},
  [1903] = {.lex_state = 159},
  [1904] = {.lex_state = 159},
  [1905] = {.lex_state = 95},
  [1906] = {.lex_state = 95},
  [1907] = {.lex_state = 159},
  [1908] = {.lex_state = 159},
  [1909] = {.lex_state = 159},
  [1910] = {.lex_state = 159},
  [1911] = {.lex_state = 159},
  [1912] = {.lex_state = 110},
  [1913] = {.lex_state = 159},
  [1914] = {.lex_state = 148},
  [1915] = {.lex_state = 148},
  [1916] = {.lex_state = 95},
  [1917] = {.lex_state = 148},
  [1918] = {.lex_state = 95},
  [1919] = {.lex_state = 159},
  [1920] = {.lex_state = 102},
  [1921] = {.lex_state = 102},
  [1922] = {.lex_state = 102},
  [1923] = {.lex_state = 95},
  [1924] = {.lex_state = 95},
  [1925] = {.lex_state = 102},
  [1926] = {.lex_state = 130},
  [1927] = {.lex_state = 159},
  [1928] = {.lex_state = 183},
  [1929] = {.lex_state = 139},
  [1930] = {.lex_state = 134},
  [1931] = {.lex_state = 95},
  [1932] = {.lex_state = 148},
  [1933] = {.lex_state = 148},
  [1934] = {.lex_state = 148},
  [1935] = {.lex_state = 95},
  [1936] = {.lex_state = 148},
  [1937] = {.lex_state = 174, .external_lex_state = 2},
  [1938] = {.lex_state = 148},
  [1939] = {.lex_state = 174, .external_lex_state = 2},
  [1940] = {.lex_state = 130},
  [1941] = {.lex_state = 174, .external_lex_state = 2},
  [1942] = {.lex_state = 102, .external_lex_state = 2},
  [1943] = {.lex_state = 130},
  [1944] = {.lex_state = 174, .external_lex_state = 2},
  [1945] = {.lex_state = 174, .external_lex_state = 2},
  [1946] = {.lex_state = 174, .external_lex_state = 2},
  [1947] = {.lex_state = 174, .external_lex_state = 2},
  [1948] = {.lex_state = 174, .external_lex_state = 2},
  [1949] = {.lex_state = 102},
  [1950] = {.lex_state = 95},
  [1951] = {.lex_state = 139},
  [1952] = {.lex_state = 174, .external_lex_state = 2},
  [1953] = {.lex_state = 148},
  [1954] = {.lex_state = 148},
  [1955] = {.lex_state = 102},
  [1956] = {.lex_state = 148},
  [1957] = {.lex_state = 148},
  [1958] = {.lex_state = 174, .external_lex_state = 2},
  [1959] = {.lex_state = 130},
  [1960] = {.lex_state = 148},
  [1961] = {.lex_state = 166},
  [1962] = {.lex_state = 166},
  [1963] = {.lex_state = 166},
  [1964] = {.lex_state = 102},
  [1965] = {.lex_state = 148},
  [1966] = {.lex_state = 148},
  [1967] = {.lex_state = 102},
  [1968] = {.lex_state = 95},
  [1969] = {.lex_state = 148},
  [1970] = {.lex_state = 148},
  [1971] = {.lex_state = 102},
  [1972] = {.lex_state = 148},
  [1973] = {.lex_state = 148},
  [1974] = {.lex_state = 168},
  [1975] = {.lex_state = 170},
  [1976] = {.lex_state = 170},
  [1977] = {.lex_state = 170},
  [1978] = {.lex_state = 170},
  [1979] = {.lex_state = 170},
  [1980] = {.lex_state = 95},
  [1981] = {.lex_state = 95},
  [1982] = {.lex_state = 170},
  [1983] = {.lex_state = 170},
  [1984] = {.lex_state = 170},
  [1985] = {.lex_state = 170},
  [1986] = {.lex_state = 110},
  [1987] = {.lex_state = 170},
  [1988] = {.lex_state = 148},
  [1989] = {.lex_state = 148},
  [1990] = {.lex_state = 95},
  [1991] = {.lex_state = 148},
  [1992] = {.lex_state = 95},
  [1993] = {.lex_state = 170},
  [1994] = {.lex_state = 102},
  [1995] = {.lex_state = 169},
  [1996] = {.lex_state = 169},
  [1997] = {.lex_state = 95},
  [1998] = {.lex_state = 95},
  [1999] = {.lex_state = 169},
  [2000] = {.lex_state = 130},
  [2001] = {.lex_state = 170},
  [2002] = {.lex_state = 110, .external_lex_state = 2},
  [2003] = {.lex_state = 95},
  [2004] = {.lex_state = 95},
  [2005] = {.lex_state = 95},
  [2006] = {.lex_state = 95},
  [2007] = {.lex_state = 95},
  [2008] = {.lex_state = 95},
  [2009] = {.lex_state = 164},
  [2010] = {.lex_state = 168},
  [2011] = {.lex_state = 168},
  [2012] = {.lex_state = 102},
  [2013] = {.lex_state = 102},
  [2014] = {.lex_state = 168},
  [2015] = {.lex_state = 168},
  [2016] = {.lex_state = 164},
  [2017] = {.lex_state = 164},
  [2018] = {.lex_state = 164},
  [2019] = {.lex_state = 164},
  [2020] = {.lex_state = 164},
  [2021] = {.lex_state = 168},
  [2022] = {.lex_state = 95},
  [2023] = {.lex_state = 95},
  [2024] = {.lex_state = 95},
  [2025] = {.lex_state = 95},
  [2026] = {.lex_state = 95},
  [2027] = {.lex_state = 95},
  [2028] = {.lex_state = 148},
  [2029] = {.lex_state = 130},
  [2030] = {.lex_state = 95},
  [2031] = {.lex_state = 130},
  [2032] = {.lex_state = 137},
  [2033] = {.lex_state = 102},
  [2034] = {.lex_state = 102},
  [2035] = {.lex_state = 137},
  [2036] = {.lex_state = 102},
  [2037] = {.lex_state = 95},
  [2038] = {.lex_state = 95},
  [2039] = {.lex_state = 95},
  [2040] = {.lex_state = 102, .external_lex_state = 2},
  [2041] = {.lex_state = 95},
  [2042] = {.lex_state = 95},
  [2043] = {.lex_state = 95},
  [2044] = {.lex_state = 110, .external_lex_state = 2},
  [2045] = {.lex_state = 110, .external_lex_state = 2},
  [2046] = {.lex_state = 95},
  [2047] = {.lex_state = 137},
  [2048] = {.lex_state = 137},
  [2049] = {.lex_state = 137},
  [2050] = {.lex_state = 137},
  [2051] = {.lex_state = 95},
  [2052] = {.lex_state = 148},
  [2053] = {.lex_state = 148},
  [2054] = {.lex_state = 102},
  [2055] = {.lex_state = 95},
  [2056] = {.lex_state = 137},
  [2057] = {.lex_state = 148},
  [2058] = {.lex_state = 148},
  [2059] = {.lex_state = 102},
  [2060] = {.lex_state = 148},
  [2061] = {.lex_state = 148},
  [2062] = {.lex_state = 134, .external_lex_state = 2},
  [2063] = {.lex_state = 95},
  [2064] = {.lex_state = 137},
  [2065] = {.lex_state = 137},
  [2066] = {.lex_state = 102},
  [2067] = {.lex_state = 95},
  [2068] = {.lex_state = 95},
  [2069] = {.lex_state = 102},
  [2070] = {.lex_state = 102},
  [2071] = {.lex_state = 102},
  [2072] = {.lex_state = 95},
  [2073] = {.lex_state = 95},
  [2074] = {.lex_state = 95},
  [2075] = {.lex_state = 95},
  [2076] = {.lex_state = 95},
  [2077] = {.lex_state = 95},
  [2078] = {.lex_state = 169, .external_lex_state = 2},
  [2079] = {.lex_state = 169, .external_lex_state = 2},
  [2080] = {.lex_state = 95},
  [2081] = {.lex_state = 95},
  [2082] = {.lex_state = 169, .external_lex_state = 2},
  [2083] = {.lex_state = 169, .external_lex_state = 2},
  [2084] = {.lex_state = 95},
  [2085] = {.lex_state = 170, .external_lex_state = 2},
  [2086] = {.lex_state = 130},
  [2087] = {.lex_state = 169, .external_lex_state = 2},
  [2088] = {.lex_state = 95},
  [2089] = {.lex_state = 102},
  [2090] = {.lex_state = 170, .external_lex_state = 2},
  [2091] = {.lex_state = 169, .external_lex_state = 2},
  [2092] = {.lex_state = 139},
  [2093] = {.lex_state = 170, .external_lex_state = 2},
  [2094] = {.lex_state = 95},
  [2095] = {.lex_state = 170, .external_lex_state = 2},
  [2096] = {.lex_state = 169},
  [2097] = {.lex_state = 169},
  [2098] = {.lex_state = 95},
  [2099] = {.lex_state = 95},
  [2100] = {.lex_state = 169},
  [2101] = {.lex_state = 169},
  [2102] = {.lex_state = 95},
  [2103] = {.lex_state = 170},
  [2104] = {.lex_state = 130},
  [2105] = {.lex_state = 169},
  [2106] = {.lex_state = 95},
  [2107] = {.lex_state = 102},
  [2108] = {.lex_state = 170},
  [2109] = {.lex_state = 169},
  [2110] = {.lex_state = 170},
  [2111] = {.lex_state = 95},
  [2112] = {.lex_state = 170},
  [2113] = {.lex_state = 95},
  [2114] = {.lex_state = 95},
  [2115] = {.lex_state = 95},
  [2116] = {.lex_state = 95},
  [2117] = {.lex_state = 170},
  [2118] = {.lex_state = 139},
  [2119] = {.lex_state = 170},
  [2120] = {.lex_state = 170, .external_lex_state = 2},
  [2121] = {.lex_state = 139},
  [2122] = {.lex_state = 170},
  [2123] = {.lex_state = 170, .external_lex_state = 2},
  [2124] = {.lex_state = 139},
  [2125] = {.lex_state = 102, .external_lex_state = 2},
  [2126] = {.lex_state = 102, .external_lex_state = 2},
  [2127] = {.lex_state = 102, .external_lex_state = 2},
  [2128] = {.lex_state = 102, .external_lex_state = 2},
  [2129] = {.lex_state = 102, .external_lex_state = 2},
  [2130] = {.lex_state = 102, .external_lex_state = 2},
  [2131] = {.lex_state = 102, .external_lex_state = 2},
  [2132] = {.lex_state = 102, .external_lex_state = 2},
  [2133] = {.lex_state = 102, .external_lex_state = 2},
  [2134] = {.lex_state = 102, .external_lex_state = 2},
  [2135] = {.lex_state = 102, .external_lex_state = 2},
  [2136] = {.lex_state = 102, .external_lex_state = 2},
  [2137] = {.lex_state = 137},
  [2138] = {.lex_state = 130},
  [2139] = {.lex_state = 166},
  [2140] = {.lex_state = 95},
  [2141] = {.lex_state = 166},
  [2142] = {.lex_state = 166},
  [2143] = {.lex_state = 177},
  [2144] = {.lex_state = 166},
  [2145] = {.lex_state = 168},
  [2146] = {.lex_state = 166},
  [2147] = {.lex_state = 168},
  [2148] = {.lex_state = 95},
  [2149] = {.lex_state = 166},
  [2150] = {.lex_state = 166},
  [2151] = {.lex_state = 95},
  [2152] = {.lex_state = 166},
  [2153] = {.lex_state = 166},
  [2154] = {.lex_state = 166},
  [2155] = {.lex_state = 170},
  [2156] = {.lex_state = 166},
  [2157] = {.lex_state = 95},
  [2158] = {.lex_state = 148},
  [2159] = {.lex_state = 148},
  [2160] = {.lex_state = 148},
  [2161] = {.lex_state = 95},
  [2162] = {.lex_state = 148},
  [2163] = {.lex_state = 166},
  [2164] = {.lex_state = 148},
  [2165] = {.lex_state = 166},
  [2166] = {.lex_state = 130},
  [2167] = {.lex_state = 166},
  [2168] = {.lex_state = 102, .external_lex_state = 2},
  [2169] = {.lex_state = 130},
  [2170] = {.lex_state = 166},
  [2171] = {.lex_state = 166},
  [2172] = {.lex_state = 166},
  [2173] = {.lex_state = 166},
  [2174] = {.lex_state = 166},
  [2175] = {.lex_state = 102},
  [2176] = {.lex_state = 95},
  [2177] = {.lex_state = 139},
  [2178] = {.lex_state = 166},
  [2179] = {.lex_state = 148},
  [2180] = {.lex_state = 148},
  [2181] = {.lex_state = 102},
  [2182] = {.lex_state = 148},
  [2183] = {.lex_state = 148},
  [2184] = {.lex_state = 166},
  [2185] = {.lex_state = 130},
  [2186] = {.lex_state = 148},
  [2187] = {.lex_state = 130},
  [2188] = {.lex_state = 95},
  [2189] = {.lex_state = 164},
  [2190] = {.lex_state = 166},
  [2191] = {.lex_state = 95},
  [2192] = {.lex_state = 95},
  [2193] = {.lex_state = 166},
  [2194] = {.lex_state = 166},
  [2195] = {.lex_state = 110},
  [2196] = {.lex_state = 110},
  [2197] = {.lex_state = 110},
  [2198] = {.lex_state = 110},
  [2199] = {.lex_state = 164},
  [2200] = {.lex_state = 110},
  [2201] = {.lex_state = 110},
  [2202] = {.lex_state = 95},
  [2203] = {.lex_state = 95},
  [2204] = {.lex_state = 180},
  [2205] = {.lex_state = 110},
  [2206] = {.lex_state = 110},
  [2207] = {.lex_state = 130},
  [2208] = {.lex_state = 110},
  [2209] = {.lex_state = 110},
  [2210] = {.lex_state = 110},
  [2211] = {.lex_state = 110},
  [2212] = {.lex_state = 110},
  [2213] = {.lex_state = 148},
  [2214] = {.lex_state = 148},
  [2215] = {.lex_state = 95},
  [2216] = {.lex_state = 148},
  [2217] = {.lex_state = 95},
  [2218] = {.lex_state = 110},
  [2219] = {.lex_state = 102},
  [2220] = {.lex_state = 102},
  [2221] = {.lex_state = 102},
  [2222] = {.lex_state = 95},
  [2223] = {.lex_state = 95},
  [2224] = {.lex_state = 102},
  [2225] = {.lex_state = 130},
  [2226] = {.lex_state = 110},
  [2227] = {.lex_state = 102},
  [2228] = {.lex_state = 148},
  [2229] = {.lex_state = 95},
  [2230] = {.lex_state = 148},
  [2231] = {.lex_state = 130},
  [2232] = {.lex_state = 95},
  [2233] = {.lex_state = 102},
  [2234] = {.lex_state = 130},
  [2235] = {.lex_state = 148},
  [2236] = {.lex_state = 102},
  [2237] = {.lex_state = 130},
  [2238] = {.lex_state = 102},
  [2239] = {.lex_state = 148},
  [2240] = {.lex_state = 130},
  [2241] = {.lex_state = 130},
  [2242] = {.lex_state = 162, .external_lex_state = 2},
  [2243] = {.lex_state = 95},
  [2244] = {.lex_state = 130},
  [2245] = {.lex_state = 95},
  [2246] = {.lex_state = 95},
  [2247] = {.lex_state = 95},
  [2248] = {.lex_state = 95},
  [2249] = {.lex_state = 95},
  [2250] = {.lex_state = 95},
  [2251] = {.lex_state = 95},
  [2252] = {.lex_state = 168},
  [2253] = {.lex_state = 168},
  [2254] = {.lex_state = 102},
  [2255] = {.lex_state = 102},
  [2256] = {.lex_state = 168},
  [2257] = {.lex_state = 168},
  [2258] = {.lex_state = 164},
  [2259] = {.lex_state = 164},
  [2260] = {.lex_state = 164},
  [2261] = {.lex_state = 164},
  [2262] = {.lex_state = 164},
  [2263] = {.lex_state = 168},
  [2264] = {.lex_state = 95},
  [2265] = {.lex_state = 95},
  [2266] = {.lex_state = 95},
  [2267] = {.lex_state = 95},
  [2268] = {.lex_state = 95},
  [2269] = {.lex_state = 174, .external_lex_state = 2},
  [2270] = {.lex_state = 95},
  [2271] = {.lex_state = 148},
  [2272] = {.lex_state = 130},
  [2273] = {.lex_state = 95},
  [2274] = {.lex_state = 102},
  [2275] = {.lex_state = 148},
  [2276] = {.lex_state = 95},
  [2277] = {.lex_state = 102, .external_lex_state = 2},
  [2278] = {.lex_state = 130},
  [2279] = {.lex_state = 134, .external_lex_state = 2},
  [2280] = {.lex_state = 95},
  [2281] = {.lex_state = 134, .external_lex_state = 2},
  [2282] = {.lex_state = 134, .external_lex_state = 2},
  [2283] = {.lex_state = 130},
  [2284] = {.lex_state = 134, .external_lex_state = 2},
  [2285] = {.lex_state = 102, .external_lex_state = 2},
  [2286] = {.lex_state = 102, .external_lex_state = 2},
  [2287] = {.lex_state = 102, .external_lex_state = 2},
  [2288] = {.lex_state = 174, .external_lex_state = 2},
  [2289] = {.lex_state = 130},
  [2290] = {.lex_state = 134, .external_lex_state = 2},
  [2291] = {.lex_state = 134, .external_lex_state = 2},
  [2292] = {.lex_state = 102, .external_lex_state = 2},
  [2293] = {.lex_state = 102, .external_lex_state = 2},
  [2294] = {.lex_state = 95},
  [2295] = {.lex_state = 137},
  [2296] = {.lex_state = 137, .external_lex_state = 2},
  [2297] = {.lex_state = 148},
  [2298] = {.lex_state = 102, .external_lex_state = 2},
  [2299] = {.lex_state = 130},
  [2300] = {.lex_state = 95},
  [2301] = {.lex_state = 134, .external_lex_state = 2},
  [2302] = {.lex_state = 95},
  [2303] = {.lex_state = 134, .external_lex_state = 2},
  [2304] = {.lex_state = 148},
  [2305] = {.lex_state = 137},
  [2306] = {.lex_state = 95},
  [2307] = {.lex_state = 95, .external_lex_state = 2},
  [2308] = {.lex_state = 137},
  [2309] = {.lex_state = 95},
  [2310] = {.lex_state = 137},
  [2311] = {.lex_state = 95},
  [2312] = {.lex_state = 95},
  [2313] = {.lex_state = 137},
  [2314] = {.lex_state = 95},
  [2315] = {.lex_state = 95},
  [2316] = {.lex_state = 95},
  [2317] = {.lex_state = 95},
  [2318] = {.lex_state = 95},
  [2319] = {.lex_state = 159, .external_lex_state = 2},
  [2320] = {.lex_state = 159, .external_lex_state = 2},
  [2321] = {.lex_state = 102},
  [2322] = {.lex_state = 102},
  [2323] = {.lex_state = 159, .external_lex_state = 2},
  [2324] = {.lex_state = 159, .external_lex_state = 2},
  [2325] = {.lex_state = 102, .external_lex_state = 2},
  [2326] = {.lex_state = 102, .external_lex_state = 2},
  [2327] = {.lex_state = 102, .external_lex_state = 2},
  [2328] = {.lex_state = 102, .external_lex_state = 2},
  [2329] = {.lex_state = 102, .external_lex_state = 2},
  [2330] = {.lex_state = 159, .external_lex_state = 2},
  [2331] = {.lex_state = 95},
  [2332] = {.lex_state = 95},
  [2333] = {.lex_state = 95},
  [2334] = {.lex_state = 95},
  [2335] = {.lex_state = 95},
  [2336] = {.lex_state = 148},
  [2337] = {.lex_state = 130},
  [2338] = {.lex_state = 95},
  [2339] = {.lex_state = 137},
  [2340] = {.lex_state = 170},
  [2341] = {.lex_state = 139},
  [2342] = {.lex_state = 139},
  [2343] = {.lex_state = 174},
  [2344] = {.lex_state = 95},
  [2345] = {.lex_state = 102},
  [2346] = {.lex_state = 95},
  [2347] = {.lex_state = 130},
  [2348] = {.lex_state = 130},
  [2349] = {.lex_state = 95},
  [2350] = {.lex_state = 95},
  [2351] = {.lex_state = 95},
  [2352] = {.lex_state = 95},
  [2353] = {.lex_state = 95},
  [2354] = {.lex_state = 102},
  [2355] = {.lex_state = 95},
  [2356] = {.lex_state = 134},
  [2357] = {.lex_state = 95},
  [2358] = {.lex_state = 95},
  [2359] = {.lex_state = 95},
  [2360] = {.lex_state = 95},
  [2361] = {.lex_state = 95},
  [2362] = {.lex_state = 95},
  [2363] = {.lex_state = 95},
  [2364] = {.lex_state = 95},
  [2365] = {.lex_state = 95},
  [2366] = {.lex_state = 95},
  [2367] = {.lex_state = 95},
  [2368] = {.lex_state = 102, .external_lex_state = 2},
  [2369] = {.lex_state = 102},
  [2370] = {.lex_state = 102},
  [2371] = {.lex_state = 139},
  [2372] = {.lex_state = 95},
  [2373] = {.lex_state = 95},
  [2374] = {.lex_state = 95},
  [2375] = {.lex_state = 95},
  [2376] = {.lex_state = 102},
  [2377] = {.lex_state = 130},
  [2378] = {.lex_state = 110, .external_lex_state = 2},
  [2379] = {.lex_state = 102},
  [2380] = {.lex_state = 102},
  [2381] = {.lex_state = 95},
  [2382] = {.lex_state = 95},
  [2383] = {.lex_state = 102},
  [2384] = {.lex_state = 102},
  [2385] = {.lex_state = 95},
  [2386] = {.lex_state = 110},
  [2387] = {.lex_state = 130},
  [2388] = {.lex_state = 102},
  [2389] = {.lex_state = 95},
  [2390] = {.lex_state = 102},
  [2391] = {.lex_state = 110},
  [2392] = {.lex_state = 102},
  [2393] = {.lex_state = 102},
  [2394] = {.lex_state = 110},
  [2395] = {.lex_state = 95},
  [2396] = {.lex_state = 110},
  [2397] = {.lex_state = 137},
  [2398] = {.lex_state = 137},
  [2399] = {.lex_state = 102},
  [2400] = {.lex_state = 139},
  [2401] = {.lex_state = 148},
  [2402] = {.lex_state = 148},
  [2403] = {.lex_state = 102},
  [2404] = {.lex_state = 95},
  [2405] = {.lex_state = 148},
  [2406] = {.lex_state = 148},
  [2407] = {.lex_state = 102},
  [2408] = {.lex_state = 148},
  [2409] = {.lex_state = 148},
  [2410] = {.lex_state = 139},
  [2411] = {.lex_state = 169},
  [2412] = {.lex_state = 139},
  [2413] = {.lex_state = 169},
  [2414] = {.lex_state = 139},
  [2415] = {.lex_state = 139},
  [2416] = {.lex_state = 169},
  [2417] = {.lex_state = 139},
  [2418] = {.lex_state = 139},
  [2419] = {.lex_state = 169},
  [2420] = {.lex_state = 139},
  [2421] = {.lex_state = 139},
  [2422] = {.lex_state = 139},
  [2423] = {.lex_state = 148},
  [2424] = {.lex_state = 148},
  [2425] = {.lex_state = 95},
  [2426] = {.lex_state = 148},
  [2427] = {.lex_state = 139},
  [2428] = {.lex_state = 95},
  [2429] = {.lex_state = 139},
  [2430] = {.lex_state = 102},
  [2431] = {.lex_state = 170},
  [2432] = {.lex_state = 170},
  [2433] = {.lex_state = 170},
  [2434] = {.lex_state = 139},
  [2435] = {.lex_state = 102},
  [2436] = {.lex_state = 130},
  [2437] = {.lex_state = 95},
  [2438] = {.lex_state = 148},
  [2439] = {.lex_state = 148},
  [2440] = {.lex_state = 102},
  [2441] = {.lex_state = 95},
  [2442] = {.lex_state = 148},
  [2443] = {.lex_state = 148},
  [2444] = {.lex_state = 102},
  [2445] = {.lex_state = 148},
  [2446] = {.lex_state = 148},
  [2447] = {.lex_state = 130},
  [2448] = {.lex_state = 169},
  [2449] = {.lex_state = 169},
  [2450] = {.lex_state = 139},
  [2451] = {.lex_state = 169},
  [2452] = {.lex_state = 169},
  [2453] = {.lex_state = 169},
  [2454] = {.lex_state = 169},
  [2455] = {.lex_state = 139},
  [2456] = {.lex_state = 169},
  [2457] = {.lex_state = 169},
  [2458] = {.lex_state = 139},
  [2459] = {.lex_state = 169},
  [2460] = {.lex_state = 139},
  [2461] = {.lex_state = 139},
  [2462] = {.lex_state = 139},
  [2463] = {.lex_state = 137},
  [2464] = {.lex_state = 162, .external_lex_state = 2},
  [2465] = {.lex_state = 139},
  [2466] = {.lex_state = 148},
  [2467] = {.lex_state = 148},
  [2468] = {.lex_state = 102},
  [2469] = {.lex_state = 95},
  [2470] = {.lex_state = 148},
  [2471] = {.lex_state = 148},
  [2472] = {.lex_state = 102},
  [2473] = {.lex_state = 148},
  [2474] = {.lex_state = 148},
  [2475] = {.lex_state = 148},
  [2476] = {.lex_state = 148},
  [2477] = {.lex_state = 102},
  [2478] = {.lex_state = 95},
  [2479] = {.lex_state = 148},
  [2480] = {.lex_state = 171},
  [2481] = {.lex_state = 148},
  [2482] = {.lex_state = 102},
  [2483] = {.lex_state = 148},
  [2484] = {.lex_state = 148},
  [2485] = {.lex_state = 102},
  [2486] = {.lex_state = 95},
  [2487] = {.lex_state = 148},
  [2488] = {.lex_state = 148},
  [2489] = {.lex_state = 102},
  [2490] = {.lex_state = 148},
  [2491] = {.lex_state = 95},
  [2492] = {.lex_state = 95},
  [2493] = {.lex_state = 102},
  [2494] = {.lex_state = 137},
  [2495] = {.lex_state = 171},
  [2496] = {.lex_state = 102, .external_lex_state = 2},
  [2497] = {.lex_state = 95},
  [2498] = {.lex_state = 102, .external_lex_state = 2},
  [2499] = {.lex_state = 139},
  [2500] = {.lex_state = 139},
  [2501] = {.lex_state = 102, .external_lex_state = 2},
  [2502] = {.lex_state = 139},
  [2503] = {.lex_state = 130},
  [2504] = {.lex_state = 174, .external_lex_state = 2},
  [2505] = {.lex_state = 95},
  [2506] = {.lex_state = 174, .external_lex_state = 2},
  [2507] = {.lex_state = 174, .external_lex_state = 2},
  [2508] = {.lex_state = 130},
  [2509] = {.lex_state = 174, .external_lex_state = 2},
  [2510] = {.lex_state = 102, .external_lex_state = 2},
  [2511] = {.lex_state = 102, .external_lex_state = 2},
  [2512] = {.lex_state = 102, .external_lex_state = 2},
  [2513] = {.lex_state = 102, .external_lex_state = 2},
  [2514] = {.lex_state = 130},
  [2515] = {.lex_state = 110, .external_lex_state = 2},
  [2516] = {.lex_state = 95},
  [2517] = {.lex_state = 102, .external_lex_state = 2},
  [2518] = {.lex_state = 95},
  [2519] = {.lex_state = 102},
  [2520] = {.lex_state = 95},
  [2521] = {.lex_state = 102, .external_lex_state = 2},
  [2522] = {.lex_state = 95, .external_lex_state = 2},
  [2523] = {.lex_state = 95},
  [2524] = {.lex_state = 95},
  [2525] = {.lex_state = 102, .external_lex_state = 2},
  [2526] = {.lex_state = 95},
  [2527] = {.lex_state = 134},
  [2528] = {.lex_state = 102},
  [2529] = {.lex_state = 95},
  [2530] = {.lex_state = 95},
  [2531] = {.lex_state = 102, .external_lex_state = 2},
  [2532] = {.lex_state = 95},
  [2533] = {.lex_state = 137, .external_lex_state = 2},
  [2534] = {.lex_state = 148},
  [2535] = {.lex_state = 148},
  [2536] = {.lex_state = 95},
  [2537] = {.lex_state = 148},
  [2538] = {.lex_state = 137, .external_lex_state = 2},
  [2539] = {.lex_state = 95},
  [2540] = {.lex_state = 137, .external_lex_state = 2},
  [2541] = {.lex_state = 102},
  [2542] = {.lex_state = 130},
  [2543] = {.lex_state = 102, .external_lex_state = 2},
  [2544] = {.lex_state = 102, .external_lex_state = 2},
  [2545] = {.lex_state = 102, .external_lex_state = 2},
  [2546] = {.lex_state = 148},
  [2547] = {.lex_state = 95},
  [2548] = {.lex_state = 148},
  [2549] = {.lex_state = 130},
  [2550] = {.lex_state = 95},
  [2551] = {.lex_state = 102},
  [2552] = {.lex_state = 130},
  [2553] = {.lex_state = 148},
  [2554] = {.lex_state = 102},
  [2555] = {.lex_state = 130},
  [2556] = {.lex_state = 171},
  [2557] = {.lex_state = 130},
  [2558] = {.lex_state = 148},
  [2559] = {.lex_state = 130},
  [2560] = {.lex_state = 130},
  [2561] = {.lex_state = 134},
  [2562] = {.lex_state = 148},
  [2563] = {.lex_state = 130},
  [2564] = {.lex_state = 95},
  [2565] = {.lex_state = 168},
  [2566] = {.lex_state = 164},
  [2567] = {.lex_state = 95},
  [2568] = {.lex_state = 102},
  [2569] = {.lex_state = 102},
  [2570] = {.lex_state = 148},
  [2571] = {.lex_state = 95},
  [2572] = {.lex_state = 148},
  [2573] = {.lex_state = 139},
  [2574] = {.lex_state = 95},
  [2575] = {.lex_state = 102},
  [2576] = {.lex_state = 139},
  [2577] = {.lex_state = 164},
  [2578] = {.lex_state = 164},
  [2579] = {.lex_state = 164},
  [2580] = {.lex_state = 164},
  [2581] = {.lex_state = 164},
  [2582] = {.lex_state = 168},
  [2583] = {.lex_state = 174, .external_lex_state = 2},
  [2584] = {.lex_state = 174, .external_lex_state = 2},
  [2585] = {.lex_state = 174, .external_lex_state = 2},
  [2586] = {.lex_state = 174, .external_lex_state = 2},
  [2587] = {.lex_state = 174, .external_lex_state = 2},
  [2588] = {.lex_state = 174, .external_lex_state = 2},
  [2589] = {.lex_state = 130},
  [2590] = {.lex_state = 130},
  [2591] = {.lex_state = 130},
  [2592] = {.lex_state = 95},
  [2593] = {.lex_state = 174, .external_lex_state = 2},
  [2594] = {.lex_state = 130},
  [2595] = {.lex_state = 174, .external_lex_state = 2},
  [2596] = {.lex_state = 174, .external_lex_state = 2},
  [2597] = {.lex_state = 130},
  [2598] = {.lex_state = 130},
  [2599] = {.lex_state = 174, .external_lex_state = 2},
  [2600] = {.lex_state = 102, .external_lex_state = 2},
  [2601] = {.lex_state = 102, .external_lex_state = 2},
  [2602] = {.lex_state = 95},
  [2603] = {.lex_state = 130},
  [2604] = {.lex_state = 148},
  [2605] = {.lex_state = 102},
  [2606] = {.lex_state = 148},
  [2607] = {.lex_state = 139},
  [2608] = {.lex_state = 139},
  [2609] = {.lex_state = 178},
  [2610] = {.lex_state = 148},
  [2611] = {.lex_state = 134},
  [2612] = {.lex_state = 171},
  [2613] = {.lex_state = 164},
  [2614] = {.lex_state = 95},
  [2615] = {.lex_state = 134, .external_lex_state = 2},
  [2616] = {.lex_state = 148},
  [2617] = {.lex_state = 148},
  [2618] = {.lex_state = 95},
  [2619] = {.lex_state = 148},
  [2620] = {.lex_state = 134, .external_lex_state = 2},
  [2621] = {.lex_state = 95},
  [2622] = {.lex_state = 134, .external_lex_state = 2},
  [2623] = {.lex_state = 102},
  [2624] = {.lex_state = 162, .external_lex_state = 2},
  [2625] = {.lex_state = 148},
  [2626] = {.lex_state = 148},
  [2627] = {.lex_state = 102},
  [2628] = {.lex_state = 95},
  [2629] = {.lex_state = 148},
  [2630] = {.lex_state = 148},
  [2631] = {.lex_state = 102},
  [2632] = {.lex_state = 148},
  [2633] = {.lex_state = 148},
  [2634] = {.lex_state = 95},
  [2635] = {.lex_state = 95},
  [2636] = {.lex_state = 169},
  [2637] = {.lex_state = 139},
  [2638] = {.lex_state = 95},
  [2639] = {.lex_state = 148},
  [2640] = {.lex_state = 148},
  [2641] = {.lex_state = 102},
  [2642] = {.lex_state = 95},
  [2643] = {.lex_state = 148},
  [2644] = {.lex_state = 148},
  [2645] = {.lex_state = 102},
  [2646] = {.lex_state = 148},
  [2647] = {.lex_state = 148},
  [2648] = {.lex_state = 130},
  [2649] = {.lex_state = 95},
  [2650] = {.lex_state = 102},
  [2651] = {.lex_state = 188},
  [2652] = {.lex_state = 95, .external_lex_state = 2},
  [2653] = {.lex_state = 102},
  [2654] = {.lex_state = 102},
  [2655] = {.lex_state = 102},
  [2656] = {.lex_state = 110, .external_lex_state = 2},
  [2657] = {.lex_state = 110, .external_lex_state = 2},
  [2658] = {.lex_state = 110, .external_lex_state = 2},
  [2659] = {.lex_state = 110, .external_lex_state = 2},
  [2660] = {.lex_state = 110, .external_lex_state = 2},
  [2661] = {.lex_state = 110, .external_lex_state = 2},
  [2662] = {.lex_state = 95},
  [2663] = {.lex_state = 95},
  [2664] = {.lex_state = 110, .external_lex_state = 2},
  [2665] = {.lex_state = 110, .external_lex_state = 2},
  [2666] = {.lex_state = 110, .external_lex_state = 2},
  [2667] = {.lex_state = 110, .external_lex_state = 2},
  [2668] = {.lex_state = 110},
  [2669] = {.lex_state = 110, .external_lex_state = 2},
  [2670] = {.lex_state = 148},
  [2671] = {.lex_state = 148},
  [2672] = {.lex_state = 95},
  [2673] = {.lex_state = 148},
  [2674] = {.lex_state = 95},
  [2675] = {.lex_state = 110, .external_lex_state = 2},
  [2676] = {.lex_state = 102},
  [2677] = {.lex_state = 102, .external_lex_state = 2},
  [2678] = {.lex_state = 110, .external_lex_state = 2},
  [2679] = {.lex_state = 102, .external_lex_state = 2},
  [2680] = {.lex_state = 95},
  [2681] = {.lex_state = 95},
  [2682] = {.lex_state = 137},
  [2683] = {.lex_state = 102, .external_lex_state = 2},
  [2684] = {.lex_state = 110, .external_lex_state = 2},
  [2685] = {.lex_state = 130},
  [2686] = {.lex_state = 110, .external_lex_state = 2},
  [2687] = {.lex_state = 137},
  [2688] = {.lex_state = 95},
  [2689] = {.lex_state = 95},
  [2690] = {.lex_state = 95},
  [2691] = {.lex_state = 95},
  [2692] = {.lex_state = 102},
  [2693] = {.lex_state = 95},
  [2694] = {.lex_state = 134},
  [2695] = {.lex_state = 95},
  [2696] = {.lex_state = 95},
  [2697] = {.lex_state = 95},
  [2698] = {.lex_state = 95},
  [2699] = {.lex_state = 95},
  [2700] = {.lex_state = 95},
  [2701] = {.lex_state = 95},
  [2702] = {.lex_state = 95},
  [2703] = {.lex_state = 95},
  [2704] = {.lex_state = 95},
  [2705] = {.lex_state = 95},
  [2706] = {.lex_state = 95},
  [2707] = {.lex_state = 95},
  [2708] = {.lex_state = 102, .external_lex_state = 2},
  [2709] = {.lex_state = 102},
  [2710] = {.lex_state = 102},
  [2711] = {.lex_state = 139},
  [2712] = {.lex_state = 95},
  [2713] = {.lex_state = 95},
  [2714] = {.lex_state = 95},
  [2715] = {.lex_state = 95},
  [2716] = {.lex_state = 102},
  [2717] = {.lex_state = 95},
  [2718] = {.lex_state = 95},
  [2719] = {.lex_state = 95, .external_lex_state = 2},
  [2720] = {.lex_state = 95},
  [2721] = {.lex_state = 95},
  [2722] = {.lex_state = 137},
  [2723] = {.lex_state = 148},
  [2724] = {.lex_state = 95},
  [2725] = {.lex_state = 148},
  [2726] = {.lex_state = 134},
  [2727] = {.lex_state = 95},
  [2728] = {.lex_state = 102},
  [2729] = {.lex_state = 134},
  [2730] = {.lex_state = 148},
  [2731] = {.lex_state = 102},
  [2732] = {.lex_state = 148},
  [2733] = {.lex_state = 134},
  [2734] = {.lex_state = 134},
  [2735] = {.lex_state = 110},
  [2736] = {.lex_state = 110},
  [2737] = {.lex_state = 110},
  [2738] = {.lex_state = 110},
  [2739] = {.lex_state = 110},
  [2740] = {.lex_state = 110},
  [2741] = {.lex_state = 95},
  [2742] = {.lex_state = 95},
  [2743] = {.lex_state = 110},
  [2744] = {.lex_state = 110},
  [2745] = {.lex_state = 110},
  [2746] = {.lex_state = 110},
  [2747] = {.lex_state = 110},
  [2748] = {.lex_state = 110},
  [2749] = {.lex_state = 148},
  [2750] = {.lex_state = 148},
  [2751] = {.lex_state = 95},
  [2752] = {.lex_state = 148},
  [2753] = {.lex_state = 95},
  [2754] = {.lex_state = 110},
  [2755] = {.lex_state = 102},
  [2756] = {.lex_state = 102},
  [2757] = {.lex_state = 102},
  [2758] = {.lex_state = 95},
  [2759] = {.lex_state = 95},
  [2760] = {.lex_state = 102},
  [2761] = {.lex_state = 130},
  [2762] = {.lex_state = 110, .external_lex_state = 2},
  [2763] = {.lex_state = 110},
  [2764] = {.lex_state = 110, .external_lex_state = 2},
  [2765] = {.lex_state = 130},
  [2766] = {.lex_state = 134},
  [2767] = {.lex_state = 110, .external_lex_state = 2},
  [2768] = {.lex_state = 110, .external_lex_state = 2},
  [2769] = {.lex_state = 102, .external_lex_state = 2},
  [2770] = {.lex_state = 137},
  [2771] = {.lex_state = 162, .external_lex_state = 2},
  [2772] = {.lex_state = 102, .external_lex_state = 2},
  [2773] = {.lex_state = 110, .external_lex_state = 2},
  [2774] = {.lex_state = 130},
  [2775] = {.lex_state = 148},
  [2776] = {.lex_state = 102},
  [2777] = {.lex_state = 110, .external_lex_state = 2},
  [2778] = {.lex_state = 110, .external_lex_state = 2},
  [2779] = {.lex_state = 110, .external_lex_state = 2},
  [2780] = {.lex_state = 148},
  [2781] = {.lex_state = 110, .external_lex_state = 2},
  [2782] = {.lex_state = 130},
  [2783] = {.lex_state = 110, .external_lex_state = 2},
  [2784] = {.lex_state = 110, .external_lex_state = 2},
  [2785] = {.lex_state = 130},
  [2786] = {.lex_state = 95},
  [2787] = {.lex_state = 102},
  [2788] = {.lex_state = 173, .external_lex_state = 2},
  [2789] = {.lex_state = 95},
  [2790] = {.lex_state = 130},
  [2791] = {.lex_state = 95},
  [2792] = {.lex_state = 188},
  [2793] = {.lex_state = 169},
  [2794] = {.lex_state = 95},
  [2795] = {.lex_state = 102},
  [2796] = {.lex_state = 102},
  [2797] = {.lex_state = 102},
  [2798] = {.lex_state = 162, .external_lex_state = 2},
  [2799] = {.lex_state = 95},
  [2800] = {.lex_state = 159},
  [2801] = {.lex_state = 159},
  [2802] = {.lex_state = 95},
  [2803] = {.lex_state = 148},
  [2804] = {.lex_state = 148},
  [2805] = {.lex_state = 102},
  [2806] = {.lex_state = 95},
  [2807] = {.lex_state = 148},
  [2808] = {.lex_state = 148},
  [2809] = {.lex_state = 102},
  [2810] = {.lex_state = 148},
  [2811] = {.lex_state = 148},
  [2812] = {.lex_state = 130},
  [2813] = {.lex_state = 102},
  [2814] = {.lex_state = 183},
  [2815] = {.lex_state = 148},
  [2816] = {.lex_state = 95},
  [2817] = {.lex_state = 148},
  [2818] = {.lex_state = 134, .external_lex_state = 2},
  [2819] = {.lex_state = 95},
  [2820] = {.lex_state = 102},
  [2821] = {.lex_state = 130},
  [2822] = {.lex_state = 134},
  [2823] = {.lex_state = 174, .external_lex_state = 2},
  [2824] = {.lex_state = 134, .external_lex_state = 2},
  [2825] = {.lex_state = 102, .external_lex_state = 2},
  [2826] = {.lex_state = 137},
  [2827] = {.lex_state = 174, .external_lex_state = 2},
  [2828] = {.lex_state = 102, .external_lex_state = 2},
  [2829] = {.lex_state = 174, .external_lex_state = 2},
  [2830] = {.lex_state = 130},
  [2831] = {.lex_state = 95},
  [2832] = {.lex_state = 148},
  [2833] = {.lex_state = 102},
  [2834] = {.lex_state = 174, .external_lex_state = 2},
  [2835] = {.lex_state = 174, .external_lex_state = 2},
  [2836] = {.lex_state = 174, .external_lex_state = 2},
  [2837] = {.lex_state = 148},
  [2838] = {.lex_state = 134, .external_lex_state = 2},
  [2839] = {.lex_state = 130},
  [2840] = {.lex_state = 174, .external_lex_state = 2},
  [2841] = {.lex_state = 134, .external_lex_state = 2},
  [2842] = {.lex_state = 166},
  [2843] = {.lex_state = 148},
  [2844] = {.lex_state = 95},
  [2845] = {.lex_state = 148},
  [2846] = {.lex_state = 134},
  [2847] = {.lex_state = 95},
  [2848] = {.lex_state = 102},
  [2849] = {.lex_state = 134},
  [2850] = {.lex_state = 148},
  [2851] = {.lex_state = 102},
  [2852] = {.lex_state = 148},
  [2853] = {.lex_state = 134},
  [2854] = {.lex_state = 134},
  [2855] = {.lex_state = 170},
  [2856] = {.lex_state = 170},
  [2857] = {.lex_state = 95},
  [2858] = {.lex_state = 148},
  [2859] = {.lex_state = 148},
  [2860] = {.lex_state = 102},
  [2861] = {.lex_state = 95},
  [2862] = {.lex_state = 148},
  [2863] = {.lex_state = 148},
  [2864] = {.lex_state = 102},
  [2865] = {.lex_state = 148},
  [2866] = {.lex_state = 148},
  [2867] = {.lex_state = 130},
  [2868] = {.lex_state = 169},
  [2869] = {.lex_state = 168},
  [2870] = {.lex_state = 168},
  [2871] = {.lex_state = 168},
  [2872] = {.lex_state = 168},
  [2873] = {.lex_state = 168},
  [2874] = {.lex_state = 168},
  [2875] = {.lex_state = 95},
  [2876] = {.lex_state = 95},
  [2877] = {.lex_state = 168},
  [2878] = {.lex_state = 168},
  [2879] = {.lex_state = 168},
  [2880] = {.lex_state = 168},
  [2881] = {.lex_state = 168},
  [2882] = {.lex_state = 110},
  [2883] = {.lex_state = 168},
  [2884] = {.lex_state = 148},
  [2885] = {.lex_state = 148},
  [2886] = {.lex_state = 95},
  [2887] = {.lex_state = 148},
  [2888] = {.lex_state = 95},
  [2889] = {.lex_state = 168},
  [2890] = {.lex_state = 102},
  [2891] = {.lex_state = 164},
  [2892] = {.lex_state = 164},
  [2893] = {.lex_state = 95},
  [2894] = {.lex_state = 95},
  [2895] = {.lex_state = 164},
  [2896] = {.lex_state = 130},
  [2897] = {.lex_state = 168},
  [2898] = {.lex_state = 130},
  [2899] = {.lex_state = 137},
  [2900] = {.lex_state = 102},
  [2901] = {.lex_state = 102},
  [2902] = {.lex_state = 102},
  [2903] = {.lex_state = 95},
  [2904] = {.lex_state = 95},
  [2905] = {.lex_state = 95},
  [2906] = {.lex_state = 95},
  [2907] = {.lex_state = 95},
  [2908] = {.lex_state = 95},
  [2909] = {.lex_state = 95},
  [2910] = {.lex_state = 102, .external_lex_state = 2},
  [2911] = {.lex_state = 102},
  [2912] = {.lex_state = 102},
  [2913] = {.lex_state = 139},
  [2914] = {.lex_state = 95},
  [2915] = {.lex_state = 95},
  [2916] = {.lex_state = 95},
  [2917] = {.lex_state = 95},
  [2918] = {.lex_state = 102},
  [2919] = {.lex_state = 137},
  [2920] = {.lex_state = 137},
  [2921] = {.lex_state = 148},
  [2922] = {.lex_state = 95},
  [2923] = {.lex_state = 148},
  [2924] = {.lex_state = 134, .external_lex_state = 2},
  [2925] = {.lex_state = 95},
  [2926] = {.lex_state = 102},
  [2927] = {.lex_state = 134, .external_lex_state = 2},
  [2928] = {.lex_state = 148},
  [2929] = {.lex_state = 102},
  [2930] = {.lex_state = 148},
  [2931] = {.lex_state = 134, .external_lex_state = 2},
  [2932] = {.lex_state = 134, .external_lex_state = 2},
  [2933] = {.lex_state = 137},
  [2934] = {.lex_state = 139},
  [2935] = {.lex_state = 102},
  [2936] = {.lex_state = 95},
  [2937] = {.lex_state = 95},
  [2938] = {.lex_state = 95},
  [2939] = {.lex_state = 95},
  [2940] = {.lex_state = 95},
  [2941] = {.lex_state = 170},
  [2942] = {.lex_state = 170},
  [2943] = {.lex_state = 170},
  [2944] = {.lex_state = 95},
  [2945] = {.lex_state = 95},
  [2946] = {.lex_state = 95},
  [2947] = {.lex_state = 95},
  [2948] = {.lex_state = 95},
  [2949] = {.lex_state = 95},
  [2950] = {.lex_state = 170, .external_lex_state = 2},
  [2951] = {.lex_state = 170, .external_lex_state = 2},
  [2952] = {.lex_state = 102},
  [2953] = {.lex_state = 102},
  [2954] = {.lex_state = 170, .external_lex_state = 2},
  [2955] = {.lex_state = 170, .external_lex_state = 2},
  [2956] = {.lex_state = 169, .external_lex_state = 2},
  [2957] = {.lex_state = 169, .external_lex_state = 2},
  [2958] = {.lex_state = 169, .external_lex_state = 2},
  [2959] = {.lex_state = 169, .external_lex_state = 2},
  [2960] = {.lex_state = 169, .external_lex_state = 2},
  [2961] = {.lex_state = 170, .external_lex_state = 2},
  [2962] = {.lex_state = 95},
  [2963] = {.lex_state = 95},
  [2964] = {.lex_state = 95},
  [2965] = {.lex_state = 95},
  [2966] = {.lex_state = 95},
  [2967] = {.lex_state = 148},
  [2968] = {.lex_state = 130},
  [2969] = {.lex_state = 95},
  [2970] = {.lex_state = 95},
  [2971] = {.lex_state = 95},
  [2972] = {.lex_state = 95},
  [2973] = {.lex_state = 95},
  [2974] = {.lex_state = 95},
  [2975] = {.lex_state = 95},
  [2976] = {.lex_state = 95},
  [2977] = {.lex_state = 170},
  [2978] = {.lex_state = 170},
  [2979] = {.lex_state = 102},
  [2980] = {.lex_state = 102},
  [2981] = {.lex_state = 170},
  [2982] = {.lex_state = 170},
  [2983] = {.lex_state = 169},
  [2984] = {.lex_state = 169},
  [2985] = {.lex_state = 169},
  [2986] = {.lex_state = 169},
  [2987] = {.lex_state = 169},
  [2988] = {.lex_state = 170},
  [2989] = {.lex_state = 95},
  [2990] = {.lex_state = 95},
  [2991] = {.lex_state = 95},
  [2992] = {.lex_state = 95},
  [2993] = {.lex_state = 95},
  [2994] = {.lex_state = 148},
  [2995] = {.lex_state = 130},
  [2996] = {.lex_state = 95},
  [2997] = {.lex_state = 95},
  [2998] = {.lex_state = 170},
  [2999] = {.lex_state = 139},
  [3000] = {.lex_state = 170},
  [3001] = {.lex_state = 139},
  [3002] = {.lex_state = 170},
  [3003] = {.lex_state = 139},
  [3004] = {.lex_state = 137},
  [3005] = {.lex_state = 95},
  [3006] = {.lex_state = 95},
  [3007] = {.lex_state = 95},
  [3008] = {.lex_state = 95},
  [3009] = {.lex_state = 95},
  [3010] = {.lex_state = 166},
  [3011] = {.lex_state = 166},
  [3012] = {.lex_state = 166},
  [3013] = {.lex_state = 166},
  [3014] = {.lex_state = 168},
  [3015] = {.lex_state = 168},
  [3016] = {.lex_state = 130},
  [3017] = {.lex_state = 134},
  [3018] = {.lex_state = 166},
  [3019] = {.lex_state = 168},
  [3020] = {.lex_state = 102, .external_lex_state = 2},
  [3021] = {.lex_state = 137},
  [3022] = {.lex_state = 166},
  [3023] = {.lex_state = 102, .external_lex_state = 2},
  [3024] = {.lex_state = 166},
  [3025] = {.lex_state = 130},
  [3026] = {.lex_state = 148},
  [3027] = {.lex_state = 102},
  [3028] = {.lex_state = 166},
  [3029] = {.lex_state = 166},
  [3030] = {.lex_state = 166},
  [3031] = {.lex_state = 148},
  [3032] = {.lex_state = 168},
  [3033] = {.lex_state = 130},
  [3034] = {.lex_state = 166},
  [3035] = {.lex_state = 168},
  [3036] = {.lex_state = 130},
  [3037] = {.lex_state = 177},
  [3038] = {.lex_state = 95},
  [3039] = {.lex_state = 166},
  [3040] = {.lex_state = 95},
  [3041] = {.lex_state = 110},
  [3042] = {.lex_state = 110},
  [3043] = {.lex_state = 95},
  [3044] = {.lex_state = 148},
  [3045] = {.lex_state = 148},
  [3046] = {.lex_state = 102},
  [3047] = {.lex_state = 95},
  [3048] = {.lex_state = 148},
  [3049] = {.lex_state = 148},
  [3050] = {.lex_state = 102},
  [3051] = {.lex_state = 148},
  [3052] = {.lex_state = 148},
  [3053] = {.lex_state = 130},
  [3054] = {.lex_state = 102},
  [3055] = {.lex_state = 102},
  [3056] = {.lex_state = 95},
  [3057] = {.lex_state = 148},
  [3058] = {.lex_state = 148},
  [3059] = {.lex_state = 102},
  [3060] = {.lex_state = 148},
  [3061] = {.lex_state = 130},
  [3062] = {.lex_state = 148},
  [3063] = {.lex_state = 130},
  [3064] = {.lex_state = 168},
  [3065] = {.lex_state = 164},
  [3066] = {.lex_state = 164},
  [3067] = {.lex_state = 95},
  [3068] = {.lex_state = 95},
  [3069] = {.lex_state = 164},
  [3070] = {.lex_state = 130},
  [3071] = {.lex_state = 95},
  [3072] = {.lex_state = 102},
  [3073] = {.lex_state = 130},
  [3074] = {.lex_state = 168},
  [3075] = {.lex_state = 168},
  [3076] = {.lex_state = 168},
  [3077] = {.lex_state = 130},
  [3078] = {.lex_state = 164},
  [3079] = {.lex_state = 168},
  [3080] = {.lex_state = 168},
  [3081] = {.lex_state = 130},
  [3082] = {.lex_state = 95},
  [3083] = {.lex_state = 95},
  [3084] = {.lex_state = 168},
  [3085] = {.lex_state = 168},
  [3086] = {.lex_state = 168},
  [3087] = {.lex_state = 168},
  [3088] = {.lex_state = 110},
  [3089] = {.lex_state = 168},
  [3090] = {.lex_state = 148},
  [3091] = {.lex_state = 148},
  [3092] = {.lex_state = 95},
  [3093] = {.lex_state = 148},
  [3094] = {.lex_state = 95},
  [3095] = {.lex_state = 168},
  [3096] = {.lex_state = 102},
  [3097] = {.lex_state = 164},
  [3098] = {.lex_state = 164},
  [3099] = {.lex_state = 95},
  [3100] = {.lex_state = 95},
  [3101] = {.lex_state = 164},
  [3102] = {.lex_state = 130},
  [3103] = {.lex_state = 168},
  [3104] = {.lex_state = 148},
  [3105] = {.lex_state = 102, .external_lex_state = 2},
  [3106] = {.lex_state = 130},
  [3107] = {.lex_state = 102, .external_lex_state = 2},
  [3108] = {.lex_state = 137, .external_lex_state = 2},
  [3109] = {.lex_state = 95},
  [3110] = {.lex_state = 130},
  [3111] = {.lex_state = 130},
  [3112] = {.lex_state = 95},
  [3113] = {.lex_state = 134, .external_lex_state = 2},
  [3114] = {.lex_state = 102, .external_lex_state = 2},
  [3115] = {.lex_state = 102, .external_lex_state = 2},
  [3116] = {.lex_state = 102, .external_lex_state = 2},
  [3117] = {.lex_state = 95},
  [3118] = {.lex_state = 102, .external_lex_state = 2},
  [3119] = {.lex_state = 102, .external_lex_state = 2},
  [3120] = {.lex_state = 137, .external_lex_state = 2},
  [3121] = {.lex_state = 137},
  [3122] = {.lex_state = 134, .external_lex_state = 2},
  [3123] = {.lex_state = 148},
  [3124] = {.lex_state = 148},
  [3125] = {.lex_state = 95},
  [3126] = {.lex_state = 148},
  [3127] = {.lex_state = 134, .external_lex_state = 2},
  [3128] = {.lex_state = 95},
  [3129] = {.lex_state = 134, .external_lex_state = 2},
  [3130] = {.lex_state = 102},
  [3131] = {.lex_state = 134, .external_lex_state = 2},
  [3132] = {.lex_state = 134, .external_lex_state = 2},
  [3133] = {.lex_state = 134, .external_lex_state = 2},
  [3134] = {.lex_state = 134, .external_lex_state = 2},
  [3135] = {.lex_state = 130},
  [3136] = {.lex_state = 134, .external_lex_state = 2},
  [3137] = {.lex_state = 134},
  [3138] = {.lex_state = 148},
  [3139] = {.lex_state = 148},
  [3140] = {.lex_state = 95},
  [3141] = {.lex_state = 148},
  [3142] = {.lex_state = 134},
  [3143] = {.lex_state = 95},
  [3144] = {.lex_state = 134},
  [3145] = {.lex_state = 102},
  [3146] = {.lex_state = 137},
  [3147] = {.lex_state = 137},
  [3148] = {.lex_state = 137},
  [3149] = {.lex_state = 137},
  [3150] = {.lex_state = 95},
  [3151] = {.lex_state = 159, .external_lex_state = 2},
  [3152] = {.lex_state = 159, .external_lex_state = 2},
  [3153] = {.lex_state = 159, .external_lex_state = 2},
  [3154] = {.lex_state = 159, .external_lex_state = 2},
  [3155] = {.lex_state = 159, .external_lex_state = 2},
  [3156] = {.lex_state = 95},
  [3157] = {.lex_state = 95},
  [3158] = {.lex_state = 159, .external_lex_state = 2},
  [3159] = {.lex_state = 159, .external_lex_state = 2},
  [3160] = {.lex_state = 159, .external_lex_state = 2},
  [3161] = {.lex_state = 159, .external_lex_state = 2},
  [3162] = {.lex_state = 110},
  [3163] = {.lex_state = 159, .external_lex_state = 2},
  [3164] = {.lex_state = 148},
  [3165] = {.lex_state = 148},
  [3166] = {.lex_state = 95},
  [3167] = {.lex_state = 148},
  [3168] = {.lex_state = 95},
  [3169] = {.lex_state = 159, .external_lex_state = 2},
  [3170] = {.lex_state = 102},
  [3171] = {.lex_state = 102, .external_lex_state = 2},
  [3172] = {.lex_state = 102, .external_lex_state = 2},
  [3173] = {.lex_state = 95},
  [3174] = {.lex_state = 95},
  [3175] = {.lex_state = 102, .external_lex_state = 2},
  [3176] = {.lex_state = 130},
  [3177] = {.lex_state = 159, .external_lex_state = 2},
  [3178] = {.lex_state = 137},
  [3179] = {.lex_state = 139},
  [3180] = {.lex_state = 102},
  [3181] = {.lex_state = 95},
  [3182] = {.lex_state = 95},
  [3183] = {.lex_state = 130},
  [3184] = {.lex_state = 137},
  [3185] = {.lex_state = 95},
  [3186] = {.lex_state = 102, .external_lex_state = 2},
  [3187] = {.lex_state = 95},
  [3188] = {.lex_state = 95},
  [3189] = {.lex_state = 95},
  [3190] = {.lex_state = 110, .external_lex_state = 2},
  [3191] = {.lex_state = 110, .external_lex_state = 2},
  [3192] = {.lex_state = 95},
  [3193] = {.lex_state = 95},
  [3194] = {.lex_state = 95},
  [3195] = {.lex_state = 95},
  [3196] = {.lex_state = 95},
  [3197] = {.lex_state = 95},
  [3198] = {.lex_state = 95},
  [3199] = {.lex_state = 170, .external_lex_state = 2},
  [3200] = {.lex_state = 139},
  [3201] = {.lex_state = 170},
  [3202] = {.lex_state = 95},
  [3203] = {.lex_state = 95},
  [3204] = {.lex_state = 95},
  [3205] = {.lex_state = 95},
  [3206] = {.lex_state = 170},
  [3207] = {.lex_state = 139},
  [3208] = {.lex_state = 170},
  [3209] = {.lex_state = 170, .external_lex_state = 2},
  [3210] = {.lex_state = 139},
  [3211] = {.lex_state = 170},
  [3212] = {.lex_state = 170, .external_lex_state = 2},
  [3213] = {.lex_state = 139},
  [3214] = {.lex_state = 148},
  [3215] = {.lex_state = 130},
  [3216] = {.lex_state = 95},
  [3217] = {.lex_state = 95},
  [3218] = {.lex_state = 95},
  [3219] = {.lex_state = 95},
  [3220] = {.lex_state = 95},
  [3221] = {.lex_state = 95},
  [3222] = {.lex_state = 95},
  [3223] = {.lex_state = 110},
  [3224] = {.lex_state = 110},
  [3225] = {.lex_state = 102},
  [3226] = {.lex_state = 102},
  [3227] = {.lex_state = 110},
  [3228] = {.lex_state = 110},
  [3229] = {.lex_state = 102},
  [3230] = {.lex_state = 102},
  [3231] = {.lex_state = 102},
  [3232] = {.lex_state = 102},
  [3233] = {.lex_state = 102},
  [3234] = {.lex_state = 110},
  [3235] = {.lex_state = 95},
  [3236] = {.lex_state = 95},
  [3237] = {.lex_state = 95},
  [3238] = {.lex_state = 95},
  [3239] = {.lex_state = 95},
  [3240] = {.lex_state = 95},
  [3241] = {.lex_state = 148},
  [3242] = {.lex_state = 130},
  [3243] = {.lex_state = 137},
  [3244] = {.lex_state = 95},
  [3245] = {.lex_state = 102, .external_lex_state = 2},
  [3246] = {.lex_state = 95},
  [3247] = {.lex_state = 95},
  [3248] = {.lex_state = 102, .external_lex_state = 2},
  [3249] = {.lex_state = 95},
  [3250] = {.lex_state = 102, .external_lex_state = 2},
  [3251] = {.lex_state = 95},
  [3252] = {.lex_state = 137},
  [3253] = {.lex_state = 95},
  [3254] = {.lex_state = 148},
  [3255] = {.lex_state = 95},
  [3256] = {.lex_state = 148},
  [3257] = {.lex_state = 179},
  [3258] = {.lex_state = 95},
  [3259] = {.lex_state = 102},
  [3260] = {.lex_state = 179},
  [3261] = {.lex_state = 148},
  [3262] = {.lex_state = 102},
  [3263] = {.lex_state = 148},
  [3264] = {.lex_state = 179},
  [3265] = {.lex_state = 179},
  [3266] = {.lex_state = 139},
  [3267] = {.lex_state = 139},
  [3268] = {.lex_state = 139},
  [3269] = {.lex_state = 139},
  [3270] = {.lex_state = 148},
  [3271] = {.lex_state = 148},
  [3272] = {.lex_state = 102},
  [3273] = {.lex_state = 95},
  [3274] = {.lex_state = 148},
  [3275] = {.lex_state = 148},
  [3276] = {.lex_state = 102},
  [3277] = {.lex_state = 148},
  [3278] = {.lex_state = 148},
  [3279] = {.lex_state = 170},
  [3280] = {.lex_state = 170},
  [3281] = {.lex_state = 170},
  [3282] = {.lex_state = 148},
  [3283] = {.lex_state = 102},
  [3284] = {.lex_state = 148},
  [3285] = {.lex_state = 170},
  [3286] = {.lex_state = 170},
  [3287] = {.lex_state = 130},
  [3288] = {.lex_state = 139},
  [3289] = {.lex_state = 169},
  [3290] = {.lex_state = 139},
  [3291] = {.lex_state = 169},
  [3292] = {.lex_state = 139},
  [3293] = {.lex_state = 139},
  [3294] = {.lex_state = 169},
  [3295] = {.lex_state = 139},
  [3296] = {.lex_state = 139},
  [3297] = {.lex_state = 169},
  [3298] = {.lex_state = 139},
  [3299] = {.lex_state = 102},
  [3300] = {.lex_state = 95},
  [3301] = {.lex_state = 148},
  [3302] = {.lex_state = 95},
  [3303] = {.lex_state = 148},
  [3304] = {.lex_state = 134},
  [3305] = {.lex_state = 95},
  [3306] = {.lex_state = 102},
  [3307] = {.lex_state = 134},
  [3308] = {.lex_state = 148},
  [3309] = {.lex_state = 102},
  [3310] = {.lex_state = 148},
  [3311] = {.lex_state = 134},
  [3312] = {.lex_state = 134},
  [3313] = {.lex_state = 148},
  [3314] = {.lex_state = 95},
  [3315] = {.lex_state = 148},
  [3316] = {.lex_state = 130},
  [3317] = {.lex_state = 95},
  [3318] = {.lex_state = 102},
  [3319] = {.lex_state = 130},
  [3320] = {.lex_state = 148},
  [3321] = {.lex_state = 102},
  [3322] = {.lex_state = 148},
  [3323] = {.lex_state = 130},
  [3324] = {.lex_state = 130},
  [3325] = {.lex_state = 148},
  [3326] = {.lex_state = 102},
  [3327] = {.lex_state = 148},
  [3328] = {.lex_state = 134},
  [3329] = {.lex_state = 130},
  [3330] = {.lex_state = 130},
  [3331] = {.lex_state = 171},
  [3332] = {.lex_state = 137},
  [3333] = {.lex_state = 102, .external_lex_state = 2},
  [3334] = {.lex_state = 139},
  [3335] = {.lex_state = 102, .external_lex_state = 2},
  [3336] = {.lex_state = 139},
  [3337] = {.lex_state = 95},
  [3338] = {.lex_state = 130},
  [3339] = {.lex_state = 130},
  [3340] = {.lex_state = 95},
  [3341] = {.lex_state = 174, .external_lex_state = 2},
  [3342] = {.lex_state = 102, .external_lex_state = 2},
  [3343] = {.lex_state = 102, .external_lex_state = 2},
  [3344] = {.lex_state = 102, .external_lex_state = 2},
  [3345] = {.lex_state = 102, .external_lex_state = 2},
  [3346] = {.lex_state = 130},
  [3347] = {.lex_state = 102, .external_lex_state = 2},
  [3348] = {.lex_state = 130},
  [3349] = {.lex_state = 102, .external_lex_state = 2},
  [3350] = {.lex_state = 102},
  [3351] = {.lex_state = 102, .external_lex_state = 2},
  [3352] = {.lex_state = 95, .external_lex_state = 2},
  [3353] = {.lex_state = 95},
  [3354] = {.lex_state = 102, .external_lex_state = 2},
  [3355] = {.lex_state = 95, .external_lex_state = 2},
  [3356] = {.lex_state = 95},
  [3357] = {.lex_state = 102, .external_lex_state = 2},
  [3358] = {.lex_state = 102, .external_lex_state = 2},
  [3359] = {.lex_state = 95},
  [3360] = {.lex_state = 148},
  [3361] = {.lex_state = 102},
  [3362] = {.lex_state = 95},
  [3363] = {.lex_state = 95},
  [3364] = {.lex_state = 110, .external_lex_state = 2},
  [3365] = {.lex_state = 148},
  [3366] = {.lex_state = 148},
  [3367] = {.lex_state = 102},
  [3368] = {.lex_state = 95},
  [3369] = {.lex_state = 148},
  [3370] = {.lex_state = 148},
  [3371] = {.lex_state = 102},
  [3372] = {.lex_state = 148},
  [3373] = {.lex_state = 148},
  [3374] = {.lex_state = 174, .external_lex_state = 2},
  [3375] = {.lex_state = 174, .external_lex_state = 2},
  [3376] = {.lex_state = 174, .external_lex_state = 2},
  [3377] = {.lex_state = 130},
  [3378] = {.lex_state = 102},
  [3379] = {.lex_state = 95},
  [3380] = {.lex_state = 148},
  [3381] = {.lex_state = 148},
  [3382] = {.lex_state = 102},
  [3383] = {.lex_state = 148},
  [3384] = {.lex_state = 130},
  [3385] = {.lex_state = 148},
  [3386] = {.lex_state = 130},
  [3387] = {.lex_state = 134},
  [3388] = {.lex_state = 130},
  [3389] = {.lex_state = 95},
  [3390] = {.lex_state = 102},
  [3391] = {.lex_state = 164},
  [3392] = {.lex_state = 95},
  [3393] = {.lex_state = 102},
  [3394] = {.lex_state = 102},
  [3395] = {.lex_state = 95},
  [3396] = {.lex_state = 148},
  [3397] = {.lex_state = 148},
  [3398] = {.lex_state = 102},
  [3399] = {.lex_state = 148},
  [3400] = {.lex_state = 130},
  [3401] = {.lex_state = 174, .external_lex_state = 2},
  [3402] = {.lex_state = 95},
  [3403] = {.lex_state = 102, .external_lex_state = 2},
  [3404] = {.lex_state = 130},
  [3405] = {.lex_state = 174, .external_lex_state = 2},
  [3406] = {.lex_state = 95},
  [3407] = {.lex_state = 174, .external_lex_state = 2},
  [3408] = {.lex_state = 174, .external_lex_state = 2},
  [3409] = {.lex_state = 130},
  [3410] = {.lex_state = 174, .external_lex_state = 2},
  [3411] = {.lex_state = 102, .external_lex_state = 2},
  [3412] = {.lex_state = 159, .external_lex_state = 2},
  [3413] = {.lex_state = 130},
  [3414] = {.lex_state = 102, .external_lex_state = 2},
  [3415] = {.lex_state = 95},
  [3416] = {.lex_state = 95},
  [3417] = {.lex_state = 137},
  [3418] = {.lex_state = 102, .external_lex_state = 2},
  [3419] = {.lex_state = 139},
  [3420] = {.lex_state = 159, .external_lex_state = 2},
  [3421] = {.lex_state = 130},
  [3422] = {.lex_state = 95},
  [3423] = {.lex_state = 102},
  [3424] = {.lex_state = 148},
  [3425] = {.lex_state = 102, .external_lex_state = 2},
  [3426] = {.lex_state = 130},
  [3427] = {.lex_state = 139},
  [3428] = {.lex_state = 148},
  [3429] = {.lex_state = 139},
  [3430] = {.lex_state = 148},
  [3431] = {.lex_state = 148},
  [3432] = {.lex_state = 102},
  [3433] = {.lex_state = 95},
  [3434] = {.lex_state = 148},
  [3435] = {.lex_state = 148},
  [3436] = {.lex_state = 102},
  [3437] = {.lex_state = 148},
  [3438] = {.lex_state = 148},
  [3439] = {.lex_state = 148},
  [3440] = {.lex_state = 95},
  [3441] = {.lex_state = 148},
  [3442] = {.lex_state = 130},
  [3443] = {.lex_state = 95},
  [3444] = {.lex_state = 102},
  [3445] = {.lex_state = 130},
  [3446] = {.lex_state = 148},
  [3447] = {.lex_state = 102},
  [3448] = {.lex_state = 148},
  [3449] = {.lex_state = 130},
  [3450] = {.lex_state = 130},
  [3451] = {.lex_state = 170},
  [3452] = {.lex_state = 110},
  [3453] = {.lex_state = 110},
  [3454] = {.lex_state = 148},
  [3455] = {.lex_state = 102},
  [3456] = {.lex_state = 148},
  [3457] = {.lex_state = 110},
  [3458] = {.lex_state = 110},
  [3459] = {.lex_state = 130},
  [3460] = {.lex_state = 189},
  [3461] = {.lex_state = 95},
  [3462] = {.lex_state = 95, .external_lex_state = 2},
  [3463] = {.lex_state = 95},
  [3464] = {.lex_state = 110, .external_lex_state = 2},
  [3465] = {.lex_state = 110, .external_lex_state = 2},
  [3466] = {.lex_state = 95},
  [3467] = {.lex_state = 148},
  [3468] = {.lex_state = 148},
  [3469] = {.lex_state = 102},
  [3470] = {.lex_state = 95},
  [3471] = {.lex_state = 148},
  [3472] = {.lex_state = 148},
  [3473] = {.lex_state = 102},
  [3474] = {.lex_state = 148},
  [3475] = {.lex_state = 148},
  [3476] = {.lex_state = 130},
  [3477] = {.lex_state = 95},
  [3478] = {.lex_state = 102, .external_lex_state = 2},
  [3479] = {.lex_state = 110, .external_lex_state = 2},
  [3480] = {.lex_state = 95},
  [3481] = {.lex_state = 95},
  [3482] = {.lex_state = 102, .external_lex_state = 2},
  [3483] = {.lex_state = 95},
  [3484] = {.lex_state = 95},
  [3485] = {.lex_state = 95},
  [3486] = {.lex_state = 110, .external_lex_state = 2},
  [3487] = {.lex_state = 110, .external_lex_state = 2},
  [3488] = {.lex_state = 95},
  [3489] = {.lex_state = 95},
  [3490] = {.lex_state = 95},
  [3491] = {.lex_state = 95},
  [3492] = {.lex_state = 95},
  [3493] = {.lex_state = 95},
  [3494] = {.lex_state = 95},
  [3495] = {.lex_state = 95},
  [3496] = {.lex_state = 170, .external_lex_state = 2},
  [3497] = {.lex_state = 139},
  [3498] = {.lex_state = 170},
  [3499] = {.lex_state = 95},
  [3500] = {.lex_state = 95},
  [3501] = {.lex_state = 95},
  [3502] = {.lex_state = 95},
  [3503] = {.lex_state = 170},
  [3504] = {.lex_state = 139},
  [3505] = {.lex_state = 170},
  [3506] = {.lex_state = 170, .external_lex_state = 2},
  [3507] = {.lex_state = 139},
  [3508] = {.lex_state = 170},
  [3509] = {.lex_state = 170, .external_lex_state = 2},
  [3510] = {.lex_state = 139},
  [3511] = {.lex_state = 148},
  [3512] = {.lex_state = 95, .external_lex_state = 2},
  [3513] = {.lex_state = 95},
  [3514] = {.lex_state = 102},
  [3515] = {.lex_state = 95},
  [3516] = {.lex_state = 148},
  [3517] = {.lex_state = 148},
  [3518] = {.lex_state = 102},
  [3519] = {.lex_state = 148},
  [3520] = {.lex_state = 134},
  [3521] = {.lex_state = 148},
  [3522] = {.lex_state = 134},
  [3523] = {.lex_state = 110},
  [3524] = {.lex_state = 110},
  [3525] = {.lex_state = 95},
  [3526] = {.lex_state = 148},
  [3527] = {.lex_state = 148},
  [3528] = {.lex_state = 102},
  [3529] = {.lex_state = 95},
  [3530] = {.lex_state = 148},
  [3531] = {.lex_state = 148},
  [3532] = {.lex_state = 102},
  [3533] = {.lex_state = 148},
  [3534] = {.lex_state = 148},
  [3535] = {.lex_state = 130},
  [3536] = {.lex_state = 102},
  [3537] = {.lex_state = 110, .external_lex_state = 2},
  [3538] = {.lex_state = 110, .external_lex_state = 2},
  [3539] = {.lex_state = 176},
  [3540] = {.lex_state = 102},
  [3541] = {.lex_state = 137},
  [3542] = {.lex_state = 162, .external_lex_state = 2},
  [3543] = {.lex_state = 102, .external_lex_state = 2},
  [3544] = {.lex_state = 110, .external_lex_state = 2},
  [3545] = {.lex_state = 110, .external_lex_state = 2},
  [3546] = {.lex_state = 148},
  [3547] = {.lex_state = 110, .external_lex_state = 2},
  [3548] = {.lex_state = 110, .external_lex_state = 2},
  [3549] = {.lex_state = 95},
  [3550] = {.lex_state = 102},
  [3551] = {.lex_state = 102},
  [3552] = {.lex_state = 173, .external_lex_state = 2},
  [3553] = {.lex_state = 169},
  [3554] = {.lex_state = 169},
  [3555] = {.lex_state = 169},
  [3556] = {.lex_state = 130},
  [3557] = {.lex_state = 95},
  [3558] = {.lex_state = 102},
  [3559] = {.lex_state = 189},
  [3560] = {.lex_state = 95},
  [3561] = {.lex_state = 102},
  [3562] = {.lex_state = 162, .external_lex_state = 2},
  [3563] = {.lex_state = 159},
  [3564] = {.lex_state = 159},
  [3565] = {.lex_state = 159},
  [3566] = {.lex_state = 148},
  [3567] = {.lex_state = 102},
  [3568] = {.lex_state = 148},
  [3569] = {.lex_state = 159},
  [3570] = {.lex_state = 159},
  [3571] = {.lex_state = 130},
  [3572] = {.lex_state = 102},
  [3573] = {.lex_state = 95},
  [3574] = {.lex_state = 148},
  [3575] = {.lex_state = 148},
  [3576] = {.lex_state = 102},
  [3577] = {.lex_state = 148},
  [3578] = {.lex_state = 174, .external_lex_state = 2},
  [3579] = {.lex_state = 174, .external_lex_state = 2},
  [3580] = {.lex_state = 176},
  [3581] = {.lex_state = 102},
  [3582] = {.lex_state = 137},
  [3583] = {.lex_state = 174, .external_lex_state = 2},
  [3584] = {.lex_state = 102, .external_lex_state = 2},
  [3585] = {.lex_state = 174, .external_lex_state = 2},
  [3586] = {.lex_state = 174, .external_lex_state = 2},
  [3587] = {.lex_state = 134, .external_lex_state = 2},
  [3588] = {.lex_state = 148},
  [3589] = {.lex_state = 134, .external_lex_state = 2},
  [3590] = {.lex_state = 174, .external_lex_state = 2},
  [3591] = {.lex_state = 102},
  [3592] = {.lex_state = 95},
  [3593] = {.lex_state = 148},
  [3594] = {.lex_state = 148},
  [3595] = {.lex_state = 102},
  [3596] = {.lex_state = 148},
  [3597] = {.lex_state = 134},
  [3598] = {.lex_state = 148},
  [3599] = {.lex_state = 134},
  [3600] = {.lex_state = 170},
  [3601] = {.lex_state = 170},
  [3602] = {.lex_state = 170},
  [3603] = {.lex_state = 148},
  [3604] = {.lex_state = 102},
  [3605] = {.lex_state = 148},
  [3606] = {.lex_state = 170},
  [3607] = {.lex_state = 170},
  [3608] = {.lex_state = 130},
  [3609] = {.lex_state = 168},
  [3610] = {.lex_state = 168},
  [3611] = {.lex_state = 95},
  [3612] = {.lex_state = 148},
  [3613] = {.lex_state = 148},
  [3614] = {.lex_state = 102},
  [3615] = {.lex_state = 95},
  [3616] = {.lex_state = 148},
  [3617] = {.lex_state = 148},
  [3618] = {.lex_state = 102},
  [3619] = {.lex_state = 148},
  [3620] = {.lex_state = 148},
  [3621] = {.lex_state = 130},
  [3622] = {.lex_state = 164},
  [3623] = {.lex_state = 137},
  [3624] = {.lex_state = 95},
  [3625] = {.lex_state = 95},
  [3626] = {.lex_state = 95},
  [3627] = {.lex_state = 95},
  [3628] = {.lex_state = 95},
  [3629] = {.lex_state = 95},
  [3630] = {.lex_state = 95},
  [3631] = {.lex_state = 170, .external_lex_state = 2},
  [3632] = {.lex_state = 139},
  [3633] = {.lex_state = 170},
  [3634] = {.lex_state = 95},
  [3635] = {.lex_state = 95},
  [3636] = {.lex_state = 95},
  [3637] = {.lex_state = 95},
  [3638] = {.lex_state = 170},
  [3639] = {.lex_state = 139},
  [3640] = {.lex_state = 170},
  [3641] = {.lex_state = 170, .external_lex_state = 2},
  [3642] = {.lex_state = 139},
  [3643] = {.lex_state = 170},
  [3644] = {.lex_state = 170, .external_lex_state = 2},
  [3645] = {.lex_state = 139},
  [3646] = {.lex_state = 148},
  [3647] = {.lex_state = 102},
  [3648] = {.lex_state = 95},
  [3649] = {.lex_state = 148},
  [3650] = {.lex_state = 148},
  [3651] = {.lex_state = 102},
  [3652] = {.lex_state = 148},
  [3653] = {.lex_state = 134, .external_lex_state = 2},
  [3654] = {.lex_state = 148},
  [3655] = {.lex_state = 134, .external_lex_state = 2},
  [3656] = {.lex_state = 95, .external_lex_state = 2},
  [3657] = {.lex_state = 170},
  [3658] = {.lex_state = 170},
  [3659] = {.lex_state = 170},
  [3660] = {.lex_state = 95},
  [3661] = {.lex_state = 95},
  [3662] = {.lex_state = 95},
  [3663] = {.lex_state = 170, .external_lex_state = 2},
  [3664] = {.lex_state = 170, .external_lex_state = 2},
  [3665] = {.lex_state = 170, .external_lex_state = 2},
  [3666] = {.lex_state = 170, .external_lex_state = 2},
  [3667] = {.lex_state = 170, .external_lex_state = 2},
  [3668] = {.lex_state = 170, .external_lex_state = 2},
  [3669] = {.lex_state = 95},
  [3670] = {.lex_state = 95},
  [3671] = {.lex_state = 170, .external_lex_state = 2},
  [3672] = {.lex_state = 170, .external_lex_state = 2},
  [3673] = {.lex_state = 170, .external_lex_state = 2},
  [3674] = {.lex_state = 170, .external_lex_state = 2},
  [3675] = {.lex_state = 110},
  [3676] = {.lex_state = 170, .external_lex_state = 2},
  [3677] = {.lex_state = 148},
  [3678] = {.lex_state = 148},
  [3679] = {.lex_state = 95},
  [3680] = {.lex_state = 148},
  [3681] = {.lex_state = 95},
  [3682] = {.lex_state = 170, .external_lex_state = 2},
  [3683] = {.lex_state = 102},
  [3684] = {.lex_state = 169, .external_lex_state = 2},
  [3685] = {.lex_state = 169, .external_lex_state = 2},
  [3686] = {.lex_state = 95},
  [3687] = {.lex_state = 95},
  [3688] = {.lex_state = 169, .external_lex_state = 2},
  [3689] = {.lex_state = 130},
  [3690] = {.lex_state = 137},
  [3691] = {.lex_state = 170, .external_lex_state = 2},
  [3692] = {.lex_state = 170},
  [3693] = {.lex_state = 170},
  [3694] = {.lex_state = 170},
  [3695] = {.lex_state = 170},
  [3696] = {.lex_state = 170},
  [3697] = {.lex_state = 170},
  [3698] = {.lex_state = 95},
  [3699] = {.lex_state = 95},
  [3700] = {.lex_state = 170},
  [3701] = {.lex_state = 170},
  [3702] = {.lex_state = 170},
  [3703] = {.lex_state = 170},
  [3704] = {.lex_state = 110},
  [3705] = {.lex_state = 170},
  [3706] = {.lex_state = 148},
  [3707] = {.lex_state = 148},
  [3708] = {.lex_state = 95},
  [3709] = {.lex_state = 148},
  [3710] = {.lex_state = 95},
  [3711] = {.lex_state = 170},
  [3712] = {.lex_state = 102},
  [3713] = {.lex_state = 169},
  [3714] = {.lex_state = 169},
  [3715] = {.lex_state = 95},
  [3716] = {.lex_state = 95},
  [3717] = {.lex_state = 169},
  [3718] = {.lex_state = 130},
  [3719] = {.lex_state = 137},
  [3720] = {.lex_state = 170},
  [3721] = {.lex_state = 95},
  [3722] = {.lex_state = 95},
  [3723] = {.lex_state = 95},
  [3724] = {.lex_state = 137},
  [3725] = {.lex_state = 137},
  [3726] = {.lex_state = 137},
  [3727] = {.lex_state = 137},
  [3728] = {.lex_state = 137},
  [3729] = {.lex_state = 166},
  [3730] = {.lex_state = 166},
  [3731] = {.lex_state = 176},
  [3732] = {.lex_state = 102},
  [3733] = {.lex_state = 137},
  [3734] = {.lex_state = 166},
  [3735] = {.lex_state = 102, .external_lex_state = 2},
  [3736] = {.lex_state = 166},
  [3737] = {.lex_state = 168},
  [3738] = {.lex_state = 148},
  [3739] = {.lex_state = 168},
  [3740] = {.lex_state = 166},
  [3741] = {.lex_state = 177},
  [3742] = {.lex_state = 166},
  [3743] = {.lex_state = 110},
  [3744] = {.lex_state = 110},
  [3745] = {.lex_state = 110},
  [3746] = {.lex_state = 148},
  [3747] = {.lex_state = 102},
  [3748] = {.lex_state = 148},
  [3749] = {.lex_state = 110},
  [3750] = {.lex_state = 110},
  [3751] = {.lex_state = 130},
  [3752] = {.lex_state = 148},
  [3753] = {.lex_state = 102},
  [3754] = {.lex_state = 148},
  [3755] = {.lex_state = 130},
  [3756] = {.lex_state = 130},
  [3757] = {.lex_state = 130},
  [3758] = {.lex_state = 164},
  [3759] = {.lex_state = 95},
  [3760] = {.lex_state = 102},
  [3761] = {.lex_state = 102},
  [3762] = {.lex_state = 102},
  [3763] = {.lex_state = 102},
  [3764] = {.lex_state = 168},
  [3765] = {.lex_state = 168},
  [3766] = {.lex_state = 95},
  [3767] = {.lex_state = 148},
  [3768] = {.lex_state = 148},
  [3769] = {.lex_state = 102},
  [3770] = {.lex_state = 95},
  [3771] = {.lex_state = 148},
  [3772] = {.lex_state = 148},
  [3773] = {.lex_state = 102},
  [3774] = {.lex_state = 148},
  [3775] = {.lex_state = 148},
  [3776] = {.lex_state = 130},
  [3777] = {.lex_state = 164},
  [3778] = {.lex_state = 134, .external_lex_state = 2},
  [3779] = {.lex_state = 148},
  [3780] = {.lex_state = 148},
  [3781] = {.lex_state = 95},
  [3782] = {.lex_state = 148},
  [3783] = {.lex_state = 134, .external_lex_state = 2},
  [3784] = {.lex_state = 95},
  [3785] = {.lex_state = 134, .external_lex_state = 2},
  [3786] = {.lex_state = 102},
  [3787] = {.lex_state = 137, .external_lex_state = 2},
  [3788] = {.lex_state = 102, .external_lex_state = 2},
  [3789] = {.lex_state = 95},
  [3790] = {.lex_state = 130},
  [3791] = {.lex_state = 102, .external_lex_state = 2},
  [3792] = {.lex_state = 102, .external_lex_state = 2},
  [3793] = {.lex_state = 102, .external_lex_state = 2},
  [3794] = {.lex_state = 137, .external_lex_state = 2},
  [3795] = {.lex_state = 148},
  [3796] = {.lex_state = 148},
  [3797] = {.lex_state = 102},
  [3798] = {.lex_state = 95},
  [3799] = {.lex_state = 148},
  [3800] = {.lex_state = 148},
  [3801] = {.lex_state = 102},
  [3802] = {.lex_state = 148},
  [3803] = {.lex_state = 148},
  [3804] = {.lex_state = 130},
  [3805] = {.lex_state = 95},
  [3806] = {.lex_state = 134, .external_lex_state = 2},
  [3807] = {.lex_state = 102, .external_lex_state = 2},
  [3808] = {.lex_state = 95},
  [3809] = {.lex_state = 148},
  [3810] = {.lex_state = 148},
  [3811] = {.lex_state = 102},
  [3812] = {.lex_state = 95},
  [3813] = {.lex_state = 148},
  [3814] = {.lex_state = 148},
  [3815] = {.lex_state = 102},
  [3816] = {.lex_state = 148},
  [3817] = {.lex_state = 148},
  [3818] = {.lex_state = 137},
  [3819] = {.lex_state = 159, .external_lex_state = 2},
  [3820] = {.lex_state = 159, .external_lex_state = 2},
  [3821] = {.lex_state = 95},
  [3822] = {.lex_state = 148},
  [3823] = {.lex_state = 148},
  [3824] = {.lex_state = 102},
  [3825] = {.lex_state = 95},
  [3826] = {.lex_state = 148},
  [3827] = {.lex_state = 148},
  [3828] = {.lex_state = 102},
  [3829] = {.lex_state = 148},
  [3830] = {.lex_state = 148},
  [3831] = {.lex_state = 130},
  [3832] = {.lex_state = 102, .external_lex_state = 2},
  [3833] = {.lex_state = 137},
  [3834] = {.lex_state = 102},
  [3835] = {.lex_state = 95},
  [3836] = {.lex_state = 95},
  [3837] = {.lex_state = 95},
  [3838] = {.lex_state = 95},
  [3839] = {.lex_state = 95},
  [3840] = {.lex_state = 95},
  [3841] = {.lex_state = 95},
  [3842] = {.lex_state = 95},
  [3843] = {.lex_state = 95},
  [3844] = {.lex_state = 102, .external_lex_state = 2},
  [3845] = {.lex_state = 102},
  [3846] = {.lex_state = 102},
  [3847] = {.lex_state = 139},
  [3848] = {.lex_state = 95},
  [3849] = {.lex_state = 95},
  [3850] = {.lex_state = 95},
  [3851] = {.lex_state = 95},
  [3852] = {.lex_state = 102},
  [3853] = {.lex_state = 95},
  [3854] = {.lex_state = 95},
  [3855] = {.lex_state = 95},
  [3856] = {.lex_state = 170},
  [3857] = {.lex_state = 170},
  [3858] = {.lex_state = 170},
  [3859] = {.lex_state = 95},
  [3860] = {.lex_state = 95},
  [3861] = {.lex_state = 170},
  [3862] = {.lex_state = 139},
  [3863] = {.lex_state = 170},
  [3864] = {.lex_state = 139},
  [3865] = {.lex_state = 170},
  [3866] = {.lex_state = 139},
  [3867] = {.lex_state = 95},
  [3868] = {.lex_state = 95},
  [3869] = {.lex_state = 95},
  [3870] = {.lex_state = 95},
  [3871] = {.lex_state = 95},
  [3872] = {.lex_state = 137},
  [3873] = {.lex_state = 148},
  [3874] = {.lex_state = 148},
  [3875] = {.lex_state = 95},
  [3876] = {.lex_state = 148},
  [3877] = {.lex_state = 137},
  [3878] = {.lex_state = 95},
  [3879] = {.lex_state = 137},
  [3880] = {.lex_state = 102},
  [3881] = {.lex_state = 130},
  [3882] = {.lex_state = 110},
  [3883] = {.lex_state = 110},
  [3884] = {.lex_state = 110},
  [3885] = {.lex_state = 110},
  [3886] = {.lex_state = 110},
  [3887] = {.lex_state = 110},
  [3888] = {.lex_state = 95},
  [3889] = {.lex_state = 95},
  [3890] = {.lex_state = 110},
  [3891] = {.lex_state = 110},
  [3892] = {.lex_state = 110},
  [3893] = {.lex_state = 110},
  [3894] = {.lex_state = 110},
  [3895] = {.lex_state = 110},
  [3896] = {.lex_state = 110},
  [3897] = {.lex_state = 148},
  [3898] = {.lex_state = 148},
  [3899] = {.lex_state = 95},
  [3900] = {.lex_state = 148},
  [3901] = {.lex_state = 95},
  [3902] = {.lex_state = 110},
  [3903] = {.lex_state = 102},
  [3904] = {.lex_state = 102},
  [3905] = {.lex_state = 102},
  [3906] = {.lex_state = 95},
  [3907] = {.lex_state = 95},
  [3908] = {.lex_state = 102},
  [3909] = {.lex_state = 130},
  [3910] = {.lex_state = 137},
  [3911] = {.lex_state = 110},
  [3912] = {.lex_state = 95},
  [3913] = {.lex_state = 95},
  [3914] = {.lex_state = 95},
  [3915] = {.lex_state = 95},
  [3916] = {.lex_state = 102},
  [3917] = {.lex_state = 95},
  [3918] = {.lex_state = 134},
  [3919] = {.lex_state = 95},
  [3920] = {.lex_state = 95},
  [3921] = {.lex_state = 95},
  [3922] = {.lex_state = 137},
  [3923] = {.lex_state = 95},
  [3924] = {.lex_state = 102},
  [3925] = {.lex_state = 95},
  [3926] = {.lex_state = 148},
  [3927] = {.lex_state = 148},
  [3928] = {.lex_state = 102},
  [3929] = {.lex_state = 148},
  [3930] = {.lex_state = 179},
  [3931] = {.lex_state = 148},
  [3932] = {.lex_state = 179},
  [3933] = {.lex_state = 148},
  [3934] = {.lex_state = 95},
  [3935] = {.lex_state = 148},
  [3936] = {.lex_state = 139},
  [3937] = {.lex_state = 95},
  [3938] = {.lex_state = 102},
  [3939] = {.lex_state = 139},
  [3940] = {.lex_state = 148},
  [3941] = {.lex_state = 102},
  [3942] = {.lex_state = 148},
  [3943] = {.lex_state = 139},
  [3944] = {.lex_state = 139},
  [3945] = {.lex_state = 170},
  [3946] = {.lex_state = 148},
  [3947] = {.lex_state = 170},
  [3948] = {.lex_state = 139},
  [3949] = {.lex_state = 139},
  [3950] = {.lex_state = 139},
  [3951] = {.lex_state = 139},
  [3952] = {.lex_state = 137},
  [3953] = {.lex_state = 102},
  [3954] = {.lex_state = 95},
  [3955] = {.lex_state = 148},
  [3956] = {.lex_state = 148},
  [3957] = {.lex_state = 102},
  [3958] = {.lex_state = 148},
  [3959] = {.lex_state = 134},
  [3960] = {.lex_state = 148},
  [3961] = {.lex_state = 134},
  [3962] = {.lex_state = 102},
  [3963] = {.lex_state = 95},
  [3964] = {.lex_state = 148},
  [3965] = {.lex_state = 148},
  [3966] = {.lex_state = 102},
  [3967] = {.lex_state = 148},
  [3968] = {.lex_state = 130},
  [3969] = {.lex_state = 148},
  [3970] = {.lex_state = 130},
  [3971] = {.lex_state = 134},
  [3972] = {.lex_state = 148},
  [3973] = {.lex_state = 134},
  [3974] = {.lex_state = 102},
  [3975] = {.lex_state = 102},
  [3976] = {.lex_state = 171},
  [3977] = {.lex_state = 102, .external_lex_state = 2},
  [3978] = {.lex_state = 139},
  [3979] = {.lex_state = 102, .external_lex_state = 2},
  [3980] = {.lex_state = 95},
  [3981] = {.lex_state = 130},
  [3982] = {.lex_state = 102, .external_lex_state = 2},
  [3983] = {.lex_state = 102, .external_lex_state = 2},
  [3984] = {.lex_state = 102, .external_lex_state = 2},
  [3985] = {.lex_state = 130},
  [3986] = {.lex_state = 102, .external_lex_state = 2},
  [3987] = {.lex_state = 102},
  [3988] = {.lex_state = 102, .external_lex_state = 2},
  [3989] = {.lex_state = 102},
  [3990] = {.lex_state = 102, .external_lex_state = 2},
  [3991] = {.lex_state = 102, .external_lex_state = 2},
  [3992] = {.lex_state = 102, .external_lex_state = 2},
  [3993] = {.lex_state = 95},
  [3994] = {.lex_state = 95},
  [3995] = {.lex_state = 102, .external_lex_state = 2},
  [3996] = {.lex_state = 134, .external_lex_state = 2},
  [3997] = {.lex_state = 148},
  [3998] = {.lex_state = 102, .external_lex_state = 2},
  [3999] = {.lex_state = 95, .external_lex_state = 2},
  [4000] = {.lex_state = 148},
  [4001] = {.lex_state = 95},
  [4002] = {.lex_state = 148},
  [4003] = {.lex_state = 137, .external_lex_state = 2},
  [4004] = {.lex_state = 95},
  [4005] = {.lex_state = 102},
  [4006] = {.lex_state = 137, .external_lex_state = 2},
  [4007] = {.lex_state = 148},
  [4008] = {.lex_state = 102},
  [4009] = {.lex_state = 148},
  [4010] = {.lex_state = 137, .external_lex_state = 2},
  [4011] = {.lex_state = 137, .external_lex_state = 2},
  [4012] = {.lex_state = 130},
  [4013] = {.lex_state = 95},
  [4014] = {.lex_state = 174, .external_lex_state = 2},
  [4015] = {.lex_state = 148},
  [4016] = {.lex_state = 102},
  [4017] = {.lex_state = 148},
  [4018] = {.lex_state = 130},
  [4019] = {.lex_state = 130},
  [4020] = {.lex_state = 95},
  [4021] = {.lex_state = 102},
  [4022] = {.lex_state = 102},
  [4023] = {.lex_state = 164},
  [4024] = {.lex_state = 148},
  [4025] = {.lex_state = 102},
  [4026] = {.lex_state = 148},
  [4027] = {.lex_state = 139},
  [4028] = {.lex_state = 164},
  [4029] = {.lex_state = 164},
  [4030] = {.lex_state = 95},
  [4031] = {.lex_state = 95},
  [4032] = {.lex_state = 164},
  [4033] = {.lex_state = 130},
  [4034] = {.lex_state = 102, .external_lex_state = 2},
  [4035] = {.lex_state = 95},
  [4036] = {.lex_state = 130},
  [4037] = {.lex_state = 130},
  [4038] = {.lex_state = 95},
  [4039] = {.lex_state = 174, .external_lex_state = 2},
  [4040] = {.lex_state = 130},
  [4041] = {.lex_state = 95},
  [4042] = {.lex_state = 102, .external_lex_state = 2},
  [4043] = {.lex_state = 159, .external_lex_state = 2},
  [4044] = {.lex_state = 137},
  [4045] = {.lex_state = 159, .external_lex_state = 2},
  [4046] = {.lex_state = 95},
  [4047] = {.lex_state = 102},
  [4048] = {.lex_state = 102},
  [4049] = {.lex_state = 137, .external_lex_state = 2},
  [4050] = {.lex_state = 148},
  [4051] = {.lex_state = 148},
  [4052] = {.lex_state = 95},
  [4053] = {.lex_state = 148},
  [4054] = {.lex_state = 137, .external_lex_state = 2},
  [4055] = {.lex_state = 95},
  [4056] = {.lex_state = 137, .external_lex_state = 2},
  [4057] = {.lex_state = 102},
  [4058] = {.lex_state = 174, .external_lex_state = 2},
  [4059] = {.lex_state = 174, .external_lex_state = 2},
  [4060] = {.lex_state = 174, .external_lex_state = 2},
  [4061] = {.lex_state = 139},
  [4062] = {.lex_state = 148},
  [4063] = {.lex_state = 95},
  [4064] = {.lex_state = 148},
  [4065] = {.lex_state = 134, .external_lex_state = 2},
  [4066] = {.lex_state = 95},
  [4067] = {.lex_state = 102},
  [4068] = {.lex_state = 134, .external_lex_state = 2},
  [4069] = {.lex_state = 148},
  [4070] = {.lex_state = 102},
  [4071] = {.lex_state = 148},
  [4072] = {.lex_state = 134, .external_lex_state = 2},
  [4073] = {.lex_state = 134, .external_lex_state = 2},
  [4074] = {.lex_state = 102},
  [4075] = {.lex_state = 95},
  [4076] = {.lex_state = 148},
  [4077] = {.lex_state = 148},
  [4078] = {.lex_state = 102},
  [4079] = {.lex_state = 148},
  [4080] = {.lex_state = 130},
  [4081] = {.lex_state = 148},
  [4082] = {.lex_state = 130},
  [4083] = {.lex_state = 110},
  [4084] = {.lex_state = 148},
  [4085] = {.lex_state = 110},
  [4086] = {.lex_state = 189},
  [4087] = {.lex_state = 110, .external_lex_state = 2},
  [4088] = {.lex_state = 110, .external_lex_state = 2},
  [4089] = {.lex_state = 110, .external_lex_state = 2},
  [4090] = {.lex_state = 148},
  [4091] = {.lex_state = 102},
  [4092] = {.lex_state = 148},
  [4093] = {.lex_state = 110, .external_lex_state = 2},
  [4094] = {.lex_state = 110, .external_lex_state = 2},
  [4095] = {.lex_state = 130},
  [4096] = {.lex_state = 102, .external_lex_state = 2},
  [4097] = {.lex_state = 95},
  [4098] = {.lex_state = 95},
  [4099] = {.lex_state = 95},
  [4100] = {.lex_state = 95},
  [4101] = {.lex_state = 95},
  [4102] = {.lex_state = 95},
  [4103] = {.lex_state = 95},
  [4104] = {.lex_state = 95},
  [4105] = {.lex_state = 102, .external_lex_state = 2},
  [4106] = {.lex_state = 102},
  [4107] = {.lex_state = 102},
  [4108] = {.lex_state = 139},
  [4109] = {.lex_state = 95},
  [4110] = {.lex_state = 95},
  [4111] = {.lex_state = 95},
  [4112] = {.lex_state = 95},
  [4113] = {.lex_state = 102},
  [4114] = {.lex_state = 95},
  [4115] = {.lex_state = 95},
  [4116] = {.lex_state = 95},
  [4117] = {.lex_state = 170},
  [4118] = {.lex_state = 170},
  [4119] = {.lex_state = 170},
  [4120] = {.lex_state = 95},
  [4121] = {.lex_state = 95},
  [4122] = {.lex_state = 170},
  [4123] = {.lex_state = 139},
  [4124] = {.lex_state = 170},
  [4125] = {.lex_state = 139},
  [4126] = {.lex_state = 170},
  [4127] = {.lex_state = 139},
  [4128] = {.lex_state = 95},
  [4129] = {.lex_state = 95},
  [4130] = {.lex_state = 95},
  [4131] = {.lex_state = 95},
  [4132] = {.lex_state = 95},
  [4133] = {.lex_state = 130},
  [4134] = {.lex_state = 148},
  [4135] = {.lex_state = 148},
  [4136] = {.lex_state = 95},
  [4137] = {.lex_state = 148},
  [4138] = {.lex_state = 130},
  [4139] = {.lex_state = 95},
  [4140] = {.lex_state = 130},
  [4141] = {.lex_state = 102},
  [4142] = {.lex_state = 148},
  [4143] = {.lex_state = 102},
  [4144] = {.lex_state = 148},
  [4145] = {.lex_state = 134},
  [4146] = {.lex_state = 134},
  [4147] = {.lex_state = 110},
  [4148] = {.lex_state = 110},
  [4149] = {.lex_state = 110},
  [4150] = {.lex_state = 148},
  [4151] = {.lex_state = 102},
  [4152] = {.lex_state = 148},
  [4153] = {.lex_state = 110},
  [4154] = {.lex_state = 110},
  [4155] = {.lex_state = 130},
  [4156] = {.lex_state = 110, .external_lex_state = 2},
  [4157] = {.lex_state = 176},
  [4158] = {.lex_state = 162, .external_lex_state = 2},
  [4159] = {.lex_state = 137},
  [4160] = {.lex_state = 110, .external_lex_state = 2},
  [4161] = {.lex_state = 102},
  [4162] = {.lex_state = 95},
  [4163] = {.lex_state = 102},
  [4164] = {.lex_state = 102},
  [4165] = {.lex_state = 189},
  [4166] = {.lex_state = 159},
  [4167] = {.lex_state = 148},
  [4168] = {.lex_state = 159},
  [4169] = {.lex_state = 148},
  [4170] = {.lex_state = 102},
  [4171] = {.lex_state = 148},
  [4172] = {.lex_state = 134, .external_lex_state = 2},
  [4173] = {.lex_state = 174, .external_lex_state = 2},
  [4174] = {.lex_state = 176},
  [4175] = {.lex_state = 174, .external_lex_state = 2},
  [4176] = {.lex_state = 137},
  [4177] = {.lex_state = 134, .external_lex_state = 2},
  [4178] = {.lex_state = 148},
  [4179] = {.lex_state = 102},
  [4180] = {.lex_state = 148},
  [4181] = {.lex_state = 134},
  [4182] = {.lex_state = 134},
  [4183] = {.lex_state = 170},
  [4184] = {.lex_state = 148},
  [4185] = {.lex_state = 170},
  [4186] = {.lex_state = 168},
  [4187] = {.lex_state = 168},
  [4188] = {.lex_state = 168},
  [4189] = {.lex_state = 148},
  [4190] = {.lex_state = 102},
  [4191] = {.lex_state = 148},
  [4192] = {.lex_state = 168},
  [4193] = {.lex_state = 168},
  [4194] = {.lex_state = 130},
  [4195] = {.lex_state = 95},
  [4196] = {.lex_state = 95},
  [4197] = {.lex_state = 95},
  [4198] = {.lex_state = 170},
  [4199] = {.lex_state = 170},
  [4200] = {.lex_state = 170},
  [4201] = {.lex_state = 95},
  [4202] = {.lex_state = 95},
  [4203] = {.lex_state = 170},
  [4204] = {.lex_state = 139},
  [4205] = {.lex_state = 170},
  [4206] = {.lex_state = 139},
  [4207] = {.lex_state = 170},
  [4208] = {.lex_state = 139},
  [4209] = {.lex_state = 95},
  [4210] = {.lex_state = 95},
  [4211] = {.lex_state = 95},
  [4212] = {.lex_state = 95},
  [4213] = {.lex_state = 95},
  [4214] = {.lex_state = 134},
  [4215] = {.lex_state = 148},
  [4216] = {.lex_state = 148},
  [4217] = {.lex_state = 95},
  [4218] = {.lex_state = 148},
  [4219] = {.lex_state = 134},
  [4220] = {.lex_state = 95},
  [4221] = {.lex_state = 134},
  [4222] = {.lex_state = 102},
  [4223] = {.lex_state = 148},
  [4224] = {.lex_state = 102},
  [4225] = {.lex_state = 148},
  [4226] = {.lex_state = 134, .external_lex_state = 2},
  [4227] = {.lex_state = 134, .external_lex_state = 2},
  [4228] = {.lex_state = 95},
  [4229] = {.lex_state = 95},
  [4230] = {.lex_state = 95},
  [4231] = {.lex_state = 137},
  [4232] = {.lex_state = 137},
  [4233] = {.lex_state = 137},
  [4234] = {.lex_state = 170, .external_lex_state = 2},
  [4235] = {.lex_state = 170, .external_lex_state = 2},
  [4236] = {.lex_state = 95},
  [4237] = {.lex_state = 148},
  [4238] = {.lex_state = 148},
  [4239] = {.lex_state = 102},
  [4240] = {.lex_state = 95},
  [4241] = {.lex_state = 148},
  [4242] = {.lex_state = 148},
  [4243] = {.lex_state = 102},
  [4244] = {.lex_state = 148},
  [4245] = {.lex_state = 148},
  [4246] = {.lex_state = 130},
  [4247] = {.lex_state = 169, .external_lex_state = 2},
  [4248] = {.lex_state = 170},
  [4249] = {.lex_state = 170},
  [4250] = {.lex_state = 95},
  [4251] = {.lex_state = 148},
  [4252] = {.lex_state = 148},
  [4253] = {.lex_state = 102},
  [4254] = {.lex_state = 95},
  [4255] = {.lex_state = 148},
  [4256] = {.lex_state = 148},
  [4257] = {.lex_state = 102},
  [4258] = {.lex_state = 148},
  [4259] = {.lex_state = 148},
  [4260] = {.lex_state = 130},
  [4261] = {.lex_state = 169},
  [4262] = {.lex_state = 137},
  [4263] = {.lex_state = 137},
  [4264] = {.lex_state = 137},
  [4265] = {.lex_state = 166},
  [4266] = {.lex_state = 176},
  [4267] = {.lex_state = 166},
  [4268] = {.lex_state = 137},
  [4269] = {.lex_state = 168},
  [4270] = {.lex_state = 110},
  [4271] = {.lex_state = 148},
  [4272] = {.lex_state = 110},
  [4273] = {.lex_state = 130},
  [4274] = {.lex_state = 148},
  [4275] = {.lex_state = 130},
  [4276] = {.lex_state = 130},
  [4277] = {.lex_state = 95},
  [4278] = {.lex_state = 102},
  [4279] = {.lex_state = 102},
  [4280] = {.lex_state = 102, .external_lex_state = 2},
  [4281] = {.lex_state = 102, .external_lex_state = 2},
  [4282] = {.lex_state = 168},
  [4283] = {.lex_state = 168},
  [4284] = {.lex_state = 168},
  [4285] = {.lex_state = 148},
  [4286] = {.lex_state = 102},
  [4287] = {.lex_state = 148},
  [4288] = {.lex_state = 168},
  [4289] = {.lex_state = 168},
  [4290] = {.lex_state = 130},
  [4291] = {.lex_state = 148},
  [4292] = {.lex_state = 148},
  [4293] = {.lex_state = 102},
  [4294] = {.lex_state = 95},
  [4295] = {.lex_state = 148},
  [4296] = {.lex_state = 148},
  [4297] = {.lex_state = 102},
  [4298] = {.lex_state = 148},
  [4299] = {.lex_state = 148},
  [4300] = {.lex_state = 137, .external_lex_state = 2},
  [4301] = {.lex_state = 102, .external_lex_state = 2},
  [4302] = {.lex_state = 95},
  [4303] = {.lex_state = 102, .external_lex_state = 2},
  [4304] = {.lex_state = 148},
  [4305] = {.lex_state = 95},
  [4306] = {.lex_state = 148},
  [4307] = {.lex_state = 134, .external_lex_state = 2},
  [4308] = {.lex_state = 95},
  [4309] = {.lex_state = 102},
  [4310] = {.lex_state = 134, .external_lex_state = 2},
  [4311] = {.lex_state = 148},
  [4312] = {.lex_state = 102},
  [4313] = {.lex_state = 148},
  [4314] = {.lex_state = 134, .external_lex_state = 2},
  [4315] = {.lex_state = 134, .external_lex_state = 2},
  [4316] = {.lex_state = 130},
  [4317] = {.lex_state = 102, .external_lex_state = 2},
  [4318] = {.lex_state = 102, .external_lex_state = 2},
  [4319] = {.lex_state = 134},
  [4320] = {.lex_state = 134},
  [4321] = {.lex_state = 148},
  [4322] = {.lex_state = 102},
  [4323] = {.lex_state = 148},
  [4324] = {.lex_state = 134},
  [4325] = {.lex_state = 134},
  [4326] = {.lex_state = 159, .external_lex_state = 2},
  [4327] = {.lex_state = 159, .external_lex_state = 2},
  [4328] = {.lex_state = 159, .external_lex_state = 2},
  [4329] = {.lex_state = 148},
  [4330] = {.lex_state = 102},
  [4331] = {.lex_state = 148},
  [4332] = {.lex_state = 159, .external_lex_state = 2},
  [4333] = {.lex_state = 159, .external_lex_state = 2},
  [4334] = {.lex_state = 130},
  [4335] = {.lex_state = 102},
  [4336] = {.lex_state = 95},
  [4337] = {.lex_state = 95},
  [4338] = {.lex_state = 95},
  [4339] = {.lex_state = 95},
  [4340] = {.lex_state = 95},
  [4341] = {.lex_state = 95},
  [4342] = {.lex_state = 95},
  [4343] = {.lex_state = 170, .external_lex_state = 2},
  [4344] = {.lex_state = 139},
  [4345] = {.lex_state = 170},
  [4346] = {.lex_state = 95},
  [4347] = {.lex_state = 95},
  [4348] = {.lex_state = 95},
  [4349] = {.lex_state = 95},
  [4350] = {.lex_state = 170},
  [4351] = {.lex_state = 139},
  [4352] = {.lex_state = 170},
  [4353] = {.lex_state = 170, .external_lex_state = 2},
  [4354] = {.lex_state = 139},
  [4355] = {.lex_state = 170},
  [4356] = {.lex_state = 170, .external_lex_state = 2},
  [4357] = {.lex_state = 139},
  [4358] = {.lex_state = 148},
  [4359] = {.lex_state = 170},
  [4360] = {.lex_state = 170},
  [4361] = {.lex_state = 170},
  [4362] = {.lex_state = 95},
  [4363] = {.lex_state = 95},
  [4364] = {.lex_state = 95},
  [4365] = {.lex_state = 95},
  [4366] = {.lex_state = 95},
  [4367] = {.lex_state = 95},
  [4368] = {.lex_state = 148},
  [4369] = {.lex_state = 148},
  [4370] = {.lex_state = 102},
  [4371] = {.lex_state = 95},
  [4372] = {.lex_state = 148},
  [4373] = {.lex_state = 148},
  [4374] = {.lex_state = 102},
  [4375] = {.lex_state = 148},
  [4376] = {.lex_state = 148},
  [4377] = {.lex_state = 95},
  [4378] = {.lex_state = 110},
  [4379] = {.lex_state = 110},
  [4380] = {.lex_state = 95},
  [4381] = {.lex_state = 148},
  [4382] = {.lex_state = 148},
  [4383] = {.lex_state = 102},
  [4384] = {.lex_state = 95},
  [4385] = {.lex_state = 148},
  [4386] = {.lex_state = 148},
  [4387] = {.lex_state = 102},
  [4388] = {.lex_state = 148},
  [4389] = {.lex_state = 148},
  [4390] = {.lex_state = 130},
  [4391] = {.lex_state = 102},
  [4392] = {.lex_state = 102, .external_lex_state = 2},
  [4393] = {.lex_state = 95},
  [4394] = {.lex_state = 95},
  [4395] = {.lex_state = 102, .external_lex_state = 2},
  [4396] = {.lex_state = 95},
  [4397] = {.lex_state = 102, .external_lex_state = 2},
  [4398] = {.lex_state = 95},
  [4399] = {.lex_state = 137},
  [4400] = {.lex_state = 95},
  [4401] = {.lex_state = 95},
  [4402] = {.lex_state = 102, .external_lex_state = 2},
  [4403] = {.lex_state = 95},
  [4404] = {.lex_state = 95},
  [4405] = {.lex_state = 95},
  [4406] = {.lex_state = 110, .external_lex_state = 2},
  [4407] = {.lex_state = 110, .external_lex_state = 2},
  [4408] = {.lex_state = 95},
  [4409] = {.lex_state = 148},
  [4410] = {.lex_state = 102},
  [4411] = {.lex_state = 148},
  [4412] = {.lex_state = 179},
  [4413] = {.lex_state = 179},
  [4414] = {.lex_state = 102},
  [4415] = {.lex_state = 95},
  [4416] = {.lex_state = 148},
  [4417] = {.lex_state = 148},
  [4418] = {.lex_state = 102},
  [4419] = {.lex_state = 148},
  [4420] = {.lex_state = 139},
  [4421] = {.lex_state = 148},
  [4422] = {.lex_state = 139},
  [4423] = {.lex_state = 170},
  [4424] = {.lex_state = 148},
  [4425] = {.lex_state = 102},
  [4426] = {.lex_state = 148},
  [4427] = {.lex_state = 134},
  [4428] = {.lex_state = 134},
  [4429] = {.lex_state = 148},
  [4430] = {.lex_state = 102},
  [4431] = {.lex_state = 148},
  [4432] = {.lex_state = 130},
  [4433] = {.lex_state = 130},
  [4434] = {.lex_state = 134},
  [4435] = {.lex_state = 102, .external_lex_state = 2},
  [4436] = {.lex_state = 102, .external_lex_state = 2},
  [4437] = {.lex_state = 95},
  [4438] = {.lex_state = 102, .external_lex_state = 2},
  [4439] = {.lex_state = 102},
  [4440] = {.lex_state = 102, .external_lex_state = 2},
  [4441] = {.lex_state = 102},
  [4442] = {.lex_state = 148},
  [4443] = {.lex_state = 102, .external_lex_state = 2},
  [4444] = {.lex_state = 95},
  [4445] = {.lex_state = 102, .external_lex_state = 2},
  [4446] = {.lex_state = 134, .external_lex_state = 2},
  [4447] = {.lex_state = 102, .external_lex_state = 2},
  [4448] = {.lex_state = 102, .external_lex_state = 2},
  [4449] = {.lex_state = 102},
  [4450] = {.lex_state = 95},
  [4451] = {.lex_state = 148},
  [4452] = {.lex_state = 148},
  [4453] = {.lex_state = 102},
  [4454] = {.lex_state = 148},
  [4455] = {.lex_state = 137, .external_lex_state = 2},
  [4456] = {.lex_state = 148},
  [4457] = {.lex_state = 137, .external_lex_state = 2},
  [4458] = {.lex_state = 130},
  [4459] = {.lex_state = 102, .external_lex_state = 2},
  [4460] = {.lex_state = 130},
  [4461] = {.lex_state = 148},
  [4462] = {.lex_state = 130},
  [4463] = {.lex_state = 102},
  [4464] = {.lex_state = 139},
  [4465] = {.lex_state = 148},
  [4466] = {.lex_state = 139},
  [4467] = {.lex_state = 130},
  [4468] = {.lex_state = 164},
  [4469] = {.lex_state = 102, .external_lex_state = 2},
  [4470] = {.lex_state = 95},
  [4471] = {.lex_state = 130},
  [4472] = {.lex_state = 130},
  [4473] = {.lex_state = 95},
  [4474] = {.lex_state = 102},
  [4475] = {.lex_state = 102, .external_lex_state = 2},
  [4476] = {.lex_state = 95},
  [4477] = {.lex_state = 102},
  [4478] = {.lex_state = 148},
  [4479] = {.lex_state = 148},
  [4480] = {.lex_state = 102},
  [4481] = {.lex_state = 95},
  [4482] = {.lex_state = 148},
  [4483] = {.lex_state = 148},
  [4484] = {.lex_state = 102},
  [4485] = {.lex_state = 148},
  [4486] = {.lex_state = 148},
  [4487] = {.lex_state = 130},
  [4488] = {.lex_state = 95},
  [4489] = {.lex_state = 174, .external_lex_state = 2},
  [4490] = {.lex_state = 102},
  [4491] = {.lex_state = 95},
  [4492] = {.lex_state = 148},
  [4493] = {.lex_state = 148},
  [4494] = {.lex_state = 102},
  [4495] = {.lex_state = 148},
  [4496] = {.lex_state = 134, .external_lex_state = 2},
  [4497] = {.lex_state = 148},
  [4498] = {.lex_state = 134, .external_lex_state = 2},
  [4499] = {.lex_state = 148},
  [4500] = {.lex_state = 102},
  [4501] = {.lex_state = 148},
  [4502] = {.lex_state = 130},
  [4503] = {.lex_state = 130},
  [4504] = {.lex_state = 110},
  [4505] = {.lex_state = 110, .external_lex_state = 2},
  [4506] = {.lex_state = 148},
  [4507] = {.lex_state = 110, .external_lex_state = 2},
  [4508] = {.lex_state = 102, .external_lex_state = 2},
  [4509] = {.lex_state = 95},
  [4510] = {.lex_state = 95},
  [4511] = {.lex_state = 95},
  [4512] = {.lex_state = 95},
  [4513] = {.lex_state = 95},
  [4514] = {.lex_state = 95},
  [4515] = {.lex_state = 170, .external_lex_state = 2},
  [4516] = {.lex_state = 139},
  [4517] = {.lex_state = 170},
  [4518] = {.lex_state = 95},
  [4519] = {.lex_state = 95},
  [4520] = {.lex_state = 95},
  [4521] = {.lex_state = 95},
  [4522] = {.lex_state = 170},
  [4523] = {.lex_state = 139},
  [4524] = {.lex_state = 170},
  [4525] = {.lex_state = 170, .external_lex_state = 2},
  [4526] = {.lex_state = 139},
  [4527] = {.lex_state = 170},
  [4528] = {.lex_state = 170, .external_lex_state = 2},
  [4529] = {.lex_state = 139},
  [4530] = {.lex_state = 148},
  [4531] = {.lex_state = 170},
  [4532] = {.lex_state = 170},
  [4533] = {.lex_state = 170},
  [4534] = {.lex_state = 95},
  [4535] = {.lex_state = 95},
  [4536] = {.lex_state = 95},
  [4537] = {.lex_state = 95},
  [4538] = {.lex_state = 95},
  [4539] = {.lex_state = 95},
  [4540] = {.lex_state = 148},
  [4541] = {.lex_state = 148},
  [4542] = {.lex_state = 102},
  [4543] = {.lex_state = 95},
  [4544] = {.lex_state = 148},
  [4545] = {.lex_state = 148},
  [4546] = {.lex_state = 102},
  [4547] = {.lex_state = 148},
  [4548] = {.lex_state = 148},
  [4549] = {.lex_state = 134},
  [4550] = {.lex_state = 148},
  [4551] = {.lex_state = 134},
  [4552] = {.lex_state = 110},
  [4553] = {.lex_state = 148},
  [4554] = {.lex_state = 110},
  [4555] = {.lex_state = 110, .external_lex_state = 2},
  [4556] = {.lex_state = 162, .external_lex_state = 2},
  [4557] = {.lex_state = 102},
  [4558] = {.lex_state = 159},
  [4559] = {.lex_state = 134, .external_lex_state = 2},
  [4560] = {.lex_state = 148},
  [4561] = {.lex_state = 134, .external_lex_state = 2},
  [4562] = {.lex_state = 174, .external_lex_state = 2},
  [4563] = {.lex_state = 174, .external_lex_state = 2},
  [4564] = {.lex_state = 134},
  [4565] = {.lex_state = 148},
  [4566] = {.lex_state = 134},
  [4567] = {.lex_state = 170},
  [4568] = {.lex_state = 168},
  [4569] = {.lex_state = 148},
  [4570] = {.lex_state = 168},
  [4571] = {.lex_state = 170},
  [4572] = {.lex_state = 170},
  [4573] = {.lex_state = 170},
  [4574] = {.lex_state = 95},
  [4575] = {.lex_state = 95},
  [4576] = {.lex_state = 95},
  [4577] = {.lex_state = 95},
  [4578] = {.lex_state = 95},
  [4579] = {.lex_state = 95},
  [4580] = {.lex_state = 148},
  [4581] = {.lex_state = 148},
  [4582] = {.lex_state = 102},
  [4583] = {.lex_state = 95},
  [4584] = {.lex_state = 148},
  [4585] = {.lex_state = 148},
  [4586] = {.lex_state = 102},
  [4587] = {.lex_state = 148},
  [4588] = {.lex_state = 148},
  [4589] = {.lex_state = 134, .external_lex_state = 2},
  [4590] = {.lex_state = 148},
  [4591] = {.lex_state = 134, .external_lex_state = 2},
  [4592] = {.lex_state = 137},
  [4593] = {.lex_state = 137},
  [4594] = {.lex_state = 137},
  [4595] = {.lex_state = 170, .external_lex_state = 2},
  [4596] = {.lex_state = 170, .external_lex_state = 2},
  [4597] = {.lex_state = 170, .external_lex_state = 2},
  [4598] = {.lex_state = 148},
  [4599] = {.lex_state = 102},
  [4600] = {.lex_state = 148},
  [4601] = {.lex_state = 170, .external_lex_state = 2},
  [4602] = {.lex_state = 170, .external_lex_state = 2},
  [4603] = {.lex_state = 130},
  [4604] = {.lex_state = 170},
  [4605] = {.lex_state = 170},
  [4606] = {.lex_state = 170},
  [4607] = {.lex_state = 148},
  [4608] = {.lex_state = 102},
  [4609] = {.lex_state = 148},
  [4610] = {.lex_state = 170},
  [4611] = {.lex_state = 170},
  [4612] = {.lex_state = 130},
  [4613] = {.lex_state = 166},
  [4614] = {.lex_state = 166},
  [4615] = {.lex_state = 110},
  [4616] = {.lex_state = 130},
  [4617] = {.lex_state = 95},
  [4618] = {.lex_state = 102},
  [4619] = {.lex_state = 102},
  [4620] = {.lex_state = 168},
  [4621] = {.lex_state = 148},
  [4622] = {.lex_state = 168},
  [4623] = {.lex_state = 148},
  [4624] = {.lex_state = 95},
  [4625] = {.lex_state = 148},
  [4626] = {.lex_state = 134, .external_lex_state = 2},
  [4627] = {.lex_state = 95},
  [4628] = {.lex_state = 102},
  [4629] = {.lex_state = 134, .external_lex_state = 2},
  [4630] = {.lex_state = 148},
  [4631] = {.lex_state = 102},
  [4632] = {.lex_state = 148},
  [4633] = {.lex_state = 134, .external_lex_state = 2},
  [4634] = {.lex_state = 134, .external_lex_state = 2},
  [4635] = {.lex_state = 137, .external_lex_state = 2},
  [4636] = {.lex_state = 102, .external_lex_state = 2},
  [4637] = {.lex_state = 102},
  [4638] = {.lex_state = 95},
  [4639] = {.lex_state = 148},
  [4640] = {.lex_state = 148},
  [4641] = {.lex_state = 102},
  [4642] = {.lex_state = 148},
  [4643] = {.lex_state = 134, .external_lex_state = 2},
  [4644] = {.lex_state = 148},
  [4645] = {.lex_state = 134, .external_lex_state = 2},
  [4646] = {.lex_state = 95},
  [4647] = {.lex_state = 102, .external_lex_state = 2},
  [4648] = {.lex_state = 134},
  [4649] = {.lex_state = 148},
  [4650] = {.lex_state = 134},
  [4651] = {.lex_state = 159, .external_lex_state = 2},
  [4652] = {.lex_state = 148},
  [4653] = {.lex_state = 159, .external_lex_state = 2},
  [4654] = {.lex_state = 102},
  [4655] = {.lex_state = 95},
  [4656] = {.lex_state = 95},
  [4657] = {.lex_state = 95},
  [4658] = {.lex_state = 170},
  [4659] = {.lex_state = 170},
  [4660] = {.lex_state = 170},
  [4661] = {.lex_state = 95},
  [4662] = {.lex_state = 95},
  [4663] = {.lex_state = 170},
  [4664] = {.lex_state = 139},
  [4665] = {.lex_state = 170},
  [4666] = {.lex_state = 139},
  [4667] = {.lex_state = 170},
  [4668] = {.lex_state = 139},
  [4669] = {.lex_state = 95},
  [4670] = {.lex_state = 95},
  [4671] = {.lex_state = 95},
  [4672] = {.lex_state = 95},
  [4673] = {.lex_state = 95},
  [4674] = {.lex_state = 137},
  [4675] = {.lex_state = 148},
  [4676] = {.lex_state = 148},
  [4677] = {.lex_state = 95},
  [4678] = {.lex_state = 148},
  [4679] = {.lex_state = 137},
  [4680] = {.lex_state = 95},
  [4681] = {.lex_state = 137},
  [4682] = {.lex_state = 102},
  [4683] = {.lex_state = 95},
  [4684] = {.lex_state = 95},
  [4685] = {.lex_state = 95},
  [4686] = {.lex_state = 137},
  [4687] = {.lex_state = 137},
  [4688] = {.lex_state = 148},
  [4689] = {.lex_state = 102},
  [4690] = {.lex_state = 148},
  [4691] = {.lex_state = 137},
  [4692] = {.lex_state = 137},
  [4693] = {.lex_state = 95},
  [4694] = {.lex_state = 110},
  [4695] = {.lex_state = 110},
  [4696] = {.lex_state = 110},
  [4697] = {.lex_state = 148},
  [4698] = {.lex_state = 102},
  [4699] = {.lex_state = 148},
  [4700] = {.lex_state = 110},
  [4701] = {.lex_state = 110},
  [4702] = {.lex_state = 130},
  [4703] = {.lex_state = 95},
  [4704] = {.lex_state = 95},
  [4705] = {.lex_state = 95},
  [4706] = {.lex_state = 95},
  [4707] = {.lex_state = 102},
  [4708] = {.lex_state = 95},
  [4709] = {.lex_state = 134},
  [4710] = {.lex_state = 95},
  [4711] = {.lex_state = 95},
  [4712] = {.lex_state = 95},
  [4713] = {.lex_state = 95},
  [4714] = {.lex_state = 95},
  [4715] = {.lex_state = 95},
  [4716] = {.lex_state = 95},
  [4717] = {.lex_state = 95},
  [4718] = {.lex_state = 95},
  [4719] = {.lex_state = 95},
  [4720] = {.lex_state = 95},
  [4721] = {.lex_state = 102, .external_lex_state = 2},
  [4722] = {.lex_state = 102},
  [4723] = {.lex_state = 102},
  [4724] = {.lex_state = 139},
  [4725] = {.lex_state = 95},
  [4726] = {.lex_state = 95},
  [4727] = {.lex_state = 95},
  [4728] = {.lex_state = 95},
  [4729] = {.lex_state = 102},
  [4730] = {.lex_state = 179},
  [4731] = {.lex_state = 148},
  [4732] = {.lex_state = 179},
  [4733] = {.lex_state = 148},
  [4734] = {.lex_state = 102},
  [4735] = {.lex_state = 148},
  [4736] = {.lex_state = 139},
  [4737] = {.lex_state = 139},
  [4738] = {.lex_state = 134},
  [4739] = {.lex_state = 148},
  [4740] = {.lex_state = 134},
  [4741] = {.lex_state = 130},
  [4742] = {.lex_state = 148},
  [4743] = {.lex_state = 130},
  [4744] = {.lex_state = 102, .external_lex_state = 2},
  [4745] = {.lex_state = 102, .external_lex_state = 2},
  [4746] = {.lex_state = 102},
  [4747] = {.lex_state = 137, .external_lex_state = 2},
  [4748] = {.lex_state = 102, .external_lex_state = 2},
  [4749] = {.lex_state = 102, .external_lex_state = 2},
  [4750] = {.lex_state = 148},
  [4751] = {.lex_state = 102},
  [4752] = {.lex_state = 148},
  [4753] = {.lex_state = 137, .external_lex_state = 2},
  [4754] = {.lex_state = 137, .external_lex_state = 2},
  [4755] = {.lex_state = 95},
  [4756] = {.lex_state = 130},
  [4757] = {.lex_state = 139},
  [4758] = {.lex_state = 130},
  [4759] = {.lex_state = 102, .external_lex_state = 2},
  [4760] = {.lex_state = 95},
  [4761] = {.lex_state = 95},
  [4762] = {.lex_state = 102},
  [4763] = {.lex_state = 102},
  [4764] = {.lex_state = 102, .external_lex_state = 2},
  [4765] = {.lex_state = 148},
  [4766] = {.lex_state = 95},
  [4767] = {.lex_state = 148},
  [4768] = {.lex_state = 137, .external_lex_state = 2},
  [4769] = {.lex_state = 95},
  [4770] = {.lex_state = 102},
  [4771] = {.lex_state = 137, .external_lex_state = 2},
  [4772] = {.lex_state = 148},
  [4773] = {.lex_state = 102},
  [4774] = {.lex_state = 148},
  [4775] = {.lex_state = 137, .external_lex_state = 2},
  [4776] = {.lex_state = 137, .external_lex_state = 2},
  [4777] = {.lex_state = 130},
  [4778] = {.lex_state = 148},
  [4779] = {.lex_state = 102},
  [4780] = {.lex_state = 148},
  [4781] = {.lex_state = 134, .external_lex_state = 2},
  [4782] = {.lex_state = 134, .external_lex_state = 2},
  [4783] = {.lex_state = 130},
  [4784] = {.lex_state = 148},
  [4785] = {.lex_state = 130},
  [4786] = {.lex_state = 110, .external_lex_state = 2},
  [4787] = {.lex_state = 95},
  [4788] = {.lex_state = 95},
  [4789] = {.lex_state = 95},
  [4790] = {.lex_state = 170},
  [4791] = {.lex_state = 170},
  [4792] = {.lex_state = 170},
  [4793] = {.lex_state = 95},
  [4794] = {.lex_state = 95},
  [4795] = {.lex_state = 170},
  [4796] = {.lex_state = 139},
  [4797] = {.lex_state = 170},
  [4798] = {.lex_state = 139},
  [4799] = {.lex_state = 170},
  [4800] = {.lex_state = 139},
  [4801] = {.lex_state = 95},
  [4802] = {.lex_state = 95},
  [4803] = {.lex_state = 95},
  [4804] = {.lex_state = 95},
  [4805] = {.lex_state = 95},
  [4806] = {.lex_state = 130},
  [4807] = {.lex_state = 148},
  [4808] = {.lex_state = 148},
  [4809] = {.lex_state = 95},
  [4810] = {.lex_state = 148},
  [4811] = {.lex_state = 130},
  [4812] = {.lex_state = 95},
  [4813] = {.lex_state = 130},
  [4814] = {.lex_state = 102},
  [4815] = {.lex_state = 95},
  [4816] = {.lex_state = 95},
  [4817] = {.lex_state = 95},
  [4818] = {.lex_state = 148},
  [4819] = {.lex_state = 95},
  [4820] = {.lex_state = 148},
  [4821] = {.lex_state = 130},
  [4822] = {.lex_state = 95},
  [4823] = {.lex_state = 102},
  [4824] = {.lex_state = 130},
  [4825] = {.lex_state = 148},
  [4826] = {.lex_state = 102},
  [4827] = {.lex_state = 148},
  [4828] = {.lex_state = 130},
  [4829] = {.lex_state = 130},
  [4830] = {.lex_state = 134},
  [4831] = {.lex_state = 110},
  [4832] = {.lex_state = 134, .external_lex_state = 2},
  [4833] = {.lex_state = 134},
  [4834] = {.lex_state = 168},
  [4835] = {.lex_state = 95},
  [4836] = {.lex_state = 95},
  [4837] = {.lex_state = 95},
  [4838] = {.lex_state = 134},
  [4839] = {.lex_state = 134},
  [4840] = {.lex_state = 148},
  [4841] = {.lex_state = 102},
  [4842] = {.lex_state = 148},
  [4843] = {.lex_state = 134},
  [4844] = {.lex_state = 134},
  [4845] = {.lex_state = 134, .external_lex_state = 2},
  [4846] = {.lex_state = 170, .external_lex_state = 2},
  [4847] = {.lex_state = 148},
  [4848] = {.lex_state = 170, .external_lex_state = 2},
  [4849] = {.lex_state = 170},
  [4850] = {.lex_state = 148},
  [4851] = {.lex_state = 170},
  [4852] = {.lex_state = 102},
  [4853] = {.lex_state = 168},
  [4854] = {.lex_state = 102},
  [4855] = {.lex_state = 95},
  [4856] = {.lex_state = 148},
  [4857] = {.lex_state = 148},
  [4858] = {.lex_state = 102},
  [4859] = {.lex_state = 148},
  [4860] = {.lex_state = 134, .external_lex_state = 2},
  [4861] = {.lex_state = 148},
  [4862] = {.lex_state = 134, .external_lex_state = 2},
  [4863] = {.lex_state = 137, .external_lex_state = 2},
  [4864] = {.lex_state = 148},
  [4865] = {.lex_state = 102},
  [4866] = {.lex_state = 148},
  [4867] = {.lex_state = 134, .external_lex_state = 2},
  [4868] = {.lex_state = 134, .external_lex_state = 2},
  [4869] = {.lex_state = 102, .external_lex_state = 2},
  [4870] = {.lex_state = 134},
  [4871] = {.lex_state = 159, .external_lex_state = 2},
  [4872] = {.lex_state = 170},
  [4873] = {.lex_state = 170},
  [4874] = {.lex_state = 170},
  [4875] = {.lex_state = 95},
  [4876] = {.lex_state = 95},
  [4877] = {.lex_state = 95},
  [4878] = {.lex_state = 95},
  [4879] = {.lex_state = 95},
  [4880] = {.lex_state = 95},
  [4881] = {.lex_state = 148},
  [4882] = {.lex_state = 148},
  [4883] = {.lex_state = 102},
  [4884] = {.lex_state = 95},
  [4885] = {.lex_state = 148},
  [4886] = {.lex_state = 148},
  [4887] = {.lex_state = 102},
  [4888] = {.lex_state = 148},
  [4889] = {.lex_state = 148},
  [4890] = {.lex_state = 137},
  [4891] = {.lex_state = 148},
  [4892] = {.lex_state = 137},
  [4893] = {.lex_state = 102},
  [4894] = {.lex_state = 110},
  [4895] = {.lex_state = 148},
  [4896] = {.lex_state = 110},
  [4897] = {.lex_state = 137},
  [4898] = {.lex_state = 95},
  [4899] = {.lex_state = 102, .external_lex_state = 2},
  [4900] = {.lex_state = 95},
  [4901] = {.lex_state = 95},
  [4902] = {.lex_state = 95},
  [4903] = {.lex_state = 110, .external_lex_state = 2},
  [4904] = {.lex_state = 110, .external_lex_state = 2},
  [4905] = {.lex_state = 95},
  [4906] = {.lex_state = 95},
  [4907] = {.lex_state = 95},
  [4908] = {.lex_state = 95},
  [4909] = {.lex_state = 95},
  [4910] = {.lex_state = 95},
  [4911] = {.lex_state = 95},
  [4912] = {.lex_state = 170, .external_lex_state = 2},
  [4913] = {.lex_state = 139},
  [4914] = {.lex_state = 170},
  [4915] = {.lex_state = 95},
  [4916] = {.lex_state = 95},
  [4917] = {.lex_state = 95},
  [4918] = {.lex_state = 95},
  [4919] = {.lex_state = 170},
  [4920] = {.lex_state = 139},
  [4921] = {.lex_state = 170},
  [4922] = {.lex_state = 170, .external_lex_state = 2},
  [4923] = {.lex_state = 139},
  [4924] = {.lex_state = 170},
  [4925] = {.lex_state = 170, .external_lex_state = 2},
  [4926] = {.lex_state = 139},
  [4927] = {.lex_state = 148},
  [4928] = {.lex_state = 179},
  [4929] = {.lex_state = 139},
  [4930] = {.lex_state = 148},
  [4931] = {.lex_state = 139},
  [4932] = {.lex_state = 134},
  [4933] = {.lex_state = 130},
  [4934] = {.lex_state = 102, .external_lex_state = 2},
  [4935] = {.lex_state = 137, .external_lex_state = 2},
  [4936] = {.lex_state = 148},
  [4937] = {.lex_state = 137, .external_lex_state = 2},
  [4938] = {.lex_state = 102, .external_lex_state = 2},
  [4939] = {.lex_state = 102, .external_lex_state = 2},
  [4940] = {.lex_state = 102},
  [4941] = {.lex_state = 102},
  [4942] = {.lex_state = 95},
  [4943] = {.lex_state = 148},
  [4944] = {.lex_state = 148},
  [4945] = {.lex_state = 102},
  [4946] = {.lex_state = 148},
  [4947] = {.lex_state = 137, .external_lex_state = 2},
  [4948] = {.lex_state = 148},
  [4949] = {.lex_state = 137, .external_lex_state = 2},
  [4950] = {.lex_state = 95},
  [4951] = {.lex_state = 134, .external_lex_state = 2},
  [4952] = {.lex_state = 148},
  [4953] = {.lex_state = 134, .external_lex_state = 2},
  [4954] = {.lex_state = 130},
  [4955] = {.lex_state = 170},
  [4956] = {.lex_state = 170},
  [4957] = {.lex_state = 170},
  [4958] = {.lex_state = 95},
  [4959] = {.lex_state = 95},
  [4960] = {.lex_state = 95},
  [4961] = {.lex_state = 95},
  [4962] = {.lex_state = 95},
  [4963] = {.lex_state = 95},
  [4964] = {.lex_state = 148},
  [4965] = {.lex_state = 148},
  [4966] = {.lex_state = 102},
  [4967] = {.lex_state = 95},
  [4968] = {.lex_state = 148},
  [4969] = {.lex_state = 148},
  [4970] = {.lex_state = 102},
  [4971] = {.lex_state = 148},
  [4972] = {.lex_state = 148},
  [4973] = {.lex_state = 102},
  [4974] = {.lex_state = 95},
  [4975] = {.lex_state = 148},
  [4976] = {.lex_state = 148},
  [4977] = {.lex_state = 102},
  [4978] = {.lex_state = 148},
  [4979] = {.lex_state = 130},
  [4980] = {.lex_state = 148},
  [4981] = {.lex_state = 130},
  [4982] = {.lex_state = 134},
  [4983] = {.lex_state = 148},
  [4984] = {.lex_state = 134},
  [4985] = {.lex_state = 170, .external_lex_state = 2},
  [4986] = {.lex_state = 170},
  [4987] = {.lex_state = 148},
  [4988] = {.lex_state = 102},
  [4989] = {.lex_state = 148},
  [4990] = {.lex_state = 134, .external_lex_state = 2},
  [4991] = {.lex_state = 134, .external_lex_state = 2},
  [4992] = {.lex_state = 134, .external_lex_state = 2},
  [4993] = {.lex_state = 148},
  [4994] = {.lex_state = 134, .external_lex_state = 2},
  [4995] = {.lex_state = 137, .external_lex_state = 2},
  [4996] = {.lex_state = 95},
  [4997] = {.lex_state = 95},
  [4998] = {.lex_state = 95},
  [4999] = {.lex_state = 137},
  [5000] = {.lex_state = 137},
  [5001] = {.lex_state = 148},
  [5002] = {.lex_state = 102},
  [5003] = {.lex_state = 148},
  [5004] = {.lex_state = 137},
  [5005] = {.lex_state = 137},
  [5006] = {.lex_state = 137},
  [5007] = {.lex_state = 110},
  [5008] = {.lex_state = 95},
  [5009] = {.lex_state = 95},
  [5010] = {.lex_state = 95},
  [5011] = {.lex_state = 95},
  [5012] = {.lex_state = 95},
  [5013] = {.lex_state = 95},
  [5014] = {.lex_state = 95},
  [5015] = {.lex_state = 102, .external_lex_state = 2},
  [5016] = {.lex_state = 102},
  [5017] = {.lex_state = 102},
  [5018] = {.lex_state = 139},
  [5019] = {.lex_state = 95},
  [5020] = {.lex_state = 95},
  [5021] = {.lex_state = 95},
  [5022] = {.lex_state = 95},
  [5023] = {.lex_state = 102},
  [5024] = {.lex_state = 95},
  [5025] = {.lex_state = 95},
  [5026] = {.lex_state = 95},
  [5027] = {.lex_state = 170},
  [5028] = {.lex_state = 170},
  [5029] = {.lex_state = 170},
  [5030] = {.lex_state = 95},
  [5031] = {.lex_state = 95},
  [5032] = {.lex_state = 170},
  [5033] = {.lex_state = 139},
  [5034] = {.lex_state = 170},
  [5035] = {.lex_state = 139},
  [5036] = {.lex_state = 170},
  [5037] = {.lex_state = 139},
  [5038] = {.lex_state = 95},
  [5039] = {.lex_state = 95},
  [5040] = {.lex_state = 95},
  [5041] = {.lex_state = 95},
  [5042] = {.lex_state = 95},
  [5043] = {.lex_state = 137},
  [5044] = {.lex_state = 148},
  [5045] = {.lex_state = 148},
  [5046] = {.lex_state = 95},
  [5047] = {.lex_state = 148},
  [5048] = {.lex_state = 137},
  [5049] = {.lex_state = 95},
  [5050] = {.lex_state = 137},
  [5051] = {.lex_state = 102},
  [5052] = {.lex_state = 139},
  [5053] = {.lex_state = 137, .external_lex_state = 2},
  [5054] = {.lex_state = 148},
  [5055] = {.lex_state = 102},
  [5056] = {.lex_state = 148},
  [5057] = {.lex_state = 137, .external_lex_state = 2},
  [5058] = {.lex_state = 137, .external_lex_state = 2},
  [5059] = {.lex_state = 102, .external_lex_state = 2},
  [5060] = {.lex_state = 134, .external_lex_state = 2},
  [5061] = {.lex_state = 95},
  [5062] = {.lex_state = 95},
  [5063] = {.lex_state = 95},
  [5064] = {.lex_state = 148},
  [5065] = {.lex_state = 95},
  [5066] = {.lex_state = 148},
  [5067] = {.lex_state = 130},
  [5068] = {.lex_state = 95},
  [5069] = {.lex_state = 102},
  [5070] = {.lex_state = 130},
  [5071] = {.lex_state = 148},
  [5072] = {.lex_state = 102},
  [5073] = {.lex_state = 148},
  [5074] = {.lex_state = 130},
  [5075] = {.lex_state = 130},
  [5076] = {.lex_state = 148},
  [5077] = {.lex_state = 102},
  [5078] = {.lex_state = 148},
  [5079] = {.lex_state = 130},
  [5080] = {.lex_state = 130},
  [5081] = {.lex_state = 134},
  [5082] = {.lex_state = 134, .external_lex_state = 2},
  [5083] = {.lex_state = 148},
  [5084] = {.lex_state = 134, .external_lex_state = 2},
  [5085] = {.lex_state = 134, .external_lex_state = 2},
  [5086] = {.lex_state = 137},
  [5087] = {.lex_state = 148},
  [5088] = {.lex_state = 137},
  [5089] = {.lex_state = 95},
  [5090] = {.lex_state = 95},
  [5091] = {.lex_state = 95},
  [5092] = {.lex_state = 95},
  [5093] = {.lex_state = 95},
  [5094] = {.lex_state = 95},
  [5095] = {.lex_state = 170, .external_lex_state = 2},
  [5096] = {.lex_state = 139},
  [5097] = {.lex_state = 170},
  [5098] = {.lex_state = 95},
  [5099] = {.lex_state = 95},
  [5100] = {.lex_state = 95},
  [5101] = {.lex_state = 95},
  [5102] = {.lex_state = 170},
  [5103] = {.lex_state = 139},
  [5104] = {.lex_state = 170},
  [5105] = {.lex_state = 170, .external_lex_state = 2},
  [5106] = {.lex_state = 139},
  [5107] = {.lex_state = 170},
  [5108] = {.lex_state = 170, .external_lex_state = 2},
  [5109] = {.lex_state = 139},
  [5110] = {.lex_state = 148},
  [5111] = {.lex_state = 170},
  [5112] = {.lex_state = 170},
  [5113] = {.lex_state = 170},
  [5114] = {.lex_state = 95},
  [5115] = {.lex_state = 95},
  [5116] = {.lex_state = 95},
  [5117] = {.lex_state = 95},
  [5118] = {.lex_state = 95},
  [5119] = {.lex_state = 95},
  [5120] = {.lex_state = 148},
  [5121] = {.lex_state = 148},
  [5122] = {.lex_state = 102},
  [5123] = {.lex_state = 95},
  [5124] = {.lex_state = 148},
  [5125] = {.lex_state = 148},
  [5126] = {.lex_state = 102},
  [5127] = {.lex_state = 148},
  [5128] = {.lex_state = 148},
  [5129] = {.lex_state = 137, .external_lex_state = 2},
  [5130] = {.lex_state = 148},
  [5131] = {.lex_state = 137, .external_lex_state = 2},
  [5132] = {.lex_state = 102},
  [5133] = {.lex_state = 95},
  [5134] = {.lex_state = 148},
  [5135] = {.lex_state = 148},
  [5136] = {.lex_state = 102},
  [5137] = {.lex_state = 148},
  [5138] = {.lex_state = 130},
  [5139] = {.lex_state = 148},
  [5140] = {.lex_state = 130},
  [5141] = {.lex_state = 130},
  [5142] = {.lex_state = 148},
  [5143] = {.lex_state = 130},
  [5144] = {.lex_state = 134, .external_lex_state = 2},
  [5145] = {.lex_state = 137},
  [5146] = {.lex_state = 95},
  [5147] = {.lex_state = 95},
  [5148] = {.lex_state = 95},
  [5149] = {.lex_state = 170},
  [5150] = {.lex_state = 170},
  [5151] = {.lex_state = 170},
  [5152] = {.lex_state = 95},
  [5153] = {.lex_state = 95},
  [5154] = {.lex_state = 170},
  [5155] = {.lex_state = 139},
  [5156] = {.lex_state = 170},
  [5157] = {.lex_state = 139},
  [5158] = {.lex_state = 170},
  [5159] = {.lex_state = 139},
  [5160] = {.lex_state = 95},
  [5161] = {.lex_state = 95},
  [5162] = {.lex_state = 95},
  [5163] = {.lex_state = 95},
  [5164] = {.lex_state = 95},
  [5165] = {.lex_state = 137},
  [5166] = {.lex_state = 148},
  [5167] = {.lex_state = 148},
  [5168] = {.lex_state = 95},
  [5169] = {.lex_state = 148},
  [5170] = {.lex_state = 137},
  [5171] = {.lex_state = 95},
  [5172] = {.lex_state = 137},
  [5173] = {.lex_state = 102},
  [5174] = {.lex_state = 95},
  [5175] = {.lex_state = 95},
  [5176] = {.lex_state = 95},
  [5177] = {.lex_state = 137},
  [5178] = {.lex_state = 137},
  [5179] = {.lex_state = 148},
  [5180] = {.lex_state = 102},
  [5181] = {.lex_state = 148},
  [5182] = {.lex_state = 137},
  [5183] = {.lex_state = 137},
  [5184] = {.lex_state = 137, .external_lex_state = 2},
  [5185] = {.lex_state = 148},
  [5186] = {.lex_state = 102},
  [5187] = {.lex_state = 148},
  [5188] = {.lex_state = 130},
  [5189] = {.lex_state = 130},
  [5190] = {.lex_state = 130},
  [5191] = {.lex_state = 170},
  [5192] = {.lex_state = 170},
  [5193] = {.lex_state = 170},
  [5194] = {.lex_state = 95},
  [5195] = {.lex_state = 95},
  [5196] = {.lex_state = 95},
  [5197] = {.lex_state = 95},
  [5198] = {.lex_state = 95},
  [5199] = {.lex_state = 95},
  [5200] = {.lex_state = 148},
  [5201] = {.lex_state = 148},
  [5202] = {.lex_state = 102},
  [5203] = {.lex_state = 95},
  [5204] = {.lex_state = 148},
  [5205] = {.lex_state = 148},
  [5206] = {.lex_state = 102},
  [5207] = {.lex_state = 148},
  [5208] = {.lex_state = 148},
  [5209] = {.lex_state = 137},
  [5210] = {.lex_state = 148},
  [5211] = {.lex_state = 137},
  [5212] = {.lex_state = 130},
  [5213] = {.lex_state = 148},
  [5214] = {.lex_state = 130},
  [5215] = {.lex_state = 95},
  [5216] = {.lex_state = 95},
  [5217] = {.lex_state = 95},
  [5218] = {.lex_state = 137},
  [5219] = {.lex_state = 137},
  [5220] = {.lex_state = 148},
  [5221] = {.lex_state = 102},
  [5222] = {.lex_state = 148},
  [5223] = {.lex_state = 137},
  [5224] = {.lex_state = 137},
  [5225] = {.lex_state = 137},
  [5226] = {.lex_state = 130},
  [5227] = {.lex_state = 137},
  [5228] = {.lex_state = 148},
  [5229] = {.lex_state = 137},
  [5230] = {.lex_state = 137},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
};

static bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
  },
  [1] = {
    [sym_type_alias_declaration] = STATE(55),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(55),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(55),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(55),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(55),
    [sym_throw_statement] = STATE(55),
    [aux_sym_program_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(55),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(55),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(55),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(55),
    [sym_abstract_class] = STATE(55),
    [sym_interface_declaration] = STATE(55),
    [sym_statement_block] = STATE(55),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(55),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(55),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(55),
    [sym_function] = STATE(59),
    [sym_program] = STATE(60),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(55),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(55),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(55),
    [sym_empty_statement] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(55),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(55),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(55),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(55),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [sym_hash_bang_line] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(121),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [3] = {
    [aux_sym_template_string_repeat1] = STATE(74),
    [sym_template_substitution] = STATE(74),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [sym_escape_sequence] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym__template_chars] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__automatic_semicolon] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(133),
  },
  [5] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [6] = {
    [sym__identifier_reference] = STATE(81),
    [sym_decorator_member_expression] = STATE(81),
    [sym_decorator_call_expression] = STATE(82),
    [anon_sym_get] = ACTIONS(145),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_module] = ACTIONS(145),
    [anon_sym_symbol] = ACTIONS(145),
    [anon_sym_number] = ACTIONS(145),
    [anon_sym_declare] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_protected] = ACTIONS(145),
    [anon_sym_string] = ACTIONS(145),
    [anon_sym_set] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_namespace] = ACTIONS(145),
    [anon_sym_any] = ACTIONS(145),
    [anon_sym_private] = ACTIONS(145),
    [anon_sym_boolean] = ACTIONS(145),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(145),
  },
  [7] = {
    [sym_new_expression] = STATE(87),
    [sym_augmented_assignment_expression] = STATE(87),
    [sym_unary_expression] = STATE(87),
    [sym_update_expression] = STATE(87),
    [sym_regex] = STATE(87),
    [sym_meta_property] = STATE(87),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(87),
    [sym_yield_expression] = STATE(87),
    [sym_as_expression] = STATE(87),
    [sym_non_null_expression] = STATE(87),
    [sym_internal_module] = STATE(87),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(87),
    [sym_await_expression] = STATE(87),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(87),
    [sym_this] = STATE(87),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(87),
    [sym_generator_function] = STATE(87),
    [sym_call_expression] = STATE(87),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(87),
    [sym_ternary_expression] = STATE(87),
    [sym_binary_expression] = STATE(87),
    [sym_template_string] = STATE(87),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(87),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(87),
    [sym_class] = STATE(87),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(157),
    [sym_true] = ACTIONS(151),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(151),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [8] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_meta_property] = STATE(90),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_internal_module] = STATE(90),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(161),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [9] = {
    [sym__automatic_semicolon] = ACTIONS(169),
    [sym_identifier] = ACTIONS(171),
    [anon_sym_SEMI] = ACTIONS(169),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_enum] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [11] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [12] = {
    [sym_new_expression] = STATE(106),
    [sym_augmented_assignment_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_update_expression] = STATE(106),
    [sym_regex] = STATE(106),
    [sym_meta_property] = STATE(106),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_yield_expression] = STATE(106),
    [sym_as_expression] = STATE(106),
    [sym_non_null_expression] = STATE(106),
    [sym_internal_module] = STATE(106),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(106),
    [sym_await_expression] = STATE(106),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(107),
    [sym_string] = STATE(106),
    [sym_this] = STATE(106),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(106),
    [sym_generator_function] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(106),
    [sym_ternary_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_template_string] = STATE(106),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(106),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(106),
    [sym_class] = STATE(106),
    [sym__automatic_semicolon] = ACTIONS(187),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(189),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(191),
    [sym_true] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(189),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [13] = {
    [sym_identifier] = ACTIONS(193),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_identifier] = ACTIONS(195),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_meta_property] = STATE(90),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_internal_module] = STATE(90),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(167),
    [sym_true] = ACTIONS(161),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [16] = {
    [sym__automatic_semicolon] = ACTIONS(197),
    [sym_identifier] = ACTIONS(199),
    [anon_sym_SEMI] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_new_expression] = STATE(112),
    [sym_augmented_assignment_expression] = STATE(112),
    [sym_unary_expression] = STATE(112),
    [sym_update_expression] = STATE(112),
    [sym_regex] = STATE(112),
    [sym_meta_property] = STATE(112),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(112),
    [sym_yield_expression] = STATE(112),
    [sym_as_expression] = STATE(112),
    [sym_non_null_expression] = STATE(112),
    [sym_internal_module] = STATE(112),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(112),
    [sym_await_expression] = STATE(112),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(112),
    [sym_this] = STATE(112),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(112),
    [sym_generator_function] = STATE(112),
    [sym_call_expression] = STATE(112),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(112),
    [sym_ternary_expression] = STATE(112),
    [sym_binary_expression] = STATE(112),
    [sym_template_string] = STATE(112),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(112),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(112),
    [sym_class] = STATE(112),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(201),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(203),
    [sym_true] = ACTIONS(201),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(201),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [18] = {
    [sym_parenthesized_expression] = STATE(114),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(207),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_SEMI] = ACTIONS(207),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym__automatic_semicolon] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [20] = {
    [sym_new_expression] = STATE(115),
    [sym_augmented_assignment_expression] = STATE(115),
    [sym_unary_expression] = STATE(115),
    [sym_update_expression] = STATE(115),
    [sym_regex] = STATE(115),
    [sym_meta_property] = STATE(115),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(115),
    [sym_yield_expression] = STATE(115),
    [sym_as_expression] = STATE(115),
    [sym_non_null_expression] = STATE(115),
    [sym_internal_module] = STATE(115),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(115),
    [sym_await_expression] = STATE(115),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(115),
    [sym_this] = STATE(115),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(115),
    [sym_generator_function] = STATE(115),
    [sym_call_expression] = STATE(115),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(115),
    [sym_ternary_expression] = STATE(115),
    [sym_binary_expression] = STATE(115),
    [sym_template_string] = STATE(115),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(115),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(115),
    [sym_class] = STATE(115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(215),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(215),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [21] = {
    [sym_new_expression] = STATE(116),
    [sym_augmented_assignment_expression] = STATE(116),
    [sym_unary_expression] = STATE(116),
    [sym_update_expression] = STATE(116),
    [sym_regex] = STATE(116),
    [sym_meta_property] = STATE(116),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(116),
    [sym_yield_expression] = STATE(116),
    [sym_as_expression] = STATE(116),
    [sym_non_null_expression] = STATE(116),
    [sym_internal_module] = STATE(116),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(116),
    [sym_await_expression] = STATE(116),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(117),
    [sym_string] = STATE(116),
    [sym_this] = STATE(116),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(116),
    [sym_generator_function] = STATE(116),
    [sym_call_expression] = STATE(116),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(116),
    [sym_ternary_expression] = STATE(116),
    [sym_binary_expression] = STATE(116),
    [sym_template_string] = STATE(116),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(116),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(116),
    [sym_class] = STATE(116),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(219),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(219),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(221),
    [sym_true] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [22] = {
    [anon_sym_class] = ACTIONS(223),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [24] = {
    [sym_import_require_clause] = STATE(124),
    [sym_import_clause] = STATE(125),
    [sym_named_imports] = STATE(126),
    [sym_string] = STATE(124),
    [sym__initializer] = STATE(79),
    [sym_namespace_import] = STATE(126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(232),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(232),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [25] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [26] = {
    [sym_new_expression] = STATE(130),
    [sym_augmented_assignment_expression] = STATE(130),
    [sym_unary_expression] = STATE(130),
    [sym_update_expression] = STATE(130),
    [sym_regex] = STATE(130),
    [sym_meta_property] = STATE(130),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(130),
    [sym_yield_expression] = STATE(130),
    [sym_as_expression] = STATE(130),
    [sym_non_null_expression] = STATE(130),
    [sym_internal_module] = STATE(130),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(130),
    [sym_await_expression] = STATE(130),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(130),
    [sym_this] = STATE(130),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(130),
    [sym_generator_function] = STATE(130),
    [sym_call_expression] = STATE(130),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(130),
    [sym_ternary_expression] = STATE(130),
    [sym_binary_expression] = STATE(130),
    [sym_template_string] = STATE(130),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(130),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(130),
    [sym_class] = STATE(130),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(238),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(240),
    [sym_true] = ACTIONS(238),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(238),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [27] = {
    [aux_sym_string_repeat1] = STATE(132),
    [sym_escape_sequence] = ACTIONS(242),
    [aux_sym_string_token1] = ACTIONS(242),
    [anon_sym_DQUOTE] = ACTIONS(244),
    [sym_comment] = ACTIONS(246),
  },
  [28] = {
    [anon_sym_await] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_new_expression] = STATE(159),
    [sym_augmented_assignment_expression] = STATE(159),
    [sym_unary_expression] = STATE(159),
    [sym_update_expression] = STATE(159),
    [sym_regex] = STATE(159),
    [sym_meta_property] = STATE(159),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(159),
    [sym_yield_expression] = STATE(159),
    [sym_as_expression] = STATE(159),
    [sym_non_null_expression] = STATE(159),
    [sym_internal_module] = STATE(159),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(159),
    [sym_await_expression] = STATE(159),
    [sym_member_expression] = STATE(161),
    [sym_spread_element] = STATE(162),
    [sym_string] = STATE(159),
    [sym_this] = STATE(159),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [aux_sym_array_repeat1] = STATE(165),
    [sym_anonymous_class] = STATE(159),
    [sym_generator_function] = STATE(159),
    [sym_call_expression] = STATE(159),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(159),
    [sym_ternary_expression] = STATE(159),
    [sym_binary_expression] = STATE(159),
    [sym_template_string] = STATE(159),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(159),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(159),
    [sym_class] = STATE(159),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(256),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(276),
    [sym_null] = ACTIONS(256),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(288),
    [sym_true] = ACTIONS(256),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(256),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [30] = {
    [sym_identifier] = ACTIONS(304),
    [anon_sym_BQUOTE] = ACTIONS(306),
    [anon_sym_debugger] = ACTIONS(304),
    [anon_sym_symbol] = ACTIONS(304),
    [anon_sym_AT] = ACTIONS(306),
    [anon_sym_DASH] = ACTIONS(304),
    [anon_sym_void] = ACTIONS(304),
    [anon_sym_break] = ACTIONS(304),
    [anon_sym_const] = ACTIONS(304),
    [sym_super] = ACTIONS(304),
    [anon_sym_return] = ACTIONS(304),
    [anon_sym_private] = ACTIONS(304),
    [anon_sym_get] = ACTIONS(304),
    [anon_sym_RBRACE] = ACTIONS(306),
    [anon_sym_interface] = ACTIONS(304),
    [anon_sym_default] = ACTIONS(304),
    [anon_sym_enum] = ACTIONS(304),
    [anon_sym_delete] = ACTIONS(304),
    [anon_sym_continue] = ACTIONS(304),
    [anon_sym_DASH_DASH] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(304),
    [anon_sym_this] = ACTIONS(304),
    [anon_sym_yield] = ACTIONS(304),
    [sym_true] = ACTIONS(304),
    [anon_sym_throw] = ACTIONS(304),
    [anon_sym_protected] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(304),
    [anon_sym_set] = ACTIONS(304),
    [anon_sym_type] = ACTIONS(304),
    [anon_sym_import] = ACTIONS(304),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_PLUS_PLUS] = ACTIONS(306),
    [anon_sym_await] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(306),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(306),
    [anon_sym_for] = ACTIONS(304),
    [anon_sym_LBRACK] = ACTIONS(306),
    [sym_false] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_case] = ACTIONS(304),
    [anon_sym_module] = ACTIONS(304),
    [anon_sym_number] = ACTIONS(304),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_declare] = ACTIONS(304),
    [anon_sym_typeof] = ACTIONS(304),
    [anon_sym_LBRACE] = ACTIONS(306),
    [anon_sym_switch] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(306),
    [sym_null] = ACTIONS(304),
    [anon_sym_any] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(304),
    [anon_sym_public] = ACTIONS(304),
    [anon_sym_var] = ACTIONS(304),
    [anon_sym_while] = ACTIONS(304),
    [anon_sym_SQUOTE] = ACTIONS(306),
    [anon_sym_try] = ACTIONS(304),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_LT] = ACTIONS(306),
    [sym_number] = ACTIONS(306),
    [anon_sym_SLASH] = ACTIONS(304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(304),
    [anon_sym_function] = ACTIONS(304),
    [sym_undefined] = ACTIONS(304),
    [anon_sym_new] = ACTIONS(304),
    [ts_builtin_sym_end] = ACTIONS(306),
    [anon_sym_let] = ACTIONS(304),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_export] = ACTIONS(304),
    [anon_sym_do] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(306),
    [anon_sym_with] = ACTIONS(304),
  },
  [31] = {
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_string] = STATE(172),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(308),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [32] = {
    [sym_class_heritage] = STATE(177),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(180),
    [anon_sym_extends] = ACTIONS(314),
    [anon_sym_implements] = ACTIONS(316),
    [sym_identifier] = ACTIONS(318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [33] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(191),
    [sym__declaration] = STATE(192),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(191),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(322),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(338),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(342),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [34] = {
    [sym_type_alias_declaration] = STATE(220),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(220),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(220),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(220),
    [sym_return_statement] = STATE(220),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_accessibility_modifier] = STATE(218),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(220),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(220),
    [sym_spread_element] = STATE(219),
    [sym_switch_statement] = STATE(220),
    [sym_string] = STATE(215),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(220),
    [sym_throw_statement] = STATE(220),
    [aux_sym_program_repeat1] = STATE(220),
    [sym__property_name] = STATE(221),
    [sym_object] = STATE(222),
    [aux_sym_object_repeat1] = STATE(223),
    [sym_ambient_declaration] = STATE(220),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(220),
    [sym_decorator] = STATE(224),
    [sym_continue_statement] = STATE(220),
    [sym_formal_parameters] = STATE(57),
    [sym_computed_property_name] = STATE(221),
    [sym_function_signature] = STATE(220),
    [sym_abstract_class] = STATE(220),
    [sym_interface_declaration] = STATE(220),
    [sym_statement_block] = STATE(220),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(220),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(220),
    [sym_method_definition] = STATE(219),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(220),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(220),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(220),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(220),
    [sym_empty_statement] = STATE(220),
    [sym_pair] = STATE(219),
    [aux_sym_export_statement_repeat1] = STATE(224),
    [sym_assignment_pattern] = STATE(219),
    [sym_import_alias] = STATE(220),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(220),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(220),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(220),
    [sym_break_statement] = STATE(220),
    [sym_labeled_statement] = STATE(220),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(225),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(220),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(356),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(362),
    [anon_sym_void] = ACTIONS(364),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(366),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_get] = ACTIONS(370),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(366),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(370),
    [anon_sym_type] = ACTIONS(376),
    [anon_sym_import] = ACTIONS(378),
    [anon_sym_namespace] = ACTIONS(380),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(386),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(388),
    [anon_sym_number] = ACTIONS(356),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(390),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(356),
    [anon_sym_boolean] = ACTIONS(356),
    [anon_sym_async] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(366),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(398),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(356),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [35] = {
    [sym_parenthesized_expression] = STATE(226),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_new_expression] = STATE(244),
    [sym_augmented_assignment_expression] = STATE(244),
    [sym_unary_expression] = STATE(244),
    [sym_update_expression] = STATE(244),
    [sym_regex] = STATE(244),
    [sym_meta_property] = STATE(244),
    [sym_call_signature] = STATE(242),
    [sym_rest_parameter] = STATE(243),
    [sym__expression] = STATE(244),
    [sym_yield_expression] = STATE(244),
    [sym_as_expression] = STATE(244),
    [sym_non_null_expression] = STATE(244),
    [sym_internal_module] = STATE(244),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(244),
    [sym_await_expression] = STATE(244),
    [sym_member_expression] = STATE(245),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(243),
    [sym_sequence_expression] = STATE(247),
    [sym_string] = STATE(244),
    [sym_this] = STATE(248),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(249),
    [sym_object] = STATE(250),
    [sym_anonymous_class] = STATE(244),
    [sym_generator_function] = STATE(244),
    [sym_call_expression] = STATE(244),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(244),
    [sym_ternary_expression] = STATE(244),
    [sym_binary_expression] = STATE(244),
    [sym_template_string] = STATE(244),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(249),
    [sym_optional_parameter] = STATE(243),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(244),
    [sym_array] = STATE(252),
    [sym_type_assertion] = STATE(244),
    [sym_class] = STATE(244),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [sym_identifier] = ACTIONS(406),
    [sym_false] = ACTIONS(408),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_symbol] = ACTIONS(412),
    [anon_sym_number] = ACTIONS(412),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(412),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(420),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(408),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(412),
    [anon_sym_private] = ACTIONS(422),
    [anon_sym_boolean] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(422),
    [anon_sym_get] = ACTIONS(412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(428),
    [sym_true] = ACTIONS(408),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(422),
    [anon_sym_string] = ACTIONS(412),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(408),
    [anon_sym_set] = ACTIONS(412),
    [anon_sym_type] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(412),
    [anon_sym_export] = ACTIONS(412),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_TILDE] = ACTIONS(410),
  },
  [37] = {
    [sym_call_signature] = STATE(253),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(442),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(442),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(442),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(442),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(442),
    [anon_sym_type] = ACTIONS(442),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(442),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(442),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(442),
    [anon_sym_declare] = ACTIONS(442),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(442),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(442),
    [anon_sym_async] = ACTIONS(442),
    [anon_sym_public] = ACTIONS(442),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(442),
    [anon_sym_function] = ACTIONS(450),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [38] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [39] = {
    [sym_type_alias_declaration] = STATE(259),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(259),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(259),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(259),
    [sym_return_statement] = STATE(259),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(259),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(259),
    [sym_switch_statement] = STATE(259),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(259),
    [sym_throw_statement] = STATE(259),
    [aux_sym_program_repeat1] = STATE(259),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(259),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(259),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(259),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(259),
    [sym_abstract_class] = STATE(259),
    [sym_interface_declaration] = STATE(259),
    [sym_statement_block] = STATE(259),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(259),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(259),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(259),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(259),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(259),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(259),
    [sym_empty_statement] = STATE(259),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(259),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(259),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(259),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(259),
    [sym_break_statement] = STATE(259),
    [sym_labeled_statement] = STATE(259),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(259),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(454),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [40] = {
    [sym_parenthesized_expression] = STATE(260),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [aux_sym_string_repeat2] = STATE(261),
    [sym_escape_sequence] = ACTIONS(456),
    [aux_sym_string_token2] = ACTIONS(456),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(244),
  },
  [42] = {
    [sym_statement_block] = STATE(263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [43] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(279),
    [sym_constructor_type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_formal_parameters] = STATE(285),
    [sym_nested_type_identifier] = STATE(281),
    [sym_array_type] = STATE(284),
    [sym_function_type] = STATE(279),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(279),
    [sym_intersection_type] = STATE(279),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_type_parameter] = STATE(282),
    [sym_string] = STATE(265),
    [sym_identifier] = ACTIONS(460),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [44] = {
    [sym_regex_pattern] = ACTIONS(496),
    [sym_comment] = ACTIONS(246),
  },
  [45] = {
    [sym_call_signature] = STATE(289),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(498),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [anon_sym_STAR] = ACTIONS(502),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(506),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(512),
    [anon_sym_symbol] = ACTIONS(512),
    [anon_sym_number] = ACTIONS(512),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(512),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(518),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(512),
    [anon_sym_private] = ACTIONS(512),
    [anon_sym_boolean] = ACTIONS(512),
    [anon_sym_async] = ACTIONS(522),
    [anon_sym_public] = ACTIONS(512),
    [anon_sym_get] = ACTIONS(512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(512),
    [anon_sym_string] = ACTIONS(512),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(512),
    [anon_sym_type] = ACTIONS(512),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(512),
    [anon_sym_namespace] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [47] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [48] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(191),
    [sym__declaration] = STATE(317),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(191),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_as] = ACTIONS(541),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(342),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [49] = {
    [sym_type_alias_declaration] = STATE(328),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(328),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(328),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(328),
    [sym_return_statement] = STATE(328),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(328),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(328),
    [sym_switch_statement] = STATE(328),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(328),
    [sym_throw_statement] = STATE(328),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(328),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(328),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(328),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(328),
    [sym_abstract_class] = STATE(328),
    [sym_interface_declaration] = STATE(328),
    [sym_statement_block] = STATE(328),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(328),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(328),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(328),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(328),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(328),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(328),
    [sym_empty_statement] = STATE(328),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(328),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(328),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(328),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(328),
    [sym_break_statement] = STATE(328),
    [sym_labeled_statement] = STATE(328),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(328),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [50] = {
    [sym_parenthesized_expression] = STATE(332),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [anon_sym_EQ_GT] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(568),
    [anon_sym_debugger] = ACTIONS(566),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(566),
    [anon_sym_AT] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_void] = ACTIONS(566),
    [anon_sym_break] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_const] = ACTIONS(566),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [sym_super] = ACTIONS(566),
    [anon_sym_return] = ACTIONS(566),
    [anon_sym_private] = ACTIONS(566),
    [anon_sym_get] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_interface] = ACTIONS(566),
    [anon_sym_default] = ACTIONS(566),
    [anon_sym_enum] = ACTIONS(566),
    [anon_sym_delete] = ACTIONS(566),
    [anon_sym_continue] = ACTIONS(566),
    [anon_sym_DASH_DASH] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(566),
    [anon_sym_as] = ACTIONS(113),
    [anon_sym_this] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(566),
    [sym_true] = ACTIONS(566),
    [anon_sym_throw] = ACTIONS(566),
    [anon_sym_instanceof] = ACTIONS(113),
    [anon_sym_protected] = ACTIONS(566),
    [anon_sym_abstract] = ACTIONS(566),
    [anon_sym_DOT] = ACTIONS(113),
    [anon_sym_set] = ACTIONS(566),
    [anon_sym_type] = ACTIONS(566),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_import] = ACTIONS(566),
    [anon_sym_namespace] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(568),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_DQUOTE] = ACTIONS(568),
    [anon_sym_else] = ACTIONS(566),
    [anon_sym_BANG] = ACTIONS(566),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_LBRACK] = ACTIONS(568),
    [sym_false] = ACTIONS(566),
    [anon_sym_SEMI] = ACTIONS(568),
    [anon_sym_case] = ACTIONS(566),
    [anon_sym_module] = ACTIONS(566),
    [anon_sym_number] = ACTIONS(566),
    [anon_sym_class] = ACTIONS(566),
    [anon_sym_declare] = ACTIONS(566),
    [anon_sym_typeof] = ACTIONS(566),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(566),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(568),
    [sym_null] = ACTIONS(566),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_any] = ACTIONS(566),
    [anon_sym_boolean] = ACTIONS(566),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_public] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_var] = ACTIONS(566),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_SQUOTE] = ACTIONS(568),
    [anon_sym_try] = ACTIONS(566),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(566),
    [sym_number] = ACTIONS(568),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(566),
    [sym_undefined] = ACTIONS(566),
    [anon_sym_new] = ACTIONS(566),
    [ts_builtin_sym_end] = ACTIONS(568),
    [anon_sym_let] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_do] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(566),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [53] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [54] = {
    [sym_formal_parameters] = STATE(333),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_type_alias_declaration] = STATE(334),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(334),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(334),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(334),
    [sym_return_statement] = STATE(334),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(334),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(334),
    [sym_switch_statement] = STATE(334),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(334),
    [sym_throw_statement] = STATE(334),
    [aux_sym_program_repeat1] = STATE(334),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(334),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(334),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(334),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(334),
    [sym_abstract_class] = STATE(334),
    [sym_interface_declaration] = STATE(334),
    [sym_statement_block] = STATE(334),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(334),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(334),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(334),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(334),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(334),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(334),
    [sym_empty_statement] = STATE(334),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(334),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(334),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(334),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(334),
    [sym_break_statement] = STATE(334),
    [sym_labeled_statement] = STATE(334),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(334),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(454),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [56] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [57] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(570),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG] = ACTIONS(604),
  },
  [59] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(566),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(566),
    [anon_sym_AT] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_void] = ACTIONS(566),
    [anon_sym_break] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_const] = ACTIONS(566),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [sym_super] = ACTIONS(566),
    [anon_sym_return] = ACTIONS(566),
    [anon_sym_private] = ACTIONS(566),
    [anon_sym_get] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_interface] = ACTIONS(566),
    [anon_sym_default] = ACTIONS(566),
    [anon_sym_enum] = ACTIONS(566),
    [anon_sym_delete] = ACTIONS(566),
    [anon_sym_continue] = ACTIONS(566),
    [anon_sym_DASH_DASH] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(566),
    [anon_sym_as] = ACTIONS(113),
    [anon_sym_this] = ACTIONS(566),
    [anon_sym_yield] = ACTIONS(566),
    [sym_true] = ACTIONS(566),
    [anon_sym_throw] = ACTIONS(566),
    [anon_sym_instanceof] = ACTIONS(113),
    [anon_sym_protected] = ACTIONS(566),
    [anon_sym_abstract] = ACTIONS(566),
    [anon_sym_DOT] = ACTIONS(113),
    [anon_sym_set] = ACTIONS(566),
    [anon_sym_type] = ACTIONS(566),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_import] = ACTIONS(566),
    [anon_sym_namespace] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(568),
    [anon_sym_await] = ACTIONS(566),
    [anon_sym_DQUOTE] = ACTIONS(568),
    [anon_sym_else] = ACTIONS(566),
    [anon_sym_BANG] = ACTIONS(566),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_LBRACK] = ACTIONS(568),
    [sym_false] = ACTIONS(566),
    [anon_sym_SEMI] = ACTIONS(568),
    [anon_sym_case] = ACTIONS(566),
    [anon_sym_module] = ACTIONS(566),
    [anon_sym_number] = ACTIONS(566),
    [anon_sym_class] = ACTIONS(566),
    [anon_sym_declare] = ACTIONS(566),
    [anon_sym_typeof] = ACTIONS(566),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(566),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(183),
    [sym_null] = ACTIONS(566),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_any] = ACTIONS(566),
    [anon_sym_boolean] = ACTIONS(566),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_public] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_var] = ACTIONS(566),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_SQUOTE] = ACTIONS(568),
    [anon_sym_try] = ACTIONS(566),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(185),
    [sym_number] = ACTIONS(568),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(566),
    [sym_undefined] = ACTIONS(566),
    [anon_sym_new] = ACTIONS(566),
    [ts_builtin_sym_end] = ACTIONS(568),
    [anon_sym_let] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_do] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(566),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [60] = {
    [ts_builtin_sym_end] = ACTIONS(606),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__automatic_semicolon] = ACTIONS(574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(574),
  },
  [62] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(608),
    [anon_sym_class] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_new_expression] = STATE(353),
    [sym_augmented_assignment_expression] = STATE(353),
    [sym_unary_expression] = STATE(353),
    [sym_update_expression] = STATE(353),
    [sym_regex] = STATE(353),
    [sym_meta_property] = STATE(353),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(353),
    [sym_yield_expression] = STATE(353),
    [sym_as_expression] = STATE(353),
    [sym_non_null_expression] = STATE(353),
    [sym_internal_module] = STATE(353),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(353),
    [sym_await_expression] = STATE(353),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(353),
    [sym_this] = STATE(353),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(353),
    [sym_generator_function] = STATE(353),
    [sym_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(353),
    [sym_ternary_expression] = STATE(353),
    [sym_binary_expression] = STATE(353),
    [sym_template_string] = STATE(353),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(353),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(353),
    [sym_class] = STATE(353),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(612),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(614),
    [sym_true] = ACTIONS(612),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [64] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [65] = {
    [sym_new_expression] = STATE(357),
    [sym_augmented_assignment_expression] = STATE(357),
    [sym_unary_expression] = STATE(357),
    [sym_update_expression] = STATE(357),
    [sym_regex] = STATE(357),
    [sym_meta_property] = STATE(357),
    [sym_call_signature] = STATE(51),
    [sym_statement_block] = STATE(356),
    [sym__expression] = STATE(357),
    [sym_yield_expression] = STATE(357),
    [sym_as_expression] = STATE(357),
    [sym_non_null_expression] = STATE(357),
    [sym_internal_module] = STATE(357),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(357),
    [sym_await_expression] = STATE(357),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(357),
    [sym_this] = STATE(357),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(357),
    [sym_generator_function] = STATE(357),
    [sym_call_expression] = STATE(357),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(357),
    [sym_ternary_expression] = STATE(357),
    [sym_binary_expression] = STATE(357),
    [sym_template_string] = STATE(357),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(357),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(357),
    [sym_class] = STATE(357),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(616),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(620),
    [sym_true] = ACTIONS(616),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(616),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [66] = {
    [sym_new_expression] = STATE(358),
    [sym_augmented_assignment_expression] = STATE(358),
    [sym_unary_expression] = STATE(358),
    [sym_update_expression] = STATE(358),
    [sym_regex] = STATE(358),
    [sym_meta_property] = STATE(358),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(358),
    [sym_yield_expression] = STATE(358),
    [sym_as_expression] = STATE(358),
    [sym_non_null_expression] = STATE(358),
    [sym_internal_module] = STATE(358),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(358),
    [sym_await_expression] = STATE(358),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(358),
    [sym_this] = STATE(358),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(358),
    [sym_generator_function] = STATE(358),
    [sym_call_expression] = STATE(358),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(358),
    [sym_ternary_expression] = STATE(358),
    [sym_binary_expression] = STATE(358),
    [sym_template_string] = STATE(358),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(358),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(358),
    [sym_class] = STATE(358),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(622),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(624),
    [sym_true] = ACTIONS(622),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(622),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [67] = {
    [sym_new_expression] = STATE(359),
    [sym_augmented_assignment_expression] = STATE(359),
    [sym_unary_expression] = STATE(359),
    [sym_update_expression] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_meta_property] = STATE(359),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(359),
    [sym_yield_expression] = STATE(359),
    [sym_as_expression] = STATE(359),
    [sym_non_null_expression] = STATE(359),
    [sym_internal_module] = STATE(359),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(359),
    [sym_await_expression] = STATE(359),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(359),
    [sym_this] = STATE(359),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(359),
    [sym_generator_function] = STATE(359),
    [sym_call_expression] = STATE(359),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(359),
    [sym_ternary_expression] = STATE(359),
    [sym_binary_expression] = STATE(359),
    [sym_template_string] = STATE(359),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(359),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(359),
    [sym_class] = STATE(359),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(626),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(628),
    [sym_true] = ACTIONS(626),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [68] = {
    [sym_new_expression] = STATE(360),
    [sym_augmented_assignment_expression] = STATE(360),
    [sym_unary_expression] = STATE(360),
    [sym_update_expression] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_meta_property] = STATE(360),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(360),
    [sym_yield_expression] = STATE(360),
    [sym_as_expression] = STATE(360),
    [sym_non_null_expression] = STATE(360),
    [sym_internal_module] = STATE(360),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(360),
    [sym_await_expression] = STATE(360),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(360),
    [sym_this] = STATE(360),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(360),
    [sym_generator_function] = STATE(360),
    [sym_call_expression] = STATE(360),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(360),
    [sym_ternary_expression] = STATE(360),
    [sym_binary_expression] = STATE(360),
    [sym_template_string] = STATE(360),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(360),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(360),
    [sym_class] = STATE(360),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(630),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(632),
    [sym_true] = ACTIONS(630),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(630),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [69] = {
    [sym_type_alias_declaration] = STATE(361),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(361),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(361),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(361),
    [sym_return_statement] = STATE(361),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(361),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(361),
    [sym_switch_statement] = STATE(361),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(361),
    [sym_throw_statement] = STATE(361),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(361),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(361),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(361),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(361),
    [sym_abstract_class] = STATE(361),
    [sym_interface_declaration] = STATE(361),
    [sym_statement_block] = STATE(361),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(361),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(361),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(361),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(361),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(361),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(361),
    [sym_empty_statement] = STATE(361),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(361),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(361),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(361),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(361),
    [sym_break_statement] = STATE(361),
    [sym_labeled_statement] = STATE(361),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(361),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [70] = {
    [sym_identifier] = ACTIONS(634),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_BANG] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym__automatic_semicolon] = ACTIONS(636),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_GT_GT_GT] = ACTIONS(636),
    [anon_sym_AMP_AMP] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_BANG_EQ] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_QMARK] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(636),
    [anon_sym_PIPE_PIPE] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(638),
    [anon_sym_instanceof] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_RPAREN] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_GT_GT] = ACTIONS(638),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_in] = ACTIONS(638),
  },
  [72] = {
    [sym_new_expression] = STATE(375),
    [sym_augmented_assignment_expression] = STATE(375),
    [sym_unary_expression] = STATE(375),
    [sym_update_expression] = STATE(375),
    [sym_regex] = STATE(375),
    [sym_meta_property] = STATE(375),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(375),
    [sym_yield_expression] = STATE(375),
    [sym_as_expression] = STATE(375),
    [sym_non_null_expression] = STATE(375),
    [sym_internal_module] = STATE(375),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(375),
    [sym_await_expression] = STATE(375),
    [sym_member_expression] = STATE(376),
    [sym_sequence_expression] = STATE(377),
    [sym_string] = STATE(375),
    [sym_this] = STATE(375),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(375),
    [sym_generator_function] = STATE(375),
    [sym_call_expression] = STATE(375),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(375),
    [sym_ternary_expression] = STATE(375),
    [sym_binary_expression] = STATE(375),
    [sym_template_string] = STATE(375),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(375),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(375),
    [sym_class] = STATE(375),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(644),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(658),
    [sym_true] = ACTIONS(644),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [73] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_BQUOTE] = ACTIONS(668),
    [sym__automatic_semicolon] = ACTIONS(668),
    [anon_sym_PIPE] = ACTIONS(670),
    [anon_sym_COMMA] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(670),
    [anon_sym_GT_GT_GT] = ACTIONS(668),
    [anon_sym_AMP_AMP] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_BANG_EQ] = ACTIONS(670),
    [anon_sym_LT_EQ] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(668),
    [anon_sym_GT_EQ] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_QMARK] = ACTIONS(668),
    [anon_sym_RBRACE] = ACTIONS(668),
    [anon_sym_as] = ACTIONS(668),
    [anon_sym_PIPE_PIPE] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(670),
    [anon_sym_instanceof] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(670),
    [anon_sym_RPAREN] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(668),
    [anon_sym_STAR_STAR] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_GT_GT] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(668),
    [anon_sym_in] = ACTIONS(670),
  },
  [74] = {
    [aux_sym_template_string_repeat1] = STATE(382),
    [sym_template_substitution] = STATE(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [sym_escape_sequence] = ACTIONS(672),
    [anon_sym_BQUOTE] = ACTIONS(674),
    [sym__template_chars] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_identifier] = ACTIONS(676),
    [anon_sym_BQUOTE] = ACTIONS(678),
    [anon_sym_debugger] = ACTIONS(676),
    [anon_sym_symbol] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(676),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_break] = ACTIONS(676),
    [anon_sym_const] = ACTIONS(676),
    [sym_super] = ACTIONS(676),
    [anon_sym_return] = ACTIONS(676),
    [anon_sym_private] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(676),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_interface] = ACTIONS(676),
    [anon_sym_default] = ACTIONS(676),
    [anon_sym_enum] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_continue] = ACTIONS(676),
    [anon_sym_DASH_DASH] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_this] = ACTIONS(676),
    [anon_sym_yield] = ACTIONS(676),
    [sym_true] = ACTIONS(676),
    [anon_sym_throw] = ACTIONS(676),
    [anon_sym_protected] = ACTIONS(676),
    [anon_sym_abstract] = ACTIONS(676),
    [anon_sym_set] = ACTIONS(676),
    [anon_sym_type] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(676),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(678),
    [anon_sym_await] = ACTIONS(676),
    [anon_sym_DQUOTE] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(678),
    [anon_sym_for] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(678),
    [sym_false] = ACTIONS(676),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_case] = ACTIONS(676),
    [anon_sym_module] = ACTIONS(676),
    [anon_sym_number] = ACTIONS(676),
    [anon_sym_class] = ACTIONS(676),
    [anon_sym_declare] = ACTIONS(676),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(676),
    [anon_sym_LPAREN] = ACTIONS(678),
    [sym_null] = ACTIONS(676),
    [anon_sym_any] = ACTIONS(676),
    [anon_sym_boolean] = ACTIONS(676),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_public] = ACTIONS(676),
    [anon_sym_var] = ACTIONS(676),
    [anon_sym_while] = ACTIONS(676),
    [anon_sym_SQUOTE] = ACTIONS(678),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [sym_number] = ACTIONS(678),
    [anon_sym_SLASH] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(676),
    [sym_undefined] = ACTIONS(676),
    [anon_sym_new] = ACTIONS(676),
    [ts_builtin_sym_end] = ACTIONS(678),
    [anon_sym_let] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(676),
    [anon_sym_export] = ACTIONS(676),
    [anon_sym_do] = ACTIONS(676),
    [anon_sym_TILDE] = ACTIONS(678),
    [anon_sym_with] = ACTIONS(676),
  },
  [76] = {
    [sym_new_expression] = STATE(384),
    [sym_augmented_assignment_expression] = STATE(384),
    [sym_unary_expression] = STATE(384),
    [sym_update_expression] = STATE(384),
    [sym_regex] = STATE(384),
    [sym_meta_property] = STATE(384),
    [sym_call_signature] = STATE(51),
    [sym_statement_block] = STATE(383),
    [sym__expression] = STATE(384),
    [sym_yield_expression] = STATE(384),
    [sym_as_expression] = STATE(384),
    [sym_non_null_expression] = STATE(384),
    [sym_internal_module] = STATE(384),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(384),
    [sym_await_expression] = STATE(384),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(384),
    [sym_this] = STATE(384),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(384),
    [sym_generator_function] = STATE(384),
    [sym_call_expression] = STATE(384),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(384),
    [sym_ternary_expression] = STATE(384),
    [sym_binary_expression] = STATE(384),
    [sym_template_string] = STATE(384),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(384),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(384),
    [sym_class] = STATE(384),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(680),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(680),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(682),
    [sym_true] = ACTIONS(680),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(680),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [77] = {
    [sym_new_expression] = STATE(385),
    [sym_augmented_assignment_expression] = STATE(385),
    [sym_unary_expression] = STATE(385),
    [sym_update_expression] = STATE(385),
    [sym_regex] = STATE(385),
    [sym_meta_property] = STATE(385),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(385),
    [sym_yield_expression] = STATE(385),
    [sym_as_expression] = STATE(385),
    [sym_non_null_expression] = STATE(385),
    [sym_internal_module] = STATE(385),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(385),
    [sym_await_expression] = STATE(385),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(385),
    [sym_this] = STATE(385),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(385),
    [sym_generator_function] = STATE(385),
    [sym_call_expression] = STATE(385),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(385),
    [sym_ternary_expression] = STATE(385),
    [sym_binary_expression] = STATE(385),
    [sym_template_string] = STATE(385),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(385),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(385),
    [sym_class] = STATE(385),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(684),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(686),
    [sym_true] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [78] = {
    [sym_identifier] = ACTIONS(688),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(690),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym__automatic_semicolon] = ACTIONS(690),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(692),
    [anon_sym_GT_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(692),
    [anon_sym_BANG_EQ] = ACTIONS(692),
    [anon_sym_LT_EQ] = ACTIONS(690),
    [anon_sym_LPAREN] = ACTIONS(690),
    [anon_sym_GT_EQ] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(692),
    [anon_sym_PERCENT] = ACTIONS(690),
    [anon_sym_QMARK] = ACTIONS(690),
    [anon_sym_RBRACE] = ACTIONS(690),
    [anon_sym_as] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_EQ_EQ] = ACTIONS(692),
    [anon_sym_instanceof] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(690),
    [anon_sym_CARET] = ACTIONS(690),
    [anon_sym_STAR_STAR] = ACTIONS(690),
    [anon_sym_PLUS] = ACTIONS(692),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(690),
    [anon_sym_in] = ACTIONS(692),
  },
  [80] = {
    [anon_sym_LBRACK] = ACTIONS(694),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_symbol] = ACTIONS(696),
    [anon_sym_number] = ACTIONS(696),
    [anon_sym_class] = ACTIONS(696),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_declare] = ACTIONS(696),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_any] = ACTIONS(696),
    [anon_sym_private] = ACTIONS(696),
    [anon_sym_boolean] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(696),
    [anon_sym_async] = ACTIONS(696),
    [anon_sym_get] = ACTIONS(696),
    [anon_sym_public] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_this] = ACTIONS(696),
    [sym_number] = ACTIONS(694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(696),
    [anon_sym_string] = ACTIONS(696),
    [anon_sym_abstract] = ACTIONS(696),
    [anon_sym_DOT] = ACTIONS(696),
    [anon_sym_set] = ACTIONS(696),
    [anon_sym_type] = ACTIONS(696),
    [anon_sym_import] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(696),
    [anon_sym_namespace] = ACTIONS(696),
    [sym_readonly] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
  },
  [81] = {
    [sym_arguments] = STATE(389),
    [anon_sym_LBRACK] = ACTIONS(698),
    [sym_identifier] = ACTIONS(700),
    [anon_sym_module] = ACTIONS(700),
    [anon_sym_symbol] = ACTIONS(700),
    [anon_sym_number] = ACTIONS(700),
    [anon_sym_class] = ACTIONS(700),
    [anon_sym_AT] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(698),
    [anon_sym_LBRACE] = ACTIONS(698),
    [anon_sym_void] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_any] = ACTIONS(700),
    [anon_sym_private] = ACTIONS(700),
    [anon_sym_boolean] = ACTIONS(700),
    [anon_sym_async] = ACTIONS(700),
    [anon_sym_public] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(700),
    [anon_sym_this] = ACTIONS(700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(700),
    [anon_sym_string] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(700),
    [anon_sym_type] = ACTIONS(700),
    [anon_sym_import] = ACTIONS(700),
    [anon_sym_export] = ACTIONS(700),
    [sym_readonly] = ACTIONS(700),
    [anon_sym_namespace] = ACTIONS(700),
  },
  [82] = {
    [anon_sym_LBRACK] = ACTIONS(698),
    [sym_identifier] = ACTIONS(700),
    [anon_sym_module] = ACTIONS(700),
    [anon_sym_symbol] = ACTIONS(700),
    [anon_sym_number] = ACTIONS(700),
    [anon_sym_class] = ACTIONS(700),
    [anon_sym_AT] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(700),
    [anon_sym_STAR] = ACTIONS(698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(698),
    [anon_sym_LBRACE] = ACTIONS(698),
    [anon_sym_void] = ACTIONS(700),
    [anon_sym_any] = ACTIONS(700),
    [anon_sym_private] = ACTIONS(700),
    [anon_sym_boolean] = ACTIONS(700),
    [anon_sym_static] = ACTIONS(700),
    [anon_sym_async] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(700),
    [anon_sym_public] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(698),
    [anon_sym_this] = ACTIONS(700),
    [sym_number] = ACTIONS(698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(700),
    [anon_sym_string] = ACTIONS(700),
    [anon_sym_abstract] = ACTIONS(700),
    [anon_sym_set] = ACTIONS(700),
    [anon_sym_type] = ACTIONS(700),
    [anon_sym_import] = ACTIONS(700),
    [anon_sym_export] = ACTIONS(700),
    [anon_sym_namespace] = ACTIONS(700),
    [sym_readonly] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(698),
  },
  [83] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [84] = {
    [sym_pair] = STATE(219),
    [sym__property_name] = STATE(221),
    [sym_object] = STATE(397),
    [sym_decorator] = STATE(398),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(398),
    [sym_computed_property_name] = STATE(221),
    [aux_sym_object_repeat1] = STATE(223),
    [sym_array] = STATE(399),
    [sym_assignment_pattern] = STATE(219),
    [sym_spread_element] = STATE(219),
    [sym_string] = STATE(221),
    [sym_method_definition] = STATE(219),
    [sym_identifier] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_module] = ACTIONS(710),
    [anon_sym_symbol] = ACTIONS(710),
    [anon_sym_number] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(710),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(362),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(710),
    [anon_sym_any] = ACTIONS(710),
    [anon_sym_private] = ACTIONS(712),
    [anon_sym_boolean] = ACTIONS(710),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_async] = ACTIONS(714),
    [anon_sym_get] = ACTIONS(716),
    [anon_sym_RBRACE] = ACTIONS(718),
    [anon_sym_public] = ACTIONS(712),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [sym_number] = ACTIONS(720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(712),
    [anon_sym_string] = ACTIONS(710),
    [anon_sym_set] = ACTIONS(716),
    [anon_sym_type] = ACTIONS(710),
    [anon_sym_import] = ACTIONS(710),
    [anon_sym_export] = ACTIONS(710),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_namespace] = ACTIONS(710),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [85] = {
    [sym_call_signature] = STATE(253),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(442),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(442),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(442),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(442),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(442),
    [anon_sym_type] = ACTIONS(442),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(442),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(442),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(442),
    [anon_sym_declare] = ACTIONS(442),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(442),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(442),
    [anon_sym_async] = ACTIONS(442),
    [anon_sym_public] = ACTIONS(442),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(442),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [86] = {
    [sym_call_signature] = STATE(289),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [anon_sym_STAR] = ACTIONS(502),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [88] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [89] = {
    [aux_sym_export_statement_repeat1] = STATE(402),
    [sym_decorator] = STATE(402),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [91] = {
    [sym_identifier] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_debugger] = ACTIONS(733),
    [anon_sym_symbol] = ACTIONS(733),
    [anon_sym_AT] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_const] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_private] = ACTIONS(733),
    [anon_sym_get] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_interface] = ACTIONS(733),
    [anon_sym_default] = ACTIONS(733),
    [anon_sym_enum] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_continue] = ACTIONS(733),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_this] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [anon_sym_throw] = ACTIONS(733),
    [anon_sym_protected] = ACTIONS(733),
    [anon_sym_abstract] = ACTIONS(733),
    [anon_sym_set] = ACTIONS(733),
    [anon_sym_type] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(733),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_await] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(735),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_false] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_number] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_declare] = ACTIONS(733),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_switch] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [sym_null] = ACTIONS(733),
    [anon_sym_any] = ACTIONS(733),
    [anon_sym_boolean] = ACTIONS(733),
    [anon_sym_async] = ACTIONS(733),
    [anon_sym_public] = ACTIONS(733),
    [anon_sym_var] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_SQUOTE] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(735),
    [sym_number] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(733),
    [anon_sym_function] = ACTIONS(733),
    [sym_undefined] = ACTIONS(733),
    [anon_sym_new] = ACTIONS(733),
    [ts_builtin_sym_end] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_with] = ACTIONS(733),
  },
  [92] = {
    [sym__automatic_semicolon] = ACTIONS(737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(737),
  },
  [93] = {
    [sym__initializer] = STATE(405),
    [sym_type_annotation] = STATE(406),
    [sym__automatic_semicolon] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_COMMA] = ACTIONS(739),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_new_expression] = STATE(408),
    [sym_augmented_assignment_expression] = STATE(408),
    [sym_unary_expression] = STATE(408),
    [sym_update_expression] = STATE(408),
    [sym_regex] = STATE(408),
    [sym_meta_property] = STATE(408),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(408),
    [sym_yield_expression] = STATE(408),
    [sym_as_expression] = STATE(408),
    [sym_non_null_expression] = STATE(408),
    [sym_internal_module] = STATE(408),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(408),
    [sym_await_expression] = STATE(408),
    [sym_member_expression] = STATE(161),
    [sym_spread_element] = STATE(409),
    [sym_string] = STATE(408),
    [sym_this] = STATE(408),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [aux_sym_array_repeat1] = STATE(410),
    [sym_anonymous_class] = STATE(408),
    [sym_generator_function] = STATE(408),
    [sym_call_expression] = STATE(408),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(408),
    [sym_ternary_expression] = STATE(408),
    [sym_binary_expression] = STATE(408),
    [sym_template_string] = STATE(408),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(408),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(408),
    [sym_class] = STATE(408),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(747),
    [sym_null] = ACTIONS(745),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(749),
    [sym_true] = ACTIONS(745),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [95] = {
    [sym_identifier] = ACTIONS(751),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_pair] = STATE(418),
    [sym__property_name] = STATE(221),
    [sym_object] = STATE(397),
    [sym_decorator] = STATE(419),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(419),
    [sym_computed_property_name] = STATE(221),
    [aux_sym_object_repeat1] = STATE(420),
    [sym_array] = STATE(399),
    [sym_assignment_pattern] = STATE(418),
    [sym_spread_element] = STATE(418),
    [sym_string] = STATE(221),
    [sym_method_definition] = STATE(418),
    [sym_identifier] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_module] = ACTIONS(755),
    [anon_sym_symbol] = ACTIONS(755),
    [anon_sym_number] = ACTIONS(755),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(755),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(362),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(755),
    [anon_sym_any] = ACTIONS(755),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(755),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(761),
    [anon_sym_RBRACE] = ACTIONS(763),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [sym_number] = ACTIONS(720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(755),
    [anon_sym_set] = ACTIONS(761),
    [anon_sym_type] = ACTIONS(755),
    [anon_sym_import] = ACTIONS(755),
    [anon_sym_export] = ACTIONS(755),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_namespace] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [97] = {
    [aux_sym_variable_declaration_repeat1] = STATE(423),
    [sym__automatic_semicolon] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_COMMA] = ACTIONS(767),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym__initializer] = STATE(425),
    [sym_type_annotation] = STATE(426),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym__initializer] = STATE(427),
    [sym_type_annotation] = STATE(428),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_new_expression] = STATE(429),
    [sym_augmented_assignment_expression] = STATE(429),
    [sym_unary_expression] = STATE(429),
    [sym_update_expression] = STATE(429),
    [sym_regex] = STATE(429),
    [sym_meta_property] = STATE(429),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(429),
    [sym_yield_expression] = STATE(429),
    [sym_as_expression] = STATE(429),
    [sym_non_null_expression] = STATE(429),
    [sym_internal_module] = STATE(429),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(429),
    [sym_await_expression] = STATE(429),
    [sym_member_expression] = STATE(161),
    [sym_sequence_expression] = STATE(430),
    [sym_string] = STATE(429),
    [sym_this] = STATE(429),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(429),
    [sym_generator_function] = STATE(429),
    [sym_call_expression] = STATE(429),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(429),
    [sym_ternary_expression] = STATE(429),
    [sym_binary_expression] = STATE(429),
    [sym_template_string] = STATE(429),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(429),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(429),
    [sym_class] = STATE(429),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(771),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(773),
    [sym_true] = ACTIONS(771),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(771),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [101] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(279),
    [sym_constructor_type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(279),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(279),
    [sym_intersection_type] = STATE(279),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [102] = {
    [sym_new_expression] = STATE(447),
    [sym_augmented_assignment_expression] = STATE(447),
    [sym_unary_expression] = STATE(447),
    [sym_update_expression] = STATE(447),
    [sym_regex] = STATE(447),
    [sym_meta_property] = STATE(447),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(447),
    [sym_yield_expression] = STATE(447),
    [sym_as_expression] = STATE(447),
    [sym_non_null_expression] = STATE(447),
    [sym_internal_module] = STATE(447),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(447),
    [sym_await_expression] = STATE(447),
    [sym_member_expression] = STATE(448),
    [sym_spread_element] = STATE(449),
    [sym_string] = STATE(447),
    [sym_this] = STATE(447),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [aux_sym_array_repeat1] = STATE(451),
    [sym_anonymous_class] = STATE(447),
    [sym_generator_function] = STATE(447),
    [sym_call_expression] = STATE(447),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(447),
    [sym_ternary_expression] = STATE(447),
    [sym_binary_expression] = STATE(447),
    [sym_template_string] = STATE(447),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(447),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(447),
    [sym_class] = STATE(447),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(781),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(789),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(781),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(801),
    [sym_true] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [103] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(811),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [sym__automatic_semicolon] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_as] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(811),
    [anon_sym_in] = ACTIONS(813),
  },
  [104] = {
    [sym_template_string] = STATE(454),
    [sym_arguments] = STATE(454),
    [anon_sym_LPAREN] = ACTIONS(183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(7),
  },
  [105] = {
    [sym_identifier] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_debugger] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_AT] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_break] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [sym_super] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_interface] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_delete] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [anon_sym_throw] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_import] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_await] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_else] = ACTIONS(815),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_LBRACK] = ACTIONS(817),
    [sym_false] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(817),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_class] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_typeof] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(817),
    [sym_null] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_var] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(817),
    [anon_sym_try] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(817),
    [sym_number] = ACTIONS(817),
    [anon_sym_SLASH] = ACTIONS(815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(815),
    [sym_undefined] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(815),
    [ts_builtin_sym_end] = ACTIONS(817),
    [anon_sym_let] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_with] = ACTIONS(815),
  },
  [106] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG] = ACTIONS(604),
  },
  [107] = {
    [sym__automatic_semicolon] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(819),
  },
  [108] = {
    [sym_type_parameters] = STATE(457),
    [sym_object_type] = STATE(458),
    [sym_extends_clause] = STATE(459),
    [anon_sym_extends] = ACTIONS(821),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(486),
  },
  [109] = {
    [sym_enum_body] = STATE(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(823),
  },
  [110] = {
    [sym_identifier] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(827),
    [anon_sym_debugger] = ACTIONS(825),
    [anon_sym_symbol] = ACTIONS(825),
    [anon_sym_AT] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_void] = ACTIONS(825),
    [anon_sym_break] = ACTIONS(825),
    [anon_sym_const] = ACTIONS(825),
    [sym_super] = ACTIONS(825),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_private] = ACTIONS(825),
    [anon_sym_get] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(827),
    [anon_sym_interface] = ACTIONS(825),
    [anon_sym_default] = ACTIONS(825),
    [anon_sym_enum] = ACTIONS(825),
    [anon_sym_delete] = ACTIONS(825),
    [anon_sym_continue] = ACTIONS(825),
    [anon_sym_DASH_DASH] = ACTIONS(827),
    [anon_sym_if] = ACTIONS(825),
    [anon_sym_this] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(825),
    [sym_true] = ACTIONS(825),
    [anon_sym_throw] = ACTIONS(825),
    [anon_sym_protected] = ACTIONS(825),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_set] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(825),
    [anon_sym_import] = ACTIONS(825),
    [anon_sym_namespace] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(827),
    [anon_sym_await] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_else] = ACTIONS(825),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_for] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(827),
    [sym_false] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_case] = ACTIONS(825),
    [anon_sym_module] = ACTIONS(825),
    [anon_sym_number] = ACTIONS(825),
    [anon_sym_class] = ACTIONS(825),
    [anon_sym_declare] = ACTIONS(825),
    [anon_sym_typeof] = ACTIONS(825),
    [anon_sym_LBRACE] = ACTIONS(827),
    [anon_sym_switch] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(827),
    [sym_null] = ACTIONS(825),
    [anon_sym_any] = ACTIONS(825),
    [anon_sym_boolean] = ACTIONS(825),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_public] = ACTIONS(825),
    [anon_sym_var] = ACTIONS(825),
    [anon_sym_while] = ACTIONS(825),
    [anon_sym_SQUOTE] = ACTIONS(827),
    [anon_sym_try] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [sym_number] = ACTIONS(827),
    [anon_sym_SLASH] = ACTIONS(825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(825),
    [sym_undefined] = ACTIONS(825),
    [anon_sym_new] = ACTIONS(825),
    [ts_builtin_sym_end] = ACTIONS(827),
    [anon_sym_let] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_export] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(827),
    [anon_sym_with] = ACTIONS(825),
  },
  [111] = {
    [sym__automatic_semicolon] = ACTIONS(829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(829),
  },
  [112] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [sym__automatic_semicolon] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [113] = {
    [sym_new_expression] = STATE(468),
    [sym_augmented_assignment_expression] = STATE(468),
    [sym_unary_expression] = STATE(468),
    [sym_update_expression] = STATE(468),
    [sym_regex] = STATE(468),
    [sym_meta_property] = STATE(468),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(468),
    [sym_yield_expression] = STATE(468),
    [sym_as_expression] = STATE(468),
    [sym_non_null_expression] = STATE(468),
    [sym_internal_module] = STATE(468),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(468),
    [sym_await_expression] = STATE(468),
    [sym_member_expression] = STATE(245),
    [sym_sequence_expression] = STATE(469),
    [sym_string] = STATE(468),
    [sym_this] = STATE(468),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(468),
    [sym_generator_function] = STATE(468),
    [sym_call_expression] = STATE(468),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(468),
    [sym_ternary_expression] = STATE(468),
    [sym_binary_expression] = STATE(468),
    [sym_template_string] = STATE(468),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(468),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(468),
    [sym_class] = STATE(468),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(837),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(845),
    [sym_true] = ACTIONS(837),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(837),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [114] = {
    [sym_type_alias_declaration] = STATE(479),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(479),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(479),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(479),
    [sym_return_statement] = STATE(479),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(479),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(479),
    [sym_switch_statement] = STATE(479),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(479),
    [sym_throw_statement] = STATE(479),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(479),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(479),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(479),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(479),
    [sym_abstract_class] = STATE(479),
    [sym_interface_declaration] = STATE(479),
    [sym_statement_block] = STATE(479),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(479),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(479),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(479),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(479),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(479),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(479),
    [sym_empty_statement] = STATE(479),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(479),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(479),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(479),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(479),
    [sym_break_statement] = STATE(479),
    [sym_labeled_statement] = STATE(479),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(479),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [115] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [116] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(865),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG] = ACTIONS(604),
  },
  [117] = {
    [sym__automatic_semicolon] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(865),
  },
  [118] = {
    [sym_identifier] = ACTIONS(867),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_type_parameters] = STATE(484),
    [anon_sym_EQ] = ACTIONS(869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [120] = {
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_COMMA] = ACTIONS(873),
    [anon_sym_from] = ACTIONS(875),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_import_require_clause] = STATE(488),
    [sym_import_clause] = STATE(489),
    [sym_named_imports] = STATE(126),
    [sym_string] = STATE(488),
    [sym_namespace_import] = STATE(126),
    [anon_sym_LBRACE] = ACTIONS(234),
    [sym_identifier] = ACTIONS(877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_STAR] = ACTIONS(879),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [122] = {
    [anon_sym_as] = ACTIONS(881),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym__import_export_specifier] = STATE(495),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_RBRACE] = ACTIONS(885),
    [anon_sym_typeof] = ACTIONS(887),
    [anon_sym_COMMA] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym__automatic_semicolon] = ACTIONS(891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(891),
  },
  [125] = {
    [sym__from_clause] = STATE(488),
    [anon_sym_from] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [anon_sym_from] = ACTIONS(875),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_statement_block] = STATE(500),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(895),
    [sym_identifier] = ACTIONS(897),
    [sym__automatic_semicolon] = ACTIONS(895),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_debugger] = ACTIONS(897),
    [ts_builtin_sym_end] = ACTIONS(895),
    [anon_sym_symbol] = ACTIONS(897),
    [anon_sym_AT] = ACTIONS(895),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(897),
    [anon_sym_STAR] = ACTIONS(897),
    [anon_sym_GT_GT_GT] = ACTIONS(895),
    [anon_sym_void] = ACTIONS(897),
    [anon_sym_break] = ACTIONS(897),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_const] = ACTIONS(897),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_super] = ACTIONS(897),
    [anon_sym_return] = ACTIONS(897),
    [anon_sym_private] = ACTIONS(897),
    [anon_sym_get] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_PERCENT] = ACTIONS(895),
    [anon_sym_interface] = ACTIONS(897),
    [anon_sym_default] = ACTIONS(897),
    [anon_sym_as] = ACTIONS(897),
    [anon_sym_delete] = ACTIONS(897),
    [anon_sym_continue] = ACTIONS(897),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_instanceof] = ACTIONS(897),
    [anon_sym_this] = ACTIONS(897),
    [anon_sym_yield] = ACTIONS(897),
    [sym_true] = ACTIONS(897),
    [anon_sym_throw] = ACTIONS(897),
    [anon_sym_enum] = ACTIONS(897),
    [anon_sym_protected] = ACTIONS(897),
    [anon_sym_abstract] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_set] = ACTIONS(897),
    [anon_sym_type] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_import] = ACTIONS(897),
    [anon_sym_PIPE_RBRACE] = ACTIONS(895),
    [anon_sym_namespace] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_await] = ACTIONS(897),
    [anon_sym_DQUOTE] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(897),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_for] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(895),
    [sym_false] = ACTIONS(897),
    [anon_sym_SEMI] = ACTIONS(895),
    [anon_sym_case] = ACTIONS(897),
    [anon_sym_module] = ACTIONS(897),
    [anon_sym_number] = ACTIONS(897),
    [anon_sym_class] = ACTIONS(897),
    [anon_sym_declare] = ACTIONS(897),
    [anon_sym_typeof] = ACTIONS(897),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_switch] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(895),
    [sym_null] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_any] = ACTIONS(897),
    [anon_sym_boolean] = ACTIONS(897),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(897),
    [anon_sym_var] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(895),
    [anon_sym_try] = ACTIONS(897),
    [anon_sym_EQ_EQ] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [sym_number] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(897),
    [anon_sym_function] = ACTIONS(897),
    [sym_undefined] = ACTIONS(897),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_let] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_export] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_with] = ACTIONS(897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(895),
    [anon_sym_in] = ACTIONS(897),
  },
  [128] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(903),
    [sym_identifier] = ACTIONS(905),
    [sym__automatic_semicolon] = ACTIONS(903),
    [anon_sym_BQUOTE] = ACTIONS(903),
    [anon_sym_debugger] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym_symbol] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_GT_GT_GT] = ACTIONS(903),
    [anon_sym_void] = ACTIONS(905),
    [anon_sym_break] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [sym_super] = ACTIONS(905),
    [anon_sym_return] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_get] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_PERCENT] = ACTIONS(903),
    [anon_sym_interface] = ACTIONS(905),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_as] = ACTIONS(905),
    [anon_sym_delete] = ACTIONS(905),
    [anon_sym_continue] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_instanceof] = ACTIONS(905),
    [anon_sym_this] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(905),
    [sym_true] = ACTIONS(905),
    [anon_sym_throw] = ACTIONS(905),
    [anon_sym_enum] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_abstract] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_set] = ACTIONS(905),
    [anon_sym_type] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(905),
    [anon_sym_PIPE_RBRACE] = ACTIONS(903),
    [anon_sym_namespace] = ACTIONS(905),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(903),
    [sym_false] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_module] = ACTIONS(905),
    [anon_sym_number] = ACTIONS(905),
    [anon_sym_class] = ACTIONS(905),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeof] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_AMP_AMP] = ACTIONS(903),
    [anon_sym_switch] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym_null] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(905),
    [anon_sym_boolean] = ACTIONS(905),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_var] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(905),
    [sym_number] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_new] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_let] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_with] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_in] = ACTIONS(905),
  },
  [129] = {
    [sym_statement_block] = STATE(500),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(895),
    [sym_identifier] = ACTIONS(897),
    [sym__automatic_semicolon] = ACTIONS(895),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_debugger] = ACTIONS(897),
    [ts_builtin_sym_end] = ACTIONS(895),
    [anon_sym_symbol] = ACTIONS(897),
    [anon_sym_AT] = ACTIONS(895),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(897),
    [anon_sym_STAR] = ACTIONS(897),
    [anon_sym_GT_GT_GT] = ACTIONS(895),
    [anon_sym_void] = ACTIONS(897),
    [anon_sym_break] = ACTIONS(897),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_const] = ACTIONS(897),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_super] = ACTIONS(897),
    [anon_sym_return] = ACTIONS(897),
    [anon_sym_private] = ACTIONS(897),
    [anon_sym_get] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_PERCENT] = ACTIONS(895),
    [anon_sym_interface] = ACTIONS(897),
    [anon_sym_default] = ACTIONS(897),
    [anon_sym_as] = ACTIONS(897),
    [anon_sym_delete] = ACTIONS(897),
    [anon_sym_continue] = ACTIONS(897),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_instanceof] = ACTIONS(897),
    [anon_sym_this] = ACTIONS(897),
    [anon_sym_yield] = ACTIONS(897),
    [sym_true] = ACTIONS(897),
    [anon_sym_throw] = ACTIONS(897),
    [anon_sym_enum] = ACTIONS(897),
    [anon_sym_protected] = ACTIONS(897),
    [anon_sym_abstract] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(897),
    [anon_sym_set] = ACTIONS(897),
    [anon_sym_type] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_import] = ACTIONS(897),
    [anon_sym_PIPE_RBRACE] = ACTIONS(895),
    [anon_sym_namespace] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_await] = ACTIONS(897),
    [anon_sym_DQUOTE] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(897),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_for] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(895),
    [sym_false] = ACTIONS(897),
    [anon_sym_SEMI] = ACTIONS(895),
    [anon_sym_case] = ACTIONS(897),
    [anon_sym_module] = ACTIONS(897),
    [anon_sym_number] = ACTIONS(897),
    [anon_sym_class] = ACTIONS(897),
    [anon_sym_declare] = ACTIONS(897),
    [anon_sym_typeof] = ACTIONS(897),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_switch] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(895),
    [sym_null] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_any] = ACTIONS(897),
    [anon_sym_boolean] = ACTIONS(897),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(897),
    [anon_sym_var] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(895),
    [anon_sym_try] = ACTIONS(897),
    [anon_sym_EQ_EQ] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [sym_number] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(897),
    [anon_sym_function] = ACTIONS(897),
    [sym_undefined] = ACTIONS(897),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_let] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_export] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_with] = ACTIONS(897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(895),
    [anon_sym_in] = ACTIONS(897),
  },
  [130] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(907),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [131] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(909),
    [sym__automatic_semicolon] = ACTIONS(909),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(909),
    [anon_sym_debugger] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(911),
    [anon_sym_symbol] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_GT_GT_GT] = ACTIONS(909),
    [anon_sym_void] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(911),
    [anon_sym_const] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [sym_super] = ACTIONS(911),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_private] = ACTIONS(911),
    [anon_sym_get] = ACTIONS(911),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_interface] = ACTIONS(911),
    [anon_sym_default] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_delete] = ACTIONS(911),
    [anon_sym_continue] = ACTIONS(911),
    [anon_sym_DASH_DASH] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(911),
    [anon_sym_instanceof] = ACTIONS(911),
    [anon_sym_this] = ACTIONS(911),
    [anon_sym_yield] = ACTIONS(911),
    [sym_true] = ACTIONS(911),
    [anon_sym_throw] = ACTIONS(911),
    [anon_sym_enum] = ACTIONS(911),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_protected] = ACTIONS(911),
    [anon_sym_abstract] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_set] = ACTIONS(911),
    [anon_sym_type] = ACTIONS(911),
    [anon_sym_STAR_STAR] = ACTIONS(909),
    [anon_sym_import] = ACTIONS(911),
    [anon_sym_PIPE_RBRACE] = ACTIONS(909),
    [anon_sym_namespace] = ACTIONS(911),
    [anon_sym_PLUS_PLUS] = ACTIONS(909),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(909),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(909),
    [sym_false] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_case] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(911),
    [anon_sym_number] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(911),
    [anon_sym_declare] = ACTIONS(911),
    [anon_sym_typeof] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_switch] = ACTIONS(911),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(909),
    [sym_null] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_any] = ACTIONS(911),
    [anon_sym_boolean] = ACTIONS(911),
    [anon_sym_async] = ACTIONS(911),
    [anon_sym_public] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_var] = ACTIONS(911),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_try] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [sym_number] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(909),
    [anon_sym_string] = ACTIONS(911),
    [anon_sym_function] = ACTIONS(911),
    [sym_undefined] = ACTIONS(911),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_in] = ACTIONS(911),
  },
  [132] = {
    [aux_sym_string_repeat1] = STATE(502),
    [sym_escape_sequence] = ACTIONS(913),
    [aux_sym_string_token1] = ACTIONS(913),
    [anon_sym_DQUOTE] = ACTIONS(915),
    [sym_comment] = ACTIONS(246),
  },
  [133] = {
    [anon_sym_LPAREN] = ACTIONS(917),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(507),
    [sym_variable_declaration] = STATE(507),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(507),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(508),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_lexical_declaration] = STATE(507),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(509),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(919),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(923),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(921),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [135] = {
    [aux_sym_string_repeat1] = STATE(511),
    [sym_escape_sequence] = ACTIONS(925),
    [aux_sym_string_token1] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [sym_comment] = ACTIONS(246),
  },
  [136] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_AMP_EQ] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(929),
    [anon_sym_STAR_EQ] = ACTIONS(929),
    [anon_sym_PIPE_EQ] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
    [anon_sym_EQ_GT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(937),
  },
  [137] = {
    [aux_sym_template_string_repeat1] = STATE(519),
    [sym_template_substitution] = STATE(519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [sym_escape_sequence] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [sym__template_chars] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [139] = {
    [sym_class_heritage] = STATE(526),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(527),
    [anon_sym_extends] = ACTIONS(314),
    [anon_sym_implements] = ACTIONS(316),
    [sym_identifier] = ACTIONS(949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [140] = {
    [sym_new_expression] = STATE(528),
    [sym_augmented_assignment_expression] = STATE(528),
    [sym_unary_expression] = STATE(528),
    [sym_update_expression] = STATE(528),
    [sym_regex] = STATE(528),
    [sym_meta_property] = STATE(528),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(528),
    [sym_yield_expression] = STATE(528),
    [sym_as_expression] = STATE(528),
    [sym_non_null_expression] = STATE(528),
    [sym_internal_module] = STATE(528),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(528),
    [sym_await_expression] = STATE(528),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(528),
    [sym_this] = STATE(528),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(528),
    [sym_generator_function] = STATE(528),
    [sym_call_expression] = STATE(528),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(528),
    [sym_ternary_expression] = STATE(528),
    [sym_binary_expression] = STATE(528),
    [sym_template_string] = STATE(528),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(528),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(528),
    [sym_class] = STATE(528),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(953),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(955),
    [sym_true] = ACTIONS(953),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [141] = {
    [sym_new_expression] = STATE(529),
    [sym_augmented_assignment_expression] = STATE(529),
    [sym_unary_expression] = STATE(529),
    [sym_update_expression] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_meta_property] = STATE(529),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(529),
    [sym_yield_expression] = STATE(529),
    [sym_as_expression] = STATE(529),
    [sym_non_null_expression] = STATE(529),
    [sym_internal_module] = STATE(529),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(529),
    [sym_await_expression] = STATE(529),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(529),
    [sym_this] = STATE(529),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(529),
    [sym_generator_function] = STATE(529),
    [sym_call_expression] = STATE(529),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(529),
    [sym_ternary_expression] = STATE(529),
    [sym_binary_expression] = STATE(529),
    [sym_template_string] = STATE(529),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(529),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(529),
    [sym_class] = STATE(529),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(957),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(959),
    [sym_true] = ACTIONS(957),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(957),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [142] = {
    [sym_new_expression] = STATE(530),
    [sym_augmented_assignment_expression] = STATE(530),
    [sym_unary_expression] = STATE(530),
    [sym_update_expression] = STATE(530),
    [sym_regex] = STATE(530),
    [sym_meta_property] = STATE(530),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(530),
    [sym_yield_expression] = STATE(530),
    [sym_as_expression] = STATE(530),
    [sym_non_null_expression] = STATE(530),
    [sym_internal_module] = STATE(530),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(530),
    [sym_await_expression] = STATE(530),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(530),
    [sym_this] = STATE(530),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(530),
    [sym_generator_function] = STATE(530),
    [sym_call_expression] = STATE(530),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(530),
    [sym_ternary_expression] = STATE(530),
    [sym_binary_expression] = STATE(530),
    [sym_template_string] = STATE(530),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(530),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(530),
    [sym_class] = STATE(530),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(961),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(963),
    [sym_true] = ACTIONS(961),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(961),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [143] = {
    [sym_new_expression] = STATE(531),
    [sym_augmented_assignment_expression] = STATE(531),
    [sym_unary_expression] = STATE(531),
    [sym_update_expression] = STATE(531),
    [sym_regex] = STATE(531),
    [sym_meta_property] = STATE(531),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(531),
    [sym_yield_expression] = STATE(531),
    [sym_as_expression] = STATE(531),
    [sym_non_null_expression] = STATE(531),
    [sym_internal_module] = STATE(531),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(531),
    [sym_await_expression] = STATE(531),
    [sym_member_expression] = STATE(161),
    [sym_spread_element] = STATE(532),
    [sym_string] = STATE(531),
    [sym_this] = STATE(531),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(531),
    [sym_generator_function] = STATE(531),
    [sym_call_expression] = STATE(531),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(531),
    [sym_ternary_expression] = STATE(531),
    [sym_binary_expression] = STATE(531),
    [sym_template_string] = STATE(531),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(531),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(531),
    [sym_class] = STATE(531),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(967),
    [sym_null] = ACTIONS(965),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(969),
    [sym_true] = ACTIONS(965),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(965),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [144] = {
    [sym_new_expression] = STATE(528),
    [sym_augmented_assignment_expression] = STATE(528),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(528),
    [sym_update_expression] = STATE(528),
    [sym_regex] = STATE(528),
    [sym_meta_property] = STATE(528),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(528),
    [sym_yield_expression] = STATE(528),
    [sym_as_expression] = STATE(528),
    [sym_non_null_expression] = STATE(528),
    [sym_internal_module] = STATE(528),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(528),
    [sym_await_expression] = STATE(528),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(528),
    [sym_this] = STATE(528),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(528),
    [sym_generator_function] = STATE(528),
    [sym_call_expression] = STATE(528),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(528),
    [sym_ternary_expression] = STATE(528),
    [sym_binary_expression] = STATE(528),
    [sym_template_string] = STATE(528),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(528),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(528),
    [sym_class] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(953),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(953),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(955),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [145] = {
    [sym_new_expression] = STATE(533),
    [sym_augmented_assignment_expression] = STATE(533),
    [sym_unary_expression] = STATE(533),
    [sym_update_expression] = STATE(533),
    [sym_regex] = STATE(533),
    [sym_meta_property] = STATE(533),
    [sym_call_signature] = STATE(242),
    [sym_rest_parameter] = STATE(243),
    [sym__expression] = STATE(533),
    [sym_yield_expression] = STATE(533),
    [sym_as_expression] = STATE(533),
    [sym_non_null_expression] = STATE(533),
    [sym_internal_module] = STATE(533),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(533),
    [sym_await_expression] = STATE(533),
    [sym_member_expression] = STATE(245),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(243),
    [sym_sequence_expression] = STATE(534),
    [sym_string] = STATE(533),
    [sym_this] = STATE(248),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(249),
    [sym_object] = STATE(250),
    [sym_anonymous_class] = STATE(533),
    [sym_generator_function] = STATE(533),
    [sym_call_expression] = STATE(533),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(533),
    [sym_ternary_expression] = STATE(533),
    [sym_binary_expression] = STATE(533),
    [sym_template_string] = STATE(533),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(249),
    [sym_optional_parameter] = STATE(243),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(533),
    [sym_array] = STATE(252),
    [sym_type_assertion] = STATE(533),
    [sym_class] = STATE(533),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [sym_identifier] = ACTIONS(406),
    [sym_false] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_symbol] = ACTIONS(412),
    [anon_sym_number] = ACTIONS(412),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(412),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(420),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(973),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(412),
    [anon_sym_private] = ACTIONS(422),
    [anon_sym_boolean] = ACTIONS(412),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(422),
    [anon_sym_get] = ACTIONS(412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(975),
    [sym_true] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(422),
    [anon_sym_string] = ACTIONS(412),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(973),
    [anon_sym_set] = ACTIONS(412),
    [anon_sym_type] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(412),
    [anon_sym_export] = ACTIONS(412),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_TILDE] = ACTIONS(410),
  },
  [146] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_SEMI] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [sym__automatic_semicolon] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_GT_GT_GT] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(979),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_of] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_as] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_DASH_DASH] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_instanceof] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(977),
    [anon_sym_in] = ACTIONS(979),
  },
  [147] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [148] = {
    [sym_call_signature] = STATE(538),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(983),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(985),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(985),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(985),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(985),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(985),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_public] = ACTIONS(985),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [149] = {
    [aux_sym_string_repeat2] = STATE(541),
    [sym_escape_sequence] = ACTIONS(989),
    [aux_sym_string_token2] = ACTIONS(989),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(927),
  },
  [150] = {
    [sym_new_expression] = STATE(542),
    [sym_augmented_assignment_expression] = STATE(542),
    [sym_unary_expression] = STATE(542),
    [sym_update_expression] = STATE(542),
    [sym_regex] = STATE(542),
    [sym_meta_property] = STATE(542),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(542),
    [sym_yield_expression] = STATE(542),
    [sym_as_expression] = STATE(542),
    [sym_non_null_expression] = STATE(542),
    [sym_internal_module] = STATE(542),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(542),
    [sym_await_expression] = STATE(542),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(542),
    [sym_this] = STATE(542),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(542),
    [sym_generator_function] = STATE(542),
    [sym_call_expression] = STATE(542),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(542),
    [sym_ternary_expression] = STATE(542),
    [sym_binary_expression] = STATE(542),
    [sym_template_string] = STATE(542),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(542),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(542),
    [sym_class] = STATE(542),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(991),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(993),
    [sym_true] = ACTIONS(991),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [151] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(207),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_RBRACK] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_implements] = ACTIONS(207),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [152] = {
    [sym_new_expression] = STATE(543),
    [sym_augmented_assignment_expression] = STATE(543),
    [sym_unary_expression] = STATE(543),
    [sym_update_expression] = STATE(543),
    [sym_regex] = STATE(543),
    [sym_meta_property] = STATE(543),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(543),
    [sym_yield_expression] = STATE(543),
    [sym_as_expression] = STATE(543),
    [sym_non_null_expression] = STATE(543),
    [sym_internal_module] = STATE(543),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(543),
    [sym_await_expression] = STATE(543),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(543),
    [sym_this] = STATE(543),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(543),
    [sym_generator_function] = STATE(543),
    [sym_call_expression] = STATE(543),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(543),
    [sym_ternary_expression] = STATE(543),
    [sym_binary_expression] = STATE(543),
    [sym_template_string] = STATE(543),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(543),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(543),
    [sym_class] = STATE(543),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(995),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(995),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(211),
    [sym_null] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [153] = {
    [sym_regex_pattern] = ACTIONS(999),
    [sym_comment] = ACTIONS(246),
  },
  [154] = {
    [sym_call_signature] = STATE(547),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [anon_sym_STAR] = ACTIONS(1003),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1005),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1009),
    [anon_sym_symbol] = ACTIONS(1009),
    [anon_sym_number] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1009),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1009),
    [anon_sym_private] = ACTIONS(1009),
    [anon_sym_boolean] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_public] = ACTIONS(1009),
    [anon_sym_get] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1009),
    [anon_sym_string] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1009),
    [anon_sym_namespace] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [156] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [157] = {
    [sym_new_expression] = STATE(563),
    [sym_augmented_assignment_expression] = STATE(563),
    [sym_unary_expression] = STATE(563),
    [sym_update_expression] = STATE(563),
    [sym_regex] = STATE(563),
    [sym_meta_property] = STATE(563),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(563),
    [sym_yield_expression] = STATE(563),
    [sym_as_expression] = STATE(563),
    [sym_non_null_expression] = STATE(563),
    [sym_internal_module] = STATE(563),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(563),
    [sym_await_expression] = STATE(563),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(563),
    [sym_this] = STATE(563),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(563),
    [sym_generator_function] = STATE(563),
    [sym_call_expression] = STATE(563),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(563),
    [sym_ternary_expression] = STATE(563),
    [sym_binary_expression] = STATE(563),
    [sym_template_string] = STATE(563),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(563),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(563),
    [sym_class] = STATE(563),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1025),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [158] = {
    [anon_sym_EQ_GT] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [aux_sym_array_repeat1] = STATE(575),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [160] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [161] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_AMP_EQ] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(929),
    [anon_sym_STAR_EQ] = ACTIONS(929),
    [anon_sym_PIPE_EQ] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [162] = {
    [aux_sym_array_repeat1] = STATE(575),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [aux_sym_export_statement_repeat1] = STATE(402),
    [sym_decorator] = STATE(402),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(937),
  },
  [165] = {
    [aux_sym_array_repeat1] = STATE(578),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [167] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(937),
  },
  [168] = {
    [sym_statement_block] = STATE(582),
    [sym_identifier] = ACTIONS(897),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_debugger] = ACTIONS(897),
    [anon_sym_symbol] = ACTIONS(897),
    [anon_sym_AT] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(897),
    [anon_sym_break] = ACTIONS(897),
    [anon_sym_const] = ACTIONS(897),
    [sym_super] = ACTIONS(897),
    [anon_sym_return] = ACTIONS(897),
    [anon_sym_private] = ACTIONS(897),
    [anon_sym_get] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_interface] = ACTIONS(897),
    [anon_sym_default] = ACTIONS(897),
    [anon_sym_enum] = ACTIONS(897),
    [anon_sym_delete] = ACTIONS(897),
    [anon_sym_continue] = ACTIONS(897),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_this] = ACTIONS(897),
    [anon_sym_yield] = ACTIONS(897),
    [sym_true] = ACTIONS(897),
    [anon_sym_throw] = ACTIONS(897),
    [anon_sym_protected] = ACTIONS(897),
    [anon_sym_abstract] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(897),
    [anon_sym_type] = ACTIONS(897),
    [anon_sym_import] = ACTIONS(897),
    [anon_sym_namespace] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_await] = ACTIONS(897),
    [anon_sym_DQUOTE] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(897),
    [anon_sym_BANG] = ACTIONS(895),
    [anon_sym_for] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(895),
    [sym_false] = ACTIONS(897),
    [anon_sym_SEMI] = ACTIONS(895),
    [anon_sym_case] = ACTIONS(897),
    [anon_sym_module] = ACTIONS(897),
    [anon_sym_number] = ACTIONS(897),
    [anon_sym_class] = ACTIONS(897),
    [anon_sym_declare] = ACTIONS(897),
    [anon_sym_typeof] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(458),
    [anon_sym_switch] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(895),
    [sym_null] = ACTIONS(897),
    [anon_sym_any] = ACTIONS(897),
    [anon_sym_boolean] = ACTIONS(897),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(897),
    [anon_sym_var] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(895),
    [anon_sym_try] = ACTIONS(897),
    [anon_sym_LT] = ACTIONS(895),
    [sym_number] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(897),
    [anon_sym_function] = ACTIONS(897),
    [sym_undefined] = ACTIONS(897),
    [anon_sym_new] = ACTIONS(897),
    [ts_builtin_sym_end] = ACTIONS(895),
    [anon_sym_let] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_export] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_with] = ACTIONS(897),
  },
  [169] = {
    [aux_sym_string_repeat2] = STATE(584),
    [sym_escape_sequence] = ACTIONS(1065),
    [aux_sym_string_token2] = ACTIONS(1065),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(1067),
  },
  [170] = {
    [aux_sym_string_repeat1] = STATE(585),
    [sym_escape_sequence] = ACTIONS(1069),
    [aux_sym_string_token1] = ACTIONS(1069),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [sym_comment] = ACTIONS(246),
  },
  [171] = {
    [sym_identifier] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_debugger] = ACTIONS(1071),
    [anon_sym_symbol] = ACTIONS(1071),
    [anon_sym_AT] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1071),
    [anon_sym_break] = ACTIONS(1071),
    [anon_sym_const] = ACTIONS(1071),
    [sym_super] = ACTIONS(1071),
    [anon_sym_return] = ACTIONS(1071),
    [anon_sym_private] = ACTIONS(1071),
    [anon_sym_get] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1071),
    [anon_sym_default] = ACTIONS(1071),
    [anon_sym_enum] = ACTIONS(1071),
    [anon_sym_delete] = ACTIONS(1071),
    [anon_sym_continue] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1071),
    [anon_sym_yield] = ACTIONS(1071),
    [sym_true] = ACTIONS(1071),
    [anon_sym_throw] = ACTIONS(1071),
    [anon_sym_protected] = ACTIONS(1071),
    [anon_sym_abstract] = ACTIONS(1071),
    [anon_sym_set] = ACTIONS(1071),
    [anon_sym_type] = ACTIONS(1071),
    [anon_sym_import] = ACTIONS(1071),
    [anon_sym_namespace] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [sym_false] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_case] = ACTIONS(1071),
    [anon_sym_module] = ACTIONS(1071),
    [anon_sym_number] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(1071),
    [anon_sym_declare] = ACTIONS(1071),
    [anon_sym_typeof] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [sym_null] = ACTIONS(1071),
    [anon_sym_any] = ACTIONS(1071),
    [anon_sym_boolean] = ACTIONS(1071),
    [anon_sym_async] = ACTIONS(1071),
    [anon_sym_public] = ACTIONS(1071),
    [anon_sym_var] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [sym_number] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1071),
    [anon_sym_function] = ACTIONS(1071),
    [sym_undefined] = ACTIONS(1071),
    [anon_sym_new] = ACTIONS(1071),
    [ts_builtin_sym_end] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_export] = ACTIONS(1071),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1071),
  },
  [172] = {
    [sym_statement_block] = STATE(582),
    [sym_identifier] = ACTIONS(897),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_debugger] = ACTIONS(897),
    [anon_sym_symbol] = ACTIONS(897),
    [anon_sym_AT] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(897),
    [anon_sym_break] = ACTIONS(897),
    [anon_sym_const] = ACTIONS(897),
    [sym_super] = ACTIONS(897),
    [anon_sym_return] = ACTIONS(897),
    [anon_sym_private] = ACTIONS(897),
    [anon_sym_get] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_interface] = ACTIONS(897),
    [anon_sym_default] = ACTIONS(897),
    [anon_sym_enum] = ACTIONS(897),
    [anon_sym_delete] = ACTIONS(897),
    [anon_sym_continue] = ACTIONS(897),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_this] = ACTIONS(897),
    [anon_sym_yield] = ACTIONS(897),
    [sym_true] = ACTIONS(897),
    [anon_sym_throw] = ACTIONS(897),
    [anon_sym_protected] = ACTIONS(897),
    [anon_sym_abstract] = ACTIONS(897),
    [anon_sym_set] = ACTIONS(897),
    [anon_sym_type] = ACTIONS(897),
    [anon_sym_import] = ACTIONS(897),
    [anon_sym_namespace] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_await] = ACTIONS(897),
    [anon_sym_DQUOTE] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(897),
    [anon_sym_BANG] = ACTIONS(895),
    [anon_sym_for] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(895),
    [sym_false] = ACTIONS(897),
    [anon_sym_SEMI] = ACTIONS(895),
    [anon_sym_case] = ACTIONS(897),
    [anon_sym_module] = ACTIONS(897),
    [anon_sym_number] = ACTIONS(897),
    [anon_sym_class] = ACTIONS(897),
    [anon_sym_declare] = ACTIONS(897),
    [anon_sym_typeof] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(458),
    [anon_sym_switch] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(895),
    [sym_null] = ACTIONS(897),
    [anon_sym_any] = ACTIONS(897),
    [anon_sym_boolean] = ACTIONS(897),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(897),
    [anon_sym_var] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(895),
    [anon_sym_try] = ACTIONS(897),
    [anon_sym_LT] = ACTIONS(895),
    [sym_number] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(897),
    [anon_sym_function] = ACTIONS(897),
    [sym_undefined] = ACTIONS(897),
    [anon_sym_new] = ACTIONS(897),
    [ts_builtin_sym_end] = ACTIONS(895),
    [anon_sym_let] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_export] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_with] = ACTIONS(897),
  },
  [173] = {
    [sym_new_expression] = STATE(599),
    [sym_augmented_assignment_expression] = STATE(599),
    [sym_unary_expression] = STATE(599),
    [sym_update_expression] = STATE(599),
    [sym_regex] = STATE(599),
    [sym_meta_property] = STATE(599),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(599),
    [sym_yield_expression] = STATE(599),
    [sym_as_expression] = STATE(599),
    [sym_non_null_expression] = STATE(599),
    [sym_internal_module] = STATE(599),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(599),
    [sym_await_expression] = STATE(599),
    [sym_member_expression] = STATE(600),
    [sym_generic_type] = STATE(605),
    [sym_string] = STATE(599),
    [sym_this] = STATE(599),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_nested_type_identifier] = STATE(602),
    [sym_anonymous_class] = STATE(599),
    [sym_generator_function] = STATE(599),
    [sym_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(599),
    [sym_ternary_expression] = STATE(599),
    [sym_binary_expression] = STATE(599),
    [sym_template_string] = STATE(599),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(599),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(599),
    [sym__type_reference] = STATE(605),
    [sym_class] = STATE(599),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1077),
    [sym_false] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1079),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1093),
    [sym_true] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [174] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(611),
    [sym_constructor_type] = STATE(611),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(611),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(611),
    [sym_intersection_type] = STATE(611),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(612),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(614),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [175] = {
    [sym_class_heritage] = STATE(615),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_type_parameters] = STATE(616),
    [sym_class_body] = STATE(617),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [176] = {
    [sym_public_field_definition] = STATE(630),
    [sym__property_name] = STATE(631),
    [sym_decorator] = STATE(633),
    [sym_method_signature] = STATE(630),
    [sym_accessibility_modifier] = STATE(632),
    [sym_abstract_method_signature] = STATE(630),
    [sym_computed_property_name] = STATE(631),
    [aux_sym_class_body_repeat1] = STATE(633),
    [sym_index_signature] = STATE(630),
    [sym_string] = STATE(631),
    [sym_method_definition] = STATE(634),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1129),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_abstract] = ACTIONS(1139),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [177] = {
    [sym_class_body] = STATE(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [178] = {
    [sym_implements_clause] = STATE(636),
    [anon_sym_implements] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1145),
  },
  [179] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1145),
  },
  [180] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1147),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym_BQUOTE] = ACTIONS(1147),
    [sym__automatic_semicolon] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1147),
    [anon_sym_STAR] = ACTIONS(1149),
    [anon_sym_GT_GT_GT] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_BANG_EQ] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [anon_sym_GT_EQ] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1149),
    [anon_sym_PERCENT] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_PIPE_PIPE] = ACTIONS(1147),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [anon_sym_EQ_EQ] = ACTIONS(1149),
    [anon_sym_instanceof] = ACTIONS(1147),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_RPAREN] = ACTIONS(1147),
    [anon_sym_SLASH] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_STAR_STAR] = ACTIONS(1147),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_GT_GT] = ACTIONS(1149),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1149),
  },
  [181] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(1153),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(310),
  },
  [182] = {
    [sym_identifier] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(191),
    [sym__declaration] = STATE(192),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(191),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(338),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(342),
    [anon_sym_global] = ACTIONS(322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(352),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [184] = {
    [sym_statement_block] = STATE(639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [185] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1157),
  },
  [186] = {
    [sym_call_signature] = STATE(643),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(1159),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [anon_sym_STAR] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_identifier] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [sym_identifier] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(191),
    [sym__declaration] = STATE(317),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(191),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(352),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [190] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(646),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(310),
  },
  [191] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(608),
    [anon_sym_class] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [anon_sym_debugger] = ACTIONS(1175),
    [anon_sym_symbol] = ACTIONS(1175),
    [anon_sym_AT] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1175),
    [anon_sym_void] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1175),
    [anon_sym_const] = ACTIONS(1175),
    [sym_super] = ACTIONS(1175),
    [anon_sym_return] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_get] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1177),
    [anon_sym_interface] = ACTIONS(1175),
    [anon_sym_default] = ACTIONS(1175),
    [anon_sym_enum] = ACTIONS(1175),
    [anon_sym_delete] = ACTIONS(1175),
    [anon_sym_continue] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1177),
    [anon_sym_if] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(1175),
    [sym_true] = ACTIONS(1175),
    [anon_sym_throw] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_abstract] = ACTIONS(1175),
    [anon_sym_set] = ACTIONS(1175),
    [anon_sym_type] = ACTIONS(1175),
    [anon_sym_import] = ACTIONS(1175),
    [anon_sym_namespace] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1177),
    [anon_sym_await] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1175),
    [anon_sym_LBRACK] = ACTIONS(1177),
    [sym_false] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1175),
    [anon_sym_module] = ACTIONS(1175),
    [anon_sym_number] = ACTIONS(1175),
    [anon_sym_class] = ACTIONS(1175),
    [anon_sym_declare] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(1177),
    [anon_sym_switch] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [sym_null] = ACTIONS(1175),
    [anon_sym_any] = ACTIONS(1175),
    [anon_sym_boolean] = ACTIONS(1175),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_var] = ACTIONS(1175),
    [anon_sym_while] = ACTIONS(1175),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_try] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(1177),
    [sym_number] = ACTIONS(1177),
    [anon_sym_SLASH] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1175),
    [anon_sym_function] = ACTIONS(1175),
    [sym_undefined] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(1175),
    [ts_builtin_sym_end] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1175),
    [anon_sym_PLUS] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(1175),
    [anon_sym_do] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1177),
    [anon_sym_with] = ACTIONS(1175),
  },
  [193] = {
    [sym__initializer] = STATE(651),
    [aux_sym_object_repeat1] = STATE(652),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1189),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [194] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(652),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [195] = {
    [sym__identifier_reference] = STATE(653),
    [sym_decorator_member_expression] = STATE(653),
    [sym_decorator_call_expression] = STATE(82),
    [anon_sym_get] = ACTIONS(145),
    [sym_identifier] = ACTIONS(1200),
    [anon_sym_module] = ACTIONS(145),
    [anon_sym_symbol] = ACTIONS(145),
    [anon_sym_number] = ACTIONS(145),
    [anon_sym_declare] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_protected] = ACTIONS(145),
    [anon_sym_string] = ACTIONS(145),
    [anon_sym_set] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_namespace] = ACTIONS(145),
    [anon_sym_any] = ACTIONS(145),
    [anon_sym_private] = ACTIONS(145),
    [anon_sym_boolean] = ACTIONS(145),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(145),
  },
  [196] = {
    [sym_pair] = STATE(659),
    [sym__property_name] = STATE(221),
    [sym_object] = STATE(397),
    [sym_decorator] = STATE(660),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(660),
    [sym_computed_property_name] = STATE(221),
    [sym_assignment_pattern] = STATE(659),
    [sym_array] = STATE(399),
    [sym_spread_element] = STATE(659),
    [sym_string] = STATE(221),
    [sym_method_definition] = STATE(659),
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_module] = ACTIONS(1204),
    [anon_sym_symbol] = ACTIONS(1204),
    [anon_sym_number] = ACTIONS(1204),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1204),
    [anon_sym_COMMA] = ACTIONS(1206),
    [anon_sym_STAR] = ACTIONS(362),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_any] = ACTIONS(1204),
    [anon_sym_private] = ACTIONS(1208),
    [anon_sym_boolean] = ACTIONS(1204),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_async] = ACTIONS(1210),
    [anon_sym_get] = ACTIONS(1212),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_public] = ACTIONS(1208),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [sym_number] = ACTIONS(720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1208),
    [anon_sym_string] = ACTIONS(1204),
    [anon_sym_set] = ACTIONS(1212),
    [anon_sym_type] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(1204),
    [anon_sym_export] = ACTIONS(1204),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_namespace] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [197] = {
    [sym_string] = STATE(663),
    [sym__property_name] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [198] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_meta_property] = STATE(90),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_internal_module] = STATE(90),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [aux_sym_object_repeat1] = STATE(652),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [199] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(652),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(1220),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1220),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [sym_number] = ACTIONS(1222),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [200] = {
    [sym_string] = STATE(663),
    [sym__property_name] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [anon_sym_get] = ACTIONS(1224),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_async] = ACTIONS(1226),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1224),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [sym_readonly] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [201] = {
    [sym__property_name] = STATE(663),
    [aux_sym_object_repeat1] = STATE(652),
    [sym_string] = STATE(663),
    [sym__initializer] = STATE(79),
    [sym_computed_property_name] = STATE(663),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [sym_number] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [202] = {
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1237),
    [sym__automatic_semicolon] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1237),
    [anon_sym_AT] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1241),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_EQ] = ACTIONS(1241),
    [anon_sym_void] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [sym_super] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_get] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_delete] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1241),
    [anon_sym_this] = ACTIONS(1237),
    [anon_sym_yield] = ACTIONS(1237),
    [sym_true] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1237),
    [anon_sym_abstract] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1237),
    [anon_sym_type] = ACTIONS(1237),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1237),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_await] = ACTIONS(1237),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [sym_false] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_module] = ACTIONS(1237),
    [anon_sym_number] = ACTIONS(1237),
    [anon_sym_class] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1237),
    [anon_sym_typeof] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [sym_null] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1237),
    [anon_sym_boolean] = ACTIONS(1237),
    [anon_sym_async] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_var] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_try] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [sym_number] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1237),
    [anon_sym_function] = ACTIONS(1237),
    [sym_undefined] = ACTIONS(1237),
    [anon_sym_new] = ACTIONS(1237),
    [ts_builtin_sym_end] = ACTIONS(1239),
    [anon_sym_let] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_with] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1241),
  },
  [203] = {
    [sym_parenthesized_expression] = STATE(668),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(652),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [205] = {
    [sym_import_require_clause] = STATE(124),
    [sym_import_clause] = STATE(125),
    [aux_sym_object_repeat1] = STATE(652),
    [sym_named_imports] = STATE(126),
    [sym_string] = STATE(124),
    [sym_namespace_import] = STATE(126),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(232),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(232),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [206] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [aux_sym_object_repeat1] = STATE(652),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [207] = {
    [sym_string] = STATE(663),
    [sym__property_name] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [anon_sym_get] = ACTIONS(1224),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1224),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1226),
  },
  [208] = {
    [anon_sym_await] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_new_expression] = STATE(671),
    [sym_augmented_assignment_expression] = STATE(671),
    [sym_unary_expression] = STATE(671),
    [sym_update_expression] = STATE(671),
    [sym_regex] = STATE(671),
    [sym_meta_property] = STATE(671),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(671),
    [sym_yield_expression] = STATE(671),
    [sym_as_expression] = STATE(671),
    [sym_non_null_expression] = STATE(671),
    [sym_internal_module] = STATE(671),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(671),
    [sym_await_expression] = STATE(671),
    [sym_member_expression] = STATE(161),
    [sym_spread_element] = STATE(162),
    [sym_string] = STATE(671),
    [sym_this] = STATE(671),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [aux_sym_array_repeat1] = STATE(165),
    [sym_anonymous_class] = STATE(671),
    [sym_generator_function] = STATE(671),
    [sym_call_expression] = STATE(671),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(671),
    [sym_ternary_expression] = STATE(671),
    [sym_binary_expression] = STATE(671),
    [sym_template_string] = STATE(671),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(671),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(671),
    [sym_class] = STATE(671),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(276),
    [sym_null] = ACTIONS(1247),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1249),
    [sym_true] = ACTIONS(1247),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1247),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [210] = {
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [aux_sym_object_repeat1] = STATE(652),
    [sym_string] = STATE(172),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(308),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [211] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(675),
    [aux_sym_object_repeat1] = STATE(652),
    [sym__initializer] = STATE(79),
    [sym__declaration] = STATE(192),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(675),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(322),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1251),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [212] = {
    [sym_new_expression] = STATE(676),
    [sym_augmented_assignment_expression] = STATE(676),
    [sym_unary_expression] = STATE(676),
    [sym_update_expression] = STATE(676),
    [sym_regex] = STATE(676),
    [sym_meta_property] = STATE(676),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(676),
    [sym_yield_expression] = STATE(676),
    [sym_as_expression] = STATE(676),
    [sym_non_null_expression] = STATE(676),
    [sym_internal_module] = STATE(676),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(676),
    [sym_await_expression] = STATE(676),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(676),
    [sym_this] = STATE(676),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(676),
    [sym_generator_function] = STATE(676),
    [sym_call_expression] = STATE(676),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(676),
    [sym_ternary_expression] = STATE(676),
    [sym_binary_expression] = STATE(676),
    [sym_template_string] = STATE(676),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(676),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(676),
    [sym_class] = STATE(676),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(1257),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1257),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1257),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [213] = {
    [sym__property_name] = STATE(663),
    [aux_sym_object_repeat1] = STATE(652),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_computed_property_name] = STATE(663),
    [sym_call_signature] = STATE(253),
    [sym_string] = STATE(663),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1263),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(1263),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1263),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1263),
    [anon_sym_declare] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1263),
    [anon_sym_async] = ACTIONS(1263),
    [anon_sym_public] = ACTIONS(1263),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1274),
    [sym_number] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1263),
    [anon_sym_function] = ACTIONS(450),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [214] = {
    [sym_parenthesized_expression] = STATE(680),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1281),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1284),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [216] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(675),
    [aux_sym_object_repeat1] = STATE(652),
    [sym__declaration] = STATE(317),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(675),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_as] = ACTIONS(541),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [217] = {
    [sym_parenthesized_expression] = STATE(681),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym_string] = STATE(663),
    [sym__property_name] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [anon_sym_get] = ACTIONS(1224),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1226),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1224),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [sym_readonly] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1214),
  },
  [219] = {
    [aux_sym_object_repeat1] = STATE(684),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym_type_alias_declaration] = STATE(689),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(689),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(689),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(689),
    [sym_return_statement] = STATE(689),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(689),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(689),
    [sym_switch_statement] = STATE(689),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(689),
    [sym_throw_statement] = STATE(689),
    [aux_sym_program_repeat1] = STATE(689),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(689),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(689),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(689),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(689),
    [sym_abstract_class] = STATE(689),
    [sym_interface_declaration] = STATE(689),
    [sym_statement_block] = STATE(689),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(689),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(689),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(689),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(689),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(689),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(689),
    [sym_empty_statement] = STATE(689),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(689),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(689),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(689),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(689),
    [sym_break_statement] = STATE(689),
    [sym_labeled_statement] = STATE(689),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(689),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1292),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [221] = {
    [sym_call_signature] = STATE(693),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_COLON] = ACTIONS(1298),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym__initializer] = STATE(694),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [223] = {
    [aux_sym_object_repeat1] = STATE(695),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym_computed_property_name] = STATE(701),
    [sym__property_name] = STATE(701),
    [sym_decorator] = STATE(702),
    [sym_method_definition] = STATE(700),
    [sym_string] = STATE(701),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(702),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_class] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(362),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1304),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_public] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [sym_number] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1304),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1312),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [225] = {
    [sym__initializer] = STATE(703),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [226] = {
    [sym_switch_body] = STATE(705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1314),
  },
  [227] = {
    [sym__initializer] = STATE(712),
    [sym_type_annotation] = STATE(713),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1325),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1328),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1331),
  },
  [228] = {
    [sym_array] = STATE(716),
    [sym_this] = STATE(717),
    [sym_object] = STATE(718),
    [anon_sym_get] = ACTIONS(1333),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1335),
    [anon_sym_module] = ACTIONS(1333),
    [anon_sym_symbol] = ACTIONS(1333),
    [anon_sym_number] = ACTIONS(1333),
    [anon_sym_declare] = ACTIONS(1333),
    [anon_sym_this] = ACTIONS(286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1333),
    [anon_sym_protected] = ACTIONS(1333),
    [anon_sym_string] = ACTIONS(1333),
    [anon_sym_set] = ACTIONS(1333),
    [anon_sym_type] = ACTIONS(1333),
    [anon_sym_import] = ACTIONS(1333),
    [anon_sym_export] = ACTIONS(1333),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_any] = ACTIONS(1333),
    [anon_sym_private] = ACTIONS(1333),
    [anon_sym_boolean] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1333),
    [anon_sym_public] = ACTIONS(1333),
  },
  [229] = {
    [sym__initializer] = STATE(722),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [230] = {
    [sym_new_expression] = STATE(724),
    [sym_augmented_assignment_expression] = STATE(724),
    [sym_unary_expression] = STATE(724),
    [sym_update_expression] = STATE(724),
    [sym_regex] = STATE(724),
    [sym_meta_property] = STATE(724),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(724),
    [sym_yield_expression] = STATE(724),
    [sym_as_expression] = STATE(724),
    [sym_non_null_expression] = STATE(724),
    [sym_internal_module] = STATE(724),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(724),
    [sym_await_expression] = STATE(724),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(724),
    [sym_this] = STATE(724),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(724),
    [sym_generator_function] = STATE(724),
    [sym_call_expression] = STATE(724),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(724),
    [sym_ternary_expression] = STATE(724),
    [sym_binary_expression] = STATE(724),
    [sym_template_string] = STATE(724),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(724),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(724),
    [sym_class] = STATE(724),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1350),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1350),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [231] = {
    [sym_new_expression] = STATE(725),
    [sym_augmented_assignment_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym_update_expression] = STATE(725),
    [sym_regex] = STATE(725),
    [sym_meta_property] = STATE(725),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(725),
    [sym_yield_expression] = STATE(725),
    [sym_as_expression] = STATE(725),
    [sym_non_null_expression] = STATE(725),
    [sym_internal_module] = STATE(725),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(725),
    [sym_await_expression] = STATE(725),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(725),
    [sym_this] = STATE(725),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(725),
    [sym_generator_function] = STATE(725),
    [sym_call_expression] = STATE(725),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(725),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_template_string] = STATE(725),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(725),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(725),
    [sym_class] = STATE(725),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(1354),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1354),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1356),
    [sym_true] = ACTIONS(1354),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [232] = {
    [sym_identifier] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_new_expression] = STATE(724),
    [sym_augmented_assignment_expression] = STATE(724),
    [sym__initializer] = STATE(722),
    [sym_unary_expression] = STATE(724),
    [sym_update_expression] = STATE(724),
    [sym_regex] = STATE(724),
    [sym_meta_property] = STATE(724),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(724),
    [sym_yield_expression] = STATE(724),
    [sym_as_expression] = STATE(724),
    [sym_non_null_expression] = STATE(724),
    [sym_internal_module] = STATE(724),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(724),
    [sym_await_expression] = STATE(724),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(724),
    [sym_this] = STATE(724),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(724),
    [sym_generator_function] = STATE(724),
    [sym_call_expression] = STATE(724),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(724),
    [sym_ternary_expression] = STATE(724),
    [sym_binary_expression] = STATE(724),
    [sym_template_string] = STATE(724),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_type_annotation] = STATE(723),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(724),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(724),
    [sym_class] = STATE(724),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(430),
    [sym_true] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1350),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1350),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1350),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [234] = {
    [sym__initializer] = STATE(722),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(1220),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1220),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [235] = {
    [sym_call_signature] = STATE(727),
    [sym__initializer] = STATE(722),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_void] = ACTIONS(1362),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1362),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1362),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_async] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [236] = {
    [sym_new_expression] = STATE(729),
    [sym_augmented_assignment_expression] = STATE(729),
    [sym_unary_expression] = STATE(729),
    [sym_update_expression] = STATE(729),
    [sym_regex] = STATE(729),
    [sym_meta_property] = STATE(729),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(729),
    [sym_yield_expression] = STATE(729),
    [sym_as_expression] = STATE(729),
    [sym_non_null_expression] = STATE(729),
    [sym_internal_module] = STATE(729),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(729),
    [sym_await_expression] = STATE(729),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(729),
    [sym_this] = STATE(729),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(729),
    [sym_generator_function] = STATE(729),
    [sym_call_expression] = STATE(729),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(729),
    [sym_ternary_expression] = STATE(729),
    [sym_binary_expression] = STATE(729),
    [sym_template_string] = STATE(729),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(729),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(729),
    [sym_class] = STATE(729),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1364),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1366),
    [sym_true] = ACTIONS(1364),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1364),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [237] = {
    [anon_sym_COLON] = ACTIONS(1368),
    [anon_sym_EQ_GT] = ACTIONS(1368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1368),
  },
  [238] = {
    [sym_new_expression] = STATE(730),
    [sym_augmented_assignment_expression] = STATE(730),
    [sym_unary_expression] = STATE(730),
    [sym_update_expression] = STATE(730),
    [sym_regex] = STATE(730),
    [sym_meta_property] = STATE(730),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(730),
    [sym_yield_expression] = STATE(730),
    [sym_as_expression] = STATE(730),
    [sym_non_null_expression] = STATE(730),
    [sym_internal_module] = STATE(730),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(730),
    [sym_await_expression] = STATE(730),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(730),
    [sym_this] = STATE(730),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(730),
    [sym_generator_function] = STATE(730),
    [sym_call_expression] = STATE(730),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(730),
    [sym_ternary_expression] = STATE(730),
    [sym_binary_expression] = STATE(730),
    [sym_template_string] = STATE(730),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(730),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(730),
    [sym_class] = STATE(730),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(430),
    [sym_true] = ACTIONS(1370),
    [anon_sym_COLON] = ACTIONS(211),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1370),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1370),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [239] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1374),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1376),
    [anon_sym_symbol] = ACTIONS(1376),
    [anon_sym_number] = ACTIONS(1376),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1378),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1376),
    [anon_sym_private] = ACTIONS(1376),
    [anon_sym_boolean] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1380),
    [anon_sym_public] = ACTIONS(1376),
    [anon_sym_get] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1376),
    [anon_sym_string] = ACTIONS(1376),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1376),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(1376),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [240] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(722),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [241] = {
    [sym_new_expression] = STATE(736),
    [sym_augmented_assignment_expression] = STATE(736),
    [sym_unary_expression] = STATE(736),
    [sym_update_expression] = STATE(736),
    [sym_regex] = STATE(736),
    [sym_meta_property] = STATE(736),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(736),
    [sym_yield_expression] = STATE(736),
    [sym_as_expression] = STATE(736),
    [sym_non_null_expression] = STATE(736),
    [sym_internal_module] = STATE(736),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(736),
    [sym_await_expression] = STATE(736),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(736),
    [sym_this] = STATE(736),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(736),
    [sym_generator_function] = STATE(736),
    [sym_call_expression] = STATE(736),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(736),
    [sym_ternary_expression] = STATE(736),
    [sym_binary_expression] = STATE(736),
    [sym_template_string] = STATE(736),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(736),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(736),
    [sym_class] = STATE(736),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1384),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1386),
    [sym_true] = ACTIONS(1384),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [242] = {
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [aux_sym_formal_parameters_repeat1] = STATE(739),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [sym_type_annotation] = STATE(751),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(1331),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_RPAREN] = ACTIONS(1416),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [245] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [246] = {
    [sym_array] = STATE(716),
    [sym_this] = STATE(717),
    [sym_object] = STATE(718),
    [anon_sym_get] = ACTIONS(1333),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1335),
    [anon_sym_public] = ACTIONS(1333),
    [anon_sym_module] = ACTIONS(1333),
    [anon_sym_symbol] = ACTIONS(1333),
    [anon_sym_number] = ACTIONS(1333),
    [anon_sym_declare] = ACTIONS(1333),
    [anon_sym_this] = ACTIONS(286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1333),
    [anon_sym_protected] = ACTIONS(1333),
    [anon_sym_string] = ACTIONS(1333),
    [anon_sym_set] = ACTIONS(1333),
    [anon_sym_type] = ACTIONS(1333),
    [anon_sym_import] = ACTIONS(1333),
    [anon_sym_export] = ACTIONS(1333),
    [sym_readonly] = ACTIONS(1422),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_any] = ACTIONS(1333),
    [anon_sym_private] = ACTIONS(1333),
    [anon_sym_boolean] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1333),
  },
  [247] = {
    [anon_sym_RPAREN] = ACTIONS(1416),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym__initializer] = STATE(754),
    [sym_type_annotation] = STATE(713),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1328),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [249] = {
    [aux_sym_export_statement_repeat1] = STATE(758),
    [sym_decorator] = STATE(758),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(760),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(760),
    [sym_optional_parameter] = STATE(760),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_class] = ACTIONS(1432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [250] = {
    [sym__initializer] = STATE(764),
    [sym_type_annotation] = STATE(765),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1328),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1331),
  },
  [251] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [252] = {
    [sym__initializer] = STATE(767),
    [sym_type_annotation] = STATE(768),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1443),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1328),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1331),
  },
  [253] = {
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [anon_sym_EQ_GT] = ACTIONS(1448),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [aux_sym_export_statement_repeat1] = STATE(771),
    [sym_decorator] = STATE(771),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(243),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(243),
    [sym_optional_parameter] = STATE(243),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [256] = {
    [sym_type_parameter] = STATE(282),
    [sym_identifier] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_call_signature] = STATE(774),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [aux_sym_variable_declaration_repeat1] = STATE(776),
    [sym__automatic_semicolon] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1454),
    [anon_sym_COMMA] = ACTIONS(767),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_type_alias_declaration] = STATE(334),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(334),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(334),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(334),
    [sym_return_statement] = STATE(334),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(334),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(334),
    [sym_switch_statement] = STATE(334),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(334),
    [sym_throw_statement] = STATE(334),
    [aux_sym_program_repeat1] = STATE(334),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(334),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(334),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(334),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(334),
    [sym_abstract_class] = STATE(334),
    [sym_interface_declaration] = STATE(334),
    [sym_statement_block] = STATE(334),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(334),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(334),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(334),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(334),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(334),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(334),
    [sym_empty_statement] = STATE(334),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(334),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(334),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(334),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(334),
    [sym_break_statement] = STATE(334),
    [sym_labeled_statement] = STATE(334),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(334),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(1456),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [260] = {
    [sym_type_alias_declaration] = STATE(777),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(777),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(777),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(777),
    [sym_return_statement] = STATE(777),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(777),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(777),
    [sym_switch_statement] = STATE(777),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(777),
    [sym_throw_statement] = STATE(777),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(777),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(777),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(777),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(777),
    [sym_abstract_class] = STATE(777),
    [sym_interface_declaration] = STATE(777),
    [sym_statement_block] = STATE(777),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(777),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(777),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(777),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(777),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(777),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(777),
    [sym_empty_statement] = STATE(777),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(777),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(777),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(777),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(777),
    [sym_break_statement] = STATE(777),
    [sym_labeled_statement] = STATE(777),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(777),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [261] = {
    [aux_sym_string_repeat2] = STATE(778),
    [sym_escape_sequence] = ACTIONS(1458),
    [aux_sym_string_token2] = ACTIONS(1458),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(915),
  },
  [262] = {
    [sym_type_alias_declaration] = STATE(220),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(220),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(220),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(220),
    [sym_return_statement] = STATE(220),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(220),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(220),
    [sym_switch_statement] = STATE(220),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(220),
    [sym_throw_statement] = STATE(220),
    [aux_sym_program_repeat1] = STATE(220),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(220),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(220),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(220),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(220),
    [sym_abstract_class] = STATE(220),
    [sym_interface_declaration] = STATE(220),
    [sym_statement_block] = STATE(220),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(220),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(220),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(220),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(220),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(220),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(220),
    [sym_empty_statement] = STATE(220),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(220),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(220),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(220),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(220),
    [sym_break_statement] = STATE(220),
    [sym_labeled_statement] = STATE(220),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(220),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [263] = {
    [sym_catch_clause] = STATE(782),
    [sym_finally_clause] = STATE(783),
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_BQUOTE] = ACTIONS(1464),
    [anon_sym_debugger] = ACTIONS(1462),
    [anon_sym_symbol] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_void] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [sym_super] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_private] = ACTIONS(1462),
    [anon_sym_get] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_interface] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [anon_sym_delete] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_DASH_DASH] = ACTIONS(1464),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_this] = ACTIONS(1462),
    [anon_sym_yield] = ACTIONS(1462),
    [sym_true] = ACTIONS(1462),
    [anon_sym_throw] = ACTIONS(1462),
    [anon_sym_protected] = ACTIONS(1462),
    [anon_sym_abstract] = ACTIONS(1462),
    [anon_sym_set] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_import] = ACTIONS(1462),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [anon_sym_await] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1464),
    [sym_false] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_number] = ACTIONS(1462),
    [anon_sym_class] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_typeof] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_LPAREN] = ACTIONS(1464),
    [sym_null] = ACTIONS(1462),
    [anon_sym_catch] = ACTIONS(1466),
    [anon_sym_any] = ACTIONS(1462),
    [anon_sym_boolean] = ACTIONS(1462),
    [anon_sym_async] = ACTIONS(1462),
    [anon_sym_public] = ACTIONS(1462),
    [anon_sym_var] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1464),
    [anon_sym_try] = ACTIONS(1462),
    [anon_sym_LT] = ACTIONS(1464),
    [sym_number] = ACTIONS(1464),
    [anon_sym_SLASH] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(1468),
    [anon_sym_string] = ACTIONS(1462),
    [anon_sym_function] = ACTIONS(1462),
    [sym_undefined] = ACTIONS(1462),
    [anon_sym_new] = ACTIONS(1462),
    [ts_builtin_sym_end] = ACTIONS(1464),
    [anon_sym_let] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_export] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1464),
    [anon_sym_with] = ACTIONS(1462),
  },
  [264] = {
    [sym_constraint] = STATE(790),
    [sym_type_arguments] = STATE(791),
    [sym_default_type] = STATE(792),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_COLON] = ACTIONS(1477),
    [anon_sym_extends] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_GT] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(1488),
  },
  [265] = {
    [sym_identifier] = ACTIONS(1490),
    [anon_sym_BQUOTE] = ACTIONS(1492),
    [anon_sym_debugger] = ACTIONS(1490),
    [anon_sym_symbol] = ACTIONS(1490),
    [anon_sym_AT] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_COMMA] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_void] = ACTIONS(1490),
    [anon_sym_break] = ACTIONS(1490),
    [anon_sym_const] = ACTIONS(1490),
    [sym_super] = ACTIONS(1490),
    [anon_sym_return] = ACTIONS(1490),
    [anon_sym_private] = ACTIONS(1490),
    [anon_sym_get] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1492),
    [anon_sym_interface] = ACTIONS(1490),
    [anon_sym_default] = ACTIONS(1490),
    [anon_sym_enum] = ACTIONS(1490),
    [anon_sym_delete] = ACTIONS(1490),
    [anon_sym_continue] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1490),
    [anon_sym_this] = ACTIONS(1490),
    [anon_sym_yield] = ACTIONS(1490),
    [sym_true] = ACTIONS(1490),
    [anon_sym_throw] = ACTIONS(1490),
    [anon_sym_protected] = ACTIONS(1490),
    [anon_sym_abstract] = ACTIONS(1490),
    [anon_sym_set] = ACTIONS(1490),
    [anon_sym_type] = ACTIONS(1490),
    [anon_sym_import] = ACTIONS(1490),
    [anon_sym_namespace] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1492),
    [anon_sym_await] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1492),
    [anon_sym_else] = ACTIONS(1490),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1490),
    [anon_sym_LBRACK] = ACTIONS(1492),
    [sym_false] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1492),
    [anon_sym_case] = ACTIONS(1490),
    [anon_sym_module] = ACTIONS(1490),
    [anon_sym_number] = ACTIONS(1490),
    [anon_sym_class] = ACTIONS(1490),
    [anon_sym_declare] = ACTIONS(1490),
    [anon_sym_typeof] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_switch] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_RBRACK] = ACTIONS(1492),
    [sym_null] = ACTIONS(1490),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_any] = ACTIONS(1490),
    [anon_sym_boolean] = ACTIONS(1490),
    [anon_sym_async] = ACTIONS(1490),
    [anon_sym_public] = ACTIONS(1490),
    [anon_sym_EQ_GT] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_var] = ACTIONS(1490),
    [anon_sym_while] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_try] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1492),
    [sym_number] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1490),
    [anon_sym_function] = ACTIONS(1490),
    [sym_undefined] = ACTIONS(1490),
    [anon_sym_new] = ACTIONS(1490),
    [ts_builtin_sym_end] = ACTIONS(1492),
    [anon_sym_let] = ACTIONS(1490),
    [anon_sym_PLUS] = ACTIONS(1490),
    [anon_sym_export] = ACTIONS(1490),
    [anon_sym_do] = ACTIONS(1490),
    [anon_sym_TILDE] = ACTIONS(1492),
    [anon_sym_with] = ACTIONS(1490),
  },
  [266] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(281),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [267] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(810),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(810),
    [sym_call_signature] = STATE(810),
    [sym_export_statement] = STATE(810),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(810),
    [sym_index_signature] = STATE(810),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1498),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [268] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(817),
    [sym_constructor_type] = STATE(817),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(817),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(817),
    [sym_intersection_type] = STATE(817),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [269] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [270] = {
    [sym_identifier] = ACTIONS(1530),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_debugger] = ACTIONS(1530),
    [anon_sym_symbol] = ACTIONS(1530),
    [anon_sym_AT] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_EQ] = ACTIONS(1530),
    [anon_sym_void] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_const] = ACTIONS(1530),
    [sym_super] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_private] = ACTIONS(1530),
    [anon_sym_get] = ACTIONS(1530),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_interface] = ACTIONS(1530),
    [anon_sym_default] = ACTIONS(1530),
    [anon_sym_enum] = ACTIONS(1530),
    [anon_sym_delete] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_this] = ACTIONS(1530),
    [anon_sym_yield] = ACTIONS(1530),
    [sym_true] = ACTIONS(1530),
    [anon_sym_throw] = ACTIONS(1530),
    [anon_sym_protected] = ACTIONS(1530),
    [anon_sym_abstract] = ACTIONS(1530),
    [anon_sym_set] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(1530),
    [anon_sym_import] = ACTIONS(1530),
    [anon_sym_namespace] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_await] = ACTIONS(1530),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1530),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_LBRACK] = ACTIONS(1532),
    [sym_false] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_case] = ACTIONS(1530),
    [anon_sym_module] = ACTIONS(1530),
    [anon_sym_number] = ACTIONS(1530),
    [anon_sym_class] = ACTIONS(1530),
    [anon_sym_declare] = ACTIONS(1530),
    [anon_sym_typeof] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_switch] = ACTIONS(1530),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [sym_null] = ACTIONS(1530),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_any] = ACTIONS(1530),
    [anon_sym_boolean] = ACTIONS(1530),
    [anon_sym_async] = ACTIONS(1530),
    [anon_sym_public] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_var] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_SQUOTE] = ACTIONS(1532),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [sym_number] = ACTIONS(1532),
    [anon_sym_SLASH] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1530),
    [anon_sym_function] = ACTIONS(1530),
    [sym_undefined] = ACTIONS(1530),
    [anon_sym_new] = ACTIONS(1530),
    [ts_builtin_sym_end] = ACTIONS(1532),
    [anon_sym_let] = ACTIONS(1530),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_export] = ACTIONS(1530),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_TILDE] = ACTIONS(1532),
    [anon_sym_with] = ACTIONS(1530),
  },
  [271] = {
    [sym_identifier] = ACTIONS(1534),
    [anon_sym_BQUOTE] = ACTIONS(1536),
    [anon_sym_debugger] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_AT] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1536),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_DASH] = ACTIONS(1534),
    [anon_sym_EQ] = ACTIONS(1534),
    [anon_sym_void] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1534),
    [anon_sym_const] = ACTIONS(1534),
    [sym_super] = ACTIONS(1534),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_RBRACE] = ACTIONS(1536),
    [anon_sym_interface] = ACTIONS(1534),
    [anon_sym_default] = ACTIONS(1534),
    [anon_sym_enum] = ACTIONS(1534),
    [anon_sym_delete] = ACTIONS(1534),
    [anon_sym_continue] = ACTIONS(1534),
    [anon_sym_DASH_DASH] = ACTIONS(1536),
    [anon_sym_if] = ACTIONS(1534),
    [anon_sym_this] = ACTIONS(1534),
    [anon_sym_yield] = ACTIONS(1534),
    [sym_true] = ACTIONS(1534),
    [anon_sym_throw] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_abstract] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_import] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1536),
    [anon_sym_await] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1536),
    [anon_sym_else] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1536),
    [anon_sym_for] = ACTIONS(1534),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [sym_false] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1536),
    [anon_sym_case] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_class] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_typeof] = ACTIONS(1534),
    [anon_sym_LBRACE] = ACTIONS(1536),
    [anon_sym_switch] = ACTIONS(1534),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [sym_null] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1536),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_async] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_EQ_GT] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1536),
    [anon_sym_var] = ACTIONS(1534),
    [anon_sym_while] = ACTIONS(1534),
    [anon_sym_SQUOTE] = ACTIONS(1536),
    [anon_sym_try] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1536),
    [sym_number] = ACTIONS(1536),
    [anon_sym_SLASH] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_function] = ACTIONS(1534),
    [sym_undefined] = ACTIONS(1534),
    [anon_sym_new] = ACTIONS(1534),
    [ts_builtin_sym_end] = ACTIONS(1536),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1534),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_do] = ACTIONS(1534),
    [anon_sym_TILDE] = ACTIONS(1536),
    [anon_sym_with] = ACTIONS(1534),
  },
  [272] = {
    [sym_nested_identifier] = STATE(822),
    [sym_identifier] = ACTIONS(1538),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_number] = ACTIONS(1540),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_identifier] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [anon_sym_debugger] = ACTIONS(1542),
    [anon_sym_symbol] = ACTIONS(1542),
    [anon_sym_AT] = ACTIONS(1544),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_COMMA] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_void] = ACTIONS(1542),
    [anon_sym_break] = ACTIONS(1542),
    [anon_sym_const] = ACTIONS(1542),
    [sym_super] = ACTIONS(1542),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_private] = ACTIONS(1542),
    [anon_sym_get] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1542),
    [anon_sym_default] = ACTIONS(1542),
    [anon_sym_enum] = ACTIONS(1542),
    [anon_sym_delete] = ACTIONS(1542),
    [anon_sym_continue] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(1542),
    [anon_sym_this] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1542),
    [sym_true] = ACTIONS(1542),
    [anon_sym_throw] = ACTIONS(1542),
    [anon_sym_protected] = ACTIONS(1542),
    [anon_sym_abstract] = ACTIONS(1542),
    [anon_sym_set] = ACTIONS(1542),
    [anon_sym_type] = ACTIONS(1542),
    [anon_sym_import] = ACTIONS(1542),
    [anon_sym_namespace] = ACTIONS(1542),
    [anon_sym_PLUS_PLUS] = ACTIONS(1544),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_BANG] = ACTIONS(1544),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [sym_false] = ACTIONS(1542),
    [anon_sym_SEMI] = ACTIONS(1544),
    [anon_sym_case] = ACTIONS(1542),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_number] = ACTIONS(1542),
    [anon_sym_class] = ACTIONS(1542),
    [anon_sym_declare] = ACTIONS(1542),
    [anon_sym_typeof] = ACTIONS(1542),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_switch] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [sym_null] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_any] = ACTIONS(1542),
    [anon_sym_boolean] = ACTIONS(1542),
    [anon_sym_async] = ACTIONS(1542),
    [anon_sym_public] = ACTIONS(1542),
    [anon_sym_EQ_GT] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_var] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(1544),
    [anon_sym_try] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1544),
    [sym_number] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1542),
    [anon_sym_function] = ACTIONS(1542),
    [sym_undefined] = ACTIONS(1542),
    [anon_sym_new] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_export] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1542),
    [anon_sym_TILDE] = ACTIONS(1544),
    [anon_sym_with] = ACTIONS(1542),
  },
  [275] = {
    [sym_nested_type_identifier] = STATE(825),
    [sym_nested_identifier] = STATE(283),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [sym_formal_parameters] = STATE(826),
    [sym_type_parameters] = STATE(827),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [277] = {
    [sym__type] = STATE(837),
    [sym_constructor_type] = STATE(837),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_function_type] = STATE(837),
    [sym_rest_parameter] = STATE(243),
    [sym_nested_identifier] = STATE(283),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(243),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(265),
    [sym_type_parameters] = STATE(838),
    [sym_this] = STATE(762),
    [sym_predefined_type] = STATE(284),
    [sym_tuple_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(771),
    [sym_object] = STATE(759),
    [sym_nested_type_identifier] = STATE(839),
    [sym_optional_parameter] = STATE(243),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(771),
    [sym_union_type] = STATE(837),
    [sym_intersection_type] = STATE(837),
    [sym_formal_parameters] = STATE(840),
    [sym_array] = STATE(761),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [sym_identifier] = ACTIONS(1550),
    [sym_false] = ACTIONS(462),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1552),
    [anon_sym_number] = ACTIONS(1552),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_void] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_any] = ACTIONS(1552),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1552),
    [anon_sym_async] = ACTIONS(1426),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_this] = ACTIONS(1562),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_string] = ACTIONS(1552),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [278] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [279] = {
    [aux_sym_implements_clause_repeat1] = STATE(846),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(1572),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [sym_formal_parameters] = STATE(847),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(1579),
  },
  [282] = {
    [aux_sym_type_parameters_repeat1] = STATE(853),
    [anon_sym_COMMA] = ACTIONS(1581),
    [anon_sym_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [anon_sym_DOT] = ACTIONS(1479),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_identifier] = ACTIONS(1585),
    [anon_sym_BQUOTE] = ACTIONS(1587),
    [anon_sym_debugger] = ACTIONS(1585),
    [anon_sym_symbol] = ACTIONS(1585),
    [anon_sym_AT] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_EQ] = ACTIONS(1585),
    [anon_sym_void] = ACTIONS(1585),
    [anon_sym_break] = ACTIONS(1585),
    [anon_sym_const] = ACTIONS(1585),
    [sym_super] = ACTIONS(1585),
    [anon_sym_return] = ACTIONS(1585),
    [anon_sym_private] = ACTIONS(1585),
    [anon_sym_get] = ACTIONS(1585),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_interface] = ACTIONS(1585),
    [anon_sym_default] = ACTIONS(1585),
    [anon_sym_enum] = ACTIONS(1585),
    [anon_sym_delete] = ACTIONS(1585),
    [anon_sym_continue] = ACTIONS(1585),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_if] = ACTIONS(1585),
    [anon_sym_this] = ACTIONS(1585),
    [anon_sym_yield] = ACTIONS(1585),
    [sym_true] = ACTIONS(1585),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_protected] = ACTIONS(1585),
    [anon_sym_abstract] = ACTIONS(1585),
    [anon_sym_set] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(1585),
    [anon_sym_import] = ACTIONS(1585),
    [anon_sym_namespace] = ACTIONS(1585),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_await] = ACTIONS(1585),
    [anon_sym_DQUOTE] = ACTIONS(1587),
    [anon_sym_else] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_for] = ACTIONS(1585),
    [anon_sym_LBRACK] = ACTIONS(1589),
    [sym_false] = ACTIONS(1585),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_case] = ACTIONS(1585),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_number] = ACTIONS(1585),
    [anon_sym_class] = ACTIONS(1585),
    [anon_sym_declare] = ACTIONS(1585),
    [anon_sym_typeof] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(1587),
    [anon_sym_switch] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_RBRACK] = ACTIONS(1587),
    [sym_null] = ACTIONS(1585),
    [anon_sym_GT] = ACTIONS(1587),
    [anon_sym_any] = ACTIONS(1585),
    [anon_sym_boolean] = ACTIONS(1585),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_public] = ACTIONS(1585),
    [anon_sym_EQ_GT] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_var] = ACTIONS(1585),
    [anon_sym_while] = ACTIONS(1585),
    [anon_sym_SQUOTE] = ACTIONS(1587),
    [anon_sym_try] = ACTIONS(1585),
    [anon_sym_RPAREN] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1587),
    [sym_number] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1585),
    [anon_sym_function] = ACTIONS(1585),
    [sym_undefined] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(1585),
    [ts_builtin_sym_end] = ACTIONS(1587),
    [anon_sym_let] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_export] = ACTIONS(1585),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_with] = ACTIONS(1585),
  },
  [285] = {
    [anon_sym_EQ_GT] = ACTIONS(1591),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [anon_sym_SLASH2] = ACTIONS(1593),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_call_signature] = STATE(857),
    [sym_formal_parameters] = STATE(858),
    [sym_type_parameters] = STATE(859),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [288] = {
    [sym_call_signature] = STATE(861),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_statement_block] = STATE(862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(901),
  },
  [290] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_COLON] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(570),
  },
  [291] = {
    [sym_formal_parameters] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(868),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [293] = {
    [sym_arguments] = STATE(868),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1599),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1599),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [294] = {
    [anon_sym_target] = ACTIONS(1607),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [296] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1615),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1615),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1623),
    [sym_true] = ACTIONS(1615),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [297] = {
    [sym_new_expression] = STATE(882),
    [sym_augmented_assignment_expression] = STATE(882),
    [sym_unary_expression] = STATE(882),
    [sym_update_expression] = STATE(882),
    [sym_regex] = STATE(882),
    [sym_meta_property] = STATE(882),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(882),
    [sym_yield_expression] = STATE(882),
    [sym_as_expression] = STATE(882),
    [sym_non_null_expression] = STATE(882),
    [sym_internal_module] = STATE(882),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(882),
    [sym_await_expression] = STATE(882),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(882),
    [sym_this] = STATE(882),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(882),
    [sym_generator_function] = STATE(882),
    [sym_call_expression] = STATE(882),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(882),
    [sym_ternary_expression] = STATE(882),
    [sym_binary_expression] = STATE(882),
    [sym_template_string] = STATE(882),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(882),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(882),
    [sym_class] = STATE(882),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1629),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1629),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1631),
    [sym_true] = ACTIONS(1629),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1629),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [298] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(870),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [299] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [300] = {
    [sym_call_signature] = STATE(253),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(442),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(442),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(442),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(442),
    [anon_sym_type] = ACTIONS(442),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(442),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(442),
    [anon_sym_declare] = ACTIONS(442),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(442),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(442),
    [anon_sym_async] = ACTIONS(442),
    [anon_sym_public] = ACTIONS(442),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(442),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [301] = {
    [sym_new_expression] = STATE(883),
    [sym_augmented_assignment_expression] = STATE(883),
    [sym_unary_expression] = STATE(883),
    [sym_update_expression] = STATE(883),
    [sym_regex] = STATE(883),
    [sym_meta_property] = STATE(883),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(883),
    [sym_yield_expression] = STATE(883),
    [sym_as_expression] = STATE(883),
    [sym_non_null_expression] = STATE(883),
    [sym_internal_module] = STATE(883),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(883),
    [sym_await_expression] = STATE(883),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(883),
    [sym_this] = STATE(883),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(883),
    [sym_generator_function] = STATE(883),
    [sym_call_expression] = STATE(883),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(883),
    [sym_ternary_expression] = STATE(883),
    [sym_binary_expression] = STATE(883),
    [sym_template_string] = STATE(883),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(883),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(883),
    [sym_class] = STATE(883),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1633),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1635),
    [sym_true] = ACTIONS(1633),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [302] = {
    [sym_new_expression] = STATE(555),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(555),
    [sym_meta_property] = STATE(555),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(555),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(555),
    [sym_this] = STATE(555),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(555),
    [sym_generator_function] = STATE(555),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(555),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(555),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(555),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1637),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(514),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1637),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(1639),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1637),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [303] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [304] = {
    [sym_new_expression] = STATE(555),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(555),
    [sym_meta_property] = STATE(555),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(555),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(555),
    [sym_this] = STATE(555),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(555),
    [sym_generator_function] = STATE(555),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(555),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(555),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(555),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1637),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1637),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [305] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_in] = ACTIONS(1643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1649),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_GT_GT_GT] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1653),
    [anon_sym_BANG_EQ] = ACTIONS(1643),
    [anon_sym_LT_EQ] = ACTIONS(1641),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1655),
    [anon_sym_PERCENT] = ACTIONS(1647),
    [anon_sym_QMARK] = ACTIONS(1657),
    [anon_sym_PIPE_PIPE] = ACTIONS(1659),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1643),
    [anon_sym_instanceof] = ACTIONS(1641),
    [anon_sym_LT] = ACTIONS(1663),
    [anon_sym_SLASH] = ACTIONS(1651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1659),
    [anon_sym_STAR_STAR] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1651),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [306] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(868),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(1599),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1599),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1599),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [307] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(868),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [308] = {
    [sym__initializer] = STATE(577),
    [sym_arguments] = STATE(868),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1599),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1599),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [309] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [310] = {
    [sym__initializer] = STATE(580),
    [sym_arguments] = STATE(868),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1599),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1599),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [311] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(310),
  },
  [312] = {
    [sym__from_clause] = STATE(892),
    [anon_sym_from] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym__import_export_specifier] = STATE(895),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_RBRACE] = ACTIONS(1667),
    [anon_sym_typeof] = ACTIONS(887),
    [anon_sym_COMMA] = ACTIONS(1669),
    [anon_sym_type] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_new_expression] = STATE(360),
    [sym_augmented_assignment_expression] = STATE(360),
    [sym_unary_expression] = STATE(360),
    [sym_update_expression] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_meta_property] = STATE(360),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(360),
    [sym_yield_expression] = STATE(360),
    [sym_as_expression] = STATE(360),
    [sym_non_null_expression] = STATE(360),
    [sym_internal_module] = STATE(360),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(360),
    [sym_await_expression] = STATE(360),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(360),
    [sym_this] = STATE(360),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(360),
    [sym_generator_function] = STATE(360),
    [sym_call_expression] = STATE(360),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(360),
    [sym_ternary_expression] = STATE(360),
    [sym_binary_expression] = STATE(360),
    [sym_template_string] = STATE(360),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(360),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(360),
    [sym_class] = STATE(360),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(1671),
    [sym_false] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(630),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(632),
    [sym_true] = ACTIONS(630),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(630),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [315] = {
    [sym_new_expression] = STATE(909),
    [sym_augmented_assignment_expression] = STATE(909),
    [sym_unary_expression] = STATE(909),
    [sym_update_expression] = STATE(909),
    [sym_regex] = STATE(909),
    [sym_meta_property] = STATE(909),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(909),
    [sym_yield_expression] = STATE(909),
    [sym_as_expression] = STATE(909),
    [sym_non_null_expression] = STATE(909),
    [sym_internal_module] = STATE(909),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(909),
    [sym_await_expression] = STATE(909),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(909),
    [sym_this] = STATE(909),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(909),
    [sym_generator_function] = STATE(909),
    [sym_call_expression] = STATE(909),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(909),
    [sym_ternary_expression] = STATE(909),
    [sym_binary_expression] = STATE(909),
    [sym_template_string] = STATE(909),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(909),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(909),
    [sym_class] = STATE(909),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1677),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(1691),
    [sym_true] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1677),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [316] = {
    [anon_sym_namespace] = ACTIONS(1701),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_debugger] = ACTIONS(1703),
    [anon_sym_symbol] = ACTIONS(1703),
    [anon_sym_AT] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1703),
    [anon_sym_void] = ACTIONS(1703),
    [anon_sym_break] = ACTIONS(1703),
    [anon_sym_const] = ACTIONS(1703),
    [sym_super] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(1703),
    [anon_sym_private] = ACTIONS(1703),
    [anon_sym_get] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_interface] = ACTIONS(1703),
    [anon_sym_default] = ACTIONS(1703),
    [anon_sym_enum] = ACTIONS(1703),
    [anon_sym_delete] = ACTIONS(1703),
    [anon_sym_continue] = ACTIONS(1703),
    [anon_sym_DASH_DASH] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_this] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(1703),
    [sym_true] = ACTIONS(1703),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_protected] = ACTIONS(1703),
    [anon_sym_abstract] = ACTIONS(1703),
    [anon_sym_set] = ACTIONS(1703),
    [anon_sym_type] = ACTIONS(1703),
    [anon_sym_import] = ACTIONS(1703),
    [anon_sym_namespace] = ACTIONS(1703),
    [anon_sym_PLUS_PLUS] = ACTIONS(1705),
    [anon_sym_await] = ACTIONS(1703),
    [anon_sym_DQUOTE] = ACTIONS(1705),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1705),
    [anon_sym_for] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [sym_false] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_case] = ACTIONS(1703),
    [anon_sym_module] = ACTIONS(1703),
    [anon_sym_number] = ACTIONS(1703),
    [anon_sym_class] = ACTIONS(1703),
    [anon_sym_declare] = ACTIONS(1703),
    [anon_sym_typeof] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1705),
    [anon_sym_switch] = ACTIONS(1703),
    [anon_sym_LPAREN] = ACTIONS(1705),
    [sym_null] = ACTIONS(1703),
    [anon_sym_any] = ACTIONS(1703),
    [anon_sym_boolean] = ACTIONS(1703),
    [anon_sym_async] = ACTIONS(1703),
    [anon_sym_public] = ACTIONS(1703),
    [anon_sym_var] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_SQUOTE] = ACTIONS(1705),
    [anon_sym_try] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1705),
    [sym_number] = ACTIONS(1705),
    [anon_sym_SLASH] = ACTIONS(1703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1703),
    [anon_sym_function] = ACTIONS(1703),
    [sym_undefined] = ACTIONS(1703),
    [anon_sym_new] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1705),
    [anon_sym_let] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_TILDE] = ACTIONS(1705),
    [anon_sym_with] = ACTIONS(1703),
  },
  [318] = {
    [sym__from_clause] = STATE(892),
    [sym__automatic_semicolon] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1709),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [320] = {
    [sym_parenthesized_expression] = STATE(917),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [anon_sym_class] = ACTIONS(1711),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [anon_sym_await] = ACTIONS(1713),
    [anon_sym_LPAREN] = ACTIONS(1715),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_string] = STATE(172),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(308),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [324] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(928),
    [sym__declaration] = STATE(192),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(928),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(322),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(1717),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1721),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1731),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [325] = {
    [sym_parenthesized_expression] = STATE(929),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(928),
    [sym__declaration] = STATE(317),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(928),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_as] = ACTIONS(541),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(1717),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1733),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1731),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [327] = {
    [sym_parenthesized_expression] = STATE(931),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [anon_sym_while] = ACTIONS(1735),
    [sym_comment] = ACTIONS(3),
  },
  [329] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(568),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [330] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(568),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [331] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(1737),
    [anon_sym_class] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [sym_type_alias_declaration] = STATE(934),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(934),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(934),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(934),
    [sym_return_statement] = STATE(934),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(934),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(934),
    [sym_switch_statement] = STATE(934),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(934),
    [sym_throw_statement] = STATE(934),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(934),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(934),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(934),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(934),
    [sym_abstract_class] = STATE(934),
    [sym_interface_declaration] = STATE(934),
    [sym_statement_block] = STATE(934),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(934),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(934),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(934),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(934),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(934),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(934),
    [sym_empty_statement] = STATE(934),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(934),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(934),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(934),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(934),
    [sym_break_statement] = STATE(934),
    [sym_labeled_statement] = STATE(934),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(934),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [333] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(1739),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [334] = {
    [sym_type_alias_declaration] = STATE(334),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(334),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(334),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(334),
    [sym_return_statement] = STATE(334),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(334),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(334),
    [sym_switch_statement] = STATE(334),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(334),
    [sym_throw_statement] = STATE(334),
    [aux_sym_program_repeat1] = STATE(334),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(334),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(334),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(334),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(334),
    [sym_abstract_class] = STATE(334),
    [sym_interface_declaration] = STATE(334),
    [sym_statement_block] = STATE(334),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(334),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(334),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(334),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(334),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(334),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(334),
    [sym_empty_statement] = STATE(334),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(334),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(334),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(334),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(334),
    [sym_break_statement] = STATE(334),
    [sym_labeled_statement] = STATE(334),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(334),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [anon_sym_debugger] = ACTIONS(1747),
    [anon_sym_symbol] = ACTIONS(1750),
    [anon_sym_AT] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(1756),
    [anon_sym_void] = ACTIONS(1759),
    [anon_sym_break] = ACTIONS(1762),
    [anon_sym_const] = ACTIONS(1765),
    [sym_super] = ACTIONS(1768),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_private] = ACTIONS(1750),
    [anon_sym_get] = ACTIONS(1750),
    [anon_sym_interface] = ACTIONS(1774),
    [anon_sym_enum] = ACTIONS(1777),
    [anon_sym_delete] = ACTIONS(1780),
    [anon_sym_continue] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1786),
    [anon_sym_if] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1792),
    [anon_sym_yield] = ACTIONS(1795),
    [sym_true] = ACTIONS(1798),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_protected] = ACTIONS(1750),
    [anon_sym_abstract] = ACTIONS(1804),
    [anon_sym_set] = ACTIONS(1750),
    [anon_sym_type] = ACTIONS(1807),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_namespace] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1786),
    [anon_sym_await] = ACTIONS(1816),
    [anon_sym_DQUOTE] = ACTIONS(1819),
    [anon_sym_BANG] = ACTIONS(1822),
    [anon_sym_for] = ACTIONS(1825),
    [anon_sym_LBRACK] = ACTIONS(1828),
    [sym_false] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(1831),
    [anon_sym_module] = ACTIONS(1834),
    [anon_sym_number] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(1837),
    [anon_sym_declare] = ACTIONS(1840),
    [anon_sym_typeof] = ACTIONS(1780),
    [anon_sym_LBRACE] = ACTIONS(1843),
    [anon_sym_switch] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [sym_null] = ACTIONS(1798),
    [anon_sym_any] = ACTIONS(1750),
    [anon_sym_boolean] = ACTIONS(1750),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_public] = ACTIONS(1750),
    [anon_sym_var] = ACTIONS(1855),
    [anon_sym_while] = ACTIONS(1858),
    [anon_sym_SQUOTE] = ACTIONS(1861),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_LT] = ACTIONS(1867),
    [sym_number] = ACTIONS(1870),
    [anon_sym_SLASH] = ACTIONS(1873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1750),
    [anon_sym_function] = ACTIONS(1876),
    [sym_undefined] = ACTIONS(1798),
    [anon_sym_new] = ACTIONS(1879),
    [ts_builtin_sym_end] = ACTIONS(1882),
    [anon_sym_let] = ACTIONS(1884),
    [anon_sym_PLUS] = ACTIONS(1756),
    [anon_sym_export] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1890),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_with] = ACTIONS(1893),
  },
  [335] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1896),
    [anon_sym_LBRACK] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1898),
    [anon_sym_SEMI] = ACTIONS(1896),
    [anon_sym_BQUOTE] = ACTIONS(1896),
    [sym__automatic_semicolon] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_COMMA] = ACTIONS(1896),
    [anon_sym_LT_LT] = ACTIONS(1896),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT_GT] = ACTIONS(1896),
    [anon_sym_AMP_AMP] = ACTIONS(1896),
    [anon_sym_DASH] = ACTIONS(1898),
    [anon_sym_BANG_EQ] = ACTIONS(1898),
    [anon_sym_LT_EQ] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1896),
    [anon_sym_GT_EQ] = ACTIONS(1896),
    [anon_sym_GT] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1896),
    [anon_sym_QMARK] = ACTIONS(1896),
    [anon_sym_RBRACE] = ACTIONS(1896),
    [anon_sym_as] = ACTIONS(1896),
    [anon_sym_PIPE_PIPE] = ACTIONS(1896),
    [anon_sym_DASH_DASH] = ACTIONS(1896),
    [anon_sym_EQ_EQ] = ACTIONS(1898),
    [anon_sym_instanceof] = ACTIONS(1896),
    [anon_sym_LT] = ACTIONS(1898),
    [anon_sym_RPAREN] = ACTIONS(1896),
    [anon_sym_SLASH] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1896),
    [anon_sym_CARET] = ACTIONS(1896),
    [anon_sym_STAR_STAR] = ACTIONS(1896),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1898),
    [anon_sym_PLUS_PLUS] = ACTIONS(1896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1896),
    [anon_sym_in] = ACTIONS(1898),
  },
  [336] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(941),
    [sym_constructor_type] = STATE(941),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(941),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(941),
    [sym_intersection_type] = STATE(941),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(942),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(944),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [337] = {
    [anon_sym_EQ_GT] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1739),
  },
  [338] = {
    [sym_identifier] = ACTIONS(1910),
    [anon_sym_BQUOTE] = ACTIONS(1912),
    [anon_sym_debugger] = ACTIONS(1910),
    [anon_sym_symbol] = ACTIONS(1910),
    [anon_sym_AT] = ACTIONS(1912),
    [anon_sym_DASH] = ACTIONS(1910),
    [anon_sym_void] = ACTIONS(1910),
    [anon_sym_break] = ACTIONS(1910),
    [anon_sym_const] = ACTIONS(1910),
    [sym_super] = ACTIONS(1910),
    [anon_sym_return] = ACTIONS(1910),
    [anon_sym_private] = ACTIONS(1910),
    [anon_sym_get] = ACTIONS(1910),
    [anon_sym_RBRACE] = ACTIONS(1912),
    [anon_sym_interface] = ACTIONS(1910),
    [anon_sym_default] = ACTIONS(1910),
    [anon_sym_enum] = ACTIONS(1910),
    [anon_sym_delete] = ACTIONS(1910),
    [anon_sym_continue] = ACTIONS(1910),
    [anon_sym_DASH_DASH] = ACTIONS(1912),
    [anon_sym_if] = ACTIONS(1910),
    [anon_sym_this] = ACTIONS(1910),
    [anon_sym_yield] = ACTIONS(1910),
    [sym_true] = ACTIONS(1910),
    [anon_sym_throw] = ACTIONS(1910),
    [anon_sym_protected] = ACTIONS(1910),
    [anon_sym_abstract] = ACTIONS(1910),
    [anon_sym_set] = ACTIONS(1910),
    [anon_sym_type] = ACTIONS(1910),
    [anon_sym_import] = ACTIONS(1910),
    [anon_sym_namespace] = ACTIONS(1910),
    [anon_sym_PLUS_PLUS] = ACTIONS(1912),
    [anon_sym_await] = ACTIONS(1910),
    [anon_sym_DQUOTE] = ACTIONS(1912),
    [anon_sym_else] = ACTIONS(1910),
    [anon_sym_BANG] = ACTIONS(1912),
    [anon_sym_for] = ACTIONS(1910),
    [anon_sym_LBRACK] = ACTIONS(1912),
    [sym_false] = ACTIONS(1910),
    [anon_sym_SEMI] = ACTIONS(1912),
    [anon_sym_case] = ACTIONS(1910),
    [anon_sym_module] = ACTIONS(1910),
    [anon_sym_number] = ACTIONS(1910),
    [anon_sym_class] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1910),
    [anon_sym_typeof] = ACTIONS(1910),
    [anon_sym_LBRACE] = ACTIONS(1912),
    [anon_sym_switch] = ACTIONS(1910),
    [anon_sym_LPAREN] = ACTIONS(1912),
    [sym_null] = ACTIONS(1910),
    [anon_sym_any] = ACTIONS(1910),
    [anon_sym_boolean] = ACTIONS(1910),
    [anon_sym_async] = ACTIONS(1910),
    [anon_sym_public] = ACTIONS(1910),
    [anon_sym_var] = ACTIONS(1910),
    [anon_sym_while] = ACTIONS(1910),
    [anon_sym_SQUOTE] = ACTIONS(1912),
    [anon_sym_try] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(1912),
    [anon_sym_LT] = ACTIONS(1912),
    [sym_number] = ACTIONS(1912),
    [anon_sym_SLASH] = ACTIONS(1910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1910),
    [anon_sym_function] = ACTIONS(1910),
    [sym_undefined] = ACTIONS(1910),
    [anon_sym_new] = ACTIONS(1910),
    [ts_builtin_sym_end] = ACTIONS(1912),
    [anon_sym_let] = ACTIONS(1910),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_export] = ACTIONS(1910),
    [anon_sym_do] = ACTIONS(1910),
    [anon_sym_TILDE] = ACTIONS(1912),
    [anon_sym_with] = ACTIONS(1910),
  },
  [339] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1914),
    [anon_sym_LBRACK] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [sym__automatic_semicolon] = ACTIONS(1914),
    [anon_sym_PIPE] = ACTIONS(1916),
    [anon_sym_COMMA] = ACTIONS(1914),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_GT_GT_GT] = ACTIONS(1914),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_BANG_EQ] = ACTIONS(1916),
    [anon_sym_LT_EQ] = ACTIONS(1914),
    [anon_sym_LPAREN] = ACTIONS(1914),
    [anon_sym_GT_EQ] = ACTIONS(1914),
    [anon_sym_GT] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym_PERCENT] = ACTIONS(1914),
    [anon_sym_QMARK] = ACTIONS(1914),
    [anon_sym_RBRACE] = ACTIONS(1914),
    [anon_sym_as] = ACTIONS(1914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [anon_sym_DASH_DASH] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(1916),
    [anon_sym_instanceof] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_RPAREN] = ACTIONS(1914),
    [anon_sym_SLASH] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1914),
    [anon_sym_CARET] = ACTIONS(1914),
    [anon_sym_STAR_STAR] = ACTIONS(1914),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_PLUS_PLUS] = ACTIONS(1914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1914),
    [anon_sym_in] = ACTIONS(1916),
  },
  [340] = {
    [sym_new_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_unary_expression] = STATE(945),
    [sym_update_expression] = STATE(945),
    [sym_regex] = STATE(945),
    [sym_meta_property] = STATE(945),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(945),
    [sym_yield_expression] = STATE(945),
    [sym_as_expression] = STATE(945),
    [sym_non_null_expression] = STATE(945),
    [sym_internal_module] = STATE(945),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(945),
    [sym_await_expression] = STATE(945),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(945),
    [sym_this] = STATE(945),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(945),
    [sym_generator_function] = STATE(945),
    [sym_call_expression] = STATE(945),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(945),
    [sym_ternary_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_template_string] = STATE(945),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(945),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(945),
    [sym_class] = STATE(945),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1918),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1918),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(1920),
    [sym_true] = ACTIONS(1918),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1918),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [341] = {
    [sym_new_expression] = STATE(946),
    [sym_augmented_assignment_expression] = STATE(946),
    [sym_unary_expression] = STATE(946),
    [sym_update_expression] = STATE(946),
    [sym_regex] = STATE(946),
    [sym_meta_property] = STATE(946),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(946),
    [sym_yield_expression] = STATE(946),
    [sym_as_expression] = STATE(946),
    [sym_non_null_expression] = STATE(946),
    [sym_internal_module] = STATE(946),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(946),
    [sym_await_expression] = STATE(946),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(946),
    [sym_this] = STATE(946),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(946),
    [sym_generator_function] = STATE(946),
    [sym_call_expression] = STATE(946),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(946),
    [sym_ternary_expression] = STATE(946),
    [sym_binary_expression] = STATE(946),
    [sym_template_string] = STATE(946),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(946),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(946),
    [sym_class] = STATE(946),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1922),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1922),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(1924),
    [sym_true] = ACTIONS(1922),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1922),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [342] = {
    [sym_new_expression] = STATE(947),
    [sym_augmented_assignment_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym_update_expression] = STATE(947),
    [sym_regex] = STATE(947),
    [sym_meta_property] = STATE(947),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(947),
    [sym_yield_expression] = STATE(947),
    [sym_as_expression] = STATE(947),
    [sym_non_null_expression] = STATE(947),
    [sym_internal_module] = STATE(947),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(947),
    [sym_await_expression] = STATE(947),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(947),
    [sym_this] = STATE(947),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(947),
    [sym_generator_function] = STATE(947),
    [sym_call_expression] = STATE(947),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(947),
    [sym_ternary_expression] = STATE(947),
    [sym_binary_expression] = STATE(947),
    [sym_template_string] = STATE(947),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(947),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(947),
    [sym_class] = STATE(947),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1926),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1926),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(1928),
    [sym_true] = ACTIONS(1926),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1926),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [343] = {
    [sym_new_expression] = STATE(948),
    [sym_augmented_assignment_expression] = STATE(948),
    [sym_unary_expression] = STATE(948),
    [sym_update_expression] = STATE(948),
    [sym_regex] = STATE(948),
    [sym_meta_property] = STATE(948),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(948),
    [sym_yield_expression] = STATE(948),
    [sym_as_expression] = STATE(948),
    [sym_non_null_expression] = STATE(948),
    [sym_internal_module] = STATE(948),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(948),
    [sym_await_expression] = STATE(948),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(948),
    [sym_this] = STATE(948),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(948),
    [sym_generator_function] = STATE(948),
    [sym_call_expression] = STATE(948),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(948),
    [sym_ternary_expression] = STATE(948),
    [sym_binary_expression] = STATE(948),
    [sym_template_string] = STATE(948),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(948),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(948),
    [sym_class] = STATE(948),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1930),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1930),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [344] = {
    [sym_new_expression] = STATE(949),
    [sym_augmented_assignment_expression] = STATE(949),
    [sym_unary_expression] = STATE(949),
    [sym_update_expression] = STATE(949),
    [sym_regex] = STATE(949),
    [sym_meta_property] = STATE(949),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(949),
    [sym_yield_expression] = STATE(949),
    [sym_as_expression] = STATE(949),
    [sym_non_null_expression] = STATE(949),
    [sym_internal_module] = STATE(949),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(949),
    [sym_await_expression] = STATE(949),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(950),
    [sym_string] = STATE(949),
    [sym_this] = STATE(949),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(949),
    [sym_generator_function] = STATE(949),
    [sym_call_expression] = STATE(949),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(949),
    [sym_ternary_expression] = STATE(949),
    [sym_binary_expression] = STATE(949),
    [sym_template_string] = STATE(949),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(949),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(949),
    [sym_class] = STATE(949),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1934),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1934),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(1936),
    [sym_true] = ACTIONS(1934),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1934),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [345] = {
    [sym_new_expression] = STATE(963),
    [sym_augmented_assignment_expression] = STATE(963),
    [sym_unary_expression] = STATE(963),
    [sym_update_expression] = STATE(963),
    [sym_regex] = STATE(963),
    [sym_meta_property] = STATE(963),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(963),
    [sym_yield_expression] = STATE(963),
    [sym_as_expression] = STATE(963),
    [sym_non_null_expression] = STATE(963),
    [sym_internal_module] = STATE(963),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(963),
    [sym_await_expression] = STATE(963),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(963),
    [sym_this] = STATE(963),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(963),
    [sym_generator_function] = STATE(963),
    [sym_call_expression] = STATE(963),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(963),
    [sym_ternary_expression] = STATE(963),
    [sym_binary_expression] = STATE(963),
    [sym_template_string] = STATE(963),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(963),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(963),
    [sym_class] = STATE(963),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1942),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1956),
    [sym_true] = ACTIONS(1942),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [346] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(983),
    [sym_constructor_type] = STATE(983),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(983),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_template_string] = STATE(987),
    [sym_union_type] = STATE(983),
    [sym_intersection_type] = STATE(983),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_keyof] = ACTIONS(1976),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_boolean] = ACTIONS(1972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1994),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [347] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [sym__automatic_semicolon] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(831),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(831),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [348] = {
    [sym_new_expression] = STATE(358),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(358),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(358),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(358),
    [sym_call_signature] = STATE(51),
    [sym_yield_expression] = STATE(358),
    [sym_as_expression] = STATE(358),
    [sym_internal_module] = STATE(358),
    [sym_arrow_function] = STATE(358),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(53),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(991),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(56),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(358),
    [sym_subscript_expression] = STATE(53),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(358),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(358),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(358),
    [sym_meta_property] = STATE(358),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(358),
    [sym_non_null_expression] = STATE(358),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(358),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(358),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_anonymous_class] = STATE(358),
    [sym_call_expression] = STATE(358),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(358),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(358),
    [sym_type_arguments] = STATE(63),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(358),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(358),
    [sym_class] = STATE(358),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(2000),
    [sym_false] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(2006),
    [anon_sym_number] = ACTIONS(2006),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [sym_null] = ACTIONS(622),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2006),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(2006),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(2018),
    [sym_number] = ACTIONS(2020),
    [sym_true] = ACTIONS(2002),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(2006),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(622),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(2022),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [349] = {
    [sym_new_expression] = STATE(1003),
    [sym_augmented_assignment_expression] = STATE(1003),
    [sym_unary_expression] = STATE(1003),
    [sym_update_expression] = STATE(1003),
    [sym_regex] = STATE(1003),
    [sym_meta_property] = STATE(1003),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(1003),
    [sym_yield_expression] = STATE(1003),
    [sym_as_expression] = STATE(1003),
    [sym_non_null_expression] = STATE(1003),
    [sym_internal_module] = STATE(1003),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1003),
    [sym_await_expression] = STATE(1003),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(1003),
    [sym_this] = STATE(1003),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(1003),
    [sym_generator_function] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(1003),
    [sym_ternary_expression] = STATE(1003),
    [sym_binary_expression] = STATE(1003),
    [sym_template_string] = STATE(1003),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(1003),
    [sym_class] = STATE(1003),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(2024),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(2024),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(2026),
    [sym_true] = ACTIONS(2024),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(2024),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [350] = {
    [sym_type_alias_declaration] = STATE(915),
    [aux_sym_export_statement_repeat1] = STATE(191),
    [sym__declaration] = STATE(915),
    [sym_ambient_declaration] = STATE(915),
    [sym_import_alias] = STATE(915),
    [sym_export_statement] = STATE(915),
    [sym_generator_function] = STATE(915),
    [sym_lexical_declaration] = STATE(915),
    [sym_internal_module] = STATE(915),
    [sym_decorator] = STATE(191),
    [sym_enum_declaration] = STATE(915),
    [sym_function] = STATE(915),
    [sym_function_signature] = STATE(915),
    [sym_variable_declaration] = STATE(915),
    [sym_abstract_class] = STATE(915),
    [sym_module] = STATE(915),
    [sym_interface_declaration] = STATE(915),
    [sym_class] = STATE(915),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(352),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [351] = {
    [sym_class_heritage] = STATE(1006),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(635),
    [anon_sym_extends] = ACTIONS(314),
    [anon_sym_implements] = ACTIONS(316),
    [sym_identifier] = ACTIONS(2030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [352] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_export] = ACTIONS(2032),
    [anon_sym_class] = ACTIONS(2032),
    [anon_sym_AT] = ACTIONS(2034),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(2039),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_BQUOTE] = ACTIONS(2037),
    [sym__automatic_semicolon] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(2037),
    [anon_sym_LT_LT] = ACTIONS(2037),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_GT_GT_GT] = ACTIONS(2037),
    [anon_sym_AMP_AMP] = ACTIONS(2037),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_BANG_EQ] = ACTIONS(2039),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2037),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_as] = ACTIONS(2037),
    [anon_sym_PIPE_PIPE] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_EQ_EQ] = ACTIONS(2039),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2039),
    [anon_sym_RPAREN] = ACTIONS(2037),
    [anon_sym_SLASH] = ACTIONS(2039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2037),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_GT_GT] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_in] = ACTIONS(2039),
  },
  [354] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2041),
    [anon_sym_LBRACK] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2041),
    [anon_sym_BQUOTE] = ACTIONS(2041),
    [sym__automatic_semicolon] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_AMP_AMP] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2043),
    [anon_sym_LT_EQ] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(2041),
    [anon_sym_GT_EQ] = ACTIONS(2041),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2041),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_as] = ACTIONS(2041),
    [anon_sym_PIPE_PIPE] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_instanceof] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_RPAREN] = ACTIONS(2041),
    [anon_sym_SLASH] = ACTIONS(2043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_GT_GT] = ACTIONS(2043),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2041),
    [anon_sym_in] = ACTIONS(2043),
  },
  [355] = {
    [sym_type_alias_declaration] = STATE(1007),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(1007),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(1007),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(1007),
    [sym_return_statement] = STATE(1007),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_accessibility_modifier] = STATE(218),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(1007),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(1007),
    [sym_spread_element] = STATE(219),
    [sym_switch_statement] = STATE(1007),
    [sym_string] = STATE(215),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(1007),
    [sym_throw_statement] = STATE(1007),
    [aux_sym_program_repeat1] = STATE(1007),
    [sym__property_name] = STATE(221),
    [sym_object] = STATE(222),
    [aux_sym_object_repeat1] = STATE(223),
    [sym_ambient_declaration] = STATE(1007),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(1007),
    [sym_decorator] = STATE(224),
    [sym_continue_statement] = STATE(1007),
    [sym_formal_parameters] = STATE(57),
    [sym_computed_property_name] = STATE(221),
    [sym_function_signature] = STATE(1007),
    [sym_abstract_class] = STATE(1007),
    [sym_interface_declaration] = STATE(1007),
    [sym_statement_block] = STATE(1007),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(1007),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(1007),
    [sym_method_definition] = STATE(219),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(1007),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(1007),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(1007),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(1007),
    [sym_empty_statement] = STATE(1007),
    [sym_pair] = STATE(219),
    [aux_sym_export_statement_repeat1] = STATE(224),
    [sym_assignment_pattern] = STATE(219),
    [sym_import_alias] = STATE(1007),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(1007),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(1007),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_labeled_statement] = STATE(1007),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(225),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(1007),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(356),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(362),
    [anon_sym_void] = ACTIONS(364),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(366),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_get] = ACTIONS(370),
    [anon_sym_RBRACE] = ACTIONS(718),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(366),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(370),
    [anon_sym_type] = ACTIONS(376),
    [anon_sym_import] = ACTIONS(378),
    [anon_sym_namespace] = ACTIONS(380),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(386),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(388),
    [anon_sym_number] = ACTIONS(356),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(390),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(356),
    [anon_sym_boolean] = ACTIONS(356),
    [anon_sym_async] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(366),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(398),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(356),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [356] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_BANG] = ACTIONS(2047),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_BQUOTE] = ACTIONS(2045),
    [sym__automatic_semicolon] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(2047),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2045),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_GT_GT_GT] = ACTIONS(2045),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2047),
    [anon_sym_BANG_EQ] = ACTIONS(2047),
    [anon_sym_LT_EQ] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(2045),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_GT] = ACTIONS(2047),
    [anon_sym_AMP] = ACTIONS(2047),
    [anon_sym_PERCENT] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_as] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_EQ_EQ] = ACTIONS(2047),
    [anon_sym_instanceof] = ACTIONS(2045),
    [anon_sym_LT] = ACTIONS(2047),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2047),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_in] = ACTIONS(2047),
  },
  [357] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [358] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [359] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [360] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2055),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [361] = {
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_BQUOTE] = ACTIONS(2059),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2059),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_this] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2059),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2059),
    [sym_false] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2059),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2059),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2059),
    [sym_null] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2059),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2059),
    [sym_number] = ACTIONS(2059),
    [anon_sym_SLASH] = ACTIONS(2057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [ts_builtin_sym_end] = ACTIONS(2059),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_with] = ACTIONS(2057),
  },
  [362] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2063),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2063),
  },
  [363] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_AMP_EQ] = ACTIONS(2065),
    [anon_sym_PLUS_EQ] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2065),
    [anon_sym_STAR_EQ] = ACTIONS(2065),
    [anon_sym_PIPE_EQ] = ACTIONS(2065),
    [anon_sym_DASH_EQ] = ACTIONS(2065),
    [anon_sym_EQ_GT] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [364] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_AMP_EQ] = ACTIONS(2073),
    [anon_sym_PLUS_EQ] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2073),
    [anon_sym_STAR_EQ] = ACTIONS(2073),
    [anon_sym_PIPE_EQ] = ACTIONS(2073),
    [anon_sym_DASH_EQ] = ACTIONS(2073),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [365] = {
    [sym_new_expression] = STATE(1014),
    [sym_augmented_assignment_expression] = STATE(1014),
    [sym_unary_expression] = STATE(1014),
    [sym_update_expression] = STATE(1014),
    [sym_regex] = STATE(1014),
    [sym_meta_property] = STATE(1014),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1014),
    [sym_yield_expression] = STATE(1014),
    [sym_as_expression] = STATE(1014),
    [sym_non_null_expression] = STATE(1014),
    [sym_internal_module] = STATE(1014),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1014),
    [sym_await_expression] = STATE(1014),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1014),
    [sym_this] = STATE(1014),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1014),
    [sym_generator_function] = STATE(1014),
    [sym_call_expression] = STATE(1014),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1014),
    [sym_ternary_expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_template_string] = STATE(1014),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1014),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1014),
    [sym_class] = STATE(1014),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2077),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2079),
    [sym_true] = ACTIONS(2077),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2077),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [366] = {
    [sym_new_expression] = STATE(1015),
    [sym_augmented_assignment_expression] = STATE(1015),
    [sym_unary_expression] = STATE(1015),
    [sym_update_expression] = STATE(1015),
    [sym_regex] = STATE(1015),
    [sym_meta_property] = STATE(1015),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1015),
    [sym_yield_expression] = STATE(1015),
    [sym_as_expression] = STATE(1015),
    [sym_non_null_expression] = STATE(1015),
    [sym_internal_module] = STATE(1015),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1015),
    [sym_await_expression] = STATE(1015),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1015),
    [sym_this] = STATE(1015),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1015),
    [sym_generator_function] = STATE(1015),
    [sym_call_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1015),
    [sym_ternary_expression] = STATE(1015),
    [sym_binary_expression] = STATE(1015),
    [sym_template_string] = STATE(1015),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1015),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1015),
    [sym_class] = STATE(1015),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2081),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2083),
    [sym_true] = ACTIONS(2081),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2081),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [367] = {
    [sym_new_expression] = STATE(1014),
    [sym_augmented_assignment_expression] = STATE(1014),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(1014),
    [sym_update_expression] = STATE(1014),
    [sym_regex] = STATE(1014),
    [sym_meta_property] = STATE(1014),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1014),
    [sym_yield_expression] = STATE(1014),
    [sym_as_expression] = STATE(1014),
    [sym_non_null_expression] = STATE(1014),
    [sym_internal_module] = STATE(1014),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1014),
    [sym_await_expression] = STATE(1014),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1014),
    [sym_this] = STATE(1014),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1014),
    [sym_generator_function] = STATE(1014),
    [sym_call_expression] = STATE(1014),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1014),
    [sym_ternary_expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_template_string] = STATE(1014),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1014),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1014),
    [sym_class] = STATE(1014),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2073),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_AMP_EQ] = ACTIONS(2073),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2073),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_PIPE_EQ] = ACTIONS(2073),
    [anon_sym_DASH_EQ] = ACTIONS(2073),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2073),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(660),
    [sym_true] = ACTIONS(2077),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2073),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2077),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2077),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_STAR_EQ] = ACTIONS(2073),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2073),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2077),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [368] = {
    [sym_call_signature] = STATE(1016),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2085),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2073),
    [anon_sym_symbol] = ACTIONS(2087),
    [anon_sym_AMP_EQ] = ACTIONS(2073),
    [anon_sym_PLUS_EQ] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2087),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(2073),
    [anon_sym_private] = ACTIONS(2087),
    [anon_sym_PIPE_EQ] = ACTIONS(2073),
    [anon_sym_DASH_EQ] = ACTIONS(2073),
    [anon_sym_get] = ACTIONS(2087),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2073),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(2087),
    [anon_sym_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(2087),
    [anon_sym_type] = ACTIONS(2087),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2073),
    [anon_sym_namespace] = ACTIONS(2087),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_number] = ACTIONS(2087),
    [anon_sym_declare] = ACTIONS(2087),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2087),
    [anon_sym_STAR_EQ] = ACTIONS(2073),
    [anon_sym_boolean] = ACTIONS(2087),
    [anon_sym_async] = ACTIONS(2087),
    [anon_sym_public] = ACTIONS(2087),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2073),
    [anon_sym_string] = ACTIONS(2087),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2087),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [369] = {
    [sym_new_expression] = STATE(1018),
    [sym_augmented_assignment_expression] = STATE(1018),
    [sym_unary_expression] = STATE(1018),
    [sym_update_expression] = STATE(1018),
    [sym_regex] = STATE(1018),
    [sym_meta_property] = STATE(1018),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1018),
    [sym_yield_expression] = STATE(1018),
    [sym_as_expression] = STATE(1018),
    [sym_non_null_expression] = STATE(1018),
    [sym_internal_module] = STATE(1018),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1018),
    [sym_await_expression] = STATE(1018),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1018),
    [sym_this] = STATE(1018),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1018),
    [sym_generator_function] = STATE(1018),
    [sym_call_expression] = STATE(1018),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1018),
    [sym_ternary_expression] = STATE(1018),
    [sym_binary_expression] = STATE(1018),
    [sym_template_string] = STATE(1018),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1018),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1018),
    [sym_class] = STATE(1018),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2089),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2091),
    [sym_true] = ACTIONS(2089),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2089),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [370] = {
    [sym_new_expression] = STATE(1019),
    [sym_augmented_assignment_expression] = STATE(1019),
    [sym_unary_expression] = STATE(1019),
    [sym_update_expression] = STATE(1019),
    [sym_regex] = STATE(1019),
    [sym_meta_property] = STATE(1019),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1019),
    [sym_yield_expression] = STATE(1019),
    [sym_as_expression] = STATE(1019),
    [sym_non_null_expression] = STATE(1019),
    [sym_internal_module] = STATE(1019),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1019),
    [sym_await_expression] = STATE(1019),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1019),
    [sym_this] = STATE(1019),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1019),
    [sym_generator_function] = STATE(1019),
    [sym_call_expression] = STATE(1019),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1019),
    [sym_ternary_expression] = STATE(1019),
    [sym_binary_expression] = STATE(1019),
    [sym_template_string] = STATE(1019),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1019),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1019),
    [sym_class] = STATE(1019),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_RBRACE] = ACTIONS(211),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(660),
    [sym_true] = ACTIONS(2093),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2093),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2095),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2093),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [371] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2097),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2099),
    [anon_sym_symbol] = ACTIONS(2099),
    [anon_sym_number] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2099),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2101),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2099),
    [anon_sym_private] = ACTIONS(2099),
    [anon_sym_boolean] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2099),
    [anon_sym_get] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2099),
    [anon_sym_string] = ACTIONS(2099),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2099),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(2099),
    [anon_sym_export] = ACTIONS(2099),
    [anon_sym_namespace] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [372] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_AMP_EQ] = ACTIONS(2073),
    [anon_sym_PLUS_EQ] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2073),
    [anon_sym_STAR_EQ] = ACTIONS(2073),
    [anon_sym_PIPE_EQ] = ACTIONS(2073),
    [anon_sym_DASH_EQ] = ACTIONS(2073),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [373] = {
    [sym_new_expression] = STATE(1025),
    [sym_augmented_assignment_expression] = STATE(1025),
    [sym_unary_expression] = STATE(1025),
    [sym_update_expression] = STATE(1025),
    [sym_regex] = STATE(1025),
    [sym_meta_property] = STATE(1025),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1025),
    [sym_as_expression] = STATE(1025),
    [sym_non_null_expression] = STATE(1025),
    [sym_internal_module] = STATE(1025),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1025),
    [sym_await_expression] = STATE(1025),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1025),
    [sym_this] = STATE(1025),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1025),
    [sym_generator_function] = STATE(1025),
    [sym_call_expression] = STATE(1025),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1025),
    [sym_ternary_expression] = STATE(1025),
    [sym_binary_expression] = STATE(1025),
    [sym_template_string] = STATE(1025),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1025),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1025),
    [sym_class] = STATE(1025),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2107),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2109),
    [sym_true] = ACTIONS(2107),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2107),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [374] = {
    [anon_sym_EQ_GT] = ACTIONS(2069),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2115),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [376] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_AMP_EQ] = ACTIONS(2065),
    [anon_sym_PLUS_EQ] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2065),
    [anon_sym_STAR_EQ] = ACTIONS(2065),
    [anon_sym_PIPE_EQ] = ACTIONS(2065),
    [anon_sym_DASH_EQ] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [377] = {
    [anon_sym_RBRACE] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [379] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [380] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [381] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(2139),
    [anon_sym_BANG] = ACTIONS(2141),
    [anon_sym_SEMI] = ACTIONS(2139),
    [anon_sym_BQUOTE] = ACTIONS(2139),
    [sym__automatic_semicolon] = ACTIONS(2139),
    [anon_sym_PIPE] = ACTIONS(2141),
    [anon_sym_COMMA] = ACTIONS(2139),
    [anon_sym_LT_LT] = ACTIONS(2139),
    [anon_sym_STAR] = ACTIONS(2141),
    [anon_sym_GT_GT_GT] = ACTIONS(2139),
    [anon_sym_AMP_AMP] = ACTIONS(2139),
    [anon_sym_DASH] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2139),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_GT_EQ] = ACTIONS(2139),
    [anon_sym_GT] = ACTIONS(2141),
    [anon_sym_AMP] = ACTIONS(2141),
    [anon_sym_PERCENT] = ACTIONS(2139),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_RBRACE] = ACTIONS(2139),
    [anon_sym_as] = ACTIONS(2139),
    [anon_sym_PIPE_PIPE] = ACTIONS(2139),
    [anon_sym_DASH_DASH] = ACTIONS(2139),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_instanceof] = ACTIONS(2139),
    [anon_sym_LT] = ACTIONS(2141),
    [anon_sym_RPAREN] = ACTIONS(2139),
    [anon_sym_SLASH] = ACTIONS(2141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2139),
    [anon_sym_CARET] = ACTIONS(2139),
    [anon_sym_STAR_STAR] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2141),
    [anon_sym_GT_GT] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2139),
    [anon_sym_in] = ACTIONS(2141),
  },
  [382] = {
    [aux_sym_template_string_repeat1] = STATE(382),
    [sym_template_substitution] = STATE(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2143),
    [sym_escape_sequence] = ACTIONS(2146),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym__template_chars] = ACTIONS(2146),
    [sym_comment] = ACTIONS(3),
  },
  [383] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_BQUOTE] = ACTIONS(2151),
    [sym__automatic_semicolon] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_STAR] = ACTIONS(2153),
    [anon_sym_GT_GT_GT] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_BANG_EQ] = ACTIONS(2153),
    [anon_sym_LT_EQ] = ACTIONS(2151),
    [anon_sym_LPAREN] = ACTIONS(2151),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2153),
    [anon_sym_AMP] = ACTIONS(2153),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_as] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_EQ_EQ] = ACTIONS(2153),
    [anon_sym_instanceof] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [anon_sym_SLASH] = ACTIONS(2153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2151),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_STAR_STAR] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_GT_GT] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2151),
    [anon_sym_in] = ACTIONS(2153),
  },
  [384] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [385] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2155),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [386] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2157),
    [sym__automatic_semicolon] = ACTIONS(2157),
    [anon_sym_PERCENT_EQ] = ACTIONS(2157),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2157),
    [anon_sym_AMP_EQ] = ACTIONS(2157),
    [anon_sym_PLUS_EQ] = ACTIONS(2157),
    [anon_sym_PIPE] = ACTIONS(2159),
    [anon_sym_COMMA] = ACTIONS(2157),
    [anon_sym_LT_LT] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_GT_GT_GT] = ACTIONS(2159),
    [anon_sym_EQ] = ACTIONS(2159),
    [anon_sym_AMP_AMP] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_BANG_EQ] = ACTIONS(2159),
    [anon_sym_LT_EQ] = ACTIONS(2157),
    [anon_sym_LPAREN] = ACTIONS(2157),
    [anon_sym_GT_EQ] = ACTIONS(2157),
    [anon_sym_GT] = ACTIONS(2159),
    [anon_sym_CARET_EQ] = ACTIONS(2157),
    [anon_sym_STAR_EQ] = ACTIONS(2157),
    [anon_sym_PIPE_EQ] = ACTIONS(2157),
    [anon_sym_DASH_EQ] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_QMARK] = ACTIONS(2157),
    [anon_sym_LT_LT_EQ] = ACTIONS(2157),
    [anon_sym_as] = ACTIONS(2157),
    [anon_sym_PIPE_PIPE] = ACTIONS(2157),
    [anon_sym_RBRACE] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_EQ_EQ] = ACTIONS(2159),
    [anon_sym_instanceof] = ACTIONS(2157),
    [anon_sym_LT] = ACTIONS(2159),
    [anon_sym_RPAREN] = ACTIONS(2157),
    [anon_sym_SLASH] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2157),
    [anon_sym_GT_GT_EQ] = ACTIONS(2157),
    [anon_sym_DOT] = ACTIONS(2157),
    [anon_sym_CARET] = ACTIONS(2159),
    [anon_sym_STAR_STAR] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2157),
    [anon_sym_GT_GT] = ACTIONS(2159),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2157),
    [anon_sym_in] = ACTIONS(2159),
  },
  [387] = {
    [sym_identifier] = ACTIONS(2161),
    [sym_comment] = ACTIONS(3),
  },
  [388] = {
    [sym_new_expression] = STATE(1038),
    [sym_augmented_assignment_expression] = STATE(1038),
    [sym_unary_expression] = STATE(1038),
    [sym_update_expression] = STATE(1038),
    [sym_regex] = STATE(1038),
    [sym_meta_property] = STATE(1038),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1038),
    [sym_yield_expression] = STATE(1038),
    [sym_as_expression] = STATE(1038),
    [sym_non_null_expression] = STATE(1038),
    [sym_internal_module] = STATE(1038),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1038),
    [sym_await_expression] = STATE(1038),
    [sym_member_expression] = STATE(448),
    [sym_spread_element] = STATE(1039),
    [sym_string] = STATE(1038),
    [sym_this] = STATE(1038),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [aux_sym_array_repeat1] = STATE(1040),
    [sym_anonymous_class] = STATE(1038),
    [sym_generator_function] = STATE(1038),
    [sym_call_expression] = STATE(1038),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1038),
    [sym_ternary_expression] = STATE(1038),
    [sym_binary_expression] = STATE(1038),
    [sym_template_string] = STATE(1038),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1038),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1038),
    [sym_class] = STATE(1038),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(789),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2163),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(2165),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2167),
    [sym_true] = ACTIONS(2163),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [389] = {
    [anon_sym_LBRACK] = ACTIONS(2169),
    [sym_identifier] = ACTIONS(2171),
    [anon_sym_module] = ACTIONS(2171),
    [anon_sym_symbol] = ACTIONS(2171),
    [anon_sym_number] = ACTIONS(2171),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_AT] = ACTIONS(2169),
    [anon_sym_declare] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_void] = ACTIONS(2171),
    [anon_sym_any] = ACTIONS(2171),
    [anon_sym_private] = ACTIONS(2171),
    [anon_sym_boolean] = ACTIONS(2171),
    [anon_sym_static] = ACTIONS(2171),
    [anon_sym_async] = ACTIONS(2171),
    [anon_sym_get] = ACTIONS(2171),
    [anon_sym_public] = ACTIONS(2171),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_this] = ACTIONS(2171),
    [sym_number] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2171),
    [anon_sym_string] = ACTIONS(2171),
    [anon_sym_abstract] = ACTIONS(2171),
    [anon_sym_set] = ACTIONS(2171),
    [anon_sym_type] = ACTIONS(2171),
    [anon_sym_import] = ACTIONS(2171),
    [anon_sym_export] = ACTIONS(2171),
    [anon_sym_namespace] = ACTIONS(2171),
    [sym_readonly] = ACTIONS(2171),
    [anon_sym_DQUOTE] = ACTIONS(2169),
  },
  [390] = {
    [sym__initializer] = STATE(1041),
    [aux_sym_object_repeat1] = STATE(652),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(2173),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(360),
    [sym_comment] = ACTIONS(3),
  },
  [391] = {
    [sym_new_expression] = STATE(1042),
    [sym_augmented_assignment_expression] = STATE(1042),
    [sym_unary_expression] = STATE(1042),
    [sym_update_expression] = STATE(1042),
    [sym_regex] = STATE(1042),
    [sym_meta_property] = STATE(1042),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1042),
    [sym_yield_expression] = STATE(1042),
    [sym_as_expression] = STATE(1042),
    [sym_non_null_expression] = STATE(1042),
    [sym_internal_module] = STATE(1042),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1042),
    [sym_await_expression] = STATE(1042),
    [sym_member_expression] = STATE(161),
    [sym_spread_element] = STATE(409),
    [sym_string] = STATE(1042),
    [sym_this] = STATE(1042),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [aux_sym_array_repeat1] = STATE(410),
    [sym_anonymous_class] = STATE(1042),
    [sym_generator_function] = STATE(1042),
    [sym_call_expression] = STATE(1042),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1042),
    [sym_ternary_expression] = STATE(1042),
    [sym_binary_expression] = STATE(1042),
    [sym_template_string] = STATE(1042),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1042),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1042),
    [sym_class] = STATE(1042),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(747),
    [sym_null] = ACTIONS(2175),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2177),
    [sym_true] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [392] = {
    [aux_sym_object_repeat1] = STATE(652),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(360),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [aux_sym_object_repeat1] = STATE(652),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_namespace] = ACTIONS(1220),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
  },
  [394] = {
    [sym__property_name] = STATE(663),
    [aux_sym_object_repeat1] = STATE(652),
    [sym_string] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(1228),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1224),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1224),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [395] = {
    [sym__property_name] = STATE(663),
    [aux_sym_object_repeat1] = STATE(652),
    [sym_string] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [396] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1241),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_EQ] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_BANG_EQ] = ACTIONS(1241),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [anon_sym_of] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1241),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1241),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1241),
  },
  [397] = {
    [sym__initializer] = STATE(1043),
    [anon_sym_EQ] = ACTIONS(2173),
    [sym_comment] = ACTIONS(3),
  },
  [398] = {
    [sym_computed_property_name] = STATE(701),
    [sym__property_name] = STATE(701),
    [sym_decorator] = STATE(1044),
    [sym_method_definition] = STATE(700),
    [sym_string] = STATE(701),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(1044),
    [anon_sym_get] = ACTIONS(1308),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [sym_number] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1304),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1304),
    [anon_sym_public] = ACTIONS(1304),
  },
  [399] = {
    [sym__initializer] = STATE(1045),
    [anon_sym_EQ] = ACTIONS(2173),
    [sym_comment] = ACTIONS(3),
  },
  [400] = {
    [sym_call_signature] = STATE(774),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(2179),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [401] = {
    [sym_call_signature] = STATE(774),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [402] = {
    [aux_sym_export_statement_repeat1] = STATE(402),
    [sym_decorator] = STATE(402),
    [anon_sym_class] = ACTIONS(2032),
    [anon_sym_AT] = ACTIONS(2034),
    [sym_comment] = ACTIONS(3),
  },
  [403] = {
    [sym_identifier] = ACTIONS(2181),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [anon_sym_debugger] = ACTIONS(2181),
    [anon_sym_symbol] = ACTIONS(2181),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_void] = ACTIONS(2181),
    [anon_sym_break] = ACTIONS(2181),
    [anon_sym_const] = ACTIONS(2181),
    [sym_super] = ACTIONS(2181),
    [anon_sym_return] = ACTIONS(2181),
    [anon_sym_private] = ACTIONS(2181),
    [anon_sym_get] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2181),
    [anon_sym_default] = ACTIONS(2181),
    [anon_sym_enum] = ACTIONS(2181),
    [anon_sym_delete] = ACTIONS(2181),
    [anon_sym_continue] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_this] = ACTIONS(2181),
    [anon_sym_yield] = ACTIONS(2181),
    [sym_true] = ACTIONS(2181),
    [anon_sym_throw] = ACTIONS(2181),
    [anon_sym_protected] = ACTIONS(2181),
    [anon_sym_abstract] = ACTIONS(2181),
    [anon_sym_set] = ACTIONS(2181),
    [anon_sym_type] = ACTIONS(2181),
    [anon_sym_import] = ACTIONS(2181),
    [anon_sym_namespace] = ACTIONS(2181),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2181),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_else] = ACTIONS(2181),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_for] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [sym_false] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_case] = ACTIONS(2181),
    [anon_sym_module] = ACTIONS(2181),
    [anon_sym_number] = ACTIONS(2181),
    [anon_sym_class] = ACTIONS(2181),
    [anon_sym_declare] = ACTIONS(2181),
    [anon_sym_typeof] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2181),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [sym_null] = ACTIONS(2181),
    [anon_sym_any] = ACTIONS(2181),
    [anon_sym_boolean] = ACTIONS(2181),
    [anon_sym_async] = ACTIONS(2181),
    [anon_sym_public] = ACTIONS(2181),
    [anon_sym_var] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [anon_sym_try] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2181),
    [anon_sym_function] = ACTIONS(2181),
    [sym_undefined] = ACTIONS(2181),
    [anon_sym_new] = ACTIONS(2181),
    [ts_builtin_sym_end] = ACTIONS(2183),
    [anon_sym_let] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_export] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_with] = ACTIONS(2181),
  },
  [404] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1062),
    [sym_constructor_type] = STATE(1062),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(1062),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1062),
    [sym_intersection_type] = STATE(1062),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1063),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1067),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [405] = {
    [sym__automatic_semicolon] = ACTIONS(2219),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_COMMA] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [sym__initializer] = STATE(1068),
    [sym__automatic_semicolon] = ACTIONS(2219),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_COMMA] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
  },
  [407] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(977),
    [anon_sym_in] = ACTIONS(979),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_GT_GT_GT] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(979),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_RBRACK] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_of] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_as] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(977),
    [anon_sym_DASH_DASH] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_instanceof] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(977),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_implements] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(979),
  },
  [408] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [aux_sym_array_repeat1] = STATE(1070),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [409] = {
    [aux_sym_array_repeat1] = STATE(1070),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
  },
  [410] = {
    [aux_sym_array_repeat1] = STATE(578),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [sym_enum_body] = STATE(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(823),
  },
  [412] = {
    [sym__initializer] = STATE(1041),
    [aux_sym_object_repeat1] = STATE(1073),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(2173),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(360),
    [sym_comment] = ACTIONS(3),
  },
  [413] = {
    [aux_sym_object_repeat1] = STATE(1073),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(360),
    [sym_comment] = ACTIONS(3),
  },
  [414] = {
    [aux_sym_object_repeat1] = STATE(1073),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_namespace] = ACTIONS(1220),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
  },
  [415] = {
    [sym__property_name] = STATE(663),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym_string] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(1228),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1224),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1224),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [416] = {
    [sym__property_name] = STATE(663),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym_string] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [417] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1241),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_EQ] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_BANG_EQ] = ACTIONS(1241),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_RBRACK] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_of] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1241),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_implements] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1241),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1241),
  },
  [418] = {
    [aux_sym_object_repeat1] = STATE(1075),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [sym_comment] = ACTIONS(3),
  },
  [419] = {
    [sym_computed_property_name] = STATE(701),
    [sym__property_name] = STATE(701),
    [sym_decorator] = STATE(1044),
    [sym_method_definition] = STATE(1076),
    [sym_string] = STATE(701),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(1044),
    [anon_sym_get] = ACTIONS(1308),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [sym_number] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1304),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1304),
    [anon_sym_public] = ACTIONS(1304),
  },
  [420] = {
    [aux_sym_object_repeat1] = STATE(695),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [sym_comment] = ACTIONS(3),
  },
  [421] = {
    [sym_variable_declarator] = STATE(1077),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [422] = {
    [sym_identifier] = ACTIONS(2227),
    [anon_sym_BQUOTE] = ACTIONS(2229),
    [anon_sym_debugger] = ACTIONS(2227),
    [anon_sym_symbol] = ACTIONS(2227),
    [anon_sym_AT] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2227),
    [anon_sym_void] = ACTIONS(2227),
    [anon_sym_break] = ACTIONS(2227),
    [anon_sym_const] = ACTIONS(2227),
    [sym_super] = ACTIONS(2227),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_private] = ACTIONS(2227),
    [anon_sym_get] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2229),
    [anon_sym_interface] = ACTIONS(2227),
    [anon_sym_default] = ACTIONS(2227),
    [anon_sym_enum] = ACTIONS(2227),
    [anon_sym_delete] = ACTIONS(2227),
    [anon_sym_continue] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_if] = ACTIONS(2227),
    [anon_sym_this] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2227),
    [sym_true] = ACTIONS(2227),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_protected] = ACTIONS(2227),
    [anon_sym_abstract] = ACTIONS(2227),
    [anon_sym_set] = ACTIONS(2227),
    [anon_sym_type] = ACTIONS(2227),
    [anon_sym_import] = ACTIONS(2227),
    [anon_sym_namespace] = ACTIONS(2227),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [anon_sym_else] = ACTIONS(2227),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_for] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(2229),
    [sym_false] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym_case] = ACTIONS(2227),
    [anon_sym_module] = ACTIONS(2227),
    [anon_sym_number] = ACTIONS(2227),
    [anon_sym_class] = ACTIONS(2227),
    [anon_sym_declare] = ACTIONS(2227),
    [anon_sym_typeof] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_switch] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(2229),
    [sym_null] = ACTIONS(2227),
    [anon_sym_any] = ACTIONS(2227),
    [anon_sym_boolean] = ACTIONS(2227),
    [anon_sym_async] = ACTIONS(2227),
    [anon_sym_public] = ACTIONS(2227),
    [anon_sym_var] = ACTIONS(2227),
    [anon_sym_while] = ACTIONS(2227),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_try] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2229),
    [sym_number] = ACTIONS(2229),
    [anon_sym_SLASH] = ACTIONS(2227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2227),
    [anon_sym_function] = ACTIONS(2227),
    [sym_undefined] = ACTIONS(2227),
    [anon_sym_new] = ACTIONS(2227),
    [ts_builtin_sym_end] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2227),
    [anon_sym_export] = ACTIONS(2227),
    [anon_sym_do] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_with] = ACTIONS(2227),
  },
  [423] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1079),
    [sym__automatic_semicolon] = ACTIONS(2231),
    [anon_sym_SEMI] = ACTIONS(2231),
    [anon_sym_COMMA] = ACTIONS(767),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1085),
    [sym_constructor_type] = STATE(1085),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(1085),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1085),
    [sym_intersection_type] = STATE(1085),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1086),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1088),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [425] = {
    [sym__automatic_semicolon] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2243),
    [anon_sym_COMMA] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
  },
  [426] = {
    [sym__initializer] = STATE(1089),
    [anon_sym_EQ] = ACTIONS(741),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym__automatic_semicolon] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [sym__initializer] = STATE(1090),
    [anon_sym_EQ] = ACTIONS(741),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [430] = {
    [anon_sym_RBRACK] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(1488),
  },
  [432] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_AMP_EQ] = ACTIONS(2251),
    [anon_sym_PLUS_EQ] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2251),
    [anon_sym_STAR_EQ] = ACTIONS(2251),
    [anon_sym_PIPE_EQ] = ACTIONS(2251),
    [anon_sym_DASH_EQ] = ACTIONS(2251),
    [anon_sym_EQ_GT] = ACTIONS(2253),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2255),
  },
  [433] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [434] = {
    [sym_new_expression] = STATE(1098),
    [sym_augmented_assignment_expression] = STATE(1098),
    [sym_unary_expression] = STATE(1098),
    [sym_update_expression] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_meta_property] = STATE(1098),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1098),
    [sym_as_expression] = STATE(1098),
    [sym_non_null_expression] = STATE(1098),
    [sym_internal_module] = STATE(1098),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1098),
    [sym_await_expression] = STATE(1098),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1098),
    [sym_this] = STATE(1098),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1098),
    [sym_generator_function] = STATE(1098),
    [sym_call_expression] = STATE(1098),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1098),
    [sym_ternary_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_template_string] = STATE(1098),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1098),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1098),
    [sym_class] = STATE(1098),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2261),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2263),
    [sym_true] = ACTIONS(2261),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2261),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [435] = {
    [sym_new_expression] = STATE(1099),
    [sym_augmented_assignment_expression] = STATE(1099),
    [sym_unary_expression] = STATE(1099),
    [sym_update_expression] = STATE(1099),
    [sym_regex] = STATE(1099),
    [sym_meta_property] = STATE(1099),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1099),
    [sym_yield_expression] = STATE(1099),
    [sym_as_expression] = STATE(1099),
    [sym_non_null_expression] = STATE(1099),
    [sym_internal_module] = STATE(1099),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1099),
    [sym_await_expression] = STATE(1099),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1099),
    [sym_this] = STATE(1099),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1099),
    [sym_generator_function] = STATE(1099),
    [sym_call_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1099),
    [sym_ternary_expression] = STATE(1099),
    [sym_binary_expression] = STATE(1099),
    [sym_template_string] = STATE(1099),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1099),
    [sym_class] = STATE(1099),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2265),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2267),
    [sym_true] = ACTIONS(2265),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2265),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [436] = {
    [sym_new_expression] = STATE(1100),
    [sym_augmented_assignment_expression] = STATE(1100),
    [sym_unary_expression] = STATE(1100),
    [sym_update_expression] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_meta_property] = STATE(1100),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1100),
    [sym_yield_expression] = STATE(1100),
    [sym_as_expression] = STATE(1100),
    [sym_non_null_expression] = STATE(1100),
    [sym_internal_module] = STATE(1100),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1100),
    [sym_await_expression] = STATE(1100),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1100),
    [sym_this] = STATE(1100),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1100),
    [sym_generator_function] = STATE(1100),
    [sym_call_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1100),
    [sym_ternary_expression] = STATE(1100),
    [sym_binary_expression] = STATE(1100),
    [sym_template_string] = STATE(1100),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1100),
    [sym_class] = STATE(1100),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2269),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2271),
    [sym_true] = ACTIONS(2269),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2269),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [437] = {
    [sym_new_expression] = STATE(1101),
    [sym_augmented_assignment_expression] = STATE(1101),
    [sym_unary_expression] = STATE(1101),
    [sym_update_expression] = STATE(1101),
    [sym_regex] = STATE(1101),
    [sym_meta_property] = STATE(1101),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1101),
    [sym_yield_expression] = STATE(1101),
    [sym_as_expression] = STATE(1101),
    [sym_non_null_expression] = STATE(1101),
    [sym_internal_module] = STATE(1101),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1101),
    [sym_await_expression] = STATE(1101),
    [sym_member_expression] = STATE(448),
    [sym_spread_element] = STATE(532),
    [sym_string] = STATE(1101),
    [sym_this] = STATE(1101),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1101),
    [sym_generator_function] = STATE(1101),
    [sym_call_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1101),
    [sym_ternary_expression] = STATE(1101),
    [sym_binary_expression] = STATE(1101),
    [sym_template_string] = STATE(1101),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1101),
    [sym_class] = STATE(1101),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(2273),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(789),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2273),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2275),
    [sym_true] = ACTIONS(2273),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2273),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [438] = {
    [sym_new_expression] = STATE(1098),
    [sym_augmented_assignment_expression] = STATE(1098),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(1098),
    [sym_update_expression] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_meta_property] = STATE(1098),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1098),
    [sym_as_expression] = STATE(1098),
    [sym_non_null_expression] = STATE(1098),
    [sym_internal_module] = STATE(1098),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1098),
    [sym_await_expression] = STATE(1098),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1098),
    [sym_this] = STATE(1098),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1098),
    [sym_generator_function] = STATE(1098),
    [sym_call_expression] = STATE(1098),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1098),
    [sym_ternary_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_template_string] = STATE(1098),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1098),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1098),
    [sym_class] = STATE(1098),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(803),
    [sym_true] = ACTIONS(2261),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2261),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2261),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2261),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [439] = {
    [sym_call_signature] = STATE(1102),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2277),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_symbol] = ACTIONS(2279),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_void] = ACTIONS(2279),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_private] = ACTIONS(2279),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_get] = ACTIONS(2279),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(2279),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(2279),
    [anon_sym_type] = ACTIONS(2279),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2279),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(2279),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_number] = ACTIONS(2279),
    [anon_sym_declare] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2279),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_boolean] = ACTIONS(2279),
    [anon_sym_async] = ACTIONS(2279),
    [anon_sym_public] = ACTIONS(2279),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_string] = ACTIONS(2279),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [440] = {
    [sym_new_expression] = STATE(1104),
    [sym_augmented_assignment_expression] = STATE(1104),
    [sym_unary_expression] = STATE(1104),
    [sym_update_expression] = STATE(1104),
    [sym_regex] = STATE(1104),
    [sym_meta_property] = STATE(1104),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1104),
    [sym_yield_expression] = STATE(1104),
    [sym_as_expression] = STATE(1104),
    [sym_non_null_expression] = STATE(1104),
    [sym_internal_module] = STATE(1104),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1104),
    [sym_await_expression] = STATE(1104),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1104),
    [sym_this] = STATE(1104),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1104),
    [sym_generator_function] = STATE(1104),
    [sym_call_expression] = STATE(1104),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1104),
    [sym_ternary_expression] = STATE(1104),
    [sym_binary_expression] = STATE(1104),
    [sym_template_string] = STATE(1104),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1104),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1104),
    [sym_class] = STATE(1104),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(2281),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2281),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2283),
    [sym_true] = ACTIONS(2281),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2281),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [441] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2285),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_SEMI] = ACTIONS(2285),
    [anon_sym_BQUOTE] = ACTIONS(2285),
    [sym__automatic_semicolon] = ACTIONS(2285),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_COMMA] = ACTIONS(2285),
    [anon_sym_LT_LT] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2287),
    [anon_sym_GT_GT_GT] = ACTIONS(2285),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_LT_EQ] = ACTIONS(2285),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_GT_EQ] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_PERCENT] = ACTIONS(2285),
    [anon_sym_QMARK] = ACTIONS(2285),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_as] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2285),
    [anon_sym_DASH_DASH] = ACTIONS(2285),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_instanceof] = ACTIONS(2285),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_RPAREN] = ACTIONS(2285),
    [anon_sym_SLASH] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2285),
    [anon_sym_CARET] = ACTIONS(2285),
    [anon_sym_STAR_STAR] = ACTIONS(2285),
    [anon_sym_PLUS] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2285),
    [anon_sym_in] = ACTIONS(2287),
  },
  [442] = {
    [sym_new_expression] = STATE(1105),
    [sym_augmented_assignment_expression] = STATE(1105),
    [sym_unary_expression] = STATE(1105),
    [sym_update_expression] = STATE(1105),
    [sym_regex] = STATE(1105),
    [sym_meta_property] = STATE(1105),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1105),
    [sym_as_expression] = STATE(1105),
    [sym_non_null_expression] = STATE(1105),
    [sym_internal_module] = STATE(1105),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1105),
    [sym_await_expression] = STATE(1105),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1105),
    [sym_this] = STATE(1105),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1105),
    [sym_generator_function] = STATE(1105),
    [sym_call_expression] = STATE(1105),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1105),
    [sym_ternary_expression] = STATE(1105),
    [sym_binary_expression] = STATE(1105),
    [sym_template_string] = STATE(1105),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1105),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1105),
    [sym_class] = STATE(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(803),
    [sym_true] = ACTIONS(2289),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2289),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2289),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2291),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2289),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [443] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2293),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2295),
    [anon_sym_symbol] = ACTIONS(2295),
    [anon_sym_number] = ACTIONS(2295),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2295),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2297),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2295),
    [anon_sym_private] = ACTIONS(2295),
    [anon_sym_boolean] = ACTIONS(2295),
    [anon_sym_async] = ACTIONS(2299),
    [anon_sym_public] = ACTIONS(2295),
    [anon_sym_get] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2295),
    [anon_sym_string] = ACTIONS(2295),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2295),
    [anon_sym_type] = ACTIONS(2295),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(2295),
    [anon_sym_export] = ACTIONS(2295),
    [anon_sym_namespace] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [444] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [445] = {
    [sym_new_expression] = STATE(1111),
    [sym_augmented_assignment_expression] = STATE(1111),
    [sym_unary_expression] = STATE(1111),
    [sym_update_expression] = STATE(1111),
    [sym_regex] = STATE(1111),
    [sym_meta_property] = STATE(1111),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1111),
    [sym_yield_expression] = STATE(1111),
    [sym_as_expression] = STATE(1111),
    [sym_non_null_expression] = STATE(1111),
    [sym_internal_module] = STATE(1111),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1111),
    [sym_await_expression] = STATE(1111),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1111),
    [sym_this] = STATE(1111),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1111),
    [sym_generator_function] = STATE(1111),
    [sym_call_expression] = STATE(1111),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1111),
    [sym_ternary_expression] = STATE(1111),
    [sym_binary_expression] = STATE(1111),
    [sym_template_string] = STATE(1111),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1111),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1111),
    [sym_class] = STATE(1111),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(2303),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2303),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2305),
    [sym_true] = ACTIONS(2303),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2303),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [446] = {
    [anon_sym_EQ_GT] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
  },
  [447] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [aux_sym_array_repeat1] = STATE(1121),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(2329),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [448] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_AMP_EQ] = ACTIONS(2251),
    [anon_sym_PLUS_EQ] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2251),
    [anon_sym_STAR_EQ] = ACTIONS(2251),
    [anon_sym_PIPE_EQ] = ACTIONS(2251),
    [anon_sym_DASH_EQ] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [449] = {
    [aux_sym_array_repeat1] = STATE(1121),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(2329),
    [sym_comment] = ACTIONS(3),
  },
  [450] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2255),
  },
  [451] = {
    [aux_sym_array_repeat1] = STATE(1122),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(2329),
    [sym_comment] = ACTIONS(3),
  },
  [452] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [453] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2255),
  },
  [454] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2333),
    [anon_sym_LBRACK] = ACTIONS(2333),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_SEMI] = ACTIONS(2333),
    [anon_sym_BQUOTE] = ACTIONS(2333),
    [sym__automatic_semicolon] = ACTIONS(2333),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_COMMA] = ACTIONS(2333),
    [anon_sym_LT_LT] = ACTIONS(2333),
    [anon_sym_STAR] = ACTIONS(2335),
    [anon_sym_GT_GT_GT] = ACTIONS(2333),
    [anon_sym_AMP_AMP] = ACTIONS(2333),
    [anon_sym_DASH] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(2335),
    [anon_sym_LT_EQ] = ACTIONS(2333),
    [anon_sym_LPAREN] = ACTIONS(2333),
    [anon_sym_GT_EQ] = ACTIONS(2333),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_AMP] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2333),
    [anon_sym_QMARK] = ACTIONS(2333),
    [anon_sym_RBRACE] = ACTIONS(2333),
    [anon_sym_as] = ACTIONS(2333),
    [anon_sym_PIPE_PIPE] = ACTIONS(2333),
    [anon_sym_DASH_DASH] = ACTIONS(2333),
    [anon_sym_EQ_EQ] = ACTIONS(2335),
    [anon_sym_instanceof] = ACTIONS(2333),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_RPAREN] = ACTIONS(2333),
    [anon_sym_SLASH] = ACTIONS(2335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2333),
    [anon_sym_CARET] = ACTIONS(2333),
    [anon_sym_STAR_STAR] = ACTIONS(2333),
    [anon_sym_PLUS] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(2333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2333),
    [anon_sym_in] = ACTIONS(2335),
  },
  [455] = {
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [anon_sym_debugger] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_AT] = ACTIONS(2339),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_break] = ACTIONS(2337),
    [anon_sym_const] = ACTIONS(2337),
    [sym_super] = ACTIONS(2337),
    [anon_sym_return] = ACTIONS(2337),
    [anon_sym_private] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_interface] = ACTIONS(2337),
    [anon_sym_default] = ACTIONS(2337),
    [anon_sym_enum] = ACTIONS(2337),
    [anon_sym_delete] = ACTIONS(2337),
    [anon_sym_continue] = ACTIONS(2337),
    [anon_sym_DASH_DASH] = ACTIONS(2339),
    [anon_sym_if] = ACTIONS(2337),
    [anon_sym_this] = ACTIONS(2337),
    [anon_sym_yield] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [anon_sym_throw] = ACTIONS(2337),
    [anon_sym_protected] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_type] = ACTIONS(2337),
    [anon_sym_import] = ACTIONS(2337),
    [anon_sym_namespace] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2339),
    [anon_sym_await] = ACTIONS(2337),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_else] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_for] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(2339),
    [sym_false] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_case] = ACTIONS(2337),
    [anon_sym_module] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_class] = ACTIONS(2337),
    [anon_sym_declare] = ACTIONS(2337),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_switch] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2339),
    [sym_null] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_public] = ACTIONS(2337),
    [anon_sym_var] = ACTIONS(2337),
    [anon_sym_while] = ACTIONS(2337),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [anon_sym_try] = ACTIONS(2337),
    [anon_sym_LT] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [anon_sym_SLASH] = ACTIONS(2337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_function] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_new] = ACTIONS(2337),
    [ts_builtin_sym_end] = ACTIONS(2339),
    [anon_sym_let] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_export] = ACTIONS(2337),
    [anon_sym_do] = ACTIONS(2337),
    [anon_sym_TILDE] = ACTIONS(2339),
    [anon_sym_with] = ACTIONS(2337),
  },
  [456] = {
    [sym_new_expression] = STATE(1135),
    [sym_augmented_assignment_expression] = STATE(1135),
    [sym_unary_expression] = STATE(1135),
    [sym_update_expression] = STATE(1135),
    [sym_regex] = STATE(1135),
    [sym_meta_property] = STATE(1135),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(1135),
    [sym_yield_expression] = STATE(1135),
    [sym_as_expression] = STATE(1135),
    [sym_non_null_expression] = STATE(1135),
    [sym_internal_module] = STATE(1135),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1135),
    [sym_await_expression] = STATE(1135),
    [sym_member_expression] = STATE(1136),
    [sym_generic_type] = STATE(1140),
    [sym_string] = STATE(1135),
    [sym_this] = STATE(1135),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_nested_type_identifier] = STATE(602),
    [sym_anonymous_class] = STATE(1135),
    [sym_generator_function] = STATE(1135),
    [sym_call_expression] = STATE(1135),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1135),
    [sym_ternary_expression] = STATE(1135),
    [sym_binary_expression] = STATE(1135),
    [sym_template_string] = STATE(1135),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(1135),
    [sym__type_reference] = STATE(1140),
    [sym_class] = STATE(1135),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(2343),
    [sym_false] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2345),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2359),
    [sym_true] = ACTIONS(2345),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2345),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [457] = {
    [sym_object_type] = STATE(1141),
    [sym_extends_clause] = STATE(1142),
    [anon_sym_extends] = ACTIONS(821),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(486),
  },
  [458] = {
    [sym_identifier] = ACTIONS(2369),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_debugger] = ACTIONS(2369),
    [anon_sym_symbol] = ACTIONS(2369),
    [anon_sym_AT] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_void] = ACTIONS(2369),
    [anon_sym_break] = ACTIONS(2369),
    [anon_sym_const] = ACTIONS(2369),
    [sym_super] = ACTIONS(2369),
    [anon_sym_return] = ACTIONS(2369),
    [anon_sym_private] = ACTIONS(2369),
    [anon_sym_get] = ACTIONS(2369),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_interface] = ACTIONS(2369),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2369),
    [anon_sym_delete] = ACTIONS(2369),
    [anon_sym_continue] = ACTIONS(2369),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_this] = ACTIONS(2369),
    [anon_sym_yield] = ACTIONS(2369),
    [sym_true] = ACTIONS(2369),
    [anon_sym_throw] = ACTIONS(2369),
    [anon_sym_protected] = ACTIONS(2369),
    [anon_sym_abstract] = ACTIONS(2369),
    [anon_sym_set] = ACTIONS(2369),
    [anon_sym_type] = ACTIONS(2369),
    [anon_sym_import] = ACTIONS(2369),
    [anon_sym_namespace] = ACTIONS(2369),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_await] = ACTIONS(2369),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [anon_sym_else] = ACTIONS(2369),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_for] = ACTIONS(2369),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [sym_false] = ACTIONS(2369),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_case] = ACTIONS(2369),
    [anon_sym_module] = ACTIONS(2369),
    [anon_sym_number] = ACTIONS(2369),
    [anon_sym_class] = ACTIONS(2369),
    [anon_sym_declare] = ACTIONS(2369),
    [anon_sym_typeof] = ACTIONS(2369),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_switch] = ACTIONS(2369),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [sym_null] = ACTIONS(2369),
    [anon_sym_any] = ACTIONS(2369),
    [anon_sym_boolean] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(2369),
    [anon_sym_public] = ACTIONS(2369),
    [anon_sym_var] = ACTIONS(2369),
    [anon_sym_while] = ACTIONS(2369),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [anon_sym_try] = ACTIONS(2369),
    [anon_sym_LT] = ACTIONS(2371),
    [sym_number] = ACTIONS(2371),
    [anon_sym_SLASH] = ACTIONS(2369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2369),
    [anon_sym_function] = ACTIONS(2369),
    [sym_undefined] = ACTIONS(2369),
    [anon_sym_new] = ACTIONS(2369),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [anon_sym_let] = ACTIONS(2369),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_export] = ACTIONS(2369),
    [anon_sym_do] = ACTIONS(2369),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_with] = ACTIONS(2369),
  },
  [459] = {
    [sym_object_type] = STATE(1141),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(486),
  },
  [460] = {
    [sym_computed_property_name] = STATE(1144),
    [sym__enum_member] = STATE(1145),
    [sym__property_name] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_enum_assignment] = STATE(1145),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(2373),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(1214),
  },
  [461] = {
    [sym_identifier] = ACTIONS(2377),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [anon_sym_debugger] = ACTIONS(2377),
    [anon_sym_symbol] = ACTIONS(2377),
    [anon_sym_AT] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_void] = ACTIONS(2377),
    [anon_sym_break] = ACTIONS(2377),
    [anon_sym_const] = ACTIONS(2377),
    [sym_super] = ACTIONS(2377),
    [anon_sym_return] = ACTIONS(2377),
    [anon_sym_private] = ACTIONS(2377),
    [anon_sym_get] = ACTIONS(2377),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_interface] = ACTIONS(2377),
    [anon_sym_default] = ACTIONS(2377),
    [anon_sym_enum] = ACTIONS(2377),
    [anon_sym_delete] = ACTIONS(2377),
    [anon_sym_continue] = ACTIONS(2377),
    [anon_sym_DASH_DASH] = ACTIONS(2379),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_this] = ACTIONS(2377),
    [anon_sym_yield] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [anon_sym_throw] = ACTIONS(2377),
    [anon_sym_protected] = ACTIONS(2377),
    [anon_sym_abstract] = ACTIONS(2377),
    [anon_sym_set] = ACTIONS(2377),
    [anon_sym_type] = ACTIONS(2377),
    [anon_sym_import] = ACTIONS(2377),
    [anon_sym_namespace] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2379),
    [anon_sym_await] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_else] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2379),
    [sym_false] = ACTIONS(2377),
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_case] = ACTIONS(2377),
    [anon_sym_module] = ACTIONS(2377),
    [anon_sym_number] = ACTIONS(2377),
    [anon_sym_class] = ACTIONS(2377),
    [anon_sym_declare] = ACTIONS(2377),
    [anon_sym_typeof] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_switch] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [sym_null] = ACTIONS(2377),
    [anon_sym_any] = ACTIONS(2377),
    [anon_sym_boolean] = ACTIONS(2377),
    [anon_sym_async] = ACTIONS(2377),
    [anon_sym_public] = ACTIONS(2377),
    [anon_sym_var] = ACTIONS(2377),
    [anon_sym_while] = ACTIONS(2377),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [anon_sym_try] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2379),
    [sym_number] = ACTIONS(2379),
    [anon_sym_SLASH] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2377),
    [anon_sym_function] = ACTIONS(2377),
    [sym_undefined] = ACTIONS(2377),
    [anon_sym_new] = ACTIONS(2377),
    [ts_builtin_sym_end] = ACTIONS(2379),
    [anon_sym_let] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_export] = ACTIONS(2377),
    [anon_sym_do] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_with] = ACTIONS(2377),
  },
  [462] = {
    [sym_identifier] = ACTIONS(2381),
    [anon_sym_BQUOTE] = ACTIONS(2383),
    [anon_sym_debugger] = ACTIONS(2381),
    [anon_sym_symbol] = ACTIONS(2381),
    [anon_sym_AT] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_void] = ACTIONS(2381),
    [anon_sym_break] = ACTIONS(2381),
    [anon_sym_const] = ACTIONS(2381),
    [sym_super] = ACTIONS(2381),
    [anon_sym_return] = ACTIONS(2381),
    [anon_sym_private] = ACTIONS(2381),
    [anon_sym_get] = ACTIONS(2381),
    [anon_sym_RBRACE] = ACTIONS(2383),
    [anon_sym_interface] = ACTIONS(2381),
    [anon_sym_default] = ACTIONS(2381),
    [anon_sym_enum] = ACTIONS(2381),
    [anon_sym_delete] = ACTIONS(2381),
    [anon_sym_continue] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(2383),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_this] = ACTIONS(2381),
    [anon_sym_yield] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [anon_sym_throw] = ACTIONS(2381),
    [anon_sym_protected] = ACTIONS(2381),
    [anon_sym_abstract] = ACTIONS(2381),
    [anon_sym_set] = ACTIONS(2381),
    [anon_sym_type] = ACTIONS(2381),
    [anon_sym_import] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2381),
    [anon_sym_PLUS_PLUS] = ACTIONS(2383),
    [anon_sym_await] = ACTIONS(2381),
    [anon_sym_DQUOTE] = ACTIONS(2383),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2383),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [sym_false] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2383),
    [anon_sym_case] = ACTIONS(2381),
    [anon_sym_module] = ACTIONS(2381),
    [anon_sym_number] = ACTIONS(2381),
    [anon_sym_class] = ACTIONS(2381),
    [anon_sym_declare] = ACTIONS(2381),
    [anon_sym_typeof] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2383),
    [sym_null] = ACTIONS(2381),
    [anon_sym_any] = ACTIONS(2381),
    [anon_sym_boolean] = ACTIONS(2381),
    [anon_sym_async] = ACTIONS(2381),
    [anon_sym_public] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_SQUOTE] = ACTIONS(2383),
    [anon_sym_try] = ACTIONS(2381),
    [anon_sym_LT] = ACTIONS(2383),
    [sym_number] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2381),
    [anon_sym_function] = ACTIONS(2381),
    [sym_undefined] = ACTIONS(2381),
    [anon_sym_new] = ACTIONS(2381),
    [ts_builtin_sym_end] = ACTIONS(2383),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_export] = ACTIONS(2381),
    [anon_sym_do] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2383),
    [anon_sym_with] = ACTIONS(2381),
  },
  [463] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1331),
  },
  [464] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [465] = {
    [sym_new_expression] = STATE(724),
    [sym_augmented_assignment_expression] = STATE(724),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(724),
    [sym_update_expression] = STATE(724),
    [sym_regex] = STATE(724),
    [sym_meta_property] = STATE(724),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(724),
    [sym_yield_expression] = STATE(724),
    [sym_as_expression] = STATE(724),
    [sym_non_null_expression] = STATE(724),
    [sym_internal_module] = STATE(724),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(724),
    [sym_await_expression] = STATE(724),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(724),
    [sym_this] = STATE(724),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(724),
    [sym_generator_function] = STATE(724),
    [sym_call_expression] = STATE(724),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(724),
    [sym_ternary_expression] = STATE(724),
    [sym_binary_expression] = STATE(724),
    [sym_template_string] = STATE(724),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(724),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(724),
    [sym_class] = STATE(724),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(430),
    [sym_true] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1350),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1350),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1350),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [466] = {
    [sym_call_signature] = STATE(727),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_void] = ACTIONS(1362),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1362),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1362),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_async] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [467] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [468] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [sym_type_annotation] = STATE(1147),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(1331),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_RPAREN] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [469] = {
    [anon_sym_RPAREN] = ACTIONS(2385),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1331),
  },
  [471] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1331),
  },
  [472] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2387),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [473] = {
    [sym_parenthesized_expression] = STATE(1149),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [anon_sym_await] = ACTIONS(2389),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(1155),
    [sym__declaration] = STATE(192),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(1155),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(322),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(2395),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2397),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [476] = {
    [sym_parenthesized_expression] = STATE(1156),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [477] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(1155),
    [sym__declaration] = STATE(317),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(1155),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_as] = ACTIONS(541),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(2395),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2397),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [478] = {
    [sym_parenthesized_expression] = STATE(1157),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [sym_identifier] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2401),
    [anon_sym_debugger] = ACTIONS(2399),
    [anon_sym_symbol] = ACTIONS(2399),
    [anon_sym_AT] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2399),
    [anon_sym_void] = ACTIONS(2399),
    [anon_sym_break] = ACTIONS(2399),
    [anon_sym_const] = ACTIONS(2399),
    [sym_super] = ACTIONS(2399),
    [anon_sym_return] = ACTIONS(2399),
    [anon_sym_private] = ACTIONS(2399),
    [anon_sym_get] = ACTIONS(2399),
    [anon_sym_interface] = ACTIONS(2399),
    [anon_sym_enum] = ACTIONS(2399),
    [anon_sym_delete] = ACTIONS(2399),
    [anon_sym_continue] = ACTIONS(2399),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2399),
    [anon_sym_this] = ACTIONS(2399),
    [anon_sym_yield] = ACTIONS(2399),
    [sym_true] = ACTIONS(2399),
    [anon_sym_throw] = ACTIONS(2399),
    [anon_sym_protected] = ACTIONS(2399),
    [anon_sym_abstract] = ACTIONS(2399),
    [anon_sym_set] = ACTIONS(2399),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_import] = ACTIONS(2399),
    [anon_sym_namespace] = ACTIONS(2399),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_await] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_else] = ACTIONS(2403),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [sym_false] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2401),
    [anon_sym_module] = ACTIONS(2399),
    [anon_sym_number] = ACTIONS(2399),
    [anon_sym_class] = ACTIONS(2399),
    [anon_sym_declare] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_switch] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [sym_null] = ACTIONS(2399),
    [anon_sym_any] = ACTIONS(2399),
    [anon_sym_boolean] = ACTIONS(2399),
    [anon_sym_async] = ACTIONS(2399),
    [anon_sym_public] = ACTIONS(2399),
    [anon_sym_var] = ACTIONS(2399),
    [anon_sym_while] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_try] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2401),
    [sym_number] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2399),
    [anon_sym_function] = ACTIONS(2399),
    [sym_undefined] = ACTIONS(2399),
    [anon_sym_new] = ACTIONS(2399),
    [ts_builtin_sym_end] = ACTIONS(2401),
    [anon_sym_let] = ACTIONS(2399),
    [anon_sym_PLUS] = ACTIONS(2399),
    [anon_sym_export] = ACTIONS(2399),
    [anon_sym_do] = ACTIONS(2399),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_with] = ACTIONS(2399),
  },
  [480] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(2405),
    [anon_sym_class] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [481] = {
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [anon_sym_debugger] = ACTIONS(2407),
    [anon_sym_symbol] = ACTIONS(2407),
    [anon_sym_AT] = ACTIONS(2409),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_void] = ACTIONS(2407),
    [anon_sym_break] = ACTIONS(2407),
    [anon_sym_const] = ACTIONS(2407),
    [sym_super] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_private] = ACTIONS(2407),
    [anon_sym_get] = ACTIONS(2407),
    [anon_sym_RBRACE] = ACTIONS(2409),
    [anon_sym_interface] = ACTIONS(2407),
    [anon_sym_default] = ACTIONS(2407),
    [anon_sym_enum] = ACTIONS(2407),
    [anon_sym_delete] = ACTIONS(2407),
    [anon_sym_continue] = ACTIONS(2407),
    [anon_sym_DASH_DASH] = ACTIONS(2409),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_this] = ACTIONS(2407),
    [anon_sym_yield] = ACTIONS(2407),
    [sym_true] = ACTIONS(2407),
    [anon_sym_throw] = ACTIONS(2407),
    [anon_sym_protected] = ACTIONS(2407),
    [anon_sym_abstract] = ACTIONS(2407),
    [anon_sym_set] = ACTIONS(2407),
    [anon_sym_type] = ACTIONS(2407),
    [anon_sym_import] = ACTIONS(2407),
    [anon_sym_namespace] = ACTIONS(2407),
    [anon_sym_PLUS_PLUS] = ACTIONS(2409),
    [anon_sym_await] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [anon_sym_else] = ACTIONS(2407),
    [anon_sym_BANG] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [sym_false] = ACTIONS(2407),
    [anon_sym_SEMI] = ACTIONS(2409),
    [anon_sym_case] = ACTIONS(2407),
    [anon_sym_module] = ACTIONS(2407),
    [anon_sym_number] = ACTIONS(2407),
    [anon_sym_class] = ACTIONS(2407),
    [anon_sym_declare] = ACTIONS(2407),
    [anon_sym_typeof] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(2409),
    [anon_sym_switch] = ACTIONS(2407),
    [anon_sym_LPAREN] = ACTIONS(2409),
    [sym_null] = ACTIONS(2407),
    [anon_sym_any] = ACTIONS(2407),
    [anon_sym_boolean] = ACTIONS(2407),
    [anon_sym_async] = ACTIONS(2407),
    [anon_sym_public] = ACTIONS(2407),
    [anon_sym_var] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_SQUOTE] = ACTIONS(2409),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_LT] = ACTIONS(2409),
    [sym_number] = ACTIONS(2409),
    [anon_sym_SLASH] = ACTIONS(2407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2407),
    [anon_sym_function] = ACTIONS(2407),
    [sym_undefined] = ACTIONS(2407),
    [anon_sym_new] = ACTIONS(2407),
    [ts_builtin_sym_end] = ACTIONS(2409),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_export] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [anon_sym_with] = ACTIONS(2407),
  },
  [482] = {
    [sym_class_heritage] = STATE(1161),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_type_parameters] = STATE(1162),
    [sym_class_body] = STATE(1163),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [483] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1169),
    [sym_constructor_type] = STATE(1169),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(1169),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1169),
    [sym_intersection_type] = STATE(1169),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [484] = {
    [anon_sym_EQ] = ACTIONS(2423),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [sym_namespace_import] = STATE(1174),
    [sym_named_imports] = STATE(1174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(234),
  },
  [486] = {
    [sym_nested_identifier] = STATE(1176),
    [anon_sym_require] = ACTIONS(2425),
    [sym_identifier] = ACTIONS(2427),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [anon_sym_EQ] = ACTIONS(2429),
    [anon_sym_COMMA] = ACTIONS(873),
    [anon_sym_from] = ACTIONS(875),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [sym__automatic_semicolon] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(2431),
  },
  [489] = {
    [sym__from_clause] = STATE(1179),
    [anon_sym_from] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [sym_identifier] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [anon_sym_RBRACE] = ACTIONS(2435),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_as] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [anon_sym_from] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [sym_identifier] = ACTIONS(2441),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [anon_sym_RBRACE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [aux_sym_named_imports_repeat1] = STATE(1186),
    [anon_sym_COMMA] = ACTIONS(2445),
    [anon_sym_RBRACE] = ACTIONS(2447),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [sym_identifier] = ACTIONS(2449),
    [anon_sym_BQUOTE] = ACTIONS(2451),
    [anon_sym_debugger] = ACTIONS(2449),
    [anon_sym_symbol] = ACTIONS(2449),
    [anon_sym_AT] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2449),
    [anon_sym_void] = ACTIONS(2449),
    [anon_sym_break] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [sym_super] = ACTIONS(2449),
    [anon_sym_return] = ACTIONS(2449),
    [anon_sym_private] = ACTIONS(2449),
    [anon_sym_get] = ACTIONS(2449),
    [anon_sym_RBRACE] = ACTIONS(2451),
    [anon_sym_interface] = ACTIONS(2449),
    [anon_sym_default] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_delete] = ACTIONS(2449),
    [anon_sym_continue] = ACTIONS(2449),
    [anon_sym_DASH_DASH] = ACTIONS(2451),
    [anon_sym_if] = ACTIONS(2449),
    [anon_sym_this] = ACTIONS(2449),
    [anon_sym_yield] = ACTIONS(2449),
    [sym_true] = ACTIONS(2449),
    [anon_sym_throw] = ACTIONS(2449),
    [anon_sym_protected] = ACTIONS(2449),
    [anon_sym_abstract] = ACTIONS(2449),
    [anon_sym_set] = ACTIONS(2449),
    [anon_sym_type] = ACTIONS(2449),
    [anon_sym_import] = ACTIONS(2449),
    [anon_sym_namespace] = ACTIONS(2449),
    [anon_sym_PLUS_PLUS] = ACTIONS(2451),
    [anon_sym_await] = ACTIONS(2449),
    [anon_sym_DQUOTE] = ACTIONS(2451),
    [anon_sym_else] = ACTIONS(2449),
    [anon_sym_BANG] = ACTIONS(2451),
    [anon_sym_for] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [sym_false] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym_case] = ACTIONS(2449),
    [anon_sym_module] = ACTIONS(2449),
    [anon_sym_number] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_declare] = ACTIONS(2449),
    [anon_sym_typeof] = ACTIONS(2449),
    [anon_sym_LBRACE] = ACTIONS(2451),
    [anon_sym_switch] = ACTIONS(2449),
    [anon_sym_LPAREN] = ACTIONS(2451),
    [sym_null] = ACTIONS(2449),
    [anon_sym_any] = ACTIONS(2449),
    [anon_sym_boolean] = ACTIONS(2449),
    [anon_sym_async] = ACTIONS(2449),
    [anon_sym_public] = ACTIONS(2449),
    [anon_sym_var] = ACTIONS(2449),
    [anon_sym_while] = ACTIONS(2449),
    [anon_sym_SQUOTE] = ACTIONS(2451),
    [anon_sym_try] = ACTIONS(2449),
    [anon_sym_LT] = ACTIONS(2451),
    [sym_number] = ACTIONS(2451),
    [anon_sym_SLASH] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2449),
    [anon_sym_function] = ACTIONS(2449),
    [sym_undefined] = ACTIONS(2449),
    [anon_sym_new] = ACTIONS(2449),
    [ts_builtin_sym_end] = ACTIONS(2451),
    [anon_sym_let] = ACTIONS(2449),
    [anon_sym_PLUS] = ACTIONS(2449),
    [anon_sym_export] = ACTIONS(2449),
    [anon_sym_do] = ACTIONS(2449),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_with] = ACTIONS(2449),
  },
  [497] = {
    [sym_string] = STATE(1187),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [498] = {
    [sym_identifier] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [sym_type_alias_declaration] = STATE(1007),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(1007),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(1007),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(1007),
    [sym_return_statement] = STATE(1007),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(1007),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(1007),
    [sym_switch_statement] = STATE(1007),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(1007),
    [sym_throw_statement] = STATE(1007),
    [aux_sym_program_repeat1] = STATE(1007),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(1007),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(1007),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(1007),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(1007),
    [sym_abstract_class] = STATE(1007),
    [sym_interface_declaration] = STATE(1007),
    [sym_statement_block] = STATE(1007),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(1007),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(1007),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(1007),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(1007),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(1007),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(1007),
    [sym_empty_statement] = STATE(1007),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(1007),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(1007),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(1007),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_labeled_statement] = STATE(1007),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(1007),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [500] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2457),
    [sym_identifier] = ACTIONS(2459),
    [sym__automatic_semicolon] = ACTIONS(2457),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2459),
    [ts_builtin_sym_end] = ACTIONS(2457),
    [anon_sym_symbol] = ACTIONS(2459),
    [anon_sym_AT] = ACTIONS(2457),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_COMMA] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_GT_GT_GT] = ACTIONS(2457),
    [anon_sym_void] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2459),
    [anon_sym_BANG_EQ] = ACTIONS(2459),
    [anon_sym_const] = ACTIONS(2459),
    [anon_sym_GT_EQ] = ACTIONS(2457),
    [sym_super] = ACTIONS(2459),
    [anon_sym_return] = ACTIONS(2459),
    [anon_sym_private] = ACTIONS(2459),
    [anon_sym_get] = ACTIONS(2459),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_PERCENT] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2459),
    [anon_sym_default] = ACTIONS(2459),
    [anon_sym_as] = ACTIONS(2459),
    [anon_sym_delete] = ACTIONS(2459),
    [anon_sym_continue] = ACTIONS(2459),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2459),
    [anon_sym_instanceof] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(2459),
    [anon_sym_yield] = ACTIONS(2459),
    [sym_true] = ACTIONS(2459),
    [anon_sym_throw] = ACTIONS(2459),
    [anon_sym_enum] = ACTIONS(2459),
    [anon_sym_protected] = ACTIONS(2459),
    [anon_sym_abstract] = ACTIONS(2459),
    [anon_sym_DOT] = ACTIONS(2459),
    [anon_sym_set] = ACTIONS(2459),
    [anon_sym_type] = ACTIONS(2459),
    [anon_sym_STAR_STAR] = ACTIONS(2457),
    [anon_sym_import] = ACTIONS(2459),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2457),
    [anon_sym_namespace] = ACTIONS(2459),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_await] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_else] = ACTIONS(2459),
    [anon_sym_BANG] = ACTIONS(2459),
    [anon_sym_for] = ACTIONS(2459),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [sym_false] = ACTIONS(2459),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_case] = ACTIONS(2459),
    [anon_sym_module] = ACTIONS(2459),
    [anon_sym_number] = ACTIONS(2459),
    [anon_sym_class] = ACTIONS(2459),
    [anon_sym_declare] = ACTIONS(2459),
    [anon_sym_typeof] = ACTIONS(2459),
    [anon_sym_LT_LT] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_AMP_AMP] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [sym_null] = ACTIONS(2459),
    [anon_sym_GT] = ACTIONS(2459),
    [anon_sym_any] = ACTIONS(2459),
    [anon_sym_boolean] = ACTIONS(2459),
    [anon_sym_async] = ACTIONS(2459),
    [anon_sym_public] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2459),
    [anon_sym_var] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_PIPE_PIPE] = ACTIONS(2457),
    [anon_sym_while] = ACTIONS(2459),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2459),
    [anon_sym_EQ_EQ] = ACTIONS(2459),
    [anon_sym_RPAREN] = ACTIONS(2457),
    [anon_sym_LT] = ACTIONS(2459),
    [sym_number] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2459),
    [anon_sym_function] = ACTIONS(2459),
    [sym_undefined] = ACTIONS(2459),
    [anon_sym_new] = ACTIONS(2459),
    [anon_sym_CARET] = ACTIONS(2457),
    [anon_sym_let] = ACTIONS(2459),
    [anon_sym_PLUS] = ACTIONS(2459),
    [anon_sym_export] = ACTIONS(2459),
    [anon_sym_GT_GT] = ACTIONS(2459),
    [anon_sym_do] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2459),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2457),
    [anon_sym_in] = ACTIONS(2459),
  },
  [501] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2461),
    [sym__automatic_semicolon] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2463),
    [anon_sym_BQUOTE] = ACTIONS(2461),
    [anon_sym_debugger] = ACTIONS(2463),
    [anon_sym_with] = ACTIONS(2463),
    [anon_sym_symbol] = ACTIONS(2463),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_DASH] = ACTIONS(2463),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2461),
    [anon_sym_void] = ACTIONS(2463),
    [anon_sym_break] = ACTIONS(2463),
    [anon_sym_BANG_EQ] = ACTIONS(2463),
    [anon_sym_const] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [sym_super] = ACTIONS(2463),
    [anon_sym_return] = ACTIONS(2463),
    [anon_sym_private] = ACTIONS(2463),
    [anon_sym_get] = ACTIONS(2463),
    [anon_sym_RBRACE] = ACTIONS(2461),
    [anon_sym_PERCENT] = ACTIONS(2461),
    [anon_sym_interface] = ACTIONS(2463),
    [anon_sym_default] = ACTIONS(2463),
    [anon_sym_as] = ACTIONS(2463),
    [anon_sym_delete] = ACTIONS(2463),
    [anon_sym_continue] = ACTIONS(2463),
    [anon_sym_DASH_DASH] = ACTIONS(2461),
    [anon_sym_if] = ACTIONS(2463),
    [anon_sym_instanceof] = ACTIONS(2463),
    [anon_sym_this] = ACTIONS(2463),
    [anon_sym_yield] = ACTIONS(2463),
    [sym_true] = ACTIONS(2463),
    [anon_sym_throw] = ACTIONS(2463),
    [anon_sym_enum] = ACTIONS(2463),
    [anon_sym_COLON] = ACTIONS(2461),
    [anon_sym_protected] = ACTIONS(2463),
    [anon_sym_abstract] = ACTIONS(2463),
    [anon_sym_DOT] = ACTIONS(2463),
    [anon_sym_set] = ACTIONS(2463),
    [anon_sym_type] = ACTIONS(2463),
    [anon_sym_STAR_STAR] = ACTIONS(2461),
    [anon_sym_import] = ACTIONS(2463),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2461),
    [anon_sym_namespace] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(2461),
    [anon_sym_await] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2461),
    [anon_sym_else] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2463),
    [anon_sym_for] = ACTIONS(2463),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [sym_false] = ACTIONS(2463),
    [anon_sym_SEMI] = ACTIONS(2461),
    [anon_sym_case] = ACTIONS(2463),
    [anon_sym_module] = ACTIONS(2463),
    [anon_sym_number] = ACTIONS(2463),
    [anon_sym_class] = ACTIONS(2463),
    [anon_sym_declare] = ACTIONS(2463),
    [anon_sym_typeof] = ACTIONS(2463),
    [anon_sym_LT_LT] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_AMP_AMP] = ACTIONS(2461),
    [anon_sym_switch] = ACTIONS(2463),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_LPAREN] = ACTIONS(2461),
    [sym_null] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_any] = ACTIONS(2463),
    [anon_sym_boolean] = ACTIONS(2463),
    [anon_sym_async] = ACTIONS(2463),
    [anon_sym_public] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(2463),
    [anon_sym_var] = ACTIONS(2463),
    [anon_sym_QMARK] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2461),
    [anon_sym_while] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2461),
    [anon_sym_try] = ACTIONS(2463),
    [anon_sym_EQ_EQ] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(2461),
    [anon_sym_LT] = ACTIONS(2463),
    [sym_number] = ACTIONS(2461),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(2461),
    [anon_sym_string] = ACTIONS(2463),
    [anon_sym_function] = ACTIONS(2463),
    [sym_undefined] = ACTIONS(2463),
    [anon_sym_CARET] = ACTIONS(2461),
    [anon_sym_new] = ACTIONS(2463),
    [anon_sym_PLUS] = ACTIONS(2463),
    [anon_sym_let] = ACTIONS(2463),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_export] = ACTIONS(2463),
    [anon_sym_do] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2461),
    [anon_sym_in] = ACTIONS(2463),
  },
  [502] = {
    [aux_sym_string_repeat1] = STATE(502),
    [sym_escape_sequence] = ACTIONS(2465),
    [aux_sym_string_token1] = ACTIONS(2465),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [sym_comment] = ACTIONS(246),
  },
  [503] = {
    [sym_array] = STATE(1192),
    [sym_object] = STATE(1193),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_var] = ACTIONS(2472),
    [anon_sym_const] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(2472),
  },
  [504] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2476),
  },
  [505] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(1197),
    [sym_object] = STATE(1198),
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [506] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(1197),
    [sym_object] = STATE(1198),
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [507] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(1199),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(1199),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [508] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(2480),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2482),
  },
  [509] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(2484),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2486),
  },
  [510] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(909),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_GT_GT_GT] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(911),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_DASH_DASH] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_instanceof] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(909),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_implements] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_PLUS_PLUS] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_in] = ACTIONS(911),
  },
  [511] = {
    [aux_sym_string_repeat1] = STATE(502),
    [sym_escape_sequence] = ACTIONS(913),
    [aux_sym_string_token1] = ACTIONS(913),
    [anon_sym_DQUOTE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(246),
  },
  [512] = {
    [sym_new_expression] = STATE(1207),
    [sym_augmented_assignment_expression] = STATE(1207),
    [sym_unary_expression] = STATE(1207),
    [sym_update_expression] = STATE(1207),
    [sym_regex] = STATE(1207),
    [sym_meta_property] = STATE(1207),
    [sym_call_signature] = STATE(158),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1207),
    [sym_as_expression] = STATE(1207),
    [sym_non_null_expression] = STATE(1207),
    [sym_internal_module] = STATE(1207),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1207),
    [sym_await_expression] = STATE(1207),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1207),
    [sym_this] = STATE(1207),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1207),
    [sym_generator_function] = STATE(1207),
    [sym_call_expression] = STATE(1207),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1207),
    [sym_ternary_expression] = STATE(1207),
    [sym_binary_expression] = STATE(1207),
    [sym_template_string] = STATE(1207),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1207),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1207),
    [sym_class] = STATE(1207),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2490),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2494),
    [sym_true] = ACTIONS(2490),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2490),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [513] = {
    [sym_new_expression] = STATE(1208),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_unary_expression] = STATE(1208),
    [sym_update_expression] = STATE(1208),
    [sym_regex] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1208),
    [sym_yield_expression] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_non_null_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1208),
    [sym_await_expression] = STATE(1208),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1208),
    [sym_this] = STATE(1208),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1208),
    [sym_generator_function] = STATE(1208),
    [sym_call_expression] = STATE(1208),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1208),
    [sym_ternary_expression] = STATE(1208),
    [sym_binary_expression] = STATE(1208),
    [sym_template_string] = STATE(1208),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1208),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1208),
    [sym_class] = STATE(1208),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2496),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2498),
    [sym_true] = ACTIONS(2496),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2496),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [514] = {
    [sym_new_expression] = STATE(1209),
    [sym_augmented_assignment_expression] = STATE(1209),
    [sym_unary_expression] = STATE(1209),
    [sym_update_expression] = STATE(1209),
    [sym_regex] = STATE(1209),
    [sym_meta_property] = STATE(1209),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1209),
    [sym_yield_expression] = STATE(1209),
    [sym_as_expression] = STATE(1209),
    [sym_non_null_expression] = STATE(1209),
    [sym_internal_module] = STATE(1209),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1209),
    [sym_await_expression] = STATE(1209),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1209),
    [sym_this] = STATE(1209),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1209),
    [sym_generator_function] = STATE(1209),
    [sym_call_expression] = STATE(1209),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1209),
    [sym_ternary_expression] = STATE(1209),
    [sym_binary_expression] = STATE(1209),
    [sym_template_string] = STATE(1209),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1209),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1209),
    [sym_class] = STATE(1209),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2500),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2500),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [515] = {
    [sym_new_expression] = STATE(1210),
    [sym_augmented_assignment_expression] = STATE(1210),
    [sym_unary_expression] = STATE(1210),
    [sym_update_expression] = STATE(1210),
    [sym_regex] = STATE(1210),
    [sym_meta_property] = STATE(1210),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1210),
    [sym_yield_expression] = STATE(1210),
    [sym_as_expression] = STATE(1210),
    [sym_non_null_expression] = STATE(1210),
    [sym_internal_module] = STATE(1210),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1210),
    [sym_await_expression] = STATE(1210),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1210),
    [sym_this] = STATE(1210),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1210),
    [sym_generator_function] = STATE(1210),
    [sym_call_expression] = STATE(1210),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1210),
    [sym_ternary_expression] = STATE(1210),
    [sym_binary_expression] = STATE(1210),
    [sym_template_string] = STATE(1210),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1210),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1210),
    [sym_class] = STATE(1210),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2504),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2506),
    [sym_true] = ACTIONS(2504),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2504),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [516] = {
    [sym_identifier] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
  },
  [517] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_BANG] = ACTIONS(638),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_GT_GT_GT] = ACTIONS(636),
    [anon_sym_AMP_AMP] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_BANG_EQ] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_RBRACK] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_QMARK] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(636),
    [anon_sym_PIPE_PIPE] = ACTIONS(636),
    [anon_sym_LBRACE_PIPE] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(638),
    [anon_sym_instanceof] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_RPAREN] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_implements] = ACTIONS(636),
    [anon_sym_GT_GT] = ACTIONS(638),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_in] = ACTIONS(638),
  },
  [518] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(670),
    [anon_sym_BQUOTE] = ACTIONS(668),
    [anon_sym_PIPE] = ACTIONS(670),
    [anon_sym_COMMA] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(670),
    [anon_sym_GT_GT_GT] = ACTIONS(668),
    [anon_sym_AMP_AMP] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(670),
    [anon_sym_BANG_EQ] = ACTIONS(670),
    [anon_sym_LT_EQ] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(668),
    [anon_sym_RBRACK] = ACTIONS(668),
    [anon_sym_GT_EQ] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_QMARK] = ACTIONS(668),
    [anon_sym_RBRACE] = ACTIONS(668),
    [anon_sym_as] = ACTIONS(668),
    [anon_sym_PIPE_PIPE] = ACTIONS(668),
    [anon_sym_LBRACE_PIPE] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(670),
    [anon_sym_instanceof] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(670),
    [anon_sym_RPAREN] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(668),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(668),
    [anon_sym_STAR_STAR] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_implements] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(668),
    [anon_sym_in] = ACTIONS(670),
  },
  [519] = {
    [aux_sym_template_string_repeat1] = STATE(382),
    [sym_template_substitution] = STATE(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [sym_escape_sequence] = ACTIONS(672),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [sym__template_chars] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [sym_new_expression] = STATE(1214),
    [sym_augmented_assignment_expression] = STATE(1214),
    [sym_unary_expression] = STATE(1214),
    [sym_update_expression] = STATE(1214),
    [sym_regex] = STATE(1214),
    [sym_meta_property] = STATE(1214),
    [sym_call_signature] = STATE(158),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(1214),
    [sym_yield_expression] = STATE(1214),
    [sym_as_expression] = STATE(1214),
    [sym_non_null_expression] = STATE(1214),
    [sym_internal_module] = STATE(1214),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1214),
    [sym_await_expression] = STATE(1214),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1214),
    [sym_this] = STATE(1214),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1214),
    [sym_generator_function] = STATE(1214),
    [sym_call_expression] = STATE(1214),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1214),
    [sym_ternary_expression] = STATE(1214),
    [sym_binary_expression] = STATE(1214),
    [sym_template_string] = STATE(1214),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1214),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1214),
    [sym_class] = STATE(1214),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2512),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2514),
    [sym_true] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2512),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [521] = {
    [sym_new_expression] = STATE(1215),
    [sym_augmented_assignment_expression] = STATE(1215),
    [sym_unary_expression] = STATE(1215),
    [sym_update_expression] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1215),
    [sym_yield_expression] = STATE(1215),
    [sym_as_expression] = STATE(1215),
    [sym_non_null_expression] = STATE(1215),
    [sym_internal_module] = STATE(1215),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1215),
    [sym_await_expression] = STATE(1215),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1215),
    [sym_this] = STATE(1215),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_call_expression] = STATE(1215),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1215),
    [sym_ternary_expression] = STATE(1215),
    [sym_binary_expression] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1215),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1215),
    [sym_class] = STATE(1215),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2516),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2518),
    [sym_true] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2516),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [522] = {
    [sym_identifier] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(690),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(692),
    [anon_sym_GT_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(692),
    [anon_sym_LBRACE] = ACTIONS(692),
    [anon_sym_BANG_EQ] = ACTIONS(692),
    [anon_sym_LT_EQ] = ACTIONS(690),
    [anon_sym_LPAREN] = ACTIONS(690),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_GT_EQ] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(692),
    [anon_sym_PERCENT] = ACTIONS(690),
    [anon_sym_QMARK] = ACTIONS(690),
    [anon_sym_RBRACE] = ACTIONS(690),
    [anon_sym_as] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LBRACE_PIPE] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_EQ_EQ] = ACTIONS(692),
    [anon_sym_instanceof] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(690),
    [anon_sym_DOT] = ACTIONS(690),
    [anon_sym_CARET] = ACTIONS(690),
    [anon_sym_STAR_STAR] = ACTIONS(690),
    [anon_sym_PLUS] = ACTIONS(692),
    [anon_sym_implements] = ACTIONS(690),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(690),
    [anon_sym_in] = ACTIONS(692),
  },
  [524] = {
    [sym_class_heritage] = STATE(1217),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_type_parameters] = STATE(1218),
    [sym_class_body] = STATE(1219),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [525] = {
    [sym_public_field_definition] = STATE(630),
    [sym__property_name] = STATE(631),
    [sym_decorator] = STATE(1221),
    [sym_method_signature] = STATE(630),
    [sym_accessibility_modifier] = STATE(632),
    [sym_abstract_method_signature] = STATE(630),
    [sym_computed_property_name] = STATE(631),
    [aux_sym_class_body_repeat1] = STATE(1221),
    [sym_index_signature] = STATE(630),
    [sym_string] = STATE(631),
    [sym_method_definition] = STATE(634),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1129),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(2522),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_abstract] = ACTIONS(1139),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [526] = {
    [sym_class_body] = STATE(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [527] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1147),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_BQUOTE] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1147),
    [anon_sym_STAR] = ACTIONS(1149),
    [anon_sym_GT_GT_GT] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_BANG_EQ] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [anon_sym_RBRACK] = ACTIONS(1147),
    [anon_sym_GT_EQ] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1149),
    [anon_sym_PERCENT] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_PIPE_PIPE] = ACTIONS(1147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1147),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [anon_sym_EQ_EQ] = ACTIONS(1149),
    [anon_sym_instanceof] = ACTIONS(1147),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_RPAREN] = ACTIONS(1147),
    [anon_sym_SLASH] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_STAR_STAR] = ACTIONS(1147),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_implements] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(1149),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1149),
  },
  [528] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(2524),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [529] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(2524),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [530] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(2527),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2527),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [531] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [532] = {
    [anon_sym_RPAREN] = ACTIONS(2529),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [sym_comment] = ACTIONS(3),
  },
  [533] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [sym_type_annotation] = STATE(1224),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(1331),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_RPAREN] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [534] = {
    [anon_sym_RPAREN] = ACTIONS(2531),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [sym_new_expression] = STATE(1225),
    [sym_augmented_assignment_expression] = STATE(1225),
    [sym_unary_expression] = STATE(1225),
    [sym_update_expression] = STATE(1225),
    [sym_regex] = STATE(1225),
    [sym_meta_property] = STATE(1225),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1225),
    [sym_yield_expression] = STATE(1225),
    [sym_as_expression] = STATE(1225),
    [sym_non_null_expression] = STATE(1225),
    [sym_internal_module] = STATE(1225),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1225),
    [sym_await_expression] = STATE(1225),
    [sym_member_expression] = STATE(161),
    [sym_sequence_expression] = STATE(1226),
    [sym_string] = STATE(1225),
    [sym_this] = STATE(1225),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1225),
    [sym_generator_function] = STATE(1225),
    [sym_call_expression] = STATE(1225),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1225),
    [sym_ternary_expression] = STATE(1225),
    [sym_binary_expression] = STATE(1225),
    [sym_template_string] = STATE(1225),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1225),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1225),
    [sym_class] = STATE(1225),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2533),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2535),
    [sym_true] = ACTIONS(2533),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2533),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [536] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(811),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(811),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_as] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_implements] = ACTIONS(811),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(811),
    [anon_sym_in] = ACTIONS(813),
  },
  [537] = {
    [sym_template_string] = STATE(1227),
    [sym_arguments] = STATE(1227),
    [anon_sym_LPAREN] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(258),
  },
  [538] = {
    [anon_sym_EQ_GT] = ACTIONS(2537),
    [sym_comment] = ACTIONS(3),
  },
  [539] = {
    [anon_sym_EQ_GT] = ACTIONS(2539),
    [sym_comment] = ACTIONS(3),
  },
  [540] = {
    [sym_call_signature] = STATE(1231),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(2541),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [aux_sym_string_repeat2] = STATE(778),
    [sym_escape_sequence] = ACTIONS(1458),
    [aux_sym_string_token2] = ACTIONS(1458),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(2488),
  },
  [542] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_RBRACK] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [543] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [544] = {
    [anon_sym_SLASH2] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
  },
  [545] = {
    [sym_call_signature] = STATE(1231),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [546] = {
    [sym_call_signature] = STATE(1234),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [547] = {
    [sym_statement_block] = STATE(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2547),
  },
  [548] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_RBRACK] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [549] = {
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_RBRACK] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1599),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1599),
    [anon_sym_DOT] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1599),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_implements] = ACTIONS(1599),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [550] = {
    [anon_sym_target] = ACTIONS(2549),
    [sym_comment] = ACTIONS(3),
  },
  [551] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_RBRACK] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [552] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_RBRACK] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [553] = {
    [sym_call_signature] = STATE(538),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(983),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(985),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(985),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(985),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_RBRACK] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(985),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_public] = ACTIONS(985),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [554] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_RBRACK] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [555] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(1643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1649),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_GT_GT_GT] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1653),
    [anon_sym_BANG_EQ] = ACTIONS(1643),
    [anon_sym_LT_EQ] = ACTIONS(1641),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1655),
    [anon_sym_PERCENT] = ACTIONS(1647),
    [anon_sym_QMARK] = ACTIONS(1657),
    [anon_sym_PIPE_PIPE] = ACTIONS(1659),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1643),
    [anon_sym_instanceof] = ACTIONS(1641),
    [anon_sym_LT] = ACTIONS(1663),
    [anon_sym_SLASH] = ACTIONS(1651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1659),
    [anon_sym_STAR_STAR] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1651),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [556] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(1237),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(1599),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_RBRACK] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1599),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1599),
    [anon_sym_DOT] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1599),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_implements] = ACTIONS(1599),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [557] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_RBRACK] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1599),
    [anon_sym_COLON] = ACTIONS(1599),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_implements] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [558] = {
    [sym__initializer] = STATE(577),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_RBRACK] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1599),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1599),
    [anon_sym_DOT] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1599),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_implements] = ACTIONS(1599),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [559] = {
    [sym__initializer] = STATE(580),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_RBRACK] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1599),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1599),
    [anon_sym_DOT] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1599),
    [anon_sym_STAR_STAR] = ACTIONS(1599),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_implements] = ACTIONS(1599),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [560] = {
    [sym_statement_block] = STATE(1241),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(895),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_STAR] = ACTIONS(897),
    [anon_sym_GT_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(2551),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RBRACK] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(897),
    [anon_sym_PERCENT] = ACTIONS(895),
    [anon_sym_QMARK] = ACTIONS(895),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_as] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_EQ_EQ] = ACTIONS(897),
    [anon_sym_instanceof] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(895),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_implements] = ACTIONS(895),
    [anon_sym_GT_GT] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(895),
    [anon_sym_in] = ACTIONS(897),
  },
  [561] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_BQUOTE] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_GT_GT_GT] = ACTIONS(903),
    [anon_sym_AMP_AMP] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RBRACK] = ACTIONS(903),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_as] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_instanceof] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_COLON] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_STAR_STAR] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_implements] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_in] = ACTIONS(905),
  },
  [562] = {
    [sym_statement_block] = STATE(1241),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(895),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_STAR] = ACTIONS(897),
    [anon_sym_GT_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(2551),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RBRACK] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(897),
    [anon_sym_PERCENT] = ACTIONS(895),
    [anon_sym_QMARK] = ACTIONS(895),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_as] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_EQ_EQ] = ACTIONS(897),
    [anon_sym_instanceof] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(895),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_implements] = ACTIONS(895),
    [anon_sym_GT_GT] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(895),
    [anon_sym_in] = ACTIONS(897),
  },
  [563] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [564] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1914),
    [anon_sym_LBRACK] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [anon_sym_PIPE] = ACTIONS(1916),
    [anon_sym_COMMA] = ACTIONS(1914),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_GT_GT_GT] = ACTIONS(1914),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1916),
    [anon_sym_BANG_EQ] = ACTIONS(1916),
    [anon_sym_LT_EQ] = ACTIONS(1914),
    [anon_sym_LPAREN] = ACTIONS(1914),
    [anon_sym_RBRACK] = ACTIONS(1914),
    [anon_sym_GT_EQ] = ACTIONS(1914),
    [anon_sym_GT] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym_PERCENT] = ACTIONS(1914),
    [anon_sym_QMARK] = ACTIONS(1914),
    [anon_sym_RBRACE] = ACTIONS(1914),
    [anon_sym_as] = ACTIONS(1914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1914),
    [anon_sym_DASH_DASH] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(1916),
    [anon_sym_instanceof] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_RPAREN] = ACTIONS(1914),
    [anon_sym_SLASH] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1914),
    [anon_sym_DOT] = ACTIONS(1914),
    [anon_sym_CARET] = ACTIONS(1914),
    [anon_sym_STAR_STAR] = ACTIONS(1914),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_implements] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_PLUS_PLUS] = ACTIONS(1914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1914),
    [anon_sym_in] = ACTIONS(1916),
  },
  [565] = {
    [sym_new_expression] = STATE(1242),
    [sym_augmented_assignment_expression] = STATE(1242),
    [sym_unary_expression] = STATE(1242),
    [sym_update_expression] = STATE(1242),
    [sym_regex] = STATE(1242),
    [sym_meta_property] = STATE(1242),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1242),
    [sym_yield_expression] = STATE(1242),
    [sym_as_expression] = STATE(1242),
    [sym_non_null_expression] = STATE(1242),
    [sym_internal_module] = STATE(1242),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1242),
    [sym_await_expression] = STATE(1242),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1242),
    [sym_this] = STATE(1242),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1242),
    [sym_generator_function] = STATE(1242),
    [sym_call_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1242),
    [sym_ternary_expression] = STATE(1242),
    [sym_binary_expression] = STATE(1242),
    [sym_template_string] = STATE(1242),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1242),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1242),
    [sym_class] = STATE(1242),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2555),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2555),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2557),
    [sym_true] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2555),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [566] = {
    [sym_new_expression] = STATE(1243),
    [sym_augmented_assignment_expression] = STATE(1243),
    [sym_unary_expression] = STATE(1243),
    [sym_update_expression] = STATE(1243),
    [sym_regex] = STATE(1243),
    [sym_meta_property] = STATE(1243),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1243),
    [sym_yield_expression] = STATE(1243),
    [sym_as_expression] = STATE(1243),
    [sym_non_null_expression] = STATE(1243),
    [sym_internal_module] = STATE(1243),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1243),
    [sym_await_expression] = STATE(1243),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1243),
    [sym_this] = STATE(1243),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1243),
    [sym_generator_function] = STATE(1243),
    [sym_call_expression] = STATE(1243),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1243),
    [sym_ternary_expression] = STATE(1243),
    [sym_binary_expression] = STATE(1243),
    [sym_template_string] = STATE(1243),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1243),
    [sym_class] = STATE(1243),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2559),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2559),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2561),
    [sym_true] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2559),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [567] = {
    [sym_new_expression] = STATE(1244),
    [sym_augmented_assignment_expression] = STATE(1244),
    [sym_unary_expression] = STATE(1244),
    [sym_update_expression] = STATE(1244),
    [sym_regex] = STATE(1244),
    [sym_meta_property] = STATE(1244),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1244),
    [sym_yield_expression] = STATE(1244),
    [sym_as_expression] = STATE(1244),
    [sym_non_null_expression] = STATE(1244),
    [sym_internal_module] = STATE(1244),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1244),
    [sym_await_expression] = STATE(1244),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1244),
    [sym_this] = STATE(1244),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1244),
    [sym_generator_function] = STATE(1244),
    [sym_call_expression] = STATE(1244),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1244),
    [sym_ternary_expression] = STATE(1244),
    [sym_binary_expression] = STATE(1244),
    [sym_template_string] = STATE(1244),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1244),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1244),
    [sym_class] = STATE(1244),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2563),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2565),
    [sym_true] = ACTIONS(2563),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2563),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [568] = {
    [sym_new_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_non_null_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1245),
    [sym_this] = STATE(1245),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1245),
    [sym_generator_function] = STATE(1245),
    [sym_call_expression] = STATE(1245),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1245),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1245),
    [sym_class] = STATE(1245),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2567),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2569),
    [sym_true] = ACTIONS(2567),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [569] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2571),
    [anon_sym_LBRACK] = ACTIONS(2571),
    [anon_sym_BANG] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2571),
    [anon_sym_BQUOTE] = ACTIONS(2571),
    [sym__automatic_semicolon] = ACTIONS(2571),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_COMMA] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2571),
    [anon_sym_STAR] = ACTIONS(2573),
    [anon_sym_GT_GT_GT] = ACTIONS(2571),
    [anon_sym_EQ] = ACTIONS(2573),
    [anon_sym_AMP_AMP] = ACTIONS(2571),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2571),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2571),
    [anon_sym_of] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_PERCENT] = ACTIONS(2571),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_RBRACE] = ACTIONS(2571),
    [anon_sym_as] = ACTIONS(2571),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(2571),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_instanceof] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(2571),
    [anon_sym_SLASH] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2571),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_PLUS_PLUS] = ACTIONS(2571),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2571),
    [anon_sym_in] = ACTIONS(2573),
  },
  [570] = {
    [sym_new_expression] = STATE(1246),
    [sym_augmented_assignment_expression] = STATE(1246),
    [sym_unary_expression] = STATE(1246),
    [sym_update_expression] = STATE(1246),
    [sym_regex] = STATE(1246),
    [sym_meta_property] = STATE(1246),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1246),
    [sym_yield_expression] = STATE(1246),
    [sym_as_expression] = STATE(1246),
    [sym_non_null_expression] = STATE(1246),
    [sym_internal_module] = STATE(1246),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1246),
    [sym_await_expression] = STATE(1246),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1246),
    [sym_this] = STATE(1246),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1246),
    [sym_generator_function] = STATE(1246),
    [sym_call_expression] = STATE(1246),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1246),
    [sym_ternary_expression] = STATE(1246),
    [sym_binary_expression] = STATE(1246),
    [sym_template_string] = STATE(1246),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1246),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1246),
    [sym_class] = STATE(1246),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(2575),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2575),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2577),
    [sym_true] = ACTIONS(2575),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2575),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [571] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [572] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LBRACE] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_RBRACK] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(831),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(831),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_implements] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [573] = {
    [sym_new_expression] = STATE(1208),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1208),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1208),
    [sym_call_signature] = STATE(158),
    [sym_yield_expression] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(161),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(164),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(1208),
    [sym_subscript_expression] = STATE(161),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1208),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1208),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(1208),
    [sym_non_null_expression] = STATE(1208),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1208),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1208),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1208),
    [sym_call_expression] = STATE(1208),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1208),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1208),
    [sym_type_arguments] = STATE(166),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(1208),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1208),
    [sym_class] = STATE(1208),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(2613),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(2617),
    [anon_sym_number] = ACTIONS(2617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(2619),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2621),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(2625),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(2496),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2617),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(2617),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(2617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2496),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(2633),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(2621),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [574] = {
    [sym_new_expression] = STATE(1279),
    [sym_augmented_assignment_expression] = STATE(1279),
    [sym_unary_expression] = STATE(1279),
    [sym_update_expression] = STATE(1279),
    [sym_regex] = STATE(1279),
    [sym_meta_property] = STATE(1279),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1279),
    [sym_yield_expression] = STATE(1279),
    [sym_as_expression] = STATE(1279),
    [sym_non_null_expression] = STATE(1279),
    [sym_internal_module] = STATE(1279),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1279),
    [sym_await_expression] = STATE(1279),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(1279),
    [sym_this] = STATE(1279),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1279),
    [sym_generator_function] = STATE(1279),
    [sym_call_expression] = STATE(1279),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1279),
    [sym_ternary_expression] = STATE(1279),
    [sym_binary_expression] = STATE(1279),
    [sym_template_string] = STATE(1279),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1279),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1279),
    [sym_class] = STATE(1279),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2635),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2637),
    [sym_true] = ACTIONS(2635),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2635),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [575] = {
    [aux_sym_array_repeat1] = STATE(578),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
  },
  [576] = {
    [sym_class_heritage] = STATE(1282),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(1222),
    [anon_sym_extends] = ACTIONS(314),
    [anon_sym_implements] = ACTIONS(316),
    [sym_identifier] = ACTIONS(2641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [577] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1896),
    [anon_sym_LBRACK] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1898),
    [anon_sym_BQUOTE] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_COMMA] = ACTIONS(1896),
    [anon_sym_LT_LT] = ACTIONS(1896),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT_GT] = ACTIONS(1896),
    [anon_sym_AMP_AMP] = ACTIONS(1896),
    [anon_sym_DASH] = ACTIONS(1898),
    [anon_sym_LBRACE] = ACTIONS(1898),
    [anon_sym_BANG_EQ] = ACTIONS(1898),
    [anon_sym_LT_EQ] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1896),
    [anon_sym_RBRACK] = ACTIONS(1896),
    [anon_sym_GT_EQ] = ACTIONS(1896),
    [anon_sym_GT] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1896),
    [anon_sym_QMARK] = ACTIONS(1896),
    [anon_sym_RBRACE] = ACTIONS(1896),
    [anon_sym_as] = ACTIONS(1896),
    [anon_sym_PIPE_PIPE] = ACTIONS(1896),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1896),
    [anon_sym_DASH_DASH] = ACTIONS(1896),
    [anon_sym_EQ_EQ] = ACTIONS(1898),
    [anon_sym_instanceof] = ACTIONS(1896),
    [anon_sym_LT] = ACTIONS(1898),
    [anon_sym_RPAREN] = ACTIONS(1896),
    [anon_sym_SLASH] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1896),
    [anon_sym_DOT] = ACTIONS(1896),
    [anon_sym_CARET] = ACTIONS(1896),
    [anon_sym_STAR_STAR] = ACTIONS(1896),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_implements] = ACTIONS(1896),
    [anon_sym_GT_GT] = ACTIONS(1898),
    [anon_sym_PLUS_PLUS] = ACTIONS(1896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1896),
    [anon_sym_in] = ACTIONS(1898),
  },
  [578] = {
    [aux_sym_array_repeat1] = STATE(578),
    [anon_sym_COMMA] = ACTIONS(2643),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [sym_comment] = ACTIONS(3),
  },
  [579] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(2039),
    [anon_sym_BQUOTE] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(2037),
    [anon_sym_LT_LT] = ACTIONS(2037),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_GT_GT_GT] = ACTIONS(2037),
    [anon_sym_AMP_AMP] = ACTIONS(2037),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_LBRACE] = ACTIONS(2039),
    [anon_sym_BANG_EQ] = ACTIONS(2039),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_RBRACK] = ACTIONS(2037),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2037),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_as] = ACTIONS(2037),
    [anon_sym_PIPE_PIPE] = ACTIONS(2037),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_EQ_EQ] = ACTIONS(2039),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2039),
    [anon_sym_RPAREN] = ACTIONS(2037),
    [anon_sym_SLASH] = ACTIONS(2039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(2037),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_implements] = ACTIONS(2037),
    [anon_sym_GT_GT] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_in] = ACTIONS(2039),
  },
  [580] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2041),
    [anon_sym_LBRACK] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(2043),
    [anon_sym_BQUOTE] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_AMP_AMP] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_LBRACE] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2043),
    [anon_sym_LT_EQ] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(2041),
    [anon_sym_RBRACK] = ACTIONS(2041),
    [anon_sym_GT_EQ] = ACTIONS(2041),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2041),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_as] = ACTIONS(2041),
    [anon_sym_PIPE_PIPE] = ACTIONS(2041),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_instanceof] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_RPAREN] = ACTIONS(2041),
    [anon_sym_SLASH] = ACTIONS(2043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2041),
    [anon_sym_DOT] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(2041),
    [anon_sym_GT_GT] = ACTIONS(2043),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2041),
    [anon_sym_in] = ACTIONS(2043),
  },
  [581] = {
    [sym_identifier] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
  },
  [582] = {
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2459),
    [anon_sym_symbol] = ACTIONS(2459),
    [anon_sym_AT] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2459),
    [anon_sym_void] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2459),
    [anon_sym_const] = ACTIONS(2459),
    [sym_super] = ACTIONS(2459),
    [anon_sym_return] = ACTIONS(2459),
    [anon_sym_private] = ACTIONS(2459),
    [anon_sym_get] = ACTIONS(2459),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2459),
    [anon_sym_default] = ACTIONS(2459),
    [anon_sym_enum] = ACTIONS(2459),
    [anon_sym_delete] = ACTIONS(2459),
    [anon_sym_continue] = ACTIONS(2459),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(2459),
    [anon_sym_yield] = ACTIONS(2459),
    [sym_true] = ACTIONS(2459),
    [anon_sym_throw] = ACTIONS(2459),
    [anon_sym_protected] = ACTIONS(2459),
    [anon_sym_abstract] = ACTIONS(2459),
    [anon_sym_set] = ACTIONS(2459),
    [anon_sym_type] = ACTIONS(2459),
    [anon_sym_import] = ACTIONS(2459),
    [anon_sym_namespace] = ACTIONS(2459),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_await] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_else] = ACTIONS(2459),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2459),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [sym_false] = ACTIONS(2459),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_case] = ACTIONS(2459),
    [anon_sym_module] = ACTIONS(2459),
    [anon_sym_number] = ACTIONS(2459),
    [anon_sym_class] = ACTIONS(2459),
    [anon_sym_declare] = ACTIONS(2459),
    [anon_sym_typeof] = ACTIONS(2459),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2459),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [sym_null] = ACTIONS(2459),
    [anon_sym_any] = ACTIONS(2459),
    [anon_sym_boolean] = ACTIONS(2459),
    [anon_sym_async] = ACTIONS(2459),
    [anon_sym_public] = ACTIONS(2459),
    [anon_sym_var] = ACTIONS(2459),
    [anon_sym_while] = ACTIONS(2459),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2457),
    [sym_number] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2459),
    [anon_sym_function] = ACTIONS(2459),
    [sym_undefined] = ACTIONS(2459),
    [anon_sym_new] = ACTIONS(2459),
    [ts_builtin_sym_end] = ACTIONS(2457),
    [anon_sym_let] = ACTIONS(2459),
    [anon_sym_PLUS] = ACTIONS(2459),
    [anon_sym_export] = ACTIONS(2459),
    [anon_sym_do] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2459),
  },
  [583] = {
    [sym_identifier] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(909),
    [anon_sym_debugger] = ACTIONS(911),
    [anon_sym_symbol] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_void] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(911),
    [anon_sym_const] = ACTIONS(911),
    [sym_super] = ACTIONS(911),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_private] = ACTIONS(911),
    [anon_sym_get] = ACTIONS(911),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_interface] = ACTIONS(911),
    [anon_sym_default] = ACTIONS(911),
    [anon_sym_enum] = ACTIONS(911),
    [anon_sym_delete] = ACTIONS(911),
    [anon_sym_continue] = ACTIONS(911),
    [anon_sym_DASH_DASH] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(911),
    [anon_sym_this] = ACTIONS(911),
    [anon_sym_yield] = ACTIONS(911),
    [sym_true] = ACTIONS(911),
    [anon_sym_throw] = ACTIONS(911),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_protected] = ACTIONS(911),
    [anon_sym_abstract] = ACTIONS(911),
    [anon_sym_set] = ACTIONS(911),
    [anon_sym_type] = ACTIONS(911),
    [anon_sym_import] = ACTIONS(911),
    [anon_sym_namespace] = ACTIONS(911),
    [anon_sym_PLUS_PLUS] = ACTIONS(909),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(909),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(909),
    [anon_sym_for] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(909),
    [sym_false] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_case] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(911),
    [anon_sym_number] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(911),
    [anon_sym_declare] = ACTIONS(911),
    [anon_sym_typeof] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_switch] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_RBRACK] = ACTIONS(909),
    [sym_null] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_any] = ACTIONS(911),
    [anon_sym_boolean] = ACTIONS(911),
    [anon_sym_async] = ACTIONS(911),
    [anon_sym_public] = ACTIONS(911),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(909),
    [anon_sym_var] = ACTIONS(911),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_try] = ACTIONS(911),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(909),
    [sym_number] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(911),
    [anon_sym_function] = ACTIONS(911),
    [sym_undefined] = ACTIONS(911),
    [anon_sym_new] = ACTIONS(911),
    [ts_builtin_sym_end] = ACTIONS(909),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(909),
    [anon_sym_with] = ACTIONS(911),
  },
  [584] = {
    [aux_sym_string_repeat2] = STATE(778),
    [sym_escape_sequence] = ACTIONS(1458),
    [aux_sym_string_token2] = ACTIONS(1458),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(2648),
  },
  [585] = {
    [aux_sym_string_repeat1] = STATE(502),
    [sym_escape_sequence] = ACTIONS(913),
    [aux_sym_string_token1] = ACTIONS(913),
    [anon_sym_DQUOTE] = ACTIONS(2648),
    [sym_comment] = ACTIONS(246),
  },
  [586] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2650),
    [anon_sym_AMP_EQ] = ACTIONS(2650),
    [anon_sym_PLUS_EQ] = ACTIONS(2650),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(2652),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2650),
    [anon_sym_STAR_EQ] = ACTIONS(2650),
    [anon_sym_PIPE_EQ] = ACTIONS(2650),
    [anon_sym_DASH_EQ] = ACTIONS(2650),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2650),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2650),
    [anon_sym_GT_GT_EQ] = ACTIONS(2650),
    [anon_sym_DOT] = ACTIONS(2661),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(2652),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2663),
  },
  [587] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2665),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_AMP_EQ] = ACTIONS(2665),
    [anon_sym_PLUS_EQ] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2665),
    [anon_sym_STAR_EQ] = ACTIONS(2665),
    [anon_sym_PIPE_EQ] = ACTIONS(2665),
    [anon_sym_DASH_EQ] = ACTIONS(2665),
    [anon_sym_EQ_GT] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2665),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2665),
    [anon_sym_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [588] = {
    [sym_new_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_non_null_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(1293),
    [sym_this] = STATE(1293),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(1293),
    [sym_generator_function] = STATE(1293),
    [sym_call_expression] = STATE(1293),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(1293),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_template_string] = STATE(1293),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1293),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(1293),
    [sym_class] = STATE(1293),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(2671),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2671),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2673),
    [sym_true] = ACTIONS(2671),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2671),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [589] = {
    [sym_new_expression] = STATE(1294),
    [sym_augmented_assignment_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1294),
    [sym_update_expression] = STATE(1294),
    [sym_regex] = STATE(1294),
    [sym_meta_property] = STATE(1294),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1294),
    [sym_as_expression] = STATE(1294),
    [sym_non_null_expression] = STATE(1294),
    [sym_internal_module] = STATE(1294),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1294),
    [sym_await_expression] = STATE(1294),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(1294),
    [sym_this] = STATE(1294),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(1294),
    [sym_generator_function] = STATE(1294),
    [sym_call_expression] = STATE(1294),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(1294),
    [sym_ternary_expression] = STATE(1294),
    [sym_binary_expression] = STATE(1294),
    [sym_template_string] = STATE(1294),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1294),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(1294),
    [sym_class] = STATE(1294),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(2675),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2675),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2677),
    [sym_true] = ACTIONS(2675),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2675),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [590] = {
    [sym_new_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_non_null_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(1293),
    [sym_this] = STATE(1293),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(1293),
    [sym_generator_function] = STATE(1293),
    [sym_call_expression] = STATE(1293),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(1293),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_template_string] = STATE(1293),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1293),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(1293),
    [sym_class] = STATE(1293),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2665),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_AMP_EQ] = ACTIONS(2665),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2665),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_PIPE_EQ] = ACTIONS(2665),
    [anon_sym_DASH_EQ] = ACTIONS(2665),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2665),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(1095),
    [sym_true] = ACTIONS(2671),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2671),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2671),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_STAR_EQ] = ACTIONS(2665),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_EQ_GT] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2673),
    [anon_sym_SLASH] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2665),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2671),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_implements] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [591] = {
    [sym_call_signature] = STATE(1295),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2665),
    [anon_sym_symbol] = ACTIONS(2681),
    [anon_sym_AMP_EQ] = ACTIONS(2665),
    [anon_sym_PLUS_EQ] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_void] = ACTIONS(2681),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(2665),
    [anon_sym_private] = ACTIONS(2681),
    [anon_sym_PIPE_EQ] = ACTIONS(2665),
    [anon_sym_DASH_EQ] = ACTIONS(2665),
    [anon_sym_get] = ACTIONS(2681),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2665),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(2681),
    [anon_sym_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(2681),
    [anon_sym_type] = ACTIONS(2681),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2681),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_number] = ACTIONS(2681),
    [anon_sym_declare] = ACTIONS(2681),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2681),
    [anon_sym_STAR_EQ] = ACTIONS(2665),
    [anon_sym_boolean] = ACTIONS(2681),
    [anon_sym_async] = ACTIONS(2681),
    [anon_sym_public] = ACTIONS(2681),
    [anon_sym_EQ_GT] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2665),
    [anon_sym_string] = ACTIONS(2681),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_implements] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [592] = {
    [sym_new_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_as_expression] = STATE(1297),
    [sym_non_null_expression] = STATE(1297),
    [sym_internal_module] = STATE(1297),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(1297),
    [sym_this] = STATE(1297),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(1297),
    [sym_generator_function] = STATE(1297),
    [sym_call_expression] = STATE(1297),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_template_string] = STATE(1297),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1297),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(1297),
    [sym_class] = STATE(1297),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2683),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2685),
    [sym_true] = ACTIONS(2683),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2683),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [593] = {
    [sym_new_expression] = STATE(1298),
    [sym_augmented_assignment_expression] = STATE(1298),
    [sym_unary_expression] = STATE(1298),
    [sym_update_expression] = STATE(1298),
    [sym_regex] = STATE(1298),
    [sym_meta_property] = STATE(1298),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(1298),
    [sym_yield_expression] = STATE(1298),
    [sym_as_expression] = STATE(1298),
    [sym_non_null_expression] = STATE(1298),
    [sym_internal_module] = STATE(1298),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1298),
    [sym_await_expression] = STATE(1298),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(1298),
    [sym_this] = STATE(1298),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(1298),
    [sym_generator_function] = STATE(1298),
    [sym_call_expression] = STATE(1298),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(1298),
    [sym_ternary_expression] = STATE(1298),
    [sym_binary_expression] = STATE(1298),
    [sym_template_string] = STATE(1298),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1298),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(1298),
    [sym_class] = STATE(1298),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(1095),
    [sym_true] = ACTIONS(2687),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2687),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2687),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2689),
    [anon_sym_SLASH] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_implements] = ACTIONS(213),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [594] = {
    [sym_regex_pattern] = ACTIONS(2691),
    [sym_comment] = ACTIONS(246),
  },
  [595] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2693),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2695),
    [anon_sym_symbol] = ACTIONS(2695),
    [anon_sym_number] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2695),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2697),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2695),
    [anon_sym_private] = ACTIONS(2695),
    [anon_sym_boolean] = ACTIONS(2695),
    [anon_sym_async] = ACTIONS(2699),
    [anon_sym_public] = ACTIONS(2695),
    [anon_sym_get] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2695),
    [anon_sym_string] = ACTIONS(2695),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2695),
    [anon_sym_type] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(2695),
    [anon_sym_export] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [596] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(2665),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_AMP_EQ] = ACTIONS(2665),
    [anon_sym_PLUS_EQ] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2665),
    [anon_sym_STAR_EQ] = ACTIONS(2665),
    [anon_sym_PIPE_EQ] = ACTIONS(2665),
    [anon_sym_DASH_EQ] = ACTIONS(2665),
    [anon_sym_EQ_GT] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2665),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2665),
    [anon_sym_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_implements] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2665),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [597] = {
    [sym_new_expression] = STATE(1305),
    [sym_augmented_assignment_expression] = STATE(1305),
    [sym_unary_expression] = STATE(1305),
    [sym_update_expression] = STATE(1305),
    [sym_regex] = STATE(1305),
    [sym_meta_property] = STATE(1305),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(1305),
    [sym_yield_expression] = STATE(1305),
    [sym_as_expression] = STATE(1305),
    [sym_non_null_expression] = STATE(1305),
    [sym_internal_module] = STATE(1305),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1305),
    [sym_await_expression] = STATE(1305),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(1305),
    [sym_this] = STATE(1305),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(1305),
    [sym_generator_function] = STATE(1305),
    [sym_call_expression] = STATE(1305),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(1305),
    [sym_ternary_expression] = STATE(1305),
    [sym_binary_expression] = STATE(1305),
    [sym_template_string] = STATE(1305),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1305),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(1305),
    [sym_class] = STATE(1305),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2703),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2703),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [598] = {
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [599] = {
    [aux_sym_extends_clause_repeat1] = STATE(1315),
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2663),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_COMMA] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(2717),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [600] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2650),
    [anon_sym_AMP_EQ] = ACTIONS(2650),
    [anon_sym_PLUS_EQ] = ACTIONS(2650),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2650),
    [anon_sym_STAR_EQ] = ACTIONS(2650),
    [anon_sym_PIPE_EQ] = ACTIONS(2650),
    [anon_sym_DASH_EQ] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2650),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2650),
    [anon_sym_GT_GT_EQ] = ACTIONS(2650),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [601] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2663),
  },
  [602] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_implements] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2735),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_COMMA] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2737),
  },
  [603] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [604] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2663),
  },
  [605] = {
    [aux_sym_extends_clause_repeat1] = STATE(1315),
    [anon_sym_implements] = ACTIONS(2717),
    [anon_sym_COMMA] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2717),
  },
  [606] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(2739),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(2741),
  },
  [607] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(613),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [608] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(612),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(614),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [609] = {
    [sym_formal_parameters] = STATE(1318),
    [sym_type_parameters] = STATE(1319),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [610] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(612),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(614),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [611] = {
    [aux_sym_implements_clause_repeat1] = STATE(1323),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_COMMA] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2749),
  },
  [612] = {
    [sym_formal_parameters] = STATE(1324),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [613] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(2751),
  },
  [614] = {
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [sym_comment] = ACTIONS(3),
  },
  [615] = {
    [sym_class_body] = STATE(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [616] = {
    [sym_class_heritage] = STATE(1328),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(1327),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [617] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2755),
    [sym_identifier] = ACTIONS(2757),
    [sym__automatic_semicolon] = ACTIONS(2755),
    [anon_sym_BQUOTE] = ACTIONS(2755),
    [anon_sym_debugger] = ACTIONS(2757),
    [ts_builtin_sym_end] = ACTIONS(2755),
    [anon_sym_symbol] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2757),
    [anon_sym_COMMA] = ACTIONS(2755),
    [anon_sym_DASH] = ACTIONS(2757),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_GT_GT_GT] = ACTIONS(2755),
    [anon_sym_void] = ACTIONS(2757),
    [anon_sym_break] = ACTIONS(2757),
    [anon_sym_BANG_EQ] = ACTIONS(2757),
    [anon_sym_const] = ACTIONS(2757),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [sym_super] = ACTIONS(2757),
    [anon_sym_return] = ACTIONS(2757),
    [anon_sym_private] = ACTIONS(2757),
    [anon_sym_get] = ACTIONS(2757),
    [anon_sym_RBRACE] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [anon_sym_interface] = ACTIONS(2757),
    [anon_sym_default] = ACTIONS(2757),
    [anon_sym_as] = ACTIONS(2757),
    [anon_sym_delete] = ACTIONS(2757),
    [anon_sym_continue] = ACTIONS(2757),
    [anon_sym_DASH_DASH] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2757),
    [anon_sym_instanceof] = ACTIONS(2757),
    [anon_sym_this] = ACTIONS(2757),
    [anon_sym_yield] = ACTIONS(2757),
    [sym_true] = ACTIONS(2757),
    [anon_sym_throw] = ACTIONS(2757),
    [anon_sym_enum] = ACTIONS(2757),
    [anon_sym_protected] = ACTIONS(2757),
    [anon_sym_abstract] = ACTIONS(2757),
    [anon_sym_DOT] = ACTIONS(2757),
    [anon_sym_set] = ACTIONS(2757),
    [anon_sym_type] = ACTIONS(2757),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_import] = ACTIONS(2757),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2755),
    [anon_sym_await] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(2757),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [sym_false] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2757),
    [anon_sym_module] = ACTIONS(2757),
    [anon_sym_number] = ACTIONS(2757),
    [anon_sym_class] = ACTIONS(2757),
    [anon_sym_declare] = ACTIONS(2757),
    [anon_sym_typeof] = ACTIONS(2757),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2757),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_LPAREN] = ACTIONS(2755),
    [sym_null] = ACTIONS(2757),
    [anon_sym_GT] = ACTIONS(2757),
    [anon_sym_any] = ACTIONS(2757),
    [anon_sym_boolean] = ACTIONS(2757),
    [anon_sym_async] = ACTIONS(2757),
    [anon_sym_public] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2757),
    [anon_sym_var] = ACTIONS(2757),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2757),
    [anon_sym_EQ_EQ] = ACTIONS(2757),
    [anon_sym_RPAREN] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2757),
    [sym_number] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2757),
    [anon_sym_function] = ACTIONS(2757),
    [sym_undefined] = ACTIONS(2757),
    [anon_sym_new] = ACTIONS(2757),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_let] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2757),
    [anon_sym_export] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_do] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2755),
    [anon_sym_with] = ACTIONS(2757),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2755),
    [anon_sym_in] = ACTIONS(2757),
  },
  [618] = {
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_COLON] = ACTIONS(1198),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [619] = {
    [sym_new_expression] = STATE(1341),
    [sym_augmented_assignment_expression] = STATE(1341),
    [sym_unary_expression] = STATE(1341),
    [sym_update_expression] = STATE(1341),
    [sym_regex] = STATE(1341),
    [sym_meta_property] = STATE(1341),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1341),
    [sym_as_expression] = STATE(1341),
    [sym_non_null_expression] = STATE(1341),
    [sym_internal_module] = STATE(1341),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1341),
    [sym_await_expression] = STATE(1341),
    [sym_member_expression] = STATE(1342),
    [sym_mapped_type] = STATE(1343),
    [sym_string] = STATE(1341),
    [sym_this] = STATE(1341),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_nested_type_identifier] = STATE(1345),
    [sym_anonymous_class] = STATE(1341),
    [sym_generator_function] = STATE(1341),
    [sym_call_expression] = STATE(1341),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(1341),
    [sym_ternary_expression] = STATE(1341),
    [sym_binary_expression] = STATE(1341),
    [sym_template_string] = STATE(1341),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1341),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(1341),
    [sym_class] = STATE(1341),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2761),
    [sym_false] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2765),
    [anon_sym_symbol] = ACTIONS(2765),
    [anon_sym_number] = ACTIONS(2765),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2765),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2763),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2765),
    [anon_sym_private] = ACTIONS(2765),
    [anon_sym_boolean] = ACTIONS(2765),
    [anon_sym_async] = ACTIONS(2773),
    [anon_sym_public] = ACTIONS(2765),
    [anon_sym_get] = ACTIONS(2765),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2777),
    [sym_true] = ACTIONS(2763),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2765),
    [anon_sym_string] = ACTIONS(2765),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2763),
    [anon_sym_set] = ACTIONS(2765),
    [anon_sym_type] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2765),
    [anon_sym_export] = ACTIONS(2765),
    [anon_sym_namespace] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [620] = {
    [sym_string] = STATE(1348),
    [sym__property_name] = STATE(1348),
    [sym_computed_property_name] = STATE(1348),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [621] = {
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_abstract] = ACTIONS(1220),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_namespace] = ACTIONS(1220),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [622] = {
    [sym_string] = STATE(1348),
    [sym__property_name] = STATE(1348),
    [sym_computed_property_name] = STATE(1348),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(2791),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [623] = {
    [sym_string] = STATE(1348),
    [sym__property_name] = STATE(1348),
    [sym_computed_property_name] = STATE(1348),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [624] = {
    [sym_string] = STATE(1355),
    [sym__property_name] = STATE(1355),
    [sym_computed_property_name] = STATE(1355),
    [anon_sym_get] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_async] = ACTIONS(2797),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(2793),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(2801),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [625] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2803),
    [sym__automatic_semicolon] = ACTIONS(2803),
    [sym_identifier] = ACTIONS(2805),
    [anon_sym_BQUOTE] = ACTIONS(2803),
    [anon_sym_debugger] = ACTIONS(2805),
    [anon_sym_with] = ACTIONS(2805),
    [anon_sym_symbol] = ACTIONS(2805),
    [anon_sym_AT] = ACTIONS(2803),
    [anon_sym_PIPE] = ACTIONS(2805),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2805),
    [anon_sym_GT_GT_GT] = ACTIONS(2803),
    [anon_sym_void] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_BANG_EQ] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [sym_super] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_private] = ACTIONS(2805),
    [anon_sym_get] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_PERCENT] = ACTIONS(2803),
    [anon_sym_interface] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_as] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2803),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_instanceof] = ACTIONS(2805),
    [anon_sym_this] = ACTIONS(2805),
    [anon_sym_yield] = ACTIONS(2805),
    [sym_true] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_protected] = ACTIONS(2805),
    [anon_sym_abstract] = ACTIONS(2805),
    [anon_sym_DOT] = ACTIONS(2805),
    [anon_sym_set] = ACTIONS(2805),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_STAR_STAR] = ACTIONS(2803),
    [anon_sym_import] = ACTIONS(2805),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2803),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_PLUS_PLUS] = ACTIONS(2803),
    [anon_sym_await] = ACTIONS(2805),
    [anon_sym_DQUOTE] = ACTIONS(2803),
    [anon_sym_else] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [sym_false] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_module] = ACTIONS(2805),
    [anon_sym_number] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_declare] = ACTIONS(2805),
    [anon_sym_typeof] = ACTIONS(2805),
    [anon_sym_LT_LT] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_AMP_AMP] = ACTIONS(2803),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_LT_EQ] = ACTIONS(2803),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [sym_null] = ACTIONS(2805),
    [anon_sym_GT] = ACTIONS(2805),
    [anon_sym_any] = ACTIONS(2805),
    [anon_sym_boolean] = ACTIONS(2805),
    [anon_sym_async] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2805),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_var] = ACTIONS(2805),
    [anon_sym_QMARK] = ACTIONS(2803),
    [anon_sym_PIPE_PIPE] = ACTIONS(2803),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_SQUOTE] = ACTIONS(2803),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_EQ_EQ] = ACTIONS(2805),
    [anon_sym_RPAREN] = ACTIONS(2803),
    [anon_sym_LT] = ACTIONS(2805),
    [sym_number] = ACTIONS(2803),
    [anon_sym_SLASH] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(2803),
    [anon_sym_string] = ACTIONS(2805),
    [anon_sym_function] = ACTIONS(2805),
    [sym_undefined] = ACTIONS(2805),
    [anon_sym_CARET] = ACTIONS(2803),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_let] = ACTIONS(2805),
    [anon_sym_GT_GT] = ACTIONS(2805),
    [anon_sym_export] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2803),
    [anon_sym_in] = ACTIONS(2805),
  },
  [626] = {
    [aux_sym_string_repeat2] = STATE(1357),
    [sym_escape_sequence] = ACTIONS(2807),
    [aux_sym_string_token2] = ACTIONS(2807),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(2809),
  },
  [627] = {
    [sym_string] = STATE(1361),
    [sym__property_name] = STATE(1361),
    [sym_computed_property_name] = STATE(1361),
    [anon_sym_get] = ACTIONS(2811),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_async] = ACTIONS(1119),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(2811),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(2817),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [628] = {
    [sym_string] = STATE(1355),
    [sym__property_name] = STATE(1355),
    [sym_computed_property_name] = STATE(1355),
    [anon_sym_get] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_set] = ACTIONS(2793),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(2797),
  },
  [629] = {
    [aux_sym_string_repeat1] = STATE(1362),
    [sym_escape_sequence] = ACTIONS(2819),
    [aux_sym_string_token1] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2809),
    [sym_comment] = ACTIONS(246),
  },
  [630] = {
    [sym__automatic_semicolon] = ACTIONS(2821),
    [anon_sym_SEMI] = ACTIONS(2821),
    [anon_sym_COMMA] = ACTIONS(2821),
    [sym_comment] = ACTIONS(3),
  },
  [631] = {
    [sym_call_signature] = STATE(1366),
    [sym__initializer] = STATE(1367),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [sym_type_annotation] = STATE(1370),
    [sym__automatic_semicolon] = ACTIONS(2823),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(2823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(2827),
  },
  [632] = {
    [sym_string] = STATE(1355),
    [sym__property_name] = STATE(1355),
    [sym_computed_property_name] = STATE(1355),
    [anon_sym_get] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(2797),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_abstract] = ACTIONS(2829),
    [anon_sym_set] = ACTIONS(2793),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(2831),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(1119),
  },
  [633] = {
    [sym_public_field_definition] = STATE(630),
    [sym__property_name] = STATE(631),
    [sym_decorator] = STATE(1375),
    [sym_method_signature] = STATE(630),
    [sym_accessibility_modifier] = STATE(632),
    [sym_abstract_method_signature] = STATE(630),
    [sym_computed_property_name] = STATE(631),
    [aux_sym_class_body_repeat1] = STATE(1375),
    [sym_index_signature] = STATE(630),
    [sym_string] = STATE(631),
    [sym_method_definition] = STATE(634),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1129),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_abstract] = ACTIONS(1139),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [634] = {
    [sym__automatic_semicolon] = ACTIONS(2821),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_SEMI] = ACTIONS(2821),
    [anon_sym_module] = ACTIONS(2839),
    [anon_sym_symbol] = ACTIONS(2839),
    [anon_sym_number] = ACTIONS(2839),
    [anon_sym_AT] = ACTIONS(2837),
    [anon_sym_declare] = ACTIONS(2839),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_void] = ACTIONS(2839),
    [anon_sym_any] = ACTIONS(2839),
    [anon_sym_private] = ACTIONS(2839),
    [anon_sym_boolean] = ACTIONS(2839),
    [anon_sym_async] = ACTIONS(2839),
    [anon_sym_public] = ACTIONS(2839),
    [anon_sym_get] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [sym_number] = ACTIONS(2837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2839),
    [anon_sym_string] = ACTIONS(2839),
    [anon_sym_abstract] = ACTIONS(2839),
    [anon_sym_set] = ACTIONS(2839),
    [anon_sym_type] = ACTIONS(2839),
    [anon_sym_import] = ACTIONS(2839),
    [anon_sym_export] = ACTIONS(2839),
    [anon_sym_namespace] = ACTIONS(2839),
    [sym_readonly] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2837),
  },
  [635] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [sym__automatic_semicolon] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2843),
    [anon_sym_GT_GT_GT] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_LT_EQ] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2841),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2843),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2841),
    [anon_sym_QMARK] = ACTIONS(2841),
    [anon_sym_RBRACE] = ACTIONS(2841),
    [anon_sym_as] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2843),
    [anon_sym_instanceof] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2843),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2841),
    [anon_sym_STAR_STAR] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_GT_GT] = ACTIONS(2843),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2841),
    [anon_sym_in] = ACTIONS(2843),
  },
  [636] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2845),
  },
  [637] = {
    [sym_identifier] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
  },
  [638] = {
    [sym_class_heritage] = STATE(1377),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_type_parameters] = STATE(1378),
    [sym_class_body] = STATE(1379),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [639] = {
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_BQUOTE] = ACTIONS(2851),
    [anon_sym_debugger] = ACTIONS(2849),
    [anon_sym_symbol] = ACTIONS(2849),
    [anon_sym_AT] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_void] = ACTIONS(2849),
    [anon_sym_break] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2849),
    [sym_super] = ACTIONS(2849),
    [anon_sym_return] = ACTIONS(2849),
    [anon_sym_private] = ACTIONS(2849),
    [anon_sym_get] = ACTIONS(2849),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2849),
    [anon_sym_default] = ACTIONS(2849),
    [anon_sym_enum] = ACTIONS(2849),
    [anon_sym_delete] = ACTIONS(2849),
    [anon_sym_continue] = ACTIONS(2849),
    [anon_sym_DASH_DASH] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_this] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2849),
    [sym_true] = ACTIONS(2849),
    [anon_sym_throw] = ACTIONS(2849),
    [anon_sym_protected] = ACTIONS(2849),
    [anon_sym_abstract] = ACTIONS(2849),
    [anon_sym_set] = ACTIONS(2849),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_import] = ACTIONS(2849),
    [anon_sym_namespace] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2851),
    [anon_sym_await] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_else] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2851),
    [anon_sym_for] = ACTIONS(2849),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [sym_false] = ACTIONS(2849),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_case] = ACTIONS(2849),
    [anon_sym_module] = ACTIONS(2849),
    [anon_sym_number] = ACTIONS(2849),
    [anon_sym_class] = ACTIONS(2849),
    [anon_sym_declare] = ACTIONS(2849),
    [anon_sym_typeof] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_switch] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [sym_null] = ACTIONS(2849),
    [anon_sym_any] = ACTIONS(2849),
    [anon_sym_boolean] = ACTIONS(2849),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_public] = ACTIONS(2849),
    [anon_sym_var] = ACTIONS(2849),
    [anon_sym_while] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2851),
    [sym_number] = ACTIONS(2851),
    [anon_sym_SLASH] = ACTIONS(2849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2849),
    [sym_undefined] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2849),
    [ts_builtin_sym_end] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_export] = ACTIONS(2849),
    [anon_sym_do] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2851),
    [anon_sym_with] = ACTIONS(2849),
  },
  [640] = {
    [sym_call_signature] = STATE(1381),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [641] = {
    [sym_call_signature] = STATE(1382),
    [sym_formal_parameters] = STATE(858),
    [sym_type_parameters] = STATE(859),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [642] = {
    [sym_call_signature] = STATE(1384),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [643] = {
    [sym_statement_block] = STATE(1385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [644] = {
    [anon_sym_EQ] = ACTIONS(2857),
    [sym_comment] = ACTIONS(3),
  },
  [645] = {
    [sym_identifier] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
  },
  [646] = {
    [sym_identifier] = ACTIONS(905),
    [anon_sym_BQUOTE] = ACTIONS(903),
    [anon_sym_debugger] = ACTIONS(905),
    [anon_sym_symbol] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_void] = ACTIONS(905),
    [anon_sym_break] = ACTIONS(905),
    [anon_sym_const] = ACTIONS(905),
    [sym_super] = ACTIONS(905),
    [anon_sym_return] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_get] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_interface] = ACTIONS(905),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_enum] = ACTIONS(905),
    [anon_sym_delete] = ACTIONS(905),
    [anon_sym_continue] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_this] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(905),
    [sym_true] = ACTIONS(905),
    [anon_sym_throw] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_abstract] = ACTIONS(905),
    [anon_sym_set] = ACTIONS(905),
    [anon_sym_type] = ACTIONS(905),
    [anon_sym_import] = ACTIONS(905),
    [anon_sym_namespace] = ACTIONS(905),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(903),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(903),
    [sym_false] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_module] = ACTIONS(905),
    [anon_sym_number] = ACTIONS(905),
    [anon_sym_class] = ACTIONS(905),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeof] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_switch] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym_null] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(905),
    [anon_sym_boolean] = ACTIONS(905),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_var] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(903),
    [sym_number] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_new] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym_let] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_with] = ACTIONS(905),
  },
  [647] = {
    [sym_identifier] = ACTIONS(2861),
    [sym_comment] = ACTIONS(3),
  },
  [648] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_BQUOTE] = ACTIONS(2863),
    [sym__automatic_semicolon] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_LT_EQ] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_of] = ACTIONS(2863),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_as] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2863),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_instanceof] = ACTIONS(2863),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_SLASH] = ACTIONS(2865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_in] = ACTIONS(2865),
  },
  [649] = {
    [sym_new_expression] = STATE(1400),
    [sym_augmented_assignment_expression] = STATE(1400),
    [sym_unary_expression] = STATE(1400),
    [sym_update_expression] = STATE(1400),
    [sym_regex] = STATE(1400),
    [sym_meta_property] = STATE(1400),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(1400),
    [sym_yield_expression] = STATE(1400),
    [sym_as_expression] = STATE(1400),
    [sym_non_null_expression] = STATE(1400),
    [sym_internal_module] = STATE(1400),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1400),
    [sym_await_expression] = STATE(1400),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(1400),
    [sym_this] = STATE(1400),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(1400),
    [sym_generator_function] = STATE(1400),
    [sym_call_expression] = STATE(1400),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(1400),
    [sym_ternary_expression] = STATE(1400),
    [sym_binary_expression] = STATE(1400),
    [sym_template_string] = STATE(1400),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1400),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(1400),
    [sym_class] = STATE(1400),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(2871),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(2885),
    [sym_true] = ACTIONS(2871),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(2871),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [650] = {
    [sym_type_alias_declaration] = STATE(361),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(361),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(361),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(361),
    [sym_return_statement] = STATE(361),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(361),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(361),
    [sym_switch_statement] = STATE(361),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(361),
    [sym_throw_statement] = STATE(361),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(361),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(361),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(361),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(361),
    [sym_abstract_class] = STATE(361),
    [sym_interface_declaration] = STATE(361),
    [sym_statement_block] = STATE(361),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(361),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(361),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(361),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(361),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(361),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(361),
    [sym_empty_statement] = STATE(361),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(361),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(361),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(361),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(361),
    [sym_break_statement] = STATE(361),
    [sym_labeled_statement] = STATE(361),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(361),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [651] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_BANG] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym__automatic_semicolon] = ACTIONS(636),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_GT_GT_GT] = ACTIONS(636),
    [anon_sym_AMP_AMP] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_BANG_EQ] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(638),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(636),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(636),
    [anon_sym_PIPE_PIPE] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(638),
    [anon_sym_instanceof] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_GT_GT] = ACTIONS(638),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_in] = ACTIONS(638),
  },
  [652] = {
    [aux_sym_object_repeat1] = STATE(695),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
  },
  [653] = {
    [sym_arguments] = STATE(389),
    [anon_sym_LBRACK] = ACTIONS(698),
    [sym_identifier] = ACTIONS(700),
    [anon_sym_module] = ACTIONS(700),
    [anon_sym_symbol] = ACTIONS(700),
    [anon_sym_number] = ACTIONS(700),
    [anon_sym_AT] = ACTIONS(698),
    [anon_sym_class] = ACTIONS(700),
    [anon_sym_declare] = ACTIONS(700),
    [anon_sym_STAR] = ACTIONS(698),
    [anon_sym_void] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_any] = ACTIONS(700),
    [anon_sym_private] = ACTIONS(700),
    [anon_sym_boolean] = ACTIONS(700),
    [anon_sym_async] = ACTIONS(700),
    [anon_sym_public] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(700),
    [anon_sym_static] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(698),
    [sym_number] = ACTIONS(698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(700),
    [anon_sym_string] = ACTIONS(700),
    [anon_sym_abstract] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(700),
    [anon_sym_type] = ACTIONS(700),
    [anon_sym_import] = ACTIONS(700),
    [anon_sym_export] = ACTIONS(700),
    [sym_readonly] = ACTIONS(700),
    [anon_sym_namespace] = ACTIONS(700),
    [anon_sym_DQUOTE] = ACTIONS(698),
  },
  [654] = {
    [sym__initializer] = STATE(1041),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_EQ] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(2904),
    [sym_comment] = ACTIONS(3),
  },
  [655] = {
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(2904),
    [sym_comment] = ACTIONS(3),
  },
  [656] = {
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_namespace] = ACTIONS(1220),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
  },
  [657] = {
    [sym_string] = STATE(663),
    [sym__property_name] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_STAR] = ACTIONS(1228),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1224),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1224),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [658] = {
    [sym_string] = STATE(663),
    [sym__property_name] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [659] = {
    [anon_sym_COMMA] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [sym_comment] = ACTIONS(3),
  },
  [660] = {
    [sym_computed_property_name] = STATE(701),
    [sym__property_name] = STATE(701),
    [sym_decorator] = STATE(1044),
    [sym_method_definition] = STATE(1407),
    [sym_string] = STATE(701),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(1044),
    [anon_sym_get] = ACTIONS(1308),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [sym_number] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1304),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1304),
    [anon_sym_public] = ACTIONS(1304),
  },
  [661] = {
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(1198),
  },
  [662] = {
    [sym_new_expression] = STATE(1413),
    [sym_augmented_assignment_expression] = STATE(1413),
    [sym_unary_expression] = STATE(1413),
    [sym_update_expression] = STATE(1413),
    [sym_regex] = STATE(1413),
    [sym_meta_property] = STATE(1413),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(1413),
    [sym_yield_expression] = STATE(1413),
    [sym_as_expression] = STATE(1413),
    [sym_non_null_expression] = STATE(1413),
    [sym_internal_module] = STATE(1413),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1413),
    [sym_await_expression] = STATE(1413),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(1413),
    [sym_this] = STATE(1413),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(1413),
    [sym_generator_function] = STATE(1413),
    [sym_call_expression] = STATE(1413),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(1413),
    [sym_ternary_expression] = STATE(1413),
    [sym_binary_expression] = STATE(1413),
    [sym_template_string] = STATE(1413),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1413),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(1413),
    [sym_class] = STATE(1413),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2910),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2918),
    [sym_true] = ACTIONS(2910),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2910),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [663] = {
    [sym_call_signature] = STATE(1415),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [664] = {
    [sym_string] = STATE(1416),
    [sym__property_name] = STATE(1416),
    [sym_computed_property_name] = STATE(1416),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [665] = {
    [sym_string] = STATE(1416),
    [sym__property_name] = STATE(1416),
    [sym_computed_property_name] = STATE(1416),
    [anon_sym_get] = ACTIONS(2926),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(2926),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(2930),
  },
  [666] = {
    [sym_string] = STATE(1416),
    [sym__property_name] = STATE(1416),
    [sym_computed_property_name] = STATE(1416),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [667] = {
    [sym_string] = STATE(1416),
    [sym__property_name] = STATE(1416),
    [sym_computed_property_name] = STATE(1416),
    [anon_sym_get] = ACTIONS(2926),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(2926),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [668] = {
    [sym_type_alias_declaration] = STATE(1427),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(1427),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(1427),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(1427),
    [sym_return_statement] = STATE(1427),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(1427),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(1427),
    [sym_switch_statement] = STATE(1427),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(1427),
    [sym_throw_statement] = STATE(1427),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(1427),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(1427),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(1427),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(1427),
    [sym_abstract_class] = STATE(1427),
    [sym_interface_declaration] = STATE(1427),
    [sym_statement_block] = STATE(1427),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(1427),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(1427),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(1427),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(1427),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(1427),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(1427),
    [sym_empty_statement] = STATE(1427),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(1427),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(1427),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(1427),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(1427),
    [sym_break_statement] = STATE(1427),
    [sym_labeled_statement] = STATE(1427),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(1427),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [669] = {
    [anon_sym_LPAREN] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
  },
  [670] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(1433),
    [sym_variable_declaration] = STATE(1433),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(1433),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1434),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_lexical_declaration] = STATE(1433),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(1435),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(2948),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2952),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [671] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [aux_sym_array_repeat1] = STATE(575),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(2954),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [672] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(310),
  },
  [673] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(675),
    [sym__declaration] = STATE(192),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(675),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(1251),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_global] = ACTIONS(322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [674] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(675),
    [sym__declaration] = STATE(317),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(675),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [675] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [676] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2527),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2527),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [677] = {
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
  },
  [678] = {
    [anon_sym_EQ_GT] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
  },
  [679] = {
    [sym_string] = STATE(1416),
    [sym__property_name] = STATE(1416),
    [sym_computed_property_name] = STATE(1416),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_EQ_GT] = ACTIONS(1448),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [680] = {
    [sym_type_alias_declaration] = STATE(777),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(777),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(777),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(777),
    [sym_return_statement] = STATE(777),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(777),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(777),
    [sym_switch_statement] = STATE(777),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(777),
    [sym_throw_statement] = STATE(777),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(777),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(777),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(777),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(777),
    [sym_abstract_class] = STATE(777),
    [sym_interface_declaration] = STATE(777),
    [sym_statement_block] = STATE(777),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(777),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(777),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(777),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(777),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(777),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(777),
    [sym_empty_statement] = STATE(777),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(777),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(777),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(777),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(777),
    [sym_break_statement] = STATE(777),
    [sym_labeled_statement] = STATE(777),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(777),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [681] = {
    [sym_type_alias_declaration] = STATE(934),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(934),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(934),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(934),
    [sym_return_statement] = STATE(934),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(934),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(934),
    [sym_switch_statement] = STATE(934),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(934),
    [sym_throw_statement] = STATE(934),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(934),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(934),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(934),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(934),
    [sym_abstract_class] = STATE(934),
    [sym_interface_declaration] = STATE(934),
    [sym_statement_block] = STATE(934),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(934),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(934),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(934),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(934),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(934),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(934),
    [sym_empty_statement] = STATE(934),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(934),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(934),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(934),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(934),
    [sym_break_statement] = STATE(934),
    [sym_labeled_statement] = STATE(934),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(934),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [682] = {
    [sym_string] = STATE(1416),
    [sym__property_name] = STATE(1416),
    [sym_computed_property_name] = STATE(1416),
    [anon_sym_get] = ACTIONS(2926),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_async] = ACTIONS(2930),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(2926),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [sym_readonly] = ACTIONS(2960),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [683] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_BQUOTE] = ACTIONS(2962),
    [sym__automatic_semicolon] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_LT_LT] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_GT_GT_GT] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2962),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_of] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_as] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_instanceof] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_CARET] = ACTIONS(2962),
    [anon_sym_STAR_STAR] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2964),
  },
  [684] = {
    [aux_sym_object_repeat1] = STATE(695),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
  },
  [685] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2968),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [686] = {
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [anon_sym_debugger] = ACTIONS(2970),
    [anon_sym_symbol] = ACTIONS(2970),
    [anon_sym_AT] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_void] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [sym_super] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_get] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_interface] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_this] = ACTIONS(2970),
    [anon_sym_yield] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_abstract] = ACTIONS(2970),
    [anon_sym_set] = ACTIONS(2970),
    [anon_sym_type] = ACTIONS(2970),
    [anon_sym_import] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_await] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [sym_false] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_module] = ACTIONS(2970),
    [anon_sym_number] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_declare] = ACTIONS(2970),
    [anon_sym_typeof] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [sym_null] = ACTIONS(2970),
    [anon_sym_catch] = ACTIONS(2970),
    [anon_sym_any] = ACTIONS(2970),
    [anon_sym_boolean] = ACTIONS(2970),
    [anon_sym_async] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_var] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_LT] = ACTIONS(2972),
    [sym_number] = ACTIONS(2972),
    [anon_sym_SLASH] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(2970),
    [anon_sym_string] = ACTIONS(2970),
    [anon_sym_function] = ACTIONS(2970),
    [sym_undefined] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [ts_builtin_sym_end] = ACTIONS(2972),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_export] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_with] = ACTIONS(2970),
  },
  [687] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(675),
    [sym__declaration] = STATE(192),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(675),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(322),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1251),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [688] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(675),
    [sym__declaration] = STATE(317),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(675),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_as] = ACTIONS(541),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [689] = {
    [sym_type_alias_declaration] = STATE(689),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(689),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(689),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(689),
    [sym_return_statement] = STATE(689),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(689),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(689),
    [sym_switch_statement] = STATE(689),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(689),
    [sym_throw_statement] = STATE(689),
    [aux_sym_program_repeat1] = STATE(689),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(689),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(689),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(689),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(689),
    [sym_abstract_class] = STATE(689),
    [sym_interface_declaration] = STATE(689),
    [sym_statement_block] = STATE(689),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(689),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(689),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(689),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(689),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(689),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(689),
    [sym_empty_statement] = STATE(689),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(689),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(689),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(689),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(689),
    [sym_break_statement] = STATE(689),
    [sym_labeled_statement] = STATE(689),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(689),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [anon_sym_debugger] = ACTIONS(1747),
    [anon_sym_symbol] = ACTIONS(1750),
    [anon_sym_AT] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(1756),
    [anon_sym_void] = ACTIONS(1759),
    [anon_sym_break] = ACTIONS(1762),
    [anon_sym_const] = ACTIONS(1765),
    [sym_super] = ACTIONS(1768),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_private] = ACTIONS(1750),
    [anon_sym_get] = ACTIONS(1750),
    [anon_sym_RBRACE] = ACTIONS(1882),
    [anon_sym_interface] = ACTIONS(1774),
    [anon_sym_enum] = ACTIONS(1777),
    [anon_sym_delete] = ACTIONS(1780),
    [anon_sym_continue] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1786),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_this] = ACTIONS(1792),
    [anon_sym_yield] = ACTIONS(1795),
    [sym_true] = ACTIONS(1798),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_protected] = ACTIONS(1750),
    [anon_sym_abstract] = ACTIONS(1804),
    [anon_sym_set] = ACTIONS(1750),
    [anon_sym_type] = ACTIONS(1807),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_namespace] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1786),
    [anon_sym_await] = ACTIONS(1816),
    [anon_sym_DQUOTE] = ACTIONS(1819),
    [anon_sym_BANG] = ACTIONS(1822),
    [anon_sym_for] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(1828),
    [sym_false] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(1831),
    [anon_sym_module] = ACTIONS(1834),
    [anon_sym_number] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(1837),
    [anon_sym_declare] = ACTIONS(2983),
    [anon_sym_typeof] = ACTIONS(1780),
    [anon_sym_LBRACE] = ACTIONS(1843),
    [anon_sym_switch] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [sym_null] = ACTIONS(1798),
    [anon_sym_any] = ACTIONS(1750),
    [anon_sym_boolean] = ACTIONS(1750),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_public] = ACTIONS(1750),
    [anon_sym_var] = ACTIONS(1855),
    [anon_sym_while] = ACTIONS(2986),
    [anon_sym_SQUOTE] = ACTIONS(1861),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_LT] = ACTIONS(1867),
    [sym_number] = ACTIONS(1870),
    [anon_sym_SLASH] = ACTIONS(1873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1750),
    [anon_sym_function] = ACTIONS(1876),
    [sym_undefined] = ACTIONS(1798),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_let] = ACTIONS(1884),
    [anon_sym_PLUS] = ACTIONS(1756),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_do] = ACTIONS(1890),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_with] = ACTIONS(2992),
  },
  [690] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [691] = {
    [sym_new_expression] = STATE(1441),
    [sym_augmented_assignment_expression] = STATE(1441),
    [sym_unary_expression] = STATE(1441),
    [sym_update_expression] = STATE(1441),
    [sym_regex] = STATE(1441),
    [sym_meta_property] = STATE(1441),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1441),
    [sym_yield_expression] = STATE(1441),
    [sym_as_expression] = STATE(1441),
    [sym_non_null_expression] = STATE(1441),
    [sym_internal_module] = STATE(1441),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1441),
    [sym_await_expression] = STATE(1441),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1441),
    [sym_this] = STATE(1441),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1441),
    [sym_generator_function] = STATE(1441),
    [sym_call_expression] = STATE(1441),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1441),
    [sym_ternary_expression] = STATE(1441),
    [sym_binary_expression] = STATE(1441),
    [sym_template_string] = STATE(1441),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1441),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1441),
    [sym_class] = STATE(1441),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2995),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2997),
    [sym_true] = ACTIONS(2995),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [692] = {
    [sym_call_signature] = STATE(1415),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [693] = {
    [sym_statement_block] = STATE(1442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [694] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1896),
    [anon_sym_LBRACK] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1898),
    [anon_sym_SEMI] = ACTIONS(1896),
    [anon_sym_BQUOTE] = ACTIONS(1896),
    [sym__automatic_semicolon] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_COMMA] = ACTIONS(2999),
    [anon_sym_LT_LT] = ACTIONS(1896),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT_GT] = ACTIONS(1896),
    [anon_sym_AMP_AMP] = ACTIONS(1896),
    [anon_sym_DASH] = ACTIONS(1898),
    [anon_sym_BANG_EQ] = ACTIONS(1898),
    [anon_sym_LT_EQ] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1896),
    [anon_sym_GT_EQ] = ACTIONS(1896),
    [anon_sym_GT] = ACTIONS(1898),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_AMP] = ACTIONS(1898),
    [anon_sym_QMARK] = ACTIONS(1896),
    [anon_sym_PERCENT] = ACTIONS(1896),
    [anon_sym_as] = ACTIONS(1896),
    [anon_sym_PIPE_PIPE] = ACTIONS(1896),
    [anon_sym_DASH_DASH] = ACTIONS(1896),
    [anon_sym_EQ_EQ] = ACTIONS(1898),
    [anon_sym_instanceof] = ACTIONS(1896),
    [anon_sym_LT] = ACTIONS(1898),
    [anon_sym_SLASH] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1896),
    [anon_sym_CARET] = ACTIONS(1896),
    [anon_sym_STAR_STAR] = ACTIONS(1896),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1898),
    [anon_sym_PLUS_PLUS] = ACTIONS(1896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1896),
    [anon_sym_in] = ACTIONS(1898),
  },
  [695] = {
    [aux_sym_object_repeat1] = STATE(695),
    [anon_sym_COMMA] = ACTIONS(3004),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [sym_comment] = ACTIONS(3),
  },
  [696] = {
    [sym_string] = STATE(663),
    [sym__property_name] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [697] = {
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_namespace] = ACTIONS(1220),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
  },
  [698] = {
    [sym_type_alias_declaration] = STATE(915),
    [aux_sym_export_statement_repeat1] = STATE(675),
    [sym__declaration] = STATE(915),
    [sym_ambient_declaration] = STATE(915),
    [sym_import_alias] = STATE(915),
    [sym_export_statement] = STATE(915),
    [sym_generator_function] = STATE(915),
    [sym_lexical_declaration] = STATE(915),
    [sym_internal_module] = STATE(915),
    [sym_decorator] = STATE(675),
    [sym_enum_declaration] = STATE(915),
    [sym_function] = STATE(915),
    [sym_function_signature] = STATE(915),
    [sym_variable_declaration] = STATE(915),
    [sym_abstract_class] = STATE(915),
    [sym_module] = STATE(915),
    [sym_interface_declaration] = STATE(915),
    [sym_class] = STATE(915),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_declare] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [699] = {
    [sym_string] = STATE(663),
    [sym__property_name] = STATE(663),
    [sym_computed_property_name] = STATE(663),
    [anon_sym_get] = ACTIONS(1224),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1224),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [700] = {
    [aux_sym_object_repeat1] = STATE(1443),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
  },
  [701] = {
    [sym_call_signature] = STATE(693),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [702] = {
    [aux_sym_export_statement_repeat1] = STATE(702),
    [sym_decorator] = STATE(702),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_symbol] = ACTIONS(3007),
    [anon_sym_number] = ACTIONS(3007),
    [anon_sym_AT] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(3007),
    [anon_sym_declare] = ACTIONS(3007),
    [anon_sym_STAR] = ACTIONS(2032),
    [anon_sym_void] = ACTIONS(3007),
    [anon_sym_any] = ACTIONS(3007),
    [anon_sym_private] = ACTIONS(3007),
    [anon_sym_boolean] = ACTIONS(3007),
    [anon_sym_async] = ACTIONS(3007),
    [anon_sym_public] = ACTIONS(3007),
    [anon_sym_get] = ACTIONS(3007),
    [anon_sym_static] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(2032),
    [sym_number] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3007),
    [anon_sym_string] = ACTIONS(3007),
    [anon_sym_set] = ACTIONS(3007),
    [anon_sym_type] = ACTIONS(3007),
    [anon_sym_import] = ACTIONS(3007),
    [anon_sym_export] = ACTIONS(3007),
    [sym_readonly] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(2032),
  },
  [703] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2041),
    [anon_sym_LBRACK] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2041),
    [anon_sym_BQUOTE] = ACTIONS(2041),
    [sym__automatic_semicolon] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_AMP_AMP] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2043),
    [anon_sym_LT_EQ] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(2041),
    [anon_sym_GT_EQ] = ACTIONS(2041),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2041),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_as] = ACTIONS(2041),
    [anon_sym_PIPE_PIPE] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_instanceof] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(2043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_GT_GT] = ACTIONS(2043),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2041),
    [anon_sym_in] = ACTIONS(2043),
  },
  [704] = {
    [sym_switch_default] = STATE(1447),
    [aux_sym_switch_body_repeat1] = STATE(1447),
    [sym_switch_case] = STATE(1447),
    [anon_sym_RBRACE] = ACTIONS(3017),
    [anon_sym_default] = ACTIONS(3019),
    [anon_sym_case] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
  },
  [705] = {
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_BQUOTE] = ACTIONS(3025),
    [anon_sym_debugger] = ACTIONS(3023),
    [anon_sym_symbol] = ACTIONS(3023),
    [anon_sym_AT] = ACTIONS(3025),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3023),
    [anon_sym_break] = ACTIONS(3023),
    [anon_sym_const] = ACTIONS(3023),
    [sym_super] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_private] = ACTIONS(3023),
    [anon_sym_get] = ACTIONS(3023),
    [anon_sym_RBRACE] = ACTIONS(3025),
    [anon_sym_interface] = ACTIONS(3023),
    [anon_sym_default] = ACTIONS(3023),
    [anon_sym_enum] = ACTIONS(3023),
    [anon_sym_delete] = ACTIONS(3023),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3025),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_this] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3023),
    [sym_true] = ACTIONS(3023),
    [anon_sym_throw] = ACTIONS(3023),
    [anon_sym_protected] = ACTIONS(3023),
    [anon_sym_abstract] = ACTIONS(3023),
    [anon_sym_set] = ACTIONS(3023),
    [anon_sym_type] = ACTIONS(3023),
    [anon_sym_import] = ACTIONS(3023),
    [anon_sym_namespace] = ACTIONS(3023),
    [anon_sym_PLUS_PLUS] = ACTIONS(3025),
    [anon_sym_await] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3025),
    [anon_sym_else] = ACTIONS(3023),
    [anon_sym_BANG] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3025),
    [sym_false] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_case] = ACTIONS(3023),
    [anon_sym_module] = ACTIONS(3023),
    [anon_sym_number] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3023),
    [anon_sym_declare] = ACTIONS(3023),
    [anon_sym_typeof] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3025),
    [anon_sym_switch] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(3025),
    [sym_null] = ACTIONS(3023),
    [anon_sym_any] = ACTIONS(3023),
    [anon_sym_boolean] = ACTIONS(3023),
    [anon_sym_async] = ACTIONS(3023),
    [anon_sym_public] = ACTIONS(3023),
    [anon_sym_var] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3025),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3025),
    [sym_number] = ACTIONS(3025),
    [anon_sym_SLASH] = ACTIONS(3023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3023),
    [anon_sym_function] = ACTIONS(3023),
    [sym_undefined] = ACTIONS(3023),
    [anon_sym_new] = ACTIONS(3023),
    [ts_builtin_sym_end] = ACTIONS(3025),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_export] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [anon_sym_with] = ACTIONS(3023),
  },
  [706] = {
    [sym_new_expression] = STATE(1448),
    [sym_augmented_assignment_expression] = STATE(1448),
    [sym_unary_expression] = STATE(1448),
    [sym_update_expression] = STATE(1448),
    [sym_regex] = STATE(1448),
    [sym_meta_property] = STATE(1448),
    [sym_call_signature] = STATE(242),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(1448),
    [sym_yield_expression] = STATE(1448),
    [sym_as_expression] = STATE(1448),
    [sym_non_null_expression] = STATE(1448),
    [sym_internal_module] = STATE(1448),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1448),
    [sym_await_expression] = STATE(1448),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1448),
    [sym_this] = STATE(1448),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1448),
    [sym_generator_function] = STATE(1448),
    [sym_call_expression] = STATE(1448),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1448),
    [sym_ternary_expression] = STATE(1448),
    [sym_binary_expression] = STATE(1448),
    [sym_template_string] = STATE(1448),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1448),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1448),
    [sym_class] = STATE(1448),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3027),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3029),
    [sym_true] = ACTIONS(3027),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3027),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [707] = {
    [sym_new_expression] = STATE(1449),
    [sym_augmented_assignment_expression] = STATE(1449),
    [sym_unary_expression] = STATE(1449),
    [sym_update_expression] = STATE(1449),
    [sym_regex] = STATE(1449),
    [sym_meta_property] = STATE(1449),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(1449),
    [sym_yield_expression] = STATE(1449),
    [sym_as_expression] = STATE(1449),
    [sym_non_null_expression] = STATE(1449),
    [sym_internal_module] = STATE(1449),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1449),
    [sym_await_expression] = STATE(1449),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1449),
    [sym_this] = STATE(1449),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1449),
    [sym_generator_function] = STATE(1449),
    [sym_call_expression] = STATE(1449),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1449),
    [sym_ternary_expression] = STATE(1449),
    [sym_binary_expression] = STATE(1449),
    [sym_template_string] = STATE(1449),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1449),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1449),
    [sym_class] = STATE(1449),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3031),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3033),
    [sym_true] = ACTIONS(3031),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3031),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [708] = {
    [sym__initializer] = STATE(1450),
    [sym_type_annotation] = STATE(1451),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
  },
  [709] = {
    [sym_new_expression] = STATE(1452),
    [sym_augmented_assignment_expression] = STATE(1452),
    [sym_unary_expression] = STATE(1452),
    [sym_update_expression] = STATE(1452),
    [sym_regex] = STATE(1452),
    [sym_meta_property] = STATE(1452),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(1452),
    [sym_yield_expression] = STATE(1452),
    [sym_as_expression] = STATE(1452),
    [sym_non_null_expression] = STATE(1452),
    [sym_internal_module] = STATE(1452),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1452),
    [sym_await_expression] = STATE(1452),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1452),
    [sym_this] = STATE(1452),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1452),
    [sym_generator_function] = STATE(1452),
    [sym_call_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1452),
    [sym_ternary_expression] = STATE(1452),
    [sym_binary_expression] = STATE(1452),
    [sym_template_string] = STATE(1452),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1452),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1452),
    [sym_class] = STATE(1452),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3041),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3043),
    [sym_true] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3041),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [710] = {
    [sym_new_expression] = STATE(1453),
    [sym_augmented_assignment_expression] = STATE(1453),
    [sym_unary_expression] = STATE(1453),
    [sym_update_expression] = STATE(1453),
    [sym_regex] = STATE(1453),
    [sym_meta_property] = STATE(1453),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(1453),
    [sym_yield_expression] = STATE(1453),
    [sym_as_expression] = STATE(1453),
    [sym_non_null_expression] = STATE(1453),
    [sym_internal_module] = STATE(1453),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1453),
    [sym_await_expression] = STATE(1453),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1453),
    [sym_this] = STATE(1453),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1453),
    [sym_generator_function] = STATE(1453),
    [sym_call_expression] = STATE(1453),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1453),
    [sym_ternary_expression] = STATE(1453),
    [sym_binary_expression] = STATE(1453),
    [sym_template_string] = STATE(1453),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1453),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1453),
    [sym_class] = STATE(1453),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3045),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3047),
    [sym_true] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3045),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [711] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1459),
    [sym_constructor_type] = STATE(1459),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(1459),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1459),
    [sym_intersection_type] = STATE(1459),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1460),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1462),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [712] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_BANG] = ACTIONS(638),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_GT_GT_GT] = ACTIONS(636),
    [anon_sym_AMP_AMP] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_BANG_EQ] = ACTIONS(638),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_QMARK] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(636),
    [anon_sym_PIPE_PIPE] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(638),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_instanceof] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_GT_GT] = ACTIONS(638),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_in] = ACTIONS(638),
  },
  [713] = {
    [sym__initializer] = STATE(1463),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3062),
    [anon_sym_COMMA] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
  },
  [714] = {
    [sym__initializer] = STATE(1465),
    [sym_type_annotation] = STATE(1466),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3064),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_COMMA] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
  },
  [715] = {
    [sym__initializer] = STATE(1463),
    [sym_type_annotation] = STATE(1468),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3062),
    [anon_sym_QMARK] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
  },
  [716] = {
    [sym__initializer] = STATE(1470),
    [sym_type_annotation] = STATE(1471),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3070),
    [anon_sym_QMARK] = ACTIONS(3072),
    [anon_sym_COMMA] = ACTIONS(3070),
    [sym_comment] = ACTIONS(3),
  },
  [717] = {
    [sym__initializer] = STATE(1463),
    [sym_type_annotation] = STATE(1468),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3062),
    [anon_sym_COMMA] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
  },
  [718] = {
    [sym__initializer] = STATE(1473),
    [sym_type_annotation] = STATE(1474),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3074),
    [anon_sym_QMARK] = ACTIONS(3076),
    [anon_sym_COMMA] = ACTIONS(3074),
    [sym_comment] = ACTIONS(3),
  },
  [719] = {
    [sym_new_expression] = STATE(1475),
    [sym_augmented_assignment_expression] = STATE(1475),
    [sym_unary_expression] = STATE(1475),
    [sym_update_expression] = STATE(1475),
    [sym_regex] = STATE(1475),
    [sym_meta_property] = STATE(1475),
    [sym_call_signature] = STATE(242),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(1475),
    [sym_yield_expression] = STATE(1475),
    [sym_as_expression] = STATE(1475),
    [sym_non_null_expression] = STATE(1475),
    [sym_internal_module] = STATE(1475),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1475),
    [sym_await_expression] = STATE(1475),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1475),
    [sym_this] = STATE(1475),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1475),
    [sym_generator_function] = STATE(1475),
    [sym_call_expression] = STATE(1475),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1475),
    [sym_ternary_expression] = STATE(1475),
    [sym_binary_expression] = STATE(1475),
    [sym_template_string] = STATE(1475),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1475),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1475),
    [sym_class] = STATE(1475),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3078),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3078),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [720] = {
    [sym__initializer] = STATE(1476),
    [sym_type_annotation] = STATE(1477),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3082),
    [anon_sym_COMMA] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
  },
  [721] = {
    [sym_new_expression] = STATE(1478),
    [sym_augmented_assignment_expression] = STATE(1478),
    [sym_unary_expression] = STATE(1478),
    [sym_update_expression] = STATE(1478),
    [sym_regex] = STATE(1478),
    [sym_meta_property] = STATE(1478),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(1478),
    [sym_yield_expression] = STATE(1478),
    [sym_as_expression] = STATE(1478),
    [sym_non_null_expression] = STATE(1478),
    [sym_internal_module] = STATE(1478),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1478),
    [sym_await_expression] = STATE(1478),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1478),
    [sym_this] = STATE(1478),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1478),
    [sym_generator_function] = STATE(1478),
    [sym_call_expression] = STATE(1478),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1478),
    [sym_ternary_expression] = STATE(1478),
    [sym_binary_expression] = STATE(1478),
    [sym_template_string] = STATE(1478),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1478),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1478),
    [sym_class] = STATE(1478),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3084),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3086),
    [sym_true] = ACTIONS(3084),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3084),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [722] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(690),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_LT_LT] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(692),
    [anon_sym_GT_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(692),
    [anon_sym_BANG_EQ] = ACTIONS(692),
    [anon_sym_LT_EQ] = ACTIONS(690),
    [anon_sym_LPAREN] = ACTIONS(690),
    [anon_sym_GT_EQ] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(692),
    [anon_sym_PERCENT] = ACTIONS(690),
    [anon_sym_QMARK] = ACTIONS(690),
    [anon_sym_as] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_EQ_EQ] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(3088),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_instanceof] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(690),
    [anon_sym_DOT] = ACTIONS(690),
    [anon_sym_CARET] = ACTIONS(690),
    [anon_sym_STAR_STAR] = ACTIONS(690),
    [anon_sym_PLUS] = ACTIONS(692),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(690),
    [anon_sym_in] = ACTIONS(692),
  },
  [723] = {
    [sym__initializer] = STATE(1479),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
  },
  [724] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [725] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [726] = {
    [sym_type_annotation] = STATE(1481),
    [anon_sym_COLON] = ACTIONS(3096),
    [anon_sym_RPAREN] = ACTIONS(3098),
    [anon_sym_COMMA] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
  },
  [727] = {
    [anon_sym_EQ_GT] = ACTIONS(3100),
    [sym_comment] = ACTIONS(3),
  },
  [728] = {
    [anon_sym_EQ_GT] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
  },
  [729] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [730] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(863),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [731] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1599),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [732] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [733] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [734] = {
    [sym_call_signature] = STATE(727),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1362),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1362),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1362),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_async] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [735] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [736] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [737] = {
    [aux_sym_export_statement_repeat1] = STATE(1485),
    [sym_decorator] = STATE(1485),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(1486),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(1486),
    [sym_optional_parameter] = STATE(1486),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [738] = {
    [anon_sym_COLON] = ACTIONS(3106),
    [anon_sym_EQ_GT] = ACTIONS(3106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3106),
  },
  [739] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1488),
    [anon_sym_COMMA] = ACTIONS(3108),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
  },
  [740] = {
    [sym_new_expression] = STATE(1489),
    [sym_augmented_assignment_expression] = STATE(1489),
    [sym_unary_expression] = STATE(1489),
    [sym_update_expression] = STATE(1489),
    [sym_regex] = STATE(1489),
    [sym_meta_property] = STATE(1489),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(1489),
    [sym_yield_expression] = STATE(1489),
    [sym_as_expression] = STATE(1489),
    [sym_non_null_expression] = STATE(1489),
    [sym_internal_module] = STATE(1489),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1489),
    [sym_await_expression] = STATE(1489),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1489),
    [sym_this] = STATE(1489),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1489),
    [sym_generator_function] = STATE(1489),
    [sym_call_expression] = STATE(1489),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1489),
    [sym_ternary_expression] = STATE(1489),
    [sym_binary_expression] = STATE(1489),
    [sym_template_string] = STATE(1489),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1489),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1489),
    [sym_class] = STATE(1489),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3110),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3110),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3112),
    [sym_true] = ACTIONS(3110),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3110),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [741] = {
    [sym_new_expression] = STATE(1490),
    [sym_augmented_assignment_expression] = STATE(1490),
    [sym_unary_expression] = STATE(1490),
    [sym_update_expression] = STATE(1490),
    [sym_regex] = STATE(1490),
    [sym_meta_property] = STATE(1490),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(1490),
    [sym_yield_expression] = STATE(1490),
    [sym_as_expression] = STATE(1490),
    [sym_non_null_expression] = STATE(1490),
    [sym_internal_module] = STATE(1490),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1490),
    [sym_await_expression] = STATE(1490),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1490),
    [sym_this] = STATE(1490),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1490),
    [sym_generator_function] = STATE(1490),
    [sym_call_expression] = STATE(1490),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1490),
    [sym_ternary_expression] = STATE(1490),
    [sym_binary_expression] = STATE(1490),
    [sym_template_string] = STATE(1490),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1490),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1490),
    [sym_class] = STATE(1490),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3114),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3114),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3116),
    [sym_true] = ACTIONS(3114),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3114),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [742] = {
    [sym_new_expression] = STATE(1491),
    [sym_augmented_assignment_expression] = STATE(1491),
    [sym_unary_expression] = STATE(1491),
    [sym_update_expression] = STATE(1491),
    [sym_regex] = STATE(1491),
    [sym_meta_property] = STATE(1491),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(1491),
    [sym_yield_expression] = STATE(1491),
    [sym_as_expression] = STATE(1491),
    [sym_non_null_expression] = STATE(1491),
    [sym_internal_module] = STATE(1491),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1491),
    [sym_await_expression] = STATE(1491),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1491),
    [sym_this] = STATE(1491),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1491),
    [sym_generator_function] = STATE(1491),
    [sym_call_expression] = STATE(1491),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1491),
    [sym_ternary_expression] = STATE(1491),
    [sym_binary_expression] = STATE(1491),
    [sym_template_string] = STATE(1491),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1491),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1491),
    [sym_class] = STATE(1491),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3118),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3118),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3120),
    [sym_true] = ACTIONS(3118),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3118),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [743] = {
    [sym_new_expression] = STATE(1492),
    [sym_augmented_assignment_expression] = STATE(1492),
    [sym_unary_expression] = STATE(1492),
    [sym_update_expression] = STATE(1492),
    [sym_regex] = STATE(1492),
    [sym_meta_property] = STATE(1492),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(1492),
    [sym_yield_expression] = STATE(1492),
    [sym_as_expression] = STATE(1492),
    [sym_non_null_expression] = STATE(1492),
    [sym_internal_module] = STATE(1492),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1492),
    [sym_await_expression] = STATE(1492),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1492),
    [sym_this] = STATE(1492),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1492),
    [sym_generator_function] = STATE(1492),
    [sym_call_expression] = STATE(1492),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1492),
    [sym_ternary_expression] = STATE(1492),
    [sym_binary_expression] = STATE(1492),
    [sym_template_string] = STATE(1492),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1492),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1492),
    [sym_class] = STATE(1492),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3122),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3124),
    [sym_true] = ACTIONS(3122),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3122),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [744] = {
    [sym_new_expression] = STATE(1493),
    [sym_augmented_assignment_expression] = STATE(1493),
    [sym_unary_expression] = STATE(1493),
    [sym_update_expression] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_meta_property] = STATE(1493),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1493),
    [sym_yield_expression] = STATE(1493),
    [sym_as_expression] = STATE(1493),
    [sym_non_null_expression] = STATE(1493),
    [sym_internal_module] = STATE(1493),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1493),
    [sym_await_expression] = STATE(1493),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(1494),
    [sym_string] = STATE(1493),
    [sym_this] = STATE(1493),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1493),
    [sym_generator_function] = STATE(1493),
    [sym_call_expression] = STATE(1493),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1493),
    [sym_ternary_expression] = STATE(1493),
    [sym_binary_expression] = STATE(1493),
    [sym_template_string] = STATE(1493),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1493),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1493),
    [sym_class] = STATE(1493),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3126),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3128),
    [sym_true] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3126),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [745] = {
    [sym_new_expression] = STATE(1495),
    [sym_augmented_assignment_expression] = STATE(1495),
    [sym_unary_expression] = STATE(1495),
    [sym_update_expression] = STATE(1495),
    [sym_regex] = STATE(1495),
    [sym_meta_property] = STATE(1495),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1495),
    [sym_yield_expression] = STATE(1495),
    [sym_as_expression] = STATE(1495),
    [sym_non_null_expression] = STATE(1495),
    [sym_internal_module] = STATE(1495),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1495),
    [sym_await_expression] = STATE(1495),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1495),
    [sym_this] = STATE(1495),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1495),
    [sym_generator_function] = STATE(1495),
    [sym_call_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1495),
    [sym_ternary_expression] = STATE(1495),
    [sym_binary_expression] = STATE(1495),
    [sym_template_string] = STATE(1495),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1495),
    [sym_class] = STATE(1495),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3130),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3132),
    [sym_true] = ACTIONS(3130),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3130),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [746] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(3136),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [747] = {
    [sym_new_expression] = STATE(1449),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(1449),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1449),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1449),
    [sym_call_signature] = STATE(242),
    [sym_yield_expression] = STATE(1449),
    [sym_as_expression] = STATE(1449),
    [sym_internal_module] = STATE(1449),
    [sym_arrow_function] = STATE(1449),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(245),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(470),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(1449),
    [sym_subscript_expression] = STATE(245),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1449),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1449),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1449),
    [sym_meta_property] = STATE(1449),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(1449),
    [sym_non_null_expression] = STATE(1449),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1449),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1449),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1449),
    [sym_call_expression] = STATE(1449),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1449),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1449),
    [sym_type_arguments] = STATE(251),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(1449),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1449),
    [sym_class] = STATE(1449),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(3144),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(3146),
    [anon_sym_number] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(3148),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(3152),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(3031),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3146),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(3146),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(3146),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3031),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [748] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [sym__automatic_semicolon] = ACTIONS(3156),
    [anon_sym_PIPE] = ACTIONS(3158),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_LT_LT] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3158),
    [anon_sym_GT_GT_GT] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3156),
    [anon_sym_GT_EQ] = ACTIONS(3156),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_PERCENT] = ACTIONS(3156),
    [anon_sym_QMARK] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_as] = ACTIONS(3156),
    [anon_sym_PIPE_PIPE] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_EQ_EQ] = ACTIONS(3158),
    [anon_sym_instanceof] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3156),
    [anon_sym_CARET] = ACTIONS(3156),
    [anon_sym_STAR_STAR] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_GT_GT] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3156),
    [anon_sym_in] = ACTIONS(3158),
  },
  [749] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1511),
    [sym_constructor_type] = STATE(1511),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(1511),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1511),
    [sym_intersection_type] = STATE(1511),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [750] = {
    [sym_new_expression] = STATE(1512),
    [sym_augmented_assignment_expression] = STATE(1512),
    [sym_unary_expression] = STATE(1512),
    [sym_update_expression] = STATE(1512),
    [sym_regex] = STATE(1512),
    [sym_meta_property] = STATE(1512),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(1512),
    [sym_yield_expression] = STATE(1512),
    [sym_as_expression] = STATE(1512),
    [sym_non_null_expression] = STATE(1512),
    [sym_internal_module] = STATE(1512),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1512),
    [sym_await_expression] = STATE(1512),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(1512),
    [sym_this] = STATE(1512),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(1512),
    [sym_generator_function] = STATE(1512),
    [sym_call_expression] = STATE(1512),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(1512),
    [sym_ternary_expression] = STATE(1512),
    [sym_binary_expression] = STATE(1512),
    [sym_template_string] = STATE(1512),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1512),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1512),
    [sym_class] = STATE(1512),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3162),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3162),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [751] = {
    [anon_sym_RPAREN] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
  },
  [752] = {
    [sym_array] = STATE(1516),
    [sym_this] = STATE(1517),
    [sym_object] = STATE(1518),
    [anon_sym_get] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(3170),
    [anon_sym_module] = ACTIONS(3168),
    [anon_sym_symbol] = ACTIONS(3168),
    [anon_sym_number] = ACTIONS(3168),
    [anon_sym_declare] = ACTIONS(3168),
    [anon_sym_this] = ACTIONS(286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3168),
    [anon_sym_protected] = ACTIONS(3168),
    [anon_sym_string] = ACTIONS(3168),
    [anon_sym_set] = ACTIONS(3168),
    [anon_sym_type] = ACTIONS(3168),
    [anon_sym_import] = ACTIONS(3168),
    [anon_sym_export] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3168),
    [anon_sym_any] = ACTIONS(3168),
    [anon_sym_private] = ACTIONS(3168),
    [anon_sym_boolean] = ACTIONS(3168),
    [anon_sym_async] = ACTIONS(3168),
    [anon_sym_public] = ACTIONS(3168),
  },
  [753] = {
    [sym_new_expression] = STATE(1519),
    [sym_augmented_assignment_expression] = STATE(1519),
    [sym_unary_expression] = STATE(1519),
    [sym_update_expression] = STATE(1519),
    [sym_regex] = STATE(1519),
    [sym_meta_property] = STATE(1519),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1519),
    [sym_yield_expression] = STATE(1519),
    [sym_as_expression] = STATE(1519),
    [sym_non_null_expression] = STATE(1519),
    [sym_internal_module] = STATE(1519),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1519),
    [sym_await_expression] = STATE(1519),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1519),
    [sym_this] = STATE(1519),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1519),
    [sym_generator_function] = STATE(1519),
    [sym_call_expression] = STATE(1519),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1519),
    [sym_ternary_expression] = STATE(1519),
    [sym_binary_expression] = STATE(1519),
    [sym_template_string] = STATE(1519),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1519),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1519),
    [sym_class] = STATE(1519),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3172),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3174),
    [sym_true] = ACTIONS(3172),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3172),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [754] = {
    [anon_sym_COMMA] = ACTIONS(3062),
    [anon_sym_RPAREN] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
  },
  [755] = {
    [sym__initializer] = STATE(1520),
    [sym_type_annotation] = STATE(723),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3176),
    [anon_sym_QMARK] = ACTIONS(3178),
    [anon_sym_COMMA] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
  },
  [756] = {
    [sym__initializer] = STATE(754),
    [sym_type_annotation] = STATE(713),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3180),
    [anon_sym_QMARK] = ACTIONS(3182),
    [anon_sym_COMMA] = ACTIONS(3180),
    [sym_comment] = ACTIONS(3),
  },
  [757] = {
    [sym__initializer] = STATE(1520),
    [sym_type_annotation] = STATE(723),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_QMARK] = ACTIONS(3178),
    [anon_sym_RPAREN] = ACTIONS(3176),
    [anon_sym_this] = ACTIONS(1220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_export] = ACTIONS(1220),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_namespace] = ACTIONS(1220),
  },
  [758] = {
    [aux_sym_export_statement_repeat1] = STATE(758),
    [sym_decorator] = STATE(758),
    [anon_sym_get] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [sym_identifier] = ACTIONS(3007),
    [sym_readonly] = ACTIONS(3007),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_symbol] = ACTIONS(3007),
    [anon_sym_number] = ACTIONS(3007),
    [anon_sym_class] = ACTIONS(3007),
    [anon_sym_AT] = ACTIONS(2034),
    [anon_sym_this] = ACTIONS(3007),
    [anon_sym_declare] = ACTIONS(3007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(3007),
    [anon_sym_protected] = ACTIONS(3007),
    [anon_sym_string] = ACTIONS(3007),
    [anon_sym_set] = ACTIONS(3007),
    [anon_sym_type] = ACTIONS(3007),
    [anon_sym_import] = ACTIONS(3007),
    [anon_sym_export] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3007),
    [anon_sym_any] = ACTIONS(3007),
    [anon_sym_private] = ACTIONS(3007),
    [anon_sym_boolean] = ACTIONS(3007),
    [anon_sym_async] = ACTIONS(3007),
    [anon_sym_public] = ACTIONS(3007),
  },
  [759] = {
    [sym__initializer] = STATE(1521),
    [sym_type_annotation] = STATE(765),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3186),
    [anon_sym_COMMA] = ACTIONS(3184),
    [sym_comment] = ACTIONS(3),
  },
  [760] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1522),
    [anon_sym_COMMA] = ACTIONS(3108),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
  },
  [761] = {
    [sym__initializer] = STATE(1523),
    [sym_type_annotation] = STATE(768),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3188),
    [anon_sym_QMARK] = ACTIONS(3190),
    [anon_sym_COMMA] = ACTIONS(3188),
    [sym_comment] = ACTIONS(3),
  },
  [762] = {
    [sym__initializer] = STATE(754),
    [sym_type_annotation] = STATE(713),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3180),
    [anon_sym_COMMA] = ACTIONS(3180),
    [sym_comment] = ACTIONS(3),
  },
  [763] = {
    [sym__initializer] = STATE(1524),
    [sym_type_annotation] = STATE(1525),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3192),
    [anon_sym_COMMA] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
  },
  [764] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1896),
    [anon_sym_LBRACK] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1898),
    [anon_sym_BQUOTE] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_COMMA] = ACTIONS(3194),
    [anon_sym_LT_LT] = ACTIONS(1896),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT_GT] = ACTIONS(1896),
    [anon_sym_AMP_AMP] = ACTIONS(1896),
    [anon_sym_DASH] = ACTIONS(1898),
    [anon_sym_BANG_EQ] = ACTIONS(1898),
    [anon_sym_LT_EQ] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1896),
    [anon_sym_GT_EQ] = ACTIONS(1896),
    [anon_sym_GT] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1896),
    [anon_sym_QMARK] = ACTIONS(1896),
    [anon_sym_as] = ACTIONS(1896),
    [anon_sym_PIPE_PIPE] = ACTIONS(1896),
    [anon_sym_DASH_DASH] = ACTIONS(1896),
    [anon_sym_EQ_EQ] = ACTIONS(1898),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LT] = ACTIONS(1898),
    [anon_sym_instanceof] = ACTIONS(1896),
    [anon_sym_SLASH] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1896),
    [anon_sym_DOT] = ACTIONS(1896),
    [anon_sym_CARET] = ACTIONS(1896),
    [anon_sym_STAR_STAR] = ACTIONS(1896),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1898),
    [anon_sym_PLUS_PLUS] = ACTIONS(1896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1896),
    [anon_sym_in] = ACTIONS(1898),
  },
  [765] = {
    [sym__initializer] = STATE(1526),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3197),
    [anon_sym_COMMA] = ACTIONS(3197),
    [sym_comment] = ACTIONS(3),
  },
  [766] = {
    [sym__initializer] = STATE(1527),
    [sym_type_annotation] = STATE(1528),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3199),
    [anon_sym_COMMA] = ACTIONS(3199),
    [sym_comment] = ACTIONS(3),
  },
  [767] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2041),
    [anon_sym_LBRACK] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(2043),
    [anon_sym_BQUOTE] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_COMMA] = ACTIONS(3201),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_AMP_AMP] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2043),
    [anon_sym_LT_EQ] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(2041),
    [anon_sym_GT_EQ] = ACTIONS(2041),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2041),
    [anon_sym_as] = ACTIONS(2041),
    [anon_sym_PIPE_PIPE] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_RPAREN] = ACTIONS(3201),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_instanceof] = ACTIONS(2041),
    [anon_sym_SLASH] = ACTIONS(2043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2041),
    [anon_sym_DOT] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_GT_GT] = ACTIONS(2043),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2041),
    [anon_sym_in] = ACTIONS(2043),
  },
  [768] = {
    [sym__initializer] = STATE(1529),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_COMMA] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
  },
  [769] = {
    [sym_new_expression] = STATE(1531),
    [sym_augmented_assignment_expression] = STATE(1531),
    [sym_unary_expression] = STATE(1531),
    [sym_update_expression] = STATE(1531),
    [sym_regex] = STATE(1531),
    [sym_meta_property] = STATE(1531),
    [sym_call_signature] = STATE(51),
    [sym_statement_block] = STATE(1530),
    [sym__expression] = STATE(1531),
    [sym_yield_expression] = STATE(1531),
    [sym_as_expression] = STATE(1531),
    [sym_non_null_expression] = STATE(1531),
    [sym_internal_module] = STATE(1531),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1531),
    [sym_await_expression] = STATE(1531),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(1531),
    [sym_this] = STATE(1531),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(1531),
    [sym_generator_function] = STATE(1531),
    [sym_call_expression] = STATE(1531),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(1531),
    [sym_ternary_expression] = STATE(1531),
    [sym_binary_expression] = STATE(1531),
    [sym_template_string] = STATE(1531),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1531),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(1531),
    [sym_class] = STATE(1531),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(3206),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3206),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3208),
    [sym_true] = ACTIONS(3206),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3206),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [770] = {
    [sym_new_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_call_signature] = STATE(51),
    [sym_statement_block] = STATE(1532),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_non_null_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(1533),
    [sym_this] = STATE(1533),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(1533),
    [sym_generator_function] = STATE(1533),
    [sym_call_expression] = STATE(1533),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1533),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(1533),
    [sym_class] = STATE(1533),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3210),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3212),
    [sym_true] = ACTIONS(3210),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3210),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [771] = {
    [aux_sym_export_statement_repeat1] = STATE(1534),
    [sym_decorator] = STATE(1534),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(760),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(760),
    [sym_optional_parameter] = STATE(760),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [772] = {
    [sym_constraint] = STATE(790),
    [sym_default_type] = STATE(792),
    [anon_sym_GT] = ACTIONS(3214),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1477),
    [anon_sym_extends] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
  },
  [773] = {
    [sym_call_signature] = STATE(1535),
    [sym_formal_parameters] = STATE(858),
    [sym_type_parameters] = STATE(859),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [774] = {
    [sym_statement_block] = STATE(1536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(901),
  },
  [775] = {
    [sym_identifier] = ACTIONS(3216),
    [anon_sym_BQUOTE] = ACTIONS(3218),
    [anon_sym_debugger] = ACTIONS(3216),
    [anon_sym_symbol] = ACTIONS(3216),
    [anon_sym_AT] = ACTIONS(3218),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_void] = ACTIONS(3216),
    [anon_sym_break] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [sym_super] = ACTIONS(3216),
    [anon_sym_return] = ACTIONS(3216),
    [anon_sym_private] = ACTIONS(3216),
    [anon_sym_get] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3216),
    [anon_sym_default] = ACTIONS(3216),
    [anon_sym_enum] = ACTIONS(3216),
    [anon_sym_delete] = ACTIONS(3216),
    [anon_sym_continue] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3216),
    [anon_sym_this] = ACTIONS(3216),
    [anon_sym_yield] = ACTIONS(3216),
    [sym_true] = ACTIONS(3216),
    [anon_sym_throw] = ACTIONS(3216),
    [anon_sym_protected] = ACTIONS(3216),
    [anon_sym_abstract] = ACTIONS(3216),
    [anon_sym_set] = ACTIONS(3216),
    [anon_sym_type] = ACTIONS(3216),
    [anon_sym_import] = ACTIONS(3216),
    [anon_sym_namespace] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3218),
    [anon_sym_await] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3218),
    [anon_sym_else] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [sym_false] = ACTIONS(3216),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_case] = ACTIONS(3216),
    [anon_sym_module] = ACTIONS(3216),
    [anon_sym_number] = ACTIONS(3216),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_declare] = ACTIONS(3216),
    [anon_sym_typeof] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_switch] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(3218),
    [sym_null] = ACTIONS(3216),
    [anon_sym_any] = ACTIONS(3216),
    [anon_sym_boolean] = ACTIONS(3216),
    [anon_sym_async] = ACTIONS(3216),
    [anon_sym_public] = ACTIONS(3216),
    [anon_sym_var] = ACTIONS(3216),
    [anon_sym_while] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3216),
    [anon_sym_LT] = ACTIONS(3218),
    [sym_number] = ACTIONS(3218),
    [anon_sym_SLASH] = ACTIONS(3216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3216),
    [anon_sym_function] = ACTIONS(3216),
    [sym_undefined] = ACTIONS(3216),
    [anon_sym_new] = ACTIONS(3216),
    [ts_builtin_sym_end] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_export] = ACTIONS(3216),
    [anon_sym_do] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_with] = ACTIONS(3216),
  },
  [776] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1079),
    [sym__automatic_semicolon] = ACTIONS(3220),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym_COMMA] = ACTIONS(767),
    [sym_comment] = ACTIONS(3),
  },
  [777] = {
    [sym_identifier] = ACTIONS(3222),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [anon_sym_debugger] = ACTIONS(3222),
    [anon_sym_symbol] = ACTIONS(3222),
    [anon_sym_AT] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_void] = ACTIONS(3222),
    [anon_sym_break] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [sym_super] = ACTIONS(3222),
    [anon_sym_return] = ACTIONS(3222),
    [anon_sym_private] = ACTIONS(3222),
    [anon_sym_get] = ACTIONS(3222),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_default] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [anon_sym_delete] = ACTIONS(3222),
    [anon_sym_continue] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_if] = ACTIONS(3222),
    [anon_sym_this] = ACTIONS(3222),
    [anon_sym_yield] = ACTIONS(3222),
    [sym_true] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_protected] = ACTIONS(3222),
    [anon_sym_abstract] = ACTIONS(3222),
    [anon_sym_set] = ACTIONS(3222),
    [anon_sym_type] = ACTIONS(3222),
    [anon_sym_import] = ACTIONS(3222),
    [anon_sym_namespace] = ACTIONS(3222),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_await] = ACTIONS(3222),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [anon_sym_else] = ACTIONS(3222),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_for] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [sym_false] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_case] = ACTIONS(3222),
    [anon_sym_module] = ACTIONS(3222),
    [anon_sym_number] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_declare] = ACTIONS(3222),
    [anon_sym_typeof] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_switch] = ACTIONS(3222),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [sym_null] = ACTIONS(3222),
    [anon_sym_any] = ACTIONS(3222),
    [anon_sym_boolean] = ACTIONS(3222),
    [anon_sym_async] = ACTIONS(3222),
    [anon_sym_public] = ACTIONS(3222),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_while] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(3222),
    [anon_sym_LT] = ACTIONS(3224),
    [sym_number] = ACTIONS(3224),
    [anon_sym_SLASH] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3222),
    [anon_sym_function] = ACTIONS(3222),
    [sym_undefined] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [ts_builtin_sym_end] = ACTIONS(3224),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_export] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3222),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_with] = ACTIONS(3222),
  },
  [778] = {
    [aux_sym_string_repeat2] = STATE(778),
    [sym_escape_sequence] = ACTIONS(3226),
    [aux_sym_string_token2] = ACTIONS(3226),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(3229),
  },
  [779] = {
    [sym_identifier] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_debugger] = ACTIONS(1237),
    [anon_sym_symbol] = ACTIONS(1237),
    [anon_sym_AT] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [sym_super] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_get] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_interface] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_delete] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_this] = ACTIONS(1237),
    [anon_sym_yield] = ACTIONS(1237),
    [sym_true] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_protected] = ACTIONS(1237),
    [anon_sym_abstract] = ACTIONS(1237),
    [anon_sym_set] = ACTIONS(1237),
    [anon_sym_type] = ACTIONS(1237),
    [anon_sym_import] = ACTIONS(1237),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_await] = ACTIONS(1237),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [sym_false] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_module] = ACTIONS(1237),
    [anon_sym_number] = ACTIONS(1237),
    [anon_sym_class] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1237),
    [anon_sym_typeof] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [sym_null] = ACTIONS(1237),
    [anon_sym_catch] = ACTIONS(1237),
    [anon_sym_any] = ACTIONS(1237),
    [anon_sym_boolean] = ACTIONS(1237),
    [anon_sym_async] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_var] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_try] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [sym_number] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(1237),
    [anon_sym_string] = ACTIONS(1237),
    [anon_sym_function] = ACTIONS(1237),
    [sym_undefined] = ACTIONS(1237),
    [anon_sym_new] = ACTIONS(1237),
    [ts_builtin_sym_end] = ACTIONS(1239),
    [anon_sym_let] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_export] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_with] = ACTIONS(1237),
  },
  [780] = {
    [sym_statement_block] = STATE(1539),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [781] = {
    [sym_statement_block] = STATE(1540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [782] = {
    [sym_finally_clause] = STATE(1541),
    [sym_identifier] = ACTIONS(3233),
    [anon_sym_BQUOTE] = ACTIONS(3235),
    [anon_sym_debugger] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_AT] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_break] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [sym_super] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3233),
    [anon_sym_private] = ACTIONS(3233),
    [anon_sym_get] = ACTIONS(3233),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_interface] = ACTIONS(3233),
    [anon_sym_default] = ACTIONS(3233),
    [anon_sym_enum] = ACTIONS(3233),
    [anon_sym_delete] = ACTIONS(3233),
    [anon_sym_continue] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3233),
    [anon_sym_this] = ACTIONS(3233),
    [anon_sym_yield] = ACTIONS(3233),
    [sym_true] = ACTIONS(3233),
    [anon_sym_throw] = ACTIONS(3233),
    [anon_sym_protected] = ACTIONS(3233),
    [anon_sym_abstract] = ACTIONS(3233),
    [anon_sym_set] = ACTIONS(3233),
    [anon_sym_type] = ACTIONS(3233),
    [anon_sym_import] = ACTIONS(3233),
    [anon_sym_namespace] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3233),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [sym_false] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_case] = ACTIONS(3233),
    [anon_sym_module] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_class] = ACTIONS(3233),
    [anon_sym_declare] = ACTIONS(3233),
    [anon_sym_typeof] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [sym_null] = ACTIONS(3233),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_async] = ACTIONS(3233),
    [anon_sym_public] = ACTIONS(3233),
    [anon_sym_var] = ACTIONS(3233),
    [anon_sym_while] = ACTIONS(3233),
    [anon_sym_SQUOTE] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(3235),
    [sym_number] = ACTIONS(3235),
    [anon_sym_SLASH] = ACTIONS(3233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(1468),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_function] = ACTIONS(3233),
    [sym_undefined] = ACTIONS(3233),
    [anon_sym_new] = ACTIONS(3233),
    [ts_builtin_sym_end] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_export] = ACTIONS(3233),
    [anon_sym_do] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3235),
    [anon_sym_with] = ACTIONS(3233),
  },
  [783] = {
    [sym_identifier] = ACTIONS(3233),
    [anon_sym_BQUOTE] = ACTIONS(3235),
    [anon_sym_debugger] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_AT] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_break] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [sym_super] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3233),
    [anon_sym_private] = ACTIONS(3233),
    [anon_sym_get] = ACTIONS(3233),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_interface] = ACTIONS(3233),
    [anon_sym_default] = ACTIONS(3233),
    [anon_sym_enum] = ACTIONS(3233),
    [anon_sym_delete] = ACTIONS(3233),
    [anon_sym_continue] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3233),
    [anon_sym_this] = ACTIONS(3233),
    [anon_sym_yield] = ACTIONS(3233),
    [sym_true] = ACTIONS(3233),
    [anon_sym_throw] = ACTIONS(3233),
    [anon_sym_protected] = ACTIONS(3233),
    [anon_sym_abstract] = ACTIONS(3233),
    [anon_sym_set] = ACTIONS(3233),
    [anon_sym_type] = ACTIONS(3233),
    [anon_sym_import] = ACTIONS(3233),
    [anon_sym_namespace] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3233),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [sym_false] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_case] = ACTIONS(3233),
    [anon_sym_module] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_class] = ACTIONS(3233),
    [anon_sym_declare] = ACTIONS(3233),
    [anon_sym_typeof] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [sym_null] = ACTIONS(3233),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_async] = ACTIONS(3233),
    [anon_sym_public] = ACTIONS(3233),
    [anon_sym_var] = ACTIONS(3233),
    [anon_sym_while] = ACTIONS(3233),
    [anon_sym_SQUOTE] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(3235),
    [sym_number] = ACTIONS(3235),
    [anon_sym_SLASH] = ACTIONS(3233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_function] = ACTIONS(3233),
    [sym_undefined] = ACTIONS(3233),
    [anon_sym_new] = ACTIONS(3233),
    [ts_builtin_sym_end] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_export] = ACTIONS(3233),
    [anon_sym_do] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3235),
    [anon_sym_with] = ACTIONS(3233),
  },
  [784] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1542),
    [sym_constructor_type] = STATE(1542),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1542),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1542),
    [sym_intersection_type] = STATE(1542),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [785] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1548),
    [sym_constructor_type] = STATE(1548),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(1548),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1548),
    [sym_intersection_type] = STATE(1548),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1549),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1551),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [786] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1557),
    [sym_constructor_type] = STATE(1557),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(1557),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1557),
    [sym_intersection_type] = STATE(1557),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [787] = {
    [sym_identifier] = ACTIONS(3257),
    [sym_comment] = ACTIONS(3),
  },
  [788] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1565),
    [sym_constructor_type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1565),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1565),
    [sym_intersection_type] = STATE(1565),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [789] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1568),
    [sym_constructor_type] = STATE(1568),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1568),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1568),
    [sym_intersection_type] = STATE(1568),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [790] = {
    [sym_default_type] = STATE(1569),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(3265),
    [sym_comment] = ACTIONS(3),
  },
  [791] = {
    [sym_identifier] = ACTIONS(3267),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_debugger] = ACTIONS(3267),
    [anon_sym_symbol] = ACTIONS(3267),
    [anon_sym_AT] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_void] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [sym_super] = ACTIONS(3267),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_get] = ACTIONS(3267),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_interface] = ACTIONS(3267),
    [anon_sym_default] = ACTIONS(3267),
    [anon_sym_enum] = ACTIONS(3267),
    [anon_sym_delete] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_this] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [sym_true] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_set] = ACTIONS(3267),
    [anon_sym_type] = ACTIONS(3267),
    [anon_sym_import] = ACTIONS(3267),
    [anon_sym_namespace] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(3269),
    [anon_sym_else] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [sym_false] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_case] = ACTIONS(3267),
    [anon_sym_module] = ACTIONS(3267),
    [anon_sym_number] = ACTIONS(3267),
    [anon_sym_class] = ACTIONS(3267),
    [anon_sym_declare] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_RBRACK] = ACTIONS(3269),
    [sym_null] = ACTIONS(3267),
    [anon_sym_GT] = ACTIONS(3269),
    [anon_sym_any] = ACTIONS(3267),
    [anon_sym_boolean] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_EQ_GT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_var] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3269),
    [sym_number] = ACTIONS(3269),
    [anon_sym_SLASH] = ACTIONS(3267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3267),
    [anon_sym_function] = ACTIONS(3267),
    [sym_undefined] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [ts_builtin_sym_end] = ACTIONS(3269),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_implements] = ACTIONS(3267),
    [anon_sym_export] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_with] = ACTIONS(3267),
  },
  [792] = {
    [anon_sym_COMMA] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [sym_comment] = ACTIONS(3),
  },
  [793] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(837),
    [sym_constructor_type] = STATE(837),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(837),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(837),
    [sym_intersection_type] = STATE(837),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [794] = {
    [sym_identifier] = ACTIONS(3271),
    [anon_sym_BQUOTE] = ACTIONS(3273),
    [anon_sym_debugger] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_AT] = ACTIONS(3273),
    [anon_sym_PIPE] = ACTIONS(3273),
    [anon_sym_COMMA] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_EQ] = ACTIONS(3271),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [sym_super] = ACTIONS(3271),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_get] = ACTIONS(3271),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_default] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
    [anon_sym_delete] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_this] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [sym_true] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_set] = ACTIONS(3271),
    [anon_sym_type] = ACTIONS(3271),
    [anon_sym_import] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(3273),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(1589),
    [sym_false] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_case] = ACTIONS(3271),
    [anon_sym_module] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_declare] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_RBRACK] = ACTIONS(3273),
    [sym_null] = ACTIONS(3271),
    [anon_sym_GT] = ACTIONS(3273),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_EQ_GT] = ACTIONS(3273),
    [anon_sym_AMP] = ACTIONS(3273),
    [anon_sym_var] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_RPAREN] = ACTIONS(3273),
    [anon_sym_LT] = ACTIONS(3273),
    [sym_number] = ACTIONS(3273),
    [anon_sym_SLASH] = ACTIONS(3271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_function] = ACTIONS(3271),
    [sym_undefined] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [ts_builtin_sym_end] = ACTIONS(3273),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_export] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_with] = ACTIONS(3271),
  },
  [795] = {
    [sym_new_expression] = STATE(1341),
    [sym_augmented_assignment_expression] = STATE(1341),
    [sym_unary_expression] = STATE(1341),
    [sym_update_expression] = STATE(1341),
    [sym_regex] = STATE(1341),
    [sym_meta_property] = STATE(1341),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1341),
    [sym_as_expression] = STATE(1341),
    [sym_non_null_expression] = STATE(1341),
    [sym_internal_module] = STATE(1341),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1341),
    [sym_await_expression] = STATE(1341),
    [sym_member_expression] = STATE(1342),
    [sym_mapped_type] = STATE(1575),
    [sym_string] = STATE(1341),
    [sym_this] = STATE(1341),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_nested_type_identifier] = STATE(1345),
    [sym_anonymous_class] = STATE(1341),
    [sym_generator_function] = STATE(1341),
    [sym_call_expression] = STATE(1341),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(1341),
    [sym_ternary_expression] = STATE(1341),
    [sym_binary_expression] = STATE(1341),
    [sym_template_string] = STATE(1341),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1341),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(1341),
    [sym_class] = STATE(1341),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(3275),
    [sym_false] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3277),
    [anon_sym_symbol] = ACTIONS(3277),
    [anon_sym_number] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2763),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_boolean] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3281),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2777),
    [sym_true] = ACTIONS(2763),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_string] = ACTIONS(3277),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2763),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_type] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(3277),
    [anon_sym_export] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [796] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(1576),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(1576),
    [sym_call_signature] = STATE(1576),
    [sym_export_statement] = STATE(1576),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(1576),
    [sym_index_signature] = STATE(1576),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [797] = {
    [sym_string] = STATE(1577),
    [sym__property_name] = STATE(1577),
    [sym_computed_property_name] = STATE(1577),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [798] = {
    [aux_sym_export_statement_repeat1] = STATE(1579),
    [sym_decorator] = STATE(1579),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(1580),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(1580),
    [sym_optional_parameter] = STATE(1580),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(3287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [799] = {
    [sym_string] = STATE(1585),
    [sym__property_name] = STATE(1585),
    [sym_computed_property_name] = STATE(1585),
    [anon_sym_get] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(3289),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [800] = {
    [sym_string] = STATE(1577),
    [sym__property_name] = STATE(1577),
    [sym_computed_property_name] = STATE(1577),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(3299),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(3299),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [801] = {
    [sym_string] = STATE(1577),
    [sym__property_name] = STATE(1577),
    [sym_computed_property_name] = STATE(1577),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [802] = {
    [sym_identifier] = ACTIONS(3301),
    [anon_sym_BQUOTE] = ACTIONS(3303),
    [anon_sym_debugger] = ACTIONS(3301),
    [anon_sym_symbol] = ACTIONS(3301),
    [anon_sym_AT] = ACTIONS(3303),
    [anon_sym_PIPE] = ACTIONS(3303),
    [anon_sym_COMMA] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_EQ] = ACTIONS(3301),
    [anon_sym_void] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [sym_super] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_get] = ACTIONS(3301),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_interface] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_this] = ACTIONS(3301),
    [anon_sym_yield] = ACTIONS(3301),
    [sym_true] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_abstract] = ACTIONS(3301),
    [anon_sym_set] = ACTIONS(3301),
    [anon_sym_type] = ACTIONS(3301),
    [anon_sym_import] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_else] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [sym_false] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_case] = ACTIONS(3301),
    [anon_sym_module] = ACTIONS(3301),
    [anon_sym_number] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_declare] = ACTIONS(3301),
    [anon_sym_typeof] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_RBRACK] = ACTIONS(3303),
    [sym_null] = ACTIONS(3301),
    [anon_sym_GT] = ACTIONS(3303),
    [anon_sym_any] = ACTIONS(3301),
    [anon_sym_boolean] = ACTIONS(3301),
    [anon_sym_async] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_EQ_GT] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_RPAREN] = ACTIONS(3303),
    [anon_sym_LT] = ACTIONS(3303),
    [sym_number] = ACTIONS(3303),
    [anon_sym_SLASH] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3301),
    [anon_sym_function] = ACTIONS(3301),
    [sym_undefined] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [ts_builtin_sym_end] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_export] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_with] = ACTIONS(3301),
  },
  [803] = {
    [sym_formal_parameters] = STATE(1587),
    [sym_type_parameters] = STATE(1588),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [804] = {
    [sym_type_alias_declaration] = STATE(1609),
    [aux_sym_export_statement_repeat1] = STATE(1608),
    [sym__declaration] = STATE(1609),
    [sym_ambient_declaration] = STATE(1609),
    [sym_import_alias] = STATE(1609),
    [sym_export_statement] = STATE(1609),
    [sym_generator_function] = STATE(1609),
    [sym_export_clause] = STATE(1610),
    [sym_lexical_declaration] = STATE(1609),
    [sym_internal_module] = STATE(1609),
    [sym_decorator] = STATE(1608),
    [sym_enum_declaration] = STATE(1609),
    [sym_function] = STATE(1609),
    [sym_function_signature] = STATE(1609),
    [sym_variable_declaration] = STATE(1609),
    [sym_abstract_class] = STATE(1609),
    [sym_module] = STATE(1609),
    [sym_interface_declaration] = STATE(1609),
    [sym_class] = STATE(1609),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_import] = ACTIONS(3337),
    [anon_sym_export] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3341),
  },
  [805] = {
    [sym_string] = STATE(1585),
    [sym__property_name] = STATE(1585),
    [sym_computed_property_name] = STATE(1585),
    [anon_sym_get] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(3289),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(3291),
  },
  [806] = {
    [aux_sym_export_statement_repeat1] = STATE(1612),
    [sym_decorator] = STATE(1612),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(3343),
    [sym_comment] = ACTIONS(3),
  },
  [807] = {
    [sym_call_signature] = STATE(1615),
    [sym_type_annotation] = STATE(1616),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [sym__automatic_semicolon] = ACTIONS(3345),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3345),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(3345),
    [sym_comment] = ACTIONS(3),
  },
  [808] = {
    [sym_string] = STATE(1585),
    [sym__property_name] = STATE(1585),
    [sym_computed_property_name] = STATE(1585),
    [anon_sym_get] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(3289),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_private] = ACTIONS(1119),
  },
  [809] = {
    [sym_type_annotation] = STATE(1618),
    [sym__automatic_semicolon] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_PIPE_RBRACE] = ACTIONS(570),
    [sym_comment] = ACTIONS(3),
  },
  [810] = {
    [aux_sym_object_type_repeat1] = STATE(1621),
    [sym__automatic_semicolon] = ACTIONS(3353),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3355),
    [sym_comment] = ACTIONS(3),
  },
  [811] = {
    [sym_formal_parameters] = STATE(1622),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [812] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_is] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_RBRACK] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3359),
  },
  [813] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(819),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [814] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [815] = {
    [sym_formal_parameters] = STATE(1625),
    [sym_type_parameters] = STATE(1626),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [816] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [817] = {
    [aux_sym_implements_clause_repeat1] = STATE(1631),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(3365),
    [anon_sym_RBRACK] = ACTIONS(3367),
    [sym_comment] = ACTIONS(3),
  },
  [818] = {
    [sym_formal_parameters] = STATE(1632),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [819] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_RBRACK] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3369),
  },
  [820] = {
    [anon_sym_EQ_GT] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
  },
  [821] = {
    [sym_identifier] = ACTIONS(3373),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [anon_sym_debugger] = ACTIONS(3373),
    [anon_sym_symbol] = ACTIONS(3373),
    [anon_sym_AT] = ACTIONS(3375),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_COMMA] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_EQ] = ACTIONS(3373),
    [anon_sym_void] = ACTIONS(3373),
    [anon_sym_break] = ACTIONS(3373),
    [anon_sym_const] = ACTIONS(3373),
    [sym_super] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3373),
    [anon_sym_private] = ACTIONS(3373),
    [anon_sym_get] = ACTIONS(3373),
    [anon_sym_RBRACE] = ACTIONS(3375),
    [anon_sym_interface] = ACTIONS(3373),
    [anon_sym_default] = ACTIONS(3373),
    [anon_sym_enum] = ACTIONS(3373),
    [anon_sym_delete] = ACTIONS(3373),
    [anon_sym_continue] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_this] = ACTIONS(3373),
    [anon_sym_yield] = ACTIONS(3373),
    [sym_true] = ACTIONS(3373),
    [anon_sym_throw] = ACTIONS(3373),
    [anon_sym_protected] = ACTIONS(3373),
    [anon_sym_abstract] = ACTIONS(3373),
    [anon_sym_set] = ACTIONS(3373),
    [anon_sym_type] = ACTIONS(3373),
    [anon_sym_import] = ACTIONS(3373),
    [anon_sym_namespace] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_await] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_else] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3373),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [sym_false] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_case] = ACTIONS(3373),
    [anon_sym_module] = ACTIONS(3373),
    [anon_sym_number] = ACTIONS(3373),
    [anon_sym_class] = ACTIONS(3373),
    [anon_sym_declare] = ACTIONS(3373),
    [anon_sym_typeof] = ACTIONS(3373),
    [anon_sym_LBRACE] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3375),
    [anon_sym_RBRACK] = ACTIONS(3375),
    [sym_null] = ACTIONS(3373),
    [anon_sym_GT] = ACTIONS(3375),
    [anon_sym_any] = ACTIONS(3373),
    [anon_sym_boolean] = ACTIONS(3373),
    [anon_sym_async] = ACTIONS(3373),
    [anon_sym_public] = ACTIONS(3373),
    [anon_sym_EQ_GT] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3373),
    [anon_sym_while] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3373),
    [anon_sym_RPAREN] = ACTIONS(3375),
    [anon_sym_LT] = ACTIONS(3375),
    [sym_number] = ACTIONS(3375),
    [anon_sym_SLASH] = ACTIONS(3373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3373),
    [anon_sym_function] = ACTIONS(3373),
    [sym_undefined] = ACTIONS(3373),
    [anon_sym_new] = ACTIONS(3373),
    [ts_builtin_sym_end] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3373),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_export] = ACTIONS(3373),
    [anon_sym_do] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3375),
    [anon_sym_with] = ACTIONS(3373),
  },
  [822] = {
    [sym_identifier] = ACTIONS(3377),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [anon_sym_debugger] = ACTIONS(3377),
    [anon_sym_symbol] = ACTIONS(3377),
    [anon_sym_AT] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_EQ] = ACTIONS(3377),
    [anon_sym_void] = ACTIONS(3377),
    [anon_sym_break] = ACTIONS(3377),
    [anon_sym_const] = ACTIONS(3377),
    [sym_super] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3377),
    [anon_sym_private] = ACTIONS(3377),
    [anon_sym_get] = ACTIONS(3377),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3377),
    [anon_sym_default] = ACTIONS(3377),
    [anon_sym_enum] = ACTIONS(3377),
    [anon_sym_delete] = ACTIONS(3377),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3377),
    [anon_sym_this] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(3377),
    [sym_true] = ACTIONS(3377),
    [anon_sym_throw] = ACTIONS(3377),
    [anon_sym_protected] = ACTIONS(3377),
    [anon_sym_abstract] = ACTIONS(3377),
    [anon_sym_DOT] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(3377),
    [anon_sym_type] = ACTIONS(3377),
    [anon_sym_import] = ACTIONS(3377),
    [anon_sym_namespace] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [sym_false] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3377),
    [anon_sym_module] = ACTIONS(3377),
    [anon_sym_number] = ACTIONS(3377),
    [anon_sym_class] = ACTIONS(3377),
    [anon_sym_declare] = ACTIONS(3377),
    [anon_sym_typeof] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [anon_sym_RBRACK] = ACTIONS(3379),
    [sym_null] = ACTIONS(3377),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_any] = ACTIONS(3377),
    [anon_sym_boolean] = ACTIONS(3377),
    [anon_sym_async] = ACTIONS(3377),
    [anon_sym_public] = ACTIONS(3377),
    [anon_sym_EQ_GT] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3377),
    [anon_sym_RPAREN] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(3379),
    [sym_number] = ACTIONS(3379),
    [anon_sym_SLASH] = ACTIONS(3377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3377),
    [anon_sym_function] = ACTIONS(3377),
    [sym_undefined] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3377),
    [ts_builtin_sym_end] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_export] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3379),
    [anon_sym_with] = ACTIONS(3377),
  },
  [823] = {
    [sym_identifier] = ACTIONS(3381),
    [anon_sym_BQUOTE] = ACTIONS(3383),
    [anon_sym_debugger] = ACTIONS(3381),
    [anon_sym_symbol] = ACTIONS(3381),
    [anon_sym_AT] = ACTIONS(3383),
    [anon_sym_PIPE] = ACTIONS(3383),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3381),
    [anon_sym_EQ] = ACTIONS(3381),
    [anon_sym_void] = ACTIONS(3381),
    [anon_sym_break] = ACTIONS(3381),
    [anon_sym_const] = ACTIONS(3381),
    [sym_super] = ACTIONS(3381),
    [anon_sym_return] = ACTIONS(3381),
    [anon_sym_private] = ACTIONS(3381),
    [anon_sym_get] = ACTIONS(3381),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3381),
    [anon_sym_default] = ACTIONS(3381),
    [anon_sym_enum] = ACTIONS(3381),
    [anon_sym_delete] = ACTIONS(3381),
    [anon_sym_continue] = ACTIONS(3381),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3381),
    [anon_sym_this] = ACTIONS(3381),
    [anon_sym_yield] = ACTIONS(3381),
    [sym_true] = ACTIONS(3381),
    [anon_sym_throw] = ACTIONS(3381),
    [anon_sym_protected] = ACTIONS(3381),
    [anon_sym_abstract] = ACTIONS(3381),
    [anon_sym_set] = ACTIONS(3381),
    [anon_sym_type] = ACTIONS(3381),
    [anon_sym_import] = ACTIONS(3381),
    [anon_sym_namespace] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_await] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3381),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [sym_false] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3381),
    [anon_sym_module] = ACTIONS(3381),
    [anon_sym_number] = ACTIONS(3381),
    [anon_sym_class] = ACTIONS(3381),
    [anon_sym_declare] = ACTIONS(3381),
    [anon_sym_typeof] = ACTIONS(3381),
    [anon_sym_LBRACE] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3381),
    [anon_sym_LPAREN] = ACTIONS(3383),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [sym_null] = ACTIONS(3381),
    [anon_sym_GT] = ACTIONS(3383),
    [anon_sym_any] = ACTIONS(3381),
    [anon_sym_boolean] = ACTIONS(3381),
    [anon_sym_async] = ACTIONS(3381),
    [anon_sym_public] = ACTIONS(3381),
    [anon_sym_EQ_GT] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3381),
    [anon_sym_while] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3381),
    [anon_sym_RPAREN] = ACTIONS(3383),
    [anon_sym_LT] = ACTIONS(3383),
    [sym_number] = ACTIONS(3383),
    [anon_sym_SLASH] = ACTIONS(3381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3381),
    [anon_sym_function] = ACTIONS(3381),
    [sym_undefined] = ACTIONS(3381),
    [anon_sym_new] = ACTIONS(3381),
    [ts_builtin_sym_end] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3381),
    [anon_sym_PLUS] = ACTIONS(3381),
    [anon_sym_export] = ACTIONS(3381),
    [anon_sym_do] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3383),
    [anon_sym_with] = ACTIONS(3381),
  },
  [824] = {
    [sym_identifier] = ACTIONS(3385),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [anon_sym_debugger] = ACTIONS(3385),
    [anon_sym_symbol] = ACTIONS(3385),
    [anon_sym_AT] = ACTIONS(3387),
    [anon_sym_PIPE] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_void] = ACTIONS(3385),
    [anon_sym_break] = ACTIONS(3385),
    [anon_sym_const] = ACTIONS(3385),
    [sym_super] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3385),
    [anon_sym_private] = ACTIONS(3385),
    [anon_sym_get] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3385),
    [anon_sym_default] = ACTIONS(3385),
    [anon_sym_enum] = ACTIONS(3385),
    [anon_sym_delete] = ACTIONS(3385),
    [anon_sym_continue] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3385),
    [anon_sym_this] = ACTIONS(3385),
    [anon_sym_yield] = ACTIONS(3385),
    [sym_true] = ACTIONS(3385),
    [anon_sym_throw] = ACTIONS(3385),
    [anon_sym_protected] = ACTIONS(3385),
    [anon_sym_abstract] = ACTIONS(3385),
    [anon_sym_DOT] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3385),
    [anon_sym_type] = ACTIONS(3385),
    [anon_sym_import] = ACTIONS(3385),
    [anon_sym_namespace] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_await] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [sym_false] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3385),
    [anon_sym_module] = ACTIONS(3385),
    [anon_sym_number] = ACTIONS(3385),
    [anon_sym_class] = ACTIONS(3385),
    [anon_sym_declare] = ACTIONS(3385),
    [anon_sym_typeof] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_RBRACK] = ACTIONS(3387),
    [sym_null] = ACTIONS(3385),
    [anon_sym_GT] = ACTIONS(3387),
    [anon_sym_any] = ACTIONS(3385),
    [anon_sym_boolean] = ACTIONS(3385),
    [anon_sym_async] = ACTIONS(3385),
    [anon_sym_public] = ACTIONS(3385),
    [anon_sym_EQ_GT] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3385),
    [anon_sym_while] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3385),
    [anon_sym_RPAREN] = ACTIONS(3387),
    [anon_sym_LT] = ACTIONS(3387),
    [sym_number] = ACTIONS(3387),
    [anon_sym_SLASH] = ACTIONS(3385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3385),
    [anon_sym_function] = ACTIONS(3385),
    [sym_undefined] = ACTIONS(3385),
    [anon_sym_new] = ACTIONS(3385),
    [ts_builtin_sym_end] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_export] = ACTIONS(3385),
    [anon_sym_do] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3387),
    [anon_sym_with] = ACTIONS(3385),
  },
  [825] = {
    [sym_identifier] = ACTIONS(3391),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [anon_sym_debugger] = ACTIONS(3391),
    [anon_sym_symbol] = ACTIONS(3391),
    [anon_sym_AT] = ACTIONS(3393),
    [anon_sym_PIPE] = ACTIONS(3393),
    [anon_sym_COMMA] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_EQ] = ACTIONS(3391),
    [anon_sym_void] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [sym_super] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_get] = ACTIONS(3391),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_this] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [sym_true] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_set] = ACTIONS(3391),
    [anon_sym_type] = ACTIONS(3391),
    [anon_sym_import] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [anon_sym_else] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [sym_false] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_module] = ACTIONS(3391),
    [anon_sym_number] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_declare] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_RBRACK] = ACTIONS(3393),
    [sym_null] = ACTIONS(3391),
    [anon_sym_GT] = ACTIONS(3393),
    [anon_sym_any] = ACTIONS(3391),
    [anon_sym_boolean] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_EQ_GT] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_RPAREN] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3393),
    [sym_number] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3391),
    [anon_sym_function] = ACTIONS(3391),
    [sym_undefined] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [ts_builtin_sym_end] = ACTIONS(3393),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_export] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_with] = ACTIONS(3391),
  },
  [826] = {
    [anon_sym_EQ_GT] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
  },
  [827] = {
    [sym_formal_parameters] = STATE(1636),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [828] = {
    [sym_new_expression] = STATE(408),
    [sym_constructor_type] = STATE(817),
    [sym_augmented_assignment_expression] = STATE(408),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(408),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(408),
    [sym_call_signature] = STATE(158),
    [sym_yield_expression] = STATE(408),
    [sym_as_expression] = STATE(408),
    [sym_internal_module] = STATE(408),
    [sym_arrow_function] = STATE(408),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(161),
    [sym_mapped_type] = STATE(284),
    [sym_spread_element] = STATE(409),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1642),
    [sym_type_parameters] = STATE(1645),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(164),
    [sym_nested_type_identifier] = STATE(819),
    [sym_generator_function] = STATE(408),
    [sym_subscript_expression] = STATE(161),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(408),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(408),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1646),
    [sym_intersection_type] = STATE(817),
    [sym__type] = STATE(817),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(408),
    [sym_meta_property] = STATE(408),
    [sym_function_type] = STATE(817),
    [sym__expression] = STATE(408),
    [sym_non_null_expression] = STATE(408),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(408),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(408),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [aux_sym_array_repeat1] = STATE(410),
    [sym_anonymous_class] = STATE(408),
    [sym_call_expression] = STATE(408),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(408),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(408),
    [sym_type_arguments] = STATE(166),
    [sym_union_type] = STATE(817),
    [sym_parenthesized_expression] = STATE(408),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(408),
    [sym_class] = STATE(408),
    [sym_identifier] = ACTIONS(3397),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3399),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(3403),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [sym_false] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(3409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_RBRACK] = ACTIONS(747),
    [sym_null] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(3399),
    [anon_sym_boolean] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3411),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3399),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(745),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_TILDE] = ACTIONS(252),
  },
  [829] = {
    [sym__initializer] = STATE(754),
    [sym_type_annotation] = STATE(713),
    [sym_type_arguments] = STATE(791),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_QMARK] = ACTIONS(3182),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_is] = ACTIONS(3415),
    [anon_sym_RPAREN] = ACTIONS(3417),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(3180),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3420),
  },
  [830] = {
    [sym__initializer] = STATE(1520),
    [sym_type_annotation] = STATE(723),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_QMARK] = ACTIONS(3178),
    [anon_sym_RPAREN] = ACTIONS(3422),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_COMMA] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
  },
  [831] = {
    [sym_pair] = STATE(418),
    [aux_sym_export_statement_repeat1] = STATE(1661),
    [sym_object] = STATE(397),
    [sym__property_name] = STATE(1662),
    [aux_sym_object_repeat1] = STATE(420),
    [sym_assignment_pattern] = STATE(418),
    [sym_method_signature] = STATE(810),
    [sym_property_signature] = STATE(810),
    [sym_call_signature] = STATE(810),
    [sym_construct_signature] = STATE(810),
    [sym_export_statement] = STATE(810),
    [sym_method_definition] = STATE(418),
    [sym_index_signature] = STATE(810),
    [sym_decorator] = STATE(1661),
    [sym_accessibility_modifier] = STATE(1663),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(1662),
    [sym_array] = STATE(399),
    [sym_spread_element] = STATE(418),
    [sym_string] = STATE(1662),
    [sym_type_parameters] = STATE(811),
    [sym_identifier] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(3429),
    [anon_sym_symbol] = ACTIONS(3429),
    [anon_sym_number] = ACTIONS(3429),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(3429),
    [anon_sym_COMMA] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_boolean] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_get] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_string] = ACTIONS(3429),
    [anon_sym_set] = ACTIONS(3441),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(3429),
    [anon_sym_export] = ACTIONS(3447),
    [sym_readonly] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [832] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [833] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [834] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(839),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [835] = {
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1536),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(1536),
    [anon_sym_COMMA] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
  },
  [836] = {
    [sym_formal_parameters] = STATE(1664),
    [sym_type_parameters] = STATE(1665),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [837] = {
    [anon_sym_AMP] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
  },
  [838] = {
    [sym_formal_parameters] = STATE(1669),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [839] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3460),
  },
  [840] = {
    [anon_sym_EQ_GT] = ACTIONS(3462),
    [sym_comment] = ACTIONS(3),
  },
  [841] = {
    [sym_identifier] = ACTIONS(3464),
    [anon_sym_BQUOTE] = ACTIONS(3466),
    [anon_sym_debugger] = ACTIONS(3464),
    [anon_sym_symbol] = ACTIONS(3464),
    [anon_sym_AT] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3466),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_EQ] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3464),
    [anon_sym_break] = ACTIONS(3464),
    [anon_sym_const] = ACTIONS(3464),
    [sym_super] = ACTIONS(3464),
    [anon_sym_return] = ACTIONS(3464),
    [anon_sym_private] = ACTIONS(3464),
    [anon_sym_get] = ACTIONS(3464),
    [anon_sym_RBRACE] = ACTIONS(3466),
    [anon_sym_interface] = ACTIONS(3464),
    [anon_sym_default] = ACTIONS(3464),
    [anon_sym_enum] = ACTIONS(3464),
    [anon_sym_delete] = ACTIONS(3464),
    [anon_sym_continue] = ACTIONS(3464),
    [anon_sym_DASH_DASH] = ACTIONS(3466),
    [anon_sym_if] = ACTIONS(3464),
    [anon_sym_this] = ACTIONS(3464),
    [anon_sym_yield] = ACTIONS(3464),
    [sym_true] = ACTIONS(3464),
    [anon_sym_throw] = ACTIONS(3464),
    [anon_sym_protected] = ACTIONS(3464),
    [anon_sym_abstract] = ACTIONS(3464),
    [anon_sym_set] = ACTIONS(3464),
    [anon_sym_type] = ACTIONS(3464),
    [anon_sym_import] = ACTIONS(3464),
    [anon_sym_namespace] = ACTIONS(3464),
    [anon_sym_PLUS_PLUS] = ACTIONS(3466),
    [anon_sym_await] = ACTIONS(3464),
    [anon_sym_DQUOTE] = ACTIONS(3466),
    [anon_sym_else] = ACTIONS(3464),
    [anon_sym_BANG] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [sym_false] = ACTIONS(3464),
    [anon_sym_SEMI] = ACTIONS(3466),
    [anon_sym_case] = ACTIONS(3464),
    [anon_sym_module] = ACTIONS(3464),
    [anon_sym_number] = ACTIONS(3464),
    [anon_sym_class] = ACTIONS(3464),
    [anon_sym_declare] = ACTIONS(3464),
    [anon_sym_typeof] = ACTIONS(3464),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_switch] = ACTIONS(3464),
    [anon_sym_LPAREN] = ACTIONS(3466),
    [anon_sym_RBRACK] = ACTIONS(3466),
    [sym_null] = ACTIONS(3464),
    [anon_sym_GT] = ACTIONS(3466),
    [anon_sym_any] = ACTIONS(3464),
    [anon_sym_boolean] = ACTIONS(3464),
    [anon_sym_async] = ACTIONS(3464),
    [anon_sym_public] = ACTIONS(3464),
    [anon_sym_EQ_GT] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3466),
    [anon_sym_var] = ACTIONS(3464),
    [anon_sym_while] = ACTIONS(3464),
    [anon_sym_SQUOTE] = ACTIONS(3466),
    [anon_sym_try] = ACTIONS(3464),
    [anon_sym_RPAREN] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [sym_number] = ACTIONS(3466),
    [anon_sym_SLASH] = ACTIONS(3464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3464),
    [anon_sym_function] = ACTIONS(3464),
    [sym_undefined] = ACTIONS(3464),
    [anon_sym_new] = ACTIONS(3464),
    [ts_builtin_sym_end] = ACTIONS(3466),
    [anon_sym_let] = ACTIONS(3464),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_export] = ACTIONS(3464),
    [anon_sym_do] = ACTIONS(3464),
    [anon_sym_TILDE] = ACTIONS(3466),
    [anon_sym_with] = ACTIONS(3464),
  },
  [842] = {
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_BQUOTE] = ACTIONS(3470),
    [anon_sym_debugger] = ACTIONS(3468),
    [anon_sym_symbol] = ACTIONS(3468),
    [anon_sym_AT] = ACTIONS(3470),
    [anon_sym_PIPE] = ACTIONS(3470),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3468),
    [anon_sym_void] = ACTIONS(3468),
    [anon_sym_break] = ACTIONS(3468),
    [anon_sym_const] = ACTIONS(3468),
    [sym_super] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_private] = ACTIONS(3468),
    [anon_sym_get] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_RBRACE] = ACTIONS(3470),
    [anon_sym_interface] = ACTIONS(3468),
    [anon_sym_default] = ACTIONS(3468),
    [anon_sym_enum] = ACTIONS(3468),
    [anon_sym_delete] = ACTIONS(3468),
    [anon_sym_continue] = ACTIONS(3468),
    [anon_sym_DASH_DASH] = ACTIONS(3470),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_this] = ACTIONS(3468),
    [anon_sym_yield] = ACTIONS(3468),
    [sym_true] = ACTIONS(3468),
    [anon_sym_throw] = ACTIONS(3468),
    [anon_sym_protected] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(3468),
    [anon_sym_set] = ACTIONS(3468),
    [anon_sym_type] = ACTIONS(3468),
    [anon_sym_import] = ACTIONS(3468),
    [anon_sym_namespace] = ACTIONS(3468),
    [anon_sym_PLUS_PLUS] = ACTIONS(3470),
    [anon_sym_await] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3470),
    [anon_sym_else] = ACTIONS(3468),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [sym_false] = ACTIONS(3468),
    [anon_sym_SEMI] = ACTIONS(3470),
    [anon_sym_case] = ACTIONS(3468),
    [anon_sym_module] = ACTIONS(3468),
    [anon_sym_number] = ACTIONS(3468),
    [anon_sym_class] = ACTIONS(3468),
    [anon_sym_declare] = ACTIONS(3468),
    [anon_sym_typeof] = ACTIONS(3468),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_switch] = ACTIONS(3468),
    [anon_sym_LPAREN] = ACTIONS(3470),
    [anon_sym_RBRACK] = ACTIONS(3470),
    [sym_null] = ACTIONS(3468),
    [anon_sym_GT] = ACTIONS(3470),
    [anon_sym_any] = ACTIONS(3468),
    [anon_sym_boolean] = ACTIONS(3468),
    [anon_sym_async] = ACTIONS(3468),
    [anon_sym_public] = ACTIONS(3468),
    [anon_sym_EQ_GT] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3470),
    [anon_sym_var] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_SQUOTE] = ACTIONS(3470),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_RPAREN] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [sym_number] = ACTIONS(3470),
    [anon_sym_SLASH] = ACTIONS(3468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3468),
    [anon_sym_function] = ACTIONS(3468),
    [sym_undefined] = ACTIONS(3468),
    [anon_sym_new] = ACTIONS(3468),
    [ts_builtin_sym_end] = ACTIONS(3470),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_implements] = ACTIONS(3468),
    [anon_sym_export] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [anon_sym_with] = ACTIONS(3468),
  },
  [843] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [844] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [845] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1675),
    [sym_constructor_type] = STATE(1675),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1675),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1675),
    [sym_intersection_type] = STATE(1675),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_boolean] = ACTIONS(472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_this] = ACTIONS(474),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [846] = {
    [aux_sym_implements_clause_repeat1] = STATE(1677),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_GT] = ACTIONS(3472),
    [sym_comment] = ACTIONS(3),
  },
  [847] = {
    [anon_sym_EQ_GT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(3),
  },
  [848] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1679),
    [sym_constructor_type] = STATE(1679),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1679),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1679),
    [sym_intersection_type] = STATE(1679),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [849] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1680),
    [sym_constructor_type] = STATE(1680),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(1680),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1680),
    [sym_intersection_type] = STATE(1680),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [850] = {
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_BQUOTE] = ACTIONS(3480),
    [anon_sym_debugger] = ACTIONS(3478),
    [anon_sym_symbol] = ACTIONS(3478),
    [anon_sym_AT] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_void] = ACTIONS(3478),
    [anon_sym_break] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(3478),
    [sym_super] = ACTIONS(3478),
    [anon_sym_return] = ACTIONS(3478),
    [anon_sym_private] = ACTIONS(3478),
    [anon_sym_get] = ACTIONS(3478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3480),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3478),
    [anon_sym_enum] = ACTIONS(3478),
    [anon_sym_delete] = ACTIONS(3478),
    [anon_sym_continue] = ACTIONS(3478),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3478),
    [anon_sym_this] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3478),
    [sym_true] = ACTIONS(3478),
    [anon_sym_throw] = ACTIONS(3478),
    [anon_sym_protected] = ACTIONS(3478),
    [anon_sym_abstract] = ACTIONS(3478),
    [anon_sym_set] = ACTIONS(3478),
    [anon_sym_type] = ACTIONS(3478),
    [anon_sym_import] = ACTIONS(3478),
    [anon_sym_namespace] = ACTIONS(3478),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_await] = ACTIONS(3478),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_else] = ACTIONS(3478),
    [anon_sym_BANG] = ACTIONS(3480),
    [anon_sym_for] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [sym_false] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym_case] = ACTIONS(3478),
    [anon_sym_module] = ACTIONS(3478),
    [anon_sym_number] = ACTIONS(3478),
    [anon_sym_class] = ACTIONS(3478),
    [anon_sym_declare] = ACTIONS(3478),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3478),
    [anon_sym_switch] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_RBRACK] = ACTIONS(3480),
    [sym_null] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3480),
    [anon_sym_any] = ACTIONS(3478),
    [anon_sym_boolean] = ACTIONS(3478),
    [anon_sym_async] = ACTIONS(3478),
    [anon_sym_public] = ACTIONS(3478),
    [anon_sym_EQ_GT] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_var] = ACTIONS(3478),
    [anon_sym_while] = ACTIONS(3478),
    [anon_sym_SQUOTE] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3478),
    [anon_sym_RPAREN] = ACTIONS(3480),
    [anon_sym_LT] = ACTIONS(3480),
    [sym_number] = ACTIONS(3480),
    [anon_sym_SLASH] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3478),
    [sym_undefined] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3478),
    [ts_builtin_sym_end] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_implements] = ACTIONS(3478),
    [anon_sym_export] = ACTIONS(3478),
    [anon_sym_do] = ACTIONS(3478),
    [anon_sym_TILDE] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3478),
  },
  [851] = {
    [sym_type_parameter] = STATE(1682),
    [anon_sym_GT] = ACTIONS(3482),
    [sym_identifier] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
  },
  [852] = {
    [anon_sym_extends] = ACTIONS(3484),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3484),
    [anon_sym_EQ] = ACTIONS(3484),
    [anon_sym_implements] = ACTIONS(3484),
    [anon_sym_LPAREN] = ACTIONS(3484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3486),
  },
  [853] = {
    [aux_sym_type_parameters_repeat1] = STATE(1684),
    [anon_sym_COMMA] = ACTIONS(3488),
    [anon_sym_GT] = ACTIONS(3482),
    [sym_comment] = ACTIONS(3),
  },
  [854] = {
    [anon_sym_RBRACK] = ACTIONS(3490),
    [sym_comment] = ACTIONS(3),
  },
  [855] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1686),
    [sym_constructor_type] = STATE(1686),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1686),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1686),
    [sym_intersection_type] = STATE(1686),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [856] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3492),
    [anon_sym_LBRACK] = ACTIONS(3492),
    [anon_sym_BANG] = ACTIONS(3494),
    [anon_sym_SEMI] = ACTIONS(3492),
    [anon_sym_BQUOTE] = ACTIONS(3492),
    [sym__automatic_semicolon] = ACTIONS(3492),
    [anon_sym_PIPE] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_LT_LT] = ACTIONS(3492),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_GT_GT_GT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3492),
    [anon_sym_GT_EQ] = ACTIONS(3492),
    [anon_sym_GT] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_QMARK] = ACTIONS(3492),
    [anon_sym_RBRACE] = ACTIONS(3492),
    [anon_sym_as] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3492),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_EQ_EQ] = ACTIONS(3494),
    [anon_sym_instanceof] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3494),
    [anon_sym_RPAREN] = ACTIONS(3492),
    [anon_sym_SLASH] = ACTIONS(3494),
    [sym_comment] = ACTIONS(3),
    [sym_regex_flags] = ACTIONS(3496),
    [anon_sym_DOT] = ACTIONS(3492),
    [anon_sym_CARET] = ACTIONS(3492),
    [anon_sym_STAR_STAR] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_GT_GT] = ACTIONS(3494),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3492),
    [anon_sym_in] = ACTIONS(3494),
  },
  [857] = {
    [sym_statement_block] = STATE(1536),
    [sym__automatic_semicolon] = ACTIONS(3498),
    [anon_sym_SEMI] = ACTIONS(3498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(901),
  },
  [858] = {
    [sym_type_annotation] = STATE(1618),
    [sym__automatic_semicolon] = ACTIONS(570),
    [anon_sym_COLON] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(570),
  },
  [859] = {
    [sym_formal_parameters] = STATE(1690),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [860] = {
    [sym_call_signature] = STATE(1691),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [861] = {
    [sym_statement_block] = STATE(1692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(901),
  },
  [862] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3502),
    [sym_identifier] = ACTIONS(3504),
    [sym__automatic_semicolon] = ACTIONS(3502),
    [anon_sym_BQUOTE] = ACTIONS(3502),
    [anon_sym_debugger] = ACTIONS(3504),
    [ts_builtin_sym_end] = ACTIONS(3502),
    [anon_sym_symbol] = ACTIONS(3504),
    [anon_sym_AT] = ACTIONS(3502),
    [anon_sym_PIPE] = ACTIONS(3504),
    [anon_sym_COMMA] = ACTIONS(3502),
    [anon_sym_DASH] = ACTIONS(3504),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_GT_GT_GT] = ACTIONS(3502),
    [anon_sym_void] = ACTIONS(3504),
    [anon_sym_break] = ACTIONS(3504),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_const] = ACTIONS(3504),
    [anon_sym_GT_EQ] = ACTIONS(3502),
    [sym_super] = ACTIONS(3504),
    [anon_sym_return] = ACTIONS(3504),
    [anon_sym_private] = ACTIONS(3504),
    [anon_sym_get] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3502),
    [anon_sym_PERCENT] = ACTIONS(3502),
    [anon_sym_interface] = ACTIONS(3504),
    [anon_sym_default] = ACTIONS(3504),
    [anon_sym_as] = ACTIONS(3504),
    [anon_sym_delete] = ACTIONS(3504),
    [anon_sym_continue] = ACTIONS(3504),
    [anon_sym_DASH_DASH] = ACTIONS(3502),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_instanceof] = ACTIONS(3504),
    [anon_sym_this] = ACTIONS(3504),
    [anon_sym_yield] = ACTIONS(3504),
    [sym_true] = ACTIONS(3504),
    [anon_sym_throw] = ACTIONS(3504),
    [anon_sym_enum] = ACTIONS(3504),
    [anon_sym_protected] = ACTIONS(3504),
    [anon_sym_abstract] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_set] = ACTIONS(3504),
    [anon_sym_type] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(3502),
    [anon_sym_import] = ACTIONS(3504),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3502),
    [anon_sym_namespace] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3502),
    [anon_sym_await] = ACTIONS(3504),
    [anon_sym_DQUOTE] = ACTIONS(3502),
    [anon_sym_else] = ACTIONS(3504),
    [anon_sym_BANG] = ACTIONS(3504),
    [anon_sym_for] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [sym_false] = ACTIONS(3504),
    [anon_sym_SEMI] = ACTIONS(3502),
    [anon_sym_case] = ACTIONS(3504),
    [anon_sym_module] = ACTIONS(3504),
    [anon_sym_number] = ACTIONS(3504),
    [anon_sym_class] = ACTIONS(3504),
    [anon_sym_declare] = ACTIONS(3504),
    [anon_sym_typeof] = ACTIONS(3504),
    [anon_sym_LT_LT] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3502),
    [anon_sym_AMP_AMP] = ACTIONS(3502),
    [anon_sym_switch] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3502),
    [anon_sym_LPAREN] = ACTIONS(3502),
    [sym_null] = ACTIONS(3504),
    [anon_sym_GT] = ACTIONS(3504),
    [anon_sym_any] = ACTIONS(3504),
    [anon_sym_boolean] = ACTIONS(3504),
    [anon_sym_async] = ACTIONS(3504),
    [anon_sym_public] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3504),
    [anon_sym_var] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE] = ACTIONS(3502),
    [anon_sym_while] = ACTIONS(3504),
    [anon_sym_SQUOTE] = ACTIONS(3502),
    [anon_sym_try] = ACTIONS(3504),
    [anon_sym_EQ_EQ] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [anon_sym_LT] = ACTIONS(3504),
    [sym_number] = ACTIONS(3502),
    [anon_sym_SLASH] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3504),
    [anon_sym_function] = ACTIONS(3504),
    [sym_undefined] = ACTIONS(3504),
    [anon_sym_new] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_let] = ACTIONS(3504),
    [anon_sym_PLUS] = ACTIONS(3504),
    [anon_sym_export] = ACTIONS(3504),
    [anon_sym_GT_GT] = ACTIONS(3504),
    [anon_sym_do] = ACTIONS(3504),
    [anon_sym_TILDE] = ACTIONS(3502),
    [anon_sym_with] = ACTIONS(3504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3502),
    [anon_sym_in] = ACTIONS(3504),
  },
  [863] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1698),
    [sym_constructor_type] = STATE(1698),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(1698),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1698),
    [sym_intersection_type] = STATE(1698),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1699),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1701),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [864] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_COLON] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1739),
  },
  [865] = {
    [sym_new_expression] = STATE(1702),
    [sym_augmented_assignment_expression] = STATE(1702),
    [sym_unary_expression] = STATE(1702),
    [sym_update_expression] = STATE(1702),
    [sym_regex] = STATE(1702),
    [sym_meta_property] = STATE(1702),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(1702),
    [sym_yield_expression] = STATE(1702),
    [sym_as_expression] = STATE(1702),
    [sym_non_null_expression] = STATE(1702),
    [sym_internal_module] = STATE(1702),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1702),
    [sym_await_expression] = STATE(1702),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(1702),
    [sym_this] = STATE(1702),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(1702),
    [sym_generator_function] = STATE(1702),
    [sym_call_expression] = STATE(1702),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(1702),
    [sym_ternary_expression] = STATE(1702),
    [sym_binary_expression] = STATE(1702),
    [sym_template_string] = STATE(1702),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1702),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(1702),
    [sym_class] = STATE(1702),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3516),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3518),
    [sym_true] = ACTIONS(3516),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3516),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [866] = {
    [sym_new_expression] = STATE(555),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(555),
    [sym_meta_property] = STATE(555),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(555),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(555),
    [sym_this] = STATE(555),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(555),
    [sym_generator_function] = STATE(555),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(555),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(555),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(555),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1637),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1637),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [867] = {
    [sym_new_expression] = STATE(555),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(555),
    [sym_meta_property] = STATE(555),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(555),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(555),
    [sym_this] = STATE(555),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(555),
    [sym_generator_function] = STATE(555),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(555),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(555),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(555),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1637),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1637),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [868] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3520),
    [anon_sym_LBRACK] = ACTIONS(3520),
    [anon_sym_BANG] = ACTIONS(3522),
    [anon_sym_SEMI] = ACTIONS(3520),
    [anon_sym_BQUOTE] = ACTIONS(3520),
    [sym__automatic_semicolon] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3522),
    [anon_sym_COMMA] = ACTIONS(3520),
    [anon_sym_LT_LT] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3522),
    [anon_sym_GT_GT_GT] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_BANG_EQ] = ACTIONS(3522),
    [anon_sym_LT_EQ] = ACTIONS(3520),
    [anon_sym_LPAREN] = ACTIONS(3520),
    [anon_sym_GT_EQ] = ACTIONS(3520),
    [anon_sym_GT] = ACTIONS(3522),
    [anon_sym_AMP] = ACTIONS(3522),
    [anon_sym_PERCENT] = ACTIONS(3520),
    [anon_sym_QMARK] = ACTIONS(3520),
    [anon_sym_RBRACE] = ACTIONS(3520),
    [anon_sym_as] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_DASH_DASH] = ACTIONS(3520),
    [anon_sym_EQ_EQ] = ACTIONS(3522),
    [anon_sym_instanceof] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(3522),
    [anon_sym_RPAREN] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3520),
    [anon_sym_CARET] = ACTIONS(3520),
    [anon_sym_STAR_STAR] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_GT_GT] = ACTIONS(3522),
    [anon_sym_PLUS_PLUS] = ACTIONS(3520),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3520),
    [anon_sym_in] = ACTIONS(3522),
  },
  [869] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3524),
    [anon_sym_LBRACK] = ACTIONS(3524),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_SEMI] = ACTIONS(3524),
    [anon_sym_BQUOTE] = ACTIONS(3524),
    [sym__automatic_semicolon] = ACTIONS(3524),
    [anon_sym_PIPE] = ACTIONS(3526),
    [anon_sym_COMMA] = ACTIONS(3524),
    [anon_sym_LT_LT] = ACTIONS(3524),
    [anon_sym_STAR] = ACTIONS(3526),
    [anon_sym_GT_GT_GT] = ACTIONS(3524),
    [anon_sym_AMP_AMP] = ACTIONS(3524),
    [anon_sym_DASH] = ACTIONS(3526),
    [anon_sym_BANG_EQ] = ACTIONS(3526),
    [anon_sym_LT_EQ] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(3524),
    [anon_sym_GT_EQ] = ACTIONS(3524),
    [anon_sym_GT] = ACTIONS(3526),
    [anon_sym_AMP] = ACTIONS(3526),
    [anon_sym_PERCENT] = ACTIONS(3524),
    [anon_sym_QMARK] = ACTIONS(3524),
    [anon_sym_RBRACE] = ACTIONS(3524),
    [anon_sym_as] = ACTIONS(3524),
    [anon_sym_PIPE_PIPE] = ACTIONS(3524),
    [anon_sym_DASH_DASH] = ACTIONS(3524),
    [anon_sym_EQ_EQ] = ACTIONS(3526),
    [anon_sym_instanceof] = ACTIONS(3524),
    [anon_sym_LT] = ACTIONS(3526),
    [anon_sym_RPAREN] = ACTIONS(3524),
    [anon_sym_SLASH] = ACTIONS(3526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3524),
    [anon_sym_CARET] = ACTIONS(3524),
    [anon_sym_STAR_STAR] = ACTIONS(3524),
    [anon_sym_PLUS] = ACTIONS(3526),
    [anon_sym_GT_GT] = ACTIONS(3526),
    [anon_sym_PLUS_PLUS] = ACTIONS(3524),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3524),
    [anon_sym_in] = ACTIONS(3526),
  },
  [870] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3528),
    [anon_sym_LBRACK] = ACTIONS(3528),
    [anon_sym_BANG] = ACTIONS(3530),
    [anon_sym_SEMI] = ACTIONS(3528),
    [anon_sym_BQUOTE] = ACTIONS(3528),
    [sym__automatic_semicolon] = ACTIONS(3528),
    [anon_sym_PIPE] = ACTIONS(3530),
    [anon_sym_COMMA] = ACTIONS(3528),
    [anon_sym_LT_LT] = ACTIONS(3528),
    [anon_sym_STAR] = ACTIONS(3530),
    [anon_sym_GT_GT_GT] = ACTIONS(3528),
    [anon_sym_AMP_AMP] = ACTIONS(3528),
    [anon_sym_DASH] = ACTIONS(3530),
    [anon_sym_BANG_EQ] = ACTIONS(3530),
    [anon_sym_LT_EQ] = ACTIONS(3528),
    [anon_sym_LPAREN] = ACTIONS(3528),
    [anon_sym_GT_EQ] = ACTIONS(3528),
    [anon_sym_GT] = ACTIONS(3530),
    [anon_sym_AMP] = ACTIONS(3530),
    [anon_sym_PERCENT] = ACTIONS(3528),
    [anon_sym_QMARK] = ACTIONS(3528),
    [anon_sym_RBRACE] = ACTIONS(3528),
    [anon_sym_as] = ACTIONS(3528),
    [anon_sym_PIPE_PIPE] = ACTIONS(3528),
    [anon_sym_DASH_DASH] = ACTIONS(3528),
    [anon_sym_EQ_EQ] = ACTIONS(3530),
    [anon_sym_instanceof] = ACTIONS(3528),
    [anon_sym_LT] = ACTIONS(3530),
    [anon_sym_RPAREN] = ACTIONS(3528),
    [anon_sym_SLASH] = ACTIONS(3530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3528),
    [anon_sym_CARET] = ACTIONS(3528),
    [anon_sym_STAR_STAR] = ACTIONS(3528),
    [anon_sym_PLUS] = ACTIONS(3530),
    [anon_sym_GT_GT] = ACTIONS(3530),
    [anon_sym_PLUS_PLUS] = ACTIONS(3528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3528),
    [anon_sym_in] = ACTIONS(3530),
  },
  [871] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3532),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1643),
  },
  [872] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [873] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(514),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [874] = {
    [sym_call_signature] = STATE(1705),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(3536),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(3538),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(3538),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(3538),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(3538),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(3538),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(3538),
    [anon_sym_type] = ACTIONS(3538),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(3538),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(3538),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(3538),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(3538),
    [anon_sym_declare] = ACTIONS(3538),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(3538),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(3538),
    [anon_sym_async] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3538),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(3538),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(3538),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [875] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(3540),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(3542),
    [anon_sym_symbol] = ACTIONS(3542),
    [anon_sym_number] = ACTIONS(3542),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3542),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3542),
    [anon_sym_private] = ACTIONS(3542),
    [anon_sym_boolean] = ACTIONS(3542),
    [anon_sym_async] = ACTIONS(3546),
    [anon_sym_public] = ACTIONS(3542),
    [anon_sym_get] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3542),
    [anon_sym_string] = ACTIONS(3542),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(3542),
    [anon_sym_type] = ACTIONS(3542),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(3542),
    [anon_sym_export] = ACTIONS(3542),
    [anon_sym_namespace] = ACTIONS(3548),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [876] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [877] = {
    [anon_sym_EQ_GT] = ACTIONS(3532),
    [sym_comment] = ACTIONS(3),
  },
  [878] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [879] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [880] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1643),
  },
  [881] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1643),
  },
  [882] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [883] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [884] = {
    [sym_new_expression] = STATE(1724),
    [sym_augmented_assignment_expression] = STATE(1724),
    [sym_unary_expression] = STATE(1724),
    [sym_update_expression] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(1724),
    [sym_yield_expression] = STATE(1724),
    [sym_as_expression] = STATE(1724),
    [sym_non_null_expression] = STATE(1724),
    [sym_internal_module] = STATE(1724),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1724),
    [sym_await_expression] = STATE(1724),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(1724),
    [sym_this] = STATE(1724),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_call_expression] = STATE(1724),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(1724),
    [sym_ternary_expression] = STATE(1724),
    [sym_binary_expression] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1724),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(1724),
    [sym_class] = STATE(1724),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3553),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3555),
    [sym_true] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3553),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [885] = {
    [sym_new_expression] = STATE(1725),
    [sym_augmented_assignment_expression] = STATE(1725),
    [sym_unary_expression] = STATE(1725),
    [sym_update_expression] = STATE(1725),
    [sym_regex] = STATE(1725),
    [sym_meta_property] = STATE(1725),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(1725),
    [sym_yield_expression] = STATE(1725),
    [sym_as_expression] = STATE(1725),
    [sym_non_null_expression] = STATE(1725),
    [sym_internal_module] = STATE(1725),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1725),
    [sym_await_expression] = STATE(1725),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(1725),
    [sym_this] = STATE(1725),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(1725),
    [sym_generator_function] = STATE(1725),
    [sym_call_expression] = STATE(1725),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(1725),
    [sym_ternary_expression] = STATE(1725),
    [sym_binary_expression] = STATE(1725),
    [sym_template_string] = STATE(1725),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1725),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(1725),
    [sym_class] = STATE(1725),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3557),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3559),
    [sym_true] = ACTIONS(3557),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3557),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [886] = {
    [sym_new_expression] = STATE(1726),
    [sym_augmented_assignment_expression] = STATE(1726),
    [sym_unary_expression] = STATE(1726),
    [sym_update_expression] = STATE(1726),
    [sym_regex] = STATE(1726),
    [sym_meta_property] = STATE(1726),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(1726),
    [sym_yield_expression] = STATE(1726),
    [sym_as_expression] = STATE(1726),
    [sym_non_null_expression] = STATE(1726),
    [sym_internal_module] = STATE(1726),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1726),
    [sym_await_expression] = STATE(1726),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(1726),
    [sym_this] = STATE(1726),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(1726),
    [sym_generator_function] = STATE(1726),
    [sym_call_expression] = STATE(1726),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(1726),
    [sym_ternary_expression] = STATE(1726),
    [sym_binary_expression] = STATE(1726),
    [sym_template_string] = STATE(1726),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1726),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(1726),
    [sym_class] = STATE(1726),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(3561),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3561),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3563),
    [sym_true] = ACTIONS(3561),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3561),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [887] = {
    [sym_new_expression] = STATE(1727),
    [sym_augmented_assignment_expression] = STATE(1727),
    [sym_unary_expression] = STATE(1727),
    [sym_update_expression] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_meta_property] = STATE(1727),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(1727),
    [sym_yield_expression] = STATE(1727),
    [sym_as_expression] = STATE(1727),
    [sym_non_null_expression] = STATE(1727),
    [sym_internal_module] = STATE(1727),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1727),
    [sym_await_expression] = STATE(1727),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(1727),
    [sym_this] = STATE(1727),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(1727),
    [sym_generator_function] = STATE(1727),
    [sym_call_expression] = STATE(1727),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(1727),
    [sym_ternary_expression] = STATE(1727),
    [sym_binary_expression] = STATE(1727),
    [sym_template_string] = STATE(1727),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1727),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(1727),
    [sym_class] = STATE(1727),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3565),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3567),
    [sym_true] = ACTIONS(3565),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3565),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [888] = {
    [sym_new_expression] = STATE(1728),
    [sym_augmented_assignment_expression] = STATE(1728),
    [sym_unary_expression] = STATE(1728),
    [sym_update_expression] = STATE(1728),
    [sym_regex] = STATE(1728),
    [sym_meta_property] = STATE(1728),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1728),
    [sym_yield_expression] = STATE(1728),
    [sym_as_expression] = STATE(1728),
    [sym_non_null_expression] = STATE(1728),
    [sym_internal_module] = STATE(1728),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1728),
    [sym_await_expression] = STATE(1728),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1728),
    [sym_this] = STATE(1728),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1728),
    [sym_generator_function] = STATE(1728),
    [sym_call_expression] = STATE(1728),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1728),
    [sym_ternary_expression] = STATE(1728),
    [sym_binary_expression] = STATE(1728),
    [sym_template_string] = STATE(1728),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1728),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1728),
    [sym_class] = STATE(1728),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(3569),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3569),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3571),
    [sym_true] = ACTIONS(3569),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3569),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [889] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(3575),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [890] = {
    [sym_new_expression] = STATE(1702),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(1702),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1702),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1702),
    [sym_call_signature] = STATE(877),
    [sym_yield_expression] = STATE(1702),
    [sym_as_expression] = STATE(1702),
    [sym_internal_module] = STATE(1702),
    [sym_arrow_function] = STATE(1702),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(879),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1738),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(880),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(1702),
    [sym_subscript_expression] = STATE(879),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1702),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1702),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1702),
    [sym_meta_property] = STATE(1702),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(1702),
    [sym_non_null_expression] = STATE(1702),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1702),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1702),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1702),
    [sym_call_expression] = STATE(1702),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1702),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1702),
    [sym_type_arguments] = STATE(309),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(1702),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(1702),
    [sym_class] = STATE(1702),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(3583),
    [sym_false] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(3587),
    [anon_sym_number] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(3589),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(3595),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(3516),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3587),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(3587),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(3597),
    [sym_number] = ACTIONS(3599),
    [sym_true] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3516),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(3601),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [891] = {
    [sym_new_expression] = STATE(1746),
    [sym_augmented_assignment_expression] = STATE(1746),
    [sym_unary_expression] = STATE(1746),
    [sym_update_expression] = STATE(1746),
    [sym_regex] = STATE(1746),
    [sym_meta_property] = STATE(1746),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(1746),
    [sym_yield_expression] = STATE(1746),
    [sym_as_expression] = STATE(1746),
    [sym_non_null_expression] = STATE(1746),
    [sym_internal_module] = STATE(1746),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1746),
    [sym_await_expression] = STATE(1746),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(1746),
    [sym_this] = STATE(1746),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(1746),
    [sym_generator_function] = STATE(1746),
    [sym_call_expression] = STATE(1746),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(1746),
    [sym_ternary_expression] = STATE(1746),
    [sym_binary_expression] = STATE(1746),
    [sym_template_string] = STATE(1746),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1746),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(1746),
    [sym_class] = STATE(1746),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(3603),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3603),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3605),
    [sym_true] = ACTIONS(3603),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3603),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [892] = {
    [sym__automatic_semicolon] = ACTIONS(3607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3607),
  },
  [893] = {
    [sym__automatic_semicolon] = ACTIONS(3609),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_from] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
  },
  [894] = {
    [anon_sym_RBRACE] = ACTIONS(3611),
    [sym_comment] = ACTIONS(3),
  },
  [895] = {
    [aux_sym_export_clause_repeat1] = STATE(1751),
    [anon_sym_COMMA] = ACTIONS(3613),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
  },
  [896] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(3617),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [897] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3620),
    [anon_sym_AMP_EQ] = ACTIONS(3620),
    [anon_sym_PLUS_EQ] = ACTIONS(3620),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(3620),
    [anon_sym_STAR_EQ] = ACTIONS(3620),
    [anon_sym_PIPE_EQ] = ACTIONS(3620),
    [anon_sym_DASH_EQ] = ACTIONS(3620),
    [anon_sym_EQ_GT] = ACTIONS(3624),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3620),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT_EQ] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3626),
  },
  [898] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3628),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_AMP_EQ] = ACTIONS(3628),
    [anon_sym_PLUS_EQ] = ACTIONS(3628),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(3628),
    [anon_sym_STAR_EQ] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3628),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3628),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3628),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [899] = {
    [sym_new_expression] = STATE(1758),
    [sym_augmented_assignment_expression] = STATE(1758),
    [sym_unary_expression] = STATE(1758),
    [sym_update_expression] = STATE(1758),
    [sym_regex] = STATE(1758),
    [sym_meta_property] = STATE(1758),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(1758),
    [sym_yield_expression] = STATE(1758),
    [sym_as_expression] = STATE(1758),
    [sym_non_null_expression] = STATE(1758),
    [sym_internal_module] = STATE(1758),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1758),
    [sym_await_expression] = STATE(1758),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(1758),
    [sym_this] = STATE(1758),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(1758),
    [sym_generator_function] = STATE(1758),
    [sym_call_expression] = STATE(1758),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(1758),
    [sym_ternary_expression] = STATE(1758),
    [sym_binary_expression] = STATE(1758),
    [sym_template_string] = STATE(1758),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1758),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(1758),
    [sym_class] = STATE(1758),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(3632),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3632),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3634),
    [sym_true] = ACTIONS(3632),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3632),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [900] = {
    [sym_new_expression] = STATE(1759),
    [sym_augmented_assignment_expression] = STATE(1759),
    [sym_unary_expression] = STATE(1759),
    [sym_update_expression] = STATE(1759),
    [sym_regex] = STATE(1759),
    [sym_meta_property] = STATE(1759),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(1759),
    [sym_yield_expression] = STATE(1759),
    [sym_as_expression] = STATE(1759),
    [sym_non_null_expression] = STATE(1759),
    [sym_internal_module] = STATE(1759),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1759),
    [sym_await_expression] = STATE(1759),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(1759),
    [sym_this] = STATE(1759),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(1759),
    [sym_generator_function] = STATE(1759),
    [sym_call_expression] = STATE(1759),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(1759),
    [sym_ternary_expression] = STATE(1759),
    [sym_binary_expression] = STATE(1759),
    [sym_template_string] = STATE(1759),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1759),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(1759),
    [sym_class] = STATE(1759),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(3636),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3636),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3638),
    [sym_true] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3636),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [901] = {
    [sym_new_expression] = STATE(1758),
    [sym_augmented_assignment_expression] = STATE(1758),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(1758),
    [sym_update_expression] = STATE(1758),
    [sym_regex] = STATE(1758),
    [sym_meta_property] = STATE(1758),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(1758),
    [sym_yield_expression] = STATE(1758),
    [sym_as_expression] = STATE(1758),
    [sym_non_null_expression] = STATE(1758),
    [sym_internal_module] = STATE(1758),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1758),
    [sym_await_expression] = STATE(1758),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(1758),
    [sym_this] = STATE(1758),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(1758),
    [sym_generator_function] = STATE(1758),
    [sym_call_expression] = STATE(1758),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(1758),
    [sym_ternary_expression] = STATE(1758),
    [sym_binary_expression] = STATE(1758),
    [sym_template_string] = STATE(1758),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1758),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(1758),
    [sym_class] = STATE(1758),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(3628),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_AMP_EQ] = ACTIONS(3628),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(3628),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(3628),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_PIPE_EQ] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3628),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3628),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1693),
    [sym_true] = ACTIONS(3632),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3628),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(3632),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3632),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_STAR_EQ] = ACTIONS(3628),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(3634),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3628),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3632),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [902] = {
    [sym_call_signature] = STATE(1760),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3628),
    [anon_sym_symbol] = ACTIONS(3642),
    [anon_sym_AMP_EQ] = ACTIONS(3628),
    [anon_sym_PLUS_EQ] = ACTIONS(3628),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_void] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(3628),
    [anon_sym_private] = ACTIONS(3642),
    [anon_sym_PIPE_EQ] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3628),
    [anon_sym_get] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3628),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(3642),
    [anon_sym_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(3642),
    [anon_sym_type] = ACTIONS(3642),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(3642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3628),
    [anon_sym_namespace] = ACTIONS(3642),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(3642),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_number] = ACTIONS(3642),
    [anon_sym_declare] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(3642),
    [anon_sym_STAR_EQ] = ACTIONS(3628),
    [anon_sym_boolean] = ACTIONS(3642),
    [anon_sym_async] = ACTIONS(3642),
    [anon_sym_public] = ACTIONS(3642),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3628),
    [anon_sym_string] = ACTIONS(3642),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(3642),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [903] = {
    [sym_new_expression] = STATE(1762),
    [sym_augmented_assignment_expression] = STATE(1762),
    [sym_unary_expression] = STATE(1762),
    [sym_update_expression] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(1762),
    [sym_yield_expression] = STATE(1762),
    [sym_as_expression] = STATE(1762),
    [sym_non_null_expression] = STATE(1762),
    [sym_internal_module] = STATE(1762),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1762),
    [sym_await_expression] = STATE(1762),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(1762),
    [sym_this] = STATE(1762),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_call_expression] = STATE(1762),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(1762),
    [sym_ternary_expression] = STATE(1762),
    [sym_binary_expression] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1762),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(1762),
    [sym_class] = STATE(1762),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(3644),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3644),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3646),
    [sym_true] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3644),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [904] = {
    [sym_new_expression] = STATE(1763),
    [sym_augmented_assignment_expression] = STATE(1763),
    [sym_unary_expression] = STATE(1763),
    [sym_update_expression] = STATE(1763),
    [sym_regex] = STATE(1763),
    [sym_meta_property] = STATE(1763),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(1763),
    [sym_yield_expression] = STATE(1763),
    [sym_as_expression] = STATE(1763),
    [sym_non_null_expression] = STATE(1763),
    [sym_internal_module] = STATE(1763),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1763),
    [sym_await_expression] = STATE(1763),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(1763),
    [sym_this] = STATE(1763),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(1763),
    [sym_generator_function] = STATE(1763),
    [sym_call_expression] = STATE(1763),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(1763),
    [sym_ternary_expression] = STATE(1763),
    [sym_binary_expression] = STATE(1763),
    [sym_template_string] = STATE(1763),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1763),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(1763),
    [sym_class] = STATE(1763),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1693),
    [sym_true] = ACTIONS(3648),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(3648),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3648),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(3650),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [905] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(3652),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(3654),
    [anon_sym_symbol] = ACTIONS(3654),
    [anon_sym_number] = ACTIONS(3654),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3654),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(3654),
    [anon_sym_private] = ACTIONS(3654),
    [anon_sym_boolean] = ACTIONS(3654),
    [anon_sym_async] = ACTIONS(3658),
    [anon_sym_public] = ACTIONS(3654),
    [anon_sym_get] = ACTIONS(3654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3654),
    [anon_sym_string] = ACTIONS(3654),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(3654),
    [anon_sym_type] = ACTIONS(3654),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(3654),
    [anon_sym_export] = ACTIONS(3654),
    [anon_sym_namespace] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [906] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(3628),
    [anon_sym_AMP_EQ] = ACTIONS(3628),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_PLUS_EQ] = ACTIONS(3628),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(3628),
    [anon_sym_STAR_EQ] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3628),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3628),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3628),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [907] = {
    [sym_new_expression] = STATE(1769),
    [sym_augmented_assignment_expression] = STATE(1769),
    [sym_unary_expression] = STATE(1769),
    [sym_update_expression] = STATE(1769),
    [sym_regex] = STATE(1769),
    [sym_meta_property] = STATE(1769),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(1769),
    [sym_yield_expression] = STATE(1769),
    [sym_as_expression] = STATE(1769),
    [sym_non_null_expression] = STATE(1769),
    [sym_internal_module] = STATE(1769),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1769),
    [sym_await_expression] = STATE(1769),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(1769),
    [sym_this] = STATE(1769),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(1769),
    [sym_generator_function] = STATE(1769),
    [sym_call_expression] = STATE(1769),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(1769),
    [sym_ternary_expression] = STATE(1769),
    [sym_binary_expression] = STATE(1769),
    [sym_template_string] = STATE(1769),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1769),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(1769),
    [sym_class] = STATE(1769),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3662),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3664),
    [sym_true] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3662),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [908] = {
    [anon_sym_EQ_GT] = ACTIONS(3624),
    [sym_comment] = ACTIONS(3),
  },
  [909] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(3607),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym_in] = ACTIONS(3626),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(604),
  },
  [910] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3620),
    [anon_sym_AMP_EQ] = ACTIONS(3620),
    [anon_sym_PLUS_EQ] = ACTIONS(3620),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(3620),
    [anon_sym_STAR_EQ] = ACTIONS(3620),
    [anon_sym_PIPE_EQ] = ACTIONS(3620),
    [anon_sym_DASH_EQ] = ACTIONS(3620),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3620),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT_EQ] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [911] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3626),
  },
  [912] = {
    [sym_new_expression] = STATE(353),
    [sym_augmented_assignment_expression] = STATE(353),
    [sym_unary_expression] = STATE(353),
    [sym_update_expression] = STATE(353),
    [sym_regex] = STATE(353),
    [sym_meta_property] = STATE(353),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(353),
    [sym_yield_expression] = STATE(353),
    [sym_as_expression] = STATE(353),
    [sym_non_null_expression] = STATE(353),
    [sym_internal_module] = STATE(353),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(353),
    [sym_await_expression] = STATE(353),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(353),
    [sym_this] = STATE(353),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(353),
    [sym_generator_function] = STATE(353),
    [sym_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(353),
    [sym_ternary_expression] = STATE(353),
    [sym_binary_expression] = STATE(353),
    [sym_template_string] = STATE(353),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(353),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(353),
    [sym_class] = STATE(353),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(612),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(614),
    [sym_true] = ACTIONS(612),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [913] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3626),
  },
  [914] = {
    [sym_identifier] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
  },
  [915] = {
    [sym_identifier] = ACTIONS(3692),
    [anon_sym_BQUOTE] = ACTIONS(3694),
    [anon_sym_debugger] = ACTIONS(3692),
    [anon_sym_symbol] = ACTIONS(3692),
    [anon_sym_AT] = ACTIONS(3694),
    [anon_sym_DASH] = ACTIONS(3692),
    [anon_sym_void] = ACTIONS(3692),
    [anon_sym_break] = ACTIONS(3692),
    [anon_sym_const] = ACTIONS(3692),
    [sym_super] = ACTIONS(3692),
    [anon_sym_return] = ACTIONS(3692),
    [anon_sym_private] = ACTIONS(3692),
    [anon_sym_get] = ACTIONS(3692),
    [anon_sym_RBRACE] = ACTIONS(3694),
    [anon_sym_interface] = ACTIONS(3692),
    [anon_sym_default] = ACTIONS(3692),
    [anon_sym_enum] = ACTIONS(3692),
    [anon_sym_delete] = ACTIONS(3692),
    [anon_sym_continue] = ACTIONS(3692),
    [anon_sym_DASH_DASH] = ACTIONS(3694),
    [anon_sym_if] = ACTIONS(3692),
    [anon_sym_this] = ACTIONS(3692),
    [anon_sym_yield] = ACTIONS(3692),
    [sym_true] = ACTIONS(3692),
    [anon_sym_throw] = ACTIONS(3692),
    [anon_sym_protected] = ACTIONS(3692),
    [anon_sym_abstract] = ACTIONS(3692),
    [anon_sym_set] = ACTIONS(3692),
    [anon_sym_type] = ACTIONS(3692),
    [anon_sym_import] = ACTIONS(3692),
    [anon_sym_namespace] = ACTIONS(3692),
    [anon_sym_PLUS_PLUS] = ACTIONS(3694),
    [anon_sym_await] = ACTIONS(3692),
    [anon_sym_DQUOTE] = ACTIONS(3694),
    [anon_sym_else] = ACTIONS(3692),
    [anon_sym_BANG] = ACTIONS(3694),
    [anon_sym_for] = ACTIONS(3692),
    [anon_sym_LBRACK] = ACTIONS(3694),
    [sym_false] = ACTIONS(3692),
    [anon_sym_SEMI] = ACTIONS(3694),
    [anon_sym_case] = ACTIONS(3692),
    [anon_sym_module] = ACTIONS(3692),
    [anon_sym_number] = ACTIONS(3692),
    [anon_sym_class] = ACTIONS(3692),
    [anon_sym_declare] = ACTIONS(3692),
    [anon_sym_typeof] = ACTIONS(3692),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_switch] = ACTIONS(3692),
    [anon_sym_LPAREN] = ACTIONS(3694),
    [sym_null] = ACTIONS(3692),
    [anon_sym_any] = ACTIONS(3692),
    [anon_sym_boolean] = ACTIONS(3692),
    [anon_sym_async] = ACTIONS(3692),
    [anon_sym_public] = ACTIONS(3692),
    [anon_sym_var] = ACTIONS(3692),
    [anon_sym_while] = ACTIONS(3692),
    [anon_sym_SQUOTE] = ACTIONS(3694),
    [anon_sym_try] = ACTIONS(3692),
    [anon_sym_LT] = ACTIONS(3694),
    [sym_number] = ACTIONS(3694),
    [anon_sym_SLASH] = ACTIONS(3692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3692),
    [anon_sym_function] = ACTIONS(3692),
    [sym_undefined] = ACTIONS(3692),
    [anon_sym_new] = ACTIONS(3692),
    [ts_builtin_sym_end] = ACTIONS(3694),
    [anon_sym_let] = ACTIONS(3692),
    [anon_sym_PLUS] = ACTIONS(3692),
    [anon_sym_export] = ACTIONS(3692),
    [anon_sym_do] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3694),
    [anon_sym_with] = ACTIONS(3692),
  },
  [916] = {
    [sym_type_alias_declaration] = STATE(361),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(361),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(361),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(361),
    [sym_return_statement] = STATE(361),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(361),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(361),
    [sym_switch_statement] = STATE(361),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(361),
    [sym_throw_statement] = STATE(361),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(361),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(361),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(361),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(361),
    [sym_abstract_class] = STATE(361),
    [sym_interface_declaration] = STATE(361),
    [sym_statement_block] = STATE(361),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(361),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(361),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(361),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(361),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(361),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(361),
    [sym_empty_statement] = STATE(361),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(361),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(361),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(361),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(361),
    [sym_break_statement] = STATE(361),
    [sym_labeled_statement] = STATE(361),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(361),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [917] = {
    [sym_type_alias_declaration] = STATE(1786),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(1786),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(1786),
    [sym_return_statement] = STATE(1786),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(1786),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(1786),
    [sym_switch_statement] = STATE(1786),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(1786),
    [sym_throw_statement] = STATE(1786),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(1786),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(1786),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(1786),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(1786),
    [sym_abstract_class] = STATE(1786),
    [sym_interface_declaration] = STATE(1786),
    [sym_statement_block] = STATE(1786),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(1786),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(1786),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(1786),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(1786),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(1786),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(1786),
    [sym_empty_statement] = STATE(1786),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(1786),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(1786),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(1786),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(1786),
    [sym_break_statement] = STATE(1786),
    [sym_labeled_statement] = STATE(1786),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(1786),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [918] = {
    [sym_identifier] = ACTIONS(3710),
    [sym_comment] = ACTIONS(3),
  },
  [919] = {
    [anon_sym_LPAREN] = ACTIONS(3712),
    [sym_comment] = ACTIONS(3),
  },
  [920] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(1793),
    [sym_variable_declaration] = STATE(1793),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(1793),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1794),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_lexical_declaration] = STATE(1793),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(1795),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(3714),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3718),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(3716),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [921] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(3720),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(282),
  },
  [922] = {
    [sym_identifier] = ACTIONS(3722),
    [sym_comment] = ACTIONS(3),
  },
  [923] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(928),
    [sym__declaration] = STATE(192),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(928),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(1721),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_global] = ACTIONS(322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(1731),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_async] = ACTIONS(1727),
  },
  [924] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(3724),
  },
  [925] = {
    [sym_call_signature] = STATE(1800),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [anon_sym_STAR] = ACTIONS(3728),
    [sym_comment] = ACTIONS(3),
  },
  [926] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(928),
    [sym__declaration] = STATE(317),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(928),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(1733),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(1731),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_async] = ACTIONS(1727),
  },
  [927] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(561),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(282),
  },
  [928] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(1737),
    [anon_sym_class] = ACTIONS(3730),
    [sym_comment] = ACTIONS(3),
  },
  [929] = {
    [sym_type_alias_declaration] = STATE(777),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(777),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(777),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(777),
    [sym_return_statement] = STATE(777),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(777),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(777),
    [sym_switch_statement] = STATE(777),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(777),
    [sym_throw_statement] = STATE(777),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(777),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(777),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(777),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(777),
    [sym_abstract_class] = STATE(777),
    [sym_interface_declaration] = STATE(777),
    [sym_statement_block] = STATE(777),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(777),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(777),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(777),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(777),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(777),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(777),
    [sym_empty_statement] = STATE(777),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(777),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(777),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(777),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(777),
    [sym_break_statement] = STATE(777),
    [sym_labeled_statement] = STATE(777),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(777),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [930] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(282),
  },
  [931] = {
    [sym_type_alias_declaration] = STATE(934),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(934),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(934),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(934),
    [sym_return_statement] = STATE(934),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(934),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(934),
    [sym_switch_statement] = STATE(934),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(934),
    [sym_throw_statement] = STATE(934),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(934),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(934),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(934),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(934),
    [sym_abstract_class] = STATE(934),
    [sym_interface_declaration] = STATE(934),
    [sym_statement_block] = STATE(934),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(934),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(934),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(934),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(934),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(934),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(934),
    [sym_empty_statement] = STATE(934),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(934),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(934),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(934),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(934),
    [sym_break_statement] = STATE(934),
    [sym_labeled_statement] = STATE(934),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(934),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [932] = {
    [sym_parenthesized_expression] = STATE(1803),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [sym_comment] = ACTIONS(3),
  },
  [933] = {
    [sym_type_alias_declaration] = STATE(915),
    [aux_sym_export_statement_repeat1] = STATE(928),
    [sym__declaration] = STATE(915),
    [sym_ambient_declaration] = STATE(915),
    [sym_import_alias] = STATE(915),
    [sym_export_statement] = STATE(915),
    [sym_generator_function] = STATE(915),
    [sym_lexical_declaration] = STATE(915),
    [sym_internal_module] = STATE(915),
    [sym_decorator] = STATE(928),
    [sym_enum_declaration] = STATE(915),
    [sym_function] = STATE(915),
    [sym_function_signature] = STATE(915),
    [sym_variable_declaration] = STATE(915),
    [sym_abstract_class] = STATE(915),
    [sym_module] = STATE(915),
    [sym_interface_declaration] = STATE(915),
    [sym_class] = STATE(915),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(1733),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(1731),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_async] = ACTIONS(1727),
  },
  [934] = {
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_BQUOTE] = ACTIONS(3736),
    [anon_sym_debugger] = ACTIONS(3734),
    [anon_sym_symbol] = ACTIONS(3734),
    [anon_sym_AT] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_void] = ACTIONS(3734),
    [anon_sym_break] = ACTIONS(3734),
    [anon_sym_const] = ACTIONS(3734),
    [sym_super] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_private] = ACTIONS(3734),
    [anon_sym_get] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3736),
    [anon_sym_interface] = ACTIONS(3734),
    [anon_sym_default] = ACTIONS(3734),
    [anon_sym_enum] = ACTIONS(3734),
    [anon_sym_delete] = ACTIONS(3734),
    [anon_sym_continue] = ACTIONS(3734),
    [anon_sym_DASH_DASH] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_this] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3734),
    [sym_true] = ACTIONS(3734),
    [anon_sym_throw] = ACTIONS(3734),
    [anon_sym_protected] = ACTIONS(3734),
    [anon_sym_abstract] = ACTIONS(3734),
    [anon_sym_set] = ACTIONS(3734),
    [anon_sym_type] = ACTIONS(3734),
    [anon_sym_import] = ACTIONS(3734),
    [anon_sym_namespace] = ACTIONS(3734),
    [anon_sym_PLUS_PLUS] = ACTIONS(3736),
    [anon_sym_await] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_else] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [sym_false] = ACTIONS(3734),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_case] = ACTIONS(3734),
    [anon_sym_module] = ACTIONS(3734),
    [anon_sym_number] = ACTIONS(3734),
    [anon_sym_class] = ACTIONS(3734),
    [anon_sym_declare] = ACTIONS(3734),
    [anon_sym_typeof] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_switch] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [sym_null] = ACTIONS(3734),
    [anon_sym_any] = ACTIONS(3734),
    [anon_sym_boolean] = ACTIONS(3734),
    [anon_sym_async] = ACTIONS(3734),
    [anon_sym_public] = ACTIONS(3734),
    [anon_sym_var] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_SQUOTE] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3736),
    [sym_number] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3734),
    [sym_undefined] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3734),
    [ts_builtin_sym_end] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_export] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3734),
  },
  [935] = {
    [anon_sym_EQ_GT] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3738),
  },
  [936] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_EQ_GT] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(3740),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3742),
  },
  [937] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(943),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [938] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(942),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(944),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [939] = {
    [sym_formal_parameters] = STATE(1806),
    [sym_type_parameters] = STATE(1807),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [940] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(942),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(944),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [941] = {
    [anon_sym_EQ_GT] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_PIPE] = ACTIONS(3748),
    [sym_comment] = ACTIONS(3),
  },
  [942] = {
    [sym_formal_parameters] = STATE(1810),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [943] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_EQ_GT] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3750),
  },
  [944] = {
    [anon_sym_EQ_GT] = ACTIONS(3752),
    [sym_comment] = ACTIONS(3),
  },
  [945] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [946] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(3754),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [947] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(3754),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [948] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [949] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(3757),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(3757),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG] = ACTIONS(604),
  },
  [950] = {
    [sym__automatic_semicolon] = ACTIONS(3757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3757),
  },
  [951] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_AMP_EQ] = ACTIONS(3759),
    [anon_sym_PLUS_EQ] = ACTIONS(3759),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(3759),
    [anon_sym_STAR_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_DASH_EQ] = ACTIONS(3759),
    [anon_sym_EQ_GT] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3759),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3765),
  },
  [952] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_AMP_EQ] = ACTIONS(3767),
    [anon_sym_PLUS_EQ] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(3767),
    [anon_sym_STAR_EQ] = ACTIONS(3767),
    [anon_sym_PIPE_EQ] = ACTIONS(3767),
    [anon_sym_DASH_EQ] = ACTIONS(3767),
    [anon_sym_EQ_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3767),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [953] = {
    [sym_new_expression] = STATE(1819),
    [sym_augmented_assignment_expression] = STATE(1819),
    [sym_unary_expression] = STATE(1819),
    [sym_update_expression] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1819),
    [sym_yield_expression] = STATE(1819),
    [sym_as_expression] = STATE(1819),
    [sym_non_null_expression] = STATE(1819),
    [sym_internal_module] = STATE(1819),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1819),
    [sym_await_expression] = STATE(1819),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1819),
    [sym_this] = STATE(1819),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_call_expression] = STATE(1819),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1819),
    [sym_ternary_expression] = STATE(1819),
    [sym_binary_expression] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1819),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1819),
    [sym_class] = STATE(1819),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3771),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [954] = {
    [sym_new_expression] = STATE(1820),
    [sym_augmented_assignment_expression] = STATE(1820),
    [sym_unary_expression] = STATE(1820),
    [sym_update_expression] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_meta_property] = STATE(1820),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1820),
    [sym_yield_expression] = STATE(1820),
    [sym_as_expression] = STATE(1820),
    [sym_non_null_expression] = STATE(1820),
    [sym_internal_module] = STATE(1820),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1820),
    [sym_await_expression] = STATE(1820),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1820),
    [sym_this] = STATE(1820),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1820),
    [sym_generator_function] = STATE(1820),
    [sym_call_expression] = STATE(1820),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1820),
    [sym_ternary_expression] = STATE(1820),
    [sym_binary_expression] = STATE(1820),
    [sym_template_string] = STATE(1820),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1820),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1820),
    [sym_class] = STATE(1820),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(3775),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3775),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3777),
    [sym_true] = ACTIONS(3775),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3775),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [955] = {
    [sym_new_expression] = STATE(1819),
    [sym_augmented_assignment_expression] = STATE(1819),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(1819),
    [sym_update_expression] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1819),
    [sym_yield_expression] = STATE(1819),
    [sym_as_expression] = STATE(1819),
    [sym_non_null_expression] = STATE(1819),
    [sym_internal_module] = STATE(1819),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1819),
    [sym_await_expression] = STATE(1819),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1819),
    [sym_this] = STATE(1819),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_call_expression] = STATE(1819),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1819),
    [sym_ternary_expression] = STATE(1819),
    [sym_binary_expression] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1819),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1819),
    [sym_class] = STATE(1819),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_AMP_EQ] = ACTIONS(3767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(3767),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_PIPE_EQ] = ACTIONS(3767),
    [anon_sym_DASH_EQ] = ACTIONS(3767),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3767),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(1958),
    [sym_true] = ACTIONS(3771),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1946),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(3771),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3771),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_STAR_EQ] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_EQ_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(3773),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [956] = {
    [sym_call_signature] = STATE(1821),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(3779),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3767),
    [anon_sym_PLUS_EQ] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_void] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(3767),
    [anon_sym_private] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3767),
    [anon_sym_DASH_EQ] = ACTIONS(3767),
    [anon_sym_get] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3767),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(3781),
    [anon_sym_type] = ACTIONS(3781),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(3781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(3781),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3781),
    [anon_sym_declare] = ACTIONS(3781),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3781),
    [anon_sym_async] = ACTIONS(3781),
    [anon_sym_public] = ACTIONS(3781),
    [anon_sym_EQ_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3781),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(3781),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [957] = {
    [sym_new_expression] = STATE(1823),
    [sym_augmented_assignment_expression] = STATE(1823),
    [sym_unary_expression] = STATE(1823),
    [sym_update_expression] = STATE(1823),
    [sym_regex] = STATE(1823),
    [sym_meta_property] = STATE(1823),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1823),
    [sym_yield_expression] = STATE(1823),
    [sym_as_expression] = STATE(1823),
    [sym_non_null_expression] = STATE(1823),
    [sym_internal_module] = STATE(1823),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1823),
    [sym_await_expression] = STATE(1823),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1823),
    [sym_this] = STATE(1823),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1823),
    [sym_generator_function] = STATE(1823),
    [sym_call_expression] = STATE(1823),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1823),
    [sym_ternary_expression] = STATE(1823),
    [sym_binary_expression] = STATE(1823),
    [sym_template_string] = STATE(1823),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1823),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1823),
    [sym_class] = STATE(1823),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(3783),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3783),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3785),
    [sym_true] = ACTIONS(3783),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3783),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [958] = {
    [sym_new_expression] = STATE(1824),
    [sym_augmented_assignment_expression] = STATE(1824),
    [sym_unary_expression] = STATE(1824),
    [sym_update_expression] = STATE(1824),
    [sym_regex] = STATE(1824),
    [sym_meta_property] = STATE(1824),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1824),
    [sym_yield_expression] = STATE(1824),
    [sym_as_expression] = STATE(1824),
    [sym_non_null_expression] = STATE(1824),
    [sym_internal_module] = STATE(1824),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1824),
    [sym_await_expression] = STATE(1824),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1824),
    [sym_this] = STATE(1824),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1824),
    [sym_generator_function] = STATE(1824),
    [sym_call_expression] = STATE(1824),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1824),
    [sym_ternary_expression] = STATE(1824),
    [sym_binary_expression] = STATE(1824),
    [sym_template_string] = STATE(1824),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1824),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1824),
    [sym_class] = STATE(1824),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(1958),
    [sym_true] = ACTIONS(3787),
    [anon_sym_COLON] = ACTIONS(211),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1946),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(3787),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3787),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(3789),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3787),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [959] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(3791),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(3793),
    [anon_sym_symbol] = ACTIONS(3793),
    [anon_sym_number] = ACTIONS(3793),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3793),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3795),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3793),
    [anon_sym_private] = ACTIONS(3793),
    [anon_sym_boolean] = ACTIONS(3793),
    [anon_sym_async] = ACTIONS(3797),
    [anon_sym_public] = ACTIONS(3793),
    [anon_sym_get] = ACTIONS(3793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3793),
    [anon_sym_string] = ACTIONS(3793),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(3793),
    [anon_sym_type] = ACTIONS(3793),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(3793),
    [anon_sym_export] = ACTIONS(3793),
    [anon_sym_namespace] = ACTIONS(3799),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [960] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_AMP_EQ] = ACTIONS(3767),
    [anon_sym_PLUS_EQ] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(3767),
    [anon_sym_STAR_EQ] = ACTIONS(3767),
    [anon_sym_PIPE_EQ] = ACTIONS(3767),
    [anon_sym_DASH_EQ] = ACTIONS(3767),
    [anon_sym_EQ_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3767),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [961] = {
    [sym_new_expression] = STATE(1830),
    [sym_augmented_assignment_expression] = STATE(1830),
    [sym_unary_expression] = STATE(1830),
    [sym_update_expression] = STATE(1830),
    [sym_regex] = STATE(1830),
    [sym_meta_property] = STATE(1830),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1830),
    [sym_yield_expression] = STATE(1830),
    [sym_as_expression] = STATE(1830),
    [sym_non_null_expression] = STATE(1830),
    [sym_internal_module] = STATE(1830),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1830),
    [sym_await_expression] = STATE(1830),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1830),
    [sym_this] = STATE(1830),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1830),
    [sym_generator_function] = STATE(1830),
    [sym_call_expression] = STATE(1830),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1830),
    [sym_ternary_expression] = STATE(1830),
    [sym_binary_expression] = STATE(1830),
    [sym_template_string] = STATE(1830),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1830),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1830),
    [sym_class] = STATE(1830),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(3801),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3801),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3803),
    [sym_true] = ACTIONS(3801),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3801),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [962] = {
    [anon_sym_EQ_GT] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
  },
  [963] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [964] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_AMP_EQ] = ACTIONS(3759),
    [anon_sym_PLUS_EQ] = ACTIONS(3759),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(3759),
    [anon_sym_STAR_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_DASH_EQ] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3759),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [965] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3765),
  },
  [966] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [967] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3765),
  },
  [968] = {
    [sym_type_arguments] = STATE(1845),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(3831),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_is] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(3843),
  },
  [969] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1492),
    [anon_sym_BQUOTE] = ACTIONS(1492),
    [sym__automatic_semicolon] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1492),
    [anon_sym_LT_LT] = ACTIONS(1492),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_GT_GT_GT] = ACTIONS(1492),
    [anon_sym_AMP_AMP] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_BANG_EQ] = ACTIONS(1490),
    [anon_sym_LT_EQ] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1490),
    [anon_sym_AMP] = ACTIONS(1490),
    [anon_sym_PERCENT] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1492),
    [anon_sym_RBRACE] = ACTIONS(1492),
    [anon_sym_as] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1492),
    [anon_sym_DASH_DASH] = ACTIONS(1492),
    [anon_sym_EQ_EQ] = ACTIONS(1490),
    [anon_sym_instanceof] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1492),
    [anon_sym_CARET] = ACTIONS(1492),
    [anon_sym_STAR_STAR] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1490),
    [anon_sym_GT_GT] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1492),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1492),
    [anon_sym_in] = ACTIONS(1490),
  },
  [970] = {
    [sym_tuple_type] = STATE(1847),
    [sym_index_type_query] = STATE(1847),
    [sym_lookup_type] = STATE(1847),
    [sym_this_type] = STATE(1847),
    [sym_flow_maybe_type] = STATE(1847),
    [sym_nested_type_identifier] = STATE(985),
    [sym_type_predicate] = STATE(1847),
    [sym_type_query] = STATE(1847),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(1847),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(1847),
    [sym__primary_type] = STATE(1847),
    [sym_generic_type] = STATE(1847),
    [sym_mapped_type] = STATE(1847),
    [sym_literal_type] = STATE(1847),
    [sym_parenthesized_type] = STATE(1847),
    [sym_predefined_type] = STATE(1847),
    [sym_string] = STATE(969),
    [sym_array_type] = STATE(1847),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [sym_true] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_LPAREN] = ACTIONS(3846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [971] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(1850),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(1850),
    [sym_call_signature] = STATE(1850),
    [sym_export_statement] = STATE(1850),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(1850),
    [sym_index_signature] = STATE(1850),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(3848),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(3848),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(3850),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3850),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [972] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1851),
    [sym_constructor_type] = STATE(1851),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(1851),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1851),
    [sym_intersection_type] = STATE(1851),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [973] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [sym__automatic_semicolon] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1530),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_STAR] = ACTIONS(1530),
    [anon_sym_GT_GT_GT] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_BANG_EQ] = ACTIONS(1530),
    [anon_sym_LT_EQ] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [anon_sym_GT_EQ] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1530),
    [anon_sym_PERCENT] = ACTIONS(1532),
    [anon_sym_QMARK] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_as] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1530),
    [anon_sym_instanceof] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1530),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_SLASH] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1532),
    [anon_sym_CARET] = ACTIONS(1532),
    [anon_sym_STAR_STAR] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_GT_GT] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1532),
    [anon_sym_in] = ACTIONS(1530),
  },
  [974] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(1852),
    [sym_constructor_type] = STATE(1852),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(1852),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(1852),
    [sym_intersection_type] = STATE(1852),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [975] = {
    [sym_nested_identifier] = STATE(1853),
    [sym_identifier] = ACTIONS(3852),
    [sym_comment] = ACTIONS(3),
  },
  [976] = {
    [sym_nested_type_identifier] = STATE(1855),
    [sym_nested_identifier] = STATE(986),
    [sym_identifier] = ACTIONS(3854),
    [sym_comment] = ACTIONS(3),
  },
  [977] = {
    [sym_number] = ACTIONS(3856),
    [sym_comment] = ACTIONS(3),
  },
  [978] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [anon_sym_BANG] = ACTIONS(1542),
    [anon_sym_SEMI] = ACTIONS(1544),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [sym__automatic_semicolon] = ACTIONS(1544),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_COMMA] = ACTIONS(1544),
    [anon_sym_LT_LT] = ACTIONS(1544),
    [anon_sym_STAR] = ACTIONS(1542),
    [anon_sym_GT_GT_GT] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_PERCENT] = ACTIONS(1544),
    [anon_sym_QMARK] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_as] = ACTIONS(1544),
    [anon_sym_PIPE_PIPE] = ACTIONS(1544),
    [anon_sym_DASH_DASH] = ACTIONS(1544),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_instanceof] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1544),
    [anon_sym_CARET] = ACTIONS(1544),
    [anon_sym_STAR_STAR] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_PLUS_PLUS] = ACTIONS(1544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1544),
    [anon_sym_in] = ACTIONS(1542),
  },
  [979] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_BANG] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1536),
    [anon_sym_BQUOTE] = ACTIONS(1536),
    [sym__automatic_semicolon] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1536),
    [anon_sym_STAR] = ACTIONS(1534),
    [anon_sym_GT_GT_GT] = ACTIONS(1536),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_DASH] = ACTIONS(1534),
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1534),
    [anon_sym_PERCENT] = ACTIONS(1536),
    [anon_sym_QMARK] = ACTIONS(1536),
    [anon_sym_RBRACE] = ACTIONS(1536),
    [anon_sym_as] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [anon_sym_DASH_DASH] = ACTIONS(1536),
    [anon_sym_EQ_EQ] = ACTIONS(1534),
    [anon_sym_instanceof] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1536),
    [anon_sym_SLASH] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1536),
    [anon_sym_CARET] = ACTIONS(1536),
    [anon_sym_STAR_STAR] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1534),
    [anon_sym_GT_GT] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1536),
    [anon_sym_in] = ACTIONS(1534),
  },
  [980] = {
    [sym_formal_parameters] = STATE(1857),
    [sym_type_parameters] = STATE(1858),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [981] = {
    [sym__type] = STATE(1859),
    [sym_constructor_type] = STATE(1859),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_function_type] = STATE(1859),
    [sym_rest_parameter] = STATE(243),
    [sym_nested_identifier] = STATE(283),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(243),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(265),
    [sym_type_parameters] = STATE(838),
    [sym_this] = STATE(762),
    [sym_predefined_type] = STATE(284),
    [sym_tuple_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(771),
    [sym_object] = STATE(759),
    [sym_nested_type_identifier] = STATE(839),
    [sym_optional_parameter] = STATE(243),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(771),
    [sym_union_type] = STATE(1859),
    [sym_intersection_type] = STATE(1859),
    [sym_formal_parameters] = STATE(840),
    [sym_array] = STATE(761),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [sym_identifier] = ACTIONS(1550),
    [sym_false] = ACTIONS(462),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1552),
    [anon_sym_number] = ACTIONS(1552),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_void] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_any] = ACTIONS(1552),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1552),
    [anon_sym_async] = ACTIONS(1426),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_this] = ACTIONS(1562),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_string] = ACTIONS(1552),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [982] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(1860),
    [sym_constructor_type] = STATE(1860),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(1860),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(1860),
    [sym_intersection_type] = STATE(1860),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [983] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3858),
    [anon_sym_LBRACK] = ACTIONS(3858),
    [anon_sym_BANG] = ACTIONS(3860),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_BQUOTE] = ACTIONS(3858),
    [sym__automatic_semicolon] = ACTIONS(3858),
    [anon_sym_PIPE] = ACTIONS(3860),
    [anon_sym_COMMA] = ACTIONS(3858),
    [anon_sym_LT_LT] = ACTIONS(3858),
    [anon_sym_STAR] = ACTIONS(3860),
    [anon_sym_GT_GT_GT] = ACTIONS(3858),
    [anon_sym_AMP_AMP] = ACTIONS(3858),
    [anon_sym_DASH] = ACTIONS(3860),
    [anon_sym_BANG_EQ] = ACTIONS(3860),
    [anon_sym_LT_EQ] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3858),
    [anon_sym_GT_EQ] = ACTIONS(3858),
    [anon_sym_GT] = ACTIONS(3860),
    [anon_sym_AMP] = ACTIONS(3860),
    [anon_sym_PERCENT] = ACTIONS(3858),
    [anon_sym_QMARK] = ACTIONS(3858),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_as] = ACTIONS(3858),
    [anon_sym_PIPE_PIPE] = ACTIONS(3858),
    [anon_sym_DASH_DASH] = ACTIONS(3858),
    [anon_sym_EQ_EQ] = ACTIONS(3860),
    [anon_sym_instanceof] = ACTIONS(3858),
    [anon_sym_LT] = ACTIONS(3860),
    [anon_sym_RPAREN] = ACTIONS(3858),
    [anon_sym_SLASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3858),
    [anon_sym_CARET] = ACTIONS(3858),
    [anon_sym_STAR_STAR] = ACTIONS(3858),
    [anon_sym_PLUS] = ACTIONS(3860),
    [anon_sym_GT_GT] = ACTIONS(3860),
    [anon_sym_PLUS_PLUS] = ACTIONS(3858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3858),
    [anon_sym_in] = ACTIONS(3860),
  },
  [984] = {
    [sym_formal_parameters] = STATE(1863),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [985] = {
    [sym_type_arguments] = STATE(1866),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(3862),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(3867),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(3870),
  },
  [986] = {
    [anon_sym_DOT] = ACTIONS(3841),
    [sym_comment] = ACTIONS(3),
  },
  [987] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3858),
    [anon_sym_LBRACK] = ACTIONS(3858),
    [anon_sym_BANG] = ACTIONS(3860),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_BQUOTE] = ACTIONS(3858),
    [sym__automatic_semicolon] = ACTIONS(3858),
    [anon_sym_PIPE] = ACTIONS(3860),
    [anon_sym_COMMA] = ACTIONS(3858),
    [anon_sym_LT_LT] = ACTIONS(3858),
    [anon_sym_STAR] = ACTIONS(3860),
    [anon_sym_GT_GT_GT] = ACTIONS(3858),
    [anon_sym_AMP_AMP] = ACTIONS(3858),
    [anon_sym_DASH] = ACTIONS(3860),
    [anon_sym_BANG_EQ] = ACTIONS(3860),
    [anon_sym_LT_EQ] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3858),
    [anon_sym_GT_EQ] = ACTIONS(3858),
    [anon_sym_GT] = ACTIONS(3860),
    [anon_sym_AMP] = ACTIONS(3860),
    [anon_sym_PERCENT] = ACTIONS(3858),
    [anon_sym_QMARK] = ACTIONS(3858),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_as] = ACTIONS(3858),
    [anon_sym_PIPE_PIPE] = ACTIONS(3858),
    [anon_sym_DASH_DASH] = ACTIONS(3858),
    [anon_sym_EQ_EQ] = ACTIONS(3860),
    [anon_sym_instanceof] = ACTIONS(3858),
    [anon_sym_LT] = ACTIONS(3860),
    [anon_sym_RPAREN] = ACTIONS(3858),
    [anon_sym_SLASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3858),
    [anon_sym_CARET] = ACTIONS(3858),
    [anon_sym_STAR_STAR] = ACTIONS(3858),
    [anon_sym_PLUS] = ACTIONS(3860),
    [anon_sym_GT_GT] = ACTIONS(3860),
    [anon_sym_PLUS_PLUS] = ACTIONS(3858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3858),
    [anon_sym_in] = ACTIONS(3860),
  },
  [988] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1587),
    [anon_sym_LBRACK] = ACTIONS(3873),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_BQUOTE] = ACTIONS(1587),
    [sym__automatic_semicolon] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(1585),
    [anon_sym_GT_GT_GT] = ACTIONS(1587),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_BANG_EQ] = ACTIONS(1585),
    [anon_sym_LT_EQ] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1587),
    [anon_sym_GT] = ACTIONS(1585),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_QMARK] = ACTIONS(1587),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_as] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_EQ_EQ] = ACTIONS(1585),
    [anon_sym_instanceof] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1585),
    [anon_sym_RPAREN] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1587),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_STAR_STAR] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_GT_GT] = ACTIONS(1585),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1587),
    [anon_sym_in] = ACTIONS(1585),
  },
  [989] = {
    [anon_sym_EQ_GT] = ACTIONS(3875),
    [sym_comment] = ACTIONS(3),
  },
  [990] = {
    [sym__initializer] = STATE(71),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(3887),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3889),
  },
  [991] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3894),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [992] = {
    [sym_new_expression] = STATE(159),
    [sym_constructor_type] = STATE(817),
    [sym_augmented_assignment_expression] = STATE(159),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(159),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(159),
    [sym_call_signature] = STATE(158),
    [sym_yield_expression] = STATE(159),
    [sym_as_expression] = STATE(159),
    [sym_internal_module] = STATE(159),
    [sym_arrow_function] = STATE(159),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(161),
    [sym_mapped_type] = STATE(284),
    [sym_spread_element] = STATE(162),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1642),
    [sym_type_parameters] = STATE(1645),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(164),
    [sym_nested_type_identifier] = STATE(819),
    [sym_generator_function] = STATE(159),
    [sym_subscript_expression] = STATE(161),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(159),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(159),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1646),
    [sym_intersection_type] = STATE(817),
    [sym__type] = STATE(817),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(159),
    [sym_meta_property] = STATE(159),
    [sym_function_type] = STATE(817),
    [sym__expression] = STATE(159),
    [sym_non_null_expression] = STATE(159),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(159),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(159),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [aux_sym_array_repeat1] = STATE(165),
    [sym_anonymous_class] = STATE(159),
    [sym_call_expression] = STATE(159),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(159),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(159),
    [sym_type_arguments] = STATE(166),
    [sym_union_type] = STATE(817),
    [sym_parenthesized_expression] = STATE(159),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(159),
    [sym_class] = STATE(159),
    [sym_identifier] = ACTIONS(3397),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3399),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(3403),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [sym_false] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(3409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_RBRACK] = ACTIONS(276),
    [sym_null] = ACTIONS(256),
    [anon_sym_any] = ACTIONS(3399),
    [anon_sym_boolean] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3411),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3399),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_TILDE] = ACTIONS(252),
  },
  [993] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [994] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_meta_property] = STATE(90),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_internal_module] = STATE(90),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(3903),
    [sym_false] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(167),
    [sym_true] = ACTIONS(161),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [995] = {
    [sym_new_expression] = STATE(87),
    [sym_augmented_assignment_expression] = STATE(87),
    [sym_unary_expression] = STATE(87),
    [sym_update_expression] = STATE(87),
    [sym_regex] = STATE(87),
    [sym_meta_property] = STATE(87),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(87),
    [sym_yield_expression] = STATE(87),
    [sym_as_expression] = STATE(87),
    [sym_non_null_expression] = STATE(87),
    [sym_internal_module] = STATE(87),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(87),
    [sym_await_expression] = STATE(87),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(87),
    [sym_this] = STATE(87),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(87),
    [sym_generator_function] = STATE(87),
    [sym_call_expression] = STATE(87),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(87),
    [sym_ternary_expression] = STATE(87),
    [sym_binary_expression] = STATE(87),
    [sym_template_string] = STATE(87),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(87),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(87),
    [sym_class] = STATE(87),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3905),
    [sym_true] = ACTIONS(151),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(151),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [996] = {
    [sym_pair] = STATE(219),
    [aux_sym_export_statement_repeat1] = STATE(1879),
    [sym_object] = STATE(397),
    [sym__property_name] = STATE(1662),
    [aux_sym_object_repeat1] = STATE(223),
    [sym_assignment_pattern] = STATE(219),
    [sym_method_signature] = STATE(810),
    [sym_property_signature] = STATE(810),
    [sym_call_signature] = STATE(810),
    [sym_construct_signature] = STATE(810),
    [sym_export_statement] = STATE(810),
    [sym_method_definition] = STATE(219),
    [sym_index_signature] = STATE(810),
    [sym_decorator] = STATE(1879),
    [sym_accessibility_modifier] = STATE(1663),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(1662),
    [sym_array] = STATE(399),
    [sym_spread_element] = STATE(219),
    [sym_string] = STATE(1662),
    [sym_type_parameters] = STATE(811),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(3909),
    [anon_sym_symbol] = ACTIONS(3909),
    [anon_sym_number] = ACTIONS(3909),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(3909),
    [anon_sym_COMMA] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(3909),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(3909),
    [anon_sym_private] = ACTIONS(3911),
    [anon_sym_boolean] = ACTIONS(3909),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3913),
    [anon_sym_get] = ACTIONS(3915),
    [anon_sym_RBRACE] = ACTIONS(718),
    [anon_sym_public] = ACTIONS(3911),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3911),
    [anon_sym_string] = ACTIONS(3909),
    [anon_sym_set] = ACTIONS(3915),
    [anon_sym_type] = ACTIONS(3909),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(3909),
    [anon_sym_export] = ACTIONS(3917),
    [sym_readonly] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3909),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [997] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_meta_property] = STATE(90),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_internal_module] = STATE(90),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(161),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [998] = {
    [sym_new_expression] = STATE(244),
    [sym_constructor_type] = STATE(837),
    [sym_augmented_assignment_expression] = STATE(244),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(244),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(244),
    [sym_call_signature] = STATE(242),
    [sym_rest_parameter] = STATE(243),
    [sym_yield_expression] = STATE(244),
    [sym_as_expression] = STATE(244),
    [sym_internal_module] = STATE(244),
    [sym_accessibility_modifier] = STATE(246),
    [sym_arrow_function] = STATE(244),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(245),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1885),
    [sym_type_parameters] = STATE(1888),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(250),
    [sym_nested_type_identifier] = STATE(839),
    [sym_generator_function] = STATE(244),
    [sym_subscript_expression] = STATE(245),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(244),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(244),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(249),
    [sym_formal_parameters] = STATE(1889),
    [sym_intersection_type] = STATE(837),
    [sym__type] = STATE(837),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(244),
    [sym_meta_property] = STATE(244),
    [sym_function_type] = STATE(837),
    [sym__expression] = STATE(244),
    [sym_non_null_expression] = STATE(244),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_required_parameter] = STATE(243),
    [sym_await_expression] = STATE(244),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_sequence_expression] = STATE(247),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(248),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(249),
    [sym_anonymous_class] = STATE(244),
    [sym_optional_parameter] = STATE(243),
    [sym_call_expression] = STATE(244),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(244),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(244),
    [sym_type_arguments] = STATE(251),
    [sym_union_type] = STATE(837),
    [sym_parenthesized_expression] = STATE(244),
    [sym_array] = STATE(252),
    [sym_type_assertion] = STATE(244),
    [sym_class] = STATE(244),
    [sym_identifier] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3921),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(3925),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(422),
    [anon_sym_get] = ACTIONS(412),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(430),
    [sym_true] = ACTIONS(3929),
    [anon_sym_protected] = ACTIONS(422),
    [anon_sym_set] = ACTIONS(412),
    [anon_sym_type] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(412),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_BANG] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [sym_false] = ACTIONS(3929),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_number] = ACTIONS(3921),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(412),
    [anon_sym_typeof] = ACTIONS(3931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(408),
    [anon_sym_any] = ACTIONS(3921),
    [anon_sym_boolean] = ACTIONS(3921),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3933),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3921),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(408),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_export] = ACTIONS(412),
    [anon_sym_TILDE] = ACTIONS(410),
  },
  [999] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_SEMI] = ACTIONS(207),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym__automatic_semicolon] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3451),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [1000] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(506),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(512),
    [anon_sym_symbol] = ACTIONS(512),
    [anon_sym_number] = ACTIONS(512),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(512),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(518),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(512),
    [anon_sym_private] = ACTIONS(512),
    [anon_sym_boolean] = ACTIONS(512),
    [anon_sym_async] = ACTIONS(522),
    [anon_sym_public] = ACTIONS(512),
    [anon_sym_get] = ACTIONS(512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(512),
    [anon_sym_string] = ACTIONS(512),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(512),
    [anon_sym_type] = ACTIONS(512),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(512),
    [anon_sym_namespace] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [1001] = {
    [sym_formal_parameters] = STATE(1892),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1002] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [1003] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(3754),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1004] = {
    [sym_new_expression] = STATE(1893),
    [sym_augmented_assignment_expression] = STATE(1893),
    [sym_unary_expression] = STATE(1893),
    [sym_update_expression] = STATE(1893),
    [sym_regex] = STATE(1893),
    [sym_meta_property] = STATE(1893),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(1893),
    [sym_yield_expression] = STATE(1893),
    [sym_as_expression] = STATE(1893),
    [sym_non_null_expression] = STATE(1893),
    [sym_internal_module] = STATE(1893),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1893),
    [sym_await_expression] = STATE(1893),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(1893),
    [sym_this] = STATE(1893),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(1893),
    [sym_generator_function] = STATE(1893),
    [sym_call_expression] = STATE(1893),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(1893),
    [sym_ternary_expression] = STATE(1893),
    [sym_binary_expression] = STATE(1893),
    [sym_template_string] = STATE(1893),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1893),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(1893),
    [sym_class] = STATE(1893),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(3943),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3943),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3945),
    [sym_true] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3943),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1005] = {
    [sym_class_heritage] = STATE(1894),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_type_parameters] = STATE(1895),
    [sym_class_body] = STATE(1896),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [1006] = {
    [sym_class_body] = STATE(1897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [1007] = {
    [sym_type_alias_declaration] = STATE(689),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(689),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(689),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(689),
    [sym_return_statement] = STATE(689),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(689),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(689),
    [sym_switch_statement] = STATE(689),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(689),
    [sym_throw_statement] = STATE(689),
    [aux_sym_program_repeat1] = STATE(689),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(689),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(689),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(689),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(689),
    [sym_abstract_class] = STATE(689),
    [sym_interface_declaration] = STATE(689),
    [sym_statement_block] = STATE(689),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(689),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(689),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(689),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(689),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(689),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(689),
    [sym_empty_statement] = STATE(689),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(689),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(689),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(689),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(689),
    [sym_break_statement] = STATE(689),
    [sym_labeled_statement] = STATE(689),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(689),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(3947),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [1008] = {
    [sym_new_expression] = STATE(1899),
    [sym_augmented_assignment_expression] = STATE(1899),
    [sym_unary_expression] = STATE(1899),
    [sym_update_expression] = STATE(1899),
    [sym_regex] = STATE(1899),
    [sym_meta_property] = STATE(1899),
    [sym_call_signature] = STATE(374),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(1899),
    [sym_yield_expression] = STATE(1899),
    [sym_as_expression] = STATE(1899),
    [sym_non_null_expression] = STATE(1899),
    [sym_internal_module] = STATE(1899),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1899),
    [sym_await_expression] = STATE(1899),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1899),
    [sym_this] = STATE(1899),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1899),
    [sym_generator_function] = STATE(1899),
    [sym_call_expression] = STATE(1899),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1899),
    [sym_ternary_expression] = STATE(1899),
    [sym_binary_expression] = STATE(1899),
    [sym_template_string] = STATE(1899),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1899),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1899),
    [sym_class] = STATE(1899),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3949),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3951),
    [sym_true] = ACTIONS(3949),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3949),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1009] = {
    [sym_new_expression] = STATE(1900),
    [sym_augmented_assignment_expression] = STATE(1900),
    [sym_unary_expression] = STATE(1900),
    [sym_update_expression] = STATE(1900),
    [sym_regex] = STATE(1900),
    [sym_meta_property] = STATE(1900),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1900),
    [sym_yield_expression] = STATE(1900),
    [sym_as_expression] = STATE(1900),
    [sym_non_null_expression] = STATE(1900),
    [sym_internal_module] = STATE(1900),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1900),
    [sym_await_expression] = STATE(1900),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1900),
    [sym_this] = STATE(1900),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1900),
    [sym_generator_function] = STATE(1900),
    [sym_call_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1900),
    [sym_ternary_expression] = STATE(1900),
    [sym_binary_expression] = STATE(1900),
    [sym_template_string] = STATE(1900),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1900),
    [sym_class] = STATE(1900),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3953),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1010] = {
    [sym_new_expression] = STATE(1901),
    [sym_augmented_assignment_expression] = STATE(1901),
    [sym_unary_expression] = STATE(1901),
    [sym_update_expression] = STATE(1901),
    [sym_regex] = STATE(1901),
    [sym_meta_property] = STATE(1901),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1901),
    [sym_yield_expression] = STATE(1901),
    [sym_as_expression] = STATE(1901),
    [sym_non_null_expression] = STATE(1901),
    [sym_internal_module] = STATE(1901),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1901),
    [sym_await_expression] = STATE(1901),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1901),
    [sym_this] = STATE(1901),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1901),
    [sym_generator_function] = STATE(1901),
    [sym_call_expression] = STATE(1901),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1901),
    [sym_ternary_expression] = STATE(1901),
    [sym_binary_expression] = STATE(1901),
    [sym_template_string] = STATE(1901),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1901),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1901),
    [sym_class] = STATE(1901),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3957),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3959),
    [sym_true] = ACTIONS(3957),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3957),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1011] = {
    [sym_new_expression] = STATE(1902),
    [sym_augmented_assignment_expression] = STATE(1902),
    [sym_unary_expression] = STATE(1902),
    [sym_update_expression] = STATE(1902),
    [sym_regex] = STATE(1902),
    [sym_meta_property] = STATE(1902),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1902),
    [sym_yield_expression] = STATE(1902),
    [sym_as_expression] = STATE(1902),
    [sym_non_null_expression] = STATE(1902),
    [sym_internal_module] = STATE(1902),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1902),
    [sym_await_expression] = STATE(1902),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1902),
    [sym_this] = STATE(1902),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1902),
    [sym_generator_function] = STATE(1902),
    [sym_call_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1902),
    [sym_ternary_expression] = STATE(1902),
    [sym_binary_expression] = STATE(1902),
    [sym_template_string] = STATE(1902),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1902),
    [sym_class] = STATE(1902),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3961),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3963),
    [sym_true] = ACTIONS(3961),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3961),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1012] = {
    [sym_new_expression] = STATE(1903),
    [sym_augmented_assignment_expression] = STATE(1903),
    [sym_unary_expression] = STATE(1903),
    [sym_update_expression] = STATE(1903),
    [sym_regex] = STATE(1903),
    [sym_meta_property] = STATE(1903),
    [sym_call_signature] = STATE(374),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(1903),
    [sym_yield_expression] = STATE(1903),
    [sym_as_expression] = STATE(1903),
    [sym_non_null_expression] = STATE(1903),
    [sym_internal_module] = STATE(1903),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1903),
    [sym_await_expression] = STATE(1903),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1903),
    [sym_this] = STATE(1903),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1903),
    [sym_generator_function] = STATE(1903),
    [sym_call_expression] = STATE(1903),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1903),
    [sym_ternary_expression] = STATE(1903),
    [sym_binary_expression] = STATE(1903),
    [sym_template_string] = STATE(1903),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1903),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1903),
    [sym_class] = STATE(1903),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3965),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3967),
    [sym_true] = ACTIONS(3965),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3965),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1013] = {
    [sym_new_expression] = STATE(1904),
    [sym_augmented_assignment_expression] = STATE(1904),
    [sym_unary_expression] = STATE(1904),
    [sym_update_expression] = STATE(1904),
    [sym_regex] = STATE(1904),
    [sym_meta_property] = STATE(1904),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1904),
    [sym_yield_expression] = STATE(1904),
    [sym_as_expression] = STATE(1904),
    [sym_non_null_expression] = STATE(1904),
    [sym_internal_module] = STATE(1904),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1904),
    [sym_await_expression] = STATE(1904),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1904),
    [sym_this] = STATE(1904),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1904),
    [sym_generator_function] = STATE(1904),
    [sym_call_expression] = STATE(1904),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1904),
    [sym_ternary_expression] = STATE(1904),
    [sym_binary_expression] = STATE(1904),
    [sym_template_string] = STATE(1904),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1904),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1904),
    [sym_class] = STATE(1904),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3969),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3971),
    [sym_true] = ACTIONS(3969),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3969),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1014] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_RBRACE] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(3973),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [1015] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_RBRACE] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(3973),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [1016] = {
    [anon_sym_EQ_GT] = ACTIONS(3976),
    [sym_comment] = ACTIONS(3),
  },
  [1017] = {
    [anon_sym_EQ_GT] = ACTIONS(3978),
    [sym_comment] = ACTIONS(3),
  },
  [1018] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [1019] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(863),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [1020] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(2069),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [1021] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1022] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1023] = {
    [sym_call_signature] = STATE(1016),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(2085),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(2087),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(2087),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(2087),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(2087),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(2087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(2087),
    [anon_sym_type] = ACTIONS(2087),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(2087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(2087),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(2087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(2087),
    [anon_sym_declare] = ACTIONS(2087),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(2087),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(2087),
    [anon_sym_async] = ACTIONS(2087),
    [anon_sym_public] = ACTIONS(2087),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(2087),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(2087),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1024] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1025] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [1026] = {
    [sym_new_expression] = STATE(1907),
    [sym_augmented_assignment_expression] = STATE(1907),
    [sym_unary_expression] = STATE(1907),
    [sym_update_expression] = STATE(1907),
    [sym_regex] = STATE(1907),
    [sym_meta_property] = STATE(1907),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1907),
    [sym_yield_expression] = STATE(1907),
    [sym_as_expression] = STATE(1907),
    [sym_non_null_expression] = STATE(1907),
    [sym_internal_module] = STATE(1907),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1907),
    [sym_await_expression] = STATE(1907),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1907),
    [sym_this] = STATE(1907),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1907),
    [sym_generator_function] = STATE(1907),
    [sym_call_expression] = STATE(1907),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1907),
    [sym_ternary_expression] = STATE(1907),
    [sym_binary_expression] = STATE(1907),
    [sym_template_string] = STATE(1907),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1907),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1907),
    [sym_class] = STATE(1907),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3980),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3982),
    [sym_true] = ACTIONS(3980),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3980),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1027] = {
    [sym_new_expression] = STATE(1908),
    [sym_augmented_assignment_expression] = STATE(1908),
    [sym_unary_expression] = STATE(1908),
    [sym_update_expression] = STATE(1908),
    [sym_regex] = STATE(1908),
    [sym_meta_property] = STATE(1908),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1908),
    [sym_yield_expression] = STATE(1908),
    [sym_as_expression] = STATE(1908),
    [sym_non_null_expression] = STATE(1908),
    [sym_internal_module] = STATE(1908),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1908),
    [sym_await_expression] = STATE(1908),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1908),
    [sym_this] = STATE(1908),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1908),
    [sym_generator_function] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1908),
    [sym_ternary_expression] = STATE(1908),
    [sym_binary_expression] = STATE(1908),
    [sym_template_string] = STATE(1908),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1908),
    [sym_class] = STATE(1908),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3984),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3986),
    [sym_true] = ACTIONS(3984),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3984),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1028] = {
    [sym_new_expression] = STATE(1909),
    [sym_augmented_assignment_expression] = STATE(1909),
    [sym_unary_expression] = STATE(1909),
    [sym_update_expression] = STATE(1909),
    [sym_regex] = STATE(1909),
    [sym_meta_property] = STATE(1909),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1909),
    [sym_yield_expression] = STATE(1909),
    [sym_as_expression] = STATE(1909),
    [sym_non_null_expression] = STATE(1909),
    [sym_internal_module] = STATE(1909),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1909),
    [sym_await_expression] = STATE(1909),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1909),
    [sym_this] = STATE(1909),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1909),
    [sym_generator_function] = STATE(1909),
    [sym_call_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1909),
    [sym_ternary_expression] = STATE(1909),
    [sym_binary_expression] = STATE(1909),
    [sym_template_string] = STATE(1909),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1909),
    [sym_class] = STATE(1909),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3988),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3990),
    [sym_true] = ACTIONS(3988),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3988),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1029] = {
    [sym_new_expression] = STATE(1910),
    [sym_augmented_assignment_expression] = STATE(1910),
    [sym_unary_expression] = STATE(1910),
    [sym_update_expression] = STATE(1910),
    [sym_regex] = STATE(1910),
    [sym_meta_property] = STATE(1910),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1910),
    [sym_yield_expression] = STATE(1910),
    [sym_as_expression] = STATE(1910),
    [sym_non_null_expression] = STATE(1910),
    [sym_internal_module] = STATE(1910),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1910),
    [sym_await_expression] = STATE(1910),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1910),
    [sym_this] = STATE(1910),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1910),
    [sym_generator_function] = STATE(1910),
    [sym_call_expression] = STATE(1910),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1910),
    [sym_ternary_expression] = STATE(1910),
    [sym_binary_expression] = STATE(1910),
    [sym_template_string] = STATE(1910),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1910),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1910),
    [sym_class] = STATE(1910),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3992),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3994),
    [sym_true] = ACTIONS(3992),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3992),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1030] = {
    [sym_new_expression] = STATE(1911),
    [sym_augmented_assignment_expression] = STATE(1911),
    [sym_unary_expression] = STATE(1911),
    [sym_update_expression] = STATE(1911),
    [sym_regex] = STATE(1911),
    [sym_meta_property] = STATE(1911),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1911),
    [sym_yield_expression] = STATE(1911),
    [sym_as_expression] = STATE(1911),
    [sym_non_null_expression] = STATE(1911),
    [sym_internal_module] = STATE(1911),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1911),
    [sym_await_expression] = STATE(1911),
    [sym_member_expression] = STATE(376),
    [sym_sequence_expression] = STATE(1494),
    [sym_string] = STATE(1911),
    [sym_this] = STATE(1911),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1911),
    [sym_generator_function] = STATE(1911),
    [sym_call_expression] = STATE(1911),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1911),
    [sym_ternary_expression] = STATE(1911),
    [sym_binary_expression] = STATE(1911),
    [sym_template_string] = STATE(1911),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1911),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1911),
    [sym_class] = STATE(1911),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3996),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3998),
    [sym_true] = ACTIONS(3996),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3996),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1031] = {
    [sym_new_expression] = STATE(1912),
    [sym_augmented_assignment_expression] = STATE(1912),
    [sym_unary_expression] = STATE(1912),
    [sym_update_expression] = STATE(1912),
    [sym_regex] = STATE(1912),
    [sym_meta_property] = STATE(1912),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1912),
    [sym_yield_expression] = STATE(1912),
    [sym_as_expression] = STATE(1912),
    [sym_non_null_expression] = STATE(1912),
    [sym_internal_module] = STATE(1912),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1912),
    [sym_await_expression] = STATE(1912),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1912),
    [sym_this] = STATE(1912),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1912),
    [sym_generator_function] = STATE(1912),
    [sym_call_expression] = STATE(1912),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1912),
    [sym_ternary_expression] = STATE(1912),
    [sym_binary_expression] = STATE(1912),
    [sym_template_string] = STATE(1912),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1912),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1912),
    [sym_class] = STATE(1912),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(4000),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4000),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4002),
    [sym_true] = ACTIONS(4000),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4000),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1032] = {
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4004),
    [sym_escape_sequence] = ACTIONS(4004),
    [anon_sym_BQUOTE] = ACTIONS(4004),
    [sym__template_chars] = ACTIONS(4004),
    [sym_comment] = ACTIONS(3),
  },
  [1033] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(4008),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [1034] = {
    [sym_new_expression] = STATE(1900),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(1900),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1900),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1900),
    [sym_call_signature] = STATE(374),
    [sym_yield_expression] = STATE(1900),
    [sym_as_expression] = STATE(1900),
    [sym_internal_module] = STATE(1900),
    [sym_arrow_function] = STATE(1900),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(376),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(378),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(1900),
    [sym_subscript_expression] = STATE(376),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1900),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1900),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1900),
    [sym_meta_property] = STATE(1900),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(1900),
    [sym_non_null_expression] = STATE(1900),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1900),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1900),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1900),
    [sym_call_expression] = STATE(1900),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1900),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1900),
    [sym_type_arguments] = STATE(379),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1900),
    [sym_class] = STATE(1900),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(4016),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(4018),
    [anon_sym_number] = ACTIONS(4018),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(4020),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(3953),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4018),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(4018),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(4018),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(4026),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1035] = {
    [sym_new_expression] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1927),
    [sym_unary_expression] = STATE(1927),
    [sym_update_expression] = STATE(1927),
    [sym_regex] = STATE(1927),
    [sym_meta_property] = STATE(1927),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1927),
    [sym_yield_expression] = STATE(1927),
    [sym_as_expression] = STATE(1927),
    [sym_non_null_expression] = STATE(1927),
    [sym_internal_module] = STATE(1927),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1927),
    [sym_await_expression] = STATE(1927),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1927),
    [sym_this] = STATE(1927),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1927),
    [sym_generator_function] = STATE(1927),
    [sym_call_expression] = STATE(1927),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1927),
    [sym_ternary_expression] = STATE(1927),
    [sym_binary_expression] = STATE(1927),
    [sym_template_string] = STATE(1927),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1927),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1927),
    [sym_class] = STATE(1927),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4028),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4030),
    [sym_true] = ACTIONS(4028),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4028),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1036] = {
    [anon_sym_LBRACK] = ACTIONS(4032),
    [sym_identifier] = ACTIONS(4034),
    [anon_sym_module] = ACTIONS(4034),
    [anon_sym_symbol] = ACTIONS(4034),
    [anon_sym_number] = ACTIONS(4034),
    [anon_sym_class] = ACTIONS(4034),
    [anon_sym_AT] = ACTIONS(4032),
    [anon_sym_declare] = ACTIONS(4034),
    [anon_sym_STAR] = ACTIONS(4032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4032),
    [anon_sym_void] = ACTIONS(4034),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [anon_sym_any] = ACTIONS(4034),
    [anon_sym_private] = ACTIONS(4034),
    [anon_sym_boolean] = ACTIONS(4034),
    [anon_sym_static] = ACTIONS(4034),
    [anon_sym_async] = ACTIONS(4034),
    [anon_sym_get] = ACTIONS(4034),
    [anon_sym_public] = ACTIONS(4034),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_SQUOTE] = ACTIONS(4032),
    [anon_sym_this] = ACTIONS(4034),
    [sym_number] = ACTIONS(4032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4034),
    [anon_sym_string] = ACTIONS(4034),
    [anon_sym_abstract] = ACTIONS(4034),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_set] = ACTIONS(4034),
    [anon_sym_type] = ACTIONS(4034),
    [anon_sym_import] = ACTIONS(4034),
    [anon_sym_export] = ACTIONS(4034),
    [anon_sym_namespace] = ACTIONS(4034),
    [sym_readonly] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4032),
  },
  [1037] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2285),
    [sym_identifier] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2285),
    [anon_sym_symbol] = ACTIONS(2287),
    [anon_sym_AT] = ACTIONS(2285),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_COMMA] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_STAR] = ACTIONS(2287),
    [anon_sym_GT_GT_GT] = ACTIONS(2285),
    [anon_sym_void] = ACTIONS(2287),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_GT_EQ] = ACTIONS(2285),
    [anon_sym_private] = ACTIONS(2287),
    [anon_sym_get] = ACTIONS(2287),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_PERCENT] = ACTIONS(2285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2285),
    [anon_sym_as] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2285),
    [anon_sym_instanceof] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2285),
    [anon_sym_protected] = ACTIONS(2287),
    [anon_sym_DOT] = ACTIONS(2287),
    [anon_sym_set] = ACTIONS(2287),
    [anon_sym_type] = ACTIONS(2287),
    [anon_sym_STAR_STAR] = ACTIONS(2285),
    [anon_sym_import] = ACTIONS(2287),
    [sym_readonly] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2285),
    [anon_sym_namespace] = ACTIONS(2287),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_module] = ACTIONS(2287),
    [anon_sym_number] = ACTIONS(2287),
    [anon_sym_class] = ACTIONS(2287),
    [anon_sym_declare] = ACTIONS(2287),
    [anon_sym_LT_LT] = ACTIONS(2285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2285),
    [anon_sym_LBRACE] = ACTIONS(2287),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_LT_EQ] = ACTIONS(2285),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_RBRACK] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_any] = ACTIONS(2287),
    [anon_sym_boolean] = ACTIONS(2287),
    [anon_sym_async] = ACTIONS(2287),
    [anon_sym_public] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_QMARK] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2285),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_RPAREN] = ACTIONS(2285),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2287),
    [anon_sym_CARET] = ACTIONS(2285),
    [anon_sym_PLUS] = ACTIONS(2287),
    [anon_sym_export] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2287),
    [anon_sym_implements] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2285),
    [anon_sym_in] = ACTIONS(2287),
  },
  [1038] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [aux_sym_array_repeat1] = STATE(1929),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1039] = {
    [aux_sym_array_repeat1] = STATE(1929),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(3),
  },
  [1040] = {
    [aux_sym_array_repeat1] = STATE(1122),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(3),
  },
  [1041] = {
    [anon_sym_COMMA] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
  },
  [1042] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [aux_sym_array_repeat1] = STATE(1070),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1043] = {
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
  },
  [1044] = {
    [aux_sym_export_statement_repeat1] = STATE(1044),
    [sym_decorator] = STATE(1044),
    [anon_sym_get] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_public] = ACTIONS(3007),
    [anon_sym_boolean] = ACTIONS(3007),
    [sym_readonly] = ACTIONS(3007),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(2032),
    [anon_sym_number] = ACTIONS(3007),
    [anon_sym_AT] = ACTIONS(3009),
    [anon_sym_declare] = ACTIONS(3007),
    [anon_sym_symbol] = ACTIONS(3007),
    [sym_number] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(3007),
    [anon_sym_protected] = ACTIONS(3007),
    [anon_sym_string] = ACTIONS(3007),
    [anon_sym_set] = ACTIONS(3007),
    [anon_sym_type] = ACTIONS(3007),
    [anon_sym_import] = ACTIONS(3007),
    [anon_sym_export] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3007),
    [anon_sym_any] = ACTIONS(3007),
    [anon_sym_private] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(2032),
    [anon_sym_static] = ACTIONS(3007),
    [anon_sym_async] = ACTIONS(3007),
  },
  [1045] = {
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [sym_comment] = ACTIONS(3),
  },
  [1046] = {
    [sym_call_signature] = STATE(1931),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1047] = {
    [sym_type_arguments] = STATE(1937),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1475),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_is] = ACTIONS(4045),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4049),
  },
  [1048] = {
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_SEMI] = ACTIONS(1492),
    [sym__automatic_semicolon] = ACTIONS(1492),
    [anon_sym_RBRACE] = ACTIONS(1492),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1492),
  },
  [1049] = {
    [sym_tuple_type] = STATE(1939),
    [sym_index_type_query] = STATE(1939),
    [sym_lookup_type] = STATE(1939),
    [sym_this_type] = STATE(1939),
    [sym_flow_maybe_type] = STATE(1939),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_type_predicate] = STATE(1939),
    [sym_type_query] = STATE(1939),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1939),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1939),
    [sym__primary_type] = STATE(1939),
    [sym_generic_type] = STATE(1939),
    [sym_mapped_type] = STATE(1939),
    [sym_literal_type] = STATE(1939),
    [sym_parenthesized_type] = STATE(1939),
    [sym_predefined_type] = STATE(1939),
    [sym_string] = STATE(1048),
    [sym_array_type] = STATE(1939),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [sym_true] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1050] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(1942),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(1942),
    [sym_call_signature] = STATE(1942),
    [sym_export_statement] = STATE(1942),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(1942),
    [sym_index_signature] = STATE(1942),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(4053),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(4053),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(4055),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4055),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1051] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1943),
    [sym_constructor_type] = STATE(1943),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(1943),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1943),
    [sym_intersection_type] = STATE(1943),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1052] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1063),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1067),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1053] = {
    [anon_sym_EQ] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym__automatic_semicolon] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1530),
    [anon_sym_COMMA] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1532),
  },
  [1054] = {
    [anon_sym_EQ] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1536),
    [anon_sym_SEMI] = ACTIONS(1536),
    [sym__automatic_semicolon] = ACTIONS(1536),
    [anon_sym_RBRACE] = ACTIONS(1536),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_COMMA] = ACTIONS(1536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1536),
  },
  [1055] = {
    [sym_nested_identifier] = STATE(1945),
    [sym_identifier] = ACTIONS(4057),
    [sym_comment] = ACTIONS(3),
  },
  [1056] = {
    [sym_number] = ACTIONS(4059),
    [sym_comment] = ACTIONS(3),
  },
  [1057] = {
    [anon_sym_EQ] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1544),
    [sym__automatic_semicolon] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1544),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_COMMA] = ACTIONS(1544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1544),
  },
  [1058] = {
    [sym_nested_type_identifier] = STATE(1948),
    [sym_nested_identifier] = STATE(1065),
    [sym_identifier] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
  },
  [1059] = {
    [sym_formal_parameters] = STATE(1949),
    [sym_type_parameters] = STATE(1950),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1060] = {
    [sym__type] = STATE(1951),
    [sym_constructor_type] = STATE(1951),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_function_type] = STATE(1951),
    [sym_rest_parameter] = STATE(243),
    [sym_nested_identifier] = STATE(283),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(243),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(265),
    [sym_type_parameters] = STATE(838),
    [sym_this] = STATE(762),
    [sym_predefined_type] = STATE(284),
    [sym_tuple_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(771),
    [sym_object] = STATE(759),
    [sym_nested_type_identifier] = STATE(839),
    [sym_optional_parameter] = STATE(243),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(771),
    [sym_union_type] = STATE(1951),
    [sym_intersection_type] = STATE(1951),
    [sym_formal_parameters] = STATE(840),
    [sym_array] = STATE(761),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [sym_identifier] = ACTIONS(1550),
    [sym_false] = ACTIONS(462),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1552),
    [anon_sym_number] = ACTIONS(1552),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_void] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_any] = ACTIONS(1552),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1552),
    [anon_sym_async] = ACTIONS(1426),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_this] = ACTIONS(1562),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_string] = ACTIONS(1552),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [1061] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1063),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1067),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1062] = {
    [anon_sym_EQ] = ACTIONS(3744),
    [sym__automatic_semicolon] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(4065),
    [sym_comment] = ACTIONS(3),
  },
  [1063] = {
    [sym_formal_parameters] = STATE(1955),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1064] = {
    [sym_type_arguments] = STATE(1958),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_SEMI] = ACTIONS(1577),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4070),
  },
  [1065] = {
    [anon_sym_DOT] = ACTIONS(4043),
    [sym_comment] = ACTIONS(3),
  },
  [1066] = {
    [anon_sym_EQ] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [sym__automatic_semicolon] = ACTIONS(1587),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_COMMA] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1587),
  },
  [1067] = {
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [sym_comment] = ACTIONS(3),
  },
  [1068] = {
    [sym__automatic_semicolon] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [sym_comment] = ACTIONS(3),
  },
  [1069] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2571),
    [anon_sym_LBRACK] = ACTIONS(2571),
    [anon_sym_in] = ACTIONS(2573),
    [anon_sym_BQUOTE] = ACTIONS(2571),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_COMMA] = ACTIONS(2571),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2573),
    [anon_sym_GT_GT_GT] = ACTIONS(2571),
    [anon_sym_EQ] = ACTIONS(2573),
    [anon_sym_AMP_AMP] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2571),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2571),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_RBRACK] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2573),
    [anon_sym_of] = ACTIONS(2571),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_PERCENT] = ACTIONS(2571),
    [anon_sym_QMARK] = ACTIONS(2571),
    [anon_sym_RBRACE] = ACTIONS(2571),
    [anon_sym_as] = ACTIONS(2571),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(2571),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_instanceof] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(2571),
    [anon_sym_SLASH] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2571),
    [anon_sym_DOT] = ACTIONS(2571),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_implements] = ACTIONS(2571),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_PLUS_PLUS] = ACTIONS(2571),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2571),
    [anon_sym_BANG] = ACTIONS(2573),
  },
  [1070] = {
    [aux_sym_array_repeat1] = STATE(578),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(4078),
    [sym_comment] = ACTIONS(3),
  },
  [1071] = {
    [sym_identifier] = ACTIONS(4080),
    [anon_sym_BQUOTE] = ACTIONS(4082),
    [anon_sym_debugger] = ACTIONS(4080),
    [anon_sym_symbol] = ACTIONS(4080),
    [anon_sym_AT] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4080),
    [anon_sym_void] = ACTIONS(4080),
    [anon_sym_break] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4080),
    [sym_super] = ACTIONS(4080),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_private] = ACTIONS(4080),
    [anon_sym_get] = ACTIONS(4080),
    [anon_sym_RBRACE] = ACTIONS(4082),
    [anon_sym_interface] = ACTIONS(4080),
    [anon_sym_default] = ACTIONS(4080),
    [anon_sym_enum] = ACTIONS(4080),
    [anon_sym_delete] = ACTIONS(4080),
    [anon_sym_continue] = ACTIONS(4080),
    [anon_sym_DASH_DASH] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4080),
    [anon_sym_this] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4080),
    [sym_true] = ACTIONS(4080),
    [anon_sym_throw] = ACTIONS(4080),
    [anon_sym_protected] = ACTIONS(4080),
    [anon_sym_abstract] = ACTIONS(4080),
    [anon_sym_set] = ACTIONS(4080),
    [anon_sym_type] = ACTIONS(4080),
    [anon_sym_import] = ACTIONS(4080),
    [anon_sym_namespace] = ACTIONS(4080),
    [anon_sym_PLUS_PLUS] = ACTIONS(4082),
    [anon_sym_await] = ACTIONS(4080),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_else] = ACTIONS(4080),
    [anon_sym_BANG] = ACTIONS(4082),
    [anon_sym_for] = ACTIONS(4080),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [sym_false] = ACTIONS(4080),
    [anon_sym_SEMI] = ACTIONS(4082),
    [anon_sym_case] = ACTIONS(4080),
    [anon_sym_module] = ACTIONS(4080),
    [anon_sym_number] = ACTIONS(4080),
    [anon_sym_class] = ACTIONS(4080),
    [anon_sym_declare] = ACTIONS(4080),
    [anon_sym_typeof] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_switch] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [sym_null] = ACTIONS(4080),
    [anon_sym_any] = ACTIONS(4080),
    [anon_sym_boolean] = ACTIONS(4080),
    [anon_sym_async] = ACTIONS(4080),
    [anon_sym_public] = ACTIONS(4080),
    [anon_sym_var] = ACTIONS(4080),
    [anon_sym_while] = ACTIONS(4080),
    [anon_sym_SQUOTE] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4082),
    [sym_number] = ACTIONS(4082),
    [anon_sym_SLASH] = ACTIONS(4080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4080),
    [sym_undefined] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4080),
    [ts_builtin_sym_end] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4080),
    [anon_sym_PLUS] = ACTIONS(4080),
    [anon_sym_export] = ACTIONS(4080),
    [anon_sym_do] = ACTIONS(4080),
    [anon_sym_TILDE] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4080),
  },
  [1072] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_LT_EQ] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_RBRACK] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_of] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_as] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2863),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_instanceof] = ACTIONS(2863),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_SLASH] = ACTIONS(2865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_implements] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_BANG] = ACTIONS(2865),
  },
  [1073] = {
    [aux_sym_object_repeat1] = STATE(695),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(4084),
    [sym_comment] = ACTIONS(3),
  },
  [1074] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2964),
    [anon_sym_BQUOTE] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_GT_GT_GT] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_LT_LT] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2962),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_RBRACK] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_of] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_as] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2962),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_instanceof] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_CARET] = ACTIONS(2962),
    [anon_sym_STAR_STAR] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_implements] = ACTIONS(2962),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2964),
  },
  [1075] = {
    [aux_sym_object_repeat1] = STATE(695),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [sym_comment] = ACTIONS(3),
  },
  [1076] = {
    [aux_sym_object_repeat1] = STATE(1964),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [sym_comment] = ACTIONS(3),
  },
  [1077] = {
    [sym__automatic_semicolon] = ACTIONS(4088),
    [anon_sym_SEMI] = ACTIONS(4088),
    [anon_sym_COMMA] = ACTIONS(4088),
    [sym_comment] = ACTIONS(3),
  },
  [1078] = {
    [sym_identifier] = ACTIONS(4090),
    [anon_sym_BQUOTE] = ACTIONS(4092),
    [anon_sym_debugger] = ACTIONS(4090),
    [anon_sym_symbol] = ACTIONS(4090),
    [anon_sym_AT] = ACTIONS(4092),
    [anon_sym_DASH] = ACTIONS(4090),
    [anon_sym_void] = ACTIONS(4090),
    [anon_sym_break] = ACTIONS(4090),
    [anon_sym_const] = ACTIONS(4090),
    [sym_super] = ACTIONS(4090),
    [anon_sym_return] = ACTIONS(4090),
    [anon_sym_private] = ACTIONS(4090),
    [anon_sym_get] = ACTIONS(4090),
    [anon_sym_RBRACE] = ACTIONS(4092),
    [anon_sym_interface] = ACTIONS(4090),
    [anon_sym_default] = ACTIONS(4090),
    [anon_sym_enum] = ACTIONS(4090),
    [anon_sym_delete] = ACTIONS(4090),
    [anon_sym_continue] = ACTIONS(4090),
    [anon_sym_DASH_DASH] = ACTIONS(4092),
    [anon_sym_if] = ACTIONS(4090),
    [anon_sym_this] = ACTIONS(4090),
    [anon_sym_yield] = ACTIONS(4090),
    [sym_true] = ACTIONS(4090),
    [anon_sym_throw] = ACTIONS(4090),
    [anon_sym_protected] = ACTIONS(4090),
    [anon_sym_abstract] = ACTIONS(4090),
    [anon_sym_set] = ACTIONS(4090),
    [anon_sym_type] = ACTIONS(4090),
    [anon_sym_import] = ACTIONS(4090),
    [anon_sym_namespace] = ACTIONS(4090),
    [anon_sym_PLUS_PLUS] = ACTIONS(4092),
    [anon_sym_await] = ACTIONS(4090),
    [anon_sym_DQUOTE] = ACTIONS(4092),
    [anon_sym_else] = ACTIONS(4090),
    [anon_sym_BANG] = ACTIONS(4092),
    [anon_sym_for] = ACTIONS(4090),
    [anon_sym_LBRACK] = ACTIONS(4092),
    [sym_false] = ACTIONS(4090),
    [anon_sym_SEMI] = ACTIONS(4092),
    [anon_sym_case] = ACTIONS(4090),
    [anon_sym_module] = ACTIONS(4090),
    [anon_sym_number] = ACTIONS(4090),
    [anon_sym_class] = ACTIONS(4090),
    [anon_sym_declare] = ACTIONS(4090),
    [anon_sym_typeof] = ACTIONS(4090),
    [anon_sym_LBRACE] = ACTIONS(4092),
    [anon_sym_switch] = ACTIONS(4090),
    [anon_sym_LPAREN] = ACTIONS(4092),
    [sym_null] = ACTIONS(4090),
    [anon_sym_any] = ACTIONS(4090),
    [anon_sym_boolean] = ACTIONS(4090),
    [anon_sym_async] = ACTIONS(4090),
    [anon_sym_public] = ACTIONS(4090),
    [anon_sym_var] = ACTIONS(4090),
    [anon_sym_while] = ACTIONS(4090),
    [anon_sym_SQUOTE] = ACTIONS(4092),
    [anon_sym_try] = ACTIONS(4090),
    [anon_sym_LT] = ACTIONS(4092),
    [sym_number] = ACTIONS(4092),
    [anon_sym_SLASH] = ACTIONS(4090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4090),
    [anon_sym_function] = ACTIONS(4090),
    [sym_undefined] = ACTIONS(4090),
    [anon_sym_new] = ACTIONS(4090),
    [ts_builtin_sym_end] = ACTIONS(4092),
    [anon_sym_let] = ACTIONS(4090),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_export] = ACTIONS(4090),
    [anon_sym_do] = ACTIONS(4090),
    [anon_sym_TILDE] = ACTIONS(4092),
    [anon_sym_with] = ACTIONS(4090),
  },
  [1079] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1079),
    [sym__automatic_semicolon] = ACTIONS(4088),
    [anon_sym_SEMI] = ACTIONS(4088),
    [anon_sym_COMMA] = ACTIONS(4094),
    [sym_comment] = ACTIONS(3),
  },
  [1080] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(4097),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4099),
  },
  [1081] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1082] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1086),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1088),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1083] = {
    [sym_formal_parameters] = STATE(1967),
    [sym_type_parameters] = STATE(1968),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1084] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1086),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1088),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1085] = {
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4103),
    [sym_comment] = ACTIONS(3),
  },
  [1086] = {
    [sym_formal_parameters] = STATE(1971),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1087] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4105),
  },
  [1088] = {
    [anon_sym_EQ_GT] = ACTIONS(4107),
    [sym_comment] = ACTIONS(3),
  },
  [1089] = {
    [sym__automatic_semicolon] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_COMMA] = ACTIONS(4109),
    [sym_comment] = ACTIONS(3),
  },
  [1090] = {
    [sym__automatic_semicolon] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
  },
  [1091] = {
    [sym_new_expression] = STATE(1974),
    [sym_augmented_assignment_expression] = STATE(1974),
    [sym_unary_expression] = STATE(1974),
    [sym_update_expression] = STATE(1974),
    [sym_regex] = STATE(1974),
    [sym_meta_property] = STATE(1974),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(1974),
    [sym_yield_expression] = STATE(1974),
    [sym_as_expression] = STATE(1974),
    [sym_non_null_expression] = STATE(1974),
    [sym_internal_module] = STATE(1974),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1974),
    [sym_await_expression] = STATE(1974),
    [sym_member_expression] = STATE(161),
    [sym_sequence_expression] = STATE(1494),
    [sym_string] = STATE(1974),
    [sym_this] = STATE(1974),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(1974),
    [sym_generator_function] = STATE(1974),
    [sym_call_expression] = STATE(1974),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(1974),
    [sym_ternary_expression] = STATE(1974),
    [sym_binary_expression] = STATE(1974),
    [sym_template_string] = STATE(1974),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1974),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1974),
    [sym_class] = STATE(1974),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(4113),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4113),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4115),
    [sym_true] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4113),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1092] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4117),
    [anon_sym_LBRACK] = ACTIONS(4117),
    [anon_sym_BANG] = ACTIONS(4119),
    [anon_sym_SEMI] = ACTIONS(4117),
    [anon_sym_BQUOTE] = ACTIONS(4117),
    [sym__automatic_semicolon] = ACTIONS(4117),
    [anon_sym_PERCENT_EQ] = ACTIONS(4117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4117),
    [anon_sym_AMP_EQ] = ACTIONS(4117),
    [anon_sym_PLUS_EQ] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4119),
    [anon_sym_COMMA] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(4119),
    [anon_sym_GT_GT_GT] = ACTIONS(4119),
    [anon_sym_EQ] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_DASH] = ACTIONS(4119),
    [anon_sym_BANG_EQ] = ACTIONS(4119),
    [anon_sym_LT_EQ] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4119),
    [anon_sym_CARET_EQ] = ACTIONS(4117),
    [anon_sym_STAR_EQ] = ACTIONS(4117),
    [anon_sym_PIPE_EQ] = ACTIONS(4117),
    [anon_sym_DASH_EQ] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4119),
    [anon_sym_PERCENT] = ACTIONS(4119),
    [anon_sym_QMARK] = ACTIONS(4117),
    [anon_sym_LT_LT_EQ] = ACTIONS(4117),
    [anon_sym_as] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [anon_sym_DASH_DASH] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4119),
    [anon_sym_instanceof] = ACTIONS(4117),
    [anon_sym_LT] = ACTIONS(4119),
    [anon_sym_RPAREN] = ACTIONS(4117),
    [anon_sym_SLASH] = ACTIONS(4119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4117),
    [anon_sym_GT_GT_EQ] = ACTIONS(4117),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_CARET] = ACTIONS(4119),
    [anon_sym_STAR_STAR] = ACTIONS(4119),
    [anon_sym_PLUS] = ACTIONS(4119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4119),
    [anon_sym_PLUS_PLUS] = ACTIONS(4117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4117),
    [anon_sym_in] = ACTIONS(4119),
  },
  [1093] = {
    [sym_new_expression] = STATE(1975),
    [sym_augmented_assignment_expression] = STATE(1975),
    [sym_unary_expression] = STATE(1975),
    [sym_update_expression] = STATE(1975),
    [sym_regex] = STATE(1975),
    [sym_meta_property] = STATE(1975),
    [sym_call_signature] = STATE(446),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(1975),
    [sym_yield_expression] = STATE(1975),
    [sym_as_expression] = STATE(1975),
    [sym_non_null_expression] = STATE(1975),
    [sym_internal_module] = STATE(1975),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1975),
    [sym_await_expression] = STATE(1975),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1975),
    [sym_this] = STATE(1975),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1975),
    [sym_generator_function] = STATE(1975),
    [sym_call_expression] = STATE(1975),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1975),
    [sym_ternary_expression] = STATE(1975),
    [sym_binary_expression] = STATE(1975),
    [sym_template_string] = STATE(1975),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1975),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1975),
    [sym_class] = STATE(1975),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4121),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4121),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4123),
    [sym_true] = ACTIONS(4121),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4121),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1094] = {
    [sym_new_expression] = STATE(1976),
    [sym_augmented_assignment_expression] = STATE(1976),
    [sym_unary_expression] = STATE(1976),
    [sym_update_expression] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1976),
    [sym_yield_expression] = STATE(1976),
    [sym_as_expression] = STATE(1976),
    [sym_non_null_expression] = STATE(1976),
    [sym_internal_module] = STATE(1976),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1976),
    [sym_await_expression] = STATE(1976),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1976),
    [sym_this] = STATE(1976),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_call_expression] = STATE(1976),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1976),
    [sym_ternary_expression] = STATE(1976),
    [sym_binary_expression] = STATE(1976),
    [sym_template_string] = STATE(1976),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1976),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1976),
    [sym_class] = STATE(1976),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4125),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4125),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4127),
    [sym_true] = ACTIONS(4125),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4125),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1095] = {
    [sym_new_expression] = STATE(1977),
    [sym_augmented_assignment_expression] = STATE(1977),
    [sym_unary_expression] = STATE(1977),
    [sym_update_expression] = STATE(1977),
    [sym_regex] = STATE(1977),
    [sym_meta_property] = STATE(1977),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1977),
    [sym_yield_expression] = STATE(1977),
    [sym_as_expression] = STATE(1977),
    [sym_non_null_expression] = STATE(1977),
    [sym_internal_module] = STATE(1977),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1977),
    [sym_await_expression] = STATE(1977),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1977),
    [sym_this] = STATE(1977),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1977),
    [sym_generator_function] = STATE(1977),
    [sym_call_expression] = STATE(1977),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1977),
    [sym_ternary_expression] = STATE(1977),
    [sym_binary_expression] = STATE(1977),
    [sym_template_string] = STATE(1977),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1977),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1977),
    [sym_class] = STATE(1977),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4129),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4129),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4131),
    [sym_true] = ACTIONS(4129),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4129),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1096] = {
    [sym_new_expression] = STATE(1978),
    [sym_augmented_assignment_expression] = STATE(1978),
    [sym_unary_expression] = STATE(1978),
    [sym_update_expression] = STATE(1978),
    [sym_regex] = STATE(1978),
    [sym_meta_property] = STATE(1978),
    [sym_call_signature] = STATE(446),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(1978),
    [sym_yield_expression] = STATE(1978),
    [sym_as_expression] = STATE(1978),
    [sym_non_null_expression] = STATE(1978),
    [sym_internal_module] = STATE(1978),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1978),
    [sym_await_expression] = STATE(1978),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1978),
    [sym_this] = STATE(1978),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1978),
    [sym_generator_function] = STATE(1978),
    [sym_call_expression] = STATE(1978),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1978),
    [sym_ternary_expression] = STATE(1978),
    [sym_binary_expression] = STATE(1978),
    [sym_template_string] = STATE(1978),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1978),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1978),
    [sym_class] = STATE(1978),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4133),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4133),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4135),
    [sym_true] = ACTIONS(4133),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4133),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1097] = {
    [sym_new_expression] = STATE(1979),
    [sym_augmented_assignment_expression] = STATE(1979),
    [sym_unary_expression] = STATE(1979),
    [sym_update_expression] = STATE(1979),
    [sym_regex] = STATE(1979),
    [sym_meta_property] = STATE(1979),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1979),
    [sym_yield_expression] = STATE(1979),
    [sym_as_expression] = STATE(1979),
    [sym_non_null_expression] = STATE(1979),
    [sym_internal_module] = STATE(1979),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1979),
    [sym_await_expression] = STATE(1979),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1979),
    [sym_this] = STATE(1979),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1979),
    [sym_generator_function] = STATE(1979),
    [sym_call_expression] = STATE(1979),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1979),
    [sym_ternary_expression] = STATE(1979),
    [sym_binary_expression] = STATE(1979),
    [sym_template_string] = STATE(1979),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1979),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1979),
    [sym_class] = STATE(1979),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4137),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4139),
    [sym_true] = ACTIONS(4137),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4137),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1098] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(4141),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [1099] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(4141),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [1100] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2527),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(2527),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1101] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(2529),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1102] = {
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
  },
  [1103] = {
    [anon_sym_EQ_GT] = ACTIONS(4146),
    [sym_comment] = ACTIONS(3),
  },
  [1104] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [1105] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1106] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(2253),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [1107] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1108] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1109] = {
    [sym_call_signature] = STATE(1102),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(2277),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(2279),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(2279),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(2279),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(2279),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(2279),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(2279),
    [anon_sym_type] = ACTIONS(2279),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(2279),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(2279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(2279),
    [anon_sym_declare] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(2279),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(2279),
    [anon_sym_async] = ACTIONS(2279),
    [anon_sym_public] = ACTIONS(2279),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(2279),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1110] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1111] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1112] = {
    [sym_new_expression] = STATE(1982),
    [sym_augmented_assignment_expression] = STATE(1982),
    [sym_unary_expression] = STATE(1982),
    [sym_update_expression] = STATE(1982),
    [sym_regex] = STATE(1982),
    [sym_meta_property] = STATE(1982),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1982),
    [sym_yield_expression] = STATE(1982),
    [sym_as_expression] = STATE(1982),
    [sym_non_null_expression] = STATE(1982),
    [sym_internal_module] = STATE(1982),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1982),
    [sym_await_expression] = STATE(1982),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1982),
    [sym_this] = STATE(1982),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1982),
    [sym_generator_function] = STATE(1982),
    [sym_call_expression] = STATE(1982),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1982),
    [sym_ternary_expression] = STATE(1982),
    [sym_binary_expression] = STATE(1982),
    [sym_template_string] = STATE(1982),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1982),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1982),
    [sym_class] = STATE(1982),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4148),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4150),
    [sym_true] = ACTIONS(4148),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4148),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1113] = {
    [sym_new_expression] = STATE(1983),
    [sym_augmented_assignment_expression] = STATE(1983),
    [sym_unary_expression] = STATE(1983),
    [sym_update_expression] = STATE(1983),
    [sym_regex] = STATE(1983),
    [sym_meta_property] = STATE(1983),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1983),
    [sym_yield_expression] = STATE(1983),
    [sym_as_expression] = STATE(1983),
    [sym_non_null_expression] = STATE(1983),
    [sym_internal_module] = STATE(1983),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1983),
    [sym_await_expression] = STATE(1983),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1983),
    [sym_this] = STATE(1983),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1983),
    [sym_generator_function] = STATE(1983),
    [sym_call_expression] = STATE(1983),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1983),
    [sym_ternary_expression] = STATE(1983),
    [sym_binary_expression] = STATE(1983),
    [sym_template_string] = STATE(1983),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1983),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1983),
    [sym_class] = STATE(1983),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4152),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4152),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4154),
    [sym_true] = ACTIONS(4152),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4152),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1114] = {
    [sym_new_expression] = STATE(1984),
    [sym_augmented_assignment_expression] = STATE(1984),
    [sym_unary_expression] = STATE(1984),
    [sym_update_expression] = STATE(1984),
    [sym_regex] = STATE(1984),
    [sym_meta_property] = STATE(1984),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1984),
    [sym_yield_expression] = STATE(1984),
    [sym_as_expression] = STATE(1984),
    [sym_non_null_expression] = STATE(1984),
    [sym_internal_module] = STATE(1984),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1984),
    [sym_await_expression] = STATE(1984),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1984),
    [sym_this] = STATE(1984),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1984),
    [sym_generator_function] = STATE(1984),
    [sym_call_expression] = STATE(1984),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1984),
    [sym_ternary_expression] = STATE(1984),
    [sym_binary_expression] = STATE(1984),
    [sym_template_string] = STATE(1984),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1984),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1984),
    [sym_class] = STATE(1984),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4156),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4156),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4158),
    [sym_true] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4156),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1115] = {
    [sym_new_expression] = STATE(1985),
    [sym_augmented_assignment_expression] = STATE(1985),
    [sym_unary_expression] = STATE(1985),
    [sym_update_expression] = STATE(1985),
    [sym_regex] = STATE(1985),
    [sym_meta_property] = STATE(1985),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1985),
    [sym_yield_expression] = STATE(1985),
    [sym_as_expression] = STATE(1985),
    [sym_non_null_expression] = STATE(1985),
    [sym_internal_module] = STATE(1985),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1985),
    [sym_await_expression] = STATE(1985),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1985),
    [sym_this] = STATE(1985),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1985),
    [sym_generator_function] = STATE(1985),
    [sym_call_expression] = STATE(1985),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1985),
    [sym_ternary_expression] = STATE(1985),
    [sym_binary_expression] = STATE(1985),
    [sym_template_string] = STATE(1985),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1985),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1985),
    [sym_class] = STATE(1985),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4160),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4160),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4162),
    [sym_true] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4160),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1116] = {
    [sym_new_expression] = STATE(1986),
    [sym_augmented_assignment_expression] = STATE(1986),
    [sym_unary_expression] = STATE(1986),
    [sym_update_expression] = STATE(1986),
    [sym_regex] = STATE(1986),
    [sym_meta_property] = STATE(1986),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1986),
    [sym_yield_expression] = STATE(1986),
    [sym_as_expression] = STATE(1986),
    [sym_non_null_expression] = STATE(1986),
    [sym_internal_module] = STATE(1986),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1986),
    [sym_await_expression] = STATE(1986),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1986),
    [sym_this] = STATE(1986),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1986),
    [sym_generator_function] = STATE(1986),
    [sym_call_expression] = STATE(1986),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1986),
    [sym_ternary_expression] = STATE(1986),
    [sym_binary_expression] = STATE(1986),
    [sym_template_string] = STATE(1986),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1986),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1986),
    [sym_class] = STATE(1986),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4164),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4166),
    [sym_true] = ACTIONS(4164),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4164),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1117] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(4170),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [1118] = {
    [sym_new_expression] = STATE(1976),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(1976),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1976),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1976),
    [sym_call_signature] = STATE(446),
    [sym_yield_expression] = STATE(1976),
    [sym_as_expression] = STATE(1976),
    [sym_internal_module] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(448),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(450),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(1976),
    [sym_subscript_expression] = STATE(448),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1976),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1976),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(1976),
    [sym_non_null_expression] = STATE(1976),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1976),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1976),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1976),
    [sym_call_expression] = STATE(1976),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1976),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1976),
    [sym_type_arguments] = STATE(452),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(1976),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1976),
    [sym_class] = STATE(1976),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(4180),
    [anon_sym_number] = ACTIONS(4180),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(4182),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4184),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(4186),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(4125),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4180),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(4180),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(4180),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4125),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(4188),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(4184),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1119] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4190),
    [anon_sym_LBRACK] = ACTIONS(4190),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4190),
    [sym__automatic_semicolon] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_COMMA] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_BANG_EQ] = ACTIONS(4192),
    [anon_sym_LT_EQ] = ACTIONS(4190),
    [anon_sym_LPAREN] = ACTIONS(4190),
    [anon_sym_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_PIPE_PIPE] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4192),
    [anon_sym_instanceof] = ACTIONS(4190),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_STAR_STAR] = ACTIONS(4190),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_GT_GT] = ACTIONS(4192),
    [anon_sym_PLUS_PLUS] = ACTIONS(4190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4190),
    [anon_sym_in] = ACTIONS(4192),
  },
  [1120] = {
    [sym_new_expression] = STATE(2001),
    [sym_augmented_assignment_expression] = STATE(2001),
    [sym_unary_expression] = STATE(2001),
    [sym_update_expression] = STATE(2001),
    [sym_regex] = STATE(2001),
    [sym_meta_property] = STATE(2001),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(2001),
    [sym_yield_expression] = STATE(2001),
    [sym_as_expression] = STATE(2001),
    [sym_non_null_expression] = STATE(2001),
    [sym_internal_module] = STATE(2001),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2001),
    [sym_await_expression] = STATE(2001),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(2001),
    [sym_this] = STATE(2001),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(2001),
    [sym_generator_function] = STATE(2001),
    [sym_call_expression] = STATE(2001),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(2001),
    [sym_ternary_expression] = STATE(2001),
    [sym_binary_expression] = STATE(2001),
    [sym_template_string] = STATE(2001),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2001),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(2001),
    [sym_class] = STATE(2001),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4194),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4194),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4196),
    [sym_true] = ACTIONS(4194),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1121] = {
    [aux_sym_array_repeat1] = STATE(1122),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [sym_comment] = ACTIONS(3),
  },
  [1122] = {
    [aux_sym_array_repeat1] = STATE(1122),
    [anon_sym_COMMA] = ACTIONS(4200),
    [anon_sym_RPAREN] = ACTIONS(2529),
    [sym_comment] = ACTIONS(3),
  },
  [1123] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4203),
    [anon_sym_AMP_EQ] = ACTIONS(4203),
    [anon_sym_PLUS_EQ] = ACTIONS(4203),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(4205),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4203),
    [anon_sym_STAR_EQ] = ACTIONS(4203),
    [anon_sym_PIPE_EQ] = ACTIONS(4203),
    [anon_sym_DASH_EQ] = ACTIONS(4203),
    [anon_sym_EQ_GT] = ACTIONS(4209),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2652),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4203),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT_EQ] = ACTIONS(4203),
    [anon_sym_DOT] = ACTIONS(2661),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4211),
  },
  [1124] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_EQ_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1125] = {
    [sym_new_expression] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(2010),
    [sym_unary_expression] = STATE(2010),
    [sym_update_expression] = STATE(2010),
    [sym_regex] = STATE(2010),
    [sym_meta_property] = STATE(2010),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2010),
    [sym_yield_expression] = STATE(2010),
    [sym_as_expression] = STATE(2010),
    [sym_non_null_expression] = STATE(2010),
    [sym_internal_module] = STATE(2010),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2010),
    [sym_await_expression] = STATE(2010),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2010),
    [sym_this] = STATE(2010),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2010),
    [sym_generator_function] = STATE(2010),
    [sym_call_expression] = STATE(2010),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2010),
    [sym_ternary_expression] = STATE(2010),
    [sym_binary_expression] = STATE(2010),
    [sym_template_string] = STATE(2010),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2010),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2010),
    [sym_class] = STATE(2010),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4219),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4221),
    [sym_true] = ACTIONS(4219),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4219),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [1126] = {
    [sym_new_expression] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(2011),
    [sym_unary_expression] = STATE(2011),
    [sym_update_expression] = STATE(2011),
    [sym_regex] = STATE(2011),
    [sym_meta_property] = STATE(2011),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2011),
    [sym_yield_expression] = STATE(2011),
    [sym_as_expression] = STATE(2011),
    [sym_non_null_expression] = STATE(2011),
    [sym_internal_module] = STATE(2011),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2011),
    [sym_await_expression] = STATE(2011),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2011),
    [sym_this] = STATE(2011),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2011),
    [sym_generator_function] = STATE(2011),
    [sym_call_expression] = STATE(2011),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2011),
    [sym_ternary_expression] = STATE(2011),
    [sym_binary_expression] = STATE(2011),
    [sym_template_string] = STATE(2011),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2011),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2011),
    [sym_class] = STATE(2011),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4223),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4225),
    [sym_true] = ACTIONS(4223),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4223),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [1127] = {
    [sym_new_expression] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(2010),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(2010),
    [sym_update_expression] = STATE(2010),
    [sym_regex] = STATE(2010),
    [sym_meta_property] = STATE(2010),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2010),
    [sym_yield_expression] = STATE(2010),
    [sym_as_expression] = STATE(2010),
    [sym_non_null_expression] = STATE(2010),
    [sym_internal_module] = STATE(2010),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2010),
    [sym_await_expression] = STATE(2010),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2010),
    [sym_this] = STATE(2010),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2010),
    [sym_generator_function] = STATE(2010),
    [sym_call_expression] = STATE(2010),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2010),
    [sym_ternary_expression] = STATE(2010),
    [sym_binary_expression] = STATE(2010),
    [sym_template_string] = STATE(2010),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2010),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2010),
    [sym_class] = STATE(2010),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4217),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(2361),
    [sym_true] = ACTIONS(4219),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4213),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4219),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(4227),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4219),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4221),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4219),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1128] = {
    [sym_call_signature] = STATE(2012),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4229),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_symbol] = ACTIONS(4231),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_void] = ACTIONS(4231),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_private] = ACTIONS(4231),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_get] = ACTIONS(4231),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(4231),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(4231),
    [anon_sym_type] = ACTIONS(4231),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4231),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4213),
    [anon_sym_namespace] = ACTIONS(4231),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4231),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_number] = ACTIONS(4231),
    [anon_sym_declare] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4231),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_boolean] = ACTIONS(4231),
    [anon_sym_async] = ACTIONS(4231),
    [anon_sym_public] = ACTIONS(4231),
    [anon_sym_EQ_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_string] = ACTIONS(4231),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4231),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1129] = {
    [sym_new_expression] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(2014),
    [sym_unary_expression] = STATE(2014),
    [sym_update_expression] = STATE(2014),
    [sym_regex] = STATE(2014),
    [sym_meta_property] = STATE(2014),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2014),
    [sym_yield_expression] = STATE(2014),
    [sym_as_expression] = STATE(2014),
    [sym_non_null_expression] = STATE(2014),
    [sym_internal_module] = STATE(2014),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2014),
    [sym_await_expression] = STATE(2014),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2014),
    [sym_this] = STATE(2014),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2014),
    [sym_generator_function] = STATE(2014),
    [sym_call_expression] = STATE(2014),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2014),
    [sym_ternary_expression] = STATE(2014),
    [sym_binary_expression] = STATE(2014),
    [sym_template_string] = STATE(2014),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2014),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2014),
    [sym_class] = STATE(2014),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(4233),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4233),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4235),
    [sym_true] = ACTIONS(4233),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4233),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [1130] = {
    [sym_new_expression] = STATE(2015),
    [sym_augmented_assignment_expression] = STATE(2015),
    [sym_unary_expression] = STATE(2015),
    [sym_update_expression] = STATE(2015),
    [sym_regex] = STATE(2015),
    [sym_meta_property] = STATE(2015),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2015),
    [sym_yield_expression] = STATE(2015),
    [sym_as_expression] = STATE(2015),
    [sym_non_null_expression] = STATE(2015),
    [sym_internal_module] = STATE(2015),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2015),
    [sym_await_expression] = STATE(2015),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2015),
    [sym_this] = STATE(2015),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2015),
    [sym_generator_function] = STATE(2015),
    [sym_call_expression] = STATE(2015),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2015),
    [sym_ternary_expression] = STATE(2015),
    [sym_binary_expression] = STATE(2015),
    [sym_template_string] = STATE(2015),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2015),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2015),
    [sym_class] = STATE(2015),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(4217),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(211),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(2361),
    [sym_true] = ACTIONS(4237),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4237),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(4227),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4237),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4239),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4237),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [1131] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4241),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4243),
    [anon_sym_symbol] = ACTIONS(4243),
    [anon_sym_number] = ACTIONS(4243),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4243),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4245),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4243),
    [anon_sym_private] = ACTIONS(4243),
    [anon_sym_boolean] = ACTIONS(4243),
    [anon_sym_async] = ACTIONS(4247),
    [anon_sym_public] = ACTIONS(4243),
    [anon_sym_get] = ACTIONS(4243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4243),
    [anon_sym_string] = ACTIONS(4243),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(4243),
    [anon_sym_type] = ACTIONS(4243),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(4243),
    [anon_sym_export] = ACTIONS(4243),
    [anon_sym_namespace] = ACTIONS(4249),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [1132] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_EQ_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1133] = {
    [sym_new_expression] = STATE(2021),
    [sym_augmented_assignment_expression] = STATE(2021),
    [sym_unary_expression] = STATE(2021),
    [sym_update_expression] = STATE(2021),
    [sym_regex] = STATE(2021),
    [sym_meta_property] = STATE(2021),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2021),
    [sym_yield_expression] = STATE(2021),
    [sym_as_expression] = STATE(2021),
    [sym_non_null_expression] = STATE(2021),
    [sym_internal_module] = STATE(2021),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2021),
    [sym_await_expression] = STATE(2021),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2021),
    [sym_this] = STATE(2021),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2021),
    [sym_generator_function] = STATE(2021),
    [sym_call_expression] = STATE(2021),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2021),
    [sym_ternary_expression] = STATE(2021),
    [sym_binary_expression] = STATE(2021),
    [sym_template_string] = STATE(2021),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2021),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2021),
    [sym_class] = STATE(2021),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(4251),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4251),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4253),
    [sym_true] = ACTIONS(4251),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4251),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [1134] = {
    [anon_sym_EQ_GT] = ACTIONS(4209),
    [sym_comment] = ACTIONS(3),
  },
  [1135] = {
    [aux_sym_extends_clause_repeat1] = STATE(2031),
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(4211),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_COMMA] = ACTIONS(4261),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_LBRACE] = ACTIONS(4265),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1136] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4203),
    [anon_sym_AMP_EQ] = ACTIONS(4203),
    [anon_sym_PLUS_EQ] = ACTIONS(4203),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4203),
    [anon_sym_STAR_EQ] = ACTIONS(4203),
    [anon_sym_PIPE_EQ] = ACTIONS(4203),
    [anon_sym_DASH_EQ] = ACTIONS(4203),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4203),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT_EQ] = ACTIONS(4203),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1137] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4211),
  },
  [1138] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [1139] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4211),
  },
  [1140] = {
    [aux_sym_extends_clause_repeat1] = STATE(2031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2717),
    [anon_sym_COMMA] = ACTIONS(4261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4265),
  },
  [1141] = {
    [sym_identifier] = ACTIONS(4283),
    [anon_sym_BQUOTE] = ACTIONS(4285),
    [anon_sym_debugger] = ACTIONS(4283),
    [anon_sym_symbol] = ACTIONS(4283),
    [anon_sym_AT] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4283),
    [anon_sym_void] = ACTIONS(4283),
    [anon_sym_break] = ACTIONS(4283),
    [anon_sym_const] = ACTIONS(4283),
    [sym_super] = ACTIONS(4283),
    [anon_sym_return] = ACTIONS(4283),
    [anon_sym_private] = ACTIONS(4283),
    [anon_sym_get] = ACTIONS(4283),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_interface] = ACTIONS(4283),
    [anon_sym_default] = ACTIONS(4283),
    [anon_sym_enum] = ACTIONS(4283),
    [anon_sym_delete] = ACTIONS(4283),
    [anon_sym_continue] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4285),
    [anon_sym_if] = ACTIONS(4283),
    [anon_sym_this] = ACTIONS(4283),
    [anon_sym_yield] = ACTIONS(4283),
    [sym_true] = ACTIONS(4283),
    [anon_sym_throw] = ACTIONS(4283),
    [anon_sym_protected] = ACTIONS(4283),
    [anon_sym_abstract] = ACTIONS(4283),
    [anon_sym_set] = ACTIONS(4283),
    [anon_sym_type] = ACTIONS(4283),
    [anon_sym_import] = ACTIONS(4283),
    [anon_sym_namespace] = ACTIONS(4283),
    [anon_sym_PLUS_PLUS] = ACTIONS(4285),
    [anon_sym_await] = ACTIONS(4283),
    [anon_sym_DQUOTE] = ACTIONS(4285),
    [anon_sym_else] = ACTIONS(4283),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_for] = ACTIONS(4283),
    [anon_sym_LBRACK] = ACTIONS(4285),
    [sym_false] = ACTIONS(4283),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_case] = ACTIONS(4283),
    [anon_sym_module] = ACTIONS(4283),
    [anon_sym_number] = ACTIONS(4283),
    [anon_sym_class] = ACTIONS(4283),
    [anon_sym_declare] = ACTIONS(4283),
    [anon_sym_typeof] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_switch] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4285),
    [sym_null] = ACTIONS(4283),
    [anon_sym_any] = ACTIONS(4283),
    [anon_sym_boolean] = ACTIONS(4283),
    [anon_sym_async] = ACTIONS(4283),
    [anon_sym_public] = ACTIONS(4283),
    [anon_sym_var] = ACTIONS(4283),
    [anon_sym_while] = ACTIONS(4283),
    [anon_sym_SQUOTE] = ACTIONS(4285),
    [anon_sym_try] = ACTIONS(4283),
    [anon_sym_LT] = ACTIONS(4285),
    [sym_number] = ACTIONS(4285),
    [anon_sym_SLASH] = ACTIONS(4283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4283),
    [anon_sym_function] = ACTIONS(4283),
    [sym_undefined] = ACTIONS(4283),
    [anon_sym_new] = ACTIONS(4283),
    [ts_builtin_sym_end] = ACTIONS(4285),
    [anon_sym_let] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4283),
    [anon_sym_export] = ACTIONS(4283),
    [anon_sym_do] = ACTIONS(4283),
    [anon_sym_TILDE] = ACTIONS(4285),
    [anon_sym_with] = ACTIONS(4283),
  },
  [1142] = {
    [sym_object_type] = STATE(2032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(486),
  },
  [1143] = {
    [sym_identifier] = ACTIONS(4287),
    [anon_sym_BQUOTE] = ACTIONS(4289),
    [anon_sym_debugger] = ACTIONS(4287),
    [anon_sym_symbol] = ACTIONS(4287),
    [anon_sym_AT] = ACTIONS(4289),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_void] = ACTIONS(4287),
    [anon_sym_break] = ACTIONS(4287),
    [anon_sym_const] = ACTIONS(4287),
    [sym_super] = ACTIONS(4287),
    [anon_sym_return] = ACTIONS(4287),
    [anon_sym_private] = ACTIONS(4287),
    [anon_sym_get] = ACTIONS(4287),
    [anon_sym_RBRACE] = ACTIONS(4289),
    [anon_sym_interface] = ACTIONS(4287),
    [anon_sym_default] = ACTIONS(4287),
    [anon_sym_enum] = ACTIONS(4287),
    [anon_sym_delete] = ACTIONS(4287),
    [anon_sym_continue] = ACTIONS(4287),
    [anon_sym_DASH_DASH] = ACTIONS(4289),
    [anon_sym_if] = ACTIONS(4287),
    [anon_sym_this] = ACTIONS(4287),
    [anon_sym_yield] = ACTIONS(4287),
    [sym_true] = ACTIONS(4287),
    [anon_sym_throw] = ACTIONS(4287),
    [anon_sym_protected] = ACTIONS(4287),
    [anon_sym_abstract] = ACTIONS(4287),
    [anon_sym_set] = ACTIONS(4287),
    [anon_sym_type] = ACTIONS(4287),
    [anon_sym_import] = ACTIONS(4287),
    [anon_sym_namespace] = ACTIONS(4287),
    [anon_sym_PLUS_PLUS] = ACTIONS(4289),
    [anon_sym_await] = ACTIONS(4287),
    [anon_sym_DQUOTE] = ACTIONS(4289),
    [anon_sym_else] = ACTIONS(4287),
    [anon_sym_BANG] = ACTIONS(4289),
    [anon_sym_for] = ACTIONS(4287),
    [anon_sym_LBRACK] = ACTIONS(4289),
    [sym_false] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4289),
    [anon_sym_case] = ACTIONS(4287),
    [anon_sym_module] = ACTIONS(4287),
    [anon_sym_number] = ACTIONS(4287),
    [anon_sym_class] = ACTIONS(4287),
    [anon_sym_declare] = ACTIONS(4287),
    [anon_sym_typeof] = ACTIONS(4287),
    [anon_sym_LBRACE] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(4289),
    [sym_null] = ACTIONS(4287),
    [anon_sym_any] = ACTIONS(4287),
    [anon_sym_boolean] = ACTIONS(4287),
    [anon_sym_async] = ACTIONS(4287),
    [anon_sym_public] = ACTIONS(4287),
    [anon_sym_var] = ACTIONS(4287),
    [anon_sym_while] = ACTIONS(4287),
    [anon_sym_SQUOTE] = ACTIONS(4289),
    [anon_sym_try] = ACTIONS(4287),
    [anon_sym_LT] = ACTIONS(4289),
    [sym_number] = ACTIONS(4289),
    [anon_sym_SLASH] = ACTIONS(4287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4287),
    [anon_sym_function] = ACTIONS(4287),
    [sym_undefined] = ACTIONS(4287),
    [anon_sym_new] = ACTIONS(4287),
    [ts_builtin_sym_end] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_export] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4287),
    [anon_sym_TILDE] = ACTIONS(4289),
    [anon_sym_with] = ACTIONS(4287),
  },
  [1144] = {
    [sym__initializer] = STATE(2033),
    [anon_sym_EQ] = ACTIONS(2173),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_COMMA] = ACTIONS(4291),
    [sym_comment] = ACTIONS(3),
  },
  [1145] = {
    [aux_sym_enum_body_repeat1] = STATE(2036),
    [anon_sym_COMMA] = ACTIONS(4293),
    [anon_sym_RBRACE] = ACTIONS(4295),
    [sym_comment] = ACTIONS(3),
  },
  [1146] = {
    [sym_identifier] = ACTIONS(3158),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [anon_sym_debugger] = ACTIONS(3158),
    [anon_sym_symbol] = ACTIONS(3158),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_void] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [sym_super] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_private] = ACTIONS(3158),
    [anon_sym_get] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_this] = ACTIONS(3158),
    [anon_sym_yield] = ACTIONS(3158),
    [sym_true] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_protected] = ACTIONS(3158),
    [anon_sym_abstract] = ACTIONS(3158),
    [anon_sym_set] = ACTIONS(3158),
    [anon_sym_type] = ACTIONS(3158),
    [anon_sym_import] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_await] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [sym_false] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym_module] = ACTIONS(3158),
    [anon_sym_number] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_declare] = ACTIONS(3158),
    [anon_sym_typeof] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_LPAREN] = ACTIONS(3156),
    [sym_null] = ACTIONS(3158),
    [anon_sym_any] = ACTIONS(3158),
    [anon_sym_boolean] = ACTIONS(3158),
    [anon_sym_async] = ACTIONS(3158),
    [anon_sym_public] = ACTIONS(3158),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_LT] = ACTIONS(3156),
    [sym_number] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3158),
    [anon_sym_function] = ACTIONS(3158),
    [sym_undefined] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_export] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3158),
  },
  [1147] = {
    [anon_sym_RPAREN] = ACTIONS(4297),
    [sym_comment] = ACTIONS(3),
  },
  [1148] = {
    [sym_type_alias_declaration] = STATE(361),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(361),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(361),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(361),
    [sym_return_statement] = STATE(361),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(361),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(361),
    [sym_switch_statement] = STATE(361),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(361),
    [sym_throw_statement] = STATE(361),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(361),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(361),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(361),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(361),
    [sym_abstract_class] = STATE(361),
    [sym_interface_declaration] = STATE(361),
    [sym_statement_block] = STATE(361),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(361),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(361),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(361),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(361),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(361),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(361),
    [sym_empty_statement] = STATE(361),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(361),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(361),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(361),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(361),
    [sym_break_statement] = STATE(361),
    [sym_labeled_statement] = STATE(361),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(361),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [1149] = {
    [sym_type_alias_declaration] = STATE(2038),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2038),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2038),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2038),
    [sym_return_statement] = STATE(2038),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2038),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2038),
    [sym_switch_statement] = STATE(2038),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2038),
    [sym_throw_statement] = STATE(2038),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2038),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2038),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(2038),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2038),
    [sym_abstract_class] = STATE(2038),
    [sym_interface_declaration] = STATE(2038),
    [sym_statement_block] = STATE(2038),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2038),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2038),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2038),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2038),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2038),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2038),
    [sym_empty_statement] = STATE(2038),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(2038),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2038),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2038),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2038),
    [sym_break_statement] = STATE(2038),
    [sym_labeled_statement] = STATE(2038),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2038),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [1150] = {
    [anon_sym_LPAREN] = ACTIONS(4299),
    [sym_comment] = ACTIONS(3),
  },
  [1151] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2043),
    [sym_variable_declaration] = STATE(2043),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(2043),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2044),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_lexical_declaration] = STATE(2043),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(2045),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(4301),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(4303),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4305),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(4303),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [1152] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(4307),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(310),
  },
  [1153] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(1155),
    [sym__declaration] = STATE(192),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(1155),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(2393),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2395),
    [anon_sym_global] = ACTIONS(322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(2397),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [1154] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(1155),
    [sym__declaration] = STATE(317),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(1155),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(2397),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [1155] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(2405),
    [anon_sym_class] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [1156] = {
    [sym_type_alias_declaration] = STATE(777),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(777),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(777),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(777),
    [sym_return_statement] = STATE(777),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(777),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(777),
    [sym_switch_statement] = STATE(777),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(777),
    [sym_throw_statement] = STATE(777),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(777),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(777),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(777),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(777),
    [sym_abstract_class] = STATE(777),
    [sym_interface_declaration] = STATE(777),
    [sym_statement_block] = STATE(777),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(777),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(777),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(777),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(777),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(777),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(777),
    [sym_empty_statement] = STATE(777),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(777),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(777),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(777),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(777),
    [sym_break_statement] = STATE(777),
    [sym_labeled_statement] = STATE(777),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(777),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [1157] = {
    [sym_type_alias_declaration] = STATE(934),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(934),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(934),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(934),
    [sym_return_statement] = STATE(934),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(934),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(934),
    [sym_switch_statement] = STATE(934),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(934),
    [sym_throw_statement] = STATE(934),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(934),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(934),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(934),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(934),
    [sym_abstract_class] = STATE(934),
    [sym_interface_declaration] = STATE(934),
    [sym_statement_block] = STATE(934),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(934),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(934),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(934),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(934),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(934),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(934),
    [sym_empty_statement] = STATE(934),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(934),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(934),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(934),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(934),
    [sym_break_statement] = STATE(934),
    [sym_labeled_statement] = STATE(934),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(934),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [1158] = {
    [sym_type_alias_declaration] = STATE(2047),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2047),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2047),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2047),
    [sym_return_statement] = STATE(2047),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2047),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2047),
    [sym_switch_statement] = STATE(2047),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2047),
    [sym_throw_statement] = STATE(2047),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2047),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2047),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(2047),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2047),
    [sym_abstract_class] = STATE(2047),
    [sym_interface_declaration] = STATE(2047),
    [sym_statement_block] = STATE(2047),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2047),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2047),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2047),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2047),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2047),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2047),
    [sym_empty_statement] = STATE(2047),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(2047),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2047),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2047),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2047),
    [sym_break_statement] = STATE(2047),
    [sym_labeled_statement] = STATE(2047),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2047),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1159] = {
    [sym_type_alias_declaration] = STATE(915),
    [aux_sym_export_statement_repeat1] = STATE(1155),
    [sym__declaration] = STATE(915),
    [sym_ambient_declaration] = STATE(915),
    [sym_import_alias] = STATE(915),
    [sym_export_statement] = STATE(915),
    [sym_generator_function] = STATE(915),
    [sym_lexical_declaration] = STATE(915),
    [sym_internal_module] = STATE(915),
    [sym_decorator] = STATE(1155),
    [sym_enum_declaration] = STATE(915),
    [sym_function] = STATE(915),
    [sym_function_signature] = STATE(915),
    [sym_variable_declaration] = STATE(915),
    [sym_abstract_class] = STATE(915),
    [sym_module] = STATE(915),
    [sym_interface_declaration] = STATE(915),
    [sym_class] = STATE(915),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(2397),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [1160] = {
    [sym_public_field_definition] = STATE(630),
    [sym__property_name] = STATE(631),
    [sym_decorator] = STATE(2049),
    [sym_method_signature] = STATE(630),
    [sym_accessibility_modifier] = STATE(632),
    [sym_abstract_method_signature] = STATE(630),
    [sym_computed_property_name] = STATE(631),
    [aux_sym_class_body_repeat1] = STATE(2049),
    [sym_index_signature] = STATE(630),
    [sym_string] = STATE(631),
    [sym_method_definition] = STATE(634),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1129),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(4309),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_abstract] = ACTIONS(1139),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1161] = {
    [sym_class_body] = STATE(2050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [1162] = {
    [sym_class_heritage] = STATE(2051),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(2050),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [1163] = {
    [sym_identifier] = ACTIONS(4311),
    [anon_sym_BQUOTE] = ACTIONS(4313),
    [anon_sym_debugger] = ACTIONS(4311),
    [anon_sym_symbol] = ACTIONS(4311),
    [anon_sym_AT] = ACTIONS(4313),
    [anon_sym_DASH] = ACTIONS(4311),
    [anon_sym_void] = ACTIONS(4311),
    [anon_sym_break] = ACTIONS(4311),
    [anon_sym_const] = ACTIONS(4311),
    [sym_super] = ACTIONS(4311),
    [anon_sym_return] = ACTIONS(4311),
    [anon_sym_private] = ACTIONS(4311),
    [anon_sym_get] = ACTIONS(4311),
    [anon_sym_RBRACE] = ACTIONS(4313),
    [anon_sym_interface] = ACTIONS(4311),
    [anon_sym_default] = ACTIONS(4311),
    [anon_sym_enum] = ACTIONS(4311),
    [anon_sym_delete] = ACTIONS(4311),
    [anon_sym_continue] = ACTIONS(4311),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_if] = ACTIONS(4311),
    [anon_sym_this] = ACTIONS(4311),
    [anon_sym_yield] = ACTIONS(4311),
    [sym_true] = ACTIONS(4311),
    [anon_sym_throw] = ACTIONS(4311),
    [anon_sym_protected] = ACTIONS(4311),
    [anon_sym_abstract] = ACTIONS(4311),
    [anon_sym_set] = ACTIONS(4311),
    [anon_sym_type] = ACTIONS(4311),
    [anon_sym_import] = ACTIONS(4311),
    [anon_sym_namespace] = ACTIONS(4311),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_await] = ACTIONS(4311),
    [anon_sym_DQUOTE] = ACTIONS(4313),
    [anon_sym_else] = ACTIONS(4311),
    [anon_sym_BANG] = ACTIONS(4313),
    [anon_sym_for] = ACTIONS(4311),
    [anon_sym_LBRACK] = ACTIONS(4313),
    [sym_false] = ACTIONS(4311),
    [anon_sym_SEMI] = ACTIONS(4313),
    [anon_sym_case] = ACTIONS(4311),
    [anon_sym_module] = ACTIONS(4311),
    [anon_sym_number] = ACTIONS(4311),
    [anon_sym_class] = ACTIONS(4311),
    [anon_sym_declare] = ACTIONS(4311),
    [anon_sym_typeof] = ACTIONS(4311),
    [anon_sym_LBRACE] = ACTIONS(4313),
    [anon_sym_switch] = ACTIONS(4311),
    [anon_sym_LPAREN] = ACTIONS(4313),
    [sym_null] = ACTIONS(4311),
    [anon_sym_any] = ACTIONS(4311),
    [anon_sym_boolean] = ACTIONS(4311),
    [anon_sym_async] = ACTIONS(4311),
    [anon_sym_public] = ACTIONS(4311),
    [anon_sym_var] = ACTIONS(4311),
    [anon_sym_while] = ACTIONS(4311),
    [anon_sym_SQUOTE] = ACTIONS(4313),
    [anon_sym_try] = ACTIONS(4311),
    [anon_sym_LT] = ACTIONS(4313),
    [sym_number] = ACTIONS(4313),
    [anon_sym_SLASH] = ACTIONS(4311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4311),
    [anon_sym_function] = ACTIONS(4311),
    [sym_undefined] = ACTIONS(4311),
    [anon_sym_new] = ACTIONS(4311),
    [ts_builtin_sym_end] = ACTIONS(4313),
    [anon_sym_let] = ACTIONS(4311),
    [anon_sym_PLUS] = ACTIONS(4311),
    [anon_sym_export] = ACTIONS(4311),
    [anon_sym_do] = ACTIONS(4311),
    [anon_sym_TILDE] = ACTIONS(4313),
    [anon_sym_with] = ACTIONS(4311),
  },
  [1164] = {
    [sym_type_arguments] = STATE(1937),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_is] = ACTIONS(4315),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4317),
  },
  [1165] = {
    [sym_tuple_type] = STATE(1939),
    [sym_index_type_query] = STATE(1939),
    [sym_lookup_type] = STATE(1939),
    [sym_this_type] = STATE(1939),
    [sym_flow_maybe_type] = STATE(1939),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_type_predicate] = STATE(1939),
    [sym_type_query] = STATE(1939),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1939),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1939),
    [sym__primary_type] = STATE(1939),
    [sym_generic_type] = STATE(1939),
    [sym_mapped_type] = STATE(1939),
    [sym_literal_type] = STATE(1939),
    [sym_parenthesized_type] = STATE(1939),
    [sym_predefined_type] = STATE(1939),
    [sym_string] = STATE(1048),
    [sym_array_type] = STATE(1939),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [sym_true] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1166] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1167] = {
    [sym_formal_parameters] = STATE(2054),
    [sym_type_parameters] = STATE(2055),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1168] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1169] = {
    [sym__automatic_semicolon] = ACTIONS(4319),
    [anon_sym_AMP] = ACTIONS(4321),
    [anon_sym_PIPE] = ACTIONS(4323),
    [anon_sym_SEMI] = ACTIONS(4319),
    [sym_comment] = ACTIONS(3),
  },
  [1170] = {
    [sym_formal_parameters] = STATE(2059),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1171] = {
    [sym_type_arguments] = STATE(1958),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4325),
  },
  [1172] = {
    [anon_sym_EQ_GT] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
  },
  [1173] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2062),
    [sym_constructor_type] = STATE(2062),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(2062),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2062),
    [sym_intersection_type] = STATE(2062),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1174] = {
    [anon_sym_from] = ACTIONS(4329),
    [sym_comment] = ACTIONS(3),
  },
  [1175] = {
    [anon_sym_LPAREN] = ACTIONS(4331),
    [sym_comment] = ACTIONS(3),
  },
  [1176] = {
    [sym__automatic_semicolon] = ACTIONS(4333),
    [anon_sym_SEMI] = ACTIONS(4333),
    [anon_sym_DOT] = ACTIONS(4335),
    [sym_comment] = ACTIONS(3),
  },
  [1177] = {
    [anon_sym_require] = ACTIONS(4337),
    [sym_comment] = ACTIONS(3),
  },
  [1178] = {
    [sym_identifier] = ACTIONS(4339),
    [anon_sym_BQUOTE] = ACTIONS(4341),
    [anon_sym_debugger] = ACTIONS(4339),
    [anon_sym_symbol] = ACTIONS(4339),
    [anon_sym_AT] = ACTIONS(4341),
    [anon_sym_DASH] = ACTIONS(4339),
    [anon_sym_void] = ACTIONS(4339),
    [anon_sym_break] = ACTIONS(4339),
    [anon_sym_const] = ACTIONS(4339),
    [sym_super] = ACTIONS(4339),
    [anon_sym_return] = ACTIONS(4339),
    [anon_sym_private] = ACTIONS(4339),
    [anon_sym_get] = ACTIONS(4339),
    [anon_sym_RBRACE] = ACTIONS(4341),
    [anon_sym_interface] = ACTIONS(4339),
    [anon_sym_default] = ACTIONS(4339),
    [anon_sym_enum] = ACTIONS(4339),
    [anon_sym_delete] = ACTIONS(4339),
    [anon_sym_continue] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4341),
    [anon_sym_if] = ACTIONS(4339),
    [anon_sym_this] = ACTIONS(4339),
    [anon_sym_yield] = ACTIONS(4339),
    [sym_true] = ACTIONS(4339),
    [anon_sym_throw] = ACTIONS(4339),
    [anon_sym_protected] = ACTIONS(4339),
    [anon_sym_abstract] = ACTIONS(4339),
    [anon_sym_set] = ACTIONS(4339),
    [anon_sym_type] = ACTIONS(4339),
    [anon_sym_import] = ACTIONS(4339),
    [anon_sym_namespace] = ACTIONS(4339),
    [anon_sym_PLUS_PLUS] = ACTIONS(4341),
    [anon_sym_await] = ACTIONS(4339),
    [anon_sym_DQUOTE] = ACTIONS(4341),
    [anon_sym_else] = ACTIONS(4339),
    [anon_sym_BANG] = ACTIONS(4341),
    [anon_sym_for] = ACTIONS(4339),
    [anon_sym_LBRACK] = ACTIONS(4341),
    [sym_false] = ACTIONS(4339),
    [anon_sym_SEMI] = ACTIONS(4341),
    [anon_sym_case] = ACTIONS(4339),
    [anon_sym_module] = ACTIONS(4339),
    [anon_sym_number] = ACTIONS(4339),
    [anon_sym_class] = ACTIONS(4339),
    [anon_sym_declare] = ACTIONS(4339),
    [anon_sym_typeof] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_switch] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4341),
    [sym_null] = ACTIONS(4339),
    [anon_sym_any] = ACTIONS(4339),
    [anon_sym_boolean] = ACTIONS(4339),
    [anon_sym_async] = ACTIONS(4339),
    [anon_sym_public] = ACTIONS(4339),
    [anon_sym_var] = ACTIONS(4339),
    [anon_sym_while] = ACTIONS(4339),
    [anon_sym_SQUOTE] = ACTIONS(4341),
    [anon_sym_try] = ACTIONS(4339),
    [anon_sym_LT] = ACTIONS(4341),
    [sym_number] = ACTIONS(4341),
    [anon_sym_SLASH] = ACTIONS(4339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4339),
    [anon_sym_function] = ACTIONS(4339),
    [sym_undefined] = ACTIONS(4339),
    [anon_sym_new] = ACTIONS(4339),
    [ts_builtin_sym_end] = ACTIONS(4341),
    [anon_sym_let] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4339),
    [anon_sym_export] = ACTIONS(4339),
    [anon_sym_do] = ACTIONS(4339),
    [anon_sym_TILDE] = ACTIONS(4341),
    [anon_sym_with] = ACTIONS(4339),
  },
  [1179] = {
    [sym__automatic_semicolon] = ACTIONS(4343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4343),
  },
  [1180] = {
    [anon_sym_from] = ACTIONS(4345),
    [sym_comment] = ACTIONS(3),
  },
  [1181] = {
    [sym_identifier] = ACTIONS(4347),
    [sym_comment] = ACTIONS(3),
  },
  [1182] = {
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_as] = ACTIONS(4351),
    [sym_comment] = ACTIONS(3),
  },
  [1183] = {
    [anon_sym_from] = ACTIONS(4353),
    [sym_comment] = ACTIONS(3),
  },
  [1184] = {
    [sym__import_export_specifier] = STATE(2069),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_RBRACE] = ACTIONS(4355),
    [anon_sym_typeof] = ACTIONS(887),
    [anon_sym_type] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
  },
  [1185] = {
    [anon_sym_from] = ACTIONS(4357),
    [sym_comment] = ACTIONS(3),
  },
  [1186] = {
    [aux_sym_named_imports_repeat1] = STATE(2071),
    [anon_sym_COMMA] = ACTIONS(4359),
    [anon_sym_RBRACE] = ACTIONS(4355),
    [sym_comment] = ACTIONS(3),
  },
  [1187] = {
    [sym__automatic_semicolon] = ACTIONS(4361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4361),
  },
  [1188] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4363),
    [sym_identifier] = ACTIONS(4365),
    [sym__automatic_semicolon] = ACTIONS(4363),
    [anon_sym_BQUOTE] = ACTIONS(4363),
    [anon_sym_debugger] = ACTIONS(4365),
    [ts_builtin_sym_end] = ACTIONS(4363),
    [anon_sym_symbol] = ACTIONS(4365),
    [anon_sym_AT] = ACTIONS(4363),
    [anon_sym_PIPE] = ACTIONS(4365),
    [anon_sym_COMMA] = ACTIONS(4363),
    [anon_sym_DASH] = ACTIONS(4365),
    [anon_sym_STAR] = ACTIONS(4365),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_void] = ACTIONS(4365),
    [anon_sym_break] = ACTIONS(4365),
    [anon_sym_BANG_EQ] = ACTIONS(4365),
    [anon_sym_const] = ACTIONS(4365),
    [anon_sym_GT_EQ] = ACTIONS(4363),
    [sym_super] = ACTIONS(4365),
    [anon_sym_return] = ACTIONS(4365),
    [anon_sym_private] = ACTIONS(4365),
    [anon_sym_get] = ACTIONS(4365),
    [anon_sym_RBRACE] = ACTIONS(4363),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_interface] = ACTIONS(4365),
    [anon_sym_default] = ACTIONS(4365),
    [anon_sym_as] = ACTIONS(4365),
    [anon_sym_delete] = ACTIONS(4365),
    [anon_sym_continue] = ACTIONS(4365),
    [anon_sym_DASH_DASH] = ACTIONS(4363),
    [anon_sym_if] = ACTIONS(4365),
    [anon_sym_instanceof] = ACTIONS(4365),
    [anon_sym_this] = ACTIONS(4365),
    [anon_sym_yield] = ACTIONS(4365),
    [sym_true] = ACTIONS(4365),
    [anon_sym_throw] = ACTIONS(4365),
    [anon_sym_enum] = ACTIONS(4365),
    [anon_sym_protected] = ACTIONS(4365),
    [anon_sym_abstract] = ACTIONS(4365),
    [anon_sym_DOT] = ACTIONS(4365),
    [anon_sym_set] = ACTIONS(4365),
    [anon_sym_type] = ACTIONS(4365),
    [anon_sym_STAR_STAR] = ACTIONS(4363),
    [anon_sym_import] = ACTIONS(4365),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4363),
    [anon_sym_namespace] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4363),
    [anon_sym_await] = ACTIONS(4365),
    [anon_sym_DQUOTE] = ACTIONS(4363),
    [anon_sym_else] = ACTIONS(4365),
    [anon_sym_BANG] = ACTIONS(4365),
    [anon_sym_for] = ACTIONS(4365),
    [anon_sym_LBRACK] = ACTIONS(4363),
    [sym_false] = ACTIONS(4365),
    [anon_sym_SEMI] = ACTIONS(4363),
    [anon_sym_case] = ACTIONS(4365),
    [anon_sym_module] = ACTIONS(4365),
    [anon_sym_number] = ACTIONS(4365),
    [anon_sym_class] = ACTIONS(4365),
    [anon_sym_declare] = ACTIONS(4365),
    [anon_sym_typeof] = ACTIONS(4365),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_LBRACE] = ACTIONS(4363),
    [anon_sym_AMP_AMP] = ACTIONS(4363),
    [anon_sym_switch] = ACTIONS(4365),
    [anon_sym_LT_EQ] = ACTIONS(4363),
    [anon_sym_LPAREN] = ACTIONS(4363),
    [sym_null] = ACTIONS(4365),
    [anon_sym_GT] = ACTIONS(4365),
    [anon_sym_any] = ACTIONS(4365),
    [anon_sym_boolean] = ACTIONS(4365),
    [anon_sym_async] = ACTIONS(4365),
    [anon_sym_public] = ACTIONS(4365),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_var] = ACTIONS(4365),
    [anon_sym_QMARK] = ACTIONS(4363),
    [anon_sym_PIPE_PIPE] = ACTIONS(4363),
    [anon_sym_while] = ACTIONS(4365),
    [anon_sym_SQUOTE] = ACTIONS(4363),
    [anon_sym_try] = ACTIONS(4365),
    [anon_sym_EQ_EQ] = ACTIONS(4365),
    [anon_sym_RPAREN] = ACTIONS(4363),
    [anon_sym_LT] = ACTIONS(4365),
    [sym_number] = ACTIONS(4363),
    [anon_sym_SLASH] = ACTIONS(4365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4365),
    [anon_sym_function] = ACTIONS(4365),
    [sym_undefined] = ACTIONS(4365),
    [anon_sym_new] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4363),
    [anon_sym_let] = ACTIONS(4365),
    [anon_sym_PLUS] = ACTIONS(4365),
    [anon_sym_export] = ACTIONS(4365),
    [anon_sym_GT_GT] = ACTIONS(4365),
    [anon_sym_do] = ACTIONS(4365),
    [anon_sym_TILDE] = ACTIONS(4363),
    [anon_sym_with] = ACTIONS(4365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4363),
    [anon_sym_in] = ACTIONS(4365),
  },
  [1189] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [sym_identifier] = ACTIONS(1237),
    [sym__automatic_semicolon] = ACTIONS(1239),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_debugger] = ACTIONS(1237),
    [ts_builtin_sym_end] = ACTIONS(1239),
    [anon_sym_symbol] = ACTIONS(1237),
    [anon_sym_AT] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1239),
    [anon_sym_void] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [sym_super] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_get] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1239),
    [anon_sym_interface] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1237),
    [anon_sym_delete] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_this] = ACTIONS(1237),
    [anon_sym_yield] = ACTIONS(1237),
    [sym_true] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_protected] = ACTIONS(1237),
    [anon_sym_abstract] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_set] = ACTIONS(1237),
    [anon_sym_type] = ACTIONS(1237),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_import] = ACTIONS(1237),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1239),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_await] = ACTIONS(1237),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [sym_false] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_module] = ACTIONS(1237),
    [anon_sym_number] = ACTIONS(1237),
    [anon_sym_class] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1237),
    [anon_sym_typeof] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [sym_null] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_any] = ACTIONS(1237),
    [anon_sym_boolean] = ACTIONS(1237),
    [anon_sym_async] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_var] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_try] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1237),
    [sym_number] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1237),
    [anon_sym_function] = ACTIONS(1237),
    [sym_undefined] = ACTIONS(1237),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1239),
    [anon_sym_let] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_export] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_with] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1237),
  },
  [1190] = {
    [sym_array] = STATE(2073),
    [sym_object] = STATE(2074),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(4367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1191] = {
    [anon_sym_of] = ACTIONS(4369),
    [sym_comment] = ACTIONS(3),
  },
  [1192] = {
    [anon_sym_of] = ACTIONS(4371),
    [sym_comment] = ACTIONS(3),
  },
  [1193] = {
    [anon_sym_of] = ACTIONS(4373),
    [sym_comment] = ACTIONS(3),
  },
  [1194] = {
    [sym_new_expression] = STATE(2090),
    [sym_augmented_assignment_expression] = STATE(2090),
    [sym_unary_expression] = STATE(2090),
    [sym_update_expression] = STATE(2090),
    [sym_regex] = STATE(2090),
    [sym_meta_property] = STATE(2090),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2090),
    [sym_yield_expression] = STATE(2090),
    [sym_as_expression] = STATE(2090),
    [sym_non_null_expression] = STATE(2090),
    [sym_internal_module] = STATE(2090),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2090),
    [sym_await_expression] = STATE(2090),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(2092),
    [sym_string] = STATE(2090),
    [sym_this] = STATE(2090),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2090),
    [sym_generator_function] = STATE(2090),
    [sym_call_expression] = STATE(2090),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2090),
    [sym_ternary_expression] = STATE(2090),
    [sym_binary_expression] = STATE(2090),
    [sym_template_string] = STATE(2090),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2090),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2090),
    [sym_class] = STATE(2090),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4379),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(4393),
    [sym_true] = ACTIONS(4379),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4379),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [1195] = {
    [sym_new_expression] = STATE(2108),
    [sym_augmented_assignment_expression] = STATE(2108),
    [sym_unary_expression] = STATE(2108),
    [sym_update_expression] = STATE(2108),
    [sym_regex] = STATE(2108),
    [sym_meta_property] = STATE(2108),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2108),
    [sym_yield_expression] = STATE(2108),
    [sym_as_expression] = STATE(2108),
    [sym_non_null_expression] = STATE(2108),
    [sym_internal_module] = STATE(2108),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2108),
    [sym_await_expression] = STATE(2108),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2108),
    [sym_this] = STATE(2108),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2108),
    [sym_generator_function] = STATE(2108),
    [sym_call_expression] = STATE(2108),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2108),
    [sym_ternary_expression] = STATE(2108),
    [sym_binary_expression] = STATE(2108),
    [sym_template_string] = STATE(2108),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2108),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2108),
    [sym_class] = STATE(2108),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(4407),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4407),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4421),
    [sym_true] = ACTIONS(4407),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4407),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [1196] = {
    [sym__initializer] = STATE(405),
    [sym_type_annotation] = STATE(406),
    [sym__automatic_semicolon] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_of] = ACTIONS(4369),
    [anon_sym_COMMA] = ACTIONS(739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4431),
  },
  [1197] = {
    [sym__initializer] = STATE(425),
    [sym_type_annotation] = STATE(426),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(4371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4433),
  },
  [1198] = {
    [sym__initializer] = STATE(427),
    [sym_type_annotation] = STATE(428),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(4373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4435),
  },
  [1199] = {
    [sym_new_expression] = STATE(2117),
    [sym_augmented_assignment_expression] = STATE(2117),
    [sym_unary_expression] = STATE(2117),
    [sym_update_expression] = STATE(2117),
    [sym_regex] = STATE(2117),
    [sym_meta_property] = STATE(2117),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(2117),
    [sym_yield_expression] = STATE(2117),
    [sym_as_expression] = STATE(2117),
    [sym_non_null_expression] = STATE(2117),
    [sym_internal_module] = STATE(2117),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2117),
    [sym_await_expression] = STATE(2117),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(2118),
    [sym_string] = STATE(2117),
    [sym_this] = STATE(2117),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(2117),
    [sym_generator_function] = STATE(2117),
    [sym_call_expression] = STATE(2117),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(2117),
    [sym_ternary_expression] = STATE(2117),
    [sym_binary_expression] = STATE(2117),
    [sym_template_string] = STATE(2117),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2117),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(2117),
    [sym_class] = STATE(2117),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4437),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4437),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(4439),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4441),
    [sym_true] = ACTIONS(4437),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4437),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1200] = {
    [sym_new_expression] = STATE(2119),
    [sym_augmented_assignment_expression] = STATE(2119),
    [sym_unary_expression] = STATE(2119),
    [sym_update_expression] = STATE(2119),
    [sym_regex] = STATE(2119),
    [sym_meta_property] = STATE(2119),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2119),
    [sym_yield_expression] = STATE(2119),
    [sym_as_expression] = STATE(2119),
    [sym_non_null_expression] = STATE(2119),
    [sym_internal_module] = STATE(2119),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2119),
    [sym_await_expression] = STATE(2119),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2119),
    [sym_this] = STATE(2119),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2119),
    [sym_generator_function] = STATE(2119),
    [sym_call_expression] = STATE(2119),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2119),
    [sym_ternary_expression] = STATE(2119),
    [sym_binary_expression] = STATE(2119),
    [sym_template_string] = STATE(2119),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2119),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2119),
    [sym_class] = STATE(2119),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(4443),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4443),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4445),
    [sym_true] = ACTIONS(4443),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4443),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [1201] = {
    [sym_new_expression] = STATE(2120),
    [sym_augmented_assignment_expression] = STATE(2120),
    [sym_unary_expression] = STATE(2120),
    [sym_update_expression] = STATE(2120),
    [sym_regex] = STATE(2120),
    [sym_meta_property] = STATE(2120),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2120),
    [sym_yield_expression] = STATE(2120),
    [sym_as_expression] = STATE(2120),
    [sym_non_null_expression] = STATE(2120),
    [sym_internal_module] = STATE(2120),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2120),
    [sym_await_expression] = STATE(2120),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(2121),
    [sym_string] = STATE(2120),
    [sym_this] = STATE(2120),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2120),
    [sym_generator_function] = STATE(2120),
    [sym_call_expression] = STATE(2120),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2120),
    [sym_ternary_expression] = STATE(2120),
    [sym_binary_expression] = STATE(2120),
    [sym_template_string] = STATE(2120),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2120),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2120),
    [sym_class] = STATE(2120),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(4447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4447),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(4449),
    [sym_true] = ACTIONS(4447),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4447),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [1202] = {
    [sym_new_expression] = STATE(2122),
    [sym_augmented_assignment_expression] = STATE(2122),
    [sym_unary_expression] = STATE(2122),
    [sym_update_expression] = STATE(2122),
    [sym_regex] = STATE(2122),
    [sym_meta_property] = STATE(2122),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2122),
    [sym_yield_expression] = STATE(2122),
    [sym_as_expression] = STATE(2122),
    [sym_non_null_expression] = STATE(2122),
    [sym_internal_module] = STATE(2122),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2122),
    [sym_await_expression] = STATE(2122),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2122),
    [sym_this] = STATE(2122),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2122),
    [sym_generator_function] = STATE(2122),
    [sym_call_expression] = STATE(2122),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2122),
    [sym_ternary_expression] = STATE(2122),
    [sym_binary_expression] = STATE(2122),
    [sym_template_string] = STATE(2122),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2122),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2122),
    [sym_class] = STATE(2122),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4451),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4453),
    [sym_true] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4451),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [1203] = {
    [sym_new_expression] = STATE(2123),
    [sym_augmented_assignment_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_update_expression] = STATE(2123),
    [sym_regex] = STATE(2123),
    [sym_meta_property] = STATE(2123),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2123),
    [sym_yield_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_non_null_expression] = STATE(2123),
    [sym_internal_module] = STATE(2123),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(2124),
    [sym_string] = STATE(2123),
    [sym_this] = STATE(2123),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2123),
    [sym_generator_function] = STATE(2123),
    [sym_call_expression] = STATE(2123),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_template_string] = STATE(2123),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2123),
    [sym_class] = STATE(2123),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4455),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(4457),
    [sym_true] = ACTIONS(4455),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4455),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [1204] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [anon_sym_BANG] = ACTIONS(2463),
    [anon_sym_BQUOTE] = ACTIONS(2461),
    [anon_sym_else] = ACTIONS(2461),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_LT_LT] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2461),
    [anon_sym_AMP_AMP] = ACTIONS(2461),
    [anon_sym_DASH] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_BANG_EQ] = ACTIONS(2463),
    [anon_sym_LT_EQ] = ACTIONS(2461),
    [anon_sym_LPAREN] = ACTIONS(2461),
    [anon_sym_RBRACK] = ACTIONS(2461),
    [anon_sym_GT_EQ] = ACTIONS(2461),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_EQ] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(2463),
    [anon_sym_PERCENT] = ACTIONS(2461),
    [anon_sym_QMARK] = ACTIONS(2461),
    [anon_sym_RBRACE] = ACTIONS(2461),
    [anon_sym_as] = ACTIONS(2461),
    [anon_sym_PIPE_PIPE] = ACTIONS(2461),
    [anon_sym_while] = ACTIONS(2461),
    [anon_sym_DASH_DASH] = ACTIONS(2461),
    [anon_sym_EQ_EQ] = ACTIONS(2463),
    [anon_sym_instanceof] = ACTIONS(2461),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(2461),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2461),
    [anon_sym_COLON] = ACTIONS(2461),
    [anon_sym_DOT] = ACTIONS(2461),
    [anon_sym_CARET] = ACTIONS(2461),
    [anon_sym_STAR_STAR] = ACTIONS(2461),
    [anon_sym_PLUS] = ACTIONS(2463),
    [anon_sym_implements] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(2461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2461),
    [anon_sym_in] = ACTIONS(2463),
  },
  [1205] = {
    [sym_type_alias_declaration] = STATE(2137),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2137),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2137),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2137),
    [sym_return_statement] = STATE(2137),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_accessibility_modifier] = STATE(218),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2137),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2137),
    [sym_spread_element] = STATE(418),
    [sym_switch_statement] = STATE(2137),
    [sym_string] = STATE(215),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2137),
    [sym_throw_statement] = STATE(2137),
    [aux_sym_program_repeat1] = STATE(2137),
    [sym__property_name] = STATE(221),
    [sym_object] = STATE(222),
    [aux_sym_object_repeat1] = STATE(420),
    [sym_ambient_declaration] = STATE(2137),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2137),
    [sym_decorator] = STATE(2138),
    [sym_continue_statement] = STATE(2137),
    [sym_formal_parameters] = STATE(57),
    [sym_computed_property_name] = STATE(221),
    [sym_function_signature] = STATE(2137),
    [sym_abstract_class] = STATE(2137),
    [sym_interface_declaration] = STATE(2137),
    [sym_statement_block] = STATE(2137),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2137),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2137),
    [sym_method_definition] = STATE(418),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2137),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2137),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2137),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2137),
    [sym_empty_statement] = STATE(2137),
    [sym_pair] = STATE(418),
    [aux_sym_export_statement_repeat1] = STATE(2138),
    [sym_assignment_pattern] = STATE(418),
    [sym_import_alias] = STATE(2137),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2137),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2137),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2137),
    [sym_break_statement] = STATE(2137),
    [sym_labeled_statement] = STATE(2137),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(225),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2137),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(4459),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4461),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(362),
    [anon_sym_void] = ACTIONS(4463),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4465),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_get] = ACTIONS(4467),
    [anon_sym_RBRACE] = ACTIONS(763),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(4465),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(4467),
    [anon_sym_type] = ACTIONS(4469),
    [anon_sym_import] = ACTIONS(4471),
    [anon_sym_namespace] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(386),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(4475),
    [anon_sym_number] = ACTIONS(4461),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4477),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(4461),
    [anon_sym_boolean] = ACTIONS(4461),
    [anon_sym_async] = ACTIONS(4479),
    [anon_sym_public] = ACTIONS(4465),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(398),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4461),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4481),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [1206] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_BANG] = ACTIONS(2047),
    [anon_sym_BQUOTE] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(2047),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2045),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_GT_GT_GT] = ACTIONS(2045),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_BANG_EQ] = ACTIONS(2047),
    [anon_sym_LT_EQ] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(2045),
    [anon_sym_RBRACK] = ACTIONS(2045),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_GT] = ACTIONS(2047),
    [anon_sym_AMP] = ACTIONS(2047),
    [anon_sym_PERCENT] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_as] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2045),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_EQ_EQ] = ACTIONS(2047),
    [anon_sym_instanceof] = ACTIONS(2045),
    [anon_sym_LT] = ACTIONS(2047),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2047),
    [anon_sym_implements] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_in] = ACTIONS(2047),
  },
  [1207] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2045),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [1208] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1209] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [1210] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2055),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [1211] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2063),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_implements] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2063),
  },
  [1212] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(2139),
    [anon_sym_BANG] = ACTIONS(2141),
    [anon_sym_BQUOTE] = ACTIONS(2139),
    [anon_sym_PIPE] = ACTIONS(2141),
    [anon_sym_COMMA] = ACTIONS(2139),
    [anon_sym_LT_LT] = ACTIONS(2139),
    [anon_sym_STAR] = ACTIONS(2141),
    [anon_sym_GT_GT_GT] = ACTIONS(2139),
    [anon_sym_AMP_AMP] = ACTIONS(2139),
    [anon_sym_DASH] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2139),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_RBRACK] = ACTIONS(2139),
    [anon_sym_GT_EQ] = ACTIONS(2139),
    [anon_sym_GT] = ACTIONS(2141),
    [anon_sym_AMP] = ACTIONS(2141),
    [anon_sym_PERCENT] = ACTIONS(2139),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_RBRACE] = ACTIONS(2139),
    [anon_sym_as] = ACTIONS(2139),
    [anon_sym_PIPE_PIPE] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2139),
    [anon_sym_DASH_DASH] = ACTIONS(2139),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_instanceof] = ACTIONS(2139),
    [anon_sym_LT] = ACTIONS(2141),
    [anon_sym_RPAREN] = ACTIONS(2139),
    [anon_sym_SLASH] = ACTIONS(2141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2139),
    [anon_sym_DOT] = ACTIONS(2139),
    [anon_sym_CARET] = ACTIONS(2139),
    [anon_sym_STAR_STAR] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2141),
    [anon_sym_implements] = ACTIONS(2139),
    [anon_sym_GT_GT] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2139),
    [anon_sym_in] = ACTIONS(2141),
  },
  [1213] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_BQUOTE] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_STAR] = ACTIONS(2153),
    [anon_sym_GT_GT_GT] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_LBRACE] = ACTIONS(2153),
    [anon_sym_BANG_EQ] = ACTIONS(2153),
    [anon_sym_LT_EQ] = ACTIONS(2151),
    [anon_sym_LPAREN] = ACTIONS(2151),
    [anon_sym_RBRACK] = ACTIONS(2151),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2153),
    [anon_sym_AMP] = ACTIONS(2153),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_as] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_EQ_EQ] = ACTIONS(2153),
    [anon_sym_instanceof] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [anon_sym_SLASH] = ACTIONS(2153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2151),
    [anon_sym_DOT] = ACTIONS(2151),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_STAR_STAR] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_implements] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2151),
    [anon_sym_in] = ACTIONS(2153),
  },
  [1214] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2151),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [1215] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2155),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [1216] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2159),
    [anon_sym_BQUOTE] = ACTIONS(2157),
    [anon_sym_PERCENT_EQ] = ACTIONS(2157),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2157),
    [anon_sym_AMP_EQ] = ACTIONS(2157),
    [anon_sym_PLUS_EQ] = ACTIONS(2157),
    [anon_sym_PIPE] = ACTIONS(2159),
    [anon_sym_COMMA] = ACTIONS(2157),
    [anon_sym_LT_LT] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_GT_GT_GT] = ACTIONS(2159),
    [anon_sym_EQ] = ACTIONS(2159),
    [anon_sym_AMP_AMP] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_BANG_EQ] = ACTIONS(2159),
    [anon_sym_LT_EQ] = ACTIONS(2157),
    [anon_sym_LPAREN] = ACTIONS(2157),
    [anon_sym_RBRACK] = ACTIONS(2157),
    [anon_sym_GT_EQ] = ACTIONS(2157),
    [anon_sym_GT] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_CARET_EQ] = ACTIONS(2157),
    [anon_sym_STAR_EQ] = ACTIONS(2157),
    [anon_sym_PIPE_EQ] = ACTIONS(2157),
    [anon_sym_DASH_EQ] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_QMARK] = ACTIONS(2157),
    [anon_sym_LT_LT_EQ] = ACTIONS(2157),
    [anon_sym_as] = ACTIONS(2157),
    [anon_sym_PIPE_PIPE] = ACTIONS(2157),
    [anon_sym_RBRACE] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_EQ_EQ] = ACTIONS(2159),
    [anon_sym_instanceof] = ACTIONS(2157),
    [anon_sym_LT] = ACTIONS(2159),
    [anon_sym_RPAREN] = ACTIONS(2157),
    [anon_sym_SLASH] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2157),
    [anon_sym_COLON] = ACTIONS(2157),
    [anon_sym_SLASH_EQ] = ACTIONS(2157),
    [anon_sym_GT_GT_EQ] = ACTIONS(2157),
    [anon_sym_DOT] = ACTIONS(2157),
    [anon_sym_CARET] = ACTIONS(2159),
    [anon_sym_STAR_STAR] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2157),
    [anon_sym_GT_GT] = ACTIONS(2159),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_implements] = ACTIONS(2157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2157),
    [anon_sym_in] = ACTIONS(2159),
  },
  [1217] = {
    [sym_class_body] = STATE(2139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [1218] = {
    [sym_class_heritage] = STATE(2140),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(2139),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [1219] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_BQUOTE] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2757),
    [anon_sym_COMMA] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_GT_GT_GT] = ACTIONS(2755),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_DASH] = ACTIONS(2757),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_BANG_EQ] = ACTIONS(2757),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_LPAREN] = ACTIONS(2755),
    [anon_sym_RBRACK] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_GT] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2757),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_RBRACE] = ACTIONS(2755),
    [anon_sym_as] = ACTIONS(2755),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2757),
    [anon_sym_instanceof] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2757),
    [anon_sym_RPAREN] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
    [anon_sym_COLON] = ACTIONS(2755),
    [anon_sym_DOT] = ACTIONS(2755),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2757),
    [anon_sym_implements] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2755),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2755),
    [anon_sym_in] = ACTIONS(2757),
  },
  [1220] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_BANG] = ACTIONS(2805),
    [anon_sym_BQUOTE] = ACTIONS(2803),
    [anon_sym_else] = ACTIONS(2803),
    [anon_sym_PIPE] = ACTIONS(2805),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_LT_LT] = ACTIONS(2803),
    [anon_sym_STAR] = ACTIONS(2805),
    [anon_sym_GT_GT_GT] = ACTIONS(2803),
    [anon_sym_AMP_AMP] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2805),
    [anon_sym_BANG_EQ] = ACTIONS(2805),
    [anon_sym_LT_EQ] = ACTIONS(2803),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [anon_sym_RBRACK] = ACTIONS(2803),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_GT] = ACTIONS(2805),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_PERCENT] = ACTIONS(2803),
    [anon_sym_QMARK] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_as] = ACTIONS(2803),
    [anon_sym_PIPE_PIPE] = ACTIONS(2803),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2803),
    [anon_sym_DASH_DASH] = ACTIONS(2803),
    [anon_sym_EQ_EQ] = ACTIONS(2805),
    [anon_sym_instanceof] = ACTIONS(2803),
    [anon_sym_LT] = ACTIONS(2805),
    [anon_sym_RPAREN] = ACTIONS(2803),
    [anon_sym_SLASH] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(2803),
    [anon_sym_COLON] = ACTIONS(2803),
    [anon_sym_DOT] = ACTIONS(2803),
    [anon_sym_CARET] = ACTIONS(2803),
    [anon_sym_STAR_STAR] = ACTIONS(2803),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_implements] = ACTIONS(2803),
    [anon_sym_GT_GT] = ACTIONS(2805),
    [anon_sym_PLUS_PLUS] = ACTIONS(2803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2803),
    [anon_sym_in] = ACTIONS(2805),
  },
  [1221] = {
    [sym_public_field_definition] = STATE(630),
    [sym__property_name] = STATE(631),
    [sym_decorator] = STATE(1375),
    [sym_method_signature] = STATE(630),
    [sym_accessibility_modifier] = STATE(632),
    [sym_abstract_method_signature] = STATE(630),
    [sym_computed_property_name] = STATE(631),
    [aux_sym_class_body_repeat1] = STATE(1375),
    [sym_index_signature] = STATE(630),
    [sym_string] = STATE(631),
    [sym_method_definition] = STATE(634),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1129),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(4483),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_abstract] = ACTIONS(1139),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1222] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_STAR] = ACTIONS(2843),
    [anon_sym_GT_GT_GT] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_LT_EQ] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2841),
    [anon_sym_RBRACK] = ACTIONS(2841),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2843),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2841),
    [anon_sym_QMARK] = ACTIONS(2841),
    [anon_sym_RBRACE] = ACTIONS(2841),
    [anon_sym_as] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2843),
    [anon_sym_instanceof] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2843),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2841),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2841),
    [anon_sym_STAR_STAR] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_implements] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2843),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2841),
    [anon_sym_in] = ACTIONS(2843),
  },
  [1223] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [anon_sym_PIPE] = ACTIONS(3158),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_LT_LT] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3158),
    [anon_sym_GT_GT_GT] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3156),
    [anon_sym_RBRACK] = ACTIONS(3156),
    [anon_sym_GT_EQ] = ACTIONS(3156),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_PERCENT] = ACTIONS(3156),
    [anon_sym_QMARK] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_as] = ACTIONS(3156),
    [anon_sym_PIPE_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_EQ_EQ] = ACTIONS(3158),
    [anon_sym_instanceof] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3156),
    [anon_sym_DOT] = ACTIONS(3156),
    [anon_sym_CARET] = ACTIONS(3156),
    [anon_sym_STAR_STAR] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_implements] = ACTIONS(3156),
    [anon_sym_GT_GT] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3156),
    [anon_sym_in] = ACTIONS(3158),
  },
  [1224] = {
    [anon_sym_RPAREN] = ACTIONS(4485),
    [sym_comment] = ACTIONS(3),
  },
  [1225] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(4487),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1226] = {
    [anon_sym_RBRACK] = ACTIONS(4487),
    [sym_comment] = ACTIONS(3),
  },
  [1227] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2333),
    [anon_sym_LBRACK] = ACTIONS(2333),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_BQUOTE] = ACTIONS(2333),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_COMMA] = ACTIONS(2333),
    [anon_sym_LT_LT] = ACTIONS(2333),
    [anon_sym_STAR] = ACTIONS(2335),
    [anon_sym_GT_GT_GT] = ACTIONS(2333),
    [anon_sym_AMP_AMP] = ACTIONS(2333),
    [anon_sym_DASH] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(2335),
    [anon_sym_LT_EQ] = ACTIONS(2333),
    [anon_sym_LPAREN] = ACTIONS(2333),
    [anon_sym_RBRACK] = ACTIONS(2333),
    [anon_sym_GT_EQ] = ACTIONS(2333),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_AMP] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2333),
    [anon_sym_QMARK] = ACTIONS(2333),
    [anon_sym_RBRACE] = ACTIONS(2333),
    [anon_sym_as] = ACTIONS(2333),
    [anon_sym_PIPE_PIPE] = ACTIONS(2333),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2333),
    [anon_sym_DASH_DASH] = ACTIONS(2333),
    [anon_sym_EQ_EQ] = ACTIONS(2335),
    [anon_sym_instanceof] = ACTIONS(2333),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_RPAREN] = ACTIONS(2333),
    [anon_sym_SLASH] = ACTIONS(2335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2333),
    [anon_sym_DOT] = ACTIONS(2333),
    [anon_sym_CARET] = ACTIONS(2333),
    [anon_sym_STAR_STAR] = ACTIONS(2333),
    [anon_sym_PLUS] = ACTIONS(2335),
    [anon_sym_implements] = ACTIONS(2333),
    [anon_sym_GT_GT] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(2333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2333),
    [anon_sym_in] = ACTIONS(2335),
  },
  [1228] = {
    [sym_new_expression] = STATE(2145),
    [sym_augmented_assignment_expression] = STATE(2145),
    [sym_unary_expression] = STATE(2145),
    [sym_update_expression] = STATE(2145),
    [sym_regex] = STATE(2145),
    [sym_meta_property] = STATE(2145),
    [sym_call_signature] = STATE(158),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(2145),
    [sym_yield_expression] = STATE(2145),
    [sym_as_expression] = STATE(2145),
    [sym_non_null_expression] = STATE(2145),
    [sym_internal_module] = STATE(2145),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2145),
    [sym_await_expression] = STATE(2145),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(2145),
    [sym_this] = STATE(2145),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(2145),
    [sym_generator_function] = STATE(2145),
    [sym_call_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(2145),
    [sym_ternary_expression] = STATE(2145),
    [sym_binary_expression] = STATE(2145),
    [sym_template_string] = STATE(2145),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(2145),
    [sym_class] = STATE(2145),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(4489),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4489),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4491),
    [sym_true] = ACTIONS(4489),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4489),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1229] = {
    [sym_new_expression] = STATE(2147),
    [sym_augmented_assignment_expression] = STATE(2147),
    [sym_unary_expression] = STATE(2147),
    [sym_update_expression] = STATE(2147),
    [sym_regex] = STATE(2147),
    [sym_meta_property] = STATE(2147),
    [sym_call_signature] = STATE(158),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(2147),
    [sym_yield_expression] = STATE(2147),
    [sym_as_expression] = STATE(2147),
    [sym_non_null_expression] = STATE(2147),
    [sym_internal_module] = STATE(2147),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2147),
    [sym_await_expression] = STATE(2147),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(2147),
    [sym_this] = STATE(2147),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(2147),
    [sym_generator_function] = STATE(2147),
    [sym_call_expression] = STATE(2147),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(2147),
    [sym_ternary_expression] = STATE(2147),
    [sym_binary_expression] = STATE(2147),
    [sym_template_string] = STATE(2147),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2147),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(2147),
    [sym_class] = STATE(2147),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4493),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4495),
    [sym_true] = ACTIONS(4493),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4493),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1230] = {
    [sym_call_signature] = STATE(2148),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1231] = {
    [sym_statement_block] = STATE(2149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2547),
  },
  [1232] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3492),
    [anon_sym_LBRACK] = ACTIONS(3492),
    [anon_sym_BANG] = ACTIONS(3494),
    [anon_sym_BQUOTE] = ACTIONS(3492),
    [anon_sym_PIPE] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_LT_LT] = ACTIONS(3492),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_GT_GT_GT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3492),
    [anon_sym_RBRACK] = ACTIONS(3492),
    [anon_sym_GT_EQ] = ACTIONS(3492),
    [anon_sym_GT] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_QMARK] = ACTIONS(3492),
    [anon_sym_RBRACE] = ACTIONS(3492),
    [anon_sym_as] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_EQ_EQ] = ACTIONS(3494),
    [anon_sym_instanceof] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3494),
    [anon_sym_RPAREN] = ACTIONS(3492),
    [anon_sym_SLASH] = ACTIONS(3494),
    [sym_comment] = ACTIONS(3),
    [sym_regex_flags] = ACTIONS(4497),
    [anon_sym_COLON] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(3492),
    [anon_sym_CARET] = ACTIONS(3492),
    [anon_sym_STAR_STAR] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_GT_GT] = ACTIONS(3494),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3492),
    [anon_sym_in] = ACTIONS(3494),
  },
  [1233] = {
    [sym_call_signature] = STATE(2151),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1234] = {
    [sym_statement_block] = STATE(2152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2547),
  },
  [1235] = {
    [sym_type_alias_declaration] = STATE(2137),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2137),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2137),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2137),
    [sym_return_statement] = STATE(2137),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2137),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2137),
    [sym_switch_statement] = STATE(2137),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2137),
    [sym_throw_statement] = STATE(2137),
    [aux_sym_program_repeat1] = STATE(2137),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2137),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2137),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(2137),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2137),
    [sym_abstract_class] = STATE(2137),
    [sym_interface_declaration] = STATE(2137),
    [sym_statement_block] = STATE(2137),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2137),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2137),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2137),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2137),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2137),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2137),
    [sym_empty_statement] = STATE(2137),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(2137),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2137),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2137),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2137),
    [sym_break_statement] = STATE(2137),
    [sym_labeled_statement] = STATE(2137),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2137),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4499),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [1236] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [anon_sym_BANG] = ACTIONS(3504),
    [anon_sym_BQUOTE] = ACTIONS(3502),
    [anon_sym_else] = ACTIONS(3502),
    [anon_sym_PIPE] = ACTIONS(3504),
    [anon_sym_COMMA] = ACTIONS(3502),
    [anon_sym_LT_LT] = ACTIONS(3502),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_GT_GT_GT] = ACTIONS(3502),
    [anon_sym_AMP_AMP] = ACTIONS(3502),
    [anon_sym_DASH] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3502),
    [anon_sym_LPAREN] = ACTIONS(3502),
    [anon_sym_RBRACK] = ACTIONS(3502),
    [anon_sym_GT_EQ] = ACTIONS(3502),
    [anon_sym_GT] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3502),
    [anon_sym_QMARK] = ACTIONS(3502),
    [anon_sym_RBRACE] = ACTIONS(3502),
    [anon_sym_as] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE] = ACTIONS(3502),
    [anon_sym_while] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3502),
    [anon_sym_EQ_EQ] = ACTIONS(3504),
    [anon_sym_instanceof] = ACTIONS(3502),
    [anon_sym_LT] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [anon_sym_SLASH] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(3502),
    [anon_sym_DOT] = ACTIONS(3502),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_STAR_STAR] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3504),
    [anon_sym_implements] = ACTIONS(3502),
    [anon_sym_GT_GT] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3502),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3502),
    [anon_sym_in] = ACTIONS(3504),
  },
  [1237] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3520),
    [anon_sym_LBRACK] = ACTIONS(3520),
    [anon_sym_BANG] = ACTIONS(3522),
    [anon_sym_BQUOTE] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3522),
    [anon_sym_COMMA] = ACTIONS(3520),
    [anon_sym_LT_LT] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3522),
    [anon_sym_GT_GT_GT] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LBRACE] = ACTIONS(3522),
    [anon_sym_BANG_EQ] = ACTIONS(3522),
    [anon_sym_LT_EQ] = ACTIONS(3520),
    [anon_sym_LPAREN] = ACTIONS(3520),
    [anon_sym_RBRACK] = ACTIONS(3520),
    [anon_sym_GT_EQ] = ACTIONS(3520),
    [anon_sym_GT] = ACTIONS(3522),
    [anon_sym_AMP] = ACTIONS(3522),
    [anon_sym_PERCENT] = ACTIONS(3520),
    [anon_sym_QMARK] = ACTIONS(3520),
    [anon_sym_RBRACE] = ACTIONS(3520),
    [anon_sym_as] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3520),
    [anon_sym_DASH_DASH] = ACTIONS(3520),
    [anon_sym_EQ_EQ] = ACTIONS(3522),
    [anon_sym_instanceof] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(3522),
    [anon_sym_RPAREN] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3520),
    [anon_sym_DOT] = ACTIONS(3520),
    [anon_sym_CARET] = ACTIONS(3520),
    [anon_sym_STAR_STAR] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_implements] = ACTIONS(3520),
    [anon_sym_GT_GT] = ACTIONS(3522),
    [anon_sym_PLUS_PLUS] = ACTIONS(3520),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3520),
    [anon_sym_in] = ACTIONS(3522),
  },
  [1238] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3524),
    [anon_sym_LBRACK] = ACTIONS(3524),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_BQUOTE] = ACTIONS(3524),
    [anon_sym_PIPE] = ACTIONS(3526),
    [anon_sym_COMMA] = ACTIONS(3524),
    [anon_sym_LT_LT] = ACTIONS(3524),
    [anon_sym_STAR] = ACTIONS(3526),
    [anon_sym_GT_GT_GT] = ACTIONS(3524),
    [anon_sym_AMP_AMP] = ACTIONS(3524),
    [anon_sym_DASH] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(3526),
    [anon_sym_BANG_EQ] = ACTIONS(3526),
    [anon_sym_LT_EQ] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(3524),
    [anon_sym_RBRACK] = ACTIONS(3524),
    [anon_sym_GT_EQ] = ACTIONS(3524),
    [anon_sym_GT] = ACTIONS(3526),
    [anon_sym_AMP] = ACTIONS(3526),
    [anon_sym_PERCENT] = ACTIONS(3524),
    [anon_sym_QMARK] = ACTIONS(3524),
    [anon_sym_RBRACE] = ACTIONS(3524),
    [anon_sym_as] = ACTIONS(3524),
    [anon_sym_PIPE_PIPE] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3524),
    [anon_sym_DASH_DASH] = ACTIONS(3524),
    [anon_sym_EQ_EQ] = ACTIONS(3526),
    [anon_sym_instanceof] = ACTIONS(3524),
    [anon_sym_LT] = ACTIONS(3526),
    [anon_sym_RPAREN] = ACTIONS(3524),
    [anon_sym_SLASH] = ACTIONS(3526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3524),
    [anon_sym_DOT] = ACTIONS(3524),
    [anon_sym_CARET] = ACTIONS(3524),
    [anon_sym_STAR_STAR] = ACTIONS(3524),
    [anon_sym_PLUS] = ACTIONS(3526),
    [anon_sym_implements] = ACTIONS(3524),
    [anon_sym_GT_GT] = ACTIONS(3526),
    [anon_sym_PLUS_PLUS] = ACTIONS(3524),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3524),
    [anon_sym_in] = ACTIONS(3526),
  },
  [1239] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3528),
    [anon_sym_LBRACK] = ACTIONS(3528),
    [anon_sym_BANG] = ACTIONS(3530),
    [anon_sym_BQUOTE] = ACTIONS(3528),
    [anon_sym_PIPE] = ACTIONS(3530),
    [anon_sym_COMMA] = ACTIONS(3528),
    [anon_sym_LT_LT] = ACTIONS(3528),
    [anon_sym_STAR] = ACTIONS(3530),
    [anon_sym_GT_GT_GT] = ACTIONS(3528),
    [anon_sym_AMP_AMP] = ACTIONS(3528),
    [anon_sym_DASH] = ACTIONS(3530),
    [anon_sym_LBRACE] = ACTIONS(3530),
    [anon_sym_BANG_EQ] = ACTIONS(3530),
    [anon_sym_LT_EQ] = ACTIONS(3528),
    [anon_sym_LPAREN] = ACTIONS(3528),
    [anon_sym_RBRACK] = ACTIONS(3528),
    [anon_sym_GT_EQ] = ACTIONS(3528),
    [anon_sym_GT] = ACTIONS(3530),
    [anon_sym_AMP] = ACTIONS(3530),
    [anon_sym_PERCENT] = ACTIONS(3528),
    [anon_sym_QMARK] = ACTIONS(3528),
    [anon_sym_RBRACE] = ACTIONS(3528),
    [anon_sym_as] = ACTIONS(3528),
    [anon_sym_PIPE_PIPE] = ACTIONS(3528),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3528),
    [anon_sym_DASH_DASH] = ACTIONS(3528),
    [anon_sym_EQ_EQ] = ACTIONS(3530),
    [anon_sym_instanceof] = ACTIONS(3528),
    [anon_sym_LT] = ACTIONS(3530),
    [anon_sym_RPAREN] = ACTIONS(3528),
    [anon_sym_SLASH] = ACTIONS(3530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3528),
    [anon_sym_DOT] = ACTIONS(3528),
    [anon_sym_CARET] = ACTIONS(3528),
    [anon_sym_STAR_STAR] = ACTIONS(3528),
    [anon_sym_PLUS] = ACTIONS(3530),
    [anon_sym_implements] = ACTIONS(3528),
    [anon_sym_GT_GT] = ACTIONS(3530),
    [anon_sym_PLUS_PLUS] = ACTIONS(3528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3528),
    [anon_sym_in] = ACTIONS(3530),
  },
  [1240] = {
    [sym_identifier] = ACTIONS(4501),
    [sym_comment] = ACTIONS(3),
  },
  [1241] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2459),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_COMMA] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_GT_GT_GT] = ACTIONS(2457),
    [anon_sym_AMP_AMP] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2459),
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_BANG_EQ] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [anon_sym_RBRACK] = ACTIONS(2457),
    [anon_sym_GT_EQ] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2459),
    [anon_sym_PERCENT] = ACTIONS(2457),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_as] = ACTIONS(2457),
    [anon_sym_PIPE_PIPE] = ACTIONS(2457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_EQ_EQ] = ACTIONS(2459),
    [anon_sym_instanceof] = ACTIONS(2457),
    [anon_sym_LT] = ACTIONS(2459),
    [anon_sym_RPAREN] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2457),
    [anon_sym_DOT] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2457),
    [anon_sym_STAR_STAR] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2459),
    [anon_sym_implements] = ACTIONS(2457),
    [anon_sym_GT_GT] = ACTIONS(2459),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2457),
    [anon_sym_in] = ACTIONS(2459),
  },
  [1242] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [1243] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(4503),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1244] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(4503),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1245] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [1246] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4506),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1247] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_is] = ACTIONS(4511),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_RBRACK] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(4518),
  },
  [1248] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_BQUOTE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1492),
    [anon_sym_LT_LT] = ACTIONS(1492),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_GT_GT_GT] = ACTIONS(1492),
    [anon_sym_AMP_AMP] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_BANG_EQ] = ACTIONS(1490),
    [anon_sym_LT_EQ] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_RBRACK] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1490),
    [anon_sym_AMP] = ACTIONS(1490),
    [anon_sym_PERCENT] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1492),
    [anon_sym_RBRACE] = ACTIONS(1492),
    [anon_sym_as] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1492),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1492),
    [anon_sym_DASH_DASH] = ACTIONS(1492),
    [anon_sym_EQ_EQ] = ACTIONS(1490),
    [anon_sym_instanceof] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOT] = ACTIONS(1492),
    [anon_sym_CARET] = ACTIONS(1492),
    [anon_sym_STAR_STAR] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1490),
    [anon_sym_implements] = ACTIONS(1492),
    [anon_sym_GT_GT] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1492),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1492),
    [anon_sym_in] = ACTIONS(1490),
  },
  [1249] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1250] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2168),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2168),
    [sym_call_signature] = STATE(2168),
    [sym_export_statement] = STATE(2168),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2168),
    [sym_index_signature] = STATE(2168),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(4523),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(4525),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1251] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(2169),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1252] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1530),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1530),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_STAR] = ACTIONS(1530),
    [anon_sym_GT_GT_GT] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_BANG_EQ] = ACTIONS(1530),
    [anon_sym_LT_EQ] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [anon_sym_GT_EQ] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1530),
    [anon_sym_PERCENT] = ACTIONS(1532),
    [anon_sym_QMARK] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_as] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1532),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1530),
    [anon_sym_instanceof] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1530),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_SLASH] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1532),
    [anon_sym_CARET] = ACTIONS(1532),
    [anon_sym_STAR_STAR] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_implements] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1532),
    [anon_sym_in] = ACTIONS(1530),
  },
  [1253] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1254] = {
    [sym_nested_identifier] = STATE(2171),
    [sym_identifier] = ACTIONS(4527),
    [sym_comment] = ACTIONS(3),
  },
  [1255] = {
    [sym_nested_type_identifier] = STATE(2173),
    [sym_nested_identifier] = STATE(1265),
    [sym_identifier] = ACTIONS(4529),
    [sym_comment] = ACTIONS(3),
  },
  [1256] = {
    [sym_number] = ACTIONS(4531),
    [sym_comment] = ACTIONS(3),
  },
  [1257] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [anon_sym_BANG] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_COMMA] = ACTIONS(1544),
    [anon_sym_LT_LT] = ACTIONS(1544),
    [anon_sym_STAR] = ACTIONS(1542),
    [anon_sym_GT_GT_GT] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_PERCENT] = ACTIONS(1544),
    [anon_sym_QMARK] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_as] = ACTIONS(1544),
    [anon_sym_PIPE_PIPE] = ACTIONS(1544),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1544),
    [anon_sym_DASH_DASH] = ACTIONS(1544),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_instanceof] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1544),
    [anon_sym_DOT] = ACTIONS(1544),
    [anon_sym_CARET] = ACTIONS(1544),
    [anon_sym_STAR_STAR] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_implements] = ACTIONS(1544),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_PLUS_PLUS] = ACTIONS(1544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1544),
    [anon_sym_in] = ACTIONS(1542),
  },
  [1258] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_BANG] = ACTIONS(1534),
    [anon_sym_BQUOTE] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1536),
    [anon_sym_STAR] = ACTIONS(1534),
    [anon_sym_GT_GT_GT] = ACTIONS(1536),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_DASH] = ACTIONS(1534),
    [anon_sym_LBRACE] = ACTIONS(1534),
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1534),
    [anon_sym_PERCENT] = ACTIONS(1536),
    [anon_sym_QMARK] = ACTIONS(1536),
    [anon_sym_RBRACE] = ACTIONS(1536),
    [anon_sym_as] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_DASH_DASH] = ACTIONS(1536),
    [anon_sym_EQ_EQ] = ACTIONS(1534),
    [anon_sym_instanceof] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1536),
    [anon_sym_SLASH] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1536),
    [anon_sym_DOT] = ACTIONS(1536),
    [anon_sym_CARET] = ACTIONS(1536),
    [anon_sym_STAR_STAR] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1534),
    [anon_sym_implements] = ACTIONS(1536),
    [anon_sym_GT_GT] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1536),
    [anon_sym_in] = ACTIONS(1534),
  },
  [1259] = {
    [sym_formal_parameters] = STATE(2175),
    [sym_type_parameters] = STATE(2176),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1260] = {
    [sym__type] = STATE(2177),
    [sym_constructor_type] = STATE(2177),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_function_type] = STATE(2177),
    [sym_rest_parameter] = STATE(243),
    [sym_nested_identifier] = STATE(283),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(243),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(265),
    [sym_type_parameters] = STATE(838),
    [sym_this] = STATE(762),
    [sym_predefined_type] = STATE(284),
    [sym_tuple_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(771),
    [sym_object] = STATE(759),
    [sym_nested_type_identifier] = STATE(839),
    [sym_optional_parameter] = STATE(243),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(771),
    [sym_union_type] = STATE(2177),
    [sym_intersection_type] = STATE(2177),
    [sym_formal_parameters] = STATE(840),
    [sym_array] = STATE(761),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [sym_identifier] = ACTIONS(1550),
    [sym_false] = ACTIONS(462),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1552),
    [anon_sym_number] = ACTIONS(1552),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_void] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_any] = ACTIONS(1552),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1552),
    [anon_sym_async] = ACTIONS(1426),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_this] = ACTIONS(1562),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_string] = ACTIONS(1552),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [1261] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1262] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3858),
    [anon_sym_LBRACK] = ACTIONS(3858),
    [anon_sym_BANG] = ACTIONS(3860),
    [anon_sym_BQUOTE] = ACTIONS(3858),
    [anon_sym_PIPE] = ACTIONS(3860),
    [anon_sym_COMMA] = ACTIONS(3858),
    [anon_sym_LT_LT] = ACTIONS(3858),
    [anon_sym_STAR] = ACTIONS(3860),
    [anon_sym_GT_GT_GT] = ACTIONS(3858),
    [anon_sym_AMP_AMP] = ACTIONS(3858),
    [anon_sym_DASH] = ACTIONS(3860),
    [anon_sym_LBRACE] = ACTIONS(3860),
    [anon_sym_BANG_EQ] = ACTIONS(3860),
    [anon_sym_LT_EQ] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3858),
    [anon_sym_RBRACK] = ACTIONS(3858),
    [anon_sym_GT_EQ] = ACTIONS(3858),
    [anon_sym_GT] = ACTIONS(3860),
    [anon_sym_AMP] = ACTIONS(3860),
    [anon_sym_PERCENT] = ACTIONS(3858),
    [anon_sym_QMARK] = ACTIONS(3858),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_as] = ACTIONS(3858),
    [anon_sym_PIPE_PIPE] = ACTIONS(3858),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3858),
    [anon_sym_DASH_DASH] = ACTIONS(3858),
    [anon_sym_EQ_EQ] = ACTIONS(3860),
    [anon_sym_instanceof] = ACTIONS(3858),
    [anon_sym_LT] = ACTIONS(3860),
    [anon_sym_RPAREN] = ACTIONS(3858),
    [anon_sym_SLASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3858),
    [anon_sym_DOT] = ACTIONS(3858),
    [anon_sym_CARET] = ACTIONS(3858),
    [anon_sym_STAR_STAR] = ACTIONS(3858),
    [anon_sym_PLUS] = ACTIONS(3860),
    [anon_sym_implements] = ACTIONS(3858),
    [anon_sym_GT_GT] = ACTIONS(3860),
    [anon_sym_PLUS_PLUS] = ACTIONS(3858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3858),
    [anon_sym_in] = ACTIONS(3860),
  },
  [1263] = {
    [sym_formal_parameters] = STATE(2181),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1264] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_RBRACK] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(4539),
  },
  [1265] = {
    [anon_sym_DOT] = ACTIONS(4516),
    [sym_comment] = ACTIONS(3),
  },
  [1266] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3858),
    [anon_sym_LBRACK] = ACTIONS(3858),
    [anon_sym_BANG] = ACTIONS(3860),
    [anon_sym_BQUOTE] = ACTIONS(3858),
    [anon_sym_PIPE] = ACTIONS(3860),
    [anon_sym_COMMA] = ACTIONS(3858),
    [anon_sym_LT_LT] = ACTIONS(3858),
    [anon_sym_STAR] = ACTIONS(3860),
    [anon_sym_GT_GT_GT] = ACTIONS(3858),
    [anon_sym_AMP_AMP] = ACTIONS(3858),
    [anon_sym_DASH] = ACTIONS(3860),
    [anon_sym_LBRACE] = ACTIONS(3860),
    [anon_sym_BANG_EQ] = ACTIONS(3860),
    [anon_sym_LT_EQ] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3858),
    [anon_sym_RBRACK] = ACTIONS(3858),
    [anon_sym_GT_EQ] = ACTIONS(3858),
    [anon_sym_GT] = ACTIONS(3860),
    [anon_sym_AMP] = ACTIONS(3860),
    [anon_sym_PERCENT] = ACTIONS(3858),
    [anon_sym_QMARK] = ACTIONS(3858),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_as] = ACTIONS(3858),
    [anon_sym_PIPE_PIPE] = ACTIONS(3858),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3858),
    [anon_sym_DASH_DASH] = ACTIONS(3858),
    [anon_sym_EQ_EQ] = ACTIONS(3860),
    [anon_sym_instanceof] = ACTIONS(3858),
    [anon_sym_LT] = ACTIONS(3860),
    [anon_sym_RPAREN] = ACTIONS(3858),
    [anon_sym_SLASH] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3858),
    [anon_sym_DOT] = ACTIONS(3858),
    [anon_sym_CARET] = ACTIONS(3858),
    [anon_sym_STAR_STAR] = ACTIONS(3858),
    [anon_sym_PLUS] = ACTIONS(3860),
    [anon_sym_implements] = ACTIONS(3858),
    [anon_sym_GT_GT] = ACTIONS(3860),
    [anon_sym_PLUS_PLUS] = ACTIONS(3858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3858),
    [anon_sym_in] = ACTIONS(3860),
  },
  [1267] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1587),
    [anon_sym_LBRACK] = ACTIONS(4542),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_BQUOTE] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(1585),
    [anon_sym_GT_GT_GT] = ACTIONS(1587),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_BANG_EQ] = ACTIONS(1585),
    [anon_sym_LT_EQ] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_RBRACK] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1587),
    [anon_sym_GT] = ACTIONS(1585),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_QMARK] = ACTIONS(1587),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_as] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_EQ_EQ] = ACTIONS(1585),
    [anon_sym_instanceof] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1585),
    [anon_sym_RPAREN] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1587),
    [anon_sym_DOT] = ACTIONS(1587),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_STAR_STAR] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_implements] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1585),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1587),
    [anon_sym_in] = ACTIONS(1585),
  },
  [1268] = {
    [anon_sym_EQ_GT] = ACTIONS(4544),
    [sym_comment] = ACTIONS(3),
  },
  [1269] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_AMP_EQ] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_CARET_EQ] = ACTIONS(929),
    [anon_sym_STAR_EQ] = ACTIONS(929),
    [anon_sym_PIPE_EQ] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
    [anon_sym_EQ_GT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4548),
  },
  [1270] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3894),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1271] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1272] = {
    [sym_new_expression] = STATE(528),
    [sym_augmented_assignment_expression] = STATE(528),
    [sym_unary_expression] = STATE(528),
    [sym_update_expression] = STATE(528),
    [sym_regex] = STATE(528),
    [sym_meta_property] = STATE(528),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(528),
    [sym_yield_expression] = STATE(528),
    [sym_as_expression] = STATE(528),
    [sym_non_null_expression] = STATE(528),
    [sym_internal_module] = STATE(528),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(528),
    [sym_await_expression] = STATE(528),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(528),
    [sym_this] = STATE(528),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(528),
    [sym_generator_function] = STATE(528),
    [sym_call_expression] = STATE(528),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(528),
    [sym_ternary_expression] = STATE(528),
    [sym_binary_expression] = STATE(528),
    [sym_template_string] = STATE(528),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(528),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(528),
    [sym_class] = STATE(528),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(4550),
    [sym_false] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(953),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(955),
    [sym_true] = ACTIONS(953),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1273] = {
    [sym_new_expression] = STATE(529),
    [sym_augmented_assignment_expression] = STATE(529),
    [sym_unary_expression] = STATE(529),
    [sym_update_expression] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_meta_property] = STATE(529),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(529),
    [sym_yield_expression] = STATE(529),
    [sym_as_expression] = STATE(529),
    [sym_non_null_expression] = STATE(529),
    [sym_internal_module] = STATE(529),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(529),
    [sym_await_expression] = STATE(529),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(529),
    [sym_this] = STATE(529),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(529),
    [sym_generator_function] = STATE(529),
    [sym_call_expression] = STATE(529),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(529),
    [sym_ternary_expression] = STATE(529),
    [sym_binary_expression] = STATE(529),
    [sym_template_string] = STATE(529),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(529),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(529),
    [sym_class] = STATE(529),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(957),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(957),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(957),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1274] = {
    [sym_pair] = STATE(418),
    [aux_sym_export_statement_repeat1] = STATE(1661),
    [sym_object] = STATE(397),
    [sym__property_name] = STATE(1662),
    [aux_sym_object_repeat1] = STATE(420),
    [sym_assignment_pattern] = STATE(418),
    [sym_method_signature] = STATE(810),
    [sym_property_signature] = STATE(810),
    [sym_call_signature] = STATE(810),
    [sym_construct_signature] = STATE(810),
    [sym_export_statement] = STATE(810),
    [sym_method_definition] = STATE(418),
    [sym_index_signature] = STATE(810),
    [sym_decorator] = STATE(1661),
    [sym_accessibility_modifier] = STATE(1663),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(1662),
    [sym_array] = STATE(399),
    [sym_spread_element] = STATE(418),
    [sym_string] = STATE(1662),
    [sym_type_parameters] = STATE(811),
    [sym_identifier] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(3429),
    [anon_sym_symbol] = ACTIONS(3429),
    [anon_sym_number] = ACTIONS(3429),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(3429),
    [anon_sym_COMMA] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_boolean] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_get] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(763),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_string] = ACTIONS(3429),
    [anon_sym_set] = ACTIONS(3441),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(3429),
    [anon_sym_export] = ACTIONS(3447),
    [sym_readonly] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1275] = {
    [sym_new_expression] = STATE(528),
    [sym_augmented_assignment_expression] = STATE(528),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(528),
    [sym_update_expression] = STATE(528),
    [sym_regex] = STATE(528),
    [sym_meta_property] = STATE(528),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(528),
    [sym_yield_expression] = STATE(528),
    [sym_as_expression] = STATE(528),
    [sym_non_null_expression] = STATE(528),
    [sym_internal_module] = STATE(528),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(528),
    [sym_await_expression] = STATE(528),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(528),
    [sym_this] = STATE(528),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(528),
    [sym_generator_function] = STATE(528),
    [sym_call_expression] = STATE(528),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(528),
    [sym_ternary_expression] = STATE(528),
    [sym_binary_expression] = STATE(528),
    [sym_template_string] = STATE(528),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(528),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(528),
    [sym_class] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(953),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(953),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(955),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1276] = {
    [sym_new_expression] = STATE(533),
    [sym_constructor_type] = STATE(837),
    [sym_augmented_assignment_expression] = STATE(533),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(533),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(533),
    [sym_call_signature] = STATE(242),
    [sym_rest_parameter] = STATE(243),
    [sym_yield_expression] = STATE(533),
    [sym_as_expression] = STATE(533),
    [sym_internal_module] = STATE(533),
    [sym_accessibility_modifier] = STATE(246),
    [sym_arrow_function] = STATE(533),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(245),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1885),
    [sym_type_parameters] = STATE(1888),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(250),
    [sym_nested_type_identifier] = STATE(839),
    [sym_generator_function] = STATE(533),
    [sym_subscript_expression] = STATE(245),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(533),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(533),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(249),
    [sym_formal_parameters] = STATE(1889),
    [sym_intersection_type] = STATE(837),
    [sym__type] = STATE(837),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(533),
    [sym_meta_property] = STATE(533),
    [sym_function_type] = STATE(837),
    [sym__expression] = STATE(533),
    [sym_non_null_expression] = STATE(533),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_required_parameter] = STATE(243),
    [sym_await_expression] = STATE(533),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_sequence_expression] = STATE(534),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(248),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(249),
    [sym_anonymous_class] = STATE(533),
    [sym_optional_parameter] = STATE(243),
    [sym_call_expression] = STATE(533),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(533),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(533),
    [sym_type_arguments] = STATE(251),
    [sym_union_type] = STATE(837),
    [sym_parenthesized_expression] = STATE(533),
    [sym_array] = STATE(252),
    [sym_type_assertion] = STATE(533),
    [sym_class] = STATE(533),
    [sym_identifier] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3921),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(3925),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(422),
    [anon_sym_get] = ACTIONS(412),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(430),
    [sym_true] = ACTIONS(3929),
    [anon_sym_protected] = ACTIONS(422),
    [anon_sym_set] = ACTIONS(412),
    [anon_sym_type] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(412),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_BANG] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [sym_false] = ACTIONS(3929),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_number] = ACTIONS(3921),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(412),
    [anon_sym_typeof] = ACTIONS(3931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(973),
    [anon_sym_any] = ACTIONS(3921),
    [anon_sym_boolean] = ACTIONS(3921),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3933),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3921),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(973),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_export] = ACTIONS(412),
    [anon_sym_TILDE] = ACTIONS(410),
  },
  [1277] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3451),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_RBRACK] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_implements] = ACTIONS(207),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [1278] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1005),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1009),
    [anon_sym_symbol] = ACTIONS(1009),
    [anon_sym_number] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1009),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1009),
    [anon_sym_private] = ACTIONS(1009),
    [anon_sym_boolean] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_public] = ACTIONS(1009),
    [anon_sym_get] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1009),
    [anon_sym_string] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1009),
    [anon_sym_namespace] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [1279] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(4503),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1280] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4554),
    [anon_sym_LBRACK] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_SEMI] = ACTIONS(4554),
    [anon_sym_BQUOTE] = ACTIONS(4554),
    [sym__automatic_semicolon] = ACTIONS(4554),
    [anon_sym_PIPE] = ACTIONS(4556),
    [anon_sym_COMMA] = ACTIONS(4554),
    [anon_sym_LT_LT] = ACTIONS(4554),
    [anon_sym_STAR] = ACTIONS(4556),
    [anon_sym_GT_GT_GT] = ACTIONS(4554),
    [anon_sym_EQ] = ACTIONS(4556),
    [anon_sym_AMP_AMP] = ACTIONS(4554),
    [anon_sym_DASH] = ACTIONS(4556),
    [anon_sym_BANG_EQ] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(4554),
    [anon_sym_LPAREN] = ACTIONS(4554),
    [anon_sym_GT_EQ] = ACTIONS(4554),
    [anon_sym_of] = ACTIONS(4554),
    [anon_sym_GT] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4556),
    [anon_sym_PERCENT] = ACTIONS(4554),
    [anon_sym_QMARK] = ACTIONS(4554),
    [anon_sym_RBRACE] = ACTIONS(4554),
    [anon_sym_as] = ACTIONS(4554),
    [anon_sym_PIPE_PIPE] = ACTIONS(4554),
    [anon_sym_DASH_DASH] = ACTIONS(4554),
    [anon_sym_EQ_EQ] = ACTIONS(4556),
    [anon_sym_instanceof] = ACTIONS(4554),
    [anon_sym_LT] = ACTIONS(4556),
    [anon_sym_RPAREN] = ACTIONS(4554),
    [anon_sym_SLASH] = ACTIONS(4556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4554),
    [anon_sym_CARET] = ACTIONS(4554),
    [anon_sym_STAR_STAR] = ACTIONS(4554),
    [anon_sym_PLUS] = ACTIONS(4556),
    [anon_sym_GT_GT] = ACTIONS(4556),
    [anon_sym_PLUS_PLUS] = ACTIONS(4554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4554),
    [anon_sym_in] = ACTIONS(4556),
  },
  [1281] = {
    [sym_class_heritage] = STATE(2191),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_type_parameters] = STATE(2192),
    [sym_class_body] = STATE(2193),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [1282] = {
    [sym_class_body] = STATE(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [1283] = {
    [sym_identifier] = ACTIONS(4365),
    [anon_sym_BQUOTE] = ACTIONS(4363),
    [anon_sym_debugger] = ACTIONS(4365),
    [anon_sym_symbol] = ACTIONS(4365),
    [anon_sym_AT] = ACTIONS(4363),
    [anon_sym_PIPE] = ACTIONS(4363),
    [anon_sym_COMMA] = ACTIONS(4363),
    [anon_sym_DASH] = ACTIONS(4365),
    [anon_sym_EQ] = ACTIONS(4365),
    [anon_sym_void] = ACTIONS(4365),
    [anon_sym_break] = ACTIONS(4365),
    [anon_sym_const] = ACTIONS(4365),
    [sym_super] = ACTIONS(4365),
    [anon_sym_return] = ACTIONS(4365),
    [anon_sym_private] = ACTIONS(4365),
    [anon_sym_get] = ACTIONS(4365),
    [anon_sym_RBRACE] = ACTIONS(4363),
    [anon_sym_interface] = ACTIONS(4365),
    [anon_sym_default] = ACTIONS(4365),
    [anon_sym_enum] = ACTIONS(4365),
    [anon_sym_delete] = ACTIONS(4365),
    [anon_sym_continue] = ACTIONS(4365),
    [anon_sym_DASH_DASH] = ACTIONS(4363),
    [anon_sym_if] = ACTIONS(4365),
    [anon_sym_this] = ACTIONS(4365),
    [anon_sym_yield] = ACTIONS(4365),
    [sym_true] = ACTIONS(4365),
    [anon_sym_throw] = ACTIONS(4365),
    [anon_sym_protected] = ACTIONS(4365),
    [anon_sym_abstract] = ACTIONS(4365),
    [anon_sym_DOT] = ACTIONS(4365),
    [anon_sym_set] = ACTIONS(4365),
    [anon_sym_type] = ACTIONS(4365),
    [anon_sym_import] = ACTIONS(4365),
    [anon_sym_namespace] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4363),
    [anon_sym_await] = ACTIONS(4365),
    [anon_sym_DQUOTE] = ACTIONS(4363),
    [anon_sym_else] = ACTIONS(4365),
    [anon_sym_BANG] = ACTIONS(4363),
    [anon_sym_for] = ACTIONS(4365),
    [anon_sym_LBRACK] = ACTIONS(4363),
    [sym_false] = ACTIONS(4365),
    [anon_sym_SEMI] = ACTIONS(4363),
    [anon_sym_case] = ACTIONS(4365),
    [anon_sym_module] = ACTIONS(4365),
    [anon_sym_number] = ACTIONS(4365),
    [anon_sym_class] = ACTIONS(4365),
    [anon_sym_declare] = ACTIONS(4365),
    [anon_sym_typeof] = ACTIONS(4365),
    [anon_sym_LBRACE] = ACTIONS(4363),
    [anon_sym_switch] = ACTIONS(4365),
    [anon_sym_LPAREN] = ACTIONS(4363),
    [anon_sym_RBRACK] = ACTIONS(4363),
    [sym_null] = ACTIONS(4365),
    [anon_sym_GT] = ACTIONS(4363),
    [anon_sym_any] = ACTIONS(4365),
    [anon_sym_boolean] = ACTIONS(4365),
    [anon_sym_async] = ACTIONS(4365),
    [anon_sym_public] = ACTIONS(4365),
    [anon_sym_EQ_GT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4363),
    [anon_sym_var] = ACTIONS(4365),
    [anon_sym_while] = ACTIONS(4365),
    [anon_sym_SQUOTE] = ACTIONS(4363),
    [anon_sym_try] = ACTIONS(4365),
    [anon_sym_RPAREN] = ACTIONS(4363),
    [anon_sym_LT] = ACTIONS(4363),
    [sym_number] = ACTIONS(4363),
    [anon_sym_SLASH] = ACTIONS(4365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4365),
    [anon_sym_function] = ACTIONS(4365),
    [sym_undefined] = ACTIONS(4365),
    [anon_sym_new] = ACTIONS(4365),
    [ts_builtin_sym_end] = ACTIONS(4363),
    [anon_sym_let] = ACTIONS(4365),
    [anon_sym_PLUS] = ACTIONS(4365),
    [anon_sym_export] = ACTIONS(4365),
    [anon_sym_do] = ACTIONS(4365),
    [anon_sym_TILDE] = ACTIONS(4363),
    [anon_sym_with] = ACTIONS(4365),
  },
  [1284] = {
    [sym_identifier] = ACTIONS(2463),
    [anon_sym_BQUOTE] = ACTIONS(2461),
    [anon_sym_debugger] = ACTIONS(2463),
    [anon_sym_symbol] = ACTIONS(2463),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_DASH] = ACTIONS(2463),
    [anon_sym_EQ] = ACTIONS(2463),
    [anon_sym_void] = ACTIONS(2463),
    [anon_sym_break] = ACTIONS(2463),
    [anon_sym_const] = ACTIONS(2463),
    [sym_super] = ACTIONS(2463),
    [anon_sym_return] = ACTIONS(2463),
    [anon_sym_private] = ACTIONS(2463),
    [anon_sym_get] = ACTIONS(2463),
    [anon_sym_RBRACE] = ACTIONS(2461),
    [anon_sym_interface] = ACTIONS(2463),
    [anon_sym_default] = ACTIONS(2463),
    [anon_sym_enum] = ACTIONS(2463),
    [anon_sym_delete] = ACTIONS(2463),
    [anon_sym_continue] = ACTIONS(2463),
    [anon_sym_DASH_DASH] = ACTIONS(2461),
    [anon_sym_if] = ACTIONS(2463),
    [anon_sym_this] = ACTIONS(2463),
    [anon_sym_yield] = ACTIONS(2463),
    [sym_true] = ACTIONS(2463),
    [anon_sym_throw] = ACTIONS(2463),
    [anon_sym_COLON] = ACTIONS(2461),
    [anon_sym_protected] = ACTIONS(2463),
    [anon_sym_abstract] = ACTIONS(2463),
    [anon_sym_set] = ACTIONS(2463),
    [anon_sym_type] = ACTIONS(2463),
    [anon_sym_import] = ACTIONS(2463),
    [anon_sym_namespace] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(2461),
    [anon_sym_await] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2461),
    [anon_sym_else] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2461),
    [anon_sym_for] = ACTIONS(2463),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [sym_false] = ACTIONS(2463),
    [anon_sym_SEMI] = ACTIONS(2461),
    [anon_sym_case] = ACTIONS(2463),
    [anon_sym_module] = ACTIONS(2463),
    [anon_sym_number] = ACTIONS(2463),
    [anon_sym_class] = ACTIONS(2463),
    [anon_sym_declare] = ACTIONS(2463),
    [anon_sym_typeof] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_switch] = ACTIONS(2463),
    [anon_sym_LPAREN] = ACTIONS(2461),
    [anon_sym_RBRACK] = ACTIONS(2461),
    [sym_null] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2461),
    [anon_sym_any] = ACTIONS(2463),
    [anon_sym_boolean] = ACTIONS(2463),
    [anon_sym_async] = ACTIONS(2463),
    [anon_sym_public] = ACTIONS(2463),
    [anon_sym_EQ_GT] = ACTIONS(2461),
    [anon_sym_AMP] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [anon_sym_QMARK] = ACTIONS(2461),
    [anon_sym_while] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2461),
    [anon_sym_try] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(2461),
    [anon_sym_LT] = ACTIONS(2461),
    [sym_number] = ACTIONS(2461),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2463),
    [anon_sym_function] = ACTIONS(2463),
    [sym_undefined] = ACTIONS(2463),
    [anon_sym_new] = ACTIONS(2463),
    [ts_builtin_sym_end] = ACTIONS(2461),
    [anon_sym_let] = ACTIONS(2463),
    [anon_sym_PLUS] = ACTIONS(2463),
    [anon_sym_export] = ACTIONS(2463),
    [anon_sym_do] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2461),
    [anon_sym_with] = ACTIONS(2463),
  },
  [1285] = {
    [sym_new_expression] = STATE(2195),
    [sym_augmented_assignment_expression] = STATE(2195),
    [sym_unary_expression] = STATE(2195),
    [sym_update_expression] = STATE(2195),
    [sym_regex] = STATE(2195),
    [sym_meta_property] = STATE(2195),
    [sym_call_signature] = STATE(598),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(2195),
    [sym_yield_expression] = STATE(2195),
    [sym_as_expression] = STATE(2195),
    [sym_non_null_expression] = STATE(2195),
    [sym_internal_module] = STATE(2195),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2195),
    [sym_await_expression] = STATE(2195),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2195),
    [sym_this] = STATE(2195),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2195),
    [sym_generator_function] = STATE(2195),
    [sym_call_expression] = STATE(2195),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2195),
    [sym_ternary_expression] = STATE(2195),
    [sym_binary_expression] = STATE(2195),
    [sym_template_string] = STATE(2195),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2195),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2195),
    [sym_class] = STATE(2195),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4558),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4558),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4560),
    [sym_true] = ACTIONS(4558),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4558),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1286] = {
    [sym_new_expression] = STATE(2196),
    [sym_augmented_assignment_expression] = STATE(2196),
    [sym_unary_expression] = STATE(2196),
    [sym_update_expression] = STATE(2196),
    [sym_regex] = STATE(2196),
    [sym_meta_property] = STATE(2196),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(2196),
    [sym_yield_expression] = STATE(2196),
    [sym_as_expression] = STATE(2196),
    [sym_non_null_expression] = STATE(2196),
    [sym_internal_module] = STATE(2196),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2196),
    [sym_await_expression] = STATE(2196),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2196),
    [sym_this] = STATE(2196),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2196),
    [sym_generator_function] = STATE(2196),
    [sym_call_expression] = STATE(2196),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2196),
    [sym_ternary_expression] = STATE(2196),
    [sym_binary_expression] = STATE(2196),
    [sym_template_string] = STATE(2196),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2196),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2196),
    [sym_class] = STATE(2196),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4562),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4562),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4564),
    [sym_true] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4562),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1287] = {
    [sym_new_expression] = STATE(2197),
    [sym_augmented_assignment_expression] = STATE(2197),
    [sym_unary_expression] = STATE(2197),
    [sym_update_expression] = STATE(2197),
    [sym_regex] = STATE(2197),
    [sym_meta_property] = STATE(2197),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(2197),
    [sym_yield_expression] = STATE(2197),
    [sym_as_expression] = STATE(2197),
    [sym_non_null_expression] = STATE(2197),
    [sym_internal_module] = STATE(2197),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2197),
    [sym_await_expression] = STATE(2197),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2197),
    [sym_this] = STATE(2197),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2197),
    [sym_generator_function] = STATE(2197),
    [sym_call_expression] = STATE(2197),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2197),
    [sym_ternary_expression] = STATE(2197),
    [sym_binary_expression] = STATE(2197),
    [sym_template_string] = STATE(2197),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2197),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2197),
    [sym_class] = STATE(2197),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4566),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4566),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4568),
    [sym_true] = ACTIONS(4566),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4566),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1288] = {
    [sym_new_expression] = STATE(2198),
    [sym_augmented_assignment_expression] = STATE(2198),
    [sym_unary_expression] = STATE(2198),
    [sym_update_expression] = STATE(2198),
    [sym_regex] = STATE(2198),
    [sym_meta_property] = STATE(2198),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(2198),
    [sym_yield_expression] = STATE(2198),
    [sym_as_expression] = STATE(2198),
    [sym_non_null_expression] = STATE(2198),
    [sym_internal_module] = STATE(2198),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2198),
    [sym_await_expression] = STATE(2198),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2198),
    [sym_this] = STATE(2198),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2198),
    [sym_generator_function] = STATE(2198),
    [sym_call_expression] = STATE(2198),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2198),
    [sym_ternary_expression] = STATE(2198),
    [sym_binary_expression] = STATE(2198),
    [sym_template_string] = STATE(2198),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2198),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2198),
    [sym_class] = STATE(2198),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4570),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4570),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4572),
    [sym_true] = ACTIONS(4570),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4570),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1289] = {
    [sym_identifier] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
  },
  [1290] = {
    [sym_new_expression] = STATE(2200),
    [sym_augmented_assignment_expression] = STATE(2200),
    [sym_unary_expression] = STATE(2200),
    [sym_update_expression] = STATE(2200),
    [sym_regex] = STATE(2200),
    [sym_meta_property] = STATE(2200),
    [sym_call_signature] = STATE(598),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(2200),
    [sym_yield_expression] = STATE(2200),
    [sym_as_expression] = STATE(2200),
    [sym_non_null_expression] = STATE(2200),
    [sym_internal_module] = STATE(2200),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2200),
    [sym_await_expression] = STATE(2200),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2200),
    [sym_this] = STATE(2200),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2200),
    [sym_generator_function] = STATE(2200),
    [sym_call_expression] = STATE(2200),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2200),
    [sym_ternary_expression] = STATE(2200),
    [sym_binary_expression] = STATE(2200),
    [sym_template_string] = STATE(2200),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2200),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2200),
    [sym_class] = STATE(2200),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4576),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4576),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4578),
    [sym_true] = ACTIONS(4576),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4576),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1291] = {
    [sym_new_expression] = STATE(2201),
    [sym_augmented_assignment_expression] = STATE(2201),
    [sym_unary_expression] = STATE(2201),
    [sym_update_expression] = STATE(2201),
    [sym_regex] = STATE(2201),
    [sym_meta_property] = STATE(2201),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(2201),
    [sym_yield_expression] = STATE(2201),
    [sym_as_expression] = STATE(2201),
    [sym_non_null_expression] = STATE(2201),
    [sym_internal_module] = STATE(2201),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2201),
    [sym_await_expression] = STATE(2201),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2201),
    [sym_this] = STATE(2201),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2201),
    [sym_generator_function] = STATE(2201),
    [sym_call_expression] = STATE(2201),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2201),
    [sym_ternary_expression] = STATE(2201),
    [sym_binary_expression] = STATE(2201),
    [sym_template_string] = STATE(2201),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2201),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2201),
    [sym_class] = STATE(2201),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4580),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4580),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4582),
    [sym_true] = ACTIONS(4580),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4580),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1292] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2650),
    [anon_sym_AMP_EQ] = ACTIONS(2650),
    [anon_sym_PLUS_EQ] = ACTIONS(2650),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2650),
    [anon_sym_STAR_EQ] = ACTIONS(2650),
    [anon_sym_PIPE_EQ] = ACTIONS(2650),
    [anon_sym_DASH_EQ] = ACTIONS(2650),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2650),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2650),
    [anon_sym_GT_GT_EQ] = ACTIONS(2650),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2663),
  },
  [1293] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_implements] = ACTIONS(726),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [1294] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_implements] = ACTIONS(726),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [1295] = {
    [anon_sym_EQ_GT] = ACTIONS(4587),
    [sym_comment] = ACTIONS(3),
  },
  [1296] = {
    [anon_sym_EQ_GT] = ACTIONS(4589),
    [sym_comment] = ACTIONS(3),
  },
  [1297] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_LBRACE] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_implements] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [1298] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(863),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [1299] = {
    [anon_sym_SLASH2] = ACTIONS(4591),
    [sym_comment] = ACTIONS(3),
  },
  [1300] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_implements] = ACTIONS(1599),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [1301] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_implements] = ACTIONS(1609),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1302] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_implements] = ACTIONS(1611),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1303] = {
    [sym_call_signature] = STATE(1295),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(2681),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(2681),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(2681),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(2681),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(2681),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(2681),
    [anon_sym_type] = ACTIONS(2681),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(2681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(2681),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(2681),
    [anon_sym_declare] = ACTIONS(2681),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(2681),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(2681),
    [anon_sym_async] = ACTIONS(2681),
    [anon_sym_public] = ACTIONS(2681),
    [anon_sym_EQ_GT] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(2681),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_implements] = ACTIONS(1611),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(2681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1304] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_implements] = ACTIONS(1611),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1305] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [1306] = {
    [sym_new_expression] = STATE(2205),
    [sym_augmented_assignment_expression] = STATE(2205),
    [sym_unary_expression] = STATE(2205),
    [sym_update_expression] = STATE(2205),
    [sym_regex] = STATE(2205),
    [sym_meta_property] = STATE(2205),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(2205),
    [sym_yield_expression] = STATE(2205),
    [sym_as_expression] = STATE(2205),
    [sym_non_null_expression] = STATE(2205),
    [sym_internal_module] = STATE(2205),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2205),
    [sym_await_expression] = STATE(2205),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2205),
    [sym_this] = STATE(2205),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2205),
    [sym_generator_function] = STATE(2205),
    [sym_call_expression] = STATE(2205),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2205),
    [sym_ternary_expression] = STATE(2205),
    [sym_binary_expression] = STATE(2205),
    [sym_template_string] = STATE(2205),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2205),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2205),
    [sym_class] = STATE(2205),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4593),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4595),
    [sym_true] = ACTIONS(4593),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4593),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1307] = {
    [sym_new_expression] = STATE(2206),
    [sym_augmented_assignment_expression] = STATE(2206),
    [sym_unary_expression] = STATE(2206),
    [sym_update_expression] = STATE(2206),
    [sym_regex] = STATE(2206),
    [sym_meta_property] = STATE(2206),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(2206),
    [sym_yield_expression] = STATE(2206),
    [sym_as_expression] = STATE(2206),
    [sym_non_null_expression] = STATE(2206),
    [sym_internal_module] = STATE(2206),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2206),
    [sym_await_expression] = STATE(2206),
    [sym_member_expression] = STATE(600),
    [sym_generic_type] = STATE(2207),
    [sym_string] = STATE(2206),
    [sym_this] = STATE(2206),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_nested_type_identifier] = STATE(602),
    [sym_anonymous_class] = STATE(2206),
    [sym_generator_function] = STATE(2206),
    [sym_call_expression] = STATE(2206),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2206),
    [sym_ternary_expression] = STATE(2206),
    [sym_binary_expression] = STATE(2206),
    [sym_template_string] = STATE(2206),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2206),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2206),
    [sym__type_reference] = STATE(2207),
    [sym_class] = STATE(2206),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1077),
    [sym_false] = ACTIONS(4597),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4597),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4599),
    [sym_true] = ACTIONS(4597),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4597),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1308] = {
    [sym_new_expression] = STATE(2208),
    [sym_augmented_assignment_expression] = STATE(2208),
    [sym_unary_expression] = STATE(2208),
    [sym_update_expression] = STATE(2208),
    [sym_regex] = STATE(2208),
    [sym_meta_property] = STATE(2208),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(2208),
    [sym_yield_expression] = STATE(2208),
    [sym_as_expression] = STATE(2208),
    [sym_non_null_expression] = STATE(2208),
    [sym_internal_module] = STATE(2208),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2208),
    [sym_await_expression] = STATE(2208),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2208),
    [sym_this] = STATE(2208),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2208),
    [sym_generator_function] = STATE(2208),
    [sym_call_expression] = STATE(2208),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2208),
    [sym_ternary_expression] = STATE(2208),
    [sym_binary_expression] = STATE(2208),
    [sym_template_string] = STATE(2208),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2208),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2208),
    [sym_class] = STATE(2208),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4601),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4601),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4603),
    [sym_true] = ACTIONS(4601),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4601),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1309] = {
    [sym_new_expression] = STATE(2209),
    [sym_augmented_assignment_expression] = STATE(2209),
    [sym_unary_expression] = STATE(2209),
    [sym_update_expression] = STATE(2209),
    [sym_regex] = STATE(2209),
    [sym_meta_property] = STATE(2209),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(2209),
    [sym_yield_expression] = STATE(2209),
    [sym_as_expression] = STATE(2209),
    [sym_non_null_expression] = STATE(2209),
    [sym_internal_module] = STATE(2209),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2209),
    [sym_await_expression] = STATE(2209),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2209),
    [sym_this] = STATE(2209),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2209),
    [sym_generator_function] = STATE(2209),
    [sym_call_expression] = STATE(2209),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2209),
    [sym_ternary_expression] = STATE(2209),
    [sym_binary_expression] = STATE(2209),
    [sym_template_string] = STATE(2209),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2209),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2209),
    [sym_class] = STATE(2209),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4605),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4605),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4607),
    [sym_true] = ACTIONS(4605),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4605),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1310] = {
    [sym_new_expression] = STATE(2210),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_regex] = STATE(2210),
    [sym_meta_property] = STATE(2210),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(2210),
    [sym_yield_expression] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_non_null_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2210),
    [sym_this] = STATE(2210),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2210),
    [sym_generator_function] = STATE(2210),
    [sym_call_expression] = STATE(2210),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2210),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_template_string] = STATE(2210),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2210),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2210),
    [sym_class] = STATE(2210),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4609),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4609),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4611),
    [sym_true] = ACTIONS(4609),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4609),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1311] = {
    [sym_new_expression] = STATE(2211),
    [sym_augmented_assignment_expression] = STATE(2211),
    [sym_unary_expression] = STATE(2211),
    [sym_update_expression] = STATE(2211),
    [sym_regex] = STATE(2211),
    [sym_meta_property] = STATE(2211),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2211),
    [sym_yield_expression] = STATE(2211),
    [sym_as_expression] = STATE(2211),
    [sym_non_null_expression] = STATE(2211),
    [sym_internal_module] = STATE(2211),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2211),
    [sym_await_expression] = STATE(2211),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2211),
    [sym_this] = STATE(2211),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2211),
    [sym_generator_function] = STATE(2211),
    [sym_call_expression] = STATE(2211),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2211),
    [sym_ternary_expression] = STATE(2211),
    [sym_binary_expression] = STATE(2211),
    [sym_template_string] = STATE(2211),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2211),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2211),
    [sym_class] = STATE(2211),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(4613),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4613),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4615),
    [sym_true] = ACTIONS(4613),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4613),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1312] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(4619),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [1313] = {
    [sym_new_expression] = STATE(2196),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(2196),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(2196),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(2196),
    [sym_call_signature] = STATE(598),
    [sym_yield_expression] = STATE(2196),
    [sym_as_expression] = STATE(2196),
    [sym_internal_module] = STATE(2196),
    [sym_arrow_function] = STATE(2196),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(600),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(601),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(2196),
    [sym_subscript_expression] = STATE(600),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(2196),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(2196),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(2196),
    [sym_meta_property] = STATE(2196),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(2196),
    [sym_non_null_expression] = STATE(2196),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(2196),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(2196),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(2196),
    [sym_call_expression] = STATE(2196),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(2196),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(2196),
    [sym_type_arguments] = STATE(603),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(2196),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2196),
    [sym_class] = STATE(2196),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(4627),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(4629),
    [anon_sym_number] = ACTIONS(4629),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(4631),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4633),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(4635),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(4562),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4629),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(4629),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(4629),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4562),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(4637),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(4633),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1314] = {
    [sym_new_expression] = STATE(2226),
    [sym_augmented_assignment_expression] = STATE(2226),
    [sym_unary_expression] = STATE(2226),
    [sym_update_expression] = STATE(2226),
    [sym_regex] = STATE(2226),
    [sym_meta_property] = STATE(2226),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(2226),
    [sym_yield_expression] = STATE(2226),
    [sym_as_expression] = STATE(2226),
    [sym_non_null_expression] = STATE(2226),
    [sym_internal_module] = STATE(2226),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2226),
    [sym_await_expression] = STATE(2226),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(2226),
    [sym_this] = STATE(2226),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(2226),
    [sym_generator_function] = STATE(2226),
    [sym_call_expression] = STATE(2226),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(2226),
    [sym_ternary_expression] = STATE(2226),
    [sym_binary_expression] = STATE(2226),
    [sym_template_string] = STATE(2226),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2226),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2226),
    [sym_class] = STATE(2226),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(4639),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4639),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4641),
    [sym_true] = ACTIONS(4639),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4639),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [1315] = {
    [aux_sym_extends_clause_repeat1] = STATE(2227),
    [anon_sym_implements] = ACTIONS(4643),
    [anon_sym_COMMA] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4643),
  },
  [1316] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2231),
    [sym_constructor_type] = STATE(2231),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(2231),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2231),
    [sym_intersection_type] = STATE(2231),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1317] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2234),
    [sym_constructor_type] = STATE(2234),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(2234),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2234),
    [sym_intersection_type] = STATE(2234),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1318] = {
    [anon_sym_EQ_GT] = ACTIONS(4651),
    [sym_comment] = ACTIONS(3),
  },
  [1319] = {
    [sym_formal_parameters] = STATE(2236),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1320] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2237),
    [sym_constructor_type] = STATE(2237),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(2237),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2237),
    [sym_intersection_type] = STATE(2237),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(612),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(614),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1321] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(612),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(614),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1322] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(612),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(614),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1323] = {
    [aux_sym_implements_clause_repeat1] = STATE(2238),
    [anon_sym_COMMA] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4653),
  },
  [1324] = {
    [anon_sym_EQ_GT] = ACTIONS(4655),
    [sym_comment] = ACTIONS(3),
  },
  [1325] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2240),
    [sym_constructor_type] = STATE(2240),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(2240),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2240),
    [sym_intersection_type] = STATE(2240),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1326] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2241),
    [sym_constructor_type] = STATE(2241),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(2241),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2241),
    [sym_intersection_type] = STATE(2241),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(612),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(614),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1327] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4657),
    [sym_identifier] = ACTIONS(4659),
    [sym__automatic_semicolon] = ACTIONS(4657),
    [anon_sym_BQUOTE] = ACTIONS(4657),
    [anon_sym_debugger] = ACTIONS(4659),
    [ts_builtin_sym_end] = ACTIONS(4657),
    [anon_sym_symbol] = ACTIONS(4659),
    [anon_sym_AT] = ACTIONS(4657),
    [anon_sym_PIPE] = ACTIONS(4659),
    [anon_sym_COMMA] = ACTIONS(4657),
    [anon_sym_DASH] = ACTIONS(4659),
    [anon_sym_STAR] = ACTIONS(4659),
    [anon_sym_GT_GT_GT] = ACTIONS(4657),
    [anon_sym_void] = ACTIONS(4659),
    [anon_sym_break] = ACTIONS(4659),
    [anon_sym_BANG_EQ] = ACTIONS(4659),
    [anon_sym_const] = ACTIONS(4659),
    [anon_sym_GT_EQ] = ACTIONS(4657),
    [sym_super] = ACTIONS(4659),
    [anon_sym_return] = ACTIONS(4659),
    [anon_sym_private] = ACTIONS(4659),
    [anon_sym_get] = ACTIONS(4659),
    [anon_sym_RBRACE] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_interface] = ACTIONS(4659),
    [anon_sym_default] = ACTIONS(4659),
    [anon_sym_as] = ACTIONS(4659),
    [anon_sym_delete] = ACTIONS(4659),
    [anon_sym_continue] = ACTIONS(4659),
    [anon_sym_DASH_DASH] = ACTIONS(4657),
    [anon_sym_if] = ACTIONS(4659),
    [anon_sym_instanceof] = ACTIONS(4659),
    [anon_sym_this] = ACTIONS(4659),
    [anon_sym_yield] = ACTIONS(4659),
    [sym_true] = ACTIONS(4659),
    [anon_sym_throw] = ACTIONS(4659),
    [anon_sym_enum] = ACTIONS(4659),
    [anon_sym_protected] = ACTIONS(4659),
    [anon_sym_abstract] = ACTIONS(4659),
    [anon_sym_DOT] = ACTIONS(4659),
    [anon_sym_set] = ACTIONS(4659),
    [anon_sym_type] = ACTIONS(4659),
    [anon_sym_STAR_STAR] = ACTIONS(4657),
    [anon_sym_import] = ACTIONS(4659),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4657),
    [anon_sym_namespace] = ACTIONS(4659),
    [anon_sym_PLUS_PLUS] = ACTIONS(4657),
    [anon_sym_await] = ACTIONS(4659),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_else] = ACTIONS(4659),
    [anon_sym_BANG] = ACTIONS(4659),
    [anon_sym_for] = ACTIONS(4659),
    [anon_sym_LBRACK] = ACTIONS(4657),
    [sym_false] = ACTIONS(4659),
    [anon_sym_SEMI] = ACTIONS(4657),
    [anon_sym_case] = ACTIONS(4659),
    [anon_sym_module] = ACTIONS(4659),
    [anon_sym_number] = ACTIONS(4659),
    [anon_sym_class] = ACTIONS(4659),
    [anon_sym_declare] = ACTIONS(4659),
    [anon_sym_typeof] = ACTIONS(4659),
    [anon_sym_LT_LT] = ACTIONS(4657),
    [anon_sym_LBRACE] = ACTIONS(4657),
    [anon_sym_AMP_AMP] = ACTIONS(4657),
    [anon_sym_switch] = ACTIONS(4659),
    [anon_sym_LT_EQ] = ACTIONS(4657),
    [anon_sym_LPAREN] = ACTIONS(4657),
    [sym_null] = ACTIONS(4659),
    [anon_sym_GT] = ACTIONS(4659),
    [anon_sym_any] = ACTIONS(4659),
    [anon_sym_boolean] = ACTIONS(4659),
    [anon_sym_async] = ACTIONS(4659),
    [anon_sym_public] = ACTIONS(4659),
    [anon_sym_AMP] = ACTIONS(4659),
    [anon_sym_var] = ACTIONS(4659),
    [anon_sym_QMARK] = ACTIONS(4657),
    [anon_sym_PIPE_PIPE] = ACTIONS(4657),
    [anon_sym_while] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4657),
    [anon_sym_try] = ACTIONS(4659),
    [anon_sym_EQ_EQ] = ACTIONS(4659),
    [anon_sym_RPAREN] = ACTIONS(4657),
    [anon_sym_LT] = ACTIONS(4659),
    [sym_number] = ACTIONS(4657),
    [anon_sym_SLASH] = ACTIONS(4659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4659),
    [anon_sym_function] = ACTIONS(4659),
    [sym_undefined] = ACTIONS(4659),
    [anon_sym_new] = ACTIONS(4659),
    [anon_sym_CARET] = ACTIONS(4657),
    [anon_sym_let] = ACTIONS(4659),
    [anon_sym_PLUS] = ACTIONS(4659),
    [anon_sym_export] = ACTIONS(4659),
    [anon_sym_GT_GT] = ACTIONS(4659),
    [anon_sym_do] = ACTIONS(4659),
    [anon_sym_TILDE] = ACTIONS(4657),
    [anon_sym_with] = ACTIONS(4659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4657),
    [anon_sym_in] = ACTIONS(4659),
  },
  [1328] = {
    [sym_class_body] = STATE(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [1329] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_AMP_EQ] = ACTIONS(4661),
    [anon_sym_PLUS_EQ] = ACTIONS(4661),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_DASH_EQ] = ACTIONS(4661),
    [anon_sym_EQ_GT] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4661),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4671),
  },
  [1330] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4677),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1331] = {
    [sym_new_expression] = STATE(2252),
    [sym_augmented_assignment_expression] = STATE(2252),
    [sym_unary_expression] = STATE(2252),
    [sym_update_expression] = STATE(2252),
    [sym_regex] = STATE(2252),
    [sym_meta_property] = STATE(2252),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2252),
    [sym_yield_expression] = STATE(2252),
    [sym_as_expression] = STATE(2252),
    [sym_non_null_expression] = STATE(2252),
    [sym_internal_module] = STATE(2252),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2252),
    [sym_await_expression] = STATE(2252),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2252),
    [sym_this] = STATE(2252),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2252),
    [sym_generator_function] = STATE(2252),
    [sym_call_expression] = STATE(2252),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2252),
    [sym_ternary_expression] = STATE(2252),
    [sym_binary_expression] = STATE(2252),
    [sym_template_string] = STATE(2252),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2252),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2252),
    [sym_class] = STATE(2252),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(4679),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4679),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4681),
    [sym_true] = ACTIONS(4679),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4679),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [1332] = {
    [sym_new_expression] = STATE(2253),
    [sym_augmented_assignment_expression] = STATE(2253),
    [sym_unary_expression] = STATE(2253),
    [sym_update_expression] = STATE(2253),
    [sym_regex] = STATE(2253),
    [sym_meta_property] = STATE(2253),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2253),
    [sym_yield_expression] = STATE(2253),
    [sym_as_expression] = STATE(2253),
    [sym_non_null_expression] = STATE(2253),
    [sym_internal_module] = STATE(2253),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2253),
    [sym_await_expression] = STATE(2253),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2253),
    [sym_this] = STATE(2253),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2253),
    [sym_generator_function] = STATE(2253),
    [sym_call_expression] = STATE(2253),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2253),
    [sym_ternary_expression] = STATE(2253),
    [sym_binary_expression] = STATE(2253),
    [sym_template_string] = STATE(2253),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2253),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2253),
    [sym_class] = STATE(2253),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4683),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4685),
    [sym_true] = ACTIONS(4683),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4683),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [1333] = {
    [sym_new_expression] = STATE(2252),
    [sym_augmented_assignment_expression] = STATE(2252),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(2252),
    [sym_update_expression] = STATE(2252),
    [sym_regex] = STATE(2252),
    [sym_meta_property] = STATE(2252),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2252),
    [sym_yield_expression] = STATE(2252),
    [sym_as_expression] = STATE(2252),
    [sym_non_null_expression] = STATE(2252),
    [sym_internal_module] = STATE(2252),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2252),
    [sym_await_expression] = STATE(2252),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2252),
    [sym_this] = STATE(2252),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2252),
    [sym_generator_function] = STATE(2252),
    [sym_call_expression] = STATE(2252),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2252),
    [sym_ternary_expression] = STATE(2252),
    [sym_binary_expression] = STATE(2252),
    [sym_template_string] = STATE(2252),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2252),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2252),
    [sym_class] = STATE(2252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(2779),
    [sym_true] = ACTIONS(4679),
    [anon_sym_COLON] = ACTIONS(4677),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4679),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(4679),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4681),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4679),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1334] = {
    [sym_call_signature] = STATE(2254),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_symbol] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_void] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_private] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_get] = ACTIONS(4689),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(4677),
    [anon_sym_protected] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(4689),
    [anon_sym_type] = ACTIONS(4689),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4689),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_namespace] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4689),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_number] = ACTIONS(4689),
    [anon_sym_declare] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_boolean] = ACTIONS(4689),
    [anon_sym_async] = ACTIONS(4689),
    [anon_sym_public] = ACTIONS(4689),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_string] = ACTIONS(4689),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1335] = {
    [sym_new_expression] = STATE(2256),
    [sym_augmented_assignment_expression] = STATE(2256),
    [sym_unary_expression] = STATE(2256),
    [sym_update_expression] = STATE(2256),
    [sym_regex] = STATE(2256),
    [sym_meta_property] = STATE(2256),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2256),
    [sym_yield_expression] = STATE(2256),
    [sym_as_expression] = STATE(2256),
    [sym_non_null_expression] = STATE(2256),
    [sym_internal_module] = STATE(2256),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2256),
    [sym_await_expression] = STATE(2256),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2256),
    [sym_this] = STATE(2256),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2256),
    [sym_generator_function] = STATE(2256),
    [sym_call_expression] = STATE(2256),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2256),
    [sym_ternary_expression] = STATE(2256),
    [sym_binary_expression] = STATE(2256),
    [sym_template_string] = STATE(2256),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2256),
    [sym_class] = STATE(2256),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4691),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4693),
    [sym_true] = ACTIONS(4691),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4691),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [1336] = {
    [sym_new_expression] = STATE(2257),
    [sym_augmented_assignment_expression] = STATE(2257),
    [sym_unary_expression] = STATE(2257),
    [sym_update_expression] = STATE(2257),
    [sym_regex] = STATE(2257),
    [sym_meta_property] = STATE(2257),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2257),
    [sym_yield_expression] = STATE(2257),
    [sym_as_expression] = STATE(2257),
    [sym_non_null_expression] = STATE(2257),
    [sym_internal_module] = STATE(2257),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2257),
    [sym_await_expression] = STATE(2257),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2257),
    [sym_this] = STATE(2257),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2257),
    [sym_generator_function] = STATE(2257),
    [sym_call_expression] = STATE(2257),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2257),
    [sym_ternary_expression] = STATE(2257),
    [sym_binary_expression] = STATE(2257),
    [sym_template_string] = STATE(2257),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2257),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2257),
    [sym_class] = STATE(2257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(2779),
    [sym_true] = ACTIONS(4695),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4695),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(211),
    [sym_null] = ACTIONS(4695),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4697),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4695),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [1337] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4699),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4701),
    [anon_sym_symbol] = ACTIONS(4701),
    [anon_sym_number] = ACTIONS(4701),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4701),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4701),
    [anon_sym_private] = ACTIONS(4701),
    [anon_sym_boolean] = ACTIONS(4701),
    [anon_sym_async] = ACTIONS(4705),
    [anon_sym_public] = ACTIONS(4701),
    [anon_sym_get] = ACTIONS(4701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4701),
    [anon_sym_string] = ACTIONS(4701),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(4701),
    [anon_sym_type] = ACTIONS(4701),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(4701),
    [anon_sym_export] = ACTIONS(4701),
    [anon_sym_namespace] = ACTIONS(4707),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [1338] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4677),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1339] = {
    [sym_new_expression] = STATE(2263),
    [sym_augmented_assignment_expression] = STATE(2263),
    [sym_unary_expression] = STATE(2263),
    [sym_update_expression] = STATE(2263),
    [sym_regex] = STATE(2263),
    [sym_meta_property] = STATE(2263),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2263),
    [sym_yield_expression] = STATE(2263),
    [sym_as_expression] = STATE(2263),
    [sym_non_null_expression] = STATE(2263),
    [sym_internal_module] = STATE(2263),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2263),
    [sym_await_expression] = STATE(2263),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2263),
    [sym_this] = STATE(2263),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2263),
    [sym_generator_function] = STATE(2263),
    [sym_call_expression] = STATE(2263),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2263),
    [sym_ternary_expression] = STATE(2263),
    [sym_binary_expression] = STATE(2263),
    [sym_template_string] = STATE(2263),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2263),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2263),
    [sym_class] = STATE(2263),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(4709),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4709),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4711),
    [sym_true] = ACTIONS(4709),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4709),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [1340] = {
    [anon_sym_EQ_GT] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
  },
  [1341] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(4715),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_RBRACK] = ACTIONS(4727),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1342] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_AMP_EQ] = ACTIONS(4661),
    [anon_sym_PLUS_EQ] = ACTIONS(4661),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_DASH_EQ] = ACTIONS(4661),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4661),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1343] = {
    [anon_sym_RBRACK] = ACTIONS(4741),
    [sym_comment] = ACTIONS(3),
  },
  [1344] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4715),
  },
  [1345] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4743),
  },
  [1346] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [1347] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4715),
  },
  [1348] = {
    [sym_call_signature] = STATE(2277),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(4745),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [1349] = {
    [sym_string] = STATE(2278),
    [sym__property_name] = STATE(2278),
    [sym_computed_property_name] = STATE(2278),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(4747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [1350] = {
    [sym_string] = STATE(2278),
    [sym__property_name] = STATE(2278),
    [sym_computed_property_name] = STATE(2278),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(4747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [1351] = {
    [sym_string] = STATE(2278),
    [sym__property_name] = STATE(2278),
    [sym_computed_property_name] = STATE(2278),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(4747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [1352] = {
    [sym_new_expression] = STATE(1341),
    [sym_augmented_assignment_expression] = STATE(1341),
    [sym_unary_expression] = STATE(1341),
    [sym_update_expression] = STATE(1341),
    [sym_regex] = STATE(1341),
    [sym_meta_property] = STATE(1341),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1341),
    [sym_as_expression] = STATE(1341),
    [sym_non_null_expression] = STATE(1341),
    [sym_internal_module] = STATE(1341),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1341),
    [sym_await_expression] = STATE(1341),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(1341),
    [sym_this] = STATE(1341),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(1341),
    [sym_generator_function] = STATE(1341),
    [sym_call_expression] = STATE(1341),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(1341),
    [sym_ternary_expression] = STATE(1341),
    [sym_binary_expression] = STATE(1341),
    [sym_template_string] = STATE(1341),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1341),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(1341),
    [sym_class] = STATE(1341),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2763),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2777),
    [sym_true] = ACTIONS(2763),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2763),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [1353] = {
    [sym_string] = STATE(2282),
    [sym__property_name] = STATE(2282),
    [sym_computed_property_name] = STATE(2282),
    [anon_sym_get] = ACTIONS(4749),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(4751),
    [anon_sym_STAR] = ACTIONS(4753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(4749),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(4755),
  },
  [1354] = {
    [sym_string] = STATE(2278),
    [sym__property_name] = STATE(2278),
    [sym_computed_property_name] = STATE(2278),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(4753),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(4757),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(4747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(4757),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [1355] = {
    [sym_call_signature] = STATE(2277),
    [sym__initializer] = STATE(2286),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [sym_type_annotation] = STATE(2287),
    [sym__automatic_semicolon] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_QMARK] = ACTIONS(4761),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(4763),
  },
  [1356] = {
    [sym__automatic_semicolon] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(909),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_PIPE_RBRACE] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(909),
  },
  [1357] = {
    [aux_sym_string_repeat2] = STATE(778),
    [sym_escape_sequence] = ACTIONS(1458),
    [aux_sym_string_token2] = ACTIONS(1458),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(4765),
  },
  [1358] = {
    [sym_string] = STATE(2289),
    [sym__property_name] = STATE(2289),
    [sym_computed_property_name] = STATE(2289),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(4767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [1359] = {
    [sym_string] = STATE(2290),
    [sym__property_name] = STATE(2290),
    [sym_computed_property_name] = STATE(2290),
    [anon_sym_get] = ACTIONS(1119),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(4769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1119),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1119),
  },
  [1360] = {
    [sym_string] = STATE(2289),
    [sym__property_name] = STATE(2289),
    [sym_computed_property_name] = STATE(2289),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(4767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [1361] = {
    [sym_call_signature] = STATE(2292),
    [sym__initializer] = STATE(2286),
    [sym_formal_parameters] = STATE(2293),
    [sym_type_parameters] = STATE(2294),
    [sym_type_annotation] = STATE(2287),
    [sym__automatic_semicolon] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_QMARK] = ACTIONS(4771),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(4763),
  },
  [1362] = {
    [aux_sym_string_repeat1] = STATE(502),
    [sym_escape_sequence] = ACTIONS(913),
    [aux_sym_string_token1] = ACTIONS(913),
    [anon_sym_DQUOTE] = ACTIONS(4765),
    [sym_comment] = ACTIONS(246),
  },
  [1363] = {
    [anon_sym_LBRACK] = ACTIONS(4773),
    [sym_identifier] = ACTIONS(4775),
    [anon_sym_module] = ACTIONS(4775),
    [anon_sym_symbol] = ACTIONS(4775),
    [anon_sym_number] = ACTIONS(4775),
    [anon_sym_AT] = ACTIONS(4773),
    [anon_sym_declare] = ACTIONS(4775),
    [anon_sym_STAR] = ACTIONS(4773),
    [anon_sym_void] = ACTIONS(4775),
    [anon_sym_any] = ACTIONS(4775),
    [anon_sym_private] = ACTIONS(4775),
    [anon_sym_boolean] = ACTIONS(4775),
    [anon_sym_async] = ACTIONS(4775),
    [anon_sym_public] = ACTIONS(4775),
    [anon_sym_get] = ACTIONS(4775),
    [anon_sym_RBRACE] = ACTIONS(4773),
    [anon_sym_static] = ACTIONS(4775),
    [anon_sym_SQUOTE] = ACTIONS(4773),
    [sym_number] = ACTIONS(4773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4775),
    [anon_sym_string] = ACTIONS(4775),
    [anon_sym_abstract] = ACTIONS(4775),
    [anon_sym_set] = ACTIONS(4775),
    [anon_sym_type] = ACTIONS(4775),
    [anon_sym_import] = ACTIONS(4775),
    [anon_sym_export] = ACTIONS(4775),
    [anon_sym_namespace] = ACTIONS(4775),
    [sym_readonly] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4773),
  },
  [1364] = {
    [sym_call_signature] = STATE(2277),
    [sym__initializer] = STATE(2286),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [sym_type_annotation] = STATE(2287),
    [sym__automatic_semicolon] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
  },
  [1365] = {
    [sym__initializer] = STATE(2286),
    [sym_type_annotation] = STATE(2287),
    [sym__automatic_semicolon] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_COMMA] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
  },
  [1366] = {
    [sym_statement_block] = STATE(2296),
    [sym__automatic_semicolon] = ACTIONS(4777),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_COMMA] = ACTIONS(4777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4779),
  },
  [1367] = {
    [sym__automatic_semicolon] = ACTIONS(4759),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_COMMA] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
  },
  [1368] = {
    [sym_type_annotation] = STATE(1618),
    [sym__automatic_semicolon] = ACTIONS(570),
    [anon_sym_COLON] = ACTIONS(4781),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_COMMA] = ACTIONS(570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(570),
  },
  [1369] = {
    [sym_formal_parameters] = STATE(2298),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [1370] = {
    [sym__initializer] = STATE(2286),
    [sym__automatic_semicolon] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_COMMA] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
  },
  [1371] = {
    [sym_string] = STATE(2282),
    [sym__property_name] = STATE(2282),
    [sym_computed_property_name] = STATE(2282),
    [anon_sym_get] = ACTIONS(4749),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_async] = ACTIONS(4755),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(4751),
    [anon_sym_STAR] = ACTIONS(4753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(4749),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(4783),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1372] = {
    [sym_string] = STATE(2282),
    [sym__property_name] = STATE(2282),
    [sym_computed_property_name] = STATE(2282),
    [anon_sym_get] = ACTIONS(4749),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(4751),
    [anon_sym_STAR] = ACTIONS(4753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_abstract] = ACTIONS(4785),
    [anon_sym_set] = ACTIONS(4749),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(4755),
  },
  [1373] = {
    [sym_string] = STATE(2303),
    [sym__property_name] = STATE(2303),
    [sym_computed_property_name] = STATE(2303),
    [anon_sym_get] = ACTIONS(4787),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_async] = ACTIONS(1119),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(4789),
    [anon_sym_STAR] = ACTIONS(4791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(4787),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(4785),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1374] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4793),
    [sym__automatic_semicolon] = ACTIONS(4793),
    [sym_identifier] = ACTIONS(4795),
    [anon_sym_BQUOTE] = ACTIONS(4793),
    [anon_sym_debugger] = ACTIONS(4795),
    [anon_sym_with] = ACTIONS(4795),
    [anon_sym_symbol] = ACTIONS(4795),
    [anon_sym_AT] = ACTIONS(4793),
    [anon_sym_PIPE] = ACTIONS(4795),
    [anon_sym_COMMA] = ACTIONS(4793),
    [anon_sym_DASH] = ACTIONS(4795),
    [anon_sym_STAR] = ACTIONS(4795),
    [anon_sym_GT_GT_GT] = ACTIONS(4793),
    [anon_sym_void] = ACTIONS(4795),
    [anon_sym_break] = ACTIONS(4795),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_const] = ACTIONS(4795),
    [anon_sym_GT_EQ] = ACTIONS(4793),
    [sym_super] = ACTIONS(4795),
    [anon_sym_return] = ACTIONS(4795),
    [anon_sym_private] = ACTIONS(4795),
    [anon_sym_get] = ACTIONS(4795),
    [anon_sym_RBRACE] = ACTIONS(4793),
    [anon_sym_PERCENT] = ACTIONS(4793),
    [anon_sym_interface] = ACTIONS(4795),
    [anon_sym_default] = ACTIONS(4795),
    [anon_sym_as] = ACTIONS(4795),
    [anon_sym_delete] = ACTIONS(4795),
    [anon_sym_continue] = ACTIONS(4795),
    [anon_sym_DASH_DASH] = ACTIONS(4793),
    [anon_sym_if] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4795),
    [anon_sym_this] = ACTIONS(4795),
    [anon_sym_yield] = ACTIONS(4795),
    [sym_true] = ACTIONS(4795),
    [anon_sym_throw] = ACTIONS(4795),
    [anon_sym_enum] = ACTIONS(4795),
    [anon_sym_protected] = ACTIONS(4795),
    [anon_sym_abstract] = ACTIONS(4795),
    [anon_sym_DOT] = ACTIONS(4795),
    [anon_sym_set] = ACTIONS(4795),
    [anon_sym_type] = ACTIONS(4795),
    [anon_sym_STAR_STAR] = ACTIONS(4793),
    [anon_sym_import] = ACTIONS(4795),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4793),
    [anon_sym_namespace] = ACTIONS(4795),
    [anon_sym_PLUS_PLUS] = ACTIONS(4793),
    [anon_sym_await] = ACTIONS(4795),
    [anon_sym_DQUOTE] = ACTIONS(4793),
    [anon_sym_else] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(4795),
    [anon_sym_for] = ACTIONS(4795),
    [anon_sym_LBRACK] = ACTIONS(4793),
    [sym_false] = ACTIONS(4795),
    [anon_sym_SEMI] = ACTIONS(4793),
    [anon_sym_case] = ACTIONS(4795),
    [anon_sym_module] = ACTIONS(4795),
    [anon_sym_number] = ACTIONS(4795),
    [anon_sym_class] = ACTIONS(4795),
    [anon_sym_declare] = ACTIONS(4795),
    [anon_sym_typeof] = ACTIONS(4795),
    [anon_sym_LT_LT] = ACTIONS(4793),
    [anon_sym_LBRACE] = ACTIONS(4793),
    [anon_sym_AMP_AMP] = ACTIONS(4793),
    [anon_sym_switch] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4793),
    [anon_sym_LPAREN] = ACTIONS(4793),
    [sym_null] = ACTIONS(4795),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_any] = ACTIONS(4795),
    [anon_sym_boolean] = ACTIONS(4795),
    [anon_sym_async] = ACTIONS(4795),
    [anon_sym_public] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4795),
    [anon_sym_var] = ACTIONS(4795),
    [anon_sym_QMARK] = ACTIONS(4793),
    [anon_sym_PIPE_PIPE] = ACTIONS(4793),
    [anon_sym_while] = ACTIONS(4795),
    [anon_sym_SQUOTE] = ACTIONS(4793),
    [anon_sym_try] = ACTIONS(4795),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_RPAREN] = ACTIONS(4793),
    [anon_sym_LT] = ACTIONS(4795),
    [sym_number] = ACTIONS(4793),
    [anon_sym_SLASH] = ACTIONS(4795),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(4793),
    [anon_sym_string] = ACTIONS(4795),
    [anon_sym_function] = ACTIONS(4795),
    [sym_undefined] = ACTIONS(4795),
    [anon_sym_CARET] = ACTIONS(4793),
    [anon_sym_new] = ACTIONS(4795),
    [anon_sym_PLUS] = ACTIONS(4795),
    [anon_sym_let] = ACTIONS(4795),
    [anon_sym_GT_GT] = ACTIONS(4795),
    [anon_sym_export] = ACTIONS(4795),
    [anon_sym_do] = ACTIONS(4795),
    [anon_sym_TILDE] = ACTIONS(4793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4793),
    [anon_sym_in] = ACTIONS(4795),
  },
  [1375] = {
    [sym_public_field_definition] = STATE(630),
    [sym__property_name] = STATE(631),
    [sym_decorator] = STATE(1375),
    [sym_method_signature] = STATE(630),
    [sym_accessibility_modifier] = STATE(632),
    [sym_abstract_method_signature] = STATE(630),
    [sym_computed_property_name] = STATE(631),
    [aux_sym_class_body_repeat1] = STATE(1375),
    [sym_index_signature] = STATE(630),
    [sym_string] = STATE(631),
    [sym_method_definition] = STATE(634),
    [anon_sym_LBRACK] = ACTIONS(4797),
    [sym_identifier] = ACTIONS(4800),
    [anon_sym_module] = ACTIONS(4800),
    [anon_sym_symbol] = ACTIONS(4800),
    [anon_sym_number] = ACTIONS(4800),
    [anon_sym_AT] = ACTIONS(4803),
    [anon_sym_declare] = ACTIONS(4800),
    [anon_sym_STAR] = ACTIONS(4806),
    [anon_sym_void] = ACTIONS(4800),
    [anon_sym_any] = ACTIONS(4800),
    [anon_sym_private] = ACTIONS(4809),
    [anon_sym_boolean] = ACTIONS(4800),
    [anon_sym_async] = ACTIONS(4812),
    [anon_sym_public] = ACTIONS(4809),
    [anon_sym_get] = ACTIONS(4815),
    [anon_sym_RBRACE] = ACTIONS(4773),
    [anon_sym_static] = ACTIONS(4818),
    [anon_sym_SQUOTE] = ACTIONS(4821),
    [sym_number] = ACTIONS(4824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4809),
    [anon_sym_string] = ACTIONS(4800),
    [anon_sym_abstract] = ACTIONS(4827),
    [anon_sym_set] = ACTIONS(4815),
    [anon_sym_type] = ACTIONS(4800),
    [anon_sym_import] = ACTIONS(4800),
    [anon_sym_export] = ACTIONS(4800),
    [anon_sym_namespace] = ACTIONS(4800),
    [sym_readonly] = ACTIONS(4830),
    [anon_sym_DQUOTE] = ACTIONS(4833),
  },
  [1376] = {
    [anon_sym_COLON] = ACTIONS(4836),
    [sym_comment] = ACTIONS(3),
  },
  [1377] = {
    [sym_class_body] = STATE(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [1378] = {
    [sym_class_heritage] = STATE(2306),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(2305),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [1379] = {
    [sym_identifier] = ACTIONS(2757),
    [anon_sym_BQUOTE] = ACTIONS(2755),
    [anon_sym_debugger] = ACTIONS(2757),
    [anon_sym_symbol] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2755),
    [anon_sym_DASH] = ACTIONS(2757),
    [anon_sym_void] = ACTIONS(2757),
    [anon_sym_break] = ACTIONS(2757),
    [anon_sym_const] = ACTIONS(2757),
    [sym_super] = ACTIONS(2757),
    [anon_sym_return] = ACTIONS(2757),
    [anon_sym_private] = ACTIONS(2757),
    [anon_sym_get] = ACTIONS(2757),
    [anon_sym_RBRACE] = ACTIONS(2755),
    [anon_sym_interface] = ACTIONS(2757),
    [anon_sym_default] = ACTIONS(2757),
    [anon_sym_enum] = ACTIONS(2757),
    [anon_sym_delete] = ACTIONS(2757),
    [anon_sym_continue] = ACTIONS(2757),
    [anon_sym_DASH_DASH] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2757),
    [anon_sym_this] = ACTIONS(2757),
    [anon_sym_yield] = ACTIONS(2757),
    [sym_true] = ACTIONS(2757),
    [anon_sym_throw] = ACTIONS(2757),
    [anon_sym_protected] = ACTIONS(2757),
    [anon_sym_abstract] = ACTIONS(2757),
    [anon_sym_set] = ACTIONS(2757),
    [anon_sym_type] = ACTIONS(2757),
    [anon_sym_import] = ACTIONS(2757),
    [anon_sym_namespace] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2755),
    [anon_sym_await] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2757),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [sym_false] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2757),
    [anon_sym_module] = ACTIONS(2757),
    [anon_sym_number] = ACTIONS(2757),
    [anon_sym_class] = ACTIONS(2757),
    [anon_sym_declare] = ACTIONS(2757),
    [anon_sym_typeof] = ACTIONS(2757),
    [anon_sym_LBRACE] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2757),
    [anon_sym_LPAREN] = ACTIONS(2755),
    [sym_null] = ACTIONS(2757),
    [anon_sym_any] = ACTIONS(2757),
    [anon_sym_boolean] = ACTIONS(2757),
    [anon_sym_async] = ACTIONS(2757),
    [anon_sym_public] = ACTIONS(2757),
    [anon_sym_var] = ACTIONS(2757),
    [anon_sym_while] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(2755),
    [sym_number] = ACTIONS(2755),
    [anon_sym_SLASH] = ACTIONS(2757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2757),
    [anon_sym_function] = ACTIONS(2757),
    [sym_undefined] = ACTIONS(2757),
    [anon_sym_new] = ACTIONS(2757),
    [ts_builtin_sym_end] = ACTIONS(2755),
    [anon_sym_let] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2757),
    [anon_sym_export] = ACTIONS(2757),
    [anon_sym_do] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2755),
    [anon_sym_with] = ACTIONS(2757),
  },
  [1380] = {
    [sym_call_signature] = STATE(2307),
    [sym_formal_parameters] = STATE(858),
    [sym_type_parameters] = STATE(859),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1381] = {
    [sym_statement_block] = STATE(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [1382] = {
    [sym_statement_block] = STATE(2308),
    [sym__automatic_semicolon] = ACTIONS(3498),
    [anon_sym_SEMI] = ACTIONS(3498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [1383] = {
    [sym_call_signature] = STATE(2309),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1384] = {
    [sym_statement_block] = STATE(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [1385] = {
    [sym_identifier] = ACTIONS(3504),
    [anon_sym_BQUOTE] = ACTIONS(3502),
    [anon_sym_debugger] = ACTIONS(3504),
    [anon_sym_symbol] = ACTIONS(3504),
    [anon_sym_AT] = ACTIONS(3502),
    [anon_sym_DASH] = ACTIONS(3504),
    [anon_sym_void] = ACTIONS(3504),
    [anon_sym_break] = ACTIONS(3504),
    [anon_sym_const] = ACTIONS(3504),
    [sym_super] = ACTIONS(3504),
    [anon_sym_return] = ACTIONS(3504),
    [anon_sym_private] = ACTIONS(3504),
    [anon_sym_get] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3502),
    [anon_sym_interface] = ACTIONS(3504),
    [anon_sym_default] = ACTIONS(3504),
    [anon_sym_enum] = ACTIONS(3504),
    [anon_sym_delete] = ACTIONS(3504),
    [anon_sym_continue] = ACTIONS(3504),
    [anon_sym_DASH_DASH] = ACTIONS(3502),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_this] = ACTIONS(3504),
    [anon_sym_yield] = ACTIONS(3504),
    [sym_true] = ACTIONS(3504),
    [anon_sym_throw] = ACTIONS(3504),
    [anon_sym_protected] = ACTIONS(3504),
    [anon_sym_abstract] = ACTIONS(3504),
    [anon_sym_set] = ACTIONS(3504),
    [anon_sym_type] = ACTIONS(3504),
    [anon_sym_import] = ACTIONS(3504),
    [anon_sym_namespace] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3502),
    [anon_sym_await] = ACTIONS(3504),
    [anon_sym_DQUOTE] = ACTIONS(3502),
    [anon_sym_else] = ACTIONS(3504),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_for] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [sym_false] = ACTIONS(3504),
    [anon_sym_SEMI] = ACTIONS(3502),
    [anon_sym_case] = ACTIONS(3504),
    [anon_sym_module] = ACTIONS(3504),
    [anon_sym_number] = ACTIONS(3504),
    [anon_sym_class] = ACTIONS(3504),
    [anon_sym_declare] = ACTIONS(3504),
    [anon_sym_typeof] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3502),
    [anon_sym_switch] = ACTIONS(3504),
    [anon_sym_LPAREN] = ACTIONS(3502),
    [sym_null] = ACTIONS(3504),
    [anon_sym_any] = ACTIONS(3504),
    [anon_sym_boolean] = ACTIONS(3504),
    [anon_sym_async] = ACTIONS(3504),
    [anon_sym_public] = ACTIONS(3504),
    [anon_sym_var] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
    [anon_sym_SQUOTE] = ACTIONS(3502),
    [anon_sym_try] = ACTIONS(3504),
    [anon_sym_LT] = ACTIONS(3502),
    [sym_number] = ACTIONS(3502),
    [anon_sym_SLASH] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3504),
    [anon_sym_function] = ACTIONS(3504),
    [sym_undefined] = ACTIONS(3504),
    [anon_sym_new] = ACTIONS(3504),
    [ts_builtin_sym_end] = ACTIONS(3502),
    [anon_sym_let] = ACTIONS(3504),
    [anon_sym_PLUS] = ACTIONS(3504),
    [anon_sym_export] = ACTIONS(3504),
    [anon_sym_do] = ACTIONS(3504),
    [anon_sym_TILDE] = ACTIONS(3502),
    [anon_sym_with] = ACTIONS(3504),
  },
  [1386] = {
    [sym_nested_identifier] = STATE(1176),
    [sym_identifier] = ACTIONS(4838),
    [sym_comment] = ACTIONS(3),
  },
  [1387] = {
    [sym_class_heritage] = STATE(2311),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_type_parameters] = STATE(2312),
    [sym_class_body] = STATE(2313),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [1388] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_EQ_GT] = ACTIONS(4842),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4844),
  },
  [1389] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4846),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_AMP_EQ] = ACTIONS(4846),
    [anon_sym_PLUS_EQ] = ACTIONS(4846),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4846),
    [anon_sym_STAR_EQ] = ACTIONS(4846),
    [anon_sym_PIPE_EQ] = ACTIONS(4846),
    [anon_sym_DASH_EQ] = ACTIONS(4846),
    [anon_sym_EQ_GT] = ACTIONS(4848),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4846),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4846),
    [anon_sym_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4846),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1390] = {
    [sym_new_expression] = STATE(2319),
    [sym_augmented_assignment_expression] = STATE(2319),
    [sym_unary_expression] = STATE(2319),
    [sym_update_expression] = STATE(2319),
    [sym_regex] = STATE(2319),
    [sym_meta_property] = STATE(2319),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(2319),
    [sym_yield_expression] = STATE(2319),
    [sym_as_expression] = STATE(2319),
    [sym_non_null_expression] = STATE(2319),
    [sym_internal_module] = STATE(2319),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2319),
    [sym_await_expression] = STATE(2319),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(2319),
    [sym_this] = STATE(2319),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(2319),
    [sym_generator_function] = STATE(2319),
    [sym_call_expression] = STATE(2319),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(2319),
    [sym_ternary_expression] = STATE(2319),
    [sym_binary_expression] = STATE(2319),
    [sym_template_string] = STATE(2319),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2319),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(2319),
    [sym_class] = STATE(2319),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(4850),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4850),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(4852),
    [sym_true] = ACTIONS(4850),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4850),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [1391] = {
    [sym_new_expression] = STATE(2320),
    [sym_augmented_assignment_expression] = STATE(2320),
    [sym_unary_expression] = STATE(2320),
    [sym_update_expression] = STATE(2320),
    [sym_regex] = STATE(2320),
    [sym_meta_property] = STATE(2320),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(2320),
    [sym_yield_expression] = STATE(2320),
    [sym_as_expression] = STATE(2320),
    [sym_non_null_expression] = STATE(2320),
    [sym_internal_module] = STATE(2320),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2320),
    [sym_await_expression] = STATE(2320),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(2320),
    [sym_this] = STATE(2320),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(2320),
    [sym_generator_function] = STATE(2320),
    [sym_call_expression] = STATE(2320),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(2320),
    [sym_ternary_expression] = STATE(2320),
    [sym_binary_expression] = STATE(2320),
    [sym_template_string] = STATE(2320),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2320),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(2320),
    [sym_class] = STATE(2320),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(4854),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4854),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(4856),
    [sym_true] = ACTIONS(4854),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4854),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [1392] = {
    [sym_new_expression] = STATE(2319),
    [sym_augmented_assignment_expression] = STATE(2319),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(2319),
    [sym_update_expression] = STATE(2319),
    [sym_regex] = STATE(2319),
    [sym_meta_property] = STATE(2319),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(2319),
    [sym_yield_expression] = STATE(2319),
    [sym_as_expression] = STATE(2319),
    [sym_non_null_expression] = STATE(2319),
    [sym_internal_module] = STATE(2319),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2319),
    [sym_await_expression] = STATE(2319),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(2319),
    [sym_this] = STATE(2319),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(2319),
    [sym_generator_function] = STATE(2319),
    [sym_call_expression] = STATE(2319),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(2319),
    [sym_ternary_expression] = STATE(2319),
    [sym_binary_expression] = STATE(2319),
    [sym_template_string] = STATE(2319),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2319),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(2319),
    [sym_class] = STATE(2319),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(4846),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_AMP_EQ] = ACTIONS(4846),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4846),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(4846),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_PIPE_EQ] = ACTIONS(4846),
    [anon_sym_DASH_EQ] = ACTIONS(4846),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4846),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(2887),
    [sym_true] = ACTIONS(4850),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4846),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(4850),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4850),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_STAR_EQ] = ACTIONS(4846),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_EQ_GT] = ACTIONS(4848),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4852),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4846),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4850),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1393] = {
    [sym_call_signature] = STATE(2321),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4858),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4846),
    [anon_sym_symbol] = ACTIONS(4860),
    [anon_sym_AMP_EQ] = ACTIONS(4846),
    [anon_sym_PLUS_EQ] = ACTIONS(4846),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_void] = ACTIONS(4860),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4846),
    [anon_sym_private] = ACTIONS(4860),
    [anon_sym_PIPE_EQ] = ACTIONS(4846),
    [anon_sym_DASH_EQ] = ACTIONS(4846),
    [anon_sym_get] = ACTIONS(4860),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4846),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(4860),
    [anon_sym_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(4860),
    [anon_sym_type] = ACTIONS(4860),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4846),
    [anon_sym_namespace] = ACTIONS(4860),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4860),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_number] = ACTIONS(4860),
    [anon_sym_declare] = ACTIONS(4860),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4860),
    [anon_sym_STAR_EQ] = ACTIONS(4846),
    [anon_sym_boolean] = ACTIONS(4860),
    [anon_sym_async] = ACTIONS(4860),
    [anon_sym_public] = ACTIONS(4860),
    [anon_sym_EQ_GT] = ACTIONS(4848),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4846),
    [anon_sym_string] = ACTIONS(4860),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4860),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1394] = {
    [sym_new_expression] = STATE(2323),
    [sym_augmented_assignment_expression] = STATE(2323),
    [sym_unary_expression] = STATE(2323),
    [sym_update_expression] = STATE(2323),
    [sym_regex] = STATE(2323),
    [sym_meta_property] = STATE(2323),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(2323),
    [sym_yield_expression] = STATE(2323),
    [sym_as_expression] = STATE(2323),
    [sym_non_null_expression] = STATE(2323),
    [sym_internal_module] = STATE(2323),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2323),
    [sym_await_expression] = STATE(2323),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(2323),
    [sym_this] = STATE(2323),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(2323),
    [sym_generator_function] = STATE(2323),
    [sym_call_expression] = STATE(2323),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(2323),
    [sym_ternary_expression] = STATE(2323),
    [sym_binary_expression] = STATE(2323),
    [sym_template_string] = STATE(2323),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2323),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(2323),
    [sym_class] = STATE(2323),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4862),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(4864),
    [sym_true] = ACTIONS(4862),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4862),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [1395] = {
    [sym_new_expression] = STATE(2324),
    [sym_augmented_assignment_expression] = STATE(2324),
    [sym_unary_expression] = STATE(2324),
    [sym_update_expression] = STATE(2324),
    [sym_regex] = STATE(2324),
    [sym_meta_property] = STATE(2324),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(2324),
    [sym_yield_expression] = STATE(2324),
    [sym_as_expression] = STATE(2324),
    [sym_non_null_expression] = STATE(2324),
    [sym_internal_module] = STATE(2324),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2324),
    [sym_await_expression] = STATE(2324),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(2324),
    [sym_this] = STATE(2324),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(2324),
    [sym_generator_function] = STATE(2324),
    [sym_call_expression] = STATE(2324),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(2324),
    [sym_ternary_expression] = STATE(2324),
    [sym_binary_expression] = STATE(2324),
    [sym_template_string] = STATE(2324),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2324),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(2324),
    [sym_class] = STATE(2324),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(211),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(2887),
    [sym_true] = ACTIONS(4866),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(4866),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4866),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4868),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4866),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [1396] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4870),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4872),
    [anon_sym_symbol] = ACTIONS(4872),
    [anon_sym_number] = ACTIONS(4872),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4872),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4874),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(4872),
    [anon_sym_private] = ACTIONS(4872),
    [anon_sym_boolean] = ACTIONS(4872),
    [anon_sym_async] = ACTIONS(4876),
    [anon_sym_public] = ACTIONS(4872),
    [anon_sym_get] = ACTIONS(4872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4872),
    [anon_sym_string] = ACTIONS(4872),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(4872),
    [anon_sym_type] = ACTIONS(4872),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(4872),
    [anon_sym_export] = ACTIONS(4872),
    [anon_sym_namespace] = ACTIONS(4878),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [1397] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(4846),
    [anon_sym_AMP_EQ] = ACTIONS(4846),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_PLUS_EQ] = ACTIONS(4846),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4846),
    [anon_sym_STAR_EQ] = ACTIONS(4846),
    [anon_sym_PIPE_EQ] = ACTIONS(4846),
    [anon_sym_DASH_EQ] = ACTIONS(4846),
    [anon_sym_EQ_GT] = ACTIONS(4848),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4846),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4846),
    [anon_sym_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4846),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1398] = {
    [sym_new_expression] = STATE(2330),
    [sym_augmented_assignment_expression] = STATE(2330),
    [sym_unary_expression] = STATE(2330),
    [sym_update_expression] = STATE(2330),
    [sym_regex] = STATE(2330),
    [sym_meta_property] = STATE(2330),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(2330),
    [sym_yield_expression] = STATE(2330),
    [sym_as_expression] = STATE(2330),
    [sym_non_null_expression] = STATE(2330),
    [sym_internal_module] = STATE(2330),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2330),
    [sym_await_expression] = STATE(2330),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(2330),
    [sym_this] = STATE(2330),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(2330),
    [sym_generator_function] = STATE(2330),
    [sym_call_expression] = STATE(2330),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(2330),
    [sym_ternary_expression] = STATE(2330),
    [sym_binary_expression] = STATE(2330),
    [sym_template_string] = STATE(2330),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2330),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(2330),
    [sym_class] = STATE(2330),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(4880),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4880),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(4882),
    [sym_true] = ACTIONS(4880),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4880),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [1399] = {
    [anon_sym_EQ_GT] = ACTIONS(4842),
    [sym_comment] = ACTIONS(3),
  },
  [1400] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2055),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [1401] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1402] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4844),
  },
  [1403] = {
    [sym_new_expression] = STATE(353),
    [sym_augmented_assignment_expression] = STATE(353),
    [sym_unary_expression] = STATE(353),
    [sym_update_expression] = STATE(353),
    [sym_regex] = STATE(353),
    [sym_meta_property] = STATE(353),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(353),
    [sym_yield_expression] = STATE(353),
    [sym_as_expression] = STATE(353),
    [sym_non_null_expression] = STATE(353),
    [sym_internal_module] = STATE(353),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(353),
    [sym_await_expression] = STATE(353),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(353),
    [sym_this] = STATE(353),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(353),
    [sym_generator_function] = STATE(353),
    [sym_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(353),
    [sym_ternary_expression] = STATE(353),
    [sym_binary_expression] = STATE(353),
    [sym_template_string] = STATE(353),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(353),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(353),
    [sym_class] = STATE(353),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(612),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(614),
    [sym_true] = ACTIONS(612),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [1404] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4844),
  },
  [1405] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4908),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_BANG] = ACTIONS(4910),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [sym__automatic_semicolon] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_STAR] = ACTIONS(4910),
    [anon_sym_GT_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_DASH] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4910),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_of] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4910),
    [anon_sym_PERCENT] = ACTIONS(4908),
    [anon_sym_QMARK] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_as] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_DASH_DASH] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_instanceof] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_SLASH] = ACTIONS(4910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4908),
    [anon_sym_CARET] = ACTIONS(4908),
    [anon_sym_STAR_STAR] = ACTIONS(4908),
    [anon_sym_PLUS] = ACTIONS(4910),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_PLUS_PLUS] = ACTIONS(4908),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4908),
    [anon_sym_in] = ACTIONS(4910),
  },
  [1406] = {
    [sym_new_expression] = STATE(2340),
    [sym_augmented_assignment_expression] = STATE(2340),
    [sym_unary_expression] = STATE(2340),
    [sym_update_expression] = STATE(2340),
    [sym_regex] = STATE(2340),
    [sym_meta_property] = STATE(2340),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(2340),
    [sym_yield_expression] = STATE(2340),
    [sym_as_expression] = STATE(2340),
    [sym_non_null_expression] = STATE(2340),
    [sym_internal_module] = STATE(2340),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2340),
    [sym_await_expression] = STATE(2340),
    [sym_member_expression] = STATE(448),
    [sym_spread_element] = STATE(2341),
    [sym_string] = STATE(2340),
    [sym_this] = STATE(2340),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [aux_sym_array_repeat1] = STATE(2342),
    [sym_anonymous_class] = STATE(2340),
    [sym_generator_function] = STATE(2340),
    [sym_call_expression] = STATE(2340),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(2340),
    [sym_ternary_expression] = STATE(2340),
    [sym_binary_expression] = STATE(2340),
    [sym_template_string] = STATE(2340),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2340),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(2340),
    [sym_class] = STATE(2340),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(4912),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(789),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4912),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(4914),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4916),
    [sym_true] = ACTIONS(4912),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4912),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1407] = {
    [anon_sym_COMMA] = ACTIONS(4918),
    [anon_sym_RBRACE] = ACTIONS(4918),
    [sym_comment] = ACTIONS(3),
  },
  [1408] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_AMP_EQ] = ACTIONS(4661),
    [anon_sym_PLUS_EQ] = ACTIONS(4661),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_DASH_EQ] = ACTIONS(4661),
    [anon_sym_EQ_GT] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4661),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4715),
  },
  [1409] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1410] = {
    [sym_new_expression] = STATE(2252),
    [sym_augmented_assignment_expression] = STATE(2252),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(2252),
    [sym_update_expression] = STATE(2252),
    [sym_regex] = STATE(2252),
    [sym_meta_property] = STATE(2252),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2252),
    [sym_yield_expression] = STATE(2252),
    [sym_as_expression] = STATE(2252),
    [sym_non_null_expression] = STATE(2252),
    [sym_internal_module] = STATE(2252),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2252),
    [sym_await_expression] = STATE(2252),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2252),
    [sym_this] = STATE(2252),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2252),
    [sym_generator_function] = STATE(2252),
    [sym_call_expression] = STATE(2252),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2252),
    [sym_ternary_expression] = STATE(2252),
    [sym_binary_expression] = STATE(2252),
    [sym_template_string] = STATE(2252),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2252),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2252),
    [sym_class] = STATE(2252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(2779),
    [sym_true] = ACTIONS(4679),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4679),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(4679),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4681),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4679),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1411] = {
    [sym_call_signature] = STATE(2254),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_symbol] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_void] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_private] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_get] = ACTIONS(4689),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(4689),
    [anon_sym_type] = ACTIONS(4689),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4689),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_namespace] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4689),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_number] = ACTIONS(4689),
    [anon_sym_declare] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_boolean] = ACTIONS(4689),
    [anon_sym_async] = ACTIONS(4689),
    [anon_sym_public] = ACTIONS(4689),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_string] = ACTIONS(4689),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1412] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1413] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(4715),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1414] = {
    [sym_call_signature] = STATE(2344),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1415] = {
    [sym_statement_block] = STATE(2345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [1416] = {
    [sym_call_signature] = STATE(2344),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(4922),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1417] = {
    [sym_string] = STATE(2347),
    [sym__property_name] = STATE(2347),
    [sym_computed_property_name] = STATE(2347),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(4924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [1418] = {
    [sym_string] = STATE(2347),
    [sym__property_name] = STATE(2347),
    [sym_computed_property_name] = STATE(2347),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(4924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [1419] = {
    [sym_string] = STATE(2347),
    [sym__property_name] = STATE(2347),
    [sym_computed_property_name] = STATE(2347),
    [anon_sym_get] = ACTIONS(4926),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(4928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(4926),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [1420] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4930),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [1421] = {
    [sym_parenthesized_expression] = STATE(2351),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1422] = {
    [anon_sym_await] = ACTIONS(4932),
    [anon_sym_LPAREN] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
  },
  [1423] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(2357),
    [sym__declaration] = STATE(192),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(2357),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(322),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4936),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(4938),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4940),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1424] = {
    [sym_parenthesized_expression] = STATE(2358),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1425] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(2357),
    [sym__declaration] = STATE(317),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(2357),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_as] = ACTIONS(541),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(4938),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4940),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1426] = {
    [sym_parenthesized_expression] = STATE(2359),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1427] = {
    [sym_identifier] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2401),
    [anon_sym_debugger] = ACTIONS(2399),
    [anon_sym_symbol] = ACTIONS(2399),
    [anon_sym_AT] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2399),
    [anon_sym_void] = ACTIONS(2399),
    [anon_sym_break] = ACTIONS(2399),
    [anon_sym_const] = ACTIONS(2399),
    [sym_super] = ACTIONS(2399),
    [anon_sym_return] = ACTIONS(2399),
    [anon_sym_private] = ACTIONS(2399),
    [anon_sym_get] = ACTIONS(2399),
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_interface] = ACTIONS(2399),
    [anon_sym_enum] = ACTIONS(2399),
    [anon_sym_delete] = ACTIONS(2399),
    [anon_sym_continue] = ACTIONS(2399),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2399),
    [anon_sym_this] = ACTIONS(2399),
    [anon_sym_yield] = ACTIONS(2399),
    [sym_true] = ACTIONS(2399),
    [anon_sym_throw] = ACTIONS(2399),
    [anon_sym_protected] = ACTIONS(2399),
    [anon_sym_abstract] = ACTIONS(2399),
    [anon_sym_set] = ACTIONS(2399),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_import] = ACTIONS(2399),
    [anon_sym_namespace] = ACTIONS(2399),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_await] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_else] = ACTIONS(4942),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [sym_false] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2401),
    [anon_sym_module] = ACTIONS(2399),
    [anon_sym_number] = ACTIONS(2399),
    [anon_sym_class] = ACTIONS(2399),
    [anon_sym_declare] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_switch] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [sym_null] = ACTIONS(2399),
    [anon_sym_any] = ACTIONS(2399),
    [anon_sym_boolean] = ACTIONS(2399),
    [anon_sym_async] = ACTIONS(2399),
    [anon_sym_public] = ACTIONS(2399),
    [anon_sym_var] = ACTIONS(2399),
    [anon_sym_while] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_try] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2401),
    [sym_number] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2399),
    [anon_sym_function] = ACTIONS(2399),
    [sym_undefined] = ACTIONS(2399),
    [anon_sym_new] = ACTIONS(2399),
    [anon_sym_let] = ACTIONS(2399),
    [anon_sym_PLUS] = ACTIONS(2399),
    [anon_sym_export] = ACTIONS(2399),
    [anon_sym_do] = ACTIONS(2399),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_with] = ACTIONS(2399),
  },
  [1428] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(4944),
    [anon_sym_class] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [1429] = {
    [sym_array] = STATE(2364),
    [sym_object] = STATE(2365),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(4946),
    [anon_sym_var] = ACTIONS(4948),
    [anon_sym_const] = ACTIONS(4948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(4948),
  },
  [1430] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(4950),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4952),
  },
  [1431] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(2369),
    [sym_object] = STATE(2370),
    [sym_identifier] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1432] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(2369),
    [sym_object] = STATE(2370),
    [sym_identifier] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1433] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2371),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(2371),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [1434] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(4956),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4958),
  },
  [1435] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(4960),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4962),
  },
  [1436] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2571),
    [anon_sym_LBRACK] = ACTIONS(2571),
    [anon_sym_BANG] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2571),
    [anon_sym_BQUOTE] = ACTIONS(2571),
    [sym__automatic_semicolon] = ACTIONS(2571),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_COMMA] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2571),
    [anon_sym_STAR] = ACTIONS(2573),
    [anon_sym_GT_GT_GT] = ACTIONS(2571),
    [anon_sym_EQ] = ACTIONS(2573),
    [anon_sym_AMP_AMP] = ACTIONS(2571),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2571),
    [anon_sym_LPAREN] = ACTIONS(4964),
    [anon_sym_GT_EQ] = ACTIONS(2571),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_PERCENT] = ACTIONS(2571),
    [anon_sym_QMARK] = ACTIONS(4964),
    [anon_sym_as] = ACTIONS(2571),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(2571),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_instanceof] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(2571),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_PLUS_PLUS] = ACTIONS(2571),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2571),
    [anon_sym_in] = ACTIONS(2573),
  },
  [1437] = {
    [sym_identifier] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
  },
  [1438] = {
    [sym_type_alias_declaration] = STATE(915),
    [aux_sym_export_statement_repeat1] = STATE(675),
    [sym__declaration] = STATE(915),
    [sym_ambient_declaration] = STATE(915),
    [sym_import_alias] = STATE(915),
    [sym_export_statement] = STATE(915),
    [sym_generator_function] = STATE(915),
    [sym_lexical_declaration] = STATE(915),
    [sym_internal_module] = STATE(915),
    [sym_decorator] = STATE(675),
    [sym_enum_declaration] = STATE(915),
    [sym_function] = STATE(915),
    [sym_function_signature] = STATE(915),
    [sym_variable_declaration] = STATE(915),
    [sym_abstract_class] = STATE(915),
    [sym_module] = STATE(915),
    [sym_interface_declaration] = STATE(915),
    [sym_class] = STATE(915),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [1439] = {
    [sym_string] = STATE(2347),
    [sym__property_name] = STATE(2347),
    [sym_computed_property_name] = STATE(2347),
    [anon_sym_get] = ACTIONS(4926),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(4928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(4926),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(4974),
  },
  [1440] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4976),
    [anon_sym_BANG] = ACTIONS(4978),
    [anon_sym_SEMI] = ACTIONS(4976),
    [anon_sym_BQUOTE] = ACTIONS(4976),
    [sym__automatic_semicolon] = ACTIONS(4976),
    [anon_sym_PIPE] = ACTIONS(4978),
    [anon_sym_COMMA] = ACTIONS(4976),
    [anon_sym_LT_LT] = ACTIONS(4976),
    [anon_sym_STAR] = ACTIONS(4978),
    [anon_sym_GT_GT_GT] = ACTIONS(4976),
    [anon_sym_EQ] = ACTIONS(4978),
    [anon_sym_AMP_AMP] = ACTIONS(4976),
    [anon_sym_DASH] = ACTIONS(4978),
    [anon_sym_BANG_EQ] = ACTIONS(4978),
    [anon_sym_LT_EQ] = ACTIONS(4976),
    [anon_sym_LPAREN] = ACTIONS(4976),
    [anon_sym_GT_EQ] = ACTIONS(4976),
    [anon_sym_of] = ACTIONS(4976),
    [anon_sym_GT] = ACTIONS(4978),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_PERCENT] = ACTIONS(4976),
    [anon_sym_QMARK] = ACTIONS(4976),
    [anon_sym_RBRACE] = ACTIONS(4976),
    [anon_sym_as] = ACTIONS(4976),
    [anon_sym_PIPE_PIPE] = ACTIONS(4976),
    [anon_sym_DASH_DASH] = ACTIONS(4976),
    [anon_sym_EQ_EQ] = ACTIONS(4978),
    [anon_sym_instanceof] = ACTIONS(4976),
    [anon_sym_LT] = ACTIONS(4978),
    [anon_sym_RPAREN] = ACTIONS(4976),
    [anon_sym_SLASH] = ACTIONS(4978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4976),
    [anon_sym_CARET] = ACTIONS(4976),
    [anon_sym_STAR_STAR] = ACTIONS(4976),
    [anon_sym_PLUS] = ACTIONS(4978),
    [anon_sym_GT_GT] = ACTIONS(4978),
    [anon_sym_PLUS_PLUS] = ACTIONS(4976),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4976),
    [anon_sym_in] = ACTIONS(4978),
  },
  [1441] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(4980),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(4980),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1442] = {
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_RBRACE] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
  },
  [1443] = {
    [aux_sym_object_repeat1] = STATE(695),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
  },
  [1444] = {
    [sym_new_expression] = STATE(2391),
    [sym_augmented_assignment_expression] = STATE(2391),
    [sym_unary_expression] = STATE(2391),
    [sym_update_expression] = STATE(2391),
    [sym_regex] = STATE(2391),
    [sym_meta_property] = STATE(2391),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(2391),
    [sym_yield_expression] = STATE(2391),
    [sym_as_expression] = STATE(2391),
    [sym_non_null_expression] = STATE(2391),
    [sym_internal_module] = STATE(2391),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2391),
    [sym_await_expression] = STATE(2391),
    [sym_member_expression] = STATE(2392),
    [sym_sequence_expression] = STATE(2393),
    [sym_string] = STATE(2391),
    [sym_this] = STATE(2391),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(2391),
    [sym_generator_function] = STATE(2391),
    [sym_call_expression] = STATE(2391),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(2391),
    [sym_ternary_expression] = STATE(2391),
    [sym_binary_expression] = STATE(2391),
    [sym_template_string] = STATE(2391),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2391),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(2391),
    [sym_class] = STATE(2391),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4990),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5004),
    [sym_true] = ACTIONS(4990),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4990),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [1445] = {
    [sym_identifier] = ACTIONS(5014),
    [anon_sym_BQUOTE] = ACTIONS(5016),
    [anon_sym_debugger] = ACTIONS(5014),
    [anon_sym_symbol] = ACTIONS(5014),
    [anon_sym_AT] = ACTIONS(5016),
    [anon_sym_DASH] = ACTIONS(5014),
    [anon_sym_void] = ACTIONS(5014),
    [anon_sym_break] = ACTIONS(5014),
    [anon_sym_const] = ACTIONS(5014),
    [sym_super] = ACTIONS(5014),
    [anon_sym_return] = ACTIONS(5014),
    [anon_sym_private] = ACTIONS(5014),
    [anon_sym_get] = ACTIONS(5014),
    [anon_sym_RBRACE] = ACTIONS(5016),
    [anon_sym_interface] = ACTIONS(5014),
    [anon_sym_default] = ACTIONS(5014),
    [anon_sym_enum] = ACTIONS(5014),
    [anon_sym_delete] = ACTIONS(5014),
    [anon_sym_continue] = ACTIONS(5014),
    [anon_sym_DASH_DASH] = ACTIONS(5016),
    [anon_sym_if] = ACTIONS(5014),
    [anon_sym_this] = ACTIONS(5014),
    [anon_sym_yield] = ACTIONS(5014),
    [sym_true] = ACTIONS(5014),
    [anon_sym_throw] = ACTIONS(5014),
    [anon_sym_protected] = ACTIONS(5014),
    [anon_sym_abstract] = ACTIONS(5014),
    [anon_sym_set] = ACTIONS(5014),
    [anon_sym_type] = ACTIONS(5014),
    [anon_sym_import] = ACTIONS(5014),
    [anon_sym_namespace] = ACTIONS(5014),
    [anon_sym_PLUS_PLUS] = ACTIONS(5016),
    [anon_sym_await] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5016),
    [anon_sym_else] = ACTIONS(5014),
    [anon_sym_BANG] = ACTIONS(5016),
    [anon_sym_for] = ACTIONS(5014),
    [anon_sym_LBRACK] = ACTIONS(5016),
    [sym_false] = ACTIONS(5014),
    [anon_sym_SEMI] = ACTIONS(5016),
    [anon_sym_case] = ACTIONS(5014),
    [anon_sym_module] = ACTIONS(5014),
    [anon_sym_number] = ACTIONS(5014),
    [anon_sym_class] = ACTIONS(5014),
    [anon_sym_declare] = ACTIONS(5014),
    [anon_sym_typeof] = ACTIONS(5014),
    [anon_sym_LBRACE] = ACTIONS(5016),
    [anon_sym_switch] = ACTIONS(5014),
    [anon_sym_LPAREN] = ACTIONS(5016),
    [sym_null] = ACTIONS(5014),
    [anon_sym_any] = ACTIONS(5014),
    [anon_sym_boolean] = ACTIONS(5014),
    [anon_sym_async] = ACTIONS(5014),
    [anon_sym_public] = ACTIONS(5014),
    [anon_sym_var] = ACTIONS(5014),
    [anon_sym_while] = ACTIONS(5014),
    [anon_sym_SQUOTE] = ACTIONS(5016),
    [anon_sym_try] = ACTIONS(5014),
    [anon_sym_LT] = ACTIONS(5016),
    [sym_number] = ACTIONS(5016),
    [anon_sym_SLASH] = ACTIONS(5014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5014),
    [anon_sym_function] = ACTIONS(5014),
    [sym_undefined] = ACTIONS(5014),
    [anon_sym_new] = ACTIONS(5014),
    [ts_builtin_sym_end] = ACTIONS(5016),
    [anon_sym_let] = ACTIONS(5014),
    [anon_sym_PLUS] = ACTIONS(5014),
    [anon_sym_export] = ACTIONS(5014),
    [anon_sym_do] = ACTIONS(5014),
    [anon_sym_TILDE] = ACTIONS(5016),
    [anon_sym_with] = ACTIONS(5014),
  },
  [1446] = {
    [anon_sym_COLON] = ACTIONS(5018),
    [sym_comment] = ACTIONS(3),
  },
  [1447] = {
    [sym_switch_default] = STATE(2399),
    [aux_sym_switch_body_repeat1] = STATE(2399),
    [sym_switch_case] = STATE(2399),
    [anon_sym_RBRACE] = ACTIONS(5020),
    [anon_sym_default] = ACTIONS(3019),
    [anon_sym_case] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
  },
  [1448] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [1449] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1450] = {
    [anon_sym_COMMA] = ACTIONS(5022),
    [anon_sym_RPAREN] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [1451] = {
    [sym__initializer] = STATE(2400),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(5022),
    [anon_sym_COMMA] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [1452] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [1453] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [1454] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(5024),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5026),
  },
  [1455] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1456] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1460),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1462),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1457] = {
    [sym_formal_parameters] = STATE(2403),
    [sym_type_parameters] = STATE(2404),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1458] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1460),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1462),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1459] = {
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(5028),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_COMMA] = ACTIONS(3744),
    [sym_comment] = ACTIONS(3),
  },
  [1460] = {
    [sym_formal_parameters] = STATE(2407),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1461] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5032),
  },
  [1462] = {
    [anon_sym_EQ_GT] = ACTIONS(5034),
    [sym_comment] = ACTIONS(3),
  },
  [1463] = {
    [anon_sym_COMMA] = ACTIONS(5036),
    [anon_sym_RPAREN] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
  },
  [1464] = {
    [sym__initializer] = STATE(2410),
    [sym_type_annotation] = STATE(2411),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(5038),
    [anon_sym_COMMA] = ACTIONS(5038),
    [sym_comment] = ACTIONS(3),
  },
  [1465] = {
    [anon_sym_COMMA] = ACTIONS(5040),
    [anon_sym_RPAREN] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
  },
  [1466] = {
    [sym__initializer] = STATE(2412),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(5040),
    [anon_sym_COMMA] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
  },
  [1467] = {
    [sym__initializer] = STATE(2400),
    [sym_type_annotation] = STATE(2413),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(5022),
    [anon_sym_COMMA] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [1468] = {
    [sym__initializer] = STATE(2414),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(5036),
    [anon_sym_COMMA] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
  },
  [1469] = {
    [sym__initializer] = STATE(2415),
    [sym_type_annotation] = STATE(2416),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(5042),
    [anon_sym_COMMA] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
  },
  [1470] = {
    [anon_sym_COMMA] = ACTIONS(5044),
    [anon_sym_RPAREN] = ACTIONS(5044),
    [sym_comment] = ACTIONS(3),
  },
  [1471] = {
    [sym__initializer] = STATE(2417),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(5044),
    [anon_sym_COMMA] = ACTIONS(5044),
    [sym_comment] = ACTIONS(3),
  },
  [1472] = {
    [sym__initializer] = STATE(2418),
    [sym_type_annotation] = STATE(2419),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(5046),
    [anon_sym_COMMA] = ACTIONS(5046),
    [sym_comment] = ACTIONS(3),
  },
  [1473] = {
    [anon_sym_COMMA] = ACTIONS(5048),
    [anon_sym_RPAREN] = ACTIONS(5048),
    [sym_comment] = ACTIONS(3),
  },
  [1474] = {
    [sym__initializer] = STATE(2420),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(5048),
    [anon_sym_COMMA] = ACTIONS(5048),
    [sym_comment] = ACTIONS(3),
  },
  [1475] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2151),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [1476] = {
    [anon_sym_COMMA] = ACTIONS(5050),
    [anon_sym_RPAREN] = ACTIONS(5050),
    [sym_comment] = ACTIONS(3),
  },
  [1477] = {
    [sym__initializer] = STATE(2421),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(5050),
    [anon_sym_COMMA] = ACTIONS(5050),
    [sym_comment] = ACTIONS(3),
  },
  [1478] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(2155),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2155),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [1479] = {
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_RPAREN] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
  },
  [1480] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2427),
    [sym_constructor_type] = STATE(2427),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(2427),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2427),
    [sym_intersection_type] = STATE(2427),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2428),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2430),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5060),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1481] = {
    [anon_sym_COMMA] = ACTIONS(5064),
    [anon_sym_RPAREN] = ACTIONS(5064),
    [sym_comment] = ACTIONS(3),
  },
  [1482] = {
    [sym_new_expression] = STATE(2431),
    [sym_augmented_assignment_expression] = STATE(2431),
    [sym_unary_expression] = STATE(2431),
    [sym_update_expression] = STATE(2431),
    [sym_regex] = STATE(2431),
    [sym_meta_property] = STATE(2431),
    [sym_call_signature] = STATE(242),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(2431),
    [sym_yield_expression] = STATE(2431),
    [sym_as_expression] = STATE(2431),
    [sym_non_null_expression] = STATE(2431),
    [sym_internal_module] = STATE(2431),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2431),
    [sym_await_expression] = STATE(2431),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(2431),
    [sym_this] = STATE(2431),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(2431),
    [sym_generator_function] = STATE(2431),
    [sym_call_expression] = STATE(2431),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(2431),
    [sym_ternary_expression] = STATE(2431),
    [sym_binary_expression] = STATE(2431),
    [sym_template_string] = STATE(2431),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2431),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(2431),
    [sym_class] = STATE(2431),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(5066),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5066),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5068),
    [sym_true] = ACTIONS(5066),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5066),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [1483] = {
    [sym_new_expression] = STATE(2432),
    [sym_augmented_assignment_expression] = STATE(2432),
    [sym_unary_expression] = STATE(2432),
    [sym_update_expression] = STATE(2432),
    [sym_regex] = STATE(2432),
    [sym_meta_property] = STATE(2432),
    [sym_call_signature] = STATE(242),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(2432),
    [sym_yield_expression] = STATE(2432),
    [sym_as_expression] = STATE(2432),
    [sym_non_null_expression] = STATE(2432),
    [sym_internal_module] = STATE(2432),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2432),
    [sym_await_expression] = STATE(2432),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(2432),
    [sym_this] = STATE(2432),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(2432),
    [sym_generator_function] = STATE(2432),
    [sym_call_expression] = STATE(2432),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(2432),
    [sym_ternary_expression] = STATE(2432),
    [sym_binary_expression] = STATE(2432),
    [sym_template_string] = STATE(2432),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2432),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(2432),
    [sym_class] = STATE(2432),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(5070),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5070),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5072),
    [sym_true] = ACTIONS(5070),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5070),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [1484] = {
    [anon_sym_COLON] = ACTIONS(5074),
    [anon_sym_EQ_GT] = ACTIONS(5074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5074),
  },
  [1485] = {
    [aux_sym_export_statement_repeat1] = STATE(1534),
    [sym_decorator] = STATE(1534),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(2434),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(2434),
    [sym_optional_parameter] = STATE(2434),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [1486] = {
    [anon_sym_COMMA] = ACTIONS(5076),
    [anon_sym_RPAREN] = ACTIONS(5076),
    [sym_comment] = ACTIONS(3),
  },
  [1487] = {
    [aux_sym_export_statement_repeat1] = STATE(1485),
    [sym_decorator] = STATE(1485),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(1486),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(1486),
    [sym_optional_parameter] = STATE(1486),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(5078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [1488] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1488),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5076),
    [sym_comment] = ACTIONS(3),
  },
  [1489] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [1490] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5083),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1491] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5083),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1492] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [1493] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(3757),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1494] = {
    [anon_sym_COLON] = ACTIONS(3757),
    [anon_sym_RBRACE] = ACTIONS(3757),
    [anon_sym_RPAREN] = ACTIONS(3757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3757),
  },
  [1495] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5086),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1496] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_is] = ACTIONS(5088),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(5090),
  },
  [1497] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1498] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1499] = {
    [sym_formal_parameters] = STATE(2440),
    [sym_type_parameters] = STATE(2441),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1500] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1501] = {
    [sym_formal_parameters] = STATE(2444),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1502] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1577),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(5093),
  },
  [1503] = {
    [anon_sym_EQ_GT] = ACTIONS(5096),
    [sym_comment] = ACTIONS(3),
  },
  [1504] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5098),
  },
  [1505] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1506] = {
    [sym_new_expression] = STATE(724),
    [sym_augmented_assignment_expression] = STATE(724),
    [sym_unary_expression] = STATE(724),
    [sym_update_expression] = STATE(724),
    [sym_regex] = STATE(724),
    [sym_meta_property] = STATE(724),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(724),
    [sym_yield_expression] = STATE(724),
    [sym_as_expression] = STATE(724),
    [sym_non_null_expression] = STATE(724),
    [sym_internal_module] = STATE(724),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(724),
    [sym_await_expression] = STATE(724),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(724),
    [sym_this] = STATE(724),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(724),
    [sym_generator_function] = STATE(724),
    [sym_call_expression] = STATE(724),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(724),
    [sym_ternary_expression] = STATE(724),
    [sym_binary_expression] = STATE(724),
    [sym_template_string] = STATE(724),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(724),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(724),
    [sym_class] = STATE(724),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(5100),
    [sym_false] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1350),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1350),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [1507] = {
    [sym_new_expression] = STATE(725),
    [sym_augmented_assignment_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym_update_expression] = STATE(725),
    [sym_regex] = STATE(725),
    [sym_meta_property] = STATE(725),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(725),
    [sym_yield_expression] = STATE(725),
    [sym_as_expression] = STATE(725),
    [sym_non_null_expression] = STATE(725),
    [sym_internal_module] = STATE(725),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(725),
    [sym_await_expression] = STATE(725),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(725),
    [sym_this] = STATE(725),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(725),
    [sym_generator_function] = STATE(725),
    [sym_call_expression] = STATE(725),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(725),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_template_string] = STATE(725),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(725),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(725),
    [sym_class] = STATE(725),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(1354),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1354),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(1354),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [1508] = {
    [sym_new_expression] = STATE(724),
    [sym_augmented_assignment_expression] = STATE(724),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(724),
    [sym_update_expression] = STATE(724),
    [sym_regex] = STATE(724),
    [sym_meta_property] = STATE(724),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(724),
    [sym_yield_expression] = STATE(724),
    [sym_as_expression] = STATE(724),
    [sym_non_null_expression] = STATE(724),
    [sym_internal_module] = STATE(724),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(724),
    [sym_await_expression] = STATE(724),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(724),
    [sym_this] = STATE(724),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(724),
    [sym_generator_function] = STATE(724),
    [sym_call_expression] = STATE(724),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(724),
    [sym_ternary_expression] = STATE(724),
    [sym_binary_expression] = STATE(724),
    [sym_template_string] = STATE(724),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(724),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(724),
    [sym_class] = STATE(724),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(430),
    [sym_true] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1350),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1350),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1350),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1509] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1374),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1376),
    [anon_sym_symbol] = ACTIONS(1376),
    [anon_sym_number] = ACTIONS(1376),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1378),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1376),
    [anon_sym_private] = ACTIONS(1376),
    [anon_sym_boolean] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1380),
    [anon_sym_public] = ACTIONS(1376),
    [anon_sym_get] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1376),
    [anon_sym_string] = ACTIONS(1376),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1376),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(1376),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [1510] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_is] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3420),
  },
  [1511] = {
    [anon_sym_AMP] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
  },
  [1512] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5083),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1513] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5102),
    [anon_sym_LBRACK] = ACTIONS(5102),
    [anon_sym_BANG] = ACTIONS(5104),
    [anon_sym_SEMI] = ACTIONS(5102),
    [anon_sym_BQUOTE] = ACTIONS(5102),
    [sym__automatic_semicolon] = ACTIONS(5102),
    [anon_sym_PIPE] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5102),
    [anon_sym_LT_LT] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5104),
    [anon_sym_GT_GT_GT] = ACTIONS(5102),
    [anon_sym_AMP_AMP] = ACTIONS(5102),
    [anon_sym_DASH] = ACTIONS(5104),
    [anon_sym_BANG_EQ] = ACTIONS(5104),
    [anon_sym_LT_EQ] = ACTIONS(5102),
    [anon_sym_LPAREN] = ACTIONS(5102),
    [anon_sym_GT_EQ] = ACTIONS(5102),
    [anon_sym_GT] = ACTIONS(5104),
    [anon_sym_AMP] = ACTIONS(5104),
    [anon_sym_PERCENT] = ACTIONS(5102),
    [anon_sym_QMARK] = ACTIONS(5102),
    [anon_sym_RBRACE] = ACTIONS(5102),
    [anon_sym_as] = ACTIONS(5102),
    [anon_sym_PIPE_PIPE] = ACTIONS(5102),
    [anon_sym_DASH_DASH] = ACTIONS(5102),
    [anon_sym_EQ_EQ] = ACTIONS(5104),
    [anon_sym_instanceof] = ACTIONS(5102),
    [anon_sym_LT] = ACTIONS(5104),
    [anon_sym_RPAREN] = ACTIONS(5102),
    [anon_sym_SLASH] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5102),
    [anon_sym_CARET] = ACTIONS(5102),
    [anon_sym_STAR_STAR] = ACTIONS(5102),
    [anon_sym_PLUS] = ACTIONS(5104),
    [anon_sym_GT_GT] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5102),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5102),
    [anon_sym_in] = ACTIONS(5104),
  },
  [1514] = {
    [sym__initializer] = STATE(2450),
    [sym_type_annotation] = STATE(2451),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(5106),
    [anon_sym_QMARK] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5106),
    [sym_comment] = ACTIONS(3),
  },
  [1515] = {
    [sym__initializer] = STATE(2414),
    [sym_type_annotation] = STATE(2453),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(5036),
    [anon_sym_QMARK] = ACTIONS(5110),
    [anon_sym_COMMA] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
  },
  [1516] = {
    [sym__initializer] = STATE(2455),
    [sym_type_annotation] = STATE(2456),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(5112),
    [anon_sym_QMARK] = ACTIONS(5114),
    [anon_sym_COMMA] = ACTIONS(5112),
    [sym_comment] = ACTIONS(3),
  },
  [1517] = {
    [sym__initializer] = STATE(2414),
    [sym_type_annotation] = STATE(2453),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(5036),
    [anon_sym_COMMA] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
  },
  [1518] = {
    [sym__initializer] = STATE(2458),
    [sym_type_annotation] = STATE(2459),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(5116),
    [anon_sym_QMARK] = ACTIONS(5118),
    [anon_sym_COMMA] = ACTIONS(5116),
    [sym_comment] = ACTIONS(3),
  },
  [1519] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1520] = {
    [anon_sym_COMMA] = ACTIONS(3091),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
  },
  [1521] = {
    [anon_sym_COMMA] = ACTIONS(3197),
    [anon_sym_RPAREN] = ACTIONS(3197),
    [sym_comment] = ACTIONS(3),
  },
  [1522] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1488),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_RPAREN] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
  },
  [1523] = {
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
  },
  [1524] = {
    [anon_sym_COMMA] = ACTIONS(5122),
    [anon_sym_RPAREN] = ACTIONS(5122),
    [sym_comment] = ACTIONS(3),
  },
  [1525] = {
    [sym__initializer] = STATE(2461),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(5122),
    [anon_sym_COMMA] = ACTIONS(5122),
    [sym_comment] = ACTIONS(3),
  },
  [1526] = {
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_RPAREN] = ACTIONS(5124),
    [sym_comment] = ACTIONS(3),
  },
  [1527] = {
    [anon_sym_COMMA] = ACTIONS(5126),
    [anon_sym_RPAREN] = ACTIONS(5126),
    [sym_comment] = ACTIONS(3),
  },
  [1528] = {
    [sym__initializer] = STATE(2462),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(5126),
    [anon_sym_COMMA] = ACTIONS(5126),
    [sym_comment] = ACTIONS(3),
  },
  [1529] = {
    [anon_sym_COMMA] = ACTIONS(5128),
    [anon_sym_RPAREN] = ACTIONS(5128),
    [sym_comment] = ACTIONS(3),
  },
  [1530] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5130),
    [anon_sym_LBRACK] = ACTIONS(5130),
    [anon_sym_BANG] = ACTIONS(5132),
    [anon_sym_SEMI] = ACTIONS(5130),
    [anon_sym_BQUOTE] = ACTIONS(5130),
    [sym__automatic_semicolon] = ACTIONS(5130),
    [anon_sym_PIPE] = ACTIONS(5132),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(5130),
    [anon_sym_STAR] = ACTIONS(5132),
    [anon_sym_GT_GT_GT] = ACTIONS(5130),
    [anon_sym_AMP_AMP] = ACTIONS(5130),
    [anon_sym_DASH] = ACTIONS(5132),
    [anon_sym_BANG_EQ] = ACTIONS(5132),
    [anon_sym_LT_EQ] = ACTIONS(5130),
    [anon_sym_LPAREN] = ACTIONS(5130),
    [anon_sym_GT_EQ] = ACTIONS(5130),
    [anon_sym_GT] = ACTIONS(5132),
    [anon_sym_AMP] = ACTIONS(5132),
    [anon_sym_PERCENT] = ACTIONS(5130),
    [anon_sym_QMARK] = ACTIONS(5130),
    [anon_sym_RBRACE] = ACTIONS(5130),
    [anon_sym_as] = ACTIONS(5130),
    [anon_sym_PIPE_PIPE] = ACTIONS(5130),
    [anon_sym_DASH_DASH] = ACTIONS(5130),
    [anon_sym_EQ_EQ] = ACTIONS(5132),
    [anon_sym_instanceof] = ACTIONS(5130),
    [anon_sym_LT] = ACTIONS(5132),
    [anon_sym_RPAREN] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5130),
    [anon_sym_CARET] = ACTIONS(5130),
    [anon_sym_STAR_STAR] = ACTIONS(5130),
    [anon_sym_PLUS] = ACTIONS(5132),
    [anon_sym_GT_GT] = ACTIONS(5132),
    [anon_sym_PLUS_PLUS] = ACTIONS(5130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5130),
    [anon_sym_in] = ACTIONS(5132),
  },
  [1531] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(5130),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5130),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [1532] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5134),
    [anon_sym_LBRACK] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_SEMI] = ACTIONS(5134),
    [anon_sym_BQUOTE] = ACTIONS(5134),
    [sym__automatic_semicolon] = ACTIONS(5134),
    [anon_sym_PIPE] = ACTIONS(5136),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(5134),
    [anon_sym_STAR] = ACTIONS(5136),
    [anon_sym_GT_GT_GT] = ACTIONS(5134),
    [anon_sym_AMP_AMP] = ACTIONS(5134),
    [anon_sym_DASH] = ACTIONS(5136),
    [anon_sym_BANG_EQ] = ACTIONS(5136),
    [anon_sym_LT_EQ] = ACTIONS(5134),
    [anon_sym_LPAREN] = ACTIONS(5134),
    [anon_sym_GT_EQ] = ACTIONS(5134),
    [anon_sym_GT] = ACTIONS(5136),
    [anon_sym_AMP] = ACTIONS(5136),
    [anon_sym_PERCENT] = ACTIONS(5134),
    [anon_sym_QMARK] = ACTIONS(5134),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [anon_sym_as] = ACTIONS(5134),
    [anon_sym_PIPE_PIPE] = ACTIONS(5134),
    [anon_sym_DASH_DASH] = ACTIONS(5134),
    [anon_sym_EQ_EQ] = ACTIONS(5136),
    [anon_sym_instanceof] = ACTIONS(5134),
    [anon_sym_LT] = ACTIONS(5136),
    [anon_sym_RPAREN] = ACTIONS(5134),
    [anon_sym_SLASH] = ACTIONS(5136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5134),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_STAR_STAR] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_GT_GT] = ACTIONS(5136),
    [anon_sym_PLUS_PLUS] = ACTIONS(5134),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5134),
    [anon_sym_in] = ACTIONS(5136),
  },
  [1533] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(5134),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5134),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [1534] = {
    [aux_sym_export_statement_repeat1] = STATE(1534),
    [sym_decorator] = STATE(1534),
    [anon_sym_get] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [sym_identifier] = ACTIONS(3007),
    [sym_readonly] = ACTIONS(3007),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_symbol] = ACTIONS(3007),
    [anon_sym_number] = ACTIONS(3007),
    [anon_sym_AT] = ACTIONS(2034),
    [anon_sym_declare] = ACTIONS(3007),
    [anon_sym_this] = ACTIONS(3007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(3007),
    [anon_sym_protected] = ACTIONS(3007),
    [anon_sym_string] = ACTIONS(3007),
    [anon_sym_set] = ACTIONS(3007),
    [anon_sym_type] = ACTIONS(3007),
    [anon_sym_import] = ACTIONS(3007),
    [anon_sym_export] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3007),
    [anon_sym_any] = ACTIONS(3007),
    [anon_sym_private] = ACTIONS(3007),
    [anon_sym_boolean] = ACTIONS(3007),
    [anon_sym_async] = ACTIONS(3007),
    [anon_sym_public] = ACTIONS(3007),
  },
  [1535] = {
    [sym_statement_block] = STATE(2464),
    [sym__automatic_semicolon] = ACTIONS(5138),
    [anon_sym_SEMI] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(901),
  },
  [1536] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5140),
    [sym_identifier] = ACTIONS(5142),
    [sym__automatic_semicolon] = ACTIONS(5140),
    [anon_sym_BQUOTE] = ACTIONS(5140),
    [anon_sym_debugger] = ACTIONS(5142),
    [ts_builtin_sym_end] = ACTIONS(5140),
    [anon_sym_symbol] = ACTIONS(5142),
    [anon_sym_AT] = ACTIONS(5140),
    [anon_sym_PIPE] = ACTIONS(5142),
    [anon_sym_COMMA] = ACTIONS(5140),
    [anon_sym_DASH] = ACTIONS(5142),
    [anon_sym_STAR] = ACTIONS(5142),
    [anon_sym_GT_GT_GT] = ACTIONS(5140),
    [anon_sym_void] = ACTIONS(5142),
    [anon_sym_break] = ACTIONS(5142),
    [anon_sym_BANG_EQ] = ACTIONS(5142),
    [anon_sym_const] = ACTIONS(5142),
    [anon_sym_GT_EQ] = ACTIONS(5140),
    [sym_super] = ACTIONS(5142),
    [anon_sym_return] = ACTIONS(5142),
    [anon_sym_private] = ACTIONS(5142),
    [anon_sym_get] = ACTIONS(5142),
    [anon_sym_RBRACE] = ACTIONS(5140),
    [anon_sym_PERCENT] = ACTIONS(5140),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_default] = ACTIONS(5142),
    [anon_sym_as] = ACTIONS(5142),
    [anon_sym_delete] = ACTIONS(5142),
    [anon_sym_continue] = ACTIONS(5142),
    [anon_sym_DASH_DASH] = ACTIONS(5140),
    [anon_sym_if] = ACTIONS(5142),
    [anon_sym_instanceof] = ACTIONS(5142),
    [anon_sym_this] = ACTIONS(5142),
    [anon_sym_yield] = ACTIONS(5142),
    [sym_true] = ACTIONS(5142),
    [anon_sym_throw] = ACTIONS(5142),
    [anon_sym_enum] = ACTIONS(5142),
    [anon_sym_protected] = ACTIONS(5142),
    [anon_sym_abstract] = ACTIONS(5142),
    [anon_sym_DOT] = ACTIONS(5142),
    [anon_sym_set] = ACTIONS(5142),
    [anon_sym_type] = ACTIONS(5142),
    [anon_sym_STAR_STAR] = ACTIONS(5140),
    [anon_sym_import] = ACTIONS(5142),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5140),
    [anon_sym_namespace] = ACTIONS(5142),
    [anon_sym_PLUS_PLUS] = ACTIONS(5140),
    [anon_sym_await] = ACTIONS(5142),
    [anon_sym_DQUOTE] = ACTIONS(5140),
    [anon_sym_else] = ACTIONS(5142),
    [anon_sym_BANG] = ACTIONS(5142),
    [anon_sym_for] = ACTIONS(5142),
    [anon_sym_LBRACK] = ACTIONS(5140),
    [sym_false] = ACTIONS(5142),
    [anon_sym_SEMI] = ACTIONS(5140),
    [anon_sym_case] = ACTIONS(5142),
    [anon_sym_module] = ACTIONS(5142),
    [anon_sym_number] = ACTIONS(5142),
    [anon_sym_class] = ACTIONS(5142),
    [anon_sym_declare] = ACTIONS(5142),
    [anon_sym_typeof] = ACTIONS(5142),
    [anon_sym_LT_LT] = ACTIONS(5140),
    [anon_sym_LBRACE] = ACTIONS(5140),
    [anon_sym_AMP_AMP] = ACTIONS(5140),
    [anon_sym_switch] = ACTIONS(5142),
    [anon_sym_LT_EQ] = ACTIONS(5140),
    [anon_sym_LPAREN] = ACTIONS(5140),
    [sym_null] = ACTIONS(5142),
    [anon_sym_GT] = ACTIONS(5142),
    [anon_sym_any] = ACTIONS(5142),
    [anon_sym_boolean] = ACTIONS(5142),
    [anon_sym_async] = ACTIONS(5142),
    [anon_sym_public] = ACTIONS(5142),
    [anon_sym_AMP] = ACTIONS(5142),
    [anon_sym_var] = ACTIONS(5142),
    [anon_sym_QMARK] = ACTIONS(5140),
    [anon_sym_PIPE_PIPE] = ACTIONS(5140),
    [anon_sym_while] = ACTIONS(5142),
    [anon_sym_SQUOTE] = ACTIONS(5140),
    [anon_sym_try] = ACTIONS(5142),
    [anon_sym_EQ_EQ] = ACTIONS(5142),
    [anon_sym_RPAREN] = ACTIONS(5140),
    [anon_sym_LT] = ACTIONS(5142),
    [sym_number] = ACTIONS(5140),
    [anon_sym_SLASH] = ACTIONS(5142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5142),
    [anon_sym_function] = ACTIONS(5142),
    [sym_undefined] = ACTIONS(5142),
    [anon_sym_new] = ACTIONS(5142),
    [anon_sym_CARET] = ACTIONS(5140),
    [anon_sym_let] = ACTIONS(5142),
    [anon_sym_PLUS] = ACTIONS(5142),
    [anon_sym_export] = ACTIONS(5142),
    [anon_sym_GT_GT] = ACTIONS(5142),
    [anon_sym_do] = ACTIONS(5142),
    [anon_sym_TILDE] = ACTIONS(5140),
    [anon_sym_with] = ACTIONS(5142),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5140),
    [anon_sym_in] = ACTIONS(5142),
  },
  [1537] = {
    [sym_identifier] = ACTIONS(5144),
    [anon_sym_BQUOTE] = ACTIONS(5146),
    [anon_sym_debugger] = ACTIONS(5144),
    [anon_sym_symbol] = ACTIONS(5144),
    [anon_sym_AT] = ACTIONS(5146),
    [anon_sym_DASH] = ACTIONS(5144),
    [anon_sym_void] = ACTIONS(5144),
    [anon_sym_break] = ACTIONS(5144),
    [anon_sym_const] = ACTIONS(5144),
    [sym_super] = ACTIONS(5144),
    [anon_sym_return] = ACTIONS(5144),
    [anon_sym_private] = ACTIONS(5144),
    [anon_sym_get] = ACTIONS(5144),
    [anon_sym_RBRACE] = ACTIONS(5146),
    [anon_sym_interface] = ACTIONS(5144),
    [anon_sym_default] = ACTIONS(5144),
    [anon_sym_enum] = ACTIONS(5144),
    [anon_sym_delete] = ACTIONS(5144),
    [anon_sym_continue] = ACTIONS(5144),
    [anon_sym_DASH_DASH] = ACTIONS(5146),
    [anon_sym_if] = ACTIONS(5144),
    [anon_sym_this] = ACTIONS(5144),
    [anon_sym_yield] = ACTIONS(5144),
    [sym_true] = ACTIONS(5144),
    [anon_sym_throw] = ACTIONS(5144),
    [anon_sym_protected] = ACTIONS(5144),
    [anon_sym_abstract] = ACTIONS(5144),
    [anon_sym_set] = ACTIONS(5144),
    [anon_sym_type] = ACTIONS(5144),
    [anon_sym_import] = ACTIONS(5144),
    [anon_sym_namespace] = ACTIONS(5144),
    [anon_sym_PLUS_PLUS] = ACTIONS(5146),
    [anon_sym_await] = ACTIONS(5144),
    [anon_sym_DQUOTE] = ACTIONS(5146),
    [anon_sym_else] = ACTIONS(5144),
    [anon_sym_BANG] = ACTIONS(5146),
    [anon_sym_for] = ACTIONS(5144),
    [anon_sym_LBRACK] = ACTIONS(5146),
    [sym_false] = ACTIONS(5144),
    [anon_sym_SEMI] = ACTIONS(5146),
    [anon_sym_case] = ACTIONS(5144),
    [anon_sym_module] = ACTIONS(5144),
    [anon_sym_number] = ACTIONS(5144),
    [anon_sym_class] = ACTIONS(5144),
    [anon_sym_declare] = ACTIONS(5144),
    [anon_sym_typeof] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(5146),
    [anon_sym_switch] = ACTIONS(5144),
    [anon_sym_LPAREN] = ACTIONS(5146),
    [sym_null] = ACTIONS(5144),
    [anon_sym_any] = ACTIONS(5144),
    [anon_sym_boolean] = ACTIONS(5144),
    [anon_sym_async] = ACTIONS(5144),
    [anon_sym_public] = ACTIONS(5144),
    [anon_sym_var] = ACTIONS(5144),
    [anon_sym_while] = ACTIONS(5144),
    [anon_sym_SQUOTE] = ACTIONS(5146),
    [anon_sym_try] = ACTIONS(5144),
    [anon_sym_LT] = ACTIONS(5146),
    [sym_number] = ACTIONS(5146),
    [anon_sym_SLASH] = ACTIONS(5144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5144),
    [anon_sym_function] = ACTIONS(5144),
    [sym_undefined] = ACTIONS(5144),
    [anon_sym_new] = ACTIONS(5144),
    [ts_builtin_sym_end] = ACTIONS(5146),
    [anon_sym_let] = ACTIONS(5144),
    [anon_sym_PLUS] = ACTIONS(5144),
    [anon_sym_export] = ACTIONS(5144),
    [anon_sym_do] = ACTIONS(5144),
    [anon_sym_TILDE] = ACTIONS(5146),
    [anon_sym_with] = ACTIONS(5144),
  },
  [1538] = {
    [sym_identifier] = ACTIONS(5148),
    [sym_comment] = ACTIONS(3),
  },
  [1539] = {
    [sym_identifier] = ACTIONS(5150),
    [anon_sym_BQUOTE] = ACTIONS(5152),
    [anon_sym_debugger] = ACTIONS(5150),
    [anon_sym_symbol] = ACTIONS(5150),
    [anon_sym_AT] = ACTIONS(5152),
    [anon_sym_DASH] = ACTIONS(5150),
    [anon_sym_void] = ACTIONS(5150),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_const] = ACTIONS(5150),
    [sym_super] = ACTIONS(5150),
    [anon_sym_return] = ACTIONS(5150),
    [anon_sym_private] = ACTIONS(5150),
    [anon_sym_get] = ACTIONS(5150),
    [anon_sym_RBRACE] = ACTIONS(5152),
    [anon_sym_interface] = ACTIONS(5150),
    [anon_sym_default] = ACTIONS(5150),
    [anon_sym_enum] = ACTIONS(5150),
    [anon_sym_delete] = ACTIONS(5150),
    [anon_sym_continue] = ACTIONS(5150),
    [anon_sym_DASH_DASH] = ACTIONS(5152),
    [anon_sym_if] = ACTIONS(5150),
    [anon_sym_this] = ACTIONS(5150),
    [anon_sym_yield] = ACTIONS(5150),
    [sym_true] = ACTIONS(5150),
    [anon_sym_throw] = ACTIONS(5150),
    [anon_sym_protected] = ACTIONS(5150),
    [anon_sym_abstract] = ACTIONS(5150),
    [anon_sym_set] = ACTIONS(5150),
    [anon_sym_type] = ACTIONS(5150),
    [anon_sym_import] = ACTIONS(5150),
    [anon_sym_namespace] = ACTIONS(5150),
    [anon_sym_PLUS_PLUS] = ACTIONS(5152),
    [anon_sym_await] = ACTIONS(5150),
    [anon_sym_DQUOTE] = ACTIONS(5152),
    [anon_sym_else] = ACTIONS(5150),
    [anon_sym_BANG] = ACTIONS(5152),
    [anon_sym_for] = ACTIONS(5150),
    [anon_sym_LBRACK] = ACTIONS(5152),
    [sym_false] = ACTIONS(5150),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym_case] = ACTIONS(5150),
    [anon_sym_module] = ACTIONS(5150),
    [anon_sym_number] = ACTIONS(5150),
    [anon_sym_class] = ACTIONS(5150),
    [anon_sym_declare] = ACTIONS(5150),
    [anon_sym_typeof] = ACTIONS(5150),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_switch] = ACTIONS(5150),
    [anon_sym_LPAREN] = ACTIONS(5152),
    [sym_null] = ACTIONS(5150),
    [anon_sym_any] = ACTIONS(5150),
    [anon_sym_boolean] = ACTIONS(5150),
    [anon_sym_async] = ACTIONS(5150),
    [anon_sym_public] = ACTIONS(5150),
    [anon_sym_var] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(5150),
    [anon_sym_SQUOTE] = ACTIONS(5152),
    [anon_sym_try] = ACTIONS(5150),
    [anon_sym_LT] = ACTIONS(5152),
    [sym_number] = ACTIONS(5152),
    [anon_sym_SLASH] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(5150),
    [anon_sym_string] = ACTIONS(5150),
    [anon_sym_function] = ACTIONS(5150),
    [sym_undefined] = ACTIONS(5150),
    [anon_sym_new] = ACTIONS(5150),
    [ts_builtin_sym_end] = ACTIONS(5152),
    [anon_sym_let] = ACTIONS(5150),
    [anon_sym_PLUS] = ACTIONS(5150),
    [anon_sym_export] = ACTIONS(5150),
    [anon_sym_do] = ACTIONS(5150),
    [anon_sym_TILDE] = ACTIONS(5152),
    [anon_sym_with] = ACTIONS(5150),
  },
  [1540] = {
    [sym_identifier] = ACTIONS(5154),
    [anon_sym_BQUOTE] = ACTIONS(5156),
    [anon_sym_debugger] = ACTIONS(5154),
    [anon_sym_symbol] = ACTIONS(5154),
    [anon_sym_AT] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_void] = ACTIONS(5154),
    [anon_sym_break] = ACTIONS(5154),
    [anon_sym_const] = ACTIONS(5154),
    [sym_super] = ACTIONS(5154),
    [anon_sym_return] = ACTIONS(5154),
    [anon_sym_private] = ACTIONS(5154),
    [anon_sym_get] = ACTIONS(5154),
    [anon_sym_RBRACE] = ACTIONS(5156),
    [anon_sym_interface] = ACTIONS(5154),
    [anon_sym_default] = ACTIONS(5154),
    [anon_sym_enum] = ACTIONS(5154),
    [anon_sym_delete] = ACTIONS(5154),
    [anon_sym_continue] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5156),
    [anon_sym_if] = ACTIONS(5154),
    [anon_sym_this] = ACTIONS(5154),
    [anon_sym_yield] = ACTIONS(5154),
    [sym_true] = ACTIONS(5154),
    [anon_sym_throw] = ACTIONS(5154),
    [anon_sym_protected] = ACTIONS(5154),
    [anon_sym_abstract] = ACTIONS(5154),
    [anon_sym_set] = ACTIONS(5154),
    [anon_sym_type] = ACTIONS(5154),
    [anon_sym_import] = ACTIONS(5154),
    [anon_sym_namespace] = ACTIONS(5154),
    [anon_sym_PLUS_PLUS] = ACTIONS(5156),
    [anon_sym_await] = ACTIONS(5154),
    [anon_sym_DQUOTE] = ACTIONS(5156),
    [anon_sym_else] = ACTIONS(5154),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_for] = ACTIONS(5154),
    [anon_sym_LBRACK] = ACTIONS(5156),
    [sym_false] = ACTIONS(5154),
    [anon_sym_SEMI] = ACTIONS(5156),
    [anon_sym_case] = ACTIONS(5154),
    [anon_sym_module] = ACTIONS(5154),
    [anon_sym_number] = ACTIONS(5154),
    [anon_sym_class] = ACTIONS(5154),
    [anon_sym_declare] = ACTIONS(5154),
    [anon_sym_typeof] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_switch] = ACTIONS(5154),
    [anon_sym_LPAREN] = ACTIONS(5156),
    [sym_null] = ACTIONS(5154),
    [anon_sym_any] = ACTIONS(5154),
    [anon_sym_boolean] = ACTIONS(5154),
    [anon_sym_async] = ACTIONS(5154),
    [anon_sym_public] = ACTIONS(5154),
    [anon_sym_var] = ACTIONS(5154),
    [anon_sym_while] = ACTIONS(5154),
    [anon_sym_SQUOTE] = ACTIONS(5156),
    [anon_sym_try] = ACTIONS(5154),
    [anon_sym_LT] = ACTIONS(5156),
    [sym_number] = ACTIONS(5156),
    [anon_sym_SLASH] = ACTIONS(5154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5154),
    [anon_sym_function] = ACTIONS(5154),
    [sym_undefined] = ACTIONS(5154),
    [anon_sym_new] = ACTIONS(5154),
    [ts_builtin_sym_end] = ACTIONS(5156),
    [anon_sym_let] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_export] = ACTIONS(5154),
    [anon_sym_do] = ACTIONS(5154),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_with] = ACTIONS(5154),
  },
  [1541] = {
    [sym_identifier] = ACTIONS(5158),
    [anon_sym_BQUOTE] = ACTIONS(5160),
    [anon_sym_debugger] = ACTIONS(5158),
    [anon_sym_symbol] = ACTIONS(5158),
    [anon_sym_AT] = ACTIONS(5160),
    [anon_sym_DASH] = ACTIONS(5158),
    [anon_sym_void] = ACTIONS(5158),
    [anon_sym_break] = ACTIONS(5158),
    [anon_sym_const] = ACTIONS(5158),
    [sym_super] = ACTIONS(5158),
    [anon_sym_return] = ACTIONS(5158),
    [anon_sym_private] = ACTIONS(5158),
    [anon_sym_get] = ACTIONS(5158),
    [anon_sym_RBRACE] = ACTIONS(5160),
    [anon_sym_interface] = ACTIONS(5158),
    [anon_sym_default] = ACTIONS(5158),
    [anon_sym_enum] = ACTIONS(5158),
    [anon_sym_delete] = ACTIONS(5158),
    [anon_sym_continue] = ACTIONS(5158),
    [anon_sym_DASH_DASH] = ACTIONS(5160),
    [anon_sym_if] = ACTIONS(5158),
    [anon_sym_this] = ACTIONS(5158),
    [anon_sym_yield] = ACTIONS(5158),
    [sym_true] = ACTIONS(5158),
    [anon_sym_throw] = ACTIONS(5158),
    [anon_sym_protected] = ACTIONS(5158),
    [anon_sym_abstract] = ACTIONS(5158),
    [anon_sym_set] = ACTIONS(5158),
    [anon_sym_type] = ACTIONS(5158),
    [anon_sym_import] = ACTIONS(5158),
    [anon_sym_namespace] = ACTIONS(5158),
    [anon_sym_PLUS_PLUS] = ACTIONS(5160),
    [anon_sym_await] = ACTIONS(5158),
    [anon_sym_DQUOTE] = ACTIONS(5160),
    [anon_sym_else] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_for] = ACTIONS(5158),
    [anon_sym_LBRACK] = ACTIONS(5160),
    [sym_false] = ACTIONS(5158),
    [anon_sym_SEMI] = ACTIONS(5160),
    [anon_sym_case] = ACTIONS(5158),
    [anon_sym_module] = ACTIONS(5158),
    [anon_sym_number] = ACTIONS(5158),
    [anon_sym_class] = ACTIONS(5158),
    [anon_sym_declare] = ACTIONS(5158),
    [anon_sym_typeof] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(5160),
    [anon_sym_switch] = ACTIONS(5158),
    [anon_sym_LPAREN] = ACTIONS(5160),
    [sym_null] = ACTIONS(5158),
    [anon_sym_any] = ACTIONS(5158),
    [anon_sym_boolean] = ACTIONS(5158),
    [anon_sym_async] = ACTIONS(5158),
    [anon_sym_public] = ACTIONS(5158),
    [anon_sym_var] = ACTIONS(5158),
    [anon_sym_while] = ACTIONS(5158),
    [anon_sym_SQUOTE] = ACTIONS(5160),
    [anon_sym_try] = ACTIONS(5158),
    [anon_sym_LT] = ACTIONS(5160),
    [sym_number] = ACTIONS(5160),
    [anon_sym_SLASH] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5158),
    [anon_sym_function] = ACTIONS(5158),
    [sym_undefined] = ACTIONS(5158),
    [anon_sym_new] = ACTIONS(5158),
    [ts_builtin_sym_end] = ACTIONS(5160),
    [anon_sym_let] = ACTIONS(5158),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_export] = ACTIONS(5158),
    [anon_sym_do] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [anon_sym_with] = ACTIONS(5158),
  },
  [1542] = {
    [anon_sym_GT] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
  },
  [1543] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(5164),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5166),
  },
  [1544] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1545] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1549),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1551),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1546] = {
    [sym_formal_parameters] = STATE(2468),
    [sym_type_parameters] = STATE(2469),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1547] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1549),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1551),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1548] = {
    [anon_sym_EQ] = ACTIONS(5168),
    [anon_sym_GT] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_COMMA] = ACTIONS(5168),
    [sym_comment] = ACTIONS(3),
  },
  [1549] = {
    [sym_formal_parameters] = STATE(2472),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1550] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5174),
  },
  [1551] = {
    [anon_sym_EQ_GT] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
  },
  [1552] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_is] = ACTIONS(5178),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_RBRACK] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5180),
  },
  [1553] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1554] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1555] = {
    [sym_formal_parameters] = STATE(2477),
    [sym_type_parameters] = STATE(2478),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1556] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1557] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(5186),
    [sym_comment] = ACTIONS(3),
  },
  [1558] = {
    [sym_formal_parameters] = STATE(2482),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1559] = {
    [sym_type_arguments] = STATE(850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_RBRACK] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(5188),
  },
  [1560] = {
    [anon_sym_EQ_GT] = ACTIONS(5190),
    [sym_comment] = ACTIONS(3),
  },
  [1561] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_BQUOTE] = ACTIONS(5194),
    [anon_sym_debugger] = ACTIONS(5192),
    [anon_sym_symbol] = ACTIONS(5192),
    [anon_sym_AT] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_EQ] = ACTIONS(5192),
    [anon_sym_void] = ACTIONS(5192),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_const] = ACTIONS(5192),
    [sym_super] = ACTIONS(5192),
    [anon_sym_return] = ACTIONS(5192),
    [anon_sym_private] = ACTIONS(5192),
    [anon_sym_get] = ACTIONS(5192),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_interface] = ACTIONS(5192),
    [anon_sym_default] = ACTIONS(5192),
    [anon_sym_enum] = ACTIONS(5192),
    [anon_sym_delete] = ACTIONS(5192),
    [anon_sym_continue] = ACTIONS(5192),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_if] = ACTIONS(5192),
    [anon_sym_this] = ACTIONS(5192),
    [anon_sym_yield] = ACTIONS(5192),
    [sym_true] = ACTIONS(5192),
    [anon_sym_throw] = ACTIONS(5192),
    [anon_sym_protected] = ACTIONS(5192),
    [anon_sym_abstract] = ACTIONS(5192),
    [anon_sym_DOT] = ACTIONS(4365),
    [anon_sym_set] = ACTIONS(5192),
    [anon_sym_type] = ACTIONS(5192),
    [anon_sym_import] = ACTIONS(5192),
    [anon_sym_namespace] = ACTIONS(5192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_await] = ACTIONS(5192),
    [anon_sym_DQUOTE] = ACTIONS(5194),
    [anon_sym_else] = ACTIONS(5192),
    [anon_sym_BANG] = ACTIONS(5194),
    [anon_sym_for] = ACTIONS(5192),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [sym_false] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym_case] = ACTIONS(5192),
    [anon_sym_module] = ACTIONS(5192),
    [anon_sym_number] = ACTIONS(5192),
    [anon_sym_class] = ACTIONS(5192),
    [anon_sym_declare] = ACTIONS(5192),
    [anon_sym_typeof] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5192),
    [anon_sym_switch] = ACTIONS(5192),
    [anon_sym_LPAREN] = ACTIONS(5194),
    [anon_sym_RBRACK] = ACTIONS(5194),
    [sym_null] = ACTIONS(5192),
    [anon_sym_GT] = ACTIONS(5194),
    [anon_sym_any] = ACTIONS(5192),
    [anon_sym_boolean] = ACTIONS(5192),
    [anon_sym_async] = ACTIONS(5192),
    [anon_sym_public] = ACTIONS(5192),
    [anon_sym_EQ_GT] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5194),
    [anon_sym_var] = ACTIONS(5192),
    [anon_sym_while] = ACTIONS(5192),
    [anon_sym_SQUOTE] = ACTIONS(5194),
    [anon_sym_try] = ACTIONS(5192),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LT] = ACTIONS(5194),
    [sym_number] = ACTIONS(5194),
    [anon_sym_SLASH] = ACTIONS(5192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5192),
    [anon_sym_function] = ACTIONS(5192),
    [sym_undefined] = ACTIONS(5192),
    [anon_sym_new] = ACTIONS(5192),
    [ts_builtin_sym_end] = ACTIONS(5194),
    [anon_sym_let] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_implements] = ACTIONS(5192),
    [anon_sym_export] = ACTIONS(5192),
    [anon_sym_do] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5194),
    [anon_sym_with] = ACTIONS(5192),
    [anon_sym_in] = ACTIONS(5192),
  },
  [1562] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1563] = {
    [sym_formal_parameters] = STATE(2485),
    [sym_type_parameters] = STATE(2486),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1564] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1565] = {
    [anon_sym_GT] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(5198),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_COMMA] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
  },
  [1566] = {
    [sym_formal_parameters] = STATE(2489),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1567] = {
    [anon_sym_EQ_GT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(3),
  },
  [1568] = {
    [anon_sym_GT] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(5198),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_COMMA] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
  },
  [1569] = {
    [anon_sym_COMMA] = ACTIONS(5206),
    [anon_sym_GT] = ACTIONS(5206),
    [sym_comment] = ACTIONS(3),
  },
  [1570] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_AMP_EQ] = ACTIONS(4661),
    [anon_sym_PLUS_EQ] = ACTIONS(4661),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_DASH_EQ] = ACTIONS(4661),
    [anon_sym_EQ_GT] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4661),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5208),
    [anon_sym_SLASH_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4671),
  },
  [1571] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1572] = {
    [sym_new_expression] = STATE(2252),
    [sym_augmented_assignment_expression] = STATE(2252),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(2252),
    [sym_update_expression] = STATE(2252),
    [sym_regex] = STATE(2252),
    [sym_meta_property] = STATE(2252),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2252),
    [sym_yield_expression] = STATE(2252),
    [sym_as_expression] = STATE(2252),
    [sym_non_null_expression] = STATE(2252),
    [sym_internal_module] = STATE(2252),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2252),
    [sym_await_expression] = STATE(2252),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2252),
    [sym_this] = STATE(2252),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2252),
    [sym_generator_function] = STATE(2252),
    [sym_call_expression] = STATE(2252),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2252),
    [sym_ternary_expression] = STATE(2252),
    [sym_binary_expression] = STATE(2252),
    [sym_template_string] = STATE(2252),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2252),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2252),
    [sym_class] = STATE(2252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(2779),
    [sym_true] = ACTIONS(4679),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4679),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(4679),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4681),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4679),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1573] = {
    [sym_call_signature] = STATE(2254),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_symbol] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_void] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_private] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_get] = ACTIONS(4689),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_protected] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(4689),
    [anon_sym_type] = ACTIONS(4689),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4689),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_namespace] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4689),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_number] = ACTIONS(4689),
    [anon_sym_declare] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_boolean] = ACTIONS(4689),
    [anon_sym_async] = ACTIONS(4689),
    [anon_sym_public] = ACTIONS(4689),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_string] = ACTIONS(4689),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1574] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1575] = {
    [anon_sym_RBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
  },
  [1576] = {
    [aux_sym_object_type_repeat1] = STATE(2496),
    [sym__automatic_semicolon] = ACTIONS(5214),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_SEMI] = ACTIONS(5214),
    [anon_sym_COMMA] = ACTIONS(5214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5216),
    [sym_comment] = ACTIONS(3),
  },
  [1577] = {
    [sym_call_signature] = STATE(2498),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(5218),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [1578] = {
    [anon_sym_COLON] = ACTIONS(1368),
    [anon_sym_RBRACE] = ACTIONS(1368),
    [sym__automatic_semicolon] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1368),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1368),
    [anon_sym_COMMA] = ACTIONS(1368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1368),
  },
  [1579] = {
    [aux_sym_export_statement_repeat1] = STATE(1534),
    [sym_decorator] = STATE(1534),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(2499),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(2499),
    [sym_optional_parameter] = STATE(2499),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [1580] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2502),
    [anon_sym_COMMA] = ACTIONS(5220),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [sym_comment] = ACTIONS(3),
  },
  [1581] = {
    [sym_string] = STATE(2503),
    [sym__property_name] = STATE(2503),
    [sym_computed_property_name] = STATE(2503),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(5224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [1582] = {
    [sym_string] = STATE(2507),
    [sym__property_name] = STATE(2507),
    [sym_computed_property_name] = STATE(2507),
    [anon_sym_get] = ACTIONS(5226),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(5228),
    [anon_sym_STAR] = ACTIONS(5230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(5226),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(5232),
  },
  [1583] = {
    [sym_string] = STATE(2503),
    [sym__property_name] = STATE(2503),
    [sym_computed_property_name] = STATE(2503),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(5224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [1584] = {
    [sym_string] = STATE(2503),
    [sym__property_name] = STATE(2503),
    [sym_computed_property_name] = STATE(2503),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(5230),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(5234),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(5224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(5234),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [1585] = {
    [sym_call_signature] = STATE(2498),
    [sym_type_annotation] = STATE(2510),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [sym__automatic_semicolon] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
  },
  [1586] = {
    [sym_string] = STATE(2503),
    [sym__property_name] = STATE(2503),
    [sym_computed_property_name] = STATE(2503),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(5224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [1587] = {
    [sym_type_annotation] = STATE(2511),
    [sym__automatic_semicolon] = ACTIONS(5240),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5240),
    [sym_comment] = ACTIONS(3),
  },
  [1588] = {
    [sym_formal_parameters] = STATE(2512),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [1589] = {
    [sym_variable_declarator] = STATE(2513),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1590] = {
    [sym_identifier] = ACTIONS(5242),
    [sym_comment] = ACTIONS(3),
  },
  [1591] = {
    [sym_new_expression] = STATE(2515),
    [sym_augmented_assignment_expression] = STATE(2515),
    [sym_unary_expression] = STATE(2515),
    [sym_update_expression] = STATE(2515),
    [sym_regex] = STATE(2515),
    [sym_meta_property] = STATE(2515),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(2515),
    [sym_yield_expression] = STATE(2515),
    [sym_as_expression] = STATE(2515),
    [sym_non_null_expression] = STATE(2515),
    [sym_internal_module] = STATE(2515),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2515),
    [sym_await_expression] = STATE(2515),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2515),
    [sym_this] = STATE(2515),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2515),
    [sym_generator_function] = STATE(2515),
    [sym_call_expression] = STATE(2515),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2515),
    [sym_ternary_expression] = STATE(2515),
    [sym_binary_expression] = STATE(2515),
    [sym_template_string] = STATE(2515),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2515),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2515),
    [sym_class] = STATE(2515),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5244),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5244),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5246),
    [sym_true] = ACTIONS(5244),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5244),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1592] = {
    [sym_identifier] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
  },
  [1593] = {
    [sym_string] = STATE(129),
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(2517),
    [sym_identifier] = ACTIONS(5250),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [1594] = {
    [anon_sym_namespace] = ACTIONS(5252),
    [sym_comment] = ACTIONS(3),
  },
  [1595] = {
    [sym_identifier] = ACTIONS(5254),
    [sym_comment] = ACTIONS(3),
  },
  [1596] = {
    [sym_type_alias_declaration] = STATE(2521),
    [aux_sym_export_statement_repeat1] = STATE(1608),
    [sym__declaration] = STATE(2521),
    [sym_ambient_declaration] = STATE(2521),
    [sym_import_alias] = STATE(2521),
    [sym_export_statement] = STATE(2521),
    [sym_generator_function] = STATE(2521),
    [sym_lexical_declaration] = STATE(2521),
    [sym_internal_module] = STATE(2521),
    [sym_decorator] = STATE(1608),
    [sym_enum_declaration] = STATE(2521),
    [sym_function] = STATE(2521),
    [sym_function_signature] = STATE(2521),
    [sym_variable_declaration] = STATE(2521),
    [sym_abstract_class] = STATE(2521),
    [sym_module] = STATE(2521),
    [sym_interface_declaration] = STATE(2521),
    [sym_class] = STATE(2521),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_module] = ACTIONS(5256),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_global] = ACTIONS(5258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_import] = ACTIONS(3337),
    [anon_sym_export] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3341),
    [anon_sym_async] = ACTIONS(3317),
  },
  [1597] = {
    [sym__from_clause] = STATE(2522),
    [anon_sym_from] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
  },
  [1598] = {
    [sym_identifier] = ACTIONS(5260),
    [sym_comment] = ACTIONS(3),
  },
  [1599] = {
    [sym_call_signature] = STATE(289),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(5262),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [anon_sym_STAR] = ACTIONS(502),
    [sym_comment] = ACTIONS(3),
  },
  [1600] = {
    [sym_variable_declarator] = STATE(2525),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_enum] = ACTIONS(5264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1601] = {
    [anon_sym_class] = ACTIONS(5266),
    [sym_comment] = ACTIONS(3),
  },
  [1602] = {
    [sym_identifier] = ACTIONS(5268),
    [sym_comment] = ACTIONS(3),
  },
  [1603] = {
    [sym_variable_declarator] = STATE(2525),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1604] = {
    [sym_identifier] = ACTIONS(5270),
    [sym_comment] = ACTIONS(3),
  },
  [1605] = {
    [sym_type_alias_declaration] = STATE(1609),
    [aux_sym_export_statement_repeat1] = STATE(1608),
    [sym__declaration] = STATE(1609),
    [sym_ambient_declaration] = STATE(1609),
    [sym_import_alias] = STATE(1609),
    [sym_export_statement] = STATE(1609),
    [sym_generator_function] = STATE(1609),
    [sym_export_clause] = STATE(1610),
    [sym_lexical_declaration] = STATE(1609),
    [sym_internal_module] = STATE(1609),
    [sym_decorator] = STATE(1608),
    [sym_enum_declaration] = STATE(1609),
    [sym_function] = STATE(1609),
    [sym_function_signature] = STATE(1609),
    [sym_variable_declaration] = STATE(1609),
    [sym_abstract_class] = STATE(1609),
    [sym_module] = STATE(1609),
    [sym_interface_declaration] = STATE(1609),
    [sym_class] = STATE(1609),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_as] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(3313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_import] = ACTIONS(3337),
    [anon_sym_export] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3341),
    [anon_sym_async] = ACTIONS(3317),
  },
  [1606] = {
    [sym_string] = STATE(129),
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_identifier] = ACTIONS(5250),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [1607] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(5272),
  },
  [1608] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(3343),
    [anon_sym_class] = ACTIONS(5274),
    [sym_comment] = ACTIONS(3),
  },
  [1609] = {
    [sym__automatic_semicolon] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1705),
    [sym_comment] = ACTIONS(3),
  },
  [1610] = {
    [sym__from_clause] = STATE(2522),
    [sym__automatic_semicolon] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(5276),
    [anon_sym_from] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
  },
  [1611] = {
    [sym_type_alias_declaration] = STATE(2531),
    [aux_sym_export_statement_repeat1] = STATE(1608),
    [sym__declaration] = STATE(2531),
    [sym_ambient_declaration] = STATE(2531),
    [sym_import_alias] = STATE(2531),
    [sym_export_statement] = STATE(2531),
    [sym_generator_function] = STATE(2531),
    [sym_lexical_declaration] = STATE(2531),
    [sym_internal_module] = STATE(2531),
    [sym_decorator] = STATE(1608),
    [sym_enum_declaration] = STATE(2531),
    [sym_function] = STATE(2531),
    [sym_function_signature] = STATE(2531),
    [sym_variable_declaration] = STATE(2531),
    [sym_abstract_class] = STATE(2531),
    [sym_module] = STATE(2531),
    [sym_interface_declaration] = STATE(2531),
    [sym_class] = STATE(2531),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(5278),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_import] = ACTIONS(3337),
    [anon_sym_export] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3341),
    [anon_sym_async] = ACTIONS(3317),
  },
  [1612] = {
    [aux_sym_export_statement_repeat1] = STATE(1612),
    [sym_decorator] = STATE(1612),
    [anon_sym_export] = ACTIONS(2032),
    [anon_sym_AT] = ACTIONS(2034),
    [sym_comment] = ACTIONS(3),
  },
  [1613] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2538),
    [sym_constructor_type] = STATE(2538),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(2538),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2538),
    [sym_intersection_type] = STATE(2538),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2539),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2541),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5286),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1614] = {
    [sym_call_signature] = STATE(2498),
    [sym_type_annotation] = STATE(2510),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [sym__automatic_semicolon] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
  },
  [1615] = {
    [sym__automatic_semicolon] = ACTIONS(4777),
    [anon_sym_RBRACE] = ACTIONS(4777),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_COMMA] = ACTIONS(4777),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4777),
    [sym_comment] = ACTIONS(3),
  },
  [1616] = {
    [sym__automatic_semicolon] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
  },
  [1617] = {
    [sym_string] = STATE(2507),
    [sym__property_name] = STATE(2507),
    [sym_computed_property_name] = STATE(2507),
    [anon_sym_get] = ACTIONS(5226),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_async] = ACTIONS(5232),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(5228),
    [anon_sym_STAR] = ACTIONS(5230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(5226),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(5290),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1618] = {
    [sym__automatic_semicolon] = ACTIONS(1739),
    [anon_sym_RBRACE] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(1739),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_COMMA] = ACTIONS(1739),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
  },
  [1619] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5216),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1620] = {
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_BQUOTE] = ACTIONS(5294),
    [anon_sym_debugger] = ACTIONS(5292),
    [anon_sym_symbol] = ACTIONS(5292),
    [anon_sym_AT] = ACTIONS(5294),
    [anon_sym_PIPE] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_DASH] = ACTIONS(5292),
    [anon_sym_EQ] = ACTIONS(5292),
    [anon_sym_void] = ACTIONS(5292),
    [anon_sym_break] = ACTIONS(5292),
    [anon_sym_const] = ACTIONS(5292),
    [sym_super] = ACTIONS(5292),
    [anon_sym_return] = ACTIONS(5292),
    [anon_sym_private] = ACTIONS(5292),
    [anon_sym_get] = ACTIONS(5292),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_interface] = ACTIONS(5292),
    [anon_sym_default] = ACTIONS(5292),
    [anon_sym_enum] = ACTIONS(5292),
    [anon_sym_delete] = ACTIONS(5292),
    [anon_sym_continue] = ACTIONS(5292),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_if] = ACTIONS(5292),
    [anon_sym_this] = ACTIONS(5292),
    [anon_sym_yield] = ACTIONS(5292),
    [sym_true] = ACTIONS(5292),
    [anon_sym_throw] = ACTIONS(5292),
    [anon_sym_protected] = ACTIONS(5292),
    [anon_sym_abstract] = ACTIONS(5292),
    [anon_sym_set] = ACTIONS(5292),
    [anon_sym_type] = ACTIONS(5292),
    [anon_sym_import] = ACTIONS(5292),
    [anon_sym_namespace] = ACTIONS(5292),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_await] = ACTIONS(5292),
    [anon_sym_DQUOTE] = ACTIONS(5294),
    [anon_sym_else] = ACTIONS(5292),
    [anon_sym_BANG] = ACTIONS(5294),
    [anon_sym_for] = ACTIONS(5292),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [sym_false] = ACTIONS(5292),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_case] = ACTIONS(5292),
    [anon_sym_module] = ACTIONS(5292),
    [anon_sym_number] = ACTIONS(5292),
    [anon_sym_class] = ACTIONS(5292),
    [anon_sym_declare] = ACTIONS(5292),
    [anon_sym_typeof] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_switch] = ACTIONS(5292),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RBRACK] = ACTIONS(5294),
    [sym_null] = ACTIONS(5292),
    [anon_sym_GT] = ACTIONS(5294),
    [anon_sym_any] = ACTIONS(5292),
    [anon_sym_boolean] = ACTIONS(5292),
    [anon_sym_async] = ACTIONS(5292),
    [anon_sym_public] = ACTIONS(5292),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [anon_sym_AMP] = ACTIONS(5294),
    [anon_sym_var] = ACTIONS(5292),
    [anon_sym_while] = ACTIONS(5292),
    [anon_sym_SQUOTE] = ACTIONS(5294),
    [anon_sym_try] = ACTIONS(5292),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5294),
    [sym_number] = ACTIONS(5294),
    [anon_sym_SLASH] = ACTIONS(5292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5292),
    [anon_sym_function] = ACTIONS(5292),
    [sym_undefined] = ACTIONS(5292),
    [anon_sym_new] = ACTIONS(5292),
    [ts_builtin_sym_end] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5292),
    [anon_sym_PLUS] = ACTIONS(5292),
    [anon_sym_export] = ACTIONS(5292),
    [anon_sym_do] = ACTIONS(5292),
    [anon_sym_TILDE] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5292),
  },
  [1621] = {
    [aux_sym_object_type_repeat1] = STATE(2544),
    [sym__automatic_semicolon] = ACTIONS(5214),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_SEMI] = ACTIONS(5214),
    [anon_sym_COMMA] = ACTIONS(5214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5216),
    [sym_comment] = ACTIONS(3),
  },
  [1622] = {
    [sym_type_annotation] = STATE(2545),
    [sym__automatic_semicolon] = ACTIONS(1739),
    [anon_sym_RBRACE] = ACTIONS(1739),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_COMMA] = ACTIONS(1739),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
  },
  [1623] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2549),
    [sym_constructor_type] = STATE(2549),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(2549),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2549),
    [sym_intersection_type] = STATE(2549),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1624] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2552),
    [sym_constructor_type] = STATE(2552),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(2552),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2552),
    [sym_intersection_type] = STATE(2552),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1625] = {
    [anon_sym_EQ_GT] = ACTIONS(5302),
    [sym_comment] = ACTIONS(3),
  },
  [1626] = {
    [sym_formal_parameters] = STATE(2554),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1627] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1628] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1629] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2555),
    [sym_constructor_type] = STATE(2555),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(2555),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2555),
    [sym_intersection_type] = STATE(2555),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1630] = {
    [sym_identifier] = ACTIONS(5304),
    [anon_sym_BQUOTE] = ACTIONS(5306),
    [anon_sym_debugger] = ACTIONS(5304),
    [anon_sym_symbol] = ACTIONS(5304),
    [anon_sym_AT] = ACTIONS(5306),
    [anon_sym_PIPE] = ACTIONS(5306),
    [anon_sym_COMMA] = ACTIONS(5306),
    [anon_sym_DASH] = ACTIONS(5304),
    [anon_sym_EQ] = ACTIONS(5304),
    [anon_sym_void] = ACTIONS(5304),
    [anon_sym_break] = ACTIONS(5304),
    [anon_sym_const] = ACTIONS(5304),
    [sym_super] = ACTIONS(5304),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_private] = ACTIONS(5304),
    [anon_sym_get] = ACTIONS(5304),
    [anon_sym_RBRACE] = ACTIONS(5306),
    [anon_sym_interface] = ACTIONS(5304),
    [anon_sym_default] = ACTIONS(5304),
    [anon_sym_enum] = ACTIONS(5304),
    [anon_sym_delete] = ACTIONS(5304),
    [anon_sym_continue] = ACTIONS(5304),
    [anon_sym_DASH_DASH] = ACTIONS(5306),
    [anon_sym_if] = ACTIONS(5304),
    [anon_sym_this] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5304),
    [sym_true] = ACTIONS(5304),
    [anon_sym_throw] = ACTIONS(5304),
    [anon_sym_protected] = ACTIONS(5304),
    [anon_sym_abstract] = ACTIONS(5304),
    [anon_sym_set] = ACTIONS(5304),
    [anon_sym_type] = ACTIONS(5304),
    [anon_sym_import] = ACTIONS(5304),
    [anon_sym_namespace] = ACTIONS(5304),
    [anon_sym_PLUS_PLUS] = ACTIONS(5306),
    [anon_sym_await] = ACTIONS(5304),
    [anon_sym_DQUOTE] = ACTIONS(5306),
    [anon_sym_else] = ACTIONS(5304),
    [anon_sym_BANG] = ACTIONS(5306),
    [anon_sym_for] = ACTIONS(5304),
    [anon_sym_LBRACK] = ACTIONS(5306),
    [sym_false] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(5306),
    [anon_sym_case] = ACTIONS(5304),
    [anon_sym_module] = ACTIONS(5304),
    [anon_sym_number] = ACTIONS(5304),
    [anon_sym_class] = ACTIONS(5304),
    [anon_sym_declare] = ACTIONS(5304),
    [anon_sym_typeof] = ACTIONS(5304),
    [anon_sym_LBRACE] = ACTIONS(5306),
    [anon_sym_switch] = ACTIONS(5304),
    [anon_sym_LPAREN] = ACTIONS(5306),
    [anon_sym_RBRACK] = ACTIONS(5306),
    [sym_null] = ACTIONS(5304),
    [anon_sym_GT] = ACTIONS(5306),
    [anon_sym_any] = ACTIONS(5304),
    [anon_sym_boolean] = ACTIONS(5304),
    [anon_sym_async] = ACTIONS(5304),
    [anon_sym_public] = ACTIONS(5304),
    [anon_sym_EQ_GT] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5306),
    [anon_sym_var] = ACTIONS(5304),
    [anon_sym_while] = ACTIONS(5304),
    [anon_sym_SQUOTE] = ACTIONS(5306),
    [anon_sym_try] = ACTIONS(5304),
    [anon_sym_RPAREN] = ACTIONS(5306),
    [anon_sym_LT] = ACTIONS(5306),
    [sym_number] = ACTIONS(5306),
    [anon_sym_SLASH] = ACTIONS(5304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5304),
    [anon_sym_function] = ACTIONS(5304),
    [sym_undefined] = ACTIONS(5304),
    [anon_sym_new] = ACTIONS(5304),
    [ts_builtin_sym_end] = ACTIONS(5306),
    [anon_sym_let] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5304),
    [anon_sym_export] = ACTIONS(5304),
    [anon_sym_do] = ACTIONS(5304),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_with] = ACTIONS(5304),
  },
  [1631] = {
    [aux_sym_implements_clause_repeat1] = STATE(2557),
    [anon_sym_COMMA] = ACTIONS(3365),
    [anon_sym_RBRACK] = ACTIONS(5308),
    [sym_comment] = ACTIONS(3),
  },
  [1632] = {
    [anon_sym_EQ_GT] = ACTIONS(5310),
    [sym_comment] = ACTIONS(3),
  },
  [1633] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2559),
    [sym_constructor_type] = STATE(2559),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(2559),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2559),
    [sym_intersection_type] = STATE(2559),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1634] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2560),
    [sym_constructor_type] = STATE(2560),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(2560),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2560),
    [sym_intersection_type] = STATE(2560),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1635] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2561),
    [sym_constructor_type] = STATE(2561),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(2561),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2561),
    [sym_intersection_type] = STATE(2561),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1636] = {
    [anon_sym_EQ_GT] = ACTIONS(5312),
    [sym_comment] = ACTIONS(3),
  },
  [1637] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_AMP_EQ] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(3357),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3884),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_CARET_EQ] = ACTIONS(929),
    [anon_sym_STAR_EQ] = ACTIONS(929),
    [anon_sym_PIPE_EQ] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
    [anon_sym_EQ_GT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(5314),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5316),
  },
  [1638] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(3897),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1639] = {
    [sym_new_expression] = STATE(529),
    [sym_augmented_assignment_expression] = STATE(529),
    [sym_unary_expression] = STATE(529),
    [sym_update_expression] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_meta_property] = STATE(529),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(529),
    [sym_yield_expression] = STATE(529),
    [sym_as_expression] = STATE(529),
    [sym_non_null_expression] = STATE(529),
    [sym_internal_module] = STATE(529),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(529),
    [sym_await_expression] = STATE(529),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(529),
    [sym_this] = STATE(529),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(529),
    [sym_generator_function] = STATE(529),
    [sym_call_expression] = STATE(529),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(529),
    [sym_ternary_expression] = STATE(529),
    [sym_binary_expression] = STATE(529),
    [sym_template_string] = STATE(529),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(529),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(529),
    [sym_class] = STATE(529),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(957),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5318),
    [sym_true] = ACTIONS(957),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(957),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1640] = {
    [sym_new_expression] = STATE(528),
    [sym_augmented_assignment_expression] = STATE(528),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(528),
    [sym_update_expression] = STATE(528),
    [sym_regex] = STATE(528),
    [sym_meta_property] = STATE(528),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(528),
    [sym_yield_expression] = STATE(528),
    [sym_as_expression] = STATE(528),
    [sym_non_null_expression] = STATE(528),
    [sym_internal_module] = STATE(528),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(528),
    [sym_await_expression] = STATE(528),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(528),
    [sym_this] = STATE(528),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(528),
    [sym_generator_function] = STATE(528),
    [sym_call_expression] = STATE(528),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(528),
    [sym_ternary_expression] = STATE(528),
    [sym_binary_expression] = STATE(528),
    [sym_template_string] = STATE(528),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(528),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(528),
    [sym_class] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(953),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(953),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(3897),
    [sym_null] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(955),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1641] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3451),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_RBRACK] = ACTIONS(3451),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [1642] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3891),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1643] = {
    [sym_new_expression] = STATE(528),
    [sym_augmented_assignment_expression] = STATE(528),
    [sym_unary_expression] = STATE(528),
    [sym_update_expression] = STATE(528),
    [sym_regex] = STATE(528),
    [sym_meta_property] = STATE(528),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(528),
    [sym_yield_expression] = STATE(528),
    [sym_as_expression] = STATE(528),
    [sym_non_null_expression] = STATE(528),
    [sym_internal_module] = STATE(528),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(528),
    [sym_await_expression] = STATE(528),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(528),
    [sym_this] = STATE(528),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(528),
    [sym_generator_function] = STATE(528),
    [sym_call_expression] = STATE(528),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(528),
    [sym_ternary_expression] = STATE(528),
    [sym_binary_expression] = STATE(528),
    [sym_template_string] = STATE(528),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(528),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(528),
    [sym_class] = STATE(528),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(5320),
    [sym_false] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(953),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(955),
    [sym_true] = ACTIONS(953),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1644] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(2567),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2568),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1005),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1009),
    [anon_sym_symbol] = ACTIONS(1009),
    [anon_sym_number] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1009),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1009),
    [anon_sym_private] = ACTIONS(1009),
    [anon_sym_boolean] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_public] = ACTIONS(1009),
    [anon_sym_get] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1009),
    [anon_sym_string] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1009),
    [anon_sym_namespace] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [1645] = {
    [sym_formal_parameters] = STATE(2569),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1646] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(5322),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [1647] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2573),
    [sym_constructor_type] = STATE(2573),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(2573),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2573),
    [sym_intersection_type] = STATE(2573),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1648] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2576),
    [sym_constructor_type] = STATE(2576),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(2576),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2576),
    [sym_intersection_type] = STATE(2576),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1649] = {
    [sym__initializer] = STATE(1041),
    [aux_sym_object_repeat1] = STATE(1073),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(2173),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(360),
    [sym_comment] = ACTIONS(3),
  },
  [1650] = {
    [sym_new_expression] = STATE(2582),
    [sym_augmented_assignment_expression] = STATE(2582),
    [sym_unary_expression] = STATE(2582),
    [sym_update_expression] = STATE(2582),
    [sym_regex] = STATE(2582),
    [sym_meta_property] = STATE(2582),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(2582),
    [sym_yield_expression] = STATE(2582),
    [sym_as_expression] = STATE(2582),
    [sym_non_null_expression] = STATE(2582),
    [sym_internal_module] = STATE(2582),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2582),
    [sym_await_expression] = STATE(2582),
    [sym_member_expression] = STATE(161),
    [sym_mapped_type] = STATE(1575),
    [sym_spread_element] = STATE(409),
    [sym_string] = STATE(2582),
    [sym_this] = STATE(2582),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [aux_sym_array_repeat1] = STATE(410),
    [sym_nested_type_identifier] = STATE(1345),
    [sym_anonymous_class] = STATE(2582),
    [sym_generator_function] = STATE(2582),
    [sym_call_expression] = STATE(2582),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(2582),
    [sym_ternary_expression] = STATE(2582),
    [sym_binary_expression] = STATE(2582),
    [sym_template_string] = STATE(2582),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2582),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(2582),
    [sym_class] = STATE(2582),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(5331),
    [sym_false] = ACTIONS(5333),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5335),
    [anon_sym_symbol] = ACTIONS(5335),
    [anon_sym_number] = ACTIONS(5335),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5335),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(5337),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(747),
    [sym_null] = ACTIONS(5333),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5335),
    [anon_sym_private] = ACTIONS(5335),
    [anon_sym_boolean] = ACTIONS(5335),
    [anon_sym_async] = ACTIONS(5339),
    [anon_sym_public] = ACTIONS(5335),
    [anon_sym_get] = ACTIONS(5335),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5341),
    [sym_true] = ACTIONS(5333),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5335),
    [anon_sym_string] = ACTIONS(5335),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5333),
    [anon_sym_set] = ACTIONS(5335),
    [anon_sym_type] = ACTIONS(5335),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(5335),
    [anon_sym_export] = ACTIONS(5335),
    [anon_sym_namespace] = ACTIONS(5343),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1651] = {
    [aux_sym_object_repeat1] = STATE(1073),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(360),
    [sym_comment] = ACTIONS(3),
  },
  [1652] = {
    [sym_pair] = STATE(659),
    [aux_sym_export_statement_repeat1] = STATE(2589),
    [sym_object] = STATE(397),
    [sym__property_name] = STATE(1662),
    [sym_assignment_pattern] = STATE(659),
    [sym_method_signature] = STATE(1576),
    [sym_property_signature] = STATE(1576),
    [sym_call_signature] = STATE(1576),
    [sym_construct_signature] = STATE(1576),
    [sym_index_signature] = STATE(1576),
    [sym_export_statement] = STATE(1576),
    [sym_method_definition] = STATE(659),
    [sym_decorator] = STATE(2589),
    [sym_accessibility_modifier] = STATE(1663),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(1662),
    [sym_array] = STATE(399),
    [sym_spread_element] = STATE(659),
    [sym_string] = STATE(1662),
    [sym_type_parameters] = STATE(811),
    [sym_identifier] = ACTIONS(5345),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(5347),
    [anon_sym_symbol] = ACTIONS(5347),
    [anon_sym_number] = ACTIONS(5347),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(5347),
    [anon_sym_COMMA] = ACTIONS(1206),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(5347),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(5347),
    [anon_sym_private] = ACTIONS(5349),
    [anon_sym_boolean] = ACTIONS(5347),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(5351),
    [anon_sym_get] = ACTIONS(5353),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_public] = ACTIONS(5349),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(5349),
    [anon_sym_string] = ACTIONS(5347),
    [anon_sym_set] = ACTIONS(5353),
    [anon_sym_type] = ACTIONS(5347),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(5347),
    [anon_sym_export] = ACTIONS(5355),
    [sym_readonly] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(5347),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1653] = {
    [sym_string] = STATE(2590),
    [sym__property_name] = STATE(2590),
    [sym_computed_property_name] = STATE(2590),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [1654] = {
    [aux_sym_object_repeat1] = STATE(1073),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_namespace] = ACTIONS(1220),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
  },
  [1655] = {
    [sym__property_name] = STATE(2590),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym_string] = STATE(2590),
    [sym_computed_property_name] = STATE(2590),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(5359),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(5361),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(5361),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [1656] = {
    [sym__property_name] = STATE(2590),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym_string] = STATE(2590),
    [sym_computed_property_name] = STATE(2590),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [1657] = {
    [sym_string] = STATE(2596),
    [sym__property_name] = STATE(2596),
    [sym_computed_property_name] = STATE(2596),
    [anon_sym_get] = ACTIONS(5363),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_async] = ACTIONS(5365),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(5367),
    [anon_sym_STAR] = ACTIONS(5359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(5363),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(5369),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1658] = {
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_COLON] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(3303),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(3303),
    [anon_sym_COMMA] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
  },
  [1659] = {
    [sym_type_alias_declaration] = STATE(1609),
    [aux_sym_export_statement_repeat1] = STATE(1608),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym__declaration] = STATE(1609),
    [sym_ambient_declaration] = STATE(1609),
    [sym_import_alias] = STATE(1609),
    [sym_export_statement] = STATE(1609),
    [sym_generator_function] = STATE(1609),
    [sym_export_clause] = STATE(1610),
    [sym_lexical_declaration] = STATE(1609),
    [sym_internal_module] = STATE(1609),
    [sym_decorator] = STATE(1608),
    [sym_enum_declaration] = STATE(1609),
    [sym_function] = STATE(1609),
    [sym_function_signature] = STATE(1609),
    [sym_variable_declaration] = STATE(1609),
    [sym_abstract_class] = STATE(1609),
    [sym_module] = STATE(1609),
    [sym_interface_declaration] = STATE(1609),
    [sym_class] = STATE(1609),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_import] = ACTIONS(3337),
    [anon_sym_export] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3341),
  },
  [1660] = {
    [sym_string] = STATE(2596),
    [sym__property_name] = STATE(2596),
    [sym_computed_property_name] = STATE(2596),
    [anon_sym_get] = ACTIONS(5363),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(5367),
    [anon_sym_STAR] = ACTIONS(5359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(5363),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(5365),
  },
  [1661] = {
    [sym_computed_property_name] = STATE(701),
    [sym__property_name] = STATE(701),
    [sym_decorator] = STATE(1044),
    [sym_method_definition] = STATE(1076),
    [sym_string] = STATE(701),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(1044),
    [anon_sym_get] = ACTIONS(1308),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [sym_number] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1304),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(5371),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1304),
    [anon_sym_public] = ACTIONS(1304),
  },
  [1662] = {
    [sym_call_signature] = STATE(2600),
    [sym_type_annotation] = STATE(1616),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [sym__automatic_semicolon] = ACTIONS(3345),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [anon_sym_COLON] = ACTIONS(5373),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_QMARK] = ACTIONS(5375),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3345),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(3345),
    [sym_comment] = ACTIONS(3),
  },
  [1663] = {
    [sym_string] = STATE(2596),
    [sym__property_name] = STATE(2596),
    [sym_computed_property_name] = STATE(2596),
    [anon_sym_get] = ACTIONS(5363),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(5365),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(5367),
    [anon_sym_STAR] = ACTIONS(5359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(5363),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(5369),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(5377),
    [anon_sym_private] = ACTIONS(1119),
  },
  [1664] = {
    [anon_sym_EQ_GT] = ACTIONS(5379),
    [sym_comment] = ACTIONS(3),
  },
  [1665] = {
    [sym_formal_parameters] = STATE(2605),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1666] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1667] = {
    [sym_identifier] = ACTIONS(5381),
    [anon_sym_BQUOTE] = ACTIONS(5383),
    [anon_sym_debugger] = ACTIONS(5381),
    [anon_sym_symbol] = ACTIONS(5381),
    [anon_sym_AT] = ACTIONS(5383),
    [anon_sym_PIPE] = ACTIONS(5383),
    [anon_sym_COMMA] = ACTIONS(5383),
    [anon_sym_DASH] = ACTIONS(5381),
    [anon_sym_EQ] = ACTIONS(5381),
    [anon_sym_void] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5381),
    [anon_sym_const] = ACTIONS(5381),
    [sym_super] = ACTIONS(5381),
    [anon_sym_return] = ACTIONS(5381),
    [anon_sym_private] = ACTIONS(5381),
    [anon_sym_get] = ACTIONS(5381),
    [anon_sym_RBRACE] = ACTIONS(5383),
    [anon_sym_interface] = ACTIONS(5381),
    [anon_sym_default] = ACTIONS(5381),
    [anon_sym_enum] = ACTIONS(5381),
    [anon_sym_delete] = ACTIONS(5381),
    [anon_sym_continue] = ACTIONS(5381),
    [anon_sym_DASH_DASH] = ACTIONS(5383),
    [anon_sym_if] = ACTIONS(5381),
    [anon_sym_this] = ACTIONS(5381),
    [anon_sym_yield] = ACTIONS(5381),
    [sym_true] = ACTIONS(5381),
    [anon_sym_throw] = ACTIONS(5381),
    [anon_sym_protected] = ACTIONS(5381),
    [anon_sym_abstract] = ACTIONS(5381),
    [anon_sym_set] = ACTIONS(5381),
    [anon_sym_type] = ACTIONS(5381),
    [anon_sym_import] = ACTIONS(5381),
    [anon_sym_namespace] = ACTIONS(5381),
    [anon_sym_PLUS_PLUS] = ACTIONS(5383),
    [anon_sym_await] = ACTIONS(5381),
    [anon_sym_DQUOTE] = ACTIONS(5383),
    [anon_sym_else] = ACTIONS(5381),
    [anon_sym_BANG] = ACTIONS(5383),
    [anon_sym_for] = ACTIONS(5381),
    [anon_sym_LBRACK] = ACTIONS(5383),
    [sym_false] = ACTIONS(5381),
    [anon_sym_SEMI] = ACTIONS(5383),
    [anon_sym_case] = ACTIONS(5381),
    [anon_sym_module] = ACTIONS(5381),
    [anon_sym_number] = ACTIONS(5381),
    [anon_sym_class] = ACTIONS(5381),
    [anon_sym_declare] = ACTIONS(5381),
    [anon_sym_typeof] = ACTIONS(5381),
    [anon_sym_LBRACE] = ACTIONS(5383),
    [anon_sym_switch] = ACTIONS(5381),
    [anon_sym_LPAREN] = ACTIONS(5383),
    [anon_sym_RBRACK] = ACTIONS(5383),
    [sym_null] = ACTIONS(5381),
    [anon_sym_GT] = ACTIONS(5383),
    [anon_sym_any] = ACTIONS(5381),
    [anon_sym_boolean] = ACTIONS(5381),
    [anon_sym_async] = ACTIONS(5381),
    [anon_sym_public] = ACTIONS(5381),
    [anon_sym_EQ_GT] = ACTIONS(5383),
    [anon_sym_AMP] = ACTIONS(5383),
    [anon_sym_var] = ACTIONS(5381),
    [anon_sym_while] = ACTIONS(5381),
    [anon_sym_SQUOTE] = ACTIONS(5383),
    [anon_sym_try] = ACTIONS(5381),
    [anon_sym_RPAREN] = ACTIONS(5383),
    [anon_sym_LT] = ACTIONS(5383),
    [sym_number] = ACTIONS(5383),
    [anon_sym_SLASH] = ACTIONS(5381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5381),
    [anon_sym_function] = ACTIONS(5381),
    [sym_undefined] = ACTIONS(5381),
    [anon_sym_new] = ACTIONS(5381),
    [ts_builtin_sym_end] = ACTIONS(5383),
    [anon_sym_let] = ACTIONS(5381),
    [anon_sym_PLUS] = ACTIONS(5381),
    [anon_sym_export] = ACTIONS(5381),
    [anon_sym_do] = ACTIONS(5381),
    [anon_sym_TILDE] = ACTIONS(5383),
    [anon_sym_with] = ACTIONS(5381),
  },
  [1668] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1669] = {
    [anon_sym_EQ_GT] = ACTIONS(5385),
    [sym_comment] = ACTIONS(3),
  },
  [1670] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2607),
    [sym_constructor_type] = STATE(2607),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(2607),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2607),
    [sym_intersection_type] = STATE(2607),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1671] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2608),
    [sym_constructor_type] = STATE(2608),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(2608),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2608),
    [sym_intersection_type] = STATE(2608),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1672] = {
    [sym_identifier] = ACTIONS(5387),
    [anon_sym_BQUOTE] = ACTIONS(5389),
    [anon_sym_debugger] = ACTIONS(5387),
    [anon_sym_symbol] = ACTIONS(5387),
    [anon_sym_AT] = ACTIONS(5389),
    [anon_sym_PIPE] = ACTIONS(5389),
    [anon_sym_COMMA] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_EQ] = ACTIONS(5387),
    [anon_sym_void] = ACTIONS(5387),
    [anon_sym_break] = ACTIONS(5387),
    [anon_sym_const] = ACTIONS(5387),
    [sym_super] = ACTIONS(5387),
    [anon_sym_return] = ACTIONS(5387),
    [anon_sym_private] = ACTIONS(5387),
    [anon_sym_get] = ACTIONS(5387),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_interface] = ACTIONS(5387),
    [anon_sym_default] = ACTIONS(5387),
    [anon_sym_enum] = ACTIONS(5387),
    [anon_sym_delete] = ACTIONS(5387),
    [anon_sym_continue] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5389),
    [anon_sym_if] = ACTIONS(5387),
    [anon_sym_this] = ACTIONS(5387),
    [anon_sym_yield] = ACTIONS(5387),
    [sym_true] = ACTIONS(5387),
    [anon_sym_throw] = ACTIONS(5387),
    [anon_sym_protected] = ACTIONS(5387),
    [anon_sym_abstract] = ACTIONS(5387),
    [anon_sym_set] = ACTIONS(5387),
    [anon_sym_type] = ACTIONS(5387),
    [anon_sym_import] = ACTIONS(5387),
    [anon_sym_namespace] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5389),
    [anon_sym_await] = ACTIONS(5387),
    [anon_sym_DQUOTE] = ACTIONS(5389),
    [anon_sym_else] = ACTIONS(5387),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_for] = ACTIONS(5387),
    [anon_sym_LBRACK] = ACTIONS(5389),
    [sym_false] = ACTIONS(5387),
    [anon_sym_SEMI] = ACTIONS(5389),
    [anon_sym_case] = ACTIONS(5387),
    [anon_sym_module] = ACTIONS(5387),
    [anon_sym_number] = ACTIONS(5387),
    [anon_sym_class] = ACTIONS(5387),
    [anon_sym_declare] = ACTIONS(5387),
    [anon_sym_typeof] = ACTIONS(5387),
    [anon_sym_LBRACE] = ACTIONS(5389),
    [anon_sym_switch] = ACTIONS(5387),
    [anon_sym_LPAREN] = ACTIONS(5389),
    [anon_sym_RBRACK] = ACTIONS(5389),
    [sym_null] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5389),
    [anon_sym_any] = ACTIONS(5387),
    [anon_sym_boolean] = ACTIONS(5387),
    [anon_sym_async] = ACTIONS(5387),
    [anon_sym_public] = ACTIONS(5387),
    [anon_sym_EQ_GT] = ACTIONS(5389),
    [anon_sym_AMP] = ACTIONS(5389),
    [anon_sym_var] = ACTIONS(5387),
    [anon_sym_while] = ACTIONS(5387),
    [anon_sym_SQUOTE] = ACTIONS(5389),
    [anon_sym_try] = ACTIONS(5387),
    [anon_sym_RPAREN] = ACTIONS(5389),
    [anon_sym_LT] = ACTIONS(5389),
    [sym_number] = ACTIONS(5389),
    [anon_sym_SLASH] = ACTIONS(5387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5387),
    [anon_sym_function] = ACTIONS(5387),
    [sym_undefined] = ACTIONS(5387),
    [anon_sym_new] = ACTIONS(5387),
    [ts_builtin_sym_end] = ACTIONS(5389),
    [anon_sym_let] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_export] = ACTIONS(5387),
    [anon_sym_do] = ACTIONS(5387),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_with] = ACTIONS(5387),
  },
  [1673] = {
    [sym_identifier] = ACTIONS(5391),
    [anon_sym_BQUOTE] = ACTIONS(5393),
    [anon_sym_debugger] = ACTIONS(5391),
    [anon_sym_symbol] = ACTIONS(5391),
    [anon_sym_AT] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5391),
    [anon_sym_EQ] = ACTIONS(5391),
    [anon_sym_void] = ACTIONS(5391),
    [anon_sym_break] = ACTIONS(5391),
    [anon_sym_const] = ACTIONS(5391),
    [sym_super] = ACTIONS(5391),
    [anon_sym_return] = ACTIONS(5391),
    [anon_sym_private] = ACTIONS(5391),
    [anon_sym_get] = ACTIONS(5391),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_interface] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(5391),
    [anon_sym_enum] = ACTIONS(5391),
    [anon_sym_delete] = ACTIONS(5391),
    [anon_sym_continue] = ACTIONS(5391),
    [anon_sym_DASH_DASH] = ACTIONS(5393),
    [anon_sym_if] = ACTIONS(5391),
    [anon_sym_this] = ACTIONS(5391),
    [anon_sym_yield] = ACTIONS(5391),
    [sym_true] = ACTIONS(5391),
    [anon_sym_throw] = ACTIONS(5391),
    [anon_sym_protected] = ACTIONS(5391),
    [anon_sym_abstract] = ACTIONS(5391),
    [anon_sym_set] = ACTIONS(5391),
    [anon_sym_type] = ACTIONS(5391),
    [anon_sym_import] = ACTIONS(5391),
    [anon_sym_namespace] = ACTIONS(5391),
    [anon_sym_PLUS_PLUS] = ACTIONS(5393),
    [anon_sym_await] = ACTIONS(5391),
    [anon_sym_DQUOTE] = ACTIONS(5393),
    [anon_sym_else] = ACTIONS(5391),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_for] = ACTIONS(5391),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [sym_false] = ACTIONS(5391),
    [anon_sym_SEMI] = ACTIONS(5393),
    [anon_sym_case] = ACTIONS(5391),
    [anon_sym_module] = ACTIONS(5391),
    [anon_sym_number] = ACTIONS(5391),
    [anon_sym_class] = ACTIONS(5391),
    [anon_sym_declare] = ACTIONS(5391),
    [anon_sym_typeof] = ACTIONS(5391),
    [anon_sym_LBRACE] = ACTIONS(5393),
    [anon_sym_switch] = ACTIONS(5391),
    [anon_sym_LPAREN] = ACTIONS(5393),
    [anon_sym_RBRACK] = ACTIONS(5393),
    [sym_null] = ACTIONS(5391),
    [anon_sym_GT] = ACTIONS(5393),
    [anon_sym_any] = ACTIONS(5391),
    [anon_sym_boolean] = ACTIONS(5391),
    [anon_sym_async] = ACTIONS(5391),
    [anon_sym_public] = ACTIONS(5391),
    [anon_sym_EQ_GT] = ACTIONS(5393),
    [anon_sym_AMP] = ACTIONS(5393),
    [anon_sym_var] = ACTIONS(5391),
    [anon_sym_while] = ACTIONS(5391),
    [anon_sym_SQUOTE] = ACTIONS(5393),
    [anon_sym_try] = ACTIONS(5391),
    [anon_sym_RPAREN] = ACTIONS(5393),
    [anon_sym_LT] = ACTIONS(5393),
    [sym_number] = ACTIONS(5393),
    [anon_sym_SLASH] = ACTIONS(5391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5391),
    [anon_sym_function] = ACTIONS(5391),
    [sym_undefined] = ACTIONS(5391),
    [anon_sym_new] = ACTIONS(5391),
    [ts_builtin_sym_end] = ACTIONS(5393),
    [anon_sym_let] = ACTIONS(5391),
    [anon_sym_PLUS] = ACTIONS(5391),
    [anon_sym_export] = ACTIONS(5391),
    [anon_sym_do] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5393),
    [anon_sym_with] = ACTIONS(5391),
  },
  [1674] = {
    [sym_identifier] = ACTIONS(5395),
    [anon_sym_BQUOTE] = ACTIONS(5397),
    [anon_sym_debugger] = ACTIONS(5395),
    [anon_sym_symbol] = ACTIONS(5395),
    [anon_sym_AT] = ACTIONS(5397),
    [anon_sym_PIPE] = ACTIONS(5397),
    [anon_sym_COMMA] = ACTIONS(5397),
    [anon_sym_DASH] = ACTIONS(5395),
    [anon_sym_EQ] = ACTIONS(5395),
    [anon_sym_void] = ACTIONS(5395),
    [anon_sym_break] = ACTIONS(5395),
    [anon_sym_const] = ACTIONS(5395),
    [sym_super] = ACTIONS(5395),
    [anon_sym_return] = ACTIONS(5395),
    [anon_sym_private] = ACTIONS(5395),
    [anon_sym_get] = ACTIONS(5395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5397),
    [anon_sym_RBRACE] = ACTIONS(5397),
    [anon_sym_interface] = ACTIONS(5395),
    [anon_sym_default] = ACTIONS(5395),
    [anon_sym_enum] = ACTIONS(5395),
    [anon_sym_delete] = ACTIONS(5395),
    [anon_sym_continue] = ACTIONS(5395),
    [anon_sym_DASH_DASH] = ACTIONS(5397),
    [anon_sym_if] = ACTIONS(5395),
    [anon_sym_this] = ACTIONS(5395),
    [anon_sym_yield] = ACTIONS(5395),
    [sym_true] = ACTIONS(5395),
    [anon_sym_throw] = ACTIONS(5395),
    [anon_sym_protected] = ACTIONS(5395),
    [anon_sym_abstract] = ACTIONS(5395),
    [anon_sym_set] = ACTIONS(5395),
    [anon_sym_type] = ACTIONS(5395),
    [anon_sym_import] = ACTIONS(5395),
    [anon_sym_namespace] = ACTIONS(5395),
    [anon_sym_PLUS_PLUS] = ACTIONS(5397),
    [anon_sym_await] = ACTIONS(5395),
    [anon_sym_DQUOTE] = ACTIONS(5397),
    [anon_sym_else] = ACTIONS(5395),
    [anon_sym_BANG] = ACTIONS(5397),
    [anon_sym_for] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(5397),
    [sym_false] = ACTIONS(5395),
    [anon_sym_SEMI] = ACTIONS(5397),
    [anon_sym_case] = ACTIONS(5395),
    [anon_sym_module] = ACTIONS(5395),
    [anon_sym_number] = ACTIONS(5395),
    [anon_sym_class] = ACTIONS(5395),
    [anon_sym_declare] = ACTIONS(5395),
    [anon_sym_typeof] = ACTIONS(5395),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_switch] = ACTIONS(5395),
    [anon_sym_LPAREN] = ACTIONS(5397),
    [anon_sym_RBRACK] = ACTIONS(5397),
    [sym_null] = ACTIONS(5395),
    [anon_sym_GT] = ACTIONS(5397),
    [anon_sym_any] = ACTIONS(5395),
    [anon_sym_boolean] = ACTIONS(5395),
    [anon_sym_async] = ACTIONS(5395),
    [anon_sym_public] = ACTIONS(5395),
    [anon_sym_EQ_GT] = ACTIONS(5397),
    [anon_sym_AMP] = ACTIONS(5397),
    [anon_sym_var] = ACTIONS(5395),
    [anon_sym_while] = ACTIONS(5395),
    [anon_sym_SQUOTE] = ACTIONS(5397),
    [anon_sym_try] = ACTIONS(5395),
    [anon_sym_RPAREN] = ACTIONS(5397),
    [anon_sym_LT] = ACTIONS(5397),
    [sym_number] = ACTIONS(5397),
    [anon_sym_SLASH] = ACTIONS(5395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5395),
    [anon_sym_function] = ACTIONS(5395),
    [sym_undefined] = ACTIONS(5395),
    [anon_sym_new] = ACTIONS(5395),
    [ts_builtin_sym_end] = ACTIONS(5397),
    [anon_sym_let] = ACTIONS(5395),
    [anon_sym_PLUS] = ACTIONS(5395),
    [anon_sym_implements] = ACTIONS(5395),
    [anon_sym_export] = ACTIONS(5395),
    [anon_sym_do] = ACTIONS(5395),
    [anon_sym_TILDE] = ACTIONS(5397),
    [anon_sym_with] = ACTIONS(5395),
  },
  [1675] = {
    [anon_sym_GT] = ACTIONS(5399),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
  },
  [1676] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1675),
    [sym_constructor_type] = STATE(1675),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1675),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1675),
    [sym_intersection_type] = STATE(1675),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(5401),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_boolean] = ACTIONS(472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_this] = ACTIONS(474),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [1677] = {
    [aux_sym_implements_clause_repeat1] = STATE(1677),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_GT] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
  },
  [1678] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2611),
    [sym_constructor_type] = STATE(2611),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(2611),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2611),
    [sym_intersection_type] = STATE(2611),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1679] = {
    [anon_sym_GT] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(5198),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_COMMA] = ACTIONS(5406),
    [sym_comment] = ACTIONS(3),
  },
  [1680] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(5408),
    [sym_comment] = ACTIONS(3),
  },
  [1681] = {
    [anon_sym_extends] = ACTIONS(5410),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5410),
    [anon_sym_EQ] = ACTIONS(5410),
    [anon_sym_implements] = ACTIONS(5410),
    [anon_sym_LPAREN] = ACTIONS(5410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5412),
  },
  [1682] = {
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_GT] = ACTIONS(5414),
    [sym_comment] = ACTIONS(3),
  },
  [1683] = {
    [sym_type_parameter] = STATE(1682),
    [anon_sym_GT] = ACTIONS(5416),
    [sym_identifier] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
  },
  [1684] = {
    [aux_sym_type_parameters_repeat1] = STATE(1684),
    [anon_sym_COMMA] = ACTIONS(5418),
    [anon_sym_GT] = ACTIONS(5414),
    [sym_comment] = ACTIONS(3),
  },
  [1685] = {
    [sym_identifier] = ACTIONS(5421),
    [anon_sym_BQUOTE] = ACTIONS(5423),
    [anon_sym_debugger] = ACTIONS(5421),
    [anon_sym_symbol] = ACTIONS(5421),
    [anon_sym_AT] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5423),
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_EQ] = ACTIONS(5421),
    [anon_sym_void] = ACTIONS(5421),
    [anon_sym_break] = ACTIONS(5421),
    [anon_sym_const] = ACTIONS(5421),
    [sym_super] = ACTIONS(5421),
    [anon_sym_return] = ACTIONS(5421),
    [anon_sym_private] = ACTIONS(5421),
    [anon_sym_get] = ACTIONS(5421),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_interface] = ACTIONS(5421),
    [anon_sym_default] = ACTIONS(5421),
    [anon_sym_enum] = ACTIONS(5421),
    [anon_sym_delete] = ACTIONS(5421),
    [anon_sym_continue] = ACTIONS(5421),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_if] = ACTIONS(5421),
    [anon_sym_this] = ACTIONS(5421),
    [anon_sym_yield] = ACTIONS(5421),
    [sym_true] = ACTIONS(5421),
    [anon_sym_throw] = ACTIONS(5421),
    [anon_sym_protected] = ACTIONS(5421),
    [anon_sym_abstract] = ACTIONS(5421),
    [anon_sym_set] = ACTIONS(5421),
    [anon_sym_type] = ACTIONS(5421),
    [anon_sym_import] = ACTIONS(5421),
    [anon_sym_namespace] = ACTIONS(5421),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_await] = ACTIONS(5421),
    [anon_sym_DQUOTE] = ACTIONS(5423),
    [anon_sym_else] = ACTIONS(5421),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_for] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [sym_false] = ACTIONS(5421),
    [anon_sym_SEMI] = ACTIONS(5423),
    [anon_sym_case] = ACTIONS(5421),
    [anon_sym_module] = ACTIONS(5421),
    [anon_sym_number] = ACTIONS(5421),
    [anon_sym_class] = ACTIONS(5421),
    [anon_sym_declare] = ACTIONS(5421),
    [anon_sym_typeof] = ACTIONS(5421),
    [anon_sym_LBRACE] = ACTIONS(5423),
    [anon_sym_switch] = ACTIONS(5421),
    [anon_sym_LPAREN] = ACTIONS(5423),
    [anon_sym_RBRACK] = ACTIONS(5423),
    [sym_null] = ACTIONS(5421),
    [anon_sym_GT] = ACTIONS(5423),
    [anon_sym_any] = ACTIONS(5421),
    [anon_sym_boolean] = ACTIONS(5421),
    [anon_sym_async] = ACTIONS(5421),
    [anon_sym_public] = ACTIONS(5421),
    [anon_sym_EQ_GT] = ACTIONS(5423),
    [anon_sym_AMP] = ACTIONS(5423),
    [anon_sym_var] = ACTIONS(5421),
    [anon_sym_while] = ACTIONS(5421),
    [anon_sym_SQUOTE] = ACTIONS(5423),
    [anon_sym_try] = ACTIONS(5421),
    [anon_sym_RPAREN] = ACTIONS(5423),
    [anon_sym_LT] = ACTIONS(5423),
    [sym_number] = ACTIONS(5423),
    [anon_sym_SLASH] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5421),
    [anon_sym_function] = ACTIONS(5421),
    [sym_undefined] = ACTIONS(5421),
    [anon_sym_new] = ACTIONS(5421),
    [ts_builtin_sym_end] = ACTIONS(5423),
    [anon_sym_let] = ACTIONS(5421),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_export] = ACTIONS(5421),
    [anon_sym_do] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5423),
    [anon_sym_with] = ACTIONS(5421),
  },
  [1686] = {
    [anon_sym_GT] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [1687] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_SEMI] = ACTIONS(5427),
    [anon_sym_BQUOTE] = ACTIONS(5427),
    [sym__automatic_semicolon] = ACTIONS(5427),
    [anon_sym_PIPE] = ACTIONS(5429),
    [anon_sym_COMMA] = ACTIONS(5427),
    [anon_sym_LT_LT] = ACTIONS(5427),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_GT_GT_GT] = ACTIONS(5427),
    [anon_sym_AMP_AMP] = ACTIONS(5427),
    [anon_sym_DASH] = ACTIONS(5429),
    [anon_sym_BANG_EQ] = ACTIONS(5429),
    [anon_sym_LT_EQ] = ACTIONS(5427),
    [anon_sym_LPAREN] = ACTIONS(5427),
    [anon_sym_GT_EQ] = ACTIONS(5427),
    [anon_sym_GT] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_PERCENT] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5427),
    [anon_sym_RBRACE] = ACTIONS(5427),
    [anon_sym_as] = ACTIONS(5427),
    [anon_sym_PIPE_PIPE] = ACTIONS(5427),
    [anon_sym_DASH_DASH] = ACTIONS(5427),
    [anon_sym_EQ_EQ] = ACTIONS(5429),
    [anon_sym_instanceof] = ACTIONS(5427),
    [anon_sym_LT] = ACTIONS(5429),
    [anon_sym_RPAREN] = ACTIONS(5427),
    [anon_sym_SLASH] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5427),
    [anon_sym_CARET] = ACTIONS(5427),
    [anon_sym_STAR_STAR] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5429),
    [anon_sym_GT_GT] = ACTIONS(5429),
    [anon_sym_PLUS_PLUS] = ACTIONS(5427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5427),
    [anon_sym_in] = ACTIONS(5429),
  },
  [1688] = {
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_BQUOTE] = ACTIONS(5433),
    [anon_sym_debugger] = ACTIONS(5431),
    [anon_sym_symbol] = ACTIONS(5431),
    [anon_sym_AT] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_void] = ACTIONS(5431),
    [anon_sym_break] = ACTIONS(5431),
    [anon_sym_const] = ACTIONS(5431),
    [sym_super] = ACTIONS(5431),
    [anon_sym_return] = ACTIONS(5431),
    [anon_sym_private] = ACTIONS(5431),
    [anon_sym_get] = ACTIONS(5431),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_interface] = ACTIONS(5431),
    [anon_sym_default] = ACTIONS(5431),
    [anon_sym_enum] = ACTIONS(5431),
    [anon_sym_delete] = ACTIONS(5431),
    [anon_sym_continue] = ACTIONS(5431),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_if] = ACTIONS(5431),
    [anon_sym_this] = ACTIONS(5431),
    [anon_sym_yield] = ACTIONS(5431),
    [sym_true] = ACTIONS(5431),
    [anon_sym_throw] = ACTIONS(5431),
    [anon_sym_protected] = ACTIONS(5431),
    [anon_sym_abstract] = ACTIONS(5431),
    [anon_sym_set] = ACTIONS(5431),
    [anon_sym_type] = ACTIONS(5431),
    [anon_sym_import] = ACTIONS(5431),
    [anon_sym_namespace] = ACTIONS(5431),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_await] = ACTIONS(5431),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [anon_sym_else] = ACTIONS(5431),
    [anon_sym_BANG] = ACTIONS(5433),
    [anon_sym_for] = ACTIONS(5431),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [sym_false] = ACTIONS(5431),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym_case] = ACTIONS(5431),
    [anon_sym_module] = ACTIONS(5431),
    [anon_sym_number] = ACTIONS(5431),
    [anon_sym_class] = ACTIONS(5431),
    [anon_sym_declare] = ACTIONS(5431),
    [anon_sym_typeof] = ACTIONS(5431),
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_switch] = ACTIONS(5431),
    [anon_sym_LPAREN] = ACTIONS(5433),
    [sym_null] = ACTIONS(5431),
    [anon_sym_any] = ACTIONS(5431),
    [anon_sym_boolean] = ACTIONS(5431),
    [anon_sym_async] = ACTIONS(5431),
    [anon_sym_public] = ACTIONS(5431),
    [anon_sym_var] = ACTIONS(5431),
    [anon_sym_while] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5433),
    [anon_sym_try] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5433),
    [sym_number] = ACTIONS(5433),
    [anon_sym_SLASH] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5431),
    [anon_sym_function] = ACTIONS(5431),
    [sym_undefined] = ACTIONS(5431),
    [anon_sym_new] = ACTIONS(5431),
    [ts_builtin_sym_end] = ACTIONS(5433),
    [anon_sym_let] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_export] = ACTIONS(5431),
    [anon_sym_do] = ACTIONS(5431),
    [anon_sym_TILDE] = ACTIONS(5433),
    [anon_sym_with] = ACTIONS(5431),
  },
  [1689] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2620),
    [sym_constructor_type] = STATE(2620),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(2620),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2620),
    [sym_intersection_type] = STATE(2620),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2621),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2623),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1690] = {
    [sym_type_annotation] = STATE(2545),
    [sym__automatic_semicolon] = ACTIONS(1739),
    [anon_sym_COLON] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1739),
  },
  [1691] = {
    [sym_statement_block] = STATE(2624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(901),
  },
  [1692] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5445),
    [sym_identifier] = ACTIONS(5447),
    [sym__automatic_semicolon] = ACTIONS(5445),
    [anon_sym_BQUOTE] = ACTIONS(5445),
    [anon_sym_debugger] = ACTIONS(5447),
    [ts_builtin_sym_end] = ACTIONS(5445),
    [anon_sym_symbol] = ACTIONS(5447),
    [anon_sym_AT] = ACTIONS(5445),
    [anon_sym_PIPE] = ACTIONS(5447),
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5447),
    [anon_sym_STAR] = ACTIONS(5447),
    [anon_sym_GT_GT_GT] = ACTIONS(5445),
    [anon_sym_void] = ACTIONS(5447),
    [anon_sym_break] = ACTIONS(5447),
    [anon_sym_BANG_EQ] = ACTIONS(5447),
    [anon_sym_const] = ACTIONS(5447),
    [anon_sym_GT_EQ] = ACTIONS(5445),
    [sym_super] = ACTIONS(5447),
    [anon_sym_return] = ACTIONS(5447),
    [anon_sym_private] = ACTIONS(5447),
    [anon_sym_get] = ACTIONS(5447),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_PERCENT] = ACTIONS(5445),
    [anon_sym_interface] = ACTIONS(5447),
    [anon_sym_default] = ACTIONS(5447),
    [anon_sym_as] = ACTIONS(5447),
    [anon_sym_delete] = ACTIONS(5447),
    [anon_sym_continue] = ACTIONS(5447),
    [anon_sym_DASH_DASH] = ACTIONS(5445),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_instanceof] = ACTIONS(5447),
    [anon_sym_this] = ACTIONS(5447),
    [anon_sym_yield] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [anon_sym_throw] = ACTIONS(5447),
    [anon_sym_enum] = ACTIONS(5447),
    [anon_sym_protected] = ACTIONS(5447),
    [anon_sym_abstract] = ACTIONS(5447),
    [anon_sym_DOT] = ACTIONS(5447),
    [anon_sym_set] = ACTIONS(5447),
    [anon_sym_type] = ACTIONS(5447),
    [anon_sym_STAR_STAR] = ACTIONS(5445),
    [anon_sym_import] = ACTIONS(5447),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5445),
    [anon_sym_namespace] = ACTIONS(5447),
    [anon_sym_PLUS_PLUS] = ACTIONS(5445),
    [anon_sym_await] = ACTIONS(5447),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [anon_sym_else] = ACTIONS(5447),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_LBRACK] = ACTIONS(5445),
    [sym_false] = ACTIONS(5447),
    [anon_sym_SEMI] = ACTIONS(5445),
    [anon_sym_case] = ACTIONS(5447),
    [anon_sym_module] = ACTIONS(5447),
    [anon_sym_number] = ACTIONS(5447),
    [anon_sym_class] = ACTIONS(5447),
    [anon_sym_declare] = ACTIONS(5447),
    [anon_sym_typeof] = ACTIONS(5447),
    [anon_sym_LT_LT] = ACTIONS(5445),
    [anon_sym_LBRACE] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_switch] = ACTIONS(5447),
    [anon_sym_LT_EQ] = ACTIONS(5445),
    [anon_sym_LPAREN] = ACTIONS(5445),
    [sym_null] = ACTIONS(5447),
    [anon_sym_GT] = ACTIONS(5447),
    [anon_sym_any] = ACTIONS(5447),
    [anon_sym_boolean] = ACTIONS(5447),
    [anon_sym_async] = ACTIONS(5447),
    [anon_sym_public] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5447),
    [anon_sym_var] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_PIPE_PIPE] = ACTIONS(5445),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_try] = ACTIONS(5447),
    [anon_sym_EQ_EQ] = ACTIONS(5447),
    [anon_sym_RPAREN] = ACTIONS(5445),
    [anon_sym_LT] = ACTIONS(5447),
    [sym_number] = ACTIONS(5445),
    [anon_sym_SLASH] = ACTIONS(5447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5447),
    [anon_sym_function] = ACTIONS(5447),
    [sym_undefined] = ACTIONS(5447),
    [anon_sym_new] = ACTIONS(5447),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_let] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5447),
    [anon_sym_export] = ACTIONS(5447),
    [anon_sym_GT_GT] = ACTIONS(5447),
    [anon_sym_do] = ACTIONS(5447),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_with] = ACTIONS(5447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5445),
    [anon_sym_in] = ACTIONS(5447),
  },
  [1693] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(5449),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5451),
  },
  [1694] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1695] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1699),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1701),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1696] = {
    [sym_formal_parameters] = STATE(2627),
    [sym_type_parameters] = STATE(2628),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1697] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1699),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1701),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1698] = {
    [anon_sym_AMP] = ACTIONS(5453),
    [anon_sym_PIPE] = ACTIONS(5455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3744),
  },
  [1699] = {
    [sym_formal_parameters] = STATE(2631),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1700] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_in] = ACTIONS(5457),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1577),
  },
  [1701] = {
    [anon_sym_EQ_GT] = ACTIONS(5459),
    [sym_comment] = ACTIONS(3),
  },
  [1702] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1649),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_GT_GT_GT] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(1647),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(1663),
    [anon_sym_SLASH] = ACTIONS(1651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1651),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1703] = {
    [sym_new_expression] = STATE(555),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(555),
    [sym_meta_property] = STATE(555),
    [sym_call_signature] = STATE(877),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(555),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(555),
    [sym_this] = STATE(555),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(555),
    [sym_generator_function] = STATE(555),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(555),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(555),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(555),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1637),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1637),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [1704] = {
    [sym_new_expression] = STATE(555),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(555),
    [sym_meta_property] = STATE(555),
    [sym_call_signature] = STATE(877),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(555),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(555),
    [sym_this] = STATE(555),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(555),
    [sym_generator_function] = STATE(555),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(555),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(555),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(555),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1637),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1637),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [1705] = {
    [anon_sym_EQ_GT] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
  },
  [1706] = {
    [anon_sym_EQ_GT] = ACTIONS(5463),
    [sym_comment] = ACTIONS(3),
  },
  [1707] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3532),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [1708] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1709] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1710] = {
    [sym_call_signature] = STATE(1705),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(3536),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(3538),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(3538),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(3538),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(3538),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(3538),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(3538),
    [anon_sym_type] = ACTIONS(3538),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(3538),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(3538),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(3538),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(3538),
    [anon_sym_declare] = ACTIONS(3538),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(3538),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(3538),
    [anon_sym_async] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3538),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(3538),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(3538),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1711] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1712] = {
    [sym_new_expression] = STATE(1100),
    [sym_augmented_assignment_expression] = STATE(1100),
    [sym_unary_expression] = STATE(1100),
    [sym_update_expression] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_meta_property] = STATE(1100),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1100),
    [sym_yield_expression] = STATE(1100),
    [sym_as_expression] = STATE(1100),
    [sym_non_null_expression] = STATE(1100),
    [sym_internal_module] = STATE(1100),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1100),
    [sym_await_expression] = STATE(1100),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1100),
    [sym_this] = STATE(1100),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1100),
    [sym_generator_function] = STATE(1100),
    [sym_call_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1100),
    [sym_ternary_expression] = STATE(1100),
    [sym_binary_expression] = STATE(1100),
    [sym_template_string] = STATE(1100),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1100),
    [sym_class] = STATE(1100),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(5465),
    [sym_false] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2269),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2271),
    [sym_true] = ACTIONS(2269),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2269),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1713] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2285),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_SEMI] = ACTIONS(2285),
    [anon_sym_BQUOTE] = ACTIONS(2285),
    [sym__automatic_semicolon] = ACTIONS(2285),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_COMMA] = ACTIONS(2285),
    [anon_sym_LT_LT] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2287),
    [anon_sym_GT_GT_GT] = ACTIONS(2285),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_LT_EQ] = ACTIONS(2285),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_GT_EQ] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_EQ_GT] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_PERCENT] = ACTIONS(2285),
    [anon_sym_QMARK] = ACTIONS(2285),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_as] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2285),
    [anon_sym_DASH_DASH] = ACTIONS(2285),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_instanceof] = ACTIONS(2285),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_RPAREN] = ACTIONS(2285),
    [anon_sym_SLASH] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1368),
    [anon_sym_DOT] = ACTIONS(2285),
    [anon_sym_CARET] = ACTIONS(2285),
    [anon_sym_STAR_STAR] = ACTIONS(2285),
    [anon_sym_PLUS] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2285),
    [anon_sym_in] = ACTIONS(2287),
  },
  [1714] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [aux_sym_array_repeat1] = STATE(1121),
    [sym_type_annotation] = STATE(1224),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(1331),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_COMMA] = ACTIONS(5467),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_RPAREN] = ACTIONS(2329),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1715] = {
    [sym__initializer] = STATE(712),
    [sym_type_annotation] = STATE(713),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_AMP_EQ] = ACTIONS(2251),
    [anon_sym_PLUS_EQ] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2251),
    [anon_sym_STAR_EQ] = ACTIONS(2251),
    [anon_sym_PIPE_EQ] = ACTIONS(2251),
    [anon_sym_DASH_EQ] = ACTIONS(2251),
    [anon_sym_EQ_GT] = ACTIONS(2253),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1325),
    [anon_sym_LT_LT_EQ] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_SLASH_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1716] = {
    [sym__initializer] = STATE(722),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1717] = {
    [sym_new_expression] = STATE(1098),
    [sym_augmented_assignment_expression] = STATE(1098),
    [sym__initializer] = STATE(722),
    [sym_unary_expression] = STATE(1098),
    [sym_update_expression] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_meta_property] = STATE(1098),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1098),
    [sym_as_expression] = STATE(1098),
    [sym_non_null_expression] = STATE(1098),
    [sym_internal_module] = STATE(1098),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1098),
    [sym_await_expression] = STATE(1098),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1098),
    [sym_this] = STATE(1098),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1098),
    [sym_generator_function] = STATE(1098),
    [sym_call_expression] = STATE(1098),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1098),
    [sym_ternary_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_template_string] = STATE(1098),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_type_annotation] = STATE(723),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1098),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1098),
    [sym_class] = STATE(1098),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(803),
    [sym_true] = ACTIONS(2261),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2261),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2261),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2261),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1718] = {
    [sym__initializer] = STATE(722),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(1220),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(1220),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1719] = {
    [sym_call_signature] = STATE(1102),
    [sym__initializer] = STATE(722),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2277),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_symbol] = ACTIONS(2279),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_void] = ACTIONS(2279),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_private] = ACTIONS(2279),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_get] = ACTIONS(2279),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_protected] = ACTIONS(2279),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(2279),
    [anon_sym_type] = ACTIONS(2279),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2279),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(2279),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_number] = ACTIONS(2279),
    [anon_sym_declare] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2279),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_boolean] = ACTIONS(2279),
    [anon_sym_async] = ACTIONS(2279),
    [anon_sym_public] = ACTIONS(2279),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_string] = ACTIONS(2279),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1720] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(722),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1721] = {
    [sym__initializer] = STATE(754),
    [sym_type_annotation] = STATE(713),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1722] = {
    [sym__initializer] = STATE(764),
    [sym_type_annotation] = STATE(765),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1723] = {
    [sym__initializer] = STATE(767),
    [sym_type_annotation] = STATE(768),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1443),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1724] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1649),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_GT_GT_GT] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1653),
    [anon_sym_BANG_EQ] = ACTIONS(1643),
    [anon_sym_LT_EQ] = ACTIONS(1641),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1655),
    [anon_sym_PERCENT] = ACTIONS(1647),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1643),
    [anon_sym_instanceof] = ACTIONS(1641),
    [anon_sym_LT] = ACTIONS(1663),
    [anon_sym_SLASH] = ACTIONS(1651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1651),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1641),
    [anon_sym_in] = ACTIONS(1643),
  },
  [1725] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5469),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1726] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_GT_GT_GT] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(1647),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5469),
    [anon_sym_SLASH] = ACTIONS(1651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(1651),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1727] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1649),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_GT_GT_GT] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(1643),
    [anon_sym_LT_EQ] = ACTIONS(1641),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(1647),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1643),
    [anon_sym_instanceof] = ACTIONS(1641),
    [anon_sym_LT] = ACTIONS(1663),
    [anon_sym_SLASH] = ACTIONS(1651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1651),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1641),
    [anon_sym_in] = ACTIONS(1643),
  },
  [1728] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1729] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(5474),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(5476),
  },
  [1730] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1731] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1732] = {
    [sym_formal_parameters] = STATE(2641),
    [sym_type_parameters] = STATE(2642),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1733] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1734] = {
    [sym_formal_parameters] = STATE(2645),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1735] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(5479),
  },
  [1736] = {
    [anon_sym_EQ_GT] = ACTIONS(5482),
    [sym_comment] = ACTIONS(3),
  },
  [1737] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3532),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5486),
  },
  [1738] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3894),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1739] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1740] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(5488),
    [sym_false] = ACTIONS(1615),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1615),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1623),
    [sym_true] = ACTIONS(1615),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [1741] = {
    [sym_new_expression] = STATE(882),
    [sym_augmented_assignment_expression] = STATE(882),
    [sym_unary_expression] = STATE(882),
    [sym_update_expression] = STATE(882),
    [sym_regex] = STATE(882),
    [sym_meta_property] = STATE(882),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(882),
    [sym_yield_expression] = STATE(882),
    [sym_as_expression] = STATE(882),
    [sym_non_null_expression] = STATE(882),
    [sym_internal_module] = STATE(882),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(882),
    [sym_await_expression] = STATE(882),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(882),
    [sym_this] = STATE(882),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(882),
    [sym_generator_function] = STATE(882),
    [sym_call_expression] = STATE(882),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(882),
    [sym_ternary_expression] = STATE(882),
    [sym_binary_expression] = STATE(882),
    [sym_template_string] = STATE(882),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(882),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(882),
    [sym_class] = STATE(882),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1629),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1629),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(1629),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1629),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [1742] = {
    [sym_pair] = STATE(418),
    [aux_sym_export_statement_repeat1] = STATE(1661),
    [sym_object] = STATE(397),
    [sym__property_name] = STATE(1662),
    [aux_sym_object_repeat1] = STATE(420),
    [sym_assignment_pattern] = STATE(418),
    [sym_method_signature] = STATE(810),
    [sym_property_signature] = STATE(810),
    [sym_call_signature] = STATE(810),
    [sym_construct_signature] = STATE(810),
    [sym_export_statement] = STATE(810),
    [sym_method_definition] = STATE(418),
    [sym_index_signature] = STATE(810),
    [sym_decorator] = STATE(1661),
    [sym_accessibility_modifier] = STATE(1663),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(1662),
    [sym_array] = STATE(399),
    [sym_spread_element] = STATE(418),
    [sym_string] = STATE(1662),
    [sym_type_parameters] = STATE(811),
    [sym_identifier] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(3429),
    [anon_sym_symbol] = ACTIONS(3429),
    [anon_sym_number] = ACTIONS(3429),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(3429),
    [anon_sym_COMMA] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_boolean] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_get] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(5490),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_string] = ACTIONS(3429),
    [anon_sym_set] = ACTIONS(3441),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(3429),
    [anon_sym_export] = ACTIONS(3447),
    [sym_readonly] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1743] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(514),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1744] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3937),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_RBRACK] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [1745] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(3540),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(3542),
    [anon_sym_symbol] = ACTIONS(3542),
    [anon_sym_number] = ACTIONS(3542),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3542),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3542),
    [anon_sym_private] = ACTIONS(3542),
    [anon_sym_boolean] = ACTIONS(3542),
    [anon_sym_async] = ACTIONS(3546),
    [anon_sym_public] = ACTIONS(3542),
    [anon_sym_get] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3542),
    [anon_sym_string] = ACTIONS(3542),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(3542),
    [anon_sym_type] = ACTIONS(3542),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(3542),
    [anon_sym_export] = ACTIONS(3542),
    [anon_sym_namespace] = ACTIONS(3548),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [1746] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(1661),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5469),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1747] = {
    [sym_identifier] = ACTIONS(5492),
    [anon_sym_BQUOTE] = ACTIONS(5494),
    [anon_sym_debugger] = ACTIONS(5492),
    [anon_sym_symbol] = ACTIONS(5492),
    [anon_sym_AT] = ACTIONS(5494),
    [anon_sym_DASH] = ACTIONS(5492),
    [anon_sym_void] = ACTIONS(5492),
    [anon_sym_break] = ACTIONS(5492),
    [anon_sym_const] = ACTIONS(5492),
    [sym_super] = ACTIONS(5492),
    [anon_sym_return] = ACTIONS(5492),
    [anon_sym_private] = ACTIONS(5492),
    [anon_sym_get] = ACTIONS(5492),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_interface] = ACTIONS(5492),
    [anon_sym_default] = ACTIONS(5492),
    [anon_sym_enum] = ACTIONS(5492),
    [anon_sym_delete] = ACTIONS(5492),
    [anon_sym_continue] = ACTIONS(5492),
    [anon_sym_DASH_DASH] = ACTIONS(5494),
    [anon_sym_if] = ACTIONS(5492),
    [anon_sym_this] = ACTIONS(5492),
    [anon_sym_yield] = ACTIONS(5492),
    [sym_true] = ACTIONS(5492),
    [anon_sym_throw] = ACTIONS(5492),
    [anon_sym_protected] = ACTIONS(5492),
    [anon_sym_abstract] = ACTIONS(5492),
    [anon_sym_set] = ACTIONS(5492),
    [anon_sym_type] = ACTIONS(5492),
    [anon_sym_import] = ACTIONS(5492),
    [anon_sym_namespace] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5494),
    [anon_sym_await] = ACTIONS(5492),
    [anon_sym_DQUOTE] = ACTIONS(5494),
    [anon_sym_else] = ACTIONS(5492),
    [anon_sym_BANG] = ACTIONS(5494),
    [anon_sym_for] = ACTIONS(5492),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [sym_false] = ACTIONS(5492),
    [anon_sym_SEMI] = ACTIONS(5494),
    [anon_sym_case] = ACTIONS(5492),
    [anon_sym_module] = ACTIONS(5492),
    [anon_sym_number] = ACTIONS(5492),
    [anon_sym_class] = ACTIONS(5492),
    [anon_sym_declare] = ACTIONS(5492),
    [anon_sym_typeof] = ACTIONS(5492),
    [anon_sym_LBRACE] = ACTIONS(5494),
    [anon_sym_switch] = ACTIONS(5492),
    [anon_sym_LPAREN] = ACTIONS(5494),
    [sym_null] = ACTIONS(5492),
    [anon_sym_any] = ACTIONS(5492),
    [anon_sym_boolean] = ACTIONS(5492),
    [anon_sym_async] = ACTIONS(5492),
    [anon_sym_public] = ACTIONS(5492),
    [anon_sym_var] = ACTIONS(5492),
    [anon_sym_while] = ACTIONS(5492),
    [anon_sym_SQUOTE] = ACTIONS(5494),
    [anon_sym_try] = ACTIONS(5492),
    [anon_sym_LT] = ACTIONS(5494),
    [sym_number] = ACTIONS(5494),
    [anon_sym_SLASH] = ACTIONS(5492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5492),
    [anon_sym_function] = ACTIONS(5492),
    [sym_undefined] = ACTIONS(5492),
    [anon_sym_new] = ACTIONS(5492),
    [ts_builtin_sym_end] = ACTIONS(5494),
    [anon_sym_let] = ACTIONS(5492),
    [anon_sym_PLUS] = ACTIONS(5492),
    [anon_sym_export] = ACTIONS(5492),
    [anon_sym_do] = ACTIONS(5492),
    [anon_sym_TILDE] = ACTIONS(5494),
    [anon_sym_with] = ACTIONS(5492),
  },
  [1748] = {
    [sym__automatic_semicolon] = ACTIONS(5496),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym_from] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
  },
  [1749] = {
    [sym__import_export_specifier] = STATE(2653),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_typeof] = ACTIONS(887),
    [anon_sym_type] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
  },
  [1750] = {
    [sym__automatic_semicolon] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym_from] = ACTIONS(5500),
    [sym_comment] = ACTIONS(3),
  },
  [1751] = {
    [aux_sym_export_clause_repeat1] = STATE(2655),
    [anon_sym_COMMA] = ACTIONS(5502),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [sym_comment] = ACTIONS(3),
  },
  [1752] = {
    [sym_new_expression] = STATE(2656),
    [sym_augmented_assignment_expression] = STATE(2656),
    [sym_unary_expression] = STATE(2656),
    [sym_update_expression] = STATE(2656),
    [sym_regex] = STATE(2656),
    [sym_meta_property] = STATE(2656),
    [sym_call_signature] = STATE(908),
    [sym_statement_block] = STATE(356),
    [sym__expression] = STATE(2656),
    [sym_yield_expression] = STATE(2656),
    [sym_as_expression] = STATE(2656),
    [sym_non_null_expression] = STATE(2656),
    [sym_internal_module] = STATE(2656),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2656),
    [sym_await_expression] = STATE(2656),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2656),
    [sym_this] = STATE(2656),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2656),
    [sym_generator_function] = STATE(2656),
    [sym_call_expression] = STATE(2656),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2656),
    [sym_ternary_expression] = STATE(2656),
    [sym_binary_expression] = STATE(2656),
    [sym_template_string] = STATE(2656),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2656),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2656),
    [sym_class] = STATE(2656),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5504),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5504),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5506),
    [sym_true] = ACTIONS(5504),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5504),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1753] = {
    [sym_new_expression] = STATE(2657),
    [sym_augmented_assignment_expression] = STATE(2657),
    [sym_unary_expression] = STATE(2657),
    [sym_update_expression] = STATE(2657),
    [sym_regex] = STATE(2657),
    [sym_meta_property] = STATE(2657),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(2657),
    [sym_yield_expression] = STATE(2657),
    [sym_as_expression] = STATE(2657),
    [sym_non_null_expression] = STATE(2657),
    [sym_internal_module] = STATE(2657),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2657),
    [sym_await_expression] = STATE(2657),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2657),
    [sym_this] = STATE(2657),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2657),
    [sym_generator_function] = STATE(2657),
    [sym_call_expression] = STATE(2657),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2657),
    [sym_ternary_expression] = STATE(2657),
    [sym_binary_expression] = STATE(2657),
    [sym_template_string] = STATE(2657),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2657),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2657),
    [sym_class] = STATE(2657),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5508),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5510),
    [sym_true] = ACTIONS(5508),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5508),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1754] = {
    [sym_new_expression] = STATE(2658),
    [sym_augmented_assignment_expression] = STATE(2658),
    [sym_unary_expression] = STATE(2658),
    [sym_update_expression] = STATE(2658),
    [sym_regex] = STATE(2658),
    [sym_meta_property] = STATE(2658),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(2658),
    [sym_yield_expression] = STATE(2658),
    [sym_as_expression] = STATE(2658),
    [sym_non_null_expression] = STATE(2658),
    [sym_internal_module] = STATE(2658),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2658),
    [sym_await_expression] = STATE(2658),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2658),
    [sym_this] = STATE(2658),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2658),
    [sym_generator_function] = STATE(2658),
    [sym_call_expression] = STATE(2658),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2658),
    [sym_ternary_expression] = STATE(2658),
    [sym_binary_expression] = STATE(2658),
    [sym_template_string] = STATE(2658),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2658),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2658),
    [sym_class] = STATE(2658),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5512),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5512),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5514),
    [sym_true] = ACTIONS(5512),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5512),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1755] = {
    [sym_new_expression] = STATE(2659),
    [sym_augmented_assignment_expression] = STATE(2659),
    [sym_unary_expression] = STATE(2659),
    [sym_update_expression] = STATE(2659),
    [sym_regex] = STATE(2659),
    [sym_meta_property] = STATE(2659),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(2659),
    [sym_yield_expression] = STATE(2659),
    [sym_as_expression] = STATE(2659),
    [sym_non_null_expression] = STATE(2659),
    [sym_internal_module] = STATE(2659),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2659),
    [sym_await_expression] = STATE(2659),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2659),
    [sym_this] = STATE(2659),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2659),
    [sym_generator_function] = STATE(2659),
    [sym_call_expression] = STATE(2659),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2659),
    [sym_ternary_expression] = STATE(2659),
    [sym_binary_expression] = STATE(2659),
    [sym_template_string] = STATE(2659),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2659),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2659),
    [sym_class] = STATE(2659),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5516),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5516),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5518),
    [sym_true] = ACTIONS(5516),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5516),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1756] = {
    [sym_new_expression] = STATE(2660),
    [sym_augmented_assignment_expression] = STATE(2660),
    [sym_unary_expression] = STATE(2660),
    [sym_update_expression] = STATE(2660),
    [sym_regex] = STATE(2660),
    [sym_meta_property] = STATE(2660),
    [sym_call_signature] = STATE(908),
    [sym_statement_block] = STATE(383),
    [sym__expression] = STATE(2660),
    [sym_yield_expression] = STATE(2660),
    [sym_as_expression] = STATE(2660),
    [sym_non_null_expression] = STATE(2660),
    [sym_internal_module] = STATE(2660),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2660),
    [sym_await_expression] = STATE(2660),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2660),
    [sym_this] = STATE(2660),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2660),
    [sym_generator_function] = STATE(2660),
    [sym_call_expression] = STATE(2660),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2660),
    [sym_ternary_expression] = STATE(2660),
    [sym_binary_expression] = STATE(2660),
    [sym_template_string] = STATE(2660),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2660),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2660),
    [sym_class] = STATE(2660),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5520),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5520),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5522),
    [sym_true] = ACTIONS(5520),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5520),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1757] = {
    [sym_new_expression] = STATE(2661),
    [sym_augmented_assignment_expression] = STATE(2661),
    [sym_unary_expression] = STATE(2661),
    [sym_update_expression] = STATE(2661),
    [sym_regex] = STATE(2661),
    [sym_meta_property] = STATE(2661),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(2661),
    [sym_yield_expression] = STATE(2661),
    [sym_as_expression] = STATE(2661),
    [sym_non_null_expression] = STATE(2661),
    [sym_internal_module] = STATE(2661),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2661),
    [sym_await_expression] = STATE(2661),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2661),
    [sym_this] = STATE(2661),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2661),
    [sym_generator_function] = STATE(2661),
    [sym_call_expression] = STATE(2661),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2661),
    [sym_ternary_expression] = STATE(2661),
    [sym_binary_expression] = STATE(2661),
    [sym_template_string] = STATE(2661),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2661),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2661),
    [sym_class] = STATE(2661),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5524),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5524),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5526),
    [sym_true] = ACTIONS(5524),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5524),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1758] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [1759] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [1760] = {
    [anon_sym_EQ_GT] = ACTIONS(5531),
    [sym_comment] = ACTIONS(3),
  },
  [1761] = {
    [anon_sym_EQ_GT] = ACTIONS(5533),
    [sym_comment] = ACTIONS(3),
  },
  [1762] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [sym__automatic_semicolon] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [1763] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [1764] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(868),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3624),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [1765] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1766] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(870),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1767] = {
    [sym_call_signature] = STATE(1760),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(3642),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(3642),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(3642),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(3642),
    [anon_sym_type] = ACTIONS(3642),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(3642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(3642),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(3642),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(3642),
    [anon_sym_declare] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(3642),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(3642),
    [anon_sym_async] = ACTIONS(3642),
    [anon_sym_public] = ACTIONS(3642),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(3642),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(3642),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1768] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1769] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(907),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [1770] = {
    [sym_new_expression] = STATE(2664),
    [sym_augmented_assignment_expression] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_update_expression] = STATE(2664),
    [sym_regex] = STATE(2664),
    [sym_meta_property] = STATE(2664),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(2664),
    [sym_yield_expression] = STATE(2664),
    [sym_as_expression] = STATE(2664),
    [sym_non_null_expression] = STATE(2664),
    [sym_internal_module] = STATE(2664),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2664),
    [sym_await_expression] = STATE(2664),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2664),
    [sym_this] = STATE(2664),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2664),
    [sym_generator_function] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_template_string] = STATE(2664),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2664),
    [sym_class] = STATE(2664),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5535),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5535),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5537),
    [sym_true] = ACTIONS(5535),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5535),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1771] = {
    [sym_new_expression] = STATE(2665),
    [sym_augmented_assignment_expression] = STATE(2665),
    [sym_unary_expression] = STATE(2665),
    [sym_update_expression] = STATE(2665),
    [sym_regex] = STATE(2665),
    [sym_meta_property] = STATE(2665),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(2665),
    [sym_yield_expression] = STATE(2665),
    [sym_as_expression] = STATE(2665),
    [sym_non_null_expression] = STATE(2665),
    [sym_internal_module] = STATE(2665),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2665),
    [sym_await_expression] = STATE(2665),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2665),
    [sym_this] = STATE(2665),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2665),
    [sym_generator_function] = STATE(2665),
    [sym_call_expression] = STATE(2665),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2665),
    [sym_ternary_expression] = STATE(2665),
    [sym_binary_expression] = STATE(2665),
    [sym_template_string] = STATE(2665),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2665),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2665),
    [sym_class] = STATE(2665),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5539),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5539),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5541),
    [sym_true] = ACTIONS(5539),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5539),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1772] = {
    [sym_new_expression] = STATE(2666),
    [sym_augmented_assignment_expression] = STATE(2666),
    [sym_unary_expression] = STATE(2666),
    [sym_update_expression] = STATE(2666),
    [sym_regex] = STATE(2666),
    [sym_meta_property] = STATE(2666),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(2666),
    [sym_yield_expression] = STATE(2666),
    [sym_as_expression] = STATE(2666),
    [sym_non_null_expression] = STATE(2666),
    [sym_internal_module] = STATE(2666),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2666),
    [sym_await_expression] = STATE(2666),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2666),
    [sym_this] = STATE(2666),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2666),
    [sym_generator_function] = STATE(2666),
    [sym_call_expression] = STATE(2666),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2666),
    [sym_ternary_expression] = STATE(2666),
    [sym_binary_expression] = STATE(2666),
    [sym_template_string] = STATE(2666),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2666),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2666),
    [sym_class] = STATE(2666),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5543),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5543),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5545),
    [sym_true] = ACTIONS(5543),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5543),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1773] = {
    [sym_new_expression] = STATE(2667),
    [sym_augmented_assignment_expression] = STATE(2667),
    [sym_unary_expression] = STATE(2667),
    [sym_update_expression] = STATE(2667),
    [sym_regex] = STATE(2667),
    [sym_meta_property] = STATE(2667),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(2667),
    [sym_yield_expression] = STATE(2667),
    [sym_as_expression] = STATE(2667),
    [sym_non_null_expression] = STATE(2667),
    [sym_internal_module] = STATE(2667),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2667),
    [sym_await_expression] = STATE(2667),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2667),
    [sym_this] = STATE(2667),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2667),
    [sym_generator_function] = STATE(2667),
    [sym_call_expression] = STATE(2667),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2667),
    [sym_ternary_expression] = STATE(2667),
    [sym_binary_expression] = STATE(2667),
    [sym_template_string] = STATE(2667),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2667),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2667),
    [sym_class] = STATE(2667),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5547),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5547),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5549),
    [sym_true] = ACTIONS(5547),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5547),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1774] = {
    [sym_new_expression] = STATE(2668),
    [sym_augmented_assignment_expression] = STATE(2668),
    [sym_unary_expression] = STATE(2668),
    [sym_update_expression] = STATE(2668),
    [sym_regex] = STATE(2668),
    [sym_meta_property] = STATE(2668),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2668),
    [sym_yield_expression] = STATE(2668),
    [sym_as_expression] = STATE(2668),
    [sym_non_null_expression] = STATE(2668),
    [sym_internal_module] = STATE(2668),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2668),
    [sym_await_expression] = STATE(2668),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2668),
    [sym_this] = STATE(2668),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2668),
    [sym_generator_function] = STATE(2668),
    [sym_call_expression] = STATE(2668),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2668),
    [sym_ternary_expression] = STATE(2668),
    [sym_binary_expression] = STATE(2668),
    [sym_template_string] = STATE(2668),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2668),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2668),
    [sym_class] = STATE(2668),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5551),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5551),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5553),
    [sym_true] = ACTIONS(5551),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5551),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1775] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(983),
    [sym_constructor_type] = STATE(983),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(983),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_template_string] = STATE(987),
    [sym_union_type] = STATE(983),
    [sym_intersection_type] = STATE(983),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_keyof] = ACTIONS(1976),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(5557),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_boolean] = ACTIONS(1972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1994),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1776] = {
    [sym_new_expression] = STATE(2657),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(2657),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(2657),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(2657),
    [sym_call_signature] = STATE(908),
    [sym_yield_expression] = STATE(2657),
    [sym_as_expression] = STATE(2657),
    [sym_internal_module] = STATE(2657),
    [sym_arrow_function] = STATE(2657),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(910),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(2678),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(911),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(2657),
    [sym_subscript_expression] = STATE(910),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(2657),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(2657),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(2657),
    [sym_meta_property] = STATE(2657),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(2657),
    [sym_non_null_expression] = STATE(2657),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(2657),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(2657),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_anonymous_class] = STATE(2657),
    [sym_call_expression] = STATE(2657),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(2657),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(2657),
    [sym_type_arguments] = STATE(912),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(2657),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2657),
    [sym_class] = STATE(2657),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(5565),
    [sym_false] = ACTIONS(5567),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(5569),
    [anon_sym_number] = ACTIONS(5569),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(5571),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(5575),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(5577),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [sym_null] = ACTIONS(5508),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(5569),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(5569),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(5579),
    [sym_number] = ACTIONS(5581),
    [sym_true] = ACTIONS(5567),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(5569),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5508),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(5583),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(5573),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1777] = {
    [sym_new_expression] = STATE(2686),
    [sym_augmented_assignment_expression] = STATE(2686),
    [sym_unary_expression] = STATE(2686),
    [sym_update_expression] = STATE(2686),
    [sym_regex] = STATE(2686),
    [sym_meta_property] = STATE(2686),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(2686),
    [sym_yield_expression] = STATE(2686),
    [sym_as_expression] = STATE(2686),
    [sym_non_null_expression] = STATE(2686),
    [sym_internal_module] = STATE(2686),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2686),
    [sym_await_expression] = STATE(2686),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(2686),
    [sym_this] = STATE(2686),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(2686),
    [sym_generator_function] = STATE(2686),
    [sym_call_expression] = STATE(2686),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(2686),
    [sym_ternary_expression] = STATE(2686),
    [sym_binary_expression] = STATE(2686),
    [sym_template_string] = STATE(2686),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2686),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2686),
    [sym_class] = STATE(2686),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(5585),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5585),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5587),
    [sym_true] = ACTIONS(5585),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5585),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [1778] = {
    [sym__automatic_semicolon] = ACTIONS(5589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(5589),
  },
  [1779] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5591),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [1780] = {
    [sym_parenthesized_expression] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1781] = {
    [anon_sym_await] = ACTIONS(5593),
    [anon_sym_LPAREN] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
  },
  [1782] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(2695),
    [sym__declaration] = STATE(192),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(2695),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(322),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(1717),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(5597),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_declare] = ACTIONS(5599),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1783] = {
    [sym_parenthesized_expression] = STATE(2696),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1784] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(2695),
    [sym__declaration] = STATE(317),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(2695),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_as] = ACTIONS(541),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(1717),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1733),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_declare] = ACTIONS(5599),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1785] = {
    [sym_parenthesized_expression] = STATE(2697),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1786] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(2401),
    [anon_sym_else] = ACTIONS(5603),
  },
  [1787] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(5605),
    [anon_sym_class] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [1788] = {
    [sym_class_heritage] = STATE(2700),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_type_parameters] = STATE(2701),
    [sym_class_body] = STATE(1163),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [1789] = {
    [sym_array] = STATE(2704),
    [sym_object] = STATE(2705),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(5607),
    [anon_sym_var] = ACTIONS(5609),
    [anon_sym_const] = ACTIONS(5609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(5609),
  },
  [1790] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5611),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5613),
  },
  [1791] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(2709),
    [sym_object] = STATE(2710),
    [sym_identifier] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1792] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(2709),
    [sym_object] = STATE(2710),
    [sym_identifier] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1793] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2711),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(2711),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [1794] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5619),
  },
  [1795] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5621),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5623),
  },
  [1796] = {
    [sym_identifier] = ACTIONS(5625),
    [sym_comment] = ACTIONS(3),
  },
  [1797] = {
    [sym_call_signature] = STATE(2718),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(5627),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1798] = {
    [sym_call_signature] = STATE(2719),
    [sym_formal_parameters] = STATE(858),
    [sym_type_parameters] = STATE(859),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1799] = {
    [sym_call_signature] = STATE(2721),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1800] = {
    [sym_statement_block] = STATE(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [1801] = {
    [sym_identifier] = ACTIONS(5631),
    [sym_comment] = ACTIONS(3),
  },
  [1802] = {
    [sym_new_expression] = STATE(244),
    [sym_augmented_assignment_expression] = STATE(244),
    [sym_unary_expression] = STATE(244),
    [sym_update_expression] = STATE(244),
    [sym_regex] = STATE(244),
    [sym_meta_property] = STATE(244),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(244),
    [sym_yield_expression] = STATE(244),
    [sym_as_expression] = STATE(244),
    [sym_non_null_expression] = STATE(244),
    [sym_internal_module] = STATE(244),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(244),
    [sym_await_expression] = STATE(244),
    [sym_member_expression] = STATE(245),
    [sym_sequence_expression] = STATE(247),
    [sym_string] = STATE(244),
    [sym_this] = STATE(244),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(244),
    [sym_generator_function] = STATE(244),
    [sym_call_expression] = STATE(244),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(244),
    [sym_ternary_expression] = STATE(244),
    [sym_binary_expression] = STATE(244),
    [sym_template_string] = STATE(244),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(244),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(244),
    [sym_class] = STATE(244),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(408),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(408),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(428),
    [sym_true] = ACTIONS(408),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(408),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [1803] = {
    [sym__automatic_semicolon] = ACTIONS(5633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(5633),
  },
  [1804] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2726),
    [sym_constructor_type] = STATE(2726),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(2726),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2726),
    [sym_intersection_type] = STATE(2726),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1805] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2729),
    [sym_constructor_type] = STATE(2729),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(2729),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2729),
    [sym_intersection_type] = STATE(2729),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1806] = {
    [anon_sym_EQ_GT] = ACTIONS(5641),
    [sym_comment] = ACTIONS(3),
  },
  [1807] = {
    [sym_formal_parameters] = STATE(2731),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1808] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(942),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(944),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1809] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(942),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(944),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1810] = {
    [anon_sym_EQ_GT] = ACTIONS(5643),
    [sym_comment] = ACTIONS(3),
  },
  [1811] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2733),
    [sym_constructor_type] = STATE(2733),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(2733),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2733),
    [sym_intersection_type] = STATE(2733),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1812] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2734),
    [sym_constructor_type] = STATE(2734),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(2734),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2734),
    [sym_intersection_type] = STATE(2734),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(942),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(944),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1813] = {
    [sym_new_expression] = STATE(2735),
    [sym_augmented_assignment_expression] = STATE(2735),
    [sym_unary_expression] = STATE(2735),
    [sym_update_expression] = STATE(2735),
    [sym_regex] = STATE(2735),
    [sym_meta_property] = STATE(2735),
    [sym_call_signature] = STATE(962),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(2735),
    [sym_yield_expression] = STATE(2735),
    [sym_as_expression] = STATE(2735),
    [sym_non_null_expression] = STATE(2735),
    [sym_internal_module] = STATE(2735),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2735),
    [sym_await_expression] = STATE(2735),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2735),
    [sym_this] = STATE(2735),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2735),
    [sym_generator_function] = STATE(2735),
    [sym_call_expression] = STATE(2735),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2735),
    [sym_ternary_expression] = STATE(2735),
    [sym_binary_expression] = STATE(2735),
    [sym_template_string] = STATE(2735),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2735),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2735),
    [sym_class] = STATE(2735),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5645),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5645),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5647),
    [sym_true] = ACTIONS(5645),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5645),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1814] = {
    [sym_new_expression] = STATE(2736),
    [sym_augmented_assignment_expression] = STATE(2736),
    [sym_unary_expression] = STATE(2736),
    [sym_update_expression] = STATE(2736),
    [sym_regex] = STATE(2736),
    [sym_meta_property] = STATE(2736),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2736),
    [sym_yield_expression] = STATE(2736),
    [sym_as_expression] = STATE(2736),
    [sym_non_null_expression] = STATE(2736),
    [sym_internal_module] = STATE(2736),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2736),
    [sym_await_expression] = STATE(2736),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2736),
    [sym_this] = STATE(2736),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2736),
    [sym_generator_function] = STATE(2736),
    [sym_call_expression] = STATE(2736),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2736),
    [sym_ternary_expression] = STATE(2736),
    [sym_binary_expression] = STATE(2736),
    [sym_template_string] = STATE(2736),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2736),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2736),
    [sym_class] = STATE(2736),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5649),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5649),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5651),
    [sym_true] = ACTIONS(5649),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5649),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1815] = {
    [sym_new_expression] = STATE(2737),
    [sym_augmented_assignment_expression] = STATE(2737),
    [sym_unary_expression] = STATE(2737),
    [sym_update_expression] = STATE(2737),
    [sym_regex] = STATE(2737),
    [sym_meta_property] = STATE(2737),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2737),
    [sym_yield_expression] = STATE(2737),
    [sym_as_expression] = STATE(2737),
    [sym_non_null_expression] = STATE(2737),
    [sym_internal_module] = STATE(2737),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2737),
    [sym_await_expression] = STATE(2737),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2737),
    [sym_this] = STATE(2737),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2737),
    [sym_generator_function] = STATE(2737),
    [sym_call_expression] = STATE(2737),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2737),
    [sym_ternary_expression] = STATE(2737),
    [sym_binary_expression] = STATE(2737),
    [sym_template_string] = STATE(2737),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2737),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2737),
    [sym_class] = STATE(2737),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5653),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5653),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5655),
    [sym_true] = ACTIONS(5653),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5653),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1816] = {
    [sym_new_expression] = STATE(2738),
    [sym_augmented_assignment_expression] = STATE(2738),
    [sym_unary_expression] = STATE(2738),
    [sym_update_expression] = STATE(2738),
    [sym_regex] = STATE(2738),
    [sym_meta_property] = STATE(2738),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2738),
    [sym_yield_expression] = STATE(2738),
    [sym_as_expression] = STATE(2738),
    [sym_non_null_expression] = STATE(2738),
    [sym_internal_module] = STATE(2738),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2738),
    [sym_await_expression] = STATE(2738),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2738),
    [sym_this] = STATE(2738),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2738),
    [sym_generator_function] = STATE(2738),
    [sym_call_expression] = STATE(2738),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2738),
    [sym_ternary_expression] = STATE(2738),
    [sym_binary_expression] = STATE(2738),
    [sym_template_string] = STATE(2738),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2738),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2738),
    [sym_class] = STATE(2738),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5657),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5657),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5659),
    [sym_true] = ACTIONS(5657),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5657),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1817] = {
    [sym_new_expression] = STATE(2739),
    [sym_augmented_assignment_expression] = STATE(2739),
    [sym_unary_expression] = STATE(2739),
    [sym_update_expression] = STATE(2739),
    [sym_regex] = STATE(2739),
    [sym_meta_property] = STATE(2739),
    [sym_call_signature] = STATE(962),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(2739),
    [sym_yield_expression] = STATE(2739),
    [sym_as_expression] = STATE(2739),
    [sym_non_null_expression] = STATE(2739),
    [sym_internal_module] = STATE(2739),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2739),
    [sym_await_expression] = STATE(2739),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2739),
    [sym_this] = STATE(2739),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2739),
    [sym_generator_function] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2739),
    [sym_ternary_expression] = STATE(2739),
    [sym_binary_expression] = STATE(2739),
    [sym_template_string] = STATE(2739),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2739),
    [sym_class] = STATE(2739),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5661),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5661),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5663),
    [sym_true] = ACTIONS(5661),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5661),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1818] = {
    [sym_new_expression] = STATE(2740),
    [sym_augmented_assignment_expression] = STATE(2740),
    [sym_unary_expression] = STATE(2740),
    [sym_update_expression] = STATE(2740),
    [sym_regex] = STATE(2740),
    [sym_meta_property] = STATE(2740),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2740),
    [sym_yield_expression] = STATE(2740),
    [sym_as_expression] = STATE(2740),
    [sym_non_null_expression] = STATE(2740),
    [sym_internal_module] = STATE(2740),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2740),
    [sym_await_expression] = STATE(2740),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2740),
    [sym_this] = STATE(2740),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2740),
    [sym_generator_function] = STATE(2740),
    [sym_call_expression] = STATE(2740),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2740),
    [sym_ternary_expression] = STATE(2740),
    [sym_binary_expression] = STATE(2740),
    [sym_template_string] = STATE(2740),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2740),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2740),
    [sym_class] = STATE(2740),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5665),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5667),
    [sym_true] = ACTIONS(5665),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5665),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1819] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(5669),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [1820] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(5669),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [1821] = {
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [sym_comment] = ACTIONS(3),
  },
  [1822] = {
    [anon_sym_EQ_GT] = ACTIONS(5674),
    [sym_comment] = ACTIONS(3),
  },
  [1823] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [1824] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(863),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [1825] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1599),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [1826] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1827] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1828] = {
    [sym_call_signature] = STATE(1821),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(3779),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(3781),
    [anon_sym_type] = ACTIONS(3781),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(3781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(3781),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(3781),
    [anon_sym_declare] = ACTIONS(3781),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(3781),
    [anon_sym_async] = ACTIONS(3781),
    [anon_sym_public] = ACTIONS(3781),
    [anon_sym_EQ_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(3781),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(3781),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1829] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [1830] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [1831] = {
    [sym_new_expression] = STATE(2743),
    [sym_augmented_assignment_expression] = STATE(2743),
    [sym_unary_expression] = STATE(2743),
    [sym_update_expression] = STATE(2743),
    [sym_regex] = STATE(2743),
    [sym_meta_property] = STATE(2743),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2743),
    [sym_yield_expression] = STATE(2743),
    [sym_as_expression] = STATE(2743),
    [sym_non_null_expression] = STATE(2743),
    [sym_internal_module] = STATE(2743),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2743),
    [sym_await_expression] = STATE(2743),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2743),
    [sym_this] = STATE(2743),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2743),
    [sym_generator_function] = STATE(2743),
    [sym_call_expression] = STATE(2743),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2743),
    [sym_ternary_expression] = STATE(2743),
    [sym_binary_expression] = STATE(2743),
    [sym_template_string] = STATE(2743),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2743),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2743),
    [sym_class] = STATE(2743),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5676),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5678),
    [sym_true] = ACTIONS(5676),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5676),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1832] = {
    [sym_new_expression] = STATE(2744),
    [sym_augmented_assignment_expression] = STATE(2744),
    [sym_unary_expression] = STATE(2744),
    [sym_update_expression] = STATE(2744),
    [sym_regex] = STATE(2744),
    [sym_meta_property] = STATE(2744),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2744),
    [sym_yield_expression] = STATE(2744),
    [sym_as_expression] = STATE(2744),
    [sym_non_null_expression] = STATE(2744),
    [sym_internal_module] = STATE(2744),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2744),
    [sym_await_expression] = STATE(2744),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2744),
    [sym_this] = STATE(2744),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2744),
    [sym_generator_function] = STATE(2744),
    [sym_call_expression] = STATE(2744),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2744),
    [sym_ternary_expression] = STATE(2744),
    [sym_binary_expression] = STATE(2744),
    [sym_template_string] = STATE(2744),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2744),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2744),
    [sym_class] = STATE(2744),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5680),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5680),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5682),
    [sym_true] = ACTIONS(5680),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5680),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1833] = {
    [sym_new_expression] = STATE(2745),
    [sym_augmented_assignment_expression] = STATE(2745),
    [sym_unary_expression] = STATE(2745),
    [sym_update_expression] = STATE(2745),
    [sym_regex] = STATE(2745),
    [sym_meta_property] = STATE(2745),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2745),
    [sym_yield_expression] = STATE(2745),
    [sym_as_expression] = STATE(2745),
    [sym_non_null_expression] = STATE(2745),
    [sym_internal_module] = STATE(2745),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2745),
    [sym_await_expression] = STATE(2745),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2745),
    [sym_this] = STATE(2745),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2745),
    [sym_generator_function] = STATE(2745),
    [sym_call_expression] = STATE(2745),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2745),
    [sym_ternary_expression] = STATE(2745),
    [sym_binary_expression] = STATE(2745),
    [sym_template_string] = STATE(2745),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2745),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2745),
    [sym_class] = STATE(2745),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5684),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5686),
    [sym_true] = ACTIONS(5684),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5684),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1834] = {
    [sym_new_expression] = STATE(2746),
    [sym_augmented_assignment_expression] = STATE(2746),
    [sym_unary_expression] = STATE(2746),
    [sym_update_expression] = STATE(2746),
    [sym_regex] = STATE(2746),
    [sym_meta_property] = STATE(2746),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2746),
    [sym_yield_expression] = STATE(2746),
    [sym_as_expression] = STATE(2746),
    [sym_non_null_expression] = STATE(2746),
    [sym_internal_module] = STATE(2746),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2746),
    [sym_await_expression] = STATE(2746),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2746),
    [sym_this] = STATE(2746),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2746),
    [sym_generator_function] = STATE(2746),
    [sym_call_expression] = STATE(2746),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2746),
    [sym_ternary_expression] = STATE(2746),
    [sym_binary_expression] = STATE(2746),
    [sym_template_string] = STATE(2746),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2746),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2746),
    [sym_class] = STATE(2746),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5688),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5690),
    [sym_true] = ACTIONS(5688),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5688),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1835] = {
    [sym_new_expression] = STATE(2747),
    [sym_augmented_assignment_expression] = STATE(2747),
    [sym_unary_expression] = STATE(2747),
    [sym_update_expression] = STATE(2747),
    [sym_regex] = STATE(2747),
    [sym_meta_property] = STATE(2747),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2747),
    [sym_yield_expression] = STATE(2747),
    [sym_as_expression] = STATE(2747),
    [sym_non_null_expression] = STATE(2747),
    [sym_internal_module] = STATE(2747),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2747),
    [sym_await_expression] = STATE(2747),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2747),
    [sym_this] = STATE(2747),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2747),
    [sym_generator_function] = STATE(2747),
    [sym_call_expression] = STATE(2747),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2747),
    [sym_ternary_expression] = STATE(2747),
    [sym_binary_expression] = STATE(2747),
    [sym_template_string] = STATE(2747),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2747),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2747),
    [sym_class] = STATE(2747),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5692),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5692),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5694),
    [sym_true] = ACTIONS(5692),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5692),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1836] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [1837] = {
    [sym_new_expression] = STATE(2736),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(2736),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(2736),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(2736),
    [sym_call_signature] = STATE(962),
    [sym_yield_expression] = STATE(2736),
    [sym_as_expression] = STATE(2736),
    [sym_internal_module] = STATE(2736),
    [sym_arrow_function] = STATE(2736),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(964),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1738),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(965),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(2736),
    [sym_subscript_expression] = STATE(964),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(2736),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(2736),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(2736),
    [sym_meta_property] = STATE(2736),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(2736),
    [sym_non_null_expression] = STATE(2736),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(2736),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(2736),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(2736),
    [sym_call_expression] = STATE(2736),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(2736),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(2736),
    [sym_type_arguments] = STATE(966),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(2736),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2736),
    [sym_class] = STATE(2736),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(5706),
    [sym_false] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(5708),
    [anon_sym_number] = ACTIONS(5708),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(5710),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5712),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(5714),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(5649),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5708),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(5708),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(3597),
    [sym_number] = ACTIONS(3599),
    [sym_true] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(5708),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5649),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(5716),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(5712),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1838] = {
    [sym_new_expression] = STATE(2762),
    [sym_augmented_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2762),
    [sym_update_expression] = STATE(2762),
    [sym_regex] = STATE(2762),
    [sym_meta_property] = STATE(2762),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(2762),
    [sym_yield_expression] = STATE(2762),
    [sym_as_expression] = STATE(2762),
    [sym_non_null_expression] = STATE(2762),
    [sym_internal_module] = STATE(2762),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2762),
    [sym_await_expression] = STATE(2762),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(2762),
    [sym_this] = STATE(2762),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(2762),
    [sym_generator_function] = STATE(2762),
    [sym_call_expression] = STATE(2762),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(2762),
    [sym_ternary_expression] = STATE(2762),
    [sym_binary_expression] = STATE(2762),
    [sym_template_string] = STATE(2762),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2762),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(2762),
    [sym_class] = STATE(2762),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(5718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5718),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5720),
    [sym_true] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5718),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [1839] = {
    [sym_new_expression] = STATE(2763),
    [sym_augmented_assignment_expression] = STATE(2763),
    [sym_unary_expression] = STATE(2763),
    [sym_update_expression] = STATE(2763),
    [sym_regex] = STATE(2763),
    [sym_meta_property] = STATE(2763),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2763),
    [sym_yield_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_non_null_expression] = STATE(2763),
    [sym_internal_module] = STATE(2763),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2763),
    [sym_this] = STATE(2763),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2763),
    [sym_generator_function] = STATE(2763),
    [sym_call_expression] = STATE(2763),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2763),
    [sym_ternary_expression] = STATE(2763),
    [sym_binary_expression] = STATE(2763),
    [sym_template_string] = STATE(2763),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2763),
    [sym_class] = STATE(2763),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5722),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5724),
    [sym_true] = ACTIONS(5722),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5722),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [1840] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2764),
    [sym_constructor_type] = STATE(2764),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(2764),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2764),
    [sym_intersection_type] = STATE(2764),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [1841] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2765),
    [sym_constructor_type] = STATE(2765),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(2765),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2765),
    [sym_intersection_type] = STATE(2765),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1842] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2766),
    [sym_constructor_type] = STATE(2766),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(2766),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2766),
    [sym_intersection_type] = STATE(2766),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1843] = {
    [sym_identifier] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
  },
  [1844] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2768),
    [sym_constructor_type] = STATE(2768),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(2768),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2768),
    [sym_intersection_type] = STATE(2768),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [1845] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym__automatic_semicolon] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_STAR] = ACTIONS(3267),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_BANG_EQ] = ACTIONS(3267),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_GT] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3267),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3267),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3267),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_SLASH] = ACTIONS(3267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_GT_GT] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_in] = ACTIONS(3267),
  },
  [1846] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1859),
    [sym_constructor_type] = STATE(1859),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(1859),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1859),
    [sym_intersection_type] = STATE(1859),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1847] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(3873),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_BQUOTE] = ACTIONS(3273),
    [sym__automatic_semicolon] = ACTIONS(3273),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_COMMA] = ACTIONS(3273),
    [anon_sym_LT_LT] = ACTIONS(3273),
    [anon_sym_STAR] = ACTIONS(3271),
    [anon_sym_GT_GT_GT] = ACTIONS(3273),
    [anon_sym_AMP_AMP] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_BANG_EQ] = ACTIONS(3271),
    [anon_sym_LT_EQ] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_GT_EQ] = ACTIONS(3273),
    [anon_sym_GT] = ACTIONS(3271),
    [anon_sym_AMP] = ACTIONS(3271),
    [anon_sym_PERCENT] = ACTIONS(3273),
    [anon_sym_QMARK] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_as] = ACTIONS(3273),
    [anon_sym_PIPE_PIPE] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [anon_sym_EQ_EQ] = ACTIONS(3271),
    [anon_sym_instanceof] = ACTIONS(3273),
    [anon_sym_LT] = ACTIONS(3271),
    [anon_sym_RPAREN] = ACTIONS(3273),
    [anon_sym_SLASH] = ACTIONS(3271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3273),
    [anon_sym_CARET] = ACTIONS(3273),
    [anon_sym_STAR_STAR] = ACTIONS(3273),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_GT_GT] = ACTIONS(3271),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3273),
    [anon_sym_in] = ACTIONS(3271),
  },
  [1848] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2769),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2769),
    [sym_call_signature] = STATE(2769),
    [sym_export_statement] = STATE(2769),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2769),
    [sym_index_signature] = STATE(2769),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1849] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_BQUOTE] = ACTIONS(3303),
    [sym__automatic_semicolon] = ACTIONS(3303),
    [anon_sym_PIPE] = ACTIONS(3301),
    [anon_sym_COMMA] = ACTIONS(3303),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3301),
    [anon_sym_GT_GT_GT] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_GT_EQ] = ACTIONS(3303),
    [anon_sym_GT] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_PERCENT] = ACTIONS(3303),
    [anon_sym_QMARK] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_as] = ACTIONS(3303),
    [anon_sym_PIPE_PIPE] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3301),
    [anon_sym_instanceof] = ACTIONS(3303),
    [anon_sym_LT] = ACTIONS(3301),
    [anon_sym_RPAREN] = ACTIONS(3303),
    [anon_sym_SLASH] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3303),
    [anon_sym_CARET] = ACTIONS(3303),
    [anon_sym_STAR_STAR] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3303),
    [anon_sym_in] = ACTIONS(3301),
  },
  [1850] = {
    [aux_sym_object_type_repeat1] = STATE(2772),
    [sym__automatic_semicolon] = ACTIONS(5728),
    [anon_sym_RBRACE] = ACTIONS(5730),
    [anon_sym_SEMI] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
  },
  [1851] = {
    [aux_sym_implements_clause_repeat1] = STATE(2774),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(3365),
    [anon_sym_RBRACK] = ACTIONS(5732),
    [sym_comment] = ACTIONS(3),
  },
  [1852] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [sym__automatic_semicolon] = ACTIONS(3375),
    [anon_sym_PIPE] = ACTIONS(3373),
    [anon_sym_COMMA] = ACTIONS(3375),
    [anon_sym_LT_LT] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_GT_GT_GT] = ACTIONS(3375),
    [anon_sym_AMP_AMP] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_BANG_EQ] = ACTIONS(3373),
    [anon_sym_LT_EQ] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3375),
    [anon_sym_GT_EQ] = ACTIONS(3375),
    [anon_sym_GT] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3375),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_RBRACE] = ACTIONS(3375),
    [anon_sym_as] = ACTIONS(3375),
    [anon_sym_PIPE_PIPE] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [anon_sym_EQ_EQ] = ACTIONS(3373),
    [anon_sym_instanceof] = ACTIONS(3375),
    [anon_sym_LT] = ACTIONS(3373),
    [anon_sym_RPAREN] = ACTIONS(3375),
    [anon_sym_SLASH] = ACTIONS(3373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3375),
    [anon_sym_CARET] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_GT_GT] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3375),
    [anon_sym_in] = ACTIONS(3373),
  },
  [1853] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [sym__automatic_semicolon] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_GT_GT_GT] = ACTIONS(3379),
    [anon_sym_AMP_AMP] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_BANG_EQ] = ACTIONS(3377),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(3379),
    [anon_sym_QMARK] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_as] = ACTIONS(3379),
    [anon_sym_PIPE_PIPE] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [anon_sym_EQ_EQ] = ACTIONS(3377),
    [anon_sym_instanceof] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_RPAREN] = ACTIONS(3379),
    [anon_sym_SLASH] = ACTIONS(3377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(3379),
    [anon_sym_STAR_STAR] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_GT_GT] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3377),
  },
  [1854] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [sym__automatic_semicolon] = ACTIONS(3387),
    [anon_sym_PIPE] = ACTIONS(3385),
    [anon_sym_COMMA] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_GT_GT_GT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_BANG_EQ] = ACTIONS(3385),
    [anon_sym_LT_EQ] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_GT_EQ] = ACTIONS(3387),
    [anon_sym_GT] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3385),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_as] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [anon_sym_EQ_EQ] = ACTIONS(3385),
    [anon_sym_instanceof] = ACTIONS(3387),
    [anon_sym_LT] = ACTIONS(3385),
    [anon_sym_RPAREN] = ACTIONS(3387),
    [anon_sym_SLASH] = ACTIONS(3385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_CARET] = ACTIONS(3387),
    [anon_sym_STAR_STAR] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_GT_GT] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_in] = ACTIONS(3385),
  },
  [1855] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [sym__automatic_semicolon] = ACTIONS(3393),
    [anon_sym_PIPE] = ACTIONS(3391),
    [anon_sym_COMMA] = ACTIONS(3393),
    [anon_sym_LT_LT] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3391),
    [anon_sym_GT_GT_GT] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3391),
    [anon_sym_LT_EQ] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT] = ACTIONS(3391),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_PERCENT] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_as] = ACTIONS(3393),
    [anon_sym_PIPE_PIPE] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_instanceof] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3391),
    [anon_sym_RPAREN] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_STAR_STAR] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_GT_GT] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3393),
    [anon_sym_in] = ACTIONS(3391),
  },
  [1856] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_BQUOTE] = ACTIONS(3383),
    [sym__automatic_semicolon] = ACTIONS(3383),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_LT_LT] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_GT_GT_GT] = ACTIONS(3383),
    [anon_sym_AMP_AMP] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3381),
    [anon_sym_BANG_EQ] = ACTIONS(3381),
    [anon_sym_LT_EQ] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3383),
    [anon_sym_GT_EQ] = ACTIONS(3383),
    [anon_sym_GT] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_PERCENT] = ACTIONS(3383),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_as] = ACTIONS(3383),
    [anon_sym_PIPE_PIPE] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [anon_sym_EQ_EQ] = ACTIONS(3381),
    [anon_sym_instanceof] = ACTIONS(3383),
    [anon_sym_LT] = ACTIONS(3381),
    [anon_sym_RPAREN] = ACTIONS(3383),
    [anon_sym_SLASH] = ACTIONS(3381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3383),
    [anon_sym_CARET] = ACTIONS(3383),
    [anon_sym_STAR_STAR] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3381),
    [anon_sym_GT_GT] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3383),
    [anon_sym_in] = ACTIONS(3381),
  },
  [1857] = {
    [anon_sym_EQ_GT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
  },
  [1858] = {
    [sym_formal_parameters] = STATE(2776),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1859] = {
    [anon_sym_AMP] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(5736),
    [anon_sym_PIPE] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
  },
  [1860] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3464),
    [anon_sym_SEMI] = ACTIONS(3466),
    [anon_sym_BQUOTE] = ACTIONS(3466),
    [sym__automatic_semicolon] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3464),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_LT_LT] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_GT_GT_GT] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_BANG_EQ] = ACTIONS(3464),
    [anon_sym_LT_EQ] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3466),
    [anon_sym_GT_EQ] = ACTIONS(3466),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_AMP] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_QMARK] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(3466),
    [anon_sym_as] = ACTIONS(3466),
    [anon_sym_PIPE_PIPE] = ACTIONS(3466),
    [anon_sym_DASH_DASH] = ACTIONS(3466),
    [anon_sym_EQ_EQ] = ACTIONS(3464),
    [anon_sym_instanceof] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_RPAREN] = ACTIONS(3466),
    [anon_sym_SLASH] = ACTIONS(3464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3466),
    [anon_sym_CARET] = ACTIONS(3466),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_GT_GT] = ACTIONS(3464),
    [anon_sym_PLUS_PLUS] = ACTIONS(3466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3466),
    [anon_sym_in] = ACTIONS(3464),
  },
  [1861] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2778),
    [sym_constructor_type] = STATE(2778),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(2778),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2778),
    [sym_intersection_type] = STATE(2778),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [1862] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2779),
    [sym_constructor_type] = STATE(2779),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(2779),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2779),
    [sym_intersection_type] = STATE(2779),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [1863] = {
    [anon_sym_EQ_GT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
  },
  [1864] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2781),
    [sym_constructor_type] = STATE(2781),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(2781),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2781),
    [sym_intersection_type] = STATE(2781),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [1865] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2782),
    [sym_constructor_type] = STATE(2782),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(2782),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2782),
    [sym_intersection_type] = STATE(2782),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1866] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_BANG] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym_BQUOTE] = ACTIONS(3480),
    [sym__automatic_semicolon] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3478),
    [anon_sym_COMMA] = ACTIONS(3480),
    [anon_sym_LT_LT] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_GT_GT_GT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_BANG_EQ] = ACTIONS(3478),
    [anon_sym_LT_EQ] = ACTIONS(3480),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_GT_EQ] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [anon_sym_as] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_EQ_EQ] = ACTIONS(3478),
    [anon_sym_instanceof] = ACTIONS(3480),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_RPAREN] = ACTIONS(3480),
    [anon_sym_SLASH] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_CARET] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_GT_GT] = ACTIONS(3478),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3480),
    [anon_sym_in] = ACTIONS(3478),
  },
  [1867] = {
    [anon_sym_RBRACK] = ACTIONS(5740),
    [sym_comment] = ACTIONS(3),
  },
  [1868] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2784),
    [sym_constructor_type] = STATE(2784),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(2784),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2784),
    [sym_intersection_type] = STATE(2784),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [1869] = {
    [sym_new_expression] = STATE(358),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(358),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(358),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(358),
    [sym_call_signature] = STATE(51),
    [sym_yield_expression] = STATE(358),
    [sym_as_expression] = STATE(358),
    [sym_internal_module] = STATE(358),
    [sym_arrow_function] = STATE(358),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(53),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(991),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(56),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(358),
    [sym_subscript_expression] = STATE(53),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(358),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(358),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(358),
    [sym_meta_property] = STATE(358),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(358),
    [sym_non_null_expression] = STATE(358),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(358),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(358),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_anonymous_class] = STATE(358),
    [sym_call_expression] = STATE(358),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(358),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(358),
    [sym_type_arguments] = STATE(63),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(358),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(358),
    [sym_class] = STATE(358),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(2000),
    [sym_false] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(2006),
    [anon_sym_number] = ACTIONS(2006),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [sym_null] = ACTIONS(622),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2006),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(2006),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(2018),
    [sym_number] = ACTIONS(2020),
    [sym_true] = ACTIONS(2002),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(2006),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(622),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(5742),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [1870] = {
    [sym_identifier] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
  },
  [1871] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [1872] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1873] = {
    [sym__initializer] = STATE(1041),
    [aux_sym_object_repeat1] = STATE(652),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(2173),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(360),
    [sym_comment] = ACTIONS(3),
  },
  [1874] = {
    [aux_sym_object_repeat1] = STATE(652),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(360),
    [sym_comment] = ACTIONS(3),
  },
  [1875] = {
    [aux_sym_object_repeat1] = STATE(652),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_namespace] = ACTIONS(1220),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
  },
  [1876] = {
    [sym__property_name] = STATE(2590),
    [aux_sym_object_repeat1] = STATE(652),
    [sym_string] = STATE(2590),
    [sym_computed_property_name] = STATE(2590),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(5359),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(5361),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(5361),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [1877] = {
    [sym__property_name] = STATE(2590),
    [aux_sym_object_repeat1] = STATE(652),
    [sym_string] = STATE(2590),
    [sym_computed_property_name] = STATE(2590),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [1878] = {
    [sym_type_alias_declaration] = STATE(1609),
    [aux_sym_export_statement_repeat1] = STATE(1608),
    [aux_sym_object_repeat1] = STATE(652),
    [sym__declaration] = STATE(1609),
    [sym_ambient_declaration] = STATE(1609),
    [sym_import_alias] = STATE(1609),
    [sym_export_statement] = STATE(1609),
    [sym_generator_function] = STATE(1609),
    [sym_export_clause] = STATE(1610),
    [sym_lexical_declaration] = STATE(1609),
    [sym_internal_module] = STATE(1609),
    [sym_decorator] = STATE(1608),
    [sym_enum_declaration] = STATE(1609),
    [sym_function] = STATE(1609),
    [sym_function_signature] = STATE(1609),
    [sym_variable_declaration] = STATE(1609),
    [sym_abstract_class] = STATE(1609),
    [sym_module] = STATE(1609),
    [sym_interface_declaration] = STATE(1609),
    [sym_class] = STATE(1609),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_import] = ACTIONS(3337),
    [anon_sym_export] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3341),
  },
  [1879] = {
    [sym_computed_property_name] = STATE(701),
    [sym__property_name] = STATE(701),
    [sym_decorator] = STATE(1044),
    [sym_method_definition] = STATE(700),
    [sym_string] = STATE(701),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(1044),
    [anon_sym_get] = ACTIONS(1308),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [sym_number] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1304),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(5371),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1304),
    [anon_sym_public] = ACTIONS(1304),
  },
  [1880] = {
    [sym__initializer] = STATE(712),
    [sym_type_annotation] = STATE(713),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1325),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1328),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5754),
  },
  [1881] = {
    [sym__initializer] = STATE(722),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1882] = {
    [sym_new_expression] = STATE(725),
    [sym_augmented_assignment_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym_update_expression] = STATE(725),
    [sym_regex] = STATE(725),
    [sym_meta_property] = STATE(725),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(725),
    [sym_yield_expression] = STATE(725),
    [sym_as_expression] = STATE(725),
    [sym_non_null_expression] = STATE(725),
    [sym_internal_module] = STATE(725),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(725),
    [sym_await_expression] = STATE(725),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(725),
    [sym_this] = STATE(725),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(725),
    [sym_generator_function] = STATE(725),
    [sym_call_expression] = STATE(725),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(725),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_template_string] = STATE(725),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(725),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(725),
    [sym_class] = STATE(725),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(1354),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1354),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5760),
    [sym_true] = ACTIONS(1354),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [1883] = {
    [sym_new_expression] = STATE(724),
    [sym_augmented_assignment_expression] = STATE(724),
    [sym__initializer] = STATE(722),
    [sym_unary_expression] = STATE(724),
    [sym_update_expression] = STATE(724),
    [sym_regex] = STATE(724),
    [sym_meta_property] = STATE(724),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(724),
    [sym_yield_expression] = STATE(724),
    [sym_as_expression] = STATE(724),
    [sym_non_null_expression] = STATE(724),
    [sym_internal_module] = STATE(724),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(724),
    [sym_await_expression] = STATE(724),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(724),
    [sym_this] = STATE(724),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(724),
    [sym_generator_function] = STATE(724),
    [sym_call_expression] = STATE(724),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(724),
    [sym_ternary_expression] = STATE(724),
    [sym_binary_expression] = STATE(724),
    [sym_template_string] = STATE(724),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_type_annotation] = STATE(723),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(724),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(724),
    [sym_class] = STATE(724),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(430),
    [sym_true] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1350),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1350),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(1344),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1350),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1884] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_RBRACK] = ACTIONS(3451),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [1885] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3891),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1886] = {
    [sym_new_expression] = STATE(724),
    [sym_augmented_assignment_expression] = STATE(724),
    [sym_unary_expression] = STATE(724),
    [sym_update_expression] = STATE(724),
    [sym_regex] = STATE(724),
    [sym_meta_property] = STATE(724),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(724),
    [sym_yield_expression] = STATE(724),
    [sym_as_expression] = STATE(724),
    [sym_non_null_expression] = STATE(724),
    [sym_internal_module] = STATE(724),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(724),
    [sym_await_expression] = STATE(724),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(724),
    [sym_this] = STATE(724),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(724),
    [sym_generator_function] = STATE(724),
    [sym_call_expression] = STATE(724),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(724),
    [sym_ternary_expression] = STATE(724),
    [sym_binary_expression] = STATE(724),
    [sym_template_string] = STATE(724),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(724),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(724),
    [sym_class] = STATE(724),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(5762),
    [sym_false] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1350),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1350),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [1887] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(2794),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2795),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1374),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1376),
    [anon_sym_symbol] = ACTIONS(1376),
    [anon_sym_number] = ACTIONS(1376),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1378),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1376),
    [anon_sym_private] = ACTIONS(1376),
    [anon_sym_boolean] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1380),
    [anon_sym_public] = ACTIONS(1376),
    [anon_sym_get] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1376),
    [anon_sym_string] = ACTIONS(1376),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1376),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(1376),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [1888] = {
    [sym_formal_parameters] = STATE(2796),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1889] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [1890] = {
    [sym_formal_parameters] = STATE(2797),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1891] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(5767),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [1892] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(5770),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [1893] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(5589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(3626),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(604),
  },
  [1894] = {
    [sym_class_body] = STATE(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [1895] = {
    [sym_class_heritage] = STATE(2799),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(2798),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [1896] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5773),
    [sym_identifier] = ACTIONS(5775),
    [sym__automatic_semicolon] = ACTIONS(5773),
    [anon_sym_BQUOTE] = ACTIONS(5773),
    [anon_sym_debugger] = ACTIONS(5775),
    [ts_builtin_sym_end] = ACTIONS(5773),
    [anon_sym_symbol] = ACTIONS(5775),
    [anon_sym_AT] = ACTIONS(5773),
    [anon_sym_PIPE] = ACTIONS(5775),
    [anon_sym_COMMA] = ACTIONS(5773),
    [anon_sym_DASH] = ACTIONS(5775),
    [anon_sym_STAR] = ACTIONS(5775),
    [anon_sym_GT_GT_GT] = ACTIONS(5773),
    [anon_sym_void] = ACTIONS(5775),
    [anon_sym_break] = ACTIONS(5775),
    [anon_sym_BANG_EQ] = ACTIONS(5775),
    [anon_sym_const] = ACTIONS(5775),
    [anon_sym_GT_EQ] = ACTIONS(5773),
    [sym_super] = ACTIONS(5775),
    [anon_sym_return] = ACTIONS(5775),
    [anon_sym_private] = ACTIONS(5775),
    [anon_sym_get] = ACTIONS(5775),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [anon_sym_PERCENT] = ACTIONS(5773),
    [anon_sym_interface] = ACTIONS(5775),
    [anon_sym_default] = ACTIONS(5775),
    [anon_sym_as] = ACTIONS(5775),
    [anon_sym_delete] = ACTIONS(5775),
    [anon_sym_continue] = ACTIONS(5775),
    [anon_sym_DASH_DASH] = ACTIONS(5773),
    [anon_sym_if] = ACTIONS(5775),
    [anon_sym_instanceof] = ACTIONS(5775),
    [anon_sym_this] = ACTIONS(5775),
    [anon_sym_yield] = ACTIONS(5775),
    [sym_true] = ACTIONS(5775),
    [anon_sym_throw] = ACTIONS(5775),
    [anon_sym_enum] = ACTIONS(5775),
    [anon_sym_protected] = ACTIONS(5775),
    [anon_sym_abstract] = ACTIONS(5775),
    [anon_sym_DOT] = ACTIONS(5775),
    [anon_sym_set] = ACTIONS(5775),
    [anon_sym_type] = ACTIONS(5775),
    [anon_sym_STAR_STAR] = ACTIONS(5773),
    [anon_sym_import] = ACTIONS(5775),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5773),
    [anon_sym_namespace] = ACTIONS(5775),
    [anon_sym_PLUS_PLUS] = ACTIONS(5773),
    [anon_sym_await] = ACTIONS(5775),
    [anon_sym_DQUOTE] = ACTIONS(5773),
    [anon_sym_else] = ACTIONS(5775),
    [anon_sym_BANG] = ACTIONS(5775),
    [anon_sym_for] = ACTIONS(5775),
    [anon_sym_LBRACK] = ACTIONS(5773),
    [sym_false] = ACTIONS(5775),
    [anon_sym_SEMI] = ACTIONS(5773),
    [anon_sym_case] = ACTIONS(5775),
    [anon_sym_module] = ACTIONS(5775),
    [anon_sym_number] = ACTIONS(5775),
    [anon_sym_class] = ACTIONS(5775),
    [anon_sym_declare] = ACTIONS(5775),
    [anon_sym_typeof] = ACTIONS(5775),
    [anon_sym_LT_LT] = ACTIONS(5773),
    [anon_sym_LBRACE] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_switch] = ACTIONS(5775),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_LPAREN] = ACTIONS(5773),
    [sym_null] = ACTIONS(5775),
    [anon_sym_GT] = ACTIONS(5775),
    [anon_sym_any] = ACTIONS(5775),
    [anon_sym_boolean] = ACTIONS(5775),
    [anon_sym_async] = ACTIONS(5775),
    [anon_sym_public] = ACTIONS(5775),
    [anon_sym_AMP] = ACTIONS(5775),
    [anon_sym_var] = ACTIONS(5775),
    [anon_sym_QMARK] = ACTIONS(5773),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_while] = ACTIONS(5775),
    [anon_sym_SQUOTE] = ACTIONS(5773),
    [anon_sym_try] = ACTIONS(5775),
    [anon_sym_EQ_EQ] = ACTIONS(5775),
    [anon_sym_RPAREN] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5775),
    [sym_number] = ACTIONS(5773),
    [anon_sym_SLASH] = ACTIONS(5775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5775),
    [anon_sym_function] = ACTIONS(5775),
    [sym_undefined] = ACTIONS(5775),
    [anon_sym_new] = ACTIONS(5775),
    [anon_sym_CARET] = ACTIONS(5773),
    [anon_sym_let] = ACTIONS(5775),
    [anon_sym_PLUS] = ACTIONS(5775),
    [anon_sym_export] = ACTIONS(5775),
    [anon_sym_GT_GT] = ACTIONS(5775),
    [anon_sym_do] = ACTIONS(5775),
    [anon_sym_TILDE] = ACTIONS(5773),
    [anon_sym_with] = ACTIONS(5775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5773),
    [anon_sym_in] = ACTIONS(5775),
  },
  [1897] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5777),
    [anon_sym_LBRACK] = ACTIONS(5777),
    [anon_sym_BANG] = ACTIONS(5779),
    [anon_sym_SEMI] = ACTIONS(5777),
    [anon_sym_BQUOTE] = ACTIONS(5777),
    [sym__automatic_semicolon] = ACTIONS(5777),
    [anon_sym_PIPE] = ACTIONS(5779),
    [anon_sym_COMMA] = ACTIONS(5777),
    [anon_sym_LT_LT] = ACTIONS(5777),
    [anon_sym_STAR] = ACTIONS(5779),
    [anon_sym_GT_GT_GT] = ACTIONS(5777),
    [anon_sym_AMP_AMP] = ACTIONS(5777),
    [anon_sym_DASH] = ACTIONS(5779),
    [anon_sym_BANG_EQ] = ACTIONS(5779),
    [anon_sym_LT_EQ] = ACTIONS(5777),
    [anon_sym_LPAREN] = ACTIONS(5777),
    [anon_sym_GT_EQ] = ACTIONS(5777),
    [anon_sym_GT] = ACTIONS(5779),
    [anon_sym_AMP] = ACTIONS(5779),
    [anon_sym_PERCENT] = ACTIONS(5777),
    [anon_sym_QMARK] = ACTIONS(5777),
    [anon_sym_RBRACE] = ACTIONS(5777),
    [anon_sym_as] = ACTIONS(5777),
    [anon_sym_PIPE_PIPE] = ACTIONS(5777),
    [anon_sym_DASH_DASH] = ACTIONS(5777),
    [anon_sym_EQ_EQ] = ACTIONS(5779),
    [anon_sym_instanceof] = ACTIONS(5777),
    [anon_sym_LT] = ACTIONS(5779),
    [anon_sym_RPAREN] = ACTIONS(5777),
    [anon_sym_SLASH] = ACTIONS(5779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5777),
    [anon_sym_CARET] = ACTIONS(5777),
    [anon_sym_STAR_STAR] = ACTIONS(5777),
    [anon_sym_PLUS] = ACTIONS(5779),
    [anon_sym_GT_GT] = ACTIONS(5779),
    [anon_sym_PLUS_PLUS] = ACTIONS(5777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5777),
    [anon_sym_in] = ACTIONS(5779),
  },
  [1898] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2972),
    [sym__automatic_semicolon] = ACTIONS(2972),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [anon_sym_debugger] = ACTIONS(2970),
    [anon_sym_with] = ACTIONS(2970),
    [anon_sym_symbol] = ACTIONS(2970),
    [anon_sym_AT] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_GT_GT_GT] = ACTIONS(2972),
    [anon_sym_void] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [sym_super] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_get] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_PERCENT] = ACTIONS(2972),
    [anon_sym_interface] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_as] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_instanceof] = ACTIONS(2970),
    [anon_sym_this] = ACTIONS(2970),
    [anon_sym_yield] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_abstract] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_set] = ACTIONS(2970),
    [anon_sym_type] = ACTIONS(2970),
    [anon_sym_STAR_STAR] = ACTIONS(2972),
    [anon_sym_import] = ACTIONS(2970),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_await] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [sym_false] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_module] = ACTIONS(2970),
    [anon_sym_number] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_declare] = ACTIONS(2970),
    [anon_sym_typeof] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [sym_null] = ACTIONS(2970),
    [anon_sym_GT] = ACTIONS(2970),
    [anon_sym_any] = ACTIONS(2970),
    [anon_sym_boolean] = ACTIONS(2970),
    [anon_sym_async] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_var] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_EQ_EQ] = ACTIONS(2970),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2970),
    [sym_number] = ACTIONS(2972),
    [anon_sym_SLASH] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2970),
    [anon_sym_function] = ACTIONS(2970),
    [sym_undefined] = ACTIONS(2970),
    [anon_sym_CARET] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_GT_GT] = ACTIONS(2970),
    [anon_sym_export] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2970),
  },
  [1899] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [1900] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1901] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [1902] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [1903] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [1904] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2155),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [1905] = {
    [sym_new_expression] = STATE(2800),
    [sym_augmented_assignment_expression] = STATE(2800),
    [sym_unary_expression] = STATE(2800),
    [sym_update_expression] = STATE(2800),
    [sym_regex] = STATE(2800),
    [sym_meta_property] = STATE(2800),
    [sym_call_signature] = STATE(374),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(2800),
    [sym_yield_expression] = STATE(2800),
    [sym_as_expression] = STATE(2800),
    [sym_non_null_expression] = STATE(2800),
    [sym_internal_module] = STATE(2800),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2800),
    [sym_await_expression] = STATE(2800),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(2800),
    [sym_this] = STATE(2800),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(2800),
    [sym_generator_function] = STATE(2800),
    [sym_call_expression] = STATE(2800),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(2800),
    [sym_ternary_expression] = STATE(2800),
    [sym_binary_expression] = STATE(2800),
    [sym_template_string] = STATE(2800),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2800),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(2800),
    [sym_class] = STATE(2800),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(5781),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5781),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5783),
    [sym_true] = ACTIONS(5781),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5781),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1906] = {
    [sym_new_expression] = STATE(2801),
    [sym_augmented_assignment_expression] = STATE(2801),
    [sym_unary_expression] = STATE(2801),
    [sym_update_expression] = STATE(2801),
    [sym_regex] = STATE(2801),
    [sym_meta_property] = STATE(2801),
    [sym_call_signature] = STATE(374),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(2801),
    [sym_yield_expression] = STATE(2801),
    [sym_as_expression] = STATE(2801),
    [sym_non_null_expression] = STATE(2801),
    [sym_internal_module] = STATE(2801),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2801),
    [sym_await_expression] = STATE(2801),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(2801),
    [sym_this] = STATE(2801),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(2801),
    [sym_generator_function] = STATE(2801),
    [sym_call_expression] = STATE(2801),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(2801),
    [sym_ternary_expression] = STATE(2801),
    [sym_binary_expression] = STATE(2801),
    [sym_template_string] = STATE(2801),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2801),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(2801),
    [sym_class] = STATE(2801),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(5785),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5785),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5787),
    [sym_true] = ACTIONS(5785),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5785),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1907] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [1908] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5789),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1909] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5789),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1910] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [1911] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2115),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1912] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1913] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_is] = ACTIONS(5794),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(5796),
  },
  [1914] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1915] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1916] = {
    [sym_formal_parameters] = STATE(2805),
    [sym_type_parameters] = STATE(2806),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1917] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1918] = {
    [sym_formal_parameters] = STATE(2809),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1919] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(5799),
  },
  [1920] = {
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [sym_comment] = ACTIONS(3),
  },
  [1921] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_AMP_EQ] = ACTIONS(2065),
    [anon_sym_PLUS_EQ] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(2065),
    [anon_sym_STAR_EQ] = ACTIONS(2065),
    [anon_sym_PIPE_EQ] = ACTIONS(2065),
    [anon_sym_DASH_EQ] = ACTIONS(2065),
    [anon_sym_EQ_GT] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5804),
  },
  [1922] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_AMP_EQ] = ACTIONS(2073),
    [anon_sym_PLUS_EQ] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(2073),
    [anon_sym_STAR_EQ] = ACTIONS(2073),
    [anon_sym_PIPE_EQ] = ACTIONS(2073),
    [anon_sym_DASH_EQ] = ACTIONS(2073),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1923] = {
    [sym_new_expression] = STATE(1014),
    [sym_augmented_assignment_expression] = STATE(1014),
    [sym_unary_expression] = STATE(1014),
    [sym_update_expression] = STATE(1014),
    [sym_regex] = STATE(1014),
    [sym_meta_property] = STATE(1014),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1014),
    [sym_yield_expression] = STATE(1014),
    [sym_as_expression] = STATE(1014),
    [sym_non_null_expression] = STATE(1014),
    [sym_internal_module] = STATE(1014),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1014),
    [sym_await_expression] = STATE(1014),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1014),
    [sym_this] = STATE(1014),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1014),
    [sym_generator_function] = STATE(1014),
    [sym_call_expression] = STATE(1014),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1014),
    [sym_ternary_expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_template_string] = STATE(1014),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1014),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1014),
    [sym_class] = STATE(1014),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(5806),
    [sym_false] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2077),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2079),
    [sym_true] = ACTIONS(2077),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2077),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1924] = {
    [sym_new_expression] = STATE(1015),
    [sym_augmented_assignment_expression] = STATE(1015),
    [sym_unary_expression] = STATE(1015),
    [sym_update_expression] = STATE(1015),
    [sym_regex] = STATE(1015),
    [sym_meta_property] = STATE(1015),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1015),
    [sym_yield_expression] = STATE(1015),
    [sym_as_expression] = STATE(1015),
    [sym_non_null_expression] = STATE(1015),
    [sym_internal_module] = STATE(1015),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1015),
    [sym_await_expression] = STATE(1015),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1015),
    [sym_this] = STATE(1015),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1015),
    [sym_generator_function] = STATE(1015),
    [sym_call_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1015),
    [sym_ternary_expression] = STATE(1015),
    [sym_binary_expression] = STATE(1015),
    [sym_template_string] = STATE(1015),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1015),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1015),
    [sym_class] = STATE(1015),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2081),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(2081),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2081),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [1925] = {
    [sym_new_expression] = STATE(1014),
    [sym_augmented_assignment_expression] = STATE(1014),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(1014),
    [sym_update_expression] = STATE(1014),
    [sym_regex] = STATE(1014),
    [sym_meta_property] = STATE(1014),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1014),
    [sym_yield_expression] = STATE(1014),
    [sym_as_expression] = STATE(1014),
    [sym_non_null_expression] = STATE(1014),
    [sym_internal_module] = STATE(1014),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1014),
    [sym_await_expression] = STATE(1014),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1014),
    [sym_this] = STATE(1014),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1014),
    [sym_generator_function] = STATE(1014),
    [sym_call_expression] = STATE(1014),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1014),
    [sym_ternary_expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_template_string] = STATE(1014),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1014),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1014),
    [sym_class] = STATE(1014),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2073),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_AMP_EQ] = ACTIONS(2073),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2073),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_PIPE_EQ] = ACTIONS(2073),
    [anon_sym_DASH_EQ] = ACTIONS(2073),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2073),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(660),
    [sym_true] = ACTIONS(2077),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2073),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2077),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2077),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_STAR_EQ] = ACTIONS(2073),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2073),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2077),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1926] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2097),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2099),
    [anon_sym_symbol] = ACTIONS(2099),
    [anon_sym_number] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2099),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2101),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2099),
    [anon_sym_private] = ACTIONS(2099),
    [anon_sym_boolean] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2099),
    [anon_sym_get] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2099),
    [anon_sym_string] = ACTIONS(2099),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2099),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(2099),
    [anon_sym_export] = ACTIONS(2099),
    [anon_sym_namespace] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [1927] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5789),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1928] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4190),
    [sym_identifier] = ACTIONS(4192),
    [anon_sym_BQUOTE] = ACTIONS(4190),
    [anon_sym_symbol] = ACTIONS(4192),
    [anon_sym_AT] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_COMMA] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_void] = ACTIONS(4192),
    [anon_sym_BANG_EQ] = ACTIONS(4192),
    [anon_sym_GT_EQ] = ACTIONS(4190),
    [anon_sym_private] = ACTIONS(4192),
    [anon_sym_get] = ACTIONS(4192),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4190),
    [anon_sym_as] = ACTIONS(4192),
    [anon_sym_DASH_DASH] = ACTIONS(4190),
    [anon_sym_instanceof] = ACTIONS(4192),
    [anon_sym_this] = ACTIONS(4192),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_protected] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_set] = ACTIONS(4192),
    [anon_sym_type] = ACTIONS(4192),
    [anon_sym_STAR_STAR] = ACTIONS(4190),
    [anon_sym_import] = ACTIONS(4192),
    [sym_readonly] = ACTIONS(4192),
    [anon_sym_PLUS_PLUS] = ACTIONS(4190),
    [anon_sym_namespace] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4190),
    [anon_sym_module] = ACTIONS(4192),
    [anon_sym_number] = ACTIONS(4192),
    [anon_sym_class] = ACTIONS(4192),
    [anon_sym_declare] = ACTIONS(4192),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4190),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_AMP_AMP] = ACTIONS(4190),
    [anon_sym_LT_EQ] = ACTIONS(4190),
    [anon_sym_LPAREN] = ACTIONS(4190),
    [anon_sym_RBRACK] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_any] = ACTIONS(4192),
    [anon_sym_boolean] = ACTIONS(4192),
    [anon_sym_async] = ACTIONS(4192),
    [anon_sym_public] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_PIPE_PIPE] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4190),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_SLASH] = ACTIONS(4192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_export] = ACTIONS(4192),
    [anon_sym_GT_GT] = ACTIONS(4192),
    [anon_sym_implements] = ACTIONS(4192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4190),
    [anon_sym_in] = ACTIONS(4192),
  },
  [1929] = {
    [aux_sym_array_repeat1] = STATE(1122),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
  },
  [1930] = {
    [anon_sym_EQ] = ACTIONS(2571),
    [anon_sym_COLON] = ACTIONS(4970),
    [anon_sym_LT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4970),
    [anon_sym_LPAREN] = ACTIONS(4970),
    [sym_comment] = ACTIONS(3),
  },
  [1931] = {
    [sym_statement_block] = STATE(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(901),
  },
  [1932] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2818),
    [sym_constructor_type] = STATE(2818),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(2818),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2818),
    [sym_intersection_type] = STATE(2818),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1933] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2821),
    [sym_constructor_type] = STATE(2821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(2821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2821),
    [sym_intersection_type] = STATE(2821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1934] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2822),
    [sym_constructor_type] = STATE(2822),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(2822),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2822),
    [sym_intersection_type] = STATE(2822),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1935] = {
    [sym_identifier] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
  },
  [1936] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2824),
    [sym_constructor_type] = STATE(2824),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(2824),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2824),
    [sym_intersection_type] = STATE(2824),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1937] = {
    [anon_sym_EQ] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_SEMI] = ACTIONS(3269),
    [sym__automatic_semicolon] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_COMMA] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3269),
  },
  [1938] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1951),
    [sym_constructor_type] = STATE(1951),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(1951),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1951),
    [sym_intersection_type] = STATE(1951),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1939] = {
    [anon_sym_EQ] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(3273),
    [anon_sym_SEMI] = ACTIONS(3273),
    [sym__automatic_semicolon] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3273),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_COMMA] = ACTIONS(3273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3273),
  },
  [1940] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2825),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2825),
    [sym_call_signature] = STATE(2825),
    [sym_export_statement] = STATE(2825),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2825),
    [sym_index_signature] = STATE(2825),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [1941] = {
    [anon_sym_EQ] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3303),
    [sym__automatic_semicolon] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3303),
    [anon_sym_PIPE] = ACTIONS(3301),
    [anon_sym_COMMA] = ACTIONS(3303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3303),
  },
  [1942] = {
    [aux_sym_object_type_repeat1] = STATE(2828),
    [sym__automatic_semicolon] = ACTIONS(5818),
    [anon_sym_RBRACE] = ACTIONS(5820),
    [anon_sym_SEMI] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
  },
  [1943] = {
    [aux_sym_implements_clause_repeat1] = STATE(2830),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(3365),
    [anon_sym_RBRACK] = ACTIONS(5822),
    [sym_comment] = ACTIONS(3),
  },
  [1944] = {
    [anon_sym_EQ] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3375),
    [sym__automatic_semicolon] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_RBRACE] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3375),
    [anon_sym_PIPE] = ACTIONS(3373),
    [anon_sym_COMMA] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3375),
  },
  [1945] = {
    [anon_sym_EQ] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3379),
    [sym__automatic_semicolon] = ACTIONS(3379),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3379),
  },
  [1946] = {
    [anon_sym_EQ] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3383),
    [sym__automatic_semicolon] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3383),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_COMMA] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3383),
  },
  [1947] = {
    [anon_sym_EQ] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3387),
    [sym__automatic_semicolon] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3387),
    [anon_sym_PIPE] = ACTIONS(3385),
    [anon_sym_COMMA] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3387),
  },
  [1948] = {
    [anon_sym_EQ] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3393),
    [sym__automatic_semicolon] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3393),
    [anon_sym_PIPE] = ACTIONS(3391),
    [anon_sym_COMMA] = ACTIONS(3393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3393),
  },
  [1949] = {
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [sym_comment] = ACTIONS(3),
  },
  [1950] = {
    [sym_formal_parameters] = STATE(2833),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1951] = {
    [anon_sym_AMP] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(5828),
    [anon_sym_PIPE] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
  },
  [1952] = {
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3466),
    [sym__automatic_semicolon] = ACTIONS(3466),
    [anon_sym_SEMI] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3464),
    [anon_sym_COMMA] = ACTIONS(3466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3466),
  },
  [1953] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1063),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1067),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1954] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1063),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1067),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1955] = {
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [sym_comment] = ACTIONS(3),
  },
  [1956] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2838),
    [sym_constructor_type] = STATE(2838),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(2838),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2838),
    [sym_intersection_type] = STATE(2838),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1957] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2839),
    [sym_constructor_type] = STATE(2839),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(2839),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2839),
    [sym_intersection_type] = STATE(2839),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1958] = {
    [anon_sym_EQ] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_SEMI] = ACTIONS(3480),
    [sym__automatic_semicolon] = ACTIONS(3480),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3478),
    [anon_sym_COMMA] = ACTIONS(3480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3480),
  },
  [1959] = {
    [anon_sym_RBRACK] = ACTIONS(5832),
    [sym_comment] = ACTIONS(3),
  },
  [1960] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2841),
    [sym_constructor_type] = STATE(2841),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(2841),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1063),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1067),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [1961] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4554),
    [anon_sym_LBRACK] = ACTIONS(4554),
    [anon_sym_in] = ACTIONS(4556),
    [anon_sym_BQUOTE] = ACTIONS(4554),
    [anon_sym_PIPE] = ACTIONS(4556),
    [anon_sym_COMMA] = ACTIONS(4554),
    [anon_sym_DASH] = ACTIONS(4556),
    [anon_sym_STAR] = ACTIONS(4556),
    [anon_sym_GT_GT_GT] = ACTIONS(4554),
    [anon_sym_EQ] = ACTIONS(4556),
    [anon_sym_AMP_AMP] = ACTIONS(4554),
    [anon_sym_LT_LT] = ACTIONS(4554),
    [anon_sym_BANG_EQ] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(4554),
    [anon_sym_LPAREN] = ACTIONS(4554),
    [anon_sym_RBRACK] = ACTIONS(4554),
    [anon_sym_GT_EQ] = ACTIONS(4554),
    [anon_sym_GT] = ACTIONS(4556),
    [anon_sym_LBRACE] = ACTIONS(4556),
    [anon_sym_of] = ACTIONS(4554),
    [anon_sym_AMP] = ACTIONS(4556),
    [anon_sym_PERCENT] = ACTIONS(4554),
    [anon_sym_QMARK] = ACTIONS(4554),
    [anon_sym_RBRACE] = ACTIONS(4554),
    [anon_sym_as] = ACTIONS(4554),
    [anon_sym_PIPE_PIPE] = ACTIONS(4554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4554),
    [anon_sym_DASH_DASH] = ACTIONS(4554),
    [anon_sym_EQ_EQ] = ACTIONS(4556),
    [anon_sym_instanceof] = ACTIONS(4554),
    [anon_sym_LT] = ACTIONS(4556),
    [anon_sym_RPAREN] = ACTIONS(4554),
    [anon_sym_SLASH] = ACTIONS(4556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4554),
    [anon_sym_DOT] = ACTIONS(4554),
    [anon_sym_CARET] = ACTIONS(4554),
    [anon_sym_STAR_STAR] = ACTIONS(4554),
    [anon_sym_PLUS] = ACTIONS(4556),
    [anon_sym_implements] = ACTIONS(4554),
    [anon_sym_GT_GT] = ACTIONS(4556),
    [anon_sym_PLUS_PLUS] = ACTIONS(4554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
  },
  [1962] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4908),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_in] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_DASH] = ACTIONS(4910),
    [anon_sym_STAR] = ACTIONS(4910),
    [anon_sym_GT_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4910),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_LPAREN] = ACTIONS(4908),
    [anon_sym_RBRACK] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_LBRACE] = ACTIONS(4910),
    [anon_sym_of] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
    [anon_sym_PERCENT] = ACTIONS(4908),
    [anon_sym_QMARK] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_as] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4908),
    [anon_sym_DASH_DASH] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_instanceof] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_SLASH] = ACTIONS(4910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4908),
    [anon_sym_CARET] = ACTIONS(4908),
    [anon_sym_STAR_STAR] = ACTIONS(4908),
    [anon_sym_PLUS] = ACTIONS(4910),
    [anon_sym_implements] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_PLUS_PLUS] = ACTIONS(4908),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG] = ACTIONS(4910),
  },
  [1963] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4976),
    [anon_sym_in] = ACTIONS(4978),
    [anon_sym_BQUOTE] = ACTIONS(4976),
    [anon_sym_PIPE] = ACTIONS(4978),
    [anon_sym_COMMA] = ACTIONS(4976),
    [anon_sym_DASH] = ACTIONS(4978),
    [anon_sym_STAR] = ACTIONS(4978),
    [anon_sym_GT_GT_GT] = ACTIONS(4976),
    [anon_sym_EQ] = ACTIONS(4978),
    [anon_sym_AMP_AMP] = ACTIONS(4976),
    [anon_sym_LT_LT] = ACTIONS(4976),
    [anon_sym_BANG_EQ] = ACTIONS(4978),
    [anon_sym_LT_EQ] = ACTIONS(4976),
    [anon_sym_LPAREN] = ACTIONS(4976),
    [anon_sym_RBRACK] = ACTIONS(4976),
    [anon_sym_GT_EQ] = ACTIONS(4976),
    [anon_sym_GT] = ACTIONS(4978),
    [anon_sym_LBRACE] = ACTIONS(4978),
    [anon_sym_of] = ACTIONS(4976),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_PERCENT] = ACTIONS(4976),
    [anon_sym_QMARK] = ACTIONS(4976),
    [anon_sym_RBRACE] = ACTIONS(4976),
    [anon_sym_as] = ACTIONS(4976),
    [anon_sym_PIPE_PIPE] = ACTIONS(4976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4976),
    [anon_sym_DASH_DASH] = ACTIONS(4976),
    [anon_sym_EQ_EQ] = ACTIONS(4978),
    [anon_sym_instanceof] = ACTIONS(4976),
    [anon_sym_LT] = ACTIONS(4978),
    [anon_sym_RPAREN] = ACTIONS(4976),
    [anon_sym_SLASH] = ACTIONS(4978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4976),
    [anon_sym_DOT] = ACTIONS(4976),
    [anon_sym_CARET] = ACTIONS(4976),
    [anon_sym_STAR_STAR] = ACTIONS(4976),
    [anon_sym_PLUS] = ACTIONS(4978),
    [anon_sym_implements] = ACTIONS(4976),
    [anon_sym_GT_GT] = ACTIONS(4978),
    [anon_sym_PLUS_PLUS] = ACTIONS(4976),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4976),
    [anon_sym_BANG] = ACTIONS(4978),
  },
  [1964] = {
    [aux_sym_object_repeat1] = STATE(695),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(5834),
    [sym_comment] = ACTIONS(3),
  },
  [1965] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2846),
    [sym_constructor_type] = STATE(2846),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(2846),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1966] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2849),
    [sym_constructor_type] = STATE(2849),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(2849),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2849),
    [sym_intersection_type] = STATE(2849),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1967] = {
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [sym_comment] = ACTIONS(3),
  },
  [1968] = {
    [sym_formal_parameters] = STATE(2851),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1969] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1086),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1088),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1970] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1086),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1088),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1971] = {
    [anon_sym_EQ_GT] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
  },
  [1972] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2853),
    [sym_constructor_type] = STATE(2853),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(2853),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2853),
    [sym_intersection_type] = STATE(2853),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1973] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2854),
    [sym_constructor_type] = STATE(2854),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(2854),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2854),
    [sym_intersection_type] = STATE(2854),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1086),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1088),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [1974] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(3757),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1975] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1976] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1977] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1978] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1979] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(2155),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1980] = {
    [sym_new_expression] = STATE(2855),
    [sym_augmented_assignment_expression] = STATE(2855),
    [sym_unary_expression] = STATE(2855),
    [sym_update_expression] = STATE(2855),
    [sym_regex] = STATE(2855),
    [sym_meta_property] = STATE(2855),
    [sym_call_signature] = STATE(446),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(2855),
    [sym_yield_expression] = STATE(2855),
    [sym_as_expression] = STATE(2855),
    [sym_non_null_expression] = STATE(2855),
    [sym_internal_module] = STATE(2855),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2855),
    [sym_await_expression] = STATE(2855),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(2855),
    [sym_this] = STATE(2855),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(2855),
    [sym_generator_function] = STATE(2855),
    [sym_call_expression] = STATE(2855),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(2855),
    [sym_ternary_expression] = STATE(2855),
    [sym_binary_expression] = STATE(2855),
    [sym_template_string] = STATE(2855),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2855),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(2855),
    [sym_class] = STATE(2855),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5846),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5848),
    [sym_true] = ACTIONS(5846),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5846),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1981] = {
    [sym_new_expression] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2856),
    [sym_unary_expression] = STATE(2856),
    [sym_update_expression] = STATE(2856),
    [sym_regex] = STATE(2856),
    [sym_meta_property] = STATE(2856),
    [sym_call_signature] = STATE(446),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(2856),
    [sym_yield_expression] = STATE(2856),
    [sym_as_expression] = STATE(2856),
    [sym_non_null_expression] = STATE(2856),
    [sym_internal_module] = STATE(2856),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2856),
    [sym_await_expression] = STATE(2856),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(2856),
    [sym_this] = STATE(2856),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(2856),
    [sym_generator_function] = STATE(2856),
    [sym_call_expression] = STATE(2856),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(2856),
    [sym_ternary_expression] = STATE(2856),
    [sym_binary_expression] = STATE(2856),
    [sym_template_string] = STATE(2856),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2856),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(2856),
    [sym_class] = STATE(2856),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5850),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5852),
    [sym_true] = ACTIONS(5850),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5850),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1982] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1983] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1984] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [1985] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [1986] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [1987] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_is] = ACTIONS(5859),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(5861),
  },
  [1988] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1989] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1990] = {
    [sym_formal_parameters] = STATE(2860),
    [sym_type_parameters] = STATE(2861),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [1991] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [1992] = {
    [sym_formal_parameters] = STATE(2864),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [1993] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(5864),
  },
  [1994] = {
    [anon_sym_EQ_GT] = ACTIONS(5867),
    [sym_comment] = ACTIONS(3),
  },
  [1995] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_AMP_EQ] = ACTIONS(2251),
    [anon_sym_PLUS_EQ] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(2251),
    [anon_sym_STAR_EQ] = ACTIONS(2251),
    [anon_sym_PIPE_EQ] = ACTIONS(2251),
    [anon_sym_DASH_EQ] = ACTIONS(2251),
    [anon_sym_EQ_GT] = ACTIONS(2253),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5869),
  },
  [1996] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1997] = {
    [sym_new_expression] = STATE(1098),
    [sym_augmented_assignment_expression] = STATE(1098),
    [sym_unary_expression] = STATE(1098),
    [sym_update_expression] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_meta_property] = STATE(1098),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1098),
    [sym_as_expression] = STATE(1098),
    [sym_non_null_expression] = STATE(1098),
    [sym_internal_module] = STATE(1098),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1098),
    [sym_await_expression] = STATE(1098),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1098),
    [sym_this] = STATE(1098),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1098),
    [sym_generator_function] = STATE(1098),
    [sym_call_expression] = STATE(1098),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1098),
    [sym_ternary_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_template_string] = STATE(1098),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1098),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1098),
    [sym_class] = STATE(1098),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(5871),
    [sym_false] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2261),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2263),
    [sym_true] = ACTIONS(2261),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2261),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1998] = {
    [sym_new_expression] = STATE(1099),
    [sym_augmented_assignment_expression] = STATE(1099),
    [sym_unary_expression] = STATE(1099),
    [sym_update_expression] = STATE(1099),
    [sym_regex] = STATE(1099),
    [sym_meta_property] = STATE(1099),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1099),
    [sym_yield_expression] = STATE(1099),
    [sym_as_expression] = STATE(1099),
    [sym_non_null_expression] = STATE(1099),
    [sym_internal_module] = STATE(1099),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1099),
    [sym_await_expression] = STATE(1099),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1099),
    [sym_this] = STATE(1099),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1099),
    [sym_generator_function] = STATE(1099),
    [sym_call_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1099),
    [sym_ternary_expression] = STATE(1099),
    [sym_binary_expression] = STATE(1099),
    [sym_template_string] = STATE(1099),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1099),
    [sym_class] = STATE(1099),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2265),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(2265),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2265),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [1999] = {
    [sym_new_expression] = STATE(1098),
    [sym_augmented_assignment_expression] = STATE(1098),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(1098),
    [sym_update_expression] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_meta_property] = STATE(1098),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1098),
    [sym_as_expression] = STATE(1098),
    [sym_non_null_expression] = STATE(1098),
    [sym_internal_module] = STATE(1098),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1098),
    [sym_await_expression] = STATE(1098),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(1098),
    [sym_this] = STATE(1098),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(1098),
    [sym_generator_function] = STATE(1098),
    [sym_call_expression] = STATE(1098),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(1098),
    [sym_ternary_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_template_string] = STATE(1098),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1098),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1098),
    [sym_class] = STATE(1098),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2257),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(2257),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2257),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_PIPE_EQ] = ACTIONS(2257),
    [anon_sym_DASH_EQ] = ACTIONS(2257),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2257),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(803),
    [sym_true] = ACTIONS(2261),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2261),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2257),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2261),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(2257),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_EQ_GT] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2257),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2261),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2000] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2293),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2295),
    [anon_sym_symbol] = ACTIONS(2295),
    [anon_sym_number] = ACTIONS(2295),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2295),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2297),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2295),
    [anon_sym_private] = ACTIONS(2295),
    [anon_sym_boolean] = ACTIONS(2295),
    [anon_sym_async] = ACTIONS(2299),
    [anon_sym_public] = ACTIONS(2295),
    [anon_sym_get] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2295),
    [anon_sym_string] = ACTIONS(2295),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2295),
    [anon_sym_type] = ACTIONS(2295),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(2295),
    [anon_sym_export] = ACTIONS(2295),
    [anon_sym_namespace] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [2001] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2002] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5873),
    [anon_sym_LBRACK] = ACTIONS(5873),
    [anon_sym_BANG] = ACTIONS(5875),
    [anon_sym_SEMI] = ACTIONS(5873),
    [anon_sym_BQUOTE] = ACTIONS(5873),
    [sym__automatic_semicolon] = ACTIONS(5873),
    [anon_sym_PIPE] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5873),
    [anon_sym_LT_LT] = ACTIONS(5873),
    [anon_sym_STAR] = ACTIONS(5875),
    [anon_sym_GT_GT_GT] = ACTIONS(5873),
    [anon_sym_AMP_AMP] = ACTIONS(5873),
    [anon_sym_DASH] = ACTIONS(5875),
    [anon_sym_BANG_EQ] = ACTIONS(5875),
    [anon_sym_LT_EQ] = ACTIONS(5873),
    [anon_sym_LPAREN] = ACTIONS(5873),
    [anon_sym_GT_EQ] = ACTIONS(5873),
    [anon_sym_GT] = ACTIONS(5875),
    [anon_sym_AMP] = ACTIONS(5875),
    [anon_sym_PERCENT] = ACTIONS(5873),
    [anon_sym_QMARK] = ACTIONS(5873),
    [anon_sym_RBRACE] = ACTIONS(5873),
    [anon_sym_as] = ACTIONS(5873),
    [anon_sym_PIPE_PIPE] = ACTIONS(5873),
    [anon_sym_DASH_DASH] = ACTIONS(5873),
    [anon_sym_EQ_EQ] = ACTIONS(5875),
    [anon_sym_instanceof] = ACTIONS(5873),
    [anon_sym_LT] = ACTIONS(5875),
    [anon_sym_RPAREN] = ACTIONS(5873),
    [anon_sym_SLASH] = ACTIONS(5875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5873),
    [anon_sym_CARET] = ACTIONS(5873),
    [anon_sym_STAR_STAR] = ACTIONS(5873),
    [anon_sym_PLUS] = ACTIONS(5875),
    [anon_sym_GT_GT] = ACTIONS(5875),
    [anon_sym_PLUS_PLUS] = ACTIONS(5873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5873),
    [anon_sym_in] = ACTIONS(5875),
  },
  [2003] = {
    [sym_new_expression] = STATE(2869),
    [sym_augmented_assignment_expression] = STATE(2869),
    [sym_unary_expression] = STATE(2869),
    [sym_update_expression] = STATE(2869),
    [sym_regex] = STATE(2869),
    [sym_meta_property] = STATE(2869),
    [sym_call_signature] = STATE(1134),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(2869),
    [sym_yield_expression] = STATE(2869),
    [sym_as_expression] = STATE(2869),
    [sym_non_null_expression] = STATE(2869),
    [sym_internal_module] = STATE(2869),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2869),
    [sym_await_expression] = STATE(2869),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2869),
    [sym_this] = STATE(2869),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2869),
    [sym_generator_function] = STATE(2869),
    [sym_call_expression] = STATE(2869),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2869),
    [sym_ternary_expression] = STATE(2869),
    [sym_binary_expression] = STATE(2869),
    [sym_template_string] = STATE(2869),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2869),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2869),
    [sym_class] = STATE(2869),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5877),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5877),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5879),
    [sym_true] = ACTIONS(5877),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5877),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2004] = {
    [sym_new_expression] = STATE(2870),
    [sym_augmented_assignment_expression] = STATE(2870),
    [sym_unary_expression] = STATE(2870),
    [sym_update_expression] = STATE(2870),
    [sym_regex] = STATE(2870),
    [sym_meta_property] = STATE(2870),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2870),
    [sym_yield_expression] = STATE(2870),
    [sym_as_expression] = STATE(2870),
    [sym_non_null_expression] = STATE(2870),
    [sym_internal_module] = STATE(2870),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2870),
    [sym_await_expression] = STATE(2870),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2870),
    [sym_this] = STATE(2870),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2870),
    [sym_generator_function] = STATE(2870),
    [sym_call_expression] = STATE(2870),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2870),
    [sym_ternary_expression] = STATE(2870),
    [sym_binary_expression] = STATE(2870),
    [sym_template_string] = STATE(2870),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2870),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2870),
    [sym_class] = STATE(2870),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5881),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5881),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5883),
    [sym_true] = ACTIONS(5881),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5881),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2005] = {
    [sym_new_expression] = STATE(2871),
    [sym_augmented_assignment_expression] = STATE(2871),
    [sym_unary_expression] = STATE(2871),
    [sym_update_expression] = STATE(2871),
    [sym_regex] = STATE(2871),
    [sym_meta_property] = STATE(2871),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2871),
    [sym_yield_expression] = STATE(2871),
    [sym_as_expression] = STATE(2871),
    [sym_non_null_expression] = STATE(2871),
    [sym_internal_module] = STATE(2871),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2871),
    [sym_await_expression] = STATE(2871),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2871),
    [sym_this] = STATE(2871),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2871),
    [sym_generator_function] = STATE(2871),
    [sym_call_expression] = STATE(2871),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2871),
    [sym_ternary_expression] = STATE(2871),
    [sym_binary_expression] = STATE(2871),
    [sym_template_string] = STATE(2871),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2871),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2871),
    [sym_class] = STATE(2871),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5885),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5885),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5887),
    [sym_true] = ACTIONS(5885),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5885),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2006] = {
    [sym_new_expression] = STATE(2872),
    [sym_augmented_assignment_expression] = STATE(2872),
    [sym_unary_expression] = STATE(2872),
    [sym_update_expression] = STATE(2872),
    [sym_regex] = STATE(2872),
    [sym_meta_property] = STATE(2872),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2872),
    [sym_yield_expression] = STATE(2872),
    [sym_as_expression] = STATE(2872),
    [sym_non_null_expression] = STATE(2872),
    [sym_internal_module] = STATE(2872),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2872),
    [sym_await_expression] = STATE(2872),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2872),
    [sym_this] = STATE(2872),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2872),
    [sym_generator_function] = STATE(2872),
    [sym_call_expression] = STATE(2872),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2872),
    [sym_ternary_expression] = STATE(2872),
    [sym_binary_expression] = STATE(2872),
    [sym_template_string] = STATE(2872),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2872),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2872),
    [sym_class] = STATE(2872),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5889),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5889),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5891),
    [sym_true] = ACTIONS(5889),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5889),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2007] = {
    [sym_new_expression] = STATE(2873),
    [sym_augmented_assignment_expression] = STATE(2873),
    [sym_unary_expression] = STATE(2873),
    [sym_update_expression] = STATE(2873),
    [sym_regex] = STATE(2873),
    [sym_meta_property] = STATE(2873),
    [sym_call_signature] = STATE(1134),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(2873),
    [sym_yield_expression] = STATE(2873),
    [sym_as_expression] = STATE(2873),
    [sym_non_null_expression] = STATE(2873),
    [sym_internal_module] = STATE(2873),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2873),
    [sym_await_expression] = STATE(2873),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2873),
    [sym_this] = STATE(2873),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2873),
    [sym_generator_function] = STATE(2873),
    [sym_call_expression] = STATE(2873),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2873),
    [sym_ternary_expression] = STATE(2873),
    [sym_binary_expression] = STATE(2873),
    [sym_template_string] = STATE(2873),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2873),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2873),
    [sym_class] = STATE(2873),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5893),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5895),
    [sym_true] = ACTIONS(5893),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5893),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2008] = {
    [sym_new_expression] = STATE(2874),
    [sym_augmented_assignment_expression] = STATE(2874),
    [sym_unary_expression] = STATE(2874),
    [sym_update_expression] = STATE(2874),
    [sym_regex] = STATE(2874),
    [sym_meta_property] = STATE(2874),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2874),
    [sym_yield_expression] = STATE(2874),
    [sym_as_expression] = STATE(2874),
    [sym_non_null_expression] = STATE(2874),
    [sym_internal_module] = STATE(2874),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2874),
    [sym_await_expression] = STATE(2874),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2874),
    [sym_this] = STATE(2874),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2874),
    [sym_generator_function] = STATE(2874),
    [sym_call_expression] = STATE(2874),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2874),
    [sym_ternary_expression] = STATE(2874),
    [sym_binary_expression] = STATE(2874),
    [sym_template_string] = STATE(2874),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2874),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2874),
    [sym_class] = STATE(2874),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5897),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5897),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5899),
    [sym_true] = ACTIONS(5897),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5897),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2009] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4203),
    [anon_sym_AMP_EQ] = ACTIONS(4203),
    [anon_sym_PLUS_EQ] = ACTIONS(4203),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4203),
    [anon_sym_STAR_EQ] = ACTIONS(4203),
    [anon_sym_PIPE_EQ] = ACTIONS(4203),
    [anon_sym_DASH_EQ] = ACTIONS(4203),
    [anon_sym_EQ_GT] = ACTIONS(4209),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4203),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT_EQ] = ACTIONS(4203),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4211),
  },
  [2010] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(5901),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [2011] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(5901),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [2012] = {
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [sym_comment] = ACTIONS(3),
  },
  [2013] = {
    [anon_sym_EQ_GT] = ACTIONS(5906),
    [sym_comment] = ACTIONS(3),
  },
  [2014] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_LBRACE] = ACTIONS(833),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [2015] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [2016] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(4209),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [2017] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1609),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2018] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2019] = {
    [sym_call_signature] = STATE(2012),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(4229),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(4231),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(4231),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(4231),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(4231),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(4231),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(4231),
    [anon_sym_type] = ACTIONS(4231),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(4231),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(4231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(4231),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(4231),
    [anon_sym_declare] = ACTIONS(4231),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(4231),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(4231),
    [anon_sym_async] = ACTIONS(4231),
    [anon_sym_public] = ACTIONS(4231),
    [anon_sym_EQ_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(4231),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(4231),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2020] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1609),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2021] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(5910),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(907),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [2022] = {
    [sym_new_expression] = STATE(2877),
    [sym_augmented_assignment_expression] = STATE(2877),
    [sym_unary_expression] = STATE(2877),
    [sym_update_expression] = STATE(2877),
    [sym_regex] = STATE(2877),
    [sym_meta_property] = STATE(2877),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2877),
    [sym_yield_expression] = STATE(2877),
    [sym_as_expression] = STATE(2877),
    [sym_non_null_expression] = STATE(2877),
    [sym_internal_module] = STATE(2877),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2877),
    [sym_await_expression] = STATE(2877),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2877),
    [sym_this] = STATE(2877),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2877),
    [sym_generator_function] = STATE(2877),
    [sym_call_expression] = STATE(2877),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2877),
    [sym_ternary_expression] = STATE(2877),
    [sym_binary_expression] = STATE(2877),
    [sym_template_string] = STATE(2877),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2877),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2877),
    [sym_class] = STATE(2877),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5912),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5914),
    [sym_true] = ACTIONS(5912),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5912),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2023] = {
    [sym_new_expression] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(2878),
    [sym_unary_expression] = STATE(2878),
    [sym_update_expression] = STATE(2878),
    [sym_regex] = STATE(2878),
    [sym_meta_property] = STATE(2878),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2878),
    [sym_yield_expression] = STATE(2878),
    [sym_as_expression] = STATE(2878),
    [sym_non_null_expression] = STATE(2878),
    [sym_internal_module] = STATE(2878),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2878),
    [sym_await_expression] = STATE(2878),
    [sym_member_expression] = STATE(1136),
    [sym_generic_type] = STATE(2207),
    [sym_string] = STATE(2878),
    [sym_this] = STATE(2878),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_nested_type_identifier] = STATE(602),
    [sym_anonymous_class] = STATE(2878),
    [sym_generator_function] = STATE(2878),
    [sym_call_expression] = STATE(2878),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2878),
    [sym_ternary_expression] = STATE(2878),
    [sym_binary_expression] = STATE(2878),
    [sym_template_string] = STATE(2878),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2878),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2878),
    [sym__type_reference] = STATE(2207),
    [sym_class] = STATE(2878),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(2343),
    [sym_false] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5916),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5918),
    [sym_true] = ACTIONS(5916),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5916),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2024] = {
    [sym_new_expression] = STATE(2879),
    [sym_augmented_assignment_expression] = STATE(2879),
    [sym_unary_expression] = STATE(2879),
    [sym_update_expression] = STATE(2879),
    [sym_regex] = STATE(2879),
    [sym_meta_property] = STATE(2879),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2879),
    [sym_yield_expression] = STATE(2879),
    [sym_as_expression] = STATE(2879),
    [sym_non_null_expression] = STATE(2879),
    [sym_internal_module] = STATE(2879),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2879),
    [sym_await_expression] = STATE(2879),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2879),
    [sym_this] = STATE(2879),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2879),
    [sym_generator_function] = STATE(2879),
    [sym_call_expression] = STATE(2879),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2879),
    [sym_ternary_expression] = STATE(2879),
    [sym_binary_expression] = STATE(2879),
    [sym_template_string] = STATE(2879),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2879),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2879),
    [sym_class] = STATE(2879),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5920),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5922),
    [sym_true] = ACTIONS(5920),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5920),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2025] = {
    [sym_new_expression] = STATE(2880),
    [sym_augmented_assignment_expression] = STATE(2880),
    [sym_unary_expression] = STATE(2880),
    [sym_update_expression] = STATE(2880),
    [sym_regex] = STATE(2880),
    [sym_meta_property] = STATE(2880),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2880),
    [sym_yield_expression] = STATE(2880),
    [sym_as_expression] = STATE(2880),
    [sym_non_null_expression] = STATE(2880),
    [sym_internal_module] = STATE(2880),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2880),
    [sym_await_expression] = STATE(2880),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2880),
    [sym_this] = STATE(2880),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2880),
    [sym_generator_function] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2880),
    [sym_ternary_expression] = STATE(2880),
    [sym_binary_expression] = STATE(2880),
    [sym_template_string] = STATE(2880),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2880),
    [sym_class] = STATE(2880),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5924),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5924),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5926),
    [sym_true] = ACTIONS(5924),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5924),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2026] = {
    [sym_new_expression] = STATE(2881),
    [sym_augmented_assignment_expression] = STATE(2881),
    [sym_unary_expression] = STATE(2881),
    [sym_update_expression] = STATE(2881),
    [sym_regex] = STATE(2881),
    [sym_meta_property] = STATE(2881),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2881),
    [sym_yield_expression] = STATE(2881),
    [sym_as_expression] = STATE(2881),
    [sym_non_null_expression] = STATE(2881),
    [sym_internal_module] = STATE(2881),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2881),
    [sym_await_expression] = STATE(2881),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2881),
    [sym_this] = STATE(2881),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2881),
    [sym_generator_function] = STATE(2881),
    [sym_call_expression] = STATE(2881),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2881),
    [sym_ternary_expression] = STATE(2881),
    [sym_binary_expression] = STATE(2881),
    [sym_template_string] = STATE(2881),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2881),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2881),
    [sym_class] = STATE(2881),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5928),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5928),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5930),
    [sym_true] = ACTIONS(5928),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5928),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2027] = {
    [sym_new_expression] = STATE(2882),
    [sym_augmented_assignment_expression] = STATE(2882),
    [sym_unary_expression] = STATE(2882),
    [sym_update_expression] = STATE(2882),
    [sym_regex] = STATE(2882),
    [sym_meta_property] = STATE(2882),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(2882),
    [sym_yield_expression] = STATE(2882),
    [sym_as_expression] = STATE(2882),
    [sym_non_null_expression] = STATE(2882),
    [sym_internal_module] = STATE(2882),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2882),
    [sym_await_expression] = STATE(2882),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(2882),
    [sym_this] = STATE(2882),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(2882),
    [sym_generator_function] = STATE(2882),
    [sym_call_expression] = STATE(2882),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(2882),
    [sym_ternary_expression] = STATE(2882),
    [sym_binary_expression] = STATE(2882),
    [sym_template_string] = STATE(2882),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2882),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2882),
    [sym_class] = STATE(2882),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(5932),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5932),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5934),
    [sym_true] = ACTIONS(5932),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5932),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [2028] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(5938),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [2029] = {
    [sym_new_expression] = STATE(2870),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(2870),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(2870),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(2870),
    [sym_call_signature] = STATE(1134),
    [sym_yield_expression] = STATE(2870),
    [sym_as_expression] = STATE(2870),
    [sym_internal_module] = STATE(2870),
    [sym_arrow_function] = STATE(2870),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(1136),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(1137),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(2870),
    [sym_subscript_expression] = STATE(1136),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(2870),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(2870),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(2870),
    [sym_meta_property] = STATE(2870),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(2870),
    [sym_non_null_expression] = STATE(2870),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(2870),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(2870),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(2870),
    [sym_call_expression] = STATE(2870),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(2870),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(2870),
    [sym_type_arguments] = STATE(1138),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(2870),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2870),
    [sym_class] = STATE(2870),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(5946),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(5948),
    [anon_sym_number] = ACTIONS(5948),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(5950),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5952),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(5881),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5948),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(5948),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(5948),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5881),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(5956),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(5952),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2030] = {
    [sym_new_expression] = STATE(2897),
    [sym_augmented_assignment_expression] = STATE(2897),
    [sym_unary_expression] = STATE(2897),
    [sym_update_expression] = STATE(2897),
    [sym_regex] = STATE(2897),
    [sym_meta_property] = STATE(2897),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2897),
    [sym_yield_expression] = STATE(2897),
    [sym_as_expression] = STATE(2897),
    [sym_non_null_expression] = STATE(2897),
    [sym_internal_module] = STATE(2897),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2897),
    [sym_await_expression] = STATE(2897),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2897),
    [sym_this] = STATE(2897),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2897),
    [sym_generator_function] = STATE(2897),
    [sym_call_expression] = STATE(2897),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2897),
    [sym_ternary_expression] = STATE(2897),
    [sym_binary_expression] = STATE(2897),
    [sym_template_string] = STATE(2897),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2897),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2897),
    [sym_class] = STATE(2897),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(5958),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5958),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5960),
    [sym_true] = ACTIONS(5958),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5958),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2031] = {
    [aux_sym_extends_clause_repeat1] = STATE(2898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4643),
    [anon_sym_COMMA] = ACTIONS(4261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5962),
  },
  [2032] = {
    [sym_identifier] = ACTIONS(5964),
    [anon_sym_BQUOTE] = ACTIONS(5966),
    [anon_sym_debugger] = ACTIONS(5964),
    [anon_sym_symbol] = ACTIONS(5964),
    [anon_sym_AT] = ACTIONS(5966),
    [anon_sym_DASH] = ACTIONS(5964),
    [anon_sym_void] = ACTIONS(5964),
    [anon_sym_break] = ACTIONS(5964),
    [anon_sym_const] = ACTIONS(5964),
    [sym_super] = ACTIONS(5964),
    [anon_sym_return] = ACTIONS(5964),
    [anon_sym_private] = ACTIONS(5964),
    [anon_sym_get] = ACTIONS(5964),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_interface] = ACTIONS(5964),
    [anon_sym_default] = ACTIONS(5964),
    [anon_sym_enum] = ACTIONS(5964),
    [anon_sym_delete] = ACTIONS(5964),
    [anon_sym_continue] = ACTIONS(5964),
    [anon_sym_DASH_DASH] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5964),
    [anon_sym_this] = ACTIONS(5964),
    [anon_sym_yield] = ACTIONS(5964),
    [sym_true] = ACTIONS(5964),
    [anon_sym_throw] = ACTIONS(5964),
    [anon_sym_protected] = ACTIONS(5964),
    [anon_sym_abstract] = ACTIONS(5964),
    [anon_sym_set] = ACTIONS(5964),
    [anon_sym_type] = ACTIONS(5964),
    [anon_sym_import] = ACTIONS(5964),
    [anon_sym_namespace] = ACTIONS(5964),
    [anon_sym_PLUS_PLUS] = ACTIONS(5966),
    [anon_sym_await] = ACTIONS(5964),
    [anon_sym_DQUOTE] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5964),
    [anon_sym_BANG] = ACTIONS(5966),
    [anon_sym_for] = ACTIONS(5964),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [sym_false] = ACTIONS(5964),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_case] = ACTIONS(5964),
    [anon_sym_module] = ACTIONS(5964),
    [anon_sym_number] = ACTIONS(5964),
    [anon_sym_class] = ACTIONS(5964),
    [anon_sym_declare] = ACTIONS(5964),
    [anon_sym_typeof] = ACTIONS(5964),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_switch] = ACTIONS(5964),
    [anon_sym_LPAREN] = ACTIONS(5966),
    [sym_null] = ACTIONS(5964),
    [anon_sym_any] = ACTIONS(5964),
    [anon_sym_boolean] = ACTIONS(5964),
    [anon_sym_async] = ACTIONS(5964),
    [anon_sym_public] = ACTIONS(5964),
    [anon_sym_var] = ACTIONS(5964),
    [anon_sym_while] = ACTIONS(5964),
    [anon_sym_SQUOTE] = ACTIONS(5966),
    [anon_sym_try] = ACTIONS(5964),
    [anon_sym_LT] = ACTIONS(5966),
    [sym_number] = ACTIONS(5966),
    [anon_sym_SLASH] = ACTIONS(5964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5964),
    [anon_sym_function] = ACTIONS(5964),
    [sym_undefined] = ACTIONS(5964),
    [anon_sym_new] = ACTIONS(5964),
    [ts_builtin_sym_end] = ACTIONS(5966),
    [anon_sym_let] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(5964),
    [anon_sym_export] = ACTIONS(5964),
    [anon_sym_do] = ACTIONS(5964),
    [anon_sym_TILDE] = ACTIONS(5966),
    [anon_sym_with] = ACTIONS(5964),
  },
  [2033] = {
    [anon_sym_COMMA] = ACTIONS(5968),
    [anon_sym_RBRACE] = ACTIONS(5968),
    [sym_comment] = ACTIONS(3),
  },
  [2034] = {
    [sym_computed_property_name] = STATE(1144),
    [sym__enum_member] = STATE(2900),
    [sym__property_name] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_enum_assignment] = STATE(2900),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2035] = {
    [sym_identifier] = ACTIONS(5972),
    [anon_sym_BQUOTE] = ACTIONS(5974),
    [anon_sym_debugger] = ACTIONS(5972),
    [anon_sym_symbol] = ACTIONS(5972),
    [anon_sym_AT] = ACTIONS(5974),
    [anon_sym_DASH] = ACTIONS(5972),
    [anon_sym_void] = ACTIONS(5972),
    [anon_sym_break] = ACTIONS(5972),
    [anon_sym_const] = ACTIONS(5972),
    [sym_super] = ACTIONS(5972),
    [anon_sym_return] = ACTIONS(5972),
    [anon_sym_private] = ACTIONS(5972),
    [anon_sym_get] = ACTIONS(5972),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_interface] = ACTIONS(5972),
    [anon_sym_default] = ACTIONS(5972),
    [anon_sym_enum] = ACTIONS(5972),
    [anon_sym_delete] = ACTIONS(5972),
    [anon_sym_continue] = ACTIONS(5972),
    [anon_sym_DASH_DASH] = ACTIONS(5974),
    [anon_sym_if] = ACTIONS(5972),
    [anon_sym_this] = ACTIONS(5972),
    [anon_sym_yield] = ACTIONS(5972),
    [sym_true] = ACTIONS(5972),
    [anon_sym_throw] = ACTIONS(5972),
    [anon_sym_protected] = ACTIONS(5972),
    [anon_sym_abstract] = ACTIONS(5972),
    [anon_sym_set] = ACTIONS(5972),
    [anon_sym_type] = ACTIONS(5972),
    [anon_sym_import] = ACTIONS(5972),
    [anon_sym_namespace] = ACTIONS(5972),
    [anon_sym_PLUS_PLUS] = ACTIONS(5974),
    [anon_sym_await] = ACTIONS(5972),
    [anon_sym_DQUOTE] = ACTIONS(5974),
    [anon_sym_else] = ACTIONS(5972),
    [anon_sym_BANG] = ACTIONS(5974),
    [anon_sym_for] = ACTIONS(5972),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [sym_false] = ACTIONS(5972),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_case] = ACTIONS(5972),
    [anon_sym_module] = ACTIONS(5972),
    [anon_sym_number] = ACTIONS(5972),
    [anon_sym_class] = ACTIONS(5972),
    [anon_sym_declare] = ACTIONS(5972),
    [anon_sym_typeof] = ACTIONS(5972),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_switch] = ACTIONS(5972),
    [anon_sym_LPAREN] = ACTIONS(5974),
    [sym_null] = ACTIONS(5972),
    [anon_sym_any] = ACTIONS(5972),
    [anon_sym_boolean] = ACTIONS(5972),
    [anon_sym_async] = ACTIONS(5972),
    [anon_sym_public] = ACTIONS(5972),
    [anon_sym_var] = ACTIONS(5972),
    [anon_sym_while] = ACTIONS(5972),
    [anon_sym_SQUOTE] = ACTIONS(5974),
    [anon_sym_try] = ACTIONS(5972),
    [anon_sym_LT] = ACTIONS(5974),
    [sym_number] = ACTIONS(5974),
    [anon_sym_SLASH] = ACTIONS(5972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5972),
    [anon_sym_function] = ACTIONS(5972),
    [sym_undefined] = ACTIONS(5972),
    [anon_sym_new] = ACTIONS(5972),
    [ts_builtin_sym_end] = ACTIONS(5974),
    [anon_sym_let] = ACTIONS(5972),
    [anon_sym_PLUS] = ACTIONS(5972),
    [anon_sym_export] = ACTIONS(5972),
    [anon_sym_do] = ACTIONS(5972),
    [anon_sym_TILDE] = ACTIONS(5974),
    [anon_sym_with] = ACTIONS(5972),
  },
  [2036] = {
    [aux_sym_enum_body_repeat1] = STATE(2902),
    [anon_sym_COMMA] = ACTIONS(5976),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [sym_comment] = ACTIONS(3),
  },
  [2037] = {
    [sym_identifier] = ACTIONS(5104),
    [anon_sym_BQUOTE] = ACTIONS(5102),
    [anon_sym_debugger] = ACTIONS(5104),
    [anon_sym_symbol] = ACTIONS(5104),
    [anon_sym_AT] = ACTIONS(5102),
    [anon_sym_DASH] = ACTIONS(5104),
    [anon_sym_void] = ACTIONS(5104),
    [anon_sym_break] = ACTIONS(5104),
    [anon_sym_const] = ACTIONS(5104),
    [sym_super] = ACTIONS(5104),
    [anon_sym_return] = ACTIONS(5104),
    [anon_sym_private] = ACTIONS(5104),
    [anon_sym_get] = ACTIONS(5104),
    [anon_sym_interface] = ACTIONS(5104),
    [anon_sym_enum] = ACTIONS(5104),
    [anon_sym_delete] = ACTIONS(5104),
    [anon_sym_continue] = ACTIONS(5104),
    [anon_sym_DASH_DASH] = ACTIONS(5102),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_this] = ACTIONS(5104),
    [anon_sym_yield] = ACTIONS(5104),
    [sym_true] = ACTIONS(5104),
    [anon_sym_throw] = ACTIONS(5104),
    [anon_sym_protected] = ACTIONS(5104),
    [anon_sym_abstract] = ACTIONS(5104),
    [anon_sym_set] = ACTIONS(5104),
    [anon_sym_type] = ACTIONS(5104),
    [anon_sym_import] = ACTIONS(5104),
    [anon_sym_namespace] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5102),
    [anon_sym_await] = ACTIONS(5104),
    [anon_sym_DQUOTE] = ACTIONS(5102),
    [anon_sym_BANG] = ACTIONS(5102),
    [anon_sym_for] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5102),
    [sym_false] = ACTIONS(5104),
    [anon_sym_SEMI] = ACTIONS(5102),
    [anon_sym_module] = ACTIONS(5104),
    [anon_sym_number] = ACTIONS(5104),
    [anon_sym_class] = ACTIONS(5104),
    [anon_sym_declare] = ACTIONS(5104),
    [anon_sym_typeof] = ACTIONS(5104),
    [anon_sym_LBRACE] = ACTIONS(5102),
    [anon_sym_switch] = ACTIONS(5104),
    [anon_sym_LPAREN] = ACTIONS(5102),
    [sym_null] = ACTIONS(5104),
    [anon_sym_any] = ACTIONS(5104),
    [anon_sym_boolean] = ACTIONS(5104),
    [anon_sym_async] = ACTIONS(5104),
    [anon_sym_public] = ACTIONS(5104),
    [anon_sym_var] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_SQUOTE] = ACTIONS(5102),
    [anon_sym_try] = ACTIONS(5104),
    [anon_sym_LT] = ACTIONS(5102),
    [sym_number] = ACTIONS(5102),
    [anon_sym_SLASH] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5104),
    [anon_sym_function] = ACTIONS(5104),
    [sym_undefined] = ACTIONS(5104),
    [anon_sym_new] = ACTIONS(5104),
    [anon_sym_let] = ACTIONS(5104),
    [anon_sym_PLUS] = ACTIONS(5104),
    [anon_sym_export] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_TILDE] = ACTIONS(5102),
    [anon_sym_with] = ACTIONS(5104),
  },
  [2038] = {
    [sym_identifier] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2401),
    [anon_sym_debugger] = ACTIONS(2399),
    [anon_sym_symbol] = ACTIONS(2399),
    [anon_sym_AT] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2399),
    [anon_sym_void] = ACTIONS(2399),
    [anon_sym_break] = ACTIONS(2399),
    [anon_sym_const] = ACTIONS(2399),
    [sym_super] = ACTIONS(2399),
    [anon_sym_return] = ACTIONS(2399),
    [anon_sym_private] = ACTIONS(2399),
    [anon_sym_get] = ACTIONS(2399),
    [anon_sym_interface] = ACTIONS(2399),
    [anon_sym_enum] = ACTIONS(2399),
    [anon_sym_delete] = ACTIONS(2399),
    [anon_sym_continue] = ACTIONS(2399),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2399),
    [anon_sym_this] = ACTIONS(2399),
    [anon_sym_yield] = ACTIONS(2399),
    [sym_true] = ACTIONS(2399),
    [anon_sym_throw] = ACTIONS(2399),
    [anon_sym_protected] = ACTIONS(2399),
    [anon_sym_abstract] = ACTIONS(2399),
    [anon_sym_set] = ACTIONS(2399),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_import] = ACTIONS(2399),
    [anon_sym_namespace] = ACTIONS(2399),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_await] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_else] = ACTIONS(5978),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [sym_false] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2401),
    [anon_sym_module] = ACTIONS(2399),
    [anon_sym_number] = ACTIONS(2399),
    [anon_sym_class] = ACTIONS(2399),
    [anon_sym_declare] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_switch] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [sym_null] = ACTIONS(2399),
    [anon_sym_any] = ACTIONS(2399),
    [anon_sym_boolean] = ACTIONS(2399),
    [anon_sym_async] = ACTIONS(2399),
    [anon_sym_public] = ACTIONS(2399),
    [anon_sym_var] = ACTIONS(2399),
    [anon_sym_while] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_try] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2401),
    [sym_number] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2399),
    [anon_sym_function] = ACTIONS(2399),
    [sym_undefined] = ACTIONS(2399),
    [anon_sym_new] = ACTIONS(2399),
    [ts_builtin_sym_end] = ACTIONS(2401),
    [anon_sym_let] = ACTIONS(2399),
    [anon_sym_PLUS] = ACTIONS(2399),
    [anon_sym_export] = ACTIONS(2399),
    [anon_sym_do] = ACTIONS(2399),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_with] = ACTIONS(2399),
  },
  [2039] = {
    [sym_array] = STATE(2906),
    [sym_object] = STATE(2907),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(5980),
    [anon_sym_var] = ACTIONS(5982),
    [anon_sym_const] = ACTIONS(5982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(5982),
  },
  [2040] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5984),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5986),
  },
  [2041] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(2911),
    [sym_object] = STATE(2912),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [2042] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(2911),
    [sym_object] = STATE(2912),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [2043] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2913),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(2913),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [2044] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5990),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5992),
  },
  [2045] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5994),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5996),
  },
  [2046] = {
    [sym_identifier] = ACTIONS(5998),
    [sym_comment] = ACTIONS(3),
  },
  [2047] = {
    [sym_identifier] = ACTIONS(6000),
    [anon_sym_BQUOTE] = ACTIONS(6002),
    [anon_sym_debugger] = ACTIONS(6000),
    [anon_sym_symbol] = ACTIONS(6000),
    [anon_sym_AT] = ACTIONS(6002),
    [anon_sym_DASH] = ACTIONS(6000),
    [anon_sym_void] = ACTIONS(6000),
    [anon_sym_break] = ACTIONS(6000),
    [anon_sym_const] = ACTIONS(6000),
    [sym_super] = ACTIONS(6000),
    [anon_sym_return] = ACTIONS(6000),
    [anon_sym_private] = ACTIONS(6000),
    [anon_sym_get] = ACTIONS(6000),
    [anon_sym_RBRACE] = ACTIONS(6002),
    [anon_sym_interface] = ACTIONS(6000),
    [anon_sym_default] = ACTIONS(6000),
    [anon_sym_enum] = ACTIONS(6000),
    [anon_sym_delete] = ACTIONS(6000),
    [anon_sym_continue] = ACTIONS(6000),
    [anon_sym_DASH_DASH] = ACTIONS(6002),
    [anon_sym_if] = ACTIONS(6000),
    [anon_sym_this] = ACTIONS(6000),
    [anon_sym_yield] = ACTIONS(6000),
    [sym_true] = ACTIONS(6000),
    [anon_sym_throw] = ACTIONS(6000),
    [anon_sym_protected] = ACTIONS(6000),
    [anon_sym_abstract] = ACTIONS(6000),
    [anon_sym_set] = ACTIONS(6000),
    [anon_sym_type] = ACTIONS(6000),
    [anon_sym_import] = ACTIONS(6000),
    [anon_sym_namespace] = ACTIONS(6000),
    [anon_sym_PLUS_PLUS] = ACTIONS(6002),
    [anon_sym_await] = ACTIONS(6000),
    [anon_sym_DQUOTE] = ACTIONS(6002),
    [anon_sym_else] = ACTIONS(6000),
    [anon_sym_BANG] = ACTIONS(6002),
    [anon_sym_for] = ACTIONS(6000),
    [anon_sym_LBRACK] = ACTIONS(6002),
    [sym_false] = ACTIONS(6000),
    [anon_sym_SEMI] = ACTIONS(6002),
    [anon_sym_case] = ACTIONS(6000),
    [anon_sym_module] = ACTIONS(6000),
    [anon_sym_number] = ACTIONS(6000),
    [anon_sym_class] = ACTIONS(6000),
    [anon_sym_declare] = ACTIONS(6000),
    [anon_sym_typeof] = ACTIONS(6000),
    [anon_sym_LBRACE] = ACTIONS(6002),
    [anon_sym_switch] = ACTIONS(6000),
    [anon_sym_LPAREN] = ACTIONS(6002),
    [sym_null] = ACTIONS(6000),
    [anon_sym_any] = ACTIONS(6000),
    [anon_sym_boolean] = ACTIONS(6000),
    [anon_sym_async] = ACTIONS(6000),
    [anon_sym_public] = ACTIONS(6000),
    [anon_sym_var] = ACTIONS(6000),
    [anon_sym_while] = ACTIONS(6000),
    [anon_sym_SQUOTE] = ACTIONS(6002),
    [anon_sym_try] = ACTIONS(6000),
    [anon_sym_LT] = ACTIONS(6002),
    [sym_number] = ACTIONS(6002),
    [anon_sym_SLASH] = ACTIONS(6000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6000),
    [anon_sym_function] = ACTIONS(6000),
    [sym_undefined] = ACTIONS(6000),
    [anon_sym_new] = ACTIONS(6000),
    [ts_builtin_sym_end] = ACTIONS(6002),
    [anon_sym_let] = ACTIONS(6000),
    [anon_sym_PLUS] = ACTIONS(6000),
    [anon_sym_export] = ACTIONS(6000),
    [anon_sym_do] = ACTIONS(6000),
    [anon_sym_TILDE] = ACTIONS(6002),
    [anon_sym_with] = ACTIONS(6000),
  },
  [2048] = {
    [sym_identifier] = ACTIONS(2805),
    [anon_sym_BQUOTE] = ACTIONS(2803),
    [anon_sym_debugger] = ACTIONS(2805),
    [anon_sym_symbol] = ACTIONS(2805),
    [anon_sym_AT] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_void] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [sym_super] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_private] = ACTIONS(2805),
    [anon_sym_get] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_interface] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2803),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_this] = ACTIONS(2805),
    [anon_sym_yield] = ACTIONS(2805),
    [sym_true] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_protected] = ACTIONS(2805),
    [anon_sym_abstract] = ACTIONS(2805),
    [anon_sym_set] = ACTIONS(2805),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_import] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_PLUS_PLUS] = ACTIONS(2803),
    [anon_sym_await] = ACTIONS(2805),
    [anon_sym_DQUOTE] = ACTIONS(2803),
    [anon_sym_else] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [sym_false] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_module] = ACTIONS(2805),
    [anon_sym_number] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_declare] = ACTIONS(2805),
    [anon_sym_typeof] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [sym_null] = ACTIONS(2805),
    [anon_sym_any] = ACTIONS(2805),
    [anon_sym_boolean] = ACTIONS(2805),
    [anon_sym_async] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2805),
    [anon_sym_var] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_SQUOTE] = ACTIONS(2803),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_LT] = ACTIONS(2803),
    [sym_number] = ACTIONS(2803),
    [anon_sym_SLASH] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2805),
    [anon_sym_function] = ACTIONS(2805),
    [sym_undefined] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [ts_builtin_sym_end] = ACTIONS(2803),
    [anon_sym_let] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_export] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_with] = ACTIONS(2805),
  },
  [2049] = {
    [sym_public_field_definition] = STATE(630),
    [sym__property_name] = STATE(631),
    [sym_decorator] = STATE(1375),
    [sym_method_signature] = STATE(630),
    [sym_accessibility_modifier] = STATE(632),
    [sym_abstract_method_signature] = STATE(630),
    [sym_computed_property_name] = STATE(631),
    [aux_sym_class_body_repeat1] = STATE(1375),
    [sym_index_signature] = STATE(630),
    [sym_string] = STATE(631),
    [sym_method_definition] = STATE(634),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1129),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(6004),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_abstract] = ACTIONS(1139),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [2050] = {
    [sym_identifier] = ACTIONS(6006),
    [anon_sym_BQUOTE] = ACTIONS(6008),
    [anon_sym_debugger] = ACTIONS(6006),
    [anon_sym_symbol] = ACTIONS(6006),
    [anon_sym_AT] = ACTIONS(6008),
    [anon_sym_DASH] = ACTIONS(6006),
    [anon_sym_void] = ACTIONS(6006),
    [anon_sym_break] = ACTIONS(6006),
    [anon_sym_const] = ACTIONS(6006),
    [sym_super] = ACTIONS(6006),
    [anon_sym_return] = ACTIONS(6006),
    [anon_sym_private] = ACTIONS(6006),
    [anon_sym_get] = ACTIONS(6006),
    [anon_sym_RBRACE] = ACTIONS(6008),
    [anon_sym_interface] = ACTIONS(6006),
    [anon_sym_default] = ACTIONS(6006),
    [anon_sym_enum] = ACTIONS(6006),
    [anon_sym_delete] = ACTIONS(6006),
    [anon_sym_continue] = ACTIONS(6006),
    [anon_sym_DASH_DASH] = ACTIONS(6008),
    [anon_sym_if] = ACTIONS(6006),
    [anon_sym_this] = ACTIONS(6006),
    [anon_sym_yield] = ACTIONS(6006),
    [sym_true] = ACTIONS(6006),
    [anon_sym_throw] = ACTIONS(6006),
    [anon_sym_protected] = ACTIONS(6006),
    [anon_sym_abstract] = ACTIONS(6006),
    [anon_sym_set] = ACTIONS(6006),
    [anon_sym_type] = ACTIONS(6006),
    [anon_sym_import] = ACTIONS(6006),
    [anon_sym_namespace] = ACTIONS(6006),
    [anon_sym_PLUS_PLUS] = ACTIONS(6008),
    [anon_sym_await] = ACTIONS(6006),
    [anon_sym_DQUOTE] = ACTIONS(6008),
    [anon_sym_else] = ACTIONS(6006),
    [anon_sym_BANG] = ACTIONS(6008),
    [anon_sym_for] = ACTIONS(6006),
    [anon_sym_LBRACK] = ACTIONS(6008),
    [sym_false] = ACTIONS(6006),
    [anon_sym_SEMI] = ACTIONS(6008),
    [anon_sym_case] = ACTIONS(6006),
    [anon_sym_module] = ACTIONS(6006),
    [anon_sym_number] = ACTIONS(6006),
    [anon_sym_class] = ACTIONS(6006),
    [anon_sym_declare] = ACTIONS(6006),
    [anon_sym_typeof] = ACTIONS(6006),
    [anon_sym_LBRACE] = ACTIONS(6008),
    [anon_sym_switch] = ACTIONS(6006),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [sym_null] = ACTIONS(6006),
    [anon_sym_any] = ACTIONS(6006),
    [anon_sym_boolean] = ACTIONS(6006),
    [anon_sym_async] = ACTIONS(6006),
    [anon_sym_public] = ACTIONS(6006),
    [anon_sym_var] = ACTIONS(6006),
    [anon_sym_while] = ACTIONS(6006),
    [anon_sym_SQUOTE] = ACTIONS(6008),
    [anon_sym_try] = ACTIONS(6006),
    [anon_sym_LT] = ACTIONS(6008),
    [sym_number] = ACTIONS(6008),
    [anon_sym_SLASH] = ACTIONS(6006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6006),
    [anon_sym_function] = ACTIONS(6006),
    [sym_undefined] = ACTIONS(6006),
    [anon_sym_new] = ACTIONS(6006),
    [ts_builtin_sym_end] = ACTIONS(6008),
    [anon_sym_let] = ACTIONS(6006),
    [anon_sym_PLUS] = ACTIONS(6006),
    [anon_sym_export] = ACTIONS(6006),
    [anon_sym_do] = ACTIONS(6006),
    [anon_sym_TILDE] = ACTIONS(6008),
    [anon_sym_with] = ACTIONS(6006),
  },
  [2051] = {
    [sym_class_body] = STATE(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [2052] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2924),
    [sym_constructor_type] = STATE(2924),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(2924),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2924),
    [sym_intersection_type] = STATE(2924),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2053] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2927),
    [sym_constructor_type] = STATE(2927),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(2927),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2927),
    [sym_intersection_type] = STATE(2927),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2054] = {
    [anon_sym_EQ_GT] = ACTIONS(6016),
    [sym_comment] = ACTIONS(3),
  },
  [2055] = {
    [sym_formal_parameters] = STATE(2929),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2056] = {
    [sym_identifier] = ACTIONS(6018),
    [anon_sym_BQUOTE] = ACTIONS(6020),
    [anon_sym_debugger] = ACTIONS(6018),
    [anon_sym_symbol] = ACTIONS(6018),
    [anon_sym_AT] = ACTIONS(6020),
    [anon_sym_DASH] = ACTIONS(6018),
    [anon_sym_void] = ACTIONS(6018),
    [anon_sym_break] = ACTIONS(6018),
    [anon_sym_const] = ACTIONS(6018),
    [sym_super] = ACTIONS(6018),
    [anon_sym_return] = ACTIONS(6018),
    [anon_sym_private] = ACTIONS(6018),
    [anon_sym_get] = ACTIONS(6018),
    [anon_sym_RBRACE] = ACTIONS(6020),
    [anon_sym_interface] = ACTIONS(6018),
    [anon_sym_default] = ACTIONS(6018),
    [anon_sym_enum] = ACTIONS(6018),
    [anon_sym_delete] = ACTIONS(6018),
    [anon_sym_continue] = ACTIONS(6018),
    [anon_sym_DASH_DASH] = ACTIONS(6020),
    [anon_sym_if] = ACTIONS(6018),
    [anon_sym_this] = ACTIONS(6018),
    [anon_sym_yield] = ACTIONS(6018),
    [sym_true] = ACTIONS(6018),
    [anon_sym_throw] = ACTIONS(6018),
    [anon_sym_protected] = ACTIONS(6018),
    [anon_sym_abstract] = ACTIONS(6018),
    [anon_sym_set] = ACTIONS(6018),
    [anon_sym_type] = ACTIONS(6018),
    [anon_sym_import] = ACTIONS(6018),
    [anon_sym_namespace] = ACTIONS(6018),
    [anon_sym_PLUS_PLUS] = ACTIONS(6020),
    [anon_sym_await] = ACTIONS(6018),
    [anon_sym_DQUOTE] = ACTIONS(6020),
    [anon_sym_else] = ACTIONS(6018),
    [anon_sym_BANG] = ACTIONS(6020),
    [anon_sym_for] = ACTIONS(6018),
    [anon_sym_LBRACK] = ACTIONS(6020),
    [sym_false] = ACTIONS(6018),
    [anon_sym_SEMI] = ACTIONS(6020),
    [anon_sym_case] = ACTIONS(6018),
    [anon_sym_module] = ACTIONS(6018),
    [anon_sym_number] = ACTIONS(6018),
    [anon_sym_class] = ACTIONS(6018),
    [anon_sym_declare] = ACTIONS(6018),
    [anon_sym_typeof] = ACTIONS(6018),
    [anon_sym_LBRACE] = ACTIONS(6020),
    [anon_sym_switch] = ACTIONS(6018),
    [anon_sym_LPAREN] = ACTIONS(6020),
    [sym_null] = ACTIONS(6018),
    [anon_sym_any] = ACTIONS(6018),
    [anon_sym_boolean] = ACTIONS(6018),
    [anon_sym_async] = ACTIONS(6018),
    [anon_sym_public] = ACTIONS(6018),
    [anon_sym_var] = ACTIONS(6018),
    [anon_sym_while] = ACTIONS(6018),
    [anon_sym_SQUOTE] = ACTIONS(6020),
    [anon_sym_try] = ACTIONS(6018),
    [anon_sym_LT] = ACTIONS(6020),
    [sym_number] = ACTIONS(6020),
    [anon_sym_SLASH] = ACTIONS(6018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6018),
    [anon_sym_function] = ACTIONS(6018),
    [sym_undefined] = ACTIONS(6018),
    [anon_sym_new] = ACTIONS(6018),
    [ts_builtin_sym_end] = ACTIONS(6020),
    [anon_sym_let] = ACTIONS(6018),
    [anon_sym_PLUS] = ACTIONS(6018),
    [anon_sym_export] = ACTIONS(6018),
    [anon_sym_do] = ACTIONS(6018),
    [anon_sym_TILDE] = ACTIONS(6020),
    [anon_sym_with] = ACTIONS(6018),
  },
  [2057] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2058] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2059] = {
    [anon_sym_EQ_GT] = ACTIONS(6022),
    [sym_comment] = ACTIONS(3),
  },
  [2060] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2931),
    [sym_constructor_type] = STATE(2931),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(2931),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2931),
    [sym_intersection_type] = STATE(2931),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2061] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2932),
    [sym_constructor_type] = STATE(2932),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(2932),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2932),
    [sym_intersection_type] = STATE(2932),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2062] = {
    [sym__automatic_semicolon] = ACTIONS(6024),
    [anon_sym_AMP] = ACTIONS(4321),
    [anon_sym_PIPE] = ACTIONS(4323),
    [anon_sym_SEMI] = ACTIONS(6024),
    [sym_comment] = ACTIONS(3),
  },
  [2063] = {
    [sym_string] = STATE(2934),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(282),
  },
  [2064] = {
    [sym_identifier] = ACTIONS(6026),
    [anon_sym_BQUOTE] = ACTIONS(6028),
    [anon_sym_debugger] = ACTIONS(6026),
    [anon_sym_symbol] = ACTIONS(6026),
    [anon_sym_AT] = ACTIONS(6028),
    [anon_sym_DASH] = ACTIONS(6026),
    [anon_sym_void] = ACTIONS(6026),
    [anon_sym_break] = ACTIONS(6026),
    [anon_sym_const] = ACTIONS(6026),
    [sym_super] = ACTIONS(6026),
    [anon_sym_return] = ACTIONS(6026),
    [anon_sym_private] = ACTIONS(6026),
    [anon_sym_get] = ACTIONS(6026),
    [anon_sym_RBRACE] = ACTIONS(6028),
    [anon_sym_interface] = ACTIONS(6026),
    [anon_sym_default] = ACTIONS(6026),
    [anon_sym_enum] = ACTIONS(6026),
    [anon_sym_delete] = ACTIONS(6026),
    [anon_sym_continue] = ACTIONS(6026),
    [anon_sym_DASH_DASH] = ACTIONS(6028),
    [anon_sym_if] = ACTIONS(6026),
    [anon_sym_this] = ACTIONS(6026),
    [anon_sym_yield] = ACTIONS(6026),
    [sym_true] = ACTIONS(6026),
    [anon_sym_throw] = ACTIONS(6026),
    [anon_sym_protected] = ACTIONS(6026),
    [anon_sym_abstract] = ACTIONS(6026),
    [anon_sym_set] = ACTIONS(6026),
    [anon_sym_type] = ACTIONS(6026),
    [anon_sym_import] = ACTIONS(6026),
    [anon_sym_namespace] = ACTIONS(6026),
    [anon_sym_PLUS_PLUS] = ACTIONS(6028),
    [anon_sym_await] = ACTIONS(6026),
    [anon_sym_DQUOTE] = ACTIONS(6028),
    [anon_sym_else] = ACTIONS(6026),
    [anon_sym_BANG] = ACTIONS(6028),
    [anon_sym_for] = ACTIONS(6026),
    [anon_sym_LBRACK] = ACTIONS(6028),
    [sym_false] = ACTIONS(6026),
    [anon_sym_SEMI] = ACTIONS(6028),
    [anon_sym_case] = ACTIONS(6026),
    [anon_sym_module] = ACTIONS(6026),
    [anon_sym_number] = ACTIONS(6026),
    [anon_sym_class] = ACTIONS(6026),
    [anon_sym_declare] = ACTIONS(6026),
    [anon_sym_typeof] = ACTIONS(6026),
    [anon_sym_LBRACE] = ACTIONS(6028),
    [anon_sym_switch] = ACTIONS(6026),
    [anon_sym_LPAREN] = ACTIONS(6028),
    [sym_null] = ACTIONS(6026),
    [anon_sym_any] = ACTIONS(6026),
    [anon_sym_boolean] = ACTIONS(6026),
    [anon_sym_async] = ACTIONS(6026),
    [anon_sym_public] = ACTIONS(6026),
    [anon_sym_var] = ACTIONS(6026),
    [anon_sym_while] = ACTIONS(6026),
    [anon_sym_SQUOTE] = ACTIONS(6028),
    [anon_sym_try] = ACTIONS(6026),
    [anon_sym_LT] = ACTIONS(6028),
    [sym_number] = ACTIONS(6028),
    [anon_sym_SLASH] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6026),
    [anon_sym_function] = ACTIONS(6026),
    [sym_undefined] = ACTIONS(6026),
    [anon_sym_new] = ACTIONS(6026),
    [ts_builtin_sym_end] = ACTIONS(6028),
    [anon_sym_let] = ACTIONS(6026),
    [anon_sym_PLUS] = ACTIONS(6026),
    [anon_sym_export] = ACTIONS(6026),
    [anon_sym_do] = ACTIONS(6026),
    [anon_sym_TILDE] = ACTIONS(6028),
    [anon_sym_with] = ACTIONS(6026),
  },
  [2065] = {
    [sym_identifier] = ACTIONS(6030),
    [anon_sym_BQUOTE] = ACTIONS(6032),
    [anon_sym_debugger] = ACTIONS(6030),
    [anon_sym_symbol] = ACTIONS(6030),
    [anon_sym_AT] = ACTIONS(6032),
    [anon_sym_DASH] = ACTIONS(6030),
    [anon_sym_void] = ACTIONS(6030),
    [anon_sym_break] = ACTIONS(6030),
    [anon_sym_const] = ACTIONS(6030),
    [sym_super] = ACTIONS(6030),
    [anon_sym_return] = ACTIONS(6030),
    [anon_sym_private] = ACTIONS(6030),
    [anon_sym_get] = ACTIONS(6030),
    [anon_sym_RBRACE] = ACTIONS(6032),
    [anon_sym_interface] = ACTIONS(6030),
    [anon_sym_default] = ACTIONS(6030),
    [anon_sym_enum] = ACTIONS(6030),
    [anon_sym_delete] = ACTIONS(6030),
    [anon_sym_continue] = ACTIONS(6030),
    [anon_sym_DASH_DASH] = ACTIONS(6032),
    [anon_sym_if] = ACTIONS(6030),
    [anon_sym_this] = ACTIONS(6030),
    [anon_sym_yield] = ACTIONS(6030),
    [sym_true] = ACTIONS(6030),
    [anon_sym_throw] = ACTIONS(6030),
    [anon_sym_protected] = ACTIONS(6030),
    [anon_sym_abstract] = ACTIONS(6030),
    [anon_sym_set] = ACTIONS(6030),
    [anon_sym_type] = ACTIONS(6030),
    [anon_sym_import] = ACTIONS(6030),
    [anon_sym_namespace] = ACTIONS(6030),
    [anon_sym_PLUS_PLUS] = ACTIONS(6032),
    [anon_sym_await] = ACTIONS(6030),
    [anon_sym_DQUOTE] = ACTIONS(6032),
    [anon_sym_else] = ACTIONS(6030),
    [anon_sym_BANG] = ACTIONS(6032),
    [anon_sym_for] = ACTIONS(6030),
    [anon_sym_LBRACK] = ACTIONS(6032),
    [sym_false] = ACTIONS(6030),
    [anon_sym_SEMI] = ACTIONS(6032),
    [anon_sym_case] = ACTIONS(6030),
    [anon_sym_module] = ACTIONS(6030),
    [anon_sym_number] = ACTIONS(6030),
    [anon_sym_class] = ACTIONS(6030),
    [anon_sym_declare] = ACTIONS(6030),
    [anon_sym_typeof] = ACTIONS(6030),
    [anon_sym_LBRACE] = ACTIONS(6032),
    [anon_sym_switch] = ACTIONS(6030),
    [anon_sym_LPAREN] = ACTIONS(6032),
    [sym_null] = ACTIONS(6030),
    [anon_sym_any] = ACTIONS(6030),
    [anon_sym_boolean] = ACTIONS(6030),
    [anon_sym_async] = ACTIONS(6030),
    [anon_sym_public] = ACTIONS(6030),
    [anon_sym_var] = ACTIONS(6030),
    [anon_sym_while] = ACTIONS(6030),
    [anon_sym_SQUOTE] = ACTIONS(6032),
    [anon_sym_try] = ACTIONS(6030),
    [anon_sym_LT] = ACTIONS(6032),
    [sym_number] = ACTIONS(6032),
    [anon_sym_SLASH] = ACTIONS(6030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6030),
    [anon_sym_function] = ACTIONS(6030),
    [sym_undefined] = ACTIONS(6030),
    [anon_sym_new] = ACTIONS(6030),
    [ts_builtin_sym_end] = ACTIONS(6032),
    [anon_sym_let] = ACTIONS(6030),
    [anon_sym_PLUS] = ACTIONS(6030),
    [anon_sym_export] = ACTIONS(6030),
    [anon_sym_do] = ACTIONS(6030),
    [anon_sym_TILDE] = ACTIONS(6032),
    [anon_sym_with] = ACTIONS(6030),
  },
  [2066] = {
    [anon_sym_COMMA] = ACTIONS(6034),
    [anon_sym_RBRACE] = ACTIONS(6034),
    [sym_comment] = ACTIONS(3),
  },
  [2067] = {
    [sym_identifier] = ACTIONS(6036),
    [sym_comment] = ACTIONS(3),
  },
  [2068] = {
    [anon_sym_from] = ACTIONS(6038),
    [sym_comment] = ACTIONS(3),
  },
  [2069] = {
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [2070] = {
    [sym__import_export_specifier] = STATE(2069),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_RBRACE] = ACTIONS(6042),
    [anon_sym_typeof] = ACTIONS(887),
    [anon_sym_type] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
  },
  [2071] = {
    [aux_sym_named_imports_repeat1] = STATE(2071),
    [anon_sym_COMMA] = ACTIONS(6044),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [sym_comment] = ACTIONS(3),
  },
  [2072] = {
    [anon_sym_of] = ACTIONS(6049),
    [sym_comment] = ACTIONS(3),
  },
  [2073] = {
    [anon_sym_of] = ACTIONS(6051),
    [sym_comment] = ACTIONS(3),
  },
  [2074] = {
    [anon_sym_of] = ACTIONS(6053),
    [sym_comment] = ACTIONS(3),
  },
  [2075] = {
    [sym_new_expression] = STATE(2941),
    [sym_augmented_assignment_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2941),
    [sym_update_expression] = STATE(2941),
    [sym_regex] = STATE(2941),
    [sym_meta_property] = STATE(2941),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2941),
    [sym_yield_expression] = STATE(2941),
    [sym_as_expression] = STATE(2941),
    [sym_non_null_expression] = STATE(2941),
    [sym_internal_module] = STATE(2941),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2941),
    [sym_await_expression] = STATE(2941),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2941),
    [sym_this] = STATE(2941),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2941),
    [sym_generator_function] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2941),
    [sym_ternary_expression] = STATE(2941),
    [sym_binary_expression] = STATE(2941),
    [sym_template_string] = STATE(2941),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2941),
    [sym_class] = STATE(2941),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6055),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6055),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6057),
    [sym_true] = ACTIONS(6055),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6055),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2076] = {
    [sym_new_expression] = STATE(2942),
    [sym_augmented_assignment_expression] = STATE(2942),
    [sym_unary_expression] = STATE(2942),
    [sym_update_expression] = STATE(2942),
    [sym_regex] = STATE(2942),
    [sym_meta_property] = STATE(2942),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2942),
    [sym_yield_expression] = STATE(2942),
    [sym_as_expression] = STATE(2942),
    [sym_non_null_expression] = STATE(2942),
    [sym_internal_module] = STATE(2942),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2942),
    [sym_await_expression] = STATE(2942),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2942),
    [sym_this] = STATE(2942),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2942),
    [sym_generator_function] = STATE(2942),
    [sym_call_expression] = STATE(2942),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2942),
    [sym_ternary_expression] = STATE(2942),
    [sym_binary_expression] = STATE(2942),
    [sym_template_string] = STATE(2942),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2942),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2942),
    [sym_class] = STATE(2942),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6061),
    [sym_true] = ACTIONS(6059),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6059),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2077] = {
    [sym_new_expression] = STATE(2943),
    [sym_augmented_assignment_expression] = STATE(2943),
    [sym_unary_expression] = STATE(2943),
    [sym_update_expression] = STATE(2943),
    [sym_regex] = STATE(2943),
    [sym_meta_property] = STATE(2943),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2943),
    [sym_yield_expression] = STATE(2943),
    [sym_as_expression] = STATE(2943),
    [sym_non_null_expression] = STATE(2943),
    [sym_internal_module] = STATE(2943),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2943),
    [sym_await_expression] = STATE(2943),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2943),
    [sym_this] = STATE(2943),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2943),
    [sym_generator_function] = STATE(2943),
    [sym_call_expression] = STATE(2943),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2943),
    [sym_ternary_expression] = STATE(2943),
    [sym_binary_expression] = STATE(2943),
    [sym_template_string] = STATE(2943),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2943),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2943),
    [sym_class] = STATE(2943),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6063),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6063),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6065),
    [sym_true] = ACTIONS(6063),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6063),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2078] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6067),
    [anon_sym_AMP_EQ] = ACTIONS(6067),
    [anon_sym_PLUS_EQ] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6067),
    [anon_sym_STAR_EQ] = ACTIONS(6067),
    [anon_sym_PIPE_EQ] = ACTIONS(6067),
    [anon_sym_DASH_EQ] = ACTIONS(6067),
    [anon_sym_EQ_GT] = ACTIONS(6071),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6067),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT_EQ] = ACTIONS(6067),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6073),
  },
  [2079] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6075),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_AMP_EQ] = ACTIONS(6075),
    [anon_sym_PLUS_EQ] = ACTIONS(6075),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6075),
    [anon_sym_STAR_EQ] = ACTIONS(6075),
    [anon_sym_PIPE_EQ] = ACTIONS(6075),
    [anon_sym_DASH_EQ] = ACTIONS(6075),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6075),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6075),
    [anon_sym_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2080] = {
    [sym_new_expression] = STATE(2950),
    [sym_augmented_assignment_expression] = STATE(2950),
    [sym_unary_expression] = STATE(2950),
    [sym_update_expression] = STATE(2950),
    [sym_regex] = STATE(2950),
    [sym_meta_property] = STATE(2950),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2950),
    [sym_yield_expression] = STATE(2950),
    [sym_as_expression] = STATE(2950),
    [sym_non_null_expression] = STATE(2950),
    [sym_internal_module] = STATE(2950),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2950),
    [sym_await_expression] = STATE(2950),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(2950),
    [sym_this] = STATE(2950),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2950),
    [sym_generator_function] = STATE(2950),
    [sym_call_expression] = STATE(2950),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2950),
    [sym_ternary_expression] = STATE(2950),
    [sym_binary_expression] = STATE(2950),
    [sym_template_string] = STATE(2950),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2950),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2950),
    [sym_class] = STATE(2950),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(6079),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6079),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6081),
    [sym_true] = ACTIONS(6079),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6079),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2081] = {
    [sym_new_expression] = STATE(2951),
    [sym_augmented_assignment_expression] = STATE(2951),
    [sym_unary_expression] = STATE(2951),
    [sym_update_expression] = STATE(2951),
    [sym_regex] = STATE(2951),
    [sym_meta_property] = STATE(2951),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2951),
    [sym_yield_expression] = STATE(2951),
    [sym_as_expression] = STATE(2951),
    [sym_non_null_expression] = STATE(2951),
    [sym_internal_module] = STATE(2951),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2951),
    [sym_await_expression] = STATE(2951),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(2951),
    [sym_this] = STATE(2951),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2951),
    [sym_generator_function] = STATE(2951),
    [sym_call_expression] = STATE(2951),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2951),
    [sym_ternary_expression] = STATE(2951),
    [sym_binary_expression] = STATE(2951),
    [sym_template_string] = STATE(2951),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2951),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2951),
    [sym_class] = STATE(2951),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(6083),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6083),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6085),
    [sym_true] = ACTIONS(6083),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6083),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2082] = {
    [sym_new_expression] = STATE(2950),
    [sym_augmented_assignment_expression] = STATE(2950),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(2950),
    [sym_update_expression] = STATE(2950),
    [sym_regex] = STATE(2950),
    [sym_meta_property] = STATE(2950),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2950),
    [sym_yield_expression] = STATE(2950),
    [sym_as_expression] = STATE(2950),
    [sym_non_null_expression] = STATE(2950),
    [sym_internal_module] = STATE(2950),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2950),
    [sym_await_expression] = STATE(2950),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(2950),
    [sym_this] = STATE(2950),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2950),
    [sym_generator_function] = STATE(2950),
    [sym_call_expression] = STATE(2950),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2950),
    [sym_ternary_expression] = STATE(2950),
    [sym_binary_expression] = STATE(2950),
    [sym_template_string] = STATE(2950),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2950),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2950),
    [sym_class] = STATE(2950),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4377),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(6075),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_AMP_EQ] = ACTIONS(6075),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6075),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(6075),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_PIPE_EQ] = ACTIONS(6075),
    [anon_sym_DASH_EQ] = ACTIONS(6075),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6075),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(4395),
    [sym_true] = ACTIONS(6079),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6075),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(6079),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_STAR_EQ] = ACTIONS(6075),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6075),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6079),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2083] = {
    [sym_call_signature] = STATE(2952),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(6087),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6075),
    [anon_sym_symbol] = ACTIONS(6089),
    [anon_sym_AMP_EQ] = ACTIONS(6075),
    [anon_sym_PLUS_EQ] = ACTIONS(6075),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_void] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(6075),
    [anon_sym_private] = ACTIONS(6089),
    [anon_sym_PIPE_EQ] = ACTIONS(6075),
    [anon_sym_DASH_EQ] = ACTIONS(6075),
    [anon_sym_get] = ACTIONS(6089),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6075),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(6089),
    [anon_sym_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(6089),
    [anon_sym_type] = ACTIONS(6089),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(6089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6075),
    [anon_sym_namespace] = ACTIONS(6089),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(6089),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_number] = ACTIONS(6089),
    [anon_sym_declare] = ACTIONS(6089),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(6089),
    [anon_sym_STAR_EQ] = ACTIONS(6075),
    [anon_sym_boolean] = ACTIONS(6089),
    [anon_sym_async] = ACTIONS(6089),
    [anon_sym_public] = ACTIONS(6089),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6075),
    [anon_sym_string] = ACTIONS(6089),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(6089),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2084] = {
    [sym_new_expression] = STATE(2954),
    [sym_augmented_assignment_expression] = STATE(2954),
    [sym_unary_expression] = STATE(2954),
    [sym_update_expression] = STATE(2954),
    [sym_regex] = STATE(2954),
    [sym_meta_property] = STATE(2954),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2954),
    [sym_yield_expression] = STATE(2954),
    [sym_as_expression] = STATE(2954),
    [sym_non_null_expression] = STATE(2954),
    [sym_internal_module] = STATE(2954),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2954),
    [sym_await_expression] = STATE(2954),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(2954),
    [sym_this] = STATE(2954),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2954),
    [sym_generator_function] = STATE(2954),
    [sym_call_expression] = STATE(2954),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2954),
    [sym_ternary_expression] = STATE(2954),
    [sym_binary_expression] = STATE(2954),
    [sym_template_string] = STATE(2954),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2954),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2954),
    [sym_class] = STATE(2954),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6091),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6093),
    [sym_true] = ACTIONS(6091),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6091),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2085] = {
    [sym_new_expression] = STATE(2955),
    [sym_augmented_assignment_expression] = STATE(2955),
    [sym_unary_expression] = STATE(2955),
    [sym_update_expression] = STATE(2955),
    [sym_regex] = STATE(2955),
    [sym_meta_property] = STATE(2955),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2955),
    [sym_yield_expression] = STATE(2955),
    [sym_as_expression] = STATE(2955),
    [sym_non_null_expression] = STATE(2955),
    [sym_internal_module] = STATE(2955),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2955),
    [sym_await_expression] = STATE(2955),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(2955),
    [sym_this] = STATE(2955),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2955),
    [sym_generator_function] = STATE(2955),
    [sym_call_expression] = STATE(2955),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2955),
    [sym_ternary_expression] = STATE(2955),
    [sym_binary_expression] = STATE(2955),
    [sym_template_string] = STATE(2955),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2955),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2955),
    [sym_class] = STATE(2955),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym_identifier] = ACTIONS(4377),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(4395),
    [sym_true] = ACTIONS(6095),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(6095),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6095),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6097),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6095),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [2086] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(6099),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(6101),
    [anon_sym_symbol] = ACTIONS(6101),
    [anon_sym_number] = ACTIONS(6101),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6101),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(6103),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(6101),
    [anon_sym_private] = ACTIONS(6101),
    [anon_sym_boolean] = ACTIONS(6101),
    [anon_sym_async] = ACTIONS(6105),
    [anon_sym_public] = ACTIONS(6101),
    [anon_sym_get] = ACTIONS(6101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(6101),
    [anon_sym_string] = ACTIONS(6101),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(6101),
    [anon_sym_type] = ACTIONS(6101),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(6101),
    [anon_sym_export] = ACTIONS(6101),
    [anon_sym_namespace] = ACTIONS(6107),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [2087] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6075),
    [anon_sym_AMP_EQ] = ACTIONS(6075),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_PLUS_EQ] = ACTIONS(6075),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6075),
    [anon_sym_STAR_EQ] = ACTIONS(6075),
    [anon_sym_PIPE_EQ] = ACTIONS(6075),
    [anon_sym_DASH_EQ] = ACTIONS(6075),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6075),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6075),
    [anon_sym_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2088] = {
    [sym_new_expression] = STATE(2961),
    [sym_augmented_assignment_expression] = STATE(2961),
    [sym_unary_expression] = STATE(2961),
    [sym_update_expression] = STATE(2961),
    [sym_regex] = STATE(2961),
    [sym_meta_property] = STATE(2961),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2961),
    [sym_yield_expression] = STATE(2961),
    [sym_as_expression] = STATE(2961),
    [sym_non_null_expression] = STATE(2961),
    [sym_internal_module] = STATE(2961),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2961),
    [sym_await_expression] = STATE(2961),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(2961),
    [sym_this] = STATE(2961),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2961),
    [sym_generator_function] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2961),
    [sym_ternary_expression] = STATE(2961),
    [sym_binary_expression] = STATE(2961),
    [sym_template_string] = STATE(2961),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2961),
    [sym_class] = STATE(2961),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(6109),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6109),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6111),
    [sym_true] = ACTIONS(6109),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6109),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2089] = {
    [anon_sym_EQ_GT] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
  },
  [2090] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6123),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2091] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6067),
    [anon_sym_AMP_EQ] = ACTIONS(6067),
    [anon_sym_PLUS_EQ] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6067),
    [anon_sym_STAR_EQ] = ACTIONS(6067),
    [anon_sym_PIPE_EQ] = ACTIONS(6067),
    [anon_sym_DASH_EQ] = ACTIONS(6067),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6067),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT_EQ] = ACTIONS(6067),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2092] = {
    [anon_sym_RPAREN] = ACTIONS(6123),
    [sym_comment] = ACTIONS(3),
  },
  [2093] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6073),
  },
  [2094] = {
    [sym_new_expression] = STATE(353),
    [sym_augmented_assignment_expression] = STATE(353),
    [sym_unary_expression] = STATE(353),
    [sym_update_expression] = STATE(353),
    [sym_regex] = STATE(353),
    [sym_meta_property] = STATE(353),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(353),
    [sym_yield_expression] = STATE(353),
    [sym_as_expression] = STATE(353),
    [sym_non_null_expression] = STATE(353),
    [sym_internal_module] = STATE(353),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(353),
    [sym_await_expression] = STATE(353),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(353),
    [sym_this] = STATE(353),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(353),
    [sym_generator_function] = STATE(353),
    [sym_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(353),
    [sym_ternary_expression] = STATE(353),
    [sym_binary_expression] = STATE(353),
    [sym_template_string] = STATE(353),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(353),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(353),
    [sym_class] = STATE(353),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(612),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(614),
    [sym_true] = ACTIONS(612),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2095] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6073),
  },
  [2096] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6127),
    [anon_sym_AMP_EQ] = ACTIONS(6127),
    [anon_sym_PLUS_EQ] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6127),
    [anon_sym_STAR_EQ] = ACTIONS(6127),
    [anon_sym_PIPE_EQ] = ACTIONS(6127),
    [anon_sym_DASH_EQ] = ACTIONS(6127),
    [anon_sym_EQ_GT] = ACTIONS(6131),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6127),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT_EQ] = ACTIONS(6127),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6133),
  },
  [2097] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2098] = {
    [sym_new_expression] = STATE(2977),
    [sym_augmented_assignment_expression] = STATE(2977),
    [sym_unary_expression] = STATE(2977),
    [sym_update_expression] = STATE(2977),
    [sym_regex] = STATE(2977),
    [sym_meta_property] = STATE(2977),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2977),
    [sym_yield_expression] = STATE(2977),
    [sym_as_expression] = STATE(2977),
    [sym_non_null_expression] = STATE(2977),
    [sym_internal_module] = STATE(2977),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2977),
    [sym_await_expression] = STATE(2977),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2977),
    [sym_this] = STATE(2977),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2977),
    [sym_generator_function] = STATE(2977),
    [sym_call_expression] = STATE(2977),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2977),
    [sym_ternary_expression] = STATE(2977),
    [sym_binary_expression] = STATE(2977),
    [sym_template_string] = STATE(2977),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2977),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2977),
    [sym_class] = STATE(2977),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6139),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6139),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6141),
    [sym_true] = ACTIONS(6139),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6139),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2099] = {
    [sym_new_expression] = STATE(2978),
    [sym_augmented_assignment_expression] = STATE(2978),
    [sym_unary_expression] = STATE(2978),
    [sym_update_expression] = STATE(2978),
    [sym_regex] = STATE(2978),
    [sym_meta_property] = STATE(2978),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2978),
    [sym_yield_expression] = STATE(2978),
    [sym_as_expression] = STATE(2978),
    [sym_non_null_expression] = STATE(2978),
    [sym_internal_module] = STATE(2978),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2978),
    [sym_await_expression] = STATE(2978),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2978),
    [sym_this] = STATE(2978),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2978),
    [sym_generator_function] = STATE(2978),
    [sym_call_expression] = STATE(2978),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2978),
    [sym_ternary_expression] = STATE(2978),
    [sym_binary_expression] = STATE(2978),
    [sym_template_string] = STATE(2978),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2978),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2978),
    [sym_class] = STATE(2978),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6143),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6143),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6145),
    [sym_true] = ACTIONS(6143),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6143),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2100] = {
    [sym_new_expression] = STATE(2977),
    [sym_augmented_assignment_expression] = STATE(2977),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(2977),
    [sym_update_expression] = STATE(2977),
    [sym_regex] = STATE(2977),
    [sym_meta_property] = STATE(2977),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2977),
    [sym_yield_expression] = STATE(2977),
    [sym_as_expression] = STATE(2977),
    [sym_non_null_expression] = STATE(2977),
    [sym_internal_module] = STATE(2977),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2977),
    [sym_await_expression] = STATE(2977),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2977),
    [sym_this] = STATE(2977),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2977),
    [sym_generator_function] = STATE(2977),
    [sym_call_expression] = STATE(2977),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2977),
    [sym_ternary_expression] = STATE(2977),
    [sym_binary_expression] = STATE(2977),
    [sym_template_string] = STATE(2977),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2977),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2977),
    [sym_class] = STATE(2977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4405),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(4423),
    [sym_true] = ACTIONS(6139),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(4411),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6139),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6139),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_EQ_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6141),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6139),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2101] = {
    [sym_call_signature] = STATE(2979),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(6147),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_symbol] = ACTIONS(6149),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_void] = ACTIONS(6149),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_private] = ACTIONS(6149),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_get] = ACTIONS(6149),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(6149),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(6149),
    [anon_sym_type] = ACTIONS(6149),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(6149),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_namespace] = ACTIONS(6149),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(6149),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_number] = ACTIONS(6149),
    [anon_sym_declare] = ACTIONS(6149),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(6149),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_boolean] = ACTIONS(6149),
    [anon_sym_async] = ACTIONS(6149),
    [anon_sym_public] = ACTIONS(6149),
    [anon_sym_EQ_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_string] = ACTIONS(6149),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(6149),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2102] = {
    [sym_new_expression] = STATE(2981),
    [sym_augmented_assignment_expression] = STATE(2981),
    [sym_unary_expression] = STATE(2981),
    [sym_update_expression] = STATE(2981),
    [sym_regex] = STATE(2981),
    [sym_meta_property] = STATE(2981),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2981),
    [sym_yield_expression] = STATE(2981),
    [sym_as_expression] = STATE(2981),
    [sym_non_null_expression] = STATE(2981),
    [sym_internal_module] = STATE(2981),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2981),
    [sym_await_expression] = STATE(2981),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2981),
    [sym_this] = STATE(2981),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2981),
    [sym_generator_function] = STATE(2981),
    [sym_call_expression] = STATE(2981),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2981),
    [sym_ternary_expression] = STATE(2981),
    [sym_binary_expression] = STATE(2981),
    [sym_template_string] = STATE(2981),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2981),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2981),
    [sym_class] = STATE(2981),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6151),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6151),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6153),
    [sym_true] = ACTIONS(6151),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6151),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2103] = {
    [sym_new_expression] = STATE(2982),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_regex] = STATE(2982),
    [sym_meta_property] = STATE(2982),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2982),
    [sym_yield_expression] = STATE(2982),
    [sym_as_expression] = STATE(2982),
    [sym_non_null_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2982),
    [sym_this] = STATE(2982),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2982),
    [sym_generator_function] = STATE(2982),
    [sym_call_expression] = STATE(2982),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2982),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_template_string] = STATE(2982),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2982),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2982),
    [sym_class] = STATE(2982),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(4405),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(4423),
    [sym_true] = ACTIONS(6155),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(4411),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6155),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6155),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6157),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6155),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [2104] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(6159),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(6161),
    [anon_sym_symbol] = ACTIONS(6161),
    [anon_sym_number] = ACTIONS(6161),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(6161),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(6163),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6161),
    [anon_sym_private] = ACTIONS(6161),
    [anon_sym_boolean] = ACTIONS(6161),
    [anon_sym_async] = ACTIONS(6165),
    [anon_sym_public] = ACTIONS(6161),
    [anon_sym_get] = ACTIONS(6161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(6161),
    [anon_sym_string] = ACTIONS(6161),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(6161),
    [anon_sym_type] = ACTIONS(6161),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(6161),
    [anon_sym_export] = ACTIONS(6161),
    [anon_sym_namespace] = ACTIONS(6167),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [2105] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2106] = {
    [sym_new_expression] = STATE(2988),
    [sym_augmented_assignment_expression] = STATE(2988),
    [sym_unary_expression] = STATE(2988),
    [sym_update_expression] = STATE(2988),
    [sym_regex] = STATE(2988),
    [sym_meta_property] = STATE(2988),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2988),
    [sym_yield_expression] = STATE(2988),
    [sym_as_expression] = STATE(2988),
    [sym_non_null_expression] = STATE(2988),
    [sym_internal_module] = STATE(2988),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2988),
    [sym_await_expression] = STATE(2988),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2988),
    [sym_this] = STATE(2988),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2988),
    [sym_generator_function] = STATE(2988),
    [sym_call_expression] = STATE(2988),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2988),
    [sym_ternary_expression] = STATE(2988),
    [sym_binary_expression] = STATE(2988),
    [sym_template_string] = STATE(2988),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2988),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2988),
    [sym_class] = STATE(2988),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6169),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6169),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6171),
    [sym_true] = ACTIONS(6169),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6169),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2107] = {
    [anon_sym_EQ_GT] = ACTIONS(6131),
    [sym_comment] = ACTIONS(3),
  },
  [2108] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(6195),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2109] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6127),
    [anon_sym_AMP_EQ] = ACTIONS(6127),
    [anon_sym_PLUS_EQ] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6127),
    [anon_sym_STAR_EQ] = ACTIONS(6127),
    [anon_sym_PIPE_EQ] = ACTIONS(6127),
    [anon_sym_DASH_EQ] = ACTIONS(6127),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6127),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT_EQ] = ACTIONS(6127),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2110] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6133),
  },
  [2111] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2112] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6133),
  },
  [2113] = {
    [sym_new_expression] = STATE(2998),
    [sym_augmented_assignment_expression] = STATE(2998),
    [sym_unary_expression] = STATE(2998),
    [sym_update_expression] = STATE(2998),
    [sym_regex] = STATE(2998),
    [sym_meta_property] = STATE(2998),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(2998),
    [sym_yield_expression] = STATE(2998),
    [sym_as_expression] = STATE(2998),
    [sym_non_null_expression] = STATE(2998),
    [sym_internal_module] = STATE(2998),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2998),
    [sym_await_expression] = STATE(2998),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(2999),
    [sym_string] = STATE(2998),
    [sym_this] = STATE(2998),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(2998),
    [sym_generator_function] = STATE(2998),
    [sym_call_expression] = STATE(2998),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(2998),
    [sym_ternary_expression] = STATE(2998),
    [sym_binary_expression] = STATE(2998),
    [sym_template_string] = STATE(2998),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2998),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(2998),
    [sym_class] = STATE(2998),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(6199),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6199),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6201),
    [sym_true] = ACTIONS(6199),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6199),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [2114] = {
    [sym_new_expression] = STATE(3000),
    [sym_augmented_assignment_expression] = STATE(3000),
    [sym_unary_expression] = STATE(3000),
    [sym_update_expression] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_meta_property] = STATE(3000),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(3000),
    [sym_yield_expression] = STATE(3000),
    [sym_as_expression] = STATE(3000),
    [sym_non_null_expression] = STATE(3000),
    [sym_internal_module] = STATE(3000),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3000),
    [sym_await_expression] = STATE(3000),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(3001),
    [sym_string] = STATE(3000),
    [sym_this] = STATE(3000),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(3000),
    [sym_generator_function] = STATE(3000),
    [sym_call_expression] = STATE(3000),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(3000),
    [sym_ternary_expression] = STATE(3000),
    [sym_binary_expression] = STATE(3000),
    [sym_template_string] = STATE(3000),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3000),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(3000),
    [sym_class] = STATE(3000),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(6203),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6203),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6205),
    [sym_true] = ACTIONS(6203),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6203),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [2115] = {
    [sym_new_expression] = STATE(3002),
    [sym_augmented_assignment_expression] = STATE(3002),
    [sym_unary_expression] = STATE(3002),
    [sym_update_expression] = STATE(3002),
    [sym_regex] = STATE(3002),
    [sym_meta_property] = STATE(3002),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(3002),
    [sym_yield_expression] = STATE(3002),
    [sym_as_expression] = STATE(3002),
    [sym_non_null_expression] = STATE(3002),
    [sym_internal_module] = STATE(3002),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3002),
    [sym_await_expression] = STATE(3002),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(3003),
    [sym_string] = STATE(3002),
    [sym_this] = STATE(3002),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(3002),
    [sym_generator_function] = STATE(3002),
    [sym_call_expression] = STATE(3002),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(3002),
    [sym_ternary_expression] = STATE(3002),
    [sym_binary_expression] = STATE(3002),
    [sym_template_string] = STATE(3002),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3002),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(3002),
    [sym_class] = STATE(3002),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(6207),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6207),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6209),
    [sym_true] = ACTIONS(6207),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6207),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [2116] = {
    [sym_type_alias_declaration] = STATE(3004),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3004),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3004),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3004),
    [sym_return_statement] = STATE(3004),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3004),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3004),
    [sym_switch_statement] = STATE(3004),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3004),
    [sym_throw_statement] = STATE(3004),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3004),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3004),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(3004),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3004),
    [sym_abstract_class] = STATE(3004),
    [sym_interface_declaration] = STATE(3004),
    [sym_statement_block] = STATE(3004),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3004),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3004),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3004),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3004),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3004),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3004),
    [sym_empty_statement] = STATE(3004),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(3004),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3004),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3004),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3004),
    [sym_break_statement] = STATE(3004),
    [sym_labeled_statement] = STATE(3004),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3004),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2117] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(6211),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2118] = {
    [anon_sym_RPAREN] = ACTIONS(6211),
    [sym_comment] = ACTIONS(3),
  },
  [2119] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(6213),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2120] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6215),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2121] = {
    [anon_sym_RPAREN] = ACTIONS(6215),
    [sym_comment] = ACTIONS(3),
  },
  [2122] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2123] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6219),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2124] = {
    [anon_sym_RPAREN] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
  },
  [2125] = {
    [sym__initializer] = STATE(651),
    [aux_sym_object_repeat1] = STATE(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1189),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [2126] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2127] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_meta_property] = STATE(90),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_internal_module] = STATE(90),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(53),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2128] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(1220),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1220),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [sym_number] = ACTIONS(1222),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2129] = {
    [sym__property_name] = STATE(663),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym_string] = STATE(663),
    [sym__initializer] = STATE(79),
    [sym_computed_property_name] = STATE(663),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [sym_number] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2130] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2131] = {
    [sym_import_require_clause] = STATE(124),
    [sym_import_clause] = STATE(125),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym_named_imports] = STATE(126),
    [sym_string] = STATE(124),
    [sym_namespace_import] = STATE(126),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(232),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(232),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2132] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2133] = {
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym_string] = STATE(172),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(308),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2134] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(675),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym__initializer] = STATE(79),
    [sym__declaration] = STATE(192),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(675),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(322),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1251),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2135] = {
    [sym__property_name] = STATE(663),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_computed_property_name] = STATE(663),
    [sym_call_signature] = STATE(253),
    [sym_string] = STATE(663),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1263),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(1263),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1263),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1263),
    [anon_sym_declare] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1263),
    [anon_sym_async] = ACTIONS(1263),
    [anon_sym_public] = ACTIONS(1263),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1274),
    [sym_number] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1263),
    [anon_sym_function] = ACTIONS(450),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2136] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(675),
    [aux_sym_object_repeat1] = STATE(1073),
    [sym__declaration] = STATE(317),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(675),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_as] = ACTIONS(541),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2137] = {
    [sym_type_alias_declaration] = STATE(689),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(689),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(689),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(689),
    [sym_return_statement] = STATE(689),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(689),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(689),
    [sym_switch_statement] = STATE(689),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(689),
    [sym_throw_statement] = STATE(689),
    [aux_sym_program_repeat1] = STATE(689),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(689),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(689),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(689),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(689),
    [sym_abstract_class] = STATE(689),
    [sym_interface_declaration] = STATE(689),
    [sym_statement_block] = STATE(689),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(689),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(689),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(689),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(689),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(689),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(689),
    [sym_empty_statement] = STATE(689),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(689),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(689),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(689),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(689),
    [sym_break_statement] = STATE(689),
    [sym_labeled_statement] = STATE(689),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(689),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(6221),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [2138] = {
    [sym_computed_property_name] = STATE(701),
    [sym__property_name] = STATE(701),
    [sym_decorator] = STATE(702),
    [sym_method_definition] = STATE(1076),
    [sym_string] = STATE(701),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(702),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_class] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(362),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1304),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_public] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [sym_number] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1304),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1312),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [2139] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(4657),
    [anon_sym_BANG] = ACTIONS(4659),
    [anon_sym_BQUOTE] = ACTIONS(4657),
    [anon_sym_else] = ACTIONS(4657),
    [anon_sym_PIPE] = ACTIONS(4659),
    [anon_sym_COMMA] = ACTIONS(4657),
    [anon_sym_LT_LT] = ACTIONS(4657),
    [anon_sym_STAR] = ACTIONS(4659),
    [anon_sym_GT_GT_GT] = ACTIONS(4657),
    [anon_sym_AMP_AMP] = ACTIONS(4657),
    [anon_sym_DASH] = ACTIONS(4659),
    [anon_sym_LBRACE] = ACTIONS(4659),
    [anon_sym_BANG_EQ] = ACTIONS(4659),
    [anon_sym_LT_EQ] = ACTIONS(4657),
    [anon_sym_LPAREN] = ACTIONS(4657),
    [anon_sym_RBRACK] = ACTIONS(4657),
    [anon_sym_GT_EQ] = ACTIONS(4657),
    [anon_sym_GT] = ACTIONS(4659),
    [anon_sym_AMP] = ACTIONS(4659),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_QMARK] = ACTIONS(4657),
    [anon_sym_RBRACE] = ACTIONS(4657),
    [anon_sym_as] = ACTIONS(4657),
    [anon_sym_PIPE_PIPE] = ACTIONS(4657),
    [anon_sym_while] = ACTIONS(4657),
    [anon_sym_DASH_DASH] = ACTIONS(4657),
    [anon_sym_EQ_EQ] = ACTIONS(4659),
    [anon_sym_instanceof] = ACTIONS(4657),
    [anon_sym_LT] = ACTIONS(4659),
    [anon_sym_RPAREN] = ACTIONS(4657),
    [anon_sym_SLASH] = ACTIONS(4659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4657),
    [anon_sym_COLON] = ACTIONS(4657),
    [anon_sym_DOT] = ACTIONS(4657),
    [anon_sym_CARET] = ACTIONS(4657),
    [anon_sym_STAR_STAR] = ACTIONS(4657),
    [anon_sym_PLUS] = ACTIONS(4659),
    [anon_sym_implements] = ACTIONS(4657),
    [anon_sym_GT_GT] = ACTIONS(4659),
    [anon_sym_PLUS_PLUS] = ACTIONS(4657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4657),
    [anon_sym_in] = ACTIONS(4659),
  },
  [2140] = {
    [sym_class_body] = STATE(3011),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [2141] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4793),
    [anon_sym_LBRACK] = ACTIONS(4793),
    [anon_sym_BANG] = ACTIONS(4795),
    [anon_sym_BQUOTE] = ACTIONS(4793),
    [anon_sym_else] = ACTIONS(4793),
    [anon_sym_PIPE] = ACTIONS(4795),
    [anon_sym_COMMA] = ACTIONS(4793),
    [anon_sym_LT_LT] = ACTIONS(4793),
    [anon_sym_STAR] = ACTIONS(4795),
    [anon_sym_GT_GT_GT] = ACTIONS(4793),
    [anon_sym_AMP_AMP] = ACTIONS(4793),
    [anon_sym_DASH] = ACTIONS(4795),
    [anon_sym_LBRACE] = ACTIONS(4795),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4793),
    [anon_sym_LPAREN] = ACTIONS(4793),
    [anon_sym_RBRACK] = ACTIONS(4793),
    [anon_sym_GT_EQ] = ACTIONS(4793),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4795),
    [anon_sym_PERCENT] = ACTIONS(4793),
    [anon_sym_QMARK] = ACTIONS(4793),
    [anon_sym_RBRACE] = ACTIONS(4793),
    [anon_sym_as] = ACTIONS(4793),
    [anon_sym_PIPE_PIPE] = ACTIONS(4793),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4793),
    [anon_sym_DASH_DASH] = ACTIONS(4793),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4793),
    [anon_sym_LT] = ACTIONS(4795),
    [anon_sym_RPAREN] = ACTIONS(4793),
    [anon_sym_SLASH] = ACTIONS(4795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(4793),
    [anon_sym_COLON] = ACTIONS(4793),
    [anon_sym_DOT] = ACTIONS(4793),
    [anon_sym_CARET] = ACTIONS(4793),
    [anon_sym_STAR_STAR] = ACTIONS(4793),
    [anon_sym_PLUS] = ACTIONS(4795),
    [anon_sym_implements] = ACTIONS(4793),
    [anon_sym_GT_GT] = ACTIONS(4795),
    [anon_sym_PLUS_PLUS] = ACTIONS(4793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4793),
    [anon_sym_in] = ACTIONS(4795),
  },
  [2142] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5102),
    [anon_sym_LBRACK] = ACTIONS(5102),
    [anon_sym_BANG] = ACTIONS(5104),
    [anon_sym_BQUOTE] = ACTIONS(5102),
    [anon_sym_PIPE] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5102),
    [anon_sym_LT_LT] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5104),
    [anon_sym_GT_GT_GT] = ACTIONS(5102),
    [anon_sym_AMP_AMP] = ACTIONS(5102),
    [anon_sym_DASH] = ACTIONS(5104),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_BANG_EQ] = ACTIONS(5104),
    [anon_sym_LT_EQ] = ACTIONS(5102),
    [anon_sym_LPAREN] = ACTIONS(5102),
    [anon_sym_RBRACK] = ACTIONS(5102),
    [anon_sym_GT_EQ] = ACTIONS(5102),
    [anon_sym_GT] = ACTIONS(5104),
    [anon_sym_AMP] = ACTIONS(5104),
    [anon_sym_PERCENT] = ACTIONS(5102),
    [anon_sym_QMARK] = ACTIONS(5102),
    [anon_sym_RBRACE] = ACTIONS(5102),
    [anon_sym_as] = ACTIONS(5102),
    [anon_sym_PIPE_PIPE] = ACTIONS(5102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5102),
    [anon_sym_DASH_DASH] = ACTIONS(5102),
    [anon_sym_EQ_EQ] = ACTIONS(5104),
    [anon_sym_instanceof] = ACTIONS(5102),
    [anon_sym_LT] = ACTIONS(5104),
    [anon_sym_RPAREN] = ACTIONS(5102),
    [anon_sym_SLASH] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5102),
    [anon_sym_DOT] = ACTIONS(5102),
    [anon_sym_CARET] = ACTIONS(5102),
    [anon_sym_STAR_STAR] = ACTIONS(5102),
    [anon_sym_PLUS] = ACTIONS(5104),
    [anon_sym_implements] = ACTIONS(5102),
    [anon_sym_GT_GT] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5102),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5102),
    [anon_sym_in] = ACTIONS(5104),
  },
  [2143] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4117),
    [anon_sym_LBRACK] = ACTIONS(4117),
    [anon_sym_BANG] = ACTIONS(4119),
    [anon_sym_BQUOTE] = ACTIONS(4117),
    [anon_sym_PERCENT_EQ] = ACTIONS(4117),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4117),
    [anon_sym_AMP_EQ] = ACTIONS(4117),
    [anon_sym_PLUS_EQ] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4119),
    [anon_sym_COMMA] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(4119),
    [anon_sym_GT_GT_GT] = ACTIONS(4119),
    [anon_sym_EQ] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_DASH] = ACTIONS(4119),
    [anon_sym_BANG_EQ] = ACTIONS(4119),
    [anon_sym_LT_EQ] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(4117),
    [anon_sym_RBRACK] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4119),
    [anon_sym_LBRACE] = ACTIONS(4119),
    [anon_sym_CARET_EQ] = ACTIONS(4117),
    [anon_sym_STAR_EQ] = ACTIONS(4117),
    [anon_sym_PIPE_EQ] = ACTIONS(4117),
    [anon_sym_DASH_EQ] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4119),
    [anon_sym_PERCENT] = ACTIONS(4119),
    [anon_sym_QMARK] = ACTIONS(4117),
    [anon_sym_LT_LT_EQ] = ACTIONS(4117),
    [anon_sym_as] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [anon_sym_DASH_DASH] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4119),
    [anon_sym_instanceof] = ACTIONS(4117),
    [anon_sym_LT] = ACTIONS(4119),
    [anon_sym_RPAREN] = ACTIONS(4117),
    [anon_sym_SLASH] = ACTIONS(4119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4117),
    [anon_sym_COLON] = ACTIONS(4117),
    [anon_sym_SLASH_EQ] = ACTIONS(4117),
    [anon_sym_GT_GT_EQ] = ACTIONS(4117),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_CARET] = ACTIONS(4119),
    [anon_sym_STAR_STAR] = ACTIONS(4119),
    [anon_sym_PLUS] = ACTIONS(4119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4119),
    [anon_sym_PLUS_PLUS] = ACTIONS(4117),
    [anon_sym_implements] = ACTIONS(4117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4117),
    [anon_sym_in] = ACTIONS(4119),
  },
  [2144] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5130),
    [anon_sym_LBRACK] = ACTIONS(5130),
    [anon_sym_BANG] = ACTIONS(5132),
    [anon_sym_BQUOTE] = ACTIONS(5130),
    [anon_sym_PIPE] = ACTIONS(5132),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(5130),
    [anon_sym_STAR] = ACTIONS(5132),
    [anon_sym_GT_GT_GT] = ACTIONS(5130),
    [anon_sym_AMP_AMP] = ACTIONS(5130),
    [anon_sym_DASH] = ACTIONS(5132),
    [anon_sym_LBRACE] = ACTIONS(5132),
    [anon_sym_BANG_EQ] = ACTIONS(5132),
    [anon_sym_LT_EQ] = ACTIONS(5130),
    [anon_sym_LPAREN] = ACTIONS(5130),
    [anon_sym_RBRACK] = ACTIONS(5130),
    [anon_sym_GT_EQ] = ACTIONS(5130),
    [anon_sym_GT] = ACTIONS(5132),
    [anon_sym_AMP] = ACTIONS(5132),
    [anon_sym_PERCENT] = ACTIONS(5130),
    [anon_sym_QMARK] = ACTIONS(5130),
    [anon_sym_RBRACE] = ACTIONS(5130),
    [anon_sym_as] = ACTIONS(5130),
    [anon_sym_PIPE_PIPE] = ACTIONS(5130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5130),
    [anon_sym_DASH_DASH] = ACTIONS(5130),
    [anon_sym_EQ_EQ] = ACTIONS(5132),
    [anon_sym_instanceof] = ACTIONS(5130),
    [anon_sym_LT] = ACTIONS(5132),
    [anon_sym_RPAREN] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5130),
    [anon_sym_DOT] = ACTIONS(5130),
    [anon_sym_CARET] = ACTIONS(5130),
    [anon_sym_STAR_STAR] = ACTIONS(5130),
    [anon_sym_PLUS] = ACTIONS(5132),
    [anon_sym_implements] = ACTIONS(5130),
    [anon_sym_GT_GT] = ACTIONS(5132),
    [anon_sym_PLUS_PLUS] = ACTIONS(5130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5130),
    [anon_sym_in] = ACTIONS(5132),
  },
  [2145] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(5130),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [2146] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5134),
    [anon_sym_LBRACK] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_BQUOTE] = ACTIONS(5134),
    [anon_sym_PIPE] = ACTIONS(5136),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(5134),
    [anon_sym_STAR] = ACTIONS(5136),
    [anon_sym_GT_GT_GT] = ACTIONS(5134),
    [anon_sym_AMP_AMP] = ACTIONS(5134),
    [anon_sym_DASH] = ACTIONS(5136),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_BANG_EQ] = ACTIONS(5136),
    [anon_sym_LT_EQ] = ACTIONS(5134),
    [anon_sym_LPAREN] = ACTIONS(5134),
    [anon_sym_RBRACK] = ACTIONS(5134),
    [anon_sym_GT_EQ] = ACTIONS(5134),
    [anon_sym_GT] = ACTIONS(5136),
    [anon_sym_AMP] = ACTIONS(5136),
    [anon_sym_PERCENT] = ACTIONS(5134),
    [anon_sym_QMARK] = ACTIONS(5134),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [anon_sym_as] = ACTIONS(5134),
    [anon_sym_PIPE_PIPE] = ACTIONS(5134),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5134),
    [anon_sym_DASH_DASH] = ACTIONS(5134),
    [anon_sym_EQ_EQ] = ACTIONS(5136),
    [anon_sym_instanceof] = ACTIONS(5134),
    [anon_sym_LT] = ACTIONS(5136),
    [anon_sym_RPAREN] = ACTIONS(5134),
    [anon_sym_SLASH] = ACTIONS(5136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5134),
    [anon_sym_DOT] = ACTIONS(5134),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_STAR_STAR] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_implements] = ACTIONS(5134),
    [anon_sym_GT_GT] = ACTIONS(5136),
    [anon_sym_PLUS_PLUS] = ACTIONS(5134),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5134),
    [anon_sym_in] = ACTIONS(5136),
  },
  [2147] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(5134),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [2148] = {
    [sym_statement_block] = STATE(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2547),
  },
  [2149] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5140),
    [anon_sym_LBRACK] = ACTIONS(5140),
    [anon_sym_BANG] = ACTIONS(5142),
    [anon_sym_BQUOTE] = ACTIONS(5140),
    [anon_sym_else] = ACTIONS(5140),
    [anon_sym_PIPE] = ACTIONS(5142),
    [anon_sym_COMMA] = ACTIONS(5140),
    [anon_sym_LT_LT] = ACTIONS(5140),
    [anon_sym_STAR] = ACTIONS(5142),
    [anon_sym_GT_GT_GT] = ACTIONS(5140),
    [anon_sym_AMP_AMP] = ACTIONS(5140),
    [anon_sym_DASH] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(5142),
    [anon_sym_BANG_EQ] = ACTIONS(5142),
    [anon_sym_LT_EQ] = ACTIONS(5140),
    [anon_sym_LPAREN] = ACTIONS(5140),
    [anon_sym_RBRACK] = ACTIONS(5140),
    [anon_sym_GT_EQ] = ACTIONS(5140),
    [anon_sym_GT] = ACTIONS(5142),
    [anon_sym_AMP] = ACTIONS(5142),
    [anon_sym_PERCENT] = ACTIONS(5140),
    [anon_sym_QMARK] = ACTIONS(5140),
    [anon_sym_RBRACE] = ACTIONS(5140),
    [anon_sym_as] = ACTIONS(5140),
    [anon_sym_PIPE_PIPE] = ACTIONS(5140),
    [anon_sym_while] = ACTIONS(5140),
    [anon_sym_DASH_DASH] = ACTIONS(5140),
    [anon_sym_EQ_EQ] = ACTIONS(5142),
    [anon_sym_instanceof] = ACTIONS(5140),
    [anon_sym_LT] = ACTIONS(5142),
    [anon_sym_RPAREN] = ACTIONS(5140),
    [anon_sym_SLASH] = ACTIONS(5142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5140),
    [anon_sym_COLON] = ACTIONS(5140),
    [anon_sym_DOT] = ACTIONS(5140),
    [anon_sym_CARET] = ACTIONS(5140),
    [anon_sym_STAR_STAR] = ACTIONS(5140),
    [anon_sym_PLUS] = ACTIONS(5142),
    [anon_sym_implements] = ACTIONS(5140),
    [anon_sym_GT_GT] = ACTIONS(5142),
    [anon_sym_PLUS_PLUS] = ACTIONS(5140),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5140),
    [anon_sym_in] = ACTIONS(5142),
  },
  [2150] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_BQUOTE] = ACTIONS(5427),
    [anon_sym_PIPE] = ACTIONS(5429),
    [anon_sym_COMMA] = ACTIONS(5427),
    [anon_sym_LT_LT] = ACTIONS(5427),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_GT_GT_GT] = ACTIONS(5427),
    [anon_sym_AMP_AMP] = ACTIONS(5427),
    [anon_sym_DASH] = ACTIONS(5429),
    [anon_sym_LBRACE] = ACTIONS(5429),
    [anon_sym_BANG_EQ] = ACTIONS(5429),
    [anon_sym_LT_EQ] = ACTIONS(5427),
    [anon_sym_LPAREN] = ACTIONS(5427),
    [anon_sym_RBRACK] = ACTIONS(5427),
    [anon_sym_GT_EQ] = ACTIONS(5427),
    [anon_sym_GT] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_PERCENT] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5427),
    [anon_sym_RBRACE] = ACTIONS(5427),
    [anon_sym_as] = ACTIONS(5427),
    [anon_sym_PIPE_PIPE] = ACTIONS(5427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5427),
    [anon_sym_DASH_DASH] = ACTIONS(5427),
    [anon_sym_EQ_EQ] = ACTIONS(5429),
    [anon_sym_instanceof] = ACTIONS(5427),
    [anon_sym_LT] = ACTIONS(5429),
    [anon_sym_RPAREN] = ACTIONS(5427),
    [anon_sym_SLASH] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5427),
    [anon_sym_DOT] = ACTIONS(5427),
    [anon_sym_CARET] = ACTIONS(5427),
    [anon_sym_STAR_STAR] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5429),
    [anon_sym_implements] = ACTIONS(5427),
    [anon_sym_GT_GT] = ACTIONS(5429),
    [anon_sym_PLUS_PLUS] = ACTIONS(5427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5427),
    [anon_sym_in] = ACTIONS(5429),
  },
  [2151] = {
    [sym_statement_block] = STATE(3013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2547),
  },
  [2152] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5445),
    [anon_sym_LBRACK] = ACTIONS(5445),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_BQUOTE] = ACTIONS(5445),
    [anon_sym_else] = ACTIONS(5445),
    [anon_sym_PIPE] = ACTIONS(5447),
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_LT_LT] = ACTIONS(5445),
    [anon_sym_STAR] = ACTIONS(5447),
    [anon_sym_GT_GT_GT] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5447),
    [anon_sym_LBRACE] = ACTIONS(5447),
    [anon_sym_BANG_EQ] = ACTIONS(5447),
    [anon_sym_LT_EQ] = ACTIONS(5445),
    [anon_sym_LPAREN] = ACTIONS(5445),
    [anon_sym_RBRACK] = ACTIONS(5445),
    [anon_sym_GT_EQ] = ACTIONS(5445),
    [anon_sym_GT] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5445),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_as] = ACTIONS(5445),
    [anon_sym_PIPE_PIPE] = ACTIONS(5445),
    [anon_sym_while] = ACTIONS(5445),
    [anon_sym_DASH_DASH] = ACTIONS(5445),
    [anon_sym_EQ_EQ] = ACTIONS(5447),
    [anon_sym_instanceof] = ACTIONS(5445),
    [anon_sym_LT] = ACTIONS(5447),
    [anon_sym_RPAREN] = ACTIONS(5445),
    [anon_sym_SLASH] = ACTIONS(5447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5445),
    [anon_sym_COLON] = ACTIONS(5445),
    [anon_sym_DOT] = ACTIONS(5445),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_STAR_STAR] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5447),
    [anon_sym_implements] = ACTIONS(5445),
    [anon_sym_GT_GT] = ACTIONS(5447),
    [anon_sym_PLUS_PLUS] = ACTIONS(5445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5445),
    [anon_sym_in] = ACTIONS(5447),
  },
  [2153] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_RBRACK] = ACTIONS(1239),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1239),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_as] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1239),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_CARET] = ACTIONS(1239),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_implements] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1237),
  },
  [2154] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2285),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2285),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_COMMA] = ACTIONS(2285),
    [anon_sym_LT_LT] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2287),
    [anon_sym_GT_GT_GT] = ACTIONS(2285),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2287),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_LT_EQ] = ACTIONS(2285),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_RBRACK] = ACTIONS(2285),
    [anon_sym_GT_EQ] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_EQ_GT] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_PERCENT] = ACTIONS(2285),
    [anon_sym_QMARK] = ACTIONS(2285),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_as] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2285),
    [anon_sym_DASH_DASH] = ACTIONS(2285),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_instanceof] = ACTIONS(2285),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_RPAREN] = ACTIONS(2285),
    [anon_sym_SLASH] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1368),
    [anon_sym_DOT] = ACTIONS(2285),
    [anon_sym_CARET] = ACTIONS(2285),
    [anon_sym_STAR_STAR] = ACTIONS(2285),
    [anon_sym_PLUS] = ACTIONS(2287),
    [anon_sym_implements] = ACTIONS(2285),
    [anon_sym_GT_GT] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2285),
    [anon_sym_in] = ACTIONS(2287),
  },
  [2155] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [aux_sym_array_repeat1] = STATE(1929),
    [sym_type_annotation] = STATE(1224),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(1331),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_COMMA] = ACTIONS(5467),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2156] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4363),
    [anon_sym_LBRACK] = ACTIONS(4363),
    [anon_sym_BANG] = ACTIONS(4365),
    [anon_sym_BQUOTE] = ACTIONS(4363),
    [anon_sym_PIPE] = ACTIONS(4365),
    [anon_sym_COMMA] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_STAR] = ACTIONS(4365),
    [anon_sym_LBRACE] = ACTIONS(4365),
    [anon_sym_AMP_AMP] = ACTIONS(4363),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_DASH] = ACTIONS(4365),
    [anon_sym_BANG_EQ] = ACTIONS(4365),
    [anon_sym_LT_EQ] = ACTIONS(4363),
    [anon_sym_LPAREN] = ACTIONS(4363),
    [anon_sym_RBRACK] = ACTIONS(4363),
    [anon_sym_GT_EQ] = ACTIONS(4363),
    [anon_sym_GT] = ACTIONS(4365),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_QMARK] = ACTIONS(4363),
    [anon_sym_RBRACE] = ACTIONS(4363),
    [anon_sym_as] = ACTIONS(4363),
    [anon_sym_PIPE_PIPE] = ACTIONS(4363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4363),
    [anon_sym_DASH_DASH] = ACTIONS(4363),
    [anon_sym_EQ_EQ] = ACTIONS(4365),
    [anon_sym_instanceof] = ACTIONS(4363),
    [anon_sym_LT] = ACTIONS(4365),
    [anon_sym_RPAREN] = ACTIONS(4363),
    [anon_sym_SLASH] = ACTIONS(4365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4363),
    [anon_sym_DOT] = ACTIONS(4363),
    [anon_sym_CARET] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4363),
    [anon_sym_PLUS] = ACTIONS(4365),
    [anon_sym_implements] = ACTIONS(4363),
    [anon_sym_GT_GT] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4363),
    [anon_sym_in] = ACTIONS(4365),
  },
  [2157] = {
    [sym_new_expression] = STATE(3014),
    [sym_augmented_assignment_expression] = STATE(3014),
    [sym_unary_expression] = STATE(3014),
    [sym_update_expression] = STATE(3014),
    [sym_regex] = STATE(3014),
    [sym_meta_property] = STATE(3014),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(3014),
    [sym_yield_expression] = STATE(3014),
    [sym_as_expression] = STATE(3014),
    [sym_non_null_expression] = STATE(3014),
    [sym_internal_module] = STATE(3014),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3014),
    [sym_await_expression] = STATE(3014),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(3014),
    [sym_this] = STATE(3014),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(3014),
    [sym_generator_function] = STATE(3014),
    [sym_call_expression] = STATE(3014),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(3014),
    [sym_ternary_expression] = STATE(3014),
    [sym_binary_expression] = STATE(3014),
    [sym_template_string] = STATE(3014),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3014),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(3014),
    [sym_class] = STATE(3014),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(6223),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6223),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6225),
    [sym_true] = ACTIONS(6223),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6223),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [2158] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3015),
    [sym_constructor_type] = STATE(3015),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(3015),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3015),
    [sym_intersection_type] = STATE(3015),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2159] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3016),
    [sym_constructor_type] = STATE(3016),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(3016),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3016),
    [sym_intersection_type] = STATE(3016),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2160] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3017),
    [sym_constructor_type] = STATE(3017),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(3017),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3017),
    [sym_intersection_type] = STATE(3017),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2161] = {
    [sym_identifier] = ACTIONS(6227),
    [sym_comment] = ACTIONS(3),
  },
  [2162] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3019),
    [sym_constructor_type] = STATE(3019),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(3019),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3019),
    [sym_intersection_type] = STATE(3019),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2163] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3267),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_STAR] = ACTIONS(3267),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3267),
    [anon_sym_BANG_EQ] = ACTIONS(3267),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_RBRACK] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_GT] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3267),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3267),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3267),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_SLASH] = ACTIONS(3267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3269),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_implements] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_in] = ACTIONS(3267),
  },
  [2164] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(2177),
    [sym_constructor_type] = STATE(2177),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(2177),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(2177),
    [sym_intersection_type] = STATE(2177),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2165] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(4542),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_BQUOTE] = ACTIONS(3273),
    [anon_sym_PIPE] = ACTIONS(3271),
    [anon_sym_COMMA] = ACTIONS(3273),
    [anon_sym_LT_LT] = ACTIONS(3273),
    [anon_sym_STAR] = ACTIONS(3271),
    [anon_sym_GT_GT_GT] = ACTIONS(3273),
    [anon_sym_AMP_AMP] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3271),
    [anon_sym_BANG_EQ] = ACTIONS(3271),
    [anon_sym_LT_EQ] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_RBRACK] = ACTIONS(3273),
    [anon_sym_GT_EQ] = ACTIONS(3273),
    [anon_sym_GT] = ACTIONS(3271),
    [anon_sym_AMP] = ACTIONS(3271),
    [anon_sym_PERCENT] = ACTIONS(3273),
    [anon_sym_QMARK] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_as] = ACTIONS(3273),
    [anon_sym_PIPE_PIPE] = ACTIONS(3273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [anon_sym_EQ_EQ] = ACTIONS(3271),
    [anon_sym_instanceof] = ACTIONS(3273),
    [anon_sym_LT] = ACTIONS(3271),
    [anon_sym_RPAREN] = ACTIONS(3273),
    [anon_sym_SLASH] = ACTIONS(3271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3273),
    [anon_sym_DOT] = ACTIONS(3273),
    [anon_sym_CARET] = ACTIONS(3273),
    [anon_sym_STAR_STAR] = ACTIONS(3273),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_implements] = ACTIONS(3273),
    [anon_sym_GT_GT] = ACTIONS(3271),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3273),
    [anon_sym_in] = ACTIONS(3271),
  },
  [2166] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(3020),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(3020),
    [sym_call_signature] = STATE(3020),
    [sym_export_statement] = STATE(3020),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(3020),
    [sym_index_signature] = STATE(3020),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [2167] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_BQUOTE] = ACTIONS(3303),
    [anon_sym_PIPE] = ACTIONS(3301),
    [anon_sym_COMMA] = ACTIONS(3303),
    [anon_sym_LT_LT] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3301),
    [anon_sym_GT_GT_GT] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_BANG_EQ] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_RBRACK] = ACTIONS(3303),
    [anon_sym_GT_EQ] = ACTIONS(3303),
    [anon_sym_GT] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_PERCENT] = ACTIONS(3303),
    [anon_sym_QMARK] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_as] = ACTIONS(3303),
    [anon_sym_PIPE_PIPE] = ACTIONS(3303),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_EQ_EQ] = ACTIONS(3301),
    [anon_sym_instanceof] = ACTIONS(3303),
    [anon_sym_LT] = ACTIONS(3301),
    [anon_sym_RPAREN] = ACTIONS(3303),
    [anon_sym_SLASH] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3303),
    [anon_sym_DOT] = ACTIONS(3303),
    [anon_sym_CARET] = ACTIONS(3303),
    [anon_sym_STAR_STAR] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_implements] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3303),
    [anon_sym_in] = ACTIONS(3301),
  },
  [2168] = {
    [aux_sym_object_type_repeat1] = STATE(3023),
    [sym__automatic_semicolon] = ACTIONS(6229),
    [anon_sym_RBRACE] = ACTIONS(6231),
    [anon_sym_SEMI] = ACTIONS(6229),
    [anon_sym_COMMA] = ACTIONS(6229),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6231),
    [sym_comment] = ACTIONS(3),
  },
  [2169] = {
    [aux_sym_implements_clause_repeat1] = STATE(3025),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(3365),
    [anon_sym_RBRACK] = ACTIONS(6233),
    [sym_comment] = ACTIONS(3),
  },
  [2170] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [anon_sym_PIPE] = ACTIONS(3373),
    [anon_sym_COMMA] = ACTIONS(3375),
    [anon_sym_LT_LT] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_GT_GT_GT] = ACTIONS(3375),
    [anon_sym_AMP_AMP] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_BANG_EQ] = ACTIONS(3373),
    [anon_sym_LT_EQ] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3375),
    [anon_sym_RBRACK] = ACTIONS(3375),
    [anon_sym_GT_EQ] = ACTIONS(3375),
    [anon_sym_GT] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3373),
    [anon_sym_PERCENT] = ACTIONS(3375),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_RBRACE] = ACTIONS(3375),
    [anon_sym_as] = ACTIONS(3375),
    [anon_sym_PIPE_PIPE] = ACTIONS(3375),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [anon_sym_EQ_EQ] = ACTIONS(3373),
    [anon_sym_instanceof] = ACTIONS(3375),
    [anon_sym_LT] = ACTIONS(3373),
    [anon_sym_RPAREN] = ACTIONS(3375),
    [anon_sym_SLASH] = ACTIONS(3373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3375),
    [anon_sym_DOT] = ACTIONS(3375),
    [anon_sym_CARET] = ACTIONS(3375),
    [anon_sym_STAR_STAR] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_implements] = ACTIONS(3375),
    [anon_sym_GT_GT] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3375),
    [anon_sym_in] = ACTIONS(3373),
  },
  [2171] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_GT_GT_GT] = ACTIONS(3379),
    [anon_sym_AMP_AMP] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_BANG_EQ] = ACTIONS(3377),
    [anon_sym_LT_EQ] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [anon_sym_RBRACK] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(3379),
    [anon_sym_QMARK] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_as] = ACTIONS(3379),
    [anon_sym_PIPE_PIPE] = ACTIONS(3379),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [anon_sym_EQ_EQ] = ACTIONS(3377),
    [anon_sym_instanceof] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_RPAREN] = ACTIONS(3379),
    [anon_sym_SLASH] = ACTIONS(3377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3379),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_CARET] = ACTIONS(3379),
    [anon_sym_STAR_STAR] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_implements] = ACTIONS(3379),
    [anon_sym_GT_GT] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3377),
  },
  [2172] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [anon_sym_PIPE] = ACTIONS(3385),
    [anon_sym_COMMA] = ACTIONS(3387),
    [anon_sym_LT_LT] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_GT_GT_GT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_BANG_EQ] = ACTIONS(3385),
    [anon_sym_LT_EQ] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_RBRACK] = ACTIONS(3387),
    [anon_sym_GT_EQ] = ACTIONS(3387),
    [anon_sym_GT] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3385),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_as] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [anon_sym_EQ_EQ] = ACTIONS(3385),
    [anon_sym_instanceof] = ACTIONS(3387),
    [anon_sym_LT] = ACTIONS(3385),
    [anon_sym_RPAREN] = ACTIONS(3387),
    [anon_sym_SLASH] = ACTIONS(3385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(3387),
    [anon_sym_STAR_STAR] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_implements] = ACTIONS(3387),
    [anon_sym_GT_GT] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3387),
    [anon_sym_in] = ACTIONS(3385),
  },
  [2173] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [anon_sym_PIPE] = ACTIONS(3391),
    [anon_sym_COMMA] = ACTIONS(3393),
    [anon_sym_LT_LT] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3391),
    [anon_sym_GT_GT_GT] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3391),
    [anon_sym_LT_EQ] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_RBRACK] = ACTIONS(3393),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT] = ACTIONS(3391),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_PERCENT] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_as] = ACTIONS(3393),
    [anon_sym_PIPE_PIPE] = ACTIONS(3393),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_instanceof] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3391),
    [anon_sym_RPAREN] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3393),
    [anon_sym_DOT] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_STAR_STAR] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_implements] = ACTIONS(3393),
    [anon_sym_GT_GT] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3393),
    [anon_sym_in] = ACTIONS(3391),
  },
  [2174] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_BQUOTE] = ACTIONS(3383),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_LT_LT] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_GT_GT_GT] = ACTIONS(3383),
    [anon_sym_AMP_AMP] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3381),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_BANG_EQ] = ACTIONS(3381),
    [anon_sym_LT_EQ] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3383),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [anon_sym_GT_EQ] = ACTIONS(3383),
    [anon_sym_GT] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_PERCENT] = ACTIONS(3383),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_as] = ACTIONS(3383),
    [anon_sym_PIPE_PIPE] = ACTIONS(3383),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [anon_sym_EQ_EQ] = ACTIONS(3381),
    [anon_sym_instanceof] = ACTIONS(3383),
    [anon_sym_LT] = ACTIONS(3381),
    [anon_sym_RPAREN] = ACTIONS(3383),
    [anon_sym_SLASH] = ACTIONS(3381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3383),
    [anon_sym_DOT] = ACTIONS(3383),
    [anon_sym_CARET] = ACTIONS(3383),
    [anon_sym_STAR_STAR] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3381),
    [anon_sym_implements] = ACTIONS(3383),
    [anon_sym_GT_GT] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3383),
    [anon_sym_in] = ACTIONS(3381),
  },
  [2175] = {
    [anon_sym_EQ_GT] = ACTIONS(6235),
    [sym_comment] = ACTIONS(3),
  },
  [2176] = {
    [sym_formal_parameters] = STATE(3027),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2177] = {
    [anon_sym_AMP] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(6237),
    [anon_sym_PIPE] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
  },
  [2178] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3464),
    [anon_sym_BQUOTE] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3464),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_LT_LT] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_GT_GT_GT] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_LBRACE] = ACTIONS(3464),
    [anon_sym_BANG_EQ] = ACTIONS(3464),
    [anon_sym_LT_EQ] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3466),
    [anon_sym_RBRACK] = ACTIONS(3466),
    [anon_sym_GT_EQ] = ACTIONS(3466),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_AMP] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_QMARK] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(3466),
    [anon_sym_as] = ACTIONS(3466),
    [anon_sym_PIPE_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_DASH_DASH] = ACTIONS(3466),
    [anon_sym_EQ_EQ] = ACTIONS(3464),
    [anon_sym_instanceof] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_RPAREN] = ACTIONS(3466),
    [anon_sym_SLASH] = ACTIONS(3464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_DOT] = ACTIONS(3466),
    [anon_sym_CARET] = ACTIONS(3466),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_implements] = ACTIONS(3466),
    [anon_sym_GT_GT] = ACTIONS(3464),
    [anon_sym_PLUS_PLUS] = ACTIONS(3466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3466),
    [anon_sym_in] = ACTIONS(3464),
  },
  [2179] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2180] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2181] = {
    [anon_sym_EQ_GT] = ACTIONS(6239),
    [sym_comment] = ACTIONS(3),
  },
  [2182] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3032),
    [sym_constructor_type] = STATE(3032),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(3032),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3032),
    [sym_intersection_type] = STATE(3032),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2183] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3033),
    [sym_constructor_type] = STATE(3033),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(3033),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3033),
    [sym_intersection_type] = STATE(3033),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2184] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_BANG] = ACTIONS(3478),
    [anon_sym_BQUOTE] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3478),
    [anon_sym_COMMA] = ACTIONS(3480),
    [anon_sym_LT_LT] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_GT_GT_GT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3478),
    [anon_sym_BANG_EQ] = ACTIONS(3478),
    [anon_sym_LT_EQ] = ACTIONS(3480),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_RBRACK] = ACTIONS(3480),
    [anon_sym_GT_EQ] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [anon_sym_as] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_EQ_EQ] = ACTIONS(3478),
    [anon_sym_instanceof] = ACTIONS(3480),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_RPAREN] = ACTIONS(3480),
    [anon_sym_SLASH] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_CARET] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_implements] = ACTIONS(3480),
    [anon_sym_GT_GT] = ACTIONS(3478),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3480),
    [anon_sym_in] = ACTIONS(3478),
  },
  [2185] = {
    [anon_sym_RBRACK] = ACTIONS(6241),
    [sym_comment] = ACTIONS(3),
  },
  [2186] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3035),
    [sym_constructor_type] = STATE(3035),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(3035),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3035),
    [sym_intersection_type] = STATE(3035),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2187] = {
    [sym_new_expression] = STATE(1208),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1208),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1208),
    [sym_call_signature] = STATE(158),
    [sym_yield_expression] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(161),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(164),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(1208),
    [sym_subscript_expression] = STATE(161),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1208),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1208),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(1208),
    [sym_non_null_expression] = STATE(1208),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1208),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1208),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1208),
    [sym_call_expression] = STATE(1208),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1208),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1208),
    [sym_type_arguments] = STATE(166),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(1208),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1208),
    [sym_class] = STATE(1208),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(2613),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(2617),
    [anon_sym_number] = ACTIONS(2617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(2619),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2621),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(2625),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(2496),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2617),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(2617),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(2617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2496),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(6243),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(2621),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [2188] = {
    [sym_identifier] = ACTIONS(6245),
    [sym_comment] = ACTIONS(3),
  },
  [2189] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_AMP_EQ] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(929),
    [anon_sym_STAR_EQ] = ACTIONS(929),
    [anon_sym_PIPE_EQ] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
    [anon_sym_EQ_GT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(6247),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(937),
  },
  [2190] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2191] = {
    [sym_class_body] = STATE(3039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [2192] = {
    [sym_class_heritage] = STATE(3040),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(3039),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [2193] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5773),
    [anon_sym_LBRACK] = ACTIONS(5773),
    [anon_sym_BANG] = ACTIONS(5775),
    [anon_sym_BQUOTE] = ACTIONS(5773),
    [anon_sym_else] = ACTIONS(5773),
    [anon_sym_PIPE] = ACTIONS(5775),
    [anon_sym_COMMA] = ACTIONS(5773),
    [anon_sym_LT_LT] = ACTIONS(5773),
    [anon_sym_STAR] = ACTIONS(5775),
    [anon_sym_GT_GT_GT] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_DASH] = ACTIONS(5775),
    [anon_sym_LBRACE] = ACTIONS(5775),
    [anon_sym_BANG_EQ] = ACTIONS(5775),
    [anon_sym_LT_EQ] = ACTIONS(5773),
    [anon_sym_LPAREN] = ACTIONS(5773),
    [anon_sym_RBRACK] = ACTIONS(5773),
    [anon_sym_GT_EQ] = ACTIONS(5773),
    [anon_sym_GT] = ACTIONS(5775),
    [anon_sym_AMP] = ACTIONS(5775),
    [anon_sym_PERCENT] = ACTIONS(5773),
    [anon_sym_QMARK] = ACTIONS(5773),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [anon_sym_as] = ACTIONS(5773),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_while] = ACTIONS(5773),
    [anon_sym_DASH_DASH] = ACTIONS(5773),
    [anon_sym_EQ_EQ] = ACTIONS(5775),
    [anon_sym_instanceof] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5775),
    [anon_sym_RPAREN] = ACTIONS(5773),
    [anon_sym_SLASH] = ACTIONS(5775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5773),
    [anon_sym_COLON] = ACTIONS(5773),
    [anon_sym_DOT] = ACTIONS(5773),
    [anon_sym_CARET] = ACTIONS(5773),
    [anon_sym_STAR_STAR] = ACTIONS(5773),
    [anon_sym_PLUS] = ACTIONS(5775),
    [anon_sym_implements] = ACTIONS(5773),
    [anon_sym_GT_GT] = ACTIONS(5775),
    [anon_sym_PLUS_PLUS] = ACTIONS(5773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5773),
    [anon_sym_in] = ACTIONS(5775),
  },
  [2194] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5777),
    [anon_sym_LBRACK] = ACTIONS(5777),
    [anon_sym_BANG] = ACTIONS(5779),
    [anon_sym_BQUOTE] = ACTIONS(5777),
    [anon_sym_PIPE] = ACTIONS(5779),
    [anon_sym_COMMA] = ACTIONS(5777),
    [anon_sym_LT_LT] = ACTIONS(5777),
    [anon_sym_STAR] = ACTIONS(5779),
    [anon_sym_GT_GT_GT] = ACTIONS(5777),
    [anon_sym_AMP_AMP] = ACTIONS(5777),
    [anon_sym_DASH] = ACTIONS(5779),
    [anon_sym_LBRACE] = ACTIONS(5779),
    [anon_sym_BANG_EQ] = ACTIONS(5779),
    [anon_sym_LT_EQ] = ACTIONS(5777),
    [anon_sym_LPAREN] = ACTIONS(5777),
    [anon_sym_RBRACK] = ACTIONS(5777),
    [anon_sym_GT_EQ] = ACTIONS(5777),
    [anon_sym_GT] = ACTIONS(5779),
    [anon_sym_AMP] = ACTIONS(5779),
    [anon_sym_PERCENT] = ACTIONS(5777),
    [anon_sym_QMARK] = ACTIONS(5777),
    [anon_sym_RBRACE] = ACTIONS(5777),
    [anon_sym_as] = ACTIONS(5777),
    [anon_sym_PIPE_PIPE] = ACTIONS(5777),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5777),
    [anon_sym_DASH_DASH] = ACTIONS(5777),
    [anon_sym_EQ_EQ] = ACTIONS(5779),
    [anon_sym_instanceof] = ACTIONS(5777),
    [anon_sym_LT] = ACTIONS(5779),
    [anon_sym_RPAREN] = ACTIONS(5777),
    [anon_sym_SLASH] = ACTIONS(5779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5777),
    [anon_sym_DOT] = ACTIONS(5777),
    [anon_sym_CARET] = ACTIONS(5777),
    [anon_sym_STAR_STAR] = ACTIONS(5777),
    [anon_sym_PLUS] = ACTIONS(5779),
    [anon_sym_implements] = ACTIONS(5777),
    [anon_sym_GT_GT] = ACTIONS(5779),
    [anon_sym_PLUS_PLUS] = ACTIONS(5777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5777),
    [anon_sym_in] = ACTIONS(5779),
  },
  [2195] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [2196] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(2049),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2197] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(2053),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [2198] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [2199] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(6249),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2063),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6249),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_implements] = ACTIONS(6249),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2063),
  },
  [2200] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [2201] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2155),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(2155),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [2202] = {
    [sym_new_expression] = STATE(3041),
    [sym_augmented_assignment_expression] = STATE(3041),
    [sym_unary_expression] = STATE(3041),
    [sym_update_expression] = STATE(3041),
    [sym_regex] = STATE(3041),
    [sym_meta_property] = STATE(3041),
    [sym_call_signature] = STATE(598),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(3041),
    [sym_yield_expression] = STATE(3041),
    [sym_as_expression] = STATE(3041),
    [sym_non_null_expression] = STATE(3041),
    [sym_internal_module] = STATE(3041),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3041),
    [sym_await_expression] = STATE(3041),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(3041),
    [sym_this] = STATE(3041),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(3041),
    [sym_generator_function] = STATE(3041),
    [sym_call_expression] = STATE(3041),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(3041),
    [sym_ternary_expression] = STATE(3041),
    [sym_binary_expression] = STATE(3041),
    [sym_template_string] = STATE(3041),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3041),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(3041),
    [sym_class] = STATE(3041),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(6258),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6258),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6260),
    [sym_true] = ACTIONS(6258),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6258),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [2203] = {
    [sym_new_expression] = STATE(3042),
    [sym_augmented_assignment_expression] = STATE(3042),
    [sym_unary_expression] = STATE(3042),
    [sym_update_expression] = STATE(3042),
    [sym_regex] = STATE(3042),
    [sym_meta_property] = STATE(3042),
    [sym_call_signature] = STATE(598),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(3042),
    [sym_yield_expression] = STATE(3042),
    [sym_as_expression] = STATE(3042),
    [sym_non_null_expression] = STATE(3042),
    [sym_internal_module] = STATE(3042),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3042),
    [sym_await_expression] = STATE(3042),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(3042),
    [sym_this] = STATE(3042),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(3042),
    [sym_generator_function] = STATE(3042),
    [sym_call_expression] = STATE(3042),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(3042),
    [sym_ternary_expression] = STATE(3042),
    [sym_binary_expression] = STATE(3042),
    [sym_template_string] = STATE(3042),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3042),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(3042),
    [sym_class] = STATE(3042),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(6262),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6262),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6264),
    [sym_true] = ACTIONS(6262),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6262),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [2204] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3492),
    [anon_sym_LBRACK] = ACTIONS(3492),
    [anon_sym_BANG] = ACTIONS(3494),
    [anon_sym_BQUOTE] = ACTIONS(3492),
    [anon_sym_PIPE] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_LT_LT] = ACTIONS(3492),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_GT_GT_GT] = ACTIONS(3492),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3492),
    [anon_sym_GT_EQ] = ACTIONS(3492),
    [anon_sym_GT] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_QMARK] = ACTIONS(3492),
    [anon_sym_as] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3492),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_EQ_EQ] = ACTIONS(3494),
    [anon_sym_instanceof] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3494),
    [anon_sym_SLASH] = ACTIONS(3494),
    [sym_comment] = ACTIONS(3),
    [sym_regex_flags] = ACTIONS(4497),
    [anon_sym_DOT] = ACTIONS(3492),
    [anon_sym_CARET] = ACTIONS(3492),
    [anon_sym_STAR_STAR] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_implements] = ACTIONS(3494),
    [anon_sym_GT_GT] = ACTIONS(3494),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3492),
    [anon_sym_in] = ACTIONS(3494),
  },
  [2205] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(2049),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [2206] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2663),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(6266),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(6266),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(6266),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2207] = {
    [anon_sym_implements] = ACTIONS(6266),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6266),
    [anon_sym_COMMA] = ACTIONS(6266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6268),
  },
  [2208] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_implements] = ACTIONS(2049),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2209] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_implements] = ACTIONS(2049),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2210] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(2049),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [2211] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2212] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(6275),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_implements] = ACTIONS(1475),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(6277),
  },
  [2213] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2214] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2215] = {
    [sym_formal_parameters] = STATE(3046),
    [sym_type_parameters] = STATE(3047),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2216] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2217] = {
    [sym_formal_parameters] = STATE(3050),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2218] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_implements] = ACTIONS(1577),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(6280),
  },
  [2219] = {
    [anon_sym_EQ_GT] = ACTIONS(6283),
    [sym_comment] = ACTIONS(3),
  },
  [2220] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2650),
    [anon_sym_AMP_EQ] = ACTIONS(2650),
    [anon_sym_PLUS_EQ] = ACTIONS(2650),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_CARET_EQ] = ACTIONS(2650),
    [anon_sym_STAR_EQ] = ACTIONS(2650),
    [anon_sym_PIPE_EQ] = ACTIONS(2650),
    [anon_sym_DASH_EQ] = ACTIONS(2650),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2650),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2650),
    [anon_sym_GT_GT_EQ] = ACTIONS(2650),
    [anon_sym_DOT] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6285),
  },
  [2221] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2665),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_AMP_EQ] = ACTIONS(2665),
    [anon_sym_PLUS_EQ] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(2665),
    [anon_sym_STAR_EQ] = ACTIONS(2665),
    [anon_sym_PIPE_EQ] = ACTIONS(2665),
    [anon_sym_DASH_EQ] = ACTIONS(2665),
    [anon_sym_EQ_GT] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2665),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2665),
    [anon_sym_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2222] = {
    [sym_new_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_non_null_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(1293),
    [sym_this] = STATE(1293),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(1293),
    [sym_generator_function] = STATE(1293),
    [sym_call_expression] = STATE(1293),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(1293),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_template_string] = STATE(1293),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1293),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(1293),
    [sym_class] = STATE(1293),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(6287),
    [sym_false] = ACTIONS(2671),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2671),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2673),
    [sym_true] = ACTIONS(2671),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2671),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [2223] = {
    [sym_new_expression] = STATE(1294),
    [sym_augmented_assignment_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1294),
    [sym_update_expression] = STATE(1294),
    [sym_regex] = STATE(1294),
    [sym_meta_property] = STATE(1294),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1294),
    [sym_as_expression] = STATE(1294),
    [sym_non_null_expression] = STATE(1294),
    [sym_internal_module] = STATE(1294),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1294),
    [sym_await_expression] = STATE(1294),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(1294),
    [sym_this] = STATE(1294),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(1294),
    [sym_generator_function] = STATE(1294),
    [sym_call_expression] = STATE(1294),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(1294),
    [sym_ternary_expression] = STATE(1294),
    [sym_binary_expression] = STATE(1294),
    [sym_template_string] = STATE(1294),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1294),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(1294),
    [sym_class] = STATE(1294),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(2675),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2675),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(2675),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2675),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [2224] = {
    [sym_new_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_non_null_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(1293),
    [sym_this] = STATE(1293),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(1293),
    [sym_generator_function] = STATE(1293),
    [sym_call_expression] = STATE(1293),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(1293),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_template_string] = STATE(1293),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1293),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(1293),
    [sym_class] = STATE(1293),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2665),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_AMP_EQ] = ACTIONS(2665),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2665),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2665),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_PIPE_EQ] = ACTIONS(2665),
    [anon_sym_DASH_EQ] = ACTIONS(2665),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2665),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(1095),
    [sym_true] = ACTIONS(2671),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2671),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2665),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2671),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_STAR_EQ] = ACTIONS(2665),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_EQ_GT] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2673),
    [anon_sym_SLASH] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2665),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2671),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_implements] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2225] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2693),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2695),
    [anon_sym_symbol] = ACTIONS(2695),
    [anon_sym_number] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2695),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2697),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2695),
    [anon_sym_private] = ACTIONS(2695),
    [anon_sym_boolean] = ACTIONS(2695),
    [anon_sym_async] = ACTIONS(2699),
    [anon_sym_public] = ACTIONS(2695),
    [anon_sym_get] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2695),
    [anon_sym_string] = ACTIONS(2695),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2695),
    [anon_sym_type] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(2695),
    [anon_sym_export] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [2226] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_implements] = ACTIONS(2049),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2227] = {
    [aux_sym_extends_clause_repeat1] = STATE(2227),
    [anon_sym_implements] = ACTIONS(6266),
    [anon_sym_COMMA] = ACTIONS(6289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6266),
  },
  [2228] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2229] = {
    [sym_formal_parameters] = STATE(3055),
    [sym_type_parameters] = STATE(3056),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2230] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2231] = {
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(6292),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COMMA] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5196),
  },
  [2232] = {
    [sym_formal_parameters] = STATE(3059),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2233] = {
    [anon_sym_EQ_GT] = ACTIONS(6296),
    [sym_comment] = ACTIONS(3),
  },
  [2234] = {
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(6292),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COMMA] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5204),
  },
  [2235] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3061),
    [sym_constructor_type] = STATE(3061),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(3061),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3061),
    [sym_intersection_type] = STATE(3061),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(612),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(614),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2236] = {
    [anon_sym_EQ_GT] = ACTIONS(6298),
    [sym_comment] = ACTIONS(3),
  },
  [2237] = {
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_COMMA] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5399),
  },
  [2238] = {
    [aux_sym_implements_clause_repeat1] = STATE(2238),
    [anon_sym_COMMA] = ACTIONS(6300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5399),
  },
  [2239] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3063),
    [sym_constructor_type] = STATE(3063),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(3063),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3063),
    [sym_intersection_type] = STATE(3063),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(612),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(614),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2240] = {
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(6292),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COMMA] = ACTIONS(5406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5406),
  },
  [2241] = {
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5425),
  },
  [2242] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6303),
    [sym_identifier] = ACTIONS(6305),
    [sym__automatic_semicolon] = ACTIONS(6303),
    [anon_sym_BQUOTE] = ACTIONS(6303),
    [anon_sym_debugger] = ACTIONS(6305),
    [ts_builtin_sym_end] = ACTIONS(6303),
    [anon_sym_symbol] = ACTIONS(6305),
    [anon_sym_AT] = ACTIONS(6303),
    [anon_sym_PIPE] = ACTIONS(6305),
    [anon_sym_COMMA] = ACTIONS(6303),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_STAR] = ACTIONS(6305),
    [anon_sym_GT_GT_GT] = ACTIONS(6303),
    [anon_sym_void] = ACTIONS(6305),
    [anon_sym_break] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6305),
    [anon_sym_const] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6303),
    [sym_super] = ACTIONS(6305),
    [anon_sym_return] = ACTIONS(6305),
    [anon_sym_private] = ACTIONS(6305),
    [anon_sym_get] = ACTIONS(6305),
    [anon_sym_RBRACE] = ACTIONS(6303),
    [anon_sym_PERCENT] = ACTIONS(6303),
    [anon_sym_interface] = ACTIONS(6305),
    [anon_sym_default] = ACTIONS(6305),
    [anon_sym_as] = ACTIONS(6305),
    [anon_sym_delete] = ACTIONS(6305),
    [anon_sym_continue] = ACTIONS(6305),
    [anon_sym_DASH_DASH] = ACTIONS(6303),
    [anon_sym_if] = ACTIONS(6305),
    [anon_sym_instanceof] = ACTIONS(6305),
    [anon_sym_this] = ACTIONS(6305),
    [anon_sym_yield] = ACTIONS(6305),
    [sym_true] = ACTIONS(6305),
    [anon_sym_throw] = ACTIONS(6305),
    [anon_sym_enum] = ACTIONS(6305),
    [anon_sym_protected] = ACTIONS(6305),
    [anon_sym_abstract] = ACTIONS(6305),
    [anon_sym_DOT] = ACTIONS(6305),
    [anon_sym_set] = ACTIONS(6305),
    [anon_sym_type] = ACTIONS(6305),
    [anon_sym_STAR_STAR] = ACTIONS(6303),
    [anon_sym_import] = ACTIONS(6305),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6303),
    [anon_sym_namespace] = ACTIONS(6305),
    [anon_sym_PLUS_PLUS] = ACTIONS(6303),
    [anon_sym_await] = ACTIONS(6305),
    [anon_sym_DQUOTE] = ACTIONS(6303),
    [anon_sym_else] = ACTIONS(6305),
    [anon_sym_BANG] = ACTIONS(6305),
    [anon_sym_for] = ACTIONS(6305),
    [anon_sym_LBRACK] = ACTIONS(6303),
    [sym_false] = ACTIONS(6305),
    [anon_sym_SEMI] = ACTIONS(6303),
    [anon_sym_case] = ACTIONS(6305),
    [anon_sym_module] = ACTIONS(6305),
    [anon_sym_number] = ACTIONS(6305),
    [anon_sym_class] = ACTIONS(6305),
    [anon_sym_declare] = ACTIONS(6305),
    [anon_sym_typeof] = ACTIONS(6305),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_LBRACE] = ACTIONS(6303),
    [anon_sym_AMP_AMP] = ACTIONS(6303),
    [anon_sym_switch] = ACTIONS(6305),
    [anon_sym_LT_EQ] = ACTIONS(6303),
    [anon_sym_LPAREN] = ACTIONS(6303),
    [sym_null] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_any] = ACTIONS(6305),
    [anon_sym_boolean] = ACTIONS(6305),
    [anon_sym_async] = ACTIONS(6305),
    [anon_sym_public] = ACTIONS(6305),
    [anon_sym_AMP] = ACTIONS(6305),
    [anon_sym_var] = ACTIONS(6305),
    [anon_sym_QMARK] = ACTIONS(6303),
    [anon_sym_PIPE_PIPE] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_SQUOTE] = ACTIONS(6303),
    [anon_sym_try] = ACTIONS(6305),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_RPAREN] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [sym_number] = ACTIONS(6303),
    [anon_sym_SLASH] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6305),
    [anon_sym_function] = ACTIONS(6305),
    [sym_undefined] = ACTIONS(6305),
    [anon_sym_new] = ACTIONS(6305),
    [anon_sym_CARET] = ACTIONS(6303),
    [anon_sym_let] = ACTIONS(6305),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_export] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(6305),
    [anon_sym_TILDE] = ACTIONS(6303),
    [anon_sym_with] = ACTIONS(6305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6303),
    [anon_sym_in] = ACTIONS(6305),
  },
  [2243] = {
    [sym_new_expression] = STATE(3064),
    [sym_augmented_assignment_expression] = STATE(3064),
    [sym_unary_expression] = STATE(3064),
    [sym_update_expression] = STATE(3064),
    [sym_regex] = STATE(3064),
    [sym_meta_property] = STATE(3064),
    [sym_call_signature] = STATE(1340),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(3064),
    [sym_yield_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_non_null_expression] = STATE(3064),
    [sym_internal_module] = STATE(3064),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3064),
    [sym_await_expression] = STATE(3064),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3064),
    [sym_this] = STATE(3064),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3064),
    [sym_generator_function] = STATE(3064),
    [sym_call_expression] = STATE(3064),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3064),
    [sym_ternary_expression] = STATE(3064),
    [sym_binary_expression] = STATE(3064),
    [sym_template_string] = STATE(3064),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3064),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3064),
    [sym_class] = STATE(3064),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6307),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6307),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6309),
    [sym_true] = ACTIONS(6307),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6307),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2244] = {
    [sym_new_expression] = STATE(3074),
    [sym_constructor_type] = STATE(3073),
    [sym_augmented_assignment_expression] = STATE(3074),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3074),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3074),
    [sym_call_signature] = STATE(1340),
    [sym_yield_expression] = STATE(3074),
    [sym_as_expression] = STATE(3074),
    [sym_internal_module] = STATE(3074),
    [sym_arrow_function] = STATE(3074),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(1342),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1642),
    [sym_type_parameters] = STATE(3071),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(1344),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_generator_function] = STATE(3074),
    [sym_subscript_expression] = STATE(1342),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3074),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3074),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3072),
    [sym_intersection_type] = STATE(3073),
    [sym__type] = STATE(3073),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3074),
    [sym_meta_property] = STATE(3074),
    [sym_function_type] = STATE(3073),
    [sym__expression] = STATE(3074),
    [sym_non_null_expression] = STATE(3074),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(3074),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3074),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(3074),
    [sym_call_expression] = STATE(3074),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3074),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3074),
    [sym_type_arguments] = STATE(1346),
    [sym_union_type] = STATE(3073),
    [sym_parenthesized_expression] = STATE(3074),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3074),
    [sym_class] = STATE(3074),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(6311),
    [sym_false] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(6313),
    [anon_sym_number] = ACTIONS(6313),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(6315),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6317),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(6321),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6313),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(6313),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(3405),
    [sym_number] = ACTIONS(3411),
    [sym_true] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(6313),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6321),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(6323),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(6317),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2245] = {
    [sym_new_expression] = STATE(3075),
    [sym_augmented_assignment_expression] = STATE(3075),
    [sym_unary_expression] = STATE(3075),
    [sym_update_expression] = STATE(3075),
    [sym_regex] = STATE(3075),
    [sym_meta_property] = STATE(3075),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(3075),
    [sym_yield_expression] = STATE(3075),
    [sym_as_expression] = STATE(3075),
    [sym_non_null_expression] = STATE(3075),
    [sym_internal_module] = STATE(3075),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3075),
    [sym_await_expression] = STATE(3075),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3075),
    [sym_this] = STATE(3075),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3075),
    [sym_generator_function] = STATE(3075),
    [sym_call_expression] = STATE(3075),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3075),
    [sym_ternary_expression] = STATE(3075),
    [sym_binary_expression] = STATE(3075),
    [sym_template_string] = STATE(3075),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3075),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3075),
    [sym_class] = STATE(3075),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6325),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6325),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6327),
    [sym_true] = ACTIONS(6325),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6325),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2246] = {
    [sym_new_expression] = STATE(3076),
    [sym_augmented_assignment_expression] = STATE(3076),
    [sym_unary_expression] = STATE(3076),
    [sym_update_expression] = STATE(3076),
    [sym_regex] = STATE(3076),
    [sym_meta_property] = STATE(3076),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(3076),
    [sym_yield_expression] = STATE(3076),
    [sym_as_expression] = STATE(3076),
    [sym_non_null_expression] = STATE(3076),
    [sym_internal_module] = STATE(3076),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3076),
    [sym_await_expression] = STATE(3076),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3076),
    [sym_this] = STATE(3076),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3076),
    [sym_generator_function] = STATE(3076),
    [sym_call_expression] = STATE(3076),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3076),
    [sym_ternary_expression] = STATE(3076),
    [sym_binary_expression] = STATE(3076),
    [sym_template_string] = STATE(3076),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3076),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3076),
    [sym_class] = STATE(3076),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6329),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6329),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6331),
    [sym_true] = ACTIONS(6329),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6329),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2247] = {
    [sym_predefined_type] = STATE(3077),
    [anon_sym_number] = ACTIONS(6333),
    [anon_sym_void] = ACTIONS(6333),
    [anon_sym_string] = ACTIONS(6333),
    [anon_sym_any] = ACTIONS(6333),
    [anon_sym_boolean] = ACTIONS(6333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_symbol] = ACTIONS(6333),
  },
  [2248] = {
    [sym_identifier] = ACTIONS(6335),
    [sym_comment] = ACTIONS(3),
  },
  [2249] = {
    [sym_new_expression] = STATE(3079),
    [sym_augmented_assignment_expression] = STATE(3079),
    [sym_unary_expression] = STATE(3079),
    [sym_update_expression] = STATE(3079),
    [sym_regex] = STATE(3079),
    [sym_meta_property] = STATE(3079),
    [sym_call_signature] = STATE(1340),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(3079),
    [sym_yield_expression] = STATE(3079),
    [sym_as_expression] = STATE(3079),
    [sym_non_null_expression] = STATE(3079),
    [sym_internal_module] = STATE(3079),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3079),
    [sym_await_expression] = STATE(3079),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3079),
    [sym_this] = STATE(3079),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3079),
    [sym_generator_function] = STATE(3079),
    [sym_call_expression] = STATE(3079),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3079),
    [sym_ternary_expression] = STATE(3079),
    [sym_binary_expression] = STATE(3079),
    [sym_template_string] = STATE(3079),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3079),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3079),
    [sym_class] = STATE(3079),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6337),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6337),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6339),
    [sym_true] = ACTIONS(6337),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6337),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2250] = {
    [sym_new_expression] = STATE(3080),
    [sym_augmented_assignment_expression] = STATE(3080),
    [sym_unary_expression] = STATE(3080),
    [sym_update_expression] = STATE(3080),
    [sym_regex] = STATE(3080),
    [sym_meta_property] = STATE(3080),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(3080),
    [sym_yield_expression] = STATE(3080),
    [sym_as_expression] = STATE(3080),
    [sym_non_null_expression] = STATE(3080),
    [sym_internal_module] = STATE(3080),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3080),
    [sym_await_expression] = STATE(3080),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3080),
    [sym_this] = STATE(3080),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3080),
    [sym_generator_function] = STATE(3080),
    [sym_call_expression] = STATE(3080),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3080),
    [sym_ternary_expression] = STATE(3080),
    [sym_binary_expression] = STATE(3080),
    [sym_template_string] = STATE(3080),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3080),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3080),
    [sym_class] = STATE(3080),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6341),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6341),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6343),
    [sym_true] = ACTIONS(6341),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6341),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2251] = {
    [sym_predefined_type] = STATE(3081),
    [anon_sym_number] = ACTIONS(6333),
    [anon_sym_void] = ACTIONS(6333),
    [anon_sym_string] = ACTIONS(6333),
    [anon_sym_any] = ACTIONS(6333),
    [anon_sym_boolean] = ACTIONS(6333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_symbol] = ACTIONS(6333),
  },
  [2252] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(6345),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [2253] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(6345),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [2254] = {
    [anon_sym_EQ_GT] = ACTIONS(6348),
    [sym_comment] = ACTIONS(3),
  },
  [2255] = {
    [anon_sym_EQ_GT] = ACTIONS(6350),
    [sym_comment] = ACTIONS(3),
  },
  [2256] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_RBRACK] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [2257] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [2258] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_RBRACK] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [2259] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_RBRACK] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2260] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_RBRACK] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2261] = {
    [sym_call_signature] = STATE(2254),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(4689),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(4689),
    [anon_sym_type] = ACTIONS(4689),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(4689),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(4689),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(4689),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(4689),
    [anon_sym_declare] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_RBRACK] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(4689),
    [anon_sym_async] = ACTIONS(4689),
    [anon_sym_public] = ACTIONS(4689),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(4689),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(4689),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2262] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_RBRACK] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2263] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [2264] = {
    [sym_new_expression] = STATE(3074),
    [sym_augmented_assignment_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym_update_expression] = STATE(3074),
    [sym_regex] = STATE(3074),
    [sym_meta_property] = STATE(3074),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(3074),
    [sym_yield_expression] = STATE(3074),
    [sym_as_expression] = STATE(3074),
    [sym_non_null_expression] = STATE(3074),
    [sym_internal_module] = STATE(3074),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3074),
    [sym_await_expression] = STATE(3074),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3074),
    [sym_this] = STATE(3074),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3074),
    [sym_generator_function] = STATE(3074),
    [sym_call_expression] = STATE(3074),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3074),
    [sym_ternary_expression] = STATE(3074),
    [sym_binary_expression] = STATE(3074),
    [sym_template_string] = STATE(3074),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3074),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3074),
    [sym_class] = STATE(3074),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6321),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6321),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6352),
    [sym_true] = ACTIONS(6321),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6321),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2265] = {
    [sym_new_expression] = STATE(3084),
    [sym_augmented_assignment_expression] = STATE(3084),
    [sym_unary_expression] = STATE(3084),
    [sym_update_expression] = STATE(3084),
    [sym_regex] = STATE(3084),
    [sym_meta_property] = STATE(3084),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(3084),
    [sym_yield_expression] = STATE(3084),
    [sym_as_expression] = STATE(3084),
    [sym_non_null_expression] = STATE(3084),
    [sym_internal_module] = STATE(3084),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3084),
    [sym_await_expression] = STATE(3084),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3084),
    [sym_this] = STATE(3084),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3084),
    [sym_generator_function] = STATE(3084),
    [sym_call_expression] = STATE(3084),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3084),
    [sym_ternary_expression] = STATE(3084),
    [sym_binary_expression] = STATE(3084),
    [sym_template_string] = STATE(3084),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3084),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3084),
    [sym_class] = STATE(3084),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6354),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6354),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6356),
    [sym_true] = ACTIONS(6354),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6354),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2266] = {
    [sym_new_expression] = STATE(3085),
    [sym_augmented_assignment_expression] = STATE(3085),
    [sym_unary_expression] = STATE(3085),
    [sym_update_expression] = STATE(3085),
    [sym_regex] = STATE(3085),
    [sym_meta_property] = STATE(3085),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(3085),
    [sym_yield_expression] = STATE(3085),
    [sym_as_expression] = STATE(3085),
    [sym_non_null_expression] = STATE(3085),
    [sym_internal_module] = STATE(3085),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3085),
    [sym_await_expression] = STATE(3085),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3085),
    [sym_this] = STATE(3085),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3085),
    [sym_generator_function] = STATE(3085),
    [sym_call_expression] = STATE(3085),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3085),
    [sym_ternary_expression] = STATE(3085),
    [sym_binary_expression] = STATE(3085),
    [sym_template_string] = STATE(3085),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3085),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3085),
    [sym_class] = STATE(3085),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6358),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6360),
    [sym_true] = ACTIONS(6358),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6358),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2267] = {
    [sym_new_expression] = STATE(3086),
    [sym_augmented_assignment_expression] = STATE(3086),
    [sym_unary_expression] = STATE(3086),
    [sym_update_expression] = STATE(3086),
    [sym_regex] = STATE(3086),
    [sym_meta_property] = STATE(3086),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(3086),
    [sym_yield_expression] = STATE(3086),
    [sym_as_expression] = STATE(3086),
    [sym_non_null_expression] = STATE(3086),
    [sym_internal_module] = STATE(3086),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3086),
    [sym_await_expression] = STATE(3086),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3086),
    [sym_this] = STATE(3086),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3086),
    [sym_generator_function] = STATE(3086),
    [sym_call_expression] = STATE(3086),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3086),
    [sym_ternary_expression] = STATE(3086),
    [sym_binary_expression] = STATE(3086),
    [sym_template_string] = STATE(3086),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3086),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3086),
    [sym_class] = STATE(3086),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6362),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6364),
    [sym_true] = ACTIONS(6362),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6362),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2268] = {
    [sym_new_expression] = STATE(3087),
    [sym_augmented_assignment_expression] = STATE(3087),
    [sym_unary_expression] = STATE(3087),
    [sym_update_expression] = STATE(3087),
    [sym_regex] = STATE(3087),
    [sym_meta_property] = STATE(3087),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(3087),
    [sym_yield_expression] = STATE(3087),
    [sym_as_expression] = STATE(3087),
    [sym_non_null_expression] = STATE(3087),
    [sym_internal_module] = STATE(3087),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3087),
    [sym_await_expression] = STATE(3087),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3087),
    [sym_this] = STATE(3087),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3087),
    [sym_generator_function] = STATE(3087),
    [sym_call_expression] = STATE(3087),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3087),
    [sym_ternary_expression] = STATE(3087),
    [sym_binary_expression] = STATE(3087),
    [sym_template_string] = STATE(3087),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3087),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3087),
    [sym_class] = STATE(3087),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6366),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6366),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6368),
    [sym_true] = ACTIONS(6366),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6366),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2269] = {
    [anon_sym_EQ] = ACTIONS(4970),
    [anon_sym_COLON] = ACTIONS(4970),
    [sym__automatic_semicolon] = ACTIONS(4970),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4970),
    [anon_sym_LPAREN] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4970),
    [anon_sym_LT] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(4970),
  },
  [2270] = {
    [sym_new_expression] = STATE(3088),
    [sym_augmented_assignment_expression] = STATE(3088),
    [sym_unary_expression] = STATE(3088),
    [sym_update_expression] = STATE(3088),
    [sym_regex] = STATE(3088),
    [sym_meta_property] = STATE(3088),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(3088),
    [sym_yield_expression] = STATE(3088),
    [sym_as_expression] = STATE(3088),
    [sym_non_null_expression] = STATE(3088),
    [sym_internal_module] = STATE(3088),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3088),
    [sym_await_expression] = STATE(3088),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(3088),
    [sym_this] = STATE(3088),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(3088),
    [sym_generator_function] = STATE(3088),
    [sym_call_expression] = STATE(3088),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(3088),
    [sym_ternary_expression] = STATE(3088),
    [sym_binary_expression] = STATE(3088),
    [sym_template_string] = STATE(3088),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3088),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(3088),
    [sym_class] = STATE(3088),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6370),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6372),
    [sym_true] = ACTIONS(6370),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6370),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [2271] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(6376),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [2272] = {
    [sym_new_expression] = STATE(3074),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(3074),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3074),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3074),
    [sym_call_signature] = STATE(1340),
    [sym_yield_expression] = STATE(3074),
    [sym_as_expression] = STATE(3074),
    [sym_internal_module] = STATE(3074),
    [sym_arrow_function] = STATE(3074),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(1342),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1738),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(1344),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(3074),
    [sym_subscript_expression] = STATE(1342),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3074),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3074),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3074),
    [sym_meta_property] = STATE(3074),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(3074),
    [sym_non_null_expression] = STATE(3074),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(3074),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3074),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(3074),
    [sym_call_expression] = STATE(3074),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3074),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3074),
    [sym_type_arguments] = STATE(1346),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(3074),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3074),
    [sym_class] = STATE(3074),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(6384),
    [sym_false] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(6386),
    [anon_sym_number] = ACTIONS(6386),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(6388),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6390),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(6392),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(6321),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6386),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(6386),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(3597),
    [sym_number] = ACTIONS(3599),
    [sym_true] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(6386),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6321),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(6394),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(6390),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2273] = {
    [sym_new_expression] = STATE(3103),
    [sym_augmented_assignment_expression] = STATE(3103),
    [sym_unary_expression] = STATE(3103),
    [sym_update_expression] = STATE(3103),
    [sym_regex] = STATE(3103),
    [sym_meta_property] = STATE(3103),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(3103),
    [sym_yield_expression] = STATE(3103),
    [sym_as_expression] = STATE(3103),
    [sym_non_null_expression] = STATE(3103),
    [sym_internal_module] = STATE(3103),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3103),
    [sym_await_expression] = STATE(3103),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3103),
    [sym_this] = STATE(3103),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3103),
    [sym_generator_function] = STATE(3103),
    [sym_call_expression] = STATE(3103),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3103),
    [sym_ternary_expression] = STATE(3103),
    [sym_binary_expression] = STATE(3103),
    [sym_template_string] = STATE(3103),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3103),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3103),
    [sym_class] = STATE(3103),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(6396),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6396),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6398),
    [sym_true] = ACTIONS(6396),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6396),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [2274] = {
    [sym_type_annotation] = STATE(3105),
    [anon_sym_COLON] = ACTIONS(6400),
    [sym_comment] = ACTIONS(3),
  },
  [2275] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3106),
    [sym_constructor_type] = STATE(3106),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(3106),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3106),
    [sym_intersection_type] = STATE(3106),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2276] = {
    [sym_call_signature] = STATE(3107),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2277] = {
    [sym_statement_block] = STATE(3108),
    [sym__automatic_semicolon] = ACTIONS(6402),
    [anon_sym_SEMI] = ACTIONS(6402),
    [anon_sym_COMMA] = ACTIONS(6402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4779),
  },
  [2278] = {
    [sym_call_signature] = STATE(3107),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [2279] = {
    [sym_string] = STATE(3110),
    [sym__property_name] = STATE(3110),
    [sym_computed_property_name] = STATE(3110),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [2280] = {
    [sym_string] = STATE(3110),
    [sym__property_name] = STATE(3110),
    [sym_computed_property_name] = STATE(3110),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(6406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2281] = {
    [sym_string] = STATE(3110),
    [sym__property_name] = STATE(3110),
    [sym_computed_property_name] = STATE(3110),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(6410),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(6410),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [2282] = {
    [sym_call_signature] = STATE(3107),
    [sym__initializer] = STATE(3115),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [sym_type_annotation] = STATE(3116),
    [sym__automatic_semicolon] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(6412),
    [anon_sym_QMARK] = ACTIONS(6414),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(6412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(6416),
  },
  [2283] = {
    [sym_string] = STATE(3110),
    [sym__property_name] = STATE(3110),
    [sym_computed_property_name] = STATE(3110),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2284] = {
    [sym_call_signature] = STATE(3107),
    [sym__initializer] = STATE(3115),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [sym_type_annotation] = STATE(3116),
    [sym__automatic_semicolon] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(6412),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(6412),
    [sym_comment] = ACTIONS(3),
  },
  [2285] = {
    [sym__initializer] = STATE(3115),
    [sym_type_annotation] = STATE(3116),
    [sym__automatic_semicolon] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [sym_comment] = ACTIONS(3),
  },
  [2286] = {
    [sym__automatic_semicolon] = ACTIONS(6412),
    [anon_sym_SEMI] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [sym_comment] = ACTIONS(3),
  },
  [2287] = {
    [sym__initializer] = STATE(3115),
    [sym__automatic_semicolon] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [sym_comment] = ACTIONS(3),
  },
  [2288] = {
    [sym__automatic_semicolon] = ACTIONS(2461),
    [anon_sym_RBRACE] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [anon_sym_SEMI] = ACTIONS(2461),
    [anon_sym_QMARK] = ACTIONS(2461),
    [anon_sym_AMP] = ACTIONS(2461),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_PIPE] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_EQ] = ACTIONS(2461),
    [anon_sym_COLON] = ACTIONS(2461),
    [anon_sym_LPAREN] = ACTIONS(2461),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2461),
    [anon_sym_BANG] = ACTIONS(2461),
  },
  [2289] = {
    [sym_call_signature] = STATE(3118),
    [sym_formal_parameters] = STATE(2293),
    [sym_type_parameters] = STATE(2294),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(6418),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [2290] = {
    [sym__initializer] = STATE(3115),
    [sym_type_annotation] = STATE(3116),
    [sym__automatic_semicolon] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(6412),
    [anon_sym_QMARK] = ACTIONS(6416),
    [anon_sym_COMMA] = ACTIONS(6412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(6416),
  },
  [2291] = {
    [sym_call_signature] = STATE(3118),
    [sym__initializer] = STATE(3115),
    [sym_formal_parameters] = STATE(2293),
    [sym_type_parameters] = STATE(2294),
    [sym_type_annotation] = STATE(3116),
    [sym__automatic_semicolon] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(6412),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(6412),
    [sym_comment] = ACTIONS(3),
  },
  [2292] = {
    [sym__automatic_semicolon] = ACTIONS(6420),
    [anon_sym_SEMI] = ACTIONS(6420),
    [anon_sym_COMMA] = ACTIONS(6420),
    [sym_comment] = ACTIONS(3),
  },
  [2293] = {
    [sym_type_annotation] = STATE(1618),
    [sym__automatic_semicolon] = ACTIONS(570),
    [anon_sym_COLON] = ACTIONS(6400),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_COMMA] = ACTIONS(570),
    [sym_comment] = ACTIONS(3),
  },
  [2294] = {
    [sym_formal_parameters] = STATE(3119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [2295] = {
    [sym_type_alias_declaration] = STATE(3121),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3121),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3121),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3121),
    [sym_return_statement] = STATE(3121),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3121),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3121),
    [sym_switch_statement] = STATE(3121),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3121),
    [sym_throw_statement] = STATE(3121),
    [aux_sym_program_repeat1] = STATE(3121),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3121),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3121),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(3121),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3121),
    [sym_abstract_class] = STATE(3121),
    [sym_interface_declaration] = STATE(3121),
    [sym_statement_block] = STATE(3121),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3121),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3121),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3121),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3121),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3121),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3121),
    [sym_empty_statement] = STATE(3121),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(3121),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3121),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3121),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3121),
    [sym_break_statement] = STATE(3121),
    [sym_labeled_statement] = STATE(3121),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3121),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(6422),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [2296] = {
    [sym__automatic_semicolon] = ACTIONS(4982),
    [anon_sym_LBRACK] = ACTIONS(4982),
    [sym_identifier] = ACTIONS(6424),
    [anon_sym_SEMI] = ACTIONS(4982),
    [anon_sym_module] = ACTIONS(6424),
    [anon_sym_symbol] = ACTIONS(6424),
    [anon_sym_number] = ACTIONS(6424),
    [anon_sym_AT] = ACTIONS(4982),
    [anon_sym_declare] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_void] = ACTIONS(6424),
    [anon_sym_any] = ACTIONS(6424),
    [anon_sym_private] = ACTIONS(6424),
    [anon_sym_boolean] = ACTIONS(6424),
    [anon_sym_async] = ACTIONS(6424),
    [anon_sym_public] = ACTIONS(6424),
    [anon_sym_get] = ACTIONS(6424),
    [anon_sym_RBRACE] = ACTIONS(4982),
    [anon_sym_static] = ACTIONS(6424),
    [anon_sym_SQUOTE] = ACTIONS(4982),
    [sym_number] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(6424),
    [anon_sym_string] = ACTIONS(6424),
    [anon_sym_abstract] = ACTIONS(6424),
    [anon_sym_set] = ACTIONS(6424),
    [anon_sym_type] = ACTIONS(6424),
    [anon_sym_import] = ACTIONS(6424),
    [anon_sym_export] = ACTIONS(6424),
    [anon_sym_namespace] = ACTIONS(6424),
    [sym_readonly] = ACTIONS(6424),
    [anon_sym_DQUOTE] = ACTIONS(4982),
  },
  [2297] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(3127),
    [sym_constructor_type] = STATE(3127),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(3127),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(3127),
    [sym_intersection_type] = STATE(3127),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3128),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3130),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2298] = {
    [sym_type_annotation] = STATE(2545),
    [sym__automatic_semicolon] = ACTIONS(1739),
    [anon_sym_COLON] = ACTIONS(4781),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_COMMA] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1739),
  },
  [2299] = {
    [sym_string] = STATE(3133),
    [sym__property_name] = STATE(3133),
    [sym_computed_property_name] = STATE(3133),
    [anon_sym_get] = ACTIONS(6436),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(6438),
    [anon_sym_STAR] = ACTIONS(6408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(6436),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(6440),
  },
  [2300] = {
    [sym_string] = STATE(3134),
    [sym__property_name] = STATE(3134),
    [sym_computed_property_name] = STATE(3134),
    [anon_sym_get] = ACTIONS(1119),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(6442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1119),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1119),
  },
  [2301] = {
    [sym_string] = STATE(3135),
    [sym__property_name] = STATE(3135),
    [sym_computed_property_name] = STATE(3135),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [2302] = {
    [sym_string] = STATE(3135),
    [sym__property_name] = STATE(3135),
    [sym_computed_property_name] = STATE(3135),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(6444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2303] = {
    [sym_call_signature] = STATE(3118),
    [sym__initializer] = STATE(3115),
    [sym_formal_parameters] = STATE(2293),
    [sym_type_parameters] = STATE(2294),
    [sym_type_annotation] = STATE(3116),
    [sym__automatic_semicolon] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(6412),
    [anon_sym_QMARK] = ACTIONS(6446),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(6412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(6416),
  },
  [2304] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3142),
    [sym_constructor_type] = STATE(3142),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(3142),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3142),
    [sym_intersection_type] = STATE(3142),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2305] = {
    [sym_identifier] = ACTIONS(4659),
    [anon_sym_BQUOTE] = ACTIONS(4657),
    [anon_sym_debugger] = ACTIONS(4659),
    [anon_sym_symbol] = ACTIONS(4659),
    [anon_sym_AT] = ACTIONS(4657),
    [anon_sym_DASH] = ACTIONS(4659),
    [anon_sym_void] = ACTIONS(4659),
    [anon_sym_break] = ACTIONS(4659),
    [anon_sym_const] = ACTIONS(4659),
    [sym_super] = ACTIONS(4659),
    [anon_sym_return] = ACTIONS(4659),
    [anon_sym_private] = ACTIONS(4659),
    [anon_sym_get] = ACTIONS(4659),
    [anon_sym_RBRACE] = ACTIONS(4657),
    [anon_sym_interface] = ACTIONS(4659),
    [anon_sym_default] = ACTIONS(4659),
    [anon_sym_enum] = ACTIONS(4659),
    [anon_sym_delete] = ACTIONS(4659),
    [anon_sym_continue] = ACTIONS(4659),
    [anon_sym_DASH_DASH] = ACTIONS(4657),
    [anon_sym_if] = ACTIONS(4659),
    [anon_sym_this] = ACTIONS(4659),
    [anon_sym_yield] = ACTIONS(4659),
    [sym_true] = ACTIONS(4659),
    [anon_sym_throw] = ACTIONS(4659),
    [anon_sym_protected] = ACTIONS(4659),
    [anon_sym_abstract] = ACTIONS(4659),
    [anon_sym_set] = ACTIONS(4659),
    [anon_sym_type] = ACTIONS(4659),
    [anon_sym_import] = ACTIONS(4659),
    [anon_sym_namespace] = ACTIONS(4659),
    [anon_sym_PLUS_PLUS] = ACTIONS(4657),
    [anon_sym_await] = ACTIONS(4659),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_else] = ACTIONS(4659),
    [anon_sym_BANG] = ACTIONS(4657),
    [anon_sym_for] = ACTIONS(4659),
    [anon_sym_LBRACK] = ACTIONS(4657),
    [sym_false] = ACTIONS(4659),
    [anon_sym_SEMI] = ACTIONS(4657),
    [anon_sym_case] = ACTIONS(4659),
    [anon_sym_module] = ACTIONS(4659),
    [anon_sym_number] = ACTIONS(4659),
    [anon_sym_class] = ACTIONS(4659),
    [anon_sym_declare] = ACTIONS(4659),
    [anon_sym_typeof] = ACTIONS(4659),
    [anon_sym_LBRACE] = ACTIONS(4657),
    [anon_sym_switch] = ACTIONS(4659),
    [anon_sym_LPAREN] = ACTIONS(4657),
    [sym_null] = ACTIONS(4659),
    [anon_sym_any] = ACTIONS(4659),
    [anon_sym_boolean] = ACTIONS(4659),
    [anon_sym_async] = ACTIONS(4659),
    [anon_sym_public] = ACTIONS(4659),
    [anon_sym_var] = ACTIONS(4659),
    [anon_sym_while] = ACTIONS(4659),
    [anon_sym_SQUOTE] = ACTIONS(4657),
    [anon_sym_try] = ACTIONS(4659),
    [anon_sym_LT] = ACTIONS(4657),
    [sym_number] = ACTIONS(4657),
    [anon_sym_SLASH] = ACTIONS(4659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4659),
    [anon_sym_function] = ACTIONS(4659),
    [sym_undefined] = ACTIONS(4659),
    [anon_sym_new] = ACTIONS(4659),
    [ts_builtin_sym_end] = ACTIONS(4657),
    [anon_sym_let] = ACTIONS(4659),
    [anon_sym_PLUS] = ACTIONS(4659),
    [anon_sym_export] = ACTIONS(4659),
    [anon_sym_do] = ACTIONS(4659),
    [anon_sym_TILDE] = ACTIONS(4657),
    [anon_sym_with] = ACTIONS(4659),
  },
  [2306] = {
    [sym_class_body] = STATE(3146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [2307] = {
    [sym_statement_block] = STATE(3147),
    [sym__automatic_semicolon] = ACTIONS(5138),
    [anon_sym_SEMI] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [2308] = {
    [sym_identifier] = ACTIONS(5142),
    [anon_sym_BQUOTE] = ACTIONS(5140),
    [anon_sym_debugger] = ACTIONS(5142),
    [anon_sym_symbol] = ACTIONS(5142),
    [anon_sym_AT] = ACTIONS(5140),
    [anon_sym_DASH] = ACTIONS(5142),
    [anon_sym_void] = ACTIONS(5142),
    [anon_sym_break] = ACTIONS(5142),
    [anon_sym_const] = ACTIONS(5142),
    [sym_super] = ACTIONS(5142),
    [anon_sym_return] = ACTIONS(5142),
    [anon_sym_private] = ACTIONS(5142),
    [anon_sym_get] = ACTIONS(5142),
    [anon_sym_RBRACE] = ACTIONS(5140),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_default] = ACTIONS(5142),
    [anon_sym_enum] = ACTIONS(5142),
    [anon_sym_delete] = ACTIONS(5142),
    [anon_sym_continue] = ACTIONS(5142),
    [anon_sym_DASH_DASH] = ACTIONS(5140),
    [anon_sym_if] = ACTIONS(5142),
    [anon_sym_this] = ACTIONS(5142),
    [anon_sym_yield] = ACTIONS(5142),
    [sym_true] = ACTIONS(5142),
    [anon_sym_throw] = ACTIONS(5142),
    [anon_sym_protected] = ACTIONS(5142),
    [anon_sym_abstract] = ACTIONS(5142),
    [anon_sym_set] = ACTIONS(5142),
    [anon_sym_type] = ACTIONS(5142),
    [anon_sym_import] = ACTIONS(5142),
    [anon_sym_namespace] = ACTIONS(5142),
    [anon_sym_PLUS_PLUS] = ACTIONS(5140),
    [anon_sym_await] = ACTIONS(5142),
    [anon_sym_DQUOTE] = ACTIONS(5140),
    [anon_sym_else] = ACTIONS(5142),
    [anon_sym_BANG] = ACTIONS(5140),
    [anon_sym_for] = ACTIONS(5142),
    [anon_sym_LBRACK] = ACTIONS(5140),
    [sym_false] = ACTIONS(5142),
    [anon_sym_SEMI] = ACTIONS(5140),
    [anon_sym_case] = ACTIONS(5142),
    [anon_sym_module] = ACTIONS(5142),
    [anon_sym_number] = ACTIONS(5142),
    [anon_sym_class] = ACTIONS(5142),
    [anon_sym_declare] = ACTIONS(5142),
    [anon_sym_typeof] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(5140),
    [anon_sym_switch] = ACTIONS(5142),
    [anon_sym_LPAREN] = ACTIONS(5140),
    [sym_null] = ACTIONS(5142),
    [anon_sym_any] = ACTIONS(5142),
    [anon_sym_boolean] = ACTIONS(5142),
    [anon_sym_async] = ACTIONS(5142),
    [anon_sym_public] = ACTIONS(5142),
    [anon_sym_var] = ACTIONS(5142),
    [anon_sym_while] = ACTIONS(5142),
    [anon_sym_SQUOTE] = ACTIONS(5140),
    [anon_sym_try] = ACTIONS(5142),
    [anon_sym_LT] = ACTIONS(5140),
    [sym_number] = ACTIONS(5140),
    [anon_sym_SLASH] = ACTIONS(5142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5142),
    [anon_sym_function] = ACTIONS(5142),
    [sym_undefined] = ACTIONS(5142),
    [anon_sym_new] = ACTIONS(5142),
    [ts_builtin_sym_end] = ACTIONS(5140),
    [anon_sym_let] = ACTIONS(5142),
    [anon_sym_PLUS] = ACTIONS(5142),
    [anon_sym_export] = ACTIONS(5142),
    [anon_sym_do] = ACTIONS(5142),
    [anon_sym_TILDE] = ACTIONS(5140),
    [anon_sym_with] = ACTIONS(5142),
  },
  [2309] = {
    [sym_statement_block] = STATE(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [2310] = {
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_BQUOTE] = ACTIONS(5445),
    [anon_sym_debugger] = ACTIONS(5447),
    [anon_sym_symbol] = ACTIONS(5447),
    [anon_sym_AT] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5447),
    [anon_sym_void] = ACTIONS(5447),
    [anon_sym_break] = ACTIONS(5447),
    [anon_sym_const] = ACTIONS(5447),
    [sym_super] = ACTIONS(5447),
    [anon_sym_return] = ACTIONS(5447),
    [anon_sym_private] = ACTIONS(5447),
    [anon_sym_get] = ACTIONS(5447),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_interface] = ACTIONS(5447),
    [anon_sym_default] = ACTIONS(5447),
    [anon_sym_enum] = ACTIONS(5447),
    [anon_sym_delete] = ACTIONS(5447),
    [anon_sym_continue] = ACTIONS(5447),
    [anon_sym_DASH_DASH] = ACTIONS(5445),
    [anon_sym_if] = ACTIONS(5447),
    [anon_sym_this] = ACTIONS(5447),
    [anon_sym_yield] = ACTIONS(5447),
    [sym_true] = ACTIONS(5447),
    [anon_sym_throw] = ACTIONS(5447),
    [anon_sym_protected] = ACTIONS(5447),
    [anon_sym_abstract] = ACTIONS(5447),
    [anon_sym_set] = ACTIONS(5447),
    [anon_sym_type] = ACTIONS(5447),
    [anon_sym_import] = ACTIONS(5447),
    [anon_sym_namespace] = ACTIONS(5447),
    [anon_sym_PLUS_PLUS] = ACTIONS(5445),
    [anon_sym_await] = ACTIONS(5447),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [anon_sym_else] = ACTIONS(5447),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_for] = ACTIONS(5447),
    [anon_sym_LBRACK] = ACTIONS(5445),
    [sym_false] = ACTIONS(5447),
    [anon_sym_SEMI] = ACTIONS(5445),
    [anon_sym_case] = ACTIONS(5447),
    [anon_sym_module] = ACTIONS(5447),
    [anon_sym_number] = ACTIONS(5447),
    [anon_sym_class] = ACTIONS(5447),
    [anon_sym_declare] = ACTIONS(5447),
    [anon_sym_typeof] = ACTIONS(5447),
    [anon_sym_LBRACE] = ACTIONS(5445),
    [anon_sym_switch] = ACTIONS(5447),
    [anon_sym_LPAREN] = ACTIONS(5445),
    [sym_null] = ACTIONS(5447),
    [anon_sym_any] = ACTIONS(5447),
    [anon_sym_boolean] = ACTIONS(5447),
    [anon_sym_async] = ACTIONS(5447),
    [anon_sym_public] = ACTIONS(5447),
    [anon_sym_var] = ACTIONS(5447),
    [anon_sym_while] = ACTIONS(5447),
    [anon_sym_SQUOTE] = ACTIONS(5445),
    [anon_sym_try] = ACTIONS(5447),
    [anon_sym_LT] = ACTIONS(5445),
    [sym_number] = ACTIONS(5445),
    [anon_sym_SLASH] = ACTIONS(5447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5447),
    [anon_sym_function] = ACTIONS(5447),
    [sym_undefined] = ACTIONS(5447),
    [anon_sym_new] = ACTIONS(5447),
    [ts_builtin_sym_end] = ACTIONS(5445),
    [anon_sym_let] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5447),
    [anon_sym_export] = ACTIONS(5447),
    [anon_sym_do] = ACTIONS(5447),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_with] = ACTIONS(5447),
  },
  [2311] = {
    [sym_class_body] = STATE(3149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [2312] = {
    [sym_class_heritage] = STATE(3150),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(3149),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [2313] = {
    [sym_identifier] = ACTIONS(5775),
    [anon_sym_BQUOTE] = ACTIONS(5773),
    [anon_sym_debugger] = ACTIONS(5775),
    [anon_sym_symbol] = ACTIONS(5775),
    [anon_sym_AT] = ACTIONS(5773),
    [anon_sym_DASH] = ACTIONS(5775),
    [anon_sym_void] = ACTIONS(5775),
    [anon_sym_break] = ACTIONS(5775),
    [anon_sym_const] = ACTIONS(5775),
    [sym_super] = ACTIONS(5775),
    [anon_sym_return] = ACTIONS(5775),
    [anon_sym_private] = ACTIONS(5775),
    [anon_sym_get] = ACTIONS(5775),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [anon_sym_interface] = ACTIONS(5775),
    [anon_sym_default] = ACTIONS(5775),
    [anon_sym_enum] = ACTIONS(5775),
    [anon_sym_delete] = ACTIONS(5775),
    [anon_sym_continue] = ACTIONS(5775),
    [anon_sym_DASH_DASH] = ACTIONS(5773),
    [anon_sym_if] = ACTIONS(5775),
    [anon_sym_this] = ACTIONS(5775),
    [anon_sym_yield] = ACTIONS(5775),
    [sym_true] = ACTIONS(5775),
    [anon_sym_throw] = ACTIONS(5775),
    [anon_sym_protected] = ACTIONS(5775),
    [anon_sym_abstract] = ACTIONS(5775),
    [anon_sym_set] = ACTIONS(5775),
    [anon_sym_type] = ACTIONS(5775),
    [anon_sym_import] = ACTIONS(5775),
    [anon_sym_namespace] = ACTIONS(5775),
    [anon_sym_PLUS_PLUS] = ACTIONS(5773),
    [anon_sym_await] = ACTIONS(5775),
    [anon_sym_DQUOTE] = ACTIONS(5773),
    [anon_sym_else] = ACTIONS(5775),
    [anon_sym_BANG] = ACTIONS(5773),
    [anon_sym_for] = ACTIONS(5775),
    [anon_sym_LBRACK] = ACTIONS(5773),
    [sym_false] = ACTIONS(5775),
    [anon_sym_SEMI] = ACTIONS(5773),
    [anon_sym_case] = ACTIONS(5775),
    [anon_sym_module] = ACTIONS(5775),
    [anon_sym_number] = ACTIONS(5775),
    [anon_sym_class] = ACTIONS(5775),
    [anon_sym_declare] = ACTIONS(5775),
    [anon_sym_typeof] = ACTIONS(5775),
    [anon_sym_LBRACE] = ACTIONS(5773),
    [anon_sym_switch] = ACTIONS(5775),
    [anon_sym_LPAREN] = ACTIONS(5773),
    [sym_null] = ACTIONS(5775),
    [anon_sym_any] = ACTIONS(5775),
    [anon_sym_boolean] = ACTIONS(5775),
    [anon_sym_async] = ACTIONS(5775),
    [anon_sym_public] = ACTIONS(5775),
    [anon_sym_var] = ACTIONS(5775),
    [anon_sym_while] = ACTIONS(5775),
    [anon_sym_SQUOTE] = ACTIONS(5773),
    [anon_sym_try] = ACTIONS(5775),
    [anon_sym_LT] = ACTIONS(5773),
    [sym_number] = ACTIONS(5773),
    [anon_sym_SLASH] = ACTIONS(5775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5775),
    [anon_sym_function] = ACTIONS(5775),
    [sym_undefined] = ACTIONS(5775),
    [anon_sym_new] = ACTIONS(5775),
    [ts_builtin_sym_end] = ACTIONS(5773),
    [anon_sym_let] = ACTIONS(5775),
    [anon_sym_PLUS] = ACTIONS(5775),
    [anon_sym_export] = ACTIONS(5775),
    [anon_sym_do] = ACTIONS(5775),
    [anon_sym_TILDE] = ACTIONS(5773),
    [anon_sym_with] = ACTIONS(5775),
  },
  [2314] = {
    [sym_new_expression] = STATE(3151),
    [sym_augmented_assignment_expression] = STATE(3151),
    [sym_unary_expression] = STATE(3151),
    [sym_update_expression] = STATE(3151),
    [sym_regex] = STATE(3151),
    [sym_meta_property] = STATE(3151),
    [sym_call_signature] = STATE(1399),
    [sym_statement_block] = STATE(356),
    [sym__expression] = STATE(3151),
    [sym_yield_expression] = STATE(3151),
    [sym_as_expression] = STATE(3151),
    [sym_non_null_expression] = STATE(3151),
    [sym_internal_module] = STATE(3151),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3151),
    [sym_await_expression] = STATE(3151),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3151),
    [sym_this] = STATE(3151),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3151),
    [sym_generator_function] = STATE(3151),
    [sym_call_expression] = STATE(3151),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3151),
    [sym_ternary_expression] = STATE(3151),
    [sym_binary_expression] = STATE(3151),
    [sym_template_string] = STATE(3151),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3151),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3151),
    [sym_class] = STATE(3151),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6458),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6460),
    [sym_true] = ACTIONS(6458),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6458),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2315] = {
    [sym_new_expression] = STATE(3152),
    [sym_augmented_assignment_expression] = STATE(3152),
    [sym_unary_expression] = STATE(3152),
    [sym_update_expression] = STATE(3152),
    [sym_regex] = STATE(3152),
    [sym_meta_property] = STATE(3152),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(3152),
    [sym_yield_expression] = STATE(3152),
    [sym_as_expression] = STATE(3152),
    [sym_non_null_expression] = STATE(3152),
    [sym_internal_module] = STATE(3152),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3152),
    [sym_await_expression] = STATE(3152),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3152),
    [sym_this] = STATE(3152),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3152),
    [sym_generator_function] = STATE(3152),
    [sym_call_expression] = STATE(3152),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3152),
    [sym_ternary_expression] = STATE(3152),
    [sym_binary_expression] = STATE(3152),
    [sym_template_string] = STATE(3152),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3152),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3152),
    [sym_class] = STATE(3152),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6462),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6464),
    [sym_true] = ACTIONS(6462),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6462),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2316] = {
    [sym_new_expression] = STATE(3153),
    [sym_augmented_assignment_expression] = STATE(3153),
    [sym_unary_expression] = STATE(3153),
    [sym_update_expression] = STATE(3153),
    [sym_regex] = STATE(3153),
    [sym_meta_property] = STATE(3153),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(3153),
    [sym_yield_expression] = STATE(3153),
    [sym_as_expression] = STATE(3153),
    [sym_non_null_expression] = STATE(3153),
    [sym_internal_module] = STATE(3153),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3153),
    [sym_await_expression] = STATE(3153),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3153),
    [sym_this] = STATE(3153),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3153),
    [sym_generator_function] = STATE(3153),
    [sym_call_expression] = STATE(3153),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3153),
    [sym_ternary_expression] = STATE(3153),
    [sym_binary_expression] = STATE(3153),
    [sym_template_string] = STATE(3153),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3153),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3153),
    [sym_class] = STATE(3153),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(6466),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6466),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6468),
    [sym_true] = ACTIONS(6466),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6466),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2317] = {
    [sym_new_expression] = STATE(3154),
    [sym_augmented_assignment_expression] = STATE(3154),
    [sym_unary_expression] = STATE(3154),
    [sym_update_expression] = STATE(3154),
    [sym_regex] = STATE(3154),
    [sym_meta_property] = STATE(3154),
    [sym_call_signature] = STATE(1399),
    [sym_statement_block] = STATE(383),
    [sym__expression] = STATE(3154),
    [sym_yield_expression] = STATE(3154),
    [sym_as_expression] = STATE(3154),
    [sym_non_null_expression] = STATE(3154),
    [sym_internal_module] = STATE(3154),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3154),
    [sym_await_expression] = STATE(3154),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3154),
    [sym_this] = STATE(3154),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3154),
    [sym_generator_function] = STATE(3154),
    [sym_call_expression] = STATE(3154),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3154),
    [sym_ternary_expression] = STATE(3154),
    [sym_binary_expression] = STATE(3154),
    [sym_template_string] = STATE(3154),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3154),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3154),
    [sym_class] = STATE(3154),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(6470),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6470),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6472),
    [sym_true] = ACTIONS(6470),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6470),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2318] = {
    [sym_new_expression] = STATE(3155),
    [sym_augmented_assignment_expression] = STATE(3155),
    [sym_unary_expression] = STATE(3155),
    [sym_update_expression] = STATE(3155),
    [sym_regex] = STATE(3155),
    [sym_meta_property] = STATE(3155),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(3155),
    [sym_yield_expression] = STATE(3155),
    [sym_as_expression] = STATE(3155),
    [sym_non_null_expression] = STATE(3155),
    [sym_internal_module] = STATE(3155),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3155),
    [sym_await_expression] = STATE(3155),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3155),
    [sym_this] = STATE(3155),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3155),
    [sym_generator_function] = STATE(3155),
    [sym_call_expression] = STATE(3155),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3155),
    [sym_ternary_expression] = STATE(3155),
    [sym_binary_expression] = STATE(3155),
    [sym_template_string] = STATE(3155),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3155),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3155),
    [sym_class] = STATE(3155),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(6474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6474),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6476),
    [sym_true] = ACTIONS(6474),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6474),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2319] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_RBRACE] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [2320] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_RBRACE] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [2321] = {
    [anon_sym_EQ_GT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(3),
  },
  [2322] = {
    [anon_sym_EQ_GT] = ACTIONS(6483),
    [sym_comment] = ACTIONS(3),
  },
  [2323] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [sym__automatic_semicolon] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [2324] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(863),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [2325] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(868),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(4842),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [2326] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(4848),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2327] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(870),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(4848),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2328] = {
    [sym_call_signature] = STATE(2321),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(4858),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(4860),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(4860),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(4860),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(4860),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(4860),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(4860),
    [anon_sym_type] = ACTIONS(4860),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(4860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(4860),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(4860),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(4860),
    [anon_sym_declare] = ACTIONS(4860),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(4860),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(4860),
    [anon_sym_async] = ACTIONS(4860),
    [anon_sym_public] = ACTIONS(4860),
    [anon_sym_EQ_GT] = ACTIONS(4848),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(4860),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(4860),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2329] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(4848),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2330] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(907),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [2331] = {
    [sym_new_expression] = STATE(3158),
    [sym_augmented_assignment_expression] = STATE(3158),
    [sym_unary_expression] = STATE(3158),
    [sym_update_expression] = STATE(3158),
    [sym_regex] = STATE(3158),
    [sym_meta_property] = STATE(3158),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(3158),
    [sym_yield_expression] = STATE(3158),
    [sym_as_expression] = STATE(3158),
    [sym_non_null_expression] = STATE(3158),
    [sym_internal_module] = STATE(3158),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3158),
    [sym_await_expression] = STATE(3158),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3158),
    [sym_this] = STATE(3158),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3158),
    [sym_generator_function] = STATE(3158),
    [sym_call_expression] = STATE(3158),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3158),
    [sym_ternary_expression] = STATE(3158),
    [sym_binary_expression] = STATE(3158),
    [sym_template_string] = STATE(3158),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3158),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3158),
    [sym_class] = STATE(3158),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(6485),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6485),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6487),
    [sym_true] = ACTIONS(6485),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6485),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2332] = {
    [sym_new_expression] = STATE(3159),
    [sym_augmented_assignment_expression] = STATE(3159),
    [sym_unary_expression] = STATE(3159),
    [sym_update_expression] = STATE(3159),
    [sym_regex] = STATE(3159),
    [sym_meta_property] = STATE(3159),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(3159),
    [sym_yield_expression] = STATE(3159),
    [sym_as_expression] = STATE(3159),
    [sym_non_null_expression] = STATE(3159),
    [sym_internal_module] = STATE(3159),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3159),
    [sym_await_expression] = STATE(3159),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3159),
    [sym_this] = STATE(3159),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3159),
    [sym_generator_function] = STATE(3159),
    [sym_call_expression] = STATE(3159),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3159),
    [sym_ternary_expression] = STATE(3159),
    [sym_binary_expression] = STATE(3159),
    [sym_template_string] = STATE(3159),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3159),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3159),
    [sym_class] = STATE(3159),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(6489),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6489),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6491),
    [sym_true] = ACTIONS(6489),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6489),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2333] = {
    [sym_new_expression] = STATE(3160),
    [sym_augmented_assignment_expression] = STATE(3160),
    [sym_unary_expression] = STATE(3160),
    [sym_update_expression] = STATE(3160),
    [sym_regex] = STATE(3160),
    [sym_meta_property] = STATE(3160),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(3160),
    [sym_yield_expression] = STATE(3160),
    [sym_as_expression] = STATE(3160),
    [sym_non_null_expression] = STATE(3160),
    [sym_internal_module] = STATE(3160),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3160),
    [sym_await_expression] = STATE(3160),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3160),
    [sym_this] = STATE(3160),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3160),
    [sym_generator_function] = STATE(3160),
    [sym_call_expression] = STATE(3160),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3160),
    [sym_ternary_expression] = STATE(3160),
    [sym_binary_expression] = STATE(3160),
    [sym_template_string] = STATE(3160),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3160),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3160),
    [sym_class] = STATE(3160),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(6493),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6493),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6495),
    [sym_true] = ACTIONS(6493),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6493),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2334] = {
    [sym_new_expression] = STATE(3161),
    [sym_augmented_assignment_expression] = STATE(3161),
    [sym_unary_expression] = STATE(3161),
    [sym_update_expression] = STATE(3161),
    [sym_regex] = STATE(3161),
    [sym_meta_property] = STATE(3161),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(3161),
    [sym_yield_expression] = STATE(3161),
    [sym_as_expression] = STATE(3161),
    [sym_non_null_expression] = STATE(3161),
    [sym_internal_module] = STATE(3161),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3161),
    [sym_await_expression] = STATE(3161),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3161),
    [sym_this] = STATE(3161),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3161),
    [sym_generator_function] = STATE(3161),
    [sym_call_expression] = STATE(3161),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3161),
    [sym_ternary_expression] = STATE(3161),
    [sym_binary_expression] = STATE(3161),
    [sym_template_string] = STATE(3161),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3161),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3161),
    [sym_class] = STATE(3161),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(6497),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6497),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6499),
    [sym_true] = ACTIONS(6497),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6497),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2335] = {
    [sym_new_expression] = STATE(3162),
    [sym_augmented_assignment_expression] = STATE(3162),
    [sym_unary_expression] = STATE(3162),
    [sym_update_expression] = STATE(3162),
    [sym_regex] = STATE(3162),
    [sym_meta_property] = STATE(3162),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(3162),
    [sym_yield_expression] = STATE(3162),
    [sym_as_expression] = STATE(3162),
    [sym_non_null_expression] = STATE(3162),
    [sym_internal_module] = STATE(3162),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3162),
    [sym_await_expression] = STATE(3162),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(3162),
    [sym_this] = STATE(3162),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(3162),
    [sym_generator_function] = STATE(3162),
    [sym_call_expression] = STATE(3162),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(3162),
    [sym_ternary_expression] = STATE(3162),
    [sym_binary_expression] = STATE(3162),
    [sym_template_string] = STATE(3162),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3162),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(3162),
    [sym_class] = STATE(3162),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(6501),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6501),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6503),
    [sym_true] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6501),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [2336] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(983),
    [sym_constructor_type] = STATE(983),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(983),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_template_string] = STATE(987),
    [sym_union_type] = STATE(983),
    [sym_intersection_type] = STATE(983),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_keyof] = ACTIONS(1976),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(6507),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_boolean] = ACTIONS(1972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1994),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [2337] = {
    [sym_new_expression] = STATE(3152),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(3152),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3152),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3152),
    [sym_call_signature] = STATE(1399),
    [sym_yield_expression] = STATE(3152),
    [sym_as_expression] = STATE(3152),
    [sym_internal_module] = STATE(3152),
    [sym_arrow_function] = STATE(3152),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(1401),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(991),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(1402),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(3152),
    [sym_subscript_expression] = STATE(1401),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3152),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3152),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3152),
    [sym_meta_property] = STATE(3152),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(3152),
    [sym_non_null_expression] = STATE(3152),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(3152),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3152),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_anonymous_class] = STATE(3152),
    [sym_call_expression] = STATE(3152),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3152),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3152),
    [sym_type_arguments] = STATE(1403),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(3152),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3152),
    [sym_class] = STATE(3152),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(6515),
    [sym_false] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(6517),
    [anon_sym_number] = ACTIONS(6517),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(6519),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6521),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(6523),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [sym_null] = ACTIONS(6462),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(6517),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(6517),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(2018),
    [sym_number] = ACTIONS(2020),
    [sym_true] = ACTIONS(2002),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(6517),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6462),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(6525),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(6521),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2338] = {
    [sym_new_expression] = STATE(3177),
    [sym_augmented_assignment_expression] = STATE(3177),
    [sym_unary_expression] = STATE(3177),
    [sym_update_expression] = STATE(3177),
    [sym_regex] = STATE(3177),
    [sym_meta_property] = STATE(3177),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(3177),
    [sym_yield_expression] = STATE(3177),
    [sym_as_expression] = STATE(3177),
    [sym_non_null_expression] = STATE(3177),
    [sym_internal_module] = STATE(3177),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3177),
    [sym_await_expression] = STATE(3177),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3177),
    [sym_this] = STATE(3177),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3177),
    [sym_generator_function] = STATE(3177),
    [sym_call_expression] = STATE(3177),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3177),
    [sym_ternary_expression] = STATE(3177),
    [sym_binary_expression] = STATE(3177),
    [sym_template_string] = STATE(3177),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3177),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3177),
    [sym_class] = STATE(3177),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(6527),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6527),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6529),
    [sym_true] = ACTIONS(6527),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6527),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [2339] = {
    [anon_sym_LBRACK] = ACTIONS(2285),
    [sym_identifier] = ACTIONS(2287),
    [anon_sym_module] = ACTIONS(2287),
    [anon_sym_symbol] = ACTIONS(2287),
    [anon_sym_number] = ACTIONS(2287),
    [anon_sym_AT] = ACTIONS(2285),
    [anon_sym_class] = ACTIONS(2287),
    [anon_sym_declare] = ACTIONS(2287),
    [anon_sym_STAR] = ACTIONS(2285),
    [anon_sym_void] = ACTIONS(2287),
    [anon_sym_any] = ACTIONS(2287),
    [anon_sym_private] = ACTIONS(2287),
    [anon_sym_boolean] = ACTIONS(2287),
    [anon_sym_async] = ACTIONS(2287),
    [anon_sym_public] = ACTIONS(2287),
    [anon_sym_get] = ACTIONS(2287),
    [anon_sym_static] = ACTIONS(2287),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_SQUOTE] = ACTIONS(2285),
    [sym_number] = ACTIONS(2285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2287),
    [anon_sym_string] = ACTIONS(2287),
    [anon_sym_abstract] = ACTIONS(2287),
    [anon_sym_set] = ACTIONS(2287),
    [anon_sym_type] = ACTIONS(2287),
    [anon_sym_import] = ACTIONS(2287),
    [anon_sym_export] = ACTIONS(2287),
    [sym_readonly] = ACTIONS(2287),
    [anon_sym_namespace] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2285),
  },
  [2340] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [aux_sym_array_repeat1] = STATE(3179),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(6531),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2341] = {
    [aux_sym_array_repeat1] = STATE(3179),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(6531),
    [sym_comment] = ACTIONS(3),
  },
  [2342] = {
    [aux_sym_array_repeat1] = STATE(1122),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(6531),
    [sym_comment] = ACTIONS(3),
  },
  [2343] = {
    [anon_sym_EQ] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4970),
    [anon_sym_LT] = ACTIONS(4970),
    [anon_sym_LPAREN] = ACTIONS(4970),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(4970),
  },
  [2344] = {
    [sym_statement_block] = STATE(3180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [2345] = {
    [anon_sym_COMMA] = ACTIONS(6533),
    [anon_sym_RBRACE] = ACTIONS(6533),
    [sym_comment] = ACTIONS(3),
  },
  [2346] = {
    [sym_call_signature] = STATE(3181),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2347] = {
    [sym_call_signature] = STATE(3181),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(6535),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2348] = {
    [sym_string] = STATE(3183),
    [sym__property_name] = STATE(3183),
    [sym_computed_property_name] = STATE(3183),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2349] = {
    [sym_string] = STATE(3183),
    [sym__property_name] = STATE(3183),
    [sym_computed_property_name] = STATE(3183),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(6537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2350] = {
    [sym_type_alias_declaration] = STATE(361),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(361),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(361),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(361),
    [sym_return_statement] = STATE(361),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(361),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(361),
    [sym_switch_statement] = STATE(361),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(361),
    [sym_throw_statement] = STATE(361),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(361),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(361),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(361),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(361),
    [sym_abstract_class] = STATE(361),
    [sym_interface_declaration] = STATE(361),
    [sym_statement_block] = STATE(361),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(361),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(361),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(361),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(361),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(361),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(361),
    [sym_empty_statement] = STATE(361),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(361),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(361),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(361),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(361),
    [sym_break_statement] = STATE(361),
    [sym_labeled_statement] = STATE(361),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(361),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [2351] = {
    [sym_type_alias_declaration] = STATE(3184),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3184),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3184),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3184),
    [sym_return_statement] = STATE(3184),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3184),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3184),
    [sym_switch_statement] = STATE(3184),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3184),
    [sym_throw_statement] = STATE(3184),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3184),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3184),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(3184),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3184),
    [sym_abstract_class] = STATE(3184),
    [sym_interface_declaration] = STATE(3184),
    [sym_statement_block] = STATE(3184),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3184),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3184),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3184),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3184),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3184),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3184),
    [sym_empty_statement] = STATE(3184),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(3184),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3184),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3184),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3184),
    [sym_break_statement] = STATE(3184),
    [sym_labeled_statement] = STATE(3184),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3184),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [2352] = {
    [anon_sym_LPAREN] = ACTIONS(6539),
    [sym_comment] = ACTIONS(3),
  },
  [2353] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3189),
    [sym_variable_declaration] = STATE(3189),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(3189),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(3190),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_lexical_declaration] = STATE(3189),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(3191),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(6541),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(6543),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6545),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(6543),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [2354] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(6547),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(310),
  },
  [2355] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(2357),
    [sym__declaration] = STATE(192),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(2357),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(4936),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4938),
    [anon_sym_global] = ACTIONS(322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(4940),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [2356] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(2357),
    [sym__declaration] = STATE(317),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(2357),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4938),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(4940),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [2357] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(4944),
    [anon_sym_class] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [2358] = {
    [sym_type_alias_declaration] = STATE(777),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(777),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(777),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(777),
    [sym_return_statement] = STATE(777),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(777),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(777),
    [sym_switch_statement] = STATE(777),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(777),
    [sym_throw_statement] = STATE(777),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(777),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(777),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(777),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(777),
    [sym_abstract_class] = STATE(777),
    [sym_interface_declaration] = STATE(777),
    [sym_statement_block] = STATE(777),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(777),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(777),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(777),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(777),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(777),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(777),
    [sym_empty_statement] = STATE(777),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(777),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(777),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(777),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(777),
    [sym_break_statement] = STATE(777),
    [sym_labeled_statement] = STATE(777),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(777),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [2359] = {
    [sym_type_alias_declaration] = STATE(934),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(934),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(934),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(934),
    [sym_return_statement] = STATE(934),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(934),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(934),
    [sym_switch_statement] = STATE(934),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(934),
    [sym_throw_statement] = STATE(934),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(934),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(934),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(934),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(934),
    [sym_abstract_class] = STATE(934),
    [sym_interface_declaration] = STATE(934),
    [sym_statement_block] = STATE(934),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(934),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(934),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(934),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(934),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(934),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(934),
    [sym_empty_statement] = STATE(934),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(934),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(934),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(934),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(934),
    [sym_break_statement] = STATE(934),
    [sym_labeled_statement] = STATE(934),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(934),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [2360] = {
    [sym_type_alias_declaration] = STATE(2047),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2047),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2047),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2047),
    [sym_return_statement] = STATE(2047),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2047),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2047),
    [sym_switch_statement] = STATE(2047),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2047),
    [sym_throw_statement] = STATE(2047),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2047),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2047),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(2047),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2047),
    [sym_abstract_class] = STATE(2047),
    [sym_interface_declaration] = STATE(2047),
    [sym_statement_block] = STATE(2047),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2047),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2047),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2047),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2047),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2047),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2047),
    [sym_empty_statement] = STATE(2047),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(2047),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2047),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2047),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2047),
    [sym_break_statement] = STATE(2047),
    [sym_labeled_statement] = STATE(2047),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2047),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [2361] = {
    [sym_type_alias_declaration] = STATE(915),
    [aux_sym_export_statement_repeat1] = STATE(2357),
    [sym__declaration] = STATE(915),
    [sym_ambient_declaration] = STATE(915),
    [sym_import_alias] = STATE(915),
    [sym_export_statement] = STATE(915),
    [sym_generator_function] = STATE(915),
    [sym_lexical_declaration] = STATE(915),
    [sym_internal_module] = STATE(915),
    [sym_decorator] = STATE(2357),
    [sym_enum_declaration] = STATE(915),
    [sym_function] = STATE(915),
    [sym_function_signature] = STATE(915),
    [sym_variable_declaration] = STATE(915),
    [sym_abstract_class] = STATE(915),
    [sym_module] = STATE(915),
    [sym_interface_declaration] = STATE(915),
    [sym_class] = STATE(915),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(4940),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [2362] = {
    [sym_array] = STATE(3194),
    [sym_object] = STATE(3195),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(6549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [2363] = {
    [anon_sym_of] = ACTIONS(6551),
    [sym_comment] = ACTIONS(3),
  },
  [2364] = {
    [anon_sym_of] = ACTIONS(6553),
    [sym_comment] = ACTIONS(3),
  },
  [2365] = {
    [anon_sym_of] = ACTIONS(6555),
    [sym_comment] = ACTIONS(3),
  },
  [2366] = {
    [sym_new_expression] = STATE(3199),
    [sym_augmented_assignment_expression] = STATE(3199),
    [sym_unary_expression] = STATE(3199),
    [sym_update_expression] = STATE(3199),
    [sym_regex] = STATE(3199),
    [sym_meta_property] = STATE(3199),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3199),
    [sym_yield_expression] = STATE(3199),
    [sym_as_expression] = STATE(3199),
    [sym_non_null_expression] = STATE(3199),
    [sym_internal_module] = STATE(3199),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3199),
    [sym_await_expression] = STATE(3199),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(3200),
    [sym_string] = STATE(3199),
    [sym_this] = STATE(3199),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3199),
    [sym_generator_function] = STATE(3199),
    [sym_call_expression] = STATE(3199),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3199),
    [sym_ternary_expression] = STATE(3199),
    [sym_binary_expression] = STATE(3199),
    [sym_template_string] = STATE(3199),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3199),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3199),
    [sym_class] = STATE(3199),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6557),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6559),
    [sym_true] = ACTIONS(6557),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6557),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2367] = {
    [sym_new_expression] = STATE(3201),
    [sym_augmented_assignment_expression] = STATE(3201),
    [sym_unary_expression] = STATE(3201),
    [sym_update_expression] = STATE(3201),
    [sym_regex] = STATE(3201),
    [sym_meta_property] = STATE(3201),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3201),
    [sym_yield_expression] = STATE(3201),
    [sym_as_expression] = STATE(3201),
    [sym_non_null_expression] = STATE(3201),
    [sym_internal_module] = STATE(3201),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3201),
    [sym_await_expression] = STATE(3201),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3201),
    [sym_this] = STATE(3201),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3201),
    [sym_generator_function] = STATE(3201),
    [sym_call_expression] = STATE(3201),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3201),
    [sym_ternary_expression] = STATE(3201),
    [sym_binary_expression] = STATE(3201),
    [sym_template_string] = STATE(3201),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3201),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3201),
    [sym_class] = STATE(3201),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6561),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6561),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6563),
    [sym_true] = ACTIONS(6561),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6561),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2368] = {
    [sym__initializer] = STATE(405),
    [sym_type_annotation] = STATE(406),
    [sym__automatic_semicolon] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_of] = ACTIONS(6551),
    [anon_sym_COMMA] = ACTIONS(739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6565),
  },
  [2369] = {
    [sym__initializer] = STATE(425),
    [sym_type_annotation] = STATE(426),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(6553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6567),
  },
  [2370] = {
    [sym__initializer] = STATE(427),
    [sym_type_annotation] = STATE(428),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(6555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6569),
  },
  [2371] = {
    [sym_new_expression] = STATE(3206),
    [sym_augmented_assignment_expression] = STATE(3206),
    [sym_unary_expression] = STATE(3206),
    [sym_update_expression] = STATE(3206),
    [sym_regex] = STATE(3206),
    [sym_meta_property] = STATE(3206),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(3206),
    [sym_yield_expression] = STATE(3206),
    [sym_as_expression] = STATE(3206),
    [sym_non_null_expression] = STATE(3206),
    [sym_internal_module] = STATE(3206),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3206),
    [sym_await_expression] = STATE(3206),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(3206),
    [sym_this] = STATE(3206),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(3206),
    [sym_generator_function] = STATE(3206),
    [sym_call_expression] = STATE(3206),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(3206),
    [sym_ternary_expression] = STATE(3206),
    [sym_binary_expression] = STATE(3206),
    [sym_template_string] = STATE(3206),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3206),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(3206),
    [sym_class] = STATE(3206),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(6571),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6571),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(6573),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6575),
    [sym_true] = ACTIONS(6571),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6571),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [2372] = {
    [sym_new_expression] = STATE(3208),
    [sym_augmented_assignment_expression] = STATE(3208),
    [sym_unary_expression] = STATE(3208),
    [sym_update_expression] = STATE(3208),
    [sym_regex] = STATE(3208),
    [sym_meta_property] = STATE(3208),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3208),
    [sym_yield_expression] = STATE(3208),
    [sym_as_expression] = STATE(3208),
    [sym_non_null_expression] = STATE(3208),
    [sym_internal_module] = STATE(3208),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3208),
    [sym_await_expression] = STATE(3208),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3208),
    [sym_this] = STATE(3208),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3208),
    [sym_generator_function] = STATE(3208),
    [sym_call_expression] = STATE(3208),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3208),
    [sym_ternary_expression] = STATE(3208),
    [sym_binary_expression] = STATE(3208),
    [sym_template_string] = STATE(3208),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3208),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3208),
    [sym_class] = STATE(3208),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6577),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6577),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6579),
    [sym_true] = ACTIONS(6577),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6577),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2373] = {
    [sym_new_expression] = STATE(3209),
    [sym_augmented_assignment_expression] = STATE(3209),
    [sym_unary_expression] = STATE(3209),
    [sym_update_expression] = STATE(3209),
    [sym_regex] = STATE(3209),
    [sym_meta_property] = STATE(3209),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3209),
    [sym_yield_expression] = STATE(3209),
    [sym_as_expression] = STATE(3209),
    [sym_non_null_expression] = STATE(3209),
    [sym_internal_module] = STATE(3209),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3209),
    [sym_await_expression] = STATE(3209),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(3210),
    [sym_string] = STATE(3209),
    [sym_this] = STATE(3209),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3209),
    [sym_generator_function] = STATE(3209),
    [sym_call_expression] = STATE(3209),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3209),
    [sym_ternary_expression] = STATE(3209),
    [sym_binary_expression] = STATE(3209),
    [sym_template_string] = STATE(3209),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3209),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3209),
    [sym_class] = STATE(3209),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(6581),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6581),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6583),
    [sym_true] = ACTIONS(6581),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6581),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2374] = {
    [sym_new_expression] = STATE(3211),
    [sym_augmented_assignment_expression] = STATE(3211),
    [sym_unary_expression] = STATE(3211),
    [sym_update_expression] = STATE(3211),
    [sym_regex] = STATE(3211),
    [sym_meta_property] = STATE(3211),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3211),
    [sym_yield_expression] = STATE(3211),
    [sym_as_expression] = STATE(3211),
    [sym_non_null_expression] = STATE(3211),
    [sym_internal_module] = STATE(3211),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3211),
    [sym_await_expression] = STATE(3211),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3211),
    [sym_this] = STATE(3211),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3211),
    [sym_generator_function] = STATE(3211),
    [sym_call_expression] = STATE(3211),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3211),
    [sym_ternary_expression] = STATE(3211),
    [sym_binary_expression] = STATE(3211),
    [sym_template_string] = STATE(3211),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3211),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3211),
    [sym_class] = STATE(3211),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6585),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6585),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6587),
    [sym_true] = ACTIONS(6585),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6585),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2375] = {
    [sym_new_expression] = STATE(3212),
    [sym_augmented_assignment_expression] = STATE(3212),
    [sym_unary_expression] = STATE(3212),
    [sym_update_expression] = STATE(3212),
    [sym_regex] = STATE(3212),
    [sym_meta_property] = STATE(3212),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3212),
    [sym_yield_expression] = STATE(3212),
    [sym_as_expression] = STATE(3212),
    [sym_non_null_expression] = STATE(3212),
    [sym_internal_module] = STATE(3212),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3212),
    [sym_await_expression] = STATE(3212),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(3213),
    [sym_string] = STATE(3212),
    [sym_this] = STATE(3212),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3212),
    [sym_generator_function] = STATE(3212),
    [sym_call_expression] = STATE(3212),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3212),
    [sym_ternary_expression] = STATE(3212),
    [sym_binary_expression] = STATE(3212),
    [sym_template_string] = STATE(3212),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3212),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3212),
    [sym_class] = STATE(3212),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(6589),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6589),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6591),
    [sym_true] = ACTIONS(6589),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6589),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2376] = {
    [anon_sym_COLON] = ACTIONS(6593),
    [sym_comment] = ACTIONS(3),
  },
  [2377] = {
    [sym_string] = STATE(3183),
    [sym__property_name] = STATE(3183),
    [sym_computed_property_name] = STATE(3183),
    [anon_sym_get] = ACTIONS(6595),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6537),
    [anon_sym_STAR] = ACTIONS(6597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(6595),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2378] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6599),
    [anon_sym_LBRACK] = ACTIONS(6599),
    [anon_sym_BANG] = ACTIONS(6601),
    [anon_sym_SEMI] = ACTIONS(6599),
    [anon_sym_BQUOTE] = ACTIONS(6599),
    [sym__automatic_semicolon] = ACTIONS(6599),
    [anon_sym_PIPE] = ACTIONS(6601),
    [anon_sym_COMMA] = ACTIONS(6599),
    [anon_sym_LT_LT] = ACTIONS(6599),
    [anon_sym_STAR] = ACTIONS(6601),
    [anon_sym_GT_GT_GT] = ACTIONS(6599),
    [anon_sym_EQ] = ACTIONS(6601),
    [anon_sym_AMP_AMP] = ACTIONS(6599),
    [anon_sym_DASH] = ACTIONS(6601),
    [anon_sym_BANG_EQ] = ACTIONS(6601),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_LPAREN] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6599),
    [anon_sym_of] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_AMP] = ACTIONS(6601),
    [anon_sym_PERCENT] = ACTIONS(6599),
    [anon_sym_QMARK] = ACTIONS(6599),
    [anon_sym_RBRACE] = ACTIONS(6599),
    [anon_sym_as] = ACTIONS(6599),
    [anon_sym_PIPE_PIPE] = ACTIONS(6599),
    [anon_sym_DASH_DASH] = ACTIONS(6599),
    [anon_sym_EQ_EQ] = ACTIONS(6601),
    [anon_sym_instanceof] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_RPAREN] = ACTIONS(6599),
    [anon_sym_SLASH] = ACTIONS(6601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6599),
    [anon_sym_CARET] = ACTIONS(6599),
    [anon_sym_STAR_STAR] = ACTIONS(6599),
    [anon_sym_PLUS] = ACTIONS(6601),
    [anon_sym_GT_GT] = ACTIONS(6601),
    [anon_sym_PLUS_PLUS] = ACTIONS(6599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6599),
    [anon_sym_in] = ACTIONS(6601),
  },
  [2379] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6603),
    [anon_sym_AMP_EQ] = ACTIONS(6603),
    [anon_sym_PLUS_EQ] = ACTIONS(6603),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6603),
    [anon_sym_STAR_EQ] = ACTIONS(6603),
    [anon_sym_PIPE_EQ] = ACTIONS(6603),
    [anon_sym_DASH_EQ] = ACTIONS(6603),
    [anon_sym_EQ_GT] = ACTIONS(6607),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6603),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT_EQ] = ACTIONS(6603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6609),
  },
  [2380] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6611),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_AMP_EQ] = ACTIONS(6611),
    [anon_sym_PLUS_EQ] = ACTIONS(6611),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6611),
    [anon_sym_STAR_EQ] = ACTIONS(6611),
    [anon_sym_PIPE_EQ] = ACTIONS(6611),
    [anon_sym_DASH_EQ] = ACTIONS(6611),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6611),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(6611),
    [anon_sym_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6611),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2381] = {
    [sym_new_expression] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(3223),
    [sym_unary_expression] = STATE(3223),
    [sym_update_expression] = STATE(3223),
    [sym_regex] = STATE(3223),
    [sym_meta_property] = STATE(3223),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3223),
    [sym_yield_expression] = STATE(3223),
    [sym_as_expression] = STATE(3223),
    [sym_non_null_expression] = STATE(3223),
    [sym_internal_module] = STATE(3223),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3223),
    [sym_await_expression] = STATE(3223),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3223),
    [sym_this] = STATE(3223),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3223),
    [sym_generator_function] = STATE(3223),
    [sym_call_expression] = STATE(3223),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3223),
    [sym_ternary_expression] = STATE(3223),
    [sym_binary_expression] = STATE(3223),
    [sym_template_string] = STATE(3223),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3223),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3223),
    [sym_class] = STATE(3223),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(6615),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6615),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6617),
    [sym_true] = ACTIONS(6615),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6615),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [2382] = {
    [sym_new_expression] = STATE(3224),
    [sym_augmented_assignment_expression] = STATE(3224),
    [sym_unary_expression] = STATE(3224),
    [sym_update_expression] = STATE(3224),
    [sym_regex] = STATE(3224),
    [sym_meta_property] = STATE(3224),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3224),
    [sym_yield_expression] = STATE(3224),
    [sym_as_expression] = STATE(3224),
    [sym_non_null_expression] = STATE(3224),
    [sym_internal_module] = STATE(3224),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3224),
    [sym_await_expression] = STATE(3224),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3224),
    [sym_this] = STATE(3224),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3224),
    [sym_generator_function] = STATE(3224),
    [sym_call_expression] = STATE(3224),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3224),
    [sym_ternary_expression] = STATE(3224),
    [sym_binary_expression] = STATE(3224),
    [sym_template_string] = STATE(3224),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3224),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3224),
    [sym_class] = STATE(3224),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(6619),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6619),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6621),
    [sym_true] = ACTIONS(6619),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6619),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [2383] = {
    [sym_new_expression] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(3223),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(3223),
    [sym_update_expression] = STATE(3223),
    [sym_regex] = STATE(3223),
    [sym_meta_property] = STATE(3223),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3223),
    [sym_yield_expression] = STATE(3223),
    [sym_as_expression] = STATE(3223),
    [sym_non_null_expression] = STATE(3223),
    [sym_internal_module] = STATE(3223),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3223),
    [sym_await_expression] = STATE(3223),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3223),
    [sym_this] = STATE(3223),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3223),
    [sym_generator_function] = STATE(3223),
    [sym_call_expression] = STATE(3223),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3223),
    [sym_ternary_expression] = STATE(3223),
    [sym_binary_expression] = STATE(3223),
    [sym_template_string] = STATE(3223),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3223),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3223),
    [sym_class] = STATE(3223),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(6611),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_AMP_EQ] = ACTIONS(6611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6611),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(6611),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_PIPE_EQ] = ACTIONS(6611),
    [anon_sym_DASH_EQ] = ACTIONS(6611),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6611),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(5006),
    [sym_true] = ACTIONS(6615),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6611),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6615),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6615),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_STAR_EQ] = ACTIONS(6611),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6617),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6611),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6615),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2384] = {
    [sym_call_signature] = STATE(3225),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(6623),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6611),
    [anon_sym_symbol] = ACTIONS(6625),
    [anon_sym_AMP_EQ] = ACTIONS(6611),
    [anon_sym_PLUS_EQ] = ACTIONS(6611),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_void] = ACTIONS(6625),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(6611),
    [anon_sym_private] = ACTIONS(6625),
    [anon_sym_PIPE_EQ] = ACTIONS(6611),
    [anon_sym_DASH_EQ] = ACTIONS(6611),
    [anon_sym_get] = ACTIONS(6625),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6611),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(6625),
    [anon_sym_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(6625),
    [anon_sym_type] = ACTIONS(6625),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(6625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6611),
    [anon_sym_namespace] = ACTIONS(6625),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(6625),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_number] = ACTIONS(6625),
    [anon_sym_declare] = ACTIONS(6625),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(6625),
    [anon_sym_STAR_EQ] = ACTIONS(6611),
    [anon_sym_boolean] = ACTIONS(6625),
    [anon_sym_async] = ACTIONS(6625),
    [anon_sym_public] = ACTIONS(6625),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6611),
    [anon_sym_string] = ACTIONS(6625),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(6625),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2385] = {
    [sym_new_expression] = STATE(3227),
    [sym_augmented_assignment_expression] = STATE(3227),
    [sym_unary_expression] = STATE(3227),
    [sym_update_expression] = STATE(3227),
    [sym_regex] = STATE(3227),
    [sym_meta_property] = STATE(3227),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3227),
    [sym_yield_expression] = STATE(3227),
    [sym_as_expression] = STATE(3227),
    [sym_non_null_expression] = STATE(3227),
    [sym_internal_module] = STATE(3227),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3227),
    [sym_await_expression] = STATE(3227),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3227),
    [sym_this] = STATE(3227),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3227),
    [sym_generator_function] = STATE(3227),
    [sym_call_expression] = STATE(3227),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3227),
    [sym_ternary_expression] = STATE(3227),
    [sym_binary_expression] = STATE(3227),
    [sym_template_string] = STATE(3227),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3227),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3227),
    [sym_class] = STATE(3227),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(6627),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6627),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6629),
    [sym_true] = ACTIONS(6627),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6627),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [2386] = {
    [sym_new_expression] = STATE(3228),
    [sym_augmented_assignment_expression] = STATE(3228),
    [sym_unary_expression] = STATE(3228),
    [sym_update_expression] = STATE(3228),
    [sym_regex] = STATE(3228),
    [sym_meta_property] = STATE(3228),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3228),
    [sym_yield_expression] = STATE(3228),
    [sym_as_expression] = STATE(3228),
    [sym_non_null_expression] = STATE(3228),
    [sym_internal_module] = STATE(3228),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3228),
    [sym_await_expression] = STATE(3228),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3228),
    [sym_this] = STATE(3228),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3228),
    [sym_generator_function] = STATE(3228),
    [sym_call_expression] = STATE(3228),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3228),
    [sym_ternary_expression] = STATE(3228),
    [sym_binary_expression] = STATE(3228),
    [sym_template_string] = STATE(3228),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3228),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3228),
    [sym_class] = STATE(3228),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(5006),
    [sym_true] = ACTIONS(6631),
    [anon_sym_COLON] = ACTIONS(211),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6631),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6631),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6633),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6631),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [2387] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(6635),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(6637),
    [anon_sym_symbol] = ACTIONS(6637),
    [anon_sym_number] = ACTIONS(6637),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(6637),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(6639),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6637),
    [anon_sym_private] = ACTIONS(6637),
    [anon_sym_boolean] = ACTIONS(6637),
    [anon_sym_async] = ACTIONS(6641),
    [anon_sym_public] = ACTIONS(6637),
    [anon_sym_get] = ACTIONS(6637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(6637),
    [anon_sym_string] = ACTIONS(6637),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(6637),
    [anon_sym_type] = ACTIONS(6637),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(6637),
    [anon_sym_export] = ACTIONS(6637),
    [anon_sym_namespace] = ACTIONS(6643),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [2388] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(6611),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_AMP_EQ] = ACTIONS(6611),
    [anon_sym_PLUS_EQ] = ACTIONS(6611),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6611),
    [anon_sym_STAR_EQ] = ACTIONS(6611),
    [anon_sym_PIPE_EQ] = ACTIONS(6611),
    [anon_sym_DASH_EQ] = ACTIONS(6611),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6611),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(6611),
    [anon_sym_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6611),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2389] = {
    [sym_new_expression] = STATE(3234),
    [sym_augmented_assignment_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3234),
    [sym_update_expression] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_meta_property] = STATE(3234),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3234),
    [sym_yield_expression] = STATE(3234),
    [sym_as_expression] = STATE(3234),
    [sym_non_null_expression] = STATE(3234),
    [sym_internal_module] = STATE(3234),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3234),
    [sym_await_expression] = STATE(3234),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3234),
    [sym_this] = STATE(3234),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3234),
    [sym_generator_function] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3234),
    [sym_ternary_expression] = STATE(3234),
    [sym_binary_expression] = STATE(3234),
    [sym_template_string] = STATE(3234),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3234),
    [sym_class] = STATE(3234),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(6645),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6645),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6647),
    [sym_true] = ACTIONS(6645),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6645),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [2390] = {
    [anon_sym_EQ_GT] = ACTIONS(6607),
    [sym_comment] = ACTIONS(3),
  },
  [2391] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6609),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(6653),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6673),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2392] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6603),
    [anon_sym_AMP_EQ] = ACTIONS(6603),
    [anon_sym_PLUS_EQ] = ACTIONS(6603),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6603),
    [anon_sym_STAR_EQ] = ACTIONS(6603),
    [anon_sym_PIPE_EQ] = ACTIONS(6603),
    [anon_sym_DASH_EQ] = ACTIONS(6603),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6603),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT_EQ] = ACTIONS(6603),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2393] = {
    [anon_sym_COLON] = ACTIONS(6673),
    [sym_comment] = ACTIONS(3),
  },
  [2394] = {
    [sym__initializer] = STATE(577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6609),
  },
  [2395] = {
    [sym_new_expression] = STATE(579),
    [sym_augmented_assignment_expression] = STATE(579),
    [sym_unary_expression] = STATE(579),
    [sym_update_expression] = STATE(579),
    [sym_regex] = STATE(579),
    [sym_meta_property] = STATE(579),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(579),
    [sym_yield_expression] = STATE(579),
    [sym_as_expression] = STATE(579),
    [sym_non_null_expression] = STATE(579),
    [sym_internal_module] = STATE(579),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(579),
    [sym_await_expression] = STATE(579),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(579),
    [sym_this] = STATE(579),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(579),
    [sym_generator_function] = STATE(579),
    [sym_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(579),
    [sym_ternary_expression] = STATE(579),
    [sym_binary_expression] = STATE(579),
    [sym_template_string] = STATE(579),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(579),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(579),
    [sym_class] = STATE(579),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1059),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1061),
    [sym_true] = ACTIONS(1059),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [2396] = {
    [sym__initializer] = STATE(580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6609),
  },
  [2397] = {
    [sym_type_alias_declaration] = STATE(3252),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3252),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3252),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3252),
    [sym_return_statement] = STATE(3252),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3252),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3252),
    [sym_switch_statement] = STATE(3252),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3252),
    [sym_throw_statement] = STATE(3252),
    [aux_sym_program_repeat1] = STATE(3252),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3252),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3252),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3252),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3252),
    [sym_abstract_class] = STATE(3252),
    [sym_interface_declaration] = STATE(3252),
    [sym_statement_block] = STATE(3252),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3252),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3252),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3252),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3252),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3252),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3252),
    [sym_empty_statement] = STATE(3252),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3252),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3252),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3252),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3252),
    [sym_break_statement] = STATE(3252),
    [sym_labeled_statement] = STATE(3252),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3252),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(6679),
    [anon_sym_default] = ACTIONS(6681),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(6681),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [2398] = {
    [sym_identifier] = ACTIONS(6695),
    [anon_sym_BQUOTE] = ACTIONS(6697),
    [anon_sym_debugger] = ACTIONS(6695),
    [anon_sym_symbol] = ACTIONS(6695),
    [anon_sym_AT] = ACTIONS(6697),
    [anon_sym_DASH] = ACTIONS(6695),
    [anon_sym_void] = ACTIONS(6695),
    [anon_sym_break] = ACTIONS(6695),
    [anon_sym_const] = ACTIONS(6695),
    [sym_super] = ACTIONS(6695),
    [anon_sym_return] = ACTIONS(6695),
    [anon_sym_private] = ACTIONS(6695),
    [anon_sym_get] = ACTIONS(6695),
    [anon_sym_RBRACE] = ACTIONS(6697),
    [anon_sym_interface] = ACTIONS(6695),
    [anon_sym_default] = ACTIONS(6695),
    [anon_sym_enum] = ACTIONS(6695),
    [anon_sym_delete] = ACTIONS(6695),
    [anon_sym_continue] = ACTIONS(6695),
    [anon_sym_DASH_DASH] = ACTIONS(6697),
    [anon_sym_if] = ACTIONS(6695),
    [anon_sym_this] = ACTIONS(6695),
    [anon_sym_yield] = ACTIONS(6695),
    [sym_true] = ACTIONS(6695),
    [anon_sym_throw] = ACTIONS(6695),
    [anon_sym_protected] = ACTIONS(6695),
    [anon_sym_abstract] = ACTIONS(6695),
    [anon_sym_set] = ACTIONS(6695),
    [anon_sym_type] = ACTIONS(6695),
    [anon_sym_import] = ACTIONS(6695),
    [anon_sym_namespace] = ACTIONS(6695),
    [anon_sym_PLUS_PLUS] = ACTIONS(6697),
    [anon_sym_await] = ACTIONS(6695),
    [anon_sym_DQUOTE] = ACTIONS(6697),
    [anon_sym_else] = ACTIONS(6695),
    [anon_sym_BANG] = ACTIONS(6697),
    [anon_sym_for] = ACTIONS(6695),
    [anon_sym_LBRACK] = ACTIONS(6697),
    [sym_false] = ACTIONS(6695),
    [anon_sym_SEMI] = ACTIONS(6697),
    [anon_sym_case] = ACTIONS(6695),
    [anon_sym_module] = ACTIONS(6695),
    [anon_sym_number] = ACTIONS(6695),
    [anon_sym_class] = ACTIONS(6695),
    [anon_sym_declare] = ACTIONS(6695),
    [anon_sym_typeof] = ACTIONS(6695),
    [anon_sym_LBRACE] = ACTIONS(6697),
    [anon_sym_switch] = ACTIONS(6695),
    [anon_sym_LPAREN] = ACTIONS(6697),
    [sym_null] = ACTIONS(6695),
    [anon_sym_any] = ACTIONS(6695),
    [anon_sym_boolean] = ACTIONS(6695),
    [anon_sym_async] = ACTIONS(6695),
    [anon_sym_public] = ACTIONS(6695),
    [anon_sym_var] = ACTIONS(6695),
    [anon_sym_while] = ACTIONS(6695),
    [anon_sym_SQUOTE] = ACTIONS(6697),
    [anon_sym_try] = ACTIONS(6695),
    [anon_sym_LT] = ACTIONS(6697),
    [sym_number] = ACTIONS(6697),
    [anon_sym_SLASH] = ACTIONS(6695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6695),
    [anon_sym_function] = ACTIONS(6695),
    [sym_undefined] = ACTIONS(6695),
    [anon_sym_new] = ACTIONS(6695),
    [ts_builtin_sym_end] = ACTIONS(6697),
    [anon_sym_let] = ACTIONS(6695),
    [anon_sym_PLUS] = ACTIONS(6695),
    [anon_sym_export] = ACTIONS(6695),
    [anon_sym_do] = ACTIONS(6695),
    [anon_sym_TILDE] = ACTIONS(6697),
    [anon_sym_with] = ACTIONS(6695),
  },
  [2399] = {
    [sym_switch_default] = STATE(2399),
    [aux_sym_switch_body_repeat1] = STATE(2399),
    [sym_switch_case] = STATE(2399),
    [anon_sym_RBRACE] = ACTIONS(6699),
    [anon_sym_default] = ACTIONS(6701),
    [anon_sym_case] = ACTIONS(6704),
    [sym_comment] = ACTIONS(3),
  },
  [2400] = {
    [anon_sym_COMMA] = ACTIONS(6707),
    [anon_sym_RPAREN] = ACTIONS(6707),
    [sym_comment] = ACTIONS(3),
  },
  [2401] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3257),
    [sym_constructor_type] = STATE(3257),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(3257),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3257),
    [sym_intersection_type] = STATE(3257),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2402] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3260),
    [sym_constructor_type] = STATE(3260),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(3260),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3260),
    [sym_intersection_type] = STATE(3260),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2403] = {
    [anon_sym_EQ_GT] = ACTIONS(6715),
    [sym_comment] = ACTIONS(3),
  },
  [2404] = {
    [sym_formal_parameters] = STATE(3262),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2405] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1460),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1462),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2406] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1460),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1462),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2407] = {
    [anon_sym_EQ_GT] = ACTIONS(6717),
    [sym_comment] = ACTIONS(3),
  },
  [2408] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3264),
    [sym_constructor_type] = STATE(3264),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(3264),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3264),
    [sym_intersection_type] = STATE(3264),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2409] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3265),
    [sym_constructor_type] = STATE(3265),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(3265),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3265),
    [sym_intersection_type] = STATE(3265),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1460),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1462),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2410] = {
    [anon_sym_COMMA] = ACTIONS(6719),
    [anon_sym_RPAREN] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
  },
  [2411] = {
    [sym__initializer] = STATE(3266),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(6719),
    [anon_sym_COMMA] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
  },
  [2412] = {
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_RPAREN] = ACTIONS(6721),
    [sym_comment] = ACTIONS(3),
  },
  [2413] = {
    [sym__initializer] = STATE(3267),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(6707),
    [anon_sym_COMMA] = ACTIONS(6707),
    [sym_comment] = ACTIONS(3),
  },
  [2414] = {
    [anon_sym_COMMA] = ACTIONS(6723),
    [anon_sym_RPAREN] = ACTIONS(6723),
    [sym_comment] = ACTIONS(3),
  },
  [2415] = {
    [anon_sym_COMMA] = ACTIONS(6725),
    [anon_sym_RPAREN] = ACTIONS(6725),
    [sym_comment] = ACTIONS(3),
  },
  [2416] = {
    [sym__initializer] = STATE(3268),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(6725),
    [anon_sym_COMMA] = ACTIONS(6725),
    [sym_comment] = ACTIONS(3),
  },
  [2417] = {
    [anon_sym_COMMA] = ACTIONS(6727),
    [anon_sym_RPAREN] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
  },
  [2418] = {
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_RPAREN] = ACTIONS(6729),
    [sym_comment] = ACTIONS(3),
  },
  [2419] = {
    [sym__initializer] = STATE(3269),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [sym_comment] = ACTIONS(3),
  },
  [2420] = {
    [anon_sym_COMMA] = ACTIONS(6731),
    [anon_sym_RPAREN] = ACTIONS(6731),
    [sym_comment] = ACTIONS(3),
  },
  [2421] = {
    [anon_sym_COMMA] = ACTIONS(6733),
    [anon_sym_RPAREN] = ACTIONS(6733),
    [sym_comment] = ACTIONS(3),
  },
  [2422] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_is] = ACTIONS(6735),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6737),
  },
  [2423] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2424] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2428),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2430),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5060),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2425] = {
    [sym_formal_parameters] = STATE(3272),
    [sym_type_parameters] = STATE(3273),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2426] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2428),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2430),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5060),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2427] = {
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(3744),
    [sym_comment] = ACTIONS(3),
  },
  [2428] = {
    [sym_formal_parameters] = STATE(3276),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2429] = {
    [sym_type_arguments] = STATE(850),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6743),
  },
  [2430] = {
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
  },
  [2431] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(5130),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5130),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [2432] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(5134),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5134),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [2433] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2285),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2285),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_COMMA] = ACTIONS(2285),
    [anon_sym_LT_LT] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2287),
    [anon_sym_GT_GT_GT] = ACTIONS(2285),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_LT_EQ] = ACTIONS(2285),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_GT_EQ] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_EQ_GT] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_PERCENT] = ACTIONS(2285),
    [anon_sym_QMARK] = ACTIONS(2285),
    [anon_sym_as] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2285),
    [anon_sym_DASH_DASH] = ACTIONS(2285),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_RPAREN] = ACTIONS(2285),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_instanceof] = ACTIONS(2285),
    [anon_sym_SLASH] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2285),
    [anon_sym_DOT] = ACTIONS(2285),
    [anon_sym_CARET] = ACTIONS(2285),
    [anon_sym_STAR_STAR] = ACTIONS(2285),
    [anon_sym_PLUS] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2285),
    [anon_sym_in] = ACTIONS(2287),
  },
  [2434] = {
    [anon_sym_COMMA] = ACTIONS(6747),
    [anon_sym_RPAREN] = ACTIONS(6747),
    [sym_comment] = ACTIONS(3),
  },
  [2435] = {
    [anon_sym_COLON] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6749),
  },
  [2436] = {
    [aux_sym_export_statement_repeat1] = STATE(1485),
    [sym_decorator] = STATE(1485),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(1486),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(1486),
    [sym_optional_parameter] = STATE(1486),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [2437] = {
    [sym_new_expression] = STATE(3279),
    [sym_augmented_assignment_expression] = STATE(3279),
    [sym_unary_expression] = STATE(3279),
    [sym_update_expression] = STATE(3279),
    [sym_regex] = STATE(3279),
    [sym_meta_property] = STATE(3279),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(3279),
    [sym_yield_expression] = STATE(3279),
    [sym_as_expression] = STATE(3279),
    [sym_non_null_expression] = STATE(3279),
    [sym_internal_module] = STATE(3279),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3279),
    [sym_await_expression] = STATE(3279),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(3279),
    [sym_this] = STATE(3279),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(3279),
    [sym_generator_function] = STATE(3279),
    [sym_call_expression] = STATE(3279),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(3279),
    [sym_ternary_expression] = STATE(3279),
    [sym_binary_expression] = STATE(3279),
    [sym_template_string] = STATE(3279),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3279),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(3279),
    [sym_class] = STATE(3279),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(835),
    [sym_false] = ACTIONS(6751),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6751),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6753),
    [sym_true] = ACTIONS(6751),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6751),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [2438] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3280),
    [sym_constructor_type] = STATE(3280),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(3280),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3280),
    [sym_intersection_type] = STATE(3280),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2439] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3281),
    [sym_constructor_type] = STATE(3281),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(3281),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3281),
    [sym_intersection_type] = STATE(3281),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2440] = {
    [anon_sym_EQ_GT] = ACTIONS(6755),
    [sym_comment] = ACTIONS(3),
  },
  [2441] = {
    [sym_formal_parameters] = STATE(3283),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2442] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2443] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2444] = {
    [anon_sym_EQ_GT] = ACTIONS(6757),
    [sym_comment] = ACTIONS(3),
  },
  [2445] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3285),
    [sym_constructor_type] = STATE(3285),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(3285),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3285),
    [sym_intersection_type] = STATE(3285),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2446] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3286),
    [sym_constructor_type] = STATE(3286),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(3286),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3286),
    [sym_intersection_type] = STATE(3286),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2447] = {
    [sym_new_expression] = STATE(1449),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(1449),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1449),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1449),
    [sym_call_signature] = STATE(242),
    [sym_yield_expression] = STATE(1449),
    [sym_as_expression] = STATE(1449),
    [sym_internal_module] = STATE(1449),
    [sym_arrow_function] = STATE(1449),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(245),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(470),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(1449),
    [sym_subscript_expression] = STATE(245),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1449),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1449),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1449),
    [sym_meta_property] = STATE(1449),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(1449),
    [sym_non_null_expression] = STATE(1449),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1449),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1449),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1449),
    [sym_call_expression] = STATE(1449),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1449),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1449),
    [sym_type_arguments] = STATE(251),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(1449),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1449),
    [sym_class] = STATE(1449),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(3144),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(3146),
    [anon_sym_number] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(3148),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(3152),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(3031),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3146),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(3146),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(3146),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3031),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(6759),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [2448] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(6247),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1331),
  },
  [2449] = {
    [sym__initializer] = STATE(3288),
    [sym_type_annotation] = STATE(3289),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(6761),
    [anon_sym_COMMA] = ACTIONS(6761),
    [sym_comment] = ACTIONS(3),
  },
  [2450] = {
    [anon_sym_COMMA] = ACTIONS(6763),
    [anon_sym_RPAREN] = ACTIONS(6763),
    [sym_comment] = ACTIONS(3),
  },
  [2451] = {
    [sym__initializer] = STATE(3290),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(6763),
    [anon_sym_COMMA] = ACTIONS(6763),
    [sym_comment] = ACTIONS(3),
  },
  [2452] = {
    [sym__initializer] = STATE(3267),
    [sym_type_annotation] = STATE(3291),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(6707),
    [anon_sym_COMMA] = ACTIONS(6707),
    [sym_comment] = ACTIONS(3),
  },
  [2453] = {
    [sym__initializer] = STATE(3292),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(6723),
    [anon_sym_COMMA] = ACTIONS(6723),
    [sym_comment] = ACTIONS(3),
  },
  [2454] = {
    [sym__initializer] = STATE(3293),
    [sym_type_annotation] = STATE(3294),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(6765),
    [anon_sym_COMMA] = ACTIONS(6765),
    [sym_comment] = ACTIONS(3),
  },
  [2455] = {
    [anon_sym_COMMA] = ACTIONS(6767),
    [anon_sym_RPAREN] = ACTIONS(6767),
    [sym_comment] = ACTIONS(3),
  },
  [2456] = {
    [sym__initializer] = STATE(3295),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(6767),
    [anon_sym_COMMA] = ACTIONS(6767),
    [sym_comment] = ACTIONS(3),
  },
  [2457] = {
    [sym__initializer] = STATE(3296),
    [sym_type_annotation] = STATE(3297),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(6769),
    [anon_sym_COMMA] = ACTIONS(6769),
    [sym_comment] = ACTIONS(3),
  },
  [2458] = {
    [anon_sym_COMMA] = ACTIONS(6771),
    [anon_sym_RPAREN] = ACTIONS(6771),
    [sym_comment] = ACTIONS(3),
  },
  [2459] = {
    [sym__initializer] = STATE(3298),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(6771),
    [anon_sym_COMMA] = ACTIONS(6771),
    [sym_comment] = ACTIONS(3),
  },
  [2460] = {
    [aux_sym_export_statement_repeat1] = STATE(1485),
    [sym_decorator] = STATE(1485),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(1486),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(1486),
    [sym_optional_parameter] = STATE(1486),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(6773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [2461] = {
    [anon_sym_COMMA] = ACTIONS(6775),
    [anon_sym_RPAREN] = ACTIONS(6775),
    [sym_comment] = ACTIONS(3),
  },
  [2462] = {
    [anon_sym_COMMA] = ACTIONS(6777),
    [anon_sym_RPAREN] = ACTIONS(6777),
    [sym_comment] = ACTIONS(3),
  },
  [2463] = {
    [sym_identifier] = ACTIONS(6779),
    [anon_sym_BQUOTE] = ACTIONS(6781),
    [anon_sym_debugger] = ACTIONS(6779),
    [anon_sym_symbol] = ACTIONS(6779),
    [anon_sym_AT] = ACTIONS(6781),
    [anon_sym_DASH] = ACTIONS(6779),
    [anon_sym_void] = ACTIONS(6779),
    [anon_sym_break] = ACTIONS(6779),
    [anon_sym_const] = ACTIONS(6779),
    [sym_super] = ACTIONS(6779),
    [anon_sym_return] = ACTIONS(6779),
    [anon_sym_private] = ACTIONS(6779),
    [anon_sym_get] = ACTIONS(6779),
    [anon_sym_RBRACE] = ACTIONS(6781),
    [anon_sym_interface] = ACTIONS(6779),
    [anon_sym_default] = ACTIONS(6779),
    [anon_sym_enum] = ACTIONS(6779),
    [anon_sym_delete] = ACTIONS(6779),
    [anon_sym_continue] = ACTIONS(6779),
    [anon_sym_DASH_DASH] = ACTIONS(6781),
    [anon_sym_if] = ACTIONS(6779),
    [anon_sym_this] = ACTIONS(6779),
    [anon_sym_yield] = ACTIONS(6779),
    [sym_true] = ACTIONS(6779),
    [anon_sym_throw] = ACTIONS(6779),
    [anon_sym_protected] = ACTIONS(6779),
    [anon_sym_abstract] = ACTIONS(6779),
    [anon_sym_set] = ACTIONS(6779),
    [anon_sym_type] = ACTIONS(6779),
    [anon_sym_import] = ACTIONS(6779),
    [anon_sym_namespace] = ACTIONS(6779),
    [anon_sym_PLUS_PLUS] = ACTIONS(6781),
    [anon_sym_await] = ACTIONS(6779),
    [anon_sym_DQUOTE] = ACTIONS(6781),
    [anon_sym_else] = ACTIONS(6779),
    [anon_sym_BANG] = ACTIONS(6781),
    [anon_sym_for] = ACTIONS(6779),
    [anon_sym_LBRACK] = ACTIONS(6781),
    [sym_false] = ACTIONS(6779),
    [anon_sym_SEMI] = ACTIONS(6781),
    [anon_sym_case] = ACTIONS(6779),
    [anon_sym_module] = ACTIONS(6779),
    [anon_sym_number] = ACTIONS(6779),
    [anon_sym_class] = ACTIONS(6779),
    [anon_sym_declare] = ACTIONS(6779),
    [anon_sym_typeof] = ACTIONS(6779),
    [anon_sym_LBRACE] = ACTIONS(6781),
    [anon_sym_switch] = ACTIONS(6779),
    [anon_sym_LPAREN] = ACTIONS(6781),
    [sym_null] = ACTIONS(6779),
    [anon_sym_any] = ACTIONS(6779),
    [anon_sym_boolean] = ACTIONS(6779),
    [anon_sym_async] = ACTIONS(6779),
    [anon_sym_public] = ACTIONS(6779),
    [anon_sym_var] = ACTIONS(6779),
    [anon_sym_while] = ACTIONS(6779),
    [anon_sym_SQUOTE] = ACTIONS(6781),
    [anon_sym_try] = ACTIONS(6779),
    [anon_sym_LT] = ACTIONS(6781),
    [sym_number] = ACTIONS(6781),
    [anon_sym_SLASH] = ACTIONS(6779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6779),
    [anon_sym_function] = ACTIONS(6779),
    [sym_undefined] = ACTIONS(6779),
    [anon_sym_new] = ACTIONS(6779),
    [ts_builtin_sym_end] = ACTIONS(6781),
    [anon_sym_let] = ACTIONS(6779),
    [anon_sym_PLUS] = ACTIONS(6779),
    [anon_sym_export] = ACTIONS(6779),
    [anon_sym_do] = ACTIONS(6779),
    [anon_sym_TILDE] = ACTIONS(6781),
    [anon_sym_with] = ACTIONS(6779),
  },
  [2464] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6783),
    [sym_identifier] = ACTIONS(6785),
    [sym__automatic_semicolon] = ACTIONS(6783),
    [anon_sym_BQUOTE] = ACTIONS(6783),
    [anon_sym_debugger] = ACTIONS(6785),
    [ts_builtin_sym_end] = ACTIONS(6783),
    [anon_sym_symbol] = ACTIONS(6785),
    [anon_sym_AT] = ACTIONS(6783),
    [anon_sym_PIPE] = ACTIONS(6785),
    [anon_sym_COMMA] = ACTIONS(6783),
    [anon_sym_DASH] = ACTIONS(6785),
    [anon_sym_STAR] = ACTIONS(6785),
    [anon_sym_GT_GT_GT] = ACTIONS(6783),
    [anon_sym_void] = ACTIONS(6785),
    [anon_sym_break] = ACTIONS(6785),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_const] = ACTIONS(6785),
    [anon_sym_GT_EQ] = ACTIONS(6783),
    [sym_super] = ACTIONS(6785),
    [anon_sym_return] = ACTIONS(6785),
    [anon_sym_private] = ACTIONS(6785),
    [anon_sym_get] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(6783),
    [anon_sym_PERCENT] = ACTIONS(6783),
    [anon_sym_interface] = ACTIONS(6785),
    [anon_sym_default] = ACTIONS(6785),
    [anon_sym_as] = ACTIONS(6785),
    [anon_sym_delete] = ACTIONS(6785),
    [anon_sym_continue] = ACTIONS(6785),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_if] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6785),
    [anon_sym_this] = ACTIONS(6785),
    [anon_sym_yield] = ACTIONS(6785),
    [sym_true] = ACTIONS(6785),
    [anon_sym_throw] = ACTIONS(6785),
    [anon_sym_enum] = ACTIONS(6785),
    [anon_sym_protected] = ACTIONS(6785),
    [anon_sym_abstract] = ACTIONS(6785),
    [anon_sym_DOT] = ACTIONS(6785),
    [anon_sym_set] = ACTIONS(6785),
    [anon_sym_type] = ACTIONS(6785),
    [anon_sym_STAR_STAR] = ACTIONS(6783),
    [anon_sym_import] = ACTIONS(6785),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6783),
    [anon_sym_namespace] = ACTIONS(6785),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_await] = ACTIONS(6785),
    [anon_sym_DQUOTE] = ACTIONS(6783),
    [anon_sym_else] = ACTIONS(6785),
    [anon_sym_BANG] = ACTIONS(6785),
    [anon_sym_for] = ACTIONS(6785),
    [anon_sym_LBRACK] = ACTIONS(6783),
    [sym_false] = ACTIONS(6785),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym_case] = ACTIONS(6785),
    [anon_sym_module] = ACTIONS(6785),
    [anon_sym_number] = ACTIONS(6785),
    [anon_sym_class] = ACTIONS(6785),
    [anon_sym_declare] = ACTIONS(6785),
    [anon_sym_typeof] = ACTIONS(6785),
    [anon_sym_LT_LT] = ACTIONS(6783),
    [anon_sym_LBRACE] = ACTIONS(6783),
    [anon_sym_AMP_AMP] = ACTIONS(6783),
    [anon_sym_switch] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6783),
    [anon_sym_LPAREN] = ACTIONS(6783),
    [sym_null] = ACTIONS(6785),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_any] = ACTIONS(6785),
    [anon_sym_boolean] = ACTIONS(6785),
    [anon_sym_async] = ACTIONS(6785),
    [anon_sym_public] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6785),
    [anon_sym_var] = ACTIONS(6785),
    [anon_sym_QMARK] = ACTIONS(6783),
    [anon_sym_PIPE_PIPE] = ACTIONS(6783),
    [anon_sym_while] = ACTIONS(6785),
    [anon_sym_SQUOTE] = ACTIONS(6783),
    [anon_sym_try] = ACTIONS(6785),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_RPAREN] = ACTIONS(6783),
    [anon_sym_LT] = ACTIONS(6785),
    [sym_number] = ACTIONS(6783),
    [anon_sym_SLASH] = ACTIONS(6785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6785),
    [anon_sym_function] = ACTIONS(6785),
    [sym_undefined] = ACTIONS(6785),
    [anon_sym_new] = ACTIONS(6785),
    [anon_sym_CARET] = ACTIONS(6783),
    [anon_sym_let] = ACTIONS(6785),
    [anon_sym_PLUS] = ACTIONS(6785),
    [anon_sym_export] = ACTIONS(6785),
    [anon_sym_GT_GT] = ACTIONS(6785),
    [anon_sym_do] = ACTIONS(6785),
    [anon_sym_TILDE] = ACTIONS(6783),
    [anon_sym_with] = ACTIONS(6785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6783),
    [anon_sym_in] = ACTIONS(6785),
  },
  [2465] = {
    [anon_sym_RPAREN] = ACTIONS(6787),
    [sym_comment] = ACTIONS(3),
  },
  [2466] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3304),
    [sym_constructor_type] = STATE(3304),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(3304),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3304),
    [sym_intersection_type] = STATE(3304),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2467] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3307),
    [sym_constructor_type] = STATE(3307),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(3307),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3307),
    [sym_intersection_type] = STATE(3307),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2468] = {
    [anon_sym_EQ_GT] = ACTIONS(6795),
    [sym_comment] = ACTIONS(3),
  },
  [2469] = {
    [sym_formal_parameters] = STATE(3309),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2470] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1549),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1551),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2471] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1549),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1551),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2472] = {
    [anon_sym_EQ_GT] = ACTIONS(6797),
    [sym_comment] = ACTIONS(3),
  },
  [2473] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3311),
    [sym_constructor_type] = STATE(3311),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(3311),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3311),
    [sym_intersection_type] = STATE(3311),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2474] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3312),
    [sym_constructor_type] = STATE(3312),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(3312),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3312),
    [sym_intersection_type] = STATE(3312),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1549),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1551),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2475] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3316),
    [sym_constructor_type] = STATE(3316),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(3316),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3316),
    [sym_intersection_type] = STATE(3316),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2476] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3319),
    [sym_constructor_type] = STATE(3319),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(3319),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3319),
    [sym_intersection_type] = STATE(3319),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2477] = {
    [anon_sym_EQ_GT] = ACTIONS(6805),
    [sym_comment] = ACTIONS(3),
  },
  [2478] = {
    [sym_formal_parameters] = STATE(3321),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2479] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2480] = {
    [sym_identifier] = ACTIONS(6807),
    [anon_sym_BQUOTE] = ACTIONS(6809),
    [anon_sym_debugger] = ACTIONS(6807),
    [anon_sym_symbol] = ACTIONS(6807),
    [anon_sym_AT] = ACTIONS(6809),
    [anon_sym_PIPE] = ACTIONS(6809),
    [anon_sym_COMMA] = ACTIONS(6809),
    [anon_sym_DASH] = ACTIONS(6807),
    [anon_sym_EQ] = ACTIONS(6807),
    [anon_sym_void] = ACTIONS(6807),
    [anon_sym_break] = ACTIONS(6807),
    [anon_sym_const] = ACTIONS(6807),
    [sym_super] = ACTIONS(6807),
    [anon_sym_return] = ACTIONS(6807),
    [anon_sym_private] = ACTIONS(6807),
    [anon_sym_get] = ACTIONS(6807),
    [anon_sym_RBRACE] = ACTIONS(6809),
    [anon_sym_interface] = ACTIONS(6807),
    [anon_sym_default] = ACTIONS(6807),
    [anon_sym_enum] = ACTIONS(6807),
    [anon_sym_delete] = ACTIONS(6807),
    [anon_sym_continue] = ACTIONS(6807),
    [anon_sym_DASH_DASH] = ACTIONS(6809),
    [anon_sym_if] = ACTIONS(6807),
    [anon_sym_this] = ACTIONS(6807),
    [anon_sym_yield] = ACTIONS(6807),
    [sym_true] = ACTIONS(6807),
    [anon_sym_throw] = ACTIONS(6807),
    [anon_sym_protected] = ACTIONS(6807),
    [anon_sym_abstract] = ACTIONS(6807),
    [anon_sym_set] = ACTIONS(6807),
    [anon_sym_type] = ACTIONS(6807),
    [anon_sym_import] = ACTIONS(6807),
    [anon_sym_namespace] = ACTIONS(6807),
    [anon_sym_PLUS_PLUS] = ACTIONS(6809),
    [anon_sym_await] = ACTIONS(6807),
    [anon_sym_DQUOTE] = ACTIONS(6809),
    [anon_sym_else] = ACTIONS(6807),
    [anon_sym_BANG] = ACTIONS(6809),
    [anon_sym_for] = ACTIONS(6807),
    [anon_sym_LBRACK] = ACTIONS(6809),
    [sym_false] = ACTIONS(6807),
    [anon_sym_SEMI] = ACTIONS(6809),
    [anon_sym_case] = ACTIONS(6807),
    [anon_sym_module] = ACTIONS(6807),
    [anon_sym_number] = ACTIONS(6807),
    [anon_sym_class] = ACTIONS(6807),
    [anon_sym_declare] = ACTIONS(6807),
    [anon_sym_typeof] = ACTIONS(6807),
    [anon_sym_LBRACE] = ACTIONS(6809),
    [anon_sym_switch] = ACTIONS(6807),
    [anon_sym_LPAREN] = ACTIONS(6809),
    [anon_sym_RBRACK] = ACTIONS(6809),
    [sym_null] = ACTIONS(6807),
    [anon_sym_GT] = ACTIONS(6809),
    [anon_sym_any] = ACTIONS(6807),
    [anon_sym_boolean] = ACTIONS(6807),
    [anon_sym_async] = ACTIONS(6807),
    [anon_sym_public] = ACTIONS(6807),
    [anon_sym_EQ_GT] = ACTIONS(6809),
    [anon_sym_AMP] = ACTIONS(6809),
    [anon_sym_var] = ACTIONS(6807),
    [anon_sym_while] = ACTIONS(6807),
    [anon_sym_SQUOTE] = ACTIONS(6809),
    [anon_sym_try] = ACTIONS(6807),
    [anon_sym_RPAREN] = ACTIONS(6809),
    [anon_sym_LT] = ACTIONS(6809),
    [sym_number] = ACTIONS(6809),
    [anon_sym_SLASH] = ACTIONS(6807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6807),
    [anon_sym_function] = ACTIONS(6807),
    [sym_undefined] = ACTIONS(6807),
    [anon_sym_new] = ACTIONS(6807),
    [ts_builtin_sym_end] = ACTIONS(6809),
    [anon_sym_let] = ACTIONS(6807),
    [anon_sym_PLUS] = ACTIONS(6807),
    [anon_sym_export] = ACTIONS(6807),
    [anon_sym_do] = ACTIONS(6807),
    [anon_sym_TILDE] = ACTIONS(6809),
    [anon_sym_with] = ACTIONS(6807),
  },
  [2481] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2482] = {
    [anon_sym_EQ_GT] = ACTIONS(6811),
    [sym_comment] = ACTIONS(3),
  },
  [2483] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3323),
    [sym_constructor_type] = STATE(3323),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(3323),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3323),
    [sym_intersection_type] = STATE(3323),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2484] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3324),
    [sym_constructor_type] = STATE(3324),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(3324),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3324),
    [sym_intersection_type] = STATE(3324),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2485] = {
    [anon_sym_EQ_GT] = ACTIONS(6813),
    [sym_comment] = ACTIONS(3),
  },
  [2486] = {
    [sym_formal_parameters] = STATE(3326),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2487] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2488] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2489] = {
    [anon_sym_EQ_GT] = ACTIONS(6815),
    [sym_comment] = ACTIONS(3),
  },
  [2490] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3328),
    [sym_constructor_type] = STATE(3328),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(3328),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3328),
    [sym_intersection_type] = STATE(3328),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2491] = {
    [sym_predefined_type] = STATE(3329),
    [anon_sym_number] = ACTIONS(6333),
    [anon_sym_void] = ACTIONS(6333),
    [anon_sym_string] = ACTIONS(6333),
    [anon_sym_any] = ACTIONS(6333),
    [anon_sym_boolean] = ACTIONS(6333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_symbol] = ACTIONS(6333),
  },
  [2492] = {
    [sym_predefined_type] = STATE(3330),
    [anon_sym_number] = ACTIONS(6333),
    [anon_sym_void] = ACTIONS(6333),
    [anon_sym_string] = ACTIONS(6333),
    [anon_sym_any] = ACTIONS(6333),
    [anon_sym_boolean] = ACTIONS(6333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_symbol] = ACTIONS(6333),
  },
  [2493] = {
    [sym_type_annotation] = STATE(3105),
    [anon_sym_COLON] = ACTIONS(3347),
    [sym_comment] = ACTIONS(3),
  },
  [2494] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(6817),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6817),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [2495] = {
    [sym_identifier] = ACTIONS(6819),
    [anon_sym_BQUOTE] = ACTIONS(6821),
    [anon_sym_debugger] = ACTIONS(6819),
    [anon_sym_symbol] = ACTIONS(6819),
    [anon_sym_AT] = ACTIONS(6821),
    [anon_sym_PIPE] = ACTIONS(6821),
    [anon_sym_COMMA] = ACTIONS(6821),
    [anon_sym_DASH] = ACTIONS(6819),
    [anon_sym_EQ] = ACTIONS(6819),
    [anon_sym_void] = ACTIONS(6819),
    [anon_sym_break] = ACTIONS(6819),
    [anon_sym_const] = ACTIONS(6819),
    [sym_super] = ACTIONS(6819),
    [anon_sym_return] = ACTIONS(6819),
    [anon_sym_private] = ACTIONS(6819),
    [anon_sym_get] = ACTIONS(6819),
    [anon_sym_RBRACE] = ACTIONS(6821),
    [anon_sym_interface] = ACTIONS(6819),
    [anon_sym_default] = ACTIONS(6819),
    [anon_sym_enum] = ACTIONS(6819),
    [anon_sym_delete] = ACTIONS(6819),
    [anon_sym_continue] = ACTIONS(6819),
    [anon_sym_DASH_DASH] = ACTIONS(6821),
    [anon_sym_if] = ACTIONS(6819),
    [anon_sym_this] = ACTIONS(6819),
    [anon_sym_yield] = ACTIONS(6819),
    [sym_true] = ACTIONS(6819),
    [anon_sym_throw] = ACTIONS(6819),
    [anon_sym_protected] = ACTIONS(6819),
    [anon_sym_abstract] = ACTIONS(6819),
    [anon_sym_set] = ACTIONS(6819),
    [anon_sym_type] = ACTIONS(6819),
    [anon_sym_import] = ACTIONS(6819),
    [anon_sym_namespace] = ACTIONS(6819),
    [anon_sym_PLUS_PLUS] = ACTIONS(6821),
    [anon_sym_await] = ACTIONS(6819),
    [anon_sym_DQUOTE] = ACTIONS(6821),
    [anon_sym_else] = ACTIONS(6819),
    [anon_sym_BANG] = ACTIONS(6821),
    [anon_sym_for] = ACTIONS(6819),
    [anon_sym_LBRACK] = ACTIONS(6821),
    [sym_false] = ACTIONS(6819),
    [anon_sym_SEMI] = ACTIONS(6821),
    [anon_sym_case] = ACTIONS(6819),
    [anon_sym_module] = ACTIONS(6819),
    [anon_sym_number] = ACTIONS(6819),
    [anon_sym_class] = ACTIONS(6819),
    [anon_sym_declare] = ACTIONS(6819),
    [anon_sym_typeof] = ACTIONS(6819),
    [anon_sym_LBRACE] = ACTIONS(6821),
    [anon_sym_switch] = ACTIONS(6819),
    [anon_sym_LPAREN] = ACTIONS(6821),
    [anon_sym_RBRACK] = ACTIONS(6821),
    [sym_null] = ACTIONS(6819),
    [anon_sym_GT] = ACTIONS(6821),
    [anon_sym_any] = ACTIONS(6819),
    [anon_sym_boolean] = ACTIONS(6819),
    [anon_sym_async] = ACTIONS(6819),
    [anon_sym_public] = ACTIONS(6819),
    [anon_sym_EQ_GT] = ACTIONS(6821),
    [anon_sym_AMP] = ACTIONS(6821),
    [anon_sym_var] = ACTIONS(6819),
    [anon_sym_while] = ACTIONS(6819),
    [anon_sym_SQUOTE] = ACTIONS(6821),
    [anon_sym_try] = ACTIONS(6819),
    [anon_sym_RPAREN] = ACTIONS(6821),
    [anon_sym_LT] = ACTIONS(6821),
    [sym_number] = ACTIONS(6821),
    [anon_sym_SLASH] = ACTIONS(6819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6819),
    [anon_sym_function] = ACTIONS(6819),
    [sym_undefined] = ACTIONS(6819),
    [anon_sym_new] = ACTIONS(6819),
    [ts_builtin_sym_end] = ACTIONS(6821),
    [anon_sym_let] = ACTIONS(6819),
    [anon_sym_PLUS] = ACTIONS(6819),
    [anon_sym_export] = ACTIONS(6819),
    [anon_sym_do] = ACTIONS(6819),
    [anon_sym_TILDE] = ACTIONS(6821),
    [anon_sym_with] = ACTIONS(6819),
  },
  [2496] = {
    [aux_sym_object_type_repeat1] = STATE(2544),
    [sym__automatic_semicolon] = ACTIONS(6823),
    [anon_sym_RBRACE] = ACTIONS(6817),
    [anon_sym_SEMI] = ACTIONS(6823),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6817),
    [sym_comment] = ACTIONS(3),
  },
  [2497] = {
    [sym_call_signature] = STATE(3333),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2498] = {
    [sym__automatic_semicolon] = ACTIONS(6402),
    [anon_sym_RBRACE] = ACTIONS(6402),
    [anon_sym_SEMI] = ACTIONS(6402),
    [anon_sym_COMMA] = ACTIONS(6402),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6402),
    [sym_comment] = ACTIONS(3),
  },
  [2499] = {
    [aux_sym_formal_parameters_repeat1] = STATE(3336),
    [anon_sym_COMMA] = ACTIONS(6825),
    [anon_sym_RPAREN] = ACTIONS(6827),
    [sym_comment] = ACTIONS(3),
  },
  [2500] = {
    [aux_sym_export_statement_repeat1] = STATE(1485),
    [sym_decorator] = STATE(1485),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(1486),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(1486),
    [sym_optional_parameter] = STATE(1486),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(6827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [2501] = {
    [anon_sym_COLON] = ACTIONS(3106),
    [anon_sym_RBRACE] = ACTIONS(3106),
    [sym__automatic_semicolon] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3106),
    [anon_sym_COMMA] = ACTIONS(3106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3106),
  },
  [2502] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1488),
    [anon_sym_COMMA] = ACTIONS(6825),
    [anon_sym_RPAREN] = ACTIONS(6827),
    [sym_comment] = ACTIONS(3),
  },
  [2503] = {
    [sym_call_signature] = STATE(3333),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(6829),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [2504] = {
    [sym_string] = STATE(3338),
    [sym__property_name] = STATE(3338),
    [sym_computed_property_name] = STATE(3338),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [2505] = {
    [sym_string] = STATE(3338),
    [sym__property_name] = STATE(3338),
    [sym_computed_property_name] = STATE(3338),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(6831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2506] = {
    [sym_string] = STATE(3338),
    [sym__property_name] = STATE(3338),
    [sym_computed_property_name] = STATE(3338),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(6833),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(6835),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(6835),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [2507] = {
    [sym_call_signature] = STATE(3333),
    [sym_type_annotation] = STATE(3342),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [sym__automatic_semicolon] = ACTIONS(6837),
    [anon_sym_RBRACE] = ACTIONS(6837),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(6837),
    [anon_sym_QMARK] = ACTIONS(6839),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6837),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
  },
  [2508] = {
    [sym_string] = STATE(3338),
    [sym__property_name] = STATE(3338),
    [sym_computed_property_name] = STATE(3338),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2509] = {
    [sym_call_signature] = STATE(3333),
    [sym_type_annotation] = STATE(3342),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [sym__automatic_semicolon] = ACTIONS(6837),
    [anon_sym_RBRACE] = ACTIONS(6837),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(6837),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6837),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
  },
  [2510] = {
    [sym__automatic_semicolon] = ACTIONS(6837),
    [anon_sym_RBRACE] = ACTIONS(6837),
    [anon_sym_SEMI] = ACTIONS(6837),
    [anon_sym_COMMA] = ACTIONS(6837),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
  },
  [2511] = {
    [sym__automatic_semicolon] = ACTIONS(6841),
    [anon_sym_RBRACE] = ACTIONS(6841),
    [anon_sym_SEMI] = ACTIONS(6841),
    [anon_sym_COMMA] = ACTIONS(6841),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6841),
    [sym_comment] = ACTIONS(3),
  },
  [2512] = {
    [sym_type_annotation] = STATE(3343),
    [sym__automatic_semicolon] = ACTIONS(6841),
    [anon_sym_RBRACE] = ACTIONS(6841),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(6841),
    [anon_sym_COMMA] = ACTIONS(6841),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6841),
    [sym_comment] = ACTIONS(3),
  },
  [2513] = {
    [aux_sym_variable_declaration_repeat1] = STATE(3345),
    [sym__automatic_semicolon] = ACTIONS(6843),
    [anon_sym_SEMI] = ACTIONS(6843),
    [anon_sym_COMMA] = ACTIONS(767),
    [sym_comment] = ACTIONS(3),
  },
  [2514] = {
    [sym_type_parameters] = STATE(3346),
    [sym_object_type] = STATE(3347),
    [sym_extends_clause] = STATE(3348),
    [anon_sym_extends] = ACTIONS(821),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1982),
  },
  [2515] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(6845),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6845),
    [anon_sym_in] = ACTIONS(3626),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(604),
  },
  [2516] = {
    [sym_enum_body] = STATE(3351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6847),
  },
  [2517] = {
    [sym__automatic_semicolon] = ACTIONS(1073),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
  },
  [2518] = {
    [sym_identifier] = ACTIONS(6849),
    [sym_comment] = ACTIONS(3),
  },
  [2519] = {
    [sym_string] = STATE(129),
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(2517),
    [sym_identifier] = ACTIONS(5250),
    [anon_sym_DOT] = ACTIONS(6851),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [2520] = {
    [sym_statement_block] = STATE(3354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(901),
  },
  [2521] = {
    [sym__automatic_semicolon] = ACTIONS(1177),
    [anon_sym_RBRACE] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
  },
  [2522] = {
    [sym__automatic_semicolon] = ACTIONS(6845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(6845),
  },
  [2523] = {
    [sym_call_signature] = STATE(3355),
    [sym_formal_parameters] = STATE(858),
    [sym_type_parameters] = STATE(859),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2524] = {
    [sym_identifier] = ACTIONS(6853),
    [sym_comment] = ACTIONS(3),
  },
  [2525] = {
    [aux_sym_variable_declaration_repeat1] = STATE(3358),
    [sym__automatic_semicolon] = ACTIONS(6855),
    [anon_sym_SEMI] = ACTIONS(6855),
    [anon_sym_COMMA] = ACTIONS(767),
    [sym_comment] = ACTIONS(3),
  },
  [2526] = {
    [sym_identifier] = ACTIONS(6857),
    [sym_comment] = ACTIONS(3),
  },
  [2527] = {
    [sym_type_parameters] = STATE(3361),
    [anon_sym_EQ] = ACTIONS(6859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2528] = {
    [anon_sym_EQ] = ACTIONS(6861),
    [sym_comment] = ACTIONS(3),
  },
  [2529] = {
    [sym_call_signature] = STATE(774),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [sym_identifier] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2530] = {
    [sym_identifier] = ACTIONS(6865),
    [sym_comment] = ACTIONS(3),
  },
  [2531] = {
    [sym__automatic_semicolon] = ACTIONS(3694),
    [anon_sym_RBRACE] = ACTIONS(3694),
    [anon_sym_SEMI] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3694),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3694),
    [sym_comment] = ACTIONS(3),
  },
  [2532] = {
    [sym_new_expression] = STATE(3364),
    [sym_augmented_assignment_expression] = STATE(3364),
    [sym_unary_expression] = STATE(3364),
    [sym_update_expression] = STATE(3364),
    [sym_regex] = STATE(3364),
    [sym_meta_property] = STATE(3364),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(3364),
    [sym_yield_expression] = STATE(3364),
    [sym_as_expression] = STATE(3364),
    [sym_non_null_expression] = STATE(3364),
    [sym_internal_module] = STATE(3364),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3364),
    [sym_await_expression] = STATE(3364),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(3364),
    [sym_this] = STATE(3364),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(3364),
    [sym_generator_function] = STATE(3364),
    [sym_call_expression] = STATE(3364),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(3364),
    [sym_ternary_expression] = STATE(3364),
    [sym_binary_expression] = STATE(3364),
    [sym_template_string] = STATE(3364),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3364),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(3364),
    [sym_class] = STATE(3364),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(6867),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6867),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6869),
    [sym_true] = ACTIONS(6867),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6867),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [2533] = {
    [sym_type_arguments] = STATE(1937),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(6871),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6873),
  },
  [2534] = {
    [sym_tuple_type] = STATE(1939),
    [sym_index_type_query] = STATE(1939),
    [sym_lookup_type] = STATE(1939),
    [sym_this_type] = STATE(1939),
    [sym_flow_maybe_type] = STATE(1939),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_type_predicate] = STATE(1939),
    [sym_type_query] = STATE(1939),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1939),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1939),
    [sym__primary_type] = STATE(1939),
    [sym_generic_type] = STATE(1939),
    [sym_mapped_type] = STATE(1939),
    [sym_literal_type] = STATE(1939),
    [sym_parenthesized_type] = STATE(1939),
    [sym_predefined_type] = STATE(1939),
    [sym_string] = STATE(1048),
    [sym_array_type] = STATE(1939),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [sym_true] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2535] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2539),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2541),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5286),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2536] = {
    [sym_formal_parameters] = STATE(3367),
    [sym_type_parameters] = STATE(3368),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2537] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2539),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2541),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5286),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2538] = {
    [sym__automatic_semicolon] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(6875),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(6877),
    [anon_sym_COMMA] = ACTIONS(3744),
    [sym_comment] = ACTIONS(3),
  },
  [2539] = {
    [sym_formal_parameters] = STATE(3371),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2540] = {
    [sym_type_arguments] = STATE(1958),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6879),
  },
  [2541] = {
    [anon_sym_EQ_GT] = ACTIONS(6881),
    [sym_comment] = ACTIONS(3),
  },
  [2542] = {
    [sym_string] = STATE(3376),
    [sym__property_name] = STATE(3376),
    [sym_computed_property_name] = STATE(3376),
    [anon_sym_get] = ACTIONS(6883),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(6885),
    [anon_sym_STAR] = ACTIONS(6833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(6883),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(6887),
  },
  [2543] = {
    [sym__automatic_semicolon] = ACTIONS(6889),
    [anon_sym_RBRACE] = ACTIONS(6889),
    [anon_sym_SEMI] = ACTIONS(6889),
    [anon_sym_COMMA] = ACTIONS(6889),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
  },
  [2544] = {
    [aux_sym_object_type_repeat1] = STATE(2544),
    [sym__automatic_semicolon] = ACTIONS(6891),
    [anon_sym_RBRACE] = ACTIONS(6889),
    [anon_sym_SEMI] = ACTIONS(6891),
    [anon_sym_COMMA] = ACTIONS(6891),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
  },
  [2545] = {
    [sym__automatic_semicolon] = ACTIONS(3738),
    [anon_sym_RBRACE] = ACTIONS(3738),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_SEMI] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3738),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
  },
  [2546] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2547] = {
    [sym_formal_parameters] = STATE(3378),
    [sym_type_parameters] = STATE(3379),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2548] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2549] = {
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_RBRACK] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
  },
  [2550] = {
    [sym_formal_parameters] = STATE(3382),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2551] = {
    [anon_sym_EQ_GT] = ACTIONS(6898),
    [sym_comment] = ACTIONS(3),
  },
  [2552] = {
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_RBRACK] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
  },
  [2553] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3384),
    [sym_constructor_type] = STATE(3384),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(3384),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3384),
    [sym_intersection_type] = STATE(3384),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2554] = {
    [anon_sym_EQ_GT] = ACTIONS(6900),
    [sym_comment] = ACTIONS(3),
  },
  [2555] = {
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(5399),
    [anon_sym_RBRACK] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
  },
  [2556] = {
    [sym_identifier] = ACTIONS(6902),
    [anon_sym_BQUOTE] = ACTIONS(6904),
    [anon_sym_debugger] = ACTIONS(6902),
    [anon_sym_symbol] = ACTIONS(6902),
    [anon_sym_AT] = ACTIONS(6904),
    [anon_sym_PIPE] = ACTIONS(6904),
    [anon_sym_COMMA] = ACTIONS(6904),
    [anon_sym_DASH] = ACTIONS(6902),
    [anon_sym_EQ] = ACTIONS(6902),
    [anon_sym_void] = ACTIONS(6902),
    [anon_sym_break] = ACTIONS(6902),
    [anon_sym_const] = ACTIONS(6902),
    [sym_super] = ACTIONS(6902),
    [anon_sym_return] = ACTIONS(6902),
    [anon_sym_private] = ACTIONS(6902),
    [anon_sym_get] = ACTIONS(6902),
    [anon_sym_RBRACE] = ACTIONS(6904),
    [anon_sym_interface] = ACTIONS(6902),
    [anon_sym_default] = ACTIONS(6902),
    [anon_sym_enum] = ACTIONS(6902),
    [anon_sym_delete] = ACTIONS(6902),
    [anon_sym_continue] = ACTIONS(6902),
    [anon_sym_DASH_DASH] = ACTIONS(6904),
    [anon_sym_if] = ACTIONS(6902),
    [anon_sym_this] = ACTIONS(6902),
    [anon_sym_yield] = ACTIONS(6902),
    [sym_true] = ACTIONS(6902),
    [anon_sym_throw] = ACTIONS(6902),
    [anon_sym_protected] = ACTIONS(6902),
    [anon_sym_abstract] = ACTIONS(6902),
    [anon_sym_set] = ACTIONS(6902),
    [anon_sym_type] = ACTIONS(6902),
    [anon_sym_import] = ACTIONS(6902),
    [anon_sym_namespace] = ACTIONS(6902),
    [anon_sym_PLUS_PLUS] = ACTIONS(6904),
    [anon_sym_await] = ACTIONS(6902),
    [anon_sym_DQUOTE] = ACTIONS(6904),
    [anon_sym_else] = ACTIONS(6902),
    [anon_sym_BANG] = ACTIONS(6904),
    [anon_sym_for] = ACTIONS(6902),
    [anon_sym_LBRACK] = ACTIONS(6904),
    [sym_false] = ACTIONS(6902),
    [anon_sym_SEMI] = ACTIONS(6904),
    [anon_sym_case] = ACTIONS(6902),
    [anon_sym_module] = ACTIONS(6902),
    [anon_sym_number] = ACTIONS(6902),
    [anon_sym_class] = ACTIONS(6902),
    [anon_sym_declare] = ACTIONS(6902),
    [anon_sym_typeof] = ACTIONS(6902),
    [anon_sym_LBRACE] = ACTIONS(6904),
    [anon_sym_switch] = ACTIONS(6902),
    [anon_sym_LPAREN] = ACTIONS(6904),
    [anon_sym_RBRACK] = ACTIONS(6904),
    [sym_null] = ACTIONS(6902),
    [anon_sym_GT] = ACTIONS(6904),
    [anon_sym_any] = ACTIONS(6902),
    [anon_sym_boolean] = ACTIONS(6902),
    [anon_sym_async] = ACTIONS(6902),
    [anon_sym_public] = ACTIONS(6902),
    [anon_sym_EQ_GT] = ACTIONS(6904),
    [anon_sym_AMP] = ACTIONS(6904),
    [anon_sym_var] = ACTIONS(6902),
    [anon_sym_while] = ACTIONS(6902),
    [anon_sym_SQUOTE] = ACTIONS(6904),
    [anon_sym_try] = ACTIONS(6902),
    [anon_sym_RPAREN] = ACTIONS(6904),
    [anon_sym_LT] = ACTIONS(6904),
    [sym_number] = ACTIONS(6904),
    [anon_sym_SLASH] = ACTIONS(6902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6902),
    [anon_sym_function] = ACTIONS(6902),
    [sym_undefined] = ACTIONS(6902),
    [anon_sym_new] = ACTIONS(6902),
    [ts_builtin_sym_end] = ACTIONS(6904),
    [anon_sym_let] = ACTIONS(6902),
    [anon_sym_PLUS] = ACTIONS(6902),
    [anon_sym_export] = ACTIONS(6902),
    [anon_sym_do] = ACTIONS(6902),
    [anon_sym_TILDE] = ACTIONS(6904),
    [anon_sym_with] = ACTIONS(6902),
  },
  [2557] = {
    [aux_sym_implements_clause_repeat1] = STATE(2557),
    [anon_sym_COMMA] = ACTIONS(6906),
    [anon_sym_RBRACK] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
  },
  [2558] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3386),
    [sym_constructor_type] = STATE(3386),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(3386),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3386),
    [sym_intersection_type] = STATE(3386),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2559] = {
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_RBRACK] = ACTIONS(5406),
    [sym_comment] = ACTIONS(3),
  },
  [2560] = {
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_RBRACK] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [2561] = {
    [anon_sym_GT] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [2562] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3387),
    [sym_constructor_type] = STATE(3387),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(3387),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3387),
    [sym_intersection_type] = STATE(3387),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2563] = {
    [sym_new_expression] = STATE(1208),
    [sym_constructor_type] = STATE(2549),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1208),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1208),
    [sym_call_signature] = STATE(158),
    [sym_yield_expression] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(161),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1642),
    [sym_type_parameters] = STATE(3389),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(164),
    [sym_nested_type_identifier] = STATE(819),
    [sym_generator_function] = STATE(1208),
    [sym_subscript_expression] = STATE(161),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1208),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1208),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3390),
    [sym_intersection_type] = STATE(2549),
    [sym__type] = STATE(2549),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_function_type] = STATE(2549),
    [sym__expression] = STATE(1208),
    [sym_non_null_expression] = STATE(1208),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1208),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1208),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1208),
    [sym_call_expression] = STATE(1208),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1208),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1208),
    [sym_type_arguments] = STATE(166),
    [sym_union_type] = STATE(2549),
    [sym_parenthesized_expression] = STATE(1208),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1208),
    [sym_class] = STATE(1208),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(3397),
    [sym_false] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(3399),
    [anon_sym_number] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(3409),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(3403),
    [anon_sym_PIPE] = ACTIONS(5300),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(2496),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(3405),
    [sym_number] = ACTIONS(3411),
    [sym_true] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(3399),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2496),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(6911),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [2564] = {
    [sym_identifier] = ACTIONS(6913),
    [sym_comment] = ACTIONS(3),
  },
  [2565] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2566] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_AMP_EQ] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(929),
    [anon_sym_STAR_EQ] = ACTIONS(929),
    [anon_sym_PIPE_EQ] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
    [anon_sym_EQ_GT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(6915),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(937),
  },
  [2567] = {
    [sym_formal_parameters] = STATE(3393),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2568] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(6917),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [2569] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(6920),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [2570] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2571] = {
    [sym_formal_parameters] = STATE(3394),
    [sym_type_parameters] = STATE(3395),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2572] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2573] = {
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_RPAREN] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(6923),
    [anon_sym_PIPE] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
  },
  [2574] = {
    [sym_formal_parameters] = STATE(3398),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2575] = {
    [anon_sym_EQ_GT] = ACTIONS(6927),
    [sym_comment] = ACTIONS(3),
  },
  [2576] = {
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_RPAREN] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(6923),
    [anon_sym_PIPE] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
  },
  [2577] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_AMP_EQ] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(929),
    [anon_sym_STAR_EQ] = ACTIONS(929),
    [anon_sym_PIPE_EQ] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
    [anon_sym_EQ_GT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5208),
    [anon_sym_SLASH_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6929),
  },
  [2578] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2579] = {
    [sym_new_expression] = STATE(528),
    [sym_augmented_assignment_expression] = STATE(528),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(528),
    [sym_update_expression] = STATE(528),
    [sym_regex] = STATE(528),
    [sym_meta_property] = STATE(528),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(528),
    [sym_yield_expression] = STATE(528),
    [sym_as_expression] = STATE(528),
    [sym_non_null_expression] = STATE(528),
    [sym_internal_module] = STATE(528),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(528),
    [sym_await_expression] = STATE(528),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(528),
    [sym_this] = STATE(528),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(528),
    [sym_generator_function] = STATE(528),
    [sym_call_expression] = STATE(528),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(528),
    [sym_ternary_expression] = STATE(528),
    [sym_binary_expression] = STATE(528),
    [sym_template_string] = STATE(528),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(528),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(528),
    [sym_class] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(953),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(953),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(955),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2580] = {
    [sym_call_signature] = STATE(538),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(983),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(985),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(985),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_protected] = ACTIONS(985),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(985),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(985),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_public] = ACTIONS(985),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(447),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2581] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2582] = {
    [sym_template_string] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [aux_sym_array_repeat1] = STATE(1070),
    [sym_arguments] = STATE(536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(6931),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2583] = {
    [sym__initializer] = STATE(1041),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(2173),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(6933),
    [sym_comment] = ACTIONS(3),
  },
  [2584] = {
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(6933),
    [sym_comment] = ACTIONS(3),
  },
  [2585] = {
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(6933),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_get] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1220),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_set] = ACTIONS(1220),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_export] = ACTIONS(1220),
    [anon_sym_namespace] = ACTIONS(1220),
    [sym_readonly] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
  },
  [2586] = {
    [sym_string] = STATE(2590),
    [sym__property_name] = STATE(2590),
    [sym_computed_property_name] = STATE(2590),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(6933),
    [anon_sym_STAR] = ACTIONS(5359),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(5361),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(5361),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [2587] = {
    [sym_string] = STATE(2590),
    [sym__property_name] = STATE(2590),
    [sym_computed_property_name] = STATE(2590),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(6933),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [2588] = {
    [sym_type_alias_declaration] = STATE(1609),
    [aux_sym_export_statement_repeat1] = STATE(1608),
    [sym__declaration] = STATE(1609),
    [sym_ambient_declaration] = STATE(1609),
    [sym_import_alias] = STATE(1609),
    [sym_export_statement] = STATE(1609),
    [sym_generator_function] = STATE(1609),
    [sym_export_clause] = STATE(1610),
    [sym_lexical_declaration] = STATE(1609),
    [sym_internal_module] = STATE(1609),
    [sym_decorator] = STATE(1608),
    [sym_enum_declaration] = STATE(1609),
    [sym_function] = STATE(1609),
    [sym_function_signature] = STATE(1609),
    [sym_variable_declaration] = STATE(1609),
    [sym_abstract_class] = STATE(1609),
    [sym_module] = STATE(1609),
    [sym_interface_declaration] = STATE(1609),
    [sym_class] = STATE(1609),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_COMMA] = ACTIONS(6933),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_import] = ACTIONS(3337),
    [anon_sym_export] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3341),
  },
  [2589] = {
    [sym_computed_property_name] = STATE(701),
    [sym__property_name] = STATE(701),
    [sym_decorator] = STATE(1044),
    [sym_method_definition] = STATE(1407),
    [sym_string] = STATE(701),
    [sym_accessibility_modifier] = STATE(218),
    [aux_sym_export_statement_repeat1] = STATE(1044),
    [anon_sym_get] = ACTIONS(1308),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [sym_number] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1304),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(5371),
    [sym_readonly] = ACTIONS(382),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1304),
    [anon_sym_public] = ACTIONS(1304),
  },
  [2590] = {
    [sym_call_signature] = STATE(3403),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(6936),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [2591] = {
    [sym_string] = STATE(3404),
    [sym__property_name] = STATE(3404),
    [sym_computed_property_name] = STATE(3404),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2592] = {
    [sym_string] = STATE(3404),
    [sym__property_name] = STATE(3404),
    [sym_computed_property_name] = STATE(3404),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(6938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2593] = {
    [sym_string] = STATE(3404),
    [sym__property_name] = STATE(3404),
    [sym_computed_property_name] = STATE(3404),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [2594] = {
    [sym_string] = STATE(3408),
    [sym__property_name] = STATE(3408),
    [sym_computed_property_name] = STATE(3408),
    [anon_sym_get] = ACTIONS(6940),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(6942),
    [anon_sym_STAR] = ACTIONS(6944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(6940),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(6946),
  },
  [2595] = {
    [sym_string] = STATE(3404),
    [sym__property_name] = STATE(3404),
    [sym_computed_property_name] = STATE(3404),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(6944),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(6948),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(6938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(6948),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [2596] = {
    [sym_call_signature] = STATE(3403),
    [sym_type_annotation] = STATE(2510),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [sym__automatic_semicolon] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_QMARK] = ACTIONS(6950),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
  },
  [2597] = {
    [sym_type_alias_declaration] = STATE(2531),
    [aux_sym_export_statement_repeat1] = STATE(1608),
    [sym__declaration] = STATE(2531),
    [sym_ambient_declaration] = STATE(2531),
    [sym_import_alias] = STATE(2531),
    [sym_export_statement] = STATE(2531),
    [sym_generator_function] = STATE(2531),
    [sym_lexical_declaration] = STATE(2531),
    [sym_internal_module] = STATE(2531),
    [sym_decorator] = STATE(1608),
    [sym_enum_declaration] = STATE(2531),
    [sym_function] = STATE(2531),
    [sym_function_signature] = STATE(2531),
    [sym_variable_declaration] = STATE(2531),
    [sym_abstract_class] = STATE(2531),
    [sym_module] = STATE(2531),
    [sym_interface_declaration] = STATE(2531),
    [sym_class] = STATE(2531),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_default] = ACTIONS(5278),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_declare] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_import] = ACTIONS(3337),
    [anon_sym_export] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3341),
    [anon_sym_async] = ACTIONS(3317),
  },
  [2598] = {
    [sym_new_expression] = STATE(1441),
    [sym_constructor_type] = STATE(2538),
    [sym_augmented_assignment_expression] = STATE(1441),
    [sym_lookup_type] = STATE(1066),
    [sym_unary_expression] = STATE(1441),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_regex] = STATE(1441),
    [sym_call_signature] = STATE(374),
    [sym_yield_expression] = STATE(1441),
    [sym_as_expression] = STATE(1441),
    [sym_internal_module] = STATE(1441),
    [sym_arrow_function] = STATE(1441),
    [sym__primary_type] = STATE(1066),
    [sym_member_expression] = STATE(376),
    [sym_mapped_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_string] = STATE(3412),
    [sym_type_parameters] = STATE(3422),
    [sym_array_type] = STATE(1066),
    [sym_object] = STATE(378),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_generator_function] = STATE(1441),
    [sym_subscript_expression] = STATE(376),
    [sym_type_query] = STATE(1066),
    [sym_ternary_expression] = STATE(1441),
    [sym_existential_type] = STATE(1066),
    [sym_template_string] = STATE(1441),
    [sym_object_type] = STATE(1066),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3423),
    [sym_intersection_type] = STATE(2538),
    [sym__type] = STATE(2538),
    [sym_index_type_query] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_update_expression] = STATE(1441),
    [sym_meta_property] = STATE(1441),
    [sym_function_type] = STATE(2538),
    [sym__expression] = STATE(1441),
    [sym_non_null_expression] = STATE(1441),
    [sym_nested_identifier] = STATE(1065),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1441),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_this] = STATE(1441),
    [sym_tuple_type] = STATE(1066),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1441),
    [sym_call_expression] = STATE(1441),
    [sym_type_predicate] = STATE(1066),
    [sym_assignment_expression] = STATE(1441),
    [sym__number] = STATE(1048),
    [sym_binary_expression] = STATE(1441),
    [sym_type_arguments] = STATE(379),
    [sym_union_type] = STATE(2538),
    [sym_parenthesized_expression] = STATE(1441),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1441),
    [sym_class] = STATE(1441),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(6952),
    [sym_false] = ACTIONS(6954),
    [anon_sym_LBRACK] = ACTIONS(6956),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(6958),
    [anon_sym_number] = ACTIONS(6958),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(6960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6962),
    [anon_sym_keyof] = ACTIONS(2207),
    [anon_sym_LBRACE] = ACTIONS(6964),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_void] = ACTIONS(6966),
    [anon_sym_PIPE] = ACTIONS(5288),
    [anon_sym_LPAREN] = ACTIONS(6968),
    [sym_null] = ACTIONS(2995),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6958),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(6958),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(6970),
    [sym_number] = ACTIONS(6972),
    [sym_true] = ACTIONS(6954),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(6958),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(6974),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(6962),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [2599] = {
    [sym_call_signature] = STATE(3403),
    [sym_type_annotation] = STATE(2510),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [sym__automatic_semicolon] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
  },
  [2600] = {
    [sym_statement_block] = STATE(1442),
    [sym__automatic_semicolon] = ACTIONS(4777),
    [anon_sym_RBRACE] = ACTIONS(4777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_COMMA] = ACTIONS(4777),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4777),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [2601] = {
    [sym_type_annotation] = STATE(1618),
    [sym__automatic_semicolon] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_COLON] = ACTIONS(6976),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_PIPE_RBRACE] = ACTIONS(570),
    [anon_sym_COMMA] = ACTIONS(570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(570),
  },
  [2602] = {
    [sym_formal_parameters] = STATE(3425),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [2603] = {
    [sym_string] = STATE(3408),
    [sym__property_name] = STATE(3408),
    [sym_computed_property_name] = STATE(3408),
    [anon_sym_get] = ACTIONS(6940),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_async] = ACTIONS(6946),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(6942),
    [anon_sym_STAR] = ACTIONS(6944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(6940),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(6978),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [2604] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3427),
    [sym_constructor_type] = STATE(3427),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(3427),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3427),
    [sym_intersection_type] = STATE(3427),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2605] = {
    [anon_sym_EQ_GT] = ACTIONS(6980),
    [sym_comment] = ACTIONS(3),
  },
  [2606] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3429),
    [sym_constructor_type] = STATE(3429),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(3429),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3429),
    [sym_intersection_type] = STATE(3429),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2607] = {
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_RPAREN] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(6923),
    [anon_sym_PIPE] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
  },
  [2608] = {
    [anon_sym_AMP] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
  },
  [2609] = {
    [sym_identifier] = ACTIONS(6982),
    [anon_sym_BQUOTE] = ACTIONS(6984),
    [anon_sym_debugger] = ACTIONS(6982),
    [anon_sym_symbol] = ACTIONS(6982),
    [anon_sym_AT] = ACTIONS(6984),
    [anon_sym_PIPE] = ACTIONS(6984),
    [anon_sym_COMMA] = ACTIONS(6984),
    [anon_sym_DASH] = ACTIONS(6982),
    [anon_sym_EQ] = ACTIONS(6982),
    [anon_sym_void] = ACTIONS(6982),
    [anon_sym_break] = ACTIONS(6982),
    [anon_sym_const] = ACTIONS(6982),
    [sym_super] = ACTIONS(6982),
    [anon_sym_return] = ACTIONS(6982),
    [anon_sym_private] = ACTIONS(6982),
    [anon_sym_get] = ACTIONS(6982),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6984),
    [anon_sym_RBRACE] = ACTIONS(6984),
    [anon_sym_interface] = ACTIONS(6982),
    [anon_sym_default] = ACTIONS(6982),
    [anon_sym_enum] = ACTIONS(6982),
    [anon_sym_delete] = ACTIONS(6982),
    [anon_sym_continue] = ACTIONS(6982),
    [anon_sym_DASH_DASH] = ACTIONS(6984),
    [anon_sym_if] = ACTIONS(6982),
    [anon_sym_this] = ACTIONS(6982),
    [anon_sym_yield] = ACTIONS(6982),
    [sym_true] = ACTIONS(6982),
    [anon_sym_throw] = ACTIONS(6982),
    [anon_sym_protected] = ACTIONS(6982),
    [anon_sym_abstract] = ACTIONS(6982),
    [anon_sym_set] = ACTIONS(6982),
    [anon_sym_type] = ACTIONS(6982),
    [anon_sym_import] = ACTIONS(6982),
    [anon_sym_namespace] = ACTIONS(6982),
    [anon_sym_PLUS_PLUS] = ACTIONS(6984),
    [anon_sym_await] = ACTIONS(6982),
    [anon_sym_DQUOTE] = ACTIONS(6984),
    [anon_sym_else] = ACTIONS(6982),
    [anon_sym_BANG] = ACTIONS(6984),
    [anon_sym_for] = ACTIONS(6982),
    [anon_sym_LBRACK] = ACTIONS(6984),
    [sym_false] = ACTIONS(6982),
    [anon_sym_SEMI] = ACTIONS(6984),
    [anon_sym_case] = ACTIONS(6982),
    [anon_sym_module] = ACTIONS(6982),
    [anon_sym_number] = ACTIONS(6982),
    [anon_sym_class] = ACTIONS(6982),
    [anon_sym_declare] = ACTIONS(6982),
    [anon_sym_typeof] = ACTIONS(6982),
    [anon_sym_LBRACE] = ACTIONS(6982),
    [anon_sym_switch] = ACTIONS(6982),
    [anon_sym_LPAREN] = ACTIONS(6984),
    [anon_sym_RBRACK] = ACTIONS(6984),
    [sym_null] = ACTIONS(6982),
    [anon_sym_GT] = ACTIONS(6984),
    [anon_sym_any] = ACTIONS(6982),
    [anon_sym_boolean] = ACTIONS(6982),
    [anon_sym_async] = ACTIONS(6982),
    [anon_sym_public] = ACTIONS(6982),
    [anon_sym_EQ_GT] = ACTIONS(6984),
    [anon_sym_AMP] = ACTIONS(6984),
    [anon_sym_var] = ACTIONS(6982),
    [anon_sym_while] = ACTIONS(6982),
    [anon_sym_SQUOTE] = ACTIONS(6984),
    [anon_sym_try] = ACTIONS(6982),
    [anon_sym_RPAREN] = ACTIONS(6984),
    [anon_sym_LT] = ACTIONS(6984),
    [sym_number] = ACTIONS(6984),
    [anon_sym_SLASH] = ACTIONS(6982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6982),
    [anon_sym_function] = ACTIONS(6982),
    [sym_undefined] = ACTIONS(6982),
    [anon_sym_new] = ACTIONS(6982),
    [ts_builtin_sym_end] = ACTIONS(6984),
    [anon_sym_let] = ACTIONS(6982),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_implements] = ACTIONS(6982),
    [anon_sym_export] = ACTIONS(6982),
    [anon_sym_do] = ACTIONS(6982),
    [anon_sym_TILDE] = ACTIONS(6984),
    [anon_sym_with] = ACTIONS(6982),
  },
  [2610] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1675),
    [sym_constructor_type] = STATE(1675),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1675),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1675),
    [sym_intersection_type] = STATE(1675),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2611] = {
    [anon_sym_GT] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [2612] = {
    [sym_identifier] = ACTIONS(6988),
    [anon_sym_BQUOTE] = ACTIONS(6990),
    [anon_sym_debugger] = ACTIONS(6988),
    [anon_sym_symbol] = ACTIONS(6988),
    [anon_sym_AT] = ACTIONS(6990),
    [anon_sym_PIPE] = ACTIONS(6990),
    [anon_sym_COMMA] = ACTIONS(6990),
    [anon_sym_DASH] = ACTIONS(6988),
    [anon_sym_EQ] = ACTIONS(6988),
    [anon_sym_void] = ACTIONS(6988),
    [anon_sym_break] = ACTIONS(6988),
    [anon_sym_const] = ACTIONS(6988),
    [sym_super] = ACTIONS(6988),
    [anon_sym_return] = ACTIONS(6988),
    [anon_sym_private] = ACTIONS(6988),
    [anon_sym_get] = ACTIONS(6988),
    [anon_sym_RBRACE] = ACTIONS(6990),
    [anon_sym_interface] = ACTIONS(6988),
    [anon_sym_default] = ACTIONS(6988),
    [anon_sym_enum] = ACTIONS(6988),
    [anon_sym_delete] = ACTIONS(6988),
    [anon_sym_continue] = ACTIONS(6988),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_if] = ACTIONS(6988),
    [anon_sym_this] = ACTIONS(6988),
    [anon_sym_yield] = ACTIONS(6988),
    [sym_true] = ACTIONS(6988),
    [anon_sym_throw] = ACTIONS(6988),
    [anon_sym_protected] = ACTIONS(6988),
    [anon_sym_abstract] = ACTIONS(6988),
    [anon_sym_set] = ACTIONS(6988),
    [anon_sym_type] = ACTIONS(6988),
    [anon_sym_import] = ACTIONS(6988),
    [anon_sym_namespace] = ACTIONS(6988),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_await] = ACTIONS(6988),
    [anon_sym_DQUOTE] = ACTIONS(6990),
    [anon_sym_else] = ACTIONS(6988),
    [anon_sym_BANG] = ACTIONS(6990),
    [anon_sym_for] = ACTIONS(6988),
    [anon_sym_LBRACK] = ACTIONS(6990),
    [sym_false] = ACTIONS(6988),
    [anon_sym_SEMI] = ACTIONS(6990),
    [anon_sym_case] = ACTIONS(6988),
    [anon_sym_module] = ACTIONS(6988),
    [anon_sym_number] = ACTIONS(6988),
    [anon_sym_class] = ACTIONS(6988),
    [anon_sym_declare] = ACTIONS(6988),
    [anon_sym_typeof] = ACTIONS(6988),
    [anon_sym_LBRACE] = ACTIONS(6990),
    [anon_sym_switch] = ACTIONS(6988),
    [anon_sym_LPAREN] = ACTIONS(6990),
    [anon_sym_RBRACK] = ACTIONS(6990),
    [sym_null] = ACTIONS(6988),
    [anon_sym_GT] = ACTIONS(6990),
    [anon_sym_any] = ACTIONS(6988),
    [anon_sym_boolean] = ACTIONS(6988),
    [anon_sym_async] = ACTIONS(6988),
    [anon_sym_public] = ACTIONS(6988),
    [anon_sym_EQ_GT] = ACTIONS(6990),
    [anon_sym_AMP] = ACTIONS(6990),
    [anon_sym_var] = ACTIONS(6988),
    [anon_sym_while] = ACTIONS(6988),
    [anon_sym_SQUOTE] = ACTIONS(6990),
    [anon_sym_try] = ACTIONS(6988),
    [anon_sym_RPAREN] = ACTIONS(6990),
    [anon_sym_LT] = ACTIONS(6990),
    [sym_number] = ACTIONS(6990),
    [anon_sym_SLASH] = ACTIONS(6988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6988),
    [anon_sym_function] = ACTIONS(6988),
    [sym_undefined] = ACTIONS(6988),
    [anon_sym_new] = ACTIONS(6988),
    [ts_builtin_sym_end] = ACTIONS(6990),
    [anon_sym_let] = ACTIONS(6988),
    [anon_sym_PLUS] = ACTIONS(6988),
    [anon_sym_export] = ACTIONS(6988),
    [anon_sym_do] = ACTIONS(6988),
    [anon_sym_TILDE] = ACTIONS(6990),
    [anon_sym_with] = ACTIONS(6988),
  },
  [2613] = {
    [anon_sym_extends] = ACTIONS(6992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6992),
    [anon_sym_EQ] = ACTIONS(6992),
    [anon_sym_implements] = ACTIONS(6992),
    [anon_sym_LPAREN] = ACTIONS(6992),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6994),
  },
  [2614] = {
    [sym_type_parameter] = STATE(1682),
    [sym_identifier] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
  },
  [2615] = {
    [sym_type_arguments] = STATE(1937),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_is] = ACTIONS(6996),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6998),
  },
  [2616] = {
    [sym_tuple_type] = STATE(1939),
    [sym_index_type_query] = STATE(1939),
    [sym_lookup_type] = STATE(1939),
    [sym_this_type] = STATE(1939),
    [sym_flow_maybe_type] = STATE(1939),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_type_predicate] = STATE(1939),
    [sym_type_query] = STATE(1939),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1939),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1939),
    [sym__primary_type] = STATE(1939),
    [sym_generic_type] = STATE(1939),
    [sym_mapped_type] = STATE(1939),
    [sym_literal_type] = STATE(1939),
    [sym_parenthesized_type] = STATE(1939),
    [sym_predefined_type] = STATE(1939),
    [sym_string] = STATE(1048),
    [sym_array_type] = STATE(1939),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [sym_true] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2617] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2621),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2623),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2618] = {
    [sym_formal_parameters] = STATE(3432),
    [sym_type_parameters] = STATE(3433),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2619] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2621),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2623),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2620] = {
    [sym__automatic_semicolon] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(7000),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(7002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3744),
  },
  [2621] = {
    [sym_formal_parameters] = STATE(3436),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2622] = {
    [sym_type_arguments] = STATE(1958),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7004),
  },
  [2623] = {
    [anon_sym_EQ_GT] = ACTIONS(7006),
    [sym_comment] = ACTIONS(3),
  },
  [2624] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7008),
    [sym_identifier] = ACTIONS(7010),
    [sym__automatic_semicolon] = ACTIONS(7008),
    [anon_sym_BQUOTE] = ACTIONS(7008),
    [anon_sym_debugger] = ACTIONS(7010),
    [ts_builtin_sym_end] = ACTIONS(7008),
    [anon_sym_symbol] = ACTIONS(7010),
    [anon_sym_AT] = ACTIONS(7008),
    [anon_sym_PIPE] = ACTIONS(7010),
    [anon_sym_COMMA] = ACTIONS(7008),
    [anon_sym_DASH] = ACTIONS(7010),
    [anon_sym_STAR] = ACTIONS(7010),
    [anon_sym_GT_GT_GT] = ACTIONS(7008),
    [anon_sym_void] = ACTIONS(7010),
    [anon_sym_break] = ACTIONS(7010),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_const] = ACTIONS(7010),
    [anon_sym_GT_EQ] = ACTIONS(7008),
    [sym_super] = ACTIONS(7010),
    [anon_sym_return] = ACTIONS(7010),
    [anon_sym_private] = ACTIONS(7010),
    [anon_sym_get] = ACTIONS(7010),
    [anon_sym_RBRACE] = ACTIONS(7008),
    [anon_sym_PERCENT] = ACTIONS(7008),
    [anon_sym_interface] = ACTIONS(7010),
    [anon_sym_default] = ACTIONS(7010),
    [anon_sym_as] = ACTIONS(7010),
    [anon_sym_delete] = ACTIONS(7010),
    [anon_sym_continue] = ACTIONS(7010),
    [anon_sym_DASH_DASH] = ACTIONS(7008),
    [anon_sym_if] = ACTIONS(7010),
    [anon_sym_instanceof] = ACTIONS(7010),
    [anon_sym_this] = ACTIONS(7010),
    [anon_sym_yield] = ACTIONS(7010),
    [sym_true] = ACTIONS(7010),
    [anon_sym_throw] = ACTIONS(7010),
    [anon_sym_enum] = ACTIONS(7010),
    [anon_sym_protected] = ACTIONS(7010),
    [anon_sym_abstract] = ACTIONS(7010),
    [anon_sym_DOT] = ACTIONS(7010),
    [anon_sym_set] = ACTIONS(7010),
    [anon_sym_type] = ACTIONS(7010),
    [anon_sym_STAR_STAR] = ACTIONS(7008),
    [anon_sym_import] = ACTIONS(7010),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7008),
    [anon_sym_namespace] = ACTIONS(7010),
    [anon_sym_PLUS_PLUS] = ACTIONS(7008),
    [anon_sym_await] = ACTIONS(7010),
    [anon_sym_DQUOTE] = ACTIONS(7008),
    [anon_sym_else] = ACTIONS(7010),
    [anon_sym_BANG] = ACTIONS(7010),
    [anon_sym_for] = ACTIONS(7010),
    [anon_sym_LBRACK] = ACTIONS(7008),
    [sym_false] = ACTIONS(7010),
    [anon_sym_SEMI] = ACTIONS(7008),
    [anon_sym_case] = ACTIONS(7010),
    [anon_sym_module] = ACTIONS(7010),
    [anon_sym_number] = ACTIONS(7010),
    [anon_sym_class] = ACTIONS(7010),
    [anon_sym_declare] = ACTIONS(7010),
    [anon_sym_typeof] = ACTIONS(7010),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_LBRACE] = ACTIONS(7008),
    [anon_sym_AMP_AMP] = ACTIONS(7008),
    [anon_sym_switch] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(7008),
    [anon_sym_LPAREN] = ACTIONS(7008),
    [sym_null] = ACTIONS(7010),
    [anon_sym_GT] = ACTIONS(7010),
    [anon_sym_any] = ACTIONS(7010),
    [anon_sym_boolean] = ACTIONS(7010),
    [anon_sym_async] = ACTIONS(7010),
    [anon_sym_public] = ACTIONS(7010),
    [anon_sym_AMP] = ACTIONS(7010),
    [anon_sym_var] = ACTIONS(7010),
    [anon_sym_QMARK] = ACTIONS(7008),
    [anon_sym_PIPE_PIPE] = ACTIONS(7008),
    [anon_sym_while] = ACTIONS(7010),
    [anon_sym_SQUOTE] = ACTIONS(7008),
    [anon_sym_try] = ACTIONS(7010),
    [anon_sym_EQ_EQ] = ACTIONS(7010),
    [anon_sym_RPAREN] = ACTIONS(7008),
    [anon_sym_LT] = ACTIONS(7010),
    [sym_number] = ACTIONS(7008),
    [anon_sym_SLASH] = ACTIONS(7010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7010),
    [anon_sym_function] = ACTIONS(7010),
    [sym_undefined] = ACTIONS(7010),
    [anon_sym_new] = ACTIONS(7010),
    [anon_sym_CARET] = ACTIONS(7008),
    [anon_sym_let] = ACTIONS(7010),
    [anon_sym_PLUS] = ACTIONS(7010),
    [anon_sym_export] = ACTIONS(7010),
    [anon_sym_GT_GT] = ACTIONS(7010),
    [anon_sym_do] = ACTIONS(7010),
    [anon_sym_TILDE] = ACTIONS(7008),
    [anon_sym_with] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7008),
    [anon_sym_in] = ACTIONS(7010),
  },
  [2625] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3442),
    [sym_constructor_type] = STATE(3442),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(3442),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3442),
    [sym_intersection_type] = STATE(3442),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2626] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3445),
    [sym_constructor_type] = STATE(3445),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(3445),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3445),
    [sym_intersection_type] = STATE(3445),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2627] = {
    [anon_sym_EQ_GT] = ACTIONS(7018),
    [sym_comment] = ACTIONS(3),
  },
  [2628] = {
    [sym_formal_parameters] = STATE(3447),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2629] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1699),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1701),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2630] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1699),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1701),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2631] = {
    [anon_sym_EQ_GT] = ACTIONS(7020),
    [sym_comment] = ACTIONS(3),
  },
  [2632] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3449),
    [sym_constructor_type] = STATE(3449),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(3449),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3449),
    [sym_intersection_type] = STATE(3449),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2633] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3450),
    [sym_constructor_type] = STATE(3450),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(3450),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3450),
    [sym_intersection_type] = STATE(3450),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1699),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1701),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2634] = {
    [sym_new_expression] = STATE(555),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(555),
    [sym_meta_property] = STATE(555),
    [sym_call_signature] = STATE(877),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(555),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(555),
    [sym_this] = STATE(555),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(555),
    [sym_generator_function] = STATE(555),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(555),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(555),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(555),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1637),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1637),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [2635] = {
    [sym_new_expression] = STATE(555),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(555),
    [sym_meta_property] = STATE(555),
    [sym_call_signature] = STATE(877),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(555),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(555),
    [sym_this] = STATE(555),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(555),
    [sym_generator_function] = STATE(555),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(555),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(555),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(555),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1637),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1637),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [2636] = {
    [sym__initializer] = STATE(517),
    [sym_type_annotation] = STATE(1481),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_AMP_EQ] = ACTIONS(2251),
    [anon_sym_PLUS_EQ] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(7022),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2251),
    [anon_sym_STAR_EQ] = ACTIONS(2251),
    [anon_sym_PIPE_EQ] = ACTIONS(2251),
    [anon_sym_DASH_EQ] = ACTIONS(2251),
    [anon_sym_EQ_GT] = ACTIONS(2253),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(7022),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3096),
    [anon_sym_SLASH_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2255),
  },
  [2637] = {
    [sym_new_expression] = STATE(3451),
    [sym_augmented_assignment_expression] = STATE(3451),
    [sym_unary_expression] = STATE(3451),
    [sym_update_expression] = STATE(3451),
    [sym_regex] = STATE(3451),
    [sym_meta_property] = STATE(3451),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(3451),
    [sym_yield_expression] = STATE(3451),
    [sym_as_expression] = STATE(3451),
    [sym_non_null_expression] = STATE(3451),
    [sym_internal_module] = STATE(3451),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3451),
    [sym_await_expression] = STATE(3451),
    [sym_member_expression] = STATE(448),
    [sym_spread_element] = STATE(532),
    [sym_sequence_expression] = STATE(1494),
    [sym_string] = STATE(3451),
    [sym_this] = STATE(3451),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(3451),
    [sym_generator_function] = STATE(3451),
    [sym_call_expression] = STATE(3451),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(3451),
    [sym_ternary_expression] = STATE(3451),
    [sym_binary_expression] = STATE(3451),
    [sym_template_string] = STATE(3451),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3451),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(3451),
    [sym_class] = STATE(3451),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(7025),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(789),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7025),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7027),
    [sym_true] = ACTIONS(7025),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7025),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [2638] = {
    [sym_new_expression] = STATE(555),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(555),
    [sym_meta_property] = STATE(555),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(555),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(555),
    [sym_this] = STATE(555),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(555),
    [sym_generator_function] = STATE(555),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(555),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(555),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(555),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(1613),
    [sym_false] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1637),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1639),
    [sym_true] = ACTIONS(1637),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1637),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [2639] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3452),
    [sym_constructor_type] = STATE(3452),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(3452),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3452),
    [sym_intersection_type] = STATE(3452),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2640] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3453),
    [sym_constructor_type] = STATE(3453),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(3453),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3453),
    [sym_intersection_type] = STATE(3453),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2641] = {
    [anon_sym_EQ_GT] = ACTIONS(7029),
    [sym_comment] = ACTIONS(3),
  },
  [2642] = {
    [sym_formal_parameters] = STATE(3455),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2643] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2644] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2645] = {
    [anon_sym_EQ_GT] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
  },
  [2646] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3457),
    [sym_constructor_type] = STATE(3457),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(3457),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3457),
    [sym_intersection_type] = STATE(3457),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2647] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3458),
    [sym_constructor_type] = STATE(3458),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(3458),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3458),
    [sym_intersection_type] = STATE(3458),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2648] = {
    [sym_new_expression] = STATE(1702),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(1702),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1702),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1702),
    [sym_call_signature] = STATE(877),
    [sym_yield_expression] = STATE(1702),
    [sym_as_expression] = STATE(1702),
    [sym_internal_module] = STATE(1702),
    [sym_arrow_function] = STATE(1702),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(879),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1738),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(880),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(1702),
    [sym_subscript_expression] = STATE(879),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1702),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1702),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1702),
    [sym_meta_property] = STATE(1702),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(1702),
    [sym_non_null_expression] = STATE(1702),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1702),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1702),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1702),
    [sym_call_expression] = STATE(1702),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1702),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1702),
    [sym_type_arguments] = STATE(309),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(1702),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(1702),
    [sym_class] = STATE(1702),
    [anon_sym_BANG] = ACTIONS(510),
    [sym_identifier] = ACTIONS(3583),
    [sym_false] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(3587),
    [anon_sym_number] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(3589),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(3595),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(3516),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3587),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(3587),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(3597),
    [sym_number] = ACTIONS(3599),
    [sym_true] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3516),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(7033),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
  },
  [2649] = {
    [sym_identifier] = ACTIONS(7035),
    [sym_comment] = ACTIONS(3),
  },
  [2650] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(3532),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(7037),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1643),
  },
  [2651] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1241),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1241),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_EQ] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(3303),
    [anon_sym_BANG_EQ] = ACTIONS(1241),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [anon_sym_RBRACK] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1241),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1241),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1241),
  },
  [2652] = {
    [sym__automatic_semicolon] = ACTIONS(7039),
    [anon_sym_SEMI] = ACTIONS(7039),
    [anon_sym_from] = ACTIONS(7039),
    [sym_comment] = ACTIONS(3),
  },
  [2653] = {
    [anon_sym_COMMA] = ACTIONS(7041),
    [anon_sym_RBRACE] = ACTIONS(7041),
    [sym_comment] = ACTIONS(3),
  },
  [2654] = {
    [sym__import_export_specifier] = STATE(2653),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_RBRACE] = ACTIONS(7043),
    [anon_sym_typeof] = ACTIONS(887),
    [anon_sym_type] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
  },
  [2655] = {
    [aux_sym_export_clause_repeat1] = STATE(2655),
    [anon_sym_COMMA] = ACTIONS(7045),
    [anon_sym_RBRACE] = ACTIONS(7048),
    [sym_comment] = ACTIONS(3),
  },
  [2656] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [2657] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2658] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [2659] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2055),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [2660] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [2661] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2155),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [2662] = {
    [sym_new_expression] = STATE(3464),
    [sym_augmented_assignment_expression] = STATE(3464),
    [sym_unary_expression] = STATE(3464),
    [sym_update_expression] = STATE(3464),
    [sym_regex] = STATE(3464),
    [sym_meta_property] = STATE(3464),
    [sym_call_signature] = STATE(908),
    [sym_statement_block] = STATE(1530),
    [sym__expression] = STATE(3464),
    [sym_yield_expression] = STATE(3464),
    [sym_as_expression] = STATE(3464),
    [sym_non_null_expression] = STATE(3464),
    [sym_internal_module] = STATE(3464),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3464),
    [sym_await_expression] = STATE(3464),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(3464),
    [sym_this] = STATE(3464),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(3464),
    [sym_generator_function] = STATE(3464),
    [sym_call_expression] = STATE(3464),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(3464),
    [sym_ternary_expression] = STATE(3464),
    [sym_binary_expression] = STATE(3464),
    [sym_template_string] = STATE(3464),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3464),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(3464),
    [sym_class] = STATE(3464),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(7050),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7050),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7052),
    [sym_true] = ACTIONS(7050),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7050),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [2663] = {
    [sym_new_expression] = STATE(3465),
    [sym_augmented_assignment_expression] = STATE(3465),
    [sym_unary_expression] = STATE(3465),
    [sym_update_expression] = STATE(3465),
    [sym_regex] = STATE(3465),
    [sym_meta_property] = STATE(3465),
    [sym_call_signature] = STATE(908),
    [sym_statement_block] = STATE(1532),
    [sym__expression] = STATE(3465),
    [sym_yield_expression] = STATE(3465),
    [sym_as_expression] = STATE(3465),
    [sym_non_null_expression] = STATE(3465),
    [sym_internal_module] = STATE(3465),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3465),
    [sym_await_expression] = STATE(3465),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(3465),
    [sym_this] = STATE(3465),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(3465),
    [sym_generator_function] = STATE(3465),
    [sym_call_expression] = STATE(3465),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(3465),
    [sym_ternary_expression] = STATE(3465),
    [sym_binary_expression] = STATE(3465),
    [sym_template_string] = STATE(3465),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3465),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(3465),
    [sym_class] = STATE(3465),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(7054),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7054),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7056),
    [sym_true] = ACTIONS(7054),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7054),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [2664] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [2665] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7058),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2666] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7058),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2667] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [2668] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7061),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2669] = {
    [sym_type_arguments] = STATE(1845),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(3831),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(7063),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(7065),
  },
  [2670] = {
    [sym_tuple_type] = STATE(1847),
    [sym_index_type_query] = STATE(1847),
    [sym_lookup_type] = STATE(1847),
    [sym_this_type] = STATE(1847),
    [sym_flow_maybe_type] = STATE(1847),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_type_predicate] = STATE(1847),
    [sym_type_query] = STATE(1847),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(1847),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(1847),
    [sym__primary_type] = STATE(1847),
    [sym_generic_type] = STATE(1847),
    [sym_mapped_type] = STATE(1847),
    [sym_literal_type] = STATE(1847),
    [sym_parenthesized_type] = STATE(1847),
    [sym_predefined_type] = STATE(1847),
    [sym_string] = STATE(969),
    [sym_array_type] = STATE(1847),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [sym_true] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_LPAREN] = ACTIONS(3846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [2671] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(1852),
    [sym_constructor_type] = STATE(1852),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(1852),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(1852),
    [sym_intersection_type] = STATE(1852),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [2672] = {
    [sym_formal_parameters] = STATE(3469),
    [sym_type_parameters] = STATE(3470),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2673] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(1860),
    [sym_constructor_type] = STATE(1860),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(1860),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(1860),
    [sym_intersection_type] = STATE(1860),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [2674] = {
    [sym_formal_parameters] = STATE(3473),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2675] = {
    [sym_type_arguments] = STATE(1866),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(3862),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(3867),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(7068),
  },
  [2676] = {
    [anon_sym_EQ_GT] = ACTIONS(7071),
    [sym_comment] = ACTIONS(3),
  },
  [2677] = {
    [sym__initializer] = STATE(71),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3620),
    [anon_sym_AMP_EQ] = ACTIONS(3620),
    [anon_sym_PLUS_EQ] = ACTIONS(3620),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(3620),
    [anon_sym_STAR_EQ] = ACTIONS(3620),
    [anon_sym_PIPE_EQ] = ACTIONS(3620),
    [anon_sym_DASH_EQ] = ACTIONS(3620),
    [anon_sym_EQ_GT] = ACTIONS(3624),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3620),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT_EQ] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(7073),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7075),
  },
  [2678] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3894),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2679] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3628),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_AMP_EQ] = ACTIONS(3628),
    [anon_sym_PLUS_EQ] = ACTIONS(3628),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(3628),
    [anon_sym_STAR_EQ] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3628),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3628),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3628),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2680] = {
    [sym_new_expression] = STATE(1758),
    [sym_augmented_assignment_expression] = STATE(1758),
    [sym_unary_expression] = STATE(1758),
    [sym_update_expression] = STATE(1758),
    [sym_regex] = STATE(1758),
    [sym_meta_property] = STATE(1758),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(1758),
    [sym_yield_expression] = STATE(1758),
    [sym_as_expression] = STATE(1758),
    [sym_non_null_expression] = STATE(1758),
    [sym_internal_module] = STATE(1758),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1758),
    [sym_await_expression] = STATE(1758),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(1758),
    [sym_this] = STATE(1758),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(1758),
    [sym_generator_function] = STATE(1758),
    [sym_call_expression] = STATE(1758),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(1758),
    [sym_ternary_expression] = STATE(1758),
    [sym_binary_expression] = STATE(1758),
    [sym_template_string] = STATE(1758),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1758),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(1758),
    [sym_class] = STATE(1758),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(7077),
    [sym_false] = ACTIONS(3632),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3632),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3634),
    [sym_true] = ACTIONS(3632),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3632),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [2681] = {
    [sym_new_expression] = STATE(1759),
    [sym_augmented_assignment_expression] = STATE(1759),
    [sym_unary_expression] = STATE(1759),
    [sym_update_expression] = STATE(1759),
    [sym_regex] = STATE(1759),
    [sym_meta_property] = STATE(1759),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(1759),
    [sym_yield_expression] = STATE(1759),
    [sym_as_expression] = STATE(1759),
    [sym_non_null_expression] = STATE(1759),
    [sym_internal_module] = STATE(1759),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1759),
    [sym_await_expression] = STATE(1759),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(1759),
    [sym_this] = STATE(1759),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(1759),
    [sym_generator_function] = STATE(1759),
    [sym_call_expression] = STATE(1759),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(1759),
    [sym_ternary_expression] = STATE(1759),
    [sym_binary_expression] = STATE(1759),
    [sym_template_string] = STATE(1759),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1759),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(1759),
    [sym_class] = STATE(1759),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(3636),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3636),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3905),
    [sym_true] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3636),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [2682] = {
    [sym_pair] = STATE(219),
    [aux_sym_export_statement_repeat1] = STATE(1879),
    [sym_object] = STATE(397),
    [sym__property_name] = STATE(1662),
    [aux_sym_object_repeat1] = STATE(223),
    [sym_assignment_pattern] = STATE(219),
    [sym_method_signature] = STATE(810),
    [sym_property_signature] = STATE(810),
    [sym_call_signature] = STATE(810),
    [sym_construct_signature] = STATE(810),
    [sym_export_statement] = STATE(810),
    [sym_method_definition] = STATE(219),
    [sym_index_signature] = STATE(810),
    [sym_decorator] = STATE(1879),
    [sym_accessibility_modifier] = STATE(1663),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(1662),
    [sym_array] = STATE(399),
    [sym_spread_element] = STATE(219),
    [sym_string] = STATE(1662),
    [sym_type_parameters] = STATE(811),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(3909),
    [anon_sym_symbol] = ACTIONS(3909),
    [anon_sym_number] = ACTIONS(3909),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(3909),
    [anon_sym_COMMA] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(3909),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(3909),
    [anon_sym_private] = ACTIONS(3911),
    [anon_sym_boolean] = ACTIONS(3909),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3913),
    [anon_sym_get] = ACTIONS(3915),
    [anon_sym_RBRACE] = ACTIONS(7079),
    [anon_sym_public] = ACTIONS(3911),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3911),
    [anon_sym_string] = ACTIONS(3909),
    [anon_sym_set] = ACTIONS(3915),
    [anon_sym_type] = ACTIONS(3909),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(3909),
    [anon_sym_export] = ACTIONS(3917),
    [sym_readonly] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3909),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [2683] = {
    [sym_new_expression] = STATE(1758),
    [sym_augmented_assignment_expression] = STATE(1758),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(1758),
    [sym_update_expression] = STATE(1758),
    [sym_regex] = STATE(1758),
    [sym_meta_property] = STATE(1758),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(1758),
    [sym_yield_expression] = STATE(1758),
    [sym_as_expression] = STATE(1758),
    [sym_non_null_expression] = STATE(1758),
    [sym_internal_module] = STATE(1758),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1758),
    [sym_await_expression] = STATE(1758),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(1758),
    [sym_this] = STATE(1758),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(1758),
    [sym_generator_function] = STATE(1758),
    [sym_call_expression] = STATE(1758),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(1758),
    [sym_ternary_expression] = STATE(1758),
    [sym_binary_expression] = STATE(1758),
    [sym_template_string] = STATE(1758),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1758),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(1758),
    [sym_class] = STATE(1758),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(3628),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_AMP_EQ] = ACTIONS(3628),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(3628),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(3628),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_PIPE_EQ] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3628),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3628),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1693),
    [sym_true] = ACTIONS(3632),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3628),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(3632),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3628),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3632),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_STAR_EQ] = ACTIONS(3628),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(3634),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3628),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3632),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2684] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_SEMI] = ACTIONS(207),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym__automatic_semicolon] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3937),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [2685] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(3652),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(3654),
    [anon_sym_symbol] = ACTIONS(3654),
    [anon_sym_number] = ACTIONS(3654),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3654),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(3654),
    [anon_sym_private] = ACTIONS(3654),
    [anon_sym_boolean] = ACTIONS(3654),
    [anon_sym_async] = ACTIONS(3658),
    [anon_sym_public] = ACTIONS(3654),
    [anon_sym_get] = ACTIONS(3654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3654),
    [anon_sym_string] = ACTIONS(3654),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(3654),
    [anon_sym_type] = ACTIONS(3654),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(3654),
    [anon_sym_export] = ACTIONS(3654),
    [anon_sym_namespace] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [2686] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7058),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2687] = {
    [sym_identifier] = ACTIONS(7081),
    [anon_sym_BQUOTE] = ACTIONS(7083),
    [anon_sym_debugger] = ACTIONS(7081),
    [anon_sym_symbol] = ACTIONS(7081),
    [anon_sym_AT] = ACTIONS(7083),
    [anon_sym_DASH] = ACTIONS(7081),
    [anon_sym_void] = ACTIONS(7081),
    [anon_sym_break] = ACTIONS(7081),
    [anon_sym_const] = ACTIONS(7081),
    [sym_super] = ACTIONS(7081),
    [anon_sym_return] = ACTIONS(7081),
    [anon_sym_private] = ACTIONS(7081),
    [anon_sym_get] = ACTIONS(7081),
    [anon_sym_RBRACE] = ACTIONS(7083),
    [anon_sym_interface] = ACTIONS(7081),
    [anon_sym_default] = ACTIONS(7081),
    [anon_sym_enum] = ACTIONS(7081),
    [anon_sym_delete] = ACTIONS(7081),
    [anon_sym_continue] = ACTIONS(7081),
    [anon_sym_DASH_DASH] = ACTIONS(7083),
    [anon_sym_if] = ACTIONS(7081),
    [anon_sym_this] = ACTIONS(7081),
    [anon_sym_yield] = ACTIONS(7081),
    [sym_true] = ACTIONS(7081),
    [anon_sym_throw] = ACTIONS(7081),
    [anon_sym_protected] = ACTIONS(7081),
    [anon_sym_abstract] = ACTIONS(7081),
    [anon_sym_set] = ACTIONS(7081),
    [anon_sym_type] = ACTIONS(7081),
    [anon_sym_import] = ACTIONS(7081),
    [anon_sym_namespace] = ACTIONS(7081),
    [anon_sym_PLUS_PLUS] = ACTIONS(7083),
    [anon_sym_await] = ACTIONS(7081),
    [anon_sym_DQUOTE] = ACTIONS(7083),
    [anon_sym_else] = ACTIONS(7081),
    [anon_sym_BANG] = ACTIONS(7083),
    [anon_sym_for] = ACTIONS(7081),
    [anon_sym_LBRACK] = ACTIONS(7083),
    [sym_false] = ACTIONS(7081),
    [anon_sym_SEMI] = ACTIONS(7083),
    [anon_sym_case] = ACTIONS(7081),
    [anon_sym_module] = ACTIONS(7081),
    [anon_sym_number] = ACTIONS(7081),
    [anon_sym_class] = ACTIONS(7081),
    [anon_sym_declare] = ACTIONS(7081),
    [anon_sym_typeof] = ACTIONS(7081),
    [anon_sym_LBRACE] = ACTIONS(7083),
    [anon_sym_switch] = ACTIONS(7081),
    [anon_sym_LPAREN] = ACTIONS(7083),
    [sym_null] = ACTIONS(7081),
    [anon_sym_any] = ACTIONS(7081),
    [anon_sym_boolean] = ACTIONS(7081),
    [anon_sym_async] = ACTIONS(7081),
    [anon_sym_public] = ACTIONS(7081),
    [anon_sym_var] = ACTIONS(7081),
    [anon_sym_while] = ACTIONS(7081),
    [anon_sym_SQUOTE] = ACTIONS(7083),
    [anon_sym_try] = ACTIONS(7081),
    [anon_sym_LT] = ACTIONS(7083),
    [sym_number] = ACTIONS(7083),
    [anon_sym_SLASH] = ACTIONS(7081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7081),
    [anon_sym_function] = ACTIONS(7081),
    [sym_undefined] = ACTIONS(7081),
    [anon_sym_new] = ACTIONS(7081),
    [ts_builtin_sym_end] = ACTIONS(7083),
    [anon_sym_let] = ACTIONS(7081),
    [anon_sym_PLUS] = ACTIONS(7081),
    [anon_sym_export] = ACTIONS(7081),
    [anon_sym_do] = ACTIONS(7081),
    [anon_sym_TILDE] = ACTIONS(7083),
    [anon_sym_with] = ACTIONS(7081),
  },
  [2688] = {
    [sym_type_alias_declaration] = STATE(361),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(361),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(361),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(361),
    [sym_return_statement] = STATE(361),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(361),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(361),
    [sym_switch_statement] = STATE(361),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(361),
    [sym_throw_statement] = STATE(361),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(361),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(361),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(361),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(361),
    [sym_abstract_class] = STATE(361),
    [sym_interface_declaration] = STATE(361),
    [sym_statement_block] = STATE(361),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(361),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(361),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(361),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(361),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(361),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(361),
    [sym_empty_statement] = STATE(361),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(361),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(361),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(361),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(361),
    [sym_break_statement] = STATE(361),
    [sym_labeled_statement] = STATE(361),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(361),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [2689] = {
    [sym_type_alias_declaration] = STATE(3480),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3480),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3480),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3480),
    [sym_return_statement] = STATE(3480),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3480),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3480),
    [sym_switch_statement] = STATE(3480),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3480),
    [sym_throw_statement] = STATE(3480),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3480),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3480),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(3480),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3480),
    [sym_abstract_class] = STATE(3480),
    [sym_interface_declaration] = STATE(3480),
    [sym_statement_block] = STATE(3480),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3480),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3480),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3480),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3480),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3480),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3480),
    [sym_empty_statement] = STATE(3480),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(3480),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3480),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3480),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3480),
    [sym_break_statement] = STATE(3480),
    [sym_labeled_statement] = STATE(3480),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3480),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [2690] = {
    [anon_sym_LPAREN] = ACTIONS(7085),
    [sym_comment] = ACTIONS(3),
  },
  [2691] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3485),
    [sym_variable_declaration] = STATE(3485),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(3485),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(3486),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_lexical_declaration] = STATE(3485),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(3487),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(7087),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(7089),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7091),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(7089),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [2692] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(7093),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(282),
  },
  [2693] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(2695),
    [sym__declaration] = STATE(192),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(2695),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(5597),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(5599),
    [anon_sym_global] = ACTIONS(322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(5601),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_async] = ACTIONS(1727),
  },
  [2694] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(2695),
    [sym__declaration] = STATE(317),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(2695),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(1733),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(5601),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_async] = ACTIONS(1727),
  },
  [2695] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(5605),
    [anon_sym_class] = ACTIONS(3730),
    [sym_comment] = ACTIONS(3),
  },
  [2696] = {
    [sym_type_alias_declaration] = STATE(777),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(777),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(777),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(777),
    [sym_return_statement] = STATE(777),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(777),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(777),
    [sym_switch_statement] = STATE(777),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(777),
    [sym_throw_statement] = STATE(777),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(777),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(777),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(777),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(777),
    [sym_abstract_class] = STATE(777),
    [sym_interface_declaration] = STATE(777),
    [sym_statement_block] = STATE(777),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(777),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(777),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(777),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(777),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(777),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(777),
    [sym_empty_statement] = STATE(777),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(777),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(777),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(777),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(777),
    [sym_break_statement] = STATE(777),
    [sym_labeled_statement] = STATE(777),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(777),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [2697] = {
    [sym_type_alias_declaration] = STATE(934),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(934),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(934),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(934),
    [sym_return_statement] = STATE(934),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(934),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(934),
    [sym_switch_statement] = STATE(934),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(934),
    [sym_throw_statement] = STATE(934),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(934),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(934),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(934),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(934),
    [sym_abstract_class] = STATE(934),
    [sym_interface_declaration] = STATE(934),
    [sym_statement_block] = STATE(934),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(934),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(934),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(934),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(934),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(934),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(934),
    [sym_empty_statement] = STATE(934),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(934),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(934),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(934),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(934),
    [sym_break_statement] = STATE(934),
    [sym_labeled_statement] = STATE(934),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(934),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [2698] = {
    [sym_type_alias_declaration] = STATE(2047),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2047),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2047),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2047),
    [sym_return_statement] = STATE(2047),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2047),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2047),
    [sym_switch_statement] = STATE(2047),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2047),
    [sym_throw_statement] = STATE(2047),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2047),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2047),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(2047),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2047),
    [sym_abstract_class] = STATE(2047),
    [sym_interface_declaration] = STATE(2047),
    [sym_statement_block] = STATE(2047),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2047),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2047),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2047),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2047),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2047),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2047),
    [sym_empty_statement] = STATE(2047),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(2047),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2047),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2047),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2047),
    [sym_break_statement] = STATE(2047),
    [sym_labeled_statement] = STATE(2047),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2047),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [2699] = {
    [sym_type_alias_declaration] = STATE(915),
    [aux_sym_export_statement_repeat1] = STATE(2695),
    [sym__declaration] = STATE(915),
    [sym_ambient_declaration] = STATE(915),
    [sym_import_alias] = STATE(915),
    [sym_export_statement] = STATE(915),
    [sym_generator_function] = STATE(915),
    [sym_lexical_declaration] = STATE(915),
    [sym_internal_module] = STATE(915),
    [sym_decorator] = STATE(2695),
    [sym_enum_declaration] = STATE(915),
    [sym_function] = STATE(915),
    [sym_function_signature] = STATE(915),
    [sym_variable_declaration] = STATE(915),
    [sym_abstract_class] = STATE(915),
    [sym_module] = STATE(915),
    [sym_interface_declaration] = STATE(915),
    [sym_class] = STATE(915),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(1733),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(5601),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_async] = ACTIONS(1727),
  },
  [2700] = {
    [sym_class_body] = STATE(2050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [2701] = {
    [sym_class_heritage] = STATE(3489),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(2050),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [2702] = {
    [sym_array] = STATE(3491),
    [sym_object] = STATE(3492),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(7095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [2703] = {
    [anon_sym_of] = ACTIONS(7097),
    [sym_comment] = ACTIONS(3),
  },
  [2704] = {
    [anon_sym_of] = ACTIONS(7099),
    [sym_comment] = ACTIONS(3),
  },
  [2705] = {
    [anon_sym_of] = ACTIONS(7101),
    [sym_comment] = ACTIONS(3),
  },
  [2706] = {
    [sym_new_expression] = STATE(3496),
    [sym_augmented_assignment_expression] = STATE(3496),
    [sym_unary_expression] = STATE(3496),
    [sym_update_expression] = STATE(3496),
    [sym_regex] = STATE(3496),
    [sym_meta_property] = STATE(3496),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3496),
    [sym_yield_expression] = STATE(3496),
    [sym_as_expression] = STATE(3496),
    [sym_non_null_expression] = STATE(3496),
    [sym_internal_module] = STATE(3496),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3496),
    [sym_await_expression] = STATE(3496),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(3497),
    [sym_string] = STATE(3496),
    [sym_this] = STATE(3496),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3496),
    [sym_generator_function] = STATE(3496),
    [sym_call_expression] = STATE(3496),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3496),
    [sym_ternary_expression] = STATE(3496),
    [sym_binary_expression] = STATE(3496),
    [sym_template_string] = STATE(3496),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3496),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3496),
    [sym_class] = STATE(3496),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7103),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7103),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7105),
    [sym_true] = ACTIONS(7103),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7103),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2707] = {
    [sym_new_expression] = STATE(3498),
    [sym_augmented_assignment_expression] = STATE(3498),
    [sym_unary_expression] = STATE(3498),
    [sym_update_expression] = STATE(3498),
    [sym_regex] = STATE(3498),
    [sym_meta_property] = STATE(3498),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3498),
    [sym_yield_expression] = STATE(3498),
    [sym_as_expression] = STATE(3498),
    [sym_non_null_expression] = STATE(3498),
    [sym_internal_module] = STATE(3498),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3498),
    [sym_await_expression] = STATE(3498),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3498),
    [sym_this] = STATE(3498),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3498),
    [sym_generator_function] = STATE(3498),
    [sym_call_expression] = STATE(3498),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3498),
    [sym_ternary_expression] = STATE(3498),
    [sym_binary_expression] = STATE(3498),
    [sym_template_string] = STATE(3498),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3498),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3498),
    [sym_class] = STATE(3498),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7107),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7107),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7109),
    [sym_true] = ACTIONS(7107),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7107),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2708] = {
    [sym__initializer] = STATE(405),
    [sym_type_annotation] = STATE(406),
    [sym__automatic_semicolon] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_of] = ACTIONS(7097),
    [anon_sym_COMMA] = ACTIONS(739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7111),
  },
  [2709] = {
    [sym__initializer] = STATE(425),
    [sym_type_annotation] = STATE(426),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(7099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7113),
  },
  [2710] = {
    [sym__initializer] = STATE(427),
    [sym_type_annotation] = STATE(428),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(7101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7115),
  },
  [2711] = {
    [sym_new_expression] = STATE(3503),
    [sym_augmented_assignment_expression] = STATE(3503),
    [sym_unary_expression] = STATE(3503),
    [sym_update_expression] = STATE(3503),
    [sym_regex] = STATE(3503),
    [sym_meta_property] = STATE(3503),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(3503),
    [sym_yield_expression] = STATE(3503),
    [sym_as_expression] = STATE(3503),
    [sym_non_null_expression] = STATE(3503),
    [sym_internal_module] = STATE(3503),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3503),
    [sym_await_expression] = STATE(3503),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(3504),
    [sym_string] = STATE(3503),
    [sym_this] = STATE(3503),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(3503),
    [sym_generator_function] = STATE(3503),
    [sym_call_expression] = STATE(3503),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(3503),
    [sym_ternary_expression] = STATE(3503),
    [sym_binary_expression] = STATE(3503),
    [sym_template_string] = STATE(3503),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3503),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(3503),
    [sym_class] = STATE(3503),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(7117),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7117),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7121),
    [sym_true] = ACTIONS(7117),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7117),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [2712] = {
    [sym_new_expression] = STATE(3505),
    [sym_augmented_assignment_expression] = STATE(3505),
    [sym_unary_expression] = STATE(3505),
    [sym_update_expression] = STATE(3505),
    [sym_regex] = STATE(3505),
    [sym_meta_property] = STATE(3505),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3505),
    [sym_yield_expression] = STATE(3505),
    [sym_as_expression] = STATE(3505),
    [sym_non_null_expression] = STATE(3505),
    [sym_internal_module] = STATE(3505),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3505),
    [sym_await_expression] = STATE(3505),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3505),
    [sym_this] = STATE(3505),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3505),
    [sym_generator_function] = STATE(3505),
    [sym_call_expression] = STATE(3505),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3505),
    [sym_ternary_expression] = STATE(3505),
    [sym_binary_expression] = STATE(3505),
    [sym_template_string] = STATE(3505),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3505),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3505),
    [sym_class] = STATE(3505),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7123),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7125),
    [sym_true] = ACTIONS(7123),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7123),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2713] = {
    [sym_new_expression] = STATE(3506),
    [sym_augmented_assignment_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3506),
    [sym_update_expression] = STATE(3506),
    [sym_regex] = STATE(3506),
    [sym_meta_property] = STATE(3506),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3506),
    [sym_yield_expression] = STATE(3506),
    [sym_as_expression] = STATE(3506),
    [sym_non_null_expression] = STATE(3506),
    [sym_internal_module] = STATE(3506),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3506),
    [sym_await_expression] = STATE(3506),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(3507),
    [sym_string] = STATE(3506),
    [sym_this] = STATE(3506),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3506),
    [sym_generator_function] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3506),
    [sym_ternary_expression] = STATE(3506),
    [sym_binary_expression] = STATE(3506),
    [sym_template_string] = STATE(3506),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3506),
    [sym_class] = STATE(3506),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7127),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7127),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7129),
    [sym_true] = ACTIONS(7127),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7127),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2714] = {
    [sym_new_expression] = STATE(3508),
    [sym_augmented_assignment_expression] = STATE(3508),
    [sym_unary_expression] = STATE(3508),
    [sym_update_expression] = STATE(3508),
    [sym_regex] = STATE(3508),
    [sym_meta_property] = STATE(3508),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3508),
    [sym_yield_expression] = STATE(3508),
    [sym_as_expression] = STATE(3508),
    [sym_non_null_expression] = STATE(3508),
    [sym_internal_module] = STATE(3508),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3508),
    [sym_await_expression] = STATE(3508),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3508),
    [sym_this] = STATE(3508),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3508),
    [sym_generator_function] = STATE(3508),
    [sym_call_expression] = STATE(3508),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3508),
    [sym_ternary_expression] = STATE(3508),
    [sym_binary_expression] = STATE(3508),
    [sym_template_string] = STATE(3508),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3508),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3508),
    [sym_class] = STATE(3508),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7131),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7131),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7133),
    [sym_true] = ACTIONS(7131),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7131),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2715] = {
    [sym_new_expression] = STATE(3509),
    [sym_augmented_assignment_expression] = STATE(3509),
    [sym_unary_expression] = STATE(3509),
    [sym_update_expression] = STATE(3509),
    [sym_regex] = STATE(3509),
    [sym_meta_property] = STATE(3509),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3509),
    [sym_yield_expression] = STATE(3509),
    [sym_as_expression] = STATE(3509),
    [sym_non_null_expression] = STATE(3509),
    [sym_internal_module] = STATE(3509),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3509),
    [sym_await_expression] = STATE(3509),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(3510),
    [sym_string] = STATE(3509),
    [sym_this] = STATE(3509),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3509),
    [sym_generator_function] = STATE(3509),
    [sym_call_expression] = STATE(3509),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3509),
    [sym_ternary_expression] = STATE(3509),
    [sym_binary_expression] = STATE(3509),
    [sym_template_string] = STATE(3509),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3509),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3509),
    [sym_class] = STATE(3509),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7135),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7135),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7137),
    [sym_true] = ACTIONS(7135),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7135),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2716] = {
    [anon_sym_COLON] = ACTIONS(7139),
    [sym_comment] = ACTIONS(3),
  },
  [2717] = {
    [sym_call_signature] = STATE(3512),
    [sym_formal_parameters] = STATE(858),
    [sym_type_parameters] = STATE(859),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2718] = {
    [sym_statement_block] = STATE(2149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [2719] = {
    [sym_statement_block] = STATE(2149),
    [sym__automatic_semicolon] = ACTIONS(3498),
    [anon_sym_SEMI] = ACTIONS(3498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [2720] = {
    [sym_call_signature] = STATE(3513),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2721] = {
    [sym_statement_block] = STATE(2152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [2722] = {
    [sym_identifier] = ACTIONS(7141),
    [anon_sym_BQUOTE] = ACTIONS(7143),
    [anon_sym_debugger] = ACTIONS(7141),
    [anon_sym_symbol] = ACTIONS(7141),
    [anon_sym_AT] = ACTIONS(7143),
    [anon_sym_DASH] = ACTIONS(7141),
    [anon_sym_void] = ACTIONS(7141),
    [anon_sym_break] = ACTIONS(7141),
    [anon_sym_const] = ACTIONS(7141),
    [sym_super] = ACTIONS(7141),
    [anon_sym_return] = ACTIONS(7141),
    [anon_sym_private] = ACTIONS(7141),
    [anon_sym_get] = ACTIONS(7141),
    [anon_sym_RBRACE] = ACTIONS(7143),
    [anon_sym_interface] = ACTIONS(7141),
    [anon_sym_default] = ACTIONS(7141),
    [anon_sym_enum] = ACTIONS(7141),
    [anon_sym_delete] = ACTIONS(7141),
    [anon_sym_continue] = ACTIONS(7141),
    [anon_sym_DASH_DASH] = ACTIONS(7143),
    [anon_sym_if] = ACTIONS(7141),
    [anon_sym_this] = ACTIONS(7141),
    [anon_sym_yield] = ACTIONS(7141),
    [sym_true] = ACTIONS(7141),
    [anon_sym_throw] = ACTIONS(7141),
    [anon_sym_protected] = ACTIONS(7141),
    [anon_sym_abstract] = ACTIONS(7141),
    [anon_sym_set] = ACTIONS(7141),
    [anon_sym_type] = ACTIONS(7141),
    [anon_sym_import] = ACTIONS(7141),
    [anon_sym_namespace] = ACTIONS(7141),
    [anon_sym_PLUS_PLUS] = ACTIONS(7143),
    [anon_sym_await] = ACTIONS(7141),
    [anon_sym_DQUOTE] = ACTIONS(7143),
    [anon_sym_else] = ACTIONS(7141),
    [anon_sym_BANG] = ACTIONS(7143),
    [anon_sym_for] = ACTIONS(7141),
    [anon_sym_LBRACK] = ACTIONS(7143),
    [sym_false] = ACTIONS(7141),
    [anon_sym_SEMI] = ACTIONS(7143),
    [anon_sym_case] = ACTIONS(7141),
    [anon_sym_module] = ACTIONS(7141),
    [anon_sym_number] = ACTIONS(7141),
    [anon_sym_class] = ACTIONS(7141),
    [anon_sym_declare] = ACTIONS(7141),
    [anon_sym_typeof] = ACTIONS(7141),
    [anon_sym_LBRACE] = ACTIONS(7143),
    [anon_sym_switch] = ACTIONS(7141),
    [anon_sym_LPAREN] = ACTIONS(7143),
    [sym_null] = ACTIONS(7141),
    [anon_sym_any] = ACTIONS(7141),
    [anon_sym_boolean] = ACTIONS(7141),
    [anon_sym_async] = ACTIONS(7141),
    [anon_sym_public] = ACTIONS(7141),
    [anon_sym_var] = ACTIONS(7141),
    [anon_sym_while] = ACTIONS(7141),
    [anon_sym_SQUOTE] = ACTIONS(7143),
    [anon_sym_try] = ACTIONS(7141),
    [anon_sym_LT] = ACTIONS(7143),
    [sym_number] = ACTIONS(7143),
    [anon_sym_SLASH] = ACTIONS(7141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7141),
    [anon_sym_function] = ACTIONS(7141),
    [sym_undefined] = ACTIONS(7141),
    [anon_sym_new] = ACTIONS(7141),
    [ts_builtin_sym_end] = ACTIONS(7143),
    [anon_sym_let] = ACTIONS(7141),
    [anon_sym_PLUS] = ACTIONS(7141),
    [anon_sym_export] = ACTIONS(7141),
    [anon_sym_do] = ACTIONS(7141),
    [anon_sym_TILDE] = ACTIONS(7143),
    [anon_sym_with] = ACTIONS(7141),
  },
  [2723] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2724] = {
    [sym_formal_parameters] = STATE(3514),
    [sym_type_parameters] = STATE(3515),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2725] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2726] = {
    [anon_sym_EQ_GT] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(7145),
    [anon_sym_PIPE] = ACTIONS(7147),
    [sym_comment] = ACTIONS(3),
  },
  [2727] = {
    [sym_formal_parameters] = STATE(3518),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2728] = {
    [anon_sym_EQ_GT] = ACTIONS(7149),
    [sym_comment] = ACTIONS(3),
  },
  [2729] = {
    [anon_sym_EQ_GT] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(7145),
    [anon_sym_PIPE] = ACTIONS(7147),
    [sym_comment] = ACTIONS(3),
  },
  [2730] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3520),
    [sym_constructor_type] = STATE(3520),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(3520),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3520),
    [sym_intersection_type] = STATE(3520),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(942),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(944),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2731] = {
    [anon_sym_EQ_GT] = ACTIONS(7151),
    [sym_comment] = ACTIONS(3),
  },
  [2732] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3522),
    [sym_constructor_type] = STATE(3522),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(3522),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3522),
    [sym_intersection_type] = STATE(3522),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(942),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(944),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2733] = {
    [anon_sym_EQ_GT] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(7145),
    [anon_sym_PIPE] = ACTIONS(7147),
    [sym_comment] = ACTIONS(3),
  },
  [2734] = {
    [anon_sym_EQ_GT] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_PIPE] = ACTIONS(3748),
    [sym_comment] = ACTIONS(3),
  },
  [2735] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [2736] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2737] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [2738] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [2739] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2151),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [2740] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2155),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [2741] = {
    [sym_new_expression] = STATE(3523),
    [sym_augmented_assignment_expression] = STATE(3523),
    [sym_unary_expression] = STATE(3523),
    [sym_update_expression] = STATE(3523),
    [sym_regex] = STATE(3523),
    [sym_meta_property] = STATE(3523),
    [sym_call_signature] = STATE(962),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(3523),
    [sym_yield_expression] = STATE(3523),
    [sym_as_expression] = STATE(3523),
    [sym_non_null_expression] = STATE(3523),
    [sym_internal_module] = STATE(3523),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3523),
    [sym_await_expression] = STATE(3523),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(3523),
    [sym_this] = STATE(3523),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(3523),
    [sym_generator_function] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(3523),
    [sym_ternary_expression] = STATE(3523),
    [sym_binary_expression] = STATE(3523),
    [sym_template_string] = STATE(3523),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(3523),
    [sym_class] = STATE(3523),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(7153),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7153),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7155),
    [sym_true] = ACTIONS(7153),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7153),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [2742] = {
    [sym_new_expression] = STATE(3524),
    [sym_augmented_assignment_expression] = STATE(3524),
    [sym_unary_expression] = STATE(3524),
    [sym_update_expression] = STATE(3524),
    [sym_regex] = STATE(3524),
    [sym_meta_property] = STATE(3524),
    [sym_call_signature] = STATE(962),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(3524),
    [sym_yield_expression] = STATE(3524),
    [sym_as_expression] = STATE(3524),
    [sym_non_null_expression] = STATE(3524),
    [sym_internal_module] = STATE(3524),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3524),
    [sym_await_expression] = STATE(3524),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(3524),
    [sym_this] = STATE(3524),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(3524),
    [sym_generator_function] = STATE(3524),
    [sym_call_expression] = STATE(3524),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(3524),
    [sym_ternary_expression] = STATE(3524),
    [sym_binary_expression] = STATE(3524),
    [sym_template_string] = STATE(3524),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3524),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(3524),
    [sym_class] = STATE(3524),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(7157),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7157),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7159),
    [sym_true] = ACTIONS(7157),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7157),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [2743] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [2744] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7161),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2745] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7161),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2746] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [2747] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7164),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2748] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(7166),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(7168),
  },
  [2749] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2750] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2751] = {
    [sym_formal_parameters] = STATE(3528),
    [sym_type_parameters] = STATE(3529),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2752] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2753] = {
    [sym_formal_parameters] = STATE(3532),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2754] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1577),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(7171),
  },
  [2755] = {
    [anon_sym_EQ_GT] = ACTIONS(7174),
    [sym_comment] = ACTIONS(3),
  },
  [2756] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_AMP_EQ] = ACTIONS(3759),
    [anon_sym_PLUS_EQ] = ACTIONS(3759),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(3759),
    [anon_sym_STAR_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_DASH_EQ] = ACTIONS(3759),
    [anon_sym_EQ_GT] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3759),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7176),
  },
  [2757] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_AMP_EQ] = ACTIONS(3767),
    [anon_sym_PLUS_EQ] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(3767),
    [anon_sym_STAR_EQ] = ACTIONS(3767),
    [anon_sym_PIPE_EQ] = ACTIONS(3767),
    [anon_sym_DASH_EQ] = ACTIONS(3767),
    [anon_sym_EQ_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3767),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2758] = {
    [sym_new_expression] = STATE(1819),
    [sym_augmented_assignment_expression] = STATE(1819),
    [sym_unary_expression] = STATE(1819),
    [sym_update_expression] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1819),
    [sym_yield_expression] = STATE(1819),
    [sym_as_expression] = STATE(1819),
    [sym_non_null_expression] = STATE(1819),
    [sym_internal_module] = STATE(1819),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1819),
    [sym_await_expression] = STATE(1819),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1819),
    [sym_this] = STATE(1819),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_call_expression] = STATE(1819),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1819),
    [sym_ternary_expression] = STATE(1819),
    [sym_binary_expression] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1819),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1819),
    [sym_class] = STATE(1819),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(7178),
    [sym_false] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3771),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [2759] = {
    [sym_new_expression] = STATE(1820),
    [sym_augmented_assignment_expression] = STATE(1820),
    [sym_unary_expression] = STATE(1820),
    [sym_update_expression] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_meta_property] = STATE(1820),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1820),
    [sym_yield_expression] = STATE(1820),
    [sym_as_expression] = STATE(1820),
    [sym_non_null_expression] = STATE(1820),
    [sym_internal_module] = STATE(1820),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1820),
    [sym_await_expression] = STATE(1820),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1820),
    [sym_this] = STATE(1820),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1820),
    [sym_generator_function] = STATE(1820),
    [sym_call_expression] = STATE(1820),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1820),
    [sym_ternary_expression] = STATE(1820),
    [sym_binary_expression] = STATE(1820),
    [sym_template_string] = STATE(1820),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1820),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1820),
    [sym_class] = STATE(1820),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(3775),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3775),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(3775),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3775),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [2760] = {
    [sym_new_expression] = STATE(1819),
    [sym_augmented_assignment_expression] = STATE(1819),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(1819),
    [sym_update_expression] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(1819),
    [sym_yield_expression] = STATE(1819),
    [sym_as_expression] = STATE(1819),
    [sym_non_null_expression] = STATE(1819),
    [sym_internal_module] = STATE(1819),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1819),
    [sym_await_expression] = STATE(1819),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(1819),
    [sym_this] = STATE(1819),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_call_expression] = STATE(1819),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(1819),
    [sym_ternary_expression] = STATE(1819),
    [sym_binary_expression] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1819),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(1819),
    [sym_class] = STATE(1819),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_AMP_EQ] = ACTIONS(3767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(3767),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_PIPE_EQ] = ACTIONS(3767),
    [anon_sym_DASH_EQ] = ACTIONS(3767),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3767),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(1958),
    [sym_true] = ACTIONS(3771),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1946),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(3771),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3771),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_STAR_EQ] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_EQ_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(3773),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2761] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(3791),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(3793),
    [anon_sym_symbol] = ACTIONS(3793),
    [anon_sym_number] = ACTIONS(3793),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3793),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3795),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3793),
    [anon_sym_private] = ACTIONS(3793),
    [anon_sym_boolean] = ACTIONS(3793),
    [anon_sym_async] = ACTIONS(3797),
    [anon_sym_public] = ACTIONS(3793),
    [anon_sym_get] = ACTIONS(3793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3793),
    [anon_sym_string] = ACTIONS(3793),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(3793),
    [anon_sym_type] = ACTIONS(3793),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(3793),
    [anon_sym_export] = ACTIONS(3793),
    [anon_sym_namespace] = ACTIONS(3799),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [2762] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(7180),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(7180),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_as] = ACTIONS(596),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(125),
  },
  [2763] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7161),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2764] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(7184),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(7186),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [2765] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(7188),
    [sym_comment] = ACTIONS(3),
  },
  [2766] = {
    [aux_sym_implements_clause_repeat1] = STATE(3540),
    [anon_sym_GT] = ACTIONS(7190),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
  },
  [2767] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_BANG] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym_BQUOTE] = ACTIONS(5194),
    [sym__automatic_semicolon] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_LT_LT] = ACTIONS(5194),
    [anon_sym_STAR] = ACTIONS(5192),
    [anon_sym_GT_GT_GT] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_BANG_EQ] = ACTIONS(5192),
    [anon_sym_LT_EQ] = ACTIONS(5194),
    [anon_sym_LPAREN] = ACTIONS(5194),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5194),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_as] = ACTIONS(5194),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_EQ_EQ] = ACTIONS(5192),
    [anon_sym_instanceof] = ACTIONS(5194),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_SLASH] = ACTIONS(5192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7194),
    [anon_sym_CARET] = ACTIONS(5194),
    [anon_sym_STAR_STAR] = ACTIONS(5194),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5194),
    [anon_sym_in] = ACTIONS(5192),
  },
  [2768] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(7184),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(7186),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [2769] = {
    [aux_sym_object_type_repeat1] = STATE(3543),
    [sym__automatic_semicolon] = ACTIONS(7199),
    [anon_sym_RBRACE] = ACTIONS(7201),
    [anon_sym_SEMI] = ACTIONS(7199),
    [anon_sym_COMMA] = ACTIONS(7199),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7201),
    [sym_comment] = ACTIONS(3),
  },
  [2770] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(7201),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7201),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [2771] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5294),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_BANG] = ACTIONS(5292),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_BQUOTE] = ACTIONS(5294),
    [sym__automatic_semicolon] = ACTIONS(5294),
    [anon_sym_PIPE] = ACTIONS(5292),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LT_LT] = ACTIONS(5294),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_GT_GT_GT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_DASH] = ACTIONS(5292),
    [anon_sym_BANG_EQ] = ACTIONS(5292),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_GT] = ACTIONS(5292),
    [anon_sym_AMP] = ACTIONS(5292),
    [anon_sym_PERCENT] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_EQ_EQ] = ACTIONS(5292),
    [anon_sym_instanceof] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5292),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_SLASH] = ACTIONS(5292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5294),
    [anon_sym_CARET] = ACTIONS(5294),
    [anon_sym_STAR_STAR] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5292),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5294),
    [anon_sym_GT_GT] = ACTIONS(5292),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5294),
    [anon_sym_in] = ACTIONS(5292),
  },
  [2772] = {
    [aux_sym_object_type_repeat1] = STATE(2544),
    [sym__automatic_semicolon] = ACTIONS(7199),
    [anon_sym_RBRACE] = ACTIONS(7201),
    [anon_sym_SEMI] = ACTIONS(7199),
    [anon_sym_COMMA] = ACTIONS(7199),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7201),
    [sym_comment] = ACTIONS(3),
  },
  [2773] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5306),
    [anon_sym_LBRACK] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(5306),
    [anon_sym_BQUOTE] = ACTIONS(5306),
    [sym__automatic_semicolon] = ACTIONS(5306),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_COMMA] = ACTIONS(5306),
    [anon_sym_LT_LT] = ACTIONS(5306),
    [anon_sym_STAR] = ACTIONS(5304),
    [anon_sym_GT_GT_GT] = ACTIONS(5306),
    [anon_sym_AMP_AMP] = ACTIONS(5306),
    [anon_sym_DASH] = ACTIONS(5304),
    [anon_sym_BANG_EQ] = ACTIONS(5304),
    [anon_sym_LT_EQ] = ACTIONS(5306),
    [anon_sym_LPAREN] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(5306),
    [anon_sym_GT] = ACTIONS(5304),
    [anon_sym_AMP] = ACTIONS(5304),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [anon_sym_QMARK] = ACTIONS(5306),
    [anon_sym_RBRACE] = ACTIONS(5306),
    [anon_sym_as] = ACTIONS(5306),
    [anon_sym_PIPE_PIPE] = ACTIONS(5306),
    [anon_sym_DASH_DASH] = ACTIONS(5306),
    [anon_sym_EQ_EQ] = ACTIONS(5304),
    [anon_sym_instanceof] = ACTIONS(5306),
    [anon_sym_LT] = ACTIONS(5304),
    [anon_sym_RPAREN] = ACTIONS(5306),
    [anon_sym_SLASH] = ACTIONS(5304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5306),
    [anon_sym_CARET] = ACTIONS(5306),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_PLUS] = ACTIONS(5304),
    [anon_sym_GT_GT] = ACTIONS(5304),
    [anon_sym_PLUS_PLUS] = ACTIONS(5306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5306),
    [anon_sym_in] = ACTIONS(5304),
  },
  [2774] = {
    [aux_sym_implements_clause_repeat1] = STATE(2557),
    [anon_sym_COMMA] = ACTIONS(3365),
    [anon_sym_RBRACK] = ACTIONS(7203),
    [sym_comment] = ACTIONS(3),
  },
  [2775] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(3545),
    [sym_constructor_type] = STATE(3545),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(3545),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(3545),
    [sym_intersection_type] = STATE(3545),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [2776] = {
    [anon_sym_EQ_GT] = ACTIONS(7205),
    [sym_comment] = ACTIONS(3),
  },
  [2777] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5383),
    [anon_sym_LBRACK] = ACTIONS(5383),
    [anon_sym_BANG] = ACTIONS(5381),
    [anon_sym_SEMI] = ACTIONS(5383),
    [anon_sym_BQUOTE] = ACTIONS(5383),
    [sym__automatic_semicolon] = ACTIONS(5383),
    [anon_sym_PIPE] = ACTIONS(5381),
    [anon_sym_COMMA] = ACTIONS(5383),
    [anon_sym_LT_LT] = ACTIONS(5383),
    [anon_sym_STAR] = ACTIONS(5381),
    [anon_sym_GT_GT_GT] = ACTIONS(5383),
    [anon_sym_AMP_AMP] = ACTIONS(5383),
    [anon_sym_DASH] = ACTIONS(5381),
    [anon_sym_BANG_EQ] = ACTIONS(5381),
    [anon_sym_LT_EQ] = ACTIONS(5383),
    [anon_sym_LPAREN] = ACTIONS(5383),
    [anon_sym_GT_EQ] = ACTIONS(5383),
    [anon_sym_GT] = ACTIONS(5381),
    [anon_sym_AMP] = ACTIONS(5381),
    [anon_sym_PERCENT] = ACTIONS(5383),
    [anon_sym_QMARK] = ACTIONS(5383),
    [anon_sym_RBRACE] = ACTIONS(5383),
    [anon_sym_as] = ACTIONS(5383),
    [anon_sym_PIPE_PIPE] = ACTIONS(5383),
    [anon_sym_DASH_DASH] = ACTIONS(5383),
    [anon_sym_EQ_EQ] = ACTIONS(5381),
    [anon_sym_instanceof] = ACTIONS(5383),
    [anon_sym_LT] = ACTIONS(5381),
    [anon_sym_RPAREN] = ACTIONS(5383),
    [anon_sym_SLASH] = ACTIONS(5381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_PLUS] = ACTIONS(5381),
    [anon_sym_GT_GT] = ACTIONS(5381),
    [anon_sym_PLUS_PLUS] = ACTIONS(5383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5383),
    [anon_sym_in] = ACTIONS(5381),
  },
  [2778] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5387),
    [anon_sym_SEMI] = ACTIONS(5389),
    [anon_sym_BQUOTE] = ACTIONS(5389),
    [sym__automatic_semicolon] = ACTIONS(5389),
    [anon_sym_PIPE] = ACTIONS(5387),
    [anon_sym_COMMA] = ACTIONS(5389),
    [anon_sym_LT_LT] = ACTIONS(5389),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_GT_GT_GT] = ACTIONS(5389),
    [anon_sym_AMP_AMP] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_BANG_EQ] = ACTIONS(5387),
    [anon_sym_LT_EQ] = ACTIONS(5389),
    [anon_sym_LPAREN] = ACTIONS(5389),
    [anon_sym_GT_EQ] = ACTIONS(5389),
    [anon_sym_GT] = ACTIONS(5387),
    [anon_sym_AMP] = ACTIONS(5387),
    [anon_sym_PERCENT] = ACTIONS(5389),
    [anon_sym_QMARK] = ACTIONS(5389),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_as] = ACTIONS(5389),
    [anon_sym_PIPE_PIPE] = ACTIONS(5389),
    [anon_sym_DASH_DASH] = ACTIONS(5389),
    [anon_sym_EQ_EQ] = ACTIONS(5387),
    [anon_sym_instanceof] = ACTIONS(5389),
    [anon_sym_LT] = ACTIONS(5387),
    [anon_sym_RPAREN] = ACTIONS(5389),
    [anon_sym_SLASH] = ACTIONS(5387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5389),
    [anon_sym_CARET] = ACTIONS(5389),
    [anon_sym_STAR_STAR] = ACTIONS(5389),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_GT_GT] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5389),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5389),
    [anon_sym_in] = ACTIONS(5387),
  },
  [2779] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_SEMI] = ACTIONS(5393),
    [anon_sym_BQUOTE] = ACTIONS(5393),
    [sym__automatic_semicolon] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5391),
    [anon_sym_COMMA] = ACTIONS(5393),
    [anon_sym_LT_LT] = ACTIONS(5393),
    [anon_sym_STAR] = ACTIONS(5391),
    [anon_sym_GT_GT_GT] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5391),
    [anon_sym_BANG_EQ] = ACTIONS(5391),
    [anon_sym_LT_EQ] = ACTIONS(5393),
    [anon_sym_LPAREN] = ACTIONS(5393),
    [anon_sym_GT_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5391),
    [anon_sym_AMP] = ACTIONS(5391),
    [anon_sym_PERCENT] = ACTIONS(5393),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_as] = ACTIONS(5393),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_DASH_DASH] = ACTIONS(5393),
    [anon_sym_EQ_EQ] = ACTIONS(5391),
    [anon_sym_instanceof] = ACTIONS(5393),
    [anon_sym_LT] = ACTIONS(5391),
    [anon_sym_RPAREN] = ACTIONS(5393),
    [anon_sym_SLASH] = ACTIONS(5391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5393),
    [anon_sym_CARET] = ACTIONS(5393),
    [anon_sym_STAR_STAR] = ACTIONS(5393),
    [anon_sym_PLUS] = ACTIONS(5391),
    [anon_sym_GT_GT] = ACTIONS(5391),
    [anon_sym_PLUS_PLUS] = ACTIONS(5393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5393),
    [anon_sym_in] = ACTIONS(5391),
  },
  [2780] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(3547),
    [sym_constructor_type] = STATE(3547),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(3547),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(3547),
    [sym_intersection_type] = STATE(3547),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [2781] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(7184),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(7186),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [2782] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(7209),
    [sym_comment] = ACTIONS(3),
  },
  [2783] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_SEMI] = ACTIONS(5423),
    [anon_sym_BQUOTE] = ACTIONS(5423),
    [sym__automatic_semicolon] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5421),
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_LT_LT] = ACTIONS(5423),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_GT_GT_GT] = ACTIONS(5423),
    [anon_sym_AMP_AMP] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_BANG_EQ] = ACTIONS(5421),
    [anon_sym_LT_EQ] = ACTIONS(5423),
    [anon_sym_LPAREN] = ACTIONS(5423),
    [anon_sym_GT_EQ] = ACTIONS(5423),
    [anon_sym_GT] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5421),
    [anon_sym_PERCENT] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_as] = ACTIONS(5423),
    [anon_sym_PIPE_PIPE] = ACTIONS(5423),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_EQ_EQ] = ACTIONS(5421),
    [anon_sym_instanceof] = ACTIONS(5423),
    [anon_sym_LT] = ACTIONS(5421),
    [anon_sym_RPAREN] = ACTIONS(5423),
    [anon_sym_SLASH] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5423),
    [anon_sym_CARET] = ACTIONS(5423),
    [anon_sym_STAR_STAR] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_GT_GT] = ACTIONS(5421),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5423),
    [anon_sym_in] = ACTIONS(5421),
  },
  [2784] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(7184),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(7186),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [2785] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(506),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(512),
    [anon_sym_symbol] = ACTIONS(512),
    [anon_sym_number] = ACTIONS(512),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(512),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(518),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(512),
    [anon_sym_private] = ACTIONS(512),
    [anon_sym_boolean] = ACTIONS(512),
    [anon_sym_async] = ACTIONS(522),
    [anon_sym_public] = ACTIONS(512),
    [anon_sym_get] = ACTIONS(512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(512),
    [anon_sym_string] = ACTIONS(512),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(512),
    [anon_sym_type] = ACTIONS(512),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(512),
    [anon_sym_namespace] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [2786] = {
    [sym_formal_parameters] = STATE(3551),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2787] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(7213),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [2788] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6249),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6249),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(6252),
  },
  [2789] = {
    [sym_identifier] = ACTIONS(7216),
    [sym_comment] = ACTIONS(3),
  },
  [2790] = {
    [sym_new_expression] = STATE(1449),
    [sym_constructor_type] = STATE(2573),
    [sym_augmented_assignment_expression] = STATE(1449),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1449),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1449),
    [sym_call_signature] = STATE(242),
    [sym_yield_expression] = STATE(1449),
    [sym_as_expression] = STATE(1449),
    [sym_internal_module] = STATE(1449),
    [sym_arrow_function] = STATE(1449),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(245),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1885),
    [sym_type_parameters] = STATE(3557),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(470),
    [sym_nested_type_identifier] = STATE(839),
    [sym_generator_function] = STATE(1449),
    [sym_subscript_expression] = STATE(245),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1449),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1449),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3558),
    [sym_intersection_type] = STATE(2573),
    [sym__type] = STATE(2573),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1449),
    [sym_meta_property] = STATE(1449),
    [sym_function_type] = STATE(2573),
    [sym__expression] = STATE(1449),
    [sym_non_null_expression] = STATE(1449),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1449),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1449),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1449),
    [sym_call_expression] = STATE(1449),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1449),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1449),
    [sym_type_arguments] = STATE(251),
    [sym_union_type] = STATE(2573),
    [sym_parenthesized_expression] = STATE(1449),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(1449),
    [sym_class] = STATE(1449),
    [anon_sym_BANG] = ACTIONS(410),
    [sym_identifier] = ACTIONS(7218),
    [sym_false] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(7220),
    [anon_sym_number] = ACTIONS(7220),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(3931),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(7222),
    [anon_sym_PIPE] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(3031),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(7220),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(7220),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(3927),
    [sym_number] = ACTIONS(3933),
    [sym_true] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(7220),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3031),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(7224),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
  },
  [2791] = {
    [sym_identifier] = ACTIONS(7226),
    [sym_comment] = ACTIONS(3),
  },
  [2792] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3383),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2793] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(7228),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1331),
  },
  [2794] = {
    [sym_formal_parameters] = STATE(3561),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2795] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(7230),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [2796] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(7233),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [2797] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(7236),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [2798] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7239),
    [sym_identifier] = ACTIONS(7241),
    [sym__automatic_semicolon] = ACTIONS(7239),
    [anon_sym_BQUOTE] = ACTIONS(7239),
    [anon_sym_debugger] = ACTIONS(7241),
    [ts_builtin_sym_end] = ACTIONS(7239),
    [anon_sym_symbol] = ACTIONS(7241),
    [anon_sym_AT] = ACTIONS(7239),
    [anon_sym_PIPE] = ACTIONS(7241),
    [anon_sym_COMMA] = ACTIONS(7239),
    [anon_sym_DASH] = ACTIONS(7241),
    [anon_sym_STAR] = ACTIONS(7241),
    [anon_sym_GT_GT_GT] = ACTIONS(7239),
    [anon_sym_void] = ACTIONS(7241),
    [anon_sym_break] = ACTIONS(7241),
    [anon_sym_BANG_EQ] = ACTIONS(7241),
    [anon_sym_const] = ACTIONS(7241),
    [anon_sym_GT_EQ] = ACTIONS(7239),
    [sym_super] = ACTIONS(7241),
    [anon_sym_return] = ACTIONS(7241),
    [anon_sym_private] = ACTIONS(7241),
    [anon_sym_get] = ACTIONS(7241),
    [anon_sym_RBRACE] = ACTIONS(7239),
    [anon_sym_PERCENT] = ACTIONS(7239),
    [anon_sym_interface] = ACTIONS(7241),
    [anon_sym_default] = ACTIONS(7241),
    [anon_sym_as] = ACTIONS(7241),
    [anon_sym_delete] = ACTIONS(7241),
    [anon_sym_continue] = ACTIONS(7241),
    [anon_sym_DASH_DASH] = ACTIONS(7239),
    [anon_sym_if] = ACTIONS(7241),
    [anon_sym_instanceof] = ACTIONS(7241),
    [anon_sym_this] = ACTIONS(7241),
    [anon_sym_yield] = ACTIONS(7241),
    [sym_true] = ACTIONS(7241),
    [anon_sym_throw] = ACTIONS(7241),
    [anon_sym_enum] = ACTIONS(7241),
    [anon_sym_protected] = ACTIONS(7241),
    [anon_sym_abstract] = ACTIONS(7241),
    [anon_sym_DOT] = ACTIONS(7241),
    [anon_sym_set] = ACTIONS(7241),
    [anon_sym_type] = ACTIONS(7241),
    [anon_sym_STAR_STAR] = ACTIONS(7239),
    [anon_sym_import] = ACTIONS(7241),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7239),
    [anon_sym_namespace] = ACTIONS(7241),
    [anon_sym_PLUS_PLUS] = ACTIONS(7239),
    [anon_sym_await] = ACTIONS(7241),
    [anon_sym_DQUOTE] = ACTIONS(7239),
    [anon_sym_else] = ACTIONS(7241),
    [anon_sym_BANG] = ACTIONS(7241),
    [anon_sym_for] = ACTIONS(7241),
    [anon_sym_LBRACK] = ACTIONS(7239),
    [sym_false] = ACTIONS(7241),
    [anon_sym_SEMI] = ACTIONS(7239),
    [anon_sym_case] = ACTIONS(7241),
    [anon_sym_module] = ACTIONS(7241),
    [anon_sym_number] = ACTIONS(7241),
    [anon_sym_class] = ACTIONS(7241),
    [anon_sym_declare] = ACTIONS(7241),
    [anon_sym_typeof] = ACTIONS(7241),
    [anon_sym_LT_LT] = ACTIONS(7239),
    [anon_sym_LBRACE] = ACTIONS(7239),
    [anon_sym_AMP_AMP] = ACTIONS(7239),
    [anon_sym_switch] = ACTIONS(7241),
    [anon_sym_LT_EQ] = ACTIONS(7239),
    [anon_sym_LPAREN] = ACTIONS(7239),
    [sym_null] = ACTIONS(7241),
    [anon_sym_GT] = ACTIONS(7241),
    [anon_sym_any] = ACTIONS(7241),
    [anon_sym_boolean] = ACTIONS(7241),
    [anon_sym_async] = ACTIONS(7241),
    [anon_sym_public] = ACTIONS(7241),
    [anon_sym_AMP] = ACTIONS(7241),
    [anon_sym_var] = ACTIONS(7241),
    [anon_sym_QMARK] = ACTIONS(7239),
    [anon_sym_PIPE_PIPE] = ACTIONS(7239),
    [anon_sym_while] = ACTIONS(7241),
    [anon_sym_SQUOTE] = ACTIONS(7239),
    [anon_sym_try] = ACTIONS(7241),
    [anon_sym_EQ_EQ] = ACTIONS(7241),
    [anon_sym_RPAREN] = ACTIONS(7239),
    [anon_sym_LT] = ACTIONS(7241),
    [sym_number] = ACTIONS(7239),
    [anon_sym_SLASH] = ACTIONS(7241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7241),
    [anon_sym_function] = ACTIONS(7241),
    [sym_undefined] = ACTIONS(7241),
    [anon_sym_new] = ACTIONS(7241),
    [anon_sym_CARET] = ACTIONS(7239),
    [anon_sym_let] = ACTIONS(7241),
    [anon_sym_PLUS] = ACTIONS(7241),
    [anon_sym_export] = ACTIONS(7241),
    [anon_sym_GT_GT] = ACTIONS(7241),
    [anon_sym_do] = ACTIONS(7241),
    [anon_sym_TILDE] = ACTIONS(7239),
    [anon_sym_with] = ACTIONS(7241),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7239),
    [anon_sym_in] = ACTIONS(7241),
  },
  [2799] = {
    [sym_class_body] = STATE(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [2800] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(5130),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [2801] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [2802] = {
    [sym_new_expression] = STATE(3563),
    [sym_augmented_assignment_expression] = STATE(3563),
    [sym_unary_expression] = STATE(3563),
    [sym_update_expression] = STATE(3563),
    [sym_regex] = STATE(3563),
    [sym_meta_property] = STATE(3563),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(3563),
    [sym_yield_expression] = STATE(3563),
    [sym_as_expression] = STATE(3563),
    [sym_non_null_expression] = STATE(3563),
    [sym_internal_module] = STATE(3563),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3563),
    [sym_await_expression] = STATE(3563),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(3563),
    [sym_this] = STATE(3563),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(3563),
    [sym_generator_function] = STATE(3563),
    [sym_call_expression] = STATE(3563),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(3563),
    [sym_ternary_expression] = STATE(3563),
    [sym_binary_expression] = STATE(3563),
    [sym_template_string] = STATE(3563),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3563),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(3563),
    [sym_class] = STATE(3563),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(7243),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7243),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7245),
    [sym_true] = ACTIONS(7243),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7243),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [2803] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3564),
    [sym_constructor_type] = STATE(3564),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(3564),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3564),
    [sym_intersection_type] = STATE(3564),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2804] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3565),
    [sym_constructor_type] = STATE(3565),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(3565),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3565),
    [sym_intersection_type] = STATE(3565),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2805] = {
    [anon_sym_EQ_GT] = ACTIONS(7247),
    [sym_comment] = ACTIONS(3),
  },
  [2806] = {
    [sym_formal_parameters] = STATE(3567),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2807] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2808] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2809] = {
    [anon_sym_EQ_GT] = ACTIONS(7249),
    [sym_comment] = ACTIONS(3),
  },
  [2810] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3569),
    [sym_constructor_type] = STATE(3569),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(3569),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3569),
    [sym_intersection_type] = STATE(3569),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2811] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3570),
    [sym_constructor_type] = STATE(3570),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(3570),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3570),
    [sym_intersection_type] = STATE(3570),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2812] = {
    [sym_new_expression] = STATE(1900),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(1900),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1900),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1900),
    [sym_call_signature] = STATE(374),
    [sym_yield_expression] = STATE(1900),
    [sym_as_expression] = STATE(1900),
    [sym_internal_module] = STATE(1900),
    [sym_arrow_function] = STATE(1900),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(376),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(378),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(1900),
    [sym_subscript_expression] = STATE(376),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1900),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1900),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1900),
    [sym_meta_property] = STATE(1900),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(1900),
    [sym_non_null_expression] = STATE(1900),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1900),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1900),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1900),
    [sym_call_expression] = STATE(1900),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1900),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1900),
    [sym_type_arguments] = STATE(379),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1900),
    [sym_class] = STATE(1900),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(4016),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(4018),
    [anon_sym_number] = ACTIONS(4018),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(4020),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(3953),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4018),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(4018),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(4018),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(7251),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [2813] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_AMP_EQ] = ACTIONS(2065),
    [anon_sym_PLUS_EQ] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(2065),
    [anon_sym_STAR_EQ] = ACTIONS(2065),
    [anon_sym_PIPE_EQ] = ACTIONS(2065),
    [anon_sym_DASH_EQ] = ACTIONS(2065),
    [anon_sym_EQ_GT] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(6247),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [2814] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5873),
    [sym_identifier] = ACTIONS(5875),
    [anon_sym_BQUOTE] = ACTIONS(5873),
    [anon_sym_symbol] = ACTIONS(5875),
    [anon_sym_AT] = ACTIONS(5873),
    [anon_sym_PIPE] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5873),
    [anon_sym_DASH] = ACTIONS(5875),
    [anon_sym_STAR] = ACTIONS(5875),
    [anon_sym_GT_GT_GT] = ACTIONS(5873),
    [anon_sym_void] = ACTIONS(5875),
    [anon_sym_BANG_EQ] = ACTIONS(5875),
    [anon_sym_GT_EQ] = ACTIONS(5873),
    [anon_sym_private] = ACTIONS(5875),
    [anon_sym_get] = ACTIONS(5875),
    [anon_sym_RBRACE] = ACTIONS(5873),
    [anon_sym_PERCENT] = ACTIONS(5873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5873),
    [anon_sym_as] = ACTIONS(5875),
    [anon_sym_DASH_DASH] = ACTIONS(5873),
    [anon_sym_instanceof] = ACTIONS(5875),
    [anon_sym_this] = ACTIONS(5875),
    [anon_sym_COLON] = ACTIONS(5873),
    [anon_sym_protected] = ACTIONS(5875),
    [anon_sym_DOT] = ACTIONS(5875),
    [anon_sym_set] = ACTIONS(5875),
    [anon_sym_type] = ACTIONS(5875),
    [anon_sym_STAR_STAR] = ACTIONS(5873),
    [anon_sym_import] = ACTIONS(5875),
    [sym_readonly] = ACTIONS(5875),
    [anon_sym_PLUS_PLUS] = ACTIONS(5873),
    [anon_sym_namespace] = ACTIONS(5875),
    [anon_sym_BANG] = ACTIONS(5875),
    [anon_sym_LBRACK] = ACTIONS(5873),
    [anon_sym_module] = ACTIONS(5875),
    [anon_sym_number] = ACTIONS(5875),
    [anon_sym_class] = ACTIONS(5875),
    [anon_sym_declare] = ACTIONS(5875),
    [anon_sym_LT_LT] = ACTIONS(5873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5873),
    [anon_sym_LBRACE] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5873),
    [anon_sym_LT_EQ] = ACTIONS(5873),
    [anon_sym_LPAREN] = ACTIONS(5873),
    [anon_sym_RBRACK] = ACTIONS(5873),
    [anon_sym_GT] = ACTIONS(5875),
    [anon_sym_any] = ACTIONS(5875),
    [anon_sym_boolean] = ACTIONS(5875),
    [anon_sym_async] = ACTIONS(5875),
    [anon_sym_public] = ACTIONS(5875),
    [anon_sym_AMP] = ACTIONS(5875),
    [anon_sym_QMARK] = ACTIONS(5873),
    [anon_sym_PIPE_PIPE] = ACTIONS(5873),
    [anon_sym_EQ_EQ] = ACTIONS(5875),
    [anon_sym_RPAREN] = ACTIONS(5873),
    [anon_sym_LT] = ACTIONS(5875),
    [anon_sym_SLASH] = ACTIONS(5875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5875),
    [anon_sym_CARET] = ACTIONS(5873),
    [anon_sym_PLUS] = ACTIONS(5875),
    [anon_sym_export] = ACTIONS(5875),
    [anon_sym_GT_GT] = ACTIONS(5875),
    [anon_sym_implements] = ACTIONS(5875),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5873),
    [anon_sym_in] = ACTIONS(5875),
  },
  [2815] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2816] = {
    [sym_formal_parameters] = STATE(3572),
    [sym_type_parameters] = STATE(3573),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2817] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2818] = {
    [anon_sym_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(7253),
    [anon_sym_SEMI] = ACTIONS(5196),
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(7255),
    [anon_sym_COMMA] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
  },
  [2819] = {
    [sym_formal_parameters] = STATE(3576),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2820] = {
    [anon_sym_EQ_GT] = ACTIONS(7257),
    [sym_comment] = ACTIONS(3),
  },
  [2821] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(7259),
    [sym_comment] = ACTIONS(3),
  },
  [2822] = {
    [aux_sym_implements_clause_repeat1] = STATE(3581),
    [anon_sym_GT] = ACTIONS(7261),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(7263),
    [sym_comment] = ACTIONS(3),
  },
  [2823] = {
    [anon_sym_EQ] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5194),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(4363),
    [sym__automatic_semicolon] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5194),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_LT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5194),
  },
  [2824] = {
    [anon_sym_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(7253),
    [anon_sym_SEMI] = ACTIONS(5204),
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(7255),
    [anon_sym_COMMA] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
  },
  [2825] = {
    [aux_sym_object_type_repeat1] = STATE(3584),
    [sym__automatic_semicolon] = ACTIONS(7265),
    [anon_sym_RBRACE] = ACTIONS(7267),
    [anon_sym_SEMI] = ACTIONS(7265),
    [anon_sym_COMMA] = ACTIONS(7265),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7267),
    [sym_comment] = ACTIONS(3),
  },
  [2826] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(7267),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7267),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [2827] = {
    [anon_sym_EQ] = ACTIONS(5294),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_AMP] = ACTIONS(5294),
    [anon_sym_SEMI] = ACTIONS(5294),
    [sym__automatic_semicolon] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5294),
    [anon_sym_PIPE] = ACTIONS(5292),
    [anon_sym_COMMA] = ACTIONS(5294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5294),
  },
  [2828] = {
    [aux_sym_object_type_repeat1] = STATE(2544),
    [sym__automatic_semicolon] = ACTIONS(7265),
    [anon_sym_RBRACE] = ACTIONS(7267),
    [anon_sym_SEMI] = ACTIONS(7265),
    [anon_sym_COMMA] = ACTIONS(7265),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7267),
    [sym_comment] = ACTIONS(3),
  },
  [2829] = {
    [anon_sym_EQ] = ACTIONS(5306),
    [anon_sym_LBRACK] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5306),
    [anon_sym_SEMI] = ACTIONS(5306),
    [sym__automatic_semicolon] = ACTIONS(5306),
    [anon_sym_RBRACE] = ACTIONS(5306),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5306),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_COMMA] = ACTIONS(5306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5306),
  },
  [2830] = {
    [aux_sym_implements_clause_repeat1] = STATE(2557),
    [anon_sym_COMMA] = ACTIONS(3365),
    [anon_sym_RBRACK] = ACTIONS(7269),
    [sym_comment] = ACTIONS(3),
  },
  [2831] = {
    [sym_identifier] = ACTIONS(7271),
    [sym_comment] = ACTIONS(3),
  },
  [2832] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(3587),
    [sym_constructor_type] = STATE(3587),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(3587),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(3587),
    [sym_intersection_type] = STATE(3587),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1063),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1067),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2833] = {
    [anon_sym_EQ_GT] = ACTIONS(7273),
    [sym_comment] = ACTIONS(3),
  },
  [2834] = {
    [anon_sym_EQ] = ACTIONS(5383),
    [anon_sym_LBRACK] = ACTIONS(5383),
    [anon_sym_AMP] = ACTIONS(5383),
    [anon_sym_SEMI] = ACTIONS(5383),
    [sym__automatic_semicolon] = ACTIONS(5383),
    [anon_sym_RBRACE] = ACTIONS(5383),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5383),
    [anon_sym_PIPE] = ACTIONS(5381),
    [anon_sym_COMMA] = ACTIONS(5383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5383),
  },
  [2835] = {
    [anon_sym_EQ] = ACTIONS(5389),
    [anon_sym_AMP] = ACTIONS(5389),
    [sym__automatic_semicolon] = ACTIONS(5389),
    [anon_sym_SEMI] = ACTIONS(5389),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5389),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5389),
    [anon_sym_PIPE] = ACTIONS(5387),
    [anon_sym_COMMA] = ACTIONS(5389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5389),
  },
  [2836] = {
    [anon_sym_EQ] = ACTIONS(5393),
    [anon_sym_AMP] = ACTIONS(5393),
    [sym__automatic_semicolon] = ACTIONS(5393),
    [anon_sym_SEMI] = ACTIONS(5393),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5391),
    [anon_sym_COMMA] = ACTIONS(5393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5393),
  },
  [2837] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(3589),
    [sym_constructor_type] = STATE(3589),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(3589),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(3589),
    [sym_intersection_type] = STATE(3589),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1063),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1067),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2838] = {
    [anon_sym_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(7253),
    [anon_sym_SEMI] = ACTIONS(5406),
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(7255),
    [anon_sym_COMMA] = ACTIONS(5406),
    [sym_comment] = ACTIONS(3),
  },
  [2839] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(7275),
    [sym_comment] = ACTIONS(3),
  },
  [2840] = {
    [anon_sym_EQ] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_AMP] = ACTIONS(5423),
    [anon_sym_SEMI] = ACTIONS(5423),
    [sym__automatic_semicolon] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5421),
    [anon_sym_COMMA] = ACTIONS(5423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5423),
  },
  [2841] = {
    [anon_sym_EQ] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(4063),
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(4065),
    [sym_comment] = ACTIONS(3),
  },
  [2842] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6599),
    [anon_sym_LBRACK] = ACTIONS(6599),
    [anon_sym_in] = ACTIONS(6601),
    [anon_sym_BQUOTE] = ACTIONS(6599),
    [anon_sym_PIPE] = ACTIONS(6601),
    [anon_sym_COMMA] = ACTIONS(6599),
    [anon_sym_DASH] = ACTIONS(6601),
    [anon_sym_STAR] = ACTIONS(6601),
    [anon_sym_GT_GT_GT] = ACTIONS(6599),
    [anon_sym_EQ] = ACTIONS(6601),
    [anon_sym_AMP_AMP] = ACTIONS(6599),
    [anon_sym_LT_LT] = ACTIONS(6599),
    [anon_sym_BANG_EQ] = ACTIONS(6601),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_LPAREN] = ACTIONS(6599),
    [anon_sym_RBRACK] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_LBRACE] = ACTIONS(6601),
    [anon_sym_of] = ACTIONS(6599),
    [anon_sym_AMP] = ACTIONS(6601),
    [anon_sym_PERCENT] = ACTIONS(6599),
    [anon_sym_QMARK] = ACTIONS(6599),
    [anon_sym_RBRACE] = ACTIONS(6599),
    [anon_sym_as] = ACTIONS(6599),
    [anon_sym_PIPE_PIPE] = ACTIONS(6599),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6599),
    [anon_sym_DASH_DASH] = ACTIONS(6599),
    [anon_sym_EQ_EQ] = ACTIONS(6601),
    [anon_sym_instanceof] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_RPAREN] = ACTIONS(6599),
    [anon_sym_SLASH] = ACTIONS(6601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6599),
    [anon_sym_DOT] = ACTIONS(6599),
    [anon_sym_CARET] = ACTIONS(6599),
    [anon_sym_STAR_STAR] = ACTIONS(6599),
    [anon_sym_PLUS] = ACTIONS(6601),
    [anon_sym_implements] = ACTIONS(6599),
    [anon_sym_GT_GT] = ACTIONS(6601),
    [anon_sym_PLUS_PLUS] = ACTIONS(6599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6599),
    [anon_sym_BANG] = ACTIONS(6601),
  },
  [2843] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2844] = {
    [sym_formal_parameters] = STATE(3591),
    [sym_type_parameters] = STATE(3592),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2845] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2846] = {
    [anon_sym_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(7277),
    [anon_sym_PIPE] = ACTIONS(7279),
    [sym_comment] = ACTIONS(3),
  },
  [2847] = {
    [sym_formal_parameters] = STATE(3595),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2848] = {
    [anon_sym_EQ_GT] = ACTIONS(7281),
    [sym_comment] = ACTIONS(3),
  },
  [2849] = {
    [anon_sym_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(7277),
    [anon_sym_PIPE] = ACTIONS(7279),
    [sym_comment] = ACTIONS(3),
  },
  [2850] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3597),
    [sym_constructor_type] = STATE(3597),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(3597),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3597),
    [sym_intersection_type] = STATE(3597),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1086),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1088),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2851] = {
    [anon_sym_EQ_GT] = ACTIONS(7283),
    [sym_comment] = ACTIONS(3),
  },
  [2852] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3599),
    [sym_constructor_type] = STATE(3599),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(3599),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3599),
    [sym_intersection_type] = STATE(3599),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1086),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1088),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [2853] = {
    [anon_sym_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(7277),
    [anon_sym_PIPE] = ACTIONS(7279),
    [sym_comment] = ACTIONS(3),
  },
  [2854] = {
    [anon_sym_EQ] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4103),
    [sym_comment] = ACTIONS(3),
  },
  [2855] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(5130),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [2856] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(5134),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [2857] = {
    [sym_new_expression] = STATE(3600),
    [sym_augmented_assignment_expression] = STATE(3600),
    [sym_unary_expression] = STATE(3600),
    [sym_update_expression] = STATE(3600),
    [sym_regex] = STATE(3600),
    [sym_meta_property] = STATE(3600),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(3600),
    [sym_yield_expression] = STATE(3600),
    [sym_as_expression] = STATE(3600),
    [sym_non_null_expression] = STATE(3600),
    [sym_internal_module] = STATE(3600),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3600),
    [sym_await_expression] = STATE(3600),
    [sym_member_expression] = STATE(448),
    [sym_string] = STATE(3600),
    [sym_this] = STATE(3600),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(3600),
    [sym_generator_function] = STATE(3600),
    [sym_call_expression] = STATE(3600),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(3600),
    [sym_ternary_expression] = STATE(3600),
    [sym_binary_expression] = STATE(3600),
    [sym_template_string] = STATE(3600),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3600),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(3600),
    [sym_class] = STATE(3600),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(7285),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7285),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7287),
    [sym_true] = ACTIONS(7285),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7285),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [2858] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3601),
    [sym_constructor_type] = STATE(3601),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(3601),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3601),
    [sym_intersection_type] = STATE(3601),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2859] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3602),
    [sym_constructor_type] = STATE(3602),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(3602),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3602),
    [sym_intersection_type] = STATE(3602),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2860] = {
    [anon_sym_EQ_GT] = ACTIONS(7289),
    [sym_comment] = ACTIONS(3),
  },
  [2861] = {
    [sym_formal_parameters] = STATE(3604),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2862] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2863] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2864] = {
    [anon_sym_EQ_GT] = ACTIONS(7291),
    [sym_comment] = ACTIONS(3),
  },
  [2865] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3606),
    [sym_constructor_type] = STATE(3606),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(3606),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3606),
    [sym_intersection_type] = STATE(3606),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2866] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3607),
    [sym_constructor_type] = STATE(3607),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(3607),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3607),
    [sym_intersection_type] = STATE(3607),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2867] = {
    [sym_new_expression] = STATE(1976),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(1976),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1976),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1976),
    [sym_call_signature] = STATE(446),
    [sym_yield_expression] = STATE(1976),
    [sym_as_expression] = STATE(1976),
    [sym_internal_module] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(448),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(450),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(1976),
    [sym_subscript_expression] = STATE(448),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1976),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1976),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(1976),
    [sym_non_null_expression] = STATE(1976),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1976),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1976),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1976),
    [sym_call_expression] = STATE(1976),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1976),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1976),
    [sym_type_arguments] = STATE(452),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(1976),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(1976),
    [sym_class] = STATE(1976),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(4180),
    [anon_sym_number] = ACTIONS(4180),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(4182),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4184),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(4186),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(4125),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4180),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(4180),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(4180),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4125),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(7293),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(4184),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [2868] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_AMP_EQ] = ACTIONS(2251),
    [anon_sym_PLUS_EQ] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(2251),
    [anon_sym_STAR_EQ] = ACTIONS(2251),
    [anon_sym_PIPE_EQ] = ACTIONS(2251),
    [anon_sym_DASH_EQ] = ACTIONS(2251),
    [anon_sym_EQ_GT] = ACTIONS(2253),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT_EQ] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(6247),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2255),
  },
  [2869] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2045),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [2870] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2871] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(7295),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [2872] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(7297),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2055),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [2873] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(2153),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2151),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [2874] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(7299),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2155),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [2875] = {
    [sym_new_expression] = STATE(3609),
    [sym_augmented_assignment_expression] = STATE(3609),
    [sym_unary_expression] = STATE(3609),
    [sym_update_expression] = STATE(3609),
    [sym_regex] = STATE(3609),
    [sym_meta_property] = STATE(3609),
    [sym_call_signature] = STATE(1134),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(3609),
    [sym_yield_expression] = STATE(3609),
    [sym_as_expression] = STATE(3609),
    [sym_non_null_expression] = STATE(3609),
    [sym_internal_module] = STATE(3609),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3609),
    [sym_await_expression] = STATE(3609),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(3609),
    [sym_this] = STATE(3609),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(3609),
    [sym_generator_function] = STATE(3609),
    [sym_call_expression] = STATE(3609),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(3609),
    [sym_ternary_expression] = STATE(3609),
    [sym_binary_expression] = STATE(3609),
    [sym_template_string] = STATE(3609),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3609),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(3609),
    [sym_class] = STATE(3609),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(7301),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7301),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7303),
    [sym_true] = ACTIONS(7301),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7301),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2876] = {
    [sym_new_expression] = STATE(3610),
    [sym_augmented_assignment_expression] = STATE(3610),
    [sym_unary_expression] = STATE(3610),
    [sym_update_expression] = STATE(3610),
    [sym_regex] = STATE(3610),
    [sym_meta_property] = STATE(3610),
    [sym_call_signature] = STATE(1134),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(3610),
    [sym_yield_expression] = STATE(3610),
    [sym_as_expression] = STATE(3610),
    [sym_non_null_expression] = STATE(3610),
    [sym_internal_module] = STATE(3610),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3610),
    [sym_await_expression] = STATE(3610),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(3610),
    [sym_this] = STATE(3610),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(3610),
    [sym_generator_function] = STATE(3610),
    [sym_call_expression] = STATE(3610),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(3610),
    [sym_ternary_expression] = STATE(3610),
    [sym_binary_expression] = STATE(3610),
    [sym_template_string] = STATE(3610),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3610),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(3610),
    [sym_class] = STATE(3610),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(7305),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7305),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7307),
    [sym_true] = ACTIONS(7305),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7305),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2877] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [2878] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(4211),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(6266),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(6268),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6266),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2879] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7309),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2880] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7309),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2881] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [2882] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7312),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2883] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(7314),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(7316),
  },
  [2884] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2885] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2886] = {
    [sym_formal_parameters] = STATE(3614),
    [sym_type_parameters] = STATE(3615),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2887] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [2888] = {
    [sym_formal_parameters] = STATE(3618),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2889] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3865),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(7319),
  },
  [2890] = {
    [anon_sym_EQ_GT] = ACTIONS(7322),
    [sym_comment] = ACTIONS(3),
  },
  [2891] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4203),
    [anon_sym_AMP_EQ] = ACTIONS(4203),
    [anon_sym_PLUS_EQ] = ACTIONS(4203),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_CARET_EQ] = ACTIONS(4203),
    [anon_sym_STAR_EQ] = ACTIONS(4203),
    [anon_sym_PIPE_EQ] = ACTIONS(4203),
    [anon_sym_DASH_EQ] = ACTIONS(4203),
    [anon_sym_EQ_GT] = ACTIONS(4209),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4203),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT_EQ] = ACTIONS(4203),
    [anon_sym_DOT] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7324),
  },
  [2892] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_EQ_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2893] = {
    [sym_new_expression] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(2010),
    [sym_unary_expression] = STATE(2010),
    [sym_update_expression] = STATE(2010),
    [sym_regex] = STATE(2010),
    [sym_meta_property] = STATE(2010),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2010),
    [sym_yield_expression] = STATE(2010),
    [sym_as_expression] = STATE(2010),
    [sym_non_null_expression] = STATE(2010),
    [sym_internal_module] = STATE(2010),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2010),
    [sym_await_expression] = STATE(2010),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2010),
    [sym_this] = STATE(2010),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2010),
    [sym_generator_function] = STATE(2010),
    [sym_call_expression] = STATE(2010),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2010),
    [sym_ternary_expression] = STATE(2010),
    [sym_binary_expression] = STATE(2010),
    [sym_template_string] = STATE(2010),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2010),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2010),
    [sym_class] = STATE(2010),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(7326),
    [sym_false] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4219),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4221),
    [sym_true] = ACTIONS(4219),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4219),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2894] = {
    [sym_new_expression] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(2011),
    [sym_unary_expression] = STATE(2011),
    [sym_update_expression] = STATE(2011),
    [sym_regex] = STATE(2011),
    [sym_meta_property] = STATE(2011),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2011),
    [sym_yield_expression] = STATE(2011),
    [sym_as_expression] = STATE(2011),
    [sym_non_null_expression] = STATE(2011),
    [sym_internal_module] = STATE(2011),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2011),
    [sym_await_expression] = STATE(2011),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2011),
    [sym_this] = STATE(2011),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2011),
    [sym_generator_function] = STATE(2011),
    [sym_call_expression] = STATE(2011),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2011),
    [sym_ternary_expression] = STATE(2011),
    [sym_binary_expression] = STATE(2011),
    [sym_template_string] = STATE(2011),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2011),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2011),
    [sym_class] = STATE(2011),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4223),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(4223),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4223),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [2895] = {
    [sym_new_expression] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(2010),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(2010),
    [sym_update_expression] = STATE(2010),
    [sym_regex] = STATE(2010),
    [sym_meta_property] = STATE(2010),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(2010),
    [sym_yield_expression] = STATE(2010),
    [sym_as_expression] = STATE(2010),
    [sym_non_null_expression] = STATE(2010),
    [sym_internal_module] = STATE(2010),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2010),
    [sym_await_expression] = STATE(2010),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(2010),
    [sym_this] = STATE(2010),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(2010),
    [sym_generator_function] = STATE(2010),
    [sym_call_expression] = STATE(2010),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(2010),
    [sym_ternary_expression] = STATE(2010),
    [sym_binary_expression] = STATE(2010),
    [sym_template_string] = STATE(2010),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2010),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2010),
    [sym_class] = STATE(2010),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4217),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(2361),
    [sym_true] = ACTIONS(4219),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4213),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4219),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(4227),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4219),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4221),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4219),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2896] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4241),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4243),
    [anon_sym_symbol] = ACTIONS(4243),
    [anon_sym_number] = ACTIONS(4243),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4243),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4245),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4243),
    [anon_sym_private] = ACTIONS(4243),
    [anon_sym_boolean] = ACTIONS(4243),
    [anon_sym_async] = ACTIONS(4247),
    [anon_sym_public] = ACTIONS(4243),
    [anon_sym_get] = ACTIONS(4243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4243),
    [anon_sym_string] = ACTIONS(4243),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(4243),
    [anon_sym_type] = ACTIONS(4243),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(4243),
    [anon_sym_export] = ACTIONS(4243),
    [anon_sym_namespace] = ACTIONS(4249),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [2897] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7309),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [2898] = {
    [aux_sym_extends_clause_repeat1] = STATE(2898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6266),
    [anon_sym_COMMA] = ACTIONS(7328),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6268),
  },
  [2899] = {
    [sym_identifier] = ACTIONS(7331),
    [anon_sym_BQUOTE] = ACTIONS(7333),
    [anon_sym_debugger] = ACTIONS(7331),
    [anon_sym_symbol] = ACTIONS(7331),
    [anon_sym_AT] = ACTIONS(7333),
    [anon_sym_DASH] = ACTIONS(7331),
    [anon_sym_void] = ACTIONS(7331),
    [anon_sym_break] = ACTIONS(7331),
    [anon_sym_const] = ACTIONS(7331),
    [sym_super] = ACTIONS(7331),
    [anon_sym_return] = ACTIONS(7331),
    [anon_sym_private] = ACTIONS(7331),
    [anon_sym_get] = ACTIONS(7331),
    [anon_sym_RBRACE] = ACTIONS(7333),
    [anon_sym_interface] = ACTIONS(7331),
    [anon_sym_default] = ACTIONS(7331),
    [anon_sym_enum] = ACTIONS(7331),
    [anon_sym_delete] = ACTIONS(7331),
    [anon_sym_continue] = ACTIONS(7331),
    [anon_sym_DASH_DASH] = ACTIONS(7333),
    [anon_sym_if] = ACTIONS(7331),
    [anon_sym_this] = ACTIONS(7331),
    [anon_sym_yield] = ACTIONS(7331),
    [sym_true] = ACTIONS(7331),
    [anon_sym_throw] = ACTIONS(7331),
    [anon_sym_protected] = ACTIONS(7331),
    [anon_sym_abstract] = ACTIONS(7331),
    [anon_sym_set] = ACTIONS(7331),
    [anon_sym_type] = ACTIONS(7331),
    [anon_sym_import] = ACTIONS(7331),
    [anon_sym_namespace] = ACTIONS(7331),
    [anon_sym_PLUS_PLUS] = ACTIONS(7333),
    [anon_sym_await] = ACTIONS(7331),
    [anon_sym_DQUOTE] = ACTIONS(7333),
    [anon_sym_else] = ACTIONS(7331),
    [anon_sym_BANG] = ACTIONS(7333),
    [anon_sym_for] = ACTIONS(7331),
    [anon_sym_LBRACK] = ACTIONS(7333),
    [sym_false] = ACTIONS(7331),
    [anon_sym_SEMI] = ACTIONS(7333),
    [anon_sym_case] = ACTIONS(7331),
    [anon_sym_module] = ACTIONS(7331),
    [anon_sym_number] = ACTIONS(7331),
    [anon_sym_class] = ACTIONS(7331),
    [anon_sym_declare] = ACTIONS(7331),
    [anon_sym_typeof] = ACTIONS(7331),
    [anon_sym_LBRACE] = ACTIONS(7333),
    [anon_sym_switch] = ACTIONS(7331),
    [anon_sym_LPAREN] = ACTIONS(7333),
    [sym_null] = ACTIONS(7331),
    [anon_sym_any] = ACTIONS(7331),
    [anon_sym_boolean] = ACTIONS(7331),
    [anon_sym_async] = ACTIONS(7331),
    [anon_sym_public] = ACTIONS(7331),
    [anon_sym_var] = ACTIONS(7331),
    [anon_sym_while] = ACTIONS(7331),
    [anon_sym_SQUOTE] = ACTIONS(7333),
    [anon_sym_try] = ACTIONS(7331),
    [anon_sym_LT] = ACTIONS(7333),
    [sym_number] = ACTIONS(7333),
    [anon_sym_SLASH] = ACTIONS(7331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7331),
    [anon_sym_function] = ACTIONS(7331),
    [sym_undefined] = ACTIONS(7331),
    [anon_sym_new] = ACTIONS(7331),
    [ts_builtin_sym_end] = ACTIONS(7333),
    [anon_sym_let] = ACTIONS(7331),
    [anon_sym_PLUS] = ACTIONS(7331),
    [anon_sym_export] = ACTIONS(7331),
    [anon_sym_do] = ACTIONS(7331),
    [anon_sym_TILDE] = ACTIONS(7333),
    [anon_sym_with] = ACTIONS(7331),
  },
  [2900] = {
    [anon_sym_COMMA] = ACTIONS(7335),
    [anon_sym_RBRACE] = ACTIONS(7335),
    [sym_comment] = ACTIONS(3),
  },
  [2901] = {
    [sym_computed_property_name] = STATE(1144),
    [sym__enum_member] = STATE(2900),
    [sym__property_name] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_enum_assignment] = STATE(2900),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(7337),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(1214),
  },
  [2902] = {
    [aux_sym_enum_body_repeat1] = STATE(2902),
    [anon_sym_COMMA] = ACTIONS(7339),
    [anon_sym_RBRACE] = ACTIONS(7335),
    [sym_comment] = ACTIONS(3),
  },
  [2903] = {
    [sym_type_alias_declaration] = STATE(2047),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2047),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2047),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2047),
    [sym_return_statement] = STATE(2047),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2047),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2047),
    [sym_switch_statement] = STATE(2047),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2047),
    [sym_throw_statement] = STATE(2047),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2047),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2047),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(2047),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2047),
    [sym_abstract_class] = STATE(2047),
    [sym_interface_declaration] = STATE(2047),
    [sym_statement_block] = STATE(2047),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2047),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2047),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2047),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2047),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2047),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2047),
    [sym_empty_statement] = STATE(2047),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(2047),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2047),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2047),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2047),
    [sym_break_statement] = STATE(2047),
    [sym_labeled_statement] = STATE(2047),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2047),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [2904] = {
    [sym_array] = STATE(3626),
    [sym_object] = STATE(3627),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(7342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [2905] = {
    [anon_sym_of] = ACTIONS(7344),
    [sym_comment] = ACTIONS(3),
  },
  [2906] = {
    [anon_sym_of] = ACTIONS(7346),
    [sym_comment] = ACTIONS(3),
  },
  [2907] = {
    [anon_sym_of] = ACTIONS(7348),
    [sym_comment] = ACTIONS(3),
  },
  [2908] = {
    [sym_new_expression] = STATE(3631),
    [sym_augmented_assignment_expression] = STATE(3631),
    [sym_unary_expression] = STATE(3631),
    [sym_update_expression] = STATE(3631),
    [sym_regex] = STATE(3631),
    [sym_meta_property] = STATE(3631),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3631),
    [sym_yield_expression] = STATE(3631),
    [sym_as_expression] = STATE(3631),
    [sym_non_null_expression] = STATE(3631),
    [sym_internal_module] = STATE(3631),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3631),
    [sym_await_expression] = STATE(3631),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(3632),
    [sym_string] = STATE(3631),
    [sym_this] = STATE(3631),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3631),
    [sym_generator_function] = STATE(3631),
    [sym_call_expression] = STATE(3631),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_template_string] = STATE(3631),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3631),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3631),
    [sym_class] = STATE(3631),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7350),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7350),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7352),
    [sym_true] = ACTIONS(7350),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7350),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2909] = {
    [sym_new_expression] = STATE(3633),
    [sym_augmented_assignment_expression] = STATE(3633),
    [sym_unary_expression] = STATE(3633),
    [sym_update_expression] = STATE(3633),
    [sym_regex] = STATE(3633),
    [sym_meta_property] = STATE(3633),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3633),
    [sym_yield_expression] = STATE(3633),
    [sym_as_expression] = STATE(3633),
    [sym_non_null_expression] = STATE(3633),
    [sym_internal_module] = STATE(3633),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3633),
    [sym_await_expression] = STATE(3633),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3633),
    [sym_this] = STATE(3633),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3633),
    [sym_generator_function] = STATE(3633),
    [sym_call_expression] = STATE(3633),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3633),
    [sym_ternary_expression] = STATE(3633),
    [sym_binary_expression] = STATE(3633),
    [sym_template_string] = STATE(3633),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3633),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3633),
    [sym_class] = STATE(3633),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7354),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7354),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7356),
    [sym_true] = ACTIONS(7354),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7354),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2910] = {
    [sym__initializer] = STATE(405),
    [sym_type_annotation] = STATE(406),
    [sym__automatic_semicolon] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_of] = ACTIONS(7344),
    [anon_sym_COMMA] = ACTIONS(739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7358),
  },
  [2911] = {
    [sym__initializer] = STATE(425),
    [sym_type_annotation] = STATE(426),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(7346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7360),
  },
  [2912] = {
    [sym__initializer] = STATE(427),
    [sym_type_annotation] = STATE(428),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(7348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7362),
  },
  [2913] = {
    [sym_new_expression] = STATE(3638),
    [sym_augmented_assignment_expression] = STATE(3638),
    [sym_unary_expression] = STATE(3638),
    [sym_update_expression] = STATE(3638),
    [sym_regex] = STATE(3638),
    [sym_meta_property] = STATE(3638),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(3638),
    [sym_yield_expression] = STATE(3638),
    [sym_as_expression] = STATE(3638),
    [sym_non_null_expression] = STATE(3638),
    [sym_internal_module] = STATE(3638),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3638),
    [sym_await_expression] = STATE(3638),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(3639),
    [sym_string] = STATE(3638),
    [sym_this] = STATE(3638),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(3638),
    [sym_generator_function] = STATE(3638),
    [sym_call_expression] = STATE(3638),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(3638),
    [sym_ternary_expression] = STATE(3638),
    [sym_binary_expression] = STATE(3638),
    [sym_template_string] = STATE(3638),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3638),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(3638),
    [sym_class] = STATE(3638),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(7364),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7364),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(7366),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7368),
    [sym_true] = ACTIONS(7364),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7364),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [2914] = {
    [sym_new_expression] = STATE(3640),
    [sym_augmented_assignment_expression] = STATE(3640),
    [sym_unary_expression] = STATE(3640),
    [sym_update_expression] = STATE(3640),
    [sym_regex] = STATE(3640),
    [sym_meta_property] = STATE(3640),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3640),
    [sym_yield_expression] = STATE(3640),
    [sym_as_expression] = STATE(3640),
    [sym_non_null_expression] = STATE(3640),
    [sym_internal_module] = STATE(3640),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3640),
    [sym_await_expression] = STATE(3640),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3640),
    [sym_this] = STATE(3640),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3640),
    [sym_generator_function] = STATE(3640),
    [sym_call_expression] = STATE(3640),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_template_string] = STATE(3640),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3640),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3640),
    [sym_class] = STATE(3640),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7370),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7370),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7372),
    [sym_true] = ACTIONS(7370),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7370),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2915] = {
    [sym_new_expression] = STATE(3641),
    [sym_augmented_assignment_expression] = STATE(3641),
    [sym_unary_expression] = STATE(3641),
    [sym_update_expression] = STATE(3641),
    [sym_regex] = STATE(3641),
    [sym_meta_property] = STATE(3641),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3641),
    [sym_yield_expression] = STATE(3641),
    [sym_as_expression] = STATE(3641),
    [sym_non_null_expression] = STATE(3641),
    [sym_internal_module] = STATE(3641),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3641),
    [sym_await_expression] = STATE(3641),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(3642),
    [sym_string] = STATE(3641),
    [sym_this] = STATE(3641),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3641),
    [sym_generator_function] = STATE(3641),
    [sym_call_expression] = STATE(3641),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3641),
    [sym_ternary_expression] = STATE(3641),
    [sym_binary_expression] = STATE(3641),
    [sym_template_string] = STATE(3641),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3641),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3641),
    [sym_class] = STATE(3641),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7374),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7374),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7376),
    [sym_true] = ACTIONS(7374),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7374),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2916] = {
    [sym_new_expression] = STATE(3643),
    [sym_augmented_assignment_expression] = STATE(3643),
    [sym_unary_expression] = STATE(3643),
    [sym_update_expression] = STATE(3643),
    [sym_regex] = STATE(3643),
    [sym_meta_property] = STATE(3643),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3643),
    [sym_yield_expression] = STATE(3643),
    [sym_as_expression] = STATE(3643),
    [sym_non_null_expression] = STATE(3643),
    [sym_internal_module] = STATE(3643),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3643),
    [sym_await_expression] = STATE(3643),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3643),
    [sym_this] = STATE(3643),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3643),
    [sym_generator_function] = STATE(3643),
    [sym_call_expression] = STATE(3643),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3643),
    [sym_ternary_expression] = STATE(3643),
    [sym_binary_expression] = STATE(3643),
    [sym_template_string] = STATE(3643),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3643),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3643),
    [sym_class] = STATE(3643),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7378),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7378),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7380),
    [sym_true] = ACTIONS(7378),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7378),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2917] = {
    [sym_new_expression] = STATE(3644),
    [sym_augmented_assignment_expression] = STATE(3644),
    [sym_unary_expression] = STATE(3644),
    [sym_update_expression] = STATE(3644),
    [sym_regex] = STATE(3644),
    [sym_meta_property] = STATE(3644),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3644),
    [sym_yield_expression] = STATE(3644),
    [sym_as_expression] = STATE(3644),
    [sym_non_null_expression] = STATE(3644),
    [sym_internal_module] = STATE(3644),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3644),
    [sym_await_expression] = STATE(3644),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(3645),
    [sym_string] = STATE(3644),
    [sym_this] = STATE(3644),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3644),
    [sym_generator_function] = STATE(3644),
    [sym_call_expression] = STATE(3644),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3644),
    [sym_ternary_expression] = STATE(3644),
    [sym_binary_expression] = STATE(3644),
    [sym_template_string] = STATE(3644),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3644),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3644),
    [sym_class] = STATE(3644),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7382),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7382),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7384),
    [sym_true] = ACTIONS(7382),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7382),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2918] = {
    [anon_sym_COLON] = ACTIONS(7386),
    [sym_comment] = ACTIONS(3),
  },
  [2919] = {
    [sym_identifier] = ACTIONS(4795),
    [anon_sym_BQUOTE] = ACTIONS(4793),
    [anon_sym_debugger] = ACTIONS(4795),
    [anon_sym_symbol] = ACTIONS(4795),
    [anon_sym_AT] = ACTIONS(4793),
    [anon_sym_DASH] = ACTIONS(4795),
    [anon_sym_void] = ACTIONS(4795),
    [anon_sym_break] = ACTIONS(4795),
    [anon_sym_const] = ACTIONS(4795),
    [sym_super] = ACTIONS(4795),
    [anon_sym_return] = ACTIONS(4795),
    [anon_sym_private] = ACTIONS(4795),
    [anon_sym_get] = ACTIONS(4795),
    [anon_sym_RBRACE] = ACTIONS(4793),
    [anon_sym_interface] = ACTIONS(4795),
    [anon_sym_default] = ACTIONS(4795),
    [anon_sym_enum] = ACTIONS(4795),
    [anon_sym_delete] = ACTIONS(4795),
    [anon_sym_continue] = ACTIONS(4795),
    [anon_sym_DASH_DASH] = ACTIONS(4793),
    [anon_sym_if] = ACTIONS(4795),
    [anon_sym_this] = ACTIONS(4795),
    [anon_sym_yield] = ACTIONS(4795),
    [sym_true] = ACTIONS(4795),
    [anon_sym_throw] = ACTIONS(4795),
    [anon_sym_protected] = ACTIONS(4795),
    [anon_sym_abstract] = ACTIONS(4795),
    [anon_sym_set] = ACTIONS(4795),
    [anon_sym_type] = ACTIONS(4795),
    [anon_sym_import] = ACTIONS(4795),
    [anon_sym_namespace] = ACTIONS(4795),
    [anon_sym_PLUS_PLUS] = ACTIONS(4793),
    [anon_sym_await] = ACTIONS(4795),
    [anon_sym_DQUOTE] = ACTIONS(4793),
    [anon_sym_else] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(4793),
    [anon_sym_for] = ACTIONS(4795),
    [anon_sym_LBRACK] = ACTIONS(4793),
    [sym_false] = ACTIONS(4795),
    [anon_sym_SEMI] = ACTIONS(4793),
    [anon_sym_case] = ACTIONS(4795),
    [anon_sym_module] = ACTIONS(4795),
    [anon_sym_number] = ACTIONS(4795),
    [anon_sym_class] = ACTIONS(4795),
    [anon_sym_declare] = ACTIONS(4795),
    [anon_sym_typeof] = ACTIONS(4795),
    [anon_sym_LBRACE] = ACTIONS(4793),
    [anon_sym_switch] = ACTIONS(4795),
    [anon_sym_LPAREN] = ACTIONS(4793),
    [sym_null] = ACTIONS(4795),
    [anon_sym_any] = ACTIONS(4795),
    [anon_sym_boolean] = ACTIONS(4795),
    [anon_sym_async] = ACTIONS(4795),
    [anon_sym_public] = ACTIONS(4795),
    [anon_sym_var] = ACTIONS(4795),
    [anon_sym_while] = ACTIONS(4795),
    [anon_sym_SQUOTE] = ACTIONS(4793),
    [anon_sym_try] = ACTIONS(4795),
    [anon_sym_LT] = ACTIONS(4793),
    [sym_number] = ACTIONS(4793),
    [anon_sym_SLASH] = ACTIONS(4795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4795),
    [anon_sym_function] = ACTIONS(4795),
    [sym_undefined] = ACTIONS(4795),
    [anon_sym_new] = ACTIONS(4795),
    [ts_builtin_sym_end] = ACTIONS(4793),
    [anon_sym_let] = ACTIONS(4795),
    [anon_sym_PLUS] = ACTIONS(4795),
    [anon_sym_export] = ACTIONS(4795),
    [anon_sym_do] = ACTIONS(4795),
    [anon_sym_TILDE] = ACTIONS(4793),
    [anon_sym_with] = ACTIONS(4795),
  },
  [2920] = {
    [sym_identifier] = ACTIONS(7388),
    [anon_sym_BQUOTE] = ACTIONS(7390),
    [anon_sym_debugger] = ACTIONS(7388),
    [anon_sym_symbol] = ACTIONS(7388),
    [anon_sym_AT] = ACTIONS(7390),
    [anon_sym_DASH] = ACTIONS(7388),
    [anon_sym_void] = ACTIONS(7388),
    [anon_sym_break] = ACTIONS(7388),
    [anon_sym_const] = ACTIONS(7388),
    [sym_super] = ACTIONS(7388),
    [anon_sym_return] = ACTIONS(7388),
    [anon_sym_private] = ACTIONS(7388),
    [anon_sym_get] = ACTIONS(7388),
    [anon_sym_RBRACE] = ACTIONS(7390),
    [anon_sym_interface] = ACTIONS(7388),
    [anon_sym_default] = ACTIONS(7388),
    [anon_sym_enum] = ACTIONS(7388),
    [anon_sym_delete] = ACTIONS(7388),
    [anon_sym_continue] = ACTIONS(7388),
    [anon_sym_DASH_DASH] = ACTIONS(7390),
    [anon_sym_if] = ACTIONS(7388),
    [anon_sym_this] = ACTIONS(7388),
    [anon_sym_yield] = ACTIONS(7388),
    [sym_true] = ACTIONS(7388),
    [anon_sym_throw] = ACTIONS(7388),
    [anon_sym_protected] = ACTIONS(7388),
    [anon_sym_abstract] = ACTIONS(7388),
    [anon_sym_set] = ACTIONS(7388),
    [anon_sym_type] = ACTIONS(7388),
    [anon_sym_import] = ACTIONS(7388),
    [anon_sym_namespace] = ACTIONS(7388),
    [anon_sym_PLUS_PLUS] = ACTIONS(7390),
    [anon_sym_await] = ACTIONS(7388),
    [anon_sym_DQUOTE] = ACTIONS(7390),
    [anon_sym_else] = ACTIONS(7388),
    [anon_sym_BANG] = ACTIONS(7390),
    [anon_sym_for] = ACTIONS(7388),
    [anon_sym_LBRACK] = ACTIONS(7390),
    [sym_false] = ACTIONS(7388),
    [anon_sym_SEMI] = ACTIONS(7390),
    [anon_sym_case] = ACTIONS(7388),
    [anon_sym_module] = ACTIONS(7388),
    [anon_sym_number] = ACTIONS(7388),
    [anon_sym_class] = ACTIONS(7388),
    [anon_sym_declare] = ACTIONS(7388),
    [anon_sym_typeof] = ACTIONS(7388),
    [anon_sym_LBRACE] = ACTIONS(7390),
    [anon_sym_switch] = ACTIONS(7388),
    [anon_sym_LPAREN] = ACTIONS(7390),
    [sym_null] = ACTIONS(7388),
    [anon_sym_any] = ACTIONS(7388),
    [anon_sym_boolean] = ACTIONS(7388),
    [anon_sym_async] = ACTIONS(7388),
    [anon_sym_public] = ACTIONS(7388),
    [anon_sym_var] = ACTIONS(7388),
    [anon_sym_while] = ACTIONS(7388),
    [anon_sym_SQUOTE] = ACTIONS(7390),
    [anon_sym_try] = ACTIONS(7388),
    [anon_sym_LT] = ACTIONS(7390),
    [sym_number] = ACTIONS(7390),
    [anon_sym_SLASH] = ACTIONS(7388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7388),
    [anon_sym_function] = ACTIONS(7388),
    [sym_undefined] = ACTIONS(7388),
    [anon_sym_new] = ACTIONS(7388),
    [ts_builtin_sym_end] = ACTIONS(7390),
    [anon_sym_let] = ACTIONS(7388),
    [anon_sym_PLUS] = ACTIONS(7388),
    [anon_sym_export] = ACTIONS(7388),
    [anon_sym_do] = ACTIONS(7388),
    [anon_sym_TILDE] = ACTIONS(7390),
    [anon_sym_with] = ACTIONS(7388),
  },
  [2921] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2922] = {
    [sym_formal_parameters] = STATE(3647),
    [sym_type_parameters] = STATE(3648),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [2923] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2924] = {
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(7392),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(7394),
    [sym_comment] = ACTIONS(3),
  },
  [2925] = {
    [sym_formal_parameters] = STATE(3651),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [2926] = {
    [anon_sym_EQ_GT] = ACTIONS(7396),
    [sym_comment] = ACTIONS(3),
  },
  [2927] = {
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(7392),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(7394),
    [sym_comment] = ACTIONS(3),
  },
  [2928] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(3653),
    [sym_constructor_type] = STATE(3653),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(3653),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(3653),
    [sym_intersection_type] = STATE(3653),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2929] = {
    [anon_sym_EQ_GT] = ACTIONS(7398),
    [sym_comment] = ACTIONS(3),
  },
  [2930] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(3655),
    [sym_constructor_type] = STATE(3655),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(3655),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(3655),
    [sym_intersection_type] = STATE(3655),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [2931] = {
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(7392),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(7394),
    [sym_comment] = ACTIONS(3),
  },
  [2932] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(4321),
    [anon_sym_PIPE] = ACTIONS(4323),
    [anon_sym_SEMI] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [2933] = {
    [sym_identifier] = ACTIONS(7400),
    [anon_sym_BQUOTE] = ACTIONS(7402),
    [anon_sym_debugger] = ACTIONS(7400),
    [anon_sym_symbol] = ACTIONS(7400),
    [anon_sym_AT] = ACTIONS(7402),
    [anon_sym_DASH] = ACTIONS(7400),
    [anon_sym_void] = ACTIONS(7400),
    [anon_sym_break] = ACTIONS(7400),
    [anon_sym_const] = ACTIONS(7400),
    [sym_super] = ACTIONS(7400),
    [anon_sym_return] = ACTIONS(7400),
    [anon_sym_private] = ACTIONS(7400),
    [anon_sym_get] = ACTIONS(7400),
    [anon_sym_RBRACE] = ACTIONS(7402),
    [anon_sym_interface] = ACTIONS(7400),
    [anon_sym_default] = ACTIONS(7400),
    [anon_sym_enum] = ACTIONS(7400),
    [anon_sym_delete] = ACTIONS(7400),
    [anon_sym_continue] = ACTIONS(7400),
    [anon_sym_DASH_DASH] = ACTIONS(7402),
    [anon_sym_if] = ACTIONS(7400),
    [anon_sym_this] = ACTIONS(7400),
    [anon_sym_yield] = ACTIONS(7400),
    [sym_true] = ACTIONS(7400),
    [anon_sym_throw] = ACTIONS(7400),
    [anon_sym_protected] = ACTIONS(7400),
    [anon_sym_abstract] = ACTIONS(7400),
    [anon_sym_set] = ACTIONS(7400),
    [anon_sym_type] = ACTIONS(7400),
    [anon_sym_import] = ACTIONS(7400),
    [anon_sym_namespace] = ACTIONS(7400),
    [anon_sym_PLUS_PLUS] = ACTIONS(7402),
    [anon_sym_await] = ACTIONS(7400),
    [anon_sym_DQUOTE] = ACTIONS(7402),
    [anon_sym_else] = ACTIONS(7400),
    [anon_sym_BANG] = ACTIONS(7402),
    [anon_sym_for] = ACTIONS(7400),
    [anon_sym_LBRACK] = ACTIONS(7402),
    [sym_false] = ACTIONS(7400),
    [anon_sym_SEMI] = ACTIONS(7402),
    [anon_sym_case] = ACTIONS(7400),
    [anon_sym_module] = ACTIONS(7400),
    [anon_sym_number] = ACTIONS(7400),
    [anon_sym_class] = ACTIONS(7400),
    [anon_sym_declare] = ACTIONS(7400),
    [anon_sym_typeof] = ACTIONS(7400),
    [anon_sym_LBRACE] = ACTIONS(7402),
    [anon_sym_switch] = ACTIONS(7400),
    [anon_sym_LPAREN] = ACTIONS(7402),
    [sym_null] = ACTIONS(7400),
    [anon_sym_any] = ACTIONS(7400),
    [anon_sym_boolean] = ACTIONS(7400),
    [anon_sym_async] = ACTIONS(7400),
    [anon_sym_public] = ACTIONS(7400),
    [anon_sym_var] = ACTIONS(7400),
    [anon_sym_while] = ACTIONS(7400),
    [anon_sym_SQUOTE] = ACTIONS(7402),
    [anon_sym_try] = ACTIONS(7400),
    [anon_sym_LT] = ACTIONS(7402),
    [sym_number] = ACTIONS(7402),
    [anon_sym_SLASH] = ACTIONS(7400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7400),
    [anon_sym_function] = ACTIONS(7400),
    [sym_undefined] = ACTIONS(7400),
    [anon_sym_new] = ACTIONS(7400),
    [ts_builtin_sym_end] = ACTIONS(7402),
    [anon_sym_let] = ACTIONS(7400),
    [anon_sym_PLUS] = ACTIONS(7400),
    [anon_sym_export] = ACTIONS(7400),
    [anon_sym_do] = ACTIONS(7400),
    [anon_sym_TILDE] = ACTIONS(7402),
    [anon_sym_with] = ACTIONS(7400),
  },
  [2934] = {
    [anon_sym_RPAREN] = ACTIONS(7404),
    [sym_comment] = ACTIONS(3),
  },
  [2935] = {
    [anon_sym_COMMA] = ACTIONS(7406),
    [anon_sym_RBRACE] = ACTIONS(7406),
    [sym_comment] = ACTIONS(3),
  },
  [2936] = {
    [anon_sym_from] = ACTIONS(7408),
    [sym_comment] = ACTIONS(3),
  },
  [2937] = {
    [sym__import_export_specifier] = STATE(2069),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_typeof] = ACTIONS(887),
    [anon_sym_type] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
  },
  [2938] = {
    [sym_new_expression] = STATE(3657),
    [sym_augmented_assignment_expression] = STATE(3657),
    [sym_unary_expression] = STATE(3657),
    [sym_update_expression] = STATE(3657),
    [sym_regex] = STATE(3657),
    [sym_meta_property] = STATE(3657),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3657),
    [sym_yield_expression] = STATE(3657),
    [sym_as_expression] = STATE(3657),
    [sym_non_null_expression] = STATE(3657),
    [sym_internal_module] = STATE(3657),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3657),
    [sym_await_expression] = STATE(3657),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3657),
    [sym_this] = STATE(3657),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3657),
    [sym_generator_function] = STATE(3657),
    [sym_call_expression] = STATE(3657),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3657),
    [sym_ternary_expression] = STATE(3657),
    [sym_binary_expression] = STATE(3657),
    [sym_template_string] = STATE(3657),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3657),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3657),
    [sym_class] = STATE(3657),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7410),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7410),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7412),
    [sym_true] = ACTIONS(7410),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7410),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2939] = {
    [sym_new_expression] = STATE(3658),
    [sym_augmented_assignment_expression] = STATE(3658),
    [sym_unary_expression] = STATE(3658),
    [sym_update_expression] = STATE(3658),
    [sym_regex] = STATE(3658),
    [sym_meta_property] = STATE(3658),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3658),
    [sym_yield_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_non_null_expression] = STATE(3658),
    [sym_internal_module] = STATE(3658),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3658),
    [sym_await_expression] = STATE(3658),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3658),
    [sym_this] = STATE(3658),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3658),
    [sym_generator_function] = STATE(3658),
    [sym_call_expression] = STATE(3658),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3658),
    [sym_ternary_expression] = STATE(3658),
    [sym_binary_expression] = STATE(3658),
    [sym_template_string] = STATE(3658),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3658),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3658),
    [sym_class] = STATE(3658),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7414),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7414),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7416),
    [sym_true] = ACTIONS(7414),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7414),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2940] = {
    [sym_new_expression] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(3659),
    [sym_unary_expression] = STATE(3659),
    [sym_update_expression] = STATE(3659),
    [sym_regex] = STATE(3659),
    [sym_meta_property] = STATE(3659),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3659),
    [sym_yield_expression] = STATE(3659),
    [sym_as_expression] = STATE(3659),
    [sym_non_null_expression] = STATE(3659),
    [sym_internal_module] = STATE(3659),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3659),
    [sym_await_expression] = STATE(3659),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3659),
    [sym_this] = STATE(3659),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3659),
    [sym_generator_function] = STATE(3659),
    [sym_call_expression] = STATE(3659),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3659),
    [sym_ternary_expression] = STATE(3659),
    [sym_binary_expression] = STATE(3659),
    [sym_template_string] = STATE(3659),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3659),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3659),
    [sym_class] = STATE(3659),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7418),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7418),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7420),
    [sym_true] = ACTIONS(7418),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7418),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2941] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(7422),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2942] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(7424),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2943] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(7426),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2944] = {
    [sym_new_expression] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3663),
    [sym_unary_expression] = STATE(3663),
    [sym_update_expression] = STATE(3663),
    [sym_regex] = STATE(3663),
    [sym_meta_property] = STATE(3663),
    [sym_call_signature] = STATE(2089),
    [sym_statement_block] = STATE(356),
    [sym__expression] = STATE(3663),
    [sym_yield_expression] = STATE(3663),
    [sym_as_expression] = STATE(3663),
    [sym_non_null_expression] = STATE(3663),
    [sym_internal_module] = STATE(3663),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3663),
    [sym_await_expression] = STATE(3663),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3663),
    [sym_this] = STATE(3663),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3663),
    [sym_generator_function] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3663),
    [sym_ternary_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3663),
    [sym_template_string] = STATE(3663),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3663),
    [sym_class] = STATE(3663),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7428),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7428),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7430),
    [sym_true] = ACTIONS(7428),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7428),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2945] = {
    [sym_new_expression] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(3664),
    [sym_unary_expression] = STATE(3664),
    [sym_update_expression] = STATE(3664),
    [sym_regex] = STATE(3664),
    [sym_meta_property] = STATE(3664),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3664),
    [sym_yield_expression] = STATE(3664),
    [sym_as_expression] = STATE(3664),
    [sym_non_null_expression] = STATE(3664),
    [sym_internal_module] = STATE(3664),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3664),
    [sym_await_expression] = STATE(3664),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3664),
    [sym_this] = STATE(3664),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3664),
    [sym_generator_function] = STATE(3664),
    [sym_call_expression] = STATE(3664),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3664),
    [sym_ternary_expression] = STATE(3664),
    [sym_binary_expression] = STATE(3664),
    [sym_template_string] = STATE(3664),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3664),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3664),
    [sym_class] = STATE(3664),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7432),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7432),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7434),
    [sym_true] = ACTIONS(7432),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7432),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2946] = {
    [sym_new_expression] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(3665),
    [sym_unary_expression] = STATE(3665),
    [sym_update_expression] = STATE(3665),
    [sym_regex] = STATE(3665),
    [sym_meta_property] = STATE(3665),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3665),
    [sym_yield_expression] = STATE(3665),
    [sym_as_expression] = STATE(3665),
    [sym_non_null_expression] = STATE(3665),
    [sym_internal_module] = STATE(3665),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3665),
    [sym_await_expression] = STATE(3665),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3665),
    [sym_this] = STATE(3665),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3665),
    [sym_generator_function] = STATE(3665),
    [sym_call_expression] = STATE(3665),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3665),
    [sym_ternary_expression] = STATE(3665),
    [sym_binary_expression] = STATE(3665),
    [sym_template_string] = STATE(3665),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3665),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3665),
    [sym_class] = STATE(3665),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7436),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7436),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7438),
    [sym_true] = ACTIONS(7436),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7436),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2947] = {
    [sym_new_expression] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(3666),
    [sym_unary_expression] = STATE(3666),
    [sym_update_expression] = STATE(3666),
    [sym_regex] = STATE(3666),
    [sym_meta_property] = STATE(3666),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3666),
    [sym_yield_expression] = STATE(3666),
    [sym_as_expression] = STATE(3666),
    [sym_non_null_expression] = STATE(3666),
    [sym_internal_module] = STATE(3666),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3666),
    [sym_await_expression] = STATE(3666),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3666),
    [sym_this] = STATE(3666),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3666),
    [sym_generator_function] = STATE(3666),
    [sym_call_expression] = STATE(3666),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3666),
    [sym_ternary_expression] = STATE(3666),
    [sym_binary_expression] = STATE(3666),
    [sym_template_string] = STATE(3666),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3666),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3666),
    [sym_class] = STATE(3666),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7440),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7440),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7442),
    [sym_true] = ACTIONS(7440),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7440),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2948] = {
    [sym_new_expression] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(3667),
    [sym_unary_expression] = STATE(3667),
    [sym_update_expression] = STATE(3667),
    [sym_regex] = STATE(3667),
    [sym_meta_property] = STATE(3667),
    [sym_call_signature] = STATE(2089),
    [sym_statement_block] = STATE(383),
    [sym__expression] = STATE(3667),
    [sym_yield_expression] = STATE(3667),
    [sym_as_expression] = STATE(3667),
    [sym_non_null_expression] = STATE(3667),
    [sym_internal_module] = STATE(3667),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3667),
    [sym_await_expression] = STATE(3667),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3667),
    [sym_this] = STATE(3667),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3667),
    [sym_generator_function] = STATE(3667),
    [sym_call_expression] = STATE(3667),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3667),
    [sym_ternary_expression] = STATE(3667),
    [sym_binary_expression] = STATE(3667),
    [sym_template_string] = STATE(3667),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3667),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3667),
    [sym_class] = STATE(3667),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7444),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7444),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7446),
    [sym_true] = ACTIONS(7444),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7444),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2949] = {
    [sym_new_expression] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3668),
    [sym_unary_expression] = STATE(3668),
    [sym_update_expression] = STATE(3668),
    [sym_regex] = STATE(3668),
    [sym_meta_property] = STATE(3668),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3668),
    [sym_yield_expression] = STATE(3668),
    [sym_as_expression] = STATE(3668),
    [sym_non_null_expression] = STATE(3668),
    [sym_internal_module] = STATE(3668),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3668),
    [sym_await_expression] = STATE(3668),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3668),
    [sym_this] = STATE(3668),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3668),
    [sym_generator_function] = STATE(3668),
    [sym_call_expression] = STATE(3668),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3668),
    [sym_ternary_expression] = STATE(3668),
    [sym_binary_expression] = STATE(3668),
    [sym_template_string] = STATE(3668),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3668),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3668),
    [sym_class] = STATE(3668),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7448),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7448),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7450),
    [sym_true] = ACTIONS(7448),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7448),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2950] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(7452),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [2951] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(7452),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [2952] = {
    [anon_sym_EQ_GT] = ACTIONS(7455),
    [sym_comment] = ACTIONS(3),
  },
  [2953] = {
    [anon_sym_EQ_GT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(3),
  },
  [2954] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [sym__automatic_semicolon] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [2955] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [2956] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(868),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(6071),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [2957] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2958] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(870),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2959] = {
    [sym_call_signature] = STATE(2952),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(6087),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(6089),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(6089),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(6089),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(6089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(6089),
    [anon_sym_type] = ACTIONS(6089),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(6089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(6089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(6089),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(6089),
    [anon_sym_declare] = ACTIONS(6089),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(6089),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(6089),
    [anon_sym_async] = ACTIONS(6089),
    [anon_sym_public] = ACTIONS(6089),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(6089),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(6089),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2960] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(870),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2961] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(907),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [2962] = {
    [sym_new_expression] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(3671),
    [sym_unary_expression] = STATE(3671),
    [sym_update_expression] = STATE(3671),
    [sym_regex] = STATE(3671),
    [sym_meta_property] = STATE(3671),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3671),
    [sym_yield_expression] = STATE(3671),
    [sym_as_expression] = STATE(3671),
    [sym_non_null_expression] = STATE(3671),
    [sym_internal_module] = STATE(3671),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3671),
    [sym_await_expression] = STATE(3671),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3671),
    [sym_this] = STATE(3671),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3671),
    [sym_generator_function] = STATE(3671),
    [sym_call_expression] = STATE(3671),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3671),
    [sym_ternary_expression] = STATE(3671),
    [sym_binary_expression] = STATE(3671),
    [sym_template_string] = STATE(3671),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3671),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3671),
    [sym_class] = STATE(3671),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7471),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7471),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7473),
    [sym_true] = ACTIONS(7471),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7471),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2963] = {
    [sym_new_expression] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(3672),
    [sym_unary_expression] = STATE(3672),
    [sym_update_expression] = STATE(3672),
    [sym_regex] = STATE(3672),
    [sym_meta_property] = STATE(3672),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3672),
    [sym_yield_expression] = STATE(3672),
    [sym_as_expression] = STATE(3672),
    [sym_non_null_expression] = STATE(3672),
    [sym_internal_module] = STATE(3672),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3672),
    [sym_await_expression] = STATE(3672),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3672),
    [sym_this] = STATE(3672),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3672),
    [sym_generator_function] = STATE(3672),
    [sym_call_expression] = STATE(3672),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3672),
    [sym_ternary_expression] = STATE(3672),
    [sym_binary_expression] = STATE(3672),
    [sym_template_string] = STATE(3672),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3672),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3672),
    [sym_class] = STATE(3672),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7475),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7475),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7477),
    [sym_true] = ACTIONS(7475),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7475),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2964] = {
    [sym_new_expression] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(3673),
    [sym_unary_expression] = STATE(3673),
    [sym_update_expression] = STATE(3673),
    [sym_regex] = STATE(3673),
    [sym_meta_property] = STATE(3673),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3673),
    [sym_yield_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_non_null_expression] = STATE(3673),
    [sym_internal_module] = STATE(3673),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3673),
    [sym_await_expression] = STATE(3673),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3673),
    [sym_this] = STATE(3673),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3673),
    [sym_generator_function] = STATE(3673),
    [sym_call_expression] = STATE(3673),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3673),
    [sym_ternary_expression] = STATE(3673),
    [sym_binary_expression] = STATE(3673),
    [sym_template_string] = STATE(3673),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3673),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3673),
    [sym_class] = STATE(3673),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7479),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7479),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7481),
    [sym_true] = ACTIONS(7479),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7479),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2965] = {
    [sym_new_expression] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(3674),
    [sym_unary_expression] = STATE(3674),
    [sym_update_expression] = STATE(3674),
    [sym_regex] = STATE(3674),
    [sym_meta_property] = STATE(3674),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3674),
    [sym_yield_expression] = STATE(3674),
    [sym_as_expression] = STATE(3674),
    [sym_non_null_expression] = STATE(3674),
    [sym_internal_module] = STATE(3674),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3674),
    [sym_await_expression] = STATE(3674),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3674),
    [sym_this] = STATE(3674),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3674),
    [sym_generator_function] = STATE(3674),
    [sym_call_expression] = STATE(3674),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3674),
    [sym_ternary_expression] = STATE(3674),
    [sym_binary_expression] = STATE(3674),
    [sym_template_string] = STATE(3674),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3674),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3674),
    [sym_class] = STATE(3674),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7483),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7483),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7485),
    [sym_true] = ACTIONS(7483),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7483),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2966] = {
    [sym_new_expression] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(3675),
    [sym_unary_expression] = STATE(3675),
    [sym_update_expression] = STATE(3675),
    [sym_regex] = STATE(3675),
    [sym_meta_property] = STATE(3675),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(3675),
    [sym_yield_expression] = STATE(3675),
    [sym_as_expression] = STATE(3675),
    [sym_non_null_expression] = STATE(3675),
    [sym_internal_module] = STATE(3675),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3675),
    [sym_await_expression] = STATE(3675),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(3675),
    [sym_this] = STATE(3675),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(3675),
    [sym_generator_function] = STATE(3675),
    [sym_call_expression] = STATE(3675),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(3675),
    [sym_ternary_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3675),
    [sym_template_string] = STATE(3675),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3675),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(3675),
    [sym_class] = STATE(3675),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(7487),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7487),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7489),
    [sym_true] = ACTIONS(7487),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7487),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [2967] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(983),
    [sym_constructor_type] = STATE(983),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(983),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_template_string] = STATE(987),
    [sym_union_type] = STATE(983),
    [sym_intersection_type] = STATE(983),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_keyof] = ACTIONS(1976),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(7493),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_boolean] = ACTIONS(1972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1994),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [2968] = {
    [sym_new_expression] = STATE(3664),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(3664),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3664),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3664),
    [sym_call_signature] = STATE(2089),
    [sym_yield_expression] = STATE(3664),
    [sym_as_expression] = STATE(3664),
    [sym_internal_module] = STATE(3664),
    [sym_arrow_function] = STATE(3664),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(2091),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(991),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(2093),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(3664),
    [sym_subscript_expression] = STATE(2091),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3664),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3664),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3664),
    [sym_meta_property] = STATE(3664),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(3664),
    [sym_non_null_expression] = STATE(3664),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(3664),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3664),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_anonymous_class] = STATE(3664),
    [sym_call_expression] = STATE(3664),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3664),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3664),
    [sym_type_arguments] = STATE(2094),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(3664),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3664),
    [sym_class] = STATE(3664),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(7501),
    [sym_false] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(7503),
    [anon_sym_number] = ACTIONS(7503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(7505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(7507),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(7509),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [sym_null] = ACTIONS(7432),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(7503),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(7503),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(2018),
    [sym_number] = ACTIONS(2020),
    [sym_true] = ACTIONS(2002),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(7503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7432),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(7511),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(7507),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2969] = {
    [sym_type_alias_declaration] = STATE(3690),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3690),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3690),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3690),
    [sym_return_statement] = STATE(3690),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3690),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3690),
    [sym_switch_statement] = STATE(3690),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3690),
    [sym_throw_statement] = STATE(3690),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3690),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3690),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(3690),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3690),
    [sym_abstract_class] = STATE(3690),
    [sym_interface_declaration] = STATE(3690),
    [sym_statement_block] = STATE(3690),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3690),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3690),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3690),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3690),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3690),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3690),
    [sym_empty_statement] = STATE(3690),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(3690),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3690),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3690),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3690),
    [sym_break_statement] = STATE(3690),
    [sym_labeled_statement] = STATE(3690),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3690),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2970] = {
    [sym_new_expression] = STATE(3691),
    [sym_augmented_assignment_expression] = STATE(3691),
    [sym_unary_expression] = STATE(3691),
    [sym_update_expression] = STATE(3691),
    [sym_regex] = STATE(3691),
    [sym_meta_property] = STATE(3691),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(3691),
    [sym_yield_expression] = STATE(3691),
    [sym_as_expression] = STATE(3691),
    [sym_non_null_expression] = STATE(3691),
    [sym_internal_module] = STATE(3691),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3691),
    [sym_await_expression] = STATE(3691),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(3691),
    [sym_this] = STATE(3691),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(3691),
    [sym_generator_function] = STATE(3691),
    [sym_call_expression] = STATE(3691),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3691),
    [sym_ternary_expression] = STATE(3691),
    [sym_binary_expression] = STATE(3691),
    [sym_template_string] = STATE(3691),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3691),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3691),
    [sym_class] = STATE(3691),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(7513),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7513),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7515),
    [sym_true] = ACTIONS(7513),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7513),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [2971] = {
    [sym_new_expression] = STATE(3692),
    [sym_augmented_assignment_expression] = STATE(3692),
    [sym_unary_expression] = STATE(3692),
    [sym_update_expression] = STATE(3692),
    [sym_regex] = STATE(3692),
    [sym_meta_property] = STATE(3692),
    [sym_call_signature] = STATE(2107),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(3692),
    [sym_yield_expression] = STATE(3692),
    [sym_as_expression] = STATE(3692),
    [sym_non_null_expression] = STATE(3692),
    [sym_internal_module] = STATE(3692),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3692),
    [sym_await_expression] = STATE(3692),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3692),
    [sym_this] = STATE(3692),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3692),
    [sym_generator_function] = STATE(3692),
    [sym_call_expression] = STATE(3692),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3692),
    [sym_ternary_expression] = STATE(3692),
    [sym_binary_expression] = STATE(3692),
    [sym_template_string] = STATE(3692),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3692),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3692),
    [sym_class] = STATE(3692),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7517),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7517),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7519),
    [sym_true] = ACTIONS(7517),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7517),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2972] = {
    [sym_new_expression] = STATE(3693),
    [sym_augmented_assignment_expression] = STATE(3693),
    [sym_unary_expression] = STATE(3693),
    [sym_update_expression] = STATE(3693),
    [sym_regex] = STATE(3693),
    [sym_meta_property] = STATE(3693),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3693),
    [sym_yield_expression] = STATE(3693),
    [sym_as_expression] = STATE(3693),
    [sym_non_null_expression] = STATE(3693),
    [sym_internal_module] = STATE(3693),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3693),
    [sym_await_expression] = STATE(3693),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3693),
    [sym_this] = STATE(3693),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3693),
    [sym_generator_function] = STATE(3693),
    [sym_call_expression] = STATE(3693),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3693),
    [sym_ternary_expression] = STATE(3693),
    [sym_binary_expression] = STATE(3693),
    [sym_template_string] = STATE(3693),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3693),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3693),
    [sym_class] = STATE(3693),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7521),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7521),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7523),
    [sym_true] = ACTIONS(7521),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7521),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2973] = {
    [sym_new_expression] = STATE(3694),
    [sym_augmented_assignment_expression] = STATE(3694),
    [sym_unary_expression] = STATE(3694),
    [sym_update_expression] = STATE(3694),
    [sym_regex] = STATE(3694),
    [sym_meta_property] = STATE(3694),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3694),
    [sym_yield_expression] = STATE(3694),
    [sym_as_expression] = STATE(3694),
    [sym_non_null_expression] = STATE(3694),
    [sym_internal_module] = STATE(3694),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3694),
    [sym_await_expression] = STATE(3694),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3694),
    [sym_this] = STATE(3694),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3694),
    [sym_generator_function] = STATE(3694),
    [sym_call_expression] = STATE(3694),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3694),
    [sym_ternary_expression] = STATE(3694),
    [sym_binary_expression] = STATE(3694),
    [sym_template_string] = STATE(3694),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3694),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3694),
    [sym_class] = STATE(3694),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7525),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7525),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7527),
    [sym_true] = ACTIONS(7525),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7525),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2974] = {
    [sym_new_expression] = STATE(3695),
    [sym_augmented_assignment_expression] = STATE(3695),
    [sym_unary_expression] = STATE(3695),
    [sym_update_expression] = STATE(3695),
    [sym_regex] = STATE(3695),
    [sym_meta_property] = STATE(3695),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3695),
    [sym_yield_expression] = STATE(3695),
    [sym_as_expression] = STATE(3695),
    [sym_non_null_expression] = STATE(3695),
    [sym_internal_module] = STATE(3695),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3695),
    [sym_await_expression] = STATE(3695),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3695),
    [sym_this] = STATE(3695),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3695),
    [sym_generator_function] = STATE(3695),
    [sym_call_expression] = STATE(3695),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3695),
    [sym_ternary_expression] = STATE(3695),
    [sym_binary_expression] = STATE(3695),
    [sym_template_string] = STATE(3695),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3695),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3695),
    [sym_class] = STATE(3695),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7529),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7531),
    [sym_true] = ACTIONS(7529),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7529),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2975] = {
    [sym_new_expression] = STATE(3696),
    [sym_augmented_assignment_expression] = STATE(3696),
    [sym_unary_expression] = STATE(3696),
    [sym_update_expression] = STATE(3696),
    [sym_regex] = STATE(3696),
    [sym_meta_property] = STATE(3696),
    [sym_call_signature] = STATE(2107),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(3696),
    [sym_yield_expression] = STATE(3696),
    [sym_as_expression] = STATE(3696),
    [sym_non_null_expression] = STATE(3696),
    [sym_internal_module] = STATE(3696),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3696),
    [sym_await_expression] = STATE(3696),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3696),
    [sym_this] = STATE(3696),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3696),
    [sym_generator_function] = STATE(3696),
    [sym_call_expression] = STATE(3696),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3696),
    [sym_ternary_expression] = STATE(3696),
    [sym_binary_expression] = STATE(3696),
    [sym_template_string] = STATE(3696),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3696),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3696),
    [sym_class] = STATE(3696),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7533),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7533),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7535),
    [sym_true] = ACTIONS(7533),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7533),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2976] = {
    [sym_new_expression] = STATE(3697),
    [sym_augmented_assignment_expression] = STATE(3697),
    [sym_unary_expression] = STATE(3697),
    [sym_update_expression] = STATE(3697),
    [sym_regex] = STATE(3697),
    [sym_meta_property] = STATE(3697),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3697),
    [sym_yield_expression] = STATE(3697),
    [sym_as_expression] = STATE(3697),
    [sym_non_null_expression] = STATE(3697),
    [sym_internal_module] = STATE(3697),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3697),
    [sym_await_expression] = STATE(3697),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3697),
    [sym_this] = STATE(3697),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3697),
    [sym_generator_function] = STATE(3697),
    [sym_call_expression] = STATE(3697),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3697),
    [sym_ternary_expression] = STATE(3697),
    [sym_binary_expression] = STATE(3697),
    [sym_template_string] = STATE(3697),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3697),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3697),
    [sym_class] = STATE(3697),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7537),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7537),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7539),
    [sym_true] = ACTIONS(7537),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7537),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2977] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(7541),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [2978] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(7541),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [2979] = {
    [anon_sym_EQ_GT] = ACTIONS(7544),
    [sym_comment] = ACTIONS(3),
  },
  [2980] = {
    [anon_sym_EQ_GT] = ACTIONS(7546),
    [sym_comment] = ACTIONS(3),
  },
  [2981] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [2982] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [2983] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(6131),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [2984] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2985] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2986] = {
    [sym_call_signature] = STATE(2979),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(6147),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(6149),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(6149),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(6149),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(6149),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(6149),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(6149),
    [anon_sym_type] = ACTIONS(6149),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(6149),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(6149),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(6149),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(6149),
    [anon_sym_declare] = ACTIONS(6149),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(6149),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(6149),
    [anon_sym_async] = ACTIONS(6149),
    [anon_sym_public] = ACTIONS(6149),
    [anon_sym_EQ_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(6149),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(6149),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2987] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [2988] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [2989] = {
    [sym_new_expression] = STATE(3700),
    [sym_augmented_assignment_expression] = STATE(3700),
    [sym_unary_expression] = STATE(3700),
    [sym_update_expression] = STATE(3700),
    [sym_regex] = STATE(3700),
    [sym_meta_property] = STATE(3700),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3700),
    [sym_yield_expression] = STATE(3700),
    [sym_as_expression] = STATE(3700),
    [sym_non_null_expression] = STATE(3700),
    [sym_internal_module] = STATE(3700),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3700),
    [sym_await_expression] = STATE(3700),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3700),
    [sym_this] = STATE(3700),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3700),
    [sym_generator_function] = STATE(3700),
    [sym_call_expression] = STATE(3700),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3700),
    [sym_ternary_expression] = STATE(3700),
    [sym_binary_expression] = STATE(3700),
    [sym_template_string] = STATE(3700),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3700),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3700),
    [sym_class] = STATE(3700),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7548),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7548),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7550),
    [sym_true] = ACTIONS(7548),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7548),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2990] = {
    [sym_new_expression] = STATE(3701),
    [sym_augmented_assignment_expression] = STATE(3701),
    [sym_unary_expression] = STATE(3701),
    [sym_update_expression] = STATE(3701),
    [sym_regex] = STATE(3701),
    [sym_meta_property] = STATE(3701),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3701),
    [sym_yield_expression] = STATE(3701),
    [sym_as_expression] = STATE(3701),
    [sym_non_null_expression] = STATE(3701),
    [sym_internal_module] = STATE(3701),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3701),
    [sym_await_expression] = STATE(3701),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3701),
    [sym_this] = STATE(3701),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3701),
    [sym_generator_function] = STATE(3701),
    [sym_call_expression] = STATE(3701),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3701),
    [sym_ternary_expression] = STATE(3701),
    [sym_binary_expression] = STATE(3701),
    [sym_template_string] = STATE(3701),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3701),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3701),
    [sym_class] = STATE(3701),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7552),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7552),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7554),
    [sym_true] = ACTIONS(7552),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7552),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2991] = {
    [sym_new_expression] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(3702),
    [sym_unary_expression] = STATE(3702),
    [sym_update_expression] = STATE(3702),
    [sym_regex] = STATE(3702),
    [sym_meta_property] = STATE(3702),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3702),
    [sym_yield_expression] = STATE(3702),
    [sym_as_expression] = STATE(3702),
    [sym_non_null_expression] = STATE(3702),
    [sym_internal_module] = STATE(3702),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3702),
    [sym_await_expression] = STATE(3702),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3702),
    [sym_this] = STATE(3702),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3702),
    [sym_generator_function] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3702),
    [sym_ternary_expression] = STATE(3702),
    [sym_binary_expression] = STATE(3702),
    [sym_template_string] = STATE(3702),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3702),
    [sym_class] = STATE(3702),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7556),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7556),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7558),
    [sym_true] = ACTIONS(7556),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7556),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2992] = {
    [sym_new_expression] = STATE(3703),
    [sym_augmented_assignment_expression] = STATE(3703),
    [sym_unary_expression] = STATE(3703),
    [sym_update_expression] = STATE(3703),
    [sym_regex] = STATE(3703),
    [sym_meta_property] = STATE(3703),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3703),
    [sym_yield_expression] = STATE(3703),
    [sym_as_expression] = STATE(3703),
    [sym_non_null_expression] = STATE(3703),
    [sym_internal_module] = STATE(3703),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3703),
    [sym_await_expression] = STATE(3703),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3703),
    [sym_this] = STATE(3703),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3703),
    [sym_generator_function] = STATE(3703),
    [sym_call_expression] = STATE(3703),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3703),
    [sym_ternary_expression] = STATE(3703),
    [sym_binary_expression] = STATE(3703),
    [sym_template_string] = STATE(3703),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3703),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3703),
    [sym_class] = STATE(3703),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7560),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7562),
    [sym_true] = ACTIONS(7560),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7560),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2993] = {
    [sym_new_expression] = STATE(3704),
    [sym_augmented_assignment_expression] = STATE(3704),
    [sym_unary_expression] = STATE(3704),
    [sym_update_expression] = STATE(3704),
    [sym_regex] = STATE(3704),
    [sym_meta_property] = STATE(3704),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(3704),
    [sym_yield_expression] = STATE(3704),
    [sym_as_expression] = STATE(3704),
    [sym_non_null_expression] = STATE(3704),
    [sym_internal_module] = STATE(3704),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3704),
    [sym_await_expression] = STATE(3704),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(3704),
    [sym_this] = STATE(3704),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(3704),
    [sym_generator_function] = STATE(3704),
    [sym_call_expression] = STATE(3704),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(3704),
    [sym_ternary_expression] = STATE(3704),
    [sym_binary_expression] = STATE(3704),
    [sym_template_string] = STATE(3704),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3704),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(3704),
    [sym_class] = STATE(3704),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(7564),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7564),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7566),
    [sym_true] = ACTIONS(7564),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7564),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [2994] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(7570),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [2995] = {
    [sym_new_expression] = STATE(3693),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(3693),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3693),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3693),
    [sym_call_signature] = STATE(2107),
    [sym_yield_expression] = STATE(3693),
    [sym_as_expression] = STATE(3693),
    [sym_internal_module] = STATE(3693),
    [sym_arrow_function] = STATE(3693),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(2109),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1738),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(2110),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(3693),
    [sym_subscript_expression] = STATE(2109),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3693),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3693),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3693),
    [sym_meta_property] = STATE(3693),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(3693),
    [sym_non_null_expression] = STATE(3693),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(3693),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3693),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(3693),
    [sym_call_expression] = STATE(3693),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3693),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3693),
    [sym_type_arguments] = STATE(2111),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(3693),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3693),
    [sym_class] = STATE(3693),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(7578),
    [sym_false] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(7580),
    [anon_sym_number] = ACTIONS(7580),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(7582),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(7584),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(7586),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(7521),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(7580),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(7580),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(3597),
    [sym_number] = ACTIONS(3599),
    [sym_true] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(7580),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7521),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(7588),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(7584),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2996] = {
    [sym_type_alias_declaration] = STATE(3719),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3719),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3719),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3719),
    [sym_return_statement] = STATE(3719),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3719),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3719),
    [sym_switch_statement] = STATE(3719),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3719),
    [sym_throw_statement] = STATE(3719),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3719),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3719),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(3719),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3719),
    [sym_abstract_class] = STATE(3719),
    [sym_interface_declaration] = STATE(3719),
    [sym_statement_block] = STATE(3719),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3719),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3719),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3719),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3719),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3719),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3719),
    [sym_empty_statement] = STATE(3719),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(3719),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3719),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3719),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3719),
    [sym_break_statement] = STATE(3719),
    [sym_labeled_statement] = STATE(3719),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3719),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2997] = {
    [sym_new_expression] = STATE(3720),
    [sym_augmented_assignment_expression] = STATE(3720),
    [sym_unary_expression] = STATE(3720),
    [sym_update_expression] = STATE(3720),
    [sym_regex] = STATE(3720),
    [sym_meta_property] = STATE(3720),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3720),
    [sym_yield_expression] = STATE(3720),
    [sym_as_expression] = STATE(3720),
    [sym_non_null_expression] = STATE(3720),
    [sym_internal_module] = STATE(3720),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3720),
    [sym_await_expression] = STATE(3720),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3720),
    [sym_this] = STATE(3720),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3720),
    [sym_generator_function] = STATE(3720),
    [sym_call_expression] = STATE(3720),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3720),
    [sym_ternary_expression] = STATE(3720),
    [sym_binary_expression] = STATE(3720),
    [sym_template_string] = STATE(3720),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3720),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3720),
    [sym_class] = STATE(3720),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7590),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7590),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7592),
    [sym_true] = ACTIONS(7590),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7590),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [2998] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(7594),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [2999] = {
    [anon_sym_RPAREN] = ACTIONS(7594),
    [sym_comment] = ACTIONS(3),
  },
  [3000] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(7596),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3001] = {
    [anon_sym_RPAREN] = ACTIONS(7596),
    [sym_comment] = ACTIONS(3),
  },
  [3002] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(7598),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3003] = {
    [anon_sym_RPAREN] = ACTIONS(7598),
    [sym_comment] = ACTIONS(3),
  },
  [3004] = {
    [sym_identifier] = ACTIONS(7600),
    [anon_sym_BQUOTE] = ACTIONS(7602),
    [anon_sym_debugger] = ACTIONS(7600),
    [anon_sym_symbol] = ACTIONS(7600),
    [anon_sym_AT] = ACTIONS(7602),
    [anon_sym_DASH] = ACTIONS(7600),
    [anon_sym_void] = ACTIONS(7600),
    [anon_sym_break] = ACTIONS(7600),
    [anon_sym_const] = ACTIONS(7600),
    [sym_super] = ACTIONS(7600),
    [anon_sym_return] = ACTIONS(7600),
    [anon_sym_private] = ACTIONS(7600),
    [anon_sym_get] = ACTIONS(7600),
    [anon_sym_RBRACE] = ACTIONS(7602),
    [anon_sym_interface] = ACTIONS(7600),
    [anon_sym_default] = ACTIONS(7600),
    [anon_sym_enum] = ACTIONS(7600),
    [anon_sym_delete] = ACTIONS(7600),
    [anon_sym_continue] = ACTIONS(7600),
    [anon_sym_DASH_DASH] = ACTIONS(7602),
    [anon_sym_if] = ACTIONS(7600),
    [anon_sym_this] = ACTIONS(7600),
    [anon_sym_yield] = ACTIONS(7600),
    [sym_true] = ACTIONS(7600),
    [anon_sym_throw] = ACTIONS(7600),
    [anon_sym_protected] = ACTIONS(7600),
    [anon_sym_abstract] = ACTIONS(7600),
    [anon_sym_set] = ACTIONS(7600),
    [anon_sym_type] = ACTIONS(7600),
    [anon_sym_import] = ACTIONS(7600),
    [anon_sym_namespace] = ACTIONS(7600),
    [anon_sym_PLUS_PLUS] = ACTIONS(7602),
    [anon_sym_await] = ACTIONS(7600),
    [anon_sym_DQUOTE] = ACTIONS(7602),
    [anon_sym_else] = ACTIONS(7600),
    [anon_sym_BANG] = ACTIONS(7602),
    [anon_sym_for] = ACTIONS(7600),
    [anon_sym_LBRACK] = ACTIONS(7602),
    [sym_false] = ACTIONS(7600),
    [anon_sym_SEMI] = ACTIONS(7602),
    [anon_sym_case] = ACTIONS(7600),
    [anon_sym_module] = ACTIONS(7600),
    [anon_sym_number] = ACTIONS(7600),
    [anon_sym_class] = ACTIONS(7600),
    [anon_sym_declare] = ACTIONS(7600),
    [anon_sym_typeof] = ACTIONS(7600),
    [anon_sym_LBRACE] = ACTIONS(7602),
    [anon_sym_switch] = ACTIONS(7600),
    [anon_sym_LPAREN] = ACTIONS(7602),
    [sym_null] = ACTIONS(7600),
    [anon_sym_any] = ACTIONS(7600),
    [anon_sym_boolean] = ACTIONS(7600),
    [anon_sym_async] = ACTIONS(7600),
    [anon_sym_public] = ACTIONS(7600),
    [anon_sym_var] = ACTIONS(7600),
    [anon_sym_while] = ACTIONS(7600),
    [anon_sym_SQUOTE] = ACTIONS(7602),
    [anon_sym_try] = ACTIONS(7600),
    [anon_sym_LT] = ACTIONS(7602),
    [sym_number] = ACTIONS(7602),
    [anon_sym_SLASH] = ACTIONS(7600),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7600),
    [anon_sym_function] = ACTIONS(7600),
    [sym_undefined] = ACTIONS(7600),
    [anon_sym_new] = ACTIONS(7600),
    [ts_builtin_sym_end] = ACTIONS(7602),
    [anon_sym_let] = ACTIONS(7600),
    [anon_sym_PLUS] = ACTIONS(7600),
    [anon_sym_export] = ACTIONS(7600),
    [anon_sym_do] = ACTIONS(7600),
    [anon_sym_TILDE] = ACTIONS(7602),
    [anon_sym_with] = ACTIONS(7600),
  },
  [3005] = {
    [sym_type_alias_declaration] = STATE(3724),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3724),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3724),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3724),
    [sym_return_statement] = STATE(3724),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3724),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3724),
    [sym_switch_statement] = STATE(3724),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3724),
    [sym_throw_statement] = STATE(3724),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3724),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3724),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(3724),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3724),
    [sym_abstract_class] = STATE(3724),
    [sym_interface_declaration] = STATE(3724),
    [sym_statement_block] = STATE(3724),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3724),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3724),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3724),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3724),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3724),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3724),
    [sym_empty_statement] = STATE(3724),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(3724),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3724),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3724),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3724),
    [sym_break_statement] = STATE(3724),
    [sym_labeled_statement] = STATE(3724),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3724),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3006] = {
    [sym_type_alias_declaration] = STATE(3725),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3725),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3725),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3725),
    [sym_return_statement] = STATE(3725),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3725),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3725),
    [sym_switch_statement] = STATE(3725),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3725),
    [sym_throw_statement] = STATE(3725),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3725),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3725),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(3725),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3725),
    [sym_abstract_class] = STATE(3725),
    [sym_interface_declaration] = STATE(3725),
    [sym_statement_block] = STATE(3725),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3725),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3725),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3725),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3725),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3725),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3725),
    [sym_empty_statement] = STATE(3725),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(3725),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3725),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3725),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3725),
    [sym_break_statement] = STATE(3725),
    [sym_labeled_statement] = STATE(3725),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3725),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3007] = {
    [sym_type_alias_declaration] = STATE(3726),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3726),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3726),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3726),
    [sym_return_statement] = STATE(3726),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3726),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3726),
    [sym_switch_statement] = STATE(3726),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3726),
    [sym_throw_statement] = STATE(3726),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3726),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3726),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(3726),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3726),
    [sym_abstract_class] = STATE(3726),
    [sym_interface_declaration] = STATE(3726),
    [sym_statement_block] = STATE(3726),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3726),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3726),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3726),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3726),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3726),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3726),
    [sym_empty_statement] = STATE(3726),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(3726),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3726),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3726),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3726),
    [sym_break_statement] = STATE(3726),
    [sym_labeled_statement] = STATE(3726),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3726),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3008] = {
    [sym_type_alias_declaration] = STATE(3727),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3727),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3727),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3727),
    [sym_return_statement] = STATE(3727),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3727),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3727),
    [sym_switch_statement] = STATE(3727),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3727),
    [sym_throw_statement] = STATE(3727),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3727),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3727),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(3727),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3727),
    [sym_abstract_class] = STATE(3727),
    [sym_interface_declaration] = STATE(3727),
    [sym_statement_block] = STATE(3727),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3727),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3727),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3727),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3727),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3727),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3727),
    [sym_empty_statement] = STATE(3727),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(3727),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3727),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3727),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3727),
    [sym_break_statement] = STATE(3727),
    [sym_labeled_statement] = STATE(3727),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3727),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3009] = {
    [sym_type_alias_declaration] = STATE(3728),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3728),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3728),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3728),
    [sym_return_statement] = STATE(3728),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3728),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3728),
    [sym_switch_statement] = STATE(3728),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3728),
    [sym_throw_statement] = STATE(3728),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3728),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3728),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(3728),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3728),
    [sym_abstract_class] = STATE(3728),
    [sym_interface_declaration] = STATE(3728),
    [sym_statement_block] = STATE(3728),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3728),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3728),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3728),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3728),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3728),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3728),
    [sym_empty_statement] = STATE(3728),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(3728),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3728),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3728),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3728),
    [sym_break_statement] = STATE(3728),
    [sym_labeled_statement] = STATE(3728),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3728),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3010] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_GT_GT_GT] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [anon_sym_RBRACK] = ACTIONS(2972),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_GT] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_as] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2970),
    [anon_sym_instanceof] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2970),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_SLASH] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2972),
    [anon_sym_CARET] = ACTIONS(2972),
    [anon_sym_STAR_STAR] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_implements] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2970),
  },
  [3011] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6303),
    [anon_sym_LBRACK] = ACTIONS(6303),
    [anon_sym_BANG] = ACTIONS(6305),
    [anon_sym_BQUOTE] = ACTIONS(6303),
    [anon_sym_else] = ACTIONS(6303),
    [anon_sym_PIPE] = ACTIONS(6305),
    [anon_sym_COMMA] = ACTIONS(6303),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_STAR] = ACTIONS(6305),
    [anon_sym_GT_GT_GT] = ACTIONS(6303),
    [anon_sym_AMP_AMP] = ACTIONS(6303),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_LBRACE] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6305),
    [anon_sym_LT_EQ] = ACTIONS(6303),
    [anon_sym_LPAREN] = ACTIONS(6303),
    [anon_sym_RBRACK] = ACTIONS(6303),
    [anon_sym_GT_EQ] = ACTIONS(6303),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_AMP] = ACTIONS(6305),
    [anon_sym_PERCENT] = ACTIONS(6303),
    [anon_sym_QMARK] = ACTIONS(6303),
    [anon_sym_RBRACE] = ACTIONS(6303),
    [anon_sym_as] = ACTIONS(6303),
    [anon_sym_PIPE_PIPE] = ACTIONS(6303),
    [anon_sym_while] = ACTIONS(6303),
    [anon_sym_DASH_DASH] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_instanceof] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_RPAREN] = ACTIONS(6303),
    [anon_sym_SLASH] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6303),
    [anon_sym_COLON] = ACTIONS(6303),
    [anon_sym_DOT] = ACTIONS(6303),
    [anon_sym_CARET] = ACTIONS(6303),
    [anon_sym_STAR_STAR] = ACTIONS(6303),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_implements] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6305),
    [anon_sym_PLUS_PLUS] = ACTIONS(6303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6303),
    [anon_sym_in] = ACTIONS(6305),
  },
  [3012] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6783),
    [anon_sym_LBRACK] = ACTIONS(6783),
    [anon_sym_BANG] = ACTIONS(6785),
    [anon_sym_BQUOTE] = ACTIONS(6783),
    [anon_sym_else] = ACTIONS(6783),
    [anon_sym_PIPE] = ACTIONS(6785),
    [anon_sym_COMMA] = ACTIONS(6783),
    [anon_sym_LT_LT] = ACTIONS(6783),
    [anon_sym_STAR] = ACTIONS(6785),
    [anon_sym_GT_GT_GT] = ACTIONS(6783),
    [anon_sym_AMP_AMP] = ACTIONS(6783),
    [anon_sym_DASH] = ACTIONS(6785),
    [anon_sym_LBRACE] = ACTIONS(6785),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6783),
    [anon_sym_LPAREN] = ACTIONS(6783),
    [anon_sym_RBRACK] = ACTIONS(6783),
    [anon_sym_GT_EQ] = ACTIONS(6783),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6785),
    [anon_sym_PERCENT] = ACTIONS(6783),
    [anon_sym_QMARK] = ACTIONS(6783),
    [anon_sym_RBRACE] = ACTIONS(6783),
    [anon_sym_as] = ACTIONS(6783),
    [anon_sym_PIPE_PIPE] = ACTIONS(6783),
    [anon_sym_while] = ACTIONS(6783),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6783),
    [anon_sym_LT] = ACTIONS(6785),
    [anon_sym_RPAREN] = ACTIONS(6783),
    [anon_sym_SLASH] = ACTIONS(6785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6783),
    [anon_sym_COLON] = ACTIONS(6783),
    [anon_sym_DOT] = ACTIONS(6783),
    [anon_sym_CARET] = ACTIONS(6783),
    [anon_sym_STAR_STAR] = ACTIONS(6783),
    [anon_sym_PLUS] = ACTIONS(6785),
    [anon_sym_implements] = ACTIONS(6783),
    [anon_sym_GT_GT] = ACTIONS(6785),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6783),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3013] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7008),
    [anon_sym_LBRACK] = ACTIONS(7008),
    [anon_sym_BANG] = ACTIONS(7010),
    [anon_sym_BQUOTE] = ACTIONS(7008),
    [anon_sym_else] = ACTIONS(7008),
    [anon_sym_PIPE] = ACTIONS(7010),
    [anon_sym_COMMA] = ACTIONS(7008),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_STAR] = ACTIONS(7010),
    [anon_sym_GT_GT_GT] = ACTIONS(7008),
    [anon_sym_AMP_AMP] = ACTIONS(7008),
    [anon_sym_DASH] = ACTIONS(7010),
    [anon_sym_LBRACE] = ACTIONS(7010),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(7008),
    [anon_sym_LPAREN] = ACTIONS(7008),
    [anon_sym_RBRACK] = ACTIONS(7008),
    [anon_sym_GT_EQ] = ACTIONS(7008),
    [anon_sym_GT] = ACTIONS(7010),
    [anon_sym_AMP] = ACTIONS(7010),
    [anon_sym_PERCENT] = ACTIONS(7008),
    [anon_sym_QMARK] = ACTIONS(7008),
    [anon_sym_RBRACE] = ACTIONS(7008),
    [anon_sym_as] = ACTIONS(7008),
    [anon_sym_PIPE_PIPE] = ACTIONS(7008),
    [anon_sym_while] = ACTIONS(7008),
    [anon_sym_DASH_DASH] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7010),
    [anon_sym_instanceof] = ACTIONS(7008),
    [anon_sym_LT] = ACTIONS(7010),
    [anon_sym_RPAREN] = ACTIONS(7008),
    [anon_sym_SLASH] = ACTIONS(7010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7008),
    [anon_sym_COLON] = ACTIONS(7008),
    [anon_sym_DOT] = ACTIONS(7008),
    [anon_sym_CARET] = ACTIONS(7008),
    [anon_sym_STAR_STAR] = ACTIONS(7008),
    [anon_sym_PLUS] = ACTIONS(7010),
    [anon_sym_implements] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7010),
    [anon_sym_PLUS_PLUS] = ACTIONS(7008),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7008),
    [anon_sym_in] = ACTIONS(7010),
  },
  [3014] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_LT_LT] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_GT_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(7180),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_as] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(937),
  },
  [3015] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(7604),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_RBRACK] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(7606),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [3016] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(7608),
    [sym_comment] = ACTIONS(3),
  },
  [3017] = {
    [aux_sym_implements_clause_repeat1] = STATE(3732),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(7612),
    [sym_comment] = ACTIONS(3),
  },
  [3018] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_BANG] = ACTIONS(5192),
    [anon_sym_BQUOTE] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_LT_LT] = ACTIONS(5194),
    [anon_sym_STAR] = ACTIONS(5192),
    [anon_sym_GT_GT_GT] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5192),
    [anon_sym_BANG_EQ] = ACTIONS(5192),
    [anon_sym_LT_EQ] = ACTIONS(5194),
    [anon_sym_LPAREN] = ACTIONS(5194),
    [anon_sym_RBRACK] = ACTIONS(5194),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5194),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_as] = ACTIONS(5194),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5194),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_EQ_EQ] = ACTIONS(5192),
    [anon_sym_instanceof] = ACTIONS(5194),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_SLASH] = ACTIONS(5192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(7194),
    [anon_sym_CARET] = ACTIONS(5194),
    [anon_sym_STAR_STAR] = ACTIONS(5194),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_implements] = ACTIONS(5194),
    [anon_sym_GT_GT] = ACTIONS(5192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5194),
    [anon_sym_in] = ACTIONS(5192),
  },
  [3019] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(7604),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_RBRACK] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(7606),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [3020] = {
    [aux_sym_object_type_repeat1] = STATE(3735),
    [sym__automatic_semicolon] = ACTIONS(7614),
    [anon_sym_RBRACE] = ACTIONS(7616),
    [anon_sym_SEMI] = ACTIONS(7614),
    [anon_sym_COMMA] = ACTIONS(7614),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7616),
    [sym_comment] = ACTIONS(3),
  },
  [3021] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(7616),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7616),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [3022] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5294),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_BANG] = ACTIONS(5292),
    [anon_sym_BQUOTE] = ACTIONS(5294),
    [anon_sym_PIPE] = ACTIONS(5292),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LT_LT] = ACTIONS(5294),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_GT_GT_GT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_DASH] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5292),
    [anon_sym_BANG_EQ] = ACTIONS(5292),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RBRACK] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_GT] = ACTIONS(5292),
    [anon_sym_AMP] = ACTIONS(5292),
    [anon_sym_PERCENT] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_EQ_EQ] = ACTIONS(5292),
    [anon_sym_instanceof] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5292),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_SLASH] = ACTIONS(5292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5294),
    [anon_sym_CARET] = ACTIONS(5294),
    [anon_sym_STAR_STAR] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5292),
    [anon_sym_implements] = ACTIONS(5294),
    [anon_sym_GT_GT] = ACTIONS(5292),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5294),
    [anon_sym_in] = ACTIONS(5292),
  },
  [3023] = {
    [aux_sym_object_type_repeat1] = STATE(2544),
    [sym__automatic_semicolon] = ACTIONS(7614),
    [anon_sym_RBRACE] = ACTIONS(7616),
    [anon_sym_SEMI] = ACTIONS(7614),
    [anon_sym_COMMA] = ACTIONS(7614),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7616),
    [sym_comment] = ACTIONS(3),
  },
  [3024] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5306),
    [anon_sym_LBRACK] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5304),
    [anon_sym_BQUOTE] = ACTIONS(5306),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_COMMA] = ACTIONS(5306),
    [anon_sym_LT_LT] = ACTIONS(5306),
    [anon_sym_STAR] = ACTIONS(5304),
    [anon_sym_GT_GT_GT] = ACTIONS(5306),
    [anon_sym_AMP_AMP] = ACTIONS(5306),
    [anon_sym_DASH] = ACTIONS(5304),
    [anon_sym_LBRACE] = ACTIONS(5304),
    [anon_sym_BANG_EQ] = ACTIONS(5304),
    [anon_sym_LT_EQ] = ACTIONS(5306),
    [anon_sym_LPAREN] = ACTIONS(5306),
    [anon_sym_RBRACK] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(5306),
    [anon_sym_GT] = ACTIONS(5304),
    [anon_sym_AMP] = ACTIONS(5304),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [anon_sym_QMARK] = ACTIONS(5306),
    [anon_sym_RBRACE] = ACTIONS(5306),
    [anon_sym_as] = ACTIONS(5306),
    [anon_sym_PIPE_PIPE] = ACTIONS(5306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5306),
    [anon_sym_DASH_DASH] = ACTIONS(5306),
    [anon_sym_EQ_EQ] = ACTIONS(5304),
    [anon_sym_instanceof] = ACTIONS(5306),
    [anon_sym_LT] = ACTIONS(5304),
    [anon_sym_RPAREN] = ACTIONS(5306),
    [anon_sym_SLASH] = ACTIONS(5304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5306),
    [anon_sym_DOT] = ACTIONS(5306),
    [anon_sym_CARET] = ACTIONS(5306),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_PLUS] = ACTIONS(5304),
    [anon_sym_implements] = ACTIONS(5306),
    [anon_sym_GT_GT] = ACTIONS(5304),
    [anon_sym_PLUS_PLUS] = ACTIONS(5306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5306),
    [anon_sym_in] = ACTIONS(5304),
  },
  [3025] = {
    [aux_sym_implements_clause_repeat1] = STATE(2557),
    [anon_sym_COMMA] = ACTIONS(3365),
    [anon_sym_RBRACK] = ACTIONS(7618),
    [sym_comment] = ACTIONS(3),
  },
  [3026] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3737),
    [sym_constructor_type] = STATE(3737),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(3737),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3737),
    [sym_intersection_type] = STATE(3737),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3027] = {
    [anon_sym_EQ_GT] = ACTIONS(7620),
    [sym_comment] = ACTIONS(3),
  },
  [3028] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5383),
    [anon_sym_LBRACK] = ACTIONS(5383),
    [anon_sym_BANG] = ACTIONS(5381),
    [anon_sym_BQUOTE] = ACTIONS(5383),
    [anon_sym_PIPE] = ACTIONS(5381),
    [anon_sym_COMMA] = ACTIONS(5383),
    [anon_sym_LT_LT] = ACTIONS(5383),
    [anon_sym_STAR] = ACTIONS(5381),
    [anon_sym_GT_GT_GT] = ACTIONS(5383),
    [anon_sym_AMP_AMP] = ACTIONS(5383),
    [anon_sym_DASH] = ACTIONS(5381),
    [anon_sym_LBRACE] = ACTIONS(5381),
    [anon_sym_BANG_EQ] = ACTIONS(5381),
    [anon_sym_LT_EQ] = ACTIONS(5383),
    [anon_sym_LPAREN] = ACTIONS(5383),
    [anon_sym_RBRACK] = ACTIONS(5383),
    [anon_sym_GT_EQ] = ACTIONS(5383),
    [anon_sym_GT] = ACTIONS(5381),
    [anon_sym_AMP] = ACTIONS(5381),
    [anon_sym_PERCENT] = ACTIONS(5383),
    [anon_sym_QMARK] = ACTIONS(5383),
    [anon_sym_RBRACE] = ACTIONS(5383),
    [anon_sym_as] = ACTIONS(5383),
    [anon_sym_PIPE_PIPE] = ACTIONS(5383),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5383),
    [anon_sym_DASH_DASH] = ACTIONS(5383),
    [anon_sym_EQ_EQ] = ACTIONS(5381),
    [anon_sym_instanceof] = ACTIONS(5383),
    [anon_sym_LT] = ACTIONS(5381),
    [anon_sym_RPAREN] = ACTIONS(5383),
    [anon_sym_SLASH] = ACTIONS(5381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5383),
    [anon_sym_DOT] = ACTIONS(5383),
    [anon_sym_CARET] = ACTIONS(5383),
    [anon_sym_STAR_STAR] = ACTIONS(5383),
    [anon_sym_PLUS] = ACTIONS(5381),
    [anon_sym_implements] = ACTIONS(5383),
    [anon_sym_GT_GT] = ACTIONS(5381),
    [anon_sym_PLUS_PLUS] = ACTIONS(5383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5383),
    [anon_sym_in] = ACTIONS(5381),
  },
  [3029] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(5387),
    [anon_sym_BQUOTE] = ACTIONS(5389),
    [anon_sym_PIPE] = ACTIONS(5387),
    [anon_sym_COMMA] = ACTIONS(5389),
    [anon_sym_LT_LT] = ACTIONS(5389),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_GT_GT_GT] = ACTIONS(5389),
    [anon_sym_AMP_AMP] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_LBRACE] = ACTIONS(5387),
    [anon_sym_BANG_EQ] = ACTIONS(5387),
    [anon_sym_LT_EQ] = ACTIONS(5389),
    [anon_sym_LPAREN] = ACTIONS(5389),
    [anon_sym_RBRACK] = ACTIONS(5389),
    [anon_sym_GT_EQ] = ACTIONS(5389),
    [anon_sym_GT] = ACTIONS(5387),
    [anon_sym_AMP] = ACTIONS(5387),
    [anon_sym_PERCENT] = ACTIONS(5389),
    [anon_sym_QMARK] = ACTIONS(5389),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_as] = ACTIONS(5389),
    [anon_sym_PIPE_PIPE] = ACTIONS(5389),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5389),
    [anon_sym_DASH_DASH] = ACTIONS(5389),
    [anon_sym_EQ_EQ] = ACTIONS(5387),
    [anon_sym_instanceof] = ACTIONS(5389),
    [anon_sym_LT] = ACTIONS(5387),
    [anon_sym_RPAREN] = ACTIONS(5389),
    [anon_sym_SLASH] = ACTIONS(5387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5389),
    [anon_sym_DOT] = ACTIONS(5389),
    [anon_sym_CARET] = ACTIONS(5389),
    [anon_sym_STAR_STAR] = ACTIONS(5389),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_implements] = ACTIONS(5389),
    [anon_sym_GT_GT] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5389),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5389),
    [anon_sym_in] = ACTIONS(5387),
  },
  [3030] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_BANG] = ACTIONS(5391),
    [anon_sym_BQUOTE] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5391),
    [anon_sym_COMMA] = ACTIONS(5393),
    [anon_sym_LT_LT] = ACTIONS(5393),
    [anon_sym_STAR] = ACTIONS(5391),
    [anon_sym_GT_GT_GT] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5391),
    [anon_sym_LBRACE] = ACTIONS(5391),
    [anon_sym_BANG_EQ] = ACTIONS(5391),
    [anon_sym_LT_EQ] = ACTIONS(5393),
    [anon_sym_LPAREN] = ACTIONS(5393),
    [anon_sym_RBRACK] = ACTIONS(5393),
    [anon_sym_GT_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5391),
    [anon_sym_AMP] = ACTIONS(5391),
    [anon_sym_PERCENT] = ACTIONS(5393),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_as] = ACTIONS(5393),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5393),
    [anon_sym_DASH_DASH] = ACTIONS(5393),
    [anon_sym_EQ_EQ] = ACTIONS(5391),
    [anon_sym_instanceof] = ACTIONS(5393),
    [anon_sym_LT] = ACTIONS(5391),
    [anon_sym_RPAREN] = ACTIONS(5393),
    [anon_sym_SLASH] = ACTIONS(5391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5393),
    [anon_sym_DOT] = ACTIONS(5393),
    [anon_sym_CARET] = ACTIONS(5393),
    [anon_sym_STAR_STAR] = ACTIONS(5393),
    [anon_sym_PLUS] = ACTIONS(5391),
    [anon_sym_implements] = ACTIONS(5393),
    [anon_sym_GT_GT] = ACTIONS(5391),
    [anon_sym_PLUS_PLUS] = ACTIONS(5393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5393),
    [anon_sym_in] = ACTIONS(5391),
  },
  [3031] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3739),
    [sym_constructor_type] = STATE(3739),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(3739),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3739),
    [sym_intersection_type] = STATE(3739),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3032] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(7604),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_RBRACK] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(7606),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [3033] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(7622),
    [sym_comment] = ACTIONS(3),
  },
  [3034] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_BQUOTE] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5421),
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_LT_LT] = ACTIONS(5423),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_GT_GT_GT] = ACTIONS(5423),
    [anon_sym_AMP_AMP] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_LBRACE] = ACTIONS(5421),
    [anon_sym_BANG_EQ] = ACTIONS(5421),
    [anon_sym_LT_EQ] = ACTIONS(5423),
    [anon_sym_LPAREN] = ACTIONS(5423),
    [anon_sym_RBRACK] = ACTIONS(5423),
    [anon_sym_GT_EQ] = ACTIONS(5423),
    [anon_sym_GT] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5421),
    [anon_sym_PERCENT] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_as] = ACTIONS(5423),
    [anon_sym_PIPE_PIPE] = ACTIONS(5423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5423),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_EQ_EQ] = ACTIONS(5421),
    [anon_sym_instanceof] = ACTIONS(5423),
    [anon_sym_LT] = ACTIONS(5421),
    [anon_sym_RPAREN] = ACTIONS(5423),
    [anon_sym_SLASH] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5423),
    [anon_sym_DOT] = ACTIONS(5423),
    [anon_sym_CARET] = ACTIONS(5423),
    [anon_sym_STAR_STAR] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_implements] = ACTIONS(5423),
    [anon_sym_GT_GT] = ACTIONS(5421),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5423),
    [anon_sym_in] = ACTIONS(5421),
  },
  [3035] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(7604),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_RBRACK] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(7606),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [3036] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1005),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1009),
    [anon_sym_symbol] = ACTIONS(1009),
    [anon_sym_number] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1009),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1009),
    [anon_sym_private] = ACTIONS(1009),
    [anon_sym_boolean] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_public] = ACTIONS(1009),
    [anon_sym_get] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1009),
    [anon_sym_string] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1009),
    [anon_sym_namespace] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3037] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6249),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6249),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_implements] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(6252),
  },
  [3038] = {
    [sym_identifier] = ACTIONS(7624),
    [sym_comment] = ACTIONS(3),
  },
  [3039] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7239),
    [anon_sym_LBRACK] = ACTIONS(7239),
    [anon_sym_BANG] = ACTIONS(7241),
    [anon_sym_BQUOTE] = ACTIONS(7239),
    [anon_sym_else] = ACTIONS(7239),
    [anon_sym_PIPE] = ACTIONS(7241),
    [anon_sym_COMMA] = ACTIONS(7239),
    [anon_sym_LT_LT] = ACTIONS(7239),
    [anon_sym_STAR] = ACTIONS(7241),
    [anon_sym_GT_GT_GT] = ACTIONS(7239),
    [anon_sym_AMP_AMP] = ACTIONS(7239),
    [anon_sym_DASH] = ACTIONS(7241),
    [anon_sym_LBRACE] = ACTIONS(7241),
    [anon_sym_BANG_EQ] = ACTIONS(7241),
    [anon_sym_LT_EQ] = ACTIONS(7239),
    [anon_sym_LPAREN] = ACTIONS(7239),
    [anon_sym_RBRACK] = ACTIONS(7239),
    [anon_sym_GT_EQ] = ACTIONS(7239),
    [anon_sym_GT] = ACTIONS(7241),
    [anon_sym_AMP] = ACTIONS(7241),
    [anon_sym_PERCENT] = ACTIONS(7239),
    [anon_sym_QMARK] = ACTIONS(7239),
    [anon_sym_RBRACE] = ACTIONS(7239),
    [anon_sym_as] = ACTIONS(7239),
    [anon_sym_PIPE_PIPE] = ACTIONS(7239),
    [anon_sym_while] = ACTIONS(7239),
    [anon_sym_DASH_DASH] = ACTIONS(7239),
    [anon_sym_EQ_EQ] = ACTIONS(7241),
    [anon_sym_instanceof] = ACTIONS(7239),
    [anon_sym_LT] = ACTIONS(7241),
    [anon_sym_RPAREN] = ACTIONS(7239),
    [anon_sym_SLASH] = ACTIONS(7241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7239),
    [anon_sym_COLON] = ACTIONS(7239),
    [anon_sym_DOT] = ACTIONS(7239),
    [anon_sym_CARET] = ACTIONS(7239),
    [anon_sym_STAR_STAR] = ACTIONS(7239),
    [anon_sym_PLUS] = ACTIONS(7241),
    [anon_sym_implements] = ACTIONS(7239),
    [anon_sym_GT_GT] = ACTIONS(7241),
    [anon_sym_PLUS_PLUS] = ACTIONS(7239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7239),
    [anon_sym_in] = ACTIONS(7241),
  },
  [3040] = {
    [sym_class_body] = STATE(3742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [3041] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(5130),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(5130),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [3042] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(5134),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(5134),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [3043] = {
    [sym_new_expression] = STATE(3743),
    [sym_augmented_assignment_expression] = STATE(3743),
    [sym_unary_expression] = STATE(3743),
    [sym_update_expression] = STATE(3743),
    [sym_regex] = STATE(3743),
    [sym_meta_property] = STATE(3743),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(3743),
    [sym_yield_expression] = STATE(3743),
    [sym_as_expression] = STATE(3743),
    [sym_non_null_expression] = STATE(3743),
    [sym_internal_module] = STATE(3743),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3743),
    [sym_await_expression] = STATE(3743),
    [sym_member_expression] = STATE(600),
    [sym_string] = STATE(3743),
    [sym_this] = STATE(3743),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(601),
    [sym_anonymous_class] = STATE(3743),
    [sym_generator_function] = STATE(3743),
    [sym_call_expression] = STATE(3743),
    [sym_subscript_expression] = STATE(600),
    [sym_assignment_expression] = STATE(3743),
    [sym_ternary_expression] = STATE(3743),
    [sym_binary_expression] = STATE(3743),
    [sym_template_string] = STATE(3743),
    [sym_type_arguments] = STATE(603),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3743),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(3743),
    [sym_class] = STATE(3743),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(2669),
    [sym_false] = ACTIONS(7626),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7626),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7628),
    [sym_true] = ACTIONS(7626),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7626),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [3044] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3744),
    [sym_constructor_type] = STATE(3744),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(3744),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3744),
    [sym_intersection_type] = STATE(3744),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3045] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3745),
    [sym_constructor_type] = STATE(3745),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(3745),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3745),
    [sym_intersection_type] = STATE(3745),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3046] = {
    [anon_sym_EQ_GT] = ACTIONS(7630),
    [sym_comment] = ACTIONS(3),
  },
  [3047] = {
    [sym_formal_parameters] = STATE(3747),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3048] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3049] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3050] = {
    [anon_sym_EQ_GT] = ACTIONS(7632),
    [sym_comment] = ACTIONS(3),
  },
  [3051] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3749),
    [sym_constructor_type] = STATE(3749),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(3749),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3749),
    [sym_intersection_type] = STATE(3749),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3052] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3750),
    [sym_constructor_type] = STATE(3750),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(3750),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3750),
    [sym_intersection_type] = STATE(3750),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3053] = {
    [sym_new_expression] = STATE(2196),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(2196),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(2196),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(2196),
    [sym_call_signature] = STATE(598),
    [sym_yield_expression] = STATE(2196),
    [sym_as_expression] = STATE(2196),
    [sym_internal_module] = STATE(2196),
    [sym_arrow_function] = STATE(2196),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(600),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(601),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(2196),
    [sym_subscript_expression] = STATE(600),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(2196),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(2196),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(2196),
    [sym_meta_property] = STATE(2196),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(2196),
    [sym_non_null_expression] = STATE(2196),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(2196),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(2196),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(2196),
    [sym_call_expression] = STATE(2196),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(2196),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(2196),
    [sym_type_arguments] = STATE(603),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(2196),
    [sym_array] = STATE(604),
    [sym_type_assertion] = STATE(2196),
    [sym_class] = STATE(2196),
    [anon_sym_BANG] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(4627),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(4629),
    [anon_sym_number] = ACTIONS(4629),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(4631),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4633),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(4635),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(4562),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4629),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(4629),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(4629),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4562),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_new] = ACTIONS(7634),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(4633),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
  },
  [3054] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2650),
    [anon_sym_AMP_EQ] = ACTIONS(2650),
    [anon_sym_PLUS_EQ] = ACTIONS(2650),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(2650),
    [anon_sym_STAR_EQ] = ACTIONS(2650),
    [anon_sym_PIPE_EQ] = ACTIONS(2650),
    [anon_sym_DASH_EQ] = ACTIONS(2650),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2650),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2650),
    [anon_sym_GT_GT_EQ] = ACTIONS(2650),
    [anon_sym_DOT] = ACTIONS(6247),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2663),
  },
  [3055] = {
    [anon_sym_EQ_GT] = ACTIONS(7636),
    [sym_comment] = ACTIONS(3),
  },
  [3056] = {
    [sym_formal_parameters] = STATE(3753),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3057] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3058] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3059] = {
    [anon_sym_EQ_GT] = ACTIONS(7638),
    [sym_comment] = ACTIONS(3),
  },
  [3060] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3755),
    [sym_constructor_type] = STATE(3755),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(3755),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3755),
    [sym_intersection_type] = STATE(3755),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3061] = {
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6909),
  },
  [3062] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3756),
    [sym_constructor_type] = STATE(3756),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(3756),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3756),
    [sym_intersection_type] = STATE(3756),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(612),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(614),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3063] = {
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6986),
  },
  [3064] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2045),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3065] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_AMP_EQ] = ACTIONS(4661),
    [anon_sym_PLUS_EQ] = ACTIONS(4661),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_is] = ACTIONS(5178),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3884),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_DASH_EQ] = ACTIONS(4661),
    [anon_sym_EQ_GT] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4661),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(5314),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7640),
  },
  [3066] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(3897),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3067] = {
    [sym_new_expression] = STATE(2252),
    [sym_augmented_assignment_expression] = STATE(2252),
    [sym_unary_expression] = STATE(2252),
    [sym_update_expression] = STATE(2252),
    [sym_regex] = STATE(2252),
    [sym_meta_property] = STATE(2252),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2252),
    [sym_yield_expression] = STATE(2252),
    [sym_as_expression] = STATE(2252),
    [sym_non_null_expression] = STATE(2252),
    [sym_internal_module] = STATE(2252),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2252),
    [sym_await_expression] = STATE(2252),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2252),
    [sym_this] = STATE(2252),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2252),
    [sym_generator_function] = STATE(2252),
    [sym_call_expression] = STATE(2252),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2252),
    [sym_ternary_expression] = STATE(2252),
    [sym_binary_expression] = STATE(2252),
    [sym_template_string] = STATE(2252),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2252),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2252),
    [sym_class] = STATE(2252),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(7642),
    [sym_false] = ACTIONS(4679),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4679),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4681),
    [sym_true] = ACTIONS(4679),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4679),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [3068] = {
    [sym_new_expression] = STATE(2253),
    [sym_augmented_assignment_expression] = STATE(2253),
    [sym_unary_expression] = STATE(2253),
    [sym_update_expression] = STATE(2253),
    [sym_regex] = STATE(2253),
    [sym_meta_property] = STATE(2253),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2253),
    [sym_yield_expression] = STATE(2253),
    [sym_as_expression] = STATE(2253),
    [sym_non_null_expression] = STATE(2253),
    [sym_internal_module] = STATE(2253),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2253),
    [sym_await_expression] = STATE(2253),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2253),
    [sym_this] = STATE(2253),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2253),
    [sym_generator_function] = STATE(2253),
    [sym_call_expression] = STATE(2253),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2253),
    [sym_ternary_expression] = STATE(2253),
    [sym_binary_expression] = STATE(2253),
    [sym_template_string] = STATE(2253),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2253),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2253),
    [sym_class] = STATE(2253),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4683),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5318),
    [sym_true] = ACTIONS(4683),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4683),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [3069] = {
    [sym_new_expression] = STATE(2252),
    [sym_augmented_assignment_expression] = STATE(2252),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(2252),
    [sym_update_expression] = STATE(2252),
    [sym_regex] = STATE(2252),
    [sym_meta_property] = STATE(2252),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2252),
    [sym_yield_expression] = STATE(2252),
    [sym_as_expression] = STATE(2252),
    [sym_non_null_expression] = STATE(2252),
    [sym_internal_module] = STATE(2252),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2252),
    [sym_await_expression] = STATE(2252),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2252),
    [sym_this] = STATE(2252),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2252),
    [sym_generator_function] = STATE(2252),
    [sym_call_expression] = STATE(2252),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2252),
    [sym_ternary_expression] = STATE(2252),
    [sym_binary_expression] = STATE(2252),
    [sym_template_string] = STATE(2252),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2252),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2252),
    [sym_class] = STATE(2252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(2779),
    [sym_true] = ACTIONS(4679),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4679),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(3897),
    [sym_null] = ACTIONS(4679),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4681),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4679),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3070] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3759),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3760),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4699),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4701),
    [anon_sym_symbol] = ACTIONS(4701),
    [anon_sym_number] = ACTIONS(4701),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4701),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4701),
    [anon_sym_private] = ACTIONS(4701),
    [anon_sym_boolean] = ACTIONS(4701),
    [anon_sym_async] = ACTIONS(4705),
    [anon_sym_public] = ACTIONS(4701),
    [anon_sym_get] = ACTIONS(4701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4701),
    [anon_sym_string] = ACTIONS(4701),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(4701),
    [anon_sym_type] = ACTIONS(4701),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(4701),
    [anon_sym_export] = ACTIONS(4701),
    [anon_sym_namespace] = ACTIONS(4707),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3071] = {
    [sym_formal_parameters] = STATE(3761),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3072] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(7644),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [3073] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
  },
  [3074] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3075] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3076] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2055),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3077] = {
    [anon_sym_RBRACK] = ACTIONS(7647),
    [sym_comment] = ACTIONS(3),
  },
  [3078] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2063),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(6252),
  },
  [3079] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2151),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3080] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2155),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3081] = {
    [anon_sym_RBRACK] = ACTIONS(7649),
    [sym_comment] = ACTIONS(3),
  },
  [3082] = {
    [sym_new_expression] = STATE(3764),
    [sym_augmented_assignment_expression] = STATE(3764),
    [sym_unary_expression] = STATE(3764),
    [sym_update_expression] = STATE(3764),
    [sym_regex] = STATE(3764),
    [sym_meta_property] = STATE(3764),
    [sym_call_signature] = STATE(1340),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(3764),
    [sym_yield_expression] = STATE(3764),
    [sym_as_expression] = STATE(3764),
    [sym_non_null_expression] = STATE(3764),
    [sym_internal_module] = STATE(3764),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3764),
    [sym_await_expression] = STATE(3764),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3764),
    [sym_this] = STATE(3764),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3764),
    [sym_generator_function] = STATE(3764),
    [sym_call_expression] = STATE(3764),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3764),
    [sym_ternary_expression] = STATE(3764),
    [sym_binary_expression] = STATE(3764),
    [sym_template_string] = STATE(3764),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3764),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3764),
    [sym_class] = STATE(3764),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7651),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7653),
    [sym_true] = ACTIONS(7651),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7651),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [3083] = {
    [sym_new_expression] = STATE(3765),
    [sym_augmented_assignment_expression] = STATE(3765),
    [sym_unary_expression] = STATE(3765),
    [sym_update_expression] = STATE(3765),
    [sym_regex] = STATE(3765),
    [sym_meta_property] = STATE(3765),
    [sym_call_signature] = STATE(1340),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(3765),
    [sym_yield_expression] = STATE(3765),
    [sym_as_expression] = STATE(3765),
    [sym_non_null_expression] = STATE(3765),
    [sym_internal_module] = STATE(3765),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3765),
    [sym_await_expression] = STATE(3765),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(3765),
    [sym_this] = STATE(3765),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(3765),
    [sym_generator_function] = STATE(3765),
    [sym_call_expression] = STATE(3765),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(3765),
    [sym_ternary_expression] = STATE(3765),
    [sym_binary_expression] = STATE(3765),
    [sym_template_string] = STATE(3765),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3765),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3765),
    [sym_class] = STATE(3765),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(7655),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7655),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7657),
    [sym_true] = ACTIONS(7655),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7655),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [3084] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3085] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3086] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3087] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3088] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7662),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3089] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(7664),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_RBRACK] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(7666),
  },
  [3090] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3091] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3092] = {
    [sym_formal_parameters] = STATE(3769),
    [sym_type_parameters] = STATE(3770),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3093] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3094] = {
    [sym_formal_parameters] = STATE(3773),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3095] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_RBRACK] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(7669),
  },
  [3096] = {
    [anon_sym_EQ_GT] = ACTIONS(7672),
    [sym_comment] = ACTIONS(3),
  },
  [3097] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_AMP_EQ] = ACTIONS(4661),
    [anon_sym_PLUS_EQ] = ACTIONS(4661),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_CARET_EQ] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_DASH_EQ] = ACTIONS(4661),
    [anon_sym_EQ_GT] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4661),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7674),
  },
  [3098] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3099] = {
    [sym_new_expression] = STATE(2252),
    [sym_augmented_assignment_expression] = STATE(2252),
    [sym_unary_expression] = STATE(2252),
    [sym_update_expression] = STATE(2252),
    [sym_regex] = STATE(2252),
    [sym_meta_property] = STATE(2252),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2252),
    [sym_yield_expression] = STATE(2252),
    [sym_as_expression] = STATE(2252),
    [sym_non_null_expression] = STATE(2252),
    [sym_internal_module] = STATE(2252),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2252),
    [sym_await_expression] = STATE(2252),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2252),
    [sym_this] = STATE(2252),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2252),
    [sym_generator_function] = STATE(2252),
    [sym_call_expression] = STATE(2252),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2252),
    [sym_ternary_expression] = STATE(2252),
    [sym_binary_expression] = STATE(2252),
    [sym_template_string] = STATE(2252),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2252),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2252),
    [sym_class] = STATE(2252),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(7676),
    [sym_false] = ACTIONS(4679),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4679),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4681),
    [sym_true] = ACTIONS(4679),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4679),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [3100] = {
    [sym_new_expression] = STATE(2253),
    [sym_augmented_assignment_expression] = STATE(2253),
    [sym_unary_expression] = STATE(2253),
    [sym_update_expression] = STATE(2253),
    [sym_regex] = STATE(2253),
    [sym_meta_property] = STATE(2253),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2253),
    [sym_yield_expression] = STATE(2253),
    [sym_as_expression] = STATE(2253),
    [sym_non_null_expression] = STATE(2253),
    [sym_internal_module] = STATE(2253),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2253),
    [sym_await_expression] = STATE(2253),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2253),
    [sym_this] = STATE(2253),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2253),
    [sym_generator_function] = STATE(2253),
    [sym_call_expression] = STATE(2253),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2253),
    [sym_ternary_expression] = STATE(2253),
    [sym_binary_expression] = STATE(2253),
    [sym_template_string] = STATE(2253),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2253),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2253),
    [sym_class] = STATE(2253),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4683),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(4683),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4683),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [3101] = {
    [sym_new_expression] = STATE(2252),
    [sym_augmented_assignment_expression] = STATE(2252),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(2252),
    [sym_update_expression] = STATE(2252),
    [sym_regex] = STATE(2252),
    [sym_meta_property] = STATE(2252),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(2252),
    [sym_yield_expression] = STATE(2252),
    [sym_as_expression] = STATE(2252),
    [sym_non_null_expression] = STATE(2252),
    [sym_internal_module] = STATE(2252),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2252),
    [sym_await_expression] = STATE(2252),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(2252),
    [sym_this] = STATE(2252),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(2252),
    [sym_generator_function] = STATE(2252),
    [sym_call_expression] = STATE(2252),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(2252),
    [sym_ternary_expression] = STATE(2252),
    [sym_binary_expression] = STATE(2252),
    [sym_template_string] = STATE(2252),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2252),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(2252),
    [sym_class] = STATE(2252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4673),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_AMP_EQ] = ACTIONS(4673),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4673),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4673),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_PIPE_EQ] = ACTIONS(4673),
    [anon_sym_DASH_EQ] = ACTIONS(4673),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4673),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(2779),
    [sym_true] = ACTIONS(4679),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4673),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4679),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4673),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(4679),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_STAR_EQ] = ACTIONS(4673),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_EQ_GT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4681),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4673),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(4679),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3102] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4699),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4701),
    [anon_sym_symbol] = ACTIONS(4701),
    [anon_sym_number] = ACTIONS(4701),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4701),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4701),
    [anon_sym_private] = ACTIONS(4701),
    [anon_sym_boolean] = ACTIONS(4701),
    [anon_sym_async] = ACTIONS(4705),
    [anon_sym_public] = ACTIONS(4701),
    [anon_sym_get] = ACTIONS(4701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4701),
    [anon_sym_string] = ACTIONS(4701),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(4701),
    [anon_sym_type] = ACTIONS(4701),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(4701),
    [anon_sym_export] = ACTIONS(4701),
    [anon_sym_namespace] = ACTIONS(4707),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3103] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3104] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(3783),
    [sym_constructor_type] = STATE(3783),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(3783),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(3783),
    [sym_intersection_type] = STATE(3783),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3784),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3786),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(7682),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(7684),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(7686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3105] = {
    [sym__automatic_semicolon] = ACTIONS(7688),
    [anon_sym_RBRACE] = ACTIONS(7688),
    [anon_sym_SEMI] = ACTIONS(7688),
    [anon_sym_COMMA] = ACTIONS(7688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7688),
  },
  [3106] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(5406),
    [sym_comment] = ACTIONS(3),
  },
  [3107] = {
    [sym_statement_block] = STATE(3787),
    [sym__automatic_semicolon] = ACTIONS(7690),
    [anon_sym_SEMI] = ACTIONS(7690),
    [anon_sym_COMMA] = ACTIONS(7690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4779),
  },
  [3108] = {
    [sym__automatic_semicolon] = ACTIONS(6533),
    [anon_sym_LBRACK] = ACTIONS(6533),
    [sym_identifier] = ACTIONS(7692),
    [anon_sym_SEMI] = ACTIONS(6533),
    [anon_sym_module] = ACTIONS(7692),
    [anon_sym_symbol] = ACTIONS(7692),
    [anon_sym_number] = ACTIONS(7692),
    [anon_sym_AT] = ACTIONS(6533),
    [anon_sym_declare] = ACTIONS(7692),
    [anon_sym_STAR] = ACTIONS(6533),
    [anon_sym_void] = ACTIONS(7692),
    [anon_sym_any] = ACTIONS(7692),
    [anon_sym_private] = ACTIONS(7692),
    [anon_sym_boolean] = ACTIONS(7692),
    [anon_sym_async] = ACTIONS(7692),
    [anon_sym_public] = ACTIONS(7692),
    [anon_sym_get] = ACTIONS(7692),
    [anon_sym_RBRACE] = ACTIONS(6533),
    [anon_sym_static] = ACTIONS(7692),
    [anon_sym_SQUOTE] = ACTIONS(6533),
    [sym_number] = ACTIONS(6533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(7692),
    [anon_sym_string] = ACTIONS(7692),
    [anon_sym_abstract] = ACTIONS(7692),
    [anon_sym_set] = ACTIONS(7692),
    [anon_sym_type] = ACTIONS(7692),
    [anon_sym_import] = ACTIONS(7692),
    [anon_sym_export] = ACTIONS(7692),
    [anon_sym_namespace] = ACTIONS(7692),
    [sym_readonly] = ACTIONS(7692),
    [anon_sym_DQUOTE] = ACTIONS(6533),
  },
  [3109] = {
    [sym_call_signature] = STATE(3788),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3110] = {
    [sym_call_signature] = STATE(3788),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(7694),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [3111] = {
    [sym_string] = STATE(3790),
    [sym__property_name] = STATE(3790),
    [sym_computed_property_name] = STATE(3790),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(7696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3112] = {
    [sym_string] = STATE(3790),
    [sym__property_name] = STATE(3790),
    [sym_computed_property_name] = STATE(3790),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(7696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3113] = {
    [sym_call_signature] = STATE(3788),
    [sym__initializer] = STATE(3791),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [sym_type_annotation] = STATE(3792),
    [sym__automatic_semicolon] = ACTIONS(7698),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(7698),
    [sym_comment] = ACTIONS(3),
  },
  [3114] = {
    [sym__initializer] = STATE(3791),
    [sym_type_annotation] = STATE(3792),
    [sym__automatic_semicolon] = ACTIONS(7698),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(7698),
    [anon_sym_COMMA] = ACTIONS(7698),
    [sym_comment] = ACTIONS(3),
  },
  [3115] = {
    [sym__automatic_semicolon] = ACTIONS(7698),
    [anon_sym_SEMI] = ACTIONS(7698),
    [anon_sym_COMMA] = ACTIONS(7698),
    [sym_comment] = ACTIONS(3),
  },
  [3116] = {
    [sym__initializer] = STATE(3791),
    [sym__automatic_semicolon] = ACTIONS(7698),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(7698),
    [anon_sym_COMMA] = ACTIONS(7698),
    [sym_comment] = ACTIONS(3),
  },
  [3117] = {
    [sym_call_signature] = STATE(3793),
    [sym_formal_parameters] = STATE(2293),
    [sym_type_parameters] = STATE(2294),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3118] = {
    [sym__automatic_semicolon] = ACTIONS(7700),
    [anon_sym_SEMI] = ACTIONS(7700),
    [anon_sym_COMMA] = ACTIONS(7700),
    [sym_comment] = ACTIONS(3),
  },
  [3119] = {
    [sym_type_annotation] = STATE(2545),
    [sym__automatic_semicolon] = ACTIONS(1739),
    [anon_sym_COLON] = ACTIONS(6400),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_COMMA] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
  },
  [3120] = {
    [sym__automatic_semicolon] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [sym_identifier] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_module] = ACTIONS(1237),
    [anon_sym_symbol] = ACTIONS(1237),
    [anon_sym_number] = ACTIONS(1237),
    [anon_sym_AT] = ACTIONS(1239),
    [anon_sym_declare] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_void] = ACTIONS(1237),
    [anon_sym_any] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_boolean] = ACTIONS(1237),
    [anon_sym_async] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_get] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1237),
    [anon_sym_string] = ACTIONS(1237),
    [anon_sym_abstract] = ACTIONS(1237),
    [anon_sym_set] = ACTIONS(1237),
    [anon_sym_type] = ACTIONS(1237),
    [anon_sym_import] = ACTIONS(1237),
    [anon_sym_export] = ACTIONS(1237),
    [anon_sym_namespace] = ACTIONS(1237),
    [sym_readonly] = ACTIONS(1237),
    [anon_sym_DQUOTE] = ACTIONS(1239),
  },
  [3121] = {
    [sym_type_alias_declaration] = STATE(689),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(689),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(689),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(689),
    [sym_return_statement] = STATE(689),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(689),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(689),
    [sym_switch_statement] = STATE(689),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(689),
    [sym_throw_statement] = STATE(689),
    [aux_sym_program_repeat1] = STATE(689),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(689),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(689),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(689),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(689),
    [sym_abstract_class] = STATE(689),
    [sym_interface_declaration] = STATE(689),
    [sym_statement_block] = STATE(689),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(689),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(689),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(689),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(689),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(689),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(689),
    [sym_empty_statement] = STATE(689),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(689),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(689),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(689),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(689),
    [sym_break_statement] = STATE(689),
    [sym_labeled_statement] = STATE(689),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(689),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(7702),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [3122] = {
    [sym_type_arguments] = STATE(1937),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(7704),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_is] = ACTIONS(7706),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1475),
  },
  [3123] = {
    [sym_tuple_type] = STATE(1939),
    [sym_index_type_query] = STATE(1939),
    [sym_lookup_type] = STATE(1939),
    [sym_this_type] = STATE(1939),
    [sym_flow_maybe_type] = STATE(1939),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_type_predicate] = STATE(1939),
    [sym_type_query] = STATE(1939),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1939),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1939),
    [sym__primary_type] = STATE(1939),
    [sym_generic_type] = STATE(1939),
    [sym_mapped_type] = STATE(1939),
    [sym_literal_type] = STATE(1939),
    [sym_parenthesized_type] = STATE(1939),
    [sym_predefined_type] = STATE(1939),
    [sym_string] = STATE(1048),
    [sym_array_type] = STATE(1939),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [sym_true] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3124] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3128),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3130),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3125] = {
    [sym_formal_parameters] = STATE(3797),
    [sym_type_parameters] = STATE(3798),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3126] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3128),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3130),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3127] = {
    [sym__automatic_semicolon] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(7708),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(7710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3744),
  },
  [3128] = {
    [sym_formal_parameters] = STATE(3801),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3129] = {
    [sym_type_arguments] = STATE(1958),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(7712),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1577),
  },
  [3130] = {
    [anon_sym_EQ_GT] = ACTIONS(7714),
    [sym_comment] = ACTIONS(3),
  },
  [3131] = {
    [sym_string] = STATE(3790),
    [sym__property_name] = STATE(3790),
    [sym_computed_property_name] = STATE(3790),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(7696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [3132] = {
    [sym_string] = STATE(3790),
    [sym__property_name] = STATE(3790),
    [sym_computed_property_name] = STATE(3790),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(7716),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(7718),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(7696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(7718),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_BANG] = ACTIONS(1198),
  },
  [3133] = {
    [sym_call_signature] = STATE(3788),
    [sym__initializer] = STATE(3791),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [sym_type_annotation] = STATE(3792),
    [sym__automatic_semicolon] = ACTIONS(7698),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(7698),
    [anon_sym_QMARK] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(7698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(7722),
  },
  [3134] = {
    [sym__initializer] = STATE(3791),
    [sym_type_annotation] = STATE(3792),
    [sym__automatic_semicolon] = ACTIONS(7698),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(7698),
    [anon_sym_QMARK] = ACTIONS(7722),
    [anon_sym_COMMA] = ACTIONS(7698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(7722),
  },
  [3135] = {
    [sym_call_signature] = STATE(3793),
    [sym_formal_parameters] = STATE(2293),
    [sym_type_parameters] = STATE(2294),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(7724),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [3136] = {
    [sym_call_signature] = STATE(3793),
    [sym__initializer] = STATE(3791),
    [sym_formal_parameters] = STATE(2293),
    [sym_type_parameters] = STATE(2294),
    [sym_type_annotation] = STATE(3792),
    [sym__automatic_semicolon] = ACTIONS(7698),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(7698),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(7698),
    [sym_comment] = ACTIONS(3),
  },
  [3137] = {
    [sym_type_arguments] = STATE(791),
    [sym_identifier] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_debugger] = ACTIONS(3834),
    [anon_sym_symbol] = ACTIONS(3834),
    [anon_sym_AT] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_void] = ACTIONS(3834),
    [anon_sym_break] = ACTIONS(3834),
    [anon_sym_const] = ACTIONS(3834),
    [sym_super] = ACTIONS(3834),
    [anon_sym_return] = ACTIONS(3834),
    [anon_sym_private] = ACTIONS(3834),
    [anon_sym_get] = ACTIONS(3834),
    [anon_sym_interface] = ACTIONS(3834),
    [anon_sym_enum] = ACTIONS(3834),
    [anon_sym_delete] = ACTIONS(3834),
    [anon_sym_continue] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(3834),
    [anon_sym_this] = ACTIONS(3834),
    [anon_sym_yield] = ACTIONS(3834),
    [sym_true] = ACTIONS(3834),
    [anon_sym_throw] = ACTIONS(3834),
    [anon_sym_protected] = ACTIONS(3834),
    [anon_sym_abstract] = ACTIONS(3834),
    [anon_sym_DOT] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3834),
    [anon_sym_type] = ACTIONS(3834),
    [anon_sym_import] = ACTIONS(3834),
    [anon_sym_namespace] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_await] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_for] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [sym_false] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(3834),
    [anon_sym_number] = ACTIONS(3834),
    [anon_sym_class] = ACTIONS(3834),
    [anon_sym_declare] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3834),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(7726),
    [anon_sym_switch] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [sym_null] = ACTIONS(3834),
    [anon_sym_any] = ACTIONS(3834),
    [anon_sym_boolean] = ACTIONS(3834),
    [anon_sym_async] = ACTIONS(3834),
    [anon_sym_public] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_var] = ACTIONS(3834),
    [anon_sym_while] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(3834),
    [anon_sym_LT] = ACTIONS(7728),
    [sym_number] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3834),
    [anon_sym_function] = ACTIONS(3834),
    [sym_undefined] = ACTIONS(3834),
    [anon_sym_new] = ACTIONS(3834),
    [ts_builtin_sym_end] = ACTIONS(1475),
    [anon_sym_let] = ACTIONS(3834),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_export] = ACTIONS(3834),
    [anon_sym_do] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_with] = ACTIONS(3834),
    [anon_sym_in] = ACTIONS(7731),
  },
  [3138] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3139] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3140] = {
    [sym_formal_parameters] = STATE(3811),
    [sym_type_parameters] = STATE(3812),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3141] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3142] = {
    [sym_identifier] = ACTIONS(7733),
    [anon_sym_BQUOTE] = ACTIONS(7735),
    [anon_sym_debugger] = ACTIONS(7733),
    [anon_sym_symbol] = ACTIONS(7733),
    [anon_sym_AT] = ACTIONS(7735),
    [anon_sym_PIPE] = ACTIONS(7737),
    [anon_sym_DASH] = ACTIONS(7733),
    [anon_sym_void] = ACTIONS(7733),
    [anon_sym_break] = ACTIONS(7733),
    [anon_sym_const] = ACTIONS(7733),
    [sym_super] = ACTIONS(7733),
    [anon_sym_return] = ACTIONS(7733),
    [anon_sym_private] = ACTIONS(7733),
    [anon_sym_get] = ACTIONS(7733),
    [anon_sym_interface] = ACTIONS(7733),
    [anon_sym_enum] = ACTIONS(7733),
    [anon_sym_delete] = ACTIONS(7733),
    [anon_sym_continue] = ACTIONS(7733),
    [anon_sym_DASH_DASH] = ACTIONS(7735),
    [anon_sym_if] = ACTIONS(7733),
    [anon_sym_this] = ACTIONS(7733),
    [anon_sym_yield] = ACTIONS(7733),
    [sym_true] = ACTIONS(7733),
    [anon_sym_throw] = ACTIONS(7733),
    [anon_sym_protected] = ACTIONS(7733),
    [anon_sym_abstract] = ACTIONS(7733),
    [anon_sym_set] = ACTIONS(7733),
    [anon_sym_type] = ACTIONS(7733),
    [anon_sym_import] = ACTIONS(7733),
    [anon_sym_namespace] = ACTIONS(7733),
    [anon_sym_PLUS_PLUS] = ACTIONS(7735),
    [anon_sym_await] = ACTIONS(7733),
    [anon_sym_DQUOTE] = ACTIONS(7735),
    [anon_sym_BANG] = ACTIONS(7735),
    [anon_sym_for] = ACTIONS(7733),
    [anon_sym_LBRACK] = ACTIONS(7735),
    [sym_false] = ACTIONS(7733),
    [anon_sym_SEMI] = ACTIONS(7735),
    [anon_sym_module] = ACTIONS(7733),
    [anon_sym_number] = ACTIONS(7733),
    [anon_sym_class] = ACTIONS(7733),
    [anon_sym_declare] = ACTIONS(7733),
    [anon_sym_typeof] = ACTIONS(7733),
    [anon_sym_LBRACE] = ACTIONS(7735),
    [anon_sym_switch] = ACTIONS(7733),
    [anon_sym_LPAREN] = ACTIONS(7735),
    [sym_null] = ACTIONS(7733),
    [anon_sym_any] = ACTIONS(7733),
    [anon_sym_boolean] = ACTIONS(7733),
    [anon_sym_async] = ACTIONS(7733),
    [anon_sym_public] = ACTIONS(7733),
    [anon_sym_AMP] = ACTIONS(7739),
    [anon_sym_var] = ACTIONS(7733),
    [anon_sym_while] = ACTIONS(7733),
    [anon_sym_SQUOTE] = ACTIONS(7735),
    [anon_sym_try] = ACTIONS(7733),
    [anon_sym_LT] = ACTIONS(7735),
    [sym_number] = ACTIONS(7735),
    [anon_sym_SLASH] = ACTIONS(7733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7733),
    [anon_sym_function] = ACTIONS(7733),
    [sym_undefined] = ACTIONS(7733),
    [anon_sym_new] = ACTIONS(7733),
    [ts_builtin_sym_end] = ACTIONS(7735),
    [anon_sym_let] = ACTIONS(7733),
    [anon_sym_PLUS] = ACTIONS(7733),
    [anon_sym_export] = ACTIONS(7733),
    [anon_sym_do] = ACTIONS(7733),
    [anon_sym_TILDE] = ACTIONS(7735),
    [anon_sym_with] = ACTIONS(7733),
  },
  [3143] = {
    [sym_formal_parameters] = STATE(3815),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3144] = {
    [sym_type_arguments] = STATE(850),
    [sym_identifier] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_debugger] = ACTIONS(3865),
    [anon_sym_symbol] = ACTIONS(3865),
    [anon_sym_AT] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_void] = ACTIONS(3865),
    [anon_sym_break] = ACTIONS(3865),
    [anon_sym_const] = ACTIONS(3865),
    [sym_super] = ACTIONS(3865),
    [anon_sym_return] = ACTIONS(3865),
    [anon_sym_private] = ACTIONS(3865),
    [anon_sym_get] = ACTIONS(3865),
    [anon_sym_interface] = ACTIONS(3865),
    [anon_sym_enum] = ACTIONS(3865),
    [anon_sym_delete] = ACTIONS(3865),
    [anon_sym_continue] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_if] = ACTIONS(3865),
    [anon_sym_this] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3865),
    [sym_true] = ACTIONS(3865),
    [anon_sym_throw] = ACTIONS(3865),
    [anon_sym_protected] = ACTIONS(3865),
    [anon_sym_abstract] = ACTIONS(3865),
    [anon_sym_set] = ACTIONS(3865),
    [anon_sym_type] = ACTIONS(3865),
    [anon_sym_import] = ACTIONS(3865),
    [anon_sym_namespace] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_await] = ACTIONS(3865),
    [anon_sym_DQUOTE] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [sym_false] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(3865),
    [anon_sym_number] = ACTIONS(3865),
    [anon_sym_class] = ACTIONS(3865),
    [anon_sym_declare] = ACTIONS(3865),
    [anon_sym_typeof] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_switch] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [sym_null] = ACTIONS(3865),
    [anon_sym_any] = ACTIONS(3865),
    [anon_sym_boolean] = ACTIONS(3865),
    [anon_sym_async] = ACTIONS(3865),
    [anon_sym_public] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_var] = ACTIONS(3865),
    [anon_sym_while] = ACTIONS(3865),
    [anon_sym_SQUOTE] = ACTIONS(1577),
    [anon_sym_try] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(7741),
    [sym_number] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3865),
    [sym_undefined] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3865),
    [ts_builtin_sym_end] = ACTIONS(1577),
    [anon_sym_let] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_export] = ACTIONS(3865),
    [anon_sym_do] = ACTIONS(3865),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_with] = ACTIONS(3865),
    [anon_sym_in] = ACTIONS(7744),
  },
  [3145] = {
    [anon_sym_EQ_GT] = ACTIONS(7746),
    [sym_comment] = ACTIONS(3),
  },
  [3146] = {
    [sym_identifier] = ACTIONS(6305),
    [anon_sym_BQUOTE] = ACTIONS(6303),
    [anon_sym_debugger] = ACTIONS(6305),
    [anon_sym_symbol] = ACTIONS(6305),
    [anon_sym_AT] = ACTIONS(6303),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_void] = ACTIONS(6305),
    [anon_sym_break] = ACTIONS(6305),
    [anon_sym_const] = ACTIONS(6305),
    [sym_super] = ACTIONS(6305),
    [anon_sym_return] = ACTIONS(6305),
    [anon_sym_private] = ACTIONS(6305),
    [anon_sym_get] = ACTIONS(6305),
    [anon_sym_RBRACE] = ACTIONS(6303),
    [anon_sym_interface] = ACTIONS(6305),
    [anon_sym_default] = ACTIONS(6305),
    [anon_sym_enum] = ACTIONS(6305),
    [anon_sym_delete] = ACTIONS(6305),
    [anon_sym_continue] = ACTIONS(6305),
    [anon_sym_DASH_DASH] = ACTIONS(6303),
    [anon_sym_if] = ACTIONS(6305),
    [anon_sym_this] = ACTIONS(6305),
    [anon_sym_yield] = ACTIONS(6305),
    [sym_true] = ACTIONS(6305),
    [anon_sym_throw] = ACTIONS(6305),
    [anon_sym_protected] = ACTIONS(6305),
    [anon_sym_abstract] = ACTIONS(6305),
    [anon_sym_set] = ACTIONS(6305),
    [anon_sym_type] = ACTIONS(6305),
    [anon_sym_import] = ACTIONS(6305),
    [anon_sym_namespace] = ACTIONS(6305),
    [anon_sym_PLUS_PLUS] = ACTIONS(6303),
    [anon_sym_await] = ACTIONS(6305),
    [anon_sym_DQUOTE] = ACTIONS(6303),
    [anon_sym_else] = ACTIONS(6305),
    [anon_sym_BANG] = ACTIONS(6303),
    [anon_sym_for] = ACTIONS(6305),
    [anon_sym_LBRACK] = ACTIONS(6303),
    [sym_false] = ACTIONS(6305),
    [anon_sym_SEMI] = ACTIONS(6303),
    [anon_sym_case] = ACTIONS(6305),
    [anon_sym_module] = ACTIONS(6305),
    [anon_sym_number] = ACTIONS(6305),
    [anon_sym_class] = ACTIONS(6305),
    [anon_sym_declare] = ACTIONS(6305),
    [anon_sym_typeof] = ACTIONS(6305),
    [anon_sym_LBRACE] = ACTIONS(6303),
    [anon_sym_switch] = ACTIONS(6305),
    [anon_sym_LPAREN] = ACTIONS(6303),
    [sym_null] = ACTIONS(6305),
    [anon_sym_any] = ACTIONS(6305),
    [anon_sym_boolean] = ACTIONS(6305),
    [anon_sym_async] = ACTIONS(6305),
    [anon_sym_public] = ACTIONS(6305),
    [anon_sym_var] = ACTIONS(6305),
    [anon_sym_while] = ACTIONS(6305),
    [anon_sym_SQUOTE] = ACTIONS(6303),
    [anon_sym_try] = ACTIONS(6305),
    [anon_sym_LT] = ACTIONS(6303),
    [sym_number] = ACTIONS(6303),
    [anon_sym_SLASH] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6305),
    [anon_sym_function] = ACTIONS(6305),
    [sym_undefined] = ACTIONS(6305),
    [anon_sym_new] = ACTIONS(6305),
    [ts_builtin_sym_end] = ACTIONS(6303),
    [anon_sym_let] = ACTIONS(6305),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_export] = ACTIONS(6305),
    [anon_sym_do] = ACTIONS(6305),
    [anon_sym_TILDE] = ACTIONS(6303),
    [anon_sym_with] = ACTIONS(6305),
  },
  [3147] = {
    [sym_identifier] = ACTIONS(6785),
    [anon_sym_BQUOTE] = ACTIONS(6783),
    [anon_sym_debugger] = ACTIONS(6785),
    [anon_sym_symbol] = ACTIONS(6785),
    [anon_sym_AT] = ACTIONS(6783),
    [anon_sym_DASH] = ACTIONS(6785),
    [anon_sym_void] = ACTIONS(6785),
    [anon_sym_break] = ACTIONS(6785),
    [anon_sym_const] = ACTIONS(6785),
    [sym_super] = ACTIONS(6785),
    [anon_sym_return] = ACTIONS(6785),
    [anon_sym_private] = ACTIONS(6785),
    [anon_sym_get] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(6783),
    [anon_sym_interface] = ACTIONS(6785),
    [anon_sym_default] = ACTIONS(6785),
    [anon_sym_enum] = ACTIONS(6785),
    [anon_sym_delete] = ACTIONS(6785),
    [anon_sym_continue] = ACTIONS(6785),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_if] = ACTIONS(6785),
    [anon_sym_this] = ACTIONS(6785),
    [anon_sym_yield] = ACTIONS(6785),
    [sym_true] = ACTIONS(6785),
    [anon_sym_throw] = ACTIONS(6785),
    [anon_sym_protected] = ACTIONS(6785),
    [anon_sym_abstract] = ACTIONS(6785),
    [anon_sym_set] = ACTIONS(6785),
    [anon_sym_type] = ACTIONS(6785),
    [anon_sym_import] = ACTIONS(6785),
    [anon_sym_namespace] = ACTIONS(6785),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_await] = ACTIONS(6785),
    [anon_sym_DQUOTE] = ACTIONS(6783),
    [anon_sym_else] = ACTIONS(6785),
    [anon_sym_BANG] = ACTIONS(6783),
    [anon_sym_for] = ACTIONS(6785),
    [anon_sym_LBRACK] = ACTIONS(6783),
    [sym_false] = ACTIONS(6785),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym_case] = ACTIONS(6785),
    [anon_sym_module] = ACTIONS(6785),
    [anon_sym_number] = ACTIONS(6785),
    [anon_sym_class] = ACTIONS(6785),
    [anon_sym_declare] = ACTIONS(6785),
    [anon_sym_typeof] = ACTIONS(6785),
    [anon_sym_LBRACE] = ACTIONS(6783),
    [anon_sym_switch] = ACTIONS(6785),
    [anon_sym_LPAREN] = ACTIONS(6783),
    [sym_null] = ACTIONS(6785),
    [anon_sym_any] = ACTIONS(6785),
    [anon_sym_boolean] = ACTIONS(6785),
    [anon_sym_async] = ACTIONS(6785),
    [anon_sym_public] = ACTIONS(6785),
    [anon_sym_var] = ACTIONS(6785),
    [anon_sym_while] = ACTIONS(6785),
    [anon_sym_SQUOTE] = ACTIONS(6783),
    [anon_sym_try] = ACTIONS(6785),
    [anon_sym_LT] = ACTIONS(6783),
    [sym_number] = ACTIONS(6783),
    [anon_sym_SLASH] = ACTIONS(6785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6785),
    [anon_sym_function] = ACTIONS(6785),
    [sym_undefined] = ACTIONS(6785),
    [anon_sym_new] = ACTIONS(6785),
    [ts_builtin_sym_end] = ACTIONS(6783),
    [anon_sym_let] = ACTIONS(6785),
    [anon_sym_PLUS] = ACTIONS(6785),
    [anon_sym_export] = ACTIONS(6785),
    [anon_sym_do] = ACTIONS(6785),
    [anon_sym_TILDE] = ACTIONS(6783),
    [anon_sym_with] = ACTIONS(6785),
  },
  [3148] = {
    [sym_identifier] = ACTIONS(7010),
    [anon_sym_BQUOTE] = ACTIONS(7008),
    [anon_sym_debugger] = ACTIONS(7010),
    [anon_sym_symbol] = ACTIONS(7010),
    [anon_sym_AT] = ACTIONS(7008),
    [anon_sym_DASH] = ACTIONS(7010),
    [anon_sym_void] = ACTIONS(7010),
    [anon_sym_break] = ACTIONS(7010),
    [anon_sym_const] = ACTIONS(7010),
    [sym_super] = ACTIONS(7010),
    [anon_sym_return] = ACTIONS(7010),
    [anon_sym_private] = ACTIONS(7010),
    [anon_sym_get] = ACTIONS(7010),
    [anon_sym_RBRACE] = ACTIONS(7008),
    [anon_sym_interface] = ACTIONS(7010),
    [anon_sym_default] = ACTIONS(7010),
    [anon_sym_enum] = ACTIONS(7010),
    [anon_sym_delete] = ACTIONS(7010),
    [anon_sym_continue] = ACTIONS(7010),
    [anon_sym_DASH_DASH] = ACTIONS(7008),
    [anon_sym_if] = ACTIONS(7010),
    [anon_sym_this] = ACTIONS(7010),
    [anon_sym_yield] = ACTIONS(7010),
    [sym_true] = ACTIONS(7010),
    [anon_sym_throw] = ACTIONS(7010),
    [anon_sym_protected] = ACTIONS(7010),
    [anon_sym_abstract] = ACTIONS(7010),
    [anon_sym_set] = ACTIONS(7010),
    [anon_sym_type] = ACTIONS(7010),
    [anon_sym_import] = ACTIONS(7010),
    [anon_sym_namespace] = ACTIONS(7010),
    [anon_sym_PLUS_PLUS] = ACTIONS(7008),
    [anon_sym_await] = ACTIONS(7010),
    [anon_sym_DQUOTE] = ACTIONS(7008),
    [anon_sym_else] = ACTIONS(7010),
    [anon_sym_BANG] = ACTIONS(7008),
    [anon_sym_for] = ACTIONS(7010),
    [anon_sym_LBRACK] = ACTIONS(7008),
    [sym_false] = ACTIONS(7010),
    [anon_sym_SEMI] = ACTIONS(7008),
    [anon_sym_case] = ACTIONS(7010),
    [anon_sym_module] = ACTIONS(7010),
    [anon_sym_number] = ACTIONS(7010),
    [anon_sym_class] = ACTIONS(7010),
    [anon_sym_declare] = ACTIONS(7010),
    [anon_sym_typeof] = ACTIONS(7010),
    [anon_sym_LBRACE] = ACTIONS(7008),
    [anon_sym_switch] = ACTIONS(7010),
    [anon_sym_LPAREN] = ACTIONS(7008),
    [sym_null] = ACTIONS(7010),
    [anon_sym_any] = ACTIONS(7010),
    [anon_sym_boolean] = ACTIONS(7010),
    [anon_sym_async] = ACTIONS(7010),
    [anon_sym_public] = ACTIONS(7010),
    [anon_sym_var] = ACTIONS(7010),
    [anon_sym_while] = ACTIONS(7010),
    [anon_sym_SQUOTE] = ACTIONS(7008),
    [anon_sym_try] = ACTIONS(7010),
    [anon_sym_LT] = ACTIONS(7008),
    [sym_number] = ACTIONS(7008),
    [anon_sym_SLASH] = ACTIONS(7010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7010),
    [anon_sym_function] = ACTIONS(7010),
    [sym_undefined] = ACTIONS(7010),
    [anon_sym_new] = ACTIONS(7010),
    [ts_builtin_sym_end] = ACTIONS(7008),
    [anon_sym_let] = ACTIONS(7010),
    [anon_sym_PLUS] = ACTIONS(7010),
    [anon_sym_export] = ACTIONS(7010),
    [anon_sym_do] = ACTIONS(7010),
    [anon_sym_TILDE] = ACTIONS(7008),
    [anon_sym_with] = ACTIONS(7010),
  },
  [3149] = {
    [sym_identifier] = ACTIONS(7241),
    [anon_sym_BQUOTE] = ACTIONS(7239),
    [anon_sym_debugger] = ACTIONS(7241),
    [anon_sym_symbol] = ACTIONS(7241),
    [anon_sym_AT] = ACTIONS(7239),
    [anon_sym_DASH] = ACTIONS(7241),
    [anon_sym_void] = ACTIONS(7241),
    [anon_sym_break] = ACTIONS(7241),
    [anon_sym_const] = ACTIONS(7241),
    [sym_super] = ACTIONS(7241),
    [anon_sym_return] = ACTIONS(7241),
    [anon_sym_private] = ACTIONS(7241),
    [anon_sym_get] = ACTIONS(7241),
    [anon_sym_RBRACE] = ACTIONS(7239),
    [anon_sym_interface] = ACTIONS(7241),
    [anon_sym_default] = ACTIONS(7241),
    [anon_sym_enum] = ACTIONS(7241),
    [anon_sym_delete] = ACTIONS(7241),
    [anon_sym_continue] = ACTIONS(7241),
    [anon_sym_DASH_DASH] = ACTIONS(7239),
    [anon_sym_if] = ACTIONS(7241),
    [anon_sym_this] = ACTIONS(7241),
    [anon_sym_yield] = ACTIONS(7241),
    [sym_true] = ACTIONS(7241),
    [anon_sym_throw] = ACTIONS(7241),
    [anon_sym_protected] = ACTIONS(7241),
    [anon_sym_abstract] = ACTIONS(7241),
    [anon_sym_set] = ACTIONS(7241),
    [anon_sym_type] = ACTIONS(7241),
    [anon_sym_import] = ACTIONS(7241),
    [anon_sym_namespace] = ACTIONS(7241),
    [anon_sym_PLUS_PLUS] = ACTIONS(7239),
    [anon_sym_await] = ACTIONS(7241),
    [anon_sym_DQUOTE] = ACTIONS(7239),
    [anon_sym_else] = ACTIONS(7241),
    [anon_sym_BANG] = ACTIONS(7239),
    [anon_sym_for] = ACTIONS(7241),
    [anon_sym_LBRACK] = ACTIONS(7239),
    [sym_false] = ACTIONS(7241),
    [anon_sym_SEMI] = ACTIONS(7239),
    [anon_sym_case] = ACTIONS(7241),
    [anon_sym_module] = ACTIONS(7241),
    [anon_sym_number] = ACTIONS(7241),
    [anon_sym_class] = ACTIONS(7241),
    [anon_sym_declare] = ACTIONS(7241),
    [anon_sym_typeof] = ACTIONS(7241),
    [anon_sym_LBRACE] = ACTIONS(7239),
    [anon_sym_switch] = ACTIONS(7241),
    [anon_sym_LPAREN] = ACTIONS(7239),
    [sym_null] = ACTIONS(7241),
    [anon_sym_any] = ACTIONS(7241),
    [anon_sym_boolean] = ACTIONS(7241),
    [anon_sym_async] = ACTIONS(7241),
    [anon_sym_public] = ACTIONS(7241),
    [anon_sym_var] = ACTIONS(7241),
    [anon_sym_while] = ACTIONS(7241),
    [anon_sym_SQUOTE] = ACTIONS(7239),
    [anon_sym_try] = ACTIONS(7241),
    [anon_sym_LT] = ACTIONS(7239),
    [sym_number] = ACTIONS(7239),
    [anon_sym_SLASH] = ACTIONS(7241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7241),
    [anon_sym_function] = ACTIONS(7241),
    [sym_undefined] = ACTIONS(7241),
    [anon_sym_new] = ACTIONS(7241),
    [ts_builtin_sym_end] = ACTIONS(7239),
    [anon_sym_let] = ACTIONS(7241),
    [anon_sym_PLUS] = ACTIONS(7241),
    [anon_sym_export] = ACTIONS(7241),
    [anon_sym_do] = ACTIONS(7241),
    [anon_sym_TILDE] = ACTIONS(7239),
    [anon_sym_with] = ACTIONS(7241),
  },
  [3150] = {
    [sym_class_body] = STATE(3818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2411),
  },
  [3151] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [3152] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3153] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [3154] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [3155] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2155),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(2155),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [3156] = {
    [sym_new_expression] = STATE(3819),
    [sym_augmented_assignment_expression] = STATE(3819),
    [sym_unary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_regex] = STATE(3819),
    [sym_meta_property] = STATE(3819),
    [sym_call_signature] = STATE(1399),
    [sym_statement_block] = STATE(1530),
    [sym__expression] = STATE(3819),
    [sym_yield_expression] = STATE(3819),
    [sym_as_expression] = STATE(3819),
    [sym_non_null_expression] = STATE(3819),
    [sym_internal_module] = STATE(3819),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3819),
    [sym_await_expression] = STATE(3819),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3819),
    [sym_this] = STATE(3819),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3819),
    [sym_generator_function] = STATE(3819),
    [sym_call_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3819),
    [sym_ternary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_template_string] = STATE(3819),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3819),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3819),
    [sym_class] = STATE(3819),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(7748),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7748),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7750),
    [sym_true] = ACTIONS(7748),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7748),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [3157] = {
    [sym_new_expression] = STATE(3820),
    [sym_augmented_assignment_expression] = STATE(3820),
    [sym_unary_expression] = STATE(3820),
    [sym_update_expression] = STATE(3820),
    [sym_regex] = STATE(3820),
    [sym_meta_property] = STATE(3820),
    [sym_call_signature] = STATE(1399),
    [sym_statement_block] = STATE(1532),
    [sym__expression] = STATE(3820),
    [sym_yield_expression] = STATE(3820),
    [sym_as_expression] = STATE(3820),
    [sym_non_null_expression] = STATE(3820),
    [sym_internal_module] = STATE(3820),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3820),
    [sym_await_expression] = STATE(3820),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(3820),
    [sym_this] = STATE(3820),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(3820),
    [sym_generator_function] = STATE(3820),
    [sym_call_expression] = STATE(3820),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(3820),
    [sym_ternary_expression] = STATE(3820),
    [sym_binary_expression] = STATE(3820),
    [sym_template_string] = STATE(3820),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3820),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3820),
    [sym_class] = STATE(3820),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(7752),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7752),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(7754),
    [sym_true] = ACTIONS(7752),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7752),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [3158] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [3159] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7756),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3160] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7756),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3161] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [3162] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7759),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3163] = {
    [sym_type_arguments] = STATE(1845),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(3831),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_is] = ACTIONS(7761),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(7763),
  },
  [3164] = {
    [sym_tuple_type] = STATE(1847),
    [sym_index_type_query] = STATE(1847),
    [sym_lookup_type] = STATE(1847),
    [sym_this_type] = STATE(1847),
    [sym_flow_maybe_type] = STATE(1847),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_type_predicate] = STATE(1847),
    [sym_type_query] = STATE(1847),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(1847),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(1847),
    [sym__primary_type] = STATE(1847),
    [sym_generic_type] = STATE(1847),
    [sym_mapped_type] = STATE(1847),
    [sym_literal_type] = STATE(1847),
    [sym_parenthesized_type] = STATE(1847),
    [sym_predefined_type] = STATE(1847),
    [sym_string] = STATE(969),
    [sym_array_type] = STATE(1847),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [sym_true] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_LPAREN] = ACTIONS(3846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3165] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(1852),
    [sym_constructor_type] = STATE(1852),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(1852),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(1852),
    [sym_intersection_type] = STATE(1852),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3166] = {
    [sym_formal_parameters] = STATE(3824),
    [sym_type_parameters] = STATE(3825),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3167] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(1860),
    [sym_constructor_type] = STATE(1860),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(1860),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(1860),
    [sym_intersection_type] = STATE(1860),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3168] = {
    [sym_formal_parameters] = STATE(3828),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3169] = {
    [sym_type_arguments] = STATE(1866),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(3862),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(3867),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(7766),
  },
  [3170] = {
    [anon_sym_EQ_GT] = ACTIONS(7769),
    [sym_comment] = ACTIONS(3),
  },
  [3171] = {
    [sym__initializer] = STATE(71),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_EQ_GT] = ACTIONS(4842),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(3887),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7771),
  },
  [3172] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4846),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_AMP_EQ] = ACTIONS(4846),
    [anon_sym_PLUS_EQ] = ACTIONS(4846),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(4846),
    [anon_sym_STAR_EQ] = ACTIONS(4846),
    [anon_sym_PIPE_EQ] = ACTIONS(4846),
    [anon_sym_DASH_EQ] = ACTIONS(4846),
    [anon_sym_EQ_GT] = ACTIONS(4848),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4846),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4846),
    [anon_sym_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4846),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3173] = {
    [sym_new_expression] = STATE(2319),
    [sym_augmented_assignment_expression] = STATE(2319),
    [sym_unary_expression] = STATE(2319),
    [sym_update_expression] = STATE(2319),
    [sym_regex] = STATE(2319),
    [sym_meta_property] = STATE(2319),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(2319),
    [sym_yield_expression] = STATE(2319),
    [sym_as_expression] = STATE(2319),
    [sym_non_null_expression] = STATE(2319),
    [sym_internal_module] = STATE(2319),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2319),
    [sym_await_expression] = STATE(2319),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(2319),
    [sym_this] = STATE(2319),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(2319),
    [sym_generator_function] = STATE(2319),
    [sym_call_expression] = STATE(2319),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(2319),
    [sym_ternary_expression] = STATE(2319),
    [sym_binary_expression] = STATE(2319),
    [sym_template_string] = STATE(2319),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2319),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(2319),
    [sym_class] = STATE(2319),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(7773),
    [sym_false] = ACTIONS(4850),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4850),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(4852),
    [sym_true] = ACTIONS(4850),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4850),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [3174] = {
    [sym_new_expression] = STATE(2320),
    [sym_augmented_assignment_expression] = STATE(2320),
    [sym_unary_expression] = STATE(2320),
    [sym_update_expression] = STATE(2320),
    [sym_regex] = STATE(2320),
    [sym_meta_property] = STATE(2320),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(2320),
    [sym_yield_expression] = STATE(2320),
    [sym_as_expression] = STATE(2320),
    [sym_non_null_expression] = STATE(2320),
    [sym_internal_module] = STATE(2320),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2320),
    [sym_await_expression] = STATE(2320),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(2320),
    [sym_this] = STATE(2320),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(2320),
    [sym_generator_function] = STATE(2320),
    [sym_call_expression] = STATE(2320),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(2320),
    [sym_ternary_expression] = STATE(2320),
    [sym_binary_expression] = STATE(2320),
    [sym_template_string] = STATE(2320),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2320),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(2320),
    [sym_class] = STATE(2320),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(4854),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4854),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3905),
    [sym_true] = ACTIONS(4854),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4854),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [3175] = {
    [sym_new_expression] = STATE(2319),
    [sym_augmented_assignment_expression] = STATE(2319),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(2319),
    [sym_update_expression] = STATE(2319),
    [sym_regex] = STATE(2319),
    [sym_meta_property] = STATE(2319),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(2319),
    [sym_yield_expression] = STATE(2319),
    [sym_as_expression] = STATE(2319),
    [sym_non_null_expression] = STATE(2319),
    [sym_internal_module] = STATE(2319),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2319),
    [sym_await_expression] = STATE(2319),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(2319),
    [sym_this] = STATE(2319),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(2319),
    [sym_generator_function] = STATE(2319),
    [sym_call_expression] = STATE(2319),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(2319),
    [sym_ternary_expression] = STATE(2319),
    [sym_binary_expression] = STATE(2319),
    [sym_template_string] = STATE(2319),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2319),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(2319),
    [sym_class] = STATE(2319),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(4846),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_AMP_EQ] = ACTIONS(4846),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4846),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(4846),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_PIPE_EQ] = ACTIONS(4846),
    [anon_sym_DASH_EQ] = ACTIONS(4846),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4846),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(2887),
    [sym_true] = ACTIONS(4850),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4846),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(4850),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4846),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4850),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_STAR_EQ] = ACTIONS(4846),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_EQ_GT] = ACTIONS(4848),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4852),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4846),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4850),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3176] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4870),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4872),
    [anon_sym_symbol] = ACTIONS(4872),
    [anon_sym_number] = ACTIONS(4872),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4872),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4874),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(4872),
    [anon_sym_private] = ACTIONS(4872),
    [anon_sym_boolean] = ACTIONS(4872),
    [anon_sym_async] = ACTIONS(4876),
    [anon_sym_public] = ACTIONS(4872),
    [anon_sym_get] = ACTIONS(4872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4872),
    [anon_sym_string] = ACTIONS(4872),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(4872),
    [anon_sym_type] = ACTIONS(4872),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(4872),
    [anon_sym_export] = ACTIONS(4872),
    [anon_sym_namespace] = ACTIONS(4878),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3177] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(7756),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3178] = {
    [anon_sym_LBRACK] = ACTIONS(4190),
    [sym_identifier] = ACTIONS(4192),
    [anon_sym_module] = ACTIONS(4192),
    [anon_sym_symbol] = ACTIONS(4192),
    [anon_sym_number] = ACTIONS(4192),
    [anon_sym_AT] = ACTIONS(4190),
    [anon_sym_class] = ACTIONS(4192),
    [anon_sym_declare] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_void] = ACTIONS(4192),
    [anon_sym_any] = ACTIONS(4192),
    [anon_sym_private] = ACTIONS(4192),
    [anon_sym_boolean] = ACTIONS(4192),
    [anon_sym_async] = ACTIONS(4192),
    [anon_sym_public] = ACTIONS(4192),
    [anon_sym_get] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(4192),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [sym_number] = ACTIONS(4190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4192),
    [anon_sym_string] = ACTIONS(4192),
    [anon_sym_abstract] = ACTIONS(4192),
    [anon_sym_set] = ACTIONS(4192),
    [anon_sym_type] = ACTIONS(4192),
    [anon_sym_import] = ACTIONS(4192),
    [anon_sym_export] = ACTIONS(4192),
    [sym_readonly] = ACTIONS(4192),
    [anon_sym_namespace] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4190),
  },
  [3179] = {
    [aux_sym_array_repeat1] = STATE(1122),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(7775),
    [sym_comment] = ACTIONS(3),
  },
  [3180] = {
    [anon_sym_COMMA] = ACTIONS(7777),
    [anon_sym_RBRACE] = ACTIONS(7777),
    [sym_comment] = ACTIONS(3),
  },
  [3181] = {
    [sym_statement_block] = STATE(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [3182] = {
    [sym_call_signature] = STATE(3835),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3183] = {
    [sym_call_signature] = STATE(3835),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(7779),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3184] = {
    [sym_identifier] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2401),
    [anon_sym_debugger] = ACTIONS(2399),
    [anon_sym_symbol] = ACTIONS(2399),
    [anon_sym_AT] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2399),
    [anon_sym_void] = ACTIONS(2399),
    [anon_sym_break] = ACTIONS(2399),
    [anon_sym_const] = ACTIONS(2399),
    [sym_super] = ACTIONS(2399),
    [anon_sym_return] = ACTIONS(2399),
    [anon_sym_private] = ACTIONS(2399),
    [anon_sym_get] = ACTIONS(2399),
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_interface] = ACTIONS(2399),
    [anon_sym_enum] = ACTIONS(2399),
    [anon_sym_delete] = ACTIONS(2399),
    [anon_sym_continue] = ACTIONS(2399),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2399),
    [anon_sym_this] = ACTIONS(2399),
    [anon_sym_yield] = ACTIONS(2399),
    [sym_true] = ACTIONS(2399),
    [anon_sym_throw] = ACTIONS(2399),
    [anon_sym_protected] = ACTIONS(2399),
    [anon_sym_abstract] = ACTIONS(2399),
    [anon_sym_set] = ACTIONS(2399),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_import] = ACTIONS(2399),
    [anon_sym_namespace] = ACTIONS(2399),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_await] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_else] = ACTIONS(7781),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [sym_false] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2401),
    [anon_sym_module] = ACTIONS(2399),
    [anon_sym_number] = ACTIONS(2399),
    [anon_sym_class] = ACTIONS(2399),
    [anon_sym_declare] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_switch] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [sym_null] = ACTIONS(2399),
    [anon_sym_any] = ACTIONS(2399),
    [anon_sym_boolean] = ACTIONS(2399),
    [anon_sym_async] = ACTIONS(2399),
    [anon_sym_public] = ACTIONS(2399),
    [anon_sym_var] = ACTIONS(2399),
    [anon_sym_while] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_try] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2401),
    [sym_number] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2399),
    [anon_sym_function] = ACTIONS(2399),
    [sym_undefined] = ACTIONS(2399),
    [anon_sym_new] = ACTIONS(2399),
    [anon_sym_let] = ACTIONS(2399),
    [anon_sym_PLUS] = ACTIONS(2399),
    [anon_sym_export] = ACTIONS(2399),
    [anon_sym_do] = ACTIONS(2399),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_with] = ACTIONS(2399),
  },
  [3185] = {
    [sym_array] = STATE(3840),
    [sym_object] = STATE(3841),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(7783),
    [anon_sym_var] = ACTIONS(7785),
    [anon_sym_const] = ACTIONS(7785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(7785),
  },
  [3186] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(7787),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7789),
  },
  [3187] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(3845),
    [sym_object] = STATE(3846),
    [sym_identifier] = ACTIONS(7791),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3188] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(3845),
    [sym_object] = STATE(3846),
    [sym_identifier] = ACTIONS(7791),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3189] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3847),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(3847),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [3190] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(7793),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7795),
  },
  [3191] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(7797),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7799),
  },
  [3192] = {
    [sym_identifier] = ACTIONS(7801),
    [sym_comment] = ACTIONS(3),
  },
  [3193] = {
    [anon_sym_of] = ACTIONS(7803),
    [sym_comment] = ACTIONS(3),
  },
  [3194] = {
    [anon_sym_of] = ACTIONS(7805),
    [sym_comment] = ACTIONS(3),
  },
  [3195] = {
    [anon_sym_of] = ACTIONS(7807),
    [sym_comment] = ACTIONS(3),
  },
  [3196] = {
    [sym_new_expression] = STATE(3856),
    [sym_augmented_assignment_expression] = STATE(3856),
    [sym_unary_expression] = STATE(3856),
    [sym_update_expression] = STATE(3856),
    [sym_regex] = STATE(3856),
    [sym_meta_property] = STATE(3856),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3856),
    [sym_yield_expression] = STATE(3856),
    [sym_as_expression] = STATE(3856),
    [sym_non_null_expression] = STATE(3856),
    [sym_internal_module] = STATE(3856),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3856),
    [sym_await_expression] = STATE(3856),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3856),
    [sym_this] = STATE(3856),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3856),
    [sym_generator_function] = STATE(3856),
    [sym_call_expression] = STATE(3856),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3856),
    [sym_ternary_expression] = STATE(3856),
    [sym_binary_expression] = STATE(3856),
    [sym_template_string] = STATE(3856),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3856),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3856),
    [sym_class] = STATE(3856),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7809),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7809),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7811),
    [sym_true] = ACTIONS(7809),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7809),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3197] = {
    [sym_new_expression] = STATE(3857),
    [sym_augmented_assignment_expression] = STATE(3857),
    [sym_unary_expression] = STATE(3857),
    [sym_update_expression] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_meta_property] = STATE(3857),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3857),
    [sym_yield_expression] = STATE(3857),
    [sym_as_expression] = STATE(3857),
    [sym_non_null_expression] = STATE(3857),
    [sym_internal_module] = STATE(3857),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3857),
    [sym_await_expression] = STATE(3857),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3857),
    [sym_this] = STATE(3857),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3857),
    [sym_generator_function] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3857),
    [sym_ternary_expression] = STATE(3857),
    [sym_binary_expression] = STATE(3857),
    [sym_template_string] = STATE(3857),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3857),
    [sym_class] = STATE(3857),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7813),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7813),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7815),
    [sym_true] = ACTIONS(7813),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7813),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3198] = {
    [sym_new_expression] = STATE(3858),
    [sym_augmented_assignment_expression] = STATE(3858),
    [sym_unary_expression] = STATE(3858),
    [sym_update_expression] = STATE(3858),
    [sym_regex] = STATE(3858),
    [sym_meta_property] = STATE(3858),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(3858),
    [sym_yield_expression] = STATE(3858),
    [sym_as_expression] = STATE(3858),
    [sym_non_null_expression] = STATE(3858),
    [sym_internal_module] = STATE(3858),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3858),
    [sym_await_expression] = STATE(3858),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(3858),
    [sym_this] = STATE(3858),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(3858),
    [sym_generator_function] = STATE(3858),
    [sym_call_expression] = STATE(3858),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(3858),
    [sym_ternary_expression] = STATE(3858),
    [sym_binary_expression] = STATE(3858),
    [sym_template_string] = STATE(3858),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3858),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3858),
    [sym_class] = STATE(3858),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(7817),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7817),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7819),
    [sym_true] = ACTIONS(7817),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7817),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3199] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(7821),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3200] = {
    [anon_sym_RPAREN] = ACTIONS(7821),
    [sym_comment] = ACTIONS(3),
  },
  [3201] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(7823),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3202] = {
    [sym_new_expression] = STATE(3861),
    [sym_augmented_assignment_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3861),
    [sym_update_expression] = STATE(3861),
    [sym_regex] = STATE(3861),
    [sym_meta_property] = STATE(3861),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(3861),
    [sym_yield_expression] = STATE(3861),
    [sym_as_expression] = STATE(3861),
    [sym_non_null_expression] = STATE(3861),
    [sym_internal_module] = STATE(3861),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3861),
    [sym_await_expression] = STATE(3861),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(3862),
    [sym_string] = STATE(3861),
    [sym_this] = STATE(3861),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(3861),
    [sym_generator_function] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(3861),
    [sym_ternary_expression] = STATE(3861),
    [sym_binary_expression] = STATE(3861),
    [sym_template_string] = STATE(3861),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(3861),
    [sym_class] = STATE(3861),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(7825),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7825),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7827),
    [sym_true] = ACTIONS(7825),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7825),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [3203] = {
    [sym_new_expression] = STATE(3863),
    [sym_augmented_assignment_expression] = STATE(3863),
    [sym_unary_expression] = STATE(3863),
    [sym_update_expression] = STATE(3863),
    [sym_regex] = STATE(3863),
    [sym_meta_property] = STATE(3863),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(3863),
    [sym_yield_expression] = STATE(3863),
    [sym_as_expression] = STATE(3863),
    [sym_non_null_expression] = STATE(3863),
    [sym_internal_module] = STATE(3863),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3863),
    [sym_await_expression] = STATE(3863),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(3864),
    [sym_string] = STATE(3863),
    [sym_this] = STATE(3863),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(3863),
    [sym_generator_function] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(3863),
    [sym_ternary_expression] = STATE(3863),
    [sym_binary_expression] = STATE(3863),
    [sym_template_string] = STATE(3863),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(3863),
    [sym_class] = STATE(3863),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(7829),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7829),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7831),
    [sym_true] = ACTIONS(7829),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7829),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [3204] = {
    [sym_new_expression] = STATE(3865),
    [sym_augmented_assignment_expression] = STATE(3865),
    [sym_unary_expression] = STATE(3865),
    [sym_update_expression] = STATE(3865),
    [sym_regex] = STATE(3865),
    [sym_meta_property] = STATE(3865),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(3865),
    [sym_yield_expression] = STATE(3865),
    [sym_as_expression] = STATE(3865),
    [sym_non_null_expression] = STATE(3865),
    [sym_internal_module] = STATE(3865),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3865),
    [sym_await_expression] = STATE(3865),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(3866),
    [sym_string] = STATE(3865),
    [sym_this] = STATE(3865),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(3865),
    [sym_generator_function] = STATE(3865),
    [sym_call_expression] = STATE(3865),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(3865),
    [sym_ternary_expression] = STATE(3865),
    [sym_binary_expression] = STATE(3865),
    [sym_template_string] = STATE(3865),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3865),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(3865),
    [sym_class] = STATE(3865),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(7833),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7833),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7835),
    [sym_true] = ACTIONS(7833),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7833),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [3205] = {
    [sym_type_alias_declaration] = STATE(3004),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3004),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3004),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3004),
    [sym_return_statement] = STATE(3004),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3004),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3004),
    [sym_switch_statement] = STATE(3004),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3004),
    [sym_throw_statement] = STATE(3004),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3004),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3004),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(3004),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3004),
    [sym_abstract_class] = STATE(3004),
    [sym_interface_declaration] = STATE(3004),
    [sym_statement_block] = STATE(3004),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3004),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3004),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3004),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3004),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3004),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3004),
    [sym_empty_statement] = STATE(3004),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(3004),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3004),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3004),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3004),
    [sym_break_statement] = STATE(3004),
    [sym_labeled_statement] = STATE(3004),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3004),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [3206] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(7837),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3207] = {
    [anon_sym_RPAREN] = ACTIONS(7837),
    [sym_comment] = ACTIONS(3),
  },
  [3208] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(7839),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3209] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(7841),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3210] = {
    [anon_sym_RPAREN] = ACTIONS(7841),
    [sym_comment] = ACTIONS(3),
  },
  [3211] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(7843),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3212] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(7845),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3213] = {
    [anon_sym_RPAREN] = ACTIONS(7845),
    [sym_comment] = ACTIONS(3),
  },
  [3214] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3877),
    [sym_constructor_type] = STATE(3877),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(3877),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3877),
    [sym_intersection_type] = STATE(3877),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3215] = {
    [sym_string] = STATE(3881),
    [sym__property_name] = STATE(3881),
    [sym_computed_property_name] = STATE(3881),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(7857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3216] = {
    [sym_string] = STATE(3881),
    [sym__property_name] = STATE(3881),
    [sym_computed_property_name] = STATE(3881),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(7857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3217] = {
    [sym_new_expression] = STATE(3882),
    [sym_augmented_assignment_expression] = STATE(3882),
    [sym_unary_expression] = STATE(3882),
    [sym_update_expression] = STATE(3882),
    [sym_regex] = STATE(3882),
    [sym_meta_property] = STATE(3882),
    [sym_call_signature] = STATE(2390),
    [sym_statement_block] = STATE(1206),
    [sym__expression] = STATE(3882),
    [sym_yield_expression] = STATE(3882),
    [sym_as_expression] = STATE(3882),
    [sym_non_null_expression] = STATE(3882),
    [sym_internal_module] = STATE(3882),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3882),
    [sym_await_expression] = STATE(3882),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3882),
    [sym_this] = STATE(3882),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3882),
    [sym_generator_function] = STATE(3882),
    [sym_call_expression] = STATE(3882),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3882),
    [sym_ternary_expression] = STATE(3882),
    [sym_binary_expression] = STATE(3882),
    [sym_template_string] = STATE(3882),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3882),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3882),
    [sym_class] = STATE(3882),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7859),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7859),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7861),
    [sym_true] = ACTIONS(7859),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7859),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3218] = {
    [sym_new_expression] = STATE(3883),
    [sym_augmented_assignment_expression] = STATE(3883),
    [sym_unary_expression] = STATE(3883),
    [sym_update_expression] = STATE(3883),
    [sym_regex] = STATE(3883),
    [sym_meta_property] = STATE(3883),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3883),
    [sym_yield_expression] = STATE(3883),
    [sym_as_expression] = STATE(3883),
    [sym_non_null_expression] = STATE(3883),
    [sym_internal_module] = STATE(3883),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3883),
    [sym_await_expression] = STATE(3883),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3883),
    [sym_this] = STATE(3883),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3883),
    [sym_generator_function] = STATE(3883),
    [sym_call_expression] = STATE(3883),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3883),
    [sym_ternary_expression] = STATE(3883),
    [sym_binary_expression] = STATE(3883),
    [sym_template_string] = STATE(3883),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3883),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3883),
    [sym_class] = STATE(3883),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7863),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7863),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7865),
    [sym_true] = ACTIONS(7863),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7863),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3219] = {
    [sym_new_expression] = STATE(3884),
    [sym_augmented_assignment_expression] = STATE(3884),
    [sym_unary_expression] = STATE(3884),
    [sym_update_expression] = STATE(3884),
    [sym_regex] = STATE(3884),
    [sym_meta_property] = STATE(3884),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3884),
    [sym_yield_expression] = STATE(3884),
    [sym_as_expression] = STATE(3884),
    [sym_non_null_expression] = STATE(3884),
    [sym_internal_module] = STATE(3884),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3884),
    [sym_await_expression] = STATE(3884),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3884),
    [sym_this] = STATE(3884),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3884),
    [sym_generator_function] = STATE(3884),
    [sym_call_expression] = STATE(3884),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3884),
    [sym_ternary_expression] = STATE(3884),
    [sym_binary_expression] = STATE(3884),
    [sym_template_string] = STATE(3884),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3884),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3884),
    [sym_class] = STATE(3884),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7867),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7867),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7869),
    [sym_true] = ACTIONS(7867),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7867),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3220] = {
    [sym_new_expression] = STATE(3885),
    [sym_augmented_assignment_expression] = STATE(3885),
    [sym_unary_expression] = STATE(3885),
    [sym_update_expression] = STATE(3885),
    [sym_regex] = STATE(3885),
    [sym_meta_property] = STATE(3885),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3885),
    [sym_yield_expression] = STATE(3885),
    [sym_as_expression] = STATE(3885),
    [sym_non_null_expression] = STATE(3885),
    [sym_internal_module] = STATE(3885),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3885),
    [sym_await_expression] = STATE(3885),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3885),
    [sym_this] = STATE(3885),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3885),
    [sym_generator_function] = STATE(3885),
    [sym_call_expression] = STATE(3885),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3885),
    [sym_ternary_expression] = STATE(3885),
    [sym_binary_expression] = STATE(3885),
    [sym_template_string] = STATE(3885),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3885),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3885),
    [sym_class] = STATE(3885),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7871),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7871),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7873),
    [sym_true] = ACTIONS(7871),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7871),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3221] = {
    [sym_new_expression] = STATE(3886),
    [sym_augmented_assignment_expression] = STATE(3886),
    [sym_unary_expression] = STATE(3886),
    [sym_update_expression] = STATE(3886),
    [sym_regex] = STATE(3886),
    [sym_meta_property] = STATE(3886),
    [sym_call_signature] = STATE(2390),
    [sym_statement_block] = STATE(1213),
    [sym__expression] = STATE(3886),
    [sym_yield_expression] = STATE(3886),
    [sym_as_expression] = STATE(3886),
    [sym_non_null_expression] = STATE(3886),
    [sym_internal_module] = STATE(3886),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3886),
    [sym_await_expression] = STATE(3886),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3886),
    [sym_this] = STATE(3886),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3886),
    [sym_generator_function] = STATE(3886),
    [sym_call_expression] = STATE(3886),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3886),
    [sym_ternary_expression] = STATE(3886),
    [sym_binary_expression] = STATE(3886),
    [sym_template_string] = STATE(3886),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3886),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3886),
    [sym_class] = STATE(3886),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7875),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7875),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7877),
    [sym_true] = ACTIONS(7875),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7875),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3222] = {
    [sym_new_expression] = STATE(3887),
    [sym_augmented_assignment_expression] = STATE(3887),
    [sym_unary_expression] = STATE(3887),
    [sym_update_expression] = STATE(3887),
    [sym_regex] = STATE(3887),
    [sym_meta_property] = STATE(3887),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3887),
    [sym_yield_expression] = STATE(3887),
    [sym_as_expression] = STATE(3887),
    [sym_non_null_expression] = STATE(3887),
    [sym_internal_module] = STATE(3887),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3887),
    [sym_await_expression] = STATE(3887),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3887),
    [sym_this] = STATE(3887),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3887),
    [sym_generator_function] = STATE(3887),
    [sym_call_expression] = STATE(3887),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3887),
    [sym_ternary_expression] = STATE(3887),
    [sym_binary_expression] = STATE(3887),
    [sym_template_string] = STATE(3887),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3887),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3887),
    [sym_class] = STATE(3887),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7879),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7879),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7881),
    [sym_true] = ACTIONS(7879),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7879),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3223] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(7883),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [3224] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(726),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(728),
    [anon_sym_GT_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG_EQ] = ACTIONS(728),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_instanceof] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(7883),
    [anon_sym_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(726),
    [anon_sym_STAR_STAR] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
  },
  [3225] = {
    [anon_sym_EQ_GT] = ACTIONS(7886),
    [sym_comment] = ACTIONS(3),
  },
  [3226] = {
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(3),
  },
  [3227] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_GT_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_DASH_DASH] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_instanceof] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_STAR_STAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(833),
  },
  [3228] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(863),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [3229] = {
    [sym__initializer] = STATE(517),
    [sym_arguments] = STATE(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT_EQ] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(6607),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_instanceof] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1599),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1601),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
  },
  [3230] = {
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [3231] = {
    [sym_new_expression] = STATE(878),
    [sym_augmented_assignment_expression] = STATE(878),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(878),
    [sym_update_expression] = STATE(878),
    [sym_regex] = STATE(878),
    [sym_meta_property] = STATE(878),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(878),
    [sym_yield_expression] = STATE(878),
    [sym_as_expression] = STATE(878),
    [sym_non_null_expression] = STATE(878),
    [sym_internal_module] = STATE(878),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(878),
    [sym_await_expression] = STATE(878),
    [sym_member_expression] = STATE(879),
    [sym_string] = STATE(878),
    [sym_this] = STATE(878),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(880),
    [sym_anonymous_class] = STATE(878),
    [sym_generator_function] = STATE(878),
    [sym_call_expression] = STATE(878),
    [sym_subscript_expression] = STATE(879),
    [sym_assignment_expression] = STATE(878),
    [sym_ternary_expression] = STATE(878),
    [sym_binary_expression] = STATE(878),
    [sym_template_string] = STATE(878),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(878),
    [sym_array] = STATE(881),
    [sym_type_assertion] = STATE(878),
    [sym_class] = STATE(878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(526),
    [sym_true] = ACTIONS(1615),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [sym_false] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [sym_null] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [sym_number] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [3232] = {
    [sym_call_signature] = STATE(3225),
    [sym__initializer] = STATE(523),
    [sym_formal_parameters] = STATE(57),
    [sym_type_parameters] = STATE(54),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(6623),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(6625),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(6625),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(6625),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(6625),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(6625),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_set] = ACTIONS(6625),
    [anon_sym_type] = ACTIONS(6625),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(6625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(6625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(6625),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(6625),
    [anon_sym_declare] = ACTIONS(6625),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(6625),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(6625),
    [anon_sym_async] = ACTIONS(6625),
    [anon_sym_public] = ACTIONS(6625),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(6625),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(6625),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [3233] = {
    [sym_nested_identifier] = STATE(560),
    [sym__module] = STATE(561),
    [sym_string] = STATE(562),
    [sym__initializer] = STATE(523),
    [sym_arguments] = STATE(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_AMP_EQ] = ACTIONS(1603),
    [anon_sym_PLUS_EQ] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_CARET_EQ] = ACTIONS(1603),
    [anon_sym_STAR_EQ] = ACTIONS(1603),
    [anon_sym_PIPE_EQ] = ACTIONS(1603),
    [anon_sym_DASH_EQ] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_LT_LT_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_EQ_EQ] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_SLASH_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT_EQ] = ACTIONS(1603),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1603),
    [anon_sym_GT_GT] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1611),
  },
  [3234] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [3235] = {
    [sym_new_expression] = STATE(3890),
    [sym_augmented_assignment_expression] = STATE(3890),
    [sym_unary_expression] = STATE(3890),
    [sym_update_expression] = STATE(3890),
    [sym_regex] = STATE(3890),
    [sym_meta_property] = STATE(3890),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3890),
    [sym_yield_expression] = STATE(3890),
    [sym_as_expression] = STATE(3890),
    [sym_non_null_expression] = STATE(3890),
    [sym_internal_module] = STATE(3890),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3890),
    [sym_await_expression] = STATE(3890),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3890),
    [sym_this] = STATE(3890),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3890),
    [sym_generator_function] = STATE(3890),
    [sym_call_expression] = STATE(3890),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3890),
    [sym_ternary_expression] = STATE(3890),
    [sym_binary_expression] = STATE(3890),
    [sym_template_string] = STATE(3890),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3890),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3890),
    [sym_class] = STATE(3890),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7890),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7890),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7892),
    [sym_true] = ACTIONS(7890),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7890),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3236] = {
    [sym_new_expression] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(3891),
    [sym_unary_expression] = STATE(3891),
    [sym_update_expression] = STATE(3891),
    [sym_regex] = STATE(3891),
    [sym_meta_property] = STATE(3891),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3891),
    [sym_yield_expression] = STATE(3891),
    [sym_as_expression] = STATE(3891),
    [sym_non_null_expression] = STATE(3891),
    [sym_internal_module] = STATE(3891),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3891),
    [sym_await_expression] = STATE(3891),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3891),
    [sym_this] = STATE(3891),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3891),
    [sym_generator_function] = STATE(3891),
    [sym_call_expression] = STATE(3891),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3891),
    [sym_ternary_expression] = STATE(3891),
    [sym_binary_expression] = STATE(3891),
    [sym_template_string] = STATE(3891),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3891),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3891),
    [sym_class] = STATE(3891),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7894),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7894),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7896),
    [sym_true] = ACTIONS(7894),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7894),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3237] = {
    [sym_new_expression] = STATE(3892),
    [sym_augmented_assignment_expression] = STATE(3892),
    [sym_unary_expression] = STATE(3892),
    [sym_update_expression] = STATE(3892),
    [sym_regex] = STATE(3892),
    [sym_meta_property] = STATE(3892),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3892),
    [sym_yield_expression] = STATE(3892),
    [sym_as_expression] = STATE(3892),
    [sym_non_null_expression] = STATE(3892),
    [sym_internal_module] = STATE(3892),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3892),
    [sym_await_expression] = STATE(3892),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3892),
    [sym_this] = STATE(3892),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3892),
    [sym_generator_function] = STATE(3892),
    [sym_call_expression] = STATE(3892),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3892),
    [sym_ternary_expression] = STATE(3892),
    [sym_binary_expression] = STATE(3892),
    [sym_template_string] = STATE(3892),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3892),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3892),
    [sym_class] = STATE(3892),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7898),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7898),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7900),
    [sym_true] = ACTIONS(7898),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7898),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3238] = {
    [sym_new_expression] = STATE(3893),
    [sym_augmented_assignment_expression] = STATE(3893),
    [sym_unary_expression] = STATE(3893),
    [sym_update_expression] = STATE(3893),
    [sym_regex] = STATE(3893),
    [sym_meta_property] = STATE(3893),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3893),
    [sym_yield_expression] = STATE(3893),
    [sym_as_expression] = STATE(3893),
    [sym_non_null_expression] = STATE(3893),
    [sym_internal_module] = STATE(3893),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3893),
    [sym_await_expression] = STATE(3893),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3893),
    [sym_this] = STATE(3893),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3893),
    [sym_generator_function] = STATE(3893),
    [sym_call_expression] = STATE(3893),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3893),
    [sym_ternary_expression] = STATE(3893),
    [sym_binary_expression] = STATE(3893),
    [sym_template_string] = STATE(3893),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3893),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3893),
    [sym_class] = STATE(3893),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7902),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7902),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7904),
    [sym_true] = ACTIONS(7902),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7902),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3239] = {
    [sym_new_expression] = STATE(3894),
    [sym_augmented_assignment_expression] = STATE(3894),
    [sym_unary_expression] = STATE(3894),
    [sym_update_expression] = STATE(3894),
    [sym_regex] = STATE(3894),
    [sym_meta_property] = STATE(3894),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3894),
    [sym_yield_expression] = STATE(3894),
    [sym_as_expression] = STATE(3894),
    [sym_non_null_expression] = STATE(3894),
    [sym_internal_module] = STATE(3894),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3894),
    [sym_await_expression] = STATE(3894),
    [sym_member_expression] = STATE(2392),
    [sym_sequence_expression] = STATE(1494),
    [sym_string] = STATE(3894),
    [sym_this] = STATE(3894),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3894),
    [sym_generator_function] = STATE(3894),
    [sym_call_expression] = STATE(3894),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3894),
    [sym_ternary_expression] = STATE(3894),
    [sym_binary_expression] = STATE(3894),
    [sym_template_string] = STATE(3894),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3894),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3894),
    [sym_class] = STATE(3894),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7906),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7906),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7908),
    [sym_true] = ACTIONS(7906),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7906),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3240] = {
    [sym_new_expression] = STATE(3895),
    [sym_augmented_assignment_expression] = STATE(3895),
    [sym_unary_expression] = STATE(3895),
    [sym_update_expression] = STATE(3895),
    [sym_regex] = STATE(3895),
    [sym_meta_property] = STATE(3895),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(3895),
    [sym_yield_expression] = STATE(3895),
    [sym_as_expression] = STATE(3895),
    [sym_non_null_expression] = STATE(3895),
    [sym_internal_module] = STATE(3895),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3895),
    [sym_await_expression] = STATE(3895),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(3895),
    [sym_this] = STATE(3895),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(3895),
    [sym_generator_function] = STATE(3895),
    [sym_call_expression] = STATE(3895),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(3895),
    [sym_ternary_expression] = STATE(3895),
    [sym_binary_expression] = STATE(3895),
    [sym_template_string] = STATE(3895),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3895),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(3895),
    [sym_class] = STATE(3895),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(7910),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7910),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7912),
    [sym_true] = ACTIONS(7910),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7910),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [3241] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(1262),
    [sym_constructor_type] = STATE(1262),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(1262),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_template_string] = STATE(1266),
    [sym_union_type] = STATE(1262),
    [sym_intersection_type] = STATE(1262),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_keyof] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(7916),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2607),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(302),
  },
  [3242] = {
    [sym_new_expression] = STATE(3883),
    [sym_constructor_type] = STATE(279),
    [sym_augmented_assignment_expression] = STATE(3883),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3883),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3883),
    [sym_call_signature] = STATE(2390),
    [sym_yield_expression] = STATE(3883),
    [sym_as_expression] = STATE(3883),
    [sym_internal_module] = STATE(3883),
    [sym_arrow_function] = STATE(3883),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(2392),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(1001),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(2394),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(3883),
    [sym_subscript_expression] = STATE(2392),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3883),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3883),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1002),
    [sym_intersection_type] = STATE(279),
    [sym__type] = STATE(279),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3883),
    [sym_meta_property] = STATE(3883),
    [sym_function_type] = STATE(279),
    [sym__expression] = STATE(3883),
    [sym_non_null_expression] = STATE(3883),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(3883),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3883),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(3883),
    [sym_call_expression] = STATE(3883),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3883),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3883),
    [sym_type_arguments] = STATE(2395),
    [sym_union_type] = STATE(279),
    [sym_parenthesized_expression] = STATE(3883),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3883),
    [sym_class] = STATE(3883),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(7924),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(7926),
    [anon_sym_number] = ACTIONS(7926),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(7928),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(7930),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(7932),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(7863),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(7926),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(7926),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(7926),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7863),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(7934),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(7930),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3243] = {
    [sym_type_alias_declaration] = STATE(3910),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3910),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3910),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3910),
    [sym_return_statement] = STATE(3910),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3910),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3910),
    [sym_switch_statement] = STATE(3910),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3910),
    [sym_throw_statement] = STATE(3910),
    [aux_sym_program_repeat1] = STATE(3910),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3910),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3910),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3910),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3910),
    [sym_abstract_class] = STATE(3910),
    [sym_interface_declaration] = STATE(3910),
    [sym_statement_block] = STATE(3910),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3910),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3910),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3910),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3910),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3910),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3910),
    [sym_empty_statement] = STATE(3910),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3910),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3910),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3910),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3910),
    [sym_break_statement] = STATE(3910),
    [sym_labeled_statement] = STATE(3910),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3910),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(7936),
    [anon_sym_default] = ACTIONS(7938),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(7938),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [3244] = {
    [sym_new_expression] = STATE(3911),
    [sym_augmented_assignment_expression] = STATE(3911),
    [sym_unary_expression] = STATE(3911),
    [sym_update_expression] = STATE(3911),
    [sym_regex] = STATE(3911),
    [sym_meta_property] = STATE(3911),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3911),
    [sym_yield_expression] = STATE(3911),
    [sym_as_expression] = STATE(3911),
    [sym_non_null_expression] = STATE(3911),
    [sym_internal_module] = STATE(3911),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3911),
    [sym_await_expression] = STATE(3911),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3911),
    [sym_this] = STATE(3911),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3911),
    [sym_generator_function] = STATE(3911),
    [sym_call_expression] = STATE(3911),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3911),
    [sym_ternary_expression] = STATE(3911),
    [sym_binary_expression] = STATE(3911),
    [sym_template_string] = STATE(3911),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3911),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3911),
    [sym_class] = STATE(3911),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(7940),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7940),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(7942),
    [sym_true] = ACTIONS(7940),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7940),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3245] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7944),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [3246] = {
    [sym_parenthesized_expression] = STATE(3913),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [3247] = {
    [anon_sym_await] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7948),
    [sym_comment] = ACTIONS(3),
  },
  [3248] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(3919),
    [sym__declaration] = STATE(192),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(3919),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(322),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(7950),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(7952),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(7954),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3249] = {
    [sym_parenthesized_expression] = STATE(3920),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [3250] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(3919),
    [sym__declaration] = STATE(317),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(3919),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_as] = ACTIONS(541),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(7952),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(7954),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3251] = {
    [sym_parenthesized_expression] = STATE(3921),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [3252] = {
    [sym_type_alias_declaration] = STATE(3922),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3922),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3922),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3922),
    [sym_return_statement] = STATE(3922),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3922),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3922),
    [sym_switch_statement] = STATE(3922),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3922),
    [sym_throw_statement] = STATE(3922),
    [aux_sym_program_repeat1] = STATE(3922),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3922),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3922),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3922),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3922),
    [sym_abstract_class] = STATE(3922),
    [sym_interface_declaration] = STATE(3922),
    [sym_statement_block] = STATE(3922),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3922),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3922),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3922),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3922),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3922),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3922),
    [sym_empty_statement] = STATE(3922),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3922),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3922),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3922),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3922),
    [sym_break_statement] = STATE(3922),
    [sym_labeled_statement] = STATE(3922),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3922),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(7956),
    [anon_sym_default] = ACTIONS(7958),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(7958),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [3253] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(7960),
    [anon_sym_class] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [3254] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3255] = {
    [sym_formal_parameters] = STATE(3924),
    [sym_type_parameters] = STATE(3925),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3256] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3257] = {
    [anon_sym_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_RPAREN] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(7962),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(7964),
    [sym_comment] = ACTIONS(3),
  },
  [3258] = {
    [sym_formal_parameters] = STATE(3928),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3259] = {
    [anon_sym_EQ_GT] = ACTIONS(7966),
    [sym_comment] = ACTIONS(3),
  },
  [3260] = {
    [anon_sym_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_RPAREN] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(7962),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(7964),
    [sym_comment] = ACTIONS(3),
  },
  [3261] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3930),
    [sym_constructor_type] = STATE(3930),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(3930),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3930),
    [sym_intersection_type] = STATE(3930),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1460),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1462),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3262] = {
    [anon_sym_EQ_GT] = ACTIONS(7968),
    [sym_comment] = ACTIONS(3),
  },
  [3263] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3932),
    [sym_constructor_type] = STATE(3932),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(3932),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3932),
    [sym_intersection_type] = STATE(3932),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1460),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1462),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3264] = {
    [anon_sym_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_RPAREN] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(7962),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(7964),
    [sym_comment] = ACTIONS(3),
  },
  [3265] = {
    [anon_sym_EQ] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(5028),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [3266] = {
    [anon_sym_COMMA] = ACTIONS(7970),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [sym_comment] = ACTIONS(3),
  },
  [3267] = {
    [anon_sym_COMMA] = ACTIONS(7972),
    [anon_sym_RPAREN] = ACTIONS(7972),
    [sym_comment] = ACTIONS(3),
  },
  [3268] = {
    [anon_sym_COMMA] = ACTIONS(7974),
    [anon_sym_RPAREN] = ACTIONS(7974),
    [sym_comment] = ACTIONS(3),
  },
  [3269] = {
    [anon_sym_COMMA] = ACTIONS(7976),
    [anon_sym_RPAREN] = ACTIONS(7976),
    [sym_comment] = ACTIONS(3),
  },
  [3270] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3936),
    [sym_constructor_type] = STATE(3936),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(3936),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3936),
    [sym_intersection_type] = STATE(3936),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3271] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3939),
    [sym_constructor_type] = STATE(3939),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(3939),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3939),
    [sym_intersection_type] = STATE(3939),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3272] = {
    [anon_sym_EQ_GT] = ACTIONS(7984),
    [sym_comment] = ACTIONS(3),
  },
  [3273] = {
    [sym_formal_parameters] = STATE(3941),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3274] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2428),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2430),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5060),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3275] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2428),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2430),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5060),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3276] = {
    [anon_sym_EQ_GT] = ACTIONS(7986),
    [sym_comment] = ACTIONS(3),
  },
  [3277] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3943),
    [sym_constructor_type] = STATE(3943),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(3943),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3943),
    [sym_intersection_type] = STATE(3943),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3278] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3944),
    [sym_constructor_type] = STATE(3944),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(3944),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3944),
    [sym_intersection_type] = STATE(3944),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2428),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2430),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5060),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3279] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(7180),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7180),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1331),
  },
  [3280] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(7988),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(7990),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_RPAREN] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5196),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [3281] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(7988),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(7990),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_RPAREN] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5204),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [3282] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3945),
    [sym_constructor_type] = STATE(3945),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(3945),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3945),
    [sym_intersection_type] = STATE(3945),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3283] = {
    [anon_sym_EQ_GT] = ACTIONS(7992),
    [sym_comment] = ACTIONS(3),
  },
  [3284] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3947),
    [sym_constructor_type] = STATE(3947),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(3947),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3947),
    [sym_intersection_type] = STATE(3947),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3285] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(7988),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(7990),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_RPAREN] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5406),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [3286] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(7988),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(7990),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5425),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [3287] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1374),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1376),
    [anon_sym_symbol] = ACTIONS(1376),
    [anon_sym_number] = ACTIONS(1376),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1378),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1376),
    [anon_sym_private] = ACTIONS(1376),
    [anon_sym_boolean] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1380),
    [anon_sym_public] = ACTIONS(1376),
    [anon_sym_get] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1376),
    [anon_sym_string] = ACTIONS(1376),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1376),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(1376),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3288] = {
    [anon_sym_COMMA] = ACTIONS(7994),
    [anon_sym_RPAREN] = ACTIONS(7994),
    [sym_comment] = ACTIONS(3),
  },
  [3289] = {
    [sym__initializer] = STATE(3948),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(7994),
    [anon_sym_COMMA] = ACTIONS(7994),
    [sym_comment] = ACTIONS(3),
  },
  [3290] = {
    [anon_sym_COMMA] = ACTIONS(7996),
    [anon_sym_RPAREN] = ACTIONS(7996),
    [sym_comment] = ACTIONS(3),
  },
  [3291] = {
    [sym__initializer] = STATE(3949),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(7972),
    [anon_sym_COMMA] = ACTIONS(7972),
    [sym_comment] = ACTIONS(3),
  },
  [3292] = {
    [anon_sym_COMMA] = ACTIONS(7998),
    [anon_sym_RPAREN] = ACTIONS(7998),
    [sym_comment] = ACTIONS(3),
  },
  [3293] = {
    [anon_sym_COMMA] = ACTIONS(8000),
    [anon_sym_RPAREN] = ACTIONS(8000),
    [sym_comment] = ACTIONS(3),
  },
  [3294] = {
    [sym__initializer] = STATE(3950),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(8000),
    [anon_sym_COMMA] = ACTIONS(8000),
    [sym_comment] = ACTIONS(3),
  },
  [3295] = {
    [anon_sym_COMMA] = ACTIONS(8002),
    [anon_sym_RPAREN] = ACTIONS(8002),
    [sym_comment] = ACTIONS(3),
  },
  [3296] = {
    [anon_sym_COMMA] = ACTIONS(8004),
    [anon_sym_RPAREN] = ACTIONS(8004),
    [sym_comment] = ACTIONS(3),
  },
  [3297] = {
    [sym__initializer] = STATE(3951),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(8004),
    [anon_sym_COMMA] = ACTIONS(8004),
    [sym_comment] = ACTIONS(3),
  },
  [3298] = {
    [anon_sym_COMMA] = ACTIONS(8006),
    [anon_sym_RPAREN] = ACTIONS(8006),
    [sym_comment] = ACTIONS(3),
  },
  [3299] = {
    [anon_sym_COLON] = ACTIONS(8008),
    [anon_sym_EQ_GT] = ACTIONS(8008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8008),
  },
  [3300] = {
    [sym_statement_block] = STATE(3952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [3301] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3302] = {
    [sym_formal_parameters] = STATE(3953),
    [sym_type_parameters] = STATE(3954),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3303] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3304] = {
    [anon_sym_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(8010),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8012),
    [sym_comment] = ACTIONS(3),
  },
  [3305] = {
    [sym_formal_parameters] = STATE(3957),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3306] = {
    [anon_sym_EQ_GT] = ACTIONS(8014),
    [sym_comment] = ACTIONS(3),
  },
  [3307] = {
    [anon_sym_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(8010),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8012),
    [sym_comment] = ACTIONS(3),
  },
  [3308] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3959),
    [sym_constructor_type] = STATE(3959),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(3959),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3959),
    [sym_intersection_type] = STATE(3959),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1549),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1551),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3309] = {
    [anon_sym_EQ_GT] = ACTIONS(8016),
    [sym_comment] = ACTIONS(3),
  },
  [3310] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3961),
    [sym_constructor_type] = STATE(3961),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(3961),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3961),
    [sym_intersection_type] = STATE(3961),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1549),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1551),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3311] = {
    [anon_sym_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(8010),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8012),
    [sym_comment] = ACTIONS(3),
  },
  [3312] = {
    [anon_sym_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [3313] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3314] = {
    [sym_formal_parameters] = STATE(3962),
    [sym_type_parameters] = STATE(3963),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3315] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3316] = {
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8020),
    [anon_sym_RBRACK] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
  },
  [3317] = {
    [sym_formal_parameters] = STATE(3966),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3318] = {
    [anon_sym_EQ_GT] = ACTIONS(8022),
    [sym_comment] = ACTIONS(3),
  },
  [3319] = {
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8020),
    [anon_sym_RBRACK] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
  },
  [3320] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3968),
    [sym_constructor_type] = STATE(3968),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(3968),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3968),
    [sym_intersection_type] = STATE(3968),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3321] = {
    [anon_sym_EQ_GT] = ACTIONS(8024),
    [sym_comment] = ACTIONS(3),
  },
  [3322] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3970),
    [sym_constructor_type] = STATE(3970),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(3970),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3970),
    [sym_intersection_type] = STATE(3970),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3323] = {
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8020),
    [anon_sym_RBRACK] = ACTIONS(5406),
    [sym_comment] = ACTIONS(3),
  },
  [3324] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [3325] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3971),
    [sym_constructor_type] = STATE(3971),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(3971),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3971),
    [sym_intersection_type] = STATE(3971),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3326] = {
    [anon_sym_EQ_GT] = ACTIONS(8026),
    [sym_comment] = ACTIONS(3),
  },
  [3327] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(3973),
    [sym_constructor_type] = STATE(3973),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(3973),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(3973),
    [sym_intersection_type] = STATE(3973),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3328] = {
    [anon_sym_GT] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(5198),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [3329] = {
    [anon_sym_RBRACK] = ACTIONS(8028),
    [sym_comment] = ACTIONS(3),
  },
  [3330] = {
    [anon_sym_RBRACK] = ACTIONS(8030),
    [sym_comment] = ACTIONS(3),
  },
  [3331] = {
    [sym_identifier] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8034),
    [anon_sym_debugger] = ACTIONS(8032),
    [anon_sym_symbol] = ACTIONS(8032),
    [anon_sym_AT] = ACTIONS(8034),
    [anon_sym_PIPE] = ACTIONS(8034),
    [anon_sym_COMMA] = ACTIONS(8034),
    [anon_sym_DASH] = ACTIONS(8032),
    [anon_sym_EQ] = ACTIONS(8032),
    [anon_sym_void] = ACTIONS(8032),
    [anon_sym_break] = ACTIONS(8032),
    [anon_sym_const] = ACTIONS(8032),
    [sym_super] = ACTIONS(8032),
    [anon_sym_return] = ACTIONS(8032),
    [anon_sym_private] = ACTIONS(8032),
    [anon_sym_get] = ACTIONS(8032),
    [anon_sym_RBRACE] = ACTIONS(8034),
    [anon_sym_interface] = ACTIONS(8032),
    [anon_sym_default] = ACTIONS(8032),
    [anon_sym_enum] = ACTIONS(8032),
    [anon_sym_delete] = ACTIONS(8032),
    [anon_sym_continue] = ACTIONS(8032),
    [anon_sym_DASH_DASH] = ACTIONS(8034),
    [anon_sym_if] = ACTIONS(8032),
    [anon_sym_this] = ACTIONS(8032),
    [anon_sym_yield] = ACTIONS(8032),
    [sym_true] = ACTIONS(8032),
    [anon_sym_throw] = ACTIONS(8032),
    [anon_sym_protected] = ACTIONS(8032),
    [anon_sym_abstract] = ACTIONS(8032),
    [anon_sym_set] = ACTIONS(8032),
    [anon_sym_type] = ACTIONS(8032),
    [anon_sym_import] = ACTIONS(8032),
    [anon_sym_namespace] = ACTIONS(8032),
    [anon_sym_PLUS_PLUS] = ACTIONS(8034),
    [anon_sym_await] = ACTIONS(8032),
    [anon_sym_DQUOTE] = ACTIONS(8034),
    [anon_sym_else] = ACTIONS(8032),
    [anon_sym_BANG] = ACTIONS(8034),
    [anon_sym_for] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(8034),
    [sym_false] = ACTIONS(8032),
    [anon_sym_SEMI] = ACTIONS(8034),
    [anon_sym_case] = ACTIONS(8032),
    [anon_sym_module] = ACTIONS(8032),
    [anon_sym_number] = ACTIONS(8032),
    [anon_sym_class] = ACTIONS(8032),
    [anon_sym_declare] = ACTIONS(8032),
    [anon_sym_typeof] = ACTIONS(8032),
    [anon_sym_LBRACE] = ACTIONS(8034),
    [anon_sym_switch] = ACTIONS(8032),
    [anon_sym_LPAREN] = ACTIONS(8034),
    [anon_sym_RBRACK] = ACTIONS(8034),
    [sym_null] = ACTIONS(8032),
    [anon_sym_GT] = ACTIONS(8034),
    [anon_sym_any] = ACTIONS(8032),
    [anon_sym_boolean] = ACTIONS(8032),
    [anon_sym_async] = ACTIONS(8032),
    [anon_sym_public] = ACTIONS(8032),
    [anon_sym_EQ_GT] = ACTIONS(8034),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_var] = ACTIONS(8032),
    [anon_sym_while] = ACTIONS(8032),
    [anon_sym_SQUOTE] = ACTIONS(8034),
    [anon_sym_try] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8034),
    [sym_number] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8032),
    [anon_sym_function] = ACTIONS(8032),
    [sym_undefined] = ACTIONS(8032),
    [anon_sym_new] = ACTIONS(8032),
    [ts_builtin_sym_end] = ACTIONS(8034),
    [anon_sym_let] = ACTIONS(8032),
    [anon_sym_PLUS] = ACTIONS(8032),
    [anon_sym_export] = ACTIONS(8032),
    [anon_sym_do] = ACTIONS(8032),
    [anon_sym_TILDE] = ACTIONS(8034),
    [anon_sym_with] = ACTIONS(8032),
  },
  [3332] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(8036),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8036),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [3333] = {
    [sym__automatic_semicolon] = ACTIONS(7690),
    [anon_sym_RBRACE] = ACTIONS(7690),
    [anon_sym_SEMI] = ACTIONS(7690),
    [anon_sym_COMMA] = ACTIONS(7690),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7690),
    [sym_comment] = ACTIONS(3),
  },
  [3334] = {
    [aux_sym_export_statement_repeat1] = STATE(1485),
    [sym_decorator] = STATE(1485),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(1486),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(1486),
    [sym_optional_parameter] = STATE(1486),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(8038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [3335] = {
    [anon_sym_COLON] = ACTIONS(5074),
    [anon_sym_RBRACE] = ACTIONS(5074),
    [sym__automatic_semicolon] = ACTIONS(5074),
    [anon_sym_SEMI] = ACTIONS(5074),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5074),
    [anon_sym_COMMA] = ACTIONS(5074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5074),
  },
  [3336] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1488),
    [anon_sym_COMMA] = ACTIONS(8040),
    [anon_sym_RPAREN] = ACTIONS(8038),
    [sym_comment] = ACTIONS(3),
  },
  [3337] = {
    [sym_call_signature] = STATE(3979),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3338] = {
    [sym_call_signature] = STATE(3979),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(8042),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [3339] = {
    [sym_string] = STATE(3981),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(3981),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3340] = {
    [sym_string] = STATE(3981),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(3981),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(8044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3341] = {
    [sym_call_signature] = STATE(3979),
    [sym_type_annotation] = STATE(3982),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [sym__automatic_semicolon] = ACTIONS(8046),
    [anon_sym_RBRACE] = ACTIONS(8046),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(8046),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8046),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(8046),
    [sym_comment] = ACTIONS(3),
  },
  [3342] = {
    [sym__automatic_semicolon] = ACTIONS(8046),
    [anon_sym_RBRACE] = ACTIONS(8046),
    [anon_sym_SEMI] = ACTIONS(8046),
    [anon_sym_COMMA] = ACTIONS(8046),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8046),
    [sym_comment] = ACTIONS(3),
  },
  [3343] = {
    [sym__automatic_semicolon] = ACTIONS(8048),
    [anon_sym_RBRACE] = ACTIONS(8048),
    [anon_sym_SEMI] = ACTIONS(8048),
    [anon_sym_COMMA] = ACTIONS(8048),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8048),
    [sym_comment] = ACTIONS(3),
  },
  [3344] = {
    [sym__automatic_semicolon] = ACTIONS(3218),
    [anon_sym_RBRACE] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_COMMA] = ACTIONS(3218),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
  },
  [3345] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1079),
    [sym__automatic_semicolon] = ACTIONS(8050),
    [anon_sym_SEMI] = ACTIONS(8050),
    [anon_sym_COMMA] = ACTIONS(767),
    [sym_comment] = ACTIONS(3),
  },
  [3346] = {
    [sym_object_type] = STATE(3984),
    [sym_extends_clause] = STATE(3985),
    [anon_sym_extends] = ACTIONS(821),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1982),
  },
  [3347] = {
    [sym__automatic_semicolon] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_COMMA] = ACTIONS(2371),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
  },
  [3348] = {
    [sym_object_type] = STATE(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1982),
  },
  [3349] = {
    [sym__automatic_semicolon] = ACTIONS(5494),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_SEMI] = ACTIONS(5494),
    [anon_sym_COMMA] = ACTIONS(5494),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5494),
    [sym_comment] = ACTIONS(3),
  },
  [3350] = {
    [sym_computed_property_name] = STATE(1144),
    [sym__enum_member] = STATE(3987),
    [sym__property_name] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_enum_assignment] = STATE(3987),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(8052),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3351] = {
    [sym__automatic_semicolon] = ACTIONS(2379),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_COMMA] = ACTIONS(2379),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2379),
    [sym_comment] = ACTIONS(3),
  },
  [3352] = {
    [sym__automatic_semicolon] = ACTIONS(8054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(8054),
  },
  [3353] = {
    [sym_identifier] = ACTIONS(8056),
    [sym_comment] = ACTIONS(3),
  },
  [3354] = {
    [sym__automatic_semicolon] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2851),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
  },
  [3355] = {
    [sym_statement_block] = STATE(1536),
    [sym__automatic_semicolon] = ACTIONS(8058),
    [anon_sym_SEMI] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(901),
  },
  [3356] = {
    [sym_enum_body] = STATE(3991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6847),
  },
  [3357] = {
    [sym__automatic_semicolon] = ACTIONS(2229),
    [anon_sym_RBRACE] = ACTIONS(2229),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym_COMMA] = ACTIONS(2229),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
  },
  [3358] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1079),
    [sym__automatic_semicolon] = ACTIONS(8060),
    [anon_sym_SEMI] = ACTIONS(8060),
    [anon_sym_COMMA] = ACTIONS(767),
    [sym_comment] = ACTIONS(3),
  },
  [3359] = {
    [sym_class_heritage] = STATE(3993),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_type_parameters] = STATE(3994),
    [sym_class_body] = STATE(3995),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [3360] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(3996),
    [sym_constructor_type] = STATE(3996),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(3996),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(3996),
    [sym_intersection_type] = STATE(3996),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3361] = {
    [anon_sym_EQ] = ACTIONS(8062),
    [sym_comment] = ACTIONS(3),
  },
  [3362] = {
    [sym_nested_identifier] = STATE(3998),
    [sym_identifier] = ACTIONS(8064),
    [sym_comment] = ACTIONS(3),
  },
  [3363] = {
    [sym_call_signature] = STATE(3999),
    [sym_formal_parameters] = STATE(858),
    [sym_type_parameters] = STATE(859),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3364] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(8054),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(8054),
    [anon_sym_in] = ACTIONS(3626),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(604),
  },
  [3365] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4003),
    [sym_constructor_type] = STATE(4003),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4003),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4003),
    [sym_intersection_type] = STATE(4003),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3366] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4006),
    [sym_constructor_type] = STATE(4006),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4006),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4006),
    [sym_intersection_type] = STATE(4006),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3367] = {
    [anon_sym_EQ_GT] = ACTIONS(8072),
    [sym_comment] = ACTIONS(3),
  },
  [3368] = {
    [sym_formal_parameters] = STATE(4008),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3369] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2539),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2541),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5286),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3370] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2539),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2541),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5286),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3371] = {
    [anon_sym_EQ_GT] = ACTIONS(8074),
    [sym_comment] = ACTIONS(3),
  },
  [3372] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4010),
    [sym_constructor_type] = STATE(4010),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4010),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4010),
    [sym_intersection_type] = STATE(4010),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3373] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4011),
    [sym_constructor_type] = STATE(4011),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4011),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4011),
    [sym_intersection_type] = STATE(4011),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2539),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2541),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5286),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3374] = {
    [sym_string] = STATE(3981),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(3981),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [3375] = {
    [sym_string] = STATE(3981),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(3981),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(8076),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(8078),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(8078),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [3376] = {
    [sym_call_signature] = STATE(3979),
    [sym_type_annotation] = STATE(3982),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [sym__automatic_semicolon] = ACTIONS(8046),
    [anon_sym_RBRACE] = ACTIONS(8046),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(8046),
    [anon_sym_QMARK] = ACTIONS(8080),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8046),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(8046),
    [sym_comment] = ACTIONS(3),
  },
  [3377] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [3378] = {
    [anon_sym_EQ_GT] = ACTIONS(8082),
    [sym_comment] = ACTIONS(3),
  },
  [3379] = {
    [sym_formal_parameters] = STATE(4016),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3380] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3381] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3382] = {
    [anon_sym_EQ_GT] = ACTIONS(8084),
    [sym_comment] = ACTIONS(3),
  },
  [3383] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4018),
    [sym_constructor_type] = STATE(4018),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(4018),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4018),
    [sym_intersection_type] = STATE(4018),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3384] = {
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_RBRACK] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [3385] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4019),
    [sym_constructor_type] = STATE(4019),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(4019),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4019),
    [sym_intersection_type] = STATE(4019),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(818),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(820),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3386] = {
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_RBRACK] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [3387] = {
    [anon_sym_GT] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [3388] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(4020),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(4021),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1005),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1009),
    [anon_sym_symbol] = ACTIONS(1009),
    [anon_sym_number] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1009),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1009),
    [anon_sym_private] = ACTIONS(1009),
    [anon_sym_boolean] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_public] = ACTIONS(1009),
    [anon_sym_get] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1009),
    [anon_sym_string] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1009),
    [anon_sym_namespace] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3389] = {
    [sym_formal_parameters] = STATE(4022),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3390] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(8088),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [3391] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6249),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6249),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(6249),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(6252),
  },
  [3392] = {
    [sym_identifier] = ACTIONS(8091),
    [sym_comment] = ACTIONS(3),
  },
  [3393] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(8093),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [3394] = {
    [anon_sym_EQ_GT] = ACTIONS(8096),
    [sym_comment] = ACTIONS(3),
  },
  [3395] = {
    [sym_formal_parameters] = STATE(4025),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3396] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3397] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3398] = {
    [anon_sym_EQ_GT] = ACTIONS(8098),
    [sym_comment] = ACTIONS(3),
  },
  [3399] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4027),
    [sym_constructor_type] = STATE(4027),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(4027),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4027),
    [sym_intersection_type] = STATE(4027),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3400] = {
    [sym_new_expression] = STATE(1208),
    [sym_constructor_type] = STATE(3073),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1208),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1208),
    [sym_call_signature] = STATE(158),
    [sym_yield_expression] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(161),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1885),
    [sym_type_parameters] = STATE(3071),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(164),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_generator_function] = STATE(1208),
    [sym_subscript_expression] = STATE(161),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1208),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1208),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3072),
    [sym_intersection_type] = STATE(3073),
    [sym__type] = STATE(3073),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_function_type] = STATE(3073),
    [sym__expression] = STATE(1208),
    [sym_non_null_expression] = STATE(1208),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1208),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1208),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1208),
    [sym_call_expression] = STATE(1208),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1208),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1208),
    [sym_type_arguments] = STATE(166),
    [sym_union_type] = STATE(3073),
    [sym_parenthesized_expression] = STATE(1208),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1208),
    [sym_class] = STATE(1208),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(8100),
    [sym_false] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(8102),
    [anon_sym_number] = ACTIONS(8102),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(8104),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(8106),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(8108),
    [anon_sym_PIPE] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(2496),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(8102),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(8102),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(3927),
    [sym_number] = ACTIONS(3933),
    [sym_true] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(8102),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2496),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(8110),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(8106),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [3401] = {
    [anon_sym_EQ] = ACTIONS(2571),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_COLON] = ACTIONS(4970),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4970),
    [anon_sym_LPAREN] = ACTIONS(4970),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4970),
    [sym__automatic_semicolon] = ACTIONS(4970),
    [anon_sym_LT] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [sym_comment] = ACTIONS(3),
  },
  [3402] = {
    [sym_call_signature] = STATE(4034),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3403] = {
    [sym_statement_block] = STATE(2345),
    [sym__automatic_semicolon] = ACTIONS(6402),
    [anon_sym_RBRACE] = ACTIONS(6402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(6402),
    [anon_sym_COMMA] = ACTIONS(6402),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6402),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [3404] = {
    [sym_call_signature] = STATE(4034),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(8112),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [3405] = {
    [sym_string] = STATE(4036),
    [sym__property_name] = STATE(4036),
    [sym_computed_property_name] = STATE(4036),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [3406] = {
    [sym_string] = STATE(4036),
    [sym__property_name] = STATE(4036),
    [sym_computed_property_name] = STATE(4036),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(8114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3407] = {
    [sym_string] = STATE(4036),
    [sym__property_name] = STATE(4036),
    [sym_computed_property_name] = STATE(4036),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(8116),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(8118),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(8118),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [3408] = {
    [sym_call_signature] = STATE(4034),
    [sym_type_annotation] = STATE(3342),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [sym__automatic_semicolon] = ACTIONS(6837),
    [anon_sym_RBRACE] = ACTIONS(6837),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(6837),
    [anon_sym_QMARK] = ACTIONS(8120),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6837),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
  },
  [3409] = {
    [sym_string] = STATE(4036),
    [sym__property_name] = STATE(4036),
    [sym_computed_property_name] = STATE(4036),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3410] = {
    [sym_call_signature] = STATE(4034),
    [sym_type_annotation] = STATE(3342),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [sym__automatic_semicolon] = ACTIONS(6837),
    [anon_sym_RBRACE] = ACTIONS(6837),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(6837),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6837),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
  },
  [3411] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(1937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(8122),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(1475),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_PERCENT_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_AMP_EQ] = ACTIONS(2065),
    [anon_sym_PLUS_EQ] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(6871),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2065),
    [anon_sym_STAR_EQ] = ACTIONS(2065),
    [anon_sym_PIPE_EQ] = ACTIONS(2065),
    [anon_sym_DASH_EQ] = ACTIONS(2065),
    [anon_sym_EQ_GT] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(3884),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(8126),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(8129),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1475),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8131),
  },
  [3412] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(1492),
    [sym__automatic_semicolon] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1492),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [3413] = {
    [sym_new_expression] = STATE(408),
    [sym_constructor_type] = STATE(1943),
    [sym_augmented_assignment_expression] = STATE(408),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(408),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(408),
    [sym_call_signature] = STATE(158),
    [sym_yield_expression] = STATE(408),
    [sym_as_expression] = STATE(408),
    [sym_internal_module] = STATE(408),
    [sym_arrow_function] = STATE(408),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(161),
    [sym_mapped_type] = STATE(284),
    [sym_spread_element] = STATE(409),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1642),
    [sym_type_parameters] = STATE(1645),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(164),
    [sym_nested_type_identifier] = STATE(819),
    [sym_generator_function] = STATE(408),
    [sym_subscript_expression] = STATE(161),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(408),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(408),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1646),
    [sym_intersection_type] = STATE(1943),
    [sym__type] = STATE(1943),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(408),
    [sym_meta_property] = STATE(408),
    [sym_function_type] = STATE(1943),
    [sym__expression] = STATE(408),
    [sym_non_null_expression] = STATE(408),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(408),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(408),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [aux_sym_array_repeat1] = STATE(410),
    [sym_anonymous_class] = STATE(408),
    [sym_call_expression] = STATE(408),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(408),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(408),
    [sym_type_arguments] = STATE(166),
    [sym_union_type] = STATE(1943),
    [sym_parenthesized_expression] = STATE(408),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(408),
    [sym_class] = STATE(408),
    [sym_identifier] = ACTIONS(3397),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3399),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(3403),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [sym_false] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(3409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_RBRACK] = ACTIONS(747),
    [sym_null] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(3399),
    [anon_sym_boolean] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3411),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3399),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(745),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_TILDE] = ACTIONS(252),
  },
  [3414] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym__automatic_semicolon] = ACTIONS(1532),
    [anon_sym_PERCENT_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_AMP_EQ] = ACTIONS(2073),
    [anon_sym_PLUS_EQ] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2073),
    [anon_sym_STAR_EQ] = ACTIONS(2073),
    [anon_sym_PIPE_EQ] = ACTIONS(2073),
    [anon_sym_DASH_EQ] = ACTIONS(2073),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2073),
    [anon_sym_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3415] = {
    [sym_new_expression] = STATE(1014),
    [sym_augmented_assignment_expression] = STATE(1014),
    [sym_unary_expression] = STATE(1014),
    [sym_update_expression] = STATE(1014),
    [sym_regex] = STATE(1014),
    [sym_meta_property] = STATE(1014),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1014),
    [sym_yield_expression] = STATE(1014),
    [sym_as_expression] = STATE(1014),
    [sym_non_null_expression] = STATE(1014),
    [sym_internal_module] = STATE(1014),
    [sym_nested_identifier] = STATE(1945),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1014),
    [sym_await_expression] = STATE(1014),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1014),
    [sym_this] = STATE(1014),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1014),
    [sym_generator_function] = STATE(1014),
    [sym_call_expression] = STATE(1014),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1014),
    [sym_ternary_expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_template_string] = STATE(1014),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1014),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1014),
    [sym_class] = STATE(1014),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(8133),
    [sym_false] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2077),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(2079),
    [sym_true] = ACTIONS(2077),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2077),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [3416] = {
    [sym_new_expression] = STATE(1015),
    [sym_augmented_assignment_expression] = STATE(1015),
    [sym_unary_expression] = STATE(1015),
    [sym_update_expression] = STATE(1015),
    [sym_regex] = STATE(1015),
    [sym_meta_property] = STATE(1015),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1015),
    [sym_yield_expression] = STATE(1015),
    [sym_as_expression] = STATE(1015),
    [sym_non_null_expression] = STATE(1015),
    [sym_internal_module] = STATE(1015),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1015),
    [sym_await_expression] = STATE(1015),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1015),
    [sym_this] = STATE(1015),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1015),
    [sym_generator_function] = STATE(1015),
    [sym_call_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1015),
    [sym_ternary_expression] = STATE(1015),
    [sym_binary_expression] = STATE(1015),
    [sym_template_string] = STATE(1015),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1015),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1015),
    [sym_class] = STATE(1015),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_false] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2081),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8135),
    [sym_true] = ACTIONS(2081),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2081),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [3417] = {
    [sym_pair] = STATE(418),
    [aux_sym_export_statement_repeat1] = STATE(1661),
    [sym_object] = STATE(397),
    [sym__property_name] = STATE(1662),
    [aux_sym_object_repeat1] = STATE(420),
    [sym_assignment_pattern] = STATE(418),
    [sym_method_signature] = STATE(1942),
    [sym_property_signature] = STATE(1942),
    [sym_call_signature] = STATE(1942),
    [sym_construct_signature] = STATE(1942),
    [sym_export_statement] = STATE(1942),
    [sym_method_definition] = STATE(418),
    [sym_index_signature] = STATE(1942),
    [sym_decorator] = STATE(1661),
    [sym_accessibility_modifier] = STATE(1663),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(1662),
    [sym_array] = STATE(399),
    [sym_spread_element] = STATE(418),
    [sym_string] = STATE(1662),
    [sym_type_parameters] = STATE(811),
    [sym_identifier] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(4053),
    [anon_sym_module] = ACTIONS(3429),
    [anon_sym_symbol] = ACTIONS(3429),
    [anon_sym_number] = ACTIONS(3429),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(3429),
    [anon_sym_COMMA] = ACTIONS(8137),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_boolean] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_get] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(8139),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_string] = ACTIONS(3429),
    [anon_sym_set] = ACTIONS(3441),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(3429),
    [anon_sym_export] = ACTIONS(3447),
    [sym_readonly] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4055),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [3418] = {
    [sym_new_expression] = STATE(1014),
    [sym_augmented_assignment_expression] = STATE(1014),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(1014),
    [sym_update_expression] = STATE(1014),
    [sym_regex] = STATE(1014),
    [sym_meta_property] = STATE(1014),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(1014),
    [sym_yield_expression] = STATE(1014),
    [sym_as_expression] = STATE(1014),
    [sym_non_null_expression] = STATE(1014),
    [sym_internal_module] = STATE(1014),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(1014),
    [sym_await_expression] = STATE(1014),
    [sym_member_expression] = STATE(376),
    [sym_string] = STATE(1014),
    [sym_this] = STATE(1014),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(378),
    [sym_anonymous_class] = STATE(1014),
    [sym_generator_function] = STATE(1014),
    [sym_call_expression] = STATE(1014),
    [sym_subscript_expression] = STATE(376),
    [sym_assignment_expression] = STATE(1014),
    [sym_ternary_expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_template_string] = STATE(1014),
    [sym_type_arguments] = STATE(379),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1014),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1014),
    [sym_class] = STATE(1014),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(1532),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2073),
    [anon_sym_symbol] = ACTIONS(646),
    [anon_sym_AMP_EQ] = ACTIONS(2073),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2073),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_PIPE_EQ] = ACTIONS(2073),
    [anon_sym_DASH_EQ] = ACTIONS(2073),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_RBRACE] = ACTIONS(3897),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2073),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(660),
    [sym_true] = ACTIONS(2077),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1532),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2077),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2073),
    [anon_sym_number] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2077),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(646),
    [anon_sym_STAR_EQ] = ACTIONS(2073),
    [anon_sym_boolean] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_EQ_GT] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2073),
    [anon_sym_string] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2077),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3419] = {
    [sym_new_expression] = STATE(533),
    [sym_constructor_type] = STATE(1951),
    [sym_augmented_assignment_expression] = STATE(533),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(533),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(533),
    [sym_call_signature] = STATE(242),
    [sym_rest_parameter] = STATE(243),
    [sym_yield_expression] = STATE(533),
    [sym_as_expression] = STATE(533),
    [sym_internal_module] = STATE(533),
    [sym_accessibility_modifier] = STATE(246),
    [sym_arrow_function] = STATE(533),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(245),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1885),
    [sym_type_parameters] = STATE(1888),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(250),
    [sym_nested_type_identifier] = STATE(839),
    [sym_generator_function] = STATE(533),
    [sym_subscript_expression] = STATE(245),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(533),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(533),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(249),
    [sym_formal_parameters] = STATE(1889),
    [sym_intersection_type] = STATE(1951),
    [sym__type] = STATE(1951),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(533),
    [sym_meta_property] = STATE(533),
    [sym_function_type] = STATE(1951),
    [sym__expression] = STATE(533),
    [sym_non_null_expression] = STATE(533),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_required_parameter] = STATE(243),
    [sym_await_expression] = STATE(533),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_sequence_expression] = STATE(534),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(248),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(249),
    [sym_anonymous_class] = STATE(533),
    [sym_optional_parameter] = STATE(243),
    [sym_call_expression] = STATE(533),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(533),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(533),
    [sym_type_arguments] = STATE(251),
    [sym_union_type] = STATE(1951),
    [sym_parenthesized_expression] = STATE(533),
    [sym_array] = STATE(252),
    [sym_type_assertion] = STATE(533),
    [sym_class] = STATE(533),
    [sym_identifier] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3921),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(3925),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(422),
    [anon_sym_get] = ACTIONS(412),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(430),
    [sym_true] = ACTIONS(3929),
    [anon_sym_protected] = ACTIONS(422),
    [anon_sym_set] = ACTIONS(412),
    [anon_sym_type] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(412),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_BANG] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [sym_false] = ACTIONS(3929),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_number] = ACTIONS(3921),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(412),
    [anon_sym_typeof] = ACTIONS(3931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(973),
    [anon_sym_any] = ACTIONS(3921),
    [anon_sym_boolean] = ACTIONS(3921),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3933),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3921),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(973),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_export] = ACTIONS(412),
    [anon_sym_TILDE] = ACTIONS(410),
  },
  [3420] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(1536),
    [sym__automatic_semicolon] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3451),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_RBRACE] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1536),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [3421] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(4046),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(4047),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2097),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2099),
    [anon_sym_symbol] = ACTIONS(2099),
    [anon_sym_number] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2099),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2101),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2099),
    [anon_sym_private] = ACTIONS(2099),
    [anon_sym_boolean] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2099),
    [anon_sym_get] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2099),
    [anon_sym_string] = ACTIONS(2099),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2099),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(2099),
    [anon_sym_export] = ACTIONS(2099),
    [anon_sym_namespace] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3422] = {
    [sym_formal_parameters] = STATE(4048),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3423] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(8141),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [3424] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4054),
    [sym_constructor_type] = STATE(4054),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(4054),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4054),
    [sym_intersection_type] = STATE(4054),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4055),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4057),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8148),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8150),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3425] = {
    [sym_type_annotation] = STATE(2545),
    [sym__automatic_semicolon] = ACTIONS(1739),
    [anon_sym_RBRACE] = ACTIONS(1739),
    [anon_sym_COLON] = ACTIONS(6976),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1739),
    [anon_sym_COMMA] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1739),
  },
  [3426] = {
    [sym_string] = STATE(4060),
    [sym__property_name] = STATE(4060),
    [sym_computed_property_name] = STATE(4060),
    [anon_sym_get] = ACTIONS(8154),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [sym_number] = ACTIONS(8156),
    [anon_sym_STAR] = ACTIONS(8116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(8154),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(8158),
  },
  [3427] = {
    [anon_sym_AMP] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
  },
  [3428] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4061),
    [sym_constructor_type] = STATE(4061),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(4061),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4061),
    [sym_intersection_type] = STATE(4061),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(838),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(840),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3429] = {
    [anon_sym_AMP] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
  },
  [3430] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4065),
    [sym_constructor_type] = STATE(4065),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(4065),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4065),
    [sym_intersection_type] = STATE(4065),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3431] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4068),
    [sym_constructor_type] = STATE(4068),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(4068),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4068),
    [sym_intersection_type] = STATE(4068),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3432] = {
    [anon_sym_EQ_GT] = ACTIONS(8166),
    [sym_comment] = ACTIONS(3),
  },
  [3433] = {
    [sym_formal_parameters] = STATE(4070),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3434] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2621),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2623),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3435] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2621),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2623),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3436] = {
    [anon_sym_EQ_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(3),
  },
  [3437] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4072),
    [sym_constructor_type] = STATE(4072),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(4072),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3438] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4073),
    [sym_constructor_type] = STATE(4073),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(4073),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4073),
    [sym_intersection_type] = STATE(4073),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2621),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2623),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3439] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3440] = {
    [sym_formal_parameters] = STATE(4074),
    [sym_type_parameters] = STATE(4075),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3441] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3442] = {
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(8170),
    [anon_sym_PIPE] = ACTIONS(8172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5196),
  },
  [3443] = {
    [sym_formal_parameters] = STATE(4078),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3444] = {
    [anon_sym_EQ_GT] = ACTIONS(8174),
    [sym_comment] = ACTIONS(3),
  },
  [3445] = {
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(8170),
    [anon_sym_PIPE] = ACTIONS(8172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5204),
  },
  [3446] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4080),
    [sym_constructor_type] = STATE(4080),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(4080),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4080),
    [sym_intersection_type] = STATE(4080),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1699),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1701),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3447] = {
    [anon_sym_EQ_GT] = ACTIONS(8176),
    [sym_comment] = ACTIONS(3),
  },
  [3448] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4082),
    [sym_constructor_type] = STATE(4082),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(4082),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4082),
    [sym_intersection_type] = STATE(4082),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1699),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1701),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3449] = {
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(8170),
    [anon_sym_PIPE] = ACTIONS(8172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5406),
  },
  [3450] = {
    [anon_sym_AMP] = ACTIONS(5453),
    [anon_sym_PIPE] = ACTIONS(5455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5425),
  },
  [3451] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(2529),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3452] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(8180),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [3453] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(8180),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [3454] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4083),
    [sym_constructor_type] = STATE(4083),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(4083),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4083),
    [sym_intersection_type] = STATE(4083),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3455] = {
    [anon_sym_EQ_GT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(3),
  },
  [3456] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4085),
    [sym_constructor_type] = STATE(4085),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(4085),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4085),
    [sym_intersection_type] = STATE(4085),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3457] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(8180),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [3458] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(8180),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [3459] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(877),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(3540),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(3542),
    [anon_sym_symbol] = ACTIONS(3542),
    [anon_sym_number] = ACTIONS(3542),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3542),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3542),
    [anon_sym_private] = ACTIONS(3542),
    [anon_sym_boolean] = ACTIONS(3542),
    [anon_sym_async] = ACTIONS(3546),
    [anon_sym_public] = ACTIONS(3542),
    [anon_sym_get] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3542),
    [anon_sym_string] = ACTIONS(3542),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(3542),
    [anon_sym_type] = ACTIONS(3542),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(3542),
    [anon_sym_export] = ACTIONS(3542),
    [anon_sym_namespace] = ACTIONS(3548),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3460] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6249),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(6252),
  },
  [3461] = {
    [sym_identifier] = ACTIONS(8184),
    [sym_comment] = ACTIONS(3),
  },
  [3462] = {
    [sym__automatic_semicolon] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8186),
    [anon_sym_from] = ACTIONS(8186),
    [sym_comment] = ACTIONS(3),
  },
  [3463] = {
    [sym__import_export_specifier] = STATE(2653),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_typeof] = ACTIONS(887),
    [anon_sym_type] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
  },
  [3464] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(5130),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5130),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [3465] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(5134),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5134),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [3466] = {
    [sym_new_expression] = STATE(4087),
    [sym_augmented_assignment_expression] = STATE(4087),
    [sym_unary_expression] = STATE(4087),
    [sym_update_expression] = STATE(4087),
    [sym_regex] = STATE(4087),
    [sym_meta_property] = STATE(4087),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(4087),
    [sym_yield_expression] = STATE(4087),
    [sym_as_expression] = STATE(4087),
    [sym_non_null_expression] = STATE(4087),
    [sym_internal_module] = STATE(4087),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4087),
    [sym_await_expression] = STATE(4087),
    [sym_member_expression] = STATE(910),
    [sym_string] = STATE(4087),
    [sym_this] = STATE(4087),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(911),
    [sym_anonymous_class] = STATE(4087),
    [sym_generator_function] = STATE(4087),
    [sym_call_expression] = STATE(4087),
    [sym_subscript_expression] = STATE(910),
    [sym_assignment_expression] = STATE(4087),
    [sym_ternary_expression] = STATE(4087),
    [sym_binary_expression] = STATE(4087),
    [sym_template_string] = STATE(4087),
    [sym_type_arguments] = STATE(912),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4087),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(4087),
    [sym_class] = STATE(4087),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [sym_false] = ACTIONS(8188),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1685),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8188),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(8190),
    [sym_true] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8188),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [3467] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4088),
    [sym_constructor_type] = STATE(4088),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(4088),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4088),
    [sym_intersection_type] = STATE(4088),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3468] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4089),
    [sym_constructor_type] = STATE(4089),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(4089),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4089),
    [sym_intersection_type] = STATE(4089),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3469] = {
    [anon_sym_EQ_GT] = ACTIONS(8192),
    [sym_comment] = ACTIONS(3),
  },
  [3470] = {
    [sym_formal_parameters] = STATE(4091),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3471] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2778),
    [sym_constructor_type] = STATE(2778),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(2778),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2778),
    [sym_intersection_type] = STATE(2778),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3472] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2779),
    [sym_constructor_type] = STATE(2779),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(2779),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2779),
    [sym_intersection_type] = STATE(2779),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3473] = {
    [anon_sym_EQ_GT] = ACTIONS(8194),
    [sym_comment] = ACTIONS(3),
  },
  [3474] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4093),
    [sym_constructor_type] = STATE(4093),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(4093),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4093),
    [sym_intersection_type] = STATE(4093),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3475] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4094),
    [sym_constructor_type] = STATE(4094),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(4094),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4094),
    [sym_intersection_type] = STATE(4094),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3476] = {
    [sym_new_expression] = STATE(2657),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(2657),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(2657),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(2657),
    [sym_call_signature] = STATE(908),
    [sym_yield_expression] = STATE(2657),
    [sym_as_expression] = STATE(2657),
    [sym_internal_module] = STATE(2657),
    [sym_arrow_function] = STATE(2657),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(910),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(2678),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(911),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(2657),
    [sym_subscript_expression] = STATE(910),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(2657),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(2657),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(2657),
    [sym_meta_property] = STATE(2657),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(2657),
    [sym_non_null_expression] = STATE(2657),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(2657),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(2657),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_anonymous_class] = STATE(2657),
    [sym_call_expression] = STATE(2657),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(2657),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(2657),
    [sym_type_arguments] = STATE(912),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(2657),
    [sym_array] = STATE(913),
    [sym_type_assertion] = STATE(2657),
    [sym_class] = STATE(2657),
    [anon_sym_BANG] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(5565),
    [sym_false] = ACTIONS(5567),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(5569),
    [anon_sym_number] = ACTIONS(5569),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(5571),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(5575),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(5577),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [sym_null] = ACTIONS(5508),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(5569),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(5569),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1689),
    [anon_sym_this] = ACTIONS(5579),
    [sym_number] = ACTIONS(5581),
    [sym_true] = ACTIONS(5567),
    [anon_sym_yield] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(5569),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5508),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_new] = ACTIONS(8196),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(5573),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1689),
  },
  [3477] = {
    [sym_identifier] = ACTIONS(8198),
    [sym_comment] = ACTIONS(3),
  },
  [3478] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3620),
    [anon_sym_AMP_EQ] = ACTIONS(3620),
    [anon_sym_PLUS_EQ] = ACTIONS(3620),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(3620),
    [anon_sym_STAR_EQ] = ACTIONS(3620),
    [anon_sym_PIPE_EQ] = ACTIONS(3620),
    [anon_sym_DASH_EQ] = ACTIONS(3620),
    [anon_sym_EQ_GT] = ACTIONS(3624),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3620),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT_EQ] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(8200),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3620),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3626),
  },
  [3479] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1241),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1241),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_EQ] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(3303),
    [anon_sym_BANG_EQ] = ACTIONS(1241),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1241),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_SLASH] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1241),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1241),
  },
  [3480] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(8202),
    [anon_sym_while] = ACTIONS(2401),
  },
  [3481] = {
    [sym_array] = STATE(4101),
    [sym_object] = STATE(4102),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(8204),
    [anon_sym_var] = ACTIONS(8206),
    [anon_sym_const] = ACTIONS(8206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(8206),
  },
  [3482] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(8208),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8210),
  },
  [3483] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(4106),
    [sym_object] = STATE(4107),
    [sym_identifier] = ACTIONS(8212),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3484] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(4106),
    [sym_object] = STATE(4107),
    [sym_identifier] = ACTIONS(8212),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3485] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4108),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(4108),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [3486] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(8214),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8216),
  },
  [3487] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(8218),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8220),
  },
  [3488] = {
    [sym_identifier] = ACTIONS(8222),
    [sym_comment] = ACTIONS(3),
  },
  [3489] = {
    [sym_class_body] = STATE(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(951),
  },
  [3490] = {
    [anon_sym_of] = ACTIONS(8224),
    [sym_comment] = ACTIONS(3),
  },
  [3491] = {
    [anon_sym_of] = ACTIONS(8226),
    [sym_comment] = ACTIONS(3),
  },
  [3492] = {
    [anon_sym_of] = ACTIONS(8228),
    [sym_comment] = ACTIONS(3),
  },
  [3493] = {
    [sym_new_expression] = STATE(4117),
    [sym_augmented_assignment_expression] = STATE(4117),
    [sym_unary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_regex] = STATE(4117),
    [sym_meta_property] = STATE(4117),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4117),
    [sym_yield_expression] = STATE(4117),
    [sym_as_expression] = STATE(4117),
    [sym_non_null_expression] = STATE(4117),
    [sym_internal_module] = STATE(4117),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4117),
    [sym_await_expression] = STATE(4117),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4117),
    [sym_this] = STATE(4117),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4117),
    [sym_generator_function] = STATE(4117),
    [sym_call_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4117),
    [sym_ternary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_template_string] = STATE(4117),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4117),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4117),
    [sym_class] = STATE(4117),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8230),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8230),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8232),
    [sym_true] = ACTIONS(8230),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8230),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3494] = {
    [sym_new_expression] = STATE(4118),
    [sym_augmented_assignment_expression] = STATE(4118),
    [sym_unary_expression] = STATE(4118),
    [sym_update_expression] = STATE(4118),
    [sym_regex] = STATE(4118),
    [sym_meta_property] = STATE(4118),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4118),
    [sym_yield_expression] = STATE(4118),
    [sym_as_expression] = STATE(4118),
    [sym_non_null_expression] = STATE(4118),
    [sym_internal_module] = STATE(4118),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4118),
    [sym_await_expression] = STATE(4118),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4118),
    [sym_this] = STATE(4118),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4118),
    [sym_generator_function] = STATE(4118),
    [sym_call_expression] = STATE(4118),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4118),
    [sym_ternary_expression] = STATE(4118),
    [sym_binary_expression] = STATE(4118),
    [sym_template_string] = STATE(4118),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4118),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4118),
    [sym_class] = STATE(4118),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8234),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8234),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8236),
    [sym_true] = ACTIONS(8234),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8234),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3495] = {
    [sym_new_expression] = STATE(4119),
    [sym_augmented_assignment_expression] = STATE(4119),
    [sym_unary_expression] = STATE(4119),
    [sym_update_expression] = STATE(4119),
    [sym_regex] = STATE(4119),
    [sym_meta_property] = STATE(4119),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4119),
    [sym_yield_expression] = STATE(4119),
    [sym_as_expression] = STATE(4119),
    [sym_non_null_expression] = STATE(4119),
    [sym_internal_module] = STATE(4119),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4119),
    [sym_await_expression] = STATE(4119),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4119),
    [sym_this] = STATE(4119),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4119),
    [sym_generator_function] = STATE(4119),
    [sym_call_expression] = STATE(4119),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4119),
    [sym_ternary_expression] = STATE(4119),
    [sym_binary_expression] = STATE(4119),
    [sym_template_string] = STATE(4119),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4119),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4119),
    [sym_class] = STATE(4119),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8238),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8238),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8240),
    [sym_true] = ACTIONS(8238),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8238),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3496] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(8242),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3497] = {
    [anon_sym_RPAREN] = ACTIONS(8242),
    [sym_comment] = ACTIONS(3),
  },
  [3498] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8244),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3499] = {
    [sym_new_expression] = STATE(4122),
    [sym_augmented_assignment_expression] = STATE(4122),
    [sym_unary_expression] = STATE(4122),
    [sym_update_expression] = STATE(4122),
    [sym_regex] = STATE(4122),
    [sym_meta_property] = STATE(4122),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4122),
    [sym_yield_expression] = STATE(4122),
    [sym_as_expression] = STATE(4122),
    [sym_non_null_expression] = STATE(4122),
    [sym_internal_module] = STATE(4122),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4122),
    [sym_await_expression] = STATE(4122),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4123),
    [sym_string] = STATE(4122),
    [sym_this] = STATE(4122),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4122),
    [sym_generator_function] = STATE(4122),
    [sym_call_expression] = STATE(4122),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4122),
    [sym_ternary_expression] = STATE(4122),
    [sym_binary_expression] = STATE(4122),
    [sym_template_string] = STATE(4122),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4122),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4122),
    [sym_class] = STATE(4122),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(8246),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8246),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8248),
    [sym_true] = ACTIONS(8246),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8246),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [3500] = {
    [sym_new_expression] = STATE(4124),
    [sym_augmented_assignment_expression] = STATE(4124),
    [sym_unary_expression] = STATE(4124),
    [sym_update_expression] = STATE(4124),
    [sym_regex] = STATE(4124),
    [sym_meta_property] = STATE(4124),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4124),
    [sym_yield_expression] = STATE(4124),
    [sym_as_expression] = STATE(4124),
    [sym_non_null_expression] = STATE(4124),
    [sym_internal_module] = STATE(4124),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4124),
    [sym_await_expression] = STATE(4124),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4125),
    [sym_string] = STATE(4124),
    [sym_this] = STATE(4124),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4124),
    [sym_generator_function] = STATE(4124),
    [sym_call_expression] = STATE(4124),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4124),
    [sym_ternary_expression] = STATE(4124),
    [sym_binary_expression] = STATE(4124),
    [sym_template_string] = STATE(4124),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4124),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4124),
    [sym_class] = STATE(4124),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(8250),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8250),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8252),
    [sym_true] = ACTIONS(8250),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8250),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [3501] = {
    [sym_new_expression] = STATE(4126),
    [sym_augmented_assignment_expression] = STATE(4126),
    [sym_unary_expression] = STATE(4126),
    [sym_update_expression] = STATE(4126),
    [sym_regex] = STATE(4126),
    [sym_meta_property] = STATE(4126),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4126),
    [sym_yield_expression] = STATE(4126),
    [sym_as_expression] = STATE(4126),
    [sym_non_null_expression] = STATE(4126),
    [sym_internal_module] = STATE(4126),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4126),
    [sym_await_expression] = STATE(4126),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4127),
    [sym_string] = STATE(4126),
    [sym_this] = STATE(4126),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4126),
    [sym_generator_function] = STATE(4126),
    [sym_call_expression] = STATE(4126),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4126),
    [sym_ternary_expression] = STATE(4126),
    [sym_binary_expression] = STATE(4126),
    [sym_template_string] = STATE(4126),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4126),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4126),
    [sym_class] = STATE(4126),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(8254),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8254),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8256),
    [sym_true] = ACTIONS(8254),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8254),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [3502] = {
    [sym_type_alias_declaration] = STATE(3004),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3004),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3004),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3004),
    [sym_return_statement] = STATE(3004),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3004),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3004),
    [sym_switch_statement] = STATE(3004),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3004),
    [sym_throw_statement] = STATE(3004),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3004),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3004),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(3004),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3004),
    [sym_abstract_class] = STATE(3004),
    [sym_interface_declaration] = STATE(3004),
    [sym_statement_block] = STATE(3004),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3004),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3004),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3004),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3004),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3004),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3004),
    [sym_empty_statement] = STATE(3004),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(3004),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3004),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3004),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3004),
    [sym_break_statement] = STATE(3004),
    [sym_labeled_statement] = STATE(3004),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3004),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [3503] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3504] = {
    [anon_sym_RPAREN] = ACTIONS(8258),
    [sym_comment] = ACTIONS(3),
  },
  [3505] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8260),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3506] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3507] = {
    [anon_sym_RPAREN] = ACTIONS(8262),
    [sym_comment] = ACTIONS(3),
  },
  [3508] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8264),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3509] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(8266),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3510] = {
    [anon_sym_RPAREN] = ACTIONS(8266),
    [sym_comment] = ACTIONS(3),
  },
  [3511] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4138),
    [sym_constructor_type] = STATE(4138),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(4138),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4138),
    [sym_intersection_type] = STATE(4138),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4139),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4141),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3512] = {
    [sym_statement_block] = STATE(3012),
    [sym__automatic_semicolon] = ACTIONS(5138),
    [anon_sym_SEMI] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [3513] = {
    [sym_statement_block] = STATE(3013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [3514] = {
    [anon_sym_EQ_GT] = ACTIONS(8278),
    [sym_comment] = ACTIONS(3),
  },
  [3515] = {
    [sym_formal_parameters] = STATE(4143),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3516] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3517] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3518] = {
    [anon_sym_EQ_GT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(3),
  },
  [3519] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4145),
    [sym_constructor_type] = STATE(4145),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(4145),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4145),
    [sym_intersection_type] = STATE(4145),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3520] = {
    [anon_sym_EQ_GT] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_PIPE] = ACTIONS(3748),
    [sym_comment] = ACTIONS(3),
  },
  [3521] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4146),
    [sym_constructor_type] = STATE(4146),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(4146),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4146),
    [sym_intersection_type] = STATE(4146),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(942),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(944),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3522] = {
    [anon_sym_EQ_GT] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_PIPE] = ACTIONS(3748),
    [sym_comment] = ACTIONS(3),
  },
  [3523] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5130),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [3524] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5134),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [3525] = {
    [sym_new_expression] = STATE(4147),
    [sym_augmented_assignment_expression] = STATE(4147),
    [sym_unary_expression] = STATE(4147),
    [sym_update_expression] = STATE(4147),
    [sym_regex] = STATE(4147),
    [sym_meta_property] = STATE(4147),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(4147),
    [sym_yield_expression] = STATE(4147),
    [sym_as_expression] = STATE(4147),
    [sym_non_null_expression] = STATE(4147),
    [sym_internal_module] = STATE(4147),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4147),
    [sym_await_expression] = STATE(4147),
    [sym_member_expression] = STATE(964),
    [sym_string] = STATE(4147),
    [sym_this] = STATE(4147),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(965),
    [sym_anonymous_class] = STATE(4147),
    [sym_generator_function] = STATE(4147),
    [sym_call_expression] = STATE(4147),
    [sym_subscript_expression] = STATE(964),
    [sym_assignment_expression] = STATE(4147),
    [sym_ternary_expression] = STATE(4147),
    [sym_binary_expression] = STATE(4147),
    [sym_template_string] = STATE(4147),
    [sym_type_arguments] = STATE(966),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4147),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(4147),
    [sym_class] = STATE(4147),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [sym_false] = ACTIONS(8282),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1950),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8282),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8284),
    [sym_true] = ACTIONS(8282),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8282),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [3526] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4148),
    [sym_constructor_type] = STATE(4148),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(4148),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4148),
    [sym_intersection_type] = STATE(4148),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3527] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4149),
    [sym_constructor_type] = STATE(4149),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(4149),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4149),
    [sym_intersection_type] = STATE(4149),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3528] = {
    [anon_sym_EQ_GT] = ACTIONS(8286),
    [sym_comment] = ACTIONS(3),
  },
  [3529] = {
    [sym_formal_parameters] = STATE(4151),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3530] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3531] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3532] = {
    [anon_sym_EQ_GT] = ACTIONS(8288),
    [sym_comment] = ACTIONS(3),
  },
  [3533] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4153),
    [sym_constructor_type] = STATE(4153),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(4153),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4153),
    [sym_intersection_type] = STATE(4153),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3534] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4154),
    [sym_constructor_type] = STATE(4154),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(4154),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4154),
    [sym_intersection_type] = STATE(4154),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3535] = {
    [sym_new_expression] = STATE(2736),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(2736),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(2736),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(2736),
    [sym_call_signature] = STATE(962),
    [sym_yield_expression] = STATE(2736),
    [sym_as_expression] = STATE(2736),
    [sym_internal_module] = STATE(2736),
    [sym_arrow_function] = STATE(2736),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(964),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1738),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(965),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(2736),
    [sym_subscript_expression] = STATE(964),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(2736),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(2736),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(2736),
    [sym_meta_property] = STATE(2736),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(2736),
    [sym_non_null_expression] = STATE(2736),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(2736),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(2736),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(2736),
    [sym_call_expression] = STATE(2736),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(2736),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(2736),
    [sym_type_arguments] = STATE(966),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(2736),
    [sym_array] = STATE(967),
    [sym_type_assertion] = STATE(2736),
    [sym_class] = STATE(2736),
    [anon_sym_BANG] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(5706),
    [sym_false] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(5708),
    [anon_sym_number] = ACTIONS(5708),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(5710),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5712),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(5714),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(5649),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5708),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(5708),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_this] = ACTIONS(3597),
    [sym_number] = ACTIONS(3599),
    [sym_true] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(5708),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5649),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(8290),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(5712),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
  },
  [3536] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_AMP_EQ] = ACTIONS(3759),
    [anon_sym_PLUS_EQ] = ACTIONS(3759),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(3759),
    [anon_sym_STAR_EQ] = ACTIONS(3759),
    [anon_sym_PIPE_EQ] = ACTIONS(3759),
    [anon_sym_DASH_EQ] = ACTIONS(3759),
    [anon_sym_EQ_GT] = ACTIONS(3763),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3759),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT_EQ] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(7037),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3759),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3765),
  },
  [3537] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6809),
    [anon_sym_LBRACK] = ACTIONS(6809),
    [anon_sym_BANG] = ACTIONS(6807),
    [anon_sym_SEMI] = ACTIONS(6809),
    [anon_sym_BQUOTE] = ACTIONS(6809),
    [sym__automatic_semicolon] = ACTIONS(6809),
    [anon_sym_PIPE] = ACTIONS(6807),
    [anon_sym_COMMA] = ACTIONS(6809),
    [anon_sym_LT_LT] = ACTIONS(6809),
    [anon_sym_STAR] = ACTIONS(6807),
    [anon_sym_GT_GT_GT] = ACTIONS(6809),
    [anon_sym_AMP_AMP] = ACTIONS(6809),
    [anon_sym_DASH] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6807),
    [anon_sym_LT_EQ] = ACTIONS(6809),
    [anon_sym_LPAREN] = ACTIONS(6809),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_GT] = ACTIONS(6807),
    [anon_sym_AMP] = ACTIONS(6807),
    [anon_sym_PERCENT] = ACTIONS(6809),
    [anon_sym_QMARK] = ACTIONS(6809),
    [anon_sym_RBRACE] = ACTIONS(6809),
    [anon_sym_as] = ACTIONS(6809),
    [anon_sym_PIPE_PIPE] = ACTIONS(6809),
    [anon_sym_DASH_DASH] = ACTIONS(6809),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_instanceof] = ACTIONS(6809),
    [anon_sym_LT] = ACTIONS(6807),
    [anon_sym_RPAREN] = ACTIONS(6809),
    [anon_sym_SLASH] = ACTIONS(6807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6809),
    [anon_sym_STAR_STAR] = ACTIONS(6809),
    [anon_sym_PLUS] = ACTIONS(6807),
    [anon_sym_GT_GT] = ACTIONS(6807),
    [anon_sym_PLUS_PLUS] = ACTIONS(6809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6809),
    [anon_sym_in] = ACTIONS(6807),
  },
  [3538] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_SEMI] = ACTIONS(3470),
    [anon_sym_BQUOTE] = ACTIONS(3470),
    [sym__automatic_semicolon] = ACTIONS(3470),
    [anon_sym_PIPE] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3468),
    [anon_sym_GT_GT_GT] = ACTIONS(3470),
    [anon_sym_AMP_AMP] = ACTIONS(3470),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_LT_EQ] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3470),
    [anon_sym_GT_EQ] = ACTIONS(3470),
    [anon_sym_GT] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3470),
    [anon_sym_QMARK] = ACTIONS(3470),
    [anon_sym_RBRACE] = ACTIONS(3470),
    [anon_sym_as] = ACTIONS(3470),
    [anon_sym_PIPE_PIPE] = ACTIONS(3470),
    [anon_sym_DASH_DASH] = ACTIONS(3470),
    [anon_sym_EQ_EQ] = ACTIONS(3468),
    [anon_sym_instanceof] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3468),
    [anon_sym_RPAREN] = ACTIONS(3470),
    [anon_sym_SLASH] = ACTIONS(3468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3470),
    [anon_sym_CARET] = ACTIONS(3470),
    [anon_sym_STAR_STAR] = ACTIONS(3470),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_GT_GT] = ACTIONS(3468),
    [anon_sym_PLUS_PLUS] = ACTIONS(3470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3470),
    [anon_sym_in] = ACTIONS(3468),
  },
  [3539] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1675),
    [sym_constructor_type] = STATE(1675),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1675),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1675),
    [sym_intersection_type] = STATE(1675),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(8292),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_boolean] = ACTIONS(472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_this] = ACTIONS(474),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [3540] = {
    [aux_sym_implements_clause_repeat1] = STATE(1677),
    [anon_sym_COMMA] = ACTIONS(8294),
    [anon_sym_GT] = ACTIONS(8292),
    [sym_comment] = ACTIONS(3),
  },
  [3541] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(8296),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8296),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [3542] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6821),
    [anon_sym_LBRACK] = ACTIONS(6821),
    [anon_sym_BANG] = ACTIONS(6819),
    [anon_sym_SEMI] = ACTIONS(6821),
    [anon_sym_BQUOTE] = ACTIONS(6821),
    [sym__automatic_semicolon] = ACTIONS(6821),
    [anon_sym_PIPE] = ACTIONS(6819),
    [anon_sym_COMMA] = ACTIONS(6821),
    [anon_sym_LT_LT] = ACTIONS(6821),
    [anon_sym_STAR] = ACTIONS(6819),
    [anon_sym_GT_GT_GT] = ACTIONS(6821),
    [anon_sym_AMP_AMP] = ACTIONS(6821),
    [anon_sym_DASH] = ACTIONS(6819),
    [anon_sym_BANG_EQ] = ACTIONS(6819),
    [anon_sym_LT_EQ] = ACTIONS(6821),
    [anon_sym_LPAREN] = ACTIONS(6821),
    [anon_sym_GT_EQ] = ACTIONS(6821),
    [anon_sym_GT] = ACTIONS(6819),
    [anon_sym_AMP] = ACTIONS(6819),
    [anon_sym_PERCENT] = ACTIONS(6821),
    [anon_sym_QMARK] = ACTIONS(6821),
    [anon_sym_RBRACE] = ACTIONS(6821),
    [anon_sym_as] = ACTIONS(6821),
    [anon_sym_PIPE_PIPE] = ACTIONS(6821),
    [anon_sym_DASH_DASH] = ACTIONS(6821),
    [anon_sym_EQ_EQ] = ACTIONS(6819),
    [anon_sym_instanceof] = ACTIONS(6821),
    [anon_sym_LT] = ACTIONS(6819),
    [anon_sym_RPAREN] = ACTIONS(6821),
    [anon_sym_SLASH] = ACTIONS(6819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6821),
    [anon_sym_CARET] = ACTIONS(6821),
    [anon_sym_STAR_STAR] = ACTIONS(6821),
    [anon_sym_PLUS] = ACTIONS(6819),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6821),
    [anon_sym_GT_GT] = ACTIONS(6819),
    [anon_sym_PLUS_PLUS] = ACTIONS(6821),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6821),
    [anon_sym_in] = ACTIONS(6819),
  },
  [3543] = {
    [aux_sym_object_type_repeat1] = STATE(2544),
    [sym__automatic_semicolon] = ACTIONS(8298),
    [anon_sym_RBRACE] = ACTIONS(8296),
    [anon_sym_SEMI] = ACTIONS(8298),
    [anon_sym_COMMA] = ACTIONS(8298),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8296),
    [sym_comment] = ACTIONS(3),
  },
  [3544] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6904),
    [anon_sym_LBRACK] = ACTIONS(6904),
    [anon_sym_BANG] = ACTIONS(6902),
    [anon_sym_SEMI] = ACTIONS(6904),
    [anon_sym_BQUOTE] = ACTIONS(6904),
    [sym__automatic_semicolon] = ACTIONS(6904),
    [anon_sym_PIPE] = ACTIONS(6902),
    [anon_sym_COMMA] = ACTIONS(6904),
    [anon_sym_LT_LT] = ACTIONS(6904),
    [anon_sym_STAR] = ACTIONS(6902),
    [anon_sym_GT_GT_GT] = ACTIONS(6904),
    [anon_sym_AMP_AMP] = ACTIONS(6904),
    [anon_sym_DASH] = ACTIONS(6902),
    [anon_sym_BANG_EQ] = ACTIONS(6902),
    [anon_sym_LT_EQ] = ACTIONS(6904),
    [anon_sym_LPAREN] = ACTIONS(6904),
    [anon_sym_GT_EQ] = ACTIONS(6904),
    [anon_sym_GT] = ACTIONS(6902),
    [anon_sym_AMP] = ACTIONS(6902),
    [anon_sym_PERCENT] = ACTIONS(6904),
    [anon_sym_QMARK] = ACTIONS(6904),
    [anon_sym_RBRACE] = ACTIONS(6904),
    [anon_sym_as] = ACTIONS(6904),
    [anon_sym_PIPE_PIPE] = ACTIONS(6904),
    [anon_sym_DASH_DASH] = ACTIONS(6904),
    [anon_sym_EQ_EQ] = ACTIONS(6902),
    [anon_sym_instanceof] = ACTIONS(6904),
    [anon_sym_LT] = ACTIONS(6902),
    [anon_sym_RPAREN] = ACTIONS(6904),
    [anon_sym_SLASH] = ACTIONS(6902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6904),
    [anon_sym_CARET] = ACTIONS(6904),
    [anon_sym_STAR_STAR] = ACTIONS(6904),
    [anon_sym_PLUS] = ACTIONS(6902),
    [anon_sym_GT_GT] = ACTIONS(6902),
    [anon_sym_PLUS_PLUS] = ACTIONS(6904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6904),
    [anon_sym_in] = ACTIONS(6902),
  },
  [3545] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(7184),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(7186),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [3546] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4160),
    [sym_constructor_type] = STATE(4160),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(985),
    [sym_function_type] = STATE(4160),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4160),
    [sym_intersection_type] = STATE(4160),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(984),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(989),
    [sym_identifier] = ACTIONS(1966),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3547] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(7184),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(7186),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [3548] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6990),
    [anon_sym_LBRACK] = ACTIONS(6990),
    [anon_sym_BANG] = ACTIONS(6988),
    [anon_sym_SEMI] = ACTIONS(6990),
    [anon_sym_BQUOTE] = ACTIONS(6990),
    [sym__automatic_semicolon] = ACTIONS(6990),
    [anon_sym_PIPE] = ACTIONS(6988),
    [anon_sym_COMMA] = ACTIONS(6990),
    [anon_sym_LT_LT] = ACTIONS(6990),
    [anon_sym_STAR] = ACTIONS(6988),
    [anon_sym_GT_GT_GT] = ACTIONS(6990),
    [anon_sym_AMP_AMP] = ACTIONS(6990),
    [anon_sym_DASH] = ACTIONS(6988),
    [anon_sym_BANG_EQ] = ACTIONS(6988),
    [anon_sym_LT_EQ] = ACTIONS(6990),
    [anon_sym_LPAREN] = ACTIONS(6990),
    [anon_sym_GT_EQ] = ACTIONS(6990),
    [anon_sym_GT] = ACTIONS(6988),
    [anon_sym_AMP] = ACTIONS(6988),
    [anon_sym_PERCENT] = ACTIONS(6990),
    [anon_sym_QMARK] = ACTIONS(6990),
    [anon_sym_RBRACE] = ACTIONS(6990),
    [anon_sym_as] = ACTIONS(6990),
    [anon_sym_PIPE_PIPE] = ACTIONS(6990),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_EQ_EQ] = ACTIONS(6988),
    [anon_sym_instanceof] = ACTIONS(6990),
    [anon_sym_LT] = ACTIONS(6988),
    [anon_sym_RPAREN] = ACTIONS(6990),
    [anon_sym_SLASH] = ACTIONS(6988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6990),
    [anon_sym_CARET] = ACTIONS(6990),
    [anon_sym_STAR_STAR] = ACTIONS(6990),
    [anon_sym_PLUS] = ACTIONS(6988),
    [anon_sym_GT_GT] = ACTIONS(6988),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6990),
    [anon_sym_in] = ACTIONS(6988),
  },
  [3549] = {
    [sym_formal_parameters] = STATE(4161),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3550] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(8304),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [3551] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(8307),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [3552] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6255),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(6255),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(8310),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(8310),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2063),
  },
  [3553] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3884),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5754),
  },
  [3554] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3555] = {
    [sym_new_expression] = STATE(724),
    [sym_augmented_assignment_expression] = STATE(724),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(724),
    [sym_update_expression] = STATE(724),
    [sym_regex] = STATE(724),
    [sym_meta_property] = STATE(724),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(724),
    [sym_yield_expression] = STATE(724),
    [sym_as_expression] = STATE(724),
    [sym_non_null_expression] = STATE(724),
    [sym_internal_module] = STATE(724),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(724),
    [sym_await_expression] = STATE(724),
    [sym_member_expression] = STATE(245),
    [sym_string] = STATE(724),
    [sym_this] = STATE(724),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(470),
    [sym_anonymous_class] = STATE(724),
    [sym_generator_function] = STATE(724),
    [sym_call_expression] = STATE(724),
    [sym_subscript_expression] = STATE(245),
    [sym_assignment_expression] = STATE(724),
    [sym_ternary_expression] = STATE(724),
    [sym_binary_expression] = STATE(724),
    [sym_template_string] = STATE(724),
    [sym_type_arguments] = STATE(251),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(724),
    [sym_array] = STATE(471),
    [sym_type_assertion] = STATE(724),
    [sym_class] = STATE(724),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_void] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(430),
    [sym_true] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_await] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1350),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1350),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(1350),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(416),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3556] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(242),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(4162),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(4163),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1374),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1376),
    [anon_sym_symbol] = ACTIONS(1376),
    [anon_sym_number] = ACTIONS(1376),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1378),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1376),
    [anon_sym_private] = ACTIONS(1376),
    [anon_sym_boolean] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1380),
    [anon_sym_public] = ACTIONS(1376),
    [anon_sym_get] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1376),
    [anon_sym_string] = ACTIONS(1376),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1376),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(1376),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3557] = {
    [sym_formal_parameters] = STATE(4164),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3558] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(8313),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [3559] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6249),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(6249),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_RPAREN] = ACTIONS(6249),
    [anon_sym_LT] = ACTIONS(6252),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(6252),
  },
  [3560] = {
    [sym_identifier] = ACTIONS(8316),
    [sym_comment] = ACTIONS(3),
  },
  [3561] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(8318),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [3562] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8321),
    [sym_identifier] = ACTIONS(8323),
    [sym__automatic_semicolon] = ACTIONS(8321),
    [anon_sym_BQUOTE] = ACTIONS(8321),
    [anon_sym_debugger] = ACTIONS(8323),
    [ts_builtin_sym_end] = ACTIONS(8321),
    [anon_sym_symbol] = ACTIONS(8323),
    [anon_sym_AT] = ACTIONS(8321),
    [anon_sym_PIPE] = ACTIONS(8323),
    [anon_sym_COMMA] = ACTIONS(8321),
    [anon_sym_DASH] = ACTIONS(8323),
    [anon_sym_STAR] = ACTIONS(8323),
    [anon_sym_GT_GT_GT] = ACTIONS(8321),
    [anon_sym_void] = ACTIONS(8323),
    [anon_sym_break] = ACTIONS(8323),
    [anon_sym_BANG_EQ] = ACTIONS(8323),
    [anon_sym_const] = ACTIONS(8323),
    [anon_sym_GT_EQ] = ACTIONS(8321),
    [sym_super] = ACTIONS(8323),
    [anon_sym_return] = ACTIONS(8323),
    [anon_sym_private] = ACTIONS(8323),
    [anon_sym_get] = ACTIONS(8323),
    [anon_sym_RBRACE] = ACTIONS(8321),
    [anon_sym_PERCENT] = ACTIONS(8321),
    [anon_sym_interface] = ACTIONS(8323),
    [anon_sym_default] = ACTIONS(8323),
    [anon_sym_as] = ACTIONS(8323),
    [anon_sym_delete] = ACTIONS(8323),
    [anon_sym_continue] = ACTIONS(8323),
    [anon_sym_DASH_DASH] = ACTIONS(8321),
    [anon_sym_if] = ACTIONS(8323),
    [anon_sym_instanceof] = ACTIONS(8323),
    [anon_sym_this] = ACTIONS(8323),
    [anon_sym_yield] = ACTIONS(8323),
    [sym_true] = ACTIONS(8323),
    [anon_sym_throw] = ACTIONS(8323),
    [anon_sym_enum] = ACTIONS(8323),
    [anon_sym_protected] = ACTIONS(8323),
    [anon_sym_abstract] = ACTIONS(8323),
    [anon_sym_DOT] = ACTIONS(8323),
    [anon_sym_set] = ACTIONS(8323),
    [anon_sym_type] = ACTIONS(8323),
    [anon_sym_STAR_STAR] = ACTIONS(8321),
    [anon_sym_import] = ACTIONS(8323),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8321),
    [anon_sym_namespace] = ACTIONS(8323),
    [anon_sym_PLUS_PLUS] = ACTIONS(8321),
    [anon_sym_await] = ACTIONS(8323),
    [anon_sym_DQUOTE] = ACTIONS(8321),
    [anon_sym_else] = ACTIONS(8323),
    [anon_sym_BANG] = ACTIONS(8323),
    [anon_sym_for] = ACTIONS(8323),
    [anon_sym_LBRACK] = ACTIONS(8321),
    [sym_false] = ACTIONS(8323),
    [anon_sym_SEMI] = ACTIONS(8321),
    [anon_sym_case] = ACTIONS(8323),
    [anon_sym_module] = ACTIONS(8323),
    [anon_sym_number] = ACTIONS(8323),
    [anon_sym_class] = ACTIONS(8323),
    [anon_sym_declare] = ACTIONS(8323),
    [anon_sym_typeof] = ACTIONS(8323),
    [anon_sym_LT_LT] = ACTIONS(8321),
    [anon_sym_LBRACE] = ACTIONS(8321),
    [anon_sym_AMP_AMP] = ACTIONS(8321),
    [anon_sym_switch] = ACTIONS(8323),
    [anon_sym_LT_EQ] = ACTIONS(8321),
    [anon_sym_LPAREN] = ACTIONS(8321),
    [sym_null] = ACTIONS(8323),
    [anon_sym_GT] = ACTIONS(8323),
    [anon_sym_any] = ACTIONS(8323),
    [anon_sym_boolean] = ACTIONS(8323),
    [anon_sym_async] = ACTIONS(8323),
    [anon_sym_public] = ACTIONS(8323),
    [anon_sym_AMP] = ACTIONS(8323),
    [anon_sym_var] = ACTIONS(8323),
    [anon_sym_QMARK] = ACTIONS(8321),
    [anon_sym_PIPE_PIPE] = ACTIONS(8321),
    [anon_sym_while] = ACTIONS(8323),
    [anon_sym_SQUOTE] = ACTIONS(8321),
    [anon_sym_try] = ACTIONS(8323),
    [anon_sym_EQ_EQ] = ACTIONS(8323),
    [anon_sym_RPAREN] = ACTIONS(8321),
    [anon_sym_LT] = ACTIONS(8323),
    [sym_number] = ACTIONS(8321),
    [anon_sym_SLASH] = ACTIONS(8323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8323),
    [anon_sym_function] = ACTIONS(8323),
    [sym_undefined] = ACTIONS(8323),
    [anon_sym_new] = ACTIONS(8323),
    [anon_sym_CARET] = ACTIONS(8321),
    [anon_sym_let] = ACTIONS(8323),
    [anon_sym_PLUS] = ACTIONS(8323),
    [anon_sym_export] = ACTIONS(8323),
    [anon_sym_GT_GT] = ACTIONS(8323),
    [anon_sym_do] = ACTIONS(8323),
    [anon_sym_TILDE] = ACTIONS(8321),
    [anon_sym_with] = ACTIONS(8323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8321),
    [anon_sym_in] = ACTIONS(8323),
  },
  [3563] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_LT_LT] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2117),
    [anon_sym_AMP_AMP] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(7180),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [3564] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8325),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(8327),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [3565] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8325),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(8327),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [3566] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4166),
    [sym_constructor_type] = STATE(4166),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(4166),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4166),
    [sym_intersection_type] = STATE(4166),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3567] = {
    [anon_sym_EQ_GT] = ACTIONS(8329),
    [sym_comment] = ACTIONS(3),
  },
  [3568] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4168),
    [sym_constructor_type] = STATE(4168),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(4168),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4168),
    [sym_intersection_type] = STATE(4168),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3569] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8325),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(8327),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [3570] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8325),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(8327),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [3571] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2097),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2099),
    [anon_sym_symbol] = ACTIONS(2099),
    [anon_sym_number] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2099),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2101),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2099),
    [anon_sym_private] = ACTIONS(2099),
    [anon_sym_boolean] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2099),
    [anon_sym_get] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2099),
    [anon_sym_string] = ACTIONS(2099),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2099),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(2099),
    [anon_sym_export] = ACTIONS(2099),
    [anon_sym_namespace] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3572] = {
    [anon_sym_EQ_GT] = ACTIONS(8331),
    [sym_comment] = ACTIONS(3),
  },
  [3573] = {
    [sym_formal_parameters] = STATE(4170),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3574] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3575] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3576] = {
    [anon_sym_EQ_GT] = ACTIONS(8333),
    [sym_comment] = ACTIONS(3),
  },
  [3577] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4172),
    [sym_constructor_type] = STATE(4172),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(4172),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4172),
    [sym_intersection_type] = STATE(4172),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3578] = {
    [anon_sym_EQ] = ACTIONS(6809),
    [anon_sym_LBRACK] = ACTIONS(6809),
    [anon_sym_AMP] = ACTIONS(6809),
    [anon_sym_SEMI] = ACTIONS(6809),
    [sym__automatic_semicolon] = ACTIONS(6809),
    [anon_sym_RBRACE] = ACTIONS(6809),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6809),
    [anon_sym_PIPE] = ACTIONS(6807),
    [anon_sym_COMMA] = ACTIONS(6809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6809),
  },
  [3579] = {
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(3470),
    [sym__automatic_semicolon] = ACTIONS(3470),
    [anon_sym_RBRACE] = ACTIONS(3470),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3470),
    [anon_sym_PIPE] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3470),
  },
  [3580] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1675),
    [sym_constructor_type] = STATE(1675),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1675),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1675),
    [sym_intersection_type] = STATE(1675),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(8335),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_boolean] = ACTIONS(472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_this] = ACTIONS(474),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [3581] = {
    [aux_sym_implements_clause_repeat1] = STATE(1677),
    [anon_sym_COMMA] = ACTIONS(8337),
    [anon_sym_GT] = ACTIONS(8335),
    [sym_comment] = ACTIONS(3),
  },
  [3582] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(8339),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8339),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [3583] = {
    [anon_sym_EQ] = ACTIONS(6821),
    [anon_sym_LBRACK] = ACTIONS(6821),
    [anon_sym_AMP] = ACTIONS(6821),
    [anon_sym_SEMI] = ACTIONS(6821),
    [sym__automatic_semicolon] = ACTIONS(6821),
    [anon_sym_RBRACE] = ACTIONS(6821),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6821),
    [anon_sym_PIPE] = ACTIONS(6819),
    [anon_sym_COMMA] = ACTIONS(6821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6821),
  },
  [3584] = {
    [aux_sym_object_type_repeat1] = STATE(2544),
    [sym__automatic_semicolon] = ACTIONS(8341),
    [anon_sym_RBRACE] = ACTIONS(8339),
    [anon_sym_SEMI] = ACTIONS(8341),
    [anon_sym_COMMA] = ACTIONS(8341),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8339),
    [sym_comment] = ACTIONS(3),
  },
  [3585] = {
    [anon_sym_EQ] = ACTIONS(6904),
    [anon_sym_LBRACK] = ACTIONS(6904),
    [anon_sym_AMP] = ACTIONS(6904),
    [anon_sym_SEMI] = ACTIONS(6904),
    [sym__automatic_semicolon] = ACTIONS(6904),
    [anon_sym_RBRACE] = ACTIONS(6904),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6904),
    [anon_sym_PIPE] = ACTIONS(6902),
    [anon_sym_COMMA] = ACTIONS(6904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6904),
  },
  [3586] = {
    [anon_sym_EQ] = ACTIONS(4363),
    [anon_sym_LBRACK] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4363),
    [anon_sym_SEMI] = ACTIONS(4363),
    [anon_sym_DOT] = ACTIONS(4363),
    [sym__automatic_semicolon] = ACTIONS(4363),
    [anon_sym_RBRACE] = ACTIONS(4363),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4363),
    [anon_sym_PIPE] = ACTIONS(4365),
    [anon_sym_COMMA] = ACTIONS(4363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4363),
  },
  [3587] = {
    [anon_sym_EQ] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(4063),
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(4065),
    [sym_comment] = ACTIONS(3),
  },
  [3588] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4177),
    [sym_constructor_type] = STATE(4177),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(4177),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4177),
    [sym_intersection_type] = STATE(4177),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1063),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1067),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3589] = {
    [anon_sym_EQ] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(4063),
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(4065),
    [sym_comment] = ACTIONS(3),
  },
  [3590] = {
    [anon_sym_EQ] = ACTIONS(6990),
    [anon_sym_LBRACK] = ACTIONS(6990),
    [anon_sym_AMP] = ACTIONS(6990),
    [anon_sym_SEMI] = ACTIONS(6990),
    [sym__automatic_semicolon] = ACTIONS(6990),
    [anon_sym_RBRACE] = ACTIONS(6990),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6990),
    [anon_sym_PIPE] = ACTIONS(6988),
    [anon_sym_COMMA] = ACTIONS(6990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6990),
  },
  [3591] = {
    [anon_sym_EQ_GT] = ACTIONS(8343),
    [sym_comment] = ACTIONS(3),
  },
  [3592] = {
    [sym_formal_parameters] = STATE(4179),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3593] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3594] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3595] = {
    [anon_sym_EQ_GT] = ACTIONS(8345),
    [sym_comment] = ACTIONS(3),
  },
  [3596] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4181),
    [sym_constructor_type] = STATE(4181),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(4181),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4181),
    [sym_intersection_type] = STATE(4181),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3597] = {
    [anon_sym_EQ] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4103),
    [sym_comment] = ACTIONS(3),
  },
  [3598] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4182),
    [sym_constructor_type] = STATE(4182),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(4182),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4182),
    [sym_intersection_type] = STATE(4182),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1086),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1088),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3599] = {
    [anon_sym_EQ] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4103),
    [sym_comment] = ACTIONS(3),
  },
  [3600] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(7180),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2255),
  },
  [3601] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8347),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_RPAREN] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [3602] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8347),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_RPAREN] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [3603] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4183),
    [sym_constructor_type] = STATE(4183),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(4183),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4183),
    [sym_intersection_type] = STATE(4183),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3604] = {
    [anon_sym_EQ_GT] = ACTIONS(8351),
    [sym_comment] = ACTIONS(3),
  },
  [3605] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4185),
    [sym_constructor_type] = STATE(4185),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(4185),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4185),
    [sym_intersection_type] = STATE(4185),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3606] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8347),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_RPAREN] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [3607] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8347),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [3608] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2293),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2295),
    [anon_sym_symbol] = ACTIONS(2295),
    [anon_sym_number] = ACTIONS(2295),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2295),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2297),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2295),
    [anon_sym_private] = ACTIONS(2295),
    [anon_sym_boolean] = ACTIONS(2295),
    [anon_sym_async] = ACTIONS(2299),
    [anon_sym_public] = ACTIONS(2295),
    [anon_sym_get] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2295),
    [anon_sym_string] = ACTIONS(2295),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2295),
    [anon_sym_type] = ACTIONS(2295),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(2295),
    [anon_sym_export] = ACTIONS(2295),
    [anon_sym_namespace] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3609] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(5132),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5130),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [3610] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5134),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [3611] = {
    [sym_new_expression] = STATE(4186),
    [sym_augmented_assignment_expression] = STATE(4186),
    [sym_unary_expression] = STATE(4186),
    [sym_update_expression] = STATE(4186),
    [sym_regex] = STATE(4186),
    [sym_meta_property] = STATE(4186),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(4186),
    [sym_yield_expression] = STATE(4186),
    [sym_as_expression] = STATE(4186),
    [sym_non_null_expression] = STATE(4186),
    [sym_internal_module] = STATE(4186),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4186),
    [sym_await_expression] = STATE(4186),
    [sym_member_expression] = STATE(1136),
    [sym_string] = STATE(4186),
    [sym_this] = STATE(4186),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1137),
    [sym_anonymous_class] = STATE(4186),
    [sym_generator_function] = STATE(4186),
    [sym_call_expression] = STATE(4186),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(4186),
    [sym_ternary_expression] = STATE(4186),
    [sym_binary_expression] = STATE(4186),
    [sym_template_string] = STATE(4186),
    [sym_type_arguments] = STATE(1138),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4186),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(4186),
    [sym_class] = STATE(4186),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(4217),
    [sym_false] = ACTIONS(8353),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8353),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8355),
    [sym_true] = ACTIONS(8353),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8353),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [3612] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4187),
    [sym_constructor_type] = STATE(4187),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(4187),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4187),
    [sym_intersection_type] = STATE(4187),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3613] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4188),
    [sym_constructor_type] = STATE(4188),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(4188),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4188),
    [sym_intersection_type] = STATE(4188),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3614] = {
    [anon_sym_EQ_GT] = ACTIONS(8357),
    [sym_comment] = ACTIONS(3),
  },
  [3615] = {
    [sym_formal_parameters] = STATE(4190),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3616] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3617] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3618] = {
    [anon_sym_EQ_GT] = ACTIONS(8359),
    [sym_comment] = ACTIONS(3),
  },
  [3619] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4192),
    [sym_constructor_type] = STATE(4192),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(4192),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4192),
    [sym_intersection_type] = STATE(4192),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3620] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4193),
    [sym_constructor_type] = STATE(4193),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(4193),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4193),
    [sym_intersection_type] = STATE(4193),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3621] = {
    [sym_new_expression] = STATE(2870),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(2870),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(2870),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(2870),
    [sym_call_signature] = STATE(1134),
    [sym_yield_expression] = STATE(2870),
    [sym_as_expression] = STATE(2870),
    [sym_internal_module] = STATE(2870),
    [sym_arrow_function] = STATE(2870),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(1136),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(1137),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(2870),
    [sym_subscript_expression] = STATE(1136),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(2870),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(2870),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(2870),
    [sym_meta_property] = STATE(2870),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(2870),
    [sym_non_null_expression] = STATE(2870),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(2870),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(2870),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(2870),
    [sym_call_expression] = STATE(2870),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(2870),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(2870),
    [sym_type_arguments] = STATE(1138),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(2870),
    [sym_array] = STATE(1139),
    [sym_type_assertion] = STATE(2870),
    [sym_class] = STATE(2870),
    [anon_sym_BANG] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(5946),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(5948),
    [anon_sym_number] = ACTIONS(5948),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(5950),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5952),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(5881),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5948),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(5948),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2357),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(5948),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(5881),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(8361),
    [anon_sym_import] = ACTIONS(2347),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(5952),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2357),
  },
  [3622] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4203),
    [anon_sym_AMP_EQ] = ACTIONS(4203),
    [anon_sym_PLUS_EQ] = ACTIONS(4203),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(4203),
    [anon_sym_STAR_EQ] = ACTIONS(4203),
    [anon_sym_PIPE_EQ] = ACTIONS(4203),
    [anon_sym_DASH_EQ] = ACTIONS(4203),
    [anon_sym_EQ_GT] = ACTIONS(4209),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4203),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT_EQ] = ACTIONS(4203),
    [anon_sym_DOT] = ACTIONS(6247),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4203),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4211),
  },
  [3623] = {
    [sym_identifier] = ACTIONS(8363),
    [anon_sym_BQUOTE] = ACTIONS(8365),
    [anon_sym_debugger] = ACTIONS(8363),
    [anon_sym_symbol] = ACTIONS(8363),
    [anon_sym_AT] = ACTIONS(8365),
    [anon_sym_DASH] = ACTIONS(8363),
    [anon_sym_void] = ACTIONS(8363),
    [anon_sym_break] = ACTIONS(8363),
    [anon_sym_const] = ACTIONS(8363),
    [sym_super] = ACTIONS(8363),
    [anon_sym_return] = ACTIONS(8363),
    [anon_sym_private] = ACTIONS(8363),
    [anon_sym_get] = ACTIONS(8363),
    [anon_sym_RBRACE] = ACTIONS(8365),
    [anon_sym_interface] = ACTIONS(8363),
    [anon_sym_default] = ACTIONS(8363),
    [anon_sym_enum] = ACTIONS(8363),
    [anon_sym_delete] = ACTIONS(8363),
    [anon_sym_continue] = ACTIONS(8363),
    [anon_sym_DASH_DASH] = ACTIONS(8365),
    [anon_sym_if] = ACTIONS(8363),
    [anon_sym_this] = ACTIONS(8363),
    [anon_sym_yield] = ACTIONS(8363),
    [sym_true] = ACTIONS(8363),
    [anon_sym_throw] = ACTIONS(8363),
    [anon_sym_protected] = ACTIONS(8363),
    [anon_sym_abstract] = ACTIONS(8363),
    [anon_sym_set] = ACTIONS(8363),
    [anon_sym_type] = ACTIONS(8363),
    [anon_sym_import] = ACTIONS(8363),
    [anon_sym_namespace] = ACTIONS(8363),
    [anon_sym_PLUS_PLUS] = ACTIONS(8365),
    [anon_sym_await] = ACTIONS(8363),
    [anon_sym_DQUOTE] = ACTIONS(8365),
    [anon_sym_else] = ACTIONS(8363),
    [anon_sym_BANG] = ACTIONS(8365),
    [anon_sym_for] = ACTIONS(8363),
    [anon_sym_LBRACK] = ACTIONS(8365),
    [sym_false] = ACTIONS(8363),
    [anon_sym_SEMI] = ACTIONS(8365),
    [anon_sym_case] = ACTIONS(8363),
    [anon_sym_module] = ACTIONS(8363),
    [anon_sym_number] = ACTIONS(8363),
    [anon_sym_class] = ACTIONS(8363),
    [anon_sym_declare] = ACTIONS(8363),
    [anon_sym_typeof] = ACTIONS(8363),
    [anon_sym_LBRACE] = ACTIONS(8365),
    [anon_sym_switch] = ACTIONS(8363),
    [anon_sym_LPAREN] = ACTIONS(8365),
    [sym_null] = ACTIONS(8363),
    [anon_sym_any] = ACTIONS(8363),
    [anon_sym_boolean] = ACTIONS(8363),
    [anon_sym_async] = ACTIONS(8363),
    [anon_sym_public] = ACTIONS(8363),
    [anon_sym_var] = ACTIONS(8363),
    [anon_sym_while] = ACTIONS(8363),
    [anon_sym_SQUOTE] = ACTIONS(8365),
    [anon_sym_try] = ACTIONS(8363),
    [anon_sym_LT] = ACTIONS(8365),
    [sym_number] = ACTIONS(8365),
    [anon_sym_SLASH] = ACTIONS(8363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8363),
    [anon_sym_function] = ACTIONS(8363),
    [sym_undefined] = ACTIONS(8363),
    [anon_sym_new] = ACTIONS(8363),
    [ts_builtin_sym_end] = ACTIONS(8365),
    [anon_sym_let] = ACTIONS(8363),
    [anon_sym_PLUS] = ACTIONS(8363),
    [anon_sym_export] = ACTIONS(8363),
    [anon_sym_do] = ACTIONS(8363),
    [anon_sym_TILDE] = ACTIONS(8365),
    [anon_sym_with] = ACTIONS(8363),
  },
  [3624] = {
    [sym_computed_property_name] = STATE(1144),
    [sym__enum_member] = STATE(2900),
    [sym__property_name] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_enum_assignment] = STATE(2900),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3625] = {
    [anon_sym_of] = ACTIONS(8367),
    [sym_comment] = ACTIONS(3),
  },
  [3626] = {
    [anon_sym_of] = ACTIONS(8369),
    [sym_comment] = ACTIONS(3),
  },
  [3627] = {
    [anon_sym_of] = ACTIONS(8371),
    [sym_comment] = ACTIONS(3),
  },
  [3628] = {
    [sym_new_expression] = STATE(4198),
    [sym_augmented_assignment_expression] = STATE(4198),
    [sym_unary_expression] = STATE(4198),
    [sym_update_expression] = STATE(4198),
    [sym_regex] = STATE(4198),
    [sym_meta_property] = STATE(4198),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4198),
    [sym_yield_expression] = STATE(4198),
    [sym_as_expression] = STATE(4198),
    [sym_non_null_expression] = STATE(4198),
    [sym_internal_module] = STATE(4198),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4198),
    [sym_await_expression] = STATE(4198),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4198),
    [sym_this] = STATE(4198),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4198),
    [sym_generator_function] = STATE(4198),
    [sym_call_expression] = STATE(4198),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4198),
    [sym_ternary_expression] = STATE(4198),
    [sym_binary_expression] = STATE(4198),
    [sym_template_string] = STATE(4198),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4198),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4198),
    [sym_class] = STATE(4198),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8373),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8373),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8375),
    [sym_true] = ACTIONS(8373),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8373),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3629] = {
    [sym_new_expression] = STATE(4199),
    [sym_augmented_assignment_expression] = STATE(4199),
    [sym_unary_expression] = STATE(4199),
    [sym_update_expression] = STATE(4199),
    [sym_regex] = STATE(4199),
    [sym_meta_property] = STATE(4199),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4199),
    [sym_yield_expression] = STATE(4199),
    [sym_as_expression] = STATE(4199),
    [sym_non_null_expression] = STATE(4199),
    [sym_internal_module] = STATE(4199),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4199),
    [sym_await_expression] = STATE(4199),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4199),
    [sym_this] = STATE(4199),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4199),
    [sym_generator_function] = STATE(4199),
    [sym_call_expression] = STATE(4199),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4199),
    [sym_ternary_expression] = STATE(4199),
    [sym_binary_expression] = STATE(4199),
    [sym_template_string] = STATE(4199),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4199),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4199),
    [sym_class] = STATE(4199),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8377),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8377),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8379),
    [sym_true] = ACTIONS(8377),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8377),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3630] = {
    [sym_new_expression] = STATE(4200),
    [sym_augmented_assignment_expression] = STATE(4200),
    [sym_unary_expression] = STATE(4200),
    [sym_update_expression] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_meta_property] = STATE(4200),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4200),
    [sym_yield_expression] = STATE(4200),
    [sym_as_expression] = STATE(4200),
    [sym_non_null_expression] = STATE(4200),
    [sym_internal_module] = STATE(4200),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4200),
    [sym_await_expression] = STATE(4200),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4200),
    [sym_this] = STATE(4200),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4200),
    [sym_generator_function] = STATE(4200),
    [sym_call_expression] = STATE(4200),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4200),
    [sym_ternary_expression] = STATE(4200),
    [sym_binary_expression] = STATE(4200),
    [sym_template_string] = STATE(4200),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4200),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4200),
    [sym_class] = STATE(4200),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8381),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8381),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8383),
    [sym_true] = ACTIONS(8381),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8381),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3631] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(8385),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3632] = {
    [anon_sym_RPAREN] = ACTIONS(8385),
    [sym_comment] = ACTIONS(3),
  },
  [3633] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8387),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3634] = {
    [sym_new_expression] = STATE(4203),
    [sym_augmented_assignment_expression] = STATE(4203),
    [sym_unary_expression] = STATE(4203),
    [sym_update_expression] = STATE(4203),
    [sym_regex] = STATE(4203),
    [sym_meta_property] = STATE(4203),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4203),
    [sym_yield_expression] = STATE(4203),
    [sym_as_expression] = STATE(4203),
    [sym_non_null_expression] = STATE(4203),
    [sym_internal_module] = STATE(4203),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4203),
    [sym_await_expression] = STATE(4203),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4204),
    [sym_string] = STATE(4203),
    [sym_this] = STATE(4203),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4203),
    [sym_generator_function] = STATE(4203),
    [sym_call_expression] = STATE(4203),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4203),
    [sym_ternary_expression] = STATE(4203),
    [sym_binary_expression] = STATE(4203),
    [sym_template_string] = STATE(4203),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4203),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4203),
    [sym_class] = STATE(4203),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(8389),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8389),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8391),
    [sym_true] = ACTIONS(8389),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8389),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [3635] = {
    [sym_new_expression] = STATE(4205),
    [sym_augmented_assignment_expression] = STATE(4205),
    [sym_unary_expression] = STATE(4205),
    [sym_update_expression] = STATE(4205),
    [sym_regex] = STATE(4205),
    [sym_meta_property] = STATE(4205),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4205),
    [sym_yield_expression] = STATE(4205),
    [sym_as_expression] = STATE(4205),
    [sym_non_null_expression] = STATE(4205),
    [sym_internal_module] = STATE(4205),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4205),
    [sym_await_expression] = STATE(4205),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4206),
    [sym_string] = STATE(4205),
    [sym_this] = STATE(4205),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4205),
    [sym_generator_function] = STATE(4205),
    [sym_call_expression] = STATE(4205),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4205),
    [sym_ternary_expression] = STATE(4205),
    [sym_binary_expression] = STATE(4205),
    [sym_template_string] = STATE(4205),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4205),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4205),
    [sym_class] = STATE(4205),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(8393),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8393),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8395),
    [sym_true] = ACTIONS(8393),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8393),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [3636] = {
    [sym_new_expression] = STATE(4207),
    [sym_augmented_assignment_expression] = STATE(4207),
    [sym_unary_expression] = STATE(4207),
    [sym_update_expression] = STATE(4207),
    [sym_regex] = STATE(4207),
    [sym_meta_property] = STATE(4207),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4207),
    [sym_yield_expression] = STATE(4207),
    [sym_as_expression] = STATE(4207),
    [sym_non_null_expression] = STATE(4207),
    [sym_internal_module] = STATE(4207),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4207),
    [sym_await_expression] = STATE(4207),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4208),
    [sym_string] = STATE(4207),
    [sym_this] = STATE(4207),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4207),
    [sym_generator_function] = STATE(4207),
    [sym_call_expression] = STATE(4207),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4207),
    [sym_ternary_expression] = STATE(4207),
    [sym_binary_expression] = STATE(4207),
    [sym_template_string] = STATE(4207),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4207),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4207),
    [sym_class] = STATE(4207),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(8397),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8397),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8399),
    [sym_true] = ACTIONS(8397),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8397),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [3637] = {
    [sym_type_alias_declaration] = STATE(3004),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3004),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3004),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3004),
    [sym_return_statement] = STATE(3004),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3004),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3004),
    [sym_switch_statement] = STATE(3004),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3004),
    [sym_throw_statement] = STATE(3004),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3004),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3004),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(3004),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3004),
    [sym_abstract_class] = STATE(3004),
    [sym_interface_declaration] = STATE(3004),
    [sym_statement_block] = STATE(3004),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3004),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3004),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3004),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3004),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3004),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3004),
    [sym_empty_statement] = STATE(3004),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(3004),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3004),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3004),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3004),
    [sym_break_statement] = STATE(3004),
    [sym_labeled_statement] = STATE(3004),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3004),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [3638] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(8401),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3639] = {
    [anon_sym_RPAREN] = ACTIONS(8401),
    [sym_comment] = ACTIONS(3),
  },
  [3640] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8403),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3641] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(8405),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3642] = {
    [anon_sym_RPAREN] = ACTIONS(8405),
    [sym_comment] = ACTIONS(3),
  },
  [3643] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8407),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3644] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(8409),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3645] = {
    [anon_sym_RPAREN] = ACTIONS(8409),
    [sym_comment] = ACTIONS(3),
  },
  [3646] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4219),
    [sym_constructor_type] = STATE(4219),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(4219),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4219),
    [sym_intersection_type] = STATE(4219),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3647] = {
    [anon_sym_EQ_GT] = ACTIONS(8421),
    [sym_comment] = ACTIONS(3),
  },
  [3648] = {
    [sym_formal_parameters] = STATE(4224),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3649] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3650] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3651] = {
    [anon_sym_EQ_GT] = ACTIONS(8423),
    [sym_comment] = ACTIONS(3),
  },
  [3652] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4226),
    [sym_constructor_type] = STATE(4226),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(4226),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4226),
    [sym_intersection_type] = STATE(4226),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3653] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(4321),
    [anon_sym_PIPE] = ACTIONS(4323),
    [anon_sym_SEMI] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [3654] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4227),
    [sym_constructor_type] = STATE(4227),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(4227),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4227),
    [sym_intersection_type] = STATE(4227),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3655] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(4321),
    [anon_sym_PIPE] = ACTIONS(4323),
    [anon_sym_SEMI] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [3656] = {
    [sym__automatic_semicolon] = ACTIONS(8425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(8425),
  },
  [3657] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8427),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3658] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8429),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3659] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8431),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3660] = {
    [sym_type_alias_declaration] = STATE(4231),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4231),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4231),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4231),
    [sym_return_statement] = STATE(4231),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4231),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4231),
    [sym_switch_statement] = STATE(4231),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4231),
    [sym_throw_statement] = STATE(4231),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4231),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4231),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(4231),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4231),
    [sym_abstract_class] = STATE(4231),
    [sym_interface_declaration] = STATE(4231),
    [sym_statement_block] = STATE(4231),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4231),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4231),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4231),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4231),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4231),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4231),
    [sym_empty_statement] = STATE(4231),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(4231),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4231),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4231),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4231),
    [sym_break_statement] = STATE(4231),
    [sym_labeled_statement] = STATE(4231),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4231),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3661] = {
    [sym_type_alias_declaration] = STATE(4232),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4232),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4232),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4232),
    [sym_return_statement] = STATE(4232),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4232),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4232),
    [sym_switch_statement] = STATE(4232),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4232),
    [sym_throw_statement] = STATE(4232),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4232),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4232),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(4232),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4232),
    [sym_abstract_class] = STATE(4232),
    [sym_interface_declaration] = STATE(4232),
    [sym_statement_block] = STATE(4232),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4232),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4232),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4232),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4232),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4232),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4232),
    [sym_empty_statement] = STATE(4232),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(4232),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4232),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4232),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4232),
    [sym_break_statement] = STATE(4232),
    [sym_labeled_statement] = STATE(4232),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4232),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3662] = {
    [sym_type_alias_declaration] = STATE(4233),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4233),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4233),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4233),
    [sym_return_statement] = STATE(4233),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4233),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4233),
    [sym_switch_statement] = STATE(4233),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4233),
    [sym_throw_statement] = STATE(4233),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4233),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4233),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(4233),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4233),
    [sym_abstract_class] = STATE(4233),
    [sym_interface_declaration] = STATE(4233),
    [sym_statement_block] = STATE(4233),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4233),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4233),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4233),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4233),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4233),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4233),
    [sym_empty_statement] = STATE(4233),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(4233),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4233),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4233),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4233),
    [sym_break_statement] = STATE(4233),
    [sym_labeled_statement] = STATE(4233),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4233),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3663] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [3664] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3665] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [3666] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2055),
    [anon_sym_PIPE] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [3667] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [3668] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2155),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(2155),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [3669] = {
    [sym_new_expression] = STATE(4234),
    [sym_augmented_assignment_expression] = STATE(4234),
    [sym_unary_expression] = STATE(4234),
    [sym_update_expression] = STATE(4234),
    [sym_regex] = STATE(4234),
    [sym_meta_property] = STATE(4234),
    [sym_call_signature] = STATE(2089),
    [sym_statement_block] = STATE(1530),
    [sym__expression] = STATE(4234),
    [sym_yield_expression] = STATE(4234),
    [sym_as_expression] = STATE(4234),
    [sym_non_null_expression] = STATE(4234),
    [sym_internal_module] = STATE(4234),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4234),
    [sym_await_expression] = STATE(4234),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(4234),
    [sym_this] = STATE(4234),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4234),
    [sym_generator_function] = STATE(4234),
    [sym_call_expression] = STATE(4234),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4234),
    [sym_ternary_expression] = STATE(4234),
    [sym_binary_expression] = STATE(4234),
    [sym_template_string] = STATE(4234),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4234),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4234),
    [sym_class] = STATE(4234),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(8433),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8433),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(8435),
    [sym_true] = ACTIONS(8433),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8433),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [3670] = {
    [sym_new_expression] = STATE(4235),
    [sym_augmented_assignment_expression] = STATE(4235),
    [sym_unary_expression] = STATE(4235),
    [sym_update_expression] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_meta_property] = STATE(4235),
    [sym_call_signature] = STATE(2089),
    [sym_statement_block] = STATE(1532),
    [sym__expression] = STATE(4235),
    [sym_yield_expression] = STATE(4235),
    [sym_as_expression] = STATE(4235),
    [sym_non_null_expression] = STATE(4235),
    [sym_internal_module] = STATE(4235),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4235),
    [sym_await_expression] = STATE(4235),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(4235),
    [sym_this] = STATE(4235),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4235),
    [sym_generator_function] = STATE(4235),
    [sym_call_expression] = STATE(4235),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4235),
    [sym_ternary_expression] = STATE(4235),
    [sym_binary_expression] = STATE(4235),
    [sym_template_string] = STATE(4235),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4235),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4235),
    [sym_class] = STATE(4235),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(8437),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8437),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(8439),
    [sym_true] = ACTIONS(8437),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8437),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [3671] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [3672] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(8441),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3673] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(8441),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3674] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [3675] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8444),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3676] = {
    [sym_type_arguments] = STATE(1845),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(3831),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_is] = ACTIONS(8446),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(8448),
  },
  [3677] = {
    [sym_tuple_type] = STATE(1847),
    [sym_index_type_query] = STATE(1847),
    [sym_lookup_type] = STATE(1847),
    [sym_this_type] = STATE(1847),
    [sym_flow_maybe_type] = STATE(1847),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_type_predicate] = STATE(1847),
    [sym_type_query] = STATE(1847),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(1847),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(1847),
    [sym__primary_type] = STATE(1847),
    [sym_generic_type] = STATE(1847),
    [sym_mapped_type] = STATE(1847),
    [sym_literal_type] = STATE(1847),
    [sym_parenthesized_type] = STATE(1847),
    [sym_predefined_type] = STATE(1847),
    [sym_string] = STATE(969),
    [sym_array_type] = STATE(1847),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [sym_true] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_LPAREN] = ACTIONS(3846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3678] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(1852),
    [sym_constructor_type] = STATE(1852),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(1852),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(1852),
    [sym_intersection_type] = STATE(1852),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3679] = {
    [sym_formal_parameters] = STATE(4239),
    [sym_type_parameters] = STATE(4240),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3680] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(1860),
    [sym_constructor_type] = STATE(1860),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(1860),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(1860),
    [sym_intersection_type] = STATE(1860),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3681] = {
    [sym_formal_parameters] = STATE(4243),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3682] = {
    [sym_type_arguments] = STATE(1866),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(3862),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(3867),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(8451),
  },
  [3683] = {
    [anon_sym_EQ_GT] = ACTIONS(8454),
    [sym_comment] = ACTIONS(3),
  },
  [3684] = {
    [sym__initializer] = STATE(71),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6067),
    [anon_sym_AMP_EQ] = ACTIONS(6067),
    [anon_sym_PLUS_EQ] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(6067),
    [anon_sym_STAR_EQ] = ACTIONS(6067),
    [anon_sym_PIPE_EQ] = ACTIONS(6067),
    [anon_sym_DASH_EQ] = ACTIONS(6067),
    [anon_sym_EQ_GT] = ACTIONS(6071),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6067),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT_EQ] = ACTIONS(6067),
    [anon_sym_DOT] = ACTIONS(3887),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8456),
  },
  [3685] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6075),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_AMP_EQ] = ACTIONS(6075),
    [anon_sym_PLUS_EQ] = ACTIONS(6075),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(6075),
    [anon_sym_STAR_EQ] = ACTIONS(6075),
    [anon_sym_PIPE_EQ] = ACTIONS(6075),
    [anon_sym_DASH_EQ] = ACTIONS(6075),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6075),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6075),
    [anon_sym_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3686] = {
    [sym_new_expression] = STATE(2950),
    [sym_augmented_assignment_expression] = STATE(2950),
    [sym_unary_expression] = STATE(2950),
    [sym_update_expression] = STATE(2950),
    [sym_regex] = STATE(2950),
    [sym_meta_property] = STATE(2950),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2950),
    [sym_yield_expression] = STATE(2950),
    [sym_as_expression] = STATE(2950),
    [sym_non_null_expression] = STATE(2950),
    [sym_internal_module] = STATE(2950),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2950),
    [sym_await_expression] = STATE(2950),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(2950),
    [sym_this] = STATE(2950),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2950),
    [sym_generator_function] = STATE(2950),
    [sym_call_expression] = STATE(2950),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2950),
    [sym_ternary_expression] = STATE(2950),
    [sym_binary_expression] = STATE(2950),
    [sym_template_string] = STATE(2950),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2950),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2950),
    [sym_class] = STATE(2950),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(8458),
    [sym_false] = ACTIONS(6079),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6079),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(6081),
    [sym_true] = ACTIONS(6079),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6079),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [3687] = {
    [sym_new_expression] = STATE(2951),
    [sym_augmented_assignment_expression] = STATE(2951),
    [sym_unary_expression] = STATE(2951),
    [sym_update_expression] = STATE(2951),
    [sym_regex] = STATE(2951),
    [sym_meta_property] = STATE(2951),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2951),
    [sym_yield_expression] = STATE(2951),
    [sym_as_expression] = STATE(2951),
    [sym_non_null_expression] = STATE(2951),
    [sym_internal_module] = STATE(2951),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2951),
    [sym_await_expression] = STATE(2951),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(2951),
    [sym_this] = STATE(2951),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2951),
    [sym_generator_function] = STATE(2951),
    [sym_call_expression] = STATE(2951),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2951),
    [sym_ternary_expression] = STATE(2951),
    [sym_binary_expression] = STATE(2951),
    [sym_template_string] = STATE(2951),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2951),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2951),
    [sym_class] = STATE(2951),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(6083),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6083),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(3905),
    [sym_true] = ACTIONS(6083),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6083),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [3688] = {
    [sym_new_expression] = STATE(2950),
    [sym_augmented_assignment_expression] = STATE(2950),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(2950),
    [sym_update_expression] = STATE(2950),
    [sym_regex] = STATE(2950),
    [sym_meta_property] = STATE(2950),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(2950),
    [sym_yield_expression] = STATE(2950),
    [sym_as_expression] = STATE(2950),
    [sym_non_null_expression] = STATE(2950),
    [sym_internal_module] = STATE(2950),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2950),
    [sym_await_expression] = STATE(2950),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(2950),
    [sym_this] = STATE(2950),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(2950),
    [sym_generator_function] = STATE(2950),
    [sym_call_expression] = STATE(2950),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(2950),
    [sym_ternary_expression] = STATE(2950),
    [sym_binary_expression] = STATE(2950),
    [sym_template_string] = STATE(2950),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2950),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(2950),
    [sym_class] = STATE(2950),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4377),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(6075),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_AMP_EQ] = ACTIONS(6075),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6075),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(6075),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_PIPE_EQ] = ACTIONS(6075),
    [anon_sym_DASH_EQ] = ACTIONS(6075),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6075),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(4395),
    [sym_true] = ACTIONS(6079),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6075),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(6079),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6075),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6079),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_STAR_EQ] = ACTIONS(6075),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6075),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6079),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3689] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(6099),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(6101),
    [anon_sym_symbol] = ACTIONS(6101),
    [anon_sym_number] = ACTIONS(6101),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6101),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(6103),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(6101),
    [anon_sym_private] = ACTIONS(6101),
    [anon_sym_boolean] = ACTIONS(6101),
    [anon_sym_async] = ACTIONS(6105),
    [anon_sym_public] = ACTIONS(6101),
    [anon_sym_get] = ACTIONS(6101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(6101),
    [anon_sym_string] = ACTIONS(6101),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(6101),
    [anon_sym_type] = ACTIONS(6101),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(6101),
    [anon_sym_export] = ACTIONS(6101),
    [anon_sym_namespace] = ACTIONS(6107),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3690] = {
    [sym_identifier] = ACTIONS(8460),
    [anon_sym_BQUOTE] = ACTIONS(8462),
    [anon_sym_debugger] = ACTIONS(8460),
    [anon_sym_symbol] = ACTIONS(8460),
    [anon_sym_AT] = ACTIONS(8462),
    [anon_sym_DASH] = ACTIONS(8460),
    [anon_sym_void] = ACTIONS(8460),
    [anon_sym_break] = ACTIONS(8460),
    [anon_sym_const] = ACTIONS(8460),
    [sym_super] = ACTIONS(8460),
    [anon_sym_return] = ACTIONS(8460),
    [anon_sym_private] = ACTIONS(8460),
    [anon_sym_get] = ACTIONS(8460),
    [anon_sym_RBRACE] = ACTIONS(8462),
    [anon_sym_interface] = ACTIONS(8460),
    [anon_sym_default] = ACTIONS(8460),
    [anon_sym_enum] = ACTIONS(8460),
    [anon_sym_delete] = ACTIONS(8460),
    [anon_sym_continue] = ACTIONS(8460),
    [anon_sym_DASH_DASH] = ACTIONS(8462),
    [anon_sym_if] = ACTIONS(8460),
    [anon_sym_this] = ACTIONS(8460),
    [anon_sym_yield] = ACTIONS(8460),
    [sym_true] = ACTIONS(8460),
    [anon_sym_throw] = ACTIONS(8460),
    [anon_sym_protected] = ACTIONS(8460),
    [anon_sym_abstract] = ACTIONS(8460),
    [anon_sym_set] = ACTIONS(8460),
    [anon_sym_type] = ACTIONS(8460),
    [anon_sym_import] = ACTIONS(8460),
    [anon_sym_namespace] = ACTIONS(8460),
    [anon_sym_PLUS_PLUS] = ACTIONS(8462),
    [anon_sym_await] = ACTIONS(8460),
    [anon_sym_DQUOTE] = ACTIONS(8462),
    [anon_sym_else] = ACTIONS(8460),
    [anon_sym_BANG] = ACTIONS(8462),
    [anon_sym_for] = ACTIONS(8460),
    [anon_sym_LBRACK] = ACTIONS(8462),
    [sym_false] = ACTIONS(8460),
    [anon_sym_SEMI] = ACTIONS(8462),
    [anon_sym_case] = ACTIONS(8460),
    [anon_sym_module] = ACTIONS(8460),
    [anon_sym_number] = ACTIONS(8460),
    [anon_sym_class] = ACTIONS(8460),
    [anon_sym_declare] = ACTIONS(8460),
    [anon_sym_typeof] = ACTIONS(8460),
    [anon_sym_LBRACE] = ACTIONS(8462),
    [anon_sym_switch] = ACTIONS(8460),
    [anon_sym_LPAREN] = ACTIONS(8462),
    [sym_null] = ACTIONS(8460),
    [anon_sym_any] = ACTIONS(8460),
    [anon_sym_boolean] = ACTIONS(8460),
    [anon_sym_async] = ACTIONS(8460),
    [anon_sym_public] = ACTIONS(8460),
    [anon_sym_var] = ACTIONS(8460),
    [anon_sym_while] = ACTIONS(8460),
    [anon_sym_SQUOTE] = ACTIONS(8462),
    [anon_sym_try] = ACTIONS(8460),
    [anon_sym_LT] = ACTIONS(8462),
    [sym_number] = ACTIONS(8462),
    [anon_sym_SLASH] = ACTIONS(8460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8460),
    [anon_sym_function] = ACTIONS(8460),
    [sym_undefined] = ACTIONS(8460),
    [anon_sym_new] = ACTIONS(8460),
    [ts_builtin_sym_end] = ACTIONS(8462),
    [anon_sym_let] = ACTIONS(8460),
    [anon_sym_PLUS] = ACTIONS(8460),
    [anon_sym_export] = ACTIONS(8460),
    [anon_sym_do] = ACTIONS(8460),
    [anon_sym_TILDE] = ACTIONS(8462),
    [anon_sym_with] = ACTIONS(8460),
  },
  [3691] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(8441),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3692] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [3693] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3694] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [3695] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [3696] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [3697] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(2155),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [3698] = {
    [sym_new_expression] = STATE(4248),
    [sym_augmented_assignment_expression] = STATE(4248),
    [sym_unary_expression] = STATE(4248),
    [sym_update_expression] = STATE(4248),
    [sym_regex] = STATE(4248),
    [sym_meta_property] = STATE(4248),
    [sym_call_signature] = STATE(2107),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(4248),
    [sym_yield_expression] = STATE(4248),
    [sym_as_expression] = STATE(4248),
    [sym_non_null_expression] = STATE(4248),
    [sym_internal_module] = STATE(4248),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4248),
    [sym_await_expression] = STATE(4248),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4248),
    [sym_this] = STATE(4248),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4248),
    [sym_generator_function] = STATE(4248),
    [sym_call_expression] = STATE(4248),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4248),
    [sym_ternary_expression] = STATE(4248),
    [sym_binary_expression] = STATE(4248),
    [sym_template_string] = STATE(4248),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4248),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4248),
    [sym_class] = STATE(4248),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8464),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8464),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8466),
    [sym_true] = ACTIONS(8464),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8464),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3699] = {
    [sym_new_expression] = STATE(4249),
    [sym_augmented_assignment_expression] = STATE(4249),
    [sym_unary_expression] = STATE(4249),
    [sym_update_expression] = STATE(4249),
    [sym_regex] = STATE(4249),
    [sym_meta_property] = STATE(4249),
    [sym_call_signature] = STATE(2107),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(4249),
    [sym_yield_expression] = STATE(4249),
    [sym_as_expression] = STATE(4249),
    [sym_non_null_expression] = STATE(4249),
    [sym_internal_module] = STATE(4249),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4249),
    [sym_await_expression] = STATE(4249),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4249),
    [sym_this] = STATE(4249),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4249),
    [sym_generator_function] = STATE(4249),
    [sym_call_expression] = STATE(4249),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4249),
    [sym_ternary_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4249),
    [sym_template_string] = STATE(4249),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4249),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4249),
    [sym_class] = STATE(4249),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8468),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8468),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8470),
    [sym_true] = ACTIONS(8468),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8468),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3700] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [3701] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(8472),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3702] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(8472),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3703] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [3704] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8475),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3705] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(8477),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(8479),
  },
  [3706] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3707] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3708] = {
    [sym_formal_parameters] = STATE(4253),
    [sym_type_parameters] = STATE(4254),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3709] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3710] = {
    [sym_formal_parameters] = STATE(4257),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3711] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(8482),
  },
  [3712] = {
    [anon_sym_EQ_GT] = ACTIONS(8485),
    [sym_comment] = ACTIONS(3),
  },
  [3713] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6127),
    [anon_sym_AMP_EQ] = ACTIONS(6127),
    [anon_sym_PLUS_EQ] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(6127),
    [anon_sym_STAR_EQ] = ACTIONS(6127),
    [anon_sym_PIPE_EQ] = ACTIONS(6127),
    [anon_sym_DASH_EQ] = ACTIONS(6127),
    [anon_sym_EQ_GT] = ACTIONS(6131),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6127),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT_EQ] = ACTIONS(6127),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8487),
  },
  [3714] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3715] = {
    [sym_new_expression] = STATE(2977),
    [sym_augmented_assignment_expression] = STATE(2977),
    [sym_unary_expression] = STATE(2977),
    [sym_update_expression] = STATE(2977),
    [sym_regex] = STATE(2977),
    [sym_meta_property] = STATE(2977),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2977),
    [sym_yield_expression] = STATE(2977),
    [sym_as_expression] = STATE(2977),
    [sym_non_null_expression] = STATE(2977),
    [sym_internal_module] = STATE(2977),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2977),
    [sym_await_expression] = STATE(2977),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2977),
    [sym_this] = STATE(2977),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2977),
    [sym_generator_function] = STATE(2977),
    [sym_call_expression] = STATE(2977),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2977),
    [sym_ternary_expression] = STATE(2977),
    [sym_binary_expression] = STATE(2977),
    [sym_template_string] = STATE(2977),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2977),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2977),
    [sym_class] = STATE(2977),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(8489),
    [sym_false] = ACTIONS(6139),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6139),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6141),
    [sym_true] = ACTIONS(6139),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6139),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3716] = {
    [sym_new_expression] = STATE(2978),
    [sym_augmented_assignment_expression] = STATE(2978),
    [sym_unary_expression] = STATE(2978),
    [sym_update_expression] = STATE(2978),
    [sym_regex] = STATE(2978),
    [sym_meta_property] = STATE(2978),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2978),
    [sym_yield_expression] = STATE(2978),
    [sym_as_expression] = STATE(2978),
    [sym_non_null_expression] = STATE(2978),
    [sym_internal_module] = STATE(2978),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2978),
    [sym_await_expression] = STATE(2978),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2978),
    [sym_this] = STATE(2978),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2978),
    [sym_generator_function] = STATE(2978),
    [sym_call_expression] = STATE(2978),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2978),
    [sym_ternary_expression] = STATE(2978),
    [sym_binary_expression] = STATE(2978),
    [sym_template_string] = STATE(2978),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2978),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2978),
    [sym_class] = STATE(2978),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(6143),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6143),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(6143),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6143),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3717] = {
    [sym_new_expression] = STATE(2977),
    [sym_augmented_assignment_expression] = STATE(2977),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(2977),
    [sym_update_expression] = STATE(2977),
    [sym_regex] = STATE(2977),
    [sym_meta_property] = STATE(2977),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(2977),
    [sym_yield_expression] = STATE(2977),
    [sym_as_expression] = STATE(2977),
    [sym_non_null_expression] = STATE(2977),
    [sym_internal_module] = STATE(2977),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(2977),
    [sym_await_expression] = STATE(2977),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(2977),
    [sym_this] = STATE(2977),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(2977),
    [sym_generator_function] = STATE(2977),
    [sym_call_expression] = STATE(2977),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(2977),
    [sym_ternary_expression] = STATE(2977),
    [sym_binary_expression] = STATE(2977),
    [sym_template_string] = STATE(2977),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2977),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(2977),
    [sym_class] = STATE(2977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4405),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(4423),
    [sym_true] = ACTIONS(6139),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(4411),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6139),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6139),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_EQ_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6141),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6139),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3718] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(6159),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(6161),
    [anon_sym_symbol] = ACTIONS(6161),
    [anon_sym_number] = ACTIONS(6161),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(6161),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(6163),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6161),
    [anon_sym_private] = ACTIONS(6161),
    [anon_sym_boolean] = ACTIONS(6161),
    [anon_sym_async] = ACTIONS(6165),
    [anon_sym_public] = ACTIONS(6161),
    [anon_sym_get] = ACTIONS(6161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(6161),
    [anon_sym_string] = ACTIONS(6161),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(6161),
    [anon_sym_type] = ACTIONS(6161),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(6161),
    [anon_sym_export] = ACTIONS(6161),
    [anon_sym_namespace] = ACTIONS(6167),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3719] = {
    [sym_identifier] = ACTIONS(8491),
    [anon_sym_BQUOTE] = ACTIONS(8493),
    [anon_sym_debugger] = ACTIONS(8491),
    [anon_sym_symbol] = ACTIONS(8491),
    [anon_sym_AT] = ACTIONS(8493),
    [anon_sym_DASH] = ACTIONS(8491),
    [anon_sym_void] = ACTIONS(8491),
    [anon_sym_break] = ACTIONS(8491),
    [anon_sym_const] = ACTIONS(8491),
    [sym_super] = ACTIONS(8491),
    [anon_sym_return] = ACTIONS(8491),
    [anon_sym_private] = ACTIONS(8491),
    [anon_sym_get] = ACTIONS(8491),
    [anon_sym_RBRACE] = ACTIONS(8493),
    [anon_sym_interface] = ACTIONS(8491),
    [anon_sym_default] = ACTIONS(8491),
    [anon_sym_enum] = ACTIONS(8491),
    [anon_sym_delete] = ACTIONS(8491),
    [anon_sym_continue] = ACTIONS(8491),
    [anon_sym_DASH_DASH] = ACTIONS(8493),
    [anon_sym_if] = ACTIONS(8491),
    [anon_sym_this] = ACTIONS(8491),
    [anon_sym_yield] = ACTIONS(8491),
    [sym_true] = ACTIONS(8491),
    [anon_sym_throw] = ACTIONS(8491),
    [anon_sym_protected] = ACTIONS(8491),
    [anon_sym_abstract] = ACTIONS(8491),
    [anon_sym_set] = ACTIONS(8491),
    [anon_sym_type] = ACTIONS(8491),
    [anon_sym_import] = ACTIONS(8491),
    [anon_sym_namespace] = ACTIONS(8491),
    [anon_sym_PLUS_PLUS] = ACTIONS(8493),
    [anon_sym_await] = ACTIONS(8491),
    [anon_sym_DQUOTE] = ACTIONS(8493),
    [anon_sym_else] = ACTIONS(8491),
    [anon_sym_BANG] = ACTIONS(8493),
    [anon_sym_for] = ACTIONS(8491),
    [anon_sym_LBRACK] = ACTIONS(8493),
    [sym_false] = ACTIONS(8491),
    [anon_sym_SEMI] = ACTIONS(8493),
    [anon_sym_case] = ACTIONS(8491),
    [anon_sym_module] = ACTIONS(8491),
    [anon_sym_number] = ACTIONS(8491),
    [anon_sym_class] = ACTIONS(8491),
    [anon_sym_declare] = ACTIONS(8491),
    [anon_sym_typeof] = ACTIONS(8491),
    [anon_sym_LBRACE] = ACTIONS(8493),
    [anon_sym_switch] = ACTIONS(8491),
    [anon_sym_LPAREN] = ACTIONS(8493),
    [sym_null] = ACTIONS(8491),
    [anon_sym_any] = ACTIONS(8491),
    [anon_sym_boolean] = ACTIONS(8491),
    [anon_sym_async] = ACTIONS(8491),
    [anon_sym_public] = ACTIONS(8491),
    [anon_sym_var] = ACTIONS(8491),
    [anon_sym_while] = ACTIONS(8491),
    [anon_sym_SQUOTE] = ACTIONS(8493),
    [anon_sym_try] = ACTIONS(8491),
    [anon_sym_LT] = ACTIONS(8493),
    [sym_number] = ACTIONS(8493),
    [anon_sym_SLASH] = ACTIONS(8491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8491),
    [anon_sym_function] = ACTIONS(8491),
    [sym_undefined] = ACTIONS(8491),
    [anon_sym_new] = ACTIONS(8491),
    [ts_builtin_sym_end] = ACTIONS(8493),
    [anon_sym_let] = ACTIONS(8491),
    [anon_sym_PLUS] = ACTIONS(8491),
    [anon_sym_export] = ACTIONS(8491),
    [anon_sym_do] = ACTIONS(8491),
    [anon_sym_TILDE] = ACTIONS(8493),
    [anon_sym_with] = ACTIONS(8491),
  },
  [3720] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(8472),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3721] = {
    [sym_type_alias_declaration] = STATE(4262),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4262),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4262),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4262),
    [sym_return_statement] = STATE(4262),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4262),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4262),
    [sym_switch_statement] = STATE(4262),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4262),
    [sym_throw_statement] = STATE(4262),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4262),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4262),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(4262),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4262),
    [sym_abstract_class] = STATE(4262),
    [sym_interface_declaration] = STATE(4262),
    [sym_statement_block] = STATE(4262),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4262),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4262),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4262),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4262),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4262),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4262),
    [sym_empty_statement] = STATE(4262),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(4262),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4262),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4262),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4262),
    [sym_break_statement] = STATE(4262),
    [sym_labeled_statement] = STATE(4262),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4262),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3722] = {
    [sym_type_alias_declaration] = STATE(4263),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4263),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4263),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4263),
    [sym_return_statement] = STATE(4263),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4263),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4263),
    [sym_switch_statement] = STATE(4263),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4263),
    [sym_throw_statement] = STATE(4263),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4263),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4263),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(4263),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4263),
    [sym_abstract_class] = STATE(4263),
    [sym_interface_declaration] = STATE(4263),
    [sym_statement_block] = STATE(4263),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4263),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4263),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4263),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4263),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4263),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4263),
    [sym_empty_statement] = STATE(4263),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(4263),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4263),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4263),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4263),
    [sym_break_statement] = STATE(4263),
    [sym_labeled_statement] = STATE(4263),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4263),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3723] = {
    [sym_type_alias_declaration] = STATE(4264),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4264),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4264),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4264),
    [sym_return_statement] = STATE(4264),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4264),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4264),
    [sym_switch_statement] = STATE(4264),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4264),
    [sym_throw_statement] = STATE(4264),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4264),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4264),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(4264),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4264),
    [sym_abstract_class] = STATE(4264),
    [sym_interface_declaration] = STATE(4264),
    [sym_statement_block] = STATE(4264),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4264),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4264),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4264),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4264),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4264),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4264),
    [sym_empty_statement] = STATE(4264),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(4264),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4264),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4264),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4264),
    [sym_break_statement] = STATE(4264),
    [sym_labeled_statement] = STATE(4264),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4264),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3724] = {
    [sym_identifier] = ACTIONS(8495),
    [anon_sym_BQUOTE] = ACTIONS(8497),
    [anon_sym_debugger] = ACTIONS(8495),
    [anon_sym_symbol] = ACTIONS(8495),
    [anon_sym_AT] = ACTIONS(8497),
    [anon_sym_DASH] = ACTIONS(8495),
    [anon_sym_void] = ACTIONS(8495),
    [anon_sym_break] = ACTIONS(8495),
    [anon_sym_const] = ACTIONS(8495),
    [sym_super] = ACTIONS(8495),
    [anon_sym_return] = ACTIONS(8495),
    [anon_sym_private] = ACTIONS(8495),
    [anon_sym_get] = ACTIONS(8495),
    [anon_sym_RBRACE] = ACTIONS(8497),
    [anon_sym_interface] = ACTIONS(8495),
    [anon_sym_default] = ACTIONS(8495),
    [anon_sym_enum] = ACTIONS(8495),
    [anon_sym_delete] = ACTIONS(8495),
    [anon_sym_continue] = ACTIONS(8495),
    [anon_sym_DASH_DASH] = ACTIONS(8497),
    [anon_sym_if] = ACTIONS(8495),
    [anon_sym_this] = ACTIONS(8495),
    [anon_sym_yield] = ACTIONS(8495),
    [sym_true] = ACTIONS(8495),
    [anon_sym_throw] = ACTIONS(8495),
    [anon_sym_protected] = ACTIONS(8495),
    [anon_sym_abstract] = ACTIONS(8495),
    [anon_sym_set] = ACTIONS(8495),
    [anon_sym_type] = ACTIONS(8495),
    [anon_sym_import] = ACTIONS(8495),
    [anon_sym_namespace] = ACTIONS(8495),
    [anon_sym_PLUS_PLUS] = ACTIONS(8497),
    [anon_sym_await] = ACTIONS(8495),
    [anon_sym_DQUOTE] = ACTIONS(8497),
    [anon_sym_else] = ACTIONS(8495),
    [anon_sym_BANG] = ACTIONS(8497),
    [anon_sym_for] = ACTIONS(8495),
    [anon_sym_LBRACK] = ACTIONS(8497),
    [sym_false] = ACTIONS(8495),
    [anon_sym_SEMI] = ACTIONS(8497),
    [anon_sym_case] = ACTIONS(8495),
    [anon_sym_module] = ACTIONS(8495),
    [anon_sym_number] = ACTIONS(8495),
    [anon_sym_class] = ACTIONS(8495),
    [anon_sym_declare] = ACTIONS(8495),
    [anon_sym_typeof] = ACTIONS(8495),
    [anon_sym_LBRACE] = ACTIONS(8497),
    [anon_sym_switch] = ACTIONS(8495),
    [anon_sym_LPAREN] = ACTIONS(8497),
    [sym_null] = ACTIONS(8495),
    [anon_sym_any] = ACTIONS(8495),
    [anon_sym_boolean] = ACTIONS(8495),
    [anon_sym_async] = ACTIONS(8495),
    [anon_sym_public] = ACTIONS(8495),
    [anon_sym_var] = ACTIONS(8495),
    [anon_sym_while] = ACTIONS(8495),
    [anon_sym_SQUOTE] = ACTIONS(8497),
    [anon_sym_try] = ACTIONS(8495),
    [anon_sym_LT] = ACTIONS(8497),
    [sym_number] = ACTIONS(8497),
    [anon_sym_SLASH] = ACTIONS(8495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8495),
    [anon_sym_function] = ACTIONS(8495),
    [sym_undefined] = ACTIONS(8495),
    [anon_sym_new] = ACTIONS(8495),
    [ts_builtin_sym_end] = ACTIONS(8497),
    [anon_sym_let] = ACTIONS(8495),
    [anon_sym_PLUS] = ACTIONS(8495),
    [anon_sym_export] = ACTIONS(8495),
    [anon_sym_do] = ACTIONS(8495),
    [anon_sym_TILDE] = ACTIONS(8497),
    [anon_sym_with] = ACTIONS(8495),
  },
  [3725] = {
    [sym_identifier] = ACTIONS(8499),
    [anon_sym_BQUOTE] = ACTIONS(8501),
    [anon_sym_debugger] = ACTIONS(8499),
    [anon_sym_symbol] = ACTIONS(8499),
    [anon_sym_AT] = ACTIONS(8501),
    [anon_sym_DASH] = ACTIONS(8499),
    [anon_sym_void] = ACTIONS(8499),
    [anon_sym_break] = ACTIONS(8499),
    [anon_sym_const] = ACTIONS(8499),
    [sym_super] = ACTIONS(8499),
    [anon_sym_return] = ACTIONS(8499),
    [anon_sym_private] = ACTIONS(8499),
    [anon_sym_get] = ACTIONS(8499),
    [anon_sym_RBRACE] = ACTIONS(8501),
    [anon_sym_interface] = ACTIONS(8499),
    [anon_sym_default] = ACTIONS(8499),
    [anon_sym_enum] = ACTIONS(8499),
    [anon_sym_delete] = ACTIONS(8499),
    [anon_sym_continue] = ACTIONS(8499),
    [anon_sym_DASH_DASH] = ACTIONS(8501),
    [anon_sym_if] = ACTIONS(8499),
    [anon_sym_this] = ACTIONS(8499),
    [anon_sym_yield] = ACTIONS(8499),
    [sym_true] = ACTIONS(8499),
    [anon_sym_throw] = ACTIONS(8499),
    [anon_sym_protected] = ACTIONS(8499),
    [anon_sym_abstract] = ACTIONS(8499),
    [anon_sym_set] = ACTIONS(8499),
    [anon_sym_type] = ACTIONS(8499),
    [anon_sym_import] = ACTIONS(8499),
    [anon_sym_namespace] = ACTIONS(8499),
    [anon_sym_PLUS_PLUS] = ACTIONS(8501),
    [anon_sym_await] = ACTIONS(8499),
    [anon_sym_DQUOTE] = ACTIONS(8501),
    [anon_sym_else] = ACTIONS(8499),
    [anon_sym_BANG] = ACTIONS(8501),
    [anon_sym_for] = ACTIONS(8499),
    [anon_sym_LBRACK] = ACTIONS(8501),
    [sym_false] = ACTIONS(8499),
    [anon_sym_SEMI] = ACTIONS(8501),
    [anon_sym_case] = ACTIONS(8499),
    [anon_sym_module] = ACTIONS(8499),
    [anon_sym_number] = ACTIONS(8499),
    [anon_sym_class] = ACTIONS(8499),
    [anon_sym_declare] = ACTIONS(8499),
    [anon_sym_typeof] = ACTIONS(8499),
    [anon_sym_LBRACE] = ACTIONS(8501),
    [anon_sym_switch] = ACTIONS(8499),
    [anon_sym_LPAREN] = ACTIONS(8501),
    [sym_null] = ACTIONS(8499),
    [anon_sym_any] = ACTIONS(8499),
    [anon_sym_boolean] = ACTIONS(8499),
    [anon_sym_async] = ACTIONS(8499),
    [anon_sym_public] = ACTIONS(8499),
    [anon_sym_var] = ACTIONS(8499),
    [anon_sym_while] = ACTIONS(8499),
    [anon_sym_SQUOTE] = ACTIONS(8501),
    [anon_sym_try] = ACTIONS(8499),
    [anon_sym_LT] = ACTIONS(8501),
    [sym_number] = ACTIONS(8501),
    [anon_sym_SLASH] = ACTIONS(8499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8499),
    [anon_sym_function] = ACTIONS(8499),
    [sym_undefined] = ACTIONS(8499),
    [anon_sym_new] = ACTIONS(8499),
    [ts_builtin_sym_end] = ACTIONS(8501),
    [anon_sym_let] = ACTIONS(8499),
    [anon_sym_PLUS] = ACTIONS(8499),
    [anon_sym_export] = ACTIONS(8499),
    [anon_sym_do] = ACTIONS(8499),
    [anon_sym_TILDE] = ACTIONS(8501),
    [anon_sym_with] = ACTIONS(8499),
  },
  [3726] = {
    [sym_identifier] = ACTIONS(8503),
    [anon_sym_BQUOTE] = ACTIONS(8505),
    [anon_sym_debugger] = ACTIONS(8503),
    [anon_sym_symbol] = ACTIONS(8503),
    [anon_sym_AT] = ACTIONS(8505),
    [anon_sym_DASH] = ACTIONS(8503),
    [anon_sym_void] = ACTIONS(8503),
    [anon_sym_break] = ACTIONS(8503),
    [anon_sym_const] = ACTIONS(8503),
    [sym_super] = ACTIONS(8503),
    [anon_sym_return] = ACTIONS(8503),
    [anon_sym_private] = ACTIONS(8503),
    [anon_sym_get] = ACTIONS(8503),
    [anon_sym_RBRACE] = ACTIONS(8505),
    [anon_sym_interface] = ACTIONS(8503),
    [anon_sym_default] = ACTIONS(8503),
    [anon_sym_enum] = ACTIONS(8503),
    [anon_sym_delete] = ACTIONS(8503),
    [anon_sym_continue] = ACTIONS(8503),
    [anon_sym_DASH_DASH] = ACTIONS(8505),
    [anon_sym_if] = ACTIONS(8503),
    [anon_sym_this] = ACTIONS(8503),
    [anon_sym_yield] = ACTIONS(8503),
    [sym_true] = ACTIONS(8503),
    [anon_sym_throw] = ACTIONS(8503),
    [anon_sym_protected] = ACTIONS(8503),
    [anon_sym_abstract] = ACTIONS(8503),
    [anon_sym_set] = ACTIONS(8503),
    [anon_sym_type] = ACTIONS(8503),
    [anon_sym_import] = ACTIONS(8503),
    [anon_sym_namespace] = ACTIONS(8503),
    [anon_sym_PLUS_PLUS] = ACTIONS(8505),
    [anon_sym_await] = ACTIONS(8503),
    [anon_sym_DQUOTE] = ACTIONS(8505),
    [anon_sym_else] = ACTIONS(8503),
    [anon_sym_BANG] = ACTIONS(8505),
    [anon_sym_for] = ACTIONS(8503),
    [anon_sym_LBRACK] = ACTIONS(8505),
    [sym_false] = ACTIONS(8503),
    [anon_sym_SEMI] = ACTIONS(8505),
    [anon_sym_case] = ACTIONS(8503),
    [anon_sym_module] = ACTIONS(8503),
    [anon_sym_number] = ACTIONS(8503),
    [anon_sym_class] = ACTIONS(8503),
    [anon_sym_declare] = ACTIONS(8503),
    [anon_sym_typeof] = ACTIONS(8503),
    [anon_sym_LBRACE] = ACTIONS(8505),
    [anon_sym_switch] = ACTIONS(8503),
    [anon_sym_LPAREN] = ACTIONS(8505),
    [sym_null] = ACTIONS(8503),
    [anon_sym_any] = ACTIONS(8503),
    [anon_sym_boolean] = ACTIONS(8503),
    [anon_sym_async] = ACTIONS(8503),
    [anon_sym_public] = ACTIONS(8503),
    [anon_sym_var] = ACTIONS(8503),
    [anon_sym_while] = ACTIONS(8503),
    [anon_sym_SQUOTE] = ACTIONS(8505),
    [anon_sym_try] = ACTIONS(8503),
    [anon_sym_LT] = ACTIONS(8505),
    [sym_number] = ACTIONS(8505),
    [anon_sym_SLASH] = ACTIONS(8503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8503),
    [anon_sym_function] = ACTIONS(8503),
    [sym_undefined] = ACTIONS(8503),
    [anon_sym_new] = ACTIONS(8503),
    [ts_builtin_sym_end] = ACTIONS(8505),
    [anon_sym_let] = ACTIONS(8503),
    [anon_sym_PLUS] = ACTIONS(8503),
    [anon_sym_export] = ACTIONS(8503),
    [anon_sym_do] = ACTIONS(8503),
    [anon_sym_TILDE] = ACTIONS(8505),
    [anon_sym_with] = ACTIONS(8503),
  },
  [3727] = {
    [sym_identifier] = ACTIONS(8507),
    [anon_sym_BQUOTE] = ACTIONS(8509),
    [anon_sym_debugger] = ACTIONS(8507),
    [anon_sym_symbol] = ACTIONS(8507),
    [anon_sym_AT] = ACTIONS(8509),
    [anon_sym_DASH] = ACTIONS(8507),
    [anon_sym_void] = ACTIONS(8507),
    [anon_sym_break] = ACTIONS(8507),
    [anon_sym_const] = ACTIONS(8507),
    [sym_super] = ACTIONS(8507),
    [anon_sym_return] = ACTIONS(8507),
    [anon_sym_private] = ACTIONS(8507),
    [anon_sym_get] = ACTIONS(8507),
    [anon_sym_RBRACE] = ACTIONS(8509),
    [anon_sym_interface] = ACTIONS(8507),
    [anon_sym_default] = ACTIONS(8507),
    [anon_sym_enum] = ACTIONS(8507),
    [anon_sym_delete] = ACTIONS(8507),
    [anon_sym_continue] = ACTIONS(8507),
    [anon_sym_DASH_DASH] = ACTIONS(8509),
    [anon_sym_if] = ACTIONS(8507),
    [anon_sym_this] = ACTIONS(8507),
    [anon_sym_yield] = ACTIONS(8507),
    [sym_true] = ACTIONS(8507),
    [anon_sym_throw] = ACTIONS(8507),
    [anon_sym_protected] = ACTIONS(8507),
    [anon_sym_abstract] = ACTIONS(8507),
    [anon_sym_set] = ACTIONS(8507),
    [anon_sym_type] = ACTIONS(8507),
    [anon_sym_import] = ACTIONS(8507),
    [anon_sym_namespace] = ACTIONS(8507),
    [anon_sym_PLUS_PLUS] = ACTIONS(8509),
    [anon_sym_await] = ACTIONS(8507),
    [anon_sym_DQUOTE] = ACTIONS(8509),
    [anon_sym_else] = ACTIONS(8507),
    [anon_sym_BANG] = ACTIONS(8509),
    [anon_sym_for] = ACTIONS(8507),
    [anon_sym_LBRACK] = ACTIONS(8509),
    [sym_false] = ACTIONS(8507),
    [anon_sym_SEMI] = ACTIONS(8509),
    [anon_sym_case] = ACTIONS(8507),
    [anon_sym_module] = ACTIONS(8507),
    [anon_sym_number] = ACTIONS(8507),
    [anon_sym_class] = ACTIONS(8507),
    [anon_sym_declare] = ACTIONS(8507),
    [anon_sym_typeof] = ACTIONS(8507),
    [anon_sym_LBRACE] = ACTIONS(8509),
    [anon_sym_switch] = ACTIONS(8507),
    [anon_sym_LPAREN] = ACTIONS(8509),
    [sym_null] = ACTIONS(8507),
    [anon_sym_any] = ACTIONS(8507),
    [anon_sym_boolean] = ACTIONS(8507),
    [anon_sym_async] = ACTIONS(8507),
    [anon_sym_public] = ACTIONS(8507),
    [anon_sym_var] = ACTIONS(8507),
    [anon_sym_while] = ACTIONS(8507),
    [anon_sym_SQUOTE] = ACTIONS(8509),
    [anon_sym_try] = ACTIONS(8507),
    [anon_sym_LT] = ACTIONS(8509),
    [sym_number] = ACTIONS(8509),
    [anon_sym_SLASH] = ACTIONS(8507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8507),
    [anon_sym_function] = ACTIONS(8507),
    [sym_undefined] = ACTIONS(8507),
    [anon_sym_new] = ACTIONS(8507),
    [ts_builtin_sym_end] = ACTIONS(8509),
    [anon_sym_let] = ACTIONS(8507),
    [anon_sym_PLUS] = ACTIONS(8507),
    [anon_sym_export] = ACTIONS(8507),
    [anon_sym_do] = ACTIONS(8507),
    [anon_sym_TILDE] = ACTIONS(8509),
    [anon_sym_with] = ACTIONS(8507),
  },
  [3728] = {
    [sym_identifier] = ACTIONS(8511),
    [anon_sym_BQUOTE] = ACTIONS(8513),
    [anon_sym_debugger] = ACTIONS(8511),
    [anon_sym_symbol] = ACTIONS(8511),
    [anon_sym_AT] = ACTIONS(8513),
    [anon_sym_DASH] = ACTIONS(8511),
    [anon_sym_void] = ACTIONS(8511),
    [anon_sym_break] = ACTIONS(8511),
    [anon_sym_const] = ACTIONS(8511),
    [sym_super] = ACTIONS(8511),
    [anon_sym_return] = ACTIONS(8511),
    [anon_sym_private] = ACTIONS(8511),
    [anon_sym_get] = ACTIONS(8511),
    [anon_sym_RBRACE] = ACTIONS(8513),
    [anon_sym_interface] = ACTIONS(8511),
    [anon_sym_default] = ACTIONS(8511),
    [anon_sym_enum] = ACTIONS(8511),
    [anon_sym_delete] = ACTIONS(8511),
    [anon_sym_continue] = ACTIONS(8511),
    [anon_sym_DASH_DASH] = ACTIONS(8513),
    [anon_sym_if] = ACTIONS(8511),
    [anon_sym_this] = ACTIONS(8511),
    [anon_sym_yield] = ACTIONS(8511),
    [sym_true] = ACTIONS(8511),
    [anon_sym_throw] = ACTIONS(8511),
    [anon_sym_protected] = ACTIONS(8511),
    [anon_sym_abstract] = ACTIONS(8511),
    [anon_sym_set] = ACTIONS(8511),
    [anon_sym_type] = ACTIONS(8511),
    [anon_sym_import] = ACTIONS(8511),
    [anon_sym_namespace] = ACTIONS(8511),
    [anon_sym_PLUS_PLUS] = ACTIONS(8513),
    [anon_sym_await] = ACTIONS(8511),
    [anon_sym_DQUOTE] = ACTIONS(8513),
    [anon_sym_else] = ACTIONS(8511),
    [anon_sym_BANG] = ACTIONS(8513),
    [anon_sym_for] = ACTIONS(8511),
    [anon_sym_LBRACK] = ACTIONS(8513),
    [sym_false] = ACTIONS(8511),
    [anon_sym_SEMI] = ACTIONS(8513),
    [anon_sym_case] = ACTIONS(8511),
    [anon_sym_module] = ACTIONS(8511),
    [anon_sym_number] = ACTIONS(8511),
    [anon_sym_class] = ACTIONS(8511),
    [anon_sym_declare] = ACTIONS(8511),
    [anon_sym_typeof] = ACTIONS(8511),
    [anon_sym_LBRACE] = ACTIONS(8513),
    [anon_sym_switch] = ACTIONS(8511),
    [anon_sym_LPAREN] = ACTIONS(8513),
    [sym_null] = ACTIONS(8511),
    [anon_sym_any] = ACTIONS(8511),
    [anon_sym_boolean] = ACTIONS(8511),
    [anon_sym_async] = ACTIONS(8511),
    [anon_sym_public] = ACTIONS(8511),
    [anon_sym_var] = ACTIONS(8511),
    [anon_sym_while] = ACTIONS(8511),
    [anon_sym_SQUOTE] = ACTIONS(8513),
    [anon_sym_try] = ACTIONS(8511),
    [anon_sym_LT] = ACTIONS(8513),
    [sym_number] = ACTIONS(8513),
    [anon_sym_SLASH] = ACTIONS(8511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8511),
    [anon_sym_function] = ACTIONS(8511),
    [sym_undefined] = ACTIONS(8511),
    [anon_sym_new] = ACTIONS(8511),
    [ts_builtin_sym_end] = ACTIONS(8513),
    [anon_sym_let] = ACTIONS(8511),
    [anon_sym_PLUS] = ACTIONS(8511),
    [anon_sym_export] = ACTIONS(8511),
    [anon_sym_do] = ACTIONS(8511),
    [anon_sym_TILDE] = ACTIONS(8513),
    [anon_sym_with] = ACTIONS(8511),
  },
  [3729] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6809),
    [anon_sym_LBRACK] = ACTIONS(6809),
    [anon_sym_BANG] = ACTIONS(6807),
    [anon_sym_BQUOTE] = ACTIONS(6809),
    [anon_sym_PIPE] = ACTIONS(6807),
    [anon_sym_COMMA] = ACTIONS(6809),
    [anon_sym_LT_LT] = ACTIONS(6809),
    [anon_sym_STAR] = ACTIONS(6807),
    [anon_sym_GT_GT_GT] = ACTIONS(6809),
    [anon_sym_AMP_AMP] = ACTIONS(6809),
    [anon_sym_DASH] = ACTIONS(6807),
    [anon_sym_LBRACE] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6807),
    [anon_sym_LT_EQ] = ACTIONS(6809),
    [anon_sym_LPAREN] = ACTIONS(6809),
    [anon_sym_RBRACK] = ACTIONS(6809),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_GT] = ACTIONS(6807),
    [anon_sym_AMP] = ACTIONS(6807),
    [anon_sym_PERCENT] = ACTIONS(6809),
    [anon_sym_QMARK] = ACTIONS(6809),
    [anon_sym_RBRACE] = ACTIONS(6809),
    [anon_sym_as] = ACTIONS(6809),
    [anon_sym_PIPE_PIPE] = ACTIONS(6809),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6809),
    [anon_sym_DASH_DASH] = ACTIONS(6809),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_instanceof] = ACTIONS(6809),
    [anon_sym_LT] = ACTIONS(6807),
    [anon_sym_RPAREN] = ACTIONS(6809),
    [anon_sym_SLASH] = ACTIONS(6807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6809),
    [anon_sym_DOT] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6809),
    [anon_sym_STAR_STAR] = ACTIONS(6809),
    [anon_sym_PLUS] = ACTIONS(6807),
    [anon_sym_implements] = ACTIONS(6809),
    [anon_sym_GT_GT] = ACTIONS(6807),
    [anon_sym_PLUS_PLUS] = ACTIONS(6809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6809),
    [anon_sym_in] = ACTIONS(6807),
  },
  [3730] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_BQUOTE] = ACTIONS(3470),
    [anon_sym_PIPE] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3468),
    [anon_sym_GT_GT_GT] = ACTIONS(3470),
    [anon_sym_AMP_AMP] = ACTIONS(3470),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_LT_EQ] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3470),
    [anon_sym_RBRACK] = ACTIONS(3470),
    [anon_sym_GT_EQ] = ACTIONS(3470),
    [anon_sym_GT] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3470),
    [anon_sym_QMARK] = ACTIONS(3470),
    [anon_sym_RBRACE] = ACTIONS(3470),
    [anon_sym_as] = ACTIONS(3470),
    [anon_sym_PIPE_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_DASH_DASH] = ACTIONS(3470),
    [anon_sym_EQ_EQ] = ACTIONS(3468),
    [anon_sym_instanceof] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3468),
    [anon_sym_RPAREN] = ACTIONS(3470),
    [anon_sym_SLASH] = ACTIONS(3468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3470),
    [anon_sym_DOT] = ACTIONS(3470),
    [anon_sym_CARET] = ACTIONS(3470),
    [anon_sym_STAR_STAR] = ACTIONS(3470),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_implements] = ACTIONS(3470),
    [anon_sym_GT_GT] = ACTIONS(3468),
    [anon_sym_PLUS_PLUS] = ACTIONS(3470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3470),
    [anon_sym_in] = ACTIONS(3468),
  },
  [3731] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1675),
    [sym_constructor_type] = STATE(1675),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1675),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1675),
    [sym_intersection_type] = STATE(1675),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(8515),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_boolean] = ACTIONS(472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_this] = ACTIONS(474),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [3732] = {
    [aux_sym_implements_clause_repeat1] = STATE(1677),
    [anon_sym_COMMA] = ACTIONS(8517),
    [anon_sym_GT] = ACTIONS(8515),
    [sym_comment] = ACTIONS(3),
  },
  [3733] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(8519),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8519),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [3734] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6821),
    [anon_sym_LBRACK] = ACTIONS(6821),
    [anon_sym_BANG] = ACTIONS(6819),
    [anon_sym_BQUOTE] = ACTIONS(6821),
    [anon_sym_PIPE] = ACTIONS(6819),
    [anon_sym_COMMA] = ACTIONS(6821),
    [anon_sym_LT_LT] = ACTIONS(6821),
    [anon_sym_STAR] = ACTIONS(6819),
    [anon_sym_GT_GT_GT] = ACTIONS(6821),
    [anon_sym_AMP_AMP] = ACTIONS(6821),
    [anon_sym_DASH] = ACTIONS(6819),
    [anon_sym_LBRACE] = ACTIONS(6819),
    [anon_sym_BANG_EQ] = ACTIONS(6819),
    [anon_sym_LT_EQ] = ACTIONS(6821),
    [anon_sym_LPAREN] = ACTIONS(6821),
    [anon_sym_RBRACK] = ACTIONS(6821),
    [anon_sym_GT_EQ] = ACTIONS(6821),
    [anon_sym_GT] = ACTIONS(6819),
    [anon_sym_AMP] = ACTIONS(6819),
    [anon_sym_PERCENT] = ACTIONS(6821),
    [anon_sym_QMARK] = ACTIONS(6821),
    [anon_sym_RBRACE] = ACTIONS(6821),
    [anon_sym_as] = ACTIONS(6821),
    [anon_sym_PIPE_PIPE] = ACTIONS(6821),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6821),
    [anon_sym_DASH_DASH] = ACTIONS(6821),
    [anon_sym_EQ_EQ] = ACTIONS(6819),
    [anon_sym_instanceof] = ACTIONS(6821),
    [anon_sym_LT] = ACTIONS(6819),
    [anon_sym_RPAREN] = ACTIONS(6821),
    [anon_sym_SLASH] = ACTIONS(6819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6821),
    [anon_sym_DOT] = ACTIONS(6821),
    [anon_sym_CARET] = ACTIONS(6821),
    [anon_sym_STAR_STAR] = ACTIONS(6821),
    [anon_sym_PLUS] = ACTIONS(6819),
    [anon_sym_implements] = ACTIONS(6821),
    [anon_sym_GT_GT] = ACTIONS(6819),
    [anon_sym_PLUS_PLUS] = ACTIONS(6821),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6821),
    [anon_sym_in] = ACTIONS(6819),
  },
  [3735] = {
    [aux_sym_object_type_repeat1] = STATE(2544),
    [sym__automatic_semicolon] = ACTIONS(8521),
    [anon_sym_RBRACE] = ACTIONS(8519),
    [anon_sym_SEMI] = ACTIONS(8521),
    [anon_sym_COMMA] = ACTIONS(8521),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8519),
    [sym_comment] = ACTIONS(3),
  },
  [3736] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6904),
    [anon_sym_LBRACK] = ACTIONS(6904),
    [anon_sym_BANG] = ACTIONS(6902),
    [anon_sym_BQUOTE] = ACTIONS(6904),
    [anon_sym_PIPE] = ACTIONS(6902),
    [anon_sym_COMMA] = ACTIONS(6904),
    [anon_sym_LT_LT] = ACTIONS(6904),
    [anon_sym_STAR] = ACTIONS(6902),
    [anon_sym_GT_GT_GT] = ACTIONS(6904),
    [anon_sym_AMP_AMP] = ACTIONS(6904),
    [anon_sym_DASH] = ACTIONS(6902),
    [anon_sym_LBRACE] = ACTIONS(6902),
    [anon_sym_BANG_EQ] = ACTIONS(6902),
    [anon_sym_LT_EQ] = ACTIONS(6904),
    [anon_sym_LPAREN] = ACTIONS(6904),
    [anon_sym_RBRACK] = ACTIONS(6904),
    [anon_sym_GT_EQ] = ACTIONS(6904),
    [anon_sym_GT] = ACTIONS(6902),
    [anon_sym_AMP] = ACTIONS(6902),
    [anon_sym_PERCENT] = ACTIONS(6904),
    [anon_sym_QMARK] = ACTIONS(6904),
    [anon_sym_RBRACE] = ACTIONS(6904),
    [anon_sym_as] = ACTIONS(6904),
    [anon_sym_PIPE_PIPE] = ACTIONS(6904),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6904),
    [anon_sym_DASH_DASH] = ACTIONS(6904),
    [anon_sym_EQ_EQ] = ACTIONS(6902),
    [anon_sym_instanceof] = ACTIONS(6904),
    [anon_sym_LT] = ACTIONS(6902),
    [anon_sym_RPAREN] = ACTIONS(6904),
    [anon_sym_SLASH] = ACTIONS(6902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6904),
    [anon_sym_DOT] = ACTIONS(6904),
    [anon_sym_CARET] = ACTIONS(6904),
    [anon_sym_STAR_STAR] = ACTIONS(6904),
    [anon_sym_PLUS] = ACTIONS(6902),
    [anon_sym_implements] = ACTIONS(6904),
    [anon_sym_GT_GT] = ACTIONS(6902),
    [anon_sym_PLUS_PLUS] = ACTIONS(6904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6904),
    [anon_sym_in] = ACTIONS(6902),
  },
  [3737] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(7604),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_RBRACK] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(7606),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [3738] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4269),
    [sym_constructor_type] = STATE(4269),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1264),
    [sym_function_type] = STATE(4269),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4269),
    [sym_intersection_type] = STATE(4269),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1263),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1268),
    [sym_identifier] = ACTIONS(2579),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3739] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(7604),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_RBRACK] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(7606),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [3740] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6990),
    [anon_sym_LBRACK] = ACTIONS(6990),
    [anon_sym_BANG] = ACTIONS(6988),
    [anon_sym_BQUOTE] = ACTIONS(6990),
    [anon_sym_PIPE] = ACTIONS(6988),
    [anon_sym_COMMA] = ACTIONS(6990),
    [anon_sym_LT_LT] = ACTIONS(6990),
    [anon_sym_STAR] = ACTIONS(6988),
    [anon_sym_GT_GT_GT] = ACTIONS(6990),
    [anon_sym_AMP_AMP] = ACTIONS(6990),
    [anon_sym_DASH] = ACTIONS(6988),
    [anon_sym_LBRACE] = ACTIONS(6988),
    [anon_sym_BANG_EQ] = ACTIONS(6988),
    [anon_sym_LT_EQ] = ACTIONS(6990),
    [anon_sym_LPAREN] = ACTIONS(6990),
    [anon_sym_RBRACK] = ACTIONS(6990),
    [anon_sym_GT_EQ] = ACTIONS(6990),
    [anon_sym_GT] = ACTIONS(6988),
    [anon_sym_AMP] = ACTIONS(6988),
    [anon_sym_PERCENT] = ACTIONS(6990),
    [anon_sym_QMARK] = ACTIONS(6990),
    [anon_sym_RBRACE] = ACTIONS(6990),
    [anon_sym_as] = ACTIONS(6990),
    [anon_sym_PIPE_PIPE] = ACTIONS(6990),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6990),
    [anon_sym_DASH_DASH] = ACTIONS(6990),
    [anon_sym_EQ_EQ] = ACTIONS(6988),
    [anon_sym_instanceof] = ACTIONS(6990),
    [anon_sym_LT] = ACTIONS(6988),
    [anon_sym_RPAREN] = ACTIONS(6990),
    [anon_sym_SLASH] = ACTIONS(6988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6990),
    [anon_sym_DOT] = ACTIONS(6990),
    [anon_sym_CARET] = ACTIONS(6990),
    [anon_sym_STAR_STAR] = ACTIONS(6990),
    [anon_sym_PLUS] = ACTIONS(6988),
    [anon_sym_implements] = ACTIONS(6990),
    [anon_sym_GT_GT] = ACTIONS(6988),
    [anon_sym_PLUS_PLUS] = ACTIONS(6990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6990),
    [anon_sym_in] = ACTIONS(6988),
  },
  [3741] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6255),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(6255),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(8310),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(8310),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_implements] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2063),
  },
  [3742] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8321),
    [anon_sym_LBRACK] = ACTIONS(8321),
    [anon_sym_BANG] = ACTIONS(8323),
    [anon_sym_BQUOTE] = ACTIONS(8321),
    [anon_sym_else] = ACTIONS(8321),
    [anon_sym_PIPE] = ACTIONS(8323),
    [anon_sym_COMMA] = ACTIONS(8321),
    [anon_sym_LT_LT] = ACTIONS(8321),
    [anon_sym_STAR] = ACTIONS(8323),
    [anon_sym_GT_GT_GT] = ACTIONS(8321),
    [anon_sym_AMP_AMP] = ACTIONS(8321),
    [anon_sym_DASH] = ACTIONS(8323),
    [anon_sym_LBRACE] = ACTIONS(8323),
    [anon_sym_BANG_EQ] = ACTIONS(8323),
    [anon_sym_LT_EQ] = ACTIONS(8321),
    [anon_sym_LPAREN] = ACTIONS(8321),
    [anon_sym_RBRACK] = ACTIONS(8321),
    [anon_sym_GT_EQ] = ACTIONS(8321),
    [anon_sym_GT] = ACTIONS(8323),
    [anon_sym_AMP] = ACTIONS(8323),
    [anon_sym_PERCENT] = ACTIONS(8321),
    [anon_sym_QMARK] = ACTIONS(8321),
    [anon_sym_RBRACE] = ACTIONS(8321),
    [anon_sym_as] = ACTIONS(8321),
    [anon_sym_PIPE_PIPE] = ACTIONS(8321),
    [anon_sym_while] = ACTIONS(8321),
    [anon_sym_DASH_DASH] = ACTIONS(8321),
    [anon_sym_EQ_EQ] = ACTIONS(8323),
    [anon_sym_instanceof] = ACTIONS(8321),
    [anon_sym_LT] = ACTIONS(8323),
    [anon_sym_RPAREN] = ACTIONS(8321),
    [anon_sym_SLASH] = ACTIONS(8323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(8321),
    [anon_sym_COLON] = ACTIONS(8321),
    [anon_sym_DOT] = ACTIONS(8321),
    [anon_sym_CARET] = ACTIONS(8321),
    [anon_sym_STAR_STAR] = ACTIONS(8321),
    [anon_sym_PLUS] = ACTIONS(8323),
    [anon_sym_implements] = ACTIONS(8321),
    [anon_sym_GT_GT] = ACTIONS(8323),
    [anon_sym_PLUS_PLUS] = ACTIONS(8321),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8321),
    [anon_sym_in] = ACTIONS(8323),
  },
  [3743] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_LT_LT] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(7180),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_GT_GT_GT] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG_EQ] = ACTIONS(2663),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2711),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2663),
    [anon_sym_instanceof] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_SLASH] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_implements] = ACTIONS(7180),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2663),
  },
  [3744] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8523),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_LBRACE] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(8525),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_implements] = ACTIONS(5196),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [3745] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8523),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(8525),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_implements] = ACTIONS(5204),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [3746] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4270),
    [sym_constructor_type] = STATE(4270),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(4270),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4270),
    [sym_intersection_type] = STATE(4270),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3747] = {
    [anon_sym_EQ_GT] = ACTIONS(8527),
    [sym_comment] = ACTIONS(3),
  },
  [3748] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4272),
    [sym_constructor_type] = STATE(4272),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(4272),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4272),
    [sym_intersection_type] = STATE(4272),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3749] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8523),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_LBRACE] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(8525),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_implements] = ACTIONS(5406),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [3750] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8523),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(8525),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_implements] = ACTIONS(5425),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [3751] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(598),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2693),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2695),
    [anon_sym_symbol] = ACTIONS(2695),
    [anon_sym_number] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2695),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2697),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2695),
    [anon_sym_private] = ACTIONS(2695),
    [anon_sym_boolean] = ACTIONS(2695),
    [anon_sym_async] = ACTIONS(2699),
    [anon_sym_public] = ACTIONS(2695),
    [anon_sym_get] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2695),
    [anon_sym_string] = ACTIONS(2695),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2695),
    [anon_sym_type] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(2695),
    [anon_sym_export] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3752] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4273),
    [sym_constructor_type] = STATE(4273),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(4273),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4273),
    [sym_intersection_type] = STATE(4273),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3753] = {
    [anon_sym_EQ_GT] = ACTIONS(8529),
    [sym_comment] = ACTIONS(3),
  },
  [3754] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4275),
    [sym_constructor_type] = STATE(4275),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(4275),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4275),
    [sym_intersection_type] = STATE(4275),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3755] = {
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(6292),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5425),
  },
  [3756] = {
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8086),
  },
  [3757] = {
    [sym_new_expression] = STATE(3074),
    [sym_constructor_type] = STATE(3316),
    [sym_augmented_assignment_expression] = STATE(3074),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3074),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3074),
    [sym_call_signature] = STATE(1340),
    [sym_yield_expression] = STATE(3074),
    [sym_as_expression] = STATE(3074),
    [sym_internal_module] = STATE(3074),
    [sym_arrow_function] = STATE(3074),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(1342),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1642),
    [sym_type_parameters] = STATE(4277),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(1344),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_generator_function] = STATE(3074),
    [sym_subscript_expression] = STATE(1342),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3074),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3074),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(4278),
    [sym_intersection_type] = STATE(3316),
    [sym__type] = STATE(3316),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3074),
    [sym_meta_property] = STATE(3074),
    [sym_function_type] = STATE(3316),
    [sym__expression] = STATE(3074),
    [sym_non_null_expression] = STATE(3074),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(3074),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3074),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(3074),
    [sym_call_expression] = STATE(3074),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3074),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3074),
    [sym_type_arguments] = STATE(1346),
    [sym_union_type] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3074),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3074),
    [sym_class] = STATE(3074),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(6311),
    [sym_false] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(6313),
    [anon_sym_number] = ACTIONS(6313),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(6315),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6317),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(6319),
    [anon_sym_PIPE] = ACTIONS(6803),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(6321),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6313),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(6313),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(3405),
    [sym_number] = ACTIONS(3411),
    [sym_true] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(6313),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6321),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(8531),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(6317),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [3758] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_AMP_EQ] = ACTIONS(4661),
    [anon_sym_PLUS_EQ] = ACTIONS(4661),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_DASH_EQ] = ACTIONS(4661),
    [anon_sym_EQ_GT] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4661),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(6915),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3759] = {
    [sym_formal_parameters] = STATE(4279),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3760] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(8533),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [3761] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(8536),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [3762] = {
    [sym_type_annotation] = STATE(4280),
    [anon_sym_COLON] = ACTIONS(6400),
    [sym_comment] = ACTIONS(3),
  },
  [3763] = {
    [sym_type_annotation] = STATE(4281),
    [anon_sym_COLON] = ACTIONS(6400),
    [sym_comment] = ACTIONS(3),
  },
  [3764] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(5130),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3765] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(5134),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3766] = {
    [sym_new_expression] = STATE(4282),
    [sym_augmented_assignment_expression] = STATE(4282),
    [sym_unary_expression] = STATE(4282),
    [sym_update_expression] = STATE(4282),
    [sym_regex] = STATE(4282),
    [sym_meta_property] = STATE(4282),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(4282),
    [sym_yield_expression] = STATE(4282),
    [sym_as_expression] = STATE(4282),
    [sym_non_null_expression] = STATE(4282),
    [sym_internal_module] = STATE(4282),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4282),
    [sym_await_expression] = STATE(4282),
    [sym_member_expression] = STATE(1342),
    [sym_string] = STATE(4282),
    [sym_this] = STATE(4282),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(1344),
    [sym_anonymous_class] = STATE(4282),
    [sym_generator_function] = STATE(4282),
    [sym_call_expression] = STATE(4282),
    [sym_subscript_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(4282),
    [sym_ternary_expression] = STATE(4282),
    [sym_binary_expression] = STATE(4282),
    [sym_template_string] = STATE(4282),
    [sym_type_arguments] = STATE(1346),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4282),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(4282),
    [sym_class] = STATE(4282),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2908),
    [sym_false] = ACTIONS(8539),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8539),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8541),
    [sym_true] = ACTIONS(8539),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8539),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [3767] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4283),
    [sym_constructor_type] = STATE(4283),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(4283),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4283),
    [sym_intersection_type] = STATE(4283),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3768] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4284),
    [sym_constructor_type] = STATE(4284),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(4284),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4284),
    [sym_intersection_type] = STATE(4284),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3769] = {
    [anon_sym_EQ_GT] = ACTIONS(8543),
    [sym_comment] = ACTIONS(3),
  },
  [3770] = {
    [sym_formal_parameters] = STATE(4286),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3771] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3772] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3773] = {
    [anon_sym_EQ_GT] = ACTIONS(8545),
    [sym_comment] = ACTIONS(3),
  },
  [3774] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4288),
    [sym_constructor_type] = STATE(4288),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(4288),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4288),
    [sym_intersection_type] = STATE(4288),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3775] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4289),
    [sym_constructor_type] = STATE(4289),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(4289),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4289),
    [sym_intersection_type] = STATE(4289),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3776] = {
    [sym_new_expression] = STATE(3074),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(3074),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3074),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3074),
    [sym_call_signature] = STATE(1340),
    [sym_yield_expression] = STATE(3074),
    [sym_as_expression] = STATE(3074),
    [sym_internal_module] = STATE(3074),
    [sym_arrow_function] = STATE(3074),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(1342),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1738),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(1344),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(3074),
    [sym_subscript_expression] = STATE(1342),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3074),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3074),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3074),
    [sym_meta_property] = STATE(3074),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(3074),
    [sym_non_null_expression] = STATE(3074),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(3074),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3074),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(3074),
    [sym_call_expression] = STATE(3074),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3074),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3074),
    [sym_type_arguments] = STATE(1346),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(3074),
    [sym_array] = STATE(1347),
    [sym_type_assertion] = STATE(3074),
    [sym_class] = STATE(3074),
    [anon_sym_BANG] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(6384),
    [sym_false] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(6386),
    [anon_sym_number] = ACTIONS(6386),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(6388),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6390),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(6392),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(6321),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6386),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(6386),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_this] = ACTIONS(3597),
    [sym_number] = ACTIONS(3599),
    [sym_true] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(6386),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6321),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(8547),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(6390),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
  },
  [3777] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_AMP_EQ] = ACTIONS(4661),
    [anon_sym_PLUS_EQ] = ACTIONS(4661),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_EQ] = ACTIONS(4663),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_DASH_EQ] = ACTIONS(4661),
    [anon_sym_EQ_GT] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4661),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(7037),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4715),
  },
  [3778] = {
    [sym_type_arguments] = STATE(1937),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_is] = ACTIONS(8549),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8551),
  },
  [3779] = {
    [sym_tuple_type] = STATE(1939),
    [sym_index_type_query] = STATE(1939),
    [sym_lookup_type] = STATE(1939),
    [sym_this_type] = STATE(1939),
    [sym_flow_maybe_type] = STATE(1939),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_type_predicate] = STATE(1939),
    [sym_type_query] = STATE(1939),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1939),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1939),
    [sym__primary_type] = STATE(1939),
    [sym_generic_type] = STATE(1939),
    [sym_mapped_type] = STATE(1939),
    [sym_literal_type] = STATE(1939),
    [sym_parenthesized_type] = STATE(1939),
    [sym_predefined_type] = STATE(1939),
    [sym_string] = STATE(1048),
    [sym_array_type] = STATE(1939),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [sym_true] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3780] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3784),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3786),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(7682),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(7684),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(7686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3781] = {
    [sym_formal_parameters] = STATE(4293),
    [sym_type_parameters] = STATE(4294),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3782] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3784),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3786),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(7682),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(7684),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(7686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3783] = {
    [sym__automatic_semicolon] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(8553),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(8555),
    [sym_comment] = ACTIONS(3),
  },
  [3784] = {
    [sym_formal_parameters] = STATE(4297),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3785] = {
    [sym_type_arguments] = STATE(1958),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8557),
  },
  [3786] = {
    [anon_sym_EQ_GT] = ACTIONS(8559),
    [sym_comment] = ACTIONS(3),
  },
  [3787] = {
    [sym__automatic_semicolon] = ACTIONS(7777),
    [anon_sym_LBRACK] = ACTIONS(7777),
    [sym_identifier] = ACTIONS(8561),
    [anon_sym_SEMI] = ACTIONS(7777),
    [anon_sym_module] = ACTIONS(8561),
    [anon_sym_symbol] = ACTIONS(8561),
    [anon_sym_number] = ACTIONS(8561),
    [anon_sym_AT] = ACTIONS(7777),
    [anon_sym_declare] = ACTIONS(8561),
    [anon_sym_STAR] = ACTIONS(7777),
    [anon_sym_void] = ACTIONS(8561),
    [anon_sym_any] = ACTIONS(8561),
    [anon_sym_private] = ACTIONS(8561),
    [anon_sym_boolean] = ACTIONS(8561),
    [anon_sym_async] = ACTIONS(8561),
    [anon_sym_public] = ACTIONS(8561),
    [anon_sym_get] = ACTIONS(8561),
    [anon_sym_RBRACE] = ACTIONS(7777),
    [anon_sym_static] = ACTIONS(8561),
    [anon_sym_SQUOTE] = ACTIONS(7777),
    [sym_number] = ACTIONS(7777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(8561),
    [anon_sym_string] = ACTIONS(8561),
    [anon_sym_abstract] = ACTIONS(8561),
    [anon_sym_set] = ACTIONS(8561),
    [anon_sym_type] = ACTIONS(8561),
    [anon_sym_import] = ACTIONS(8561),
    [anon_sym_export] = ACTIONS(8561),
    [anon_sym_namespace] = ACTIONS(8561),
    [sym_readonly] = ACTIONS(8561),
    [anon_sym_DQUOTE] = ACTIONS(7777),
  },
  [3788] = {
    [sym_statement_block] = STATE(4300),
    [sym__automatic_semicolon] = ACTIONS(8563),
    [anon_sym_SEMI] = ACTIONS(8563),
    [anon_sym_COMMA] = ACTIONS(8563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4779),
  },
  [3789] = {
    [sym_call_signature] = STATE(4301),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3790] = {
    [sym_call_signature] = STATE(4301),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(8565),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [3791] = {
    [sym__automatic_semicolon] = ACTIONS(8567),
    [anon_sym_SEMI] = ACTIONS(8567),
    [anon_sym_COMMA] = ACTIONS(8567),
    [sym_comment] = ACTIONS(3),
  },
  [3792] = {
    [sym__initializer] = STATE(4303),
    [sym__automatic_semicolon] = ACTIONS(8567),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(8567),
    [anon_sym_COMMA] = ACTIONS(8567),
    [sym_comment] = ACTIONS(3),
  },
  [3793] = {
    [sym__automatic_semicolon] = ACTIONS(8569),
    [anon_sym_SEMI] = ACTIONS(8569),
    [anon_sym_COMMA] = ACTIONS(8569),
    [sym_comment] = ACTIONS(3),
  },
  [3794] = {
    [sym__automatic_semicolon] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_module] = ACTIONS(2970),
    [anon_sym_symbol] = ACTIONS(2970),
    [anon_sym_number] = ACTIONS(2970),
    [anon_sym_AT] = ACTIONS(2972),
    [anon_sym_declare] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_void] = ACTIONS(2970),
    [anon_sym_any] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_boolean] = ACTIONS(2970),
    [anon_sym_async] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_get] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [sym_number] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_string] = ACTIONS(2970),
    [anon_sym_abstract] = ACTIONS(2970),
    [anon_sym_set] = ACTIONS(2970),
    [anon_sym_type] = ACTIONS(2970),
    [anon_sym_import] = ACTIONS(2970),
    [anon_sym_export] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [sym_readonly] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2972),
  },
  [3795] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4307),
    [sym_constructor_type] = STATE(4307),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(4307),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4307),
    [sym_intersection_type] = STATE(4307),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3796] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4310),
    [sym_constructor_type] = STATE(4310),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(4310),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4310),
    [sym_intersection_type] = STATE(4310),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3797] = {
    [anon_sym_EQ_GT] = ACTIONS(8577),
    [sym_comment] = ACTIONS(3),
  },
  [3798] = {
    [sym_formal_parameters] = STATE(4312),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3799] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3128),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3130),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3800] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3128),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3130),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3801] = {
    [anon_sym_EQ_GT] = ACTIONS(8579),
    [sym_comment] = ACTIONS(3),
  },
  [3802] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4314),
    [sym_constructor_type] = STATE(4314),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(4314),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4314),
    [sym_intersection_type] = STATE(4314),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3803] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4315),
    [sym_constructor_type] = STATE(4315),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(4315),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4315),
    [sym_intersection_type] = STATE(4315),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3128),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3130),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3804] = {
    [sym_string] = STATE(4316),
    [sym__property_name] = STATE(4316),
    [sym_computed_property_name] = STATE(4316),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3805] = {
    [sym_string] = STATE(4316),
    [sym__property_name] = STATE(4316),
    [sym_computed_property_name] = STATE(4316),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(8581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [3806] = {
    [sym_call_signature] = STATE(4301),
    [sym__initializer] = STATE(4303),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [sym_type_annotation] = STATE(4317),
    [sym__automatic_semicolon] = ACTIONS(8567),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(8567),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(8567),
    [sym_comment] = ACTIONS(3),
  },
  [3807] = {
    [sym__initializer] = STATE(4303),
    [sym_type_annotation] = STATE(4317),
    [sym__automatic_semicolon] = ACTIONS(8567),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(8567),
    [anon_sym_COMMA] = ACTIONS(8567),
    [sym_comment] = ACTIONS(3),
  },
  [3808] = {
    [sym_call_signature] = STATE(4318),
    [sym_formal_parameters] = STATE(2293),
    [sym_type_parameters] = STATE(2294),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3809] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4319),
    [sym_constructor_type] = STATE(4319),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(4319),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4319),
    [sym_intersection_type] = STATE(4319),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3810] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4320),
    [sym_constructor_type] = STATE(4320),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(4320),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4320),
    [sym_intersection_type] = STATE(4320),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3811] = {
    [anon_sym_EQ_GT] = ACTIONS(8583),
    [sym_comment] = ACTIONS(3),
  },
  [3812] = {
    [sym_formal_parameters] = STATE(4322),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3813] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3814] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3815] = {
    [anon_sym_EQ_GT] = ACTIONS(8585),
    [sym_comment] = ACTIONS(3),
  },
  [3816] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4324),
    [sym_constructor_type] = STATE(4324),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(4324),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4324),
    [sym_intersection_type] = STATE(4324),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3817] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4325),
    [sym_constructor_type] = STATE(4325),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(4325),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4325),
    [sym_intersection_type] = STATE(4325),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3818] = {
    [sym_identifier] = ACTIONS(8323),
    [anon_sym_BQUOTE] = ACTIONS(8321),
    [anon_sym_debugger] = ACTIONS(8323),
    [anon_sym_symbol] = ACTIONS(8323),
    [anon_sym_AT] = ACTIONS(8321),
    [anon_sym_DASH] = ACTIONS(8323),
    [anon_sym_void] = ACTIONS(8323),
    [anon_sym_break] = ACTIONS(8323),
    [anon_sym_const] = ACTIONS(8323),
    [sym_super] = ACTIONS(8323),
    [anon_sym_return] = ACTIONS(8323),
    [anon_sym_private] = ACTIONS(8323),
    [anon_sym_get] = ACTIONS(8323),
    [anon_sym_RBRACE] = ACTIONS(8321),
    [anon_sym_interface] = ACTIONS(8323),
    [anon_sym_default] = ACTIONS(8323),
    [anon_sym_enum] = ACTIONS(8323),
    [anon_sym_delete] = ACTIONS(8323),
    [anon_sym_continue] = ACTIONS(8323),
    [anon_sym_DASH_DASH] = ACTIONS(8321),
    [anon_sym_if] = ACTIONS(8323),
    [anon_sym_this] = ACTIONS(8323),
    [anon_sym_yield] = ACTIONS(8323),
    [sym_true] = ACTIONS(8323),
    [anon_sym_throw] = ACTIONS(8323),
    [anon_sym_protected] = ACTIONS(8323),
    [anon_sym_abstract] = ACTIONS(8323),
    [anon_sym_set] = ACTIONS(8323),
    [anon_sym_type] = ACTIONS(8323),
    [anon_sym_import] = ACTIONS(8323),
    [anon_sym_namespace] = ACTIONS(8323),
    [anon_sym_PLUS_PLUS] = ACTIONS(8321),
    [anon_sym_await] = ACTIONS(8323),
    [anon_sym_DQUOTE] = ACTIONS(8321),
    [anon_sym_else] = ACTIONS(8323),
    [anon_sym_BANG] = ACTIONS(8321),
    [anon_sym_for] = ACTIONS(8323),
    [anon_sym_LBRACK] = ACTIONS(8321),
    [sym_false] = ACTIONS(8323),
    [anon_sym_SEMI] = ACTIONS(8321),
    [anon_sym_case] = ACTIONS(8323),
    [anon_sym_module] = ACTIONS(8323),
    [anon_sym_number] = ACTIONS(8323),
    [anon_sym_class] = ACTIONS(8323),
    [anon_sym_declare] = ACTIONS(8323),
    [anon_sym_typeof] = ACTIONS(8323),
    [anon_sym_LBRACE] = ACTIONS(8321),
    [anon_sym_switch] = ACTIONS(8323),
    [anon_sym_LPAREN] = ACTIONS(8321),
    [sym_null] = ACTIONS(8323),
    [anon_sym_any] = ACTIONS(8323),
    [anon_sym_boolean] = ACTIONS(8323),
    [anon_sym_async] = ACTIONS(8323),
    [anon_sym_public] = ACTIONS(8323),
    [anon_sym_var] = ACTIONS(8323),
    [anon_sym_while] = ACTIONS(8323),
    [anon_sym_SQUOTE] = ACTIONS(8321),
    [anon_sym_try] = ACTIONS(8323),
    [anon_sym_LT] = ACTIONS(8321),
    [sym_number] = ACTIONS(8321),
    [anon_sym_SLASH] = ACTIONS(8323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8323),
    [anon_sym_function] = ACTIONS(8323),
    [sym_undefined] = ACTIONS(8323),
    [anon_sym_new] = ACTIONS(8323),
    [ts_builtin_sym_end] = ACTIONS(8321),
    [anon_sym_let] = ACTIONS(8323),
    [anon_sym_PLUS] = ACTIONS(8323),
    [anon_sym_export] = ACTIONS(8323),
    [anon_sym_do] = ACTIONS(8323),
    [anon_sym_TILDE] = ACTIONS(8321),
    [anon_sym_with] = ACTIONS(8323),
  },
  [3819] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(5130),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5130),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(5130),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [3820] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(5134),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5134),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [3821] = {
    [sym_new_expression] = STATE(4326),
    [sym_augmented_assignment_expression] = STATE(4326),
    [sym_unary_expression] = STATE(4326),
    [sym_update_expression] = STATE(4326),
    [sym_regex] = STATE(4326),
    [sym_meta_property] = STATE(4326),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(4326),
    [sym_yield_expression] = STATE(4326),
    [sym_as_expression] = STATE(4326),
    [sym_non_null_expression] = STATE(4326),
    [sym_internal_module] = STATE(4326),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4326),
    [sym_await_expression] = STATE(4326),
    [sym_member_expression] = STATE(1401),
    [sym_string] = STATE(4326),
    [sym_this] = STATE(4326),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1402),
    [sym_anonymous_class] = STATE(4326),
    [sym_generator_function] = STATE(4326),
    [sym_call_expression] = STATE(4326),
    [sym_subscript_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(4326),
    [sym_ternary_expression] = STATE(4326),
    [sym_binary_expression] = STATE(4326),
    [sym_template_string] = STATE(4326),
    [sym_type_arguments] = STATE(1403),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4326),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(4326),
    [sym_class] = STATE(4326),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [sym_false] = ACTIONS(8587),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8587),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(8589),
    [sym_true] = ACTIONS(8587),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8587),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [3822] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4327),
    [sym_constructor_type] = STATE(4327),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(4327),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4327),
    [sym_intersection_type] = STATE(4327),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3823] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4328),
    [sym_constructor_type] = STATE(4328),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(4328),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4328),
    [sym_intersection_type] = STATE(4328),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3824] = {
    [anon_sym_EQ_GT] = ACTIONS(8591),
    [sym_comment] = ACTIONS(3),
  },
  [3825] = {
    [sym_formal_parameters] = STATE(4330),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3826] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2778),
    [sym_constructor_type] = STATE(2778),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(2778),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2778),
    [sym_intersection_type] = STATE(2778),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3827] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2779),
    [sym_constructor_type] = STATE(2779),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(2779),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2779),
    [sym_intersection_type] = STATE(2779),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3828] = {
    [anon_sym_EQ_GT] = ACTIONS(8593),
    [sym_comment] = ACTIONS(3),
  },
  [3829] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4332),
    [sym_constructor_type] = STATE(4332),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(4332),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4332),
    [sym_intersection_type] = STATE(4332),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3830] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4333),
    [sym_constructor_type] = STATE(4333),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(4333),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4333),
    [sym_intersection_type] = STATE(4333),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [3831] = {
    [sym_new_expression] = STATE(3152),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(3152),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3152),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3152),
    [sym_call_signature] = STATE(1399),
    [sym_yield_expression] = STATE(3152),
    [sym_as_expression] = STATE(3152),
    [sym_internal_module] = STATE(3152),
    [sym_arrow_function] = STATE(3152),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(1401),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(991),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(1402),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(3152),
    [sym_subscript_expression] = STATE(1401),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3152),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3152),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3152),
    [sym_meta_property] = STATE(3152),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(3152),
    [sym_non_null_expression] = STATE(3152),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(3152),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3152),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_anonymous_class] = STATE(3152),
    [sym_call_expression] = STATE(3152),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3152),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3152),
    [sym_type_arguments] = STATE(1403),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(3152),
    [sym_array] = STATE(1404),
    [sym_type_assertion] = STATE(3152),
    [sym_class] = STATE(3152),
    [anon_sym_BANG] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(6515),
    [sym_false] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(6517),
    [anon_sym_number] = ACTIONS(6517),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(6519),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6521),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(6523),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [sym_null] = ACTIONS(6462),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(6517),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(6517),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_this] = ACTIONS(2018),
    [sym_number] = ACTIONS(2020),
    [sym_true] = ACTIONS(2002),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(6517),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6462),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(8595),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(6521),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
  },
  [3832] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_EQ_GT] = ACTIONS(4842),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4844),
  },
  [3833] = {
    [anon_sym_LBRACK] = ACTIONS(5873),
    [sym_identifier] = ACTIONS(5875),
    [anon_sym_module] = ACTIONS(5875),
    [anon_sym_symbol] = ACTIONS(5875),
    [anon_sym_number] = ACTIONS(5875),
    [anon_sym_AT] = ACTIONS(5873),
    [anon_sym_class] = ACTIONS(5875),
    [anon_sym_declare] = ACTIONS(5875),
    [anon_sym_STAR] = ACTIONS(5873),
    [anon_sym_void] = ACTIONS(5875),
    [anon_sym_any] = ACTIONS(5875),
    [anon_sym_private] = ACTIONS(5875),
    [anon_sym_boolean] = ACTIONS(5875),
    [anon_sym_async] = ACTIONS(5875),
    [anon_sym_public] = ACTIONS(5875),
    [anon_sym_get] = ACTIONS(5875),
    [anon_sym_static] = ACTIONS(5875),
    [anon_sym_RBRACE] = ACTIONS(5873),
    [anon_sym_SQUOTE] = ACTIONS(5873),
    [sym_number] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(5875),
    [anon_sym_string] = ACTIONS(5875),
    [anon_sym_abstract] = ACTIONS(5875),
    [anon_sym_set] = ACTIONS(5875),
    [anon_sym_type] = ACTIONS(5875),
    [anon_sym_import] = ACTIONS(5875),
    [anon_sym_export] = ACTIONS(5875),
    [sym_readonly] = ACTIONS(5875),
    [anon_sym_namespace] = ACTIONS(5875),
    [anon_sym_DQUOTE] = ACTIONS(5873),
  },
  [3834] = {
    [anon_sym_COMMA] = ACTIONS(8597),
    [anon_sym_RBRACE] = ACTIONS(8597),
    [sym_comment] = ACTIONS(3),
  },
  [3835] = {
    [sym_statement_block] = STATE(4335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [3836] = {
    [sym_call_signature] = STATE(4336),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3837] = {
    [sym_type_alias_declaration] = STATE(2047),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2047),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2047),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2047),
    [sym_return_statement] = STATE(2047),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2047),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2047),
    [sym_switch_statement] = STATE(2047),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2047),
    [sym_throw_statement] = STATE(2047),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2047),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2047),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(2047),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2047),
    [sym_abstract_class] = STATE(2047),
    [sym_interface_declaration] = STATE(2047),
    [sym_statement_block] = STATE(2047),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2047),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2047),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2047),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2047),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2047),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2047),
    [sym_empty_statement] = STATE(2047),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(2047),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2047),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2047),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2047),
    [sym_break_statement] = STATE(2047),
    [sym_labeled_statement] = STATE(2047),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2047),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [3838] = {
    [sym_array] = STATE(4338),
    [sym_object] = STATE(4339),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(8599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3839] = {
    [anon_sym_of] = ACTIONS(8601),
    [sym_comment] = ACTIONS(3),
  },
  [3840] = {
    [anon_sym_of] = ACTIONS(8603),
    [sym_comment] = ACTIONS(3),
  },
  [3841] = {
    [anon_sym_of] = ACTIONS(8605),
    [sym_comment] = ACTIONS(3),
  },
  [3842] = {
    [sym_new_expression] = STATE(4343),
    [sym_augmented_assignment_expression] = STATE(4343),
    [sym_unary_expression] = STATE(4343),
    [sym_update_expression] = STATE(4343),
    [sym_regex] = STATE(4343),
    [sym_meta_property] = STATE(4343),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(4343),
    [sym_yield_expression] = STATE(4343),
    [sym_as_expression] = STATE(4343),
    [sym_non_null_expression] = STATE(4343),
    [sym_internal_module] = STATE(4343),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4343),
    [sym_await_expression] = STATE(4343),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(4344),
    [sym_string] = STATE(4343),
    [sym_this] = STATE(4343),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4343),
    [sym_generator_function] = STATE(4343),
    [sym_call_expression] = STATE(4343),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4343),
    [sym_ternary_expression] = STATE(4343),
    [sym_binary_expression] = STATE(4343),
    [sym_template_string] = STATE(4343),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4343),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4343),
    [sym_class] = STATE(4343),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(8607),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8607),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(8609),
    [sym_true] = ACTIONS(8607),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8607),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [3843] = {
    [sym_new_expression] = STATE(4345),
    [sym_augmented_assignment_expression] = STATE(4345),
    [sym_unary_expression] = STATE(4345),
    [sym_update_expression] = STATE(4345),
    [sym_regex] = STATE(4345),
    [sym_meta_property] = STATE(4345),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4345),
    [sym_yield_expression] = STATE(4345),
    [sym_as_expression] = STATE(4345),
    [sym_non_null_expression] = STATE(4345),
    [sym_internal_module] = STATE(4345),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4345),
    [sym_await_expression] = STATE(4345),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4345),
    [sym_this] = STATE(4345),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4345),
    [sym_generator_function] = STATE(4345),
    [sym_call_expression] = STATE(4345),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4345),
    [sym_ternary_expression] = STATE(4345),
    [sym_binary_expression] = STATE(4345),
    [sym_template_string] = STATE(4345),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4345),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4345),
    [sym_class] = STATE(4345),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8611),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8611),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8613),
    [sym_true] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8611),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3844] = {
    [sym__initializer] = STATE(405),
    [sym_type_annotation] = STATE(406),
    [sym__automatic_semicolon] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_of] = ACTIONS(8601),
    [anon_sym_COMMA] = ACTIONS(739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8615),
  },
  [3845] = {
    [sym__initializer] = STATE(425),
    [sym_type_annotation] = STATE(426),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(8603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8617),
  },
  [3846] = {
    [sym__initializer] = STATE(427),
    [sym_type_annotation] = STATE(428),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(8605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8619),
  },
  [3847] = {
    [sym_new_expression] = STATE(4350),
    [sym_augmented_assignment_expression] = STATE(4350),
    [sym_unary_expression] = STATE(4350),
    [sym_update_expression] = STATE(4350),
    [sym_regex] = STATE(4350),
    [sym_meta_property] = STATE(4350),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4350),
    [sym_yield_expression] = STATE(4350),
    [sym_as_expression] = STATE(4350),
    [sym_non_null_expression] = STATE(4350),
    [sym_internal_module] = STATE(4350),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4350),
    [sym_await_expression] = STATE(4350),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4351),
    [sym_string] = STATE(4350),
    [sym_this] = STATE(4350),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4350),
    [sym_generator_function] = STATE(4350),
    [sym_call_expression] = STATE(4350),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4350),
    [sym_ternary_expression] = STATE(4350),
    [sym_binary_expression] = STATE(4350),
    [sym_template_string] = STATE(4350),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4350),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4350),
    [sym_class] = STATE(4350),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(8621),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8621),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(8623),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8625),
    [sym_true] = ACTIONS(8621),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8621),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [3848] = {
    [sym_new_expression] = STATE(4352),
    [sym_augmented_assignment_expression] = STATE(4352),
    [sym_unary_expression] = STATE(4352),
    [sym_update_expression] = STATE(4352),
    [sym_regex] = STATE(4352),
    [sym_meta_property] = STATE(4352),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4352),
    [sym_yield_expression] = STATE(4352),
    [sym_as_expression] = STATE(4352),
    [sym_non_null_expression] = STATE(4352),
    [sym_internal_module] = STATE(4352),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4352),
    [sym_await_expression] = STATE(4352),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4352),
    [sym_this] = STATE(4352),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4352),
    [sym_generator_function] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4352),
    [sym_ternary_expression] = STATE(4352),
    [sym_binary_expression] = STATE(4352),
    [sym_template_string] = STATE(4352),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4352),
    [sym_class] = STATE(4352),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8627),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8627),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8629),
    [sym_true] = ACTIONS(8627),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8627),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3849] = {
    [sym_new_expression] = STATE(4353),
    [sym_augmented_assignment_expression] = STATE(4353),
    [sym_unary_expression] = STATE(4353),
    [sym_update_expression] = STATE(4353),
    [sym_regex] = STATE(4353),
    [sym_meta_property] = STATE(4353),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(4353),
    [sym_yield_expression] = STATE(4353),
    [sym_as_expression] = STATE(4353),
    [sym_non_null_expression] = STATE(4353),
    [sym_internal_module] = STATE(4353),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4353),
    [sym_await_expression] = STATE(4353),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(4354),
    [sym_string] = STATE(4353),
    [sym_this] = STATE(4353),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4353),
    [sym_generator_function] = STATE(4353),
    [sym_call_expression] = STATE(4353),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4353),
    [sym_ternary_expression] = STATE(4353),
    [sym_binary_expression] = STATE(4353),
    [sym_template_string] = STATE(4353),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4353),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4353),
    [sym_class] = STATE(4353),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(8631),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8631),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(8633),
    [sym_true] = ACTIONS(8631),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8631),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [3850] = {
    [sym_new_expression] = STATE(4355),
    [sym_augmented_assignment_expression] = STATE(4355),
    [sym_unary_expression] = STATE(4355),
    [sym_update_expression] = STATE(4355),
    [sym_regex] = STATE(4355),
    [sym_meta_property] = STATE(4355),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4355),
    [sym_yield_expression] = STATE(4355),
    [sym_as_expression] = STATE(4355),
    [sym_non_null_expression] = STATE(4355),
    [sym_internal_module] = STATE(4355),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4355),
    [sym_await_expression] = STATE(4355),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4355),
    [sym_this] = STATE(4355),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4355),
    [sym_generator_function] = STATE(4355),
    [sym_call_expression] = STATE(4355),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4355),
    [sym_ternary_expression] = STATE(4355),
    [sym_binary_expression] = STATE(4355),
    [sym_template_string] = STATE(4355),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4355),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4355),
    [sym_class] = STATE(4355),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8635),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8635),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8637),
    [sym_true] = ACTIONS(8635),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8635),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3851] = {
    [sym_new_expression] = STATE(4356),
    [sym_augmented_assignment_expression] = STATE(4356),
    [sym_unary_expression] = STATE(4356),
    [sym_update_expression] = STATE(4356),
    [sym_regex] = STATE(4356),
    [sym_meta_property] = STATE(4356),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(4356),
    [sym_yield_expression] = STATE(4356),
    [sym_as_expression] = STATE(4356),
    [sym_non_null_expression] = STATE(4356),
    [sym_internal_module] = STATE(4356),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4356),
    [sym_await_expression] = STATE(4356),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(4357),
    [sym_string] = STATE(4356),
    [sym_this] = STATE(4356),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4356),
    [sym_generator_function] = STATE(4356),
    [sym_call_expression] = STATE(4356),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4356),
    [sym_ternary_expression] = STATE(4356),
    [sym_binary_expression] = STATE(4356),
    [sym_template_string] = STATE(4356),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4356),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4356),
    [sym_class] = STATE(4356),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(8639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8639),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(8641),
    [sym_true] = ACTIONS(8639),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8639),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [3852] = {
    [anon_sym_COLON] = ACTIONS(8643),
    [sym_comment] = ACTIONS(3),
  },
  [3853] = {
    [sym_new_expression] = STATE(4359),
    [sym_augmented_assignment_expression] = STATE(4359),
    [sym_unary_expression] = STATE(4359),
    [sym_update_expression] = STATE(4359),
    [sym_regex] = STATE(4359),
    [sym_meta_property] = STATE(4359),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4359),
    [sym_yield_expression] = STATE(4359),
    [sym_as_expression] = STATE(4359),
    [sym_non_null_expression] = STATE(4359),
    [sym_internal_module] = STATE(4359),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4359),
    [sym_await_expression] = STATE(4359),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4359),
    [sym_this] = STATE(4359),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4359),
    [sym_generator_function] = STATE(4359),
    [sym_call_expression] = STATE(4359),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4359),
    [sym_ternary_expression] = STATE(4359),
    [sym_binary_expression] = STATE(4359),
    [sym_template_string] = STATE(4359),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4359),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4359),
    [sym_class] = STATE(4359),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8645),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8645),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8647),
    [sym_true] = ACTIONS(8645),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8645),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3854] = {
    [sym_new_expression] = STATE(4360),
    [sym_augmented_assignment_expression] = STATE(4360),
    [sym_unary_expression] = STATE(4360),
    [sym_update_expression] = STATE(4360),
    [sym_regex] = STATE(4360),
    [sym_meta_property] = STATE(4360),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4360),
    [sym_yield_expression] = STATE(4360),
    [sym_as_expression] = STATE(4360),
    [sym_non_null_expression] = STATE(4360),
    [sym_internal_module] = STATE(4360),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4360),
    [sym_await_expression] = STATE(4360),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4360),
    [sym_this] = STATE(4360),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4360),
    [sym_generator_function] = STATE(4360),
    [sym_call_expression] = STATE(4360),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4360),
    [sym_ternary_expression] = STATE(4360),
    [sym_binary_expression] = STATE(4360),
    [sym_template_string] = STATE(4360),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4360),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4360),
    [sym_class] = STATE(4360),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8649),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8649),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8651),
    [sym_true] = ACTIONS(8649),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8649),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3855] = {
    [sym_new_expression] = STATE(4361),
    [sym_augmented_assignment_expression] = STATE(4361),
    [sym_unary_expression] = STATE(4361),
    [sym_update_expression] = STATE(4361),
    [sym_regex] = STATE(4361),
    [sym_meta_property] = STATE(4361),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4361),
    [sym_yield_expression] = STATE(4361),
    [sym_as_expression] = STATE(4361),
    [sym_non_null_expression] = STATE(4361),
    [sym_internal_module] = STATE(4361),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4361),
    [sym_await_expression] = STATE(4361),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4361),
    [sym_this] = STATE(4361),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4361),
    [sym_generator_function] = STATE(4361),
    [sym_call_expression] = STATE(4361),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4361),
    [sym_ternary_expression] = STATE(4361),
    [sym_binary_expression] = STATE(4361),
    [sym_template_string] = STATE(4361),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4361),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4361),
    [sym_class] = STATE(4361),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8653),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8653),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8655),
    [sym_true] = ACTIONS(8653),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8653),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [3856] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8657),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3857] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8659),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3858] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3859] = {
    [sym_type_alias_declaration] = STATE(3690),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3690),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3690),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3690),
    [sym_return_statement] = STATE(3690),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3690),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3690),
    [sym_switch_statement] = STATE(3690),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3690),
    [sym_throw_statement] = STATE(3690),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3690),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3690),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(3690),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3690),
    [sym_abstract_class] = STATE(3690),
    [sym_interface_declaration] = STATE(3690),
    [sym_statement_block] = STATE(3690),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3690),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3690),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3690),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3690),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3690),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3690),
    [sym_empty_statement] = STATE(3690),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(3690),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3690),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3690),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3690),
    [sym_break_statement] = STATE(3690),
    [sym_labeled_statement] = STATE(3690),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3690),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [3860] = {
    [sym_type_alias_declaration] = STATE(3719),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3719),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3719),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3719),
    [sym_return_statement] = STATE(3719),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3719),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3719),
    [sym_switch_statement] = STATE(3719),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3719),
    [sym_throw_statement] = STATE(3719),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3719),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3719),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(3719),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3719),
    [sym_abstract_class] = STATE(3719),
    [sym_interface_declaration] = STATE(3719),
    [sym_statement_block] = STATE(3719),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3719),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3719),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3719),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3719),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3719),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3719),
    [sym_empty_statement] = STATE(3719),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(3719),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3719),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3719),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3719),
    [sym_break_statement] = STATE(3719),
    [sym_labeled_statement] = STATE(3719),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3719),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [3861] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(8663),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3862] = {
    [anon_sym_RPAREN] = ACTIONS(8663),
    [sym_comment] = ACTIONS(3),
  },
  [3863] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(8665),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3864] = {
    [anon_sym_RPAREN] = ACTIONS(8665),
    [sym_comment] = ACTIONS(3),
  },
  [3865] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(8667),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3866] = {
    [anon_sym_RPAREN] = ACTIONS(8667),
    [sym_comment] = ACTIONS(3),
  },
  [3867] = {
    [sym_type_alias_declaration] = STATE(3724),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3724),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3724),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3724),
    [sym_return_statement] = STATE(3724),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3724),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3724),
    [sym_switch_statement] = STATE(3724),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3724),
    [sym_throw_statement] = STATE(3724),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3724),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3724),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(3724),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3724),
    [sym_abstract_class] = STATE(3724),
    [sym_interface_declaration] = STATE(3724),
    [sym_statement_block] = STATE(3724),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3724),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3724),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3724),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3724),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3724),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3724),
    [sym_empty_statement] = STATE(3724),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(3724),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3724),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3724),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3724),
    [sym_break_statement] = STATE(3724),
    [sym_labeled_statement] = STATE(3724),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3724),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [3868] = {
    [sym_type_alias_declaration] = STATE(3725),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3725),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3725),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3725),
    [sym_return_statement] = STATE(3725),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3725),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3725),
    [sym_switch_statement] = STATE(3725),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3725),
    [sym_throw_statement] = STATE(3725),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3725),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3725),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(3725),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3725),
    [sym_abstract_class] = STATE(3725),
    [sym_interface_declaration] = STATE(3725),
    [sym_statement_block] = STATE(3725),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3725),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3725),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3725),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3725),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3725),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3725),
    [sym_empty_statement] = STATE(3725),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(3725),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3725),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3725),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3725),
    [sym_break_statement] = STATE(3725),
    [sym_labeled_statement] = STATE(3725),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3725),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [3869] = {
    [sym_type_alias_declaration] = STATE(3726),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3726),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3726),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3726),
    [sym_return_statement] = STATE(3726),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3726),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3726),
    [sym_switch_statement] = STATE(3726),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3726),
    [sym_throw_statement] = STATE(3726),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3726),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3726),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(3726),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3726),
    [sym_abstract_class] = STATE(3726),
    [sym_interface_declaration] = STATE(3726),
    [sym_statement_block] = STATE(3726),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3726),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3726),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3726),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3726),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3726),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3726),
    [sym_empty_statement] = STATE(3726),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(3726),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3726),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3726),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3726),
    [sym_break_statement] = STATE(3726),
    [sym_labeled_statement] = STATE(3726),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3726),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [3870] = {
    [sym_type_alias_declaration] = STATE(3727),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3727),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3727),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3727),
    [sym_return_statement] = STATE(3727),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3727),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3727),
    [sym_switch_statement] = STATE(3727),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3727),
    [sym_throw_statement] = STATE(3727),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3727),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3727),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(3727),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3727),
    [sym_abstract_class] = STATE(3727),
    [sym_interface_declaration] = STATE(3727),
    [sym_statement_block] = STATE(3727),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3727),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3727),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3727),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3727),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3727),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3727),
    [sym_empty_statement] = STATE(3727),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(3727),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3727),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3727),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3727),
    [sym_break_statement] = STATE(3727),
    [sym_labeled_statement] = STATE(3727),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3727),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [3871] = {
    [sym_type_alias_declaration] = STATE(3728),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3728),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3728),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3728),
    [sym_return_statement] = STATE(3728),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3728),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3728),
    [sym_switch_statement] = STATE(3728),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3728),
    [sym_throw_statement] = STATE(3728),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3728),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3728),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(3728),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3728),
    [sym_abstract_class] = STATE(3728),
    [sym_interface_declaration] = STATE(3728),
    [sym_statement_block] = STATE(3728),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3728),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3728),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3728),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3728),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3728),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3728),
    [sym_empty_statement] = STATE(3728),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(3728),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3728),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3728),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3728),
    [sym_break_statement] = STATE(3728),
    [sym_labeled_statement] = STATE(3728),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3728),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [3872] = {
    [sym_type_arguments] = STATE(791),
    [sym_identifier] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_debugger] = ACTIONS(3834),
    [anon_sym_symbol] = ACTIONS(3834),
    [anon_sym_AT] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_void] = ACTIONS(3834),
    [anon_sym_break] = ACTIONS(3834),
    [anon_sym_const] = ACTIONS(3834),
    [sym_super] = ACTIONS(3834),
    [anon_sym_return] = ACTIONS(3834),
    [anon_sym_private] = ACTIONS(3834),
    [anon_sym_get] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_interface] = ACTIONS(3834),
    [anon_sym_enum] = ACTIONS(3834),
    [anon_sym_delete] = ACTIONS(3834),
    [anon_sym_continue] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(3834),
    [anon_sym_this] = ACTIONS(3834),
    [anon_sym_yield] = ACTIONS(3834),
    [sym_true] = ACTIONS(3834),
    [anon_sym_throw] = ACTIONS(3834),
    [anon_sym_protected] = ACTIONS(3834),
    [anon_sym_abstract] = ACTIONS(3834),
    [anon_sym_DOT] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3834),
    [anon_sym_type] = ACTIONS(3834),
    [anon_sym_import] = ACTIONS(3834),
    [anon_sym_namespace] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_await] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_for] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [sym_false] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(3834),
    [anon_sym_number] = ACTIONS(3834),
    [anon_sym_class] = ACTIONS(3834),
    [anon_sym_declare] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3834),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(8669),
    [anon_sym_switch] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [sym_null] = ACTIONS(3834),
    [anon_sym_any] = ACTIONS(3834),
    [anon_sym_boolean] = ACTIONS(3834),
    [anon_sym_async] = ACTIONS(3834),
    [anon_sym_public] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_var] = ACTIONS(3834),
    [anon_sym_while] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(3834),
    [anon_sym_LT] = ACTIONS(7728),
    [sym_number] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3834),
    [anon_sym_function] = ACTIONS(3834),
    [sym_undefined] = ACTIONS(3834),
    [anon_sym_new] = ACTIONS(3834),
    [anon_sym_let] = ACTIONS(3834),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_export] = ACTIONS(3834),
    [anon_sym_do] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_with] = ACTIONS(3834),
    [anon_sym_in] = ACTIONS(8671),
  },
  [3873] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3874] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3875] = {
    [sym_formal_parameters] = STATE(4370),
    [sym_type_parameters] = STATE(4371),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3876] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3877] = {
    [sym_identifier] = ACTIONS(7733),
    [anon_sym_BQUOTE] = ACTIONS(7735),
    [anon_sym_debugger] = ACTIONS(7733),
    [anon_sym_symbol] = ACTIONS(7733),
    [anon_sym_AT] = ACTIONS(7735),
    [anon_sym_PIPE] = ACTIONS(8673),
    [anon_sym_DASH] = ACTIONS(7733),
    [anon_sym_void] = ACTIONS(7733),
    [anon_sym_break] = ACTIONS(7733),
    [anon_sym_const] = ACTIONS(7733),
    [sym_super] = ACTIONS(7733),
    [anon_sym_return] = ACTIONS(7733),
    [anon_sym_private] = ACTIONS(7733),
    [anon_sym_get] = ACTIONS(7733),
    [anon_sym_RBRACE] = ACTIONS(7735),
    [anon_sym_interface] = ACTIONS(7733),
    [anon_sym_enum] = ACTIONS(7733),
    [anon_sym_delete] = ACTIONS(7733),
    [anon_sym_continue] = ACTIONS(7733),
    [anon_sym_DASH_DASH] = ACTIONS(7735),
    [anon_sym_if] = ACTIONS(7733),
    [anon_sym_this] = ACTIONS(7733),
    [anon_sym_yield] = ACTIONS(7733),
    [sym_true] = ACTIONS(7733),
    [anon_sym_throw] = ACTIONS(7733),
    [anon_sym_protected] = ACTIONS(7733),
    [anon_sym_abstract] = ACTIONS(7733),
    [anon_sym_set] = ACTIONS(7733),
    [anon_sym_type] = ACTIONS(7733),
    [anon_sym_import] = ACTIONS(7733),
    [anon_sym_namespace] = ACTIONS(7733),
    [anon_sym_PLUS_PLUS] = ACTIONS(7735),
    [anon_sym_await] = ACTIONS(7733),
    [anon_sym_DQUOTE] = ACTIONS(7735),
    [anon_sym_BANG] = ACTIONS(7735),
    [anon_sym_for] = ACTIONS(7733),
    [anon_sym_LBRACK] = ACTIONS(7735),
    [sym_false] = ACTIONS(7733),
    [anon_sym_SEMI] = ACTIONS(7735),
    [anon_sym_module] = ACTIONS(7733),
    [anon_sym_number] = ACTIONS(7733),
    [anon_sym_class] = ACTIONS(7733),
    [anon_sym_declare] = ACTIONS(7733),
    [anon_sym_typeof] = ACTIONS(7733),
    [anon_sym_LBRACE] = ACTIONS(7735),
    [anon_sym_switch] = ACTIONS(7733),
    [anon_sym_LPAREN] = ACTIONS(7735),
    [sym_null] = ACTIONS(7733),
    [anon_sym_any] = ACTIONS(7733),
    [anon_sym_boolean] = ACTIONS(7733),
    [anon_sym_async] = ACTIONS(7733),
    [anon_sym_public] = ACTIONS(7733),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_var] = ACTIONS(7733),
    [anon_sym_while] = ACTIONS(7733),
    [anon_sym_SQUOTE] = ACTIONS(7735),
    [anon_sym_try] = ACTIONS(7733),
    [anon_sym_LT] = ACTIONS(7735),
    [sym_number] = ACTIONS(7735),
    [anon_sym_SLASH] = ACTIONS(7733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7733),
    [anon_sym_function] = ACTIONS(7733),
    [sym_undefined] = ACTIONS(7733),
    [anon_sym_new] = ACTIONS(7733),
    [anon_sym_let] = ACTIONS(7733),
    [anon_sym_PLUS] = ACTIONS(7733),
    [anon_sym_export] = ACTIONS(7733),
    [anon_sym_do] = ACTIONS(7733),
    [anon_sym_TILDE] = ACTIONS(7735),
    [anon_sym_with] = ACTIONS(7733),
  },
  [3878] = {
    [sym_formal_parameters] = STATE(4374),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3879] = {
    [sym_type_arguments] = STATE(850),
    [sym_identifier] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_debugger] = ACTIONS(3865),
    [anon_sym_symbol] = ACTIONS(3865),
    [anon_sym_AT] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_void] = ACTIONS(3865),
    [anon_sym_break] = ACTIONS(3865),
    [anon_sym_const] = ACTIONS(3865),
    [sym_super] = ACTIONS(3865),
    [anon_sym_return] = ACTIONS(3865),
    [anon_sym_private] = ACTIONS(3865),
    [anon_sym_get] = ACTIONS(3865),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_interface] = ACTIONS(3865),
    [anon_sym_enum] = ACTIONS(3865),
    [anon_sym_delete] = ACTIONS(3865),
    [anon_sym_continue] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_if] = ACTIONS(3865),
    [anon_sym_this] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3865),
    [sym_true] = ACTIONS(3865),
    [anon_sym_throw] = ACTIONS(3865),
    [anon_sym_protected] = ACTIONS(3865),
    [anon_sym_abstract] = ACTIONS(3865),
    [anon_sym_set] = ACTIONS(3865),
    [anon_sym_type] = ACTIONS(3865),
    [anon_sym_import] = ACTIONS(3865),
    [anon_sym_namespace] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_await] = ACTIONS(3865),
    [anon_sym_DQUOTE] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [sym_false] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(3865),
    [anon_sym_number] = ACTIONS(3865),
    [anon_sym_class] = ACTIONS(3865),
    [anon_sym_declare] = ACTIONS(3865),
    [anon_sym_typeof] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_switch] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [sym_null] = ACTIONS(3865),
    [anon_sym_any] = ACTIONS(3865),
    [anon_sym_boolean] = ACTIONS(3865),
    [anon_sym_async] = ACTIONS(3865),
    [anon_sym_public] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_var] = ACTIONS(3865),
    [anon_sym_while] = ACTIONS(3865),
    [anon_sym_SQUOTE] = ACTIONS(1577),
    [anon_sym_try] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(7741),
    [sym_number] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3865),
    [sym_undefined] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_let] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_export] = ACTIONS(3865),
    [anon_sym_do] = ACTIONS(3865),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_with] = ACTIONS(3865),
    [anon_sym_in] = ACTIONS(8677),
  },
  [3880] = {
    [anon_sym_EQ_GT] = ACTIONS(8679),
    [sym_comment] = ACTIONS(3),
  },
  [3881] = {
    [sym_call_signature] = STATE(4336),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(8681),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3882] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [3883] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3884] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [3885] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [3886] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2151),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [3887] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2155),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [3888] = {
    [sym_new_expression] = STATE(4378),
    [sym_augmented_assignment_expression] = STATE(4378),
    [sym_unary_expression] = STATE(4378),
    [sym_update_expression] = STATE(4378),
    [sym_regex] = STATE(4378),
    [sym_meta_property] = STATE(4378),
    [sym_call_signature] = STATE(2390),
    [sym_statement_block] = STATE(2144),
    [sym__expression] = STATE(4378),
    [sym_yield_expression] = STATE(4378),
    [sym_as_expression] = STATE(4378),
    [sym_non_null_expression] = STATE(4378),
    [sym_internal_module] = STATE(4378),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4378),
    [sym_await_expression] = STATE(4378),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(4378),
    [sym_this] = STATE(4378),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(4378),
    [sym_generator_function] = STATE(4378),
    [sym_call_expression] = STATE(4378),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(4378),
    [sym_ternary_expression] = STATE(4378),
    [sym_binary_expression] = STATE(4378),
    [sym_template_string] = STATE(4378),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4378),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(4378),
    [sym_class] = STATE(4378),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(8683),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8683),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8685),
    [sym_true] = ACTIONS(8683),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8683),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3889] = {
    [sym_new_expression] = STATE(4379),
    [sym_augmented_assignment_expression] = STATE(4379),
    [sym_unary_expression] = STATE(4379),
    [sym_update_expression] = STATE(4379),
    [sym_regex] = STATE(4379),
    [sym_meta_property] = STATE(4379),
    [sym_call_signature] = STATE(2390),
    [sym_statement_block] = STATE(2146),
    [sym__expression] = STATE(4379),
    [sym_yield_expression] = STATE(4379),
    [sym_as_expression] = STATE(4379),
    [sym_non_null_expression] = STATE(4379),
    [sym_internal_module] = STATE(4379),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4379),
    [sym_await_expression] = STATE(4379),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(4379),
    [sym_this] = STATE(4379),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(4379),
    [sym_generator_function] = STATE(4379),
    [sym_call_expression] = STATE(4379),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(4379),
    [sym_ternary_expression] = STATE(4379),
    [sym_binary_expression] = STATE(4379),
    [sym_template_string] = STATE(4379),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4379),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(4379),
    [sym_class] = STATE(4379),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(8687),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8687),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8689),
    [sym_true] = ACTIONS(8687),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8687),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3890] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [3891] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3892] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3893] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [3894] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6609),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(6653),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3757),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3895] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(3765),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8694),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [3896] = {
    [sym_type_arguments] = STATE(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_GT_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_is] = ACTIONS(8696),
    [anon_sym_BANG_EQ] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(8698),
  },
  [3897] = {
    [sym_tuple_type] = STATE(2165),
    [sym_index_type_query] = STATE(2165),
    [sym_lookup_type] = STATE(2165),
    [sym_this_type] = STATE(2165),
    [sym_flow_maybe_type] = STATE(2165),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_type_predicate] = STATE(2165),
    [sym_type_query] = STATE(2165),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(2165),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(2165),
    [sym__primary_type] = STATE(2165),
    [sym_generic_type] = STATE(2165),
    [sym_mapped_type] = STATE(2165),
    [sym_literal_type] = STATE(2165),
    [sym_parenthesized_type] = STATE(2165),
    [sym_predefined_type] = STATE(2165),
    [sym_string] = STATE(1248),
    [sym_array_type] = STATE(2165),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [sym_true] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3898] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2170),
    [sym_constructor_type] = STATE(2170),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(2170),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2170),
    [sym_intersection_type] = STATE(2170),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3899] = {
    [sym_formal_parameters] = STATE(4383),
    [sym_type_parameters] = STATE(4384),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3900] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(2178),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3901] = {
    [sym_formal_parameters] = STATE(4387),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3902] = {
    [sym_type_arguments] = STATE(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(3865),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_BANG_EQ] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_PIPE_PIPE] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_EQ_EQ] = ACTIONS(3865),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1577),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1577),
    [anon_sym_STAR_STAR] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_GT_GT] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(8701),
  },
  [3903] = {
    [anon_sym_EQ_GT] = ACTIONS(8704),
    [sym_comment] = ACTIONS(3),
  },
  [3904] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6603),
    [anon_sym_AMP_EQ] = ACTIONS(6603),
    [anon_sym_PLUS_EQ] = ACTIONS(6603),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_CARET_EQ] = ACTIONS(6603),
    [anon_sym_STAR_EQ] = ACTIONS(6603),
    [anon_sym_PIPE_EQ] = ACTIONS(6603),
    [anon_sym_DASH_EQ] = ACTIONS(6603),
    [anon_sym_EQ_GT] = ACTIONS(6607),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6603),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT_EQ] = ACTIONS(6603),
    [anon_sym_DOT] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8706),
  },
  [3905] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6611),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_AMP_EQ] = ACTIONS(6611),
    [anon_sym_PLUS_EQ] = ACTIONS(6611),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_CARET_EQ] = ACTIONS(6611),
    [anon_sym_STAR_EQ] = ACTIONS(6611),
    [anon_sym_PIPE_EQ] = ACTIONS(6611),
    [anon_sym_DASH_EQ] = ACTIONS(6611),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6611),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(6611),
    [anon_sym_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6611),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3906] = {
    [sym_new_expression] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(3223),
    [sym_unary_expression] = STATE(3223),
    [sym_update_expression] = STATE(3223),
    [sym_regex] = STATE(3223),
    [sym_meta_property] = STATE(3223),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3223),
    [sym_yield_expression] = STATE(3223),
    [sym_as_expression] = STATE(3223),
    [sym_non_null_expression] = STATE(3223),
    [sym_internal_module] = STATE(3223),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3223),
    [sym_await_expression] = STATE(3223),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3223),
    [sym_this] = STATE(3223),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3223),
    [sym_generator_function] = STATE(3223),
    [sym_call_expression] = STATE(3223),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3223),
    [sym_ternary_expression] = STATE(3223),
    [sym_binary_expression] = STATE(3223),
    [sym_template_string] = STATE(3223),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3223),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3223),
    [sym_class] = STATE(3223),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(8708),
    [sym_false] = ACTIONS(6615),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6615),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(6617),
    [sym_true] = ACTIONS(6615),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6615),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3907] = {
    [sym_new_expression] = STATE(3224),
    [sym_augmented_assignment_expression] = STATE(3224),
    [sym_unary_expression] = STATE(3224),
    [sym_update_expression] = STATE(3224),
    [sym_regex] = STATE(3224),
    [sym_meta_property] = STATE(3224),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3224),
    [sym_yield_expression] = STATE(3224),
    [sym_as_expression] = STATE(3224),
    [sym_non_null_expression] = STATE(3224),
    [sym_internal_module] = STATE(3224),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3224),
    [sym_await_expression] = STATE(3224),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3224),
    [sym_this] = STATE(3224),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3224),
    [sym_generator_function] = STATE(3224),
    [sym_call_expression] = STATE(3224),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3224),
    [sym_ternary_expression] = STATE(3224),
    [sym_binary_expression] = STATE(3224),
    [sym_template_string] = STATE(3224),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3224),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3224),
    [sym_class] = STATE(3224),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(6619),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6619),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(4552),
    [sym_true] = ACTIONS(6619),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6619),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [3908] = {
    [sym_new_expression] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(3223),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(3223),
    [sym_update_expression] = STATE(3223),
    [sym_regex] = STATE(3223),
    [sym_meta_property] = STATE(3223),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(3223),
    [sym_yield_expression] = STATE(3223),
    [sym_as_expression] = STATE(3223),
    [sym_non_null_expression] = STATE(3223),
    [sym_internal_module] = STATE(3223),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(3223),
    [sym_await_expression] = STATE(3223),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(3223),
    [sym_this] = STATE(3223),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(3223),
    [sym_generator_function] = STATE(3223),
    [sym_call_expression] = STATE(3223),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(3223),
    [sym_ternary_expression] = STATE(3223),
    [sym_binary_expression] = STATE(3223),
    [sym_template_string] = STATE(3223),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3223),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3223),
    [sym_class] = STATE(3223),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(6611),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_AMP_EQ] = ACTIONS(6611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6611),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(6611),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_PIPE_EQ] = ACTIONS(6611),
    [anon_sym_DASH_EQ] = ACTIONS(6611),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6611),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(5006),
    [sym_true] = ACTIONS(6615),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6611),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6615),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6611),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6615),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_STAR_EQ] = ACTIONS(6611),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_EQ_GT] = ACTIONS(6613),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6617),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6611),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(6615),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3909] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(1890),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(1891),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(6635),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(6637),
    [anon_sym_symbol] = ACTIONS(6637),
    [anon_sym_number] = ACTIONS(6637),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(6637),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(6639),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6637),
    [anon_sym_private] = ACTIONS(6637),
    [anon_sym_boolean] = ACTIONS(6637),
    [anon_sym_async] = ACTIONS(6641),
    [anon_sym_public] = ACTIONS(6637),
    [anon_sym_get] = ACTIONS(6637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(6637),
    [anon_sym_string] = ACTIONS(6637),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(6637),
    [anon_sym_type] = ACTIONS(6637),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(6637),
    [anon_sym_export] = ACTIONS(6637),
    [anon_sym_namespace] = ACTIONS(6643),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [3910] = {
    [sym_type_alias_declaration] = STATE(3922),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3922),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3922),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3922),
    [sym_return_statement] = STATE(3922),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3922),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3922),
    [sym_switch_statement] = STATE(3922),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3922),
    [sym_throw_statement] = STATE(3922),
    [aux_sym_program_repeat1] = STATE(3922),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3922),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3922),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3922),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3922),
    [sym_abstract_class] = STATE(3922),
    [sym_interface_declaration] = STATE(3922),
    [sym_statement_block] = STATE(3922),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3922),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3922),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3922),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3922),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3922),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3922),
    [sym_empty_statement] = STATE(3922),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3922),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3922),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3922),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3922),
    [sym_break_statement] = STATE(3922),
    [sym_labeled_statement] = STATE(3922),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3922),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(8710),
    [anon_sym_default] = ACTIONS(8712),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(8712),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [3911] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_GT_GT_GT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(8691),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [3912] = {
    [sym_type_alias_declaration] = STATE(361),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(361),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(361),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(361),
    [sym_return_statement] = STATE(361),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(361),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(361),
    [sym_switch_statement] = STATE(361),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(361),
    [sym_throw_statement] = STATE(361),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(361),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(361),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(361),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(361),
    [sym_abstract_class] = STATE(361),
    [sym_interface_declaration] = STATE(361),
    [sym_statement_block] = STATE(361),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(361),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(361),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(361),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(361),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(361),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(361),
    [sym_empty_statement] = STATE(361),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(361),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(361),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(361),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(361),
    [sym_break_statement] = STATE(361),
    [sym_labeled_statement] = STATE(361),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(361),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [3913] = {
    [sym_type_alias_declaration] = STATE(4399),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4399),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4399),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4399),
    [sym_return_statement] = STATE(4399),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4399),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4399),
    [sym_switch_statement] = STATE(4399),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4399),
    [sym_throw_statement] = STATE(4399),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4399),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4399),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4399),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4399),
    [sym_abstract_class] = STATE(4399),
    [sym_interface_declaration] = STATE(4399),
    [sym_statement_block] = STATE(4399),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4399),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4399),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4399),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4399),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4399),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4399),
    [sym_empty_statement] = STATE(4399),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4399),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4399),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4399),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4399),
    [sym_break_statement] = STATE(4399),
    [sym_labeled_statement] = STATE(4399),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4399),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [3914] = {
    [anon_sym_LPAREN] = ACTIONS(8728),
    [sym_comment] = ACTIONS(3),
  },
  [3915] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4405),
    [sym_variable_declaration] = STATE(4405),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(4405),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(4406),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_lexical_declaration] = STATE(4405),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(4407),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(8730),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(8732),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(8734),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(8732),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [3916] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(8736),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(310),
  },
  [3917] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(3919),
    [sym__declaration] = STATE(192),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(3919),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(7950),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(7952),
    [anon_sym_global] = ACTIONS(322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(7954),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [3918] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(3919),
    [sym__declaration] = STATE(317),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(3919),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(7952),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(7954),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [3919] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(7960),
    [anon_sym_class] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [3920] = {
    [sym_type_alias_declaration] = STATE(777),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(777),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(777),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(777),
    [sym_return_statement] = STATE(777),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(777),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(777),
    [sym_switch_statement] = STATE(777),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(777),
    [sym_throw_statement] = STATE(777),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(777),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(777),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(777),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(777),
    [sym_abstract_class] = STATE(777),
    [sym_interface_declaration] = STATE(777),
    [sym_statement_block] = STATE(777),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(777),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(777),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(777),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(777),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(777),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(777),
    [sym_empty_statement] = STATE(777),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(777),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(777),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(777),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(777),
    [sym_break_statement] = STATE(777),
    [sym_labeled_statement] = STATE(777),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(777),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [3921] = {
    [sym_type_alias_declaration] = STATE(934),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(934),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(934),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(934),
    [sym_return_statement] = STATE(934),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(934),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(934),
    [sym_switch_statement] = STATE(934),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(934),
    [sym_throw_statement] = STATE(934),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(934),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(934),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(934),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(934),
    [sym_abstract_class] = STATE(934),
    [sym_interface_declaration] = STATE(934),
    [sym_statement_block] = STATE(934),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(934),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(934),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(934),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(934),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(934),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(934),
    [sym_empty_statement] = STATE(934),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(934),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(934),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(934),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(934),
    [sym_break_statement] = STATE(934),
    [sym_labeled_statement] = STATE(934),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(934),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [3922] = {
    [sym_type_alias_declaration] = STATE(3922),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3922),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3922),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3922),
    [sym_return_statement] = STATE(3922),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3922),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3922),
    [sym_switch_statement] = STATE(3922),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3922),
    [sym_throw_statement] = STATE(3922),
    [aux_sym_program_repeat1] = STATE(3922),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3922),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3922),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3922),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3922),
    [sym_abstract_class] = STATE(3922),
    [sym_interface_declaration] = STATE(3922),
    [sym_statement_block] = STATE(3922),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3922),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3922),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3922),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3922),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3922),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3922),
    [sym_empty_statement] = STATE(3922),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3922),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3922),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3922),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3922),
    [sym_break_statement] = STATE(3922),
    [sym_labeled_statement] = STATE(3922),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3922),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8738),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [anon_sym_debugger] = ACTIONS(1747),
    [anon_sym_symbol] = ACTIONS(1750),
    [anon_sym_AT] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(1756),
    [anon_sym_void] = ACTIONS(1759),
    [anon_sym_break] = ACTIONS(1762),
    [anon_sym_const] = ACTIONS(1765),
    [sym_super] = ACTIONS(1768),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_private] = ACTIONS(1750),
    [anon_sym_get] = ACTIONS(1750),
    [anon_sym_RBRACE] = ACTIONS(1882),
    [anon_sym_default] = ACTIONS(8741),
    [anon_sym_interface] = ACTIONS(1774),
    [anon_sym_enum] = ACTIONS(1777),
    [anon_sym_delete] = ACTIONS(1780),
    [anon_sym_continue] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1786),
    [anon_sym_if] = ACTIONS(8743),
    [anon_sym_this] = ACTIONS(1792),
    [anon_sym_yield] = ACTIONS(1795),
    [sym_true] = ACTIONS(1798),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_protected] = ACTIONS(1750),
    [anon_sym_abstract] = ACTIONS(1804),
    [anon_sym_set] = ACTIONS(1750),
    [anon_sym_type] = ACTIONS(1807),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_namespace] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1786),
    [anon_sym_await] = ACTIONS(1816),
    [anon_sym_DQUOTE] = ACTIONS(1819),
    [anon_sym_BANG] = ACTIONS(1822),
    [anon_sym_for] = ACTIONS(8746),
    [anon_sym_LBRACK] = ACTIONS(1828),
    [sym_false] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(1831),
    [anon_sym_case] = ACTIONS(8741),
    [anon_sym_module] = ACTIONS(1834),
    [anon_sym_number] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(1837),
    [anon_sym_declare] = ACTIONS(8749),
    [anon_sym_typeof] = ACTIONS(1780),
    [anon_sym_LBRACE] = ACTIONS(1843),
    [anon_sym_switch] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [sym_null] = ACTIONS(1798),
    [anon_sym_any] = ACTIONS(1750),
    [anon_sym_boolean] = ACTIONS(1750),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_public] = ACTIONS(1750),
    [anon_sym_var] = ACTIONS(1855),
    [anon_sym_while] = ACTIONS(8752),
    [anon_sym_SQUOTE] = ACTIONS(1861),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_LT] = ACTIONS(1867),
    [sym_number] = ACTIONS(1870),
    [anon_sym_SLASH] = ACTIONS(1873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1750),
    [anon_sym_function] = ACTIONS(1876),
    [sym_undefined] = ACTIONS(1798),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_let] = ACTIONS(1884),
    [anon_sym_PLUS] = ACTIONS(1756),
    [anon_sym_export] = ACTIONS(8755),
    [anon_sym_do] = ACTIONS(1890),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_with] = ACTIONS(8758),
  },
  [3923] = {
    [sym_type_alias_declaration] = STATE(915),
    [aux_sym_export_statement_repeat1] = STATE(3919),
    [sym__declaration] = STATE(915),
    [sym_ambient_declaration] = STATE(915),
    [sym_import_alias] = STATE(915),
    [sym_export_statement] = STATE(915),
    [sym_generator_function] = STATE(915),
    [sym_lexical_declaration] = STATE(915),
    [sym_internal_module] = STATE(915),
    [sym_decorator] = STATE(3919),
    [sym_enum_declaration] = STATE(915),
    [sym_function] = STATE(915),
    [sym_function_signature] = STATE(915),
    [sym_variable_declaration] = STATE(915),
    [sym_abstract_class] = STATE(915),
    [sym_module] = STATE(915),
    [sym_interface_declaration] = STATE(915),
    [sym_class] = STATE(915),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(7952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(7954),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [3924] = {
    [anon_sym_EQ_GT] = ACTIONS(8761),
    [sym_comment] = ACTIONS(3),
  },
  [3925] = {
    [sym_formal_parameters] = STATE(4410),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3926] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3927] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3928] = {
    [anon_sym_EQ_GT] = ACTIONS(8763),
    [sym_comment] = ACTIONS(3),
  },
  [3929] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4412),
    [sym_constructor_type] = STATE(4412),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(4412),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4412),
    [sym_intersection_type] = STATE(4412),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3930] = {
    [anon_sym_EQ] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(5028),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [3931] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4413),
    [sym_constructor_type] = STATE(4413),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(4413),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4413),
    [sym_intersection_type] = STATE(4413),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1460),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1462),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3932] = {
    [anon_sym_EQ] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(5028),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [3933] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3934] = {
    [sym_formal_parameters] = STATE(4414),
    [sym_type_parameters] = STATE(4415),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3935] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3936] = {
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_RPAREN] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(8765),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8767),
    [sym_comment] = ACTIONS(3),
  },
  [3937] = {
    [sym_formal_parameters] = STATE(4418),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3938] = {
    [anon_sym_EQ_GT] = ACTIONS(8769),
    [sym_comment] = ACTIONS(3),
  },
  [3939] = {
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_RPAREN] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(8765),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8767),
    [sym_comment] = ACTIONS(3),
  },
  [3940] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4420),
    [sym_constructor_type] = STATE(4420),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(4420),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4420),
    [sym_intersection_type] = STATE(4420),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2428),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2430),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5060),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3941] = {
    [anon_sym_EQ_GT] = ACTIONS(8771),
    [sym_comment] = ACTIONS(3),
  },
  [3942] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4422),
    [sym_constructor_type] = STATE(4422),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(4422),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4422),
    [sym_intersection_type] = STATE(4422),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2428),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2430),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5060),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3943] = {
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_RPAREN] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(8765),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8767),
    [sym_comment] = ACTIONS(3),
  },
  [3944] = {
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [3945] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(7988),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(7990),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [3946] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4423),
    [sym_constructor_type] = STATE(4423),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1502),
    [sym_function_type] = STATE(4423),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4423),
    [sym_intersection_type] = STATE(4423),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1501),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1503),
    [sym_identifier] = ACTIONS(3134),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [3947] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(7988),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(7990),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6986),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [3948] = {
    [anon_sym_COMMA] = ACTIONS(8773),
    [anon_sym_RPAREN] = ACTIONS(8773),
    [sym_comment] = ACTIONS(3),
  },
  [3949] = {
    [anon_sym_COMMA] = ACTIONS(8775),
    [anon_sym_RPAREN] = ACTIONS(8775),
    [sym_comment] = ACTIONS(3),
  },
  [3950] = {
    [anon_sym_COMMA] = ACTIONS(8777),
    [anon_sym_RPAREN] = ACTIONS(8777),
    [sym_comment] = ACTIONS(3),
  },
  [3951] = {
    [anon_sym_COMMA] = ACTIONS(8779),
    [anon_sym_RPAREN] = ACTIONS(8779),
    [sym_comment] = ACTIONS(3),
  },
  [3952] = {
    [sym_identifier] = ACTIONS(8781),
    [anon_sym_BQUOTE] = ACTIONS(8783),
    [anon_sym_debugger] = ACTIONS(8781),
    [anon_sym_symbol] = ACTIONS(8781),
    [anon_sym_AT] = ACTIONS(8783),
    [anon_sym_DASH] = ACTIONS(8781),
    [anon_sym_void] = ACTIONS(8781),
    [anon_sym_break] = ACTIONS(8781),
    [anon_sym_const] = ACTIONS(8781),
    [sym_super] = ACTIONS(8781),
    [anon_sym_return] = ACTIONS(8781),
    [anon_sym_private] = ACTIONS(8781),
    [anon_sym_get] = ACTIONS(8781),
    [anon_sym_RBRACE] = ACTIONS(8783),
    [anon_sym_interface] = ACTIONS(8781),
    [anon_sym_default] = ACTIONS(8781),
    [anon_sym_enum] = ACTIONS(8781),
    [anon_sym_delete] = ACTIONS(8781),
    [anon_sym_continue] = ACTIONS(8781),
    [anon_sym_DASH_DASH] = ACTIONS(8783),
    [anon_sym_if] = ACTIONS(8781),
    [anon_sym_this] = ACTIONS(8781),
    [anon_sym_yield] = ACTIONS(8781),
    [sym_true] = ACTIONS(8781),
    [anon_sym_throw] = ACTIONS(8781),
    [anon_sym_protected] = ACTIONS(8781),
    [anon_sym_abstract] = ACTIONS(8781),
    [anon_sym_set] = ACTIONS(8781),
    [anon_sym_type] = ACTIONS(8781),
    [anon_sym_import] = ACTIONS(8781),
    [anon_sym_namespace] = ACTIONS(8781),
    [anon_sym_PLUS_PLUS] = ACTIONS(8783),
    [anon_sym_await] = ACTIONS(8781),
    [anon_sym_DQUOTE] = ACTIONS(8783),
    [anon_sym_else] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_for] = ACTIONS(8781),
    [anon_sym_LBRACK] = ACTIONS(8783),
    [sym_false] = ACTIONS(8781),
    [anon_sym_SEMI] = ACTIONS(8783),
    [anon_sym_case] = ACTIONS(8781),
    [anon_sym_module] = ACTIONS(8781),
    [anon_sym_number] = ACTIONS(8781),
    [anon_sym_class] = ACTIONS(8781),
    [anon_sym_declare] = ACTIONS(8781),
    [anon_sym_typeof] = ACTIONS(8781),
    [anon_sym_LBRACE] = ACTIONS(8783),
    [anon_sym_switch] = ACTIONS(8781),
    [anon_sym_LPAREN] = ACTIONS(8783),
    [sym_null] = ACTIONS(8781),
    [anon_sym_any] = ACTIONS(8781),
    [anon_sym_boolean] = ACTIONS(8781),
    [anon_sym_async] = ACTIONS(8781),
    [anon_sym_public] = ACTIONS(8781),
    [anon_sym_var] = ACTIONS(8781),
    [anon_sym_while] = ACTIONS(8781),
    [anon_sym_SQUOTE] = ACTIONS(8783),
    [anon_sym_try] = ACTIONS(8781),
    [anon_sym_LT] = ACTIONS(8783),
    [sym_number] = ACTIONS(8783),
    [anon_sym_SLASH] = ACTIONS(8781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(8781),
    [anon_sym_string] = ACTIONS(8781),
    [anon_sym_function] = ACTIONS(8781),
    [sym_undefined] = ACTIONS(8781),
    [anon_sym_new] = ACTIONS(8781),
    [ts_builtin_sym_end] = ACTIONS(8783),
    [anon_sym_let] = ACTIONS(8781),
    [anon_sym_PLUS] = ACTIONS(8781),
    [anon_sym_export] = ACTIONS(8781),
    [anon_sym_do] = ACTIONS(8781),
    [anon_sym_TILDE] = ACTIONS(8783),
    [anon_sym_with] = ACTIONS(8781),
  },
  [3953] = {
    [anon_sym_EQ_GT] = ACTIONS(8785),
    [sym_comment] = ACTIONS(3),
  },
  [3954] = {
    [sym_formal_parameters] = STATE(4425),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3955] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3956] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3957] = {
    [anon_sym_EQ_GT] = ACTIONS(8787),
    [sym_comment] = ACTIONS(3),
  },
  [3958] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4427),
    [sym_constructor_type] = STATE(4427),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(4427),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4427),
    [sym_intersection_type] = STATE(4427),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3959] = {
    [anon_sym_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [3960] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4428),
    [sym_constructor_type] = STATE(4428),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(4428),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4428),
    [sym_intersection_type] = STATE(4428),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1549),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1551),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3961] = {
    [anon_sym_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [3962] = {
    [anon_sym_EQ_GT] = ACTIONS(8789),
    [sym_comment] = ACTIONS(3),
  },
  [3963] = {
    [sym_formal_parameters] = STATE(4430),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [3964] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3965] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3966] = {
    [anon_sym_EQ_GT] = ACTIONS(8791),
    [sym_comment] = ACTIONS(3),
  },
  [3967] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4432),
    [sym_constructor_type] = STATE(4432),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(4432),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4432),
    [sym_intersection_type] = STATE(4432),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3968] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [3969] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4433),
    [sym_constructor_type] = STATE(4433),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(4433),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4433),
    [sym_intersection_type] = STATE(4433),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1558),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1560),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3970] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [3971] = {
    [anon_sym_GT] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(5198),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [3972] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4434),
    [sym_constructor_type] = STATE(4434),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(4434),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4434),
    [sym_intersection_type] = STATE(4434),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1566),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1567),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [3973] = {
    [anon_sym_GT] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(5198),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [3974] = {
    [sym_type_annotation] = STATE(4280),
    [anon_sym_COLON] = ACTIONS(3347),
    [sym_comment] = ACTIONS(3),
  },
  [3975] = {
    [sym_type_annotation] = STATE(4281),
    [anon_sym_COLON] = ACTIONS(3347),
    [sym_comment] = ACTIONS(3),
  },
  [3976] = {
    [sym_identifier] = ACTIONS(8793),
    [anon_sym_BQUOTE] = ACTIONS(8795),
    [anon_sym_debugger] = ACTIONS(8793),
    [anon_sym_symbol] = ACTIONS(8793),
    [anon_sym_AT] = ACTIONS(8795),
    [anon_sym_PIPE] = ACTIONS(8795),
    [anon_sym_COMMA] = ACTIONS(8795),
    [anon_sym_DASH] = ACTIONS(8793),
    [anon_sym_EQ] = ACTIONS(8793),
    [anon_sym_void] = ACTIONS(8793),
    [anon_sym_break] = ACTIONS(8793),
    [anon_sym_const] = ACTIONS(8793),
    [sym_super] = ACTIONS(8793),
    [anon_sym_return] = ACTIONS(8793),
    [anon_sym_private] = ACTIONS(8793),
    [anon_sym_get] = ACTIONS(8793),
    [anon_sym_RBRACE] = ACTIONS(8795),
    [anon_sym_interface] = ACTIONS(8793),
    [anon_sym_default] = ACTIONS(8793),
    [anon_sym_enum] = ACTIONS(8793),
    [anon_sym_delete] = ACTIONS(8793),
    [anon_sym_continue] = ACTIONS(8793),
    [anon_sym_DASH_DASH] = ACTIONS(8795),
    [anon_sym_if] = ACTIONS(8793),
    [anon_sym_this] = ACTIONS(8793),
    [anon_sym_yield] = ACTIONS(8793),
    [sym_true] = ACTIONS(8793),
    [anon_sym_throw] = ACTIONS(8793),
    [anon_sym_protected] = ACTIONS(8793),
    [anon_sym_abstract] = ACTIONS(8793),
    [anon_sym_set] = ACTIONS(8793),
    [anon_sym_type] = ACTIONS(8793),
    [anon_sym_import] = ACTIONS(8793),
    [anon_sym_namespace] = ACTIONS(8793),
    [anon_sym_PLUS_PLUS] = ACTIONS(8795),
    [anon_sym_await] = ACTIONS(8793),
    [anon_sym_DQUOTE] = ACTIONS(8795),
    [anon_sym_else] = ACTIONS(8793),
    [anon_sym_BANG] = ACTIONS(8795),
    [anon_sym_for] = ACTIONS(8793),
    [anon_sym_LBRACK] = ACTIONS(8795),
    [sym_false] = ACTIONS(8793),
    [anon_sym_SEMI] = ACTIONS(8795),
    [anon_sym_case] = ACTIONS(8793),
    [anon_sym_module] = ACTIONS(8793),
    [anon_sym_number] = ACTIONS(8793),
    [anon_sym_class] = ACTIONS(8793),
    [anon_sym_declare] = ACTIONS(8793),
    [anon_sym_typeof] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(8795),
    [anon_sym_switch] = ACTIONS(8793),
    [anon_sym_LPAREN] = ACTIONS(8795),
    [anon_sym_RBRACK] = ACTIONS(8795),
    [sym_null] = ACTIONS(8793),
    [anon_sym_GT] = ACTIONS(8795),
    [anon_sym_any] = ACTIONS(8793),
    [anon_sym_boolean] = ACTIONS(8793),
    [anon_sym_async] = ACTIONS(8793),
    [anon_sym_public] = ACTIONS(8793),
    [anon_sym_EQ_GT] = ACTIONS(8795),
    [anon_sym_AMP] = ACTIONS(8795),
    [anon_sym_var] = ACTIONS(8793),
    [anon_sym_while] = ACTIONS(8793),
    [anon_sym_SQUOTE] = ACTIONS(8795),
    [anon_sym_try] = ACTIONS(8793),
    [anon_sym_RPAREN] = ACTIONS(8795),
    [anon_sym_LT] = ACTIONS(8795),
    [sym_number] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8793),
    [anon_sym_function] = ACTIONS(8793),
    [sym_undefined] = ACTIONS(8793),
    [anon_sym_new] = ACTIONS(8793),
    [ts_builtin_sym_end] = ACTIONS(8795),
    [anon_sym_let] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8793),
    [anon_sym_export] = ACTIONS(8793),
    [anon_sym_do] = ACTIONS(8793),
    [anon_sym_TILDE] = ACTIONS(8795),
    [anon_sym_with] = ACTIONS(8793),
  },
  [3977] = {
    [anon_sym_COLON] = ACTIONS(6749),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [sym__automatic_semicolon] = ACTIONS(6749),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6749),
    [anon_sym_COMMA] = ACTIONS(6749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6749),
  },
  [3978] = {
    [aux_sym_export_statement_repeat1] = STATE(1485),
    [sym_decorator] = STATE(1485),
    [sym_object] = STATE(759),
    [sym_accessibility_modifier] = STATE(246),
    [sym_required_parameter] = STATE(1486),
    [sym_array] = STATE(761),
    [sym_rest_parameter] = STATE(1486),
    [sym_optional_parameter] = STATE(1486),
    [sym_this] = STATE(762),
    [anon_sym_get] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1426),
    [anon_sym_symbol] = ACTIONS(1426),
    [anon_sym_number] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(8797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_string] = ACTIONS(1426),
    [anon_sym_set] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_export] = ACTIONS(1426),
    [sym_readonly] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1426),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
  },
  [3979] = {
    [sym__automatic_semicolon] = ACTIONS(8563),
    [anon_sym_RBRACE] = ACTIONS(8563),
    [anon_sym_SEMI] = ACTIONS(8563),
    [anon_sym_COMMA] = ACTIONS(8563),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8563),
    [sym_comment] = ACTIONS(3),
  },
  [3980] = {
    [sym_call_signature] = STATE(4436),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [3981] = {
    [sym_call_signature] = STATE(4436),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(8799),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [3982] = {
    [sym__automatic_semicolon] = ACTIONS(8801),
    [anon_sym_RBRACE] = ACTIONS(8801),
    [anon_sym_SEMI] = ACTIONS(8801),
    [anon_sym_COMMA] = ACTIONS(8801),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8801),
    [sym_comment] = ACTIONS(3),
  },
  [3983] = {
    [sym__automatic_semicolon] = ACTIONS(5146),
    [anon_sym_RBRACE] = ACTIONS(5146),
    [anon_sym_SEMI] = ACTIONS(5146),
    [anon_sym_COMMA] = ACTIONS(5146),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5146),
    [sym_comment] = ACTIONS(3),
  },
  [3984] = {
    [sym__automatic_semicolon] = ACTIONS(4285),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym_COMMA] = ACTIONS(4285),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4285),
    [sym_comment] = ACTIONS(3),
  },
  [3985] = {
    [sym_object_type] = STATE(4438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1982),
  },
  [3986] = {
    [sym__automatic_semicolon] = ACTIONS(4289),
    [anon_sym_RBRACE] = ACTIONS(4289),
    [anon_sym_SEMI] = ACTIONS(4289),
    [anon_sym_COMMA] = ACTIONS(4289),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4289),
    [sym_comment] = ACTIONS(3),
  },
  [3987] = {
    [aux_sym_enum_body_repeat1] = STATE(4441),
    [anon_sym_COMMA] = ACTIONS(8803),
    [anon_sym_RBRACE] = ACTIONS(8805),
    [sym_comment] = ACTIONS(3),
  },
  [3988] = {
    [sym__automatic_semicolon] = ACTIONS(7083),
    [anon_sym_RBRACE] = ACTIONS(7083),
    [anon_sym_SEMI] = ACTIONS(7083),
    [anon_sym_COMMA] = ACTIONS(7083),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7083),
    [sym_comment] = ACTIONS(3),
  },
  [3989] = {
    [anon_sym_COLON] = ACTIONS(8807),
    [sym_comment] = ACTIONS(3),
  },
  [3990] = {
    [sym__automatic_semicolon] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
  },
  [3991] = {
    [sym__automatic_semicolon] = ACTIONS(4082),
    [anon_sym_RBRACE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4082),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4082),
    [sym_comment] = ACTIONS(3),
  },
  [3992] = {
    [sym__automatic_semicolon] = ACTIONS(4092),
    [anon_sym_RBRACE] = ACTIONS(4092),
    [anon_sym_SEMI] = ACTIONS(4092),
    [anon_sym_COMMA] = ACTIONS(4092),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4092),
    [sym_comment] = ACTIONS(3),
  },
  [3993] = {
    [sym_class_body] = STATE(4443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [3994] = {
    [sym_class_heritage] = STATE(4444),
    [sym_extends_clause] = STATE(178),
    [sym_implements_clause] = STATE(179),
    [sym_class_body] = STATE(4443),
    [anon_sym_extends] = ACTIONS(1115),
    [anon_sym_implements] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [3995] = {
    [sym__automatic_semicolon] = ACTIONS(4313),
    [anon_sym_RBRACE] = ACTIONS(4313),
    [anon_sym_SEMI] = ACTIONS(4313),
    [anon_sym_COMMA] = ACTIONS(4313),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4313),
    [sym_comment] = ACTIONS(3),
  },
  [3996] = {
    [sym__automatic_semicolon] = ACTIONS(8809),
    [anon_sym_AMP] = ACTIONS(4321),
    [anon_sym_PIPE] = ACTIONS(4323),
    [anon_sym_SEMI] = ACTIONS(8809),
    [sym_comment] = ACTIONS(3),
  },
  [3997] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4446),
    [sym_constructor_type] = STATE(4446),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(4446),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4446),
    [sym_intersection_type] = STATE(4446),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(1170),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(1172),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [3998] = {
    [sym__automatic_semicolon] = ACTIONS(8811),
    [anon_sym_SEMI] = ACTIONS(8811),
    [anon_sym_DOT] = ACTIONS(4335),
    [sym_comment] = ACTIONS(3),
  },
  [3999] = {
    [sym_statement_block] = STATE(2464),
    [sym__automatic_semicolon] = ACTIONS(8813),
    [anon_sym_SEMI] = ACTIONS(8813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(901),
  },
  [4000] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4001] = {
    [sym_formal_parameters] = STATE(4449),
    [sym_type_parameters] = STATE(4450),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4002] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4003] = {
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(8815),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8817),
    [anon_sym_COMMA] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
  },
  [4004] = {
    [sym_formal_parameters] = STATE(4453),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4005] = {
    [anon_sym_EQ_GT] = ACTIONS(8819),
    [sym_comment] = ACTIONS(3),
  },
  [4006] = {
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(8815),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8817),
    [anon_sym_COMMA] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
  },
  [4007] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4455),
    [sym_constructor_type] = STATE(4455),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4455),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4455),
    [sym_intersection_type] = STATE(4455),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2539),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2541),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5286),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4008] = {
    [anon_sym_EQ_GT] = ACTIONS(8821),
    [sym_comment] = ACTIONS(3),
  },
  [4009] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4457),
    [sym_constructor_type] = STATE(4457),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4457),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4457),
    [sym_intersection_type] = STATE(4457),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2539),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2541),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5286),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4010] = {
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(8815),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8817),
    [anon_sym_COMMA] = ACTIONS(5406),
    [sym_comment] = ACTIONS(3),
  },
  [4011] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(6875),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(6877),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [4012] = {
    [sym_string] = STATE(4458),
    [sym__property_name] = STATE(4458),
    [sym_computed_property_name] = STATE(4458),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [4013] = {
    [sym_string] = STATE(4458),
    [sym__property_name] = STATE(4458),
    [sym_computed_property_name] = STATE(4458),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(8823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [4014] = {
    [sym_call_signature] = STATE(4436),
    [sym_type_annotation] = STATE(4459),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [sym__automatic_semicolon] = ACTIONS(8801),
    [anon_sym_RBRACE] = ACTIONS(8801),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(8801),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8801),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(8801),
    [sym_comment] = ACTIONS(3),
  },
  [4015] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4460),
    [sym_constructor_type] = STATE(4460),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(4460),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4460),
    [sym_intersection_type] = STATE(4460),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4016] = {
    [anon_sym_EQ_GT] = ACTIONS(8825),
    [sym_comment] = ACTIONS(3),
  },
  [4017] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4462),
    [sym_constructor_type] = STATE(4462),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(4462),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4462),
    [sym_intersection_type] = STATE(4462),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4018] = {
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_RBRACK] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [4019] = {
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_RBRACK] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4020] = {
    [sym_formal_parameters] = STATE(4463),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4021] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(8827),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4022] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(8830),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4023] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6255),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(6255),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(6255),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(8310),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2063),
  },
  [4024] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4464),
    [sym_constructor_type] = STATE(4464),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(4464),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4464),
    [sym_intersection_type] = STATE(4464),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4025] = {
    [anon_sym_EQ_GT] = ACTIONS(8833),
    [sym_comment] = ACTIONS(3),
  },
  [4026] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4466),
    [sym_constructor_type] = STATE(4466),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(4466),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4466),
    [sym_intersection_type] = STATE(4466),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4027] = {
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(6923),
    [anon_sym_PIPE] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
  },
  [4028] = {
    [sym__initializer] = STATE(517),
    [sym_type_arguments] = STATE(791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_AMP_EQ] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(5178),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3884),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_CARET_EQ] = ACTIONS(929),
    [anon_sym_STAR_EQ] = ACTIONS(929),
    [anon_sym_PIPE_EQ] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
    [anon_sym_EQ_GT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8835),
  },
  [4029] = {
    [sym__initializer] = STATE(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(3897),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [4030] = {
    [sym_new_expression] = STATE(528),
    [sym_augmented_assignment_expression] = STATE(528),
    [sym_unary_expression] = STATE(528),
    [sym_update_expression] = STATE(528),
    [sym_regex] = STATE(528),
    [sym_meta_property] = STATE(528),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(528),
    [sym_yield_expression] = STATE(528),
    [sym_as_expression] = STATE(528),
    [sym_non_null_expression] = STATE(528),
    [sym_internal_module] = STATE(528),
    [sym_nested_identifier] = STATE(822),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(528),
    [sym_await_expression] = STATE(528),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(528),
    [sym_this] = STATE(528),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(528),
    [sym_generator_function] = STATE(528),
    [sym_call_expression] = STATE(528),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(528),
    [sym_ternary_expression] = STATE(528),
    [sym_binary_expression] = STATE(528),
    [sym_template_string] = STATE(528),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(528),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(528),
    [sym_class] = STATE(528),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(8837),
    [sym_false] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(953),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(955),
    [sym_true] = ACTIONS(953),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [4031] = {
    [sym_new_expression] = STATE(529),
    [sym_augmented_assignment_expression] = STATE(529),
    [sym_unary_expression] = STATE(529),
    [sym_update_expression] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_meta_property] = STATE(529),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(529),
    [sym_yield_expression] = STATE(529),
    [sym_as_expression] = STATE(529),
    [sym_non_null_expression] = STATE(529),
    [sym_internal_module] = STATE(529),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(529),
    [sym_await_expression] = STATE(529),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(529),
    [sym_this] = STATE(529),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(529),
    [sym_generator_function] = STATE(529),
    [sym_call_expression] = STATE(529),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(529),
    [sym_ternary_expression] = STATE(529),
    [sym_binary_expression] = STATE(529),
    [sym_template_string] = STATE(529),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(529),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(529),
    [sym_class] = STATE(529),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(957),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(5760),
    [sym_true] = ACTIONS(957),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(957),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [4032] = {
    [sym_new_expression] = STATE(528),
    [sym_augmented_assignment_expression] = STATE(528),
    [sym__initializer] = STATE(523),
    [sym_unary_expression] = STATE(528),
    [sym_update_expression] = STATE(528),
    [sym_regex] = STATE(528),
    [sym_meta_property] = STATE(528),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(528),
    [sym_yield_expression] = STATE(528),
    [sym_as_expression] = STATE(528),
    [sym_non_null_expression] = STATE(528),
    [sym_internal_module] = STATE(528),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(528),
    [sym_await_expression] = STATE(528),
    [sym_member_expression] = STATE(161),
    [sym_string] = STATE(528),
    [sym_this] = STATE(528),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(164),
    [sym_anonymous_class] = STATE(528),
    [sym_generator_function] = STATE(528),
    [sym_call_expression] = STATE(528),
    [sym_subscript_expression] = STATE(161),
    [sym_assignment_expression] = STATE(528),
    [sym_ternary_expression] = STATE(528),
    [sym_binary_expression] = STATE(528),
    [sym_template_string] = STATE(528),
    [sym_type_arguments] = STATE(166),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(528),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(528),
    [sym_class] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(953),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(953),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(3897),
    [sym_null] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(955),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [4033] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3759),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3760),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1005),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1009),
    [anon_sym_symbol] = ACTIONS(1009),
    [anon_sym_number] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1009),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1009),
    [anon_sym_private] = ACTIONS(1009),
    [anon_sym_boolean] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_public] = ACTIONS(1009),
    [anon_sym_get] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1009),
    [anon_sym_string] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1009),
    [anon_sym_namespace] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4034] = {
    [sym_statement_block] = STATE(3180),
    [sym__automatic_semicolon] = ACTIONS(7690),
    [anon_sym_RBRACE] = ACTIONS(7690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(7690),
    [anon_sym_COMMA] = ACTIONS(7690),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7690),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [4035] = {
    [sym_call_signature] = STATE(4469),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4036] = {
    [sym_call_signature] = STATE(4469),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(8839),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [4037] = {
    [sym_string] = STATE(4471),
    [sym__property_name] = STATE(4471),
    [sym_computed_property_name] = STATE(4471),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [4038] = {
    [sym_string] = STATE(4471),
    [sym__property_name] = STATE(4471),
    [sym_computed_property_name] = STATE(4471),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(8841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [4039] = {
    [sym_call_signature] = STATE(4469),
    [sym_type_annotation] = STATE(3982),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [sym__automatic_semicolon] = ACTIONS(8046),
    [anon_sym_RBRACE] = ACTIONS(8046),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(8046),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8046),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(8046),
    [sym_comment] = ACTIONS(3),
  },
  [4040] = {
    [sym_new_expression] = STATE(1900),
    [sym_constructor_type] = STATE(4003),
    [sym_augmented_assignment_expression] = STATE(1900),
    [sym_lookup_type] = STATE(1066),
    [sym_unary_expression] = STATE(1900),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_regex] = STATE(1900),
    [sym_call_signature] = STATE(374),
    [sym_yield_expression] = STATE(1900),
    [sym_as_expression] = STATE(1900),
    [sym_internal_module] = STATE(1900),
    [sym_arrow_function] = STATE(1900),
    [sym__primary_type] = STATE(1066),
    [sym_member_expression] = STATE(376),
    [sym_mapped_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_string] = STATE(3412),
    [sym_type_parameters] = STATE(4473),
    [sym_array_type] = STATE(1066),
    [sym_object] = STATE(378),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_generator_function] = STATE(1900),
    [sym_subscript_expression] = STATE(376),
    [sym_type_query] = STATE(1066),
    [sym_ternary_expression] = STATE(1900),
    [sym_existential_type] = STATE(1066),
    [sym_template_string] = STATE(1900),
    [sym_object_type] = STATE(1066),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(4474),
    [sym_intersection_type] = STATE(4003),
    [sym__type] = STATE(4003),
    [sym_index_type_query] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_update_expression] = STATE(1900),
    [sym_meta_property] = STATE(1900),
    [sym_function_type] = STATE(4003),
    [sym__expression] = STATE(1900),
    [sym_non_null_expression] = STATE(1900),
    [sym_nested_identifier] = STATE(1065),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1900),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_this] = STATE(1900),
    [sym_tuple_type] = STATE(1066),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1900),
    [sym_call_expression] = STATE(1900),
    [sym_type_predicate] = STATE(1066),
    [sym_assignment_expression] = STATE(1900),
    [sym__number] = STATE(1048),
    [sym_binary_expression] = STATE(1900),
    [sym_type_arguments] = STATE(379),
    [sym_union_type] = STATE(4003),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_array] = STATE(380),
    [sym_type_assertion] = STATE(1900),
    [sym_class] = STATE(1900),
    [anon_sym_BANG] = ACTIONS(640),
    [sym_identifier] = ACTIONS(6952),
    [sym_false] = ACTIONS(6954),
    [anon_sym_LBRACK] = ACTIONS(6956),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_symbol] = ACTIONS(6958),
    [anon_sym_number] = ACTIONS(6958),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(646),
    [anon_sym_typeof] = ACTIONS(6960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6962),
    [anon_sym_keyof] = ACTIONS(2207),
    [anon_sym_LBRACE] = ACTIONS(6964),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_void] = ACTIONS(6966),
    [anon_sym_PIPE] = ACTIONS(8070),
    [anon_sym_LPAREN] = ACTIONS(6968),
    [sym_null] = ACTIONS(3953),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6958),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_boolean] = ACTIONS(6958),
    [anon_sym_async] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_get] = ACTIONS(646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_this] = ACTIONS(6970),
    [sym_number] = ACTIONS(6972),
    [sym_true] = ACTIONS(6954),
    [anon_sym_yield] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_string] = ACTIONS(6958),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_set] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(8843),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_export] = ACTIONS(646),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(6962),
    [anon_sym_await] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
  },
  [4041] = {
    [sym_identifier] = ACTIONS(8845),
    [sym_comment] = ACTIONS(3),
  },
  [4042] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(3379),
    [sym__automatic_semicolon] = ACTIONS(3379),
    [anon_sym_PERCENT_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_AMP_EQ] = ACTIONS(2065),
    [anon_sym_PLUS_EQ] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2065),
    [anon_sym_STAR_EQ] = ACTIONS(2065),
    [anon_sym_PIPE_EQ] = ACTIONS(2065),
    [anon_sym_DASH_EQ] = ACTIONS(2065),
    [anon_sym_EQ_GT] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2065),
    [anon_sym_GT_GT_EQ] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(8847),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3379),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2071),
  },
  [4043] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(3383),
    [sym__automatic_semicolon] = ACTIONS(3383),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3383),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [4044] = {
    [sym_pair] = STATE(659),
    [aux_sym_export_statement_repeat1] = STATE(2589),
    [sym_object] = STATE(397),
    [sym__property_name] = STATE(1662),
    [sym_assignment_pattern] = STATE(659),
    [sym_method_signature] = STATE(2825),
    [sym_property_signature] = STATE(2825),
    [sym_call_signature] = STATE(2825),
    [sym_construct_signature] = STATE(2825),
    [sym_index_signature] = STATE(2825),
    [sym_export_statement] = STATE(2825),
    [sym_method_definition] = STATE(659),
    [sym_decorator] = STATE(2589),
    [sym_accessibility_modifier] = STATE(1663),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(1662),
    [sym_array] = STATE(399),
    [sym_spread_element] = STATE(659),
    [sym_string] = STATE(1662),
    [sym_type_parameters] = STATE(811),
    [sym_identifier] = ACTIONS(5345),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(5347),
    [anon_sym_symbol] = ACTIONS(5347),
    [anon_sym_number] = ACTIONS(5347),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_declare] = ACTIONS(5347),
    [anon_sym_COMMA] = ACTIONS(1206),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(392),
    [anon_sym_void] = ACTIONS(5347),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(5347),
    [anon_sym_private] = ACTIONS(5349),
    [anon_sym_boolean] = ACTIONS(5347),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(5351),
    [anon_sym_get] = ACTIONS(5353),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_public] = ACTIONS(5349),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(5349),
    [anon_sym_string] = ACTIONS(5347),
    [anon_sym_set] = ACTIONS(5353),
    [anon_sym_type] = ACTIONS(5347),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(5347),
    [anon_sym_export] = ACTIONS(5355),
    [sym_readonly] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(5347),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [4045] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(3303),
    [sym__automatic_semicolon] = ACTIONS(3303),
    [anon_sym_PIPE] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1241),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_EQ] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_BANG_EQ] = ACTIONS(1241),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1241),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_SLASH] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3303),
    [anon_sym_GT_GT] = ACTIONS(1241),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1241),
  },
  [4046] = {
    [sym_formal_parameters] = STATE(4477),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4047] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(8849),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4048] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(8852),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4049] = {
    [sym_type_arguments] = STATE(1937),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(8855),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_is] = ACTIONS(8857),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1475),
  },
  [4050] = {
    [sym_tuple_type] = STATE(1939),
    [sym_index_type_query] = STATE(1939),
    [sym_lookup_type] = STATE(1939),
    [sym_this_type] = STATE(1939),
    [sym_flow_maybe_type] = STATE(1939),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_type_predicate] = STATE(1939),
    [sym_type_query] = STATE(1939),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1939),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1939),
    [sym__primary_type] = STATE(1939),
    [sym_generic_type] = STATE(1939),
    [sym_mapped_type] = STATE(1939),
    [sym_literal_type] = STATE(1939),
    [sym_parenthesized_type] = STATE(1939),
    [sym_predefined_type] = STATE(1939),
    [sym_string] = STATE(1048),
    [sym_array_type] = STATE(1939),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [sym_true] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4051] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4055),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4057),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8148),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8150),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4052] = {
    [sym_formal_parameters] = STATE(4480),
    [sym_type_parameters] = STATE(4481),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4053] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4055),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4057),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8148),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8150),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4054] = {
    [sym__automatic_semicolon] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(8859),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_COMMA] = ACTIONS(3744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3744),
  },
  [4055] = {
    [sym_formal_parameters] = STATE(4484),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4056] = {
    [sym_type_arguments] = STATE(1958),
    [sym__automatic_semicolon] = ACTIONS(1577),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(8863),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(3865),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1577),
  },
  [4057] = {
    [anon_sym_EQ_GT] = ACTIONS(8865),
    [sym_comment] = ACTIONS(3),
  },
  [4058] = {
    [sym_string] = STATE(4471),
    [sym__property_name] = STATE(4471),
    [sym_computed_property_name] = STATE(4471),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [4059] = {
    [sym_string] = STATE(4471),
    [sym__property_name] = STATE(4471),
    [sym_computed_property_name] = STATE(4471),
    [sym__automatic_semicolon] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(8867),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_get] = ACTIONS(8869),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(8841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1198),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(8869),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [4060] = {
    [sym_call_signature] = STATE(4469),
    [sym_type_annotation] = STATE(3982),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [sym__automatic_semicolon] = ACTIONS(8046),
    [anon_sym_RBRACE] = ACTIONS(8046),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(8046),
    [anon_sym_QMARK] = ACTIONS(8871),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8046),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(8046),
    [sym_comment] = ACTIONS(3),
  },
  [4061] = {
    [anon_sym_AMP] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
  },
  [4062] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4063] = {
    [sym_formal_parameters] = STATE(4490),
    [sym_type_parameters] = STATE(4491),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4064] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4065] = {
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(8873),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5196),
  },
  [4066] = {
    [sym_formal_parameters] = STATE(4494),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4067] = {
    [anon_sym_EQ_GT] = ACTIONS(8877),
    [sym_comment] = ACTIONS(3),
  },
  [4068] = {
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(8873),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5204),
  },
  [4069] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4496),
    [sym_constructor_type] = STATE(4496),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(4496),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4496),
    [sym_intersection_type] = STATE(4496),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2621),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2623),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4070] = {
    [anon_sym_EQ_GT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(3),
  },
  [4071] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4498),
    [sym_constructor_type] = STATE(4498),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(4498),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4498),
    [sym_intersection_type] = STATE(4498),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2621),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2623),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4072] = {
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(8873),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5406),
  },
  [4073] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(7000),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(7002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5425),
  },
  [4074] = {
    [anon_sym_EQ_GT] = ACTIONS(8881),
    [sym_comment] = ACTIONS(3),
  },
  [4075] = {
    [sym_formal_parameters] = STATE(4500),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4076] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4077] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4078] = {
    [anon_sym_EQ_GT] = ACTIONS(8883),
    [sym_comment] = ACTIONS(3),
  },
  [4079] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4502),
    [sym_constructor_type] = STATE(4502),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(4502),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4502),
    [sym_intersection_type] = STATE(4502),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4080] = {
    [anon_sym_AMP] = ACTIONS(5453),
    [anon_sym_PIPE] = ACTIONS(5455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6909),
  },
  [4081] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4503),
    [sym_constructor_type] = STATE(4503),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(4503),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4503),
    [sym_intersection_type] = STATE(4503),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(1699),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(1701),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(3512),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4082] = {
    [anon_sym_AMP] = ACTIONS(5453),
    [anon_sym_PIPE] = ACTIONS(5455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6986),
  },
  [4083] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8180),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4084] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4504),
    [sym_constructor_type] = STATE(4504),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1735),
    [sym_function_type] = STATE(4504),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4504),
    [sym_intersection_type] = STATE(4504),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1734),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1736),
    [sym_identifier] = ACTIONS(3573),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4085] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(8180),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4086] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6255),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(8310),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(8310),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2063),
  },
  [4087] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(7180),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(7180),
    [anon_sym_PIPE] = ACTIONS(3668),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_LT_EQ] = ACTIONS(3666),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_instanceof] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3682),
    [anon_sym_STAR_STAR] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3626),
  },
  [4088] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8885),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(8887),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [4089] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8885),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(8887),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [4090] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4505),
    [sym_constructor_type] = STATE(4505),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(4505),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4505),
    [sym_intersection_type] = STATE(4505),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4091] = {
    [anon_sym_EQ_GT] = ACTIONS(8889),
    [sym_comment] = ACTIONS(3),
  },
  [4092] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4507),
    [sym_constructor_type] = STATE(4507),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(4507),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4507),
    [sym_intersection_type] = STATE(4507),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4093] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8885),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(8887),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [4094] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8885),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(8887),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [4095] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(908),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(3652),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(3654),
    [anon_sym_symbol] = ACTIONS(3654),
    [anon_sym_number] = ACTIONS(3654),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3654),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(3654),
    [anon_sym_private] = ACTIONS(3654),
    [anon_sym_boolean] = ACTIONS(3654),
    [anon_sym_async] = ACTIONS(3658),
    [anon_sym_public] = ACTIONS(3654),
    [anon_sym_get] = ACTIONS(3654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3654),
    [anon_sym_string] = ACTIONS(3654),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(3654),
    [anon_sym_type] = ACTIONS(3654),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_import] = ACTIONS(3654),
    [anon_sym_export] = ACTIONS(3654),
    [anon_sym_namespace] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4096] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6249),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(6252),
  },
  [4097] = {
    [sym_identifier] = ACTIONS(8891),
    [sym_comment] = ACTIONS(3),
  },
  [4098] = {
    [sym_type_alias_declaration] = STATE(2047),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2047),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2047),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2047),
    [sym_return_statement] = STATE(2047),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2047),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2047),
    [sym_switch_statement] = STATE(2047),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2047),
    [sym_throw_statement] = STATE(2047),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2047),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2047),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(2047),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2047),
    [sym_abstract_class] = STATE(2047),
    [sym_interface_declaration] = STATE(2047),
    [sym_statement_block] = STATE(2047),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2047),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2047),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2047),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2047),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2047),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2047),
    [sym_empty_statement] = STATE(2047),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(2047),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2047),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2047),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2047),
    [sym_break_statement] = STATE(2047),
    [sym_labeled_statement] = STATE(2047),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2047),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4099] = {
    [sym_array] = STATE(4510),
    [sym_object] = STATE(4511),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(8893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4100] = {
    [anon_sym_of] = ACTIONS(8895),
    [sym_comment] = ACTIONS(3),
  },
  [4101] = {
    [anon_sym_of] = ACTIONS(8897),
    [sym_comment] = ACTIONS(3),
  },
  [4102] = {
    [anon_sym_of] = ACTIONS(8899),
    [sym_comment] = ACTIONS(3),
  },
  [4103] = {
    [sym_new_expression] = STATE(4515),
    [sym_augmented_assignment_expression] = STATE(4515),
    [sym_unary_expression] = STATE(4515),
    [sym_update_expression] = STATE(4515),
    [sym_regex] = STATE(4515),
    [sym_meta_property] = STATE(4515),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(4515),
    [sym_yield_expression] = STATE(4515),
    [sym_as_expression] = STATE(4515),
    [sym_non_null_expression] = STATE(4515),
    [sym_internal_module] = STATE(4515),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4515),
    [sym_await_expression] = STATE(4515),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(4516),
    [sym_string] = STATE(4515),
    [sym_this] = STATE(4515),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4515),
    [sym_generator_function] = STATE(4515),
    [sym_call_expression] = STATE(4515),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4515),
    [sym_ternary_expression] = STATE(4515),
    [sym_binary_expression] = STATE(4515),
    [sym_template_string] = STATE(4515),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4515),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4515),
    [sym_class] = STATE(4515),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(8901),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8901),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(8903),
    [sym_true] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8901),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [4104] = {
    [sym_new_expression] = STATE(4517),
    [sym_augmented_assignment_expression] = STATE(4517),
    [sym_unary_expression] = STATE(4517),
    [sym_update_expression] = STATE(4517),
    [sym_regex] = STATE(4517),
    [sym_meta_property] = STATE(4517),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4517),
    [sym_yield_expression] = STATE(4517),
    [sym_as_expression] = STATE(4517),
    [sym_non_null_expression] = STATE(4517),
    [sym_internal_module] = STATE(4517),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4517),
    [sym_await_expression] = STATE(4517),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4517),
    [sym_this] = STATE(4517),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4517),
    [sym_generator_function] = STATE(4517),
    [sym_call_expression] = STATE(4517),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4517),
    [sym_ternary_expression] = STATE(4517),
    [sym_binary_expression] = STATE(4517),
    [sym_template_string] = STATE(4517),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4517),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4517),
    [sym_class] = STATE(4517),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8905),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8905),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8907),
    [sym_true] = ACTIONS(8905),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8905),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4105] = {
    [sym__initializer] = STATE(405),
    [sym_type_annotation] = STATE(406),
    [sym__automatic_semicolon] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_of] = ACTIONS(8895),
    [anon_sym_COMMA] = ACTIONS(739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8909),
  },
  [4106] = {
    [sym__initializer] = STATE(425),
    [sym_type_annotation] = STATE(426),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(8897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8911),
  },
  [4107] = {
    [sym__initializer] = STATE(427),
    [sym_type_annotation] = STATE(428),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(8899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8913),
  },
  [4108] = {
    [sym_new_expression] = STATE(4522),
    [sym_augmented_assignment_expression] = STATE(4522),
    [sym_unary_expression] = STATE(4522),
    [sym_update_expression] = STATE(4522),
    [sym_regex] = STATE(4522),
    [sym_meta_property] = STATE(4522),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4522),
    [sym_yield_expression] = STATE(4522),
    [sym_as_expression] = STATE(4522),
    [sym_non_null_expression] = STATE(4522),
    [sym_internal_module] = STATE(4522),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4522),
    [sym_await_expression] = STATE(4522),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4523),
    [sym_string] = STATE(4522),
    [sym_this] = STATE(4522),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4522),
    [sym_generator_function] = STATE(4522),
    [sym_call_expression] = STATE(4522),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4522),
    [sym_ternary_expression] = STATE(4522),
    [sym_binary_expression] = STATE(4522),
    [sym_template_string] = STATE(4522),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4522),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4522),
    [sym_class] = STATE(4522),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(8915),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8915),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(8917),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8919),
    [sym_true] = ACTIONS(8915),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8915),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4109] = {
    [sym_new_expression] = STATE(4524),
    [sym_augmented_assignment_expression] = STATE(4524),
    [sym_unary_expression] = STATE(4524),
    [sym_update_expression] = STATE(4524),
    [sym_regex] = STATE(4524),
    [sym_meta_property] = STATE(4524),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4524),
    [sym_yield_expression] = STATE(4524),
    [sym_as_expression] = STATE(4524),
    [sym_non_null_expression] = STATE(4524),
    [sym_internal_module] = STATE(4524),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4524),
    [sym_await_expression] = STATE(4524),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4524),
    [sym_this] = STATE(4524),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4524),
    [sym_generator_function] = STATE(4524),
    [sym_call_expression] = STATE(4524),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4524),
    [sym_ternary_expression] = STATE(4524),
    [sym_binary_expression] = STATE(4524),
    [sym_template_string] = STATE(4524),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4524),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4524),
    [sym_class] = STATE(4524),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8921),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8921),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8923),
    [sym_true] = ACTIONS(8921),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8921),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4110] = {
    [sym_new_expression] = STATE(4525),
    [sym_augmented_assignment_expression] = STATE(4525),
    [sym_unary_expression] = STATE(4525),
    [sym_update_expression] = STATE(4525),
    [sym_regex] = STATE(4525),
    [sym_meta_property] = STATE(4525),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(4525),
    [sym_yield_expression] = STATE(4525),
    [sym_as_expression] = STATE(4525),
    [sym_non_null_expression] = STATE(4525),
    [sym_internal_module] = STATE(4525),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4525),
    [sym_await_expression] = STATE(4525),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(4526),
    [sym_string] = STATE(4525),
    [sym_this] = STATE(4525),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4525),
    [sym_generator_function] = STATE(4525),
    [sym_call_expression] = STATE(4525),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4525),
    [sym_ternary_expression] = STATE(4525),
    [sym_binary_expression] = STATE(4525),
    [sym_template_string] = STATE(4525),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4525),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4525),
    [sym_class] = STATE(4525),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(8925),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8925),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(8927),
    [sym_true] = ACTIONS(8925),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8925),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [4111] = {
    [sym_new_expression] = STATE(4527),
    [sym_augmented_assignment_expression] = STATE(4527),
    [sym_unary_expression] = STATE(4527),
    [sym_update_expression] = STATE(4527),
    [sym_regex] = STATE(4527),
    [sym_meta_property] = STATE(4527),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4527),
    [sym_yield_expression] = STATE(4527),
    [sym_as_expression] = STATE(4527),
    [sym_non_null_expression] = STATE(4527),
    [sym_internal_module] = STATE(4527),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4527),
    [sym_await_expression] = STATE(4527),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4527),
    [sym_this] = STATE(4527),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4527),
    [sym_generator_function] = STATE(4527),
    [sym_call_expression] = STATE(4527),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4527),
    [sym_ternary_expression] = STATE(4527),
    [sym_binary_expression] = STATE(4527),
    [sym_template_string] = STATE(4527),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4527),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4527),
    [sym_class] = STATE(4527),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8929),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8929),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8931),
    [sym_true] = ACTIONS(8929),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8929),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4112] = {
    [sym_new_expression] = STATE(4528),
    [sym_augmented_assignment_expression] = STATE(4528),
    [sym_unary_expression] = STATE(4528),
    [sym_update_expression] = STATE(4528),
    [sym_regex] = STATE(4528),
    [sym_meta_property] = STATE(4528),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(4528),
    [sym_yield_expression] = STATE(4528),
    [sym_as_expression] = STATE(4528),
    [sym_non_null_expression] = STATE(4528),
    [sym_internal_module] = STATE(4528),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4528),
    [sym_await_expression] = STATE(4528),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(4529),
    [sym_string] = STATE(4528),
    [sym_this] = STATE(4528),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4528),
    [sym_generator_function] = STATE(4528),
    [sym_call_expression] = STATE(4528),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4528),
    [sym_ternary_expression] = STATE(4528),
    [sym_binary_expression] = STATE(4528),
    [sym_template_string] = STATE(4528),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4528),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4528),
    [sym_class] = STATE(4528),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(8933),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8933),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(8935),
    [sym_true] = ACTIONS(8933),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8933),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [4113] = {
    [anon_sym_COLON] = ACTIONS(8937),
    [sym_comment] = ACTIONS(3),
  },
  [4114] = {
    [sym_new_expression] = STATE(4531),
    [sym_augmented_assignment_expression] = STATE(4531),
    [sym_unary_expression] = STATE(4531),
    [sym_update_expression] = STATE(4531),
    [sym_regex] = STATE(4531),
    [sym_meta_property] = STATE(4531),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4531),
    [sym_yield_expression] = STATE(4531),
    [sym_as_expression] = STATE(4531),
    [sym_non_null_expression] = STATE(4531),
    [sym_internal_module] = STATE(4531),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4531),
    [sym_await_expression] = STATE(4531),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4531),
    [sym_this] = STATE(4531),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4531),
    [sym_generator_function] = STATE(4531),
    [sym_call_expression] = STATE(4531),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4531),
    [sym_ternary_expression] = STATE(4531),
    [sym_binary_expression] = STATE(4531),
    [sym_template_string] = STATE(4531),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4531),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4531),
    [sym_class] = STATE(4531),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8939),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8939),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8941),
    [sym_true] = ACTIONS(8939),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8939),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4115] = {
    [sym_new_expression] = STATE(4532),
    [sym_augmented_assignment_expression] = STATE(4532),
    [sym_unary_expression] = STATE(4532),
    [sym_update_expression] = STATE(4532),
    [sym_regex] = STATE(4532),
    [sym_meta_property] = STATE(4532),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4532),
    [sym_yield_expression] = STATE(4532),
    [sym_as_expression] = STATE(4532),
    [sym_non_null_expression] = STATE(4532),
    [sym_internal_module] = STATE(4532),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4532),
    [sym_await_expression] = STATE(4532),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4532),
    [sym_this] = STATE(4532),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4532),
    [sym_generator_function] = STATE(4532),
    [sym_call_expression] = STATE(4532),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4532),
    [sym_ternary_expression] = STATE(4532),
    [sym_binary_expression] = STATE(4532),
    [sym_template_string] = STATE(4532),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4532),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4532),
    [sym_class] = STATE(4532),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8943),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8943),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8945),
    [sym_true] = ACTIONS(8943),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8943),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4116] = {
    [sym_new_expression] = STATE(4533),
    [sym_augmented_assignment_expression] = STATE(4533),
    [sym_unary_expression] = STATE(4533),
    [sym_update_expression] = STATE(4533),
    [sym_regex] = STATE(4533),
    [sym_meta_property] = STATE(4533),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4533),
    [sym_yield_expression] = STATE(4533),
    [sym_as_expression] = STATE(4533),
    [sym_non_null_expression] = STATE(4533),
    [sym_internal_module] = STATE(4533),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4533),
    [sym_await_expression] = STATE(4533),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4533),
    [sym_this] = STATE(4533),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4533),
    [sym_generator_function] = STATE(4533),
    [sym_call_expression] = STATE(4533),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4533),
    [sym_ternary_expression] = STATE(4533),
    [sym_binary_expression] = STATE(4533),
    [sym_template_string] = STATE(4533),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4533),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4533),
    [sym_class] = STATE(4533),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(8947),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8947),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(8949),
    [sym_true] = ACTIONS(8947),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(8947),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4117] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8951),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4118] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8953),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4119] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(8955),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4120] = {
    [sym_type_alias_declaration] = STATE(3690),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3690),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3690),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3690),
    [sym_return_statement] = STATE(3690),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3690),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3690),
    [sym_switch_statement] = STATE(3690),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3690),
    [sym_throw_statement] = STATE(3690),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3690),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3690),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(3690),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3690),
    [sym_abstract_class] = STATE(3690),
    [sym_interface_declaration] = STATE(3690),
    [sym_statement_block] = STATE(3690),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3690),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3690),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3690),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3690),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3690),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3690),
    [sym_empty_statement] = STATE(3690),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(3690),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3690),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3690),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3690),
    [sym_break_statement] = STATE(3690),
    [sym_labeled_statement] = STATE(3690),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3690),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4121] = {
    [sym_type_alias_declaration] = STATE(3719),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3719),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3719),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3719),
    [sym_return_statement] = STATE(3719),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3719),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3719),
    [sym_switch_statement] = STATE(3719),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3719),
    [sym_throw_statement] = STATE(3719),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3719),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3719),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(3719),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3719),
    [sym_abstract_class] = STATE(3719),
    [sym_interface_declaration] = STATE(3719),
    [sym_statement_block] = STATE(3719),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3719),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3719),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3719),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3719),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3719),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3719),
    [sym_empty_statement] = STATE(3719),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(3719),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3719),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3719),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3719),
    [sym_break_statement] = STATE(3719),
    [sym_labeled_statement] = STATE(3719),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3719),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4122] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(8957),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4123] = {
    [anon_sym_RPAREN] = ACTIONS(8957),
    [sym_comment] = ACTIONS(3),
  },
  [4124] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(8959),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4125] = {
    [anon_sym_RPAREN] = ACTIONS(8959),
    [sym_comment] = ACTIONS(3),
  },
  [4126] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4127] = {
    [anon_sym_RPAREN] = ACTIONS(8961),
    [sym_comment] = ACTIONS(3),
  },
  [4128] = {
    [sym_type_alias_declaration] = STATE(3724),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3724),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3724),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3724),
    [sym_return_statement] = STATE(3724),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3724),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3724),
    [sym_switch_statement] = STATE(3724),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3724),
    [sym_throw_statement] = STATE(3724),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3724),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3724),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(3724),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3724),
    [sym_abstract_class] = STATE(3724),
    [sym_interface_declaration] = STATE(3724),
    [sym_statement_block] = STATE(3724),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3724),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3724),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3724),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3724),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3724),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3724),
    [sym_empty_statement] = STATE(3724),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(3724),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3724),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3724),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3724),
    [sym_break_statement] = STATE(3724),
    [sym_labeled_statement] = STATE(3724),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3724),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4129] = {
    [sym_type_alias_declaration] = STATE(3725),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3725),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3725),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3725),
    [sym_return_statement] = STATE(3725),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3725),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3725),
    [sym_switch_statement] = STATE(3725),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3725),
    [sym_throw_statement] = STATE(3725),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3725),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3725),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(3725),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3725),
    [sym_abstract_class] = STATE(3725),
    [sym_interface_declaration] = STATE(3725),
    [sym_statement_block] = STATE(3725),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3725),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3725),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3725),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3725),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3725),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3725),
    [sym_empty_statement] = STATE(3725),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(3725),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3725),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3725),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3725),
    [sym_break_statement] = STATE(3725),
    [sym_labeled_statement] = STATE(3725),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3725),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4130] = {
    [sym_type_alias_declaration] = STATE(3726),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3726),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3726),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3726),
    [sym_return_statement] = STATE(3726),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3726),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3726),
    [sym_switch_statement] = STATE(3726),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3726),
    [sym_throw_statement] = STATE(3726),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3726),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3726),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(3726),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3726),
    [sym_abstract_class] = STATE(3726),
    [sym_interface_declaration] = STATE(3726),
    [sym_statement_block] = STATE(3726),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3726),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3726),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3726),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3726),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3726),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3726),
    [sym_empty_statement] = STATE(3726),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(3726),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3726),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3726),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3726),
    [sym_break_statement] = STATE(3726),
    [sym_labeled_statement] = STATE(3726),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3726),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4131] = {
    [sym_type_alias_declaration] = STATE(3727),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3727),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3727),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3727),
    [sym_return_statement] = STATE(3727),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3727),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3727),
    [sym_switch_statement] = STATE(3727),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3727),
    [sym_throw_statement] = STATE(3727),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3727),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3727),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(3727),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3727),
    [sym_abstract_class] = STATE(3727),
    [sym_interface_declaration] = STATE(3727),
    [sym_statement_block] = STATE(3727),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3727),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3727),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3727),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3727),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3727),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3727),
    [sym_empty_statement] = STATE(3727),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(3727),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3727),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3727),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3727),
    [sym_break_statement] = STATE(3727),
    [sym_labeled_statement] = STATE(3727),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3727),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4132] = {
    [sym_type_alias_declaration] = STATE(3728),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3728),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3728),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3728),
    [sym_return_statement] = STATE(3728),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3728),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3728),
    [sym_switch_statement] = STATE(3728),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3728),
    [sym_throw_statement] = STATE(3728),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3728),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3728),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(3728),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3728),
    [sym_abstract_class] = STATE(3728),
    [sym_interface_declaration] = STATE(3728),
    [sym_statement_block] = STATE(3728),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3728),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3728),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3728),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3728),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3728),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3728),
    [sym_empty_statement] = STATE(3728),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(3728),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3728),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3728),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3728),
    [sym_break_statement] = STATE(3728),
    [sym_labeled_statement] = STATE(3728),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3728),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4133] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_is] = ACTIONS(8963),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8965),
  },
  [4134] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4135] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4139),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4141),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4136] = {
    [sym_formal_parameters] = STATE(4542),
    [sym_type_parameters] = STATE(4543),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4137] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4139),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4141),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4138] = {
    [anon_sym_AMP] = ACTIONS(8967),
    [anon_sym_PIPE] = ACTIONS(8969),
    [anon_sym_while] = ACTIONS(7735),
    [sym_comment] = ACTIONS(3),
  },
  [4139] = {
    [sym_formal_parameters] = STATE(4546),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4140] = {
    [sym_type_arguments] = STATE(850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_while] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(8971),
  },
  [4141] = {
    [anon_sym_EQ_GT] = ACTIONS(8973),
    [sym_comment] = ACTIONS(3),
  },
  [4142] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4549),
    [sym_constructor_type] = STATE(4549),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(4549),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4549),
    [sym_intersection_type] = STATE(4549),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4143] = {
    [anon_sym_EQ_GT] = ACTIONS(8975),
    [sym_comment] = ACTIONS(3),
  },
  [4144] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4551),
    [sym_constructor_type] = STATE(4551),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(4551),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4551),
    [sym_intersection_type] = STATE(4551),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4145] = {
    [anon_sym_EQ_GT] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(7145),
    [anon_sym_PIPE] = ACTIONS(7147),
    [sym_comment] = ACTIONS(3),
  },
  [4146] = {
    [anon_sym_EQ_GT] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_PIPE] = ACTIONS(3748),
    [sym_comment] = ACTIONS(3),
  },
  [4147] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3805),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3807),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3809),
    [anon_sym_AMP_AMP] = ACTIONS(3815),
    [anon_sym_BANG_EQ] = ACTIONS(3765),
    [anon_sym_LT_EQ] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_PERCENT] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(3819),
    [anon_sym_as] = ACTIONS(3823),
    [anon_sym_PIPE_PIPE] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(3765),
    [anon_sym_instanceof] = ACTIONS(3805),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7180),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_STAR_STAR] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3805),
    [anon_sym_in] = ACTIONS(3765),
  },
  [4148] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8977),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(8979),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5196),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [4149] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8977),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(8979),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5204),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [4150] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4552),
    [sym_constructor_type] = STATE(4552),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(4552),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4552),
    [sym_intersection_type] = STATE(4552),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4151] = {
    [anon_sym_EQ_GT] = ACTIONS(8981),
    [sym_comment] = ACTIONS(3),
  },
  [4152] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4554),
    [sym_constructor_type] = STATE(4554),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(4554),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4554),
    [sym_intersection_type] = STATE(4554),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4153] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8977),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(8979),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5406),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [4154] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8977),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(8979),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5425),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [4155] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(962),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(3791),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(3793),
    [anon_sym_symbol] = ACTIONS(3793),
    [anon_sym_number] = ACTIONS(3793),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3793),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3795),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3793),
    [anon_sym_private] = ACTIONS(3793),
    [anon_sym_boolean] = ACTIONS(3793),
    [anon_sym_async] = ACTIONS(3797),
    [anon_sym_public] = ACTIONS(3793),
    [anon_sym_get] = ACTIONS(3793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3793),
    [anon_sym_string] = ACTIONS(3793),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(3793),
    [anon_sym_type] = ACTIONS(3793),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(3793),
    [anon_sym_export] = ACTIONS(3793),
    [anon_sym_namespace] = ACTIONS(3799),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4156] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5397),
    [anon_sym_LBRACK] = ACTIONS(5397),
    [anon_sym_BANG] = ACTIONS(5395),
    [anon_sym_SEMI] = ACTIONS(5397),
    [anon_sym_BQUOTE] = ACTIONS(5397),
    [sym__automatic_semicolon] = ACTIONS(5397),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_COMMA] = ACTIONS(5397),
    [anon_sym_LT_LT] = ACTIONS(5397),
    [anon_sym_STAR] = ACTIONS(5395),
    [anon_sym_GT_GT_GT] = ACTIONS(5397),
    [anon_sym_AMP_AMP] = ACTIONS(5397),
    [anon_sym_DASH] = ACTIONS(5395),
    [anon_sym_BANG_EQ] = ACTIONS(5395),
    [anon_sym_LT_EQ] = ACTIONS(5397),
    [anon_sym_LPAREN] = ACTIONS(5397),
    [anon_sym_GT_EQ] = ACTIONS(5397),
    [anon_sym_GT] = ACTIONS(5395),
    [anon_sym_AMP] = ACTIONS(5395),
    [anon_sym_PERCENT] = ACTIONS(5397),
    [anon_sym_QMARK] = ACTIONS(5397),
    [anon_sym_RBRACE] = ACTIONS(5397),
    [anon_sym_as] = ACTIONS(5397),
    [anon_sym_PIPE_PIPE] = ACTIONS(5397),
    [anon_sym_DASH_DASH] = ACTIONS(5397),
    [anon_sym_EQ_EQ] = ACTIONS(5395),
    [anon_sym_instanceof] = ACTIONS(5397),
    [anon_sym_LT] = ACTIONS(5395),
    [anon_sym_RPAREN] = ACTIONS(5397),
    [anon_sym_SLASH] = ACTIONS(5395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5397),
    [anon_sym_CARET] = ACTIONS(5397),
    [anon_sym_STAR_STAR] = ACTIONS(5397),
    [anon_sym_PLUS] = ACTIONS(5395),
    [anon_sym_GT_GT] = ACTIONS(5395),
    [anon_sym_PLUS_PLUS] = ACTIONS(5397),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5397),
    [anon_sym_in] = ACTIONS(5395),
  },
  [4157] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1675),
    [sym_constructor_type] = STATE(1675),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1675),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1675),
    [sym_intersection_type] = STATE(1675),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(8983),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_boolean] = ACTIONS(472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_this] = ACTIONS(474),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [4158] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8034),
    [anon_sym_LBRACK] = ACTIONS(8034),
    [anon_sym_BANG] = ACTIONS(8032),
    [anon_sym_SEMI] = ACTIONS(8034),
    [anon_sym_BQUOTE] = ACTIONS(8034),
    [sym__automatic_semicolon] = ACTIONS(8034),
    [anon_sym_PIPE] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8034),
    [anon_sym_LT_LT] = ACTIONS(8034),
    [anon_sym_STAR] = ACTIONS(8032),
    [anon_sym_GT_GT_GT] = ACTIONS(8034),
    [anon_sym_AMP_AMP] = ACTIONS(8034),
    [anon_sym_DASH] = ACTIONS(8032),
    [anon_sym_BANG_EQ] = ACTIONS(8032),
    [anon_sym_LT_EQ] = ACTIONS(8034),
    [anon_sym_LPAREN] = ACTIONS(8034),
    [anon_sym_GT_EQ] = ACTIONS(8034),
    [anon_sym_GT] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8034),
    [anon_sym_QMARK] = ACTIONS(8034),
    [anon_sym_RBRACE] = ACTIONS(8034),
    [anon_sym_as] = ACTIONS(8034),
    [anon_sym_PIPE_PIPE] = ACTIONS(8034),
    [anon_sym_DASH_DASH] = ACTIONS(8034),
    [anon_sym_EQ_EQ] = ACTIONS(8032),
    [anon_sym_instanceof] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8034),
    [anon_sym_CARET] = ACTIONS(8034),
    [anon_sym_STAR_STAR] = ACTIONS(8034),
    [anon_sym_PLUS] = ACTIONS(8032),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8034),
    [anon_sym_GT_GT] = ACTIONS(8032),
    [anon_sym_PLUS_PLUS] = ACTIONS(8034),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8034),
    [anon_sym_in] = ACTIONS(8032),
  },
  [4159] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(8985),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8985),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [4160] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(7184),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(7186),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4161] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(8989),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4162] = {
    [sym_formal_parameters] = STATE(4557),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4163] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(8992),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4164] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(8995),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4165] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6255),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(6255),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(8310),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_RPAREN] = ACTIONS(6255),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2063),
  },
  [4166] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8325),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(8327),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4167] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4558),
    [sym_constructor_type] = STATE(4558),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1919),
    [sym_function_type] = STATE(4558),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4558),
    [sym_intersection_type] = STATE(4558),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1918),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1920),
    [sym_identifier] = ACTIONS(4006),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4168] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8325),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(8327),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4169] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4559),
    [sym_constructor_type] = STATE(4559),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(4559),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4559),
    [sym_intersection_type] = STATE(4559),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4170] = {
    [anon_sym_EQ_GT] = ACTIONS(8998),
    [sym_comment] = ACTIONS(3),
  },
  [4171] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4561),
    [sym_constructor_type] = STATE(4561),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(4561),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4561),
    [sym_intersection_type] = STATE(4561),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4172] = {
    [anon_sym_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(7253),
    [anon_sym_SEMI] = ACTIONS(5425),
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(7255),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [4173] = {
    [anon_sym_EQ] = ACTIONS(5397),
    [anon_sym_LBRACK] = ACTIONS(5397),
    [anon_sym_AMP] = ACTIONS(5397),
    [anon_sym_SEMI] = ACTIONS(5397),
    [sym__automatic_semicolon] = ACTIONS(5397),
    [anon_sym_RBRACE] = ACTIONS(5397),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5397),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_COMMA] = ACTIONS(5397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5397),
  },
  [4174] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1675),
    [sym_constructor_type] = STATE(1675),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1675),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1675),
    [sym_intersection_type] = STATE(1675),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(9000),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_boolean] = ACTIONS(472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_this] = ACTIONS(474),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [4175] = {
    [anon_sym_EQ] = ACTIONS(8034),
    [anon_sym_LBRACK] = ACTIONS(8034),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_SEMI] = ACTIONS(8034),
    [sym__automatic_semicolon] = ACTIONS(8034),
    [anon_sym_RBRACE] = ACTIONS(8034),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8034),
    [anon_sym_PIPE] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8034),
  },
  [4176] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(9002),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9002),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [4177] = {
    [anon_sym_EQ] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(4063),
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(4065),
    [sym_comment] = ACTIONS(3),
  },
  [4178] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4564),
    [sym_constructor_type] = STATE(4564),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(4564),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4564),
    [sym_intersection_type] = STATE(4564),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4179] = {
    [anon_sym_EQ_GT] = ACTIONS(9004),
    [sym_comment] = ACTIONS(3),
  },
  [4180] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4566),
    [sym_constructor_type] = STATE(4566),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(4566),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4566),
    [sym_intersection_type] = STATE(4566),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4181] = {
    [anon_sym_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(7277),
    [anon_sym_PIPE] = ACTIONS(7279),
    [sym_comment] = ACTIONS(3),
  },
  [4182] = {
    [anon_sym_EQ] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4103),
    [sym_comment] = ACTIONS(3),
  },
  [4183] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8347),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4184] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4567),
    [sym_constructor_type] = STATE(4567),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(1993),
    [sym_function_type] = STATE(4567),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4567),
    [sym_intersection_type] = STATE(4567),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(1992),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(1994),
    [sym_identifier] = ACTIONS(4168),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4172),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4185] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8347),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4186] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4257),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_LT_LT] = ACTIONS(4259),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(9006),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_GT_GT_GT] = ACTIONS(4259),
    [anon_sym_DASH] = ACTIONS(4263),
    [anon_sym_BANG_EQ] = ACTIONS(4211),
    [anon_sym_LT_EQ] = ACTIONS(4255),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(4255),
    [anon_sym_GT] = ACTIONS(4211),
    [anon_sym_AMP] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_QMARK] = ACTIONS(4273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7180),
    [anon_sym_as] = ACTIONS(4277),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4211),
    [anon_sym_instanceof] = ACTIONS(4255),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_STAR_STAR] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4263),
    [anon_sym_GT_GT] = ACTIONS(4269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4255),
    [anon_sym_in] = ACTIONS(4211),
  },
  [4187] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9008),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_LBRACE] = ACTIONS(7182),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(9010),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [4188] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9008),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_LBRACE] = ACTIONS(7197),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(9010),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [4189] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4568),
    [sym_constructor_type] = STATE(4568),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(4568),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4568),
    [sym_intersection_type] = STATE(4568),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4190] = {
    [anon_sym_EQ_GT] = ACTIONS(9012),
    [sym_comment] = ACTIONS(3),
  },
  [4191] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4570),
    [sym_constructor_type] = STATE(4570),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(4570),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4570),
    [sym_intersection_type] = STATE(4570),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4192] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9008),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_LBRACE] = ACTIONS(7207),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(9010),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [4193] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9008),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(9010),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [4194] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(1134),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4241),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4243),
    [anon_sym_symbol] = ACTIONS(4243),
    [anon_sym_number] = ACTIONS(4243),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4243),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4245),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4243),
    [anon_sym_private] = ACTIONS(4243),
    [anon_sym_boolean] = ACTIONS(4243),
    [anon_sym_async] = ACTIONS(4247),
    [anon_sym_public] = ACTIONS(4243),
    [anon_sym_get] = ACTIONS(4243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4243),
    [anon_sym_string] = ACTIONS(4243),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(4243),
    [anon_sym_type] = ACTIONS(4243),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(4243),
    [anon_sym_export] = ACTIONS(4243),
    [anon_sym_namespace] = ACTIONS(4249),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4195] = {
    [sym_new_expression] = STATE(4571),
    [sym_augmented_assignment_expression] = STATE(4571),
    [sym_unary_expression] = STATE(4571),
    [sym_update_expression] = STATE(4571),
    [sym_regex] = STATE(4571),
    [sym_meta_property] = STATE(4571),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4571),
    [sym_yield_expression] = STATE(4571),
    [sym_as_expression] = STATE(4571),
    [sym_non_null_expression] = STATE(4571),
    [sym_internal_module] = STATE(4571),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4571),
    [sym_await_expression] = STATE(4571),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4571),
    [sym_this] = STATE(4571),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4571),
    [sym_generator_function] = STATE(4571),
    [sym_call_expression] = STATE(4571),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4571),
    [sym_ternary_expression] = STATE(4571),
    [sym_binary_expression] = STATE(4571),
    [sym_template_string] = STATE(4571),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4571),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4571),
    [sym_class] = STATE(4571),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9014),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9014),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9016),
    [sym_true] = ACTIONS(9014),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9014),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4196] = {
    [sym_new_expression] = STATE(4572),
    [sym_augmented_assignment_expression] = STATE(4572),
    [sym_unary_expression] = STATE(4572),
    [sym_update_expression] = STATE(4572),
    [sym_regex] = STATE(4572),
    [sym_meta_property] = STATE(4572),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4572),
    [sym_yield_expression] = STATE(4572),
    [sym_as_expression] = STATE(4572),
    [sym_non_null_expression] = STATE(4572),
    [sym_internal_module] = STATE(4572),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4572),
    [sym_await_expression] = STATE(4572),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4572),
    [sym_this] = STATE(4572),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4572),
    [sym_generator_function] = STATE(4572),
    [sym_call_expression] = STATE(4572),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4572),
    [sym_ternary_expression] = STATE(4572),
    [sym_binary_expression] = STATE(4572),
    [sym_template_string] = STATE(4572),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4572),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4572),
    [sym_class] = STATE(4572),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9018),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9018),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9020),
    [sym_true] = ACTIONS(9018),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9018),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4197] = {
    [sym_new_expression] = STATE(4573),
    [sym_augmented_assignment_expression] = STATE(4573),
    [sym_unary_expression] = STATE(4573),
    [sym_update_expression] = STATE(4573),
    [sym_regex] = STATE(4573),
    [sym_meta_property] = STATE(4573),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4573),
    [sym_yield_expression] = STATE(4573),
    [sym_as_expression] = STATE(4573),
    [sym_non_null_expression] = STATE(4573),
    [sym_internal_module] = STATE(4573),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4573),
    [sym_await_expression] = STATE(4573),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4573),
    [sym_this] = STATE(4573),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4573),
    [sym_generator_function] = STATE(4573),
    [sym_call_expression] = STATE(4573),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4573),
    [sym_ternary_expression] = STATE(4573),
    [sym_binary_expression] = STATE(4573),
    [sym_template_string] = STATE(4573),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4573),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4573),
    [sym_class] = STATE(4573),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9022),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9022),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9024),
    [sym_true] = ACTIONS(9022),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9022),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4198] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9026),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4199] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9028),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4200] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9030),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4201] = {
    [sym_type_alias_declaration] = STATE(3690),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3690),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3690),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3690),
    [sym_return_statement] = STATE(3690),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3690),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3690),
    [sym_switch_statement] = STATE(3690),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3690),
    [sym_throw_statement] = STATE(3690),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3690),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3690),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(3690),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3690),
    [sym_abstract_class] = STATE(3690),
    [sym_interface_declaration] = STATE(3690),
    [sym_statement_block] = STATE(3690),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3690),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3690),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3690),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3690),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3690),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3690),
    [sym_empty_statement] = STATE(3690),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(3690),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3690),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3690),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3690),
    [sym_break_statement] = STATE(3690),
    [sym_labeled_statement] = STATE(3690),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3690),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4202] = {
    [sym_type_alias_declaration] = STATE(3719),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3719),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3719),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3719),
    [sym_return_statement] = STATE(3719),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3719),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3719),
    [sym_switch_statement] = STATE(3719),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3719),
    [sym_throw_statement] = STATE(3719),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3719),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3719),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(3719),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3719),
    [sym_abstract_class] = STATE(3719),
    [sym_interface_declaration] = STATE(3719),
    [sym_statement_block] = STATE(3719),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3719),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3719),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3719),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3719),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3719),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3719),
    [sym_empty_statement] = STATE(3719),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(3719),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3719),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3719),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3719),
    [sym_break_statement] = STATE(3719),
    [sym_labeled_statement] = STATE(3719),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3719),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4203] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9032),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4204] = {
    [anon_sym_RPAREN] = ACTIONS(9032),
    [sym_comment] = ACTIONS(3),
  },
  [4205] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9034),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4206] = {
    [anon_sym_RPAREN] = ACTIONS(9034),
    [sym_comment] = ACTIONS(3),
  },
  [4207] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9036),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4208] = {
    [anon_sym_RPAREN] = ACTIONS(9036),
    [sym_comment] = ACTIONS(3),
  },
  [4209] = {
    [sym_type_alias_declaration] = STATE(3724),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3724),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3724),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3724),
    [sym_return_statement] = STATE(3724),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3724),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3724),
    [sym_switch_statement] = STATE(3724),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3724),
    [sym_throw_statement] = STATE(3724),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3724),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3724),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(3724),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3724),
    [sym_abstract_class] = STATE(3724),
    [sym_interface_declaration] = STATE(3724),
    [sym_statement_block] = STATE(3724),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3724),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3724),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3724),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3724),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3724),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3724),
    [sym_empty_statement] = STATE(3724),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(3724),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3724),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3724),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3724),
    [sym_break_statement] = STATE(3724),
    [sym_labeled_statement] = STATE(3724),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3724),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4210] = {
    [sym_type_alias_declaration] = STATE(3725),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3725),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3725),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3725),
    [sym_return_statement] = STATE(3725),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3725),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3725),
    [sym_switch_statement] = STATE(3725),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3725),
    [sym_throw_statement] = STATE(3725),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3725),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3725),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(3725),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3725),
    [sym_abstract_class] = STATE(3725),
    [sym_interface_declaration] = STATE(3725),
    [sym_statement_block] = STATE(3725),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3725),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3725),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3725),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3725),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3725),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3725),
    [sym_empty_statement] = STATE(3725),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(3725),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3725),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3725),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3725),
    [sym_break_statement] = STATE(3725),
    [sym_labeled_statement] = STATE(3725),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3725),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4211] = {
    [sym_type_alias_declaration] = STATE(3726),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3726),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3726),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3726),
    [sym_return_statement] = STATE(3726),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3726),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3726),
    [sym_switch_statement] = STATE(3726),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3726),
    [sym_throw_statement] = STATE(3726),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3726),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3726),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(3726),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3726),
    [sym_abstract_class] = STATE(3726),
    [sym_interface_declaration] = STATE(3726),
    [sym_statement_block] = STATE(3726),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3726),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3726),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3726),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3726),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3726),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3726),
    [sym_empty_statement] = STATE(3726),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(3726),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3726),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3726),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3726),
    [sym_break_statement] = STATE(3726),
    [sym_labeled_statement] = STATE(3726),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3726),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4212] = {
    [sym_type_alias_declaration] = STATE(3727),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3727),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3727),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3727),
    [sym_return_statement] = STATE(3727),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3727),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3727),
    [sym_switch_statement] = STATE(3727),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3727),
    [sym_throw_statement] = STATE(3727),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3727),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3727),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(3727),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3727),
    [sym_abstract_class] = STATE(3727),
    [sym_interface_declaration] = STATE(3727),
    [sym_statement_block] = STATE(3727),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3727),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3727),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3727),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3727),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3727),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3727),
    [sym_empty_statement] = STATE(3727),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(3727),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3727),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3727),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3727),
    [sym_break_statement] = STATE(3727),
    [sym_labeled_statement] = STATE(3727),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3727),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4213] = {
    [sym_type_alias_declaration] = STATE(3728),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3728),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3728),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3728),
    [sym_return_statement] = STATE(3728),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3728),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3728),
    [sym_switch_statement] = STATE(3728),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3728),
    [sym_throw_statement] = STATE(3728),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3728),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3728),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(3728),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3728),
    [sym_abstract_class] = STATE(3728),
    [sym_interface_declaration] = STATE(3728),
    [sym_statement_block] = STATE(3728),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3728),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3728),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3728),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3728),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3728),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3728),
    [sym_empty_statement] = STATE(3728),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(3728),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3728),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3728),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3728),
    [sym_break_statement] = STATE(3728),
    [sym_labeled_statement] = STATE(3728),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3728),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4214] = {
    [sym_type_arguments] = STATE(791),
    [sym_identifier] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_debugger] = ACTIONS(3834),
    [anon_sym_symbol] = ACTIONS(3834),
    [anon_sym_AT] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_void] = ACTIONS(3834),
    [anon_sym_break] = ACTIONS(3834),
    [anon_sym_const] = ACTIONS(3834),
    [sym_super] = ACTIONS(3834),
    [anon_sym_return] = ACTIONS(3834),
    [anon_sym_private] = ACTIONS(3834),
    [anon_sym_get] = ACTIONS(3834),
    [anon_sym_interface] = ACTIONS(3834),
    [anon_sym_enum] = ACTIONS(3834),
    [anon_sym_delete] = ACTIONS(3834),
    [anon_sym_continue] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(3834),
    [anon_sym_this] = ACTIONS(3834),
    [anon_sym_yield] = ACTIONS(3834),
    [sym_true] = ACTIONS(3834),
    [anon_sym_throw] = ACTIONS(3834),
    [anon_sym_protected] = ACTIONS(3834),
    [anon_sym_abstract] = ACTIONS(3834),
    [anon_sym_DOT] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3834),
    [anon_sym_type] = ACTIONS(3834),
    [anon_sym_import] = ACTIONS(3834),
    [anon_sym_namespace] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_await] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [anon_sym_else] = ACTIONS(3834),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_for] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [sym_false] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(3834),
    [anon_sym_number] = ACTIONS(3834),
    [anon_sym_class] = ACTIONS(3834),
    [anon_sym_declare] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3834),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(9038),
    [anon_sym_switch] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [sym_null] = ACTIONS(3834),
    [anon_sym_any] = ACTIONS(3834),
    [anon_sym_boolean] = ACTIONS(3834),
    [anon_sym_async] = ACTIONS(3834),
    [anon_sym_public] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_var] = ACTIONS(3834),
    [anon_sym_while] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(3834),
    [anon_sym_LT] = ACTIONS(7728),
    [sym_number] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3834),
    [anon_sym_function] = ACTIONS(3834),
    [sym_undefined] = ACTIONS(3834),
    [anon_sym_new] = ACTIONS(3834),
    [ts_builtin_sym_end] = ACTIONS(1475),
    [anon_sym_let] = ACTIONS(3834),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_export] = ACTIONS(3834),
    [anon_sym_do] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_with] = ACTIONS(3834),
    [anon_sym_in] = ACTIONS(9040),
  },
  [4215] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4216] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4217] = {
    [sym_formal_parameters] = STATE(4582),
    [sym_type_parameters] = STATE(4583),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4218] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4219] = {
    [sym_identifier] = ACTIONS(7733),
    [anon_sym_BQUOTE] = ACTIONS(7735),
    [anon_sym_debugger] = ACTIONS(7733),
    [anon_sym_symbol] = ACTIONS(7733),
    [anon_sym_AT] = ACTIONS(7735),
    [anon_sym_PIPE] = ACTIONS(9042),
    [anon_sym_DASH] = ACTIONS(7733),
    [anon_sym_void] = ACTIONS(7733),
    [anon_sym_break] = ACTIONS(7733),
    [anon_sym_const] = ACTIONS(7733),
    [sym_super] = ACTIONS(7733),
    [anon_sym_return] = ACTIONS(7733),
    [anon_sym_private] = ACTIONS(7733),
    [anon_sym_get] = ACTIONS(7733),
    [anon_sym_interface] = ACTIONS(7733),
    [anon_sym_enum] = ACTIONS(7733),
    [anon_sym_delete] = ACTIONS(7733),
    [anon_sym_continue] = ACTIONS(7733),
    [anon_sym_DASH_DASH] = ACTIONS(7735),
    [anon_sym_if] = ACTIONS(7733),
    [anon_sym_this] = ACTIONS(7733),
    [anon_sym_yield] = ACTIONS(7733),
    [sym_true] = ACTIONS(7733),
    [anon_sym_throw] = ACTIONS(7733),
    [anon_sym_protected] = ACTIONS(7733),
    [anon_sym_abstract] = ACTIONS(7733),
    [anon_sym_set] = ACTIONS(7733),
    [anon_sym_type] = ACTIONS(7733),
    [anon_sym_import] = ACTIONS(7733),
    [anon_sym_namespace] = ACTIONS(7733),
    [anon_sym_PLUS_PLUS] = ACTIONS(7735),
    [anon_sym_await] = ACTIONS(7733),
    [anon_sym_DQUOTE] = ACTIONS(7735),
    [anon_sym_else] = ACTIONS(7733),
    [anon_sym_BANG] = ACTIONS(7735),
    [anon_sym_for] = ACTIONS(7733),
    [anon_sym_LBRACK] = ACTIONS(7735),
    [sym_false] = ACTIONS(7733),
    [anon_sym_SEMI] = ACTIONS(7735),
    [anon_sym_module] = ACTIONS(7733),
    [anon_sym_number] = ACTIONS(7733),
    [anon_sym_class] = ACTIONS(7733),
    [anon_sym_declare] = ACTIONS(7733),
    [anon_sym_typeof] = ACTIONS(7733),
    [anon_sym_LBRACE] = ACTIONS(7735),
    [anon_sym_switch] = ACTIONS(7733),
    [anon_sym_LPAREN] = ACTIONS(7735),
    [sym_null] = ACTIONS(7733),
    [anon_sym_any] = ACTIONS(7733),
    [anon_sym_boolean] = ACTIONS(7733),
    [anon_sym_async] = ACTIONS(7733),
    [anon_sym_public] = ACTIONS(7733),
    [anon_sym_AMP] = ACTIONS(9044),
    [anon_sym_var] = ACTIONS(7733),
    [anon_sym_while] = ACTIONS(7733),
    [anon_sym_SQUOTE] = ACTIONS(7735),
    [anon_sym_try] = ACTIONS(7733),
    [anon_sym_LT] = ACTIONS(7735),
    [sym_number] = ACTIONS(7735),
    [anon_sym_SLASH] = ACTIONS(7733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7733),
    [anon_sym_function] = ACTIONS(7733),
    [sym_undefined] = ACTIONS(7733),
    [anon_sym_new] = ACTIONS(7733),
    [ts_builtin_sym_end] = ACTIONS(7735),
    [anon_sym_let] = ACTIONS(7733),
    [anon_sym_PLUS] = ACTIONS(7733),
    [anon_sym_export] = ACTIONS(7733),
    [anon_sym_do] = ACTIONS(7733),
    [anon_sym_TILDE] = ACTIONS(7735),
    [anon_sym_with] = ACTIONS(7733),
  },
  [4220] = {
    [sym_formal_parameters] = STATE(4586),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4221] = {
    [sym_type_arguments] = STATE(850),
    [sym_identifier] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_debugger] = ACTIONS(3865),
    [anon_sym_symbol] = ACTIONS(3865),
    [anon_sym_AT] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_void] = ACTIONS(3865),
    [anon_sym_break] = ACTIONS(3865),
    [anon_sym_const] = ACTIONS(3865),
    [sym_super] = ACTIONS(3865),
    [anon_sym_return] = ACTIONS(3865),
    [anon_sym_private] = ACTIONS(3865),
    [anon_sym_get] = ACTIONS(3865),
    [anon_sym_interface] = ACTIONS(3865),
    [anon_sym_enum] = ACTIONS(3865),
    [anon_sym_delete] = ACTIONS(3865),
    [anon_sym_continue] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_if] = ACTIONS(3865),
    [anon_sym_this] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3865),
    [sym_true] = ACTIONS(3865),
    [anon_sym_throw] = ACTIONS(3865),
    [anon_sym_protected] = ACTIONS(3865),
    [anon_sym_abstract] = ACTIONS(3865),
    [anon_sym_set] = ACTIONS(3865),
    [anon_sym_type] = ACTIONS(3865),
    [anon_sym_import] = ACTIONS(3865),
    [anon_sym_namespace] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_await] = ACTIONS(3865),
    [anon_sym_DQUOTE] = ACTIONS(1577),
    [anon_sym_else] = ACTIONS(3865),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [sym_false] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(3865),
    [anon_sym_number] = ACTIONS(3865),
    [anon_sym_class] = ACTIONS(3865),
    [anon_sym_declare] = ACTIONS(3865),
    [anon_sym_typeof] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_switch] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [sym_null] = ACTIONS(3865),
    [anon_sym_any] = ACTIONS(3865),
    [anon_sym_boolean] = ACTIONS(3865),
    [anon_sym_async] = ACTIONS(3865),
    [anon_sym_public] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_var] = ACTIONS(3865),
    [anon_sym_while] = ACTIONS(3865),
    [anon_sym_SQUOTE] = ACTIONS(1577),
    [anon_sym_try] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(7741),
    [sym_number] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3865),
    [sym_undefined] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3865),
    [ts_builtin_sym_end] = ACTIONS(1577),
    [anon_sym_let] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_export] = ACTIONS(3865),
    [anon_sym_do] = ACTIONS(3865),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_with] = ACTIONS(3865),
    [anon_sym_in] = ACTIONS(9046),
  },
  [4222] = {
    [anon_sym_EQ_GT] = ACTIONS(9048),
    [sym_comment] = ACTIONS(3),
  },
  [4223] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4589),
    [sym_constructor_type] = STATE(4589),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(4589),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4589),
    [sym_intersection_type] = STATE(4589),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4224] = {
    [anon_sym_EQ_GT] = ACTIONS(9050),
    [sym_comment] = ACTIONS(3),
  },
  [4225] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4591),
    [sym_constructor_type] = STATE(4591),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(4591),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4591),
    [sym_intersection_type] = STATE(4591),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4226] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(7392),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(7394),
    [sym_comment] = ACTIONS(3),
  },
  [4227] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(4321),
    [anon_sym_PIPE] = ACTIONS(4323),
    [anon_sym_SEMI] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4228] = {
    [sym_type_alias_declaration] = STATE(4592),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4592),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4592),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4592),
    [sym_return_statement] = STATE(4592),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4592),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4592),
    [sym_switch_statement] = STATE(4592),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4592),
    [sym_throw_statement] = STATE(4592),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4592),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4592),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(4592),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4592),
    [sym_abstract_class] = STATE(4592),
    [sym_interface_declaration] = STATE(4592),
    [sym_statement_block] = STATE(4592),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4592),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4592),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4592),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4592),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4592),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4592),
    [sym_empty_statement] = STATE(4592),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(4592),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4592),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4592),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4592),
    [sym_break_statement] = STATE(4592),
    [sym_labeled_statement] = STATE(4592),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4592),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [4229] = {
    [sym_type_alias_declaration] = STATE(4593),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4593),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4593),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4593),
    [sym_return_statement] = STATE(4593),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4593),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4593),
    [sym_switch_statement] = STATE(4593),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4593),
    [sym_throw_statement] = STATE(4593),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4593),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4593),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(4593),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4593),
    [sym_abstract_class] = STATE(4593),
    [sym_interface_declaration] = STATE(4593),
    [sym_statement_block] = STATE(4593),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4593),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4593),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4593),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4593),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4593),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4593),
    [sym_empty_statement] = STATE(4593),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(4593),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4593),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4593),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4593),
    [sym_break_statement] = STATE(4593),
    [sym_labeled_statement] = STATE(4593),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4593),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [4230] = {
    [sym_type_alias_declaration] = STATE(4594),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4594),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4594),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4594),
    [sym_return_statement] = STATE(4594),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4594),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4594),
    [sym_switch_statement] = STATE(4594),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4594),
    [sym_throw_statement] = STATE(4594),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4594),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4594),
    [sym_decorator] = STATE(62),
    [sym_continue_statement] = STATE(4594),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4594),
    [sym_abstract_class] = STATE(4594),
    [sym_interface_declaration] = STATE(4594),
    [sym_statement_block] = STATE(4594),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4594),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4594),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4594),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4594),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4594),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4594),
    [sym_empty_statement] = STATE(4594),
    [aux_sym_export_statement_repeat1] = STATE(62),
    [sym_import_alias] = STATE(4594),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4594),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4594),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4594),
    [sym_break_statement] = STATE(4594),
    [sym_labeled_statement] = STATE(4594),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4594),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [4231] = {
    [sym_identifier] = ACTIONS(9052),
    [anon_sym_BQUOTE] = ACTIONS(9054),
    [anon_sym_debugger] = ACTIONS(9052),
    [anon_sym_symbol] = ACTIONS(9052),
    [anon_sym_AT] = ACTIONS(9054),
    [anon_sym_DASH] = ACTIONS(9052),
    [anon_sym_void] = ACTIONS(9052),
    [anon_sym_break] = ACTIONS(9052),
    [anon_sym_const] = ACTIONS(9052),
    [sym_super] = ACTIONS(9052),
    [anon_sym_return] = ACTIONS(9052),
    [anon_sym_private] = ACTIONS(9052),
    [anon_sym_get] = ACTIONS(9052),
    [anon_sym_RBRACE] = ACTIONS(9054),
    [anon_sym_interface] = ACTIONS(9052),
    [anon_sym_default] = ACTIONS(9052),
    [anon_sym_enum] = ACTIONS(9052),
    [anon_sym_delete] = ACTIONS(9052),
    [anon_sym_continue] = ACTIONS(9052),
    [anon_sym_DASH_DASH] = ACTIONS(9054),
    [anon_sym_if] = ACTIONS(9052),
    [anon_sym_this] = ACTIONS(9052),
    [anon_sym_yield] = ACTIONS(9052),
    [sym_true] = ACTIONS(9052),
    [anon_sym_throw] = ACTIONS(9052),
    [anon_sym_protected] = ACTIONS(9052),
    [anon_sym_abstract] = ACTIONS(9052),
    [anon_sym_set] = ACTIONS(9052),
    [anon_sym_type] = ACTIONS(9052),
    [anon_sym_import] = ACTIONS(9052),
    [anon_sym_namespace] = ACTIONS(9052),
    [anon_sym_PLUS_PLUS] = ACTIONS(9054),
    [anon_sym_await] = ACTIONS(9052),
    [anon_sym_DQUOTE] = ACTIONS(9054),
    [anon_sym_else] = ACTIONS(9052),
    [anon_sym_BANG] = ACTIONS(9054),
    [anon_sym_for] = ACTIONS(9052),
    [anon_sym_LBRACK] = ACTIONS(9054),
    [sym_false] = ACTIONS(9052),
    [anon_sym_SEMI] = ACTIONS(9054),
    [anon_sym_case] = ACTIONS(9052),
    [anon_sym_module] = ACTIONS(9052),
    [anon_sym_number] = ACTIONS(9052),
    [anon_sym_class] = ACTIONS(9052),
    [anon_sym_declare] = ACTIONS(9052),
    [anon_sym_typeof] = ACTIONS(9052),
    [anon_sym_LBRACE] = ACTIONS(9054),
    [anon_sym_switch] = ACTIONS(9052),
    [anon_sym_LPAREN] = ACTIONS(9054),
    [sym_null] = ACTIONS(9052),
    [anon_sym_any] = ACTIONS(9052),
    [anon_sym_boolean] = ACTIONS(9052),
    [anon_sym_async] = ACTIONS(9052),
    [anon_sym_public] = ACTIONS(9052),
    [anon_sym_var] = ACTIONS(9052),
    [anon_sym_while] = ACTIONS(9052),
    [anon_sym_SQUOTE] = ACTIONS(9054),
    [anon_sym_try] = ACTIONS(9052),
    [anon_sym_LT] = ACTIONS(9054),
    [sym_number] = ACTIONS(9054),
    [anon_sym_SLASH] = ACTIONS(9052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9052),
    [anon_sym_function] = ACTIONS(9052),
    [sym_undefined] = ACTIONS(9052),
    [anon_sym_new] = ACTIONS(9052),
    [ts_builtin_sym_end] = ACTIONS(9054),
    [anon_sym_let] = ACTIONS(9052),
    [anon_sym_PLUS] = ACTIONS(9052),
    [anon_sym_export] = ACTIONS(9052),
    [anon_sym_do] = ACTIONS(9052),
    [anon_sym_TILDE] = ACTIONS(9054),
    [anon_sym_with] = ACTIONS(9052),
  },
  [4232] = {
    [sym_identifier] = ACTIONS(9056),
    [anon_sym_BQUOTE] = ACTIONS(9058),
    [anon_sym_debugger] = ACTIONS(9056),
    [anon_sym_symbol] = ACTIONS(9056),
    [anon_sym_AT] = ACTIONS(9058),
    [anon_sym_DASH] = ACTIONS(9056),
    [anon_sym_void] = ACTIONS(9056),
    [anon_sym_break] = ACTIONS(9056),
    [anon_sym_const] = ACTIONS(9056),
    [sym_super] = ACTIONS(9056),
    [anon_sym_return] = ACTIONS(9056),
    [anon_sym_private] = ACTIONS(9056),
    [anon_sym_get] = ACTIONS(9056),
    [anon_sym_RBRACE] = ACTIONS(9058),
    [anon_sym_interface] = ACTIONS(9056),
    [anon_sym_default] = ACTIONS(9056),
    [anon_sym_enum] = ACTIONS(9056),
    [anon_sym_delete] = ACTIONS(9056),
    [anon_sym_continue] = ACTIONS(9056),
    [anon_sym_DASH_DASH] = ACTIONS(9058),
    [anon_sym_if] = ACTIONS(9056),
    [anon_sym_this] = ACTIONS(9056),
    [anon_sym_yield] = ACTIONS(9056),
    [sym_true] = ACTIONS(9056),
    [anon_sym_throw] = ACTIONS(9056),
    [anon_sym_protected] = ACTIONS(9056),
    [anon_sym_abstract] = ACTIONS(9056),
    [anon_sym_set] = ACTIONS(9056),
    [anon_sym_type] = ACTIONS(9056),
    [anon_sym_import] = ACTIONS(9056),
    [anon_sym_namespace] = ACTIONS(9056),
    [anon_sym_PLUS_PLUS] = ACTIONS(9058),
    [anon_sym_await] = ACTIONS(9056),
    [anon_sym_DQUOTE] = ACTIONS(9058),
    [anon_sym_else] = ACTIONS(9056),
    [anon_sym_BANG] = ACTIONS(9058),
    [anon_sym_for] = ACTIONS(9056),
    [anon_sym_LBRACK] = ACTIONS(9058),
    [sym_false] = ACTIONS(9056),
    [anon_sym_SEMI] = ACTIONS(9058),
    [anon_sym_case] = ACTIONS(9056),
    [anon_sym_module] = ACTIONS(9056),
    [anon_sym_number] = ACTIONS(9056),
    [anon_sym_class] = ACTIONS(9056),
    [anon_sym_declare] = ACTIONS(9056),
    [anon_sym_typeof] = ACTIONS(9056),
    [anon_sym_LBRACE] = ACTIONS(9058),
    [anon_sym_switch] = ACTIONS(9056),
    [anon_sym_LPAREN] = ACTIONS(9058),
    [sym_null] = ACTIONS(9056),
    [anon_sym_any] = ACTIONS(9056),
    [anon_sym_boolean] = ACTIONS(9056),
    [anon_sym_async] = ACTIONS(9056),
    [anon_sym_public] = ACTIONS(9056),
    [anon_sym_var] = ACTIONS(9056),
    [anon_sym_while] = ACTIONS(9056),
    [anon_sym_SQUOTE] = ACTIONS(9058),
    [anon_sym_try] = ACTIONS(9056),
    [anon_sym_LT] = ACTIONS(9058),
    [sym_number] = ACTIONS(9058),
    [anon_sym_SLASH] = ACTIONS(9056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9056),
    [anon_sym_function] = ACTIONS(9056),
    [sym_undefined] = ACTIONS(9056),
    [anon_sym_new] = ACTIONS(9056),
    [ts_builtin_sym_end] = ACTIONS(9058),
    [anon_sym_let] = ACTIONS(9056),
    [anon_sym_PLUS] = ACTIONS(9056),
    [anon_sym_export] = ACTIONS(9056),
    [anon_sym_do] = ACTIONS(9056),
    [anon_sym_TILDE] = ACTIONS(9058),
    [anon_sym_with] = ACTIONS(9056),
  },
  [4233] = {
    [sym_identifier] = ACTIONS(9060),
    [anon_sym_BQUOTE] = ACTIONS(9062),
    [anon_sym_debugger] = ACTIONS(9060),
    [anon_sym_symbol] = ACTIONS(9060),
    [anon_sym_AT] = ACTIONS(9062),
    [anon_sym_DASH] = ACTIONS(9060),
    [anon_sym_void] = ACTIONS(9060),
    [anon_sym_break] = ACTIONS(9060),
    [anon_sym_const] = ACTIONS(9060),
    [sym_super] = ACTIONS(9060),
    [anon_sym_return] = ACTIONS(9060),
    [anon_sym_private] = ACTIONS(9060),
    [anon_sym_get] = ACTIONS(9060),
    [anon_sym_RBRACE] = ACTIONS(9062),
    [anon_sym_interface] = ACTIONS(9060),
    [anon_sym_default] = ACTIONS(9060),
    [anon_sym_enum] = ACTIONS(9060),
    [anon_sym_delete] = ACTIONS(9060),
    [anon_sym_continue] = ACTIONS(9060),
    [anon_sym_DASH_DASH] = ACTIONS(9062),
    [anon_sym_if] = ACTIONS(9060),
    [anon_sym_this] = ACTIONS(9060),
    [anon_sym_yield] = ACTIONS(9060),
    [sym_true] = ACTIONS(9060),
    [anon_sym_throw] = ACTIONS(9060),
    [anon_sym_protected] = ACTIONS(9060),
    [anon_sym_abstract] = ACTIONS(9060),
    [anon_sym_set] = ACTIONS(9060),
    [anon_sym_type] = ACTIONS(9060),
    [anon_sym_import] = ACTIONS(9060),
    [anon_sym_namespace] = ACTIONS(9060),
    [anon_sym_PLUS_PLUS] = ACTIONS(9062),
    [anon_sym_await] = ACTIONS(9060),
    [anon_sym_DQUOTE] = ACTIONS(9062),
    [anon_sym_else] = ACTIONS(9060),
    [anon_sym_BANG] = ACTIONS(9062),
    [anon_sym_for] = ACTIONS(9060),
    [anon_sym_LBRACK] = ACTIONS(9062),
    [sym_false] = ACTIONS(9060),
    [anon_sym_SEMI] = ACTIONS(9062),
    [anon_sym_case] = ACTIONS(9060),
    [anon_sym_module] = ACTIONS(9060),
    [anon_sym_number] = ACTIONS(9060),
    [anon_sym_class] = ACTIONS(9060),
    [anon_sym_declare] = ACTIONS(9060),
    [anon_sym_typeof] = ACTIONS(9060),
    [anon_sym_LBRACE] = ACTIONS(9062),
    [anon_sym_switch] = ACTIONS(9060),
    [anon_sym_LPAREN] = ACTIONS(9062),
    [sym_null] = ACTIONS(9060),
    [anon_sym_any] = ACTIONS(9060),
    [anon_sym_boolean] = ACTIONS(9060),
    [anon_sym_async] = ACTIONS(9060),
    [anon_sym_public] = ACTIONS(9060),
    [anon_sym_var] = ACTIONS(9060),
    [anon_sym_while] = ACTIONS(9060),
    [anon_sym_SQUOTE] = ACTIONS(9062),
    [anon_sym_try] = ACTIONS(9060),
    [anon_sym_LT] = ACTIONS(9062),
    [sym_number] = ACTIONS(9062),
    [anon_sym_SLASH] = ACTIONS(9060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9060),
    [anon_sym_function] = ACTIONS(9060),
    [sym_undefined] = ACTIONS(9060),
    [anon_sym_new] = ACTIONS(9060),
    [ts_builtin_sym_end] = ACTIONS(9062),
    [anon_sym_let] = ACTIONS(9060),
    [anon_sym_PLUS] = ACTIONS(9060),
    [anon_sym_export] = ACTIONS(9060),
    [anon_sym_do] = ACTIONS(9060),
    [anon_sym_TILDE] = ACTIONS(9062),
    [anon_sym_with] = ACTIONS(9060),
  },
  [4234] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(5130),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5130),
    [anon_sym_PIPE] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(5130),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [4235] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(5134),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5134),
    [anon_sym_PIPE] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(5134),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [4236] = {
    [sym_new_expression] = STATE(4595),
    [sym_augmented_assignment_expression] = STATE(4595),
    [sym_unary_expression] = STATE(4595),
    [sym_update_expression] = STATE(4595),
    [sym_regex] = STATE(4595),
    [sym_meta_property] = STATE(4595),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(4595),
    [sym_yield_expression] = STATE(4595),
    [sym_as_expression] = STATE(4595),
    [sym_non_null_expression] = STATE(4595),
    [sym_internal_module] = STATE(4595),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4595),
    [sym_await_expression] = STATE(4595),
    [sym_member_expression] = STATE(2091),
    [sym_string] = STATE(4595),
    [sym_this] = STATE(4595),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4595),
    [sym_generator_function] = STATE(4595),
    [sym_call_expression] = STATE(4595),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4595),
    [sym_ternary_expression] = STATE(4595),
    [sym_binary_expression] = STATE(4595),
    [sym_template_string] = STATE(4595),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4595),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4595),
    [sym_class] = STATE(4595),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(9064),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9064),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(9066),
    [sym_true] = ACTIONS(9064),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9064),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [4237] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4596),
    [sym_constructor_type] = STATE(4596),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(4596),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4596),
    [sym_intersection_type] = STATE(4596),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4238] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4597),
    [sym_constructor_type] = STATE(4597),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(4597),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4597),
    [sym_intersection_type] = STATE(4597),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4239] = {
    [anon_sym_EQ_GT] = ACTIONS(9068),
    [sym_comment] = ACTIONS(3),
  },
  [4240] = {
    [sym_formal_parameters] = STATE(4599),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4241] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2778),
    [sym_constructor_type] = STATE(2778),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(2778),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2778),
    [sym_intersection_type] = STATE(2778),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4242] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(2779),
    [sym_constructor_type] = STATE(2779),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(2779),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(2779),
    [sym_intersection_type] = STATE(2779),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4243] = {
    [anon_sym_EQ_GT] = ACTIONS(9070),
    [sym_comment] = ACTIONS(3),
  },
  [4244] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4601),
    [sym_constructor_type] = STATE(4601),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(4601),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4601),
    [sym_intersection_type] = STATE(4601),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4245] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4602),
    [sym_constructor_type] = STATE(4602),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(4602),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4602),
    [sym_intersection_type] = STATE(4602),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4246] = {
    [sym_new_expression] = STATE(3664),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(3664),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3664),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3664),
    [sym_call_signature] = STATE(2089),
    [sym_yield_expression] = STATE(3664),
    [sym_as_expression] = STATE(3664),
    [sym_internal_module] = STATE(3664),
    [sym_arrow_function] = STATE(3664),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(2091),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(991),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(2093),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(3664),
    [sym_subscript_expression] = STATE(2091),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3664),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3664),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3664),
    [sym_meta_property] = STATE(3664),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(3664),
    [sym_non_null_expression] = STATE(3664),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(3664),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3664),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_anonymous_class] = STATE(3664),
    [sym_call_expression] = STATE(3664),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3664),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3664),
    [sym_type_arguments] = STATE(2094),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(3664),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(3664),
    [sym_class] = STATE(3664),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(7501),
    [sym_false] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(7503),
    [anon_sym_number] = ACTIONS(7503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(7505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(7507),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(7509),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [sym_null] = ACTIONS(7432),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(7503),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(7503),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(2018),
    [sym_number] = ACTIONS(2020),
    [sym_true] = ACTIONS(2002),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(7503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7432),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(9072),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(7507),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [4247] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6067),
    [anon_sym_AMP_EQ] = ACTIONS(6067),
    [anon_sym_PLUS_EQ] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(6067),
    [anon_sym_STAR_EQ] = ACTIONS(6067),
    [anon_sym_PIPE_EQ] = ACTIONS(6067),
    [anon_sym_DASH_EQ] = ACTIONS(6067),
    [anon_sym_EQ_GT] = ACTIONS(6071),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6067),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT_EQ] = ACTIONS(6067),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6073),
  },
  [4248] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(5130),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [4249] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(5134),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [4250] = {
    [sym_new_expression] = STATE(4604),
    [sym_augmented_assignment_expression] = STATE(4604),
    [sym_unary_expression] = STATE(4604),
    [sym_update_expression] = STATE(4604),
    [sym_regex] = STATE(4604),
    [sym_meta_property] = STATE(4604),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4604),
    [sym_yield_expression] = STATE(4604),
    [sym_as_expression] = STATE(4604),
    [sym_non_null_expression] = STATE(4604),
    [sym_internal_module] = STATE(4604),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4604),
    [sym_await_expression] = STATE(4604),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4604),
    [sym_this] = STATE(4604),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4604),
    [sym_generator_function] = STATE(4604),
    [sym_call_expression] = STATE(4604),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4604),
    [sym_ternary_expression] = STATE(4604),
    [sym_binary_expression] = STATE(4604),
    [sym_template_string] = STATE(4604),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4604),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4604),
    [sym_class] = STATE(4604),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9074),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9074),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9076),
    [sym_true] = ACTIONS(9074),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9074),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4251] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4605),
    [sym_constructor_type] = STATE(4605),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(4605),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4605),
    [sym_intersection_type] = STATE(4605),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4252] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4606),
    [sym_constructor_type] = STATE(4606),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(4606),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4606),
    [sym_intersection_type] = STATE(4606),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4253] = {
    [anon_sym_EQ_GT] = ACTIONS(9078),
    [sym_comment] = ACTIONS(3),
  },
  [4254] = {
    [sym_formal_parameters] = STATE(4608),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4255] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4256] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4257] = {
    [anon_sym_EQ_GT] = ACTIONS(9080),
    [sym_comment] = ACTIONS(3),
  },
  [4258] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4610),
    [sym_constructor_type] = STATE(4610),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(4610),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4610),
    [sym_intersection_type] = STATE(4610),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4259] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4611),
    [sym_constructor_type] = STATE(4611),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(4611),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4611),
    [sym_intersection_type] = STATE(4611),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4260] = {
    [sym_new_expression] = STATE(3693),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(3693),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3693),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3693),
    [sym_call_signature] = STATE(2107),
    [sym_yield_expression] = STATE(3693),
    [sym_as_expression] = STATE(3693),
    [sym_internal_module] = STATE(3693),
    [sym_arrow_function] = STATE(3693),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(2109),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1738),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(2110),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(3693),
    [sym_subscript_expression] = STATE(2109),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3693),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3693),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3693),
    [sym_meta_property] = STATE(3693),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(3693),
    [sym_non_null_expression] = STATE(3693),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(3693),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3693),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(3693),
    [sym_call_expression] = STATE(3693),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3693),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3693),
    [sym_type_arguments] = STATE(2111),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(3693),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(3693),
    [sym_class] = STATE(3693),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(7578),
    [sym_false] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(7580),
    [anon_sym_number] = ACTIONS(7580),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(7582),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(7584),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(7586),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(7521),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(7580),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(7580),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(3597),
    [sym_number] = ACTIONS(3599),
    [sym_true] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(7580),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7521),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(9082),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(7584),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4261] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6127),
    [anon_sym_AMP_EQ] = ACTIONS(6127),
    [anon_sym_PLUS_EQ] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(6127),
    [anon_sym_STAR_EQ] = ACTIONS(6127),
    [anon_sym_PIPE_EQ] = ACTIONS(6127),
    [anon_sym_DASH_EQ] = ACTIONS(6127),
    [anon_sym_EQ_GT] = ACTIONS(6131),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6127),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT_EQ] = ACTIONS(6127),
    [anon_sym_DOT] = ACTIONS(7037),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6133),
  },
  [4262] = {
    [sym_identifier] = ACTIONS(9084),
    [anon_sym_BQUOTE] = ACTIONS(9086),
    [anon_sym_debugger] = ACTIONS(9084),
    [anon_sym_symbol] = ACTIONS(9084),
    [anon_sym_AT] = ACTIONS(9086),
    [anon_sym_DASH] = ACTIONS(9084),
    [anon_sym_void] = ACTIONS(9084),
    [anon_sym_break] = ACTIONS(9084),
    [anon_sym_const] = ACTIONS(9084),
    [sym_super] = ACTIONS(9084),
    [anon_sym_return] = ACTIONS(9084),
    [anon_sym_private] = ACTIONS(9084),
    [anon_sym_get] = ACTIONS(9084),
    [anon_sym_RBRACE] = ACTIONS(9086),
    [anon_sym_interface] = ACTIONS(9084),
    [anon_sym_default] = ACTIONS(9084),
    [anon_sym_enum] = ACTIONS(9084),
    [anon_sym_delete] = ACTIONS(9084),
    [anon_sym_continue] = ACTIONS(9084),
    [anon_sym_DASH_DASH] = ACTIONS(9086),
    [anon_sym_if] = ACTIONS(9084),
    [anon_sym_this] = ACTIONS(9084),
    [anon_sym_yield] = ACTIONS(9084),
    [sym_true] = ACTIONS(9084),
    [anon_sym_throw] = ACTIONS(9084),
    [anon_sym_protected] = ACTIONS(9084),
    [anon_sym_abstract] = ACTIONS(9084),
    [anon_sym_set] = ACTIONS(9084),
    [anon_sym_type] = ACTIONS(9084),
    [anon_sym_import] = ACTIONS(9084),
    [anon_sym_namespace] = ACTIONS(9084),
    [anon_sym_PLUS_PLUS] = ACTIONS(9086),
    [anon_sym_await] = ACTIONS(9084),
    [anon_sym_DQUOTE] = ACTIONS(9086),
    [anon_sym_else] = ACTIONS(9084),
    [anon_sym_BANG] = ACTIONS(9086),
    [anon_sym_for] = ACTIONS(9084),
    [anon_sym_LBRACK] = ACTIONS(9086),
    [sym_false] = ACTIONS(9084),
    [anon_sym_SEMI] = ACTIONS(9086),
    [anon_sym_case] = ACTIONS(9084),
    [anon_sym_module] = ACTIONS(9084),
    [anon_sym_number] = ACTIONS(9084),
    [anon_sym_class] = ACTIONS(9084),
    [anon_sym_declare] = ACTIONS(9084),
    [anon_sym_typeof] = ACTIONS(9084),
    [anon_sym_LBRACE] = ACTIONS(9086),
    [anon_sym_switch] = ACTIONS(9084),
    [anon_sym_LPAREN] = ACTIONS(9086),
    [sym_null] = ACTIONS(9084),
    [anon_sym_any] = ACTIONS(9084),
    [anon_sym_boolean] = ACTIONS(9084),
    [anon_sym_async] = ACTIONS(9084),
    [anon_sym_public] = ACTIONS(9084),
    [anon_sym_var] = ACTIONS(9084),
    [anon_sym_while] = ACTIONS(9084),
    [anon_sym_SQUOTE] = ACTIONS(9086),
    [anon_sym_try] = ACTIONS(9084),
    [anon_sym_LT] = ACTIONS(9086),
    [sym_number] = ACTIONS(9086),
    [anon_sym_SLASH] = ACTIONS(9084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9084),
    [anon_sym_function] = ACTIONS(9084),
    [sym_undefined] = ACTIONS(9084),
    [anon_sym_new] = ACTIONS(9084),
    [ts_builtin_sym_end] = ACTIONS(9086),
    [anon_sym_let] = ACTIONS(9084),
    [anon_sym_PLUS] = ACTIONS(9084),
    [anon_sym_export] = ACTIONS(9084),
    [anon_sym_do] = ACTIONS(9084),
    [anon_sym_TILDE] = ACTIONS(9086),
    [anon_sym_with] = ACTIONS(9084),
  },
  [4263] = {
    [sym_identifier] = ACTIONS(9088),
    [anon_sym_BQUOTE] = ACTIONS(9090),
    [anon_sym_debugger] = ACTIONS(9088),
    [anon_sym_symbol] = ACTIONS(9088),
    [anon_sym_AT] = ACTIONS(9090),
    [anon_sym_DASH] = ACTIONS(9088),
    [anon_sym_void] = ACTIONS(9088),
    [anon_sym_break] = ACTIONS(9088),
    [anon_sym_const] = ACTIONS(9088),
    [sym_super] = ACTIONS(9088),
    [anon_sym_return] = ACTIONS(9088),
    [anon_sym_private] = ACTIONS(9088),
    [anon_sym_get] = ACTIONS(9088),
    [anon_sym_RBRACE] = ACTIONS(9090),
    [anon_sym_interface] = ACTIONS(9088),
    [anon_sym_default] = ACTIONS(9088),
    [anon_sym_enum] = ACTIONS(9088),
    [anon_sym_delete] = ACTIONS(9088),
    [anon_sym_continue] = ACTIONS(9088),
    [anon_sym_DASH_DASH] = ACTIONS(9090),
    [anon_sym_if] = ACTIONS(9088),
    [anon_sym_this] = ACTIONS(9088),
    [anon_sym_yield] = ACTIONS(9088),
    [sym_true] = ACTIONS(9088),
    [anon_sym_throw] = ACTIONS(9088),
    [anon_sym_protected] = ACTIONS(9088),
    [anon_sym_abstract] = ACTIONS(9088),
    [anon_sym_set] = ACTIONS(9088),
    [anon_sym_type] = ACTIONS(9088),
    [anon_sym_import] = ACTIONS(9088),
    [anon_sym_namespace] = ACTIONS(9088),
    [anon_sym_PLUS_PLUS] = ACTIONS(9090),
    [anon_sym_await] = ACTIONS(9088),
    [anon_sym_DQUOTE] = ACTIONS(9090),
    [anon_sym_else] = ACTIONS(9088),
    [anon_sym_BANG] = ACTIONS(9090),
    [anon_sym_for] = ACTIONS(9088),
    [anon_sym_LBRACK] = ACTIONS(9090),
    [sym_false] = ACTIONS(9088),
    [anon_sym_SEMI] = ACTIONS(9090),
    [anon_sym_case] = ACTIONS(9088),
    [anon_sym_module] = ACTIONS(9088),
    [anon_sym_number] = ACTIONS(9088),
    [anon_sym_class] = ACTIONS(9088),
    [anon_sym_declare] = ACTIONS(9088),
    [anon_sym_typeof] = ACTIONS(9088),
    [anon_sym_LBRACE] = ACTIONS(9090),
    [anon_sym_switch] = ACTIONS(9088),
    [anon_sym_LPAREN] = ACTIONS(9090),
    [sym_null] = ACTIONS(9088),
    [anon_sym_any] = ACTIONS(9088),
    [anon_sym_boolean] = ACTIONS(9088),
    [anon_sym_async] = ACTIONS(9088),
    [anon_sym_public] = ACTIONS(9088),
    [anon_sym_var] = ACTIONS(9088),
    [anon_sym_while] = ACTIONS(9088),
    [anon_sym_SQUOTE] = ACTIONS(9090),
    [anon_sym_try] = ACTIONS(9088),
    [anon_sym_LT] = ACTIONS(9090),
    [sym_number] = ACTIONS(9090),
    [anon_sym_SLASH] = ACTIONS(9088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9088),
    [anon_sym_function] = ACTIONS(9088),
    [sym_undefined] = ACTIONS(9088),
    [anon_sym_new] = ACTIONS(9088),
    [ts_builtin_sym_end] = ACTIONS(9090),
    [anon_sym_let] = ACTIONS(9088),
    [anon_sym_PLUS] = ACTIONS(9088),
    [anon_sym_export] = ACTIONS(9088),
    [anon_sym_do] = ACTIONS(9088),
    [anon_sym_TILDE] = ACTIONS(9090),
    [anon_sym_with] = ACTIONS(9088),
  },
  [4264] = {
    [sym_identifier] = ACTIONS(9092),
    [anon_sym_BQUOTE] = ACTIONS(9094),
    [anon_sym_debugger] = ACTIONS(9092),
    [anon_sym_symbol] = ACTIONS(9092),
    [anon_sym_AT] = ACTIONS(9094),
    [anon_sym_DASH] = ACTIONS(9092),
    [anon_sym_void] = ACTIONS(9092),
    [anon_sym_break] = ACTIONS(9092),
    [anon_sym_const] = ACTIONS(9092),
    [sym_super] = ACTIONS(9092),
    [anon_sym_return] = ACTIONS(9092),
    [anon_sym_private] = ACTIONS(9092),
    [anon_sym_get] = ACTIONS(9092),
    [anon_sym_RBRACE] = ACTIONS(9094),
    [anon_sym_interface] = ACTIONS(9092),
    [anon_sym_default] = ACTIONS(9092),
    [anon_sym_enum] = ACTIONS(9092),
    [anon_sym_delete] = ACTIONS(9092),
    [anon_sym_continue] = ACTIONS(9092),
    [anon_sym_DASH_DASH] = ACTIONS(9094),
    [anon_sym_if] = ACTIONS(9092),
    [anon_sym_this] = ACTIONS(9092),
    [anon_sym_yield] = ACTIONS(9092),
    [sym_true] = ACTIONS(9092),
    [anon_sym_throw] = ACTIONS(9092),
    [anon_sym_protected] = ACTIONS(9092),
    [anon_sym_abstract] = ACTIONS(9092),
    [anon_sym_set] = ACTIONS(9092),
    [anon_sym_type] = ACTIONS(9092),
    [anon_sym_import] = ACTIONS(9092),
    [anon_sym_namespace] = ACTIONS(9092),
    [anon_sym_PLUS_PLUS] = ACTIONS(9094),
    [anon_sym_await] = ACTIONS(9092),
    [anon_sym_DQUOTE] = ACTIONS(9094),
    [anon_sym_else] = ACTIONS(9092),
    [anon_sym_BANG] = ACTIONS(9094),
    [anon_sym_for] = ACTIONS(9092),
    [anon_sym_LBRACK] = ACTIONS(9094),
    [sym_false] = ACTIONS(9092),
    [anon_sym_SEMI] = ACTIONS(9094),
    [anon_sym_case] = ACTIONS(9092),
    [anon_sym_module] = ACTIONS(9092),
    [anon_sym_number] = ACTIONS(9092),
    [anon_sym_class] = ACTIONS(9092),
    [anon_sym_declare] = ACTIONS(9092),
    [anon_sym_typeof] = ACTIONS(9092),
    [anon_sym_LBRACE] = ACTIONS(9094),
    [anon_sym_switch] = ACTIONS(9092),
    [anon_sym_LPAREN] = ACTIONS(9094),
    [sym_null] = ACTIONS(9092),
    [anon_sym_any] = ACTIONS(9092),
    [anon_sym_boolean] = ACTIONS(9092),
    [anon_sym_async] = ACTIONS(9092),
    [anon_sym_public] = ACTIONS(9092),
    [anon_sym_var] = ACTIONS(9092),
    [anon_sym_while] = ACTIONS(9092),
    [anon_sym_SQUOTE] = ACTIONS(9094),
    [anon_sym_try] = ACTIONS(9092),
    [anon_sym_LT] = ACTIONS(9094),
    [sym_number] = ACTIONS(9094),
    [anon_sym_SLASH] = ACTIONS(9092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9092),
    [anon_sym_function] = ACTIONS(9092),
    [sym_undefined] = ACTIONS(9092),
    [anon_sym_new] = ACTIONS(9092),
    [ts_builtin_sym_end] = ACTIONS(9094),
    [anon_sym_let] = ACTIONS(9092),
    [anon_sym_PLUS] = ACTIONS(9092),
    [anon_sym_export] = ACTIONS(9092),
    [anon_sym_do] = ACTIONS(9092),
    [anon_sym_TILDE] = ACTIONS(9094),
    [anon_sym_with] = ACTIONS(9092),
  },
  [4265] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5397),
    [anon_sym_LBRACK] = ACTIONS(5397),
    [anon_sym_BANG] = ACTIONS(5395),
    [anon_sym_BQUOTE] = ACTIONS(5397),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_COMMA] = ACTIONS(5397),
    [anon_sym_LT_LT] = ACTIONS(5397),
    [anon_sym_STAR] = ACTIONS(5395),
    [anon_sym_GT_GT_GT] = ACTIONS(5397),
    [anon_sym_AMP_AMP] = ACTIONS(5397),
    [anon_sym_DASH] = ACTIONS(5395),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_BANG_EQ] = ACTIONS(5395),
    [anon_sym_LT_EQ] = ACTIONS(5397),
    [anon_sym_LPAREN] = ACTIONS(5397),
    [anon_sym_RBRACK] = ACTIONS(5397),
    [anon_sym_GT_EQ] = ACTIONS(5397),
    [anon_sym_GT] = ACTIONS(5395),
    [anon_sym_AMP] = ACTIONS(5395),
    [anon_sym_PERCENT] = ACTIONS(5397),
    [anon_sym_QMARK] = ACTIONS(5397),
    [anon_sym_RBRACE] = ACTIONS(5397),
    [anon_sym_as] = ACTIONS(5397),
    [anon_sym_PIPE_PIPE] = ACTIONS(5397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5397),
    [anon_sym_DASH_DASH] = ACTIONS(5397),
    [anon_sym_EQ_EQ] = ACTIONS(5395),
    [anon_sym_instanceof] = ACTIONS(5397),
    [anon_sym_LT] = ACTIONS(5395),
    [anon_sym_RPAREN] = ACTIONS(5397),
    [anon_sym_SLASH] = ACTIONS(5395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5397),
    [anon_sym_DOT] = ACTIONS(5397),
    [anon_sym_CARET] = ACTIONS(5397),
    [anon_sym_STAR_STAR] = ACTIONS(5397),
    [anon_sym_PLUS] = ACTIONS(5395),
    [anon_sym_implements] = ACTIONS(5397),
    [anon_sym_GT_GT] = ACTIONS(5395),
    [anon_sym_PLUS_PLUS] = ACTIONS(5397),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5397),
    [anon_sym_in] = ACTIONS(5395),
  },
  [4266] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1675),
    [sym_constructor_type] = STATE(1675),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(281),
    [sym_function_type] = STATE(1675),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1675),
    [sym_intersection_type] = STATE(1675),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(280),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(285),
    [sym_identifier] = ACTIONS(775),
    [sym_false] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(9096),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_boolean] = ACTIONS(472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_this] = ACTIONS(474),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(312),
  },
  [4267] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8034),
    [anon_sym_LBRACK] = ACTIONS(8034),
    [anon_sym_BANG] = ACTIONS(8032),
    [anon_sym_BQUOTE] = ACTIONS(8034),
    [anon_sym_PIPE] = ACTIONS(8032),
    [anon_sym_COMMA] = ACTIONS(8034),
    [anon_sym_LT_LT] = ACTIONS(8034),
    [anon_sym_STAR] = ACTIONS(8032),
    [anon_sym_GT_GT_GT] = ACTIONS(8034),
    [anon_sym_AMP_AMP] = ACTIONS(8034),
    [anon_sym_DASH] = ACTIONS(8032),
    [anon_sym_LBRACE] = ACTIONS(8032),
    [anon_sym_BANG_EQ] = ACTIONS(8032),
    [anon_sym_LT_EQ] = ACTIONS(8034),
    [anon_sym_LPAREN] = ACTIONS(8034),
    [anon_sym_RBRACK] = ACTIONS(8034),
    [anon_sym_GT_EQ] = ACTIONS(8034),
    [anon_sym_GT] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8034),
    [anon_sym_QMARK] = ACTIONS(8034),
    [anon_sym_RBRACE] = ACTIONS(8034),
    [anon_sym_as] = ACTIONS(8034),
    [anon_sym_PIPE_PIPE] = ACTIONS(8034),
    [anon_sym_LBRACE_PIPE] = ACTIONS(8034),
    [anon_sym_DASH_DASH] = ACTIONS(8034),
    [anon_sym_EQ_EQ] = ACTIONS(8032),
    [anon_sym_instanceof] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8032),
    [anon_sym_RPAREN] = ACTIONS(8034),
    [anon_sym_SLASH] = ACTIONS(8032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8034),
    [anon_sym_DOT] = ACTIONS(8034),
    [anon_sym_CARET] = ACTIONS(8034),
    [anon_sym_STAR_STAR] = ACTIONS(8034),
    [anon_sym_PLUS] = ACTIONS(8032),
    [anon_sym_implements] = ACTIONS(8034),
    [anon_sym_GT_GT] = ACTIONS(8032),
    [anon_sym_PLUS_PLUS] = ACTIONS(8034),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8034),
    [anon_sym_in] = ACTIONS(8032),
  },
  [4268] = {
    [aux_sym_export_statement_repeat1] = STATE(806),
    [sym_method_signature] = STATE(2543),
    [sym_decorator] = STATE(806),
    [sym__property_name] = STATE(807),
    [sym_accessibility_modifier] = STATE(808),
    [sym_formal_parameters] = STATE(809),
    [sym_computed_property_name] = STATE(807),
    [sym_property_signature] = STATE(2543),
    [sym_call_signature] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_string] = STATE(807),
    [sym_type_parameters] = STATE(811),
    [sym_construct_signature] = STATE(2543),
    [sym_index_signature] = STATE(2543),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(9098),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(492),
    [sym_number] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1516),
    [sym_readonly] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9098),
    [anon_sym_DQUOTE] = ACTIONS(1143),
  },
  [4269] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(7604),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_RBRACK] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(7606),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4270] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8523),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8525),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_implements] = ACTIONS(6909),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4271] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4615),
    [sym_constructor_type] = STATE(4615),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2218),
    [sym_function_type] = STATE(4615),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4615),
    [sym_intersection_type] = STATE(4615),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2217),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2219),
    [sym_identifier] = ACTIONS(4617),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4272] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8523),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_LBRACE] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(8525),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_implements] = ACTIONS(6986),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4273] = {
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(6292),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6909),
  },
  [4274] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4616),
    [sym_constructor_type] = STATE(4616),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(613),
    [sym_function_type] = STATE(4616),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4616),
    [sym_intersection_type] = STATE(4616),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2232),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2233),
    [sym_identifier] = ACTIONS(1105),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4275] = {
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(6292),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6986),
  },
  [4276] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(4617),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(4618),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4699),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4701),
    [anon_sym_symbol] = ACTIONS(4701),
    [anon_sym_number] = ACTIONS(4701),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4701),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4701),
    [anon_sym_private] = ACTIONS(4701),
    [anon_sym_boolean] = ACTIONS(4701),
    [anon_sym_async] = ACTIONS(4705),
    [anon_sym_public] = ACTIONS(4701),
    [anon_sym_get] = ACTIONS(4701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4701),
    [anon_sym_string] = ACTIONS(4701),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(4701),
    [anon_sym_type] = ACTIONS(4701),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(4701),
    [anon_sym_export] = ACTIONS(4701),
    [anon_sym_namespace] = ACTIONS(4707),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4277] = {
    [sym_formal_parameters] = STATE(4619),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4278] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(9100),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4279] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(9103),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4280] = {
    [sym__automatic_semicolon] = ACTIONS(9106),
    [anon_sym_RBRACE] = ACTIONS(9106),
    [anon_sym_SEMI] = ACTIONS(9106),
    [anon_sym_COMMA] = ACTIONS(9106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9106),
  },
  [4281] = {
    [sym__automatic_semicolon] = ACTIONS(9108),
    [anon_sym_RBRACE] = ACTIONS(9108),
    [anon_sym_SEMI] = ACTIONS(9108),
    [anon_sym_COMMA] = ACTIONS(9108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9108),
  },
  [4282] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4717),
    [anon_sym_LT_LT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_GT_GT_GT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_BANG_EQ] = ACTIONS(4715),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(7180),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_GT] = ACTIONS(4715),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_QMARK] = ACTIONS(4731),
    [anon_sym_as] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(4715),
    [anon_sym_instanceof] = ACTIONS(4713),
    [anon_sym_LT] = ACTIONS(4737),
    [anon_sym_SLASH] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(4733),
    [anon_sym_STAR_STAR] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_GT_GT] = ACTIONS(4723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4713),
    [anon_sym_in] = ACTIONS(4715),
  },
  [4283] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9110),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_RBRACK] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(9112),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [4284] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9110),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_RBRACK] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(9112),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [4285] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4620),
    [sym_constructor_type] = STATE(4620),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(4620),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4620),
    [sym_intersection_type] = STATE(4620),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4286] = {
    [anon_sym_EQ_GT] = ACTIONS(9114),
    [sym_comment] = ACTIONS(3),
  },
  [4287] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4622),
    [sym_constructor_type] = STATE(4622),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(4622),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4622),
    [sym_intersection_type] = STATE(4622),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4288] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9110),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_RBRACK] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(9112),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [4289] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9110),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_RBRACK] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(9112),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [4290] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(1340),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4699),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4701),
    [anon_sym_symbol] = ACTIONS(4701),
    [anon_sym_number] = ACTIONS(4701),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4701),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4701),
    [anon_sym_private] = ACTIONS(4701),
    [anon_sym_boolean] = ACTIONS(4701),
    [anon_sym_async] = ACTIONS(4705),
    [anon_sym_public] = ACTIONS(4701),
    [anon_sym_get] = ACTIONS(4701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4701),
    [anon_sym_string] = ACTIONS(4701),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(4701),
    [anon_sym_type] = ACTIONS(4701),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(4701),
    [anon_sym_export] = ACTIONS(4701),
    [anon_sym_namespace] = ACTIONS(4707),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4291] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4626),
    [sym_constructor_type] = STATE(4626),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(4626),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4626),
    [sym_intersection_type] = STATE(4626),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4292] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4629),
    [sym_constructor_type] = STATE(4629),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(4629),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4629),
    [sym_intersection_type] = STATE(4629),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4293] = {
    [anon_sym_EQ_GT] = ACTIONS(9122),
    [sym_comment] = ACTIONS(3),
  },
  [4294] = {
    [sym_formal_parameters] = STATE(4631),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4295] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3784),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3786),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(7682),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(7684),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(7686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4296] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3784),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3786),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(7682),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(7684),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(7686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4297] = {
    [anon_sym_EQ_GT] = ACTIONS(9124),
    [sym_comment] = ACTIONS(3),
  },
  [4298] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4633),
    [sym_constructor_type] = STATE(4633),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(4633),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4633),
    [sym_intersection_type] = STATE(4633),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4299] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4634),
    [sym_constructor_type] = STATE(4634),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(4634),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4634),
    [sym_intersection_type] = STATE(4634),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3784),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3786),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(7682),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(7684),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(7686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4300] = {
    [sym__automatic_semicolon] = ACTIONS(8597),
    [anon_sym_LBRACK] = ACTIONS(8597),
    [sym_identifier] = ACTIONS(9126),
    [anon_sym_SEMI] = ACTIONS(8597),
    [anon_sym_module] = ACTIONS(9126),
    [anon_sym_symbol] = ACTIONS(9126),
    [anon_sym_number] = ACTIONS(9126),
    [anon_sym_AT] = ACTIONS(8597),
    [anon_sym_declare] = ACTIONS(9126),
    [anon_sym_STAR] = ACTIONS(8597),
    [anon_sym_void] = ACTIONS(9126),
    [anon_sym_any] = ACTIONS(9126),
    [anon_sym_private] = ACTIONS(9126),
    [anon_sym_boolean] = ACTIONS(9126),
    [anon_sym_async] = ACTIONS(9126),
    [anon_sym_public] = ACTIONS(9126),
    [anon_sym_get] = ACTIONS(9126),
    [anon_sym_RBRACE] = ACTIONS(8597),
    [anon_sym_static] = ACTIONS(9126),
    [anon_sym_SQUOTE] = ACTIONS(8597),
    [sym_number] = ACTIONS(8597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(9126),
    [anon_sym_string] = ACTIONS(9126),
    [anon_sym_abstract] = ACTIONS(9126),
    [anon_sym_set] = ACTIONS(9126),
    [anon_sym_type] = ACTIONS(9126),
    [anon_sym_import] = ACTIONS(9126),
    [anon_sym_export] = ACTIONS(9126),
    [anon_sym_namespace] = ACTIONS(9126),
    [sym_readonly] = ACTIONS(9126),
    [anon_sym_DQUOTE] = ACTIONS(8597),
  },
  [4301] = {
    [sym_statement_block] = STATE(4635),
    [sym__automatic_semicolon] = ACTIONS(9128),
    [anon_sym_SEMI] = ACTIONS(9128),
    [anon_sym_COMMA] = ACTIONS(9128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4779),
  },
  [4302] = {
    [sym_call_signature] = STATE(4636),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4303] = {
    [sym__automatic_semicolon] = ACTIONS(9130),
    [anon_sym_SEMI] = ACTIONS(9130),
    [anon_sym_COMMA] = ACTIONS(9130),
    [sym_comment] = ACTIONS(3),
  },
  [4304] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4305] = {
    [sym_formal_parameters] = STATE(4637),
    [sym_type_parameters] = STATE(4638),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4306] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4307] = {
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(9132),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9134),
    [anon_sym_COMMA] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5196),
  },
  [4308] = {
    [sym_formal_parameters] = STATE(4641),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4309] = {
    [anon_sym_EQ_GT] = ACTIONS(9136),
    [sym_comment] = ACTIONS(3),
  },
  [4310] = {
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(9132),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9134),
    [anon_sym_COMMA] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5204),
  },
  [4311] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4643),
    [sym_constructor_type] = STATE(4643),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(4643),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4643),
    [sym_intersection_type] = STATE(4643),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3128),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3130),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4312] = {
    [anon_sym_EQ_GT] = ACTIONS(9138),
    [sym_comment] = ACTIONS(3),
  },
  [4313] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4645),
    [sym_constructor_type] = STATE(4645),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(4645),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4645),
    [sym_intersection_type] = STATE(4645),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3128),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3130),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4314] = {
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(9132),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9134),
    [anon_sym_COMMA] = ACTIONS(5406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5406),
  },
  [4315] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(7708),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(7710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5425),
  },
  [4316] = {
    [sym_call_signature] = STATE(4636),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(9140),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [4317] = {
    [sym__initializer] = STATE(4647),
    [sym__automatic_semicolon] = ACTIONS(9130),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(9130),
    [anon_sym_COMMA] = ACTIONS(9130),
    [sym_comment] = ACTIONS(3),
  },
  [4318] = {
    [sym__automatic_semicolon] = ACTIONS(9142),
    [anon_sym_SEMI] = ACTIONS(9142),
    [anon_sym_COMMA] = ACTIONS(9142),
    [sym_comment] = ACTIONS(3),
  },
  [4319] = {
    [sym_identifier] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_debugger] = ACTIONS(7182),
    [anon_sym_symbol] = ACTIONS(7182),
    [anon_sym_AT] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(7737),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_void] = ACTIONS(7182),
    [anon_sym_break] = ACTIONS(7182),
    [anon_sym_const] = ACTIONS(7182),
    [sym_super] = ACTIONS(7182),
    [anon_sym_return] = ACTIONS(7182),
    [anon_sym_private] = ACTIONS(7182),
    [anon_sym_get] = ACTIONS(7182),
    [anon_sym_interface] = ACTIONS(7182),
    [anon_sym_enum] = ACTIONS(7182),
    [anon_sym_delete] = ACTIONS(7182),
    [anon_sym_continue] = ACTIONS(7182),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_if] = ACTIONS(7182),
    [anon_sym_this] = ACTIONS(7182),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_true] = ACTIONS(7182),
    [anon_sym_throw] = ACTIONS(7182),
    [anon_sym_protected] = ACTIONS(7182),
    [anon_sym_abstract] = ACTIONS(7182),
    [anon_sym_set] = ACTIONS(7182),
    [anon_sym_type] = ACTIONS(7182),
    [anon_sym_import] = ACTIONS(7182),
    [anon_sym_namespace] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_await] = ACTIONS(7182),
    [anon_sym_DQUOTE] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(5196),
    [anon_sym_for] = ACTIONS(7182),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [sym_false] = ACTIONS(7182),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_module] = ACTIONS(7182),
    [anon_sym_number] = ACTIONS(7182),
    [anon_sym_class] = ACTIONS(7182),
    [anon_sym_declare] = ACTIONS(7182),
    [anon_sym_typeof] = ACTIONS(7182),
    [anon_sym_LBRACE] = ACTIONS(5196),
    [anon_sym_switch] = ACTIONS(7182),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [sym_null] = ACTIONS(7182),
    [anon_sym_any] = ACTIONS(7182),
    [anon_sym_boolean] = ACTIONS(7182),
    [anon_sym_async] = ACTIONS(7182),
    [anon_sym_public] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(7739),
    [anon_sym_var] = ACTIONS(7182),
    [anon_sym_while] = ACTIONS(7182),
    [anon_sym_SQUOTE] = ACTIONS(5196),
    [anon_sym_try] = ACTIONS(7182),
    [anon_sym_LT] = ACTIONS(5196),
    [sym_number] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7182),
    [anon_sym_function] = ACTIONS(7182),
    [sym_undefined] = ACTIONS(7182),
    [anon_sym_new] = ACTIONS(7182),
    [ts_builtin_sym_end] = ACTIONS(5196),
    [anon_sym_let] = ACTIONS(7182),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_export] = ACTIONS(7182),
    [anon_sym_do] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(5196),
    [anon_sym_with] = ACTIONS(7182),
  },
  [4320] = {
    [sym_identifier] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_debugger] = ACTIONS(7197),
    [anon_sym_symbol] = ACTIONS(7197),
    [anon_sym_AT] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(7737),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_void] = ACTIONS(7197),
    [anon_sym_break] = ACTIONS(7197),
    [anon_sym_const] = ACTIONS(7197),
    [sym_super] = ACTIONS(7197),
    [anon_sym_return] = ACTIONS(7197),
    [anon_sym_private] = ACTIONS(7197),
    [anon_sym_get] = ACTIONS(7197),
    [anon_sym_interface] = ACTIONS(7197),
    [anon_sym_enum] = ACTIONS(7197),
    [anon_sym_delete] = ACTIONS(7197),
    [anon_sym_continue] = ACTIONS(7197),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_if] = ACTIONS(7197),
    [anon_sym_this] = ACTIONS(7197),
    [anon_sym_yield] = ACTIONS(7197),
    [sym_true] = ACTIONS(7197),
    [anon_sym_throw] = ACTIONS(7197),
    [anon_sym_protected] = ACTIONS(7197),
    [anon_sym_abstract] = ACTIONS(7197),
    [anon_sym_set] = ACTIONS(7197),
    [anon_sym_type] = ACTIONS(7197),
    [anon_sym_import] = ACTIONS(7197),
    [anon_sym_namespace] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_await] = ACTIONS(7197),
    [anon_sym_DQUOTE] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(5204),
    [anon_sym_for] = ACTIONS(7197),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [sym_false] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_module] = ACTIONS(7197),
    [anon_sym_number] = ACTIONS(7197),
    [anon_sym_class] = ACTIONS(7197),
    [anon_sym_declare] = ACTIONS(7197),
    [anon_sym_typeof] = ACTIONS(7197),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_switch] = ACTIONS(7197),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [sym_null] = ACTIONS(7197),
    [anon_sym_any] = ACTIONS(7197),
    [anon_sym_boolean] = ACTIONS(7197),
    [anon_sym_async] = ACTIONS(7197),
    [anon_sym_public] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(7739),
    [anon_sym_var] = ACTIONS(7197),
    [anon_sym_while] = ACTIONS(7197),
    [anon_sym_SQUOTE] = ACTIONS(5204),
    [anon_sym_try] = ACTIONS(7197),
    [anon_sym_LT] = ACTIONS(5204),
    [sym_number] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7197),
    [anon_sym_function] = ACTIONS(7197),
    [sym_undefined] = ACTIONS(7197),
    [anon_sym_new] = ACTIONS(7197),
    [ts_builtin_sym_end] = ACTIONS(5204),
    [anon_sym_let] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_export] = ACTIONS(7197),
    [anon_sym_do] = ACTIONS(7197),
    [anon_sym_TILDE] = ACTIONS(5204),
    [anon_sym_with] = ACTIONS(7197),
  },
  [4321] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4648),
    [sym_constructor_type] = STATE(4648),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(4648),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4648),
    [sym_intersection_type] = STATE(4648),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4322] = {
    [anon_sym_EQ_GT] = ACTIONS(9144),
    [sym_comment] = ACTIONS(3),
  },
  [4323] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4650),
    [sym_constructor_type] = STATE(4650),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(4650),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4650),
    [sym_intersection_type] = STATE(4650),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4324] = {
    [sym_identifier] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_debugger] = ACTIONS(7207),
    [anon_sym_symbol] = ACTIONS(7207),
    [anon_sym_AT] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(7737),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_void] = ACTIONS(7207),
    [anon_sym_break] = ACTIONS(7207),
    [anon_sym_const] = ACTIONS(7207),
    [sym_super] = ACTIONS(7207),
    [anon_sym_return] = ACTIONS(7207),
    [anon_sym_private] = ACTIONS(7207),
    [anon_sym_get] = ACTIONS(7207),
    [anon_sym_interface] = ACTIONS(7207),
    [anon_sym_enum] = ACTIONS(7207),
    [anon_sym_delete] = ACTIONS(7207),
    [anon_sym_continue] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_if] = ACTIONS(7207),
    [anon_sym_this] = ACTIONS(7207),
    [anon_sym_yield] = ACTIONS(7207),
    [sym_true] = ACTIONS(7207),
    [anon_sym_throw] = ACTIONS(7207),
    [anon_sym_protected] = ACTIONS(7207),
    [anon_sym_abstract] = ACTIONS(7207),
    [anon_sym_set] = ACTIONS(7207),
    [anon_sym_type] = ACTIONS(7207),
    [anon_sym_import] = ACTIONS(7207),
    [anon_sym_namespace] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_await] = ACTIONS(7207),
    [anon_sym_DQUOTE] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(5406),
    [anon_sym_for] = ACTIONS(7207),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [sym_false] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_module] = ACTIONS(7207),
    [anon_sym_number] = ACTIONS(7207),
    [anon_sym_class] = ACTIONS(7207),
    [anon_sym_declare] = ACTIONS(7207),
    [anon_sym_typeof] = ACTIONS(7207),
    [anon_sym_LBRACE] = ACTIONS(5406),
    [anon_sym_switch] = ACTIONS(7207),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [sym_null] = ACTIONS(7207),
    [anon_sym_any] = ACTIONS(7207),
    [anon_sym_boolean] = ACTIONS(7207),
    [anon_sym_async] = ACTIONS(7207),
    [anon_sym_public] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(7739),
    [anon_sym_var] = ACTIONS(7207),
    [anon_sym_while] = ACTIONS(7207),
    [anon_sym_SQUOTE] = ACTIONS(5406),
    [anon_sym_try] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(5406),
    [sym_number] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7207),
    [anon_sym_function] = ACTIONS(7207),
    [sym_undefined] = ACTIONS(7207),
    [anon_sym_new] = ACTIONS(7207),
    [ts_builtin_sym_end] = ACTIONS(5406),
    [anon_sym_let] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_export] = ACTIONS(7207),
    [anon_sym_do] = ACTIONS(7207),
    [anon_sym_TILDE] = ACTIONS(5406),
    [anon_sym_with] = ACTIONS(7207),
  },
  [4325] = {
    [sym_identifier] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_debugger] = ACTIONS(7211),
    [anon_sym_symbol] = ACTIONS(7211),
    [anon_sym_AT] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(7737),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_void] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [sym_super] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_private] = ACTIONS(7211),
    [anon_sym_get] = ACTIONS(7211),
    [anon_sym_interface] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_delete] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_this] = ACTIONS(7211),
    [anon_sym_yield] = ACTIONS(7211),
    [sym_true] = ACTIONS(7211),
    [anon_sym_throw] = ACTIONS(7211),
    [anon_sym_protected] = ACTIONS(7211),
    [anon_sym_abstract] = ACTIONS(7211),
    [anon_sym_set] = ACTIONS(7211),
    [anon_sym_type] = ACTIONS(7211),
    [anon_sym_import] = ACTIONS(7211),
    [anon_sym_namespace] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_await] = ACTIONS(7211),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(5425),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [sym_false] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_module] = ACTIONS(7211),
    [anon_sym_number] = ACTIONS(7211),
    [anon_sym_class] = ACTIONS(7211),
    [anon_sym_declare] = ACTIONS(7211),
    [anon_sym_typeof] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(5425),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [sym_null] = ACTIONS(7211),
    [anon_sym_any] = ACTIONS(7211),
    [anon_sym_boolean] = ACTIONS(7211),
    [anon_sym_async] = ACTIONS(7211),
    [anon_sym_public] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(7739),
    [anon_sym_var] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_try] = ACTIONS(7211),
    [anon_sym_LT] = ACTIONS(5425),
    [sym_number] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7211),
    [anon_sym_function] = ACTIONS(7211),
    [sym_undefined] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [ts_builtin_sym_end] = ACTIONS(5425),
    [anon_sym_let] = ACTIONS(7211),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_export] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_TILDE] = ACTIONS(5425),
    [anon_sym_with] = ACTIONS(7211),
  },
  [4326] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(7180),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(7180),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_LT_LT] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4890),
    [anon_sym_GT_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_BANG_EQ] = ACTIONS(4844),
    [anon_sym_LT_EQ] = ACTIONS(4884),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(7180),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4888),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(4844),
    [anon_sym_instanceof] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_STAR_STAR] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4844),
  },
  [4327] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9146),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(9148),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [4328] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9146),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(9148),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [4329] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4651),
    [sym_constructor_type] = STATE(4651),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(4651),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4651),
    [sym_intersection_type] = STATE(4651),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4330] = {
    [anon_sym_EQ_GT] = ACTIONS(9150),
    [sym_comment] = ACTIONS(3),
  },
  [4331] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4653),
    [sym_constructor_type] = STATE(4653),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(4653),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4653),
    [sym_intersection_type] = STATE(4653),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4332] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9146),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(9148),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [4333] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9146),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(9148),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [4334] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(1399),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(4870),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(4872),
    [anon_sym_symbol] = ACTIONS(4872),
    [anon_sym_number] = ACTIONS(4872),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4872),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4874),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(4872),
    [anon_sym_private] = ACTIONS(4872),
    [anon_sym_boolean] = ACTIONS(4872),
    [anon_sym_async] = ACTIONS(4876),
    [anon_sym_public] = ACTIONS(4872),
    [anon_sym_get] = ACTIONS(4872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4872),
    [anon_sym_string] = ACTIONS(4872),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(4872),
    [anon_sym_type] = ACTIONS(4872),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(4872),
    [anon_sym_export] = ACTIONS(4872),
    [anon_sym_namespace] = ACTIONS(4878),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4335] = {
    [anon_sym_COMMA] = ACTIONS(9152),
    [anon_sym_RBRACE] = ACTIONS(9152),
    [sym_comment] = ACTIONS(3),
  },
  [4336] = {
    [sym_statement_block] = STATE(4654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [4337] = {
    [anon_sym_of] = ACTIONS(9154),
    [sym_comment] = ACTIONS(3),
  },
  [4338] = {
    [anon_sym_of] = ACTIONS(9156),
    [sym_comment] = ACTIONS(3),
  },
  [4339] = {
    [anon_sym_of] = ACTIONS(9158),
    [sym_comment] = ACTIONS(3),
  },
  [4340] = {
    [sym_new_expression] = STATE(4658),
    [sym_augmented_assignment_expression] = STATE(4658),
    [sym_unary_expression] = STATE(4658),
    [sym_update_expression] = STATE(4658),
    [sym_regex] = STATE(4658),
    [sym_meta_property] = STATE(4658),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4658),
    [sym_yield_expression] = STATE(4658),
    [sym_as_expression] = STATE(4658),
    [sym_non_null_expression] = STATE(4658),
    [sym_internal_module] = STATE(4658),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4658),
    [sym_await_expression] = STATE(4658),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4658),
    [sym_this] = STATE(4658),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4658),
    [sym_generator_function] = STATE(4658),
    [sym_call_expression] = STATE(4658),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4658),
    [sym_ternary_expression] = STATE(4658),
    [sym_binary_expression] = STATE(4658),
    [sym_template_string] = STATE(4658),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4658),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4658),
    [sym_class] = STATE(4658),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9160),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9160),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9162),
    [sym_true] = ACTIONS(9160),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9160),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4341] = {
    [sym_new_expression] = STATE(4659),
    [sym_augmented_assignment_expression] = STATE(4659),
    [sym_unary_expression] = STATE(4659),
    [sym_update_expression] = STATE(4659),
    [sym_regex] = STATE(4659),
    [sym_meta_property] = STATE(4659),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4659),
    [sym_yield_expression] = STATE(4659),
    [sym_as_expression] = STATE(4659),
    [sym_non_null_expression] = STATE(4659),
    [sym_internal_module] = STATE(4659),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4659),
    [sym_await_expression] = STATE(4659),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4659),
    [sym_this] = STATE(4659),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4659),
    [sym_generator_function] = STATE(4659),
    [sym_call_expression] = STATE(4659),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4659),
    [sym_ternary_expression] = STATE(4659),
    [sym_binary_expression] = STATE(4659),
    [sym_template_string] = STATE(4659),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4659),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4659),
    [sym_class] = STATE(4659),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9164),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9164),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9166),
    [sym_true] = ACTIONS(9164),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9164),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4342] = {
    [sym_new_expression] = STATE(4660),
    [sym_augmented_assignment_expression] = STATE(4660),
    [sym_unary_expression] = STATE(4660),
    [sym_update_expression] = STATE(4660),
    [sym_regex] = STATE(4660),
    [sym_meta_property] = STATE(4660),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4660),
    [sym_yield_expression] = STATE(4660),
    [sym_as_expression] = STATE(4660),
    [sym_non_null_expression] = STATE(4660),
    [sym_internal_module] = STATE(4660),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4660),
    [sym_await_expression] = STATE(4660),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4660),
    [sym_this] = STATE(4660),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4660),
    [sym_generator_function] = STATE(4660),
    [sym_call_expression] = STATE(4660),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4660),
    [sym_ternary_expression] = STATE(4660),
    [sym_binary_expression] = STATE(4660),
    [sym_template_string] = STATE(4660),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4660),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4660),
    [sym_class] = STATE(4660),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9168),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9168),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9170),
    [sym_true] = ACTIONS(9168),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9168),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4343] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [4344] = {
    [anon_sym_RPAREN] = ACTIONS(9172),
    [sym_comment] = ACTIONS(3),
  },
  [4345] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9174),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4346] = {
    [sym_new_expression] = STATE(4663),
    [sym_augmented_assignment_expression] = STATE(4663),
    [sym_unary_expression] = STATE(4663),
    [sym_update_expression] = STATE(4663),
    [sym_regex] = STATE(4663),
    [sym_meta_property] = STATE(4663),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4663),
    [sym_yield_expression] = STATE(4663),
    [sym_as_expression] = STATE(4663),
    [sym_non_null_expression] = STATE(4663),
    [sym_internal_module] = STATE(4663),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4663),
    [sym_await_expression] = STATE(4663),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4664),
    [sym_string] = STATE(4663),
    [sym_this] = STATE(4663),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4663),
    [sym_generator_function] = STATE(4663),
    [sym_call_expression] = STATE(4663),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4663),
    [sym_ternary_expression] = STATE(4663),
    [sym_binary_expression] = STATE(4663),
    [sym_template_string] = STATE(4663),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4663),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4663),
    [sym_class] = STATE(4663),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9176),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9176),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9178),
    [sym_true] = ACTIONS(9176),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9176),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4347] = {
    [sym_new_expression] = STATE(4665),
    [sym_augmented_assignment_expression] = STATE(4665),
    [sym_unary_expression] = STATE(4665),
    [sym_update_expression] = STATE(4665),
    [sym_regex] = STATE(4665),
    [sym_meta_property] = STATE(4665),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4665),
    [sym_yield_expression] = STATE(4665),
    [sym_as_expression] = STATE(4665),
    [sym_non_null_expression] = STATE(4665),
    [sym_internal_module] = STATE(4665),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4665),
    [sym_await_expression] = STATE(4665),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4666),
    [sym_string] = STATE(4665),
    [sym_this] = STATE(4665),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4665),
    [sym_generator_function] = STATE(4665),
    [sym_call_expression] = STATE(4665),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4665),
    [sym_ternary_expression] = STATE(4665),
    [sym_binary_expression] = STATE(4665),
    [sym_template_string] = STATE(4665),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4665),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4665),
    [sym_class] = STATE(4665),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9180),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9180),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9182),
    [sym_true] = ACTIONS(9180),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9180),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4348] = {
    [sym_new_expression] = STATE(4667),
    [sym_augmented_assignment_expression] = STATE(4667),
    [sym_unary_expression] = STATE(4667),
    [sym_update_expression] = STATE(4667),
    [sym_regex] = STATE(4667),
    [sym_meta_property] = STATE(4667),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4667),
    [sym_yield_expression] = STATE(4667),
    [sym_as_expression] = STATE(4667),
    [sym_non_null_expression] = STATE(4667),
    [sym_internal_module] = STATE(4667),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4667),
    [sym_await_expression] = STATE(4667),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4668),
    [sym_string] = STATE(4667),
    [sym_this] = STATE(4667),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4667),
    [sym_generator_function] = STATE(4667),
    [sym_call_expression] = STATE(4667),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4667),
    [sym_ternary_expression] = STATE(4667),
    [sym_binary_expression] = STATE(4667),
    [sym_template_string] = STATE(4667),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4667),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4667),
    [sym_class] = STATE(4667),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9184),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9184),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9186),
    [sym_true] = ACTIONS(9184),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9184),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4349] = {
    [sym_type_alias_declaration] = STATE(3004),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3004),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3004),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3004),
    [sym_return_statement] = STATE(3004),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3004),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3004),
    [sym_switch_statement] = STATE(3004),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3004),
    [sym_throw_statement] = STATE(3004),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3004),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3004),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(3004),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3004),
    [sym_abstract_class] = STATE(3004),
    [sym_interface_declaration] = STATE(3004),
    [sym_statement_block] = STATE(3004),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3004),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3004),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3004),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3004),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3004),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3004),
    [sym_empty_statement] = STATE(3004),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(3004),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3004),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3004),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3004),
    [sym_break_statement] = STATE(3004),
    [sym_labeled_statement] = STATE(3004),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3004),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4350] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9188),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4351] = {
    [anon_sym_RPAREN] = ACTIONS(9188),
    [sym_comment] = ACTIONS(3),
  },
  [4352] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9190),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4353] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [4354] = {
    [anon_sym_RPAREN] = ACTIONS(9192),
    [sym_comment] = ACTIONS(3),
  },
  [4355] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9194),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4356] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9196),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [4357] = {
    [anon_sym_RPAREN] = ACTIONS(9196),
    [sym_comment] = ACTIONS(3),
  },
  [4358] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4679),
    [sym_constructor_type] = STATE(4679),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(4679),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4679),
    [sym_intersection_type] = STATE(4679),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4359] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9208),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4360] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9210),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4361] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4362] = {
    [sym_type_alias_declaration] = STATE(4231),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4231),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4231),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4231),
    [sym_return_statement] = STATE(4231),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4231),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4231),
    [sym_switch_statement] = STATE(4231),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4231),
    [sym_throw_statement] = STATE(4231),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4231),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4231),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(4231),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4231),
    [sym_abstract_class] = STATE(4231),
    [sym_interface_declaration] = STATE(4231),
    [sym_statement_block] = STATE(4231),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4231),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4231),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4231),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4231),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4231),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4231),
    [sym_empty_statement] = STATE(4231),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(4231),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4231),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4231),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4231),
    [sym_break_statement] = STATE(4231),
    [sym_labeled_statement] = STATE(4231),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4231),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [4363] = {
    [sym_type_alias_declaration] = STATE(4232),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4232),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4232),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4232),
    [sym_return_statement] = STATE(4232),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4232),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4232),
    [sym_switch_statement] = STATE(4232),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4232),
    [sym_throw_statement] = STATE(4232),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4232),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4232),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(4232),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4232),
    [sym_abstract_class] = STATE(4232),
    [sym_interface_declaration] = STATE(4232),
    [sym_statement_block] = STATE(4232),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4232),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4232),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4232),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4232),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4232),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4232),
    [sym_empty_statement] = STATE(4232),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(4232),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4232),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4232),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4232),
    [sym_break_statement] = STATE(4232),
    [sym_labeled_statement] = STATE(4232),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4232),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [4364] = {
    [sym_type_alias_declaration] = STATE(4233),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4233),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4233),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4233),
    [sym_return_statement] = STATE(4233),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4233),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4233),
    [sym_switch_statement] = STATE(4233),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4233),
    [sym_throw_statement] = STATE(4233),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4233),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4233),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(4233),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4233),
    [sym_abstract_class] = STATE(4233),
    [sym_interface_declaration] = STATE(4233),
    [sym_statement_block] = STATE(4233),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4233),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4233),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4233),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4233),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4233),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4233),
    [sym_empty_statement] = STATE(4233),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(4233),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4233),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4233),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4233),
    [sym_break_statement] = STATE(4233),
    [sym_labeled_statement] = STATE(4233),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4233),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [4365] = {
    [sym_type_alias_declaration] = STATE(4262),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4262),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4262),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4262),
    [sym_return_statement] = STATE(4262),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4262),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4262),
    [sym_switch_statement] = STATE(4262),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4262),
    [sym_throw_statement] = STATE(4262),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4262),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4262),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(4262),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4262),
    [sym_abstract_class] = STATE(4262),
    [sym_interface_declaration] = STATE(4262),
    [sym_statement_block] = STATE(4262),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4262),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4262),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4262),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4262),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4262),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4262),
    [sym_empty_statement] = STATE(4262),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(4262),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4262),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4262),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4262),
    [sym_break_statement] = STATE(4262),
    [sym_labeled_statement] = STATE(4262),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4262),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [4366] = {
    [sym_type_alias_declaration] = STATE(4263),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4263),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4263),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4263),
    [sym_return_statement] = STATE(4263),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4263),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4263),
    [sym_switch_statement] = STATE(4263),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4263),
    [sym_throw_statement] = STATE(4263),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4263),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4263),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(4263),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4263),
    [sym_abstract_class] = STATE(4263),
    [sym_interface_declaration] = STATE(4263),
    [sym_statement_block] = STATE(4263),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4263),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4263),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4263),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4263),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4263),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4263),
    [sym_empty_statement] = STATE(4263),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(4263),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4263),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4263),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4263),
    [sym_break_statement] = STATE(4263),
    [sym_labeled_statement] = STATE(4263),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4263),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [4367] = {
    [sym_type_alias_declaration] = STATE(4264),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4264),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4264),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4264),
    [sym_return_statement] = STATE(4264),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4264),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4264),
    [sym_switch_statement] = STATE(4264),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4264),
    [sym_throw_statement] = STATE(4264),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4264),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4264),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(4264),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4264),
    [sym_abstract_class] = STATE(4264),
    [sym_interface_declaration] = STATE(4264),
    [sym_statement_block] = STATE(4264),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4264),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4264),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4264),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4264),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4264),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4264),
    [sym_empty_statement] = STATE(4264),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(4264),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4264),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4264),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4264),
    [sym_break_statement] = STATE(4264),
    [sym_labeled_statement] = STATE(4264),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4264),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [4368] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4686),
    [sym_constructor_type] = STATE(4686),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(4686),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4686),
    [sym_intersection_type] = STATE(4686),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4369] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4687),
    [sym_constructor_type] = STATE(4687),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(4687),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4687),
    [sym_intersection_type] = STATE(4687),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4370] = {
    [anon_sym_EQ_GT] = ACTIONS(9214),
    [sym_comment] = ACTIONS(3),
  },
  [4371] = {
    [sym_formal_parameters] = STATE(4689),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4372] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4373] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4374] = {
    [anon_sym_EQ_GT] = ACTIONS(9216),
    [sym_comment] = ACTIONS(3),
  },
  [4375] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4691),
    [sym_constructor_type] = STATE(4691),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(4691),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4691),
    [sym_intersection_type] = STATE(4691),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4376] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4692),
    [sym_constructor_type] = STATE(4692),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(4692),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4692),
    [sym_intersection_type] = STATE(4692),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4377] = {
    [sym_call_signature] = STATE(4693),
    [sym_formal_parameters] = STATE(290),
    [sym_type_parameters] = STATE(291),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4378] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5130),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [4379] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5134),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [4380] = {
    [sym_new_expression] = STATE(4694),
    [sym_augmented_assignment_expression] = STATE(4694),
    [sym_unary_expression] = STATE(4694),
    [sym_update_expression] = STATE(4694),
    [sym_regex] = STATE(4694),
    [sym_meta_property] = STATE(4694),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(4694),
    [sym_yield_expression] = STATE(4694),
    [sym_as_expression] = STATE(4694),
    [sym_non_null_expression] = STATE(4694),
    [sym_internal_module] = STATE(4694),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4694),
    [sym_await_expression] = STATE(4694),
    [sym_member_expression] = STATE(2392),
    [sym_string] = STATE(4694),
    [sym_this] = STATE(4694),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2394),
    [sym_anonymous_class] = STATE(4694),
    [sym_generator_function] = STATE(4694),
    [sym_call_expression] = STATE(4694),
    [sym_subscript_expression] = STATE(2392),
    [sym_assignment_expression] = STATE(4694),
    [sym_ternary_expression] = STATE(4694),
    [sym_binary_expression] = STATE(4694),
    [sym_template_string] = STATE(4694),
    [sym_type_arguments] = STATE(2395),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4694),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(4694),
    [sym_class] = STATE(4694),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(9218),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(4992),
    [anon_sym_number] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9218),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(4992),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9220),
    [sym_true] = ACTIONS(9218),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(4992),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9218),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [4381] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4695),
    [sym_constructor_type] = STATE(4695),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(4695),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4695),
    [sym_intersection_type] = STATE(4695),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4382] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4696),
    [sym_constructor_type] = STATE(4696),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(4696),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4696),
    [sym_intersection_type] = STATE(4696),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4383] = {
    [anon_sym_EQ_GT] = ACTIONS(9222),
    [sym_comment] = ACTIONS(3),
  },
  [4384] = {
    [sym_formal_parameters] = STATE(4698),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4385] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3029),
    [sym_constructor_type] = STATE(3029),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(3029),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3029),
    [sym_intersection_type] = STATE(3029),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4386] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(3030),
    [sym_constructor_type] = STATE(3030),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(3030),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(3030),
    [sym_intersection_type] = STATE(3030),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4387] = {
    [anon_sym_EQ_GT] = ACTIONS(9224),
    [sym_comment] = ACTIONS(3),
  },
  [4388] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4700),
    [sym_constructor_type] = STATE(4700),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(4700),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4700),
    [sym_intersection_type] = STATE(4700),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4389] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4701),
    [sym_constructor_type] = STATE(4701),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(4701),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4701),
    [sym_intersection_type] = STATE(4701),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4390] = {
    [sym_new_expression] = STATE(3883),
    [sym_constructor_type] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(3883),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(3883),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(3883),
    [sym_call_signature] = STATE(2390),
    [sym_yield_expression] = STATE(3883),
    [sym_as_expression] = STATE(3883),
    [sym_internal_module] = STATE(3883),
    [sym_arrow_function] = STATE(3883),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(2392),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1270),
    [sym_type_parameters] = STATE(2786),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(2394),
    [sym_nested_type_identifier] = STATE(281),
    [sym_generator_function] = STATE(3883),
    [sym_subscript_expression] = STATE(2392),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(3883),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(3883),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(2787),
    [sym_intersection_type] = STATE(1565),
    [sym__type] = STATE(1565),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(3883),
    [sym_meta_property] = STATE(3883),
    [sym_function_type] = STATE(1565),
    [sym__expression] = STATE(3883),
    [sym_non_null_expression] = STATE(3883),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(3883),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(3883),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(3883),
    [sym_call_expression] = STATE(3883),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(3883),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(3883),
    [sym_type_arguments] = STATE(2395),
    [sym_union_type] = STATE(1565),
    [sym_parenthesized_expression] = STATE(3883),
    [sym_array] = STATE(2396),
    [sym_type_assertion] = STATE(3883),
    [sym_class] = STATE(3883),
    [anon_sym_BANG] = ACTIONS(4986),
    [sym_identifier] = ACTIONS(7924),
    [sym_false] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4992),
    [anon_sym_symbol] = ACTIONS(7926),
    [anon_sym_number] = ACTIONS(7926),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4992),
    [anon_sym_typeof] = ACTIONS(7928),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(7930),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(7932),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(7863),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(7926),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_boolean] = ACTIONS(7926),
    [anon_sym_async] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_get] = ACTIONS(4992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_delete] = ACTIONS(4994),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5002),
    [anon_sym_this] = ACTIONS(2629),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_string] = ACTIONS(7926),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(7863),
    [anon_sym_set] = ACTIONS(4992),
    [anon_sym_type] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(9226),
    [anon_sym_import] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(4992),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(7930),
    [anon_sym_await] = ACTIONS(5012),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(5002),
  },
  [4391] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6603),
    [anon_sym_AMP_EQ] = ACTIONS(6603),
    [anon_sym_PLUS_EQ] = ACTIONS(6603),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6605),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_CARET_EQ] = ACTIONS(6603),
    [anon_sym_STAR_EQ] = ACTIONS(6603),
    [anon_sym_PIPE_EQ] = ACTIONS(6603),
    [anon_sym_DASH_EQ] = ACTIONS(6603),
    [anon_sym_EQ_GT] = ACTIONS(6607),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6603),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT_EQ] = ACTIONS(6603),
    [anon_sym_DOT] = ACTIONS(6247),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6603),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6609),
  },
  [4392] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(9228),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [4393] = {
    [sym_parenthesized_expression] = STATE(4704),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [4394] = {
    [anon_sym_await] = ACTIONS(9230),
    [anon_sym_LPAREN] = ACTIONS(9232),
    [sym_comment] = ACTIONS(3),
  },
  [4395] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(4710),
    [sym__declaration] = STATE(192),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(4710),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(322),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(9234),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(9236),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(9238),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [4396] = {
    [sym_parenthesized_expression] = STATE(4711),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [4397] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(4710),
    [sym__declaration] = STATE(317),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(4710),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_as] = ACTIONS(541),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_declare] = ACTIONS(9236),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(9238),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [4398] = {
    [sym_parenthesized_expression] = STATE(4712),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [4399] = {
    [sym_identifier] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2401),
    [anon_sym_debugger] = ACTIONS(2399),
    [anon_sym_symbol] = ACTIONS(2399),
    [anon_sym_AT] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2399),
    [anon_sym_void] = ACTIONS(2399),
    [anon_sym_break] = ACTIONS(2399),
    [anon_sym_const] = ACTIONS(2399),
    [sym_super] = ACTIONS(2399),
    [anon_sym_return] = ACTIONS(2399),
    [anon_sym_private] = ACTIONS(2399),
    [anon_sym_get] = ACTIONS(2399),
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_default] = ACTIONS(2399),
    [anon_sym_interface] = ACTIONS(2399),
    [anon_sym_enum] = ACTIONS(2399),
    [anon_sym_delete] = ACTIONS(2399),
    [anon_sym_continue] = ACTIONS(2399),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2399),
    [anon_sym_this] = ACTIONS(2399),
    [anon_sym_yield] = ACTIONS(2399),
    [sym_true] = ACTIONS(2399),
    [anon_sym_throw] = ACTIONS(2399),
    [anon_sym_protected] = ACTIONS(2399),
    [anon_sym_abstract] = ACTIONS(2399),
    [anon_sym_set] = ACTIONS(2399),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_import] = ACTIONS(2399),
    [anon_sym_namespace] = ACTIONS(2399),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_await] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_else] = ACTIONS(9240),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [sym_false] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2401),
    [anon_sym_case] = ACTIONS(2399),
    [anon_sym_module] = ACTIONS(2399),
    [anon_sym_number] = ACTIONS(2399),
    [anon_sym_class] = ACTIONS(2399),
    [anon_sym_declare] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_switch] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [sym_null] = ACTIONS(2399),
    [anon_sym_any] = ACTIONS(2399),
    [anon_sym_boolean] = ACTIONS(2399),
    [anon_sym_async] = ACTIONS(2399),
    [anon_sym_public] = ACTIONS(2399),
    [anon_sym_var] = ACTIONS(2399),
    [anon_sym_while] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_try] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2401),
    [sym_number] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2399),
    [anon_sym_function] = ACTIONS(2399),
    [sym_undefined] = ACTIONS(2399),
    [anon_sym_new] = ACTIONS(2399),
    [anon_sym_let] = ACTIONS(2399),
    [anon_sym_PLUS] = ACTIONS(2399),
    [anon_sym_export] = ACTIONS(2399),
    [anon_sym_do] = ACTIONS(2399),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_with] = ACTIONS(2399),
  },
  [4400] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(9242),
    [anon_sym_class] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [4401] = {
    [sym_array] = STATE(4717),
    [sym_object] = STATE(4718),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(9244),
    [anon_sym_var] = ACTIONS(9246),
    [anon_sym_const] = ACTIONS(9246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(9246),
  },
  [4402] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9248),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9250),
  },
  [4403] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(4722),
    [sym_object] = STATE(4723),
    [sym_identifier] = ACTIONS(9252),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4404] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(4722),
    [sym_object] = STATE(4723),
    [sym_identifier] = ACTIONS(9252),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4405] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4724),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(4724),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [4406] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9254),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9256),
  },
  [4407] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9258),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9260),
  },
  [4408] = {
    [sym_identifier] = ACTIONS(9262),
    [sym_comment] = ACTIONS(3),
  },
  [4409] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4730),
    [sym_constructor_type] = STATE(4730),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(4730),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4730),
    [sym_intersection_type] = STATE(4730),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4410] = {
    [anon_sym_EQ_GT] = ACTIONS(9264),
    [sym_comment] = ACTIONS(3),
  },
  [4411] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4732),
    [sym_constructor_type] = STATE(4732),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(4732),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4732),
    [sym_intersection_type] = STATE(4732),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4412] = {
    [anon_sym_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(7962),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(7964),
    [sym_comment] = ACTIONS(3),
  },
  [4413] = {
    [anon_sym_EQ] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(5028),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4414] = {
    [anon_sym_EQ_GT] = ACTIONS(9266),
    [sym_comment] = ACTIONS(3),
  },
  [4415] = {
    [sym_formal_parameters] = STATE(4734),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4416] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4417] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4418] = {
    [anon_sym_EQ_GT] = ACTIONS(9268),
    [sym_comment] = ACTIONS(3),
  },
  [4419] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4736),
    [sym_constructor_type] = STATE(4736),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(4736),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4736),
    [sym_intersection_type] = STATE(4736),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4420] = {
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [4421] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4737),
    [sym_constructor_type] = STATE(4737),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(4737),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4737),
    [sym_intersection_type] = STATE(4737),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2428),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2430),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5060),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4422] = {
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [4423] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(7988),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(7990),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8086),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4424] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4738),
    [sym_constructor_type] = STATE(4738),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(4738),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4738),
    [sym_intersection_type] = STATE(4738),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4425] = {
    [anon_sym_EQ_GT] = ACTIONS(9270),
    [sym_comment] = ACTIONS(3),
  },
  [4426] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4740),
    [sym_constructor_type] = STATE(4740),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(4740),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4740),
    [sym_intersection_type] = STATE(4740),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4427] = {
    [anon_sym_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(8010),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8012),
    [sym_comment] = ACTIONS(3),
  },
  [4428] = {
    [anon_sym_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4429] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4741),
    [sym_constructor_type] = STATE(4741),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(4741),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4741),
    [sym_intersection_type] = STATE(4741),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4430] = {
    [anon_sym_EQ_GT] = ACTIONS(9272),
    [sym_comment] = ACTIONS(3),
  },
  [4431] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4743),
    [sym_constructor_type] = STATE(4743),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(4743),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4743),
    [sym_intersection_type] = STATE(4743),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4432] = {
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8020),
    [anon_sym_RBRACK] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [4433] = {
    [anon_sym_AMP] = ACTIONS(5182),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_RBRACK] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4434] = {
    [anon_sym_GT] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(5198),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4435] = {
    [anon_sym_COLON] = ACTIONS(8008),
    [anon_sym_RBRACE] = ACTIONS(8008),
    [sym__automatic_semicolon] = ACTIONS(8008),
    [anon_sym_SEMI] = ACTIONS(8008),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8008),
    [anon_sym_COMMA] = ACTIONS(8008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8008),
  },
  [4436] = {
    [sym__automatic_semicolon] = ACTIONS(9128),
    [anon_sym_RBRACE] = ACTIONS(9128),
    [anon_sym_SEMI] = ACTIONS(9128),
    [anon_sym_COMMA] = ACTIONS(9128),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9128),
    [sym_comment] = ACTIONS(3),
  },
  [4437] = {
    [sym_call_signature] = STATE(4744),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4438] = {
    [sym__automatic_semicolon] = ACTIONS(5966),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5966),
    [sym_comment] = ACTIONS(3),
  },
  [4439] = {
    [sym_computed_property_name] = STATE(1144),
    [sym__enum_member] = STATE(2900),
    [sym__property_name] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_enum_assignment] = STATE(2900),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(9274),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(1214),
  },
  [4440] = {
    [sym__automatic_semicolon] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5974),
    [sym_comment] = ACTIONS(3),
  },
  [4441] = {
    [aux_sym_enum_body_repeat1] = STATE(2902),
    [anon_sym_COMMA] = ACTIONS(9276),
    [anon_sym_RBRACE] = ACTIONS(9274),
    [sym_comment] = ACTIONS(3),
  },
  [4442] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4747),
    [sym_constructor_type] = STATE(4747),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4747),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4747),
    [sym_intersection_type] = STATE(4747),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2539),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2541),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5286),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4443] = {
    [sym__automatic_semicolon] = ACTIONS(6008),
    [anon_sym_RBRACE] = ACTIONS(6008),
    [anon_sym_SEMI] = ACTIONS(6008),
    [anon_sym_COMMA] = ACTIONS(6008),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6008),
    [sym_comment] = ACTIONS(3),
  },
  [4444] = {
    [sym_class_body] = STATE(4748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(320),
  },
  [4445] = {
    [sym__automatic_semicolon] = ACTIONS(6020),
    [anon_sym_RBRACE] = ACTIONS(6020),
    [anon_sym_SEMI] = ACTIONS(6020),
    [anon_sym_COMMA] = ACTIONS(6020),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6020),
    [sym_comment] = ACTIONS(3),
  },
  [4446] = {
    [sym__automatic_semicolon] = ACTIONS(9278),
    [anon_sym_AMP] = ACTIONS(4321),
    [anon_sym_PIPE] = ACTIONS(4323),
    [anon_sym_SEMI] = ACTIONS(9278),
    [sym_comment] = ACTIONS(3),
  },
  [4447] = {
    [sym__automatic_semicolon] = ACTIONS(6028),
    [anon_sym_RBRACE] = ACTIONS(6028),
    [anon_sym_SEMI] = ACTIONS(6028),
    [anon_sym_COMMA] = ACTIONS(6028),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6028),
    [sym_comment] = ACTIONS(3),
  },
  [4448] = {
    [sym__automatic_semicolon] = ACTIONS(6781),
    [anon_sym_RBRACE] = ACTIONS(6781),
    [anon_sym_SEMI] = ACTIONS(6781),
    [anon_sym_COMMA] = ACTIONS(6781),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6781),
    [sym_comment] = ACTIONS(3),
  },
  [4449] = {
    [anon_sym_EQ_GT] = ACTIONS(9280),
    [sym_comment] = ACTIONS(3),
  },
  [4450] = {
    [sym_formal_parameters] = STATE(4751),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4451] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4452] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4453] = {
    [anon_sym_EQ_GT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(3),
  },
  [4454] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4753),
    [sym_constructor_type] = STATE(4753),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4753),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4753),
    [sym_intersection_type] = STATE(4753),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4455] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(6875),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(6877),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [4456] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4754),
    [sym_constructor_type] = STATE(4754),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4754),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4754),
    [sym_intersection_type] = STATE(4754),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2539),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2541),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5284),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5286),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4457] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(6875),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(6877),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [4458] = {
    [sym_call_signature] = STATE(4744),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(9284),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [4459] = {
    [sym__automatic_semicolon] = ACTIONS(9286),
    [anon_sym_RBRACE] = ACTIONS(9286),
    [anon_sym_SEMI] = ACTIONS(9286),
    [anon_sym_COMMA] = ACTIONS(9286),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9286),
    [sym_comment] = ACTIONS(3),
  },
  [4460] = {
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_RBRACK] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [4461] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4756),
    [sym_constructor_type] = STATE(4756),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(819),
    [sym_function_type] = STATE(4756),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4756),
    [sym_intersection_type] = STATE(4756),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2550),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2551),
    [sym_identifier] = ACTIONS(1520),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4462] = {
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_RBRACK] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [4463] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(9288),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4464] = {
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(6923),
    [anon_sym_PIPE] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
  },
  [4465] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4757),
    [sym_constructor_type] = STATE(4757),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(839),
    [sym_function_type] = STATE(4757),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4757),
    [sym_intersection_type] = STATE(4757),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2574),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2575),
    [sym_identifier] = ACTIONS(3160),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4466] = {
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(6923),
    [anon_sym_PIPE] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
  },
  [4467] = {
    [sym_new_expression] = STATE(1208),
    [sym_constructor_type] = STATE(3316),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_lookup_type] = STATE(284),
    [sym_unary_expression] = STATE(1208),
    [sym_flow_maybe_type] = STATE(284),
    [sym_regex] = STATE(1208),
    [sym_call_signature] = STATE(158),
    [sym_yield_expression] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__primary_type] = STATE(284),
    [sym_member_expression] = STATE(161),
    [sym_mapped_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_string] = STATE(1885),
    [sym_type_parameters] = STATE(4277),
    [sym_array_type] = STATE(284),
    [sym_object] = STATE(164),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_generator_function] = STATE(1208),
    [sym_subscript_expression] = STATE(161),
    [sym_type_query] = STATE(284),
    [sym_ternary_expression] = STATE(1208),
    [sym_existential_type] = STATE(284),
    [sym_template_string] = STATE(1208),
    [sym_object_type] = STATE(284),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(4278),
    [sym_intersection_type] = STATE(3316),
    [sym__type] = STATE(3316),
    [sym_index_type_query] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_update_expression] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_function_type] = STATE(3316),
    [sym__expression] = STATE(1208),
    [sym_non_null_expression] = STATE(1208),
    [sym_nested_identifier] = STATE(283),
    [sym_function] = STATE(160),
    [sym_await_expression] = STATE(1208),
    [sym_generic_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_this] = STATE(1208),
    [sym_tuple_type] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_anonymous_class] = STATE(1208),
    [sym_call_expression] = STATE(1208),
    [sym_type_predicate] = STATE(284),
    [sym_assignment_expression] = STATE(1208),
    [sym__number] = STATE(265),
    [sym_binary_expression] = STATE(1208),
    [sym_type_arguments] = STATE(166),
    [sym_union_type] = STATE(3316),
    [sym_parenthesized_expression] = STATE(1208),
    [sym_array] = STATE(167),
    [sym_type_assertion] = STATE(1208),
    [sym_class] = STATE(1208),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(8100),
    [sym_false] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(8102),
    [anon_sym_number] = ACTIONS(8102),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(8104),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(8106),
    [anon_sym_keyof] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_void] = ACTIONS(8108),
    [anon_sym_PIPE] = ACTIONS(6803),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [sym_null] = ACTIONS(2496),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(8102),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(8102),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(3927),
    [sym_number] = ACTIONS(3933),
    [sym_true] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(8102),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(2496),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(9291),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(8106),
    [anon_sym_await] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [4468] = {
    [sym__initializer] = STATE(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_AMP_EQ] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(929),
    [anon_sym_STAR_EQ] = ACTIONS(929),
    [anon_sym_PIPE_EQ] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
    [anon_sym_EQ_GT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(7228),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(937),
  },
  [4469] = {
    [sym_statement_block] = STATE(3834),
    [sym__automatic_semicolon] = ACTIONS(8563),
    [anon_sym_RBRACE] = ACTIONS(8563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(8563),
    [anon_sym_COMMA] = ACTIONS(8563),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8563),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [4470] = {
    [sym_call_signature] = STATE(4759),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4471] = {
    [sym_call_signature] = STATE(4759),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(9293),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [4472] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(374),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(4761),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(4762),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(2097),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(2099),
    [anon_sym_symbol] = ACTIONS(2099),
    [anon_sym_number] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2099),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2101),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2099),
    [anon_sym_private] = ACTIONS(2099),
    [anon_sym_boolean] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2099),
    [anon_sym_get] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(2099),
    [anon_sym_string] = ACTIONS(2099),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(2099),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(2099),
    [anon_sym_export] = ACTIONS(2099),
    [anon_sym_namespace] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4473] = {
    [sym_formal_parameters] = STATE(4763),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4474] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(9295),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4475] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6249),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_SEMI] = ACTIONS(5194),
    [sym__automatic_semicolon] = ACTIONS(5194),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6249),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(6249),
    [anon_sym_AMP] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5194),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(6252),
  },
  [4476] = {
    [sym_identifier] = ACTIONS(9298),
    [sym_comment] = ACTIONS(3),
  },
  [4477] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(9300),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4478] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4768),
    [sym_constructor_type] = STATE(4768),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(4768),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4768),
    [sym_intersection_type] = STATE(4768),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4479] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4771),
    [sym_constructor_type] = STATE(4771),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(4771),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4771),
    [sym_intersection_type] = STATE(4771),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4480] = {
    [anon_sym_EQ_GT] = ACTIONS(9309),
    [sym_comment] = ACTIONS(3),
  },
  [4481] = {
    [sym_formal_parameters] = STATE(4773),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4482] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4055),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4057),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8148),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8150),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4483] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4055),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4057),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8148),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8150),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4484] = {
    [anon_sym_EQ_GT] = ACTIONS(9311),
    [sym_comment] = ACTIONS(3),
  },
  [4485] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4775),
    [sym_constructor_type] = STATE(4775),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(4775),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4775),
    [sym_intersection_type] = STATE(4775),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4486] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4776),
    [sym_constructor_type] = STATE(4776),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(4776),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4776),
    [sym_intersection_type] = STATE(4776),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4055),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4057),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8148),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8150),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4487] = {
    [sym_string] = STATE(4777),
    [sym__property_name] = STATE(4777),
    [sym_computed_property_name] = STATE(4777),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1198),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1198),
    [sym_number] = ACTIONS(9313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [4488] = {
    [sym_string] = STATE(4777),
    [sym__property_name] = STATE(4777),
    [sym_computed_property_name] = STATE(4777),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(9313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_async] = ACTIONS(1214),
  },
  [4489] = {
    [sym_call_signature] = STATE(4759),
    [sym_type_annotation] = STATE(4459),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [sym__automatic_semicolon] = ACTIONS(8801),
    [anon_sym_RBRACE] = ACTIONS(8801),
    [anon_sym_COLON] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(8801),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8801),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(8801),
    [sym_comment] = ACTIONS(3),
  },
  [4490] = {
    [anon_sym_EQ_GT] = ACTIONS(9315),
    [sym_comment] = ACTIONS(3),
  },
  [4491] = {
    [sym_formal_parameters] = STATE(4779),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4492] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4493] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4494] = {
    [anon_sym_EQ_GT] = ACTIONS(9317),
    [sym_comment] = ACTIONS(3),
  },
  [4495] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4781),
    [sym_constructor_type] = STATE(4781),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(4781),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4781),
    [sym_intersection_type] = STATE(4781),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4496] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(7000),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(7002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6909),
  },
  [4497] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4782),
    [sym_constructor_type] = STATE(4782),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(4782),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4782),
    [sym_intersection_type] = STATE(4782),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2621),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2623),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4498] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(7000),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(7002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6986),
  },
  [4499] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4783),
    [sym_constructor_type] = STATE(4783),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(4783),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4783),
    [sym_intersection_type] = STATE(4783),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4500] = {
    [anon_sym_EQ_GT] = ACTIONS(9319),
    [sym_comment] = ACTIONS(3),
  },
  [4501] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4785),
    [sym_constructor_type] = STATE(4785),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(4785),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4785),
    [sym_intersection_type] = STATE(4785),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4502] = {
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(8170),
    [anon_sym_PIPE] = ACTIONS(8172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5425),
  },
  [4503] = {
    [anon_sym_AMP] = ACTIONS(5453),
    [anon_sym_PIPE] = ACTIONS(5455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8086),
  },
  [4504] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(8180),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4505] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8885),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8887),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4506] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4786),
    [sym_constructor_type] = STATE(4786),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(2675),
    [sym_function_type] = STATE(4786),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4786),
    [sym_intersection_type] = STATE(4786),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(2674),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(2676),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(5561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4507] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8885),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(8887),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4508] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(6255),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(8310),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(8310),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2063),
  },
  [4509] = {
    [anon_sym_of] = ACTIONS(9321),
    [sym_comment] = ACTIONS(3),
  },
  [4510] = {
    [anon_sym_of] = ACTIONS(9323),
    [sym_comment] = ACTIONS(3),
  },
  [4511] = {
    [anon_sym_of] = ACTIONS(9325),
    [sym_comment] = ACTIONS(3),
  },
  [4512] = {
    [sym_new_expression] = STATE(4790),
    [sym_augmented_assignment_expression] = STATE(4790),
    [sym_unary_expression] = STATE(4790),
    [sym_update_expression] = STATE(4790),
    [sym_regex] = STATE(4790),
    [sym_meta_property] = STATE(4790),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4790),
    [sym_yield_expression] = STATE(4790),
    [sym_as_expression] = STATE(4790),
    [sym_non_null_expression] = STATE(4790),
    [sym_internal_module] = STATE(4790),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4790),
    [sym_await_expression] = STATE(4790),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4790),
    [sym_this] = STATE(4790),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4790),
    [sym_generator_function] = STATE(4790),
    [sym_call_expression] = STATE(4790),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4790),
    [sym_ternary_expression] = STATE(4790),
    [sym_binary_expression] = STATE(4790),
    [sym_template_string] = STATE(4790),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4790),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4790),
    [sym_class] = STATE(4790),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9327),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9327),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9329),
    [sym_true] = ACTIONS(9327),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9327),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4513] = {
    [sym_new_expression] = STATE(4791),
    [sym_augmented_assignment_expression] = STATE(4791),
    [sym_unary_expression] = STATE(4791),
    [sym_update_expression] = STATE(4791),
    [sym_regex] = STATE(4791),
    [sym_meta_property] = STATE(4791),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4791),
    [sym_yield_expression] = STATE(4791),
    [sym_as_expression] = STATE(4791),
    [sym_non_null_expression] = STATE(4791),
    [sym_internal_module] = STATE(4791),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4791),
    [sym_await_expression] = STATE(4791),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4791),
    [sym_this] = STATE(4791),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4791),
    [sym_generator_function] = STATE(4791),
    [sym_call_expression] = STATE(4791),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4791),
    [sym_ternary_expression] = STATE(4791),
    [sym_binary_expression] = STATE(4791),
    [sym_template_string] = STATE(4791),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4791),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4791),
    [sym_class] = STATE(4791),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9331),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9331),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9333),
    [sym_true] = ACTIONS(9331),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9331),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4514] = {
    [sym_new_expression] = STATE(4792),
    [sym_augmented_assignment_expression] = STATE(4792),
    [sym_unary_expression] = STATE(4792),
    [sym_update_expression] = STATE(4792),
    [sym_regex] = STATE(4792),
    [sym_meta_property] = STATE(4792),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4792),
    [sym_yield_expression] = STATE(4792),
    [sym_as_expression] = STATE(4792),
    [sym_non_null_expression] = STATE(4792),
    [sym_internal_module] = STATE(4792),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4792),
    [sym_await_expression] = STATE(4792),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4792),
    [sym_this] = STATE(4792),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4792),
    [sym_generator_function] = STATE(4792),
    [sym_call_expression] = STATE(4792),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4792),
    [sym_ternary_expression] = STATE(4792),
    [sym_binary_expression] = STATE(4792),
    [sym_template_string] = STATE(4792),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4792),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4792),
    [sym_class] = STATE(4792),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9335),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9335),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9337),
    [sym_true] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9335),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4515] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9339),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [4516] = {
    [anon_sym_RPAREN] = ACTIONS(9339),
    [sym_comment] = ACTIONS(3),
  },
  [4517] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9341),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4518] = {
    [sym_new_expression] = STATE(4795),
    [sym_augmented_assignment_expression] = STATE(4795),
    [sym_unary_expression] = STATE(4795),
    [sym_update_expression] = STATE(4795),
    [sym_regex] = STATE(4795),
    [sym_meta_property] = STATE(4795),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4795),
    [sym_yield_expression] = STATE(4795),
    [sym_as_expression] = STATE(4795),
    [sym_non_null_expression] = STATE(4795),
    [sym_internal_module] = STATE(4795),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4795),
    [sym_await_expression] = STATE(4795),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4796),
    [sym_string] = STATE(4795),
    [sym_this] = STATE(4795),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4795),
    [sym_generator_function] = STATE(4795),
    [sym_call_expression] = STATE(4795),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4795),
    [sym_ternary_expression] = STATE(4795),
    [sym_binary_expression] = STATE(4795),
    [sym_template_string] = STATE(4795),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4795),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4795),
    [sym_class] = STATE(4795),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9343),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9343),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9345),
    [sym_true] = ACTIONS(9343),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9343),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4519] = {
    [sym_new_expression] = STATE(4797),
    [sym_augmented_assignment_expression] = STATE(4797),
    [sym_unary_expression] = STATE(4797),
    [sym_update_expression] = STATE(4797),
    [sym_regex] = STATE(4797),
    [sym_meta_property] = STATE(4797),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4797),
    [sym_yield_expression] = STATE(4797),
    [sym_as_expression] = STATE(4797),
    [sym_non_null_expression] = STATE(4797),
    [sym_internal_module] = STATE(4797),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4797),
    [sym_await_expression] = STATE(4797),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4798),
    [sym_string] = STATE(4797),
    [sym_this] = STATE(4797),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4797),
    [sym_generator_function] = STATE(4797),
    [sym_call_expression] = STATE(4797),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4797),
    [sym_ternary_expression] = STATE(4797),
    [sym_binary_expression] = STATE(4797),
    [sym_template_string] = STATE(4797),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4797),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4797),
    [sym_class] = STATE(4797),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9347),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9347),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9349),
    [sym_true] = ACTIONS(9347),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9347),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4520] = {
    [sym_new_expression] = STATE(4799),
    [sym_augmented_assignment_expression] = STATE(4799),
    [sym_unary_expression] = STATE(4799),
    [sym_update_expression] = STATE(4799),
    [sym_regex] = STATE(4799),
    [sym_meta_property] = STATE(4799),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4799),
    [sym_yield_expression] = STATE(4799),
    [sym_as_expression] = STATE(4799),
    [sym_non_null_expression] = STATE(4799),
    [sym_internal_module] = STATE(4799),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4799),
    [sym_await_expression] = STATE(4799),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4800),
    [sym_string] = STATE(4799),
    [sym_this] = STATE(4799),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4799),
    [sym_generator_function] = STATE(4799),
    [sym_call_expression] = STATE(4799),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4799),
    [sym_ternary_expression] = STATE(4799),
    [sym_binary_expression] = STATE(4799),
    [sym_template_string] = STATE(4799),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4799),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4799),
    [sym_class] = STATE(4799),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9351),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9351),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9353),
    [sym_true] = ACTIONS(9351),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9351),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4521] = {
    [sym_type_alias_declaration] = STATE(3004),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3004),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3004),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3004),
    [sym_return_statement] = STATE(3004),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3004),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3004),
    [sym_switch_statement] = STATE(3004),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3004),
    [sym_throw_statement] = STATE(3004),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3004),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3004),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(3004),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3004),
    [sym_abstract_class] = STATE(3004),
    [sym_interface_declaration] = STATE(3004),
    [sym_statement_block] = STATE(3004),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3004),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3004),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3004),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3004),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3004),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3004),
    [sym_empty_statement] = STATE(3004),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(3004),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3004),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3004),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3004),
    [sym_break_statement] = STATE(3004),
    [sym_labeled_statement] = STATE(3004),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3004),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4522] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9355),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4523] = {
    [anon_sym_RPAREN] = ACTIONS(9355),
    [sym_comment] = ACTIONS(3),
  },
  [4524] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9357),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4525] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9359),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [4526] = {
    [anon_sym_RPAREN] = ACTIONS(9359),
    [sym_comment] = ACTIONS(3),
  },
  [4527] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9361),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4528] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9363),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [4529] = {
    [anon_sym_RPAREN] = ACTIONS(9363),
    [sym_comment] = ACTIONS(3),
  },
  [4530] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4811),
    [sym_constructor_type] = STATE(4811),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(4811),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4811),
    [sym_intersection_type] = STATE(4811),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4812),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4814),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9369),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9371),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4531] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9375),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4532] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9377),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4533] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9379),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4534] = {
    [sym_type_alias_declaration] = STATE(4231),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4231),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4231),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4231),
    [sym_return_statement] = STATE(4231),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4231),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4231),
    [sym_switch_statement] = STATE(4231),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4231),
    [sym_throw_statement] = STATE(4231),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4231),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4231),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(4231),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4231),
    [sym_abstract_class] = STATE(4231),
    [sym_interface_declaration] = STATE(4231),
    [sym_statement_block] = STATE(4231),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4231),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4231),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4231),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4231),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4231),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4231),
    [sym_empty_statement] = STATE(4231),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(4231),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4231),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4231),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4231),
    [sym_break_statement] = STATE(4231),
    [sym_labeled_statement] = STATE(4231),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4231),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4535] = {
    [sym_type_alias_declaration] = STATE(4232),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4232),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4232),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4232),
    [sym_return_statement] = STATE(4232),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4232),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4232),
    [sym_switch_statement] = STATE(4232),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4232),
    [sym_throw_statement] = STATE(4232),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4232),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4232),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(4232),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4232),
    [sym_abstract_class] = STATE(4232),
    [sym_interface_declaration] = STATE(4232),
    [sym_statement_block] = STATE(4232),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4232),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4232),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4232),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4232),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4232),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4232),
    [sym_empty_statement] = STATE(4232),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(4232),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4232),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4232),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4232),
    [sym_break_statement] = STATE(4232),
    [sym_labeled_statement] = STATE(4232),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4232),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4536] = {
    [sym_type_alias_declaration] = STATE(4233),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4233),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4233),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4233),
    [sym_return_statement] = STATE(4233),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4233),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4233),
    [sym_switch_statement] = STATE(4233),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4233),
    [sym_throw_statement] = STATE(4233),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4233),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4233),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(4233),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4233),
    [sym_abstract_class] = STATE(4233),
    [sym_interface_declaration] = STATE(4233),
    [sym_statement_block] = STATE(4233),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4233),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4233),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4233),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4233),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4233),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4233),
    [sym_empty_statement] = STATE(4233),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(4233),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4233),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4233),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4233),
    [sym_break_statement] = STATE(4233),
    [sym_labeled_statement] = STATE(4233),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4233),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4537] = {
    [sym_type_alias_declaration] = STATE(4262),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4262),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4262),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4262),
    [sym_return_statement] = STATE(4262),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4262),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4262),
    [sym_switch_statement] = STATE(4262),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4262),
    [sym_throw_statement] = STATE(4262),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4262),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4262),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(4262),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4262),
    [sym_abstract_class] = STATE(4262),
    [sym_interface_declaration] = STATE(4262),
    [sym_statement_block] = STATE(4262),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4262),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4262),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4262),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4262),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4262),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4262),
    [sym_empty_statement] = STATE(4262),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(4262),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4262),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4262),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4262),
    [sym_break_statement] = STATE(4262),
    [sym_labeled_statement] = STATE(4262),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4262),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4538] = {
    [sym_type_alias_declaration] = STATE(4263),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4263),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4263),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4263),
    [sym_return_statement] = STATE(4263),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4263),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4263),
    [sym_switch_statement] = STATE(4263),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4263),
    [sym_throw_statement] = STATE(4263),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4263),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4263),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(4263),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4263),
    [sym_abstract_class] = STATE(4263),
    [sym_interface_declaration] = STATE(4263),
    [sym_statement_block] = STATE(4263),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4263),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4263),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4263),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4263),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4263),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4263),
    [sym_empty_statement] = STATE(4263),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(4263),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4263),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4263),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4263),
    [sym_break_statement] = STATE(4263),
    [sym_labeled_statement] = STATE(4263),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4263),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4539] = {
    [sym_type_alias_declaration] = STATE(4264),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4264),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4264),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4264),
    [sym_return_statement] = STATE(4264),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4264),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4264),
    [sym_switch_statement] = STATE(4264),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4264),
    [sym_throw_statement] = STATE(4264),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4264),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4264),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(4264),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4264),
    [sym_abstract_class] = STATE(4264),
    [sym_interface_declaration] = STATE(4264),
    [sym_statement_block] = STATE(4264),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4264),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4264),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4264),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4264),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4264),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4264),
    [sym_empty_statement] = STATE(4264),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(4264),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4264),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4264),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4264),
    [sym_break_statement] = STATE(4264),
    [sym_labeled_statement] = STATE(4264),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4264),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4540] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4821),
    [sym_constructor_type] = STATE(4821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(4821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4821),
    [sym_intersection_type] = STATE(4821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4541] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4824),
    [sym_constructor_type] = STATE(4824),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(4824),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4824),
    [sym_intersection_type] = STATE(4824),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4542] = {
    [anon_sym_EQ_GT] = ACTIONS(9387),
    [sym_comment] = ACTIONS(3),
  },
  [4543] = {
    [sym_formal_parameters] = STATE(4826),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4544] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4139),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4141),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4545] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4139),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4141),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4546] = {
    [anon_sym_EQ_GT] = ACTIONS(9389),
    [sym_comment] = ACTIONS(3),
  },
  [4547] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4828),
    [sym_constructor_type] = STATE(4828),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(4828),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4828),
    [sym_intersection_type] = STATE(4828),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4548] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(4829),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(4829),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4829),
    [sym_intersection_type] = STATE(4829),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4139),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4141),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4549] = {
    [anon_sym_EQ_GT] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(7145),
    [anon_sym_PIPE] = ACTIONS(7147),
    [sym_comment] = ACTIONS(3),
  },
  [4550] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4830),
    [sym_constructor_type] = STATE(4830),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(943),
    [sym_function_type] = STATE(4830),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4830),
    [sym_intersection_type] = STATE(4830),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2727),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2728),
    [sym_identifier] = ACTIONS(1900),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(1902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4551] = {
    [anon_sym_EQ_GT] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(7145),
    [anon_sym_PIPE] = ACTIONS(7147),
    [sym_comment] = ACTIONS(3),
  },
  [4552] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8977),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8979),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4553] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4831),
    [sym_constructor_type] = STATE(4831),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_function_type] = STATE(4831),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4831),
    [sym_intersection_type] = STATE(4831),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2753),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2755),
    [sym_identifier] = ACTIONS(5696),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4554] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8977),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(8979),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6986),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4555] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6984),
    [anon_sym_LBRACK] = ACTIONS(6984),
    [anon_sym_BANG] = ACTIONS(6982),
    [anon_sym_SEMI] = ACTIONS(6984),
    [anon_sym_BQUOTE] = ACTIONS(6984),
    [sym__automatic_semicolon] = ACTIONS(6984),
    [anon_sym_PIPE] = ACTIONS(6982),
    [anon_sym_COMMA] = ACTIONS(6984),
    [anon_sym_LT_LT] = ACTIONS(6984),
    [anon_sym_STAR] = ACTIONS(6982),
    [anon_sym_GT_GT_GT] = ACTIONS(6984),
    [anon_sym_AMP_AMP] = ACTIONS(6984),
    [anon_sym_DASH] = ACTIONS(6982),
    [anon_sym_BANG_EQ] = ACTIONS(6982),
    [anon_sym_LT_EQ] = ACTIONS(6984),
    [anon_sym_LPAREN] = ACTIONS(6984),
    [anon_sym_GT_EQ] = ACTIONS(6984),
    [anon_sym_GT] = ACTIONS(6982),
    [anon_sym_AMP] = ACTIONS(6982),
    [anon_sym_PERCENT] = ACTIONS(6984),
    [anon_sym_QMARK] = ACTIONS(6984),
    [anon_sym_RBRACE] = ACTIONS(6984),
    [anon_sym_as] = ACTIONS(6984),
    [anon_sym_PIPE_PIPE] = ACTIONS(6984),
    [anon_sym_DASH_DASH] = ACTIONS(6984),
    [anon_sym_EQ_EQ] = ACTIONS(6982),
    [anon_sym_instanceof] = ACTIONS(6984),
    [anon_sym_LT] = ACTIONS(6982),
    [anon_sym_RPAREN] = ACTIONS(6984),
    [anon_sym_SLASH] = ACTIONS(6982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6984),
    [anon_sym_CARET] = ACTIONS(6984),
    [anon_sym_STAR_STAR] = ACTIONS(6984),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_GT_GT] = ACTIONS(6982),
    [anon_sym_PLUS_PLUS] = ACTIONS(6984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6984),
    [anon_sym_in] = ACTIONS(6982),
  },
  [4556] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8795),
    [anon_sym_LBRACK] = ACTIONS(8795),
    [anon_sym_BANG] = ACTIONS(8793),
    [anon_sym_SEMI] = ACTIONS(8795),
    [anon_sym_BQUOTE] = ACTIONS(8795),
    [sym__automatic_semicolon] = ACTIONS(8795),
    [anon_sym_PIPE] = ACTIONS(8793),
    [anon_sym_COMMA] = ACTIONS(8795),
    [anon_sym_LT_LT] = ACTIONS(8795),
    [anon_sym_STAR] = ACTIONS(8793),
    [anon_sym_GT_GT_GT] = ACTIONS(8795),
    [anon_sym_AMP_AMP] = ACTIONS(8795),
    [anon_sym_DASH] = ACTIONS(8793),
    [anon_sym_BANG_EQ] = ACTIONS(8793),
    [anon_sym_LT_EQ] = ACTIONS(8795),
    [anon_sym_LPAREN] = ACTIONS(8795),
    [anon_sym_GT_EQ] = ACTIONS(8795),
    [anon_sym_GT] = ACTIONS(8793),
    [anon_sym_AMP] = ACTIONS(8793),
    [anon_sym_PERCENT] = ACTIONS(8795),
    [anon_sym_QMARK] = ACTIONS(8795),
    [anon_sym_RBRACE] = ACTIONS(8795),
    [anon_sym_as] = ACTIONS(8795),
    [anon_sym_PIPE_PIPE] = ACTIONS(8795),
    [anon_sym_DASH_DASH] = ACTIONS(8795),
    [anon_sym_EQ_EQ] = ACTIONS(8793),
    [anon_sym_instanceof] = ACTIONS(8795),
    [anon_sym_LT] = ACTIONS(8793),
    [anon_sym_RPAREN] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8795),
    [anon_sym_CARET] = ACTIONS(8795),
    [anon_sym_STAR_STAR] = ACTIONS(8795),
    [anon_sym_PLUS] = ACTIONS(8793),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8795),
    [anon_sym_GT_GT] = ACTIONS(8793),
    [anon_sym_PLUS_PLUS] = ACTIONS(8795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8795),
    [anon_sym_in] = ACTIONS(8793),
  },
  [4557] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(9391),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4558] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8325),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_RBRACE] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(8327),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4559] = {
    [anon_sym_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(7253),
    [anon_sym_SEMI] = ACTIONS(6909),
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(7255),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [4560] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4832),
    [sym_constructor_type] = STATE(4832),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1064),
    [sym_function_type] = STATE(4832),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4832),
    [sym_intersection_type] = STATE(4832),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2819),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2820),
    [sym_identifier] = ACTIONS(2185),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4561] = {
    [anon_sym_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(7253),
    [anon_sym_SEMI] = ACTIONS(6986),
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(7255),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [4562] = {
    [anon_sym_EQ] = ACTIONS(6984),
    [anon_sym_LBRACK] = ACTIONS(6984),
    [anon_sym_AMP] = ACTIONS(6984),
    [anon_sym_SEMI] = ACTIONS(6984),
    [sym__automatic_semicolon] = ACTIONS(6984),
    [anon_sym_RBRACE] = ACTIONS(6984),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6984),
    [anon_sym_PIPE] = ACTIONS(6982),
    [anon_sym_COMMA] = ACTIONS(6984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6984),
  },
  [4563] = {
    [anon_sym_EQ] = ACTIONS(8795),
    [anon_sym_LBRACK] = ACTIONS(8795),
    [anon_sym_AMP] = ACTIONS(8795),
    [anon_sym_SEMI] = ACTIONS(8795),
    [sym__automatic_semicolon] = ACTIONS(8795),
    [anon_sym_RBRACE] = ACTIONS(8795),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8795),
    [anon_sym_PIPE] = ACTIONS(8793),
    [anon_sym_COMMA] = ACTIONS(8795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8795),
  },
  [4564] = {
    [anon_sym_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(7277),
    [anon_sym_PIPE] = ACTIONS(7279),
    [sym_comment] = ACTIONS(3),
  },
  [4565] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4833),
    [sym_constructor_type] = STATE(4833),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1087),
    [sym_function_type] = STATE(4833),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4833),
    [sym_intersection_type] = STATE(4833),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(2847),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(2848),
    [sym_identifier] = ACTIONS(2233),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4566] = {
    [anon_sym_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(7277),
    [anon_sym_PIPE] = ACTIONS(7279),
    [sym_comment] = ACTIONS(3),
  },
  [4567] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8347),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4568] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9008),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(8300),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(9010),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4569] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4834),
    [sym_constructor_type] = STATE(4834),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(2889),
    [sym_function_type] = STATE(4834),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4834),
    [sym_intersection_type] = STATE(4834),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(2888),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(2890),
    [sym_identifier] = ACTIONS(5936),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4570] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9008),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_LBRACE] = ACTIONS(8302),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(9010),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4571] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9394),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4572] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9396),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4573] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9398),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4574] = {
    [sym_type_alias_declaration] = STATE(4231),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4231),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4231),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4231),
    [sym_return_statement] = STATE(4231),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4231),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4231),
    [sym_switch_statement] = STATE(4231),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4231),
    [sym_throw_statement] = STATE(4231),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4231),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4231),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(4231),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4231),
    [sym_abstract_class] = STATE(4231),
    [sym_interface_declaration] = STATE(4231),
    [sym_statement_block] = STATE(4231),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4231),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4231),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4231),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4231),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4231),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4231),
    [sym_empty_statement] = STATE(4231),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(4231),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4231),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4231),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4231),
    [sym_break_statement] = STATE(4231),
    [sym_labeled_statement] = STATE(4231),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4231),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4575] = {
    [sym_type_alias_declaration] = STATE(4232),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4232),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4232),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4232),
    [sym_return_statement] = STATE(4232),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4232),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4232),
    [sym_switch_statement] = STATE(4232),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4232),
    [sym_throw_statement] = STATE(4232),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4232),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4232),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(4232),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4232),
    [sym_abstract_class] = STATE(4232),
    [sym_interface_declaration] = STATE(4232),
    [sym_statement_block] = STATE(4232),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4232),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4232),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4232),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4232),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4232),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4232),
    [sym_empty_statement] = STATE(4232),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(4232),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4232),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4232),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4232),
    [sym_break_statement] = STATE(4232),
    [sym_labeled_statement] = STATE(4232),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4232),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4576] = {
    [sym_type_alias_declaration] = STATE(4233),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4233),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4233),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4233),
    [sym_return_statement] = STATE(4233),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4233),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4233),
    [sym_switch_statement] = STATE(4233),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4233),
    [sym_throw_statement] = STATE(4233),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4233),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4233),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(4233),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4233),
    [sym_abstract_class] = STATE(4233),
    [sym_interface_declaration] = STATE(4233),
    [sym_statement_block] = STATE(4233),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4233),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4233),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4233),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4233),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4233),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4233),
    [sym_empty_statement] = STATE(4233),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(4233),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4233),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4233),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4233),
    [sym_break_statement] = STATE(4233),
    [sym_labeled_statement] = STATE(4233),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4233),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4577] = {
    [sym_type_alias_declaration] = STATE(4262),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4262),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4262),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4262),
    [sym_return_statement] = STATE(4262),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4262),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4262),
    [sym_switch_statement] = STATE(4262),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4262),
    [sym_throw_statement] = STATE(4262),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4262),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4262),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(4262),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4262),
    [sym_abstract_class] = STATE(4262),
    [sym_interface_declaration] = STATE(4262),
    [sym_statement_block] = STATE(4262),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4262),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4262),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4262),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4262),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4262),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4262),
    [sym_empty_statement] = STATE(4262),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(4262),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4262),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4262),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4262),
    [sym_break_statement] = STATE(4262),
    [sym_labeled_statement] = STATE(4262),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4262),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4578] = {
    [sym_type_alias_declaration] = STATE(4263),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4263),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4263),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4263),
    [sym_return_statement] = STATE(4263),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4263),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4263),
    [sym_switch_statement] = STATE(4263),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4263),
    [sym_throw_statement] = STATE(4263),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4263),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4263),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(4263),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4263),
    [sym_abstract_class] = STATE(4263),
    [sym_interface_declaration] = STATE(4263),
    [sym_statement_block] = STATE(4263),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4263),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4263),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4263),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4263),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4263),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4263),
    [sym_empty_statement] = STATE(4263),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(4263),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4263),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4263),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4263),
    [sym_break_statement] = STATE(4263),
    [sym_labeled_statement] = STATE(4263),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4263),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4579] = {
    [sym_type_alias_declaration] = STATE(4264),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4264),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4264),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4264),
    [sym_return_statement] = STATE(4264),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4264),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4264),
    [sym_switch_statement] = STATE(4264),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4264),
    [sym_throw_statement] = STATE(4264),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4264),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4264),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(4264),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4264),
    [sym_abstract_class] = STATE(4264),
    [sym_interface_declaration] = STATE(4264),
    [sym_statement_block] = STATE(4264),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4264),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4264),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4264),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4264),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4264),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4264),
    [sym_empty_statement] = STATE(4264),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(4264),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4264),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4264),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4264),
    [sym_break_statement] = STATE(4264),
    [sym_labeled_statement] = STATE(4264),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4264),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4580] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4838),
    [sym_constructor_type] = STATE(4838),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(4838),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4838),
    [sym_intersection_type] = STATE(4838),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4581] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4839),
    [sym_constructor_type] = STATE(4839),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(4839),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4839),
    [sym_intersection_type] = STATE(4839),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4582] = {
    [anon_sym_EQ_GT] = ACTIONS(9400),
    [sym_comment] = ACTIONS(3),
  },
  [4583] = {
    [sym_formal_parameters] = STATE(4841),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4584] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4585] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4586] = {
    [anon_sym_EQ_GT] = ACTIONS(9402),
    [sym_comment] = ACTIONS(3),
  },
  [4587] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4843),
    [sym_constructor_type] = STATE(4843),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(4843),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4843),
    [sym_intersection_type] = STATE(4843),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4588] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4844),
    [sym_constructor_type] = STATE(4844),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(4844),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4844),
    [sym_intersection_type] = STATE(4844),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4589] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(7392),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(7394),
    [sym_comment] = ACTIONS(3),
  },
  [4590] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4845),
    [sym_constructor_type] = STATE(4845),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(1171),
    [sym_function_type] = STATE(4845),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4845),
    [sym_intersection_type] = STATE(4845),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(2925),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(2926),
    [sym_identifier] = ACTIONS(2413),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6012),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4591] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(7392),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(7394),
    [sym_comment] = ACTIONS(3),
  },
  [4592] = {
    [sym_identifier] = ACTIONS(9404),
    [anon_sym_BQUOTE] = ACTIONS(9406),
    [anon_sym_debugger] = ACTIONS(9404),
    [anon_sym_symbol] = ACTIONS(9404),
    [anon_sym_AT] = ACTIONS(9406),
    [anon_sym_DASH] = ACTIONS(9404),
    [anon_sym_void] = ACTIONS(9404),
    [anon_sym_break] = ACTIONS(9404),
    [anon_sym_const] = ACTIONS(9404),
    [sym_super] = ACTIONS(9404),
    [anon_sym_return] = ACTIONS(9404),
    [anon_sym_private] = ACTIONS(9404),
    [anon_sym_get] = ACTIONS(9404),
    [anon_sym_RBRACE] = ACTIONS(9406),
    [anon_sym_interface] = ACTIONS(9404),
    [anon_sym_default] = ACTIONS(9404),
    [anon_sym_enum] = ACTIONS(9404),
    [anon_sym_delete] = ACTIONS(9404),
    [anon_sym_continue] = ACTIONS(9404),
    [anon_sym_DASH_DASH] = ACTIONS(9406),
    [anon_sym_if] = ACTIONS(9404),
    [anon_sym_this] = ACTIONS(9404),
    [anon_sym_yield] = ACTIONS(9404),
    [sym_true] = ACTIONS(9404),
    [anon_sym_throw] = ACTIONS(9404),
    [anon_sym_protected] = ACTIONS(9404),
    [anon_sym_abstract] = ACTIONS(9404),
    [anon_sym_set] = ACTIONS(9404),
    [anon_sym_type] = ACTIONS(9404),
    [anon_sym_import] = ACTIONS(9404),
    [anon_sym_namespace] = ACTIONS(9404),
    [anon_sym_PLUS_PLUS] = ACTIONS(9406),
    [anon_sym_await] = ACTIONS(9404),
    [anon_sym_DQUOTE] = ACTIONS(9406),
    [anon_sym_else] = ACTIONS(9404),
    [anon_sym_BANG] = ACTIONS(9406),
    [anon_sym_for] = ACTIONS(9404),
    [anon_sym_LBRACK] = ACTIONS(9406),
    [sym_false] = ACTIONS(9404),
    [anon_sym_SEMI] = ACTIONS(9406),
    [anon_sym_case] = ACTIONS(9404),
    [anon_sym_module] = ACTIONS(9404),
    [anon_sym_number] = ACTIONS(9404),
    [anon_sym_class] = ACTIONS(9404),
    [anon_sym_declare] = ACTIONS(9404),
    [anon_sym_typeof] = ACTIONS(9404),
    [anon_sym_LBRACE] = ACTIONS(9406),
    [anon_sym_switch] = ACTIONS(9404),
    [anon_sym_LPAREN] = ACTIONS(9406),
    [sym_null] = ACTIONS(9404),
    [anon_sym_any] = ACTIONS(9404),
    [anon_sym_boolean] = ACTIONS(9404),
    [anon_sym_async] = ACTIONS(9404),
    [anon_sym_public] = ACTIONS(9404),
    [anon_sym_var] = ACTIONS(9404),
    [anon_sym_while] = ACTIONS(9404),
    [anon_sym_SQUOTE] = ACTIONS(9406),
    [anon_sym_try] = ACTIONS(9404),
    [anon_sym_LT] = ACTIONS(9406),
    [sym_number] = ACTIONS(9406),
    [anon_sym_SLASH] = ACTIONS(9404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9404),
    [anon_sym_function] = ACTIONS(9404),
    [sym_undefined] = ACTIONS(9404),
    [anon_sym_new] = ACTIONS(9404),
    [ts_builtin_sym_end] = ACTIONS(9406),
    [anon_sym_let] = ACTIONS(9404),
    [anon_sym_PLUS] = ACTIONS(9404),
    [anon_sym_export] = ACTIONS(9404),
    [anon_sym_do] = ACTIONS(9404),
    [anon_sym_TILDE] = ACTIONS(9406),
    [anon_sym_with] = ACTIONS(9404),
  },
  [4593] = {
    [sym_identifier] = ACTIONS(9408),
    [anon_sym_BQUOTE] = ACTIONS(9410),
    [anon_sym_debugger] = ACTIONS(9408),
    [anon_sym_symbol] = ACTIONS(9408),
    [anon_sym_AT] = ACTIONS(9410),
    [anon_sym_DASH] = ACTIONS(9408),
    [anon_sym_void] = ACTIONS(9408),
    [anon_sym_break] = ACTIONS(9408),
    [anon_sym_const] = ACTIONS(9408),
    [sym_super] = ACTIONS(9408),
    [anon_sym_return] = ACTIONS(9408),
    [anon_sym_private] = ACTIONS(9408),
    [anon_sym_get] = ACTIONS(9408),
    [anon_sym_RBRACE] = ACTIONS(9410),
    [anon_sym_interface] = ACTIONS(9408),
    [anon_sym_default] = ACTIONS(9408),
    [anon_sym_enum] = ACTIONS(9408),
    [anon_sym_delete] = ACTIONS(9408),
    [anon_sym_continue] = ACTIONS(9408),
    [anon_sym_DASH_DASH] = ACTIONS(9410),
    [anon_sym_if] = ACTIONS(9408),
    [anon_sym_this] = ACTIONS(9408),
    [anon_sym_yield] = ACTIONS(9408),
    [sym_true] = ACTIONS(9408),
    [anon_sym_throw] = ACTIONS(9408),
    [anon_sym_protected] = ACTIONS(9408),
    [anon_sym_abstract] = ACTIONS(9408),
    [anon_sym_set] = ACTIONS(9408),
    [anon_sym_type] = ACTIONS(9408),
    [anon_sym_import] = ACTIONS(9408),
    [anon_sym_namespace] = ACTIONS(9408),
    [anon_sym_PLUS_PLUS] = ACTIONS(9410),
    [anon_sym_await] = ACTIONS(9408),
    [anon_sym_DQUOTE] = ACTIONS(9410),
    [anon_sym_else] = ACTIONS(9408),
    [anon_sym_BANG] = ACTIONS(9410),
    [anon_sym_for] = ACTIONS(9408),
    [anon_sym_LBRACK] = ACTIONS(9410),
    [sym_false] = ACTIONS(9408),
    [anon_sym_SEMI] = ACTIONS(9410),
    [anon_sym_case] = ACTIONS(9408),
    [anon_sym_module] = ACTIONS(9408),
    [anon_sym_number] = ACTIONS(9408),
    [anon_sym_class] = ACTIONS(9408),
    [anon_sym_declare] = ACTIONS(9408),
    [anon_sym_typeof] = ACTIONS(9408),
    [anon_sym_LBRACE] = ACTIONS(9410),
    [anon_sym_switch] = ACTIONS(9408),
    [anon_sym_LPAREN] = ACTIONS(9410),
    [sym_null] = ACTIONS(9408),
    [anon_sym_any] = ACTIONS(9408),
    [anon_sym_boolean] = ACTIONS(9408),
    [anon_sym_async] = ACTIONS(9408),
    [anon_sym_public] = ACTIONS(9408),
    [anon_sym_var] = ACTIONS(9408),
    [anon_sym_while] = ACTIONS(9408),
    [anon_sym_SQUOTE] = ACTIONS(9410),
    [anon_sym_try] = ACTIONS(9408),
    [anon_sym_LT] = ACTIONS(9410),
    [sym_number] = ACTIONS(9410),
    [anon_sym_SLASH] = ACTIONS(9408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9408),
    [anon_sym_function] = ACTIONS(9408),
    [sym_undefined] = ACTIONS(9408),
    [anon_sym_new] = ACTIONS(9408),
    [ts_builtin_sym_end] = ACTIONS(9410),
    [anon_sym_let] = ACTIONS(9408),
    [anon_sym_PLUS] = ACTIONS(9408),
    [anon_sym_export] = ACTIONS(9408),
    [anon_sym_do] = ACTIONS(9408),
    [anon_sym_TILDE] = ACTIONS(9410),
    [anon_sym_with] = ACTIONS(9408),
  },
  [4594] = {
    [sym_identifier] = ACTIONS(9412),
    [anon_sym_BQUOTE] = ACTIONS(9414),
    [anon_sym_debugger] = ACTIONS(9412),
    [anon_sym_symbol] = ACTIONS(9412),
    [anon_sym_AT] = ACTIONS(9414),
    [anon_sym_DASH] = ACTIONS(9412),
    [anon_sym_void] = ACTIONS(9412),
    [anon_sym_break] = ACTIONS(9412),
    [anon_sym_const] = ACTIONS(9412),
    [sym_super] = ACTIONS(9412),
    [anon_sym_return] = ACTIONS(9412),
    [anon_sym_private] = ACTIONS(9412),
    [anon_sym_get] = ACTIONS(9412),
    [anon_sym_RBRACE] = ACTIONS(9414),
    [anon_sym_interface] = ACTIONS(9412),
    [anon_sym_default] = ACTIONS(9412),
    [anon_sym_enum] = ACTIONS(9412),
    [anon_sym_delete] = ACTIONS(9412),
    [anon_sym_continue] = ACTIONS(9412),
    [anon_sym_DASH_DASH] = ACTIONS(9414),
    [anon_sym_if] = ACTIONS(9412),
    [anon_sym_this] = ACTIONS(9412),
    [anon_sym_yield] = ACTIONS(9412),
    [sym_true] = ACTIONS(9412),
    [anon_sym_throw] = ACTIONS(9412),
    [anon_sym_protected] = ACTIONS(9412),
    [anon_sym_abstract] = ACTIONS(9412),
    [anon_sym_set] = ACTIONS(9412),
    [anon_sym_type] = ACTIONS(9412),
    [anon_sym_import] = ACTIONS(9412),
    [anon_sym_namespace] = ACTIONS(9412),
    [anon_sym_PLUS_PLUS] = ACTIONS(9414),
    [anon_sym_await] = ACTIONS(9412),
    [anon_sym_DQUOTE] = ACTIONS(9414),
    [anon_sym_else] = ACTIONS(9412),
    [anon_sym_BANG] = ACTIONS(9414),
    [anon_sym_for] = ACTIONS(9412),
    [anon_sym_LBRACK] = ACTIONS(9414),
    [sym_false] = ACTIONS(9412),
    [anon_sym_SEMI] = ACTIONS(9414),
    [anon_sym_case] = ACTIONS(9412),
    [anon_sym_module] = ACTIONS(9412),
    [anon_sym_number] = ACTIONS(9412),
    [anon_sym_class] = ACTIONS(9412),
    [anon_sym_declare] = ACTIONS(9412),
    [anon_sym_typeof] = ACTIONS(9412),
    [anon_sym_LBRACE] = ACTIONS(9414),
    [anon_sym_switch] = ACTIONS(9412),
    [anon_sym_LPAREN] = ACTIONS(9414),
    [sym_null] = ACTIONS(9412),
    [anon_sym_any] = ACTIONS(9412),
    [anon_sym_boolean] = ACTIONS(9412),
    [anon_sym_async] = ACTIONS(9412),
    [anon_sym_public] = ACTIONS(9412),
    [anon_sym_var] = ACTIONS(9412),
    [anon_sym_while] = ACTIONS(9412),
    [anon_sym_SQUOTE] = ACTIONS(9414),
    [anon_sym_try] = ACTIONS(9412),
    [anon_sym_LT] = ACTIONS(9414),
    [sym_number] = ACTIONS(9414),
    [anon_sym_SLASH] = ACTIONS(9412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9412),
    [anon_sym_function] = ACTIONS(9412),
    [sym_undefined] = ACTIONS(9412),
    [anon_sym_new] = ACTIONS(9412),
    [ts_builtin_sym_end] = ACTIONS(9414),
    [anon_sym_let] = ACTIONS(9412),
    [anon_sym_PLUS] = ACTIONS(9412),
    [anon_sym_export] = ACTIONS(9412),
    [anon_sym_do] = ACTIONS(9412),
    [anon_sym_TILDE] = ACTIONS(9414),
    [anon_sym_with] = ACTIONS(9412),
  },
  [4595] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(7180),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(7180),
    [anon_sym_PIPE] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(7463),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(7459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7459),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(7180),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_instanceof] = ACTIONS(7459),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7459),
    [anon_sym_in] = ACTIONS(6073),
  },
  [4596] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9416),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(9418),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_RPAREN] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [4597] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9416),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(9418),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_RPAREN] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [4598] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4846),
    [sym_constructor_type] = STATE(4846),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(4846),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4846),
    [sym_intersection_type] = STATE(4846),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4599] = {
    [anon_sym_EQ_GT] = ACTIONS(9420),
    [sym_comment] = ACTIONS(3),
  },
  [4600] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4848),
    [sym_constructor_type] = STATE(4848),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(4848),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4848),
    [sym_intersection_type] = STATE(4848),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4601] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9416),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(9418),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_RPAREN] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [4602] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9416),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(9418),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [4603] = {
    [sym_new_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_update_expression] = STATE(305),
    [sym_regex] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(305),
    [sym_yield_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_non_null_expression] = STATE(305),
    [sym_internal_module] = STATE(305),
    [sym_function] = STATE(306),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(307),
    [sym_string] = STATE(293),
    [sym_this] = STATE(293),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(308),
    [sym_anonymous_class] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(307),
    [sym_assignment_expression] = STATE(305),
    [sym_ternary_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_template_string] = STATE(293),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(293),
    [sym_array] = STATE(310),
    [sym_type_assertion] = STATE(305),
    [sym_class] = STATE(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(6099),
    [sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(6101),
    [anon_sym_symbol] = ACTIONS(6101),
    [anon_sym_number] = ACTIONS(6101),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6101),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(6103),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(508),
    [sym_super] = ACTIONS(520),
    [anon_sym_any] = ACTIONS(6101),
    [anon_sym_private] = ACTIONS(6101),
    [anon_sym_boolean] = ACTIONS(6101),
    [anon_sym_async] = ACTIONS(6105),
    [anon_sym_public] = ACTIONS(6101),
    [anon_sym_get] = ACTIONS(6101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(524),
    [sym_true] = ACTIONS(508),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(6101),
    [anon_sym_string] = ACTIONS(6101),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(528),
    [sym_undefined] = ACTIONS(508),
    [anon_sym_set] = ACTIONS(6101),
    [anon_sym_type] = ACTIONS(6101),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(6101),
    [anon_sym_export] = ACTIONS(6101),
    [anon_sym_namespace] = ACTIONS(6107),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4604] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(7180),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_in] = ACTIONS(6133),
  },
  [4605] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9422),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(9424),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_RPAREN] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [4606] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9422),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(9424),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_RPAREN] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [4607] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4849),
    [sym_constructor_type] = STATE(4849),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(4849),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4849),
    [sym_intersection_type] = STATE(4849),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4608] = {
    [anon_sym_EQ_GT] = ACTIONS(9426),
    [sym_comment] = ACTIONS(3),
  },
  [4609] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4851),
    [sym_constructor_type] = STATE(4851),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(4851),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4851),
    [sym_intersection_type] = STATE(4851),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4610] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9422),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(9424),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_RPAREN] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [4611] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9422),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(9424),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [4612] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(6159),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(6161),
    [anon_sym_symbol] = ACTIONS(6161),
    [anon_sym_number] = ACTIONS(6161),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(6161),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(6163),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6161),
    [anon_sym_private] = ACTIONS(6161),
    [anon_sym_boolean] = ACTIONS(6161),
    [anon_sym_async] = ACTIONS(6165),
    [anon_sym_public] = ACTIONS(6161),
    [anon_sym_get] = ACTIONS(6161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(6161),
    [anon_sym_string] = ACTIONS(6161),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(6161),
    [anon_sym_type] = ACTIONS(6161),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(6161),
    [anon_sym_export] = ACTIONS(6161),
    [anon_sym_namespace] = ACTIONS(6167),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4613] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6984),
    [anon_sym_LBRACK] = ACTIONS(6984),
    [anon_sym_BANG] = ACTIONS(6982),
    [anon_sym_BQUOTE] = ACTIONS(6984),
    [anon_sym_PIPE] = ACTIONS(6982),
    [anon_sym_COMMA] = ACTIONS(6984),
    [anon_sym_LT_LT] = ACTIONS(6984),
    [anon_sym_STAR] = ACTIONS(6982),
    [anon_sym_GT_GT_GT] = ACTIONS(6984),
    [anon_sym_AMP_AMP] = ACTIONS(6984),
    [anon_sym_DASH] = ACTIONS(6982),
    [anon_sym_LBRACE] = ACTIONS(6982),
    [anon_sym_BANG_EQ] = ACTIONS(6982),
    [anon_sym_LT_EQ] = ACTIONS(6984),
    [anon_sym_LPAREN] = ACTIONS(6984),
    [anon_sym_RBRACK] = ACTIONS(6984),
    [anon_sym_GT_EQ] = ACTIONS(6984),
    [anon_sym_GT] = ACTIONS(6982),
    [anon_sym_AMP] = ACTIONS(6982),
    [anon_sym_PERCENT] = ACTIONS(6984),
    [anon_sym_QMARK] = ACTIONS(6984),
    [anon_sym_RBRACE] = ACTIONS(6984),
    [anon_sym_as] = ACTIONS(6984),
    [anon_sym_PIPE_PIPE] = ACTIONS(6984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6984),
    [anon_sym_DASH_DASH] = ACTIONS(6984),
    [anon_sym_EQ_EQ] = ACTIONS(6982),
    [anon_sym_instanceof] = ACTIONS(6984),
    [anon_sym_LT] = ACTIONS(6982),
    [anon_sym_RPAREN] = ACTIONS(6984),
    [anon_sym_SLASH] = ACTIONS(6982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6984),
    [anon_sym_DOT] = ACTIONS(6984),
    [anon_sym_CARET] = ACTIONS(6984),
    [anon_sym_STAR_STAR] = ACTIONS(6984),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_implements] = ACTIONS(6984),
    [anon_sym_GT_GT] = ACTIONS(6982),
    [anon_sym_PLUS_PLUS] = ACTIONS(6984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6984),
    [anon_sym_in] = ACTIONS(6982),
  },
  [4614] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8795),
    [anon_sym_LBRACK] = ACTIONS(8795),
    [anon_sym_BANG] = ACTIONS(8793),
    [anon_sym_BQUOTE] = ACTIONS(8795),
    [anon_sym_PIPE] = ACTIONS(8793),
    [anon_sym_COMMA] = ACTIONS(8795),
    [anon_sym_LT_LT] = ACTIONS(8795),
    [anon_sym_STAR] = ACTIONS(8793),
    [anon_sym_GT_GT_GT] = ACTIONS(8795),
    [anon_sym_AMP_AMP] = ACTIONS(8795),
    [anon_sym_DASH] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(8793),
    [anon_sym_BANG_EQ] = ACTIONS(8793),
    [anon_sym_LT_EQ] = ACTIONS(8795),
    [anon_sym_LPAREN] = ACTIONS(8795),
    [anon_sym_RBRACK] = ACTIONS(8795),
    [anon_sym_GT_EQ] = ACTIONS(8795),
    [anon_sym_GT] = ACTIONS(8793),
    [anon_sym_AMP] = ACTIONS(8793),
    [anon_sym_PERCENT] = ACTIONS(8795),
    [anon_sym_QMARK] = ACTIONS(8795),
    [anon_sym_RBRACE] = ACTIONS(8795),
    [anon_sym_as] = ACTIONS(8795),
    [anon_sym_PIPE_PIPE] = ACTIONS(8795),
    [anon_sym_LBRACE_PIPE] = ACTIONS(8795),
    [anon_sym_DASH_DASH] = ACTIONS(8795),
    [anon_sym_EQ_EQ] = ACTIONS(8793),
    [anon_sym_instanceof] = ACTIONS(8795),
    [anon_sym_LT] = ACTIONS(8793),
    [anon_sym_RPAREN] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8795),
    [anon_sym_DOT] = ACTIONS(8795),
    [anon_sym_CARET] = ACTIONS(8795),
    [anon_sym_STAR_STAR] = ACTIONS(8795),
    [anon_sym_PLUS] = ACTIONS(8793),
    [anon_sym_implements] = ACTIONS(8795),
    [anon_sym_GT_GT] = ACTIONS(8793),
    [anon_sym_PLUS_PLUS] = ACTIONS(8795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8795),
    [anon_sym_in] = ACTIONS(8793),
  },
  [4615] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8523),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_LBRACE] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(8525),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_implements] = ACTIONS(8086),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4616] = {
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(6292),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8086),
  },
  [4617] = {
    [sym_formal_parameters] = STATE(4852),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4618] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(9428),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4619] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(9431),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4620] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9110),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_RBRACK] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(9112),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4621] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4853),
    [sym_constructor_type] = STATE(4853),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_function_type] = STATE(4853),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4853),
    [sym_intersection_type] = STATE(4853),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3094),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3096),
    [sym_identifier] = ACTIONS(6374),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(6380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(6376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4622] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9110),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_RBRACK] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(9112),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4623] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4624] = {
    [sym_formal_parameters] = STATE(4854),
    [sym_type_parameters] = STATE(4855),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4625] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4626] = {
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9436),
    [sym_comment] = ACTIONS(3),
  },
  [4627] = {
    [sym_formal_parameters] = STATE(4858),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4628] = {
    [anon_sym_EQ_GT] = ACTIONS(9438),
    [sym_comment] = ACTIONS(3),
  },
  [4629] = {
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9436),
    [sym_comment] = ACTIONS(3),
  },
  [4630] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4860),
    [sym_constructor_type] = STATE(4860),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(4860),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4860),
    [sym_intersection_type] = STATE(4860),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3784),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3786),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(7682),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(7684),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(7686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4631] = {
    [anon_sym_EQ_GT] = ACTIONS(9440),
    [sym_comment] = ACTIONS(3),
  },
  [4632] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4862),
    [sym_constructor_type] = STATE(4862),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(4862),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4862),
    [sym_intersection_type] = STATE(4862),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3784),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3786),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(7682),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(7684),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(7686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4633] = {
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9436),
    [sym_comment] = ACTIONS(3),
  },
  [4634] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(8553),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8555),
    [sym_comment] = ACTIONS(3),
  },
  [4635] = {
    [sym__automatic_semicolon] = ACTIONS(9152),
    [anon_sym_LBRACK] = ACTIONS(9152),
    [sym_identifier] = ACTIONS(9442),
    [anon_sym_SEMI] = ACTIONS(9152),
    [anon_sym_module] = ACTIONS(9442),
    [anon_sym_symbol] = ACTIONS(9442),
    [anon_sym_number] = ACTIONS(9442),
    [anon_sym_AT] = ACTIONS(9152),
    [anon_sym_declare] = ACTIONS(9442),
    [anon_sym_STAR] = ACTIONS(9152),
    [anon_sym_void] = ACTIONS(9442),
    [anon_sym_any] = ACTIONS(9442),
    [anon_sym_private] = ACTIONS(9442),
    [anon_sym_boolean] = ACTIONS(9442),
    [anon_sym_async] = ACTIONS(9442),
    [anon_sym_public] = ACTIONS(9442),
    [anon_sym_get] = ACTIONS(9442),
    [anon_sym_RBRACE] = ACTIONS(9152),
    [anon_sym_static] = ACTIONS(9442),
    [anon_sym_SQUOTE] = ACTIONS(9152),
    [sym_number] = ACTIONS(9152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(9442),
    [anon_sym_string] = ACTIONS(9442),
    [anon_sym_abstract] = ACTIONS(9442),
    [anon_sym_set] = ACTIONS(9442),
    [anon_sym_type] = ACTIONS(9442),
    [anon_sym_import] = ACTIONS(9442),
    [anon_sym_export] = ACTIONS(9442),
    [anon_sym_namespace] = ACTIONS(9442),
    [sym_readonly] = ACTIONS(9442),
    [anon_sym_DQUOTE] = ACTIONS(9152),
  },
  [4636] = {
    [sym_statement_block] = STATE(4863),
    [sym__automatic_semicolon] = ACTIONS(9444),
    [anon_sym_SEMI] = ACTIONS(9444),
    [anon_sym_COMMA] = ACTIONS(9444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4779),
  },
  [4637] = {
    [anon_sym_EQ_GT] = ACTIONS(9446),
    [sym_comment] = ACTIONS(3),
  },
  [4638] = {
    [sym_formal_parameters] = STATE(4865),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4639] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4640] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4641] = {
    [anon_sym_EQ_GT] = ACTIONS(9448),
    [sym_comment] = ACTIONS(3),
  },
  [4642] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4867),
    [sym_constructor_type] = STATE(4867),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(4867),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4867),
    [sym_intersection_type] = STATE(4867),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4643] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(7708),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(7710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6909),
  },
  [4644] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4868),
    [sym_constructor_type] = STATE(4868),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(4868),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4868),
    [sym_intersection_type] = STATE(4868),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3128),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3130),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(6434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4645] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(7708),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(7710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6986),
  },
  [4646] = {
    [sym_call_signature] = STATE(4869),
    [sym_formal_parameters] = STATE(1368),
    [sym_type_parameters] = STATE(1369),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4647] = {
    [sym__automatic_semicolon] = ACTIONS(9450),
    [anon_sym_SEMI] = ACTIONS(9450),
    [anon_sym_COMMA] = ACTIONS(9450),
    [sym_comment] = ACTIONS(3),
  },
  [4648] = {
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_debugger] = ACTIONS(8300),
    [anon_sym_symbol] = ACTIONS(8300),
    [anon_sym_AT] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(7737),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_void] = ACTIONS(8300),
    [anon_sym_break] = ACTIONS(8300),
    [anon_sym_const] = ACTIONS(8300),
    [sym_super] = ACTIONS(8300),
    [anon_sym_return] = ACTIONS(8300),
    [anon_sym_private] = ACTIONS(8300),
    [anon_sym_get] = ACTIONS(8300),
    [anon_sym_interface] = ACTIONS(8300),
    [anon_sym_enum] = ACTIONS(8300),
    [anon_sym_delete] = ACTIONS(8300),
    [anon_sym_continue] = ACTIONS(8300),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_if] = ACTIONS(8300),
    [anon_sym_this] = ACTIONS(8300),
    [anon_sym_yield] = ACTIONS(8300),
    [sym_true] = ACTIONS(8300),
    [anon_sym_throw] = ACTIONS(8300),
    [anon_sym_protected] = ACTIONS(8300),
    [anon_sym_abstract] = ACTIONS(8300),
    [anon_sym_set] = ACTIONS(8300),
    [anon_sym_type] = ACTIONS(8300),
    [anon_sym_import] = ACTIONS(8300),
    [anon_sym_namespace] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_await] = ACTIONS(8300),
    [anon_sym_DQUOTE] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(6909),
    [anon_sym_for] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [sym_false] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_module] = ACTIONS(8300),
    [anon_sym_number] = ACTIONS(8300),
    [anon_sym_class] = ACTIONS(8300),
    [anon_sym_declare] = ACTIONS(8300),
    [anon_sym_typeof] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_switch] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [sym_null] = ACTIONS(8300),
    [anon_sym_any] = ACTIONS(8300),
    [anon_sym_boolean] = ACTIONS(8300),
    [anon_sym_async] = ACTIONS(8300),
    [anon_sym_public] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(7739),
    [anon_sym_var] = ACTIONS(8300),
    [anon_sym_while] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(6909),
    [anon_sym_try] = ACTIONS(8300),
    [anon_sym_LT] = ACTIONS(6909),
    [sym_number] = ACTIONS(6909),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8300),
    [anon_sym_function] = ACTIONS(8300),
    [sym_undefined] = ACTIONS(8300),
    [anon_sym_new] = ACTIONS(8300),
    [ts_builtin_sym_end] = ACTIONS(6909),
    [anon_sym_let] = ACTIONS(8300),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_export] = ACTIONS(8300),
    [anon_sym_do] = ACTIONS(8300),
    [anon_sym_TILDE] = ACTIONS(6909),
    [anon_sym_with] = ACTIONS(8300),
  },
  [4649] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4870),
    [sym_constructor_type] = STATE(4870),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3144),
    [sym_function_type] = STATE(4870),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4870),
    [sym_intersection_type] = STATE(4870),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3143),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3145),
    [sym_identifier] = ACTIONS(6448),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(6450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4650] = {
    [sym_identifier] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_debugger] = ACTIONS(8302),
    [anon_sym_symbol] = ACTIONS(8302),
    [anon_sym_AT] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(7737),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_void] = ACTIONS(8302),
    [anon_sym_break] = ACTIONS(8302),
    [anon_sym_const] = ACTIONS(8302),
    [sym_super] = ACTIONS(8302),
    [anon_sym_return] = ACTIONS(8302),
    [anon_sym_private] = ACTIONS(8302),
    [anon_sym_get] = ACTIONS(8302),
    [anon_sym_interface] = ACTIONS(8302),
    [anon_sym_enum] = ACTIONS(8302),
    [anon_sym_delete] = ACTIONS(8302),
    [anon_sym_continue] = ACTIONS(8302),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_if] = ACTIONS(8302),
    [anon_sym_this] = ACTIONS(8302),
    [anon_sym_yield] = ACTIONS(8302),
    [sym_true] = ACTIONS(8302),
    [anon_sym_throw] = ACTIONS(8302),
    [anon_sym_protected] = ACTIONS(8302),
    [anon_sym_abstract] = ACTIONS(8302),
    [anon_sym_set] = ACTIONS(8302),
    [anon_sym_type] = ACTIONS(8302),
    [anon_sym_import] = ACTIONS(8302),
    [anon_sym_namespace] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_await] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(6986),
    [anon_sym_for] = ACTIONS(8302),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [sym_false] = ACTIONS(8302),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_module] = ACTIONS(8302),
    [anon_sym_number] = ACTIONS(8302),
    [anon_sym_class] = ACTIONS(8302),
    [anon_sym_declare] = ACTIONS(8302),
    [anon_sym_typeof] = ACTIONS(8302),
    [anon_sym_LBRACE] = ACTIONS(6986),
    [anon_sym_switch] = ACTIONS(8302),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [sym_null] = ACTIONS(8302),
    [anon_sym_any] = ACTIONS(8302),
    [anon_sym_boolean] = ACTIONS(8302),
    [anon_sym_async] = ACTIONS(8302),
    [anon_sym_public] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(7739),
    [anon_sym_var] = ACTIONS(8302),
    [anon_sym_while] = ACTIONS(8302),
    [anon_sym_SQUOTE] = ACTIONS(6986),
    [anon_sym_try] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(6986),
    [sym_number] = ACTIONS(6986),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8302),
    [anon_sym_function] = ACTIONS(8302),
    [sym_undefined] = ACTIONS(8302),
    [anon_sym_new] = ACTIONS(8302),
    [ts_builtin_sym_end] = ACTIONS(6986),
    [anon_sym_let] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_export] = ACTIONS(8302),
    [anon_sym_do] = ACTIONS(8302),
    [anon_sym_TILDE] = ACTIONS(6986),
    [anon_sym_with] = ACTIONS(8302),
  },
  [4651] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9146),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(9148),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4652] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4871),
    [sym_constructor_type] = STATE(4871),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3169),
    [sym_function_type] = STATE(4871),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4871),
    [sym_intersection_type] = STATE(4871),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3168),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3170),
    [sym_identifier] = ACTIONS(6505),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4653] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9146),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(9148),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4654] = {
    [anon_sym_COMMA] = ACTIONS(9452),
    [anon_sym_RBRACE] = ACTIONS(9452),
    [sym_comment] = ACTIONS(3),
  },
  [4655] = {
    [sym_new_expression] = STATE(4872),
    [sym_augmented_assignment_expression] = STATE(4872),
    [sym_unary_expression] = STATE(4872),
    [sym_update_expression] = STATE(4872),
    [sym_regex] = STATE(4872),
    [sym_meta_property] = STATE(4872),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4872),
    [sym_yield_expression] = STATE(4872),
    [sym_as_expression] = STATE(4872),
    [sym_non_null_expression] = STATE(4872),
    [sym_internal_module] = STATE(4872),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4872),
    [sym_await_expression] = STATE(4872),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4872),
    [sym_this] = STATE(4872),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4872),
    [sym_generator_function] = STATE(4872),
    [sym_call_expression] = STATE(4872),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4872),
    [sym_ternary_expression] = STATE(4872),
    [sym_binary_expression] = STATE(4872),
    [sym_template_string] = STATE(4872),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4872),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4872),
    [sym_class] = STATE(4872),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9454),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9454),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9456),
    [sym_true] = ACTIONS(9454),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9454),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4656] = {
    [sym_new_expression] = STATE(4873),
    [sym_augmented_assignment_expression] = STATE(4873),
    [sym_unary_expression] = STATE(4873),
    [sym_update_expression] = STATE(4873),
    [sym_regex] = STATE(4873),
    [sym_meta_property] = STATE(4873),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4873),
    [sym_yield_expression] = STATE(4873),
    [sym_as_expression] = STATE(4873),
    [sym_non_null_expression] = STATE(4873),
    [sym_internal_module] = STATE(4873),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4873),
    [sym_await_expression] = STATE(4873),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4873),
    [sym_this] = STATE(4873),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4873),
    [sym_generator_function] = STATE(4873),
    [sym_call_expression] = STATE(4873),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4873),
    [sym_ternary_expression] = STATE(4873),
    [sym_binary_expression] = STATE(4873),
    [sym_template_string] = STATE(4873),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4873),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4873),
    [sym_class] = STATE(4873),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9458),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9458),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9460),
    [sym_true] = ACTIONS(9458),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9458),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4657] = {
    [sym_new_expression] = STATE(4874),
    [sym_augmented_assignment_expression] = STATE(4874),
    [sym_unary_expression] = STATE(4874),
    [sym_update_expression] = STATE(4874),
    [sym_regex] = STATE(4874),
    [sym_meta_property] = STATE(4874),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4874),
    [sym_yield_expression] = STATE(4874),
    [sym_as_expression] = STATE(4874),
    [sym_non_null_expression] = STATE(4874),
    [sym_internal_module] = STATE(4874),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4874),
    [sym_await_expression] = STATE(4874),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4874),
    [sym_this] = STATE(4874),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4874),
    [sym_generator_function] = STATE(4874),
    [sym_call_expression] = STATE(4874),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4874),
    [sym_ternary_expression] = STATE(4874),
    [sym_binary_expression] = STATE(4874),
    [sym_template_string] = STATE(4874),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4874),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4874),
    [sym_class] = STATE(4874),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9462),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9462),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9464),
    [sym_true] = ACTIONS(9462),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9462),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4658] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9466),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4659] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9468),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4660] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9470),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4661] = {
    [sym_type_alias_declaration] = STATE(3690),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3690),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3690),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3690),
    [sym_return_statement] = STATE(3690),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3690),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3690),
    [sym_switch_statement] = STATE(3690),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3690),
    [sym_throw_statement] = STATE(3690),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3690),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3690),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(3690),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3690),
    [sym_abstract_class] = STATE(3690),
    [sym_interface_declaration] = STATE(3690),
    [sym_statement_block] = STATE(3690),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3690),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3690),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3690),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3690),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3690),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3690),
    [sym_empty_statement] = STATE(3690),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(3690),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3690),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3690),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3690),
    [sym_break_statement] = STATE(3690),
    [sym_labeled_statement] = STATE(3690),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3690),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4662] = {
    [sym_type_alias_declaration] = STATE(3719),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3719),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3719),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3719),
    [sym_return_statement] = STATE(3719),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3719),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3719),
    [sym_switch_statement] = STATE(3719),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3719),
    [sym_throw_statement] = STATE(3719),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3719),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3719),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(3719),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3719),
    [sym_abstract_class] = STATE(3719),
    [sym_interface_declaration] = STATE(3719),
    [sym_statement_block] = STATE(3719),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3719),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3719),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3719),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3719),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3719),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3719),
    [sym_empty_statement] = STATE(3719),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(3719),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3719),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3719),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3719),
    [sym_break_statement] = STATE(3719),
    [sym_labeled_statement] = STATE(3719),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3719),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4663] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9472),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4664] = {
    [anon_sym_RPAREN] = ACTIONS(9472),
    [sym_comment] = ACTIONS(3),
  },
  [4665] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4666] = {
    [anon_sym_RPAREN] = ACTIONS(9474),
    [sym_comment] = ACTIONS(3),
  },
  [4667] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9476),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4668] = {
    [anon_sym_RPAREN] = ACTIONS(9476),
    [sym_comment] = ACTIONS(3),
  },
  [4669] = {
    [sym_type_alias_declaration] = STATE(3724),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3724),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3724),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3724),
    [sym_return_statement] = STATE(3724),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3724),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3724),
    [sym_switch_statement] = STATE(3724),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3724),
    [sym_throw_statement] = STATE(3724),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3724),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3724),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(3724),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3724),
    [sym_abstract_class] = STATE(3724),
    [sym_interface_declaration] = STATE(3724),
    [sym_statement_block] = STATE(3724),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3724),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3724),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3724),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3724),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3724),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3724),
    [sym_empty_statement] = STATE(3724),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(3724),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3724),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3724),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3724),
    [sym_break_statement] = STATE(3724),
    [sym_labeled_statement] = STATE(3724),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3724),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4670] = {
    [sym_type_alias_declaration] = STATE(3725),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3725),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3725),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3725),
    [sym_return_statement] = STATE(3725),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3725),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3725),
    [sym_switch_statement] = STATE(3725),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3725),
    [sym_throw_statement] = STATE(3725),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3725),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3725),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(3725),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3725),
    [sym_abstract_class] = STATE(3725),
    [sym_interface_declaration] = STATE(3725),
    [sym_statement_block] = STATE(3725),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3725),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3725),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3725),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3725),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3725),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3725),
    [sym_empty_statement] = STATE(3725),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(3725),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3725),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3725),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3725),
    [sym_break_statement] = STATE(3725),
    [sym_labeled_statement] = STATE(3725),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3725),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4671] = {
    [sym_type_alias_declaration] = STATE(3726),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3726),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3726),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3726),
    [sym_return_statement] = STATE(3726),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3726),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3726),
    [sym_switch_statement] = STATE(3726),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3726),
    [sym_throw_statement] = STATE(3726),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3726),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3726),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(3726),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3726),
    [sym_abstract_class] = STATE(3726),
    [sym_interface_declaration] = STATE(3726),
    [sym_statement_block] = STATE(3726),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3726),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3726),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3726),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3726),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3726),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3726),
    [sym_empty_statement] = STATE(3726),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(3726),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3726),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3726),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3726),
    [sym_break_statement] = STATE(3726),
    [sym_labeled_statement] = STATE(3726),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3726),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4672] = {
    [sym_type_alias_declaration] = STATE(3727),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3727),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3727),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3727),
    [sym_return_statement] = STATE(3727),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3727),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3727),
    [sym_switch_statement] = STATE(3727),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3727),
    [sym_throw_statement] = STATE(3727),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3727),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3727),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(3727),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3727),
    [sym_abstract_class] = STATE(3727),
    [sym_interface_declaration] = STATE(3727),
    [sym_statement_block] = STATE(3727),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3727),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3727),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3727),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3727),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3727),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3727),
    [sym_empty_statement] = STATE(3727),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(3727),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3727),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3727),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3727),
    [sym_break_statement] = STATE(3727),
    [sym_labeled_statement] = STATE(3727),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3727),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4673] = {
    [sym_type_alias_declaration] = STATE(3728),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3728),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3728),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3728),
    [sym_return_statement] = STATE(3728),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3728),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3728),
    [sym_switch_statement] = STATE(3728),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3728),
    [sym_throw_statement] = STATE(3728),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3728),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3728),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(3728),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3728),
    [sym_abstract_class] = STATE(3728),
    [sym_interface_declaration] = STATE(3728),
    [sym_statement_block] = STATE(3728),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3728),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3728),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3728),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3728),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3728),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3728),
    [sym_empty_statement] = STATE(3728),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(3728),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3728),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3728),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3728),
    [sym_break_statement] = STATE(3728),
    [sym_labeled_statement] = STATE(3728),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3728),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4674] = {
    [sym_type_arguments] = STATE(791),
    [sym_identifier] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_debugger] = ACTIONS(3834),
    [anon_sym_symbol] = ACTIONS(3834),
    [anon_sym_AT] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_void] = ACTIONS(3834),
    [anon_sym_break] = ACTIONS(3834),
    [anon_sym_const] = ACTIONS(3834),
    [sym_super] = ACTIONS(3834),
    [anon_sym_return] = ACTIONS(3834),
    [anon_sym_private] = ACTIONS(3834),
    [anon_sym_get] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_interface] = ACTIONS(3834),
    [anon_sym_enum] = ACTIONS(3834),
    [anon_sym_delete] = ACTIONS(3834),
    [anon_sym_continue] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(3834),
    [anon_sym_this] = ACTIONS(3834),
    [anon_sym_yield] = ACTIONS(3834),
    [sym_true] = ACTIONS(3834),
    [anon_sym_throw] = ACTIONS(3834),
    [anon_sym_protected] = ACTIONS(3834),
    [anon_sym_abstract] = ACTIONS(3834),
    [anon_sym_DOT] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3834),
    [anon_sym_type] = ACTIONS(3834),
    [anon_sym_import] = ACTIONS(3834),
    [anon_sym_namespace] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_await] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [anon_sym_else] = ACTIONS(3834),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_for] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [sym_false] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(3834),
    [anon_sym_number] = ACTIONS(3834),
    [anon_sym_class] = ACTIONS(3834),
    [anon_sym_declare] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3834),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(9478),
    [anon_sym_switch] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [sym_null] = ACTIONS(3834),
    [anon_sym_any] = ACTIONS(3834),
    [anon_sym_boolean] = ACTIONS(3834),
    [anon_sym_async] = ACTIONS(3834),
    [anon_sym_public] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_var] = ACTIONS(3834),
    [anon_sym_while] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(3834),
    [anon_sym_LT] = ACTIONS(7728),
    [sym_number] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3834),
    [anon_sym_function] = ACTIONS(3834),
    [sym_undefined] = ACTIONS(3834),
    [anon_sym_new] = ACTIONS(3834),
    [anon_sym_let] = ACTIONS(3834),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_export] = ACTIONS(3834),
    [anon_sym_do] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_with] = ACTIONS(3834),
    [anon_sym_in] = ACTIONS(9480),
  },
  [4675] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4676] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4677] = {
    [sym_formal_parameters] = STATE(4883),
    [sym_type_parameters] = STATE(4884),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4678] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4679] = {
    [sym_identifier] = ACTIONS(7733),
    [anon_sym_BQUOTE] = ACTIONS(7735),
    [anon_sym_debugger] = ACTIONS(7733),
    [anon_sym_symbol] = ACTIONS(7733),
    [anon_sym_AT] = ACTIONS(7735),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_DASH] = ACTIONS(7733),
    [anon_sym_void] = ACTIONS(7733),
    [anon_sym_break] = ACTIONS(7733),
    [anon_sym_const] = ACTIONS(7733),
    [sym_super] = ACTIONS(7733),
    [anon_sym_return] = ACTIONS(7733),
    [anon_sym_private] = ACTIONS(7733),
    [anon_sym_get] = ACTIONS(7733),
    [anon_sym_RBRACE] = ACTIONS(7735),
    [anon_sym_interface] = ACTIONS(7733),
    [anon_sym_enum] = ACTIONS(7733),
    [anon_sym_delete] = ACTIONS(7733),
    [anon_sym_continue] = ACTIONS(7733),
    [anon_sym_DASH_DASH] = ACTIONS(7735),
    [anon_sym_if] = ACTIONS(7733),
    [anon_sym_this] = ACTIONS(7733),
    [anon_sym_yield] = ACTIONS(7733),
    [sym_true] = ACTIONS(7733),
    [anon_sym_throw] = ACTIONS(7733),
    [anon_sym_protected] = ACTIONS(7733),
    [anon_sym_abstract] = ACTIONS(7733),
    [anon_sym_set] = ACTIONS(7733),
    [anon_sym_type] = ACTIONS(7733),
    [anon_sym_import] = ACTIONS(7733),
    [anon_sym_namespace] = ACTIONS(7733),
    [anon_sym_PLUS_PLUS] = ACTIONS(7735),
    [anon_sym_await] = ACTIONS(7733),
    [anon_sym_DQUOTE] = ACTIONS(7735),
    [anon_sym_else] = ACTIONS(7733),
    [anon_sym_BANG] = ACTIONS(7735),
    [anon_sym_for] = ACTIONS(7733),
    [anon_sym_LBRACK] = ACTIONS(7735),
    [sym_false] = ACTIONS(7733),
    [anon_sym_SEMI] = ACTIONS(7735),
    [anon_sym_module] = ACTIONS(7733),
    [anon_sym_number] = ACTIONS(7733),
    [anon_sym_class] = ACTIONS(7733),
    [anon_sym_declare] = ACTIONS(7733),
    [anon_sym_typeof] = ACTIONS(7733),
    [anon_sym_LBRACE] = ACTIONS(7735),
    [anon_sym_switch] = ACTIONS(7733),
    [anon_sym_LPAREN] = ACTIONS(7735),
    [sym_null] = ACTIONS(7733),
    [anon_sym_any] = ACTIONS(7733),
    [anon_sym_boolean] = ACTIONS(7733),
    [anon_sym_async] = ACTIONS(7733),
    [anon_sym_public] = ACTIONS(7733),
    [anon_sym_AMP] = ACTIONS(9484),
    [anon_sym_var] = ACTIONS(7733),
    [anon_sym_while] = ACTIONS(7733),
    [anon_sym_SQUOTE] = ACTIONS(7735),
    [anon_sym_try] = ACTIONS(7733),
    [anon_sym_LT] = ACTIONS(7735),
    [sym_number] = ACTIONS(7735),
    [anon_sym_SLASH] = ACTIONS(7733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7733),
    [anon_sym_function] = ACTIONS(7733),
    [sym_undefined] = ACTIONS(7733),
    [anon_sym_new] = ACTIONS(7733),
    [anon_sym_let] = ACTIONS(7733),
    [anon_sym_PLUS] = ACTIONS(7733),
    [anon_sym_export] = ACTIONS(7733),
    [anon_sym_do] = ACTIONS(7733),
    [anon_sym_TILDE] = ACTIONS(7735),
    [anon_sym_with] = ACTIONS(7733),
  },
  [4680] = {
    [sym_formal_parameters] = STATE(4887),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4681] = {
    [sym_type_arguments] = STATE(850),
    [sym_identifier] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_debugger] = ACTIONS(3865),
    [anon_sym_symbol] = ACTIONS(3865),
    [anon_sym_AT] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_void] = ACTIONS(3865),
    [anon_sym_break] = ACTIONS(3865),
    [anon_sym_const] = ACTIONS(3865),
    [sym_super] = ACTIONS(3865),
    [anon_sym_return] = ACTIONS(3865),
    [anon_sym_private] = ACTIONS(3865),
    [anon_sym_get] = ACTIONS(3865),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_interface] = ACTIONS(3865),
    [anon_sym_enum] = ACTIONS(3865),
    [anon_sym_delete] = ACTIONS(3865),
    [anon_sym_continue] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_if] = ACTIONS(3865),
    [anon_sym_this] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3865),
    [sym_true] = ACTIONS(3865),
    [anon_sym_throw] = ACTIONS(3865),
    [anon_sym_protected] = ACTIONS(3865),
    [anon_sym_abstract] = ACTIONS(3865),
    [anon_sym_set] = ACTIONS(3865),
    [anon_sym_type] = ACTIONS(3865),
    [anon_sym_import] = ACTIONS(3865),
    [anon_sym_namespace] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_await] = ACTIONS(3865),
    [anon_sym_DQUOTE] = ACTIONS(1577),
    [anon_sym_else] = ACTIONS(3865),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [sym_false] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(3865),
    [anon_sym_number] = ACTIONS(3865),
    [anon_sym_class] = ACTIONS(3865),
    [anon_sym_declare] = ACTIONS(3865),
    [anon_sym_typeof] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_switch] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [sym_null] = ACTIONS(3865),
    [anon_sym_any] = ACTIONS(3865),
    [anon_sym_boolean] = ACTIONS(3865),
    [anon_sym_async] = ACTIONS(3865),
    [anon_sym_public] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_var] = ACTIONS(3865),
    [anon_sym_while] = ACTIONS(3865),
    [anon_sym_SQUOTE] = ACTIONS(1577),
    [anon_sym_try] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(7741),
    [sym_number] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3865),
    [sym_undefined] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_let] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_export] = ACTIONS(3865),
    [anon_sym_do] = ACTIONS(3865),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_with] = ACTIONS(3865),
    [anon_sym_in] = ACTIONS(9486),
  },
  [4682] = {
    [anon_sym_EQ_GT] = ACTIONS(9488),
    [sym_comment] = ACTIONS(3),
  },
  [4683] = {
    [sym_type_alias_declaration] = STATE(4592),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4592),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4592),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4592),
    [sym_return_statement] = STATE(4592),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4592),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4592),
    [sym_switch_statement] = STATE(4592),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4592),
    [sym_throw_statement] = STATE(4592),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4592),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4592),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(4592),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4592),
    [sym_abstract_class] = STATE(4592),
    [sym_interface_declaration] = STATE(4592),
    [sym_statement_block] = STATE(4592),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4592),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4592),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4592),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4592),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4592),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4592),
    [sym_empty_statement] = STATE(4592),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(4592),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4592),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4592),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4592),
    [sym_break_statement] = STATE(4592),
    [sym_labeled_statement] = STATE(4592),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4592),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [4684] = {
    [sym_type_alias_declaration] = STATE(4593),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4593),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4593),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4593),
    [sym_return_statement] = STATE(4593),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4593),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4593),
    [sym_switch_statement] = STATE(4593),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4593),
    [sym_throw_statement] = STATE(4593),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4593),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4593),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(4593),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4593),
    [sym_abstract_class] = STATE(4593),
    [sym_interface_declaration] = STATE(4593),
    [sym_statement_block] = STATE(4593),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4593),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4593),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4593),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4593),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4593),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4593),
    [sym_empty_statement] = STATE(4593),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(4593),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4593),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4593),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4593),
    [sym_break_statement] = STATE(4593),
    [sym_labeled_statement] = STATE(4593),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4593),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [4685] = {
    [sym_type_alias_declaration] = STATE(4594),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4594),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4594),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4594),
    [sym_return_statement] = STATE(4594),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4594),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4594),
    [sym_switch_statement] = STATE(4594),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4594),
    [sym_throw_statement] = STATE(4594),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4594),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4594),
    [sym_decorator] = STATE(690),
    [sym_continue_statement] = STATE(4594),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4594),
    [sym_abstract_class] = STATE(4594),
    [sym_interface_declaration] = STATE(4594),
    [sym_statement_block] = STATE(4594),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4594),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4594),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4594),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4594),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4594),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4594),
    [sym_empty_statement] = STATE(4594),
    [aux_sym_export_statement_repeat1] = STATE(690),
    [sym_import_alias] = STATE(4594),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4594),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4594),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4594),
    [sym_break_statement] = STATE(4594),
    [sym_labeled_statement] = STATE(4594),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4594),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(402),
  },
  [4686] = {
    [sym_identifier] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_debugger] = ACTIONS(7182),
    [anon_sym_symbol] = ACTIONS(7182),
    [anon_sym_AT] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(8673),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_void] = ACTIONS(7182),
    [anon_sym_break] = ACTIONS(7182),
    [anon_sym_const] = ACTIONS(7182),
    [sym_super] = ACTIONS(7182),
    [anon_sym_return] = ACTIONS(7182),
    [anon_sym_private] = ACTIONS(7182),
    [anon_sym_get] = ACTIONS(7182),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_interface] = ACTIONS(7182),
    [anon_sym_enum] = ACTIONS(7182),
    [anon_sym_delete] = ACTIONS(7182),
    [anon_sym_continue] = ACTIONS(7182),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_if] = ACTIONS(7182),
    [anon_sym_this] = ACTIONS(7182),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_true] = ACTIONS(7182),
    [anon_sym_throw] = ACTIONS(7182),
    [anon_sym_protected] = ACTIONS(7182),
    [anon_sym_abstract] = ACTIONS(7182),
    [anon_sym_set] = ACTIONS(7182),
    [anon_sym_type] = ACTIONS(7182),
    [anon_sym_import] = ACTIONS(7182),
    [anon_sym_namespace] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_await] = ACTIONS(7182),
    [anon_sym_DQUOTE] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(5196),
    [anon_sym_for] = ACTIONS(7182),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [sym_false] = ACTIONS(7182),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_module] = ACTIONS(7182),
    [anon_sym_number] = ACTIONS(7182),
    [anon_sym_class] = ACTIONS(7182),
    [anon_sym_declare] = ACTIONS(7182),
    [anon_sym_typeof] = ACTIONS(7182),
    [anon_sym_LBRACE] = ACTIONS(5196),
    [anon_sym_switch] = ACTIONS(7182),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [sym_null] = ACTIONS(7182),
    [anon_sym_any] = ACTIONS(7182),
    [anon_sym_boolean] = ACTIONS(7182),
    [anon_sym_async] = ACTIONS(7182),
    [anon_sym_public] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_var] = ACTIONS(7182),
    [anon_sym_while] = ACTIONS(7182),
    [anon_sym_SQUOTE] = ACTIONS(5196),
    [anon_sym_try] = ACTIONS(7182),
    [anon_sym_LT] = ACTIONS(5196),
    [sym_number] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7182),
    [anon_sym_function] = ACTIONS(7182),
    [sym_undefined] = ACTIONS(7182),
    [anon_sym_new] = ACTIONS(7182),
    [anon_sym_let] = ACTIONS(7182),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_export] = ACTIONS(7182),
    [anon_sym_do] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(5196),
    [anon_sym_with] = ACTIONS(7182),
  },
  [4687] = {
    [sym_identifier] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_debugger] = ACTIONS(7197),
    [anon_sym_symbol] = ACTIONS(7197),
    [anon_sym_AT] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(8673),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_void] = ACTIONS(7197),
    [anon_sym_break] = ACTIONS(7197),
    [anon_sym_const] = ACTIONS(7197),
    [sym_super] = ACTIONS(7197),
    [anon_sym_return] = ACTIONS(7197),
    [anon_sym_private] = ACTIONS(7197),
    [anon_sym_get] = ACTIONS(7197),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [anon_sym_interface] = ACTIONS(7197),
    [anon_sym_enum] = ACTIONS(7197),
    [anon_sym_delete] = ACTIONS(7197),
    [anon_sym_continue] = ACTIONS(7197),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_if] = ACTIONS(7197),
    [anon_sym_this] = ACTIONS(7197),
    [anon_sym_yield] = ACTIONS(7197),
    [sym_true] = ACTIONS(7197),
    [anon_sym_throw] = ACTIONS(7197),
    [anon_sym_protected] = ACTIONS(7197),
    [anon_sym_abstract] = ACTIONS(7197),
    [anon_sym_set] = ACTIONS(7197),
    [anon_sym_type] = ACTIONS(7197),
    [anon_sym_import] = ACTIONS(7197),
    [anon_sym_namespace] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_await] = ACTIONS(7197),
    [anon_sym_DQUOTE] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(5204),
    [anon_sym_for] = ACTIONS(7197),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [sym_false] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_module] = ACTIONS(7197),
    [anon_sym_number] = ACTIONS(7197),
    [anon_sym_class] = ACTIONS(7197),
    [anon_sym_declare] = ACTIONS(7197),
    [anon_sym_typeof] = ACTIONS(7197),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_switch] = ACTIONS(7197),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [sym_null] = ACTIONS(7197),
    [anon_sym_any] = ACTIONS(7197),
    [anon_sym_boolean] = ACTIONS(7197),
    [anon_sym_async] = ACTIONS(7197),
    [anon_sym_public] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_var] = ACTIONS(7197),
    [anon_sym_while] = ACTIONS(7197),
    [anon_sym_SQUOTE] = ACTIONS(5204),
    [anon_sym_try] = ACTIONS(7197),
    [anon_sym_LT] = ACTIONS(5204),
    [sym_number] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7197),
    [anon_sym_function] = ACTIONS(7197),
    [sym_undefined] = ACTIONS(7197),
    [anon_sym_new] = ACTIONS(7197),
    [anon_sym_let] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_export] = ACTIONS(7197),
    [anon_sym_do] = ACTIONS(7197),
    [anon_sym_TILDE] = ACTIONS(5204),
    [anon_sym_with] = ACTIONS(7197),
  },
  [4688] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4890),
    [sym_constructor_type] = STATE(4890),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(4890),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4890),
    [sym_intersection_type] = STATE(4890),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4689] = {
    [anon_sym_EQ_GT] = ACTIONS(9490),
    [sym_comment] = ACTIONS(3),
  },
  [4690] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4892),
    [sym_constructor_type] = STATE(4892),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(4892),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4892),
    [sym_intersection_type] = STATE(4892),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4691] = {
    [sym_identifier] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_debugger] = ACTIONS(7207),
    [anon_sym_symbol] = ACTIONS(7207),
    [anon_sym_AT] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(8673),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_void] = ACTIONS(7207),
    [anon_sym_break] = ACTIONS(7207),
    [anon_sym_const] = ACTIONS(7207),
    [sym_super] = ACTIONS(7207),
    [anon_sym_return] = ACTIONS(7207),
    [anon_sym_private] = ACTIONS(7207),
    [anon_sym_get] = ACTIONS(7207),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_interface] = ACTIONS(7207),
    [anon_sym_enum] = ACTIONS(7207),
    [anon_sym_delete] = ACTIONS(7207),
    [anon_sym_continue] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_if] = ACTIONS(7207),
    [anon_sym_this] = ACTIONS(7207),
    [anon_sym_yield] = ACTIONS(7207),
    [sym_true] = ACTIONS(7207),
    [anon_sym_throw] = ACTIONS(7207),
    [anon_sym_protected] = ACTIONS(7207),
    [anon_sym_abstract] = ACTIONS(7207),
    [anon_sym_set] = ACTIONS(7207),
    [anon_sym_type] = ACTIONS(7207),
    [anon_sym_import] = ACTIONS(7207),
    [anon_sym_namespace] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_await] = ACTIONS(7207),
    [anon_sym_DQUOTE] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(5406),
    [anon_sym_for] = ACTIONS(7207),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [sym_false] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_module] = ACTIONS(7207),
    [anon_sym_number] = ACTIONS(7207),
    [anon_sym_class] = ACTIONS(7207),
    [anon_sym_declare] = ACTIONS(7207),
    [anon_sym_typeof] = ACTIONS(7207),
    [anon_sym_LBRACE] = ACTIONS(5406),
    [anon_sym_switch] = ACTIONS(7207),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [sym_null] = ACTIONS(7207),
    [anon_sym_any] = ACTIONS(7207),
    [anon_sym_boolean] = ACTIONS(7207),
    [anon_sym_async] = ACTIONS(7207),
    [anon_sym_public] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_var] = ACTIONS(7207),
    [anon_sym_while] = ACTIONS(7207),
    [anon_sym_SQUOTE] = ACTIONS(5406),
    [anon_sym_try] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(5406),
    [sym_number] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7207),
    [anon_sym_function] = ACTIONS(7207),
    [sym_undefined] = ACTIONS(7207),
    [anon_sym_new] = ACTIONS(7207),
    [anon_sym_let] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_export] = ACTIONS(7207),
    [anon_sym_do] = ACTIONS(7207),
    [anon_sym_TILDE] = ACTIONS(5406),
    [anon_sym_with] = ACTIONS(7207),
  },
  [4692] = {
    [sym_identifier] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_debugger] = ACTIONS(7211),
    [anon_sym_symbol] = ACTIONS(7211),
    [anon_sym_AT] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8673),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_void] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [sym_super] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_private] = ACTIONS(7211),
    [anon_sym_get] = ACTIONS(7211),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_interface] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_delete] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_this] = ACTIONS(7211),
    [anon_sym_yield] = ACTIONS(7211),
    [sym_true] = ACTIONS(7211),
    [anon_sym_throw] = ACTIONS(7211),
    [anon_sym_protected] = ACTIONS(7211),
    [anon_sym_abstract] = ACTIONS(7211),
    [anon_sym_set] = ACTIONS(7211),
    [anon_sym_type] = ACTIONS(7211),
    [anon_sym_import] = ACTIONS(7211),
    [anon_sym_namespace] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_await] = ACTIONS(7211),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(5425),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [sym_false] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_module] = ACTIONS(7211),
    [anon_sym_number] = ACTIONS(7211),
    [anon_sym_class] = ACTIONS(7211),
    [anon_sym_declare] = ACTIONS(7211),
    [anon_sym_typeof] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(5425),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [sym_null] = ACTIONS(7211),
    [anon_sym_any] = ACTIONS(7211),
    [anon_sym_boolean] = ACTIONS(7211),
    [anon_sym_async] = ACTIONS(7211),
    [anon_sym_public] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_var] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_try] = ACTIONS(7211),
    [anon_sym_LT] = ACTIONS(5425),
    [sym_number] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7211),
    [anon_sym_function] = ACTIONS(7211),
    [sym_undefined] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [anon_sym_let] = ACTIONS(7211),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_export] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_TILDE] = ACTIONS(5425),
    [anon_sym_with] = ACTIONS(7211),
  },
  [4693] = {
    [sym_statement_block] = STATE(4893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [4694] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6649),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6651),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_LT_LT] = ACTIONS(6655),
    [anon_sym_STAR] = ACTIONS(6661),
    [anon_sym_GT_GT_GT] = ACTIONS(6655),
    [anon_sym_AMP_AMP] = ACTIONS(6659),
    [anon_sym_DASH] = ACTIONS(6657),
    [anon_sym_BANG_EQ] = ACTIONS(6609),
    [anon_sym_LT_EQ] = ACTIONS(6649),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6649),
    [anon_sym_GT] = ACTIONS(6609),
    [anon_sym_AMP] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(6655),
    [anon_sym_QMARK] = ACTIONS(6665),
    [anon_sym_as] = ACTIONS(6669),
    [anon_sym_PIPE_PIPE] = ACTIONS(6667),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6609),
    [anon_sym_instanceof] = ACTIONS(6649),
    [anon_sym_LT] = ACTIONS(6671),
    [anon_sym_SLASH] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7180),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6667),
    [anon_sym_STAR_STAR] = ACTIONS(6675),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_GT_GT] = ACTIONS(6661),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6649),
    [anon_sym_in] = ACTIONS(6609),
  },
  [4695] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9492),
    [anon_sym_COMMA] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(7182),
    [anon_sym_GT_GT_GT] = ACTIONS(5196),
    [anon_sym_AMP_AMP] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_BANG_EQ] = ACTIONS(7182),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_GT] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(9494),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5196),
    [anon_sym_as] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(7182),
    [anon_sym_instanceof] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(7182),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5196),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_STAR_STAR] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_GT_GT] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5196),
    [anon_sym_in] = ACTIONS(7182),
  },
  [4696] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9492),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_LT_LT] = ACTIONS(5204),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_GT_GT_GT] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5204),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7197),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(9494),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_as] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5204),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_EQ_EQ] = ACTIONS(7197),
    [anon_sym_instanceof] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5204),
    [anon_sym_DOT] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5204),
    [anon_sym_STAR_STAR] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(7197),
  },
  [4697] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4894),
    [sym_constructor_type] = STATE(4894),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(4894),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4894),
    [sym_intersection_type] = STATE(4894),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4698] = {
    [anon_sym_EQ_GT] = ACTIONS(9496),
    [sym_comment] = ACTIONS(3),
  },
  [4699] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4896),
    [sym_constructor_type] = STATE(4896),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(4896),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4896),
    [sym_intersection_type] = STATE(4896),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4700] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9492),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_GT_GT_GT] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_BANG_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(9494),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_as] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(7207),
    [anon_sym_instanceof] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5406),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_STAR_STAR] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(7207),
  },
  [4701] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9492),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7211),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(9494),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_instanceof] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5425),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_STAR_STAR] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(7211),
  },
  [4702] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(2390),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(3549),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(3550),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(6635),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(6637),
    [anon_sym_symbol] = ACTIONS(6637),
    [anon_sym_number] = ACTIONS(6637),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(6637),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(6639),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6637),
    [anon_sym_private] = ACTIONS(6637),
    [anon_sym_boolean] = ACTIONS(6637),
    [anon_sym_async] = ACTIONS(6641),
    [anon_sym_public] = ACTIONS(6637),
    [anon_sym_get] = ACTIONS(6637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(6637),
    [anon_sym_string] = ACTIONS(6637),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(6637),
    [anon_sym_type] = ACTIONS(6637),
    [anon_sym_new] = ACTIONS(5008),
    [anon_sym_import] = ACTIONS(6637),
    [anon_sym_export] = ACTIONS(6637),
    [anon_sym_namespace] = ACTIONS(6643),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4703] = {
    [sym_type_alias_declaration] = STATE(361),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(361),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(361),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(361),
    [sym_return_statement] = STATE(361),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(361),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(361),
    [sym_switch_statement] = STATE(361),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(361),
    [sym_throw_statement] = STATE(361),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(361),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(361),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(361),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(361),
    [sym_abstract_class] = STATE(361),
    [sym_interface_declaration] = STATE(361),
    [sym_statement_block] = STATE(361),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(361),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(361),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(361),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(361),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(361),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(361),
    [sym_empty_statement] = STATE(361),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(361),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(361),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(361),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(361),
    [sym_break_statement] = STATE(361),
    [sym_labeled_statement] = STATE(361),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(361),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [4704] = {
    [sym_type_alias_declaration] = STATE(4897),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4897),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4897),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4897),
    [sym_return_statement] = STATE(4897),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4897),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4897),
    [sym_switch_statement] = STATE(4897),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4897),
    [sym_throw_statement] = STATE(4897),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4897),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4897),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4897),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4897),
    [sym_abstract_class] = STATE(4897),
    [sym_interface_declaration] = STATE(4897),
    [sym_statement_block] = STATE(4897),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4897),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4897),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4897),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4897),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4897),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4897),
    [sym_empty_statement] = STATE(4897),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4897),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4897),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4897),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4897),
    [sym_break_statement] = STATE(4897),
    [sym_labeled_statement] = STATE(4897),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4897),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [4705] = {
    [anon_sym_LPAREN] = ACTIONS(9498),
    [sym_comment] = ACTIONS(3),
  },
  [4706] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4902),
    [sym_variable_declaration] = STATE(4902),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(4902),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(4903),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_lexical_declaration] = STATE(4902),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(4904),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(9500),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(9502),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(9504),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(9502),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [4707] = {
    [sym_string] = STATE(172),
    [sym_nested_identifier] = STATE(168),
    [sym__module] = STATE(171),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(9506),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(310),
  },
  [4708] = {
    [sym_type_alias_declaration] = STATE(192),
    [aux_sym_export_statement_repeat1] = STATE(4710),
    [sym__declaration] = STATE(192),
    [sym_ambient_declaration] = STATE(192),
    [sym_import_alias] = STATE(192),
    [sym_export_statement] = STATE(192),
    [sym_generator_function] = STATE(192),
    [sym_lexical_declaration] = STATE(192),
    [sym_internal_module] = STATE(192),
    [sym_decorator] = STATE(4710),
    [sym_enum_declaration] = STATE(192),
    [sym_function] = STATE(192),
    [sym_function_signature] = STATE(192),
    [sym_variable_declaration] = STATE(192),
    [sym_abstract_class] = STATE(192),
    [sym_module] = STATE(192),
    [sym_interface_declaration] = STATE(192),
    [sym_class] = STATE(192),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(9234),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(9236),
    [anon_sym_global] = ACTIONS(322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(9238),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [4709] = {
    [sym_type_alias_declaration] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(4710),
    [sym__declaration] = STATE(317),
    [sym_ambient_declaration] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_export_statement] = STATE(317),
    [sym_generator_function] = STATE(317),
    [sym_export_clause] = STATE(318),
    [sym_lexical_declaration] = STATE(317),
    [sym_internal_module] = STATE(317),
    [sym_decorator] = STATE(4710),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(317),
    [sym_function_signature] = STATE(317),
    [sym_variable_declaration] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_module] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_class] = STATE(317),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(9236),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(9238),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [4710] = {
    [aux_sym_export_statement_repeat1] = STATE(352),
    [sym_decorator] = STATE(352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(9242),
    [anon_sym_class] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [4711] = {
    [sym_type_alias_declaration] = STATE(777),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(777),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(777),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(777),
    [sym_return_statement] = STATE(777),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(777),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(777),
    [sym_switch_statement] = STATE(777),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(777),
    [sym_throw_statement] = STATE(777),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(777),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(777),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(777),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(777),
    [sym_abstract_class] = STATE(777),
    [sym_interface_declaration] = STATE(777),
    [sym_statement_block] = STATE(777),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(777),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(777),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(777),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(777),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(777),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(777),
    [sym_empty_statement] = STATE(777),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(777),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(777),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(777),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(777),
    [sym_break_statement] = STATE(777),
    [sym_labeled_statement] = STATE(777),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(777),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [4712] = {
    [sym_type_alias_declaration] = STATE(934),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(934),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(934),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(934),
    [sym_return_statement] = STATE(934),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(934),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(934),
    [sym_switch_statement] = STATE(934),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(934),
    [sym_throw_statement] = STATE(934),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(934),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(934),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(934),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(934),
    [sym_abstract_class] = STATE(934),
    [sym_interface_declaration] = STATE(934),
    [sym_statement_block] = STATE(934),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(934),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(934),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(934),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(934),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(934),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(934),
    [sym_empty_statement] = STATE(934),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(934),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(934),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(934),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(934),
    [sym_break_statement] = STATE(934),
    [sym_labeled_statement] = STATE(934),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(934),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [4713] = {
    [sym_type_alias_declaration] = STATE(2047),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2047),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2047),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2047),
    [sym_return_statement] = STATE(2047),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2047),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2047),
    [sym_switch_statement] = STATE(2047),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2047),
    [sym_throw_statement] = STATE(2047),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2047),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2047),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(2047),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2047),
    [sym_abstract_class] = STATE(2047),
    [sym_interface_declaration] = STATE(2047),
    [sym_statement_block] = STATE(2047),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2047),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2047),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2047),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2047),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2047),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2047),
    [sym_empty_statement] = STATE(2047),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(2047),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2047),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2047),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2047),
    [sym_break_statement] = STATE(2047),
    [sym_labeled_statement] = STATE(2047),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2047),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [4714] = {
    [sym_type_alias_declaration] = STATE(915),
    [aux_sym_export_statement_repeat1] = STATE(4710),
    [sym__declaration] = STATE(915),
    [sym_ambient_declaration] = STATE(915),
    [sym_import_alias] = STATE(915),
    [sym_export_statement] = STATE(915),
    [sym_generator_function] = STATE(915),
    [sym_lexical_declaration] = STATE(915),
    [sym_internal_module] = STATE(915),
    [sym_decorator] = STATE(4710),
    [sym_enum_declaration] = STATE(915),
    [sym_function] = STATE(915),
    [sym_function_signature] = STATE(915),
    [sym_variable_declaration] = STATE(915),
    [sym_abstract_class] = STATE(915),
    [sym_module] = STATE(915),
    [sym_interface_declaration] = STATE(915),
    [sym_class] = STATE(915),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_interface] = ACTIONS(326),
    [anon_sym_enum] = ACTIONS(328),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(340),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(9236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_type] = ACTIONS(332),
    [anon_sym_let] = ACTIONS(350),
    [anon_sym_import] = ACTIONS(334),
    [anon_sym_export] = ACTIONS(9238),
    [anon_sym_namespace] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(344),
  },
  [4715] = {
    [sym_array] = STATE(4907),
    [sym_object] = STATE(4908),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(9508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4716] = {
    [anon_sym_of] = ACTIONS(9510),
    [sym_comment] = ACTIONS(3),
  },
  [4717] = {
    [anon_sym_of] = ACTIONS(9512),
    [sym_comment] = ACTIONS(3),
  },
  [4718] = {
    [anon_sym_of] = ACTIONS(9514),
    [sym_comment] = ACTIONS(3),
  },
  [4719] = {
    [sym_new_expression] = STATE(4912),
    [sym_augmented_assignment_expression] = STATE(4912),
    [sym_unary_expression] = STATE(4912),
    [sym_update_expression] = STATE(4912),
    [sym_regex] = STATE(4912),
    [sym_meta_property] = STATE(4912),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(4912),
    [sym_yield_expression] = STATE(4912),
    [sym_as_expression] = STATE(4912),
    [sym_non_null_expression] = STATE(4912),
    [sym_internal_module] = STATE(4912),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4912),
    [sym_await_expression] = STATE(4912),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(4913),
    [sym_string] = STATE(4912),
    [sym_this] = STATE(4912),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4912),
    [sym_generator_function] = STATE(4912),
    [sym_call_expression] = STATE(4912),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4912),
    [sym_ternary_expression] = STATE(4912),
    [sym_binary_expression] = STATE(4912),
    [sym_template_string] = STATE(4912),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4912),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4912),
    [sym_class] = STATE(4912),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(9516),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9516),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(9518),
    [sym_true] = ACTIONS(9516),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9516),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [4720] = {
    [sym_new_expression] = STATE(4914),
    [sym_augmented_assignment_expression] = STATE(4914),
    [sym_unary_expression] = STATE(4914),
    [sym_update_expression] = STATE(4914),
    [sym_regex] = STATE(4914),
    [sym_meta_property] = STATE(4914),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4914),
    [sym_yield_expression] = STATE(4914),
    [sym_as_expression] = STATE(4914),
    [sym_non_null_expression] = STATE(4914),
    [sym_internal_module] = STATE(4914),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4914),
    [sym_await_expression] = STATE(4914),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4914),
    [sym_this] = STATE(4914),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4914),
    [sym_generator_function] = STATE(4914),
    [sym_call_expression] = STATE(4914),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4914),
    [sym_ternary_expression] = STATE(4914),
    [sym_binary_expression] = STATE(4914),
    [sym_template_string] = STATE(4914),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4914),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4914),
    [sym_class] = STATE(4914),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9520),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9520),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9522),
    [sym_true] = ACTIONS(9520),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9520),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4721] = {
    [sym__initializer] = STATE(405),
    [sym_type_annotation] = STATE(406),
    [sym__automatic_semicolon] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_of] = ACTIONS(9510),
    [anon_sym_COMMA] = ACTIONS(739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9524),
  },
  [4722] = {
    [sym__initializer] = STATE(425),
    [sym_type_annotation] = STATE(426),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(9512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9526),
  },
  [4723] = {
    [sym__initializer] = STATE(427),
    [sym_type_annotation] = STATE(428),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(9514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9528),
  },
  [4724] = {
    [sym_new_expression] = STATE(4919),
    [sym_augmented_assignment_expression] = STATE(4919),
    [sym_unary_expression] = STATE(4919),
    [sym_update_expression] = STATE(4919),
    [sym_regex] = STATE(4919),
    [sym_meta_property] = STATE(4919),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(4919),
    [sym_yield_expression] = STATE(4919),
    [sym_as_expression] = STATE(4919),
    [sym_non_null_expression] = STATE(4919),
    [sym_internal_module] = STATE(4919),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4919),
    [sym_await_expression] = STATE(4919),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(4920),
    [sym_string] = STATE(4919),
    [sym_this] = STATE(4919),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(4919),
    [sym_generator_function] = STATE(4919),
    [sym_call_expression] = STATE(4919),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(4919),
    [sym_ternary_expression] = STATE(4919),
    [sym_binary_expression] = STATE(4919),
    [sym_template_string] = STATE(4919),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4919),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(4919),
    [sym_class] = STATE(4919),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9530),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9530),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(9532),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9534),
    [sym_true] = ACTIONS(9530),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9530),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4725] = {
    [sym_new_expression] = STATE(4921),
    [sym_augmented_assignment_expression] = STATE(4921),
    [sym_unary_expression] = STATE(4921),
    [sym_update_expression] = STATE(4921),
    [sym_regex] = STATE(4921),
    [sym_meta_property] = STATE(4921),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4921),
    [sym_yield_expression] = STATE(4921),
    [sym_as_expression] = STATE(4921),
    [sym_non_null_expression] = STATE(4921),
    [sym_internal_module] = STATE(4921),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4921),
    [sym_await_expression] = STATE(4921),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4921),
    [sym_this] = STATE(4921),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4921),
    [sym_generator_function] = STATE(4921),
    [sym_call_expression] = STATE(4921),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4921),
    [sym_ternary_expression] = STATE(4921),
    [sym_binary_expression] = STATE(4921),
    [sym_template_string] = STATE(4921),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4921),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4921),
    [sym_class] = STATE(4921),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9536),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9536),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9538),
    [sym_true] = ACTIONS(9536),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9536),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4726] = {
    [sym_new_expression] = STATE(4922),
    [sym_augmented_assignment_expression] = STATE(4922),
    [sym_unary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_regex] = STATE(4922),
    [sym_meta_property] = STATE(4922),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(4922),
    [sym_yield_expression] = STATE(4922),
    [sym_as_expression] = STATE(4922),
    [sym_non_null_expression] = STATE(4922),
    [sym_internal_module] = STATE(4922),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4922),
    [sym_await_expression] = STATE(4922),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(4923),
    [sym_string] = STATE(4922),
    [sym_this] = STATE(4922),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4922),
    [sym_generator_function] = STATE(4922),
    [sym_call_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4922),
    [sym_ternary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_template_string] = STATE(4922),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4922),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4922),
    [sym_class] = STATE(4922),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(9540),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9540),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(9542),
    [sym_true] = ACTIONS(9540),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9540),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [4727] = {
    [sym_new_expression] = STATE(4924),
    [sym_augmented_assignment_expression] = STATE(4924),
    [sym_unary_expression] = STATE(4924),
    [sym_update_expression] = STATE(4924),
    [sym_regex] = STATE(4924),
    [sym_meta_property] = STATE(4924),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4924),
    [sym_yield_expression] = STATE(4924),
    [sym_as_expression] = STATE(4924),
    [sym_non_null_expression] = STATE(4924),
    [sym_internal_module] = STATE(4924),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4924),
    [sym_await_expression] = STATE(4924),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4924),
    [sym_this] = STATE(4924),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4924),
    [sym_generator_function] = STATE(4924),
    [sym_call_expression] = STATE(4924),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4924),
    [sym_ternary_expression] = STATE(4924),
    [sym_binary_expression] = STATE(4924),
    [sym_template_string] = STATE(4924),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4924),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4924),
    [sym_class] = STATE(4924),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9544),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9544),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9546),
    [sym_true] = ACTIONS(9544),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9544),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4728] = {
    [sym_new_expression] = STATE(4925),
    [sym_augmented_assignment_expression] = STATE(4925),
    [sym_unary_expression] = STATE(4925),
    [sym_update_expression] = STATE(4925),
    [sym_regex] = STATE(4925),
    [sym_meta_property] = STATE(4925),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(4925),
    [sym_yield_expression] = STATE(4925),
    [sym_as_expression] = STATE(4925),
    [sym_non_null_expression] = STATE(4925),
    [sym_internal_module] = STATE(4925),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4925),
    [sym_await_expression] = STATE(4925),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(4926),
    [sym_string] = STATE(4925),
    [sym_this] = STATE(4925),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(4925),
    [sym_generator_function] = STATE(4925),
    [sym_call_expression] = STATE(4925),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(4925),
    [sym_ternary_expression] = STATE(4925),
    [sym_binary_expression] = STATE(4925),
    [sym_template_string] = STATE(4925),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4925),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(4925),
    [sym_class] = STATE(4925),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(9548),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9548),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(9550),
    [sym_true] = ACTIONS(9548),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9548),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [4729] = {
    [anon_sym_COLON] = ACTIONS(9552),
    [sym_comment] = ACTIONS(3),
  },
  [4730] = {
    [anon_sym_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(7962),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(7964),
    [sym_comment] = ACTIONS(3),
  },
  [4731] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4928),
    [sym_constructor_type] = STATE(4928),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1461),
    [sym_function_type] = STATE(4928),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4928),
    [sym_intersection_type] = STATE(4928),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3258),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3259),
    [sym_identifier] = ACTIONS(3049),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6709),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4732] = {
    [anon_sym_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(7962),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(7964),
    [sym_comment] = ACTIONS(3),
  },
  [4733] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4929),
    [sym_constructor_type] = STATE(4929),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(4929),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4929),
    [sym_intersection_type] = STATE(4929),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4734] = {
    [anon_sym_EQ_GT] = ACTIONS(9554),
    [sym_comment] = ACTIONS(3),
  },
  [4735] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4931),
    [sym_constructor_type] = STATE(4931),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(4931),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4931),
    [sym_intersection_type] = STATE(4931),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4736] = {
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(8765),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8767),
    [sym_comment] = ACTIONS(3),
  },
  [4737] = {
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4738] = {
    [anon_sym_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(8010),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8012),
    [sym_comment] = ACTIONS(3),
  },
  [4739] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4932),
    [sym_constructor_type] = STATE(4932),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1550),
    [sym_function_type] = STATE(4932),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4932),
    [sym_intersection_type] = STATE(4932),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3305),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3306),
    [sym_identifier] = ACTIONS(3237),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4740] = {
    [anon_sym_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(8010),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8012),
    [sym_comment] = ACTIONS(3),
  },
  [4741] = {
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8020),
    [anon_sym_RBRACK] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [4742] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4933),
    [sym_constructor_type] = STATE(4933),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1559),
    [sym_function_type] = STATE(4933),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4933),
    [sym_intersection_type] = STATE(4933),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3317),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3318),
    [sym_identifier] = ACTIONS(3247),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4743] = {
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8020),
    [anon_sym_RBRACK] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [4744] = {
    [sym__automatic_semicolon] = ACTIONS(9444),
    [anon_sym_RBRACE] = ACTIONS(9444),
    [anon_sym_SEMI] = ACTIONS(9444),
    [anon_sym_COMMA] = ACTIONS(9444),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9444),
    [sym_comment] = ACTIONS(3),
  },
  [4745] = {
    [sym__automatic_semicolon] = ACTIONS(7333),
    [anon_sym_RBRACE] = ACTIONS(7333),
    [anon_sym_SEMI] = ACTIONS(7333),
    [anon_sym_COMMA] = ACTIONS(7333),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7333),
    [sym_comment] = ACTIONS(3),
  },
  [4746] = {
    [sym_computed_property_name] = STATE(1144),
    [sym__enum_member] = STATE(2900),
    [sym__property_name] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_enum_assignment] = STATE(2900),
    [anon_sym_get] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(9556),
    [anon_sym_public] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1214),
    [anon_sym_symbol] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1214),
    [sym_number] = ACTIONS(2375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1214),
    [anon_sym_string] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1214),
    [anon_sym_namespace] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1214),
    [anon_sym_private] = ACTIONS(1214),
    [anon_sym_boolean] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_async] = ACTIONS(1214),
  },
  [4747] = {
    [sym__automatic_semicolon] = ACTIONS(7735),
    [anon_sym_RBRACE] = ACTIONS(7735),
    [anon_sym_AMP] = ACTIONS(6875),
    [anon_sym_SEMI] = ACTIONS(7735),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7735),
    [anon_sym_PIPE] = ACTIONS(6877),
    [anon_sym_COMMA] = ACTIONS(7735),
    [sym_comment] = ACTIONS(3),
  },
  [4748] = {
    [sym__automatic_semicolon] = ACTIONS(7390),
    [anon_sym_RBRACE] = ACTIONS(7390),
    [anon_sym_SEMI] = ACTIONS(7390),
    [anon_sym_COMMA] = ACTIONS(7390),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7390),
    [sym_comment] = ACTIONS(3),
  },
  [4749] = {
    [sym__automatic_semicolon] = ACTIONS(7402),
    [anon_sym_RBRACE] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(7402),
    [anon_sym_COMMA] = ACTIONS(7402),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7402),
    [sym_comment] = ACTIONS(3),
  },
  [4750] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4935),
    [sym_constructor_type] = STATE(4935),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4935),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4935),
    [sym_intersection_type] = STATE(4935),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4751] = {
    [anon_sym_EQ_GT] = ACTIONS(9558),
    [sym_comment] = ACTIONS(3),
  },
  [4752] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4937),
    [sym_constructor_type] = STATE(4937),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(4937),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4937),
    [sym_intersection_type] = STATE(4937),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4753] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(8815),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8817),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [4754] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_RBRACE] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(6875),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(6877),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4755] = {
    [sym_call_signature] = STATE(4938),
    [sym_formal_parameters] = STATE(809),
    [sym_type_parameters] = STATE(811),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4756] = {
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_RBRACK] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4757] = {
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(6923),
    [anon_sym_PIPE] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
  },
  [4758] = {
    [sym_new_expression] = STATE(549),
    [sym_augmented_assignment_expression] = STATE(555),
    [sym_unary_expression] = STATE(555),
    [sym_update_expression] = STATE(555),
    [sym_regex] = STATE(549),
    [sym_meta_property] = STATE(549),
    [sym_call_signature] = STATE(158),
    [sym__expression] = STATE(555),
    [sym_yield_expression] = STATE(555),
    [sym_as_expression] = STATE(555),
    [sym_non_null_expression] = STATE(555),
    [sym_internal_module] = STATE(555),
    [sym_function] = STATE(556),
    [sym_arrow_function] = STATE(549),
    [sym_await_expression] = STATE(555),
    [sym_member_expression] = STATE(557),
    [sym_string] = STATE(549),
    [sym_this] = STATE(549),
    [sym_type_parameters] = STATE(4617),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(558),
    [sym_anonymous_class] = STATE(549),
    [sym_generator_function] = STATE(549),
    [sym_call_expression] = STATE(555),
    [sym_subscript_expression] = STATE(557),
    [sym_assignment_expression] = STATE(555),
    [sym_ternary_expression] = STATE(555),
    [sym_binary_expression] = STATE(555),
    [sym_template_string] = STATE(549),
    [sym_type_arguments] = STATE(309),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(4618),
    [sym_parenthesized_expression] = STATE(549),
    [sym_array] = STATE(559),
    [sym_type_assertion] = STATE(555),
    [sym_class] = STATE(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [sym_identifier] = ACTIONS(1005),
    [sym_false] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(1009),
    [anon_sym_symbol] = ACTIONS(1009),
    [anon_sym_number] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1009),
    [anon_sym_typeof] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1007),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1009),
    [anon_sym_private] = ACTIONS(1009),
    [anon_sym_boolean] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_public] = ACTIONS(1009),
    [anon_sym_get] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(1015),
    [sym_true] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1009),
    [anon_sym_string] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_DOT] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_set] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_new] = ACTIONS(296),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1009),
    [anon_sym_namespace] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(510),
  },
  [4759] = {
    [sym_statement_block] = STATE(4335),
    [sym__automatic_semicolon] = ACTIONS(9128),
    [anon_sym_RBRACE] = ACTIONS(9128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(9128),
    [anon_sym_COMMA] = ACTIONS(9128),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9128),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [4760] = {
    [sym_call_signature] = STATE(4939),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4761] = {
    [sym_formal_parameters] = STATE(4940),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4762] = {
    [sym_type_annotation] = STATE(337),
    [anon_sym_EQ_GT] = ACTIONS(9560),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4763] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(9563),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4764] = {
    [sym__automatic_semicolon] = ACTIONS(4363),
    [anon_sym_LBRACK] = ACTIONS(6255),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_SEMI] = ACTIONS(4363),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(8310),
    [anon_sym_COMMA] = ACTIONS(6255),
    [anon_sym_LT_LT] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2063),
    [anon_sym_EQ] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_BANG_EQ] = ACTIONS(2063),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(8310),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_PERCENT] = ACTIONS(2063),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2063),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(6255),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4363),
    [anon_sym_CARET] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_STAR_STAR] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2063),
  },
  [4765] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1944),
    [sym_constructor_type] = STATE(1944),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(1944),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1944),
    [sym_intersection_type] = STATE(1944),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4766] = {
    [sym_formal_parameters] = STATE(4941),
    [sym_type_parameters] = STATE(4942),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4767] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(1952),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4768] = {
    [sym__automatic_semicolon] = ACTIONS(5196),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(9566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9568),
    [anon_sym_COMMA] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5196),
  },
  [4769] = {
    [sym_formal_parameters] = STATE(4945),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4770] = {
    [anon_sym_EQ_GT] = ACTIONS(9570),
    [sym_comment] = ACTIONS(3),
  },
  [4771] = {
    [sym__automatic_semicolon] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(9566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9568),
    [anon_sym_COMMA] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5204),
  },
  [4772] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4947),
    [sym_constructor_type] = STATE(4947),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(4947),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4947),
    [sym_intersection_type] = STATE(4947),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4055),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4057),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8148),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8150),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4773] = {
    [anon_sym_EQ_GT] = ACTIONS(9572),
    [sym_comment] = ACTIONS(3),
  },
  [4774] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4949),
    [sym_constructor_type] = STATE(4949),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(4949),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4949),
    [sym_intersection_type] = STATE(4949),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4055),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4057),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8148),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8150),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4775] = {
    [sym__automatic_semicolon] = ACTIONS(5406),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(9566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9568),
    [anon_sym_COMMA] = ACTIONS(5406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5406),
  },
  [4776] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(8859),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5425),
  },
  [4777] = {
    [sym_call_signature] = STATE(4939),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(9574),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [4778] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4951),
    [sym_constructor_type] = STATE(4951),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(4951),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4951),
    [sym_intersection_type] = STATE(4951),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4779] = {
    [anon_sym_EQ_GT] = ACTIONS(9576),
    [sym_comment] = ACTIONS(3),
  },
  [4780] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4953),
    [sym_constructor_type] = STATE(4953),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(4953),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4953),
    [sym_intersection_type] = STATE(4953),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4781] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(8873),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(8875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5425),
  },
  [4782] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(7000),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(7002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8086),
  },
  [4783] = {
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(8170),
    [anon_sym_PIPE] = ACTIONS(8172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6909),
  },
  [4784] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4954),
    [sym_constructor_type] = STATE(4954),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(1700),
    [sym_function_type] = STATE(4954),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4954),
    [sym_intersection_type] = STATE(4954),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3443),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3444),
    [sym_identifier] = ACTIONS(3506),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7012),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7014),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4785] = {
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(8170),
    [anon_sym_PIPE] = ACTIONS(8172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6986),
  },
  [4786] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8885),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(8887),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4787] = {
    [sym_new_expression] = STATE(4955),
    [sym_augmented_assignment_expression] = STATE(4955),
    [sym_unary_expression] = STATE(4955),
    [sym_update_expression] = STATE(4955),
    [sym_regex] = STATE(4955),
    [sym_meta_property] = STATE(4955),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4955),
    [sym_yield_expression] = STATE(4955),
    [sym_as_expression] = STATE(4955),
    [sym_non_null_expression] = STATE(4955),
    [sym_internal_module] = STATE(4955),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4955),
    [sym_await_expression] = STATE(4955),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4955),
    [sym_this] = STATE(4955),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4955),
    [sym_generator_function] = STATE(4955),
    [sym_call_expression] = STATE(4955),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4955),
    [sym_ternary_expression] = STATE(4955),
    [sym_binary_expression] = STATE(4955),
    [sym_template_string] = STATE(4955),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4955),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4955),
    [sym_class] = STATE(4955),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9578),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9580),
    [sym_true] = ACTIONS(9578),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9578),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4788] = {
    [sym_new_expression] = STATE(4956),
    [sym_augmented_assignment_expression] = STATE(4956),
    [sym_unary_expression] = STATE(4956),
    [sym_update_expression] = STATE(4956),
    [sym_regex] = STATE(4956),
    [sym_meta_property] = STATE(4956),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4956),
    [sym_yield_expression] = STATE(4956),
    [sym_as_expression] = STATE(4956),
    [sym_non_null_expression] = STATE(4956),
    [sym_internal_module] = STATE(4956),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4956),
    [sym_await_expression] = STATE(4956),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4956),
    [sym_this] = STATE(4956),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4956),
    [sym_generator_function] = STATE(4956),
    [sym_call_expression] = STATE(4956),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4956),
    [sym_ternary_expression] = STATE(4956),
    [sym_binary_expression] = STATE(4956),
    [sym_template_string] = STATE(4956),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4956),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4956),
    [sym_class] = STATE(4956),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9582),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9582),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9584),
    [sym_true] = ACTIONS(9582),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9582),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4789] = {
    [sym_new_expression] = STATE(4957),
    [sym_augmented_assignment_expression] = STATE(4957),
    [sym_unary_expression] = STATE(4957),
    [sym_update_expression] = STATE(4957),
    [sym_regex] = STATE(4957),
    [sym_meta_property] = STATE(4957),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(4957),
    [sym_yield_expression] = STATE(4957),
    [sym_as_expression] = STATE(4957),
    [sym_non_null_expression] = STATE(4957),
    [sym_internal_module] = STATE(4957),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(4957),
    [sym_await_expression] = STATE(4957),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(4957),
    [sym_this] = STATE(4957),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(4957),
    [sym_generator_function] = STATE(4957),
    [sym_call_expression] = STATE(4957),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(4957),
    [sym_ternary_expression] = STATE(4957),
    [sym_binary_expression] = STATE(4957),
    [sym_template_string] = STATE(4957),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4957),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(4957),
    [sym_class] = STATE(4957),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9586),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9586),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9588),
    [sym_true] = ACTIONS(9586),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9586),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4790] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9590),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4791] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9592),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4792] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9594),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4793] = {
    [sym_type_alias_declaration] = STATE(3690),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3690),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3690),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3690),
    [sym_return_statement] = STATE(3690),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3690),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3690),
    [sym_switch_statement] = STATE(3690),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3690),
    [sym_throw_statement] = STATE(3690),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3690),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3690),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(3690),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3690),
    [sym_abstract_class] = STATE(3690),
    [sym_interface_declaration] = STATE(3690),
    [sym_statement_block] = STATE(3690),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3690),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3690),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3690),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3690),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3690),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3690),
    [sym_empty_statement] = STATE(3690),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(3690),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3690),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3690),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3690),
    [sym_break_statement] = STATE(3690),
    [sym_labeled_statement] = STATE(3690),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3690),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4794] = {
    [sym_type_alias_declaration] = STATE(3719),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3719),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3719),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3719),
    [sym_return_statement] = STATE(3719),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3719),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3719),
    [sym_switch_statement] = STATE(3719),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3719),
    [sym_throw_statement] = STATE(3719),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3719),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3719),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(3719),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3719),
    [sym_abstract_class] = STATE(3719),
    [sym_interface_declaration] = STATE(3719),
    [sym_statement_block] = STATE(3719),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3719),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3719),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3719),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3719),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3719),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3719),
    [sym_empty_statement] = STATE(3719),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(3719),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3719),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3719),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3719),
    [sym_break_statement] = STATE(3719),
    [sym_labeled_statement] = STATE(3719),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3719),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4795] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9596),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4796] = {
    [anon_sym_RPAREN] = ACTIONS(9596),
    [sym_comment] = ACTIONS(3),
  },
  [4797] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9598),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4798] = {
    [anon_sym_RPAREN] = ACTIONS(9598),
    [sym_comment] = ACTIONS(3),
  },
  [4799] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9600),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4800] = {
    [anon_sym_RPAREN] = ACTIONS(9600),
    [sym_comment] = ACTIONS(3),
  },
  [4801] = {
    [sym_type_alias_declaration] = STATE(3724),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3724),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3724),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3724),
    [sym_return_statement] = STATE(3724),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3724),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3724),
    [sym_switch_statement] = STATE(3724),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3724),
    [sym_throw_statement] = STATE(3724),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3724),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3724),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(3724),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3724),
    [sym_abstract_class] = STATE(3724),
    [sym_interface_declaration] = STATE(3724),
    [sym_statement_block] = STATE(3724),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3724),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3724),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3724),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3724),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3724),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3724),
    [sym_empty_statement] = STATE(3724),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(3724),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3724),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3724),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3724),
    [sym_break_statement] = STATE(3724),
    [sym_labeled_statement] = STATE(3724),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3724),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4802] = {
    [sym_type_alias_declaration] = STATE(3725),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3725),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3725),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3725),
    [sym_return_statement] = STATE(3725),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3725),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3725),
    [sym_switch_statement] = STATE(3725),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3725),
    [sym_throw_statement] = STATE(3725),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3725),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3725),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(3725),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3725),
    [sym_abstract_class] = STATE(3725),
    [sym_interface_declaration] = STATE(3725),
    [sym_statement_block] = STATE(3725),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3725),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3725),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3725),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3725),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3725),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3725),
    [sym_empty_statement] = STATE(3725),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(3725),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3725),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3725),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3725),
    [sym_break_statement] = STATE(3725),
    [sym_labeled_statement] = STATE(3725),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3725),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4803] = {
    [sym_type_alias_declaration] = STATE(3726),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3726),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3726),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3726),
    [sym_return_statement] = STATE(3726),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3726),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3726),
    [sym_switch_statement] = STATE(3726),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3726),
    [sym_throw_statement] = STATE(3726),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3726),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3726),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(3726),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3726),
    [sym_abstract_class] = STATE(3726),
    [sym_interface_declaration] = STATE(3726),
    [sym_statement_block] = STATE(3726),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3726),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3726),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3726),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3726),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3726),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3726),
    [sym_empty_statement] = STATE(3726),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(3726),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3726),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3726),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3726),
    [sym_break_statement] = STATE(3726),
    [sym_labeled_statement] = STATE(3726),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3726),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4804] = {
    [sym_type_alias_declaration] = STATE(3727),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3727),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3727),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3727),
    [sym_return_statement] = STATE(3727),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3727),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3727),
    [sym_switch_statement] = STATE(3727),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3727),
    [sym_throw_statement] = STATE(3727),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3727),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3727),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(3727),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3727),
    [sym_abstract_class] = STATE(3727),
    [sym_interface_declaration] = STATE(3727),
    [sym_statement_block] = STATE(3727),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3727),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3727),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3727),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3727),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3727),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3727),
    [sym_empty_statement] = STATE(3727),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(3727),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3727),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3727),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3727),
    [sym_break_statement] = STATE(3727),
    [sym_labeled_statement] = STATE(3727),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3727),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4805] = {
    [sym_type_alias_declaration] = STATE(3728),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3728),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3728),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3728),
    [sym_return_statement] = STATE(3728),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3728),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3728),
    [sym_switch_statement] = STATE(3728),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3728),
    [sym_throw_statement] = STATE(3728),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3728),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3728),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(3728),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3728),
    [sym_abstract_class] = STATE(3728),
    [sym_interface_declaration] = STATE(3728),
    [sym_statement_block] = STATE(3728),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3728),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3728),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3728),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3728),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3728),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3728),
    [sym_empty_statement] = STATE(3728),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(3728),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3728),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3728),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3728),
    [sym_break_statement] = STATE(3728),
    [sym_labeled_statement] = STATE(3728),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3728),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4806] = {
    [sym_type_arguments] = STATE(791),
    [anon_sym_is] = ACTIONS(9602),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_else] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(9604),
  },
  [4807] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4808] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4812),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4814),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9369),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9371),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4809] = {
    [sym_formal_parameters] = STATE(4966),
    [sym_type_parameters] = STATE(4967),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4810] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4812),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4814),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9369),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9371),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4811] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_PIPE] = ACTIONS(9608),
    [anon_sym_else] = ACTIONS(7735),
    [anon_sym_while] = ACTIONS(7735),
  },
  [4812] = {
    [sym_formal_parameters] = STATE(4970),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4813] = {
    [sym_type_arguments] = STATE(850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_while] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_else] = ACTIONS(1577),
    [anon_sym_in] = ACTIONS(9610),
  },
  [4814] = {
    [anon_sym_EQ_GT] = ACTIONS(9612),
    [sym_comment] = ACTIONS(3),
  },
  [4815] = {
    [sym_type_alias_declaration] = STATE(4592),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4592),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4592),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4592),
    [sym_return_statement] = STATE(4592),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4592),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4592),
    [sym_switch_statement] = STATE(4592),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4592),
    [sym_throw_statement] = STATE(4592),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4592),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4592),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(4592),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4592),
    [sym_abstract_class] = STATE(4592),
    [sym_interface_declaration] = STATE(4592),
    [sym_statement_block] = STATE(4592),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4592),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4592),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4592),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4592),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4592),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4592),
    [sym_empty_statement] = STATE(4592),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(4592),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4592),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4592),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4592),
    [sym_break_statement] = STATE(4592),
    [sym_labeled_statement] = STATE(4592),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4592),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4816] = {
    [sym_type_alias_declaration] = STATE(4593),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4593),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4593),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4593),
    [sym_return_statement] = STATE(4593),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4593),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4593),
    [sym_switch_statement] = STATE(4593),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4593),
    [sym_throw_statement] = STATE(4593),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4593),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4593),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(4593),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4593),
    [sym_abstract_class] = STATE(4593),
    [sym_interface_declaration] = STATE(4593),
    [sym_statement_block] = STATE(4593),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4593),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4593),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4593),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4593),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4593),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4593),
    [sym_empty_statement] = STATE(4593),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(4593),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4593),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4593),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4593),
    [sym_break_statement] = STATE(4593),
    [sym_labeled_statement] = STATE(4593),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4593),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4817] = {
    [sym_type_alias_declaration] = STATE(4594),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4594),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4594),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4594),
    [sym_return_statement] = STATE(4594),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4594),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4594),
    [sym_switch_statement] = STATE(4594),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4594),
    [sym_throw_statement] = STATE(4594),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4594),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4594),
    [sym_decorator] = STATE(331),
    [sym_continue_statement] = STATE(4594),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4594),
    [sym_abstract_class] = STATE(4594),
    [sym_interface_declaration] = STATE(4594),
    [sym_statement_block] = STATE(4594),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4594),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4594),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4594),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4594),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4594),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4594),
    [sym_empty_statement] = STATE(4594),
    [aux_sym_export_statement_repeat1] = STATE(331),
    [sym_import_alias] = STATE(4594),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4594),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4594),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4594),
    [sym_break_statement] = STATE(4594),
    [sym_labeled_statement] = STATE(4594),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4594),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(564),
  },
  [4818] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4819] = {
    [sym_formal_parameters] = STATE(4973),
    [sym_type_parameters] = STATE(4974),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4820] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4821] = {
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(9614),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_while] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
  },
  [4822] = {
    [sym_formal_parameters] = STATE(4977),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4823] = {
    [anon_sym_EQ_GT] = ACTIONS(9618),
    [sym_comment] = ACTIONS(3),
  },
  [4824] = {
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(9614),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_while] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
  },
  [4825] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4979),
    [sym_constructor_type] = STATE(4979),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(4979),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4979),
    [sym_intersection_type] = STATE(4979),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4139),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4141),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4826] = {
    [anon_sym_EQ_GT] = ACTIONS(9620),
    [sym_comment] = ACTIONS(3),
  },
  [4827] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4981),
    [sym_constructor_type] = STATE(4981),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(4981),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4981),
    [sym_intersection_type] = STATE(4981),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4139),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4141),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4828] = {
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(9614),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_while] = ACTIONS(5406),
    [sym_comment] = ACTIONS(3),
  },
  [4829] = {
    [anon_sym_AMP] = ACTIONS(8967),
    [anon_sym_PIPE] = ACTIONS(8969),
    [anon_sym_while] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [4830] = {
    [anon_sym_EQ_GT] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(7145),
    [anon_sym_PIPE] = ACTIONS(7147),
    [sym_comment] = ACTIONS(3),
  },
  [4831] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8977),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(8979),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8086),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4832] = {
    [anon_sym_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(7253),
    [anon_sym_SEMI] = ACTIONS(8086),
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(7255),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4833] = {
    [anon_sym_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(7277),
    [anon_sym_PIPE] = ACTIONS(7279),
    [sym_comment] = ACTIONS(3),
  },
  [4834] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9008),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_LBRACE] = ACTIONS(8987),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(9010),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4835] = {
    [sym_type_alias_declaration] = STATE(4592),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4592),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4592),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4592),
    [sym_return_statement] = STATE(4592),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4592),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4592),
    [sym_switch_statement] = STATE(4592),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4592),
    [sym_throw_statement] = STATE(4592),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4592),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4592),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(4592),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4592),
    [sym_abstract_class] = STATE(4592),
    [sym_interface_declaration] = STATE(4592),
    [sym_statement_block] = STATE(4592),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4592),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4592),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4592),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4592),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4592),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4592),
    [sym_empty_statement] = STATE(4592),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(4592),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4592),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4592),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4592),
    [sym_break_statement] = STATE(4592),
    [sym_labeled_statement] = STATE(4592),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4592),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4836] = {
    [sym_type_alias_declaration] = STATE(4593),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4593),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4593),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4593),
    [sym_return_statement] = STATE(4593),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4593),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4593),
    [sym_switch_statement] = STATE(4593),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4593),
    [sym_throw_statement] = STATE(4593),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4593),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4593),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(4593),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4593),
    [sym_abstract_class] = STATE(4593),
    [sym_interface_declaration] = STATE(4593),
    [sym_statement_block] = STATE(4593),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4593),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4593),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4593),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4593),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4593),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4593),
    [sym_empty_statement] = STATE(4593),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(4593),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4593),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4593),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4593),
    [sym_break_statement] = STATE(4593),
    [sym_labeled_statement] = STATE(4593),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4593),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4837] = {
    [sym_type_alias_declaration] = STATE(4594),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4594),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4594),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4594),
    [sym_return_statement] = STATE(4594),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4594),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4594),
    [sym_switch_statement] = STATE(4594),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4594),
    [sym_throw_statement] = STATE(4594),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4594),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4594),
    [sym_decorator] = STATE(480),
    [sym_continue_statement] = STATE(4594),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4594),
    [sym_abstract_class] = STATE(4594),
    [sym_interface_declaration] = STATE(4594),
    [sym_statement_block] = STATE(4594),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4594),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4594),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4594),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4594),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4594),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4594),
    [sym_empty_statement] = STATE(4594),
    [aux_sym_export_statement_repeat1] = STATE(480),
    [sym_import_alias] = STATE(4594),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4594),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4594),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4594),
    [sym_break_statement] = STATE(4594),
    [sym_labeled_statement] = STATE(4594),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4594),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(861),
  },
  [4838] = {
    [sym_identifier] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_debugger] = ACTIONS(7182),
    [anon_sym_symbol] = ACTIONS(7182),
    [anon_sym_AT] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9042),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_void] = ACTIONS(7182),
    [anon_sym_break] = ACTIONS(7182),
    [anon_sym_const] = ACTIONS(7182),
    [sym_super] = ACTIONS(7182),
    [anon_sym_return] = ACTIONS(7182),
    [anon_sym_private] = ACTIONS(7182),
    [anon_sym_get] = ACTIONS(7182),
    [anon_sym_interface] = ACTIONS(7182),
    [anon_sym_enum] = ACTIONS(7182),
    [anon_sym_delete] = ACTIONS(7182),
    [anon_sym_continue] = ACTIONS(7182),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_if] = ACTIONS(7182),
    [anon_sym_this] = ACTIONS(7182),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_true] = ACTIONS(7182),
    [anon_sym_throw] = ACTIONS(7182),
    [anon_sym_protected] = ACTIONS(7182),
    [anon_sym_abstract] = ACTIONS(7182),
    [anon_sym_set] = ACTIONS(7182),
    [anon_sym_type] = ACTIONS(7182),
    [anon_sym_import] = ACTIONS(7182),
    [anon_sym_namespace] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_await] = ACTIONS(7182),
    [anon_sym_DQUOTE] = ACTIONS(5196),
    [anon_sym_else] = ACTIONS(7182),
    [anon_sym_BANG] = ACTIONS(5196),
    [anon_sym_for] = ACTIONS(7182),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [sym_false] = ACTIONS(7182),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_module] = ACTIONS(7182),
    [anon_sym_number] = ACTIONS(7182),
    [anon_sym_class] = ACTIONS(7182),
    [anon_sym_declare] = ACTIONS(7182),
    [anon_sym_typeof] = ACTIONS(7182),
    [anon_sym_LBRACE] = ACTIONS(5196),
    [anon_sym_switch] = ACTIONS(7182),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [sym_null] = ACTIONS(7182),
    [anon_sym_any] = ACTIONS(7182),
    [anon_sym_boolean] = ACTIONS(7182),
    [anon_sym_async] = ACTIONS(7182),
    [anon_sym_public] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(9044),
    [anon_sym_var] = ACTIONS(7182),
    [anon_sym_while] = ACTIONS(7182),
    [anon_sym_SQUOTE] = ACTIONS(5196),
    [anon_sym_try] = ACTIONS(7182),
    [anon_sym_LT] = ACTIONS(5196),
    [sym_number] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7182),
    [anon_sym_function] = ACTIONS(7182),
    [sym_undefined] = ACTIONS(7182),
    [anon_sym_new] = ACTIONS(7182),
    [ts_builtin_sym_end] = ACTIONS(5196),
    [anon_sym_let] = ACTIONS(7182),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_export] = ACTIONS(7182),
    [anon_sym_do] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(5196),
    [anon_sym_with] = ACTIONS(7182),
  },
  [4839] = {
    [sym_identifier] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_debugger] = ACTIONS(7197),
    [anon_sym_symbol] = ACTIONS(7197),
    [anon_sym_AT] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9042),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_void] = ACTIONS(7197),
    [anon_sym_break] = ACTIONS(7197),
    [anon_sym_const] = ACTIONS(7197),
    [sym_super] = ACTIONS(7197),
    [anon_sym_return] = ACTIONS(7197),
    [anon_sym_private] = ACTIONS(7197),
    [anon_sym_get] = ACTIONS(7197),
    [anon_sym_interface] = ACTIONS(7197),
    [anon_sym_enum] = ACTIONS(7197),
    [anon_sym_delete] = ACTIONS(7197),
    [anon_sym_continue] = ACTIONS(7197),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_if] = ACTIONS(7197),
    [anon_sym_this] = ACTIONS(7197),
    [anon_sym_yield] = ACTIONS(7197),
    [sym_true] = ACTIONS(7197),
    [anon_sym_throw] = ACTIONS(7197),
    [anon_sym_protected] = ACTIONS(7197),
    [anon_sym_abstract] = ACTIONS(7197),
    [anon_sym_set] = ACTIONS(7197),
    [anon_sym_type] = ACTIONS(7197),
    [anon_sym_import] = ACTIONS(7197),
    [anon_sym_namespace] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_await] = ACTIONS(7197),
    [anon_sym_DQUOTE] = ACTIONS(5204),
    [anon_sym_else] = ACTIONS(7197),
    [anon_sym_BANG] = ACTIONS(5204),
    [anon_sym_for] = ACTIONS(7197),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [sym_false] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_module] = ACTIONS(7197),
    [anon_sym_number] = ACTIONS(7197),
    [anon_sym_class] = ACTIONS(7197),
    [anon_sym_declare] = ACTIONS(7197),
    [anon_sym_typeof] = ACTIONS(7197),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_switch] = ACTIONS(7197),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [sym_null] = ACTIONS(7197),
    [anon_sym_any] = ACTIONS(7197),
    [anon_sym_boolean] = ACTIONS(7197),
    [anon_sym_async] = ACTIONS(7197),
    [anon_sym_public] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(9044),
    [anon_sym_var] = ACTIONS(7197),
    [anon_sym_while] = ACTIONS(7197),
    [anon_sym_SQUOTE] = ACTIONS(5204),
    [anon_sym_try] = ACTIONS(7197),
    [anon_sym_LT] = ACTIONS(5204),
    [sym_number] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7197),
    [anon_sym_function] = ACTIONS(7197),
    [sym_undefined] = ACTIONS(7197),
    [anon_sym_new] = ACTIONS(7197),
    [ts_builtin_sym_end] = ACTIONS(5204),
    [anon_sym_let] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_export] = ACTIONS(7197),
    [anon_sym_do] = ACTIONS(7197),
    [anon_sym_TILDE] = ACTIONS(5204),
    [anon_sym_with] = ACTIONS(7197),
  },
  [4840] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4982),
    [sym_constructor_type] = STATE(4982),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(4982),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4982),
    [sym_intersection_type] = STATE(4982),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4841] = {
    [anon_sym_EQ_GT] = ACTIONS(9622),
    [sym_comment] = ACTIONS(3),
  },
  [4842] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4984),
    [sym_constructor_type] = STATE(4984),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(4984),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4984),
    [sym_intersection_type] = STATE(4984),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4843] = {
    [sym_identifier] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_debugger] = ACTIONS(7207),
    [anon_sym_symbol] = ACTIONS(7207),
    [anon_sym_AT] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9042),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_void] = ACTIONS(7207),
    [anon_sym_break] = ACTIONS(7207),
    [anon_sym_const] = ACTIONS(7207),
    [sym_super] = ACTIONS(7207),
    [anon_sym_return] = ACTIONS(7207),
    [anon_sym_private] = ACTIONS(7207),
    [anon_sym_get] = ACTIONS(7207),
    [anon_sym_interface] = ACTIONS(7207),
    [anon_sym_enum] = ACTIONS(7207),
    [anon_sym_delete] = ACTIONS(7207),
    [anon_sym_continue] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_if] = ACTIONS(7207),
    [anon_sym_this] = ACTIONS(7207),
    [anon_sym_yield] = ACTIONS(7207),
    [sym_true] = ACTIONS(7207),
    [anon_sym_throw] = ACTIONS(7207),
    [anon_sym_protected] = ACTIONS(7207),
    [anon_sym_abstract] = ACTIONS(7207),
    [anon_sym_set] = ACTIONS(7207),
    [anon_sym_type] = ACTIONS(7207),
    [anon_sym_import] = ACTIONS(7207),
    [anon_sym_namespace] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_await] = ACTIONS(7207),
    [anon_sym_DQUOTE] = ACTIONS(5406),
    [anon_sym_else] = ACTIONS(7207),
    [anon_sym_BANG] = ACTIONS(5406),
    [anon_sym_for] = ACTIONS(7207),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [sym_false] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_module] = ACTIONS(7207),
    [anon_sym_number] = ACTIONS(7207),
    [anon_sym_class] = ACTIONS(7207),
    [anon_sym_declare] = ACTIONS(7207),
    [anon_sym_typeof] = ACTIONS(7207),
    [anon_sym_LBRACE] = ACTIONS(5406),
    [anon_sym_switch] = ACTIONS(7207),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [sym_null] = ACTIONS(7207),
    [anon_sym_any] = ACTIONS(7207),
    [anon_sym_boolean] = ACTIONS(7207),
    [anon_sym_async] = ACTIONS(7207),
    [anon_sym_public] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(9044),
    [anon_sym_var] = ACTIONS(7207),
    [anon_sym_while] = ACTIONS(7207),
    [anon_sym_SQUOTE] = ACTIONS(5406),
    [anon_sym_try] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(5406),
    [sym_number] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7207),
    [anon_sym_function] = ACTIONS(7207),
    [sym_undefined] = ACTIONS(7207),
    [anon_sym_new] = ACTIONS(7207),
    [ts_builtin_sym_end] = ACTIONS(5406),
    [anon_sym_let] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_export] = ACTIONS(7207),
    [anon_sym_do] = ACTIONS(7207),
    [anon_sym_TILDE] = ACTIONS(5406),
    [anon_sym_with] = ACTIONS(7207),
  },
  [4844] = {
    [sym_identifier] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_debugger] = ACTIONS(7211),
    [anon_sym_symbol] = ACTIONS(7211),
    [anon_sym_AT] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9042),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_void] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [sym_super] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_private] = ACTIONS(7211),
    [anon_sym_get] = ACTIONS(7211),
    [anon_sym_interface] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_delete] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_this] = ACTIONS(7211),
    [anon_sym_yield] = ACTIONS(7211),
    [sym_true] = ACTIONS(7211),
    [anon_sym_throw] = ACTIONS(7211),
    [anon_sym_protected] = ACTIONS(7211),
    [anon_sym_abstract] = ACTIONS(7211),
    [anon_sym_set] = ACTIONS(7211),
    [anon_sym_type] = ACTIONS(7211),
    [anon_sym_import] = ACTIONS(7211),
    [anon_sym_namespace] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_await] = ACTIONS(7211),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [anon_sym_else] = ACTIONS(7211),
    [anon_sym_BANG] = ACTIONS(5425),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [sym_false] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_module] = ACTIONS(7211),
    [anon_sym_number] = ACTIONS(7211),
    [anon_sym_class] = ACTIONS(7211),
    [anon_sym_declare] = ACTIONS(7211),
    [anon_sym_typeof] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(5425),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [sym_null] = ACTIONS(7211),
    [anon_sym_any] = ACTIONS(7211),
    [anon_sym_boolean] = ACTIONS(7211),
    [anon_sym_async] = ACTIONS(7211),
    [anon_sym_public] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(9044),
    [anon_sym_var] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_try] = ACTIONS(7211),
    [anon_sym_LT] = ACTIONS(5425),
    [sym_number] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7211),
    [anon_sym_function] = ACTIONS(7211),
    [sym_undefined] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [ts_builtin_sym_end] = ACTIONS(5425),
    [anon_sym_let] = ACTIONS(7211),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_export] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_TILDE] = ACTIONS(5425),
    [anon_sym_with] = ACTIONS(7211),
  },
  [4845] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(7392),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(7394),
    [sym_comment] = ACTIONS(3),
  },
  [4846] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9416),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(9418),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4847] = {
    [sym_tuple_type] = STATE(988),
    [sym__type] = STATE(4985),
    [sym_constructor_type] = STATE(4985),
    [sym_index_type_query] = STATE(988),
    [sym_lookup_type] = STATE(988),
    [sym_this_type] = STATE(988),
    [sym_flow_maybe_type] = STATE(988),
    [sym_array_type] = STATE(988),
    [sym_nested_type_identifier] = STATE(3682),
    [sym_function_type] = STATE(4985),
    [sym_type_predicate] = STATE(988),
    [sym_type_query] = STATE(988),
    [sym__number] = STATE(969),
    [sym_existential_type] = STATE(988),
    [sym_nested_identifier] = STATE(986),
    [sym_object_type] = STATE(988),
    [sym_union_type] = STATE(4985),
    [sym_intersection_type] = STATE(4985),
    [sym__primary_type] = STATE(988),
    [sym_generic_type] = STATE(988),
    [sym_mapped_type] = STATE(988),
    [sym_literal_type] = STATE(988),
    [sym_parenthesized_type] = STATE(988),
    [sym_predefined_type] = STATE(988),
    [sym_type_parameters] = STATE(3681),
    [sym_string] = STATE(969),
    [sym_formal_parameters] = STATE(3683),
    [sym_identifier] = ACTIONS(7491),
    [sym_false] = ACTIONS(1968),
    [anon_sym_QMARK] = ACTIONS(7497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(7495),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1976),
    [sym_number] = ACTIONS(1996),
    [sym_true] = ACTIONS(1968),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(7499),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(7493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1972),
  },
  [4848] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9416),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(9418),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4849] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9422),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(9424),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4850] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(4986),
    [sym_constructor_type] = STATE(4986),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3711),
    [sym_function_type] = STATE(4986),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(4986),
    [sym_intersection_type] = STATE(4986),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3710),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3712),
    [sym_identifier] = ACTIONS(7568),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7572),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7576),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4851] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9422),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(9424),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4852] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(9624),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4853] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9110),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_RBRACK] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(9112),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4854] = {
    [anon_sym_EQ_GT] = ACTIONS(9627),
    [sym_comment] = ACTIONS(3),
  },
  [4855] = {
    [sym_formal_parameters] = STATE(4988),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4856] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4857] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4858] = {
    [anon_sym_EQ_GT] = ACTIONS(9629),
    [sym_comment] = ACTIONS(3),
  },
  [4859] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4990),
    [sym_constructor_type] = STATE(4990),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(4990),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4990),
    [sym_intersection_type] = STATE(4990),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4860] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(8553),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8555),
    [sym_comment] = ACTIONS(3),
  },
  [4861] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4991),
    [sym_constructor_type] = STATE(4991),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(4991),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4991),
    [sym_intersection_type] = STATE(4991),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(3784),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(3786),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(7682),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(7684),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(7686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4862] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(8553),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8555),
    [sym_comment] = ACTIONS(3),
  },
  [4863] = {
    [sym__automatic_semicolon] = ACTIONS(9452),
    [anon_sym_LBRACK] = ACTIONS(9452),
    [sym_identifier] = ACTIONS(9631),
    [anon_sym_SEMI] = ACTIONS(9452),
    [anon_sym_module] = ACTIONS(9631),
    [anon_sym_symbol] = ACTIONS(9631),
    [anon_sym_number] = ACTIONS(9631),
    [anon_sym_AT] = ACTIONS(9452),
    [anon_sym_declare] = ACTIONS(9631),
    [anon_sym_STAR] = ACTIONS(9452),
    [anon_sym_void] = ACTIONS(9631),
    [anon_sym_any] = ACTIONS(9631),
    [anon_sym_private] = ACTIONS(9631),
    [anon_sym_boolean] = ACTIONS(9631),
    [anon_sym_async] = ACTIONS(9631),
    [anon_sym_public] = ACTIONS(9631),
    [anon_sym_get] = ACTIONS(9631),
    [anon_sym_RBRACE] = ACTIONS(9452),
    [anon_sym_static] = ACTIONS(9631),
    [anon_sym_SQUOTE] = ACTIONS(9452),
    [sym_number] = ACTIONS(9452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(9631),
    [anon_sym_string] = ACTIONS(9631),
    [anon_sym_abstract] = ACTIONS(9631),
    [anon_sym_set] = ACTIONS(9631),
    [anon_sym_type] = ACTIONS(9631),
    [anon_sym_import] = ACTIONS(9631),
    [anon_sym_export] = ACTIONS(9631),
    [anon_sym_namespace] = ACTIONS(9631),
    [sym_readonly] = ACTIONS(9631),
    [anon_sym_DQUOTE] = ACTIONS(9452),
  },
  [4864] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4992),
    [sym_constructor_type] = STATE(4992),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(4992),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4992),
    [sym_intersection_type] = STATE(4992),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4865] = {
    [anon_sym_EQ_GT] = ACTIONS(9633),
    [sym_comment] = ACTIONS(3),
  },
  [4866] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(4994),
    [sym_constructor_type] = STATE(4994),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(4994),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(4994),
    [sym_intersection_type] = STATE(4994),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4867] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(9132),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9134),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5425),
  },
  [4868] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(7708),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(7710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8086),
  },
  [4869] = {
    [sym_statement_block] = STATE(4995),
    [sym__automatic_semicolon] = ACTIONS(9635),
    [anon_sym_SEMI] = ACTIONS(9635),
    [anon_sym_COMMA] = ACTIONS(9635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4779),
  },
  [4870] = {
    [sym_identifier] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_debugger] = ACTIONS(8987),
    [anon_sym_symbol] = ACTIONS(8987),
    [anon_sym_AT] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(7737),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_void] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8987),
    [anon_sym_const] = ACTIONS(8987),
    [sym_super] = ACTIONS(8987),
    [anon_sym_return] = ACTIONS(8987),
    [anon_sym_private] = ACTIONS(8987),
    [anon_sym_get] = ACTIONS(8987),
    [anon_sym_interface] = ACTIONS(8987),
    [anon_sym_enum] = ACTIONS(8987),
    [anon_sym_delete] = ACTIONS(8987),
    [anon_sym_continue] = ACTIONS(8987),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_if] = ACTIONS(8987),
    [anon_sym_this] = ACTIONS(8987),
    [anon_sym_yield] = ACTIONS(8987),
    [sym_true] = ACTIONS(8987),
    [anon_sym_throw] = ACTIONS(8987),
    [anon_sym_protected] = ACTIONS(8987),
    [anon_sym_abstract] = ACTIONS(8987),
    [anon_sym_set] = ACTIONS(8987),
    [anon_sym_type] = ACTIONS(8987),
    [anon_sym_import] = ACTIONS(8987),
    [anon_sym_namespace] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_await] = ACTIONS(8987),
    [anon_sym_DQUOTE] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8086),
    [anon_sym_for] = ACTIONS(8987),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [sym_false] = ACTIONS(8987),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_module] = ACTIONS(8987),
    [anon_sym_number] = ACTIONS(8987),
    [anon_sym_class] = ACTIONS(8987),
    [anon_sym_declare] = ACTIONS(8987),
    [anon_sym_typeof] = ACTIONS(8987),
    [anon_sym_LBRACE] = ACTIONS(8086),
    [anon_sym_switch] = ACTIONS(8987),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [sym_null] = ACTIONS(8987),
    [anon_sym_any] = ACTIONS(8987),
    [anon_sym_boolean] = ACTIONS(8987),
    [anon_sym_async] = ACTIONS(8987),
    [anon_sym_public] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(7739),
    [anon_sym_var] = ACTIONS(8987),
    [anon_sym_while] = ACTIONS(8987),
    [anon_sym_SQUOTE] = ACTIONS(8086),
    [anon_sym_try] = ACTIONS(8987),
    [anon_sym_LT] = ACTIONS(8086),
    [sym_number] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8987),
    [anon_sym_function] = ACTIONS(8987),
    [sym_undefined] = ACTIONS(8987),
    [anon_sym_new] = ACTIONS(8987),
    [ts_builtin_sym_end] = ACTIONS(8086),
    [anon_sym_let] = ACTIONS(8987),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_export] = ACTIONS(8987),
    [anon_sym_do] = ACTIONS(8987),
    [anon_sym_TILDE] = ACTIONS(8086),
    [anon_sym_with] = ACTIONS(8987),
  },
  [4871] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9146),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_RBRACE] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(9148),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4872] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4873] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9639),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4874] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9641),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4875] = {
    [sym_type_alias_declaration] = STATE(4231),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4231),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4231),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4231),
    [sym_return_statement] = STATE(4231),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4231),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4231),
    [sym_switch_statement] = STATE(4231),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4231),
    [sym_throw_statement] = STATE(4231),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4231),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4231),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(4231),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4231),
    [sym_abstract_class] = STATE(4231),
    [sym_interface_declaration] = STATE(4231),
    [sym_statement_block] = STATE(4231),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4231),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4231),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4231),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4231),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4231),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4231),
    [sym_empty_statement] = STATE(4231),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(4231),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4231),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4231),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4231),
    [sym_break_statement] = STATE(4231),
    [sym_labeled_statement] = STATE(4231),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4231),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4876] = {
    [sym_type_alias_declaration] = STATE(4232),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4232),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4232),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4232),
    [sym_return_statement] = STATE(4232),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4232),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4232),
    [sym_switch_statement] = STATE(4232),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4232),
    [sym_throw_statement] = STATE(4232),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4232),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4232),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(4232),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4232),
    [sym_abstract_class] = STATE(4232),
    [sym_interface_declaration] = STATE(4232),
    [sym_statement_block] = STATE(4232),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4232),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4232),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4232),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4232),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4232),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4232),
    [sym_empty_statement] = STATE(4232),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(4232),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4232),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4232),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4232),
    [sym_break_statement] = STATE(4232),
    [sym_labeled_statement] = STATE(4232),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4232),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4877] = {
    [sym_type_alias_declaration] = STATE(4233),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4233),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4233),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4233),
    [sym_return_statement] = STATE(4233),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4233),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4233),
    [sym_switch_statement] = STATE(4233),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4233),
    [sym_throw_statement] = STATE(4233),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4233),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4233),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(4233),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4233),
    [sym_abstract_class] = STATE(4233),
    [sym_interface_declaration] = STATE(4233),
    [sym_statement_block] = STATE(4233),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4233),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4233),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4233),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4233),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4233),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4233),
    [sym_empty_statement] = STATE(4233),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(4233),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4233),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4233),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4233),
    [sym_break_statement] = STATE(4233),
    [sym_labeled_statement] = STATE(4233),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4233),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4878] = {
    [sym_type_alias_declaration] = STATE(4262),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4262),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4262),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4262),
    [sym_return_statement] = STATE(4262),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4262),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4262),
    [sym_switch_statement] = STATE(4262),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4262),
    [sym_throw_statement] = STATE(4262),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4262),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4262),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(4262),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4262),
    [sym_abstract_class] = STATE(4262),
    [sym_interface_declaration] = STATE(4262),
    [sym_statement_block] = STATE(4262),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4262),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4262),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4262),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4262),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4262),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4262),
    [sym_empty_statement] = STATE(4262),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(4262),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4262),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4262),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4262),
    [sym_break_statement] = STATE(4262),
    [sym_labeled_statement] = STATE(4262),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4262),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4879] = {
    [sym_type_alias_declaration] = STATE(4263),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4263),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4263),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4263),
    [sym_return_statement] = STATE(4263),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4263),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4263),
    [sym_switch_statement] = STATE(4263),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4263),
    [sym_throw_statement] = STATE(4263),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4263),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4263),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(4263),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4263),
    [sym_abstract_class] = STATE(4263),
    [sym_interface_declaration] = STATE(4263),
    [sym_statement_block] = STATE(4263),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4263),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4263),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4263),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4263),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4263),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4263),
    [sym_empty_statement] = STATE(4263),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(4263),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4263),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4263),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4263),
    [sym_break_statement] = STATE(4263),
    [sym_labeled_statement] = STATE(4263),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4263),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4880] = {
    [sym_type_alias_declaration] = STATE(4264),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4264),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4264),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4264),
    [sym_return_statement] = STATE(4264),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4264),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4264),
    [sym_switch_statement] = STATE(4264),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4264),
    [sym_throw_statement] = STATE(4264),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4264),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4264),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(4264),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4264),
    [sym_abstract_class] = STATE(4264),
    [sym_interface_declaration] = STATE(4264),
    [sym_statement_block] = STATE(4264),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4264),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4264),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4264),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4264),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4264),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4264),
    [sym_empty_statement] = STATE(4264),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(4264),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4264),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4264),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4264),
    [sym_break_statement] = STATE(4264),
    [sym_labeled_statement] = STATE(4264),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4264),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4881] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(4999),
    [sym_constructor_type] = STATE(4999),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(4999),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(4999),
    [sym_intersection_type] = STATE(4999),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4882] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5000),
    [sym_constructor_type] = STATE(5000),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(5000),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5000),
    [sym_intersection_type] = STATE(5000),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4883] = {
    [anon_sym_EQ_GT] = ACTIONS(9643),
    [sym_comment] = ACTIONS(3),
  },
  [4884] = {
    [sym_formal_parameters] = STATE(5002),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4885] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4886] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4887] = {
    [anon_sym_EQ_GT] = ACTIONS(9645),
    [sym_comment] = ACTIONS(3),
  },
  [4888] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5004),
    [sym_constructor_type] = STATE(5004),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(5004),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5004),
    [sym_intersection_type] = STATE(5004),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4889] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5005),
    [sym_constructor_type] = STATE(5005),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(5005),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5005),
    [sym_intersection_type] = STATE(5005),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4890] = {
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_debugger] = ACTIONS(8300),
    [anon_sym_symbol] = ACTIONS(8300),
    [anon_sym_AT] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8673),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_void] = ACTIONS(8300),
    [anon_sym_break] = ACTIONS(8300),
    [anon_sym_const] = ACTIONS(8300),
    [sym_super] = ACTIONS(8300),
    [anon_sym_return] = ACTIONS(8300),
    [anon_sym_private] = ACTIONS(8300),
    [anon_sym_get] = ACTIONS(8300),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_interface] = ACTIONS(8300),
    [anon_sym_enum] = ACTIONS(8300),
    [anon_sym_delete] = ACTIONS(8300),
    [anon_sym_continue] = ACTIONS(8300),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_if] = ACTIONS(8300),
    [anon_sym_this] = ACTIONS(8300),
    [anon_sym_yield] = ACTIONS(8300),
    [sym_true] = ACTIONS(8300),
    [anon_sym_throw] = ACTIONS(8300),
    [anon_sym_protected] = ACTIONS(8300),
    [anon_sym_abstract] = ACTIONS(8300),
    [anon_sym_set] = ACTIONS(8300),
    [anon_sym_type] = ACTIONS(8300),
    [anon_sym_import] = ACTIONS(8300),
    [anon_sym_namespace] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_await] = ACTIONS(8300),
    [anon_sym_DQUOTE] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(6909),
    [anon_sym_for] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [sym_false] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_module] = ACTIONS(8300),
    [anon_sym_number] = ACTIONS(8300),
    [anon_sym_class] = ACTIONS(8300),
    [anon_sym_declare] = ACTIONS(8300),
    [anon_sym_typeof] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_switch] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [sym_null] = ACTIONS(8300),
    [anon_sym_any] = ACTIONS(8300),
    [anon_sym_boolean] = ACTIONS(8300),
    [anon_sym_async] = ACTIONS(8300),
    [anon_sym_public] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_var] = ACTIONS(8300),
    [anon_sym_while] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(6909),
    [anon_sym_try] = ACTIONS(8300),
    [anon_sym_LT] = ACTIONS(6909),
    [sym_number] = ACTIONS(6909),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8300),
    [anon_sym_function] = ACTIONS(8300),
    [sym_undefined] = ACTIONS(8300),
    [anon_sym_new] = ACTIONS(8300),
    [anon_sym_let] = ACTIONS(8300),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_export] = ACTIONS(8300),
    [anon_sym_do] = ACTIONS(8300),
    [anon_sym_TILDE] = ACTIONS(6909),
    [anon_sym_with] = ACTIONS(8300),
  },
  [4891] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5006),
    [sym_constructor_type] = STATE(5006),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(3879),
    [sym_function_type] = STATE(5006),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5006),
    [sym_intersection_type] = STATE(5006),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3878),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3880),
    [sym_identifier] = ACTIONS(7847),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(7849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7851),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7853),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4892] = {
    [sym_identifier] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_debugger] = ACTIONS(8302),
    [anon_sym_symbol] = ACTIONS(8302),
    [anon_sym_AT] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8673),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_void] = ACTIONS(8302),
    [anon_sym_break] = ACTIONS(8302),
    [anon_sym_const] = ACTIONS(8302),
    [sym_super] = ACTIONS(8302),
    [anon_sym_return] = ACTIONS(8302),
    [anon_sym_private] = ACTIONS(8302),
    [anon_sym_get] = ACTIONS(8302),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_interface] = ACTIONS(8302),
    [anon_sym_enum] = ACTIONS(8302),
    [anon_sym_delete] = ACTIONS(8302),
    [anon_sym_continue] = ACTIONS(8302),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_if] = ACTIONS(8302),
    [anon_sym_this] = ACTIONS(8302),
    [anon_sym_yield] = ACTIONS(8302),
    [sym_true] = ACTIONS(8302),
    [anon_sym_throw] = ACTIONS(8302),
    [anon_sym_protected] = ACTIONS(8302),
    [anon_sym_abstract] = ACTIONS(8302),
    [anon_sym_set] = ACTIONS(8302),
    [anon_sym_type] = ACTIONS(8302),
    [anon_sym_import] = ACTIONS(8302),
    [anon_sym_namespace] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_await] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(6986),
    [anon_sym_for] = ACTIONS(8302),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [sym_false] = ACTIONS(8302),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_module] = ACTIONS(8302),
    [anon_sym_number] = ACTIONS(8302),
    [anon_sym_class] = ACTIONS(8302),
    [anon_sym_declare] = ACTIONS(8302),
    [anon_sym_typeof] = ACTIONS(8302),
    [anon_sym_LBRACE] = ACTIONS(6986),
    [anon_sym_switch] = ACTIONS(8302),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [sym_null] = ACTIONS(8302),
    [anon_sym_any] = ACTIONS(8302),
    [anon_sym_boolean] = ACTIONS(8302),
    [anon_sym_async] = ACTIONS(8302),
    [anon_sym_public] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_var] = ACTIONS(8302),
    [anon_sym_while] = ACTIONS(8302),
    [anon_sym_SQUOTE] = ACTIONS(6986),
    [anon_sym_try] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(6986),
    [sym_number] = ACTIONS(6986),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8302),
    [anon_sym_function] = ACTIONS(8302),
    [sym_undefined] = ACTIONS(8302),
    [anon_sym_new] = ACTIONS(8302),
    [anon_sym_let] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_export] = ACTIONS(8302),
    [anon_sym_do] = ACTIONS(8302),
    [anon_sym_TILDE] = ACTIONS(6986),
    [anon_sym_with] = ACTIONS(8302),
  },
  [4893] = {
    [anon_sym_COMMA] = ACTIONS(9647),
    [anon_sym_RBRACE] = ACTIONS(9647),
    [sym_comment] = ACTIONS(3),
  },
  [4894] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9492),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_LT_LT] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(8300),
    [anon_sym_GT_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP_AMP] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_BANG_EQ] = ACTIONS(8300),
    [anon_sym_LT_EQ] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_GT_EQ] = ACTIONS(6909),
    [anon_sym_GT] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(9494),
    [anon_sym_PERCENT] = ACTIONS(6909),
    [anon_sym_QMARK] = ACTIONS(6909),
    [anon_sym_as] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6909),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_EQ_EQ] = ACTIONS(8300),
    [anon_sym_instanceof] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(8300),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6909),
    [anon_sym_DOT] = ACTIONS(6909),
    [anon_sym_CARET] = ACTIONS(6909),
    [anon_sym_STAR_STAR] = ACTIONS(6909),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_GT_GT] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6909),
    [anon_sym_in] = ACTIONS(8300),
  },
  [4895] = {
    [sym_tuple_type] = STATE(1267),
    [sym__type] = STATE(5007),
    [sym_constructor_type] = STATE(5007),
    [sym_index_type_query] = STATE(1267),
    [sym_lookup_type] = STATE(1267),
    [sym_this_type] = STATE(1267),
    [sym_flow_maybe_type] = STATE(1267),
    [sym_array_type] = STATE(1267),
    [sym_nested_type_identifier] = STATE(3902),
    [sym_function_type] = STATE(5007),
    [sym_type_predicate] = STATE(1267),
    [sym_type_query] = STATE(1267),
    [sym__number] = STATE(1248),
    [sym_existential_type] = STATE(1267),
    [sym_nested_identifier] = STATE(1265),
    [sym_object_type] = STATE(1267),
    [sym_union_type] = STATE(5007),
    [sym_intersection_type] = STATE(5007),
    [sym__primary_type] = STATE(1267),
    [sym_generic_type] = STATE(1267),
    [sym_mapped_type] = STATE(1267),
    [sym_literal_type] = STATE(1267),
    [sym_parenthesized_type] = STATE(1267),
    [sym_predefined_type] = STATE(1267),
    [sym_type_parameters] = STATE(3901),
    [sym_string] = STATE(1248),
    [sym_formal_parameters] = STATE(3903),
    [sym_identifier] = ACTIONS(7914),
    [sym_false] = ACTIONS(2581),
    [anon_sym_QMARK] = ACTIONS(7920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(7918),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_keyof] = ACTIONS(2589),
    [sym_number] = ACTIONS(2609),
    [sym_true] = ACTIONS(2581),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_new] = ACTIONS(7922),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(7916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_boolean] = ACTIONS(2585),
  },
  [4896] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9492),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_LT_LT] = ACTIONS(6986),
    [anon_sym_STAR] = ACTIONS(8302),
    [anon_sym_GT_GT_GT] = ACTIONS(6986),
    [anon_sym_AMP_AMP] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_BANG_EQ] = ACTIONS(8302),
    [anon_sym_LT_EQ] = ACTIONS(6986),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [anon_sym_GT_EQ] = ACTIONS(6986),
    [anon_sym_GT] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(9494),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_QMARK] = ACTIONS(6986),
    [anon_sym_as] = ACTIONS(6986),
    [anon_sym_PIPE_PIPE] = ACTIONS(6986),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_EQ_EQ] = ACTIONS(8302),
    [anon_sym_instanceof] = ACTIONS(6986),
    [anon_sym_LT] = ACTIONS(8302),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6986),
    [anon_sym_DOT] = ACTIONS(6986),
    [anon_sym_CARET] = ACTIONS(6986),
    [anon_sym_STAR_STAR] = ACTIONS(6986),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_GT_GT] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6986),
    [anon_sym_in] = ACTIONS(8302),
  },
  [4897] = {
    [sym_identifier] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2401),
    [anon_sym_debugger] = ACTIONS(2399),
    [anon_sym_symbol] = ACTIONS(2399),
    [anon_sym_AT] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2399),
    [anon_sym_void] = ACTIONS(2399),
    [anon_sym_break] = ACTIONS(2399),
    [anon_sym_const] = ACTIONS(2399),
    [sym_super] = ACTIONS(2399),
    [anon_sym_return] = ACTIONS(2399),
    [anon_sym_private] = ACTIONS(2399),
    [anon_sym_get] = ACTIONS(2399),
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_default] = ACTIONS(2399),
    [anon_sym_interface] = ACTIONS(2399),
    [anon_sym_enum] = ACTIONS(2399),
    [anon_sym_delete] = ACTIONS(2399),
    [anon_sym_continue] = ACTIONS(2399),
    [anon_sym_DASH_DASH] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2399),
    [anon_sym_this] = ACTIONS(2399),
    [anon_sym_yield] = ACTIONS(2399),
    [sym_true] = ACTIONS(2399),
    [anon_sym_throw] = ACTIONS(2399),
    [anon_sym_protected] = ACTIONS(2399),
    [anon_sym_abstract] = ACTIONS(2399),
    [anon_sym_set] = ACTIONS(2399),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_import] = ACTIONS(2399),
    [anon_sym_namespace] = ACTIONS(2399),
    [anon_sym_PLUS_PLUS] = ACTIONS(2401),
    [anon_sym_await] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [anon_sym_else] = ACTIONS(9649),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [sym_false] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2401),
    [anon_sym_case] = ACTIONS(2399),
    [anon_sym_module] = ACTIONS(2399),
    [anon_sym_number] = ACTIONS(2399),
    [anon_sym_class] = ACTIONS(2399),
    [anon_sym_declare] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_switch] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [sym_null] = ACTIONS(2399),
    [anon_sym_any] = ACTIONS(2399),
    [anon_sym_boolean] = ACTIONS(2399),
    [anon_sym_async] = ACTIONS(2399),
    [anon_sym_public] = ACTIONS(2399),
    [anon_sym_var] = ACTIONS(2399),
    [anon_sym_while] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2401),
    [anon_sym_try] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2401),
    [sym_number] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2399),
    [anon_sym_function] = ACTIONS(2399),
    [sym_undefined] = ACTIONS(2399),
    [anon_sym_new] = ACTIONS(2399),
    [anon_sym_let] = ACTIONS(2399),
    [anon_sym_PLUS] = ACTIONS(2399),
    [anon_sym_export] = ACTIONS(2399),
    [anon_sym_do] = ACTIONS(2399),
    [anon_sym_TILDE] = ACTIONS(2401),
    [anon_sym_with] = ACTIONS(2399),
  },
  [4898] = {
    [sym_array] = STATE(5011),
    [sym_object] = STATE(5012),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(9651),
    [anon_sym_var] = ACTIONS(9653),
    [anon_sym_const] = ACTIONS(9653),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(9653),
  },
  [4899] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9655),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9657),
  },
  [4900] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(5016),
    [sym_object] = STATE(5017),
    [sym_identifier] = ACTIONS(9659),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4901] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(5016),
    [sym_object] = STATE(5017),
    [sym_identifier] = ACTIONS(9659),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4902] = {
    [sym_new_expression] = STATE(58),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_update_expression] = STATE(58),
    [sym_regex] = STATE(58),
    [sym_meta_property] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym__expression] = STATE(58),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_internal_module] = STATE(58),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(58),
    [sym_await_expression] = STATE(58),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(5018),
    [sym_sequence_expression] = STATE(61),
    [sym_string] = STATE(58),
    [sym_this] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_empty_statement] = STATE(5018),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(58),
    [sym_generator_function] = STATE(58),
    [sym_call_expression] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_assignment_expression] = STATE(58),
    [sym_ternary_expression] = STATE(58),
    [sym_binary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_class] = STATE(58),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [4903] = {
    [sym__initializer] = STATE(335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9661),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9663),
  },
  [4904] = {
    [sym__initializer] = STATE(354),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9665),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9667),
  },
  [4905] = {
    [sym_identifier] = ACTIONS(9669),
    [sym_comment] = ACTIONS(3),
  },
  [4906] = {
    [anon_sym_of] = ACTIONS(9671),
    [sym_comment] = ACTIONS(3),
  },
  [4907] = {
    [anon_sym_of] = ACTIONS(9673),
    [sym_comment] = ACTIONS(3),
  },
  [4908] = {
    [anon_sym_of] = ACTIONS(9675),
    [sym_comment] = ACTIONS(3),
  },
  [4909] = {
    [sym_new_expression] = STATE(5027),
    [sym_augmented_assignment_expression] = STATE(5027),
    [sym_unary_expression] = STATE(5027),
    [sym_update_expression] = STATE(5027),
    [sym_regex] = STATE(5027),
    [sym_meta_property] = STATE(5027),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5027),
    [sym_yield_expression] = STATE(5027),
    [sym_as_expression] = STATE(5027),
    [sym_non_null_expression] = STATE(5027),
    [sym_internal_module] = STATE(5027),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5027),
    [sym_await_expression] = STATE(5027),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5027),
    [sym_this] = STATE(5027),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5027),
    [sym_generator_function] = STATE(5027),
    [sym_call_expression] = STATE(5027),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5027),
    [sym_ternary_expression] = STATE(5027),
    [sym_binary_expression] = STATE(5027),
    [sym_template_string] = STATE(5027),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5027),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5027),
    [sym_class] = STATE(5027),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9677),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9677),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9679),
    [sym_true] = ACTIONS(9677),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9677),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4910] = {
    [sym_new_expression] = STATE(5028),
    [sym_augmented_assignment_expression] = STATE(5028),
    [sym_unary_expression] = STATE(5028),
    [sym_update_expression] = STATE(5028),
    [sym_regex] = STATE(5028),
    [sym_meta_property] = STATE(5028),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5028),
    [sym_yield_expression] = STATE(5028),
    [sym_as_expression] = STATE(5028),
    [sym_non_null_expression] = STATE(5028),
    [sym_internal_module] = STATE(5028),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5028),
    [sym_await_expression] = STATE(5028),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5028),
    [sym_this] = STATE(5028),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5028),
    [sym_generator_function] = STATE(5028),
    [sym_call_expression] = STATE(5028),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5028),
    [sym_ternary_expression] = STATE(5028),
    [sym_binary_expression] = STATE(5028),
    [sym_template_string] = STATE(5028),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5028),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5028),
    [sym_class] = STATE(5028),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9681),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9681),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9683),
    [sym_true] = ACTIONS(9681),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9681),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4911] = {
    [sym_new_expression] = STATE(5029),
    [sym_augmented_assignment_expression] = STATE(5029),
    [sym_unary_expression] = STATE(5029),
    [sym_update_expression] = STATE(5029),
    [sym_regex] = STATE(5029),
    [sym_meta_property] = STATE(5029),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5029),
    [sym_yield_expression] = STATE(5029),
    [sym_as_expression] = STATE(5029),
    [sym_non_null_expression] = STATE(5029),
    [sym_internal_module] = STATE(5029),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5029),
    [sym_await_expression] = STATE(5029),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5029),
    [sym_this] = STATE(5029),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5029),
    [sym_generator_function] = STATE(5029),
    [sym_call_expression] = STATE(5029),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5029),
    [sym_ternary_expression] = STATE(5029),
    [sym_binary_expression] = STATE(5029),
    [sym_template_string] = STATE(5029),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5029),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5029),
    [sym_class] = STATE(5029),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9685),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9685),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9687),
    [sym_true] = ACTIONS(9685),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9685),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [4912] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9689),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [4913] = {
    [anon_sym_RPAREN] = ACTIONS(9689),
    [sym_comment] = ACTIONS(3),
  },
  [4914] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9691),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4915] = {
    [sym_new_expression] = STATE(5032),
    [sym_augmented_assignment_expression] = STATE(5032),
    [sym_unary_expression] = STATE(5032),
    [sym_update_expression] = STATE(5032),
    [sym_regex] = STATE(5032),
    [sym_meta_property] = STATE(5032),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(5032),
    [sym_yield_expression] = STATE(5032),
    [sym_as_expression] = STATE(5032),
    [sym_non_null_expression] = STATE(5032),
    [sym_internal_module] = STATE(5032),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5032),
    [sym_await_expression] = STATE(5032),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(5033),
    [sym_string] = STATE(5032),
    [sym_this] = STATE(5032),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(5032),
    [sym_generator_function] = STATE(5032),
    [sym_call_expression] = STATE(5032),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(5032),
    [sym_ternary_expression] = STATE(5032),
    [sym_binary_expression] = STATE(5032),
    [sym_template_string] = STATE(5032),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5032),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(5032),
    [sym_class] = STATE(5032),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9693),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9693),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9695),
    [sym_true] = ACTIONS(9693),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9693),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4916] = {
    [sym_new_expression] = STATE(5034),
    [sym_augmented_assignment_expression] = STATE(5034),
    [sym_unary_expression] = STATE(5034),
    [sym_update_expression] = STATE(5034),
    [sym_regex] = STATE(5034),
    [sym_meta_property] = STATE(5034),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(5034),
    [sym_yield_expression] = STATE(5034),
    [sym_as_expression] = STATE(5034),
    [sym_non_null_expression] = STATE(5034),
    [sym_internal_module] = STATE(5034),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5034),
    [sym_await_expression] = STATE(5034),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(5035),
    [sym_string] = STATE(5034),
    [sym_this] = STATE(5034),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(5034),
    [sym_generator_function] = STATE(5034),
    [sym_call_expression] = STATE(5034),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(5034),
    [sym_ternary_expression] = STATE(5034),
    [sym_binary_expression] = STATE(5034),
    [sym_template_string] = STATE(5034),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5034),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(5034),
    [sym_class] = STATE(5034),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9697),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9697),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9699),
    [sym_true] = ACTIONS(9697),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9697),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4917] = {
    [sym_new_expression] = STATE(5036),
    [sym_augmented_assignment_expression] = STATE(5036),
    [sym_unary_expression] = STATE(5036),
    [sym_update_expression] = STATE(5036),
    [sym_regex] = STATE(5036),
    [sym_meta_property] = STATE(5036),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(5036),
    [sym_yield_expression] = STATE(5036),
    [sym_as_expression] = STATE(5036),
    [sym_non_null_expression] = STATE(5036),
    [sym_internal_module] = STATE(5036),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5036),
    [sym_await_expression] = STATE(5036),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(5037),
    [sym_string] = STATE(5036),
    [sym_this] = STATE(5036),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(5036),
    [sym_generator_function] = STATE(5036),
    [sym_call_expression] = STATE(5036),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(5036),
    [sym_ternary_expression] = STATE(5036),
    [sym_binary_expression] = STATE(5036),
    [sym_template_string] = STATE(5036),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5036),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(5036),
    [sym_class] = STATE(5036),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9701),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9701),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9703),
    [sym_true] = ACTIONS(9701),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9701),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [4918] = {
    [sym_type_alias_declaration] = STATE(3004),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3004),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3004),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3004),
    [sym_return_statement] = STATE(3004),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3004),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3004),
    [sym_switch_statement] = STATE(3004),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3004),
    [sym_throw_statement] = STATE(3004),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3004),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3004),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3004),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3004),
    [sym_abstract_class] = STATE(3004),
    [sym_interface_declaration] = STATE(3004),
    [sym_statement_block] = STATE(3004),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3004),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3004),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3004),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3004),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3004),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3004),
    [sym_empty_statement] = STATE(3004),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3004),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3004),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3004),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3004),
    [sym_break_statement] = STATE(3004),
    [sym_labeled_statement] = STATE(3004),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3004),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [4919] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9705),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4920] = {
    [anon_sym_RPAREN] = ACTIONS(9705),
    [sym_comment] = ACTIONS(3),
  },
  [4921] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9707),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4922] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9709),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [4923] = {
    [anon_sym_RPAREN] = ACTIONS(9709),
    [sym_comment] = ACTIONS(3),
  },
  [4924] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9711),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4925] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9713),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [4926] = {
    [anon_sym_RPAREN] = ACTIONS(9713),
    [sym_comment] = ACTIONS(3),
  },
  [4927] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5048),
    [sym_constructor_type] = STATE(5048),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(5048),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5048),
    [sym_intersection_type] = STATE(5048),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4928] = {
    [anon_sym_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(7962),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(7964),
    [sym_comment] = ACTIONS(3),
  },
  [4929] = {
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(8765),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8767),
    [sym_comment] = ACTIONS(3),
  },
  [4930] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5052),
    [sym_constructor_type] = STATE(5052),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(2429),
    [sym_function_type] = STATE(5052),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5052),
    [sym_intersection_type] = STATE(5052),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(3937),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(3938),
    [sym_identifier] = ACTIONS(5054),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(7980),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(7982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4931] = {
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(8765),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8767),
    [sym_comment] = ACTIONS(3),
  },
  [4932] = {
    [anon_sym_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(8010),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8012),
    [sym_comment] = ACTIONS(3),
  },
  [4933] = {
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8020),
    [anon_sym_RBRACK] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [4934] = {
    [sym__automatic_semicolon] = ACTIONS(8365),
    [anon_sym_RBRACE] = ACTIONS(8365),
    [anon_sym_SEMI] = ACTIONS(8365),
    [anon_sym_COMMA] = ACTIONS(8365),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8365),
    [sym_comment] = ACTIONS(3),
  },
  [4935] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(8815),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8817),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [4936] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5053),
    [sym_constructor_type] = STATE(5053),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2540),
    [sym_function_type] = STATE(5053),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5053),
    [sym_intersection_type] = STATE(5053),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4004),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4005),
    [sym_identifier] = ACTIONS(5280),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8066),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8068),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4937] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(8815),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8817),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [4938] = {
    [sym__automatic_semicolon] = ACTIONS(9635),
    [anon_sym_RBRACE] = ACTIONS(9635),
    [anon_sym_SEMI] = ACTIONS(9635),
    [anon_sym_COMMA] = ACTIONS(9635),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9635),
    [sym_comment] = ACTIONS(3),
  },
  [4939] = {
    [sym_statement_block] = STATE(4654),
    [sym__automatic_semicolon] = ACTIONS(9444),
    [anon_sym_RBRACE] = ACTIONS(9444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(9444),
    [anon_sym_COMMA] = ACTIONS(9444),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9444),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [4940] = {
    [sym_type_annotation] = STATE(935),
    [anon_sym_EQ_GT] = ACTIONS(9725),
    [anon_sym_COLON] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [4941] = {
    [anon_sym_EQ_GT] = ACTIONS(9728),
    [sym_comment] = ACTIONS(3),
  },
  [4942] = {
    [sym_formal_parameters] = STATE(5055),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4943] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2835),
    [sym_constructor_type] = STATE(2835),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(2835),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2835),
    [sym_intersection_type] = STATE(2835),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4944] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(2836),
    [sym_constructor_type] = STATE(2836),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(2836),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(2836),
    [sym_intersection_type] = STATE(2836),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4945] = {
    [anon_sym_EQ_GT] = ACTIONS(9730),
    [sym_comment] = ACTIONS(3),
  },
  [4946] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5057),
    [sym_constructor_type] = STATE(5057),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(5057),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5057),
    [sym_intersection_type] = STATE(5057),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4947] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(8859),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6909),
  },
  [4948] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5058),
    [sym_constructor_type] = STATE(5058),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(5058),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5058),
    [sym_intersection_type] = STATE(5058),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4055),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4057),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8148),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8150),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4949] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(8859),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6986),
  },
  [4950] = {
    [sym_call_signature] = STATE(5059),
    [sym_formal_parameters] = STATE(2601),
    [sym_type_parameters] = STATE(2602),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [4951] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(8873),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(8875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6909),
  },
  [4952] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5060),
    [sym_constructor_type] = STATE(5060),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(2622),
    [sym_function_type] = STATE(5060),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5060),
    [sym_intersection_type] = STATE(5060),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4066),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4067),
    [sym_identifier] = ACTIONS(5435),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8160),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8162),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4953] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(8873),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(8875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6986),
  },
  [4954] = {
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(8170),
    [anon_sym_PIPE] = ACTIONS(8172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8086),
  },
  [4955] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9732),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4956] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4957] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9736),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [4958] = {
    [sym_type_alias_declaration] = STATE(4231),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4231),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4231),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4231),
    [sym_return_statement] = STATE(4231),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4231),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4231),
    [sym_switch_statement] = STATE(4231),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4231),
    [sym_throw_statement] = STATE(4231),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4231),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4231),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(4231),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4231),
    [sym_abstract_class] = STATE(4231),
    [sym_interface_declaration] = STATE(4231),
    [sym_statement_block] = STATE(4231),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4231),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4231),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4231),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4231),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4231),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4231),
    [sym_empty_statement] = STATE(4231),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(4231),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4231),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4231),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4231),
    [sym_break_statement] = STATE(4231),
    [sym_labeled_statement] = STATE(4231),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4231),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4959] = {
    [sym_type_alias_declaration] = STATE(4232),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4232),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4232),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4232),
    [sym_return_statement] = STATE(4232),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4232),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4232),
    [sym_switch_statement] = STATE(4232),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4232),
    [sym_throw_statement] = STATE(4232),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4232),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4232),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(4232),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4232),
    [sym_abstract_class] = STATE(4232),
    [sym_interface_declaration] = STATE(4232),
    [sym_statement_block] = STATE(4232),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4232),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4232),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4232),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4232),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4232),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4232),
    [sym_empty_statement] = STATE(4232),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(4232),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4232),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4232),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4232),
    [sym_break_statement] = STATE(4232),
    [sym_labeled_statement] = STATE(4232),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4232),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4960] = {
    [sym_type_alias_declaration] = STATE(4233),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4233),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4233),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4233),
    [sym_return_statement] = STATE(4233),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4233),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4233),
    [sym_switch_statement] = STATE(4233),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4233),
    [sym_throw_statement] = STATE(4233),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4233),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4233),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(4233),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4233),
    [sym_abstract_class] = STATE(4233),
    [sym_interface_declaration] = STATE(4233),
    [sym_statement_block] = STATE(4233),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4233),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4233),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4233),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4233),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4233),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4233),
    [sym_empty_statement] = STATE(4233),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(4233),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4233),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4233),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4233),
    [sym_break_statement] = STATE(4233),
    [sym_labeled_statement] = STATE(4233),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4233),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4961] = {
    [sym_type_alias_declaration] = STATE(4262),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4262),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4262),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4262),
    [sym_return_statement] = STATE(4262),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4262),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4262),
    [sym_switch_statement] = STATE(4262),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4262),
    [sym_throw_statement] = STATE(4262),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4262),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4262),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(4262),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4262),
    [sym_abstract_class] = STATE(4262),
    [sym_interface_declaration] = STATE(4262),
    [sym_statement_block] = STATE(4262),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4262),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4262),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4262),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4262),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4262),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4262),
    [sym_empty_statement] = STATE(4262),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(4262),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4262),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4262),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4262),
    [sym_break_statement] = STATE(4262),
    [sym_labeled_statement] = STATE(4262),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4262),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4962] = {
    [sym_type_alias_declaration] = STATE(4263),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4263),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4263),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4263),
    [sym_return_statement] = STATE(4263),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4263),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4263),
    [sym_switch_statement] = STATE(4263),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4263),
    [sym_throw_statement] = STATE(4263),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4263),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4263),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(4263),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4263),
    [sym_abstract_class] = STATE(4263),
    [sym_interface_declaration] = STATE(4263),
    [sym_statement_block] = STATE(4263),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4263),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4263),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4263),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4263),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4263),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4263),
    [sym_empty_statement] = STATE(4263),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(4263),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4263),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4263),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4263),
    [sym_break_statement] = STATE(4263),
    [sym_labeled_statement] = STATE(4263),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4263),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4963] = {
    [sym_type_alias_declaration] = STATE(4264),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4264),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4264),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4264),
    [sym_return_statement] = STATE(4264),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4264),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4264),
    [sym_switch_statement] = STATE(4264),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4264),
    [sym_throw_statement] = STATE(4264),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4264),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4264),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(4264),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4264),
    [sym_abstract_class] = STATE(4264),
    [sym_interface_declaration] = STATE(4264),
    [sym_statement_block] = STATE(4264),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4264),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4264),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4264),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4264),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4264),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4264),
    [sym_empty_statement] = STATE(4264),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(4264),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4264),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4264),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4264),
    [sym_break_statement] = STATE(4264),
    [sym_labeled_statement] = STATE(4264),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4264),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [4964] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5067),
    [sym_constructor_type] = STATE(5067),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5067),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5067),
    [sym_intersection_type] = STATE(5067),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4965] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5070),
    [sym_constructor_type] = STATE(5070),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5070),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5070),
    [sym_intersection_type] = STATE(5070),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4966] = {
    [anon_sym_EQ_GT] = ACTIONS(9744),
    [sym_comment] = ACTIONS(3),
  },
  [4967] = {
    [sym_formal_parameters] = STATE(5072),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4968] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4812),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4814),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9369),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9371),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4969] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4812),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4814),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9369),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9371),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4970] = {
    [anon_sym_EQ_GT] = ACTIONS(9746),
    [sym_comment] = ACTIONS(3),
  },
  [4971] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5074),
    [sym_constructor_type] = STATE(5074),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5074),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5074),
    [sym_intersection_type] = STATE(5074),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4972] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5075),
    [sym_constructor_type] = STATE(5075),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5075),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5075),
    [sym_intersection_type] = STATE(5075),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4812),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4814),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9369),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9371),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4973] = {
    [anon_sym_EQ_GT] = ACTIONS(9748),
    [sym_comment] = ACTIONS(3),
  },
  [4974] = {
    [sym_formal_parameters] = STATE(5077),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [4975] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4976] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4977] = {
    [anon_sym_EQ_GT] = ACTIONS(9750),
    [sym_comment] = ACTIONS(3),
  },
  [4978] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5079),
    [sym_constructor_type] = STATE(5079),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(5079),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5079),
    [sym_intersection_type] = STATE(5079),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4979] = {
    [anon_sym_AMP] = ACTIONS(8967),
    [anon_sym_PIPE] = ACTIONS(8969),
    [anon_sym_while] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [4980] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5080),
    [sym_constructor_type] = STATE(5080),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(5080),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5080),
    [sym_intersection_type] = STATE(5080),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4139),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4141),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8272),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8274),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4981] = {
    [anon_sym_AMP] = ACTIONS(8967),
    [anon_sym_PIPE] = ACTIONS(8969),
    [anon_sym_while] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [4982] = {
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_debugger] = ACTIONS(8300),
    [anon_sym_symbol] = ACTIONS(8300),
    [anon_sym_AT] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9042),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_void] = ACTIONS(8300),
    [anon_sym_break] = ACTIONS(8300),
    [anon_sym_const] = ACTIONS(8300),
    [sym_super] = ACTIONS(8300),
    [anon_sym_return] = ACTIONS(8300),
    [anon_sym_private] = ACTIONS(8300),
    [anon_sym_get] = ACTIONS(8300),
    [anon_sym_interface] = ACTIONS(8300),
    [anon_sym_enum] = ACTIONS(8300),
    [anon_sym_delete] = ACTIONS(8300),
    [anon_sym_continue] = ACTIONS(8300),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_if] = ACTIONS(8300),
    [anon_sym_this] = ACTIONS(8300),
    [anon_sym_yield] = ACTIONS(8300),
    [sym_true] = ACTIONS(8300),
    [anon_sym_throw] = ACTIONS(8300),
    [anon_sym_protected] = ACTIONS(8300),
    [anon_sym_abstract] = ACTIONS(8300),
    [anon_sym_set] = ACTIONS(8300),
    [anon_sym_type] = ACTIONS(8300),
    [anon_sym_import] = ACTIONS(8300),
    [anon_sym_namespace] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_await] = ACTIONS(8300),
    [anon_sym_DQUOTE] = ACTIONS(6909),
    [anon_sym_else] = ACTIONS(8300),
    [anon_sym_BANG] = ACTIONS(6909),
    [anon_sym_for] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [sym_false] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_module] = ACTIONS(8300),
    [anon_sym_number] = ACTIONS(8300),
    [anon_sym_class] = ACTIONS(8300),
    [anon_sym_declare] = ACTIONS(8300),
    [anon_sym_typeof] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_switch] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [sym_null] = ACTIONS(8300),
    [anon_sym_any] = ACTIONS(8300),
    [anon_sym_boolean] = ACTIONS(8300),
    [anon_sym_async] = ACTIONS(8300),
    [anon_sym_public] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(9044),
    [anon_sym_var] = ACTIONS(8300),
    [anon_sym_while] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(6909),
    [anon_sym_try] = ACTIONS(8300),
    [anon_sym_LT] = ACTIONS(6909),
    [sym_number] = ACTIONS(6909),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8300),
    [anon_sym_function] = ACTIONS(8300),
    [sym_undefined] = ACTIONS(8300),
    [anon_sym_new] = ACTIONS(8300),
    [ts_builtin_sym_end] = ACTIONS(6909),
    [anon_sym_let] = ACTIONS(8300),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_export] = ACTIONS(8300),
    [anon_sym_do] = ACTIONS(8300),
    [anon_sym_TILDE] = ACTIONS(6909),
    [anon_sym_with] = ACTIONS(8300),
  },
  [4983] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5081),
    [sym_constructor_type] = STATE(5081),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4221),
    [sym_function_type] = STATE(5081),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5081),
    [sym_intersection_type] = STATE(5081),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4220),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4222),
    [sym_identifier] = ACTIONS(8411),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(8415),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(8417),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(8419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [4984] = {
    [sym_identifier] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_debugger] = ACTIONS(8302),
    [anon_sym_symbol] = ACTIONS(8302),
    [anon_sym_AT] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9042),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_void] = ACTIONS(8302),
    [anon_sym_break] = ACTIONS(8302),
    [anon_sym_const] = ACTIONS(8302),
    [sym_super] = ACTIONS(8302),
    [anon_sym_return] = ACTIONS(8302),
    [anon_sym_private] = ACTIONS(8302),
    [anon_sym_get] = ACTIONS(8302),
    [anon_sym_interface] = ACTIONS(8302),
    [anon_sym_enum] = ACTIONS(8302),
    [anon_sym_delete] = ACTIONS(8302),
    [anon_sym_continue] = ACTIONS(8302),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_if] = ACTIONS(8302),
    [anon_sym_this] = ACTIONS(8302),
    [anon_sym_yield] = ACTIONS(8302),
    [sym_true] = ACTIONS(8302),
    [anon_sym_throw] = ACTIONS(8302),
    [anon_sym_protected] = ACTIONS(8302),
    [anon_sym_abstract] = ACTIONS(8302),
    [anon_sym_set] = ACTIONS(8302),
    [anon_sym_type] = ACTIONS(8302),
    [anon_sym_import] = ACTIONS(8302),
    [anon_sym_namespace] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_await] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(6986),
    [anon_sym_else] = ACTIONS(8302),
    [anon_sym_BANG] = ACTIONS(6986),
    [anon_sym_for] = ACTIONS(8302),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [sym_false] = ACTIONS(8302),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_module] = ACTIONS(8302),
    [anon_sym_number] = ACTIONS(8302),
    [anon_sym_class] = ACTIONS(8302),
    [anon_sym_declare] = ACTIONS(8302),
    [anon_sym_typeof] = ACTIONS(8302),
    [anon_sym_LBRACE] = ACTIONS(6986),
    [anon_sym_switch] = ACTIONS(8302),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [sym_null] = ACTIONS(8302),
    [anon_sym_any] = ACTIONS(8302),
    [anon_sym_boolean] = ACTIONS(8302),
    [anon_sym_async] = ACTIONS(8302),
    [anon_sym_public] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(9044),
    [anon_sym_var] = ACTIONS(8302),
    [anon_sym_while] = ACTIONS(8302),
    [anon_sym_SQUOTE] = ACTIONS(6986),
    [anon_sym_try] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(6986),
    [sym_number] = ACTIONS(6986),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8302),
    [anon_sym_function] = ACTIONS(8302),
    [sym_undefined] = ACTIONS(8302),
    [anon_sym_new] = ACTIONS(8302),
    [ts_builtin_sym_end] = ACTIONS(6986),
    [anon_sym_let] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_export] = ACTIONS(8302),
    [anon_sym_do] = ACTIONS(8302),
    [anon_sym_TILDE] = ACTIONS(6986),
    [anon_sym_with] = ACTIONS(8302),
  },
  [4985] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9416),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(9418),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4986] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9422),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(9424),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [4987] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5082),
    [sym_constructor_type] = STATE(5082),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(5082),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5082),
    [sym_intersection_type] = STATE(5082),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4988] = {
    [anon_sym_EQ_GT] = ACTIONS(9752),
    [sym_comment] = ACTIONS(3),
  },
  [4989] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5084),
    [sym_constructor_type] = STATE(5084),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(5084),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5084),
    [sym_intersection_type] = STATE(5084),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4990] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9436),
    [sym_comment] = ACTIONS(3),
  },
  [4991] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(8553),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8555),
    [sym_comment] = ACTIONS(3),
  },
  [4992] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(9132),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9134),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6909),
  },
  [4993] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5085),
    [sym_constructor_type] = STATE(5085),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3129),
    [sym_function_type] = STATE(5085),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5085),
    [sym_intersection_type] = STATE(5085),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4308),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4309),
    [sym_identifier] = ACTIONS(6426),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(6428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(8571),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(8573),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [4994] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(9132),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9134),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6986),
  },
  [4995] = {
    [sym__automatic_semicolon] = ACTIONS(9647),
    [anon_sym_LBRACK] = ACTIONS(9647),
    [sym_identifier] = ACTIONS(9754),
    [anon_sym_SEMI] = ACTIONS(9647),
    [anon_sym_module] = ACTIONS(9754),
    [anon_sym_symbol] = ACTIONS(9754),
    [anon_sym_number] = ACTIONS(9754),
    [anon_sym_AT] = ACTIONS(9647),
    [anon_sym_declare] = ACTIONS(9754),
    [anon_sym_STAR] = ACTIONS(9647),
    [anon_sym_void] = ACTIONS(9754),
    [anon_sym_any] = ACTIONS(9754),
    [anon_sym_private] = ACTIONS(9754),
    [anon_sym_boolean] = ACTIONS(9754),
    [anon_sym_async] = ACTIONS(9754),
    [anon_sym_public] = ACTIONS(9754),
    [anon_sym_get] = ACTIONS(9754),
    [anon_sym_RBRACE] = ACTIONS(9647),
    [anon_sym_static] = ACTIONS(9754),
    [anon_sym_SQUOTE] = ACTIONS(9647),
    [sym_number] = ACTIONS(9647),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(9754),
    [anon_sym_string] = ACTIONS(9754),
    [anon_sym_abstract] = ACTIONS(9754),
    [anon_sym_set] = ACTIONS(9754),
    [anon_sym_type] = ACTIONS(9754),
    [anon_sym_import] = ACTIONS(9754),
    [anon_sym_export] = ACTIONS(9754),
    [anon_sym_namespace] = ACTIONS(9754),
    [sym_readonly] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9647),
  },
  [4996] = {
    [sym_type_alias_declaration] = STATE(4592),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4592),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4592),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4592),
    [sym_return_statement] = STATE(4592),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4592),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4592),
    [sym_switch_statement] = STATE(4592),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4592),
    [sym_throw_statement] = STATE(4592),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4592),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4592),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(4592),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4592),
    [sym_abstract_class] = STATE(4592),
    [sym_interface_declaration] = STATE(4592),
    [sym_statement_block] = STATE(4592),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4592),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4592),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4592),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4592),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4592),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4592),
    [sym_empty_statement] = STATE(4592),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(4592),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4592),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4592),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4592),
    [sym_break_statement] = STATE(4592),
    [sym_labeled_statement] = STATE(4592),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4592),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4997] = {
    [sym_type_alias_declaration] = STATE(4593),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4593),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4593),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4593),
    [sym_return_statement] = STATE(4593),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4593),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4593),
    [sym_switch_statement] = STATE(4593),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4593),
    [sym_throw_statement] = STATE(4593),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4593),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4593),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(4593),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4593),
    [sym_abstract_class] = STATE(4593),
    [sym_interface_declaration] = STATE(4593),
    [sym_statement_block] = STATE(4593),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4593),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4593),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4593),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4593),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4593),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4593),
    [sym_empty_statement] = STATE(4593),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(4593),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4593),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4593),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4593),
    [sym_break_statement] = STATE(4593),
    [sym_labeled_statement] = STATE(4593),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4593),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4998] = {
    [sym_type_alias_declaration] = STATE(4594),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4594),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4594),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4594),
    [sym_return_statement] = STATE(4594),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4594),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4594),
    [sym_switch_statement] = STATE(4594),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4594),
    [sym_throw_statement] = STATE(4594),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4594),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4594),
    [sym_decorator] = STATE(1428),
    [sym_continue_statement] = STATE(4594),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4594),
    [sym_abstract_class] = STATE(4594),
    [sym_interface_declaration] = STATE(4594),
    [sym_statement_block] = STATE(4594),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4594),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4594),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4594),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4594),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4594),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4594),
    [sym_empty_statement] = STATE(4594),
    [aux_sym_export_statement_repeat1] = STATE(1428),
    [sym_import_alias] = STATE(4594),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4594),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4594),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4594),
    [sym_break_statement] = STATE(4594),
    [sym_labeled_statement] = STATE(4594),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4594),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(2944),
  },
  [4999] = {
    [sym_identifier] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_debugger] = ACTIONS(7182),
    [anon_sym_symbol] = ACTIONS(7182),
    [anon_sym_AT] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_void] = ACTIONS(7182),
    [anon_sym_break] = ACTIONS(7182),
    [anon_sym_const] = ACTIONS(7182),
    [sym_super] = ACTIONS(7182),
    [anon_sym_return] = ACTIONS(7182),
    [anon_sym_private] = ACTIONS(7182),
    [anon_sym_get] = ACTIONS(7182),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_interface] = ACTIONS(7182),
    [anon_sym_enum] = ACTIONS(7182),
    [anon_sym_delete] = ACTIONS(7182),
    [anon_sym_continue] = ACTIONS(7182),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_if] = ACTIONS(7182),
    [anon_sym_this] = ACTIONS(7182),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_true] = ACTIONS(7182),
    [anon_sym_throw] = ACTIONS(7182),
    [anon_sym_protected] = ACTIONS(7182),
    [anon_sym_abstract] = ACTIONS(7182),
    [anon_sym_set] = ACTIONS(7182),
    [anon_sym_type] = ACTIONS(7182),
    [anon_sym_import] = ACTIONS(7182),
    [anon_sym_namespace] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_await] = ACTIONS(7182),
    [anon_sym_DQUOTE] = ACTIONS(5196),
    [anon_sym_else] = ACTIONS(7182),
    [anon_sym_BANG] = ACTIONS(5196),
    [anon_sym_for] = ACTIONS(7182),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [sym_false] = ACTIONS(7182),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_module] = ACTIONS(7182),
    [anon_sym_number] = ACTIONS(7182),
    [anon_sym_class] = ACTIONS(7182),
    [anon_sym_declare] = ACTIONS(7182),
    [anon_sym_typeof] = ACTIONS(7182),
    [anon_sym_LBRACE] = ACTIONS(5196),
    [anon_sym_switch] = ACTIONS(7182),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [sym_null] = ACTIONS(7182),
    [anon_sym_any] = ACTIONS(7182),
    [anon_sym_boolean] = ACTIONS(7182),
    [anon_sym_async] = ACTIONS(7182),
    [anon_sym_public] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(9484),
    [anon_sym_var] = ACTIONS(7182),
    [anon_sym_while] = ACTIONS(7182),
    [anon_sym_SQUOTE] = ACTIONS(5196),
    [anon_sym_try] = ACTIONS(7182),
    [anon_sym_LT] = ACTIONS(5196),
    [sym_number] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7182),
    [anon_sym_function] = ACTIONS(7182),
    [sym_undefined] = ACTIONS(7182),
    [anon_sym_new] = ACTIONS(7182),
    [anon_sym_let] = ACTIONS(7182),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_export] = ACTIONS(7182),
    [anon_sym_do] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(5196),
    [anon_sym_with] = ACTIONS(7182),
  },
  [5000] = {
    [sym_identifier] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_debugger] = ACTIONS(7197),
    [anon_sym_symbol] = ACTIONS(7197),
    [anon_sym_AT] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_void] = ACTIONS(7197),
    [anon_sym_break] = ACTIONS(7197),
    [anon_sym_const] = ACTIONS(7197),
    [sym_super] = ACTIONS(7197),
    [anon_sym_return] = ACTIONS(7197),
    [anon_sym_private] = ACTIONS(7197),
    [anon_sym_get] = ACTIONS(7197),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [anon_sym_interface] = ACTIONS(7197),
    [anon_sym_enum] = ACTIONS(7197),
    [anon_sym_delete] = ACTIONS(7197),
    [anon_sym_continue] = ACTIONS(7197),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_if] = ACTIONS(7197),
    [anon_sym_this] = ACTIONS(7197),
    [anon_sym_yield] = ACTIONS(7197),
    [sym_true] = ACTIONS(7197),
    [anon_sym_throw] = ACTIONS(7197),
    [anon_sym_protected] = ACTIONS(7197),
    [anon_sym_abstract] = ACTIONS(7197),
    [anon_sym_set] = ACTIONS(7197),
    [anon_sym_type] = ACTIONS(7197),
    [anon_sym_import] = ACTIONS(7197),
    [anon_sym_namespace] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_await] = ACTIONS(7197),
    [anon_sym_DQUOTE] = ACTIONS(5204),
    [anon_sym_else] = ACTIONS(7197),
    [anon_sym_BANG] = ACTIONS(5204),
    [anon_sym_for] = ACTIONS(7197),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [sym_false] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_module] = ACTIONS(7197),
    [anon_sym_number] = ACTIONS(7197),
    [anon_sym_class] = ACTIONS(7197),
    [anon_sym_declare] = ACTIONS(7197),
    [anon_sym_typeof] = ACTIONS(7197),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_switch] = ACTIONS(7197),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [sym_null] = ACTIONS(7197),
    [anon_sym_any] = ACTIONS(7197),
    [anon_sym_boolean] = ACTIONS(7197),
    [anon_sym_async] = ACTIONS(7197),
    [anon_sym_public] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(9484),
    [anon_sym_var] = ACTIONS(7197),
    [anon_sym_while] = ACTIONS(7197),
    [anon_sym_SQUOTE] = ACTIONS(5204),
    [anon_sym_try] = ACTIONS(7197),
    [anon_sym_LT] = ACTIONS(5204),
    [sym_number] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7197),
    [anon_sym_function] = ACTIONS(7197),
    [sym_undefined] = ACTIONS(7197),
    [anon_sym_new] = ACTIONS(7197),
    [anon_sym_let] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_export] = ACTIONS(7197),
    [anon_sym_do] = ACTIONS(7197),
    [anon_sym_TILDE] = ACTIONS(5204),
    [anon_sym_with] = ACTIONS(7197),
  },
  [5001] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5086),
    [sym_constructor_type] = STATE(5086),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(5086),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5086),
    [sym_intersection_type] = STATE(5086),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5002] = {
    [anon_sym_EQ_GT] = ACTIONS(9756),
    [sym_comment] = ACTIONS(3),
  },
  [5003] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5088),
    [sym_constructor_type] = STATE(5088),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(5088),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5088),
    [sym_intersection_type] = STATE(5088),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5004] = {
    [sym_identifier] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_debugger] = ACTIONS(7207),
    [anon_sym_symbol] = ACTIONS(7207),
    [anon_sym_AT] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_void] = ACTIONS(7207),
    [anon_sym_break] = ACTIONS(7207),
    [anon_sym_const] = ACTIONS(7207),
    [sym_super] = ACTIONS(7207),
    [anon_sym_return] = ACTIONS(7207),
    [anon_sym_private] = ACTIONS(7207),
    [anon_sym_get] = ACTIONS(7207),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_interface] = ACTIONS(7207),
    [anon_sym_enum] = ACTIONS(7207),
    [anon_sym_delete] = ACTIONS(7207),
    [anon_sym_continue] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_if] = ACTIONS(7207),
    [anon_sym_this] = ACTIONS(7207),
    [anon_sym_yield] = ACTIONS(7207),
    [sym_true] = ACTIONS(7207),
    [anon_sym_throw] = ACTIONS(7207),
    [anon_sym_protected] = ACTIONS(7207),
    [anon_sym_abstract] = ACTIONS(7207),
    [anon_sym_set] = ACTIONS(7207),
    [anon_sym_type] = ACTIONS(7207),
    [anon_sym_import] = ACTIONS(7207),
    [anon_sym_namespace] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_await] = ACTIONS(7207),
    [anon_sym_DQUOTE] = ACTIONS(5406),
    [anon_sym_else] = ACTIONS(7207),
    [anon_sym_BANG] = ACTIONS(5406),
    [anon_sym_for] = ACTIONS(7207),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [sym_false] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_module] = ACTIONS(7207),
    [anon_sym_number] = ACTIONS(7207),
    [anon_sym_class] = ACTIONS(7207),
    [anon_sym_declare] = ACTIONS(7207),
    [anon_sym_typeof] = ACTIONS(7207),
    [anon_sym_LBRACE] = ACTIONS(5406),
    [anon_sym_switch] = ACTIONS(7207),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [sym_null] = ACTIONS(7207),
    [anon_sym_any] = ACTIONS(7207),
    [anon_sym_boolean] = ACTIONS(7207),
    [anon_sym_async] = ACTIONS(7207),
    [anon_sym_public] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(9484),
    [anon_sym_var] = ACTIONS(7207),
    [anon_sym_while] = ACTIONS(7207),
    [anon_sym_SQUOTE] = ACTIONS(5406),
    [anon_sym_try] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(5406),
    [sym_number] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7207),
    [anon_sym_function] = ACTIONS(7207),
    [sym_undefined] = ACTIONS(7207),
    [anon_sym_new] = ACTIONS(7207),
    [anon_sym_let] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_export] = ACTIONS(7207),
    [anon_sym_do] = ACTIONS(7207),
    [anon_sym_TILDE] = ACTIONS(5406),
    [anon_sym_with] = ACTIONS(7207),
  },
  [5005] = {
    [sym_identifier] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_debugger] = ACTIONS(7211),
    [anon_sym_symbol] = ACTIONS(7211),
    [anon_sym_AT] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_void] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [sym_super] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_private] = ACTIONS(7211),
    [anon_sym_get] = ACTIONS(7211),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_interface] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_delete] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_this] = ACTIONS(7211),
    [anon_sym_yield] = ACTIONS(7211),
    [sym_true] = ACTIONS(7211),
    [anon_sym_throw] = ACTIONS(7211),
    [anon_sym_protected] = ACTIONS(7211),
    [anon_sym_abstract] = ACTIONS(7211),
    [anon_sym_set] = ACTIONS(7211),
    [anon_sym_type] = ACTIONS(7211),
    [anon_sym_import] = ACTIONS(7211),
    [anon_sym_namespace] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_await] = ACTIONS(7211),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [anon_sym_else] = ACTIONS(7211),
    [anon_sym_BANG] = ACTIONS(5425),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [sym_false] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_module] = ACTIONS(7211),
    [anon_sym_number] = ACTIONS(7211),
    [anon_sym_class] = ACTIONS(7211),
    [anon_sym_declare] = ACTIONS(7211),
    [anon_sym_typeof] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(5425),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [sym_null] = ACTIONS(7211),
    [anon_sym_any] = ACTIONS(7211),
    [anon_sym_boolean] = ACTIONS(7211),
    [anon_sym_async] = ACTIONS(7211),
    [anon_sym_public] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(9484),
    [anon_sym_var] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_try] = ACTIONS(7211),
    [anon_sym_LT] = ACTIONS(5425),
    [sym_number] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7211),
    [anon_sym_function] = ACTIONS(7211),
    [sym_undefined] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [anon_sym_let] = ACTIONS(7211),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_export] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_TILDE] = ACTIONS(5425),
    [anon_sym_with] = ACTIONS(7211),
  },
  [5006] = {
    [sym_identifier] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_debugger] = ACTIONS(8987),
    [anon_sym_symbol] = ACTIONS(8987),
    [anon_sym_AT] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8673),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_void] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8987),
    [anon_sym_const] = ACTIONS(8987),
    [sym_super] = ACTIONS(8987),
    [anon_sym_return] = ACTIONS(8987),
    [anon_sym_private] = ACTIONS(8987),
    [anon_sym_get] = ACTIONS(8987),
    [anon_sym_RBRACE] = ACTIONS(8086),
    [anon_sym_interface] = ACTIONS(8987),
    [anon_sym_enum] = ACTIONS(8987),
    [anon_sym_delete] = ACTIONS(8987),
    [anon_sym_continue] = ACTIONS(8987),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_if] = ACTIONS(8987),
    [anon_sym_this] = ACTIONS(8987),
    [anon_sym_yield] = ACTIONS(8987),
    [sym_true] = ACTIONS(8987),
    [anon_sym_throw] = ACTIONS(8987),
    [anon_sym_protected] = ACTIONS(8987),
    [anon_sym_abstract] = ACTIONS(8987),
    [anon_sym_set] = ACTIONS(8987),
    [anon_sym_type] = ACTIONS(8987),
    [anon_sym_import] = ACTIONS(8987),
    [anon_sym_namespace] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_await] = ACTIONS(8987),
    [anon_sym_DQUOTE] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8086),
    [anon_sym_for] = ACTIONS(8987),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [sym_false] = ACTIONS(8987),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_module] = ACTIONS(8987),
    [anon_sym_number] = ACTIONS(8987),
    [anon_sym_class] = ACTIONS(8987),
    [anon_sym_declare] = ACTIONS(8987),
    [anon_sym_typeof] = ACTIONS(8987),
    [anon_sym_LBRACE] = ACTIONS(8086),
    [anon_sym_switch] = ACTIONS(8987),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [sym_null] = ACTIONS(8987),
    [anon_sym_any] = ACTIONS(8987),
    [anon_sym_boolean] = ACTIONS(8987),
    [anon_sym_async] = ACTIONS(8987),
    [anon_sym_public] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_var] = ACTIONS(8987),
    [anon_sym_while] = ACTIONS(8987),
    [anon_sym_SQUOTE] = ACTIONS(8086),
    [anon_sym_try] = ACTIONS(8987),
    [anon_sym_LT] = ACTIONS(8086),
    [sym_number] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8987),
    [anon_sym_function] = ACTIONS(8987),
    [sym_undefined] = ACTIONS(8987),
    [anon_sym_new] = ACTIONS(8987),
    [anon_sym_let] = ACTIONS(8987),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_export] = ACTIONS(8987),
    [anon_sym_do] = ACTIONS(8987),
    [anon_sym_TILDE] = ACTIONS(8086),
    [anon_sym_with] = ACTIONS(8987),
  },
  [5007] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9492),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_LT_LT] = ACTIONS(8086),
    [anon_sym_STAR] = ACTIONS(8987),
    [anon_sym_GT_GT_GT] = ACTIONS(8086),
    [anon_sym_AMP_AMP] = ACTIONS(8086),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_BANG_EQ] = ACTIONS(8987),
    [anon_sym_LT_EQ] = ACTIONS(8086),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [anon_sym_GT_EQ] = ACTIONS(8086),
    [anon_sym_GT] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(9494),
    [anon_sym_PERCENT] = ACTIONS(8086),
    [anon_sym_QMARK] = ACTIONS(8086),
    [anon_sym_as] = ACTIONS(8086),
    [anon_sym_PIPE_PIPE] = ACTIONS(8086),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_EQ_EQ] = ACTIONS(8987),
    [anon_sym_instanceof] = ACTIONS(8086),
    [anon_sym_LT] = ACTIONS(8987),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8086),
    [anon_sym_DOT] = ACTIONS(8086),
    [anon_sym_CARET] = ACTIONS(8086),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_GT_GT] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8086),
    [anon_sym_in] = ACTIONS(8987),
  },
  [5008] = {
    [sym_type_alias_declaration] = STATE(2047),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(2047),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(2047),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(2047),
    [sym_return_statement] = STATE(2047),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(2047),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(2047),
    [sym_switch_statement] = STATE(2047),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(2047),
    [sym_throw_statement] = STATE(2047),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2047),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(2047),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(2047),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2047),
    [sym_abstract_class] = STATE(2047),
    [sym_interface_declaration] = STATE(2047),
    [sym_statement_block] = STATE(2047),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(2047),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(2047),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(2047),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(2047),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(2047),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(2047),
    [sym_empty_statement] = STATE(2047),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(2047),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(2047),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(2047),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(2047),
    [sym_break_statement] = STATE(2047),
    [sym_labeled_statement] = STATE(2047),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(2047),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5009] = {
    [sym_array] = STATE(5090),
    [sym_object] = STATE(5091),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(9758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [5010] = {
    [anon_sym_of] = ACTIONS(9760),
    [sym_comment] = ACTIONS(3),
  },
  [5011] = {
    [anon_sym_of] = ACTIONS(9762),
    [sym_comment] = ACTIONS(3),
  },
  [5012] = {
    [anon_sym_of] = ACTIONS(9764),
    [sym_comment] = ACTIONS(3),
  },
  [5013] = {
    [sym_new_expression] = STATE(5095),
    [sym_augmented_assignment_expression] = STATE(5095),
    [sym_unary_expression] = STATE(5095),
    [sym_update_expression] = STATE(5095),
    [sym_regex] = STATE(5095),
    [sym_meta_property] = STATE(5095),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(5095),
    [sym_yield_expression] = STATE(5095),
    [sym_as_expression] = STATE(5095),
    [sym_non_null_expression] = STATE(5095),
    [sym_internal_module] = STATE(5095),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(5095),
    [sym_await_expression] = STATE(5095),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(5096),
    [sym_string] = STATE(5095),
    [sym_this] = STATE(5095),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(5095),
    [sym_generator_function] = STATE(5095),
    [sym_call_expression] = STATE(5095),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(5095),
    [sym_ternary_expression] = STATE(5095),
    [sym_binary_expression] = STATE(5095),
    [sym_template_string] = STATE(5095),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5095),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(5095),
    [sym_class] = STATE(5095),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(9766),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9766),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(9768),
    [sym_true] = ACTIONS(9766),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9766),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [5014] = {
    [sym_new_expression] = STATE(5097),
    [sym_augmented_assignment_expression] = STATE(5097),
    [sym_unary_expression] = STATE(5097),
    [sym_update_expression] = STATE(5097),
    [sym_regex] = STATE(5097),
    [sym_meta_property] = STATE(5097),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5097),
    [sym_yield_expression] = STATE(5097),
    [sym_as_expression] = STATE(5097),
    [sym_non_null_expression] = STATE(5097),
    [sym_internal_module] = STATE(5097),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5097),
    [sym_await_expression] = STATE(5097),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5097),
    [sym_this] = STATE(5097),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5097),
    [sym_generator_function] = STATE(5097),
    [sym_call_expression] = STATE(5097),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5097),
    [sym_ternary_expression] = STATE(5097),
    [sym_binary_expression] = STATE(5097),
    [sym_template_string] = STATE(5097),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5097),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5097),
    [sym_class] = STATE(5097),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9770),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9770),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9772),
    [sym_true] = ACTIONS(9770),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9770),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5015] = {
    [sym__initializer] = STATE(405),
    [sym_type_annotation] = STATE(406),
    [sym__automatic_semicolon] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_of] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9774),
  },
  [5016] = {
    [sym__initializer] = STATE(425),
    [sym_type_annotation] = STATE(426),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(9762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9776),
  },
  [5017] = {
    [sym__initializer] = STATE(427),
    [sym_type_annotation] = STATE(428),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_of] = ACTIONS(9764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9778),
  },
  [5018] = {
    [sym_new_expression] = STATE(5102),
    [sym_augmented_assignment_expression] = STATE(5102),
    [sym_unary_expression] = STATE(5102),
    [sym_update_expression] = STATE(5102),
    [sym_regex] = STATE(5102),
    [sym_meta_property] = STATE(5102),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(5102),
    [sym_yield_expression] = STATE(5102),
    [sym_as_expression] = STATE(5102),
    [sym_non_null_expression] = STATE(5102),
    [sym_internal_module] = STATE(5102),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5102),
    [sym_await_expression] = STATE(5102),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(5103),
    [sym_string] = STATE(5102),
    [sym_this] = STATE(5102),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(5102),
    [sym_generator_function] = STATE(5102),
    [sym_call_expression] = STATE(5102),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(5102),
    [sym_ternary_expression] = STATE(5102),
    [sym_binary_expression] = STATE(5102),
    [sym_template_string] = STATE(5102),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5102),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(5102),
    [sym_class] = STATE(5102),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9780),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(9782),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9784),
    [sym_true] = ACTIONS(9780),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9780),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [5019] = {
    [sym_new_expression] = STATE(5104),
    [sym_augmented_assignment_expression] = STATE(5104),
    [sym_unary_expression] = STATE(5104),
    [sym_update_expression] = STATE(5104),
    [sym_regex] = STATE(5104),
    [sym_meta_property] = STATE(5104),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5104),
    [sym_yield_expression] = STATE(5104),
    [sym_as_expression] = STATE(5104),
    [sym_non_null_expression] = STATE(5104),
    [sym_internal_module] = STATE(5104),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5104),
    [sym_await_expression] = STATE(5104),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5104),
    [sym_this] = STATE(5104),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5104),
    [sym_generator_function] = STATE(5104),
    [sym_call_expression] = STATE(5104),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5104),
    [sym_ternary_expression] = STATE(5104),
    [sym_binary_expression] = STATE(5104),
    [sym_template_string] = STATE(5104),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5104),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5104),
    [sym_class] = STATE(5104),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9786),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9786),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9788),
    [sym_true] = ACTIONS(9786),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9786),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5020] = {
    [sym_new_expression] = STATE(5105),
    [sym_augmented_assignment_expression] = STATE(5105),
    [sym_unary_expression] = STATE(5105),
    [sym_update_expression] = STATE(5105),
    [sym_regex] = STATE(5105),
    [sym_meta_property] = STATE(5105),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(5105),
    [sym_yield_expression] = STATE(5105),
    [sym_as_expression] = STATE(5105),
    [sym_non_null_expression] = STATE(5105),
    [sym_internal_module] = STATE(5105),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(5105),
    [sym_await_expression] = STATE(5105),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(5106),
    [sym_string] = STATE(5105),
    [sym_this] = STATE(5105),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(5105),
    [sym_generator_function] = STATE(5105),
    [sym_call_expression] = STATE(5105),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(5105),
    [sym_ternary_expression] = STATE(5105),
    [sym_binary_expression] = STATE(5105),
    [sym_template_string] = STATE(5105),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5105),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(5105),
    [sym_class] = STATE(5105),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9790),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(9792),
    [sym_true] = ACTIONS(9790),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9790),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [5021] = {
    [sym_new_expression] = STATE(5107),
    [sym_augmented_assignment_expression] = STATE(5107),
    [sym_unary_expression] = STATE(5107),
    [sym_update_expression] = STATE(5107),
    [sym_regex] = STATE(5107),
    [sym_meta_property] = STATE(5107),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5107),
    [sym_yield_expression] = STATE(5107),
    [sym_as_expression] = STATE(5107),
    [sym_non_null_expression] = STATE(5107),
    [sym_internal_module] = STATE(5107),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5107),
    [sym_await_expression] = STATE(5107),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5107),
    [sym_this] = STATE(5107),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5107),
    [sym_generator_function] = STATE(5107),
    [sym_call_expression] = STATE(5107),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5107),
    [sym_ternary_expression] = STATE(5107),
    [sym_binary_expression] = STATE(5107),
    [sym_template_string] = STATE(5107),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5107),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5107),
    [sym_class] = STATE(5107),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9794),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9794),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9796),
    [sym_true] = ACTIONS(9794),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9794),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5022] = {
    [sym_new_expression] = STATE(5108),
    [sym_augmented_assignment_expression] = STATE(5108),
    [sym_unary_expression] = STATE(5108),
    [sym_update_expression] = STATE(5108),
    [sym_regex] = STATE(5108),
    [sym_meta_property] = STATE(5108),
    [sym_call_signature] = STATE(2089),
    [sym__expression] = STATE(5108),
    [sym_yield_expression] = STATE(5108),
    [sym_as_expression] = STATE(5108),
    [sym_non_null_expression] = STATE(5108),
    [sym_internal_module] = STATE(5108),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(5108),
    [sym_await_expression] = STATE(5108),
    [sym_member_expression] = STATE(2091),
    [sym_sequence_expression] = STATE(5109),
    [sym_string] = STATE(5108),
    [sym_this] = STATE(5108),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2093),
    [sym_anonymous_class] = STATE(5108),
    [sym_generator_function] = STATE(5108),
    [sym_call_expression] = STATE(5108),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(5108),
    [sym_ternary_expression] = STATE(5108),
    [sym_binary_expression] = STATE(5108),
    [sym_template_string] = STATE(5108),
    [sym_type_arguments] = STATE(2094),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5108),
    [sym_array] = STATE(2095),
    [sym_type_assertion] = STATE(5108),
    [sym_class] = STATE(5108),
    [anon_sym_BANG] = ACTIONS(4375),
    [sym_identifier] = ACTIONS(4377),
    [sym_false] = ACTIONS(9798),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4381),
    [anon_sym_symbol] = ACTIONS(4381),
    [anon_sym_number] = ACTIONS(4381),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9798),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4381),
    [anon_sym_private] = ACTIONS(4381),
    [anon_sym_boolean] = ACTIONS(4381),
    [anon_sym_async] = ACTIONS(4389),
    [anon_sym_public] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4381),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4391),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(9800),
    [sym_true] = ACTIONS(9798),
    [anon_sym_yield] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4381),
    [anon_sym_string] = ACTIONS(4381),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9798),
    [anon_sym_set] = ACTIONS(4381),
    [anon_sym_type] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4397),
    [anon_sym_import] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4381),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_await] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4391),
  },
  [5023] = {
    [anon_sym_COLON] = ACTIONS(9802),
    [sym_comment] = ACTIONS(3),
  },
  [5024] = {
    [sym_new_expression] = STATE(5111),
    [sym_augmented_assignment_expression] = STATE(5111),
    [sym_unary_expression] = STATE(5111),
    [sym_update_expression] = STATE(5111),
    [sym_regex] = STATE(5111),
    [sym_meta_property] = STATE(5111),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5111),
    [sym_yield_expression] = STATE(5111),
    [sym_as_expression] = STATE(5111),
    [sym_non_null_expression] = STATE(5111),
    [sym_internal_module] = STATE(5111),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5111),
    [sym_await_expression] = STATE(5111),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5111),
    [sym_this] = STATE(5111),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5111),
    [sym_generator_function] = STATE(5111),
    [sym_call_expression] = STATE(5111),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5111),
    [sym_ternary_expression] = STATE(5111),
    [sym_binary_expression] = STATE(5111),
    [sym_template_string] = STATE(5111),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5111),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5111),
    [sym_class] = STATE(5111),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9804),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9804),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9806),
    [sym_true] = ACTIONS(9804),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9804),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5025] = {
    [sym_new_expression] = STATE(5112),
    [sym_augmented_assignment_expression] = STATE(5112),
    [sym_unary_expression] = STATE(5112),
    [sym_update_expression] = STATE(5112),
    [sym_regex] = STATE(5112),
    [sym_meta_property] = STATE(5112),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5112),
    [sym_yield_expression] = STATE(5112),
    [sym_as_expression] = STATE(5112),
    [sym_non_null_expression] = STATE(5112),
    [sym_internal_module] = STATE(5112),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5112),
    [sym_await_expression] = STATE(5112),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5112),
    [sym_this] = STATE(5112),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5112),
    [sym_generator_function] = STATE(5112),
    [sym_call_expression] = STATE(5112),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5112),
    [sym_ternary_expression] = STATE(5112),
    [sym_binary_expression] = STATE(5112),
    [sym_template_string] = STATE(5112),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5112),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5112),
    [sym_class] = STATE(5112),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9808),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9808),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9810),
    [sym_true] = ACTIONS(9808),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9808),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5026] = {
    [sym_new_expression] = STATE(5113),
    [sym_augmented_assignment_expression] = STATE(5113),
    [sym_unary_expression] = STATE(5113),
    [sym_update_expression] = STATE(5113),
    [sym_regex] = STATE(5113),
    [sym_meta_property] = STATE(5113),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5113),
    [sym_yield_expression] = STATE(5113),
    [sym_as_expression] = STATE(5113),
    [sym_non_null_expression] = STATE(5113),
    [sym_internal_module] = STATE(5113),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5113),
    [sym_await_expression] = STATE(5113),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5113),
    [sym_this] = STATE(5113),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5113),
    [sym_generator_function] = STATE(5113),
    [sym_call_expression] = STATE(5113),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5113),
    [sym_ternary_expression] = STATE(5113),
    [sym_binary_expression] = STATE(5113),
    [sym_template_string] = STATE(5113),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5113),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5113),
    [sym_class] = STATE(5113),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9812),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9812),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9814),
    [sym_true] = ACTIONS(9812),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9812),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5027] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9816),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5028] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9818),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5029] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9820),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5030] = {
    [sym_type_alias_declaration] = STATE(3690),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3690),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3690),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3690),
    [sym_return_statement] = STATE(3690),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3690),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3690),
    [sym_switch_statement] = STATE(3690),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3690),
    [sym_throw_statement] = STATE(3690),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3690),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3690),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3690),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3690),
    [sym_abstract_class] = STATE(3690),
    [sym_interface_declaration] = STATE(3690),
    [sym_statement_block] = STATE(3690),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3690),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3690),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3690),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3690),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3690),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3690),
    [sym_empty_statement] = STATE(3690),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3690),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3690),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3690),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3690),
    [sym_break_statement] = STATE(3690),
    [sym_labeled_statement] = STATE(3690),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3690),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5031] = {
    [sym_type_alias_declaration] = STATE(3719),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3719),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3719),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3719),
    [sym_return_statement] = STATE(3719),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3719),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3719),
    [sym_switch_statement] = STATE(3719),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3719),
    [sym_throw_statement] = STATE(3719),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3719),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3719),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3719),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3719),
    [sym_abstract_class] = STATE(3719),
    [sym_interface_declaration] = STATE(3719),
    [sym_statement_block] = STATE(3719),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3719),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3719),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3719),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3719),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3719),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3719),
    [sym_empty_statement] = STATE(3719),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3719),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3719),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3719),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3719),
    [sym_break_statement] = STATE(3719),
    [sym_labeled_statement] = STATE(3719),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3719),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5032] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9822),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5033] = {
    [anon_sym_RPAREN] = ACTIONS(9822),
    [sym_comment] = ACTIONS(3),
  },
  [5034] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9824),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5035] = {
    [anon_sym_RPAREN] = ACTIONS(9824),
    [sym_comment] = ACTIONS(3),
  },
  [5036] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9826),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5037] = {
    [anon_sym_RPAREN] = ACTIONS(9826),
    [sym_comment] = ACTIONS(3),
  },
  [5038] = {
    [sym_type_alias_declaration] = STATE(3724),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3724),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3724),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3724),
    [sym_return_statement] = STATE(3724),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3724),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3724),
    [sym_switch_statement] = STATE(3724),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3724),
    [sym_throw_statement] = STATE(3724),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3724),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3724),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3724),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3724),
    [sym_abstract_class] = STATE(3724),
    [sym_interface_declaration] = STATE(3724),
    [sym_statement_block] = STATE(3724),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3724),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3724),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3724),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3724),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3724),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3724),
    [sym_empty_statement] = STATE(3724),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3724),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3724),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3724),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3724),
    [sym_break_statement] = STATE(3724),
    [sym_labeled_statement] = STATE(3724),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3724),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5039] = {
    [sym_type_alias_declaration] = STATE(3725),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3725),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3725),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3725),
    [sym_return_statement] = STATE(3725),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3725),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3725),
    [sym_switch_statement] = STATE(3725),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3725),
    [sym_throw_statement] = STATE(3725),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3725),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3725),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3725),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3725),
    [sym_abstract_class] = STATE(3725),
    [sym_interface_declaration] = STATE(3725),
    [sym_statement_block] = STATE(3725),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3725),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3725),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3725),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3725),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3725),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3725),
    [sym_empty_statement] = STATE(3725),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3725),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3725),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3725),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3725),
    [sym_break_statement] = STATE(3725),
    [sym_labeled_statement] = STATE(3725),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3725),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5040] = {
    [sym_type_alias_declaration] = STATE(3726),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3726),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3726),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3726),
    [sym_return_statement] = STATE(3726),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3726),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3726),
    [sym_switch_statement] = STATE(3726),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3726),
    [sym_throw_statement] = STATE(3726),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3726),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3726),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3726),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3726),
    [sym_abstract_class] = STATE(3726),
    [sym_interface_declaration] = STATE(3726),
    [sym_statement_block] = STATE(3726),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3726),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3726),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3726),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3726),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3726),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3726),
    [sym_empty_statement] = STATE(3726),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3726),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3726),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3726),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3726),
    [sym_break_statement] = STATE(3726),
    [sym_labeled_statement] = STATE(3726),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3726),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5041] = {
    [sym_type_alias_declaration] = STATE(3727),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3727),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3727),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3727),
    [sym_return_statement] = STATE(3727),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3727),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3727),
    [sym_switch_statement] = STATE(3727),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3727),
    [sym_throw_statement] = STATE(3727),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3727),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3727),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3727),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3727),
    [sym_abstract_class] = STATE(3727),
    [sym_interface_declaration] = STATE(3727),
    [sym_statement_block] = STATE(3727),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3727),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3727),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3727),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3727),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3727),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3727),
    [sym_empty_statement] = STATE(3727),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3727),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3727),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3727),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3727),
    [sym_break_statement] = STATE(3727),
    [sym_labeled_statement] = STATE(3727),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3727),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5042] = {
    [sym_type_alias_declaration] = STATE(3728),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3728),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3728),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3728),
    [sym_return_statement] = STATE(3728),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3728),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3728),
    [sym_switch_statement] = STATE(3728),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3728),
    [sym_throw_statement] = STATE(3728),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3728),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3728),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(3728),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3728),
    [sym_abstract_class] = STATE(3728),
    [sym_interface_declaration] = STATE(3728),
    [sym_statement_block] = STATE(3728),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3728),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3728),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3728),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3728),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3728),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3728),
    [sym_empty_statement] = STATE(3728),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(3728),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3728),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3728),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3728),
    [sym_break_statement] = STATE(3728),
    [sym_labeled_statement] = STATE(3728),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3728),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5043] = {
    [sym_type_arguments] = STATE(791),
    [sym_identifier] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_debugger] = ACTIONS(3834),
    [anon_sym_symbol] = ACTIONS(3834),
    [anon_sym_AT] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_void] = ACTIONS(3834),
    [anon_sym_break] = ACTIONS(3834),
    [anon_sym_const] = ACTIONS(3834),
    [sym_super] = ACTIONS(3834),
    [anon_sym_return] = ACTIONS(3834),
    [anon_sym_private] = ACTIONS(3834),
    [anon_sym_get] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_default] = ACTIONS(3834),
    [anon_sym_interface] = ACTIONS(3834),
    [anon_sym_enum] = ACTIONS(3834),
    [anon_sym_delete] = ACTIONS(3834),
    [anon_sym_continue] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(3834),
    [anon_sym_this] = ACTIONS(3834),
    [anon_sym_yield] = ACTIONS(3834),
    [sym_true] = ACTIONS(3834),
    [anon_sym_throw] = ACTIONS(3834),
    [anon_sym_protected] = ACTIONS(3834),
    [anon_sym_abstract] = ACTIONS(3834),
    [anon_sym_DOT] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3834),
    [anon_sym_type] = ACTIONS(3834),
    [anon_sym_import] = ACTIONS(3834),
    [anon_sym_namespace] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_await] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_for] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [sym_false] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(3834),
    [anon_sym_module] = ACTIONS(3834),
    [anon_sym_number] = ACTIONS(3834),
    [anon_sym_class] = ACTIONS(3834),
    [anon_sym_declare] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3834),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(9828),
    [anon_sym_switch] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [sym_null] = ACTIONS(3834),
    [anon_sym_any] = ACTIONS(3834),
    [anon_sym_boolean] = ACTIONS(3834),
    [anon_sym_async] = ACTIONS(3834),
    [anon_sym_public] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_var] = ACTIONS(3834),
    [anon_sym_while] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(3834),
    [anon_sym_LT] = ACTIONS(7728),
    [sym_number] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3834),
    [anon_sym_function] = ACTIONS(3834),
    [sym_undefined] = ACTIONS(3834),
    [anon_sym_new] = ACTIONS(3834),
    [anon_sym_let] = ACTIONS(3834),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_export] = ACTIONS(3834),
    [anon_sym_do] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_with] = ACTIONS(3834),
    [anon_sym_in] = ACTIONS(9830),
  },
  [5044] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5045] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5046] = {
    [sym_formal_parameters] = STATE(5122),
    [sym_type_parameters] = STATE(5123),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [5047] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5048] = {
    [sym_identifier] = ACTIONS(7733),
    [anon_sym_BQUOTE] = ACTIONS(7735),
    [anon_sym_debugger] = ACTIONS(7733),
    [anon_sym_symbol] = ACTIONS(7733),
    [anon_sym_AT] = ACTIONS(7735),
    [anon_sym_PIPE] = ACTIONS(9832),
    [anon_sym_DASH] = ACTIONS(7733),
    [anon_sym_void] = ACTIONS(7733),
    [anon_sym_break] = ACTIONS(7733),
    [anon_sym_const] = ACTIONS(7733),
    [sym_super] = ACTIONS(7733),
    [anon_sym_return] = ACTIONS(7733),
    [anon_sym_private] = ACTIONS(7733),
    [anon_sym_get] = ACTIONS(7733),
    [anon_sym_RBRACE] = ACTIONS(7735),
    [anon_sym_default] = ACTIONS(7733),
    [anon_sym_interface] = ACTIONS(7733),
    [anon_sym_enum] = ACTIONS(7733),
    [anon_sym_delete] = ACTIONS(7733),
    [anon_sym_continue] = ACTIONS(7733),
    [anon_sym_DASH_DASH] = ACTIONS(7735),
    [anon_sym_if] = ACTIONS(7733),
    [anon_sym_this] = ACTIONS(7733),
    [anon_sym_yield] = ACTIONS(7733),
    [sym_true] = ACTIONS(7733),
    [anon_sym_throw] = ACTIONS(7733),
    [anon_sym_protected] = ACTIONS(7733),
    [anon_sym_abstract] = ACTIONS(7733),
    [anon_sym_set] = ACTIONS(7733),
    [anon_sym_type] = ACTIONS(7733),
    [anon_sym_import] = ACTIONS(7733),
    [anon_sym_namespace] = ACTIONS(7733),
    [anon_sym_PLUS_PLUS] = ACTIONS(7735),
    [anon_sym_await] = ACTIONS(7733),
    [anon_sym_DQUOTE] = ACTIONS(7735),
    [anon_sym_BANG] = ACTIONS(7735),
    [anon_sym_for] = ACTIONS(7733),
    [anon_sym_LBRACK] = ACTIONS(7735),
    [sym_false] = ACTIONS(7733),
    [anon_sym_SEMI] = ACTIONS(7735),
    [anon_sym_case] = ACTIONS(7733),
    [anon_sym_module] = ACTIONS(7733),
    [anon_sym_number] = ACTIONS(7733),
    [anon_sym_class] = ACTIONS(7733),
    [anon_sym_declare] = ACTIONS(7733),
    [anon_sym_typeof] = ACTIONS(7733),
    [anon_sym_LBRACE] = ACTIONS(7735),
    [anon_sym_switch] = ACTIONS(7733),
    [anon_sym_LPAREN] = ACTIONS(7735),
    [sym_null] = ACTIONS(7733),
    [anon_sym_any] = ACTIONS(7733),
    [anon_sym_boolean] = ACTIONS(7733),
    [anon_sym_async] = ACTIONS(7733),
    [anon_sym_public] = ACTIONS(7733),
    [anon_sym_AMP] = ACTIONS(9834),
    [anon_sym_var] = ACTIONS(7733),
    [anon_sym_while] = ACTIONS(7733),
    [anon_sym_SQUOTE] = ACTIONS(7735),
    [anon_sym_try] = ACTIONS(7733),
    [anon_sym_LT] = ACTIONS(7735),
    [sym_number] = ACTIONS(7735),
    [anon_sym_SLASH] = ACTIONS(7733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7733),
    [anon_sym_function] = ACTIONS(7733),
    [sym_undefined] = ACTIONS(7733),
    [anon_sym_new] = ACTIONS(7733),
    [anon_sym_let] = ACTIONS(7733),
    [anon_sym_PLUS] = ACTIONS(7733),
    [anon_sym_export] = ACTIONS(7733),
    [anon_sym_do] = ACTIONS(7733),
    [anon_sym_TILDE] = ACTIONS(7735),
    [anon_sym_with] = ACTIONS(7733),
  },
  [5049] = {
    [sym_formal_parameters] = STATE(5126),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [5050] = {
    [sym_type_arguments] = STATE(850),
    [sym_identifier] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_debugger] = ACTIONS(3865),
    [anon_sym_symbol] = ACTIONS(3865),
    [anon_sym_AT] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_void] = ACTIONS(3865),
    [anon_sym_break] = ACTIONS(3865),
    [anon_sym_const] = ACTIONS(3865),
    [sym_super] = ACTIONS(3865),
    [anon_sym_return] = ACTIONS(3865),
    [anon_sym_private] = ACTIONS(3865),
    [anon_sym_get] = ACTIONS(3865),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_default] = ACTIONS(3865),
    [anon_sym_interface] = ACTIONS(3865),
    [anon_sym_enum] = ACTIONS(3865),
    [anon_sym_delete] = ACTIONS(3865),
    [anon_sym_continue] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_if] = ACTIONS(3865),
    [anon_sym_this] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3865),
    [sym_true] = ACTIONS(3865),
    [anon_sym_throw] = ACTIONS(3865),
    [anon_sym_protected] = ACTIONS(3865),
    [anon_sym_abstract] = ACTIONS(3865),
    [anon_sym_set] = ACTIONS(3865),
    [anon_sym_type] = ACTIONS(3865),
    [anon_sym_import] = ACTIONS(3865),
    [anon_sym_namespace] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_await] = ACTIONS(3865),
    [anon_sym_DQUOTE] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [sym_false] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_case] = ACTIONS(3865),
    [anon_sym_module] = ACTIONS(3865),
    [anon_sym_number] = ACTIONS(3865),
    [anon_sym_class] = ACTIONS(3865),
    [anon_sym_declare] = ACTIONS(3865),
    [anon_sym_typeof] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_switch] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [sym_null] = ACTIONS(3865),
    [anon_sym_any] = ACTIONS(3865),
    [anon_sym_boolean] = ACTIONS(3865),
    [anon_sym_async] = ACTIONS(3865),
    [anon_sym_public] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_var] = ACTIONS(3865),
    [anon_sym_while] = ACTIONS(3865),
    [anon_sym_SQUOTE] = ACTIONS(1577),
    [anon_sym_try] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(7741),
    [sym_number] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3865),
    [sym_undefined] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_let] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_export] = ACTIONS(3865),
    [anon_sym_do] = ACTIONS(3865),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_with] = ACTIONS(3865),
    [anon_sym_in] = ACTIONS(9836),
  },
  [5051] = {
    [anon_sym_EQ_GT] = ACTIONS(9838),
    [sym_comment] = ACTIONS(3),
  },
  [5052] = {
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(8765),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8767),
    [sym_comment] = ACTIONS(3),
  },
  [5053] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_RBRACE] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(8815),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8817),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [5054] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5129),
    [sym_constructor_type] = STATE(5129),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(5129),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5129),
    [sym_intersection_type] = STATE(5129),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [5055] = {
    [anon_sym_EQ_GT] = ACTIONS(9840),
    [sym_comment] = ACTIONS(3),
  },
  [5056] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5131),
    [sym_constructor_type] = STATE(5131),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(5131),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5131),
    [sym_intersection_type] = STATE(5131),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [5057] = {
    [sym__automatic_semicolon] = ACTIONS(5425),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(9566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9568),
    [anon_sym_COMMA] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5425),
  },
  [5058] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_RBRACE] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(8859),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8086),
  },
  [5059] = {
    [sym_statement_block] = STATE(4893),
    [sym__automatic_semicolon] = ACTIONS(9635),
    [anon_sym_RBRACE] = ACTIONS(9635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(9635),
    [anon_sym_COMMA] = ACTIONS(9635),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9635),
    [anon_sym_LBRACE] = ACTIONS(458),
  },
  [5060] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(8873),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(8875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8086),
  },
  [5061] = {
    [sym_type_alias_declaration] = STATE(4592),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4592),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4592),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4592),
    [sym_return_statement] = STATE(4592),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4592),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4592),
    [sym_switch_statement] = STATE(4592),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4592),
    [sym_throw_statement] = STATE(4592),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4592),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4592),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(4592),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4592),
    [sym_abstract_class] = STATE(4592),
    [sym_interface_declaration] = STATE(4592),
    [sym_statement_block] = STATE(4592),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4592),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4592),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4592),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4592),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4592),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4592),
    [sym_empty_statement] = STATE(4592),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(4592),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4592),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4592),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4592),
    [sym_break_statement] = STATE(4592),
    [sym_labeled_statement] = STATE(4592),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4592),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [5062] = {
    [sym_type_alias_declaration] = STATE(4593),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4593),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4593),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4593),
    [sym_return_statement] = STATE(4593),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4593),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4593),
    [sym_switch_statement] = STATE(4593),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4593),
    [sym_throw_statement] = STATE(4593),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4593),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4593),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(4593),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4593),
    [sym_abstract_class] = STATE(4593),
    [sym_interface_declaration] = STATE(4593),
    [sym_statement_block] = STATE(4593),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4593),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4593),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4593),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4593),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4593),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4593),
    [sym_empty_statement] = STATE(4593),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(4593),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4593),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4593),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4593),
    [sym_break_statement] = STATE(4593),
    [sym_labeled_statement] = STATE(4593),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4593),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [5063] = {
    [sym_type_alias_declaration] = STATE(4594),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4594),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4594),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4594),
    [sym_return_statement] = STATE(4594),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(329),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4594),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4594),
    [sym_switch_statement] = STATE(4594),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4594),
    [sym_throw_statement] = STATE(4594),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4594),
    [sym_generator_function] = STATE(329),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4594),
    [sym_decorator] = STATE(1787),
    [sym_continue_statement] = STATE(4594),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4594),
    [sym_abstract_class] = STATE(4594),
    [sym_interface_declaration] = STATE(4594),
    [sym_statement_block] = STATE(4594),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4594),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4594),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4594),
    [sym_function] = STATE(330),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4594),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4594),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4594),
    [sym_empty_statement] = STATE(4594),
    [aux_sym_export_statement_repeat1] = STATE(1787),
    [sym_import_alias] = STATE(4594),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4594),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4594),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4594),
    [sym_break_statement] = STATE(4594),
    [sym_labeled_statement] = STATE(4594),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4594),
    [sym_class] = STATE(329),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3702),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3708),
  },
  [5064] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5065] = {
    [sym_formal_parameters] = STATE(5132),
    [sym_type_parameters] = STATE(5133),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [5066] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5067] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(9842),
    [anon_sym_PIPE] = ACTIONS(9844),
    [anon_sym_else] = ACTIONS(5196),
    [anon_sym_while] = ACTIONS(5196),
  },
  [5068] = {
    [sym_formal_parameters] = STATE(5136),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [5069] = {
    [anon_sym_EQ_GT] = ACTIONS(9846),
    [sym_comment] = ACTIONS(3),
  },
  [5070] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_AMP] = ACTIONS(9842),
    [anon_sym_PIPE] = ACTIONS(9844),
    [anon_sym_else] = ACTIONS(5204),
    [anon_sym_while] = ACTIONS(5204),
  },
  [5071] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5138),
    [sym_constructor_type] = STATE(5138),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5138),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5138),
    [sym_intersection_type] = STATE(5138),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4812),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4814),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9369),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9371),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5072] = {
    [anon_sym_EQ_GT] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
  },
  [5073] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5140),
    [sym_constructor_type] = STATE(5140),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5140),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5140),
    [sym_intersection_type] = STATE(5140),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4812),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4814),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9369),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9371),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5074] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(9842),
    [anon_sym_PIPE] = ACTIONS(9844),
    [anon_sym_else] = ACTIONS(5406),
    [anon_sym_while] = ACTIONS(5406),
  },
  [5075] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_PIPE] = ACTIONS(9608),
    [anon_sym_else] = ACTIONS(5425),
    [anon_sym_while] = ACTIONS(5425),
  },
  [5076] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5141),
    [sym_constructor_type] = STATE(5141),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(5141),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5141),
    [sym_intersection_type] = STATE(5141),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5077] = {
    [anon_sym_EQ_GT] = ACTIONS(9850),
    [sym_comment] = ACTIONS(3),
  },
  [5078] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5143),
    [sym_constructor_type] = STATE(5143),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(5143),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5143),
    [sym_intersection_type] = STATE(5143),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5079] = {
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(9614),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_while] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [5080] = {
    [anon_sym_AMP] = ACTIONS(8967),
    [anon_sym_PIPE] = ACTIONS(8969),
    [anon_sym_while] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [5081] = {
    [sym_identifier] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_debugger] = ACTIONS(8987),
    [anon_sym_symbol] = ACTIONS(8987),
    [anon_sym_AT] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9042),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_void] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8987),
    [anon_sym_const] = ACTIONS(8987),
    [sym_super] = ACTIONS(8987),
    [anon_sym_return] = ACTIONS(8987),
    [anon_sym_private] = ACTIONS(8987),
    [anon_sym_get] = ACTIONS(8987),
    [anon_sym_interface] = ACTIONS(8987),
    [anon_sym_enum] = ACTIONS(8987),
    [anon_sym_delete] = ACTIONS(8987),
    [anon_sym_continue] = ACTIONS(8987),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_if] = ACTIONS(8987),
    [anon_sym_this] = ACTIONS(8987),
    [anon_sym_yield] = ACTIONS(8987),
    [sym_true] = ACTIONS(8987),
    [anon_sym_throw] = ACTIONS(8987),
    [anon_sym_protected] = ACTIONS(8987),
    [anon_sym_abstract] = ACTIONS(8987),
    [anon_sym_set] = ACTIONS(8987),
    [anon_sym_type] = ACTIONS(8987),
    [anon_sym_import] = ACTIONS(8987),
    [anon_sym_namespace] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_await] = ACTIONS(8987),
    [anon_sym_DQUOTE] = ACTIONS(8086),
    [anon_sym_else] = ACTIONS(8987),
    [anon_sym_BANG] = ACTIONS(8086),
    [anon_sym_for] = ACTIONS(8987),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [sym_false] = ACTIONS(8987),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_module] = ACTIONS(8987),
    [anon_sym_number] = ACTIONS(8987),
    [anon_sym_class] = ACTIONS(8987),
    [anon_sym_declare] = ACTIONS(8987),
    [anon_sym_typeof] = ACTIONS(8987),
    [anon_sym_LBRACE] = ACTIONS(8086),
    [anon_sym_switch] = ACTIONS(8987),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [sym_null] = ACTIONS(8987),
    [anon_sym_any] = ACTIONS(8987),
    [anon_sym_boolean] = ACTIONS(8987),
    [anon_sym_async] = ACTIONS(8987),
    [anon_sym_public] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(9044),
    [anon_sym_var] = ACTIONS(8987),
    [anon_sym_while] = ACTIONS(8987),
    [anon_sym_SQUOTE] = ACTIONS(8086),
    [anon_sym_try] = ACTIONS(8987),
    [anon_sym_LT] = ACTIONS(8086),
    [sym_number] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8987),
    [anon_sym_function] = ACTIONS(8987),
    [sym_undefined] = ACTIONS(8987),
    [anon_sym_new] = ACTIONS(8987),
    [ts_builtin_sym_end] = ACTIONS(8086),
    [anon_sym_let] = ACTIONS(8987),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_export] = ACTIONS(8987),
    [anon_sym_do] = ACTIONS(8987),
    [anon_sym_TILDE] = ACTIONS(8086),
    [anon_sym_with] = ACTIONS(8987),
  },
  [5082] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9436),
    [sym_comment] = ACTIONS(3),
  },
  [5083] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5144),
    [sym_constructor_type] = STATE(5144),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3785),
    [sym_function_type] = STATE(5144),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5144),
    [sym_intersection_type] = STATE(5144),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4627),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4628),
    [sym_identifier] = ACTIONS(7678),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(7680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9116),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9118),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [5084] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_COMMA] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9436),
    [sym_comment] = ACTIONS(3),
  },
  [5085] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(9132),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9134),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8086),
  },
  [5086] = {
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_debugger] = ACTIONS(8300),
    [anon_sym_symbol] = ACTIONS(8300),
    [anon_sym_AT] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_void] = ACTIONS(8300),
    [anon_sym_break] = ACTIONS(8300),
    [anon_sym_const] = ACTIONS(8300),
    [sym_super] = ACTIONS(8300),
    [anon_sym_return] = ACTIONS(8300),
    [anon_sym_private] = ACTIONS(8300),
    [anon_sym_get] = ACTIONS(8300),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_interface] = ACTIONS(8300),
    [anon_sym_enum] = ACTIONS(8300),
    [anon_sym_delete] = ACTIONS(8300),
    [anon_sym_continue] = ACTIONS(8300),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_if] = ACTIONS(8300),
    [anon_sym_this] = ACTIONS(8300),
    [anon_sym_yield] = ACTIONS(8300),
    [sym_true] = ACTIONS(8300),
    [anon_sym_throw] = ACTIONS(8300),
    [anon_sym_protected] = ACTIONS(8300),
    [anon_sym_abstract] = ACTIONS(8300),
    [anon_sym_set] = ACTIONS(8300),
    [anon_sym_type] = ACTIONS(8300),
    [anon_sym_import] = ACTIONS(8300),
    [anon_sym_namespace] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_await] = ACTIONS(8300),
    [anon_sym_DQUOTE] = ACTIONS(6909),
    [anon_sym_else] = ACTIONS(8300),
    [anon_sym_BANG] = ACTIONS(6909),
    [anon_sym_for] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [sym_false] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_module] = ACTIONS(8300),
    [anon_sym_number] = ACTIONS(8300),
    [anon_sym_class] = ACTIONS(8300),
    [anon_sym_declare] = ACTIONS(8300),
    [anon_sym_typeof] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_switch] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [sym_null] = ACTIONS(8300),
    [anon_sym_any] = ACTIONS(8300),
    [anon_sym_boolean] = ACTIONS(8300),
    [anon_sym_async] = ACTIONS(8300),
    [anon_sym_public] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(9484),
    [anon_sym_var] = ACTIONS(8300),
    [anon_sym_while] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(6909),
    [anon_sym_try] = ACTIONS(8300),
    [anon_sym_LT] = ACTIONS(6909),
    [sym_number] = ACTIONS(6909),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8300),
    [anon_sym_function] = ACTIONS(8300),
    [sym_undefined] = ACTIONS(8300),
    [anon_sym_new] = ACTIONS(8300),
    [anon_sym_let] = ACTIONS(8300),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_export] = ACTIONS(8300),
    [anon_sym_do] = ACTIONS(8300),
    [anon_sym_TILDE] = ACTIONS(6909),
    [anon_sym_with] = ACTIONS(8300),
  },
  [5087] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5145),
    [sym_constructor_type] = STATE(5145),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4681),
    [sym_function_type] = STATE(5145),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5145),
    [sym_intersection_type] = STATE(5145),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4680),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4682),
    [sym_identifier] = ACTIONS(9198),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9202),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9204),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5088] = {
    [sym_identifier] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_debugger] = ACTIONS(8302),
    [anon_sym_symbol] = ACTIONS(8302),
    [anon_sym_AT] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_void] = ACTIONS(8302),
    [anon_sym_break] = ACTIONS(8302),
    [anon_sym_const] = ACTIONS(8302),
    [sym_super] = ACTIONS(8302),
    [anon_sym_return] = ACTIONS(8302),
    [anon_sym_private] = ACTIONS(8302),
    [anon_sym_get] = ACTIONS(8302),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_interface] = ACTIONS(8302),
    [anon_sym_enum] = ACTIONS(8302),
    [anon_sym_delete] = ACTIONS(8302),
    [anon_sym_continue] = ACTIONS(8302),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_if] = ACTIONS(8302),
    [anon_sym_this] = ACTIONS(8302),
    [anon_sym_yield] = ACTIONS(8302),
    [sym_true] = ACTIONS(8302),
    [anon_sym_throw] = ACTIONS(8302),
    [anon_sym_protected] = ACTIONS(8302),
    [anon_sym_abstract] = ACTIONS(8302),
    [anon_sym_set] = ACTIONS(8302),
    [anon_sym_type] = ACTIONS(8302),
    [anon_sym_import] = ACTIONS(8302),
    [anon_sym_namespace] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_await] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(6986),
    [anon_sym_else] = ACTIONS(8302),
    [anon_sym_BANG] = ACTIONS(6986),
    [anon_sym_for] = ACTIONS(8302),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [sym_false] = ACTIONS(8302),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_module] = ACTIONS(8302),
    [anon_sym_number] = ACTIONS(8302),
    [anon_sym_class] = ACTIONS(8302),
    [anon_sym_declare] = ACTIONS(8302),
    [anon_sym_typeof] = ACTIONS(8302),
    [anon_sym_LBRACE] = ACTIONS(6986),
    [anon_sym_switch] = ACTIONS(8302),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [sym_null] = ACTIONS(8302),
    [anon_sym_any] = ACTIONS(8302),
    [anon_sym_boolean] = ACTIONS(8302),
    [anon_sym_async] = ACTIONS(8302),
    [anon_sym_public] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(9484),
    [anon_sym_var] = ACTIONS(8302),
    [anon_sym_while] = ACTIONS(8302),
    [anon_sym_SQUOTE] = ACTIONS(6986),
    [anon_sym_try] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(6986),
    [sym_number] = ACTIONS(6986),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8302),
    [anon_sym_function] = ACTIONS(8302),
    [sym_undefined] = ACTIONS(8302),
    [anon_sym_new] = ACTIONS(8302),
    [anon_sym_let] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_export] = ACTIONS(8302),
    [anon_sym_do] = ACTIONS(8302),
    [anon_sym_TILDE] = ACTIONS(6986),
    [anon_sym_with] = ACTIONS(8302),
  },
  [5089] = {
    [anon_sym_of] = ACTIONS(9852),
    [sym_comment] = ACTIONS(3),
  },
  [5090] = {
    [anon_sym_of] = ACTIONS(9854),
    [sym_comment] = ACTIONS(3),
  },
  [5091] = {
    [anon_sym_of] = ACTIONS(9856),
    [sym_comment] = ACTIONS(3),
  },
  [5092] = {
    [sym_new_expression] = STATE(5149),
    [sym_augmented_assignment_expression] = STATE(5149),
    [sym_unary_expression] = STATE(5149),
    [sym_update_expression] = STATE(5149),
    [sym_regex] = STATE(5149),
    [sym_meta_property] = STATE(5149),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5149),
    [sym_yield_expression] = STATE(5149),
    [sym_as_expression] = STATE(5149),
    [sym_non_null_expression] = STATE(5149),
    [sym_internal_module] = STATE(5149),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5149),
    [sym_await_expression] = STATE(5149),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5149),
    [sym_this] = STATE(5149),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5149),
    [sym_generator_function] = STATE(5149),
    [sym_call_expression] = STATE(5149),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5149),
    [sym_ternary_expression] = STATE(5149),
    [sym_binary_expression] = STATE(5149),
    [sym_template_string] = STATE(5149),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5149),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5149),
    [sym_class] = STATE(5149),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9858),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9858),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9860),
    [sym_true] = ACTIONS(9858),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9858),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5093] = {
    [sym_new_expression] = STATE(5150),
    [sym_augmented_assignment_expression] = STATE(5150),
    [sym_unary_expression] = STATE(5150),
    [sym_update_expression] = STATE(5150),
    [sym_regex] = STATE(5150),
    [sym_meta_property] = STATE(5150),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5150),
    [sym_yield_expression] = STATE(5150),
    [sym_as_expression] = STATE(5150),
    [sym_non_null_expression] = STATE(5150),
    [sym_internal_module] = STATE(5150),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5150),
    [sym_await_expression] = STATE(5150),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5150),
    [sym_this] = STATE(5150),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5150),
    [sym_generator_function] = STATE(5150),
    [sym_call_expression] = STATE(5150),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5150),
    [sym_ternary_expression] = STATE(5150),
    [sym_binary_expression] = STATE(5150),
    [sym_template_string] = STATE(5150),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5150),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5150),
    [sym_class] = STATE(5150),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9862),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9862),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9864),
    [sym_true] = ACTIONS(9862),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9862),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5094] = {
    [sym_new_expression] = STATE(5151),
    [sym_augmented_assignment_expression] = STATE(5151),
    [sym_unary_expression] = STATE(5151),
    [sym_update_expression] = STATE(5151),
    [sym_regex] = STATE(5151),
    [sym_meta_property] = STATE(5151),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5151),
    [sym_yield_expression] = STATE(5151),
    [sym_as_expression] = STATE(5151),
    [sym_non_null_expression] = STATE(5151),
    [sym_internal_module] = STATE(5151),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5151),
    [sym_await_expression] = STATE(5151),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5151),
    [sym_this] = STATE(5151),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5151),
    [sym_generator_function] = STATE(5151),
    [sym_call_expression] = STATE(5151),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5151),
    [sym_ternary_expression] = STATE(5151),
    [sym_binary_expression] = STATE(5151),
    [sym_template_string] = STATE(5151),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5151),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5151),
    [sym_class] = STATE(5151),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9866),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9866),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9868),
    [sym_true] = ACTIONS(9866),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9866),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5095] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9870),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [5096] = {
    [anon_sym_RPAREN] = ACTIONS(9870),
    [sym_comment] = ACTIONS(3),
  },
  [5097] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9872),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5098] = {
    [sym_new_expression] = STATE(5154),
    [sym_augmented_assignment_expression] = STATE(5154),
    [sym_unary_expression] = STATE(5154),
    [sym_update_expression] = STATE(5154),
    [sym_regex] = STATE(5154),
    [sym_meta_property] = STATE(5154),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(5154),
    [sym_yield_expression] = STATE(5154),
    [sym_as_expression] = STATE(5154),
    [sym_non_null_expression] = STATE(5154),
    [sym_internal_module] = STATE(5154),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5154),
    [sym_await_expression] = STATE(5154),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(5155),
    [sym_string] = STATE(5154),
    [sym_this] = STATE(5154),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(5154),
    [sym_generator_function] = STATE(5154),
    [sym_call_expression] = STATE(5154),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(5154),
    [sym_ternary_expression] = STATE(5154),
    [sym_binary_expression] = STATE(5154),
    [sym_template_string] = STATE(5154),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5154),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(5154),
    [sym_class] = STATE(5154),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9874),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9874),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9876),
    [sym_true] = ACTIONS(9874),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9874),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [5099] = {
    [sym_new_expression] = STATE(5156),
    [sym_augmented_assignment_expression] = STATE(5156),
    [sym_unary_expression] = STATE(5156),
    [sym_update_expression] = STATE(5156),
    [sym_regex] = STATE(5156),
    [sym_meta_property] = STATE(5156),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(5156),
    [sym_yield_expression] = STATE(5156),
    [sym_as_expression] = STATE(5156),
    [sym_non_null_expression] = STATE(5156),
    [sym_internal_module] = STATE(5156),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5156),
    [sym_await_expression] = STATE(5156),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(5157),
    [sym_string] = STATE(5156),
    [sym_this] = STATE(5156),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(5156),
    [sym_generator_function] = STATE(5156),
    [sym_call_expression] = STATE(5156),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(5156),
    [sym_ternary_expression] = STATE(5156),
    [sym_binary_expression] = STATE(5156),
    [sym_template_string] = STATE(5156),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5156),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(5156),
    [sym_class] = STATE(5156),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9878),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9878),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9880),
    [sym_true] = ACTIONS(9878),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9878),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [5100] = {
    [sym_new_expression] = STATE(5158),
    [sym_augmented_assignment_expression] = STATE(5158),
    [sym_unary_expression] = STATE(5158),
    [sym_update_expression] = STATE(5158),
    [sym_regex] = STATE(5158),
    [sym_meta_property] = STATE(5158),
    [sym_call_signature] = STATE(446),
    [sym__expression] = STATE(5158),
    [sym_yield_expression] = STATE(5158),
    [sym_as_expression] = STATE(5158),
    [sym_non_null_expression] = STATE(5158),
    [sym_internal_module] = STATE(5158),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5158),
    [sym_await_expression] = STATE(5158),
    [sym_member_expression] = STATE(448),
    [sym_sequence_expression] = STATE(5159),
    [sym_string] = STATE(5158),
    [sym_this] = STATE(5158),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(450),
    [sym_anonymous_class] = STATE(5158),
    [sym_generator_function] = STATE(5158),
    [sym_call_expression] = STATE(5158),
    [sym_subscript_expression] = STATE(448),
    [sym_assignment_expression] = STATE(5158),
    [sym_ternary_expression] = STATE(5158),
    [sym_binary_expression] = STATE(5158),
    [sym_template_string] = STATE(5158),
    [sym_type_arguments] = STATE(452),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5158),
    [sym_array] = STATE(453),
    [sym_type_assertion] = STATE(5158),
    [sym_class] = STATE(5158),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_identifier] = ACTIONS(779),
    [sym_false] = ACTIONS(9882),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(783),
    [anon_sym_symbol] = ACTIONS(783),
    [anon_sym_number] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9882),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_boolean] = ACTIONS(783),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_get] = ACTIONS(783),
    [anon_sym_delete] = ACTIONS(785),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9884),
    [sym_true] = ACTIONS(9882),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9882),
    [anon_sym_set] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(783),
    [anon_sym_export] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
  },
  [5101] = {
    [sym_type_alias_declaration] = STATE(3004),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3004),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3004),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3004),
    [sym_return_statement] = STATE(3004),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3004),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3004),
    [sym_switch_statement] = STATE(3004),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3004),
    [sym_throw_statement] = STATE(3004),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3004),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3004),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(3004),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3004),
    [sym_abstract_class] = STATE(3004),
    [sym_interface_declaration] = STATE(3004),
    [sym_statement_block] = STATE(3004),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3004),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3004),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3004),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3004),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3004),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3004),
    [sym_empty_statement] = STATE(3004),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(3004),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3004),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3004),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3004),
    [sym_break_statement] = STATE(3004),
    [sym_labeled_statement] = STATE(3004),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3004),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5102] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9886),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5103] = {
    [anon_sym_RPAREN] = ACTIONS(9886),
    [sym_comment] = ACTIONS(3),
  },
  [5104] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5105] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9890),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [5106] = {
    [anon_sym_RPAREN] = ACTIONS(9890),
    [sym_comment] = ACTIONS(3),
  },
  [5107] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9892),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5108] = {
    [sym_template_string] = STATE(103),
    [sym_arguments] = STATE(103),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_GT_GT_GT] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_as] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(2051),
    [anon_sym_instanceof] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(9894),
    [anon_sym_SLASH] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(2049),
    [anon_sym_STAR_STAR] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2049),
    [anon_sym_in] = ACTIONS(2051),
  },
  [5109] = {
    [anon_sym_RPAREN] = ACTIONS(9894),
    [sym_comment] = ACTIONS(3),
  },
  [5110] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5170),
    [sym_constructor_type] = STATE(5170),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(5170),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5170),
    [sym_intersection_type] = STATE(5170),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5111] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9906),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5112] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9908),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5113] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9910),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5114] = {
    [sym_type_alias_declaration] = STATE(4231),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4231),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4231),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4231),
    [sym_return_statement] = STATE(4231),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4231),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4231),
    [sym_switch_statement] = STATE(4231),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4231),
    [sym_throw_statement] = STATE(4231),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4231),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4231),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(4231),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4231),
    [sym_abstract_class] = STATE(4231),
    [sym_interface_declaration] = STATE(4231),
    [sym_statement_block] = STATE(4231),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4231),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4231),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4231),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4231),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4231),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4231),
    [sym_empty_statement] = STATE(4231),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(4231),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4231),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4231),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4231),
    [sym_break_statement] = STATE(4231),
    [sym_labeled_statement] = STATE(4231),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4231),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5115] = {
    [sym_type_alias_declaration] = STATE(4232),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4232),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4232),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4232),
    [sym_return_statement] = STATE(4232),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4232),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4232),
    [sym_switch_statement] = STATE(4232),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4232),
    [sym_throw_statement] = STATE(4232),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4232),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4232),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(4232),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4232),
    [sym_abstract_class] = STATE(4232),
    [sym_interface_declaration] = STATE(4232),
    [sym_statement_block] = STATE(4232),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4232),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4232),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4232),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4232),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4232),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4232),
    [sym_empty_statement] = STATE(4232),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(4232),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4232),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4232),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4232),
    [sym_break_statement] = STATE(4232),
    [sym_labeled_statement] = STATE(4232),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4232),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5116] = {
    [sym_type_alias_declaration] = STATE(4233),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4233),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4233),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4233),
    [sym_return_statement] = STATE(4233),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4233),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4233),
    [sym_switch_statement] = STATE(4233),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4233),
    [sym_throw_statement] = STATE(4233),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4233),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4233),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(4233),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4233),
    [sym_abstract_class] = STATE(4233),
    [sym_interface_declaration] = STATE(4233),
    [sym_statement_block] = STATE(4233),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4233),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4233),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4233),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4233),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4233),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4233),
    [sym_empty_statement] = STATE(4233),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(4233),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4233),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4233),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4233),
    [sym_break_statement] = STATE(4233),
    [sym_labeled_statement] = STATE(4233),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4233),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5117] = {
    [sym_type_alias_declaration] = STATE(4262),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4262),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4262),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4262),
    [sym_return_statement] = STATE(4262),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4262),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4262),
    [sym_switch_statement] = STATE(4262),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4262),
    [sym_throw_statement] = STATE(4262),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4262),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4262),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(4262),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4262),
    [sym_abstract_class] = STATE(4262),
    [sym_interface_declaration] = STATE(4262),
    [sym_statement_block] = STATE(4262),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4262),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4262),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4262),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4262),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4262),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4262),
    [sym_empty_statement] = STATE(4262),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(4262),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4262),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4262),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4262),
    [sym_break_statement] = STATE(4262),
    [sym_labeled_statement] = STATE(4262),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4262),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5118] = {
    [sym_type_alias_declaration] = STATE(4263),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4263),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4263),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4263),
    [sym_return_statement] = STATE(4263),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4263),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4263),
    [sym_switch_statement] = STATE(4263),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4263),
    [sym_throw_statement] = STATE(4263),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4263),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4263),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(4263),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4263),
    [sym_abstract_class] = STATE(4263),
    [sym_interface_declaration] = STATE(4263),
    [sym_statement_block] = STATE(4263),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4263),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4263),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4263),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4263),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4263),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4263),
    [sym_empty_statement] = STATE(4263),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(4263),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4263),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4263),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4263),
    [sym_break_statement] = STATE(4263),
    [sym_labeled_statement] = STATE(4263),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4263),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5119] = {
    [sym_type_alias_declaration] = STATE(4264),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4264),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4264),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4264),
    [sym_return_statement] = STATE(4264),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4264),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4264),
    [sym_switch_statement] = STATE(4264),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4264),
    [sym_throw_statement] = STATE(4264),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4264),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4264),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(4264),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4264),
    [sym_abstract_class] = STATE(4264),
    [sym_interface_declaration] = STATE(4264),
    [sym_statement_block] = STATE(4264),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4264),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4264),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4264),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4264),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4264),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4264),
    [sym_empty_statement] = STATE(4264),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(4264),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4264),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4264),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4264),
    [sym_break_statement] = STATE(4264),
    [sym_labeled_statement] = STATE(4264),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4264),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5120] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5177),
    [sym_constructor_type] = STATE(5177),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(5177),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5177),
    [sym_intersection_type] = STATE(5177),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5121] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5178),
    [sym_constructor_type] = STATE(5178),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(5178),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5178),
    [sym_intersection_type] = STATE(5178),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5122] = {
    [anon_sym_EQ_GT] = ACTIONS(9912),
    [sym_comment] = ACTIONS(3),
  },
  [5123] = {
    [sym_formal_parameters] = STATE(5180),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [5124] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5125] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5126] = {
    [anon_sym_EQ_GT] = ACTIONS(9914),
    [sym_comment] = ACTIONS(3),
  },
  [5127] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5182),
    [sym_constructor_type] = STATE(5182),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(5182),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5182),
    [sym_intersection_type] = STATE(5182),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5128] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5183),
    [sym_constructor_type] = STATE(5183),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(5183),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5183),
    [sym_intersection_type] = STATE(5183),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5129] = {
    [sym__automatic_semicolon] = ACTIONS(6909),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(9566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9568),
    [anon_sym_COMMA] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6909),
  },
  [5130] = {
    [sym_tuple_type] = STATE(1066),
    [sym__type] = STATE(5184),
    [sym_constructor_type] = STATE(5184),
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_array_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4056),
    [sym_function_type] = STATE(5184),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym__number] = STATE(1048),
    [sym_existential_type] = STATE(1066),
    [sym_nested_identifier] = STATE(1065),
    [sym_object_type] = STATE(1066),
    [sym_union_type] = STATE(5184),
    [sym_intersection_type] = STATE(5184),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_mapped_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_predefined_type] = STATE(1066),
    [sym_type_parameters] = STATE(4769),
    [sym_string] = STATE(1048),
    [sym_formal_parameters] = STATE(4770),
    [sym_identifier] = ACTIONS(8144),
    [sym_false] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(8146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(9303),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_keyof] = ACTIONS(2207),
    [sym_number] = ACTIONS(2209),
    [sym_true] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(9305),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(9307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(2197),
  },
  [5131] = {
    [sym__automatic_semicolon] = ACTIONS(6986),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(9566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9568),
    [anon_sym_COMMA] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6986),
  },
  [5132] = {
    [anon_sym_EQ_GT] = ACTIONS(9916),
    [sym_comment] = ACTIONS(3),
  },
  [5133] = {
    [sym_formal_parameters] = STATE(5186),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [5134] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5135] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5136] = {
    [anon_sym_EQ_GT] = ACTIONS(9918),
    [sym_comment] = ACTIONS(3),
  },
  [5137] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5188),
    [sym_constructor_type] = STATE(5188),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5188),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5188),
    [sym_intersection_type] = STATE(5188),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5138] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_PIPE] = ACTIONS(9608),
    [anon_sym_else] = ACTIONS(6909),
    [anon_sym_while] = ACTIONS(6909),
  },
  [5139] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5189),
    [sym_constructor_type] = STATE(5189),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5189),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5189),
    [sym_intersection_type] = STATE(5189),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4812),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4814),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9369),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9371),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5140] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_PIPE] = ACTIONS(9608),
    [anon_sym_else] = ACTIONS(6986),
    [anon_sym_while] = ACTIONS(6986),
  },
  [5141] = {
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(9614),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_while] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [5142] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5190),
    [sym_constructor_type] = STATE(5190),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4140),
    [sym_function_type] = STATE(5190),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5190),
    [sym_intersection_type] = STATE(5190),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(4822),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(4823),
    [sym_identifier] = ACTIONS(8268),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(8270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9381),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9383),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5143] = {
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(9614),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_while] = ACTIONS(6986),
    [sym_comment] = ACTIONS(3),
  },
  [5144] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_COMMA] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9436),
    [sym_comment] = ACTIONS(3),
  },
  [5145] = {
    [sym_identifier] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_debugger] = ACTIONS(8987),
    [anon_sym_symbol] = ACTIONS(8987),
    [anon_sym_AT] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9482),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_void] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8987),
    [anon_sym_const] = ACTIONS(8987),
    [sym_super] = ACTIONS(8987),
    [anon_sym_return] = ACTIONS(8987),
    [anon_sym_private] = ACTIONS(8987),
    [anon_sym_get] = ACTIONS(8987),
    [anon_sym_RBRACE] = ACTIONS(8086),
    [anon_sym_interface] = ACTIONS(8987),
    [anon_sym_enum] = ACTIONS(8987),
    [anon_sym_delete] = ACTIONS(8987),
    [anon_sym_continue] = ACTIONS(8987),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_if] = ACTIONS(8987),
    [anon_sym_this] = ACTIONS(8987),
    [anon_sym_yield] = ACTIONS(8987),
    [sym_true] = ACTIONS(8987),
    [anon_sym_throw] = ACTIONS(8987),
    [anon_sym_protected] = ACTIONS(8987),
    [anon_sym_abstract] = ACTIONS(8987),
    [anon_sym_set] = ACTIONS(8987),
    [anon_sym_type] = ACTIONS(8987),
    [anon_sym_import] = ACTIONS(8987),
    [anon_sym_namespace] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_await] = ACTIONS(8987),
    [anon_sym_DQUOTE] = ACTIONS(8086),
    [anon_sym_else] = ACTIONS(8987),
    [anon_sym_BANG] = ACTIONS(8086),
    [anon_sym_for] = ACTIONS(8987),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [sym_false] = ACTIONS(8987),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_module] = ACTIONS(8987),
    [anon_sym_number] = ACTIONS(8987),
    [anon_sym_class] = ACTIONS(8987),
    [anon_sym_declare] = ACTIONS(8987),
    [anon_sym_typeof] = ACTIONS(8987),
    [anon_sym_LBRACE] = ACTIONS(8086),
    [anon_sym_switch] = ACTIONS(8987),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [sym_null] = ACTIONS(8987),
    [anon_sym_any] = ACTIONS(8987),
    [anon_sym_boolean] = ACTIONS(8987),
    [anon_sym_async] = ACTIONS(8987),
    [anon_sym_public] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(9484),
    [anon_sym_var] = ACTIONS(8987),
    [anon_sym_while] = ACTIONS(8987),
    [anon_sym_SQUOTE] = ACTIONS(8086),
    [anon_sym_try] = ACTIONS(8987),
    [anon_sym_LT] = ACTIONS(8086),
    [sym_number] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8987),
    [anon_sym_function] = ACTIONS(8987),
    [sym_undefined] = ACTIONS(8987),
    [anon_sym_new] = ACTIONS(8987),
    [anon_sym_let] = ACTIONS(8987),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_export] = ACTIONS(8987),
    [anon_sym_do] = ACTIONS(8987),
    [anon_sym_TILDE] = ACTIONS(8086),
    [anon_sym_with] = ACTIONS(8987),
  },
  [5146] = {
    [sym_new_expression] = STATE(5191),
    [sym_augmented_assignment_expression] = STATE(5191),
    [sym_unary_expression] = STATE(5191),
    [sym_update_expression] = STATE(5191),
    [sym_regex] = STATE(5191),
    [sym_meta_property] = STATE(5191),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5191),
    [sym_yield_expression] = STATE(5191),
    [sym_as_expression] = STATE(5191),
    [sym_non_null_expression] = STATE(5191),
    [sym_internal_module] = STATE(5191),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5191),
    [sym_await_expression] = STATE(5191),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5191),
    [sym_this] = STATE(5191),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5191),
    [sym_generator_function] = STATE(5191),
    [sym_call_expression] = STATE(5191),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5191),
    [sym_ternary_expression] = STATE(5191),
    [sym_binary_expression] = STATE(5191),
    [sym_template_string] = STATE(5191),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5191),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5191),
    [sym_class] = STATE(5191),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9920),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9922),
    [sym_true] = ACTIONS(9920),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9920),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5147] = {
    [sym_new_expression] = STATE(5192),
    [sym_augmented_assignment_expression] = STATE(5192),
    [sym_unary_expression] = STATE(5192),
    [sym_update_expression] = STATE(5192),
    [sym_regex] = STATE(5192),
    [sym_meta_property] = STATE(5192),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5192),
    [sym_yield_expression] = STATE(5192),
    [sym_as_expression] = STATE(5192),
    [sym_non_null_expression] = STATE(5192),
    [sym_internal_module] = STATE(5192),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5192),
    [sym_await_expression] = STATE(5192),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5192),
    [sym_this] = STATE(5192),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5192),
    [sym_generator_function] = STATE(5192),
    [sym_call_expression] = STATE(5192),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5192),
    [sym_ternary_expression] = STATE(5192),
    [sym_binary_expression] = STATE(5192),
    [sym_template_string] = STATE(5192),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5192),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5192),
    [sym_class] = STATE(5192),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9924),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9924),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9926),
    [sym_true] = ACTIONS(9924),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9924),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5148] = {
    [sym_new_expression] = STATE(5193),
    [sym_augmented_assignment_expression] = STATE(5193),
    [sym_unary_expression] = STATE(5193),
    [sym_update_expression] = STATE(5193),
    [sym_regex] = STATE(5193),
    [sym_meta_property] = STATE(5193),
    [sym_call_signature] = STATE(2107),
    [sym__expression] = STATE(5193),
    [sym_yield_expression] = STATE(5193),
    [sym_as_expression] = STATE(5193),
    [sym_non_null_expression] = STATE(5193),
    [sym_internal_module] = STATE(5193),
    [sym_function] = STATE(160),
    [sym_arrow_function] = STATE(5193),
    [sym_await_expression] = STATE(5193),
    [sym_member_expression] = STATE(2109),
    [sym_string] = STATE(5193),
    [sym_this] = STATE(5193),
    [sym_type_parameters] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(163),
    [sym_object] = STATE(2110),
    [sym_anonymous_class] = STATE(5193),
    [sym_generator_function] = STATE(5193),
    [sym_call_expression] = STATE(5193),
    [sym_subscript_expression] = STATE(2109),
    [sym_assignment_expression] = STATE(5193),
    [sym_ternary_expression] = STATE(5193),
    [sym_binary_expression] = STATE(5193),
    [sym_template_string] = STATE(5193),
    [sym_type_arguments] = STATE(2111),
    [sym_decorator] = STATE(163),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5193),
    [sym_array] = STATE(2112),
    [sym_type_assertion] = STATE(5193),
    [sym_class] = STATE(5193),
    [anon_sym_BANG] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(4405),
    [sym_false] = ACTIONS(9928),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4415),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9928),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4417),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4419),
    [anon_sym_this] = ACTIONS(286),
    [sym_number] = ACTIONS(9930),
    [sym_true] = ACTIONS(9928),
    [anon_sym_yield] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(294),
    [sym_undefined] = ACTIONS(9928),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4427),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_await] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4419),
  },
  [5149] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9932),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5150] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9934),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5151] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5152] = {
    [sym_type_alias_declaration] = STATE(3690),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3690),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3690),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3690),
    [sym_return_statement] = STATE(3690),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3690),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3690),
    [sym_switch_statement] = STATE(3690),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3690),
    [sym_throw_statement] = STATE(3690),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3690),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3690),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(3690),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3690),
    [sym_abstract_class] = STATE(3690),
    [sym_interface_declaration] = STATE(3690),
    [sym_statement_block] = STATE(3690),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3690),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3690),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3690),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3690),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3690),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3690),
    [sym_empty_statement] = STATE(3690),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(3690),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3690),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3690),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3690),
    [sym_break_statement] = STATE(3690),
    [sym_labeled_statement] = STATE(3690),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3690),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5153] = {
    [sym_type_alias_declaration] = STATE(3719),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3719),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3719),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3719),
    [sym_return_statement] = STATE(3719),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3719),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3719),
    [sym_switch_statement] = STATE(3719),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3719),
    [sym_throw_statement] = STATE(3719),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3719),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3719),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(3719),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3719),
    [sym_abstract_class] = STATE(3719),
    [sym_interface_declaration] = STATE(3719),
    [sym_statement_block] = STATE(3719),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3719),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3719),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3719),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3719),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3719),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3719),
    [sym_empty_statement] = STATE(3719),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(3719),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3719),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3719),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3719),
    [sym_break_statement] = STATE(3719),
    [sym_labeled_statement] = STATE(3719),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3719),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5154] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9938),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5155] = {
    [anon_sym_RPAREN] = ACTIONS(9938),
    [sym_comment] = ACTIONS(3),
  },
  [5156] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9940),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5157] = {
    [anon_sym_RPAREN] = ACTIONS(9940),
    [sym_comment] = ACTIONS(3),
  },
  [5158] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_RPAREN] = ACTIONS(9942),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5159] = {
    [anon_sym_RPAREN] = ACTIONS(9942),
    [sym_comment] = ACTIONS(3),
  },
  [5160] = {
    [sym_type_alias_declaration] = STATE(3724),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3724),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3724),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3724),
    [sym_return_statement] = STATE(3724),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3724),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3724),
    [sym_switch_statement] = STATE(3724),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3724),
    [sym_throw_statement] = STATE(3724),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3724),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3724),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(3724),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3724),
    [sym_abstract_class] = STATE(3724),
    [sym_interface_declaration] = STATE(3724),
    [sym_statement_block] = STATE(3724),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3724),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3724),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3724),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3724),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3724),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3724),
    [sym_empty_statement] = STATE(3724),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(3724),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3724),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3724),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3724),
    [sym_break_statement] = STATE(3724),
    [sym_labeled_statement] = STATE(3724),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3724),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5161] = {
    [sym_type_alias_declaration] = STATE(3725),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3725),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3725),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3725),
    [sym_return_statement] = STATE(3725),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3725),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3725),
    [sym_switch_statement] = STATE(3725),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3725),
    [sym_throw_statement] = STATE(3725),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3725),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3725),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(3725),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3725),
    [sym_abstract_class] = STATE(3725),
    [sym_interface_declaration] = STATE(3725),
    [sym_statement_block] = STATE(3725),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3725),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3725),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3725),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3725),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3725),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3725),
    [sym_empty_statement] = STATE(3725),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(3725),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3725),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3725),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3725),
    [sym_break_statement] = STATE(3725),
    [sym_labeled_statement] = STATE(3725),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3725),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5162] = {
    [sym_type_alias_declaration] = STATE(3726),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3726),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3726),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3726),
    [sym_return_statement] = STATE(3726),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3726),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3726),
    [sym_switch_statement] = STATE(3726),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3726),
    [sym_throw_statement] = STATE(3726),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3726),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3726),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(3726),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3726),
    [sym_abstract_class] = STATE(3726),
    [sym_interface_declaration] = STATE(3726),
    [sym_statement_block] = STATE(3726),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3726),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3726),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3726),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3726),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3726),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3726),
    [sym_empty_statement] = STATE(3726),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(3726),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3726),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3726),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3726),
    [sym_break_statement] = STATE(3726),
    [sym_labeled_statement] = STATE(3726),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3726),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5163] = {
    [sym_type_alias_declaration] = STATE(3727),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3727),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3727),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3727),
    [sym_return_statement] = STATE(3727),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3727),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3727),
    [sym_switch_statement] = STATE(3727),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3727),
    [sym_throw_statement] = STATE(3727),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3727),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3727),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(3727),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3727),
    [sym_abstract_class] = STATE(3727),
    [sym_interface_declaration] = STATE(3727),
    [sym_statement_block] = STATE(3727),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3727),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3727),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3727),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3727),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3727),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3727),
    [sym_empty_statement] = STATE(3727),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(3727),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3727),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3727),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3727),
    [sym_break_statement] = STATE(3727),
    [sym_labeled_statement] = STATE(3727),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3727),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5164] = {
    [sym_type_alias_declaration] = STATE(3728),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(3728),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(3728),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(3728),
    [sym_return_statement] = STATE(3728),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(3728),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(3728),
    [sym_switch_statement] = STATE(3728),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(3728),
    [sym_throw_statement] = STATE(3728),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3728),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(3728),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(3728),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3728),
    [sym_abstract_class] = STATE(3728),
    [sym_interface_declaration] = STATE(3728),
    [sym_statement_block] = STATE(3728),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(3728),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(3728),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(3728),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(3728),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(3728),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(3728),
    [sym_empty_statement] = STATE(3728),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(3728),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(3728),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(3728),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(3728),
    [sym_break_statement] = STATE(3728),
    [sym_labeled_statement] = STATE(3728),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(3728),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5165] = {
    [sym_type_arguments] = STATE(791),
    [sym_identifier] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [anon_sym_debugger] = ACTIONS(3834),
    [anon_sym_symbol] = ACTIONS(3834),
    [anon_sym_AT] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_void] = ACTIONS(3834),
    [anon_sym_break] = ACTIONS(3834),
    [anon_sym_const] = ACTIONS(3834),
    [sym_super] = ACTIONS(3834),
    [anon_sym_return] = ACTIONS(3834),
    [anon_sym_private] = ACTIONS(3834),
    [anon_sym_get] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_default] = ACTIONS(3834),
    [anon_sym_interface] = ACTIONS(3834),
    [anon_sym_enum] = ACTIONS(3834),
    [anon_sym_delete] = ACTIONS(3834),
    [anon_sym_continue] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(3834),
    [anon_sym_this] = ACTIONS(3834),
    [anon_sym_yield] = ACTIONS(3834),
    [sym_true] = ACTIONS(3834),
    [anon_sym_throw] = ACTIONS(3834),
    [anon_sym_protected] = ACTIONS(3834),
    [anon_sym_abstract] = ACTIONS(3834),
    [anon_sym_DOT] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3834),
    [anon_sym_type] = ACTIONS(3834),
    [anon_sym_import] = ACTIONS(3834),
    [anon_sym_namespace] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_await] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [anon_sym_else] = ACTIONS(3834),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_for] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [sym_false] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(3834),
    [anon_sym_module] = ACTIONS(3834),
    [anon_sym_number] = ACTIONS(3834),
    [anon_sym_class] = ACTIONS(3834),
    [anon_sym_declare] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3834),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_is] = ACTIONS(9944),
    [anon_sym_switch] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [sym_null] = ACTIONS(3834),
    [anon_sym_any] = ACTIONS(3834),
    [anon_sym_boolean] = ACTIONS(3834),
    [anon_sym_async] = ACTIONS(3834),
    [anon_sym_public] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_var] = ACTIONS(3834),
    [anon_sym_while] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(3834),
    [anon_sym_LT] = ACTIONS(7728),
    [sym_number] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3834),
    [anon_sym_function] = ACTIONS(3834),
    [sym_undefined] = ACTIONS(3834),
    [anon_sym_new] = ACTIONS(3834),
    [anon_sym_let] = ACTIONS(3834),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_export] = ACTIONS(3834),
    [anon_sym_do] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_with] = ACTIONS(3834),
    [anon_sym_in] = ACTIONS(9946),
  },
  [5166] = {
    [sym_tuple_type] = STATE(794),
    [sym_index_type_query] = STATE(794),
    [sym_lookup_type] = STATE(794),
    [sym_this_type] = STATE(794),
    [sym_flow_maybe_type] = STATE(794),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_type_predicate] = STATE(794),
    [sym_type_query] = STATE(794),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(794),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(794),
    [sym__primary_type] = STATE(794),
    [sym_generic_type] = STATE(794),
    [sym_mapped_type] = STATE(794),
    [sym_literal_type] = STATE(794),
    [sym_parenthesized_type] = STATE(794),
    [sym_predefined_type] = STATE(794),
    [sym_string] = STATE(265),
    [sym_array_type] = STATE(794),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [sym_true] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5167] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(821),
    [sym_constructor_type] = STATE(821),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(821),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(821),
    [sym_intersection_type] = STATE(821),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5168] = {
    [sym_formal_parameters] = STATE(5202),
    [sym_type_parameters] = STATE(5203),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(492),
  },
  [5169] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(841),
    [sym_constructor_type] = STATE(841),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(841),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(841),
    [sym_intersection_type] = STATE(841),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5170] = {
    [sym_identifier] = ACTIONS(7733),
    [anon_sym_BQUOTE] = ACTIONS(7735),
    [anon_sym_debugger] = ACTIONS(7733),
    [anon_sym_symbol] = ACTIONS(7733),
    [anon_sym_AT] = ACTIONS(7735),
    [anon_sym_PIPE] = ACTIONS(9948),
    [anon_sym_DASH] = ACTIONS(7733),
    [anon_sym_void] = ACTIONS(7733),
    [anon_sym_break] = ACTIONS(7733),
    [anon_sym_const] = ACTIONS(7733),
    [sym_super] = ACTIONS(7733),
    [anon_sym_return] = ACTIONS(7733),
    [anon_sym_private] = ACTIONS(7733),
    [anon_sym_get] = ACTIONS(7733),
    [anon_sym_RBRACE] = ACTIONS(7735),
    [anon_sym_default] = ACTIONS(7733),
    [anon_sym_interface] = ACTIONS(7733),
    [anon_sym_enum] = ACTIONS(7733),
    [anon_sym_delete] = ACTIONS(7733),
    [anon_sym_continue] = ACTIONS(7733),
    [anon_sym_DASH_DASH] = ACTIONS(7735),
    [anon_sym_if] = ACTIONS(7733),
    [anon_sym_this] = ACTIONS(7733),
    [anon_sym_yield] = ACTIONS(7733),
    [sym_true] = ACTIONS(7733),
    [anon_sym_throw] = ACTIONS(7733),
    [anon_sym_protected] = ACTIONS(7733),
    [anon_sym_abstract] = ACTIONS(7733),
    [anon_sym_set] = ACTIONS(7733),
    [anon_sym_type] = ACTIONS(7733),
    [anon_sym_import] = ACTIONS(7733),
    [anon_sym_namespace] = ACTIONS(7733),
    [anon_sym_PLUS_PLUS] = ACTIONS(7735),
    [anon_sym_await] = ACTIONS(7733),
    [anon_sym_DQUOTE] = ACTIONS(7735),
    [anon_sym_else] = ACTIONS(7733),
    [anon_sym_BANG] = ACTIONS(7735),
    [anon_sym_for] = ACTIONS(7733),
    [anon_sym_LBRACK] = ACTIONS(7735),
    [sym_false] = ACTIONS(7733),
    [anon_sym_SEMI] = ACTIONS(7735),
    [anon_sym_case] = ACTIONS(7733),
    [anon_sym_module] = ACTIONS(7733),
    [anon_sym_number] = ACTIONS(7733),
    [anon_sym_class] = ACTIONS(7733),
    [anon_sym_declare] = ACTIONS(7733),
    [anon_sym_typeof] = ACTIONS(7733),
    [anon_sym_LBRACE] = ACTIONS(7735),
    [anon_sym_switch] = ACTIONS(7733),
    [anon_sym_LPAREN] = ACTIONS(7735),
    [sym_null] = ACTIONS(7733),
    [anon_sym_any] = ACTIONS(7733),
    [anon_sym_boolean] = ACTIONS(7733),
    [anon_sym_async] = ACTIONS(7733),
    [anon_sym_public] = ACTIONS(7733),
    [anon_sym_AMP] = ACTIONS(9950),
    [anon_sym_var] = ACTIONS(7733),
    [anon_sym_while] = ACTIONS(7733),
    [anon_sym_SQUOTE] = ACTIONS(7735),
    [anon_sym_try] = ACTIONS(7733),
    [anon_sym_LT] = ACTIONS(7735),
    [sym_number] = ACTIONS(7735),
    [anon_sym_SLASH] = ACTIONS(7733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7733),
    [anon_sym_function] = ACTIONS(7733),
    [sym_undefined] = ACTIONS(7733),
    [anon_sym_new] = ACTIONS(7733),
    [anon_sym_let] = ACTIONS(7733),
    [anon_sym_PLUS] = ACTIONS(7733),
    [anon_sym_export] = ACTIONS(7733),
    [anon_sym_do] = ACTIONS(7733),
    [anon_sym_TILDE] = ACTIONS(7735),
    [anon_sym_with] = ACTIONS(7733),
  },
  [5171] = {
    [sym_formal_parameters] = STATE(5206),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [5172] = {
    [sym_type_arguments] = STATE(850),
    [sym_identifier] = ACTIONS(3865),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_debugger] = ACTIONS(3865),
    [anon_sym_symbol] = ACTIONS(3865),
    [anon_sym_AT] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_void] = ACTIONS(3865),
    [anon_sym_break] = ACTIONS(3865),
    [anon_sym_const] = ACTIONS(3865),
    [sym_super] = ACTIONS(3865),
    [anon_sym_return] = ACTIONS(3865),
    [anon_sym_private] = ACTIONS(3865),
    [anon_sym_get] = ACTIONS(3865),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_default] = ACTIONS(3865),
    [anon_sym_interface] = ACTIONS(3865),
    [anon_sym_enum] = ACTIONS(3865),
    [anon_sym_delete] = ACTIONS(3865),
    [anon_sym_continue] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_if] = ACTIONS(3865),
    [anon_sym_this] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3865),
    [sym_true] = ACTIONS(3865),
    [anon_sym_throw] = ACTIONS(3865),
    [anon_sym_protected] = ACTIONS(3865),
    [anon_sym_abstract] = ACTIONS(3865),
    [anon_sym_set] = ACTIONS(3865),
    [anon_sym_type] = ACTIONS(3865),
    [anon_sym_import] = ACTIONS(3865),
    [anon_sym_namespace] = ACTIONS(3865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_await] = ACTIONS(3865),
    [anon_sym_DQUOTE] = ACTIONS(1577),
    [anon_sym_else] = ACTIONS(3865),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [sym_false] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_case] = ACTIONS(3865),
    [anon_sym_module] = ACTIONS(3865),
    [anon_sym_number] = ACTIONS(3865),
    [anon_sym_class] = ACTIONS(3865),
    [anon_sym_declare] = ACTIONS(3865),
    [anon_sym_typeof] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_switch] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [sym_null] = ACTIONS(3865),
    [anon_sym_any] = ACTIONS(3865),
    [anon_sym_boolean] = ACTIONS(3865),
    [anon_sym_async] = ACTIONS(3865),
    [anon_sym_public] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_var] = ACTIONS(3865),
    [anon_sym_while] = ACTIONS(3865),
    [anon_sym_SQUOTE] = ACTIONS(1577),
    [anon_sym_try] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(7741),
    [sym_number] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3865),
    [sym_undefined] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_let] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_export] = ACTIONS(3865),
    [anon_sym_do] = ACTIONS(3865),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_with] = ACTIONS(3865),
    [anon_sym_in] = ACTIONS(9952),
  },
  [5173] = {
    [anon_sym_EQ_GT] = ACTIONS(9954),
    [sym_comment] = ACTIONS(3),
  },
  [5174] = {
    [sym_type_alias_declaration] = STATE(4592),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4592),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4592),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4592),
    [sym_return_statement] = STATE(4592),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4592),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4592),
    [sym_switch_statement] = STATE(4592),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4592),
    [sym_throw_statement] = STATE(4592),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4592),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4592),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(4592),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4592),
    [sym_abstract_class] = STATE(4592),
    [sym_interface_declaration] = STATE(4592),
    [sym_statement_block] = STATE(4592),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4592),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4592),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4592),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4592),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4592),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4592),
    [sym_empty_statement] = STATE(4592),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(4592),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4592),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4592),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4592),
    [sym_break_statement] = STATE(4592),
    [sym_labeled_statement] = STATE(4592),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4592),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5175] = {
    [sym_type_alias_declaration] = STATE(4593),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4593),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4593),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4593),
    [sym_return_statement] = STATE(4593),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4593),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4593),
    [sym_switch_statement] = STATE(4593),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4593),
    [sym_throw_statement] = STATE(4593),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4593),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4593),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(4593),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4593),
    [sym_abstract_class] = STATE(4593),
    [sym_interface_declaration] = STATE(4593),
    [sym_statement_block] = STATE(4593),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4593),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4593),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4593),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4593),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4593),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4593),
    [sym_empty_statement] = STATE(4593),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(4593),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4593),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4593),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4593),
    [sym_break_statement] = STATE(4593),
    [sym_labeled_statement] = STATE(4593),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4593),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5176] = {
    [sym_type_alias_declaration] = STATE(4594),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4594),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4594),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4594),
    [sym_return_statement] = STATE(4594),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4594),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4594),
    [sym_switch_statement] = STATE(4594),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4594),
    [sym_throw_statement] = STATE(4594),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4594),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4594),
    [sym_decorator] = STATE(3253),
    [sym_continue_statement] = STATE(4594),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4594),
    [sym_abstract_class] = STATE(4594),
    [sym_interface_declaration] = STATE(4594),
    [sym_statement_block] = STATE(4594),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4594),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4594),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4594),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4594),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4594),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4594),
    [sym_empty_statement] = STATE(4594),
    [aux_sym_export_statement_repeat1] = STATE(3253),
    [sym_import_alias] = STATE(4594),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4594),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4594),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4594),
    [sym_break_statement] = STATE(4594),
    [sym_labeled_statement] = STATE(4594),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4594),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(6677),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6683),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6685),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6687),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6693),
  },
  [5177] = {
    [sym_identifier] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_debugger] = ACTIONS(7182),
    [anon_sym_symbol] = ACTIONS(7182),
    [anon_sym_AT] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9832),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_void] = ACTIONS(7182),
    [anon_sym_break] = ACTIONS(7182),
    [anon_sym_const] = ACTIONS(7182),
    [sym_super] = ACTIONS(7182),
    [anon_sym_return] = ACTIONS(7182),
    [anon_sym_private] = ACTIONS(7182),
    [anon_sym_get] = ACTIONS(7182),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_default] = ACTIONS(7182),
    [anon_sym_interface] = ACTIONS(7182),
    [anon_sym_enum] = ACTIONS(7182),
    [anon_sym_delete] = ACTIONS(7182),
    [anon_sym_continue] = ACTIONS(7182),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_if] = ACTIONS(7182),
    [anon_sym_this] = ACTIONS(7182),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_true] = ACTIONS(7182),
    [anon_sym_throw] = ACTIONS(7182),
    [anon_sym_protected] = ACTIONS(7182),
    [anon_sym_abstract] = ACTIONS(7182),
    [anon_sym_set] = ACTIONS(7182),
    [anon_sym_type] = ACTIONS(7182),
    [anon_sym_import] = ACTIONS(7182),
    [anon_sym_namespace] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_await] = ACTIONS(7182),
    [anon_sym_DQUOTE] = ACTIONS(5196),
    [anon_sym_BANG] = ACTIONS(5196),
    [anon_sym_for] = ACTIONS(7182),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [sym_false] = ACTIONS(7182),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_case] = ACTIONS(7182),
    [anon_sym_module] = ACTIONS(7182),
    [anon_sym_number] = ACTIONS(7182),
    [anon_sym_class] = ACTIONS(7182),
    [anon_sym_declare] = ACTIONS(7182),
    [anon_sym_typeof] = ACTIONS(7182),
    [anon_sym_LBRACE] = ACTIONS(5196),
    [anon_sym_switch] = ACTIONS(7182),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [sym_null] = ACTIONS(7182),
    [anon_sym_any] = ACTIONS(7182),
    [anon_sym_boolean] = ACTIONS(7182),
    [anon_sym_async] = ACTIONS(7182),
    [anon_sym_public] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(9834),
    [anon_sym_var] = ACTIONS(7182),
    [anon_sym_while] = ACTIONS(7182),
    [anon_sym_SQUOTE] = ACTIONS(5196),
    [anon_sym_try] = ACTIONS(7182),
    [anon_sym_LT] = ACTIONS(5196),
    [sym_number] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7182),
    [anon_sym_function] = ACTIONS(7182),
    [sym_undefined] = ACTIONS(7182),
    [anon_sym_new] = ACTIONS(7182),
    [anon_sym_let] = ACTIONS(7182),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_export] = ACTIONS(7182),
    [anon_sym_do] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(5196),
    [anon_sym_with] = ACTIONS(7182),
  },
  [5178] = {
    [sym_identifier] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_debugger] = ACTIONS(7197),
    [anon_sym_symbol] = ACTIONS(7197),
    [anon_sym_AT] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9832),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_void] = ACTIONS(7197),
    [anon_sym_break] = ACTIONS(7197),
    [anon_sym_const] = ACTIONS(7197),
    [sym_super] = ACTIONS(7197),
    [anon_sym_return] = ACTIONS(7197),
    [anon_sym_private] = ACTIONS(7197),
    [anon_sym_get] = ACTIONS(7197),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [anon_sym_default] = ACTIONS(7197),
    [anon_sym_interface] = ACTIONS(7197),
    [anon_sym_enum] = ACTIONS(7197),
    [anon_sym_delete] = ACTIONS(7197),
    [anon_sym_continue] = ACTIONS(7197),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_if] = ACTIONS(7197),
    [anon_sym_this] = ACTIONS(7197),
    [anon_sym_yield] = ACTIONS(7197),
    [sym_true] = ACTIONS(7197),
    [anon_sym_throw] = ACTIONS(7197),
    [anon_sym_protected] = ACTIONS(7197),
    [anon_sym_abstract] = ACTIONS(7197),
    [anon_sym_set] = ACTIONS(7197),
    [anon_sym_type] = ACTIONS(7197),
    [anon_sym_import] = ACTIONS(7197),
    [anon_sym_namespace] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_await] = ACTIONS(7197),
    [anon_sym_DQUOTE] = ACTIONS(5204),
    [anon_sym_BANG] = ACTIONS(5204),
    [anon_sym_for] = ACTIONS(7197),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [sym_false] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_case] = ACTIONS(7197),
    [anon_sym_module] = ACTIONS(7197),
    [anon_sym_number] = ACTIONS(7197),
    [anon_sym_class] = ACTIONS(7197),
    [anon_sym_declare] = ACTIONS(7197),
    [anon_sym_typeof] = ACTIONS(7197),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_switch] = ACTIONS(7197),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [sym_null] = ACTIONS(7197),
    [anon_sym_any] = ACTIONS(7197),
    [anon_sym_boolean] = ACTIONS(7197),
    [anon_sym_async] = ACTIONS(7197),
    [anon_sym_public] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(9834),
    [anon_sym_var] = ACTIONS(7197),
    [anon_sym_while] = ACTIONS(7197),
    [anon_sym_SQUOTE] = ACTIONS(5204),
    [anon_sym_try] = ACTIONS(7197),
    [anon_sym_LT] = ACTIONS(5204),
    [sym_number] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7197),
    [anon_sym_function] = ACTIONS(7197),
    [sym_undefined] = ACTIONS(7197),
    [anon_sym_new] = ACTIONS(7197),
    [anon_sym_let] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_export] = ACTIONS(7197),
    [anon_sym_do] = ACTIONS(7197),
    [anon_sym_TILDE] = ACTIONS(5204),
    [anon_sym_with] = ACTIONS(7197),
  },
  [5179] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5209),
    [sym_constructor_type] = STATE(5209),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(5209),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5209),
    [sym_intersection_type] = STATE(5209),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5180] = {
    [anon_sym_EQ_GT] = ACTIONS(9956),
    [sym_comment] = ACTIONS(3),
  },
  [5181] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5211),
    [sym_constructor_type] = STATE(5211),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(5211),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5211),
    [sym_intersection_type] = STATE(5211),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5182] = {
    [sym_identifier] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_debugger] = ACTIONS(7207),
    [anon_sym_symbol] = ACTIONS(7207),
    [anon_sym_AT] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9832),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_void] = ACTIONS(7207),
    [anon_sym_break] = ACTIONS(7207),
    [anon_sym_const] = ACTIONS(7207),
    [sym_super] = ACTIONS(7207),
    [anon_sym_return] = ACTIONS(7207),
    [anon_sym_private] = ACTIONS(7207),
    [anon_sym_get] = ACTIONS(7207),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_default] = ACTIONS(7207),
    [anon_sym_interface] = ACTIONS(7207),
    [anon_sym_enum] = ACTIONS(7207),
    [anon_sym_delete] = ACTIONS(7207),
    [anon_sym_continue] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_if] = ACTIONS(7207),
    [anon_sym_this] = ACTIONS(7207),
    [anon_sym_yield] = ACTIONS(7207),
    [sym_true] = ACTIONS(7207),
    [anon_sym_throw] = ACTIONS(7207),
    [anon_sym_protected] = ACTIONS(7207),
    [anon_sym_abstract] = ACTIONS(7207),
    [anon_sym_set] = ACTIONS(7207),
    [anon_sym_type] = ACTIONS(7207),
    [anon_sym_import] = ACTIONS(7207),
    [anon_sym_namespace] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_await] = ACTIONS(7207),
    [anon_sym_DQUOTE] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(5406),
    [anon_sym_for] = ACTIONS(7207),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [sym_false] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_case] = ACTIONS(7207),
    [anon_sym_module] = ACTIONS(7207),
    [anon_sym_number] = ACTIONS(7207),
    [anon_sym_class] = ACTIONS(7207),
    [anon_sym_declare] = ACTIONS(7207),
    [anon_sym_typeof] = ACTIONS(7207),
    [anon_sym_LBRACE] = ACTIONS(5406),
    [anon_sym_switch] = ACTIONS(7207),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [sym_null] = ACTIONS(7207),
    [anon_sym_any] = ACTIONS(7207),
    [anon_sym_boolean] = ACTIONS(7207),
    [anon_sym_async] = ACTIONS(7207),
    [anon_sym_public] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(9834),
    [anon_sym_var] = ACTIONS(7207),
    [anon_sym_while] = ACTIONS(7207),
    [anon_sym_SQUOTE] = ACTIONS(5406),
    [anon_sym_try] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(5406),
    [sym_number] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7207),
    [anon_sym_function] = ACTIONS(7207),
    [sym_undefined] = ACTIONS(7207),
    [anon_sym_new] = ACTIONS(7207),
    [anon_sym_let] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_export] = ACTIONS(7207),
    [anon_sym_do] = ACTIONS(7207),
    [anon_sym_TILDE] = ACTIONS(5406),
    [anon_sym_with] = ACTIONS(7207),
  },
  [5183] = {
    [sym_identifier] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_debugger] = ACTIONS(7211),
    [anon_sym_symbol] = ACTIONS(7211),
    [anon_sym_AT] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9832),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_void] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [sym_super] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_private] = ACTIONS(7211),
    [anon_sym_get] = ACTIONS(7211),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_default] = ACTIONS(7211),
    [anon_sym_interface] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_delete] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_this] = ACTIONS(7211),
    [anon_sym_yield] = ACTIONS(7211),
    [sym_true] = ACTIONS(7211),
    [anon_sym_throw] = ACTIONS(7211),
    [anon_sym_protected] = ACTIONS(7211),
    [anon_sym_abstract] = ACTIONS(7211),
    [anon_sym_set] = ACTIONS(7211),
    [anon_sym_type] = ACTIONS(7211),
    [anon_sym_import] = ACTIONS(7211),
    [anon_sym_namespace] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_await] = ACTIONS(7211),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(5425),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [sym_false] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_case] = ACTIONS(7211),
    [anon_sym_module] = ACTIONS(7211),
    [anon_sym_number] = ACTIONS(7211),
    [anon_sym_class] = ACTIONS(7211),
    [anon_sym_declare] = ACTIONS(7211),
    [anon_sym_typeof] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(5425),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [sym_null] = ACTIONS(7211),
    [anon_sym_any] = ACTIONS(7211),
    [anon_sym_boolean] = ACTIONS(7211),
    [anon_sym_async] = ACTIONS(7211),
    [anon_sym_public] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(9834),
    [anon_sym_var] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_try] = ACTIONS(7211),
    [anon_sym_LT] = ACTIONS(5425),
    [sym_number] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7211),
    [anon_sym_function] = ACTIONS(7211),
    [sym_undefined] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [anon_sym_let] = ACTIONS(7211),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_export] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_TILDE] = ACTIONS(5425),
    [anon_sym_with] = ACTIONS(7211),
  },
  [5184] = {
    [sym__automatic_semicolon] = ACTIONS(8086),
    [anon_sym_RBRACE] = ACTIONS(8086),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(9566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9568),
    [anon_sym_COMMA] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8086),
  },
  [5185] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5212),
    [sym_constructor_type] = STATE(5212),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5212),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5212),
    [sym_intersection_type] = STATE(5212),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5186] = {
    [anon_sym_EQ_GT] = ACTIONS(9958),
    [sym_comment] = ACTIONS(3),
  },
  [5187] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5214),
    [sym_constructor_type] = STATE(5214),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5214),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5214),
    [sym_intersection_type] = STATE(5214),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5188] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(9842),
    [anon_sym_PIPE] = ACTIONS(9844),
    [anon_sym_else] = ACTIONS(5425),
    [anon_sym_while] = ACTIONS(5425),
  },
  [5189] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_PIPE] = ACTIONS(9608),
    [anon_sym_else] = ACTIONS(8086),
    [anon_sym_while] = ACTIONS(8086),
  },
  [5190] = {
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(9614),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_while] = ACTIONS(8086),
    [sym_comment] = ACTIONS(3),
  },
  [5191] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9960),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5192] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9962),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5193] = {
    [sym_template_string] = STATE(536),
    [sym_arguments] = STATE(536),
    [sym_type_arguments] = STATE(537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6175),
    [anon_sym_LT_LT] = ACTIONS(6177),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_GT_GT_GT] = ACTIONS(6177),
    [anon_sym_AMP_AMP] = ACTIONS(6183),
    [anon_sym_BANG_EQ] = ACTIONS(6133),
    [anon_sym_LT_EQ] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6185),
    [anon_sym_PERCENT] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_as] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(6133),
    [anon_sym_instanceof] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(9964),
    [anon_sym_SLASH] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_STAR_STAR] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(1055),
  },
  [5194] = {
    [sym_type_alias_declaration] = STATE(4231),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4231),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4231),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4231),
    [sym_return_statement] = STATE(4231),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4231),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4231),
    [sym_switch_statement] = STATE(4231),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4231),
    [sym_throw_statement] = STATE(4231),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4231),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4231),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4231),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4231),
    [sym_abstract_class] = STATE(4231),
    [sym_interface_declaration] = STATE(4231),
    [sym_statement_block] = STATE(4231),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4231),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4231),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4231),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4231),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4231),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4231),
    [sym_empty_statement] = STATE(4231),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4231),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4231),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4231),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4231),
    [sym_break_statement] = STATE(4231),
    [sym_labeled_statement] = STATE(4231),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4231),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5195] = {
    [sym_type_alias_declaration] = STATE(4232),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4232),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4232),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4232),
    [sym_return_statement] = STATE(4232),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4232),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4232),
    [sym_switch_statement] = STATE(4232),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4232),
    [sym_throw_statement] = STATE(4232),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4232),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4232),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4232),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4232),
    [sym_abstract_class] = STATE(4232),
    [sym_interface_declaration] = STATE(4232),
    [sym_statement_block] = STATE(4232),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4232),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4232),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4232),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4232),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4232),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4232),
    [sym_empty_statement] = STATE(4232),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4232),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4232),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4232),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4232),
    [sym_break_statement] = STATE(4232),
    [sym_labeled_statement] = STATE(4232),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4232),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5196] = {
    [sym_type_alias_declaration] = STATE(4233),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4233),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4233),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4233),
    [sym_return_statement] = STATE(4233),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4233),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4233),
    [sym_switch_statement] = STATE(4233),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4233),
    [sym_throw_statement] = STATE(4233),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4233),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4233),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4233),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4233),
    [sym_abstract_class] = STATE(4233),
    [sym_interface_declaration] = STATE(4233),
    [sym_statement_block] = STATE(4233),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4233),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4233),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4233),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4233),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4233),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4233),
    [sym_empty_statement] = STATE(4233),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4233),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4233),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4233),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4233),
    [sym_break_statement] = STATE(4233),
    [sym_labeled_statement] = STATE(4233),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4233),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5197] = {
    [sym_type_alias_declaration] = STATE(4262),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4262),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4262),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4262),
    [sym_return_statement] = STATE(4262),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4262),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4262),
    [sym_switch_statement] = STATE(4262),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4262),
    [sym_throw_statement] = STATE(4262),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4262),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4262),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4262),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4262),
    [sym_abstract_class] = STATE(4262),
    [sym_interface_declaration] = STATE(4262),
    [sym_statement_block] = STATE(4262),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4262),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4262),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4262),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4262),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4262),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4262),
    [sym_empty_statement] = STATE(4262),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4262),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4262),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4262),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4262),
    [sym_break_statement] = STATE(4262),
    [sym_labeled_statement] = STATE(4262),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4262),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5198] = {
    [sym_type_alias_declaration] = STATE(4263),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4263),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4263),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4263),
    [sym_return_statement] = STATE(4263),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4263),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4263),
    [sym_switch_statement] = STATE(4263),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4263),
    [sym_throw_statement] = STATE(4263),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4263),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4263),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4263),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4263),
    [sym_abstract_class] = STATE(4263),
    [sym_interface_declaration] = STATE(4263),
    [sym_statement_block] = STATE(4263),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4263),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4263),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4263),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4263),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4263),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4263),
    [sym_empty_statement] = STATE(4263),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4263),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4263),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4263),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4263),
    [sym_break_statement] = STATE(4263),
    [sym_labeled_statement] = STATE(4263),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4263),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5199] = {
    [sym_type_alias_declaration] = STATE(4264),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4264),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4264),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4264),
    [sym_return_statement] = STATE(4264),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4264),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4264),
    [sym_switch_statement] = STATE(4264),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4264),
    [sym_throw_statement] = STATE(4264),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4264),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4264),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4264),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4264),
    [sym_abstract_class] = STATE(4264),
    [sym_interface_declaration] = STATE(4264),
    [sym_statement_block] = STATE(4264),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4264),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4264),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4264),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4264),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4264),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4264),
    [sym_empty_statement] = STATE(4264),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4264),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4264),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4264),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4264),
    [sym_break_statement] = STATE(4264),
    [sym_labeled_statement] = STATE(4264),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4264),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5200] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5218),
    [sym_constructor_type] = STATE(5218),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(5218),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5218),
    [sym_intersection_type] = STATE(5218),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5201] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5219),
    [sym_constructor_type] = STATE(5219),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(5219),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5219),
    [sym_intersection_type] = STATE(5219),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5202] = {
    [anon_sym_EQ_GT] = ACTIONS(9966),
    [sym_comment] = ACTIONS(3),
  },
  [5203] = {
    [sym_formal_parameters] = STATE(5221),
    [anon_sym_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [5204] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1672),
    [sym_constructor_type] = STATE(1672),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(1672),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1672),
    [sym_intersection_type] = STATE(1672),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5205] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(1673),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5206] = {
    [anon_sym_EQ_GT] = ACTIONS(9968),
    [sym_comment] = ACTIONS(3),
  },
  [5207] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5223),
    [sym_constructor_type] = STATE(5223),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(5223),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5223),
    [sym_intersection_type] = STATE(5223),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5208] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5224),
    [sym_constructor_type] = STATE(5224),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(5224),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5224),
    [sym_intersection_type] = STATE(5224),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5209] = {
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_debugger] = ACTIONS(8300),
    [anon_sym_symbol] = ACTIONS(8300),
    [anon_sym_AT] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9832),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_void] = ACTIONS(8300),
    [anon_sym_break] = ACTIONS(8300),
    [anon_sym_const] = ACTIONS(8300),
    [sym_super] = ACTIONS(8300),
    [anon_sym_return] = ACTIONS(8300),
    [anon_sym_private] = ACTIONS(8300),
    [anon_sym_get] = ACTIONS(8300),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_default] = ACTIONS(8300),
    [anon_sym_interface] = ACTIONS(8300),
    [anon_sym_enum] = ACTIONS(8300),
    [anon_sym_delete] = ACTIONS(8300),
    [anon_sym_continue] = ACTIONS(8300),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_if] = ACTIONS(8300),
    [anon_sym_this] = ACTIONS(8300),
    [anon_sym_yield] = ACTIONS(8300),
    [sym_true] = ACTIONS(8300),
    [anon_sym_throw] = ACTIONS(8300),
    [anon_sym_protected] = ACTIONS(8300),
    [anon_sym_abstract] = ACTIONS(8300),
    [anon_sym_set] = ACTIONS(8300),
    [anon_sym_type] = ACTIONS(8300),
    [anon_sym_import] = ACTIONS(8300),
    [anon_sym_namespace] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_await] = ACTIONS(8300),
    [anon_sym_DQUOTE] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(6909),
    [anon_sym_for] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [sym_false] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_case] = ACTIONS(8300),
    [anon_sym_module] = ACTIONS(8300),
    [anon_sym_number] = ACTIONS(8300),
    [anon_sym_class] = ACTIONS(8300),
    [anon_sym_declare] = ACTIONS(8300),
    [anon_sym_typeof] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_switch] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [sym_null] = ACTIONS(8300),
    [anon_sym_any] = ACTIONS(8300),
    [anon_sym_boolean] = ACTIONS(8300),
    [anon_sym_async] = ACTIONS(8300),
    [anon_sym_public] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(9834),
    [anon_sym_var] = ACTIONS(8300),
    [anon_sym_while] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(6909),
    [anon_sym_try] = ACTIONS(8300),
    [anon_sym_LT] = ACTIONS(6909),
    [sym_number] = ACTIONS(6909),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8300),
    [anon_sym_function] = ACTIONS(8300),
    [sym_undefined] = ACTIONS(8300),
    [anon_sym_new] = ACTIONS(8300),
    [anon_sym_let] = ACTIONS(8300),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_export] = ACTIONS(8300),
    [anon_sym_do] = ACTIONS(8300),
    [anon_sym_TILDE] = ACTIONS(6909),
    [anon_sym_with] = ACTIONS(8300),
  },
  [5210] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5225),
    [sym_constructor_type] = STATE(5225),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5050),
    [sym_function_type] = STATE(5225),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5225),
    [sym_intersection_type] = STATE(5225),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5049),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5051),
    [sym_identifier] = ACTIONS(9715),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9719),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9721),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5211] = {
    [sym_identifier] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_debugger] = ACTIONS(8302),
    [anon_sym_symbol] = ACTIONS(8302),
    [anon_sym_AT] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9832),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_void] = ACTIONS(8302),
    [anon_sym_break] = ACTIONS(8302),
    [anon_sym_const] = ACTIONS(8302),
    [sym_super] = ACTIONS(8302),
    [anon_sym_return] = ACTIONS(8302),
    [anon_sym_private] = ACTIONS(8302),
    [anon_sym_get] = ACTIONS(8302),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_default] = ACTIONS(8302),
    [anon_sym_interface] = ACTIONS(8302),
    [anon_sym_enum] = ACTIONS(8302),
    [anon_sym_delete] = ACTIONS(8302),
    [anon_sym_continue] = ACTIONS(8302),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_if] = ACTIONS(8302),
    [anon_sym_this] = ACTIONS(8302),
    [anon_sym_yield] = ACTIONS(8302),
    [sym_true] = ACTIONS(8302),
    [anon_sym_throw] = ACTIONS(8302),
    [anon_sym_protected] = ACTIONS(8302),
    [anon_sym_abstract] = ACTIONS(8302),
    [anon_sym_set] = ACTIONS(8302),
    [anon_sym_type] = ACTIONS(8302),
    [anon_sym_import] = ACTIONS(8302),
    [anon_sym_namespace] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_await] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(6986),
    [anon_sym_BANG] = ACTIONS(6986),
    [anon_sym_for] = ACTIONS(8302),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [sym_false] = ACTIONS(8302),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_case] = ACTIONS(8302),
    [anon_sym_module] = ACTIONS(8302),
    [anon_sym_number] = ACTIONS(8302),
    [anon_sym_class] = ACTIONS(8302),
    [anon_sym_declare] = ACTIONS(8302),
    [anon_sym_typeof] = ACTIONS(8302),
    [anon_sym_LBRACE] = ACTIONS(6986),
    [anon_sym_switch] = ACTIONS(8302),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [sym_null] = ACTIONS(8302),
    [anon_sym_any] = ACTIONS(8302),
    [anon_sym_boolean] = ACTIONS(8302),
    [anon_sym_async] = ACTIONS(8302),
    [anon_sym_public] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(9834),
    [anon_sym_var] = ACTIONS(8302),
    [anon_sym_while] = ACTIONS(8302),
    [anon_sym_SQUOTE] = ACTIONS(6986),
    [anon_sym_try] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(6986),
    [sym_number] = ACTIONS(6986),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8302),
    [anon_sym_function] = ACTIONS(8302),
    [sym_undefined] = ACTIONS(8302),
    [anon_sym_new] = ACTIONS(8302),
    [anon_sym_let] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_export] = ACTIONS(8302),
    [anon_sym_do] = ACTIONS(8302),
    [anon_sym_TILDE] = ACTIONS(6986),
    [anon_sym_with] = ACTIONS(8302),
  },
  [5212] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(9842),
    [anon_sym_PIPE] = ACTIONS(9844),
    [anon_sym_else] = ACTIONS(6909),
    [anon_sym_while] = ACTIONS(6909),
  },
  [5213] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5226),
    [sym_constructor_type] = STATE(5226),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(4813),
    [sym_function_type] = STATE(5226),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5226),
    [sym_intersection_type] = STATE(5226),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5068),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5069),
    [sym_identifier] = ACTIONS(9365),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9740),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5214] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(9842),
    [anon_sym_PIPE] = ACTIONS(9844),
    [anon_sym_else] = ACTIONS(6986),
    [anon_sym_while] = ACTIONS(6986),
  },
  [5215] = {
    [sym_type_alias_declaration] = STATE(4592),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4592),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4592),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4592),
    [sym_return_statement] = STATE(4592),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4592),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4592),
    [sym_switch_statement] = STATE(4592),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4592),
    [sym_throw_statement] = STATE(4592),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4592),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4592),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4592),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4592),
    [sym_abstract_class] = STATE(4592),
    [sym_interface_declaration] = STATE(4592),
    [sym_statement_block] = STATE(4592),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4592),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4592),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4592),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4592),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4592),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4592),
    [sym_empty_statement] = STATE(4592),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4592),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4592),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4592),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4592),
    [sym_break_statement] = STATE(4592),
    [sym_labeled_statement] = STATE(4592),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4592),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5216] = {
    [sym_type_alias_declaration] = STATE(4593),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4593),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4593),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4593),
    [sym_return_statement] = STATE(4593),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4593),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4593),
    [sym_switch_statement] = STATE(4593),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4593),
    [sym_throw_statement] = STATE(4593),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4593),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4593),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4593),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4593),
    [sym_abstract_class] = STATE(4593),
    [sym_interface_declaration] = STATE(4593),
    [sym_statement_block] = STATE(4593),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4593),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4593),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4593),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4593),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4593),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4593),
    [sym_empty_statement] = STATE(4593),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4593),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4593),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4593),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4593),
    [sym_break_statement] = STATE(4593),
    [sym_labeled_statement] = STATE(4593),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4593),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5217] = {
    [sym_type_alias_declaration] = STATE(4594),
    [sym_new_expression] = STATE(58),
    [sym__declaration] = STATE(4594),
    [sym_augmented_assignment_expression] = STATE(58),
    [sym_unary_expression] = STATE(58),
    [sym_if_statement] = STATE(4594),
    [sym_regex] = STATE(58),
    [sym_call_signature] = STATE(51),
    [sym_do_statement] = STATE(4594),
    [sym_return_statement] = STATE(4594),
    [sym_yield_expression] = STATE(58),
    [sym_as_expression] = STATE(58),
    [sym_internal_module] = STATE(52),
    [sym_arrow_function] = STATE(58),
    [sym_import_statement] = STATE(4594),
    [sym_member_expression] = STATE(53),
    [sym_expression_statement] = STATE(4594),
    [sym_switch_statement] = STATE(4594),
    [sym_string] = STATE(58),
    [sym_type_parameters] = STATE(54),
    [sym_try_statement] = STATE(4594),
    [sym_throw_statement] = STATE(4594),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4594),
    [sym_generator_function] = STATE(52),
    [sym_subscript_expression] = STATE(53),
    [sym_ternary_expression] = STATE(58),
    [sym_template_string] = STATE(58),
    [sym_for_of_statement] = STATE(4594),
    [sym_decorator] = STATE(4400),
    [sym_continue_statement] = STATE(4594),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4594),
    [sym_abstract_class] = STATE(4594),
    [sym_interface_declaration] = STATE(4594),
    [sym_statement_block] = STATE(4594),
    [sym_update_expression] = STATE(58),
    [sym_while_statement] = STATE(4594),
    [sym_meta_property] = STATE(58),
    [sym_debugger_statement] = STATE(4594),
    [sym__expression] = STATE(58),
    [sym_non_null_expression] = STATE(58),
    [sym_enum_declaration] = STATE(4594),
    [sym_function] = STATE(59),
    [sym_await_expression] = STATE(58),
    [sym_variable_declaration] = STATE(4594),
    [sym_sequence_expression] = STATE(61),
    [sym_for_statement] = STATE(4594),
    [sym_this] = STATE(58),
    [sym_with_statement] = STATE(4594),
    [sym_empty_statement] = STATE(4594),
    [aux_sym_export_statement_repeat1] = STATE(4400),
    [sym_import_alias] = STATE(4594),
    [sym_anonymous_class] = STATE(58),
    [sym_export_statement] = STATE(4594),
    [sym_call_expression] = STATE(58),
    [sym_assignment_expression] = STATE(58),
    [sym_lexical_declaration] = STATE(4594),
    [sym_binary_expression] = STATE(58),
    [sym_type_arguments] = STATE(63),
    [sym_for_in_statement] = STATE(4594),
    [sym_break_statement] = STATE(4594),
    [sym_labeled_statement] = STATE(4594),
    [sym_parenthesized_expression] = STATE(58),
    [sym_array] = STATE(64),
    [sym_type_assertion] = STATE(58),
    [sym_module] = STATE(4594),
    [sym_class] = STATE(52),
    [sym_identifier] = ACTIONS(8714),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8716),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8718),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8720),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8722),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8724),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8726),
  },
  [5218] = {
    [sym_identifier] = ACTIONS(7182),
    [anon_sym_BQUOTE] = ACTIONS(5196),
    [anon_sym_debugger] = ACTIONS(7182),
    [anon_sym_symbol] = ACTIONS(7182),
    [anon_sym_AT] = ACTIONS(5196),
    [anon_sym_PIPE] = ACTIONS(9948),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_void] = ACTIONS(7182),
    [anon_sym_break] = ACTIONS(7182),
    [anon_sym_const] = ACTIONS(7182),
    [sym_super] = ACTIONS(7182),
    [anon_sym_return] = ACTIONS(7182),
    [anon_sym_private] = ACTIONS(7182),
    [anon_sym_get] = ACTIONS(7182),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_default] = ACTIONS(7182),
    [anon_sym_interface] = ACTIONS(7182),
    [anon_sym_enum] = ACTIONS(7182),
    [anon_sym_delete] = ACTIONS(7182),
    [anon_sym_continue] = ACTIONS(7182),
    [anon_sym_DASH_DASH] = ACTIONS(5196),
    [anon_sym_if] = ACTIONS(7182),
    [anon_sym_this] = ACTIONS(7182),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_true] = ACTIONS(7182),
    [anon_sym_throw] = ACTIONS(7182),
    [anon_sym_protected] = ACTIONS(7182),
    [anon_sym_abstract] = ACTIONS(7182),
    [anon_sym_set] = ACTIONS(7182),
    [anon_sym_type] = ACTIONS(7182),
    [anon_sym_import] = ACTIONS(7182),
    [anon_sym_namespace] = ACTIONS(7182),
    [anon_sym_PLUS_PLUS] = ACTIONS(5196),
    [anon_sym_await] = ACTIONS(7182),
    [anon_sym_DQUOTE] = ACTIONS(5196),
    [anon_sym_else] = ACTIONS(7182),
    [anon_sym_BANG] = ACTIONS(5196),
    [anon_sym_for] = ACTIONS(7182),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [sym_false] = ACTIONS(7182),
    [anon_sym_SEMI] = ACTIONS(5196),
    [anon_sym_case] = ACTIONS(7182),
    [anon_sym_module] = ACTIONS(7182),
    [anon_sym_number] = ACTIONS(7182),
    [anon_sym_class] = ACTIONS(7182),
    [anon_sym_declare] = ACTIONS(7182),
    [anon_sym_typeof] = ACTIONS(7182),
    [anon_sym_LBRACE] = ACTIONS(5196),
    [anon_sym_switch] = ACTIONS(7182),
    [anon_sym_LPAREN] = ACTIONS(5196),
    [sym_null] = ACTIONS(7182),
    [anon_sym_any] = ACTIONS(7182),
    [anon_sym_boolean] = ACTIONS(7182),
    [anon_sym_async] = ACTIONS(7182),
    [anon_sym_public] = ACTIONS(7182),
    [anon_sym_AMP] = ACTIONS(9950),
    [anon_sym_var] = ACTIONS(7182),
    [anon_sym_while] = ACTIONS(7182),
    [anon_sym_SQUOTE] = ACTIONS(5196),
    [anon_sym_try] = ACTIONS(7182),
    [anon_sym_LT] = ACTIONS(5196),
    [sym_number] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(7182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7182),
    [anon_sym_function] = ACTIONS(7182),
    [sym_undefined] = ACTIONS(7182),
    [anon_sym_new] = ACTIONS(7182),
    [anon_sym_let] = ACTIONS(7182),
    [anon_sym_PLUS] = ACTIONS(7182),
    [anon_sym_export] = ACTIONS(7182),
    [anon_sym_do] = ACTIONS(7182),
    [anon_sym_TILDE] = ACTIONS(5196),
    [anon_sym_with] = ACTIONS(7182),
  },
  [5219] = {
    [sym_identifier] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5204),
    [anon_sym_debugger] = ACTIONS(7197),
    [anon_sym_symbol] = ACTIONS(7197),
    [anon_sym_AT] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(9948),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_void] = ACTIONS(7197),
    [anon_sym_break] = ACTIONS(7197),
    [anon_sym_const] = ACTIONS(7197),
    [sym_super] = ACTIONS(7197),
    [anon_sym_return] = ACTIONS(7197),
    [anon_sym_private] = ACTIONS(7197),
    [anon_sym_get] = ACTIONS(7197),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [anon_sym_default] = ACTIONS(7197),
    [anon_sym_interface] = ACTIONS(7197),
    [anon_sym_enum] = ACTIONS(7197),
    [anon_sym_delete] = ACTIONS(7197),
    [anon_sym_continue] = ACTIONS(7197),
    [anon_sym_DASH_DASH] = ACTIONS(5204),
    [anon_sym_if] = ACTIONS(7197),
    [anon_sym_this] = ACTIONS(7197),
    [anon_sym_yield] = ACTIONS(7197),
    [sym_true] = ACTIONS(7197),
    [anon_sym_throw] = ACTIONS(7197),
    [anon_sym_protected] = ACTIONS(7197),
    [anon_sym_abstract] = ACTIONS(7197),
    [anon_sym_set] = ACTIONS(7197),
    [anon_sym_type] = ACTIONS(7197),
    [anon_sym_import] = ACTIONS(7197),
    [anon_sym_namespace] = ACTIONS(7197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5204),
    [anon_sym_await] = ACTIONS(7197),
    [anon_sym_DQUOTE] = ACTIONS(5204),
    [anon_sym_else] = ACTIONS(7197),
    [anon_sym_BANG] = ACTIONS(5204),
    [anon_sym_for] = ACTIONS(7197),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [sym_false] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_case] = ACTIONS(7197),
    [anon_sym_module] = ACTIONS(7197),
    [anon_sym_number] = ACTIONS(7197),
    [anon_sym_class] = ACTIONS(7197),
    [anon_sym_declare] = ACTIONS(7197),
    [anon_sym_typeof] = ACTIONS(7197),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_switch] = ACTIONS(7197),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [sym_null] = ACTIONS(7197),
    [anon_sym_any] = ACTIONS(7197),
    [anon_sym_boolean] = ACTIONS(7197),
    [anon_sym_async] = ACTIONS(7197),
    [anon_sym_public] = ACTIONS(7197),
    [anon_sym_AMP] = ACTIONS(9950),
    [anon_sym_var] = ACTIONS(7197),
    [anon_sym_while] = ACTIONS(7197),
    [anon_sym_SQUOTE] = ACTIONS(5204),
    [anon_sym_try] = ACTIONS(7197),
    [anon_sym_LT] = ACTIONS(5204),
    [sym_number] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(7197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7197),
    [anon_sym_function] = ACTIONS(7197),
    [sym_undefined] = ACTIONS(7197),
    [anon_sym_new] = ACTIONS(7197),
    [anon_sym_let] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_export] = ACTIONS(7197),
    [anon_sym_do] = ACTIONS(7197),
    [anon_sym_TILDE] = ACTIONS(5204),
    [anon_sym_with] = ACTIONS(7197),
  },
  [5220] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5227),
    [sym_constructor_type] = STATE(5227),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(5227),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5227),
    [sym_intersection_type] = STATE(5227),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5221] = {
    [anon_sym_EQ_GT] = ACTIONS(9970),
    [sym_comment] = ACTIONS(3),
  },
  [5222] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5229),
    [sym_constructor_type] = STATE(5229),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(5229),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5229),
    [sym_intersection_type] = STATE(5229),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5223] = {
    [sym_identifier] = ACTIONS(7207),
    [anon_sym_BQUOTE] = ACTIONS(5406),
    [anon_sym_debugger] = ACTIONS(7207),
    [anon_sym_symbol] = ACTIONS(7207),
    [anon_sym_AT] = ACTIONS(5406),
    [anon_sym_PIPE] = ACTIONS(9948),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_void] = ACTIONS(7207),
    [anon_sym_break] = ACTIONS(7207),
    [anon_sym_const] = ACTIONS(7207),
    [sym_super] = ACTIONS(7207),
    [anon_sym_return] = ACTIONS(7207),
    [anon_sym_private] = ACTIONS(7207),
    [anon_sym_get] = ACTIONS(7207),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_default] = ACTIONS(7207),
    [anon_sym_interface] = ACTIONS(7207),
    [anon_sym_enum] = ACTIONS(7207),
    [anon_sym_delete] = ACTIONS(7207),
    [anon_sym_continue] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(5406),
    [anon_sym_if] = ACTIONS(7207),
    [anon_sym_this] = ACTIONS(7207),
    [anon_sym_yield] = ACTIONS(7207),
    [sym_true] = ACTIONS(7207),
    [anon_sym_throw] = ACTIONS(7207),
    [anon_sym_protected] = ACTIONS(7207),
    [anon_sym_abstract] = ACTIONS(7207),
    [anon_sym_set] = ACTIONS(7207),
    [anon_sym_type] = ACTIONS(7207),
    [anon_sym_import] = ACTIONS(7207),
    [anon_sym_namespace] = ACTIONS(7207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5406),
    [anon_sym_await] = ACTIONS(7207),
    [anon_sym_DQUOTE] = ACTIONS(5406),
    [anon_sym_else] = ACTIONS(7207),
    [anon_sym_BANG] = ACTIONS(5406),
    [anon_sym_for] = ACTIONS(7207),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [sym_false] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_case] = ACTIONS(7207),
    [anon_sym_module] = ACTIONS(7207),
    [anon_sym_number] = ACTIONS(7207),
    [anon_sym_class] = ACTIONS(7207),
    [anon_sym_declare] = ACTIONS(7207),
    [anon_sym_typeof] = ACTIONS(7207),
    [anon_sym_LBRACE] = ACTIONS(5406),
    [anon_sym_switch] = ACTIONS(7207),
    [anon_sym_LPAREN] = ACTIONS(5406),
    [sym_null] = ACTIONS(7207),
    [anon_sym_any] = ACTIONS(7207),
    [anon_sym_boolean] = ACTIONS(7207),
    [anon_sym_async] = ACTIONS(7207),
    [anon_sym_public] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(9950),
    [anon_sym_var] = ACTIONS(7207),
    [anon_sym_while] = ACTIONS(7207),
    [anon_sym_SQUOTE] = ACTIONS(5406),
    [anon_sym_try] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(5406),
    [sym_number] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(7207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7207),
    [anon_sym_function] = ACTIONS(7207),
    [sym_undefined] = ACTIONS(7207),
    [anon_sym_new] = ACTIONS(7207),
    [anon_sym_let] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_export] = ACTIONS(7207),
    [anon_sym_do] = ACTIONS(7207),
    [anon_sym_TILDE] = ACTIONS(5406),
    [anon_sym_with] = ACTIONS(7207),
  },
  [5224] = {
    [sym_identifier] = ACTIONS(7211),
    [anon_sym_BQUOTE] = ACTIONS(5425),
    [anon_sym_debugger] = ACTIONS(7211),
    [anon_sym_symbol] = ACTIONS(7211),
    [anon_sym_AT] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(9948),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_void] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(7211),
    [anon_sym_const] = ACTIONS(7211),
    [sym_super] = ACTIONS(7211),
    [anon_sym_return] = ACTIONS(7211),
    [anon_sym_private] = ACTIONS(7211),
    [anon_sym_get] = ACTIONS(7211),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_default] = ACTIONS(7211),
    [anon_sym_interface] = ACTIONS(7211),
    [anon_sym_enum] = ACTIONS(7211),
    [anon_sym_delete] = ACTIONS(7211),
    [anon_sym_continue] = ACTIONS(7211),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_if] = ACTIONS(7211),
    [anon_sym_this] = ACTIONS(7211),
    [anon_sym_yield] = ACTIONS(7211),
    [sym_true] = ACTIONS(7211),
    [anon_sym_throw] = ACTIONS(7211),
    [anon_sym_protected] = ACTIONS(7211),
    [anon_sym_abstract] = ACTIONS(7211),
    [anon_sym_set] = ACTIONS(7211),
    [anon_sym_type] = ACTIONS(7211),
    [anon_sym_import] = ACTIONS(7211),
    [anon_sym_namespace] = ACTIONS(7211),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_await] = ACTIONS(7211),
    [anon_sym_DQUOTE] = ACTIONS(5425),
    [anon_sym_else] = ACTIONS(7211),
    [anon_sym_BANG] = ACTIONS(5425),
    [anon_sym_for] = ACTIONS(7211),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [sym_false] = ACTIONS(7211),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_case] = ACTIONS(7211),
    [anon_sym_module] = ACTIONS(7211),
    [anon_sym_number] = ACTIONS(7211),
    [anon_sym_class] = ACTIONS(7211),
    [anon_sym_declare] = ACTIONS(7211),
    [anon_sym_typeof] = ACTIONS(7211),
    [anon_sym_LBRACE] = ACTIONS(5425),
    [anon_sym_switch] = ACTIONS(7211),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [sym_null] = ACTIONS(7211),
    [anon_sym_any] = ACTIONS(7211),
    [anon_sym_boolean] = ACTIONS(7211),
    [anon_sym_async] = ACTIONS(7211),
    [anon_sym_public] = ACTIONS(7211),
    [anon_sym_AMP] = ACTIONS(9950),
    [anon_sym_var] = ACTIONS(7211),
    [anon_sym_while] = ACTIONS(7211),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_try] = ACTIONS(7211),
    [anon_sym_LT] = ACTIONS(5425),
    [sym_number] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(7211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7211),
    [anon_sym_function] = ACTIONS(7211),
    [sym_undefined] = ACTIONS(7211),
    [anon_sym_new] = ACTIONS(7211),
    [anon_sym_let] = ACTIONS(7211),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_export] = ACTIONS(7211),
    [anon_sym_do] = ACTIONS(7211),
    [anon_sym_TILDE] = ACTIONS(5425),
    [anon_sym_with] = ACTIONS(7211),
  },
  [5225] = {
    [sym_identifier] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_debugger] = ACTIONS(8987),
    [anon_sym_symbol] = ACTIONS(8987),
    [anon_sym_AT] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9832),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_void] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8987),
    [anon_sym_const] = ACTIONS(8987),
    [sym_super] = ACTIONS(8987),
    [anon_sym_return] = ACTIONS(8987),
    [anon_sym_private] = ACTIONS(8987),
    [anon_sym_get] = ACTIONS(8987),
    [anon_sym_RBRACE] = ACTIONS(8086),
    [anon_sym_default] = ACTIONS(8987),
    [anon_sym_interface] = ACTIONS(8987),
    [anon_sym_enum] = ACTIONS(8987),
    [anon_sym_delete] = ACTIONS(8987),
    [anon_sym_continue] = ACTIONS(8987),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_if] = ACTIONS(8987),
    [anon_sym_this] = ACTIONS(8987),
    [anon_sym_yield] = ACTIONS(8987),
    [sym_true] = ACTIONS(8987),
    [anon_sym_throw] = ACTIONS(8987),
    [anon_sym_protected] = ACTIONS(8987),
    [anon_sym_abstract] = ACTIONS(8987),
    [anon_sym_set] = ACTIONS(8987),
    [anon_sym_type] = ACTIONS(8987),
    [anon_sym_import] = ACTIONS(8987),
    [anon_sym_namespace] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_await] = ACTIONS(8987),
    [anon_sym_DQUOTE] = ACTIONS(8086),
    [anon_sym_BANG] = ACTIONS(8086),
    [anon_sym_for] = ACTIONS(8987),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [sym_false] = ACTIONS(8987),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_case] = ACTIONS(8987),
    [anon_sym_module] = ACTIONS(8987),
    [anon_sym_number] = ACTIONS(8987),
    [anon_sym_class] = ACTIONS(8987),
    [anon_sym_declare] = ACTIONS(8987),
    [anon_sym_typeof] = ACTIONS(8987),
    [anon_sym_LBRACE] = ACTIONS(8086),
    [anon_sym_switch] = ACTIONS(8987),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [sym_null] = ACTIONS(8987),
    [anon_sym_any] = ACTIONS(8987),
    [anon_sym_boolean] = ACTIONS(8987),
    [anon_sym_async] = ACTIONS(8987),
    [anon_sym_public] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(9834),
    [anon_sym_var] = ACTIONS(8987),
    [anon_sym_while] = ACTIONS(8987),
    [anon_sym_SQUOTE] = ACTIONS(8086),
    [anon_sym_try] = ACTIONS(8987),
    [anon_sym_LT] = ACTIONS(8086),
    [sym_number] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8987),
    [anon_sym_function] = ACTIONS(8987),
    [sym_undefined] = ACTIONS(8987),
    [anon_sym_new] = ACTIONS(8987),
    [anon_sym_let] = ACTIONS(8987),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_export] = ACTIONS(8987),
    [anon_sym_do] = ACTIONS(8987),
    [anon_sym_TILDE] = ACTIONS(8086),
    [anon_sym_with] = ACTIONS(8987),
  },
  [5226] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [anon_sym_AMP] = ACTIONS(9842),
    [anon_sym_PIPE] = ACTIONS(9844),
    [anon_sym_else] = ACTIONS(8086),
    [anon_sym_while] = ACTIONS(8086),
  },
  [5227] = {
    [sym_identifier] = ACTIONS(8300),
    [anon_sym_BQUOTE] = ACTIONS(6909),
    [anon_sym_debugger] = ACTIONS(8300),
    [anon_sym_symbol] = ACTIONS(8300),
    [anon_sym_AT] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(9948),
    [anon_sym_DASH] = ACTIONS(8300),
    [anon_sym_void] = ACTIONS(8300),
    [anon_sym_break] = ACTIONS(8300),
    [anon_sym_const] = ACTIONS(8300),
    [sym_super] = ACTIONS(8300),
    [anon_sym_return] = ACTIONS(8300),
    [anon_sym_private] = ACTIONS(8300),
    [anon_sym_get] = ACTIONS(8300),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_default] = ACTIONS(8300),
    [anon_sym_interface] = ACTIONS(8300),
    [anon_sym_enum] = ACTIONS(8300),
    [anon_sym_delete] = ACTIONS(8300),
    [anon_sym_continue] = ACTIONS(8300),
    [anon_sym_DASH_DASH] = ACTIONS(6909),
    [anon_sym_if] = ACTIONS(8300),
    [anon_sym_this] = ACTIONS(8300),
    [anon_sym_yield] = ACTIONS(8300),
    [sym_true] = ACTIONS(8300),
    [anon_sym_throw] = ACTIONS(8300),
    [anon_sym_protected] = ACTIONS(8300),
    [anon_sym_abstract] = ACTIONS(8300),
    [anon_sym_set] = ACTIONS(8300),
    [anon_sym_type] = ACTIONS(8300),
    [anon_sym_import] = ACTIONS(8300),
    [anon_sym_namespace] = ACTIONS(8300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6909),
    [anon_sym_await] = ACTIONS(8300),
    [anon_sym_DQUOTE] = ACTIONS(6909),
    [anon_sym_else] = ACTIONS(8300),
    [anon_sym_BANG] = ACTIONS(6909),
    [anon_sym_for] = ACTIONS(8300),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [sym_false] = ACTIONS(8300),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_case] = ACTIONS(8300),
    [anon_sym_module] = ACTIONS(8300),
    [anon_sym_number] = ACTIONS(8300),
    [anon_sym_class] = ACTIONS(8300),
    [anon_sym_declare] = ACTIONS(8300),
    [anon_sym_typeof] = ACTIONS(8300),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_switch] = ACTIONS(8300),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [sym_null] = ACTIONS(8300),
    [anon_sym_any] = ACTIONS(8300),
    [anon_sym_boolean] = ACTIONS(8300),
    [anon_sym_async] = ACTIONS(8300),
    [anon_sym_public] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(9950),
    [anon_sym_var] = ACTIONS(8300),
    [anon_sym_while] = ACTIONS(8300),
    [anon_sym_SQUOTE] = ACTIONS(6909),
    [anon_sym_try] = ACTIONS(8300),
    [anon_sym_LT] = ACTIONS(6909),
    [sym_number] = ACTIONS(6909),
    [anon_sym_SLASH] = ACTIONS(8300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8300),
    [anon_sym_function] = ACTIONS(8300),
    [sym_undefined] = ACTIONS(8300),
    [anon_sym_new] = ACTIONS(8300),
    [anon_sym_let] = ACTIONS(8300),
    [anon_sym_PLUS] = ACTIONS(8300),
    [anon_sym_export] = ACTIONS(8300),
    [anon_sym_do] = ACTIONS(8300),
    [anon_sym_TILDE] = ACTIONS(6909),
    [anon_sym_with] = ACTIONS(8300),
  },
  [5228] = {
    [sym_tuple_type] = STATE(284),
    [sym__type] = STATE(5230),
    [sym_constructor_type] = STATE(5230),
    [sym_index_type_query] = STATE(284),
    [sym_lookup_type] = STATE(284),
    [sym_this_type] = STATE(284),
    [sym_flow_maybe_type] = STATE(284),
    [sym_array_type] = STATE(284),
    [sym_nested_type_identifier] = STATE(5172),
    [sym_function_type] = STATE(5230),
    [sym_type_predicate] = STATE(284),
    [sym_type_query] = STATE(284),
    [sym__number] = STATE(265),
    [sym_existential_type] = STATE(284),
    [sym_nested_identifier] = STATE(283),
    [sym_object_type] = STATE(284),
    [sym_union_type] = STATE(5230),
    [sym_intersection_type] = STATE(5230),
    [sym__primary_type] = STATE(284),
    [sym_generic_type] = STATE(284),
    [sym_mapped_type] = STATE(284),
    [sym_literal_type] = STATE(284),
    [sym_parenthesized_type] = STATE(284),
    [sym_predefined_type] = STATE(284),
    [sym_type_parameters] = STATE(5171),
    [sym_string] = STATE(265),
    [sym_formal_parameters] = STATE(5173),
    [sym_identifier] = ACTIONS(9896),
    [sym_false] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_LBRACE_PIPE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_number] = ACTIONS(472),
    [anon_sym_symbol] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_keyof] = ACTIONS(482),
    [sym_number] = ACTIONS(484),
    [sym_true] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(9902),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(9904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_boolean] = ACTIONS(472),
  },
  [5229] = {
    [sym_identifier] = ACTIONS(8302),
    [anon_sym_BQUOTE] = ACTIONS(6986),
    [anon_sym_debugger] = ACTIONS(8302),
    [anon_sym_symbol] = ACTIONS(8302),
    [anon_sym_AT] = ACTIONS(6986),
    [anon_sym_PIPE] = ACTIONS(9948),
    [anon_sym_DASH] = ACTIONS(8302),
    [anon_sym_void] = ACTIONS(8302),
    [anon_sym_break] = ACTIONS(8302),
    [anon_sym_const] = ACTIONS(8302),
    [sym_super] = ACTIONS(8302),
    [anon_sym_return] = ACTIONS(8302),
    [anon_sym_private] = ACTIONS(8302),
    [anon_sym_get] = ACTIONS(8302),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_default] = ACTIONS(8302),
    [anon_sym_interface] = ACTIONS(8302),
    [anon_sym_enum] = ACTIONS(8302),
    [anon_sym_delete] = ACTIONS(8302),
    [anon_sym_continue] = ACTIONS(8302),
    [anon_sym_DASH_DASH] = ACTIONS(6986),
    [anon_sym_if] = ACTIONS(8302),
    [anon_sym_this] = ACTIONS(8302),
    [anon_sym_yield] = ACTIONS(8302),
    [sym_true] = ACTIONS(8302),
    [anon_sym_throw] = ACTIONS(8302),
    [anon_sym_protected] = ACTIONS(8302),
    [anon_sym_abstract] = ACTIONS(8302),
    [anon_sym_set] = ACTIONS(8302),
    [anon_sym_type] = ACTIONS(8302),
    [anon_sym_import] = ACTIONS(8302),
    [anon_sym_namespace] = ACTIONS(8302),
    [anon_sym_PLUS_PLUS] = ACTIONS(6986),
    [anon_sym_await] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(6986),
    [anon_sym_else] = ACTIONS(8302),
    [anon_sym_BANG] = ACTIONS(6986),
    [anon_sym_for] = ACTIONS(8302),
    [anon_sym_LBRACK] = ACTIONS(6986),
    [sym_false] = ACTIONS(8302),
    [anon_sym_SEMI] = ACTIONS(6986),
    [anon_sym_case] = ACTIONS(8302),
    [anon_sym_module] = ACTIONS(8302),
    [anon_sym_number] = ACTIONS(8302),
    [anon_sym_class] = ACTIONS(8302),
    [anon_sym_declare] = ACTIONS(8302),
    [anon_sym_typeof] = ACTIONS(8302),
    [anon_sym_LBRACE] = ACTIONS(6986),
    [anon_sym_switch] = ACTIONS(8302),
    [anon_sym_LPAREN] = ACTIONS(6986),
    [sym_null] = ACTIONS(8302),
    [anon_sym_any] = ACTIONS(8302),
    [anon_sym_boolean] = ACTIONS(8302),
    [anon_sym_async] = ACTIONS(8302),
    [anon_sym_public] = ACTIONS(8302),
    [anon_sym_AMP] = ACTIONS(9950),
    [anon_sym_var] = ACTIONS(8302),
    [anon_sym_while] = ACTIONS(8302),
    [anon_sym_SQUOTE] = ACTIONS(6986),
    [anon_sym_try] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(6986),
    [sym_number] = ACTIONS(6986),
    [anon_sym_SLASH] = ACTIONS(8302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8302),
    [anon_sym_function] = ACTIONS(8302),
    [sym_undefined] = ACTIONS(8302),
    [anon_sym_new] = ACTIONS(8302),
    [anon_sym_let] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8302),
    [anon_sym_export] = ACTIONS(8302),
    [anon_sym_do] = ACTIONS(8302),
    [anon_sym_TILDE] = ACTIONS(6986),
    [anon_sym_with] = ACTIONS(8302),
  },
  [5230] = {
    [sym_identifier] = ACTIONS(8987),
    [anon_sym_BQUOTE] = ACTIONS(8086),
    [anon_sym_debugger] = ACTIONS(8987),
    [anon_sym_symbol] = ACTIONS(8987),
    [anon_sym_AT] = ACTIONS(8086),
    [anon_sym_PIPE] = ACTIONS(9948),
    [anon_sym_DASH] = ACTIONS(8987),
    [anon_sym_void] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8987),
    [anon_sym_const] = ACTIONS(8987),
    [sym_super] = ACTIONS(8987),
    [anon_sym_return] = ACTIONS(8987),
    [anon_sym_private] = ACTIONS(8987),
    [anon_sym_get] = ACTIONS(8987),
    [anon_sym_RBRACE] = ACTIONS(8086),
    [anon_sym_default] = ACTIONS(8987),
    [anon_sym_interface] = ACTIONS(8987),
    [anon_sym_enum] = ACTIONS(8987),
    [anon_sym_delete] = ACTIONS(8987),
    [anon_sym_continue] = ACTIONS(8987),
    [anon_sym_DASH_DASH] = ACTIONS(8086),
    [anon_sym_if] = ACTIONS(8987),
    [anon_sym_this] = ACTIONS(8987),
    [anon_sym_yield] = ACTIONS(8987),
    [sym_true] = ACTIONS(8987),
    [anon_sym_throw] = ACTIONS(8987),
    [anon_sym_protected] = ACTIONS(8987),
    [anon_sym_abstract] = ACTIONS(8987),
    [anon_sym_set] = ACTIONS(8987),
    [anon_sym_type] = ACTIONS(8987),
    [anon_sym_import] = ACTIONS(8987),
    [anon_sym_namespace] = ACTIONS(8987),
    [anon_sym_PLUS_PLUS] = ACTIONS(8086),
    [anon_sym_await] = ACTIONS(8987),
    [anon_sym_DQUOTE] = ACTIONS(8086),
    [anon_sym_else] = ACTIONS(8987),
    [anon_sym_BANG] = ACTIONS(8086),
    [anon_sym_for] = ACTIONS(8987),
    [anon_sym_LBRACK] = ACTIONS(8086),
    [sym_false] = ACTIONS(8987),
    [anon_sym_SEMI] = ACTIONS(8086),
    [anon_sym_case] = ACTIONS(8987),
    [anon_sym_module] = ACTIONS(8987),
    [anon_sym_number] = ACTIONS(8987),
    [anon_sym_class] = ACTIONS(8987),
    [anon_sym_declare] = ACTIONS(8987),
    [anon_sym_typeof] = ACTIONS(8987),
    [anon_sym_LBRACE] = ACTIONS(8086),
    [anon_sym_switch] = ACTIONS(8987),
    [anon_sym_LPAREN] = ACTIONS(8086),
    [sym_null] = ACTIONS(8987),
    [anon_sym_any] = ACTIONS(8987),
    [anon_sym_boolean] = ACTIONS(8987),
    [anon_sym_async] = ACTIONS(8987),
    [anon_sym_public] = ACTIONS(8987),
    [anon_sym_AMP] = ACTIONS(9950),
    [anon_sym_var] = ACTIONS(8987),
    [anon_sym_while] = ACTIONS(8987),
    [anon_sym_SQUOTE] = ACTIONS(8086),
    [anon_sym_try] = ACTIONS(8987),
    [anon_sym_LT] = ACTIONS(8086),
    [sym_number] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8987),
    [anon_sym_function] = ACTIONS(8987),
    [sym_undefined] = ACTIONS(8987),
    [anon_sym_new] = ACTIONS(8987),
    [anon_sym_let] = ACTIONS(8987),
    [anon_sym_PLUS] = ACTIONS(8987),
    [anon_sym_export] = ACTIONS(8987),
    [anon_sym_do] = ACTIONS(8987),
    [anon_sym_TILDE] = ACTIONS(8086),
    [anon_sym_with] = ACTIONS(8987),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = false}, SHIFT(4),
  [11] = {.count = 1, .reusable = false}, SHIFT(5),
  [13] = {.count = 1, .reusable = true}, SHIFT(6),
  [15] = {.count = 1, .reusable = false}, SHIFT(7),
  [17] = {.count = 1, .reusable = false}, SHIFT(8),
  [19] = {.count = 1, .reusable = false}, SHIFT(9),
  [21] = {.count = 1, .reusable = false}, SHIFT(10),
  [23] = {.count = 1, .reusable = false}, SHIFT(11),
  [25] = {.count = 1, .reusable = false}, SHIFT(12),
  [27] = {.count = 1, .reusable = false}, SHIFT(13),
  [29] = {.count = 1, .reusable = false}, SHIFT(14),
  [31] = {.count = 1, .reusable = false}, SHIFT(15),
  [33] = {.count = 1, .reusable = false}, SHIFT(16),
  [35] = {.count = 1, .reusable = true}, SHIFT(17),
  [37] = {.count = 1, .reusable = false}, SHIFT(18),
  [39] = {.count = 1, .reusable = false}, SHIFT(19),
  [41] = {.count = 1, .reusable = false}, SHIFT(20),
  [43] = {.count = 1, .reusable = false}, SHIFT(58),
  [45] = {.count = 1, .reusable = false}, SHIFT(21),
  [47] = {.count = 1, .reusable = false}, SHIFT(22),
  [49] = {.count = 1, .reusable = false}, SHIFT(23),
  [51] = {.count = 1, .reusable = false}, SHIFT(24),
  [53] = {.count = 1, .reusable = false}, SHIFT(25),
  [55] = {.count = 1, .reusable = false}, SHIFT(26),
  [57] = {.count = 1, .reusable = true}, SHIFT(27),
  [59] = {.count = 1, .reusable = true}, SHIFT(15),
  [61] = {.count = 1, .reusable = false}, SHIFT(28),
  [63] = {.count = 1, .reusable = true}, SHIFT(29),
  [65] = {.count = 1, .reusable = true}, SHIFT(30),
  [67] = {.count = 1, .reusable = false}, SHIFT(31),
  [69] = {.count = 1, .reusable = false}, SHIFT(32),
  [71] = {.count = 1, .reusable = false}, SHIFT(33),
  [73] = {.count = 1, .reusable = true}, SHIFT(34),
  [75] = {.count = 1, .reusable = false}, SHIFT(35),
  [77] = {.count = 1, .reusable = true}, SHIFT(36),
  [79] = {.count = 1, .reusable = false}, SHIFT(37),
  [81] = {.count = 1, .reusable = false}, SHIFT(38),
  [83] = {.count = 1, .reusable = true}, SHIFT(39),
  [85] = {.count = 1, .reusable = false}, SHIFT(40),
  [87] = {.count = 1, .reusable = true}, SHIFT(41),
  [89] = {.count = 1, .reusable = false}, SHIFT(42),
  [91] = {.count = 1, .reusable = true}, SHIFT(43),
  [93] = {.count = 1, .reusable = true}, SHIFT(58),
  [95] = {.count = 1, .reusable = false}, SHIFT(44),
  [97] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [99] = {.count = 1, .reusable = false}, SHIFT(45),
  [101] = {.count = 1, .reusable = false}, SHIFT(46),
  [103] = {.count = 1, .reusable = false}, SHIFT(47),
  [105] = {.count = 1, .reusable = false}, SHIFT(48),
  [107] = {.count = 1, .reusable = false}, SHIFT(49),
  [109] = {.count = 1, .reusable = false}, SHIFT(50),
  [111] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [113] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [115] = {.count = 1, .reusable = true}, SHIFT(67),
  [117] = {.count = 1, .reusable = false}, SHIFT(68),
  [119] = {.count = 1, .reusable = true}, SHIFT(65),
  [121] = {.count = 1, .reusable = true}, SHIFT(69),
  [123] = {.count = 1, .reusable = true}, SHIFT(70),
  [125] = {.count = 1, .reusable = false}, SHIFT(66),
  [127] = {.count = 1, .reusable = true}, SHIFT(72),
  [129] = {.count = 1, .reusable = true}, SHIFT(74),
  [131] = {.count = 1, .reusable = true}, SHIFT(73),
  [133] = {.count = 1, .reusable = true}, SHIFT(75),
  [135] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [137] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [139] = {.count = 1, .reusable = true}, SHIFT(77),
  [141] = {.count = 1, .reusable = true}, SHIFT(76),
  [143] = {.count = 1, .reusable = true}, SHIFT(78),
  [145] = {.count = 1, .reusable = false}, SHIFT(80),
  [147] = {.count = 1, .reusable = false}, SHIFT(81),
  [149] = {.count = 1, .reusable = false}, SHIFT(83),
  [151] = {.count = 1, .reusable = false}, SHIFT(87),
  [153] = {.count = 1, .reusable = true}, SHIFT(84),
  [155] = {.count = 1, .reusable = false}, SHIFT(85),
  [157] = {.count = 1, .reusable = true}, SHIFT(87),
  [159] = {.count = 1, .reusable = false}, SHIFT(86),
  [161] = {.count = 1, .reusable = false}, SHIFT(90),
  [163] = {.count = 1, .reusable = false}, SHIFT(78),
  [165] = {.count = 1, .reusable = false}, SHIFT(43),
  [167] = {.count = 1, .reusable = true}, SHIFT(90),
  [169] = {.count = 1, .reusable = true}, SHIFT(91),
  [171] = {.count = 1, .reusable = true}, SHIFT(92),
  [173] = {.count = 1, .reusable = false}, SHIFT(93),
  [175] = {.count = 1, .reusable = true}, SHIFT(94),
  [177] = {.count = 1, .reusable = false}, SHIFT(95),
  [179] = {.count = 1, .reusable = true}, SHIFT(96),
  [181] = {.count = 1, .reusable = true}, SHIFT(100),
  [183] = {.count = 1, .reusable = true}, SHIFT(102),
  [185] = {.count = 1, .reusable = false}, SHIFT(101),
  [187] = {.count = 1, .reusable = true}, SHIFT(105),
  [189] = {.count = 1, .reusable = false}, SHIFT(106),
  [191] = {.count = 1, .reusable = true}, SHIFT(106),
  [193] = {.count = 1, .reusable = true}, SHIFT(108),
  [195] = {.count = 1, .reusable = true}, SHIFT(109),
  [197] = {.count = 1, .reusable = true}, SHIFT(110),
  [199] = {.count = 1, .reusable = true}, SHIFT(111),
  [201] = {.count = 1, .reusable = false}, SHIFT(112),
  [203] = {.count = 1, .reusable = true}, SHIFT(112),
  [205] = {.count = 1, .reusable = true}, SHIFT(113),
  [207] = {.count = 1, .reusable = true}, REDUCE(sym_this, 1),
  [209] = {.count = 1, .reusable = false}, REDUCE(sym_this, 1),
  [211] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [213] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [215] = {.count = 1, .reusable = false}, SHIFT(115),
  [217] = {.count = 1, .reusable = true}, SHIFT(115),
  [219] = {.count = 1, .reusable = false}, SHIFT(116),
  [221] = {.count = 1, .reusable = true}, SHIFT(116),
  [223] = {.count = 1, .reusable = true}, SHIFT(118),
  [225] = {.count = 1, .reusable = false}, SHIFT(119),
  [227] = {.count = 1, .reusable = false}, SHIFT(120),
  [229] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(122),
  [232] = {.count = 1, .reusable = false}, SHIFT(121),
  [234] = {.count = 1, .reusable = true}, SHIFT(123),
  [236] = {.count = 1, .reusable = false}, SHIFT(127),
  [238] = {.count = 1, .reusable = false}, SHIFT(130),
  [240] = {.count = 1, .reusable = true}, SHIFT(130),
  [242] = {.count = 1, .reusable = true}, SHIFT(132),
  [244] = {.count = 1, .reusable = false}, SHIFT(131),
  [246] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [248] = {.count = 1, .reusable = true}, SHIFT(133),
  [250] = {.count = 1, .reusable = true}, SHIFT(134),
  [252] = {.count = 1, .reusable = true}, SHIFT(140),
  [254] = {.count = 1, .reusable = false}, SHIFT(136),
  [256] = {.count = 1, .reusable = false}, SHIFT(159),
  [258] = {.count = 1, .reusable = true}, SHIFT(137),
  [260] = {.count = 1, .reusable = false}, SHIFT(138),
  [262] = {.count = 1, .reusable = false}, SHIFT(139),
  [264] = {.count = 1, .reusable = false}, SHIFT(140),
  [266] = {.count = 1, .reusable = false}, SHIFT(141),
  [268] = {.count = 1, .reusable = true}, SHIFT(142),
  [270] = {.count = 1, .reusable = true}, SHIFT(143),
  [272] = {.count = 1, .reusable = false}, SHIFT(144),
  [274] = {.count = 1, .reusable = true}, SHIFT(145),
  [276] = {.count = 1, .reusable = true}, SHIFT(146),
  [278] = {.count = 1, .reusable = false}, SHIFT(147),
  [280] = {.count = 1, .reusable = false}, SHIFT(148),
  [282] = {.count = 1, .reusable = true}, SHIFT(149),
  [284] = {.count = 1, .reusable = true}, SHIFT(150),
  [286] = {.count = 1, .reusable = false}, SHIFT(151),
  [288] = {.count = 1, .reusable = true}, SHIFT(159),
  [290] = {.count = 1, .reusable = false}, SHIFT(152),
  [292] = {.count = 1, .reusable = false}, SHIFT(153),
  [294] = {.count = 1, .reusable = false}, SHIFT(154),
  [296] = {.count = 1, .reusable = false}, SHIFT(155),
  [298] = {.count = 1, .reusable = false}, SHIFT(156),
  [300] = {.count = 1, .reusable = false}, SHIFT(157),
  [302] = {.count = 1, .reusable = true}, SHIFT(135),
  [304] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [306] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [308] = {.count = 1, .reusable = false}, SHIFT(168),
  [310] = {.count = 1, .reusable = true}, SHIFT(169),
  [312] = {.count = 1, .reusable = true}, SHIFT(170),
  [314] = {.count = 1, .reusable = false}, SHIFT(173),
  [316] = {.count = 1, .reusable = false}, SHIFT(174),
  [318] = {.count = 1, .reusable = false}, SHIFT(175),
  [320] = {.count = 1, .reusable = true}, SHIFT(176),
  [322] = {.count = 1, .reusable = true}, SHIFT(184),
  [324] = {.count = 1, .reusable = true}, SHIFT(10),
  [326] = {.count = 1, .reusable = true}, SHIFT(13),
  [328] = {.count = 1, .reusable = true}, SHIFT(14),
  [330] = {.count = 1, .reusable = true}, SHIFT(22),
  [332] = {.count = 1, .reusable = true}, SHIFT(187),
  [334] = {.count = 1, .reusable = true}, SHIFT(188),
  [336] = {.count = 1, .reusable = true}, SHIFT(190),
  [338] = {.count = 1, .reusable = true}, SHIFT(181),
  [340] = {.count = 1, .reusable = true}, SHIFT(182),
  [342] = {.count = 1, .reusable = true}, SHIFT(183),
  [344] = {.count = 1, .reusable = true}, SHIFT(185),
  [346] = {.count = 1, .reusable = true}, SHIFT(38),
  [348] = {.count = 1, .reusable = true}, SHIFT(186),
  [350] = {.count = 1, .reusable = true}, SHIFT(47),
  [352] = {.count = 1, .reusable = true}, SHIFT(189),
  [354] = {.count = 1, .reusable = false}, SHIFT(193),
  [356] = {.count = 1, .reusable = false}, SHIFT(194),
  [358] = {.count = 1, .reusable = true}, SHIFT(195),
  [360] = {.count = 1, .reusable = true}, SHIFT(196),
  [362] = {.count = 1, .reusable = true}, SHIFT(197),
  [364] = {.count = 1, .reusable = false}, SHIFT(198),
  [366] = {.count = 1, .reusable = false}, SHIFT(199),
  [368] = {.count = 1, .reusable = false}, SHIFT(200),
  [370] = {.count = 1, .reusable = false}, SHIFT(201),
  [372] = {.count = 1, .reusable = true}, SHIFT(202),
  [374] = {.count = 1, .reusable = false}, SHIFT(203),
  [376] = {.count = 1, .reusable = false}, SHIFT(204),
  [378] = {.count = 1, .reusable = false}, SHIFT(205),
  [380] = {.count = 1, .reusable = false}, SHIFT(206),
  [382] = {.count = 1, .reusable = false}, SHIFT(207),
  [384] = {.count = 1, .reusable = false}, SHIFT(208),
  [386] = {.count = 1, .reusable = true}, SHIFT(209),
  [388] = {.count = 1, .reusable = false}, SHIFT(210),
  [390] = {.count = 1, .reusable = false}, SHIFT(211),
  [392] = {.count = 1, .reusable = true}, SHIFT(212),
  [394] = {.count = 1, .reusable = false}, SHIFT(213),
  [396] = {.count = 1, .reusable = false}, SHIFT(214),
  [398] = {.count = 1, .reusable = true}, SHIFT(215),
  [400] = {.count = 1, .reusable = false}, SHIFT(216),
  [402] = {.count = 1, .reusable = false}, SHIFT(217),
  [404] = {.count = 1, .reusable = true}, SHIFT(236),
  [406] = {.count = 1, .reusable = false}, SHIFT(227),
  [408] = {.count = 1, .reusable = false}, SHIFT(244),
  [410] = {.count = 1, .reusable = true}, SHIFT(230),
  [412] = {.count = 1, .reusable = false}, SHIFT(229),
  [414] = {.count = 1, .reusable = false}, SHIFT(230),
  [416] = {.count = 1, .reusable = false}, SHIFT(231),
  [418] = {.count = 1, .reusable = true}, SHIFT(232),
  [420] = {.count = 1, .reusable = false}, SHIFT(233),
  [422] = {.count = 1, .reusable = false}, SHIFT(234),
  [424] = {.count = 1, .reusable = false}, SHIFT(235),
  [426] = {.count = 1, .reusable = true}, SHIFT(237),
  [428] = {.count = 1, .reusable = true}, SHIFT(244),
  [430] = {.count = 1, .reusable = false}, SHIFT(238),
  [432] = {.count = 1, .reusable = false}, SHIFT(239),
  [434] = {.count = 1, .reusable = false}, SHIFT(228),
  [436] = {.count = 1, .reusable = false}, SHIFT(240),
  [438] = {.count = 1, .reusable = false}, SHIFT(241),
  [440] = {.count = 1, .reusable = false}, SHIFT(253),
  [442] = {.count = 1, .reusable = false}, SHIFT(254),
  [444] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(255),
  [447] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(256),
  [450] = {.count = 1, .reusable = false}, SHIFT(257),
  [452] = {.count = 1, .reusable = true}, SHIFT(93),
  [454] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [456] = {.count = 1, .reusable = true}, SHIFT(261),
  [458] = {.count = 1, .reusable = true}, SHIFT(262),
  [460] = {.count = 1, .reusable = false}, SHIFT(264),
  [462] = {.count = 1, .reusable = false}, SHIFT(265),
  [464] = {.count = 1, .reusable = true}, SHIFT(266),
  [466] = {.count = 1, .reusable = true}, SHIFT(267),
  [468] = {.count = 1, .reusable = true}, SHIFT(268),
  [470] = {.count = 1, .reusable = true}, SHIFT(269),
  [472] = {.count = 1, .reusable = false}, SHIFT(270),
  [474] = {.count = 1, .reusable = false}, SHIFT(271),
  [476] = {.count = 1, .reusable = false}, SHIFT(272),
  [478] = {.count = 1, .reusable = true}, SHIFT(273),
  [480] = {.count = 1, .reusable = true}, SHIFT(274),
  [482] = {.count = 1, .reusable = false}, SHIFT(275),
  [484] = {.count = 1, .reusable = true}, SHIFT(265),
  [486] = {.count = 1, .reusable = false}, SHIFT(267),
  [488] = {.count = 1, .reusable = false}, SHIFT(276),
  [490] = {.count = 1, .reusable = true}, SHIFT(277),
  [492] = {.count = 1, .reusable = true}, SHIFT(256),
  [494] = {.count = 1, .reusable = true}, SHIFT(278),
  [496] = {.count = 1, .reusable = false}, SHIFT(286),
  [498] = {.count = 1, .reusable = true}, SHIFT(287),
  [500] = {.count = 1, .reusable = true}, SHIFT(255),
  [502] = {.count = 1, .reusable = true}, SHIFT(288),
  [504] = {.count = 1, .reusable = true}, SHIFT(301),
  [506] = {.count = 1, .reusable = false}, SHIFT(292),
  [508] = {.count = 1, .reusable = false}, SHIFT(293),
  [510] = {.count = 1, .reusable = true}, SHIFT(296),
  [512] = {.count = 1, .reusable = false}, SHIFT(295),
  [514] = {.count = 1, .reusable = false}, SHIFT(296),
  [516] = {.count = 1, .reusable = false}, SHIFT(297),
  [518] = {.count = 1, .reusable = false}, SHIFT(298),
  [520] = {.count = 1, .reusable = false}, SHIFT(299),
  [522] = {.count = 1, .reusable = false}, SHIFT(300),
  [524] = {.count = 1, .reusable = true}, SHIFT(293),
  [526] = {.count = 1, .reusable = false}, SHIFT(302),
  [528] = {.count = 1, .reusable = false}, SHIFT(294),
  [530] = {.count = 1, .reusable = false}, SHIFT(303),
  [532] = {.count = 1, .reusable = false}, SHIFT(304),
  [534] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(312),
  [537] = {.count = 1, .reusable = false}, SHIFT(314),
  [539] = {.count = 1, .reusable = true}, SHIFT(315),
  [541] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(316),
  [544] = {.count = 1, .reusable = true}, SHIFT(311),
  [546] = {.count = 1, .reusable = true}, SHIFT(313),
  [548] = {.count = 1, .reusable = false}, SHIFT(319),
  [550] = {.count = 1, .reusable = false}, SHIFT(320),
  [552] = {.count = 1, .reusable = false}, SHIFT(321),
  [554] = {.count = 1, .reusable = false}, SHIFT(322),
  [556] = {.count = 1, .reusable = false}, SHIFT(323),
  [558] = {.count = 1, .reusable = false}, SHIFT(324),
  [560] = {.count = 1, .reusable = false}, SHIFT(325),
  [562] = {.count = 1, .reusable = false}, SHIFT(326),
  [564] = {.count = 1, .reusable = false}, SHIFT(327),
  [566] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [568] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [570] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 1),
  [572] = {.count = 1, .reusable = true}, SHIFT(336),
  [574] = {.count = 1, .reusable = true}, SHIFT(338),
  [576] = {.count = 1, .reusable = true}, SHIFT(66),
  [578] = {.count = 1, .reusable = false}, SHIFT(340),
  [580] = {.count = 1, .reusable = true}, SHIFT(344),
  [582] = {.count = 1, .reusable = true}, SHIFT(341),
  [584] = {.count = 1, .reusable = false}, SHIFT(342),
  [586] = {.count = 1, .reusable = true}, SHIFT(343),
  [588] = {.count = 1, .reusable = false}, SHIFT(341),
  [590] = {.count = 1, .reusable = false}, SHIFT(343),
  [592] = {.count = 1, .reusable = true}, SHIFT(345),
  [594] = {.count = 1, .reusable = true}, SHIFT(340),
  [596] = {.count = 1, .reusable = true}, SHIFT(346),
  [598] = {.count = 1, .reusable = true}, SHIFT(347),
  [600] = {.count = 1, .reusable = false}, SHIFT(348),
  [602] = {.count = 1, .reusable = true}, SHIFT(349),
  [604] = {.count = 1, .reusable = false}, SHIFT(339),
  [606] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [608] = {.count = 1, .reusable = true}, SHIFT(350),
  [610] = {.count = 1, .reusable = true}, SHIFT(351),
  [612] = {.count = 1, .reusable = false}, SHIFT(353),
  [614] = {.count = 1, .reusable = true}, SHIFT(353),
  [616] = {.count = 1, .reusable = false}, SHIFT(357),
  [618] = {.count = 1, .reusable = true}, SHIFT(355),
  [620] = {.count = 1, .reusable = true}, SHIFT(357),
  [622] = {.count = 1, .reusable = false}, SHIFT(358),
  [624] = {.count = 1, .reusable = true}, SHIFT(358),
  [626] = {.count = 1, .reusable = false}, SHIFT(359),
  [628] = {.count = 1, .reusable = true}, SHIFT(359),
  [630] = {.count = 1, .reusable = false}, SHIFT(360),
  [632] = {.count = 1, .reusable = true}, SHIFT(360),
  [634] = {.count = 1, .reusable = true}, SHIFT(362),
  [636] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2),
  [638] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2),
  [640] = {.count = 1, .reusable = true}, SHIFT(365),
  [642] = {.count = 1, .reusable = false}, SHIFT(363),
  [644] = {.count = 1, .reusable = false}, SHIFT(375),
  [646] = {.count = 1, .reusable = false}, SHIFT(364),
  [648] = {.count = 1, .reusable = false}, SHIFT(365),
  [650] = {.count = 1, .reusable = false}, SHIFT(366),
  [652] = {.count = 1, .reusable = false}, SHIFT(367),
  [654] = {.count = 1, .reusable = false}, SHIFT(368),
  [656] = {.count = 1, .reusable = true}, SHIFT(369),
  [658] = {.count = 1, .reusable = true}, SHIFT(375),
  [660] = {.count = 1, .reusable = false}, SHIFT(370),
  [662] = {.count = 1, .reusable = false}, SHIFT(371),
  [664] = {.count = 1, .reusable = false}, SHIFT(372),
  [666] = {.count = 1, .reusable = false}, SHIFT(373),
  [668] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [670] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [672] = {.count = 1, .reusable = true}, SHIFT(382),
  [674] = {.count = 1, .reusable = true}, SHIFT(381),
  [676] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [678] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [680] = {.count = 1, .reusable = false}, SHIFT(384),
  [682] = {.count = 1, .reusable = true}, SHIFT(384),
  [684] = {.count = 1, .reusable = false}, SHIFT(385),
  [686] = {.count = 1, .reusable = true}, SHIFT(385),
  [688] = {.count = 1, .reusable = true}, SHIFT(386),
  [690] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 1),
  [692] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 1),
  [694] = {.count = 1, .reusable = true}, REDUCE(sym__identifier_reference, 1, .alias_sequence_id = 1),
  [696] = {.count = 1, .reusable = false}, REDUCE(sym__identifier_reference, 1, .alias_sequence_id = 1),
  [698] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [700] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [702] = {.count = 1, .reusable = true}, SHIFT(388),
  [704] = {.count = 1, .reusable = false}, SHIFT(387),
  [706] = {.count = 1, .reusable = false}, SHIFT(390),
  [708] = {.count = 1, .reusable = true}, SHIFT(391),
  [710] = {.count = 1, .reusable = false}, SHIFT(392),
  [712] = {.count = 1, .reusable = false}, SHIFT(393),
  [714] = {.count = 1, .reusable = false}, SHIFT(394),
  [716] = {.count = 1, .reusable = false}, SHIFT(395),
  [718] = {.count = 1, .reusable = true}, SHIFT(396),
  [720] = {.count = 1, .reusable = true}, SHIFT(221),
  [722] = {.count = 1, .reusable = false}, SHIFT(400),
  [724] = {.count = 1, .reusable = true}, SHIFT(401),
  [726] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [728] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [730] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(348),
  [733] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [735] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [737] = {.count = 1, .reusable = true}, SHIFT(403),
  [739] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1),
  [741] = {.count = 1, .reusable = true}, SHIFT(68),
  [743] = {.count = 1, .reusable = true}, SHIFT(404),
  [745] = {.count = 1, .reusable = false}, SHIFT(408),
  [747] = {.count = 1, .reusable = true}, SHIFT(407),
  [749] = {.count = 1, .reusable = true}, SHIFT(408),
  [751] = {.count = 1, .reusable = true}, SHIFT(411),
  [753] = {.count = 1, .reusable = false}, SHIFT(412),
  [755] = {.count = 1, .reusable = false}, SHIFT(413),
  [757] = {.count = 1, .reusable = false}, SHIFT(414),
  [759] = {.count = 1, .reusable = false}, SHIFT(415),
  [761] = {.count = 1, .reusable = false}, SHIFT(416),
  [763] = {.count = 1, .reusable = true}, SHIFT(417),
  [765] = {.count = 1, .reusable = true}, SHIFT(422),
  [767] = {.count = 1, .reusable = true}, SHIFT(421),
  [769] = {.count = 1, .reusable = true}, SHIFT(424),
  [771] = {.count = 1, .reusable = false}, SHIFT(429),
  [773] = {.count = 1, .reusable = true}, SHIFT(429),
  [775] = {.count = 1, .reusable = false}, SHIFT(431),
  [777] = {.count = 1, .reusable = true}, SHIFT(434),
  [779] = {.count = 1, .reusable = false}, SHIFT(432),
  [781] = {.count = 1, .reusable = false}, SHIFT(447),
  [783] = {.count = 1, .reusable = false}, SHIFT(433),
  [785] = {.count = 1, .reusable = false}, SHIFT(434),
  [787] = {.count = 1, .reusable = false}, SHIFT(435),
  [789] = {.count = 1, .reusable = true}, SHIFT(436),
  [791] = {.count = 1, .reusable = true}, SHIFT(437),
  [793] = {.count = 1, .reusable = false}, SHIFT(438),
  [795] = {.count = 1, .reusable = false}, SHIFT(439),
  [797] = {.count = 1, .reusable = true}, SHIFT(440),
  [799] = {.count = 1, .reusable = true}, SHIFT(441),
  [801] = {.count = 1, .reusable = true}, SHIFT(447),
  [803] = {.count = 1, .reusable = false}, SHIFT(442),
  [805] = {.count = 1, .reusable = false}, SHIFT(443),
  [807] = {.count = 1, .reusable = false}, SHIFT(444),
  [809] = {.count = 1, .reusable = false}, SHIFT(445),
  [811] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2),
  [813] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2),
  [815] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [817] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [819] = {.count = 1, .reusable = true}, SHIFT(455),
  [821] = {.count = 1, .reusable = true}, SHIFT(456),
  [823] = {.count = 1, .reusable = true}, SHIFT(460),
  [825] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [827] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [829] = {.count = 1, .reusable = true}, SHIFT(462),
  [831] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2),
  [833] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2),
  [835] = {.count = 1, .reusable = false}, SHIFT(463),
  [837] = {.count = 1, .reusable = false}, SHIFT(468),
  [839] = {.count = 1, .reusable = false}, SHIFT(464),
  [841] = {.count = 1, .reusable = false}, SHIFT(465),
  [843] = {.count = 1, .reusable = false}, SHIFT(466),
  [845] = {.count = 1, .reusable = true}, SHIFT(468),
  [847] = {.count = 1, .reusable = false}, SHIFT(467),
  [849] = {.count = 1, .reusable = false}, SHIFT(472),
  [851] = {.count = 1, .reusable = false}, SHIFT(473),
  [853] = {.count = 1, .reusable = false}, SHIFT(474),
  [855] = {.count = 1, .reusable = false}, SHIFT(475),
  [857] = {.count = 1, .reusable = false}, SHIFT(476),
  [859] = {.count = 1, .reusable = false}, SHIFT(477),
  [861] = {.count = 1, .reusable = false}, SHIFT(478),
  [863] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [865] = {.count = 1, .reusable = true}, SHIFT(481),
  [867] = {.count = 1, .reusable = true}, SHIFT(482),
  [869] = {.count = 1, .reusable = true}, SHIFT(483),
  [871] = {.count = 1, .reusable = true}, SHIFT(486),
  [873] = {.count = 1, .reusable = true}, SHIFT(485),
  [875] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [877] = {.count = 1, .reusable = true}, SHIFT(487),
  [879] = {.count = 1, .reusable = true}, SHIFT(122),
  [881] = {.count = 1, .reusable = true}, SHIFT(490),
  [883] = {.count = 1, .reusable = false}, SHIFT(491),
  [885] = {.count = 1, .reusable = true}, SHIFT(492),
  [887] = {.count = 1, .reusable = false}, SHIFT(493),
  [889] = {.count = 1, .reusable = true}, SHIFT(494),
  [891] = {.count = 1, .reusable = true}, SHIFT(496),
  [893] = {.count = 1, .reusable = true}, SHIFT(497),
  [895] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1),
  [897] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1),
  [899] = {.count = 1, .reusable = false}, SHIFT(498),
  [901] = {.count = 1, .reusable = true}, SHIFT(499),
  [903] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2),
  [905] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2),
  [907] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [909] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [911] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [913] = {.count = 1, .reusable = true}, SHIFT(502),
  [915] = {.count = 1, .reusable = false}, SHIFT(501),
  [917] = {.count = 1, .reusable = true}, SHIFT(503),
  [919] = {.count = 1, .reusable = false}, SHIFT(504),
  [921] = {.count = 1, .reusable = false}, SHIFT(505),
  [923] = {.count = 1, .reusable = false}, SHIFT(506),
  [925] = {.count = 1, .reusable = true}, SHIFT(511),
  [927] = {.count = 1, .reusable = false}, SHIFT(510),
  [929] = {.count = 1, .reusable = true}, SHIFT(514),
  [931] = {.count = 1, .reusable = false}, SHIFT(515),
  [933] = {.count = 1, .reusable = true}, SHIFT(512),
  [935] = {.count = 1, .reusable = true}, SHIFT(516),
  [937] = {.count = 1, .reusable = false}, SHIFT(513),
  [939] = {.count = 1, .reusable = true}, SHIFT(519),
  [941] = {.count = 1, .reusable = true}, SHIFT(518),
  [943] = {.count = 1, .reusable = true}, SHIFT(521),
  [945] = {.count = 1, .reusable = true}, SHIFT(520),
  [947] = {.count = 1, .reusable = true}, SHIFT(522),
  [949] = {.count = 1, .reusable = false}, SHIFT(524),
  [951] = {.count = 1, .reusable = true}, SHIFT(525),
  [953] = {.count = 1, .reusable = false}, SHIFT(528),
  [955] = {.count = 1, .reusable = true}, SHIFT(528),
  [957] = {.count = 1, .reusable = false}, SHIFT(529),
  [959] = {.count = 1, .reusable = true}, SHIFT(529),
  [961] = {.count = 1, .reusable = false}, SHIFT(530),
  [963] = {.count = 1, .reusable = true}, SHIFT(530),
  [965] = {.count = 1, .reusable = false}, SHIFT(531),
  [967] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [969] = {.count = 1, .reusable = true}, SHIFT(531),
  [971] = {.count = 1, .reusable = false}, SHIFT(522),
  [973] = {.count = 1, .reusable = false}, SHIFT(533),
  [975] = {.count = 1, .reusable = true}, SHIFT(533),
  [977] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [979] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [981] = {.count = 1, .reusable = true}, SHIFT(535),
  [983] = {.count = 1, .reusable = false}, SHIFT(538),
  [985] = {.count = 1, .reusable = false}, SHIFT(539),
  [987] = {.count = 1, .reusable = false}, SHIFT(540),
  [989] = {.count = 1, .reusable = true}, SHIFT(541),
  [991] = {.count = 1, .reusable = false}, SHIFT(542),
  [993] = {.count = 1, .reusable = true}, SHIFT(542),
  [995] = {.count = 1, .reusable = false}, SHIFT(543),
  [997] = {.count = 1, .reusable = true}, SHIFT(543),
  [999] = {.count = 1, .reusable = false}, SHIFT(544),
  [1001] = {.count = 1, .reusable = true}, SHIFT(545),
  [1003] = {.count = 1, .reusable = true}, SHIFT(546),
  [1005] = {.count = 1, .reusable = false}, SHIFT(548),
  [1007] = {.count = 1, .reusable = false}, SHIFT(549),
  [1009] = {.count = 1, .reusable = false}, SHIFT(551),
  [1011] = {.count = 1, .reusable = false}, SHIFT(552),
  [1013] = {.count = 1, .reusable = false}, SHIFT(553),
  [1015] = {.count = 1, .reusable = true}, SHIFT(549),
  [1017] = {.count = 1, .reusable = false}, SHIFT(550),
  [1019] = {.count = 1, .reusable = false}, SHIFT(554),
  [1021] = {.count = 1, .reusable = false}, SHIFT(560),
  [1023] = {.count = 1, .reusable = false}, SHIFT(563),
  [1025] = {.count = 1, .reusable = true}, SHIFT(563),
  [1027] = {.count = 1, .reusable = true}, SHIFT(513),
  [1029] = {.count = 1, .reusable = false}, SHIFT(565),
  [1031] = {.count = 1, .reusable = true}, SHIFT(567),
  [1033] = {.count = 1, .reusable = false}, SHIFT(566),
  [1035] = {.count = 1, .reusable = true}, SHIFT(568),
  [1037] = {.count = 1, .reusable = false}, SHIFT(567),
  [1039] = {.count = 1, .reusable = true}, SHIFT(569),
  [1041] = {.count = 1, .reusable = false}, SHIFT(568),
  [1043] = {.count = 1, .reusable = true}, SHIFT(570),
  [1045] = {.count = 1, .reusable = true}, SHIFT(565),
  [1047] = {.count = 1, .reusable = true}, SHIFT(571),
  [1049] = {.count = 1, .reusable = true}, SHIFT(572),
  [1051] = {.count = 1, .reusable = false}, SHIFT(573),
  [1053] = {.count = 1, .reusable = true}, SHIFT(574),
  [1055] = {.count = 1, .reusable = false}, SHIFT(564),
  [1057] = {.count = 1, .reusable = true}, SHIFT(576),
  [1059] = {.count = 1, .reusable = false}, SHIFT(579),
  [1061] = {.count = 1, .reusable = true}, SHIFT(579),
  [1063] = {.count = 1, .reusable = false}, SHIFT(581),
  [1065] = {.count = 1, .reusable = true}, SHIFT(584),
  [1067] = {.count = 1, .reusable = false}, SHIFT(583),
  [1069] = {.count = 1, .reusable = true}, SHIFT(585),
  [1071] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2),
  [1073] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2),
  [1075] = {.count = 1, .reusable = true}, SHIFT(588),
  [1077] = {.count = 1, .reusable = false}, SHIFT(586),
  [1079] = {.count = 1, .reusable = false}, SHIFT(599),
  [1081] = {.count = 1, .reusable = false}, SHIFT(587),
  [1083] = {.count = 1, .reusable = false}, SHIFT(588),
  [1085] = {.count = 1, .reusable = false}, SHIFT(589),
  [1087] = {.count = 1, .reusable = false}, SHIFT(590),
  [1089] = {.count = 1, .reusable = false}, SHIFT(591),
  [1091] = {.count = 1, .reusable = true}, SHIFT(592),
  [1093] = {.count = 1, .reusable = true}, SHIFT(599),
  [1095] = {.count = 1, .reusable = false}, SHIFT(593),
  [1097] = {.count = 1, .reusable = false}, SHIFT(594),
  [1099] = {.count = 1, .reusable = false}, SHIFT(595),
  [1101] = {.count = 1, .reusable = false}, SHIFT(596),
  [1103] = {.count = 1, .reusable = false}, SHIFT(597),
  [1105] = {.count = 1, .reusable = false}, SHIFT(606),
  [1107] = {.count = 1, .reusable = true}, SHIFT(607),
  [1109] = {.count = 1, .reusable = true}, SHIFT(608),
  [1111] = {.count = 1, .reusable = false}, SHIFT(609),
  [1113] = {.count = 1, .reusable = true}, SHIFT(610),
  [1115] = {.count = 1, .reusable = true}, SHIFT(173),
  [1117] = {.count = 1, .reusable = true}, SHIFT(174),
  [1119] = {.count = 1, .reusable = false}, SHIFT(618),
  [1121] = {.count = 1, .reusable = true}, SHIFT(619),
  [1123] = {.count = 1, .reusable = true}, SHIFT(620),
  [1125] = {.count = 1, .reusable = false}, SHIFT(621),
  [1127] = {.count = 1, .reusable = false}, SHIFT(624),
  [1129] = {.count = 1, .reusable = false}, SHIFT(622),
  [1131] = {.count = 1, .reusable = false}, SHIFT(623),
  [1133] = {.count = 1, .reusable = true}, SHIFT(625),
  [1135] = {.count = 1, .reusable = true}, SHIFT(626),
  [1137] = {.count = 1, .reusable = true}, SHIFT(631),
  [1139] = {.count = 1, .reusable = false}, SHIFT(627),
  [1141] = {.count = 1, .reusable = false}, SHIFT(628),
  [1143] = {.count = 1, .reusable = true}, SHIFT(629),
  [1145] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [1147] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 2),
  [1149] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 2),
  [1151] = {.count = 1, .reusable = true}, SHIFT(168),
  [1153] = {.count = 1, .reusable = true}, SHIFT(637),
  [1155] = {.count = 1, .reusable = true}, SHIFT(638),
  [1157] = {.count = 1, .reusable = true}, SHIFT(640),
  [1159] = {.count = 1, .reusable = true}, SHIFT(641),
  [1161] = {.count = 1, .reusable = true}, SHIFT(642),
  [1163] = {.count = 1, .reusable = true}, SHIFT(119),
  [1165] = {.count = 1, .reusable = true}, SHIFT(644),
  [1167] = {.count = 1, .reusable = false}, SHIFT(316),
  [1169] = {.count = 1, .reusable = true}, SHIFT(312),
  [1171] = {.count = 1, .reusable = true}, SHIFT(645),
  [1173] = {.count = 1, .reusable = true}, SHIFT(647),
  [1175] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [1177] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [1179] = {.count = 1, .reusable = false}, SHIFT(649),
  [1181] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [1184] = {.count = 1, .reusable = true}, SHIFT(648),
  [1186] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [1189] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .alias_sequence_id = 2), SHIFT(650),
  [1192] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [1195] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [1198] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [1200] = {.count = 1, .reusable = false}, SHIFT(653),
  [1202] = {.count = 1, .reusable = false}, SHIFT(654),
  [1204] = {.count = 1, .reusable = false}, SHIFT(655),
  [1206] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [1208] = {.count = 1, .reusable = false}, SHIFT(656),
  [1210] = {.count = 1, .reusable = false}, SHIFT(657),
  [1212] = {.count = 1, .reusable = false}, SHIFT(658),
  [1214] = {.count = 1, .reusable = false}, SHIFT(661),
  [1216] = {.count = 1, .reusable = true}, SHIFT(662),
  [1218] = {.count = 1, .reusable = true}, SHIFT(663),
  [1220] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [1222] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [1224] = {.count = 1, .reusable = false}, SHIFT(664),
  [1226] = {.count = 1, .reusable = false}, SHIFT(667),
  [1228] = {.count = 1, .reusable = true}, SHIFT(666),
  [1230] = {.count = 1, .reusable = false}, SHIFT(665),
  [1232] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(662),
  [1235] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1237] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1239] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1241] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1243] = {.count = 1, .reusable = true}, SHIFT(669),
  [1245] = {.count = 1, .reusable = true}, SHIFT(670),
  [1247] = {.count = 1, .reusable = false}, SHIFT(671),
  [1249] = {.count = 1, .reusable = true}, SHIFT(671),
  [1251] = {.count = 1, .reusable = true}, SHIFT(672),
  [1253] = {.count = 1, .reusable = true}, SHIFT(673),
  [1255] = {.count = 1, .reusable = true}, SHIFT(674),
  [1257] = {.count = 1, .reusable = false}, SHIFT(676),
  [1259] = {.count = 1, .reusable = true}, SHIFT(676),
  [1261] = {.count = 1, .reusable = false}, SHIFT(677),
  [1263] = {.count = 1, .reusable = false}, SHIFT(678),
  [1265] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(666),
  [1268] = {.count = 1, .reusable = false}, SHIFT(679),
  [1270] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2), SHIFT(255),
  [1274] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2), SHIFT(256),
  [1278] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1281] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1284] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [1286] = {.count = 1, .reusable = false}, SHIFT(682),
  [1288] = {.count = 1, .reusable = true}, SHIFT(683),
  [1290] = {.count = 1, .reusable = false}, SHIFT(685),
  [1292] = {.count = 1, .reusable = true}, SHIFT(686),
  [1294] = {.count = 1, .reusable = false}, SHIFT(687),
  [1296] = {.count = 1, .reusable = false}, SHIFT(688),
  [1298] = {.count = 1, .reusable = true}, SHIFT(691),
  [1300] = {.count = 1, .reusable = true}, SHIFT(692),
  [1302] = {.count = 1, .reusable = false}, SHIFT(351),
  [1304] = {.count = 1, .reusable = false}, SHIFT(697),
  [1306] = {.count = 1, .reusable = false}, SHIFT(699),
  [1308] = {.count = 1, .reusable = false}, SHIFT(696),
  [1310] = {.count = 1, .reusable = true}, SHIFT(701),
  [1312] = {.count = 1, .reusable = false}, SHIFT(698),
  [1314] = {.count = 1, .reusable = true}, SHIFT(704),
  [1316] = {.count = 1, .reusable = true}, SHIFT(709),
  [1318] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1),
  [1321] = {.count = 1, .reusable = false}, SHIFT(710),
  [1323] = {.count = 1, .reusable = true}, SHIFT(706),
  [1325] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(708),
  [1328] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(711),
  [1331] = {.count = 1, .reusable = false}, SHIFT(707),
  [1333] = {.count = 1, .reusable = false}, SHIFT(714),
  [1335] = {.count = 1, .reusable = false}, SHIFT(715),
  [1337] = {.count = 1, .reusable = true}, SHIFT(721),
  [1339] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym_required_parameter, 1, .alias_sequence_id = 1),
  [1342] = {.count = 1, .reusable = true}, SHIFT(719),
  [1344] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(720),
  [1347] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(711),
  [1350] = {.count = 1, .reusable = false}, SHIFT(724),
  [1352] = {.count = 1, .reusable = true}, SHIFT(724),
  [1354] = {.count = 1, .reusable = false}, SHIFT(725),
  [1356] = {.count = 1, .reusable = true}, SHIFT(725),
  [1358] = {.count = 1, .reusable = true}, SHIFT(726),
  [1360] = {.count = 1, .reusable = false}, SHIFT(727),
  [1362] = {.count = 1, .reusable = false}, SHIFT(728),
  [1364] = {.count = 1, .reusable = false}, SHIFT(729),
  [1366] = {.count = 1, .reusable = true}, SHIFT(729),
  [1368] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [1370] = {.count = 1, .reusable = false}, SHIFT(730),
  [1372] = {.count = 1, .reusable = true}, SHIFT(730),
  [1374] = {.count = 1, .reusable = false}, SHIFT(731),
  [1376] = {.count = 1, .reusable = false}, SHIFT(732),
  [1378] = {.count = 1, .reusable = false}, SHIFT(733),
  [1380] = {.count = 1, .reusable = false}, SHIFT(734),
  [1382] = {.count = 1, .reusable = false}, SHIFT(735),
  [1384] = {.count = 1, .reusable = false}, SHIFT(736),
  [1386] = {.count = 1, .reusable = true}, SHIFT(736),
  [1388] = {.count = 1, .reusable = true}, SHIFT(737),
  [1390] = {.count = 1, .reusable = true}, SHIFT(738),
  [1392] = {.count = 1, .reusable = true}, SHIFT(707),
  [1394] = {.count = 1, .reusable = false}, SHIFT(740),
  [1396] = {.count = 1, .reusable = true}, SHIFT(744),
  [1398] = {.count = 1, .reusable = true}, SHIFT(741),
  [1400] = {.count = 1, .reusable = false}, SHIFT(742),
  [1402] = {.count = 1, .reusable = true}, SHIFT(743),
  [1404] = {.count = 1, .reusable = false}, SHIFT(741),
  [1406] = {.count = 1, .reusable = false}, SHIFT(743),
  [1408] = {.count = 1, .reusable = true}, SHIFT(745),
  [1410] = {.count = 1, .reusable = true}, SHIFT(740),
  [1412] = {.count = 1, .reusable = true}, SHIFT(746),
  [1414] = {.count = 1, .reusable = false}, SHIFT(747),
  [1416] = {.count = 1, .reusable = true}, SHIFT(748),
  [1418] = {.count = 1, .reusable = true}, SHIFT(749),
  [1420] = {.count = 1, .reusable = true}, SHIFT(750),
  [1422] = {.count = 1, .reusable = false}, SHIFT(752),
  [1424] = {.count = 1, .reusable = false}, SHIFT(753),
  [1426] = {.count = 1, .reusable = false}, SHIFT(755),
  [1428] = {.count = 1, .reusable = false}, SHIFT(756),
  [1430] = {.count = 1, .reusable = false}, SHIFT(757),
  [1432] = {.count = 1, .reusable = false}, SHIFT(576),
  [1434] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1, .alias_sequence_id = 3),
  [1437] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(763),
  [1440] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1, .alias_sequence_id = 4),
  [1443] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(766),
  [1446] = {.count = 1, .reusable = true}, SHIFT(769),
  [1448] = {.count = 1, .reusable = true}, SHIFT(770),
  [1450] = {.count = 1, .reusable = true}, SHIFT(772),
  [1452] = {.count = 1, .reusable = true}, SHIFT(773),
  [1454] = {.count = 1, .reusable = true}, SHIFT(775),
  [1456] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [1458] = {.count = 1, .reusable = true}, SHIFT(778),
  [1460] = {.count = 1, .reusable = true}, SHIFT(779),
  [1462] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2),
  [1464] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2),
  [1466] = {.count = 1, .reusable = false}, SHIFT(780),
  [1468] = {.count = 1, .reusable = false}, SHIFT(781),
  [1470] = {.count = 1, .reusable = true}, SHIFT(784),
  [1472] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(786),
  [1475] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [1477] = {.count = 1, .reusable = true}, SHIFT(785),
  [1479] = {.count = 1, .reusable = true}, SHIFT(787),
  [1481] = {.count = 1, .reusable = true}, SHIFT(789),
  [1483] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), REDUCE(sym_type_parameter, 1, .alias_sequence_id = 5),
  [1486] = {.count = 1, .reusable = true}, SHIFT(101),
  [1488] = {.count = 1, .reusable = true}, SHIFT(788),
  [1490] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [1492] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [1494] = {.count = 1, .reusable = true}, SHIFT(793),
  [1496] = {.count = 1, .reusable = true}, SHIFT(795),
  [1498] = {.count = 1, .reusable = true}, SHIFT(796),
  [1500] = {.count = 1, .reusable = true}, SHIFT(797),
  [1502] = {.count = 1, .reusable = true}, SHIFT(798),
  [1504] = {.count = 1, .reusable = false}, SHIFT(799),
  [1506] = {.count = 1, .reusable = false}, SHIFT(801),
  [1508] = {.count = 1, .reusable = true}, SHIFT(802),
  [1510] = {.count = 1, .reusable = false}, SHIFT(800),
  [1512] = {.count = 1, .reusable = true}, SHIFT(807),
  [1514] = {.count = 1, .reusable = false}, SHIFT(803),
  [1516] = {.count = 1, .reusable = false}, SHIFT(804),
  [1518] = {.count = 1, .reusable = false}, SHIFT(805),
  [1520] = {.count = 1, .reusable = false}, SHIFT(812),
  [1522] = {.count = 1, .reusable = true}, SHIFT(813),
  [1524] = {.count = 1, .reusable = true}, SHIFT(814),
  [1526] = {.count = 1, .reusable = false}, SHIFT(815),
  [1528] = {.count = 1, .reusable = true}, SHIFT(816),
  [1530] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [1532] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [1534] = {.count = 1, .reusable = false}, REDUCE(sym_this_type, 1),
  [1536] = {.count = 1, .reusable = true}, REDUCE(sym_this_type, 1),
  [1538] = {.count = 1, .reusable = true}, SHIFT(822),
  [1540] = {.count = 1, .reusable = true}, SHIFT(823),
  [1542] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [1544] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [1546] = {.count = 1, .reusable = true}, SHIFT(824),
  [1548] = {.count = 1, .reusable = true}, SHIFT(828),
  [1550] = {.count = 1, .reusable = false}, SHIFT(829),
  [1552] = {.count = 1, .reusable = false}, SHIFT(830),
  [1554] = {.count = 1, .reusable = false}, SHIFT(831),
  [1556] = {.count = 1, .reusable = true}, SHIFT(832),
  [1558] = {.count = 1, .reusable = true}, SHIFT(833),
  [1560] = {.count = 1, .reusable = true}, SHIFT(834),
  [1562] = {.count = 1, .reusable = false}, SHIFT(835),
  [1564] = {.count = 1, .reusable = false}, SHIFT(836),
  [1566] = {.count = 1, .reusable = true}, SHIFT(842),
  [1568] = {.count = 1, .reusable = true}, SHIFT(843),
  [1570] = {.count = 1, .reusable = true}, SHIFT(844),
  [1572] = {.count = 1, .reusable = true}, SHIFT(845),
  [1574] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(849),
  [1577] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [1579] = {.count = 1, .reusable = true}, SHIFT(848),
  [1581] = {.count = 1, .reusable = true}, SHIFT(851),
  [1583] = {.count = 1, .reusable = true}, SHIFT(852),
  [1585] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [1587] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [1589] = {.count = 1, .reusable = true}, SHIFT(854),
  [1591] = {.count = 1, .reusable = true}, SHIFT(855),
  [1593] = {.count = 1, .reusable = false}, SHIFT(856),
  [1595] = {.count = 1, .reusable = true}, SHIFT(860),
  [1597] = {.count = 1, .reusable = true}, SHIFT(863),
  [1599] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2),
  [1601] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2),
  [1603] = {.count = 1, .reusable = true}, SHIFT(866),
  [1605] = {.count = 1, .reusable = false}, SHIFT(867),
  [1607] = {.count = 1, .reusable = true}, SHIFT(869),
  [1609] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .alias_sequence_id = 6),
  [1611] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .alias_sequence_id = 6),
  [1613] = {.count = 1, .reusable = false}, SHIFT(871),
  [1615] = {.count = 1, .reusable = false}, SHIFT(878),
  [1617] = {.count = 1, .reusable = false}, SHIFT(872),
  [1619] = {.count = 1, .reusable = false}, SHIFT(873),
  [1621] = {.count = 1, .reusable = false}, SHIFT(874),
  [1623] = {.count = 1, .reusable = true}, SHIFT(878),
  [1625] = {.count = 1, .reusable = false}, SHIFT(875),
  [1627] = {.count = 1, .reusable = false}, SHIFT(876),
  [1629] = {.count = 1, .reusable = false}, SHIFT(882),
  [1631] = {.count = 1, .reusable = true}, SHIFT(882),
  [1633] = {.count = 1, .reusable = false}, SHIFT(883),
  [1635] = {.count = 1, .reusable = true}, SHIFT(883),
  [1637] = {.count = 1, .reusable = false}, SHIFT(555),
  [1639] = {.count = 1, .reusable = true}, SHIFT(555),
  [1641] = {.count = 1, .reusable = true}, SHIFT(865),
  [1643] = {.count = 1, .reusable = false}, SHIFT(865),
  [1645] = {.count = 1, .reusable = false}, SHIFT(884),
  [1647] = {.count = 1, .reusable = true}, SHIFT(885),
  [1649] = {.count = 1, .reusable = false}, SHIFT(886),
  [1651] = {.count = 1, .reusable = false}, SHIFT(885),
  [1653] = {.count = 1, .reusable = true}, SHIFT(887),
  [1655] = {.count = 1, .reusable = false}, SHIFT(887),
  [1657] = {.count = 1, .reusable = true}, SHIFT(888),
  [1659] = {.count = 1, .reusable = true}, SHIFT(884),
  [1661] = {.count = 1, .reusable = true}, SHIFT(889),
  [1663] = {.count = 1, .reusable = false}, SHIFT(890),
  [1665] = {.count = 1, .reusable = true}, SHIFT(891),
  [1667] = {.count = 1, .reusable = true}, SHIFT(893),
  [1669] = {.count = 1, .reusable = true}, SHIFT(894),
  [1671] = {.count = 1, .reusable = false}, SHIFT(896),
  [1673] = {.count = 1, .reusable = true}, SHIFT(899),
  [1675] = {.count = 1, .reusable = false}, SHIFT(897),
  [1677] = {.count = 1, .reusable = false}, SHIFT(909),
  [1679] = {.count = 1, .reusable = false}, SHIFT(898),
  [1681] = {.count = 1, .reusable = false}, SHIFT(899),
  [1683] = {.count = 1, .reusable = false}, SHIFT(900),
  [1685] = {.count = 1, .reusable = false}, SHIFT(901),
  [1687] = {.count = 1, .reusable = false}, SHIFT(902),
  [1689] = {.count = 1, .reusable = true}, SHIFT(903),
  [1691] = {.count = 1, .reusable = true}, SHIFT(909),
  [1693] = {.count = 1, .reusable = false}, SHIFT(904),
  [1695] = {.count = 1, .reusable = false}, SHIFT(905),
  [1697] = {.count = 1, .reusable = false}, SHIFT(906),
  [1699] = {.count = 1, .reusable = false}, SHIFT(907),
  [1701] = {.count = 1, .reusable = true}, SHIFT(914),
  [1703] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2),
  [1705] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2),
  [1707] = {.count = 1, .reusable = true}, SHIFT(915),
  [1709] = {.count = 1, .reusable = true}, SHIFT(916),
  [1711] = {.count = 1, .reusable = true}, SHIFT(918),
  [1713] = {.count = 1, .reusable = true}, SHIFT(919),
  [1715] = {.count = 1, .reusable = true}, SHIFT(920),
  [1717] = {.count = 1, .reusable = true}, SHIFT(321),
  [1719] = {.count = 1, .reusable = true}, SHIFT(927),
  [1721] = {.count = 1, .reusable = true}, SHIFT(921),
  [1723] = {.count = 1, .reusable = true}, SHIFT(922),
  [1725] = {.count = 1, .reusable = true}, SHIFT(923),
  [1727] = {.count = 1, .reusable = true}, SHIFT(924),
  [1729] = {.count = 1, .reusable = true}, SHIFT(925),
  [1731] = {.count = 1, .reusable = true}, SHIFT(926),
  [1733] = {.count = 1, .reusable = true}, SHIFT(930),
  [1735] = {.count = 1, .reusable = true}, SHIFT(932),
  [1737] = {.count = 1, .reusable = true}, SHIFT(933),
  [1739] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 2),
  [1741] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [1744] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [1747] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [1750] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [1753] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [1756] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [1759] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [1762] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [1765] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [1768] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [1771] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [1774] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [1777] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [1780] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1783] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [1786] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [1789] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [1792] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [1795] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [1798] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(58),
  [1801] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [1804] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [1807] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [1810] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(24),
  [1813] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(25),
  [1816] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(26),
  [1819] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(27),
  [1822] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1825] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(28),
  [1828] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(29),
  [1831] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(30),
  [1834] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(31),
  [1837] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(32),
  [1840] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(33),
  [1843] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(34),
  [1846] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(35),
  [1849] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(36),
  [1852] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(37),
  [1855] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(38),
  [1858] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(40),
  [1861] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(41),
  [1864] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(42),
  [1867] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(43),
  [1870] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(58),
  [1873] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(44),
  [1876] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(45),
  [1879] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(46),
  [1882] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [1884] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(47),
  [1887] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(48),
  [1890] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(49),
  [1893] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(50),
  [1896] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3),
  [1898] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3),
  [1900] = {.count = 1, .reusable = false}, SHIFT(936),
  [1902] = {.count = 1, .reusable = true}, SHIFT(937),
  [1904] = {.count = 1, .reusable = true}, SHIFT(938),
  [1906] = {.count = 1, .reusable = false}, SHIFT(939),
  [1908] = {.count = 1, .reusable = true}, SHIFT(940),
  [1910] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [1912] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [1914] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [1916] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [1918] = {.count = 1, .reusable = false}, SHIFT(945),
  [1920] = {.count = 1, .reusable = true}, SHIFT(945),
  [1922] = {.count = 1, .reusable = false}, SHIFT(946),
  [1924] = {.count = 1, .reusable = true}, SHIFT(946),
  [1926] = {.count = 1, .reusable = false}, SHIFT(947),
  [1928] = {.count = 1, .reusable = true}, SHIFT(947),
  [1930] = {.count = 1, .reusable = false}, SHIFT(948),
  [1932] = {.count = 1, .reusable = true}, SHIFT(948),
  [1934] = {.count = 1, .reusable = false}, SHIFT(949),
  [1936] = {.count = 1, .reusable = true}, SHIFT(949),
  [1938] = {.count = 1, .reusable = true}, SHIFT(953),
  [1940] = {.count = 1, .reusable = false}, SHIFT(951),
  [1942] = {.count = 1, .reusable = false}, SHIFT(963),
  [1944] = {.count = 1, .reusable = false}, SHIFT(952),
  [1946] = {.count = 1, .reusable = false}, SHIFT(953),
  [1948] = {.count = 1, .reusable = false}, SHIFT(954),
  [1950] = {.count = 1, .reusable = false}, SHIFT(955),
  [1952] = {.count = 1, .reusable = false}, SHIFT(956),
  [1954] = {.count = 1, .reusable = true}, SHIFT(957),
  [1956] = {.count = 1, .reusable = true}, SHIFT(963),
  [1958] = {.count = 1, .reusable = false}, SHIFT(958),
  [1960] = {.count = 1, .reusable = false}, SHIFT(959),
  [1962] = {.count = 1, .reusable = false}, SHIFT(960),
  [1964] = {.count = 1, .reusable = false}, SHIFT(961),
  [1966] = {.count = 1, .reusable = false}, SHIFT(968),
  [1968] = {.count = 1, .reusable = false}, SHIFT(969),
  [1970] = {.count = 1, .reusable = true}, SHIFT(972),
  [1972] = {.count = 1, .reusable = false}, SHIFT(973),
  [1974] = {.count = 1, .reusable = false}, SHIFT(975),
  [1976] = {.count = 1, .reusable = false}, SHIFT(976),
  [1978] = {.count = 1, .reusable = true}, SHIFT(977),
  [1980] = {.count = 1, .reusable = true}, SHIFT(978),
  [1982] = {.count = 1, .reusable = false}, SHIFT(971),
  [1984] = {.count = 1, .reusable = true}, SHIFT(982),
  [1986] = {.count = 1, .reusable = true}, SHIFT(981),
  [1988] = {.count = 1, .reusable = true}, SHIFT(971),
  [1990] = {.count = 1, .reusable = true}, SHIFT(974),
  [1992] = {.count = 1, .reusable = true}, SHIFT(970),
  [1994] = {.count = 1, .reusable = false}, SHIFT(979),
  [1996] = {.count = 1, .reusable = true}, SHIFT(969),
  [1998] = {.count = 1, .reusable = false}, SHIFT(980),
  [2000] = {.count = 1, .reusable = false}, SHIFT(990),
  [2002] = {.count = 1, .reusable = false}, SHIFT(991),
  [2004] = {.count = 1, .reusable = true}, SHIFT(992),
  [2006] = {.count = 1, .reusable = false}, SHIFT(993),
  [2008] = {.count = 1, .reusable = false}, SHIFT(994),
  [2010] = {.count = 1, .reusable = false}, SHIFT(995),
  [2012] = {.count = 1, .reusable = false}, SHIFT(996),
  [2014] = {.count = 1, .reusable = false}, SHIFT(997),
  [2016] = {.count = 1, .reusable = true}, SHIFT(998),
  [2018] = {.count = 1, .reusable = false}, SHIFT(999),
  [2020] = {.count = 1, .reusable = true}, SHIFT(991),
  [2022] = {.count = 1, .reusable = false}, SHIFT(1000),
  [2024] = {.count = 1, .reusable = false}, SHIFT(1003),
  [2026] = {.count = 1, .reusable = true}, SHIFT(1003),
  [2028] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2030] = {.count = 1, .reusable = false}, SHIFT(1005),
  [2032] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2),
  [2034] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(6),
  [2037] = {.count = 1, .reusable = true}, REDUCE(sym_type_assertion, 2),
  [2039] = {.count = 1, .reusable = false}, REDUCE(sym_type_assertion, 2),
  [2041] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4),
  [2043] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4),
  [2045] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3),
  [2047] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3),
  [2049] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2051] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2053] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3),
  [2055] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2),
  [2057] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .alias_sequence_id = 7),
  [2059] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .alias_sequence_id = 7),
  [2061] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 8),
  [2063] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 8),
  [2065] = {.count = 1, .reusable = true}, SHIFT(1010),
  [2067] = {.count = 1, .reusable = false}, SHIFT(1011),
  [2069] = {.count = 1, .reusable = true}, SHIFT(1008),
  [2071] = {.count = 1, .reusable = false}, SHIFT(1009),
  [2073] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2075] = {.count = 1, .reusable = true}, SHIFT(1012),
  [2077] = {.count = 1, .reusable = false}, SHIFT(1014),
  [2079] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2081] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2083] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2085] = {.count = 1, .reusable = false}, SHIFT(1016),
  [2087] = {.count = 1, .reusable = false}, SHIFT(1017),
  [2089] = {.count = 1, .reusable = false}, SHIFT(1018),
  [2091] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2093] = {.count = 1, .reusable = false}, SHIFT(1019),
  [2095] = {.count = 1, .reusable = true}, SHIFT(1019),
  [2097] = {.count = 1, .reusable = false}, SHIFT(1020),
  [2099] = {.count = 1, .reusable = false}, SHIFT(1021),
  [2101] = {.count = 1, .reusable = false}, SHIFT(1022),
  [2103] = {.count = 1, .reusable = false}, SHIFT(1023),
  [2105] = {.count = 1, .reusable = false}, SHIFT(1024),
  [2107] = {.count = 1, .reusable = false}, SHIFT(1025),
  [2109] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2111] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2113] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2115] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2117] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2119] = {.count = 1, .reusable = false}, SHIFT(1028),
  [2121] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2123] = {.count = 1, .reusable = false}, SHIFT(1027),
  [2125] = {.count = 1, .reusable = false}, SHIFT(1029),
  [2127] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2129] = {.count = 1, .reusable = true}, SHIFT(1032),
  [2131] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2133] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2135] = {.count = 1, .reusable = false}, SHIFT(1034),
  [2137] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2139] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [2141] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [2143] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(72),
  [2146] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(382),
  [2149] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [2151] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .alias_sequence_id = 1),
  [2153] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .alias_sequence_id = 1),
  [2155] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .alias_sequence_id = 1),
  [2157] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 9),
  [2159] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 9),
  [2161] = {.count = 1, .reusable = true}, SHIFT(1036),
  [2163] = {.count = 1, .reusable = false}, SHIFT(1038),
  [2165] = {.count = 1, .reusable = true}, SHIFT(1037),
  [2167] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2169] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2),
  [2171] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2),
  [2173] = {.count = 1, .reusable = true}, SHIFT(1011),
  [2175] = {.count = 1, .reusable = false}, SHIFT(1042),
  [2177] = {.count = 1, .reusable = true}, SHIFT(1042),
  [2179] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2181] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .alias_sequence_id = 10),
  [2183] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .alias_sequence_id = 10),
  [2185] = {.count = 1, .reusable = false}, SHIFT(1047),
  [2187] = {.count = 1, .reusable = false}, SHIFT(1048),
  [2189] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2191] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2193] = {.count = 1, .reusable = true}, SHIFT(1051),
  [2195] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2197] = {.count = 1, .reusable = false}, SHIFT(1053),
  [2199] = {.count = 1, .reusable = false}, SHIFT(1054),
  [2201] = {.count = 1, .reusable = false}, SHIFT(1055),
  [2203] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2205] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2207] = {.count = 1, .reusable = false}, SHIFT(1058),
  [2209] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2211] = {.count = 1, .reusable = false}, SHIFT(1050),
  [2213] = {.count = 1, .reusable = false}, SHIFT(1059),
  [2215] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2217] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2219] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2),
  [2221] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2223] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2225] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2227] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [2229] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [2231] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2233] = {.count = 1, .reusable = false}, SHIFT(1080),
  [2235] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2237] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2239] = {.count = 1, .reusable = false}, SHIFT(1083),
  [2241] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2243] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .alias_sequence_id = 4),
  [2245] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .alias_sequence_id = 3),
  [2247] = {.count = 1, .reusable = true}, SHIFT(1091),
  [2249] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2251] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2255] = {.count = 1, .reusable = false}, SHIFT(1094),
  [2257] = {.count = 1, .reusable = true}, SHIFT(1097),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2261] = {.count = 1, .reusable = false}, SHIFT(1098),
  [2263] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2265] = {.count = 1, .reusable = false}, SHIFT(1099),
  [2267] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2269] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2271] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2273] = {.count = 1, .reusable = false}, SHIFT(1101),
  [2275] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2277] = {.count = 1, .reusable = false}, SHIFT(1102),
  [2279] = {.count = 1, .reusable = false}, SHIFT(1103),
  [2281] = {.count = 1, .reusable = false}, SHIFT(1104),
  [2283] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2285] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [2287] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [2289] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2291] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2293] = {.count = 1, .reusable = false}, SHIFT(1106),
  [2295] = {.count = 1, .reusable = false}, SHIFT(1107),
  [2297] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2299] = {.count = 1, .reusable = false}, SHIFT(1109),
  [2301] = {.count = 1, .reusable = false}, SHIFT(1110),
  [2303] = {.count = 1, .reusable = false}, SHIFT(1111),
  [2305] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2307] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2309] = {.count = 1, .reusable = false}, SHIFT(1112),
  [2311] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2313] = {.count = 1, .reusable = false}, SHIFT(1113),
  [2315] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2317] = {.count = 1, .reusable = false}, SHIFT(1114),
  [2319] = {.count = 1, .reusable = false}, SHIFT(1115),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2323] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2327] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2333] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3),
  [2335] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3),
  [2337] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2339] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2341] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2343] = {.count = 1, .reusable = false}, SHIFT(1123),
  [2345] = {.count = 1, .reusable = false}, SHIFT(1135),
  [2347] = {.count = 1, .reusable = false}, SHIFT(1124),
  [2349] = {.count = 1, .reusable = false}, SHIFT(1125),
  [2351] = {.count = 1, .reusable = false}, SHIFT(1126),
  [2353] = {.count = 1, .reusable = false}, SHIFT(1127),
  [2355] = {.count = 1, .reusable = false}, SHIFT(1128),
  [2357] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2359] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2361] = {.count = 1, .reusable = false}, SHIFT(1130),
  [2363] = {.count = 1, .reusable = false}, SHIFT(1131),
  [2365] = {.count = 1, .reusable = false}, SHIFT(1132),
  [2367] = {.count = 1, .reusable = false}, SHIFT(1133),
  [2369] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .alias_sequence_id = 11),
  [2371] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .alias_sequence_id = 11),
  [2373] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2377] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3),
  [2379] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3),
  [2381] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .alias_sequence_id = 10),
  [2383] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .alias_sequence_id = 10),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2387] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2389] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2391] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2393] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2395] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2397] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2399] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3),
  [2401] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3),
  [2403] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2405] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2407] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [2409] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [2411] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2413] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2415] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2417] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2419] = {.count = 1, .reusable = false}, SHIFT(1167),
  [2421] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2423] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2425] = {.count = 1, .reusable = false}, SHIFT(1175),
  [2427] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2429] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2431] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2433] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2435] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1),
  [2437] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2439] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [2441] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2443] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2445] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2447] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2449] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [2451] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [2453] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2455] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2457] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2),
  [2459] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2),
  [2461] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [2463] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [2465] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(502),
  [2468] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [2470] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2472] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2474] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2476] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2478] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2480] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2482] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2484] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2486] = {.count = 1, .reusable = false}, SHIFT(1203),
  [2488] = {.count = 1, .reusable = false}, SHIFT(1204),
  [2490] = {.count = 1, .reusable = false}, SHIFT(1207),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2494] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2496] = {.count = 1, .reusable = false}, SHIFT(1208),
  [2498] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2500] = {.count = 1, .reusable = false}, SHIFT(1209),
  [2502] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2504] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2506] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2508] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2510] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2512] = {.count = 1, .reusable = false}, SHIFT(1214),
  [2514] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2516] = {.count = 1, .reusable = false}, SHIFT(1215),
  [2518] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2520] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2522] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2524] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(573),
  [2527] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [2529] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [2531] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2533] = {.count = 1, .reusable = false}, SHIFT(1225),
  [2535] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2539] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2543] = {.count = 1, .reusable = false}, SHIFT(1232),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2547] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2549] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2551] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2555] = {.count = 1, .reusable = false}, SHIFT(1242),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2559] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2561] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2563] = {.count = 1, .reusable = false}, SHIFT(1244),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2567] = {.count = 1, .reusable = false}, SHIFT(1245),
  [2569] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2571] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [2573] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [2575] = {.count = 1, .reusable = false}, SHIFT(1246),
  [2577] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2579] = {.count = 1, .reusable = false}, SHIFT(1247),
  [2581] = {.count = 1, .reusable = false}, SHIFT(1248),
  [2583] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2585] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2587] = {.count = 1, .reusable = false}, SHIFT(1254),
  [2589] = {.count = 1, .reusable = false}, SHIFT(1255),
  [2591] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2593] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2595] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2597] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2599] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2601] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2603] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2607] = {.count = 1, .reusable = false}, SHIFT(1258),
  [2609] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2611] = {.count = 1, .reusable = false}, SHIFT(1259),
  [2613] = {.count = 1, .reusable = false}, SHIFT(1269),
  [2615] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2617] = {.count = 1, .reusable = false}, SHIFT(1271),
  [2619] = {.count = 1, .reusable = false}, SHIFT(1272),
  [2621] = {.count = 1, .reusable = false}, SHIFT(1273),
  [2623] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2625] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2629] = {.count = 1, .reusable = false}, SHIFT(1277),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2633] = {.count = 1, .reusable = false}, SHIFT(1278),
  [2635] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2637] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2641] = {.count = 1, .reusable = false}, SHIFT(1281),
  [2643] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(143),
  [2646] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2648] = {.count = 1, .reusable = false}, SHIFT(1284),
  [2650] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2652] = {.count = 1, .reusable = true}, REDUCE(sym__type_reference, 1, .alias_sequence_id = 5),
  [2654] = {.count = 1, .reusable = false}, SHIFT(1288),
  [2656] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2658] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(101),
  [2661] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2663] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2665] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2669] = {.count = 1, .reusable = false}, SHIFT(1292),
  [2671] = {.count = 1, .reusable = false}, SHIFT(1293),
  [2673] = {.count = 1, .reusable = true}, SHIFT(1293),
  [2675] = {.count = 1, .reusable = false}, SHIFT(1294),
  [2677] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2679] = {.count = 1, .reusable = false}, SHIFT(1295),
  [2681] = {.count = 1, .reusable = false}, SHIFT(1296),
  [2683] = {.count = 1, .reusable = false}, SHIFT(1297),
  [2685] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2687] = {.count = 1, .reusable = false}, SHIFT(1298),
  [2689] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2691] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2693] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2695] = {.count = 1, .reusable = false}, SHIFT(1301),
  [2697] = {.count = 1, .reusable = false}, SHIFT(1302),
  [2699] = {.count = 1, .reusable = false}, SHIFT(1303),
  [2701] = {.count = 1, .reusable = false}, SHIFT(1304),
  [2703] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2705] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2707] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2709] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2711] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2713] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2715] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2717] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2721] = {.count = 1, .reusable = false}, SHIFT(1309),
  [2723] = {.count = 1, .reusable = false}, SHIFT(1310),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2727] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2729] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2731] = {.count = 1, .reusable = false}, SHIFT(1313),
  [2733] = {.count = 1, .reusable = true}, SHIFT(1314),
  [2735] = {.count = 1, .reusable = true}, REDUCE(sym__type_reference, 1),
  [2737] = {.count = 1, .reusable = false}, REDUCE(sym__type_reference, 1),
  [2739] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2741] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2743] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2745] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2747] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2749] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2755] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .alias_sequence_id = 11),
  [2757] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .alias_sequence_id = 11),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2761] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2763] = {.count = 1, .reusable = false}, SHIFT(1341),
  [2765] = {.count = 1, .reusable = false}, SHIFT(1330),
  [2767] = {.count = 1, .reusable = false}, SHIFT(1331),
  [2769] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2771] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2773] = {.count = 1, .reusable = false}, SHIFT(1334),
  [2775] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2777] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2779] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2781] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2783] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2785] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2787] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2789] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2791] = {.count = 1, .reusable = false}, SHIFT(1349),
  [2793] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2797] = {.count = 1, .reusable = false}, SHIFT(1354),
  [2799] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2801] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2803] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [2805] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [2807] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2809] = {.count = 1, .reusable = false}, SHIFT(1356),
  [2811] = {.count = 1, .reusable = false}, SHIFT(1358),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2815] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2817] = {.count = 1, .reusable = false}, SHIFT(1359),
  [2819] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2821] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2823] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1),
  [2825] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2827] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2829] = {.count = 1, .reusable = false}, SHIFT(1373),
  [2831] = {.count = 1, .reusable = false}, SHIFT(1372),
  [2833] = {.count = 1, .reusable = false}, SHIFT(1371),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1374),
  [2837] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2839] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2841] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 3),
  [2843] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 3),
  [2845] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [2847] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2849] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2851] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2853] = {.count = 1, .reusable = true}, SHIFT(1380),
  [2855] = {.count = 1, .reusable = true}, SHIFT(1383),
  [2857] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2859] = {.count = 1, .reusable = true}, SHIFT(892),
  [2861] = {.count = 1, .reusable = true}, SHIFT(1387),
  [2863] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .alias_sequence_id = 12),
  [2865] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .alias_sequence_id = 12),
  [2867] = {.count = 1, .reusable = true}, SHIFT(1390),
  [2869] = {.count = 1, .reusable = false}, SHIFT(1388),
  [2871] = {.count = 1, .reusable = false}, SHIFT(1400),
  [2873] = {.count = 1, .reusable = false}, SHIFT(1389),
  [2875] = {.count = 1, .reusable = false}, SHIFT(1390),
  [2877] = {.count = 1, .reusable = false}, SHIFT(1391),
  [2879] = {.count = 1, .reusable = false}, SHIFT(1392),
  [2881] = {.count = 1, .reusable = false}, SHIFT(1393),
  [2883] = {.count = 1, .reusable = true}, SHIFT(1394),
  [2885] = {.count = 1, .reusable = true}, SHIFT(1400),
  [2887] = {.count = 1, .reusable = false}, SHIFT(1395),
  [2889] = {.count = 1, .reusable = false}, SHIFT(1396),
  [2891] = {.count = 1, .reusable = false}, SHIFT(1397),
  [2893] = {.count = 1, .reusable = false}, SHIFT(1398),
  [2895] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 13), REDUCE(sym_assignment_expression, 2),
  [2898] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 13),
  [2900] = {.count = 1, .reusable = true}, SHIFT(1405),
  [2902] = {.count = 1, .reusable = true}, SHIFT(1406),
  [2904] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .alias_sequence_id = 12),
  [2906] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [2908] = {.count = 1, .reusable = false}, SHIFT(1408),
  [2910] = {.count = 1, .reusable = false}, SHIFT(1413),
  [2912] = {.count = 1, .reusable = false}, SHIFT(1409),
  [2914] = {.count = 1, .reusable = false}, SHIFT(1410),
  [2916] = {.count = 1, .reusable = false}, SHIFT(1411),
  [2918] = {.count = 1, .reusable = true}, SHIFT(1413),
  [2920] = {.count = 1, .reusable = false}, SHIFT(1412),
  [2922] = {.count = 1, .reusable = true}, SHIFT(1414),
  [2924] = {.count = 1, .reusable = true}, SHIFT(1416),
  [2926] = {.count = 1, .reusable = false}, SHIFT(1417),
  [2928] = {.count = 1, .reusable = true}, SHIFT(1418),
  [2930] = {.count = 1, .reusable = false}, SHIFT(1419),
  [2932] = {.count = 1, .reusable = false}, SHIFT(1420),
  [2934] = {.count = 1, .reusable = false}, SHIFT(1421),
  [2936] = {.count = 1, .reusable = false}, SHIFT(1422),
  [2938] = {.count = 1, .reusable = false}, SHIFT(1423),
  [2940] = {.count = 1, .reusable = false}, SHIFT(1424),
  [2942] = {.count = 1, .reusable = false}, SHIFT(1425),
  [2944] = {.count = 1, .reusable = false}, SHIFT(1426),
  [2946] = {.count = 1, .reusable = true}, SHIFT(1429),
  [2948] = {.count = 1, .reusable = false}, SHIFT(1430),
  [2950] = {.count = 1, .reusable = false}, SHIFT(1431),
  [2952] = {.count = 1, .reusable = false}, SHIFT(1432),
  [2954] = {.count = 1, .reusable = true}, SHIFT(1436),
  [2956] = {.count = 1, .reusable = true}, SHIFT(1437),
  [2958] = {.count = 1, .reusable = true}, SHIFT(1438),
  [2960] = {.count = 1, .reusable = false}, SHIFT(1439),
  [2962] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [2964] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [2966] = {.count = 1, .reusable = true}, SHIFT(1440),
  [2968] = {.count = 1, .reusable = true}, SHIFT(650),
  [2970] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [2972] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [2974] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(685),
  [2977] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(203),
  [2980] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(208),
  [2983] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(687),
  [2986] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(214),
  [2989] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(688),
  [2992] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(217),
  [2995] = {.count = 1, .reusable = false}, SHIFT(1441),
  [2997] = {.count = 1, .reusable = true}, SHIFT(1441),
  [2999] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 3), REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3),
  [3002] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 3),
  [3004] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(196),
  [3007] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2),
  [3009] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(195),
  [3012] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 4), REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4),
  [3015] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 4),
  [3017] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3019] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3021] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3023] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3),
  [3025] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3),
  [3027] = {.count = 1, .reusable = false}, SHIFT(1448),
  [3029] = {.count = 1, .reusable = true}, SHIFT(1448),
  [3031] = {.count = 1, .reusable = false}, SHIFT(1449),
  [3033] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3035] = {.count = 1, .reusable = true}, SHIFT(753),
  [3037] = {.count = 1, .reusable = true}, SHIFT(711),
  [3039] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [3041] = {.count = 1, .reusable = false}, SHIFT(1452),
  [3043] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3045] = {.count = 1, .reusable = false}, SHIFT(1453),
  [3047] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3049] = {.count = 1, .reusable = false}, SHIFT(1454),
  [3051] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3053] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3055] = {.count = 1, .reusable = false}, SHIFT(1457),
  [3057] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3059] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2), REDUCE(sym_required_parameter, 2),
  [3062] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [3064] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 6),
  [3066] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3068] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3070] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 14),
  [3072] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3074] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 15),
  [3076] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3078] = {.count = 1, .reusable = false}, SHIFT(1475),
  [3080] = {.count = 1, .reusable = true}, SHIFT(1475),
  [3082] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2, .alias_sequence_id = 1),
  [3084] = {.count = 1, .reusable = false}, SHIFT(1478),
  [3086] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3088] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 1), REDUCE(sym_required_parameter, 2, .alias_sequence_id = 1),
  [3091] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 1),
  [3093] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(747),
  [3096] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3098] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [3100] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3102] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3104] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3106] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [3108] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3110] = {.count = 1, .reusable = false}, SHIFT(1489),
  [3112] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3114] = {.count = 1, .reusable = false}, SHIFT(1490),
  [3116] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3118] = {.count = 1, .reusable = false}, SHIFT(1491),
  [3120] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3122] = {.count = 1, .reusable = false}, SHIFT(1492),
  [3124] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3126] = {.count = 1, .reusable = false}, SHIFT(1493),
  [3128] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3130] = {.count = 1, .reusable = false}, SHIFT(1495),
  [3132] = {.count = 1, .reusable = true}, SHIFT(1495),
  [3134] = {.count = 1, .reusable = false}, SHIFT(1496),
  [3136] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3138] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3140] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3142] = {.count = 1, .reusable = false}, SHIFT(1499),
  [3144] = {.count = 1, .reusable = false}, SHIFT(1504),
  [3146] = {.count = 1, .reusable = false}, SHIFT(1505),
  [3148] = {.count = 1, .reusable = false}, SHIFT(1506),
  [3150] = {.count = 1, .reusable = false}, SHIFT(1507),
  [3152] = {.count = 1, .reusable = false}, SHIFT(1508),
  [3154] = {.count = 1, .reusable = false}, SHIFT(1509),
  [3156] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [3158] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [3160] = {.count = 1, .reusable = false}, SHIFT(1510),
  [3162] = {.count = 1, .reusable = false}, SHIFT(1512),
  [3164] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3166] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3168] = {.count = 1, .reusable = false}, SHIFT(1514),
  [3170] = {.count = 1, .reusable = false}, SHIFT(1515),
  [3172] = {.count = 1, .reusable = false}, SHIFT(1519),
  [3174] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3176] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1, .alias_sequence_id = 1),
  [3178] = {.count = 1, .reusable = true}, SHIFT(720),
  [3180] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [3182] = {.count = 1, .reusable = true}, SHIFT(708),
  [3184] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1, .alias_sequence_id = 3),
  [3186] = {.count = 1, .reusable = true}, SHIFT(763),
  [3188] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1, .alias_sequence_id = 4),
  [3190] = {.count = 1, .reusable = true}, SHIFT(766),
  [3192] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2, .alias_sequence_id = 3),
  [3194] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3), REDUCE(sym_required_parameter, 2, .alias_sequence_id = 3),
  [3197] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 3),
  [3199] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2, .alias_sequence_id = 4),
  [3201] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4), REDUCE(sym_required_parameter, 2, .alias_sequence_id = 4),
  [3204] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 4),
  [3206] = {.count = 1, .reusable = false}, SHIFT(1531),
  [3208] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3210] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3212] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3214] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .alias_sequence_id = 5),
  [3216] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [3218] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [3220] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3222] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [3224] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [3226] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(778),
  [3229] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [3231] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3233] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3),
  [3235] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3),
  [3237] = {.count = 1, .reusable = false}, SHIFT(1543),
  [3239] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1545),
  [3243] = {.count = 1, .reusable = false}, SHIFT(1546),
  [3245] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3247] = {.count = 1, .reusable = false}, SHIFT(1552),
  [3249] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3253] = {.count = 1, .reusable = false}, SHIFT(1555),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3257] = {.count = 1, .reusable = true}, SHIFT(1561),
  [3259] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3261] = {.count = 1, .reusable = false}, SHIFT(1563),
  [3263] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3265] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .alias_sequence_id = 5),
  [3267] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .alias_sequence_id = 5),
  [3269] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .alias_sequence_id = 5),
  [3271] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [3273] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [3275] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3277] = {.count = 1, .reusable = false}, SHIFT(1571),
  [3279] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3281] = {.count = 1, .reusable = false}, SHIFT(1573),
  [3283] = {.count = 1, .reusable = false}, SHIFT(1574),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3289] = {.count = 1, .reusable = false}, SHIFT(1581),
  [3291] = {.count = 1, .reusable = false}, SHIFT(1584),
  [3293] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3295] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3297] = {.count = 1, .reusable = false}, SHIFT(1582),
  [3299] = {.count = 1, .reusable = false}, SHIFT(1586),
  [3301] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [3303] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [3305] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3307] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3311] = {.count = 1, .reusable = true}, SHIFT(1597),
  [3313] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3315] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3319] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3321] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3325] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3327] = {.count = 1, .reusable = false}, SHIFT(1594),
  [3329] = {.count = 1, .reusable = true}, SHIFT(1599),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3333] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3337] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3339] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1606),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3345] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3349] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3351] = {.count = 1, .reusable = false}, SHIFT(1617),
  [3353] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3355] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1627),
  [3363] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3367] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3369] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3373] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [3375] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [3377] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [3379] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [3381] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2),
  [3383] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2),
  [3385] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .alias_sequence_id = 11),
  [3387] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .alias_sequence_id = 11),
  [3389] = {.count = 1, .reusable = false}, SHIFT(787),
  [3391] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [3393] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [3395] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3397] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3399] = {.count = 1, .reusable = false}, SHIFT(1638),
  [3401] = {.count = 1, .reusable = false}, SHIFT(1639),
  [3403] = {.count = 1, .reusable = false}, SHIFT(1640),
  [3405] = {.count = 1, .reusable = false}, SHIFT(1641),
  [3407] = {.count = 1, .reusable = false}, SHIFT(1642),
  [3409] = {.count = 1, .reusable = false}, SHIFT(1643),
  [3411] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3413] = {.count = 1, .reusable = false}, SHIFT(1644),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3417] = {.count = 2, .reusable = true}, REDUCE(sym_required_parameter, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [3420] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3422] = {.count = 2, .reusable = true}, REDUCE(sym_required_parameter, 1, .alias_sequence_id = 1), REDUCE(sym_predefined_type, 1),
  [3425] = {.count = 1, .reusable = false}, SHIFT(1649),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3429] = {.count = 1, .reusable = false}, SHIFT(1651),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1653),
  [3435] = {.count = 1, .reusable = false}, SHIFT(1654),
  [3437] = {.count = 1, .reusable = false}, SHIFT(1657),
  [3439] = {.count = 1, .reusable = false}, SHIFT(1655),
  [3441] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3445] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3447] = {.count = 1, .reusable = false}, SHIFT(1659),
  [3449] = {.count = 1, .reusable = false}, SHIFT(1660),
  [3451] = {.count = 2, .reusable = true}, REDUCE(sym_this, 1), REDUCE(sym_this_type, 1),
  [3454] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3456] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3458] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3460] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3462] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3464] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [3466] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [3468] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [3470] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [3472] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3474] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3476] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3478] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [3480] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [3482] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3484] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [3486] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [3488] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3490] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3492] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3),
  [3494] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3),
  [3496] = {.count = 1, .reusable = false}, SHIFT(1687),
  [3498] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3500] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3502] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3),
  [3504] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3),
  [3506] = {.count = 1, .reusable = false}, SHIFT(1693),
  [3508] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3510] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3512] = {.count = 1, .reusable = false}, SHIFT(1696),
  [3514] = {.count = 1, .reusable = true}, SHIFT(1697),
  [3516] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3518] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3520] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3),
  [3522] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3),
  [3524] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [3526] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [3528] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .alias_sequence_id = 6),
  [3530] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .alias_sequence_id = 6),
  [3532] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3534] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3536] = {.count = 1, .reusable = false}, SHIFT(1705),
  [3538] = {.count = 1, .reusable = false}, SHIFT(1706),
  [3540] = {.count = 1, .reusable = false}, SHIFT(1707),
  [3542] = {.count = 1, .reusable = false}, SHIFT(1708),
  [3544] = {.count = 1, .reusable = false}, SHIFT(1709),
  [3546] = {.count = 1, .reusable = false}, SHIFT(1710),
  [3548] = {.count = 1, .reusable = false}, SHIFT(1711),
  [3550] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(890),
  [3553] = {.count = 1, .reusable = false}, SHIFT(1724),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3557] = {.count = 1, .reusable = false}, SHIFT(1725),
  [3559] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3561] = {.count = 1, .reusable = false}, SHIFT(1726),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1726),
  [3565] = {.count = 1, .reusable = false}, SHIFT(1727),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3569] = {.count = 1, .reusable = false}, SHIFT(1728),
  [3571] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3573] = {.count = 1, .reusable = false}, SHIFT(1729),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3577] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3581] = {.count = 1, .reusable = false}, SHIFT(1732),
  [3583] = {.count = 1, .reusable = false}, SHIFT(1737),
  [3585] = {.count = 1, .reusable = false}, SHIFT(1738),
  [3587] = {.count = 1, .reusable = false}, SHIFT(1739),
  [3589] = {.count = 1, .reusable = false}, SHIFT(1740),
  [3591] = {.count = 1, .reusable = false}, SHIFT(1741),
  [3593] = {.count = 1, .reusable = false}, SHIFT(1742),
  [3595] = {.count = 1, .reusable = false}, SHIFT(1743),
  [3597] = {.count = 1, .reusable = false}, SHIFT(1744),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3601] = {.count = 1, .reusable = false}, SHIFT(1745),
  [3603] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3605] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3607] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3609] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [3611] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3613] = {.count = 1, .reusable = true}, SHIFT(1749),
  [3615] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3617] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(1747),
  [3620] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3622] = {.count = 1, .reusable = false}, SHIFT(1755),
  [3624] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3626] = {.count = 1, .reusable = false}, SHIFT(1753),
  [3628] = {.count = 1, .reusable = true}, SHIFT(1757),
  [3630] = {.count = 1, .reusable = true}, SHIFT(1756),
  [3632] = {.count = 1, .reusable = false}, SHIFT(1758),
  [3634] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3636] = {.count = 1, .reusable = false}, SHIFT(1759),
  [3638] = {.count = 1, .reusable = true}, SHIFT(1759),
  [3640] = {.count = 1, .reusable = false}, SHIFT(1760),
  [3642] = {.count = 1, .reusable = false}, SHIFT(1761),
  [3644] = {.count = 1, .reusable = false}, SHIFT(1762),
  [3646] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3648] = {.count = 1, .reusable = false}, SHIFT(1763),
  [3650] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3652] = {.count = 1, .reusable = false}, SHIFT(1764),
  [3654] = {.count = 1, .reusable = false}, SHIFT(1765),
  [3656] = {.count = 1, .reusable = false}, SHIFT(1766),
  [3658] = {.count = 1, .reusable = false}, SHIFT(1767),
  [3660] = {.count = 1, .reusable = false}, SHIFT(1768),
  [3662] = {.count = 1, .reusable = false}, SHIFT(1769),
  [3664] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3666] = {.count = 1, .reusable = true}, SHIFT(1753),
  [3668] = {.count = 1, .reusable = false}, SHIFT(1770),
  [3670] = {.count = 1, .reusable = true}, SHIFT(1771),
  [3672] = {.count = 1, .reusable = false}, SHIFT(1772),
  [3674] = {.count = 1, .reusable = false}, SHIFT(1771),
  [3676] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3678] = {.count = 1, .reusable = false}, SHIFT(1773),
  [3680] = {.count = 1, .reusable = true}, SHIFT(1774),
  [3682] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3684] = {.count = 1, .reusable = true}, SHIFT(1775),
  [3686] = {.count = 1, .reusable = false}, SHIFT(1776),
  [3688] = {.count = 1, .reusable = true}, SHIFT(1777),
  [3690] = {.count = 1, .reusable = true}, SHIFT(1778),
  [3692] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [3694] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [3696] = {.count = 1, .reusable = false}, SHIFT(1779),
  [3698] = {.count = 1, .reusable = false}, SHIFT(1780),
  [3700] = {.count = 1, .reusable = false}, SHIFT(1781),
  [3702] = {.count = 1, .reusable = false}, SHIFT(1782),
  [3704] = {.count = 1, .reusable = false}, SHIFT(1783),
  [3706] = {.count = 1, .reusable = false}, SHIFT(1784),
  [3708] = {.count = 1, .reusable = false}, SHIFT(1785),
  [3710] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3712] = {.count = 1, .reusable = true}, SHIFT(1789),
  [3714] = {.count = 1, .reusable = false}, SHIFT(1790),
  [3716] = {.count = 1, .reusable = false}, SHIFT(1791),
  [3718] = {.count = 1, .reusable = false}, SHIFT(1792),
  [3720] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3722] = {.count = 1, .reusable = true}, SHIFT(524),
  [3724] = {.count = 1, .reusable = true}, SHIFT(1797),
  [3726] = {.count = 1, .reusable = true}, SHIFT(1798),
  [3728] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3730] = {.count = 1, .reusable = true}, SHIFT(1801),
  [3732] = {.count = 1, .reusable = true}, SHIFT(1802),
  [3734] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3),
  [3736] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3),
  [3738] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 3),
  [3740] = {.count = 1, .reusable = true}, SHIFT(1805),
  [3742] = {.count = 1, .reusable = true}, SHIFT(1804),
  [3744] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [3746] = {.count = 1, .reusable = true}, SHIFT(1808),
  [3748] = {.count = 1, .reusable = true}, SHIFT(1809),
  [3750] = {.count = 1, .reusable = true}, SHIFT(1811),
  [3752] = {.count = 1, .reusable = true}, SHIFT(1812),
  [3754] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(348),
  [3757] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3),
  [3759] = {.count = 1, .reusable = true}, SHIFT(1815),
  [3761] = {.count = 1, .reusable = false}, SHIFT(1816),
  [3763] = {.count = 1, .reusable = true}, SHIFT(1813),
  [3765] = {.count = 1, .reusable = false}, SHIFT(1814),
  [3767] = {.count = 1, .reusable = true}, SHIFT(1818),
  [3769] = {.count = 1, .reusable = true}, SHIFT(1817),
  [3771] = {.count = 1, .reusable = false}, SHIFT(1819),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1819),
  [3775] = {.count = 1, .reusable = false}, SHIFT(1820),
  [3777] = {.count = 1, .reusable = true}, SHIFT(1820),
  [3779] = {.count = 1, .reusable = false}, SHIFT(1821),
  [3781] = {.count = 1, .reusable = false}, SHIFT(1822),
  [3783] = {.count = 1, .reusable = false}, SHIFT(1823),
  [3785] = {.count = 1, .reusable = true}, SHIFT(1823),
  [3787] = {.count = 1, .reusable = false}, SHIFT(1824),
  [3789] = {.count = 1, .reusable = true}, SHIFT(1824),
  [3791] = {.count = 1, .reusable = false}, SHIFT(1825),
  [3793] = {.count = 1, .reusable = false}, SHIFT(1826),
  [3795] = {.count = 1, .reusable = false}, SHIFT(1827),
  [3797] = {.count = 1, .reusable = false}, SHIFT(1828),
  [3799] = {.count = 1, .reusable = false}, SHIFT(1829),
  [3801] = {.count = 1, .reusable = false}, SHIFT(1830),
  [3803] = {.count = 1, .reusable = true}, SHIFT(1830),
  [3805] = {.count = 1, .reusable = true}, SHIFT(1814),
  [3807] = {.count = 1, .reusable = false}, SHIFT(1831),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1832),
  [3811] = {.count = 1, .reusable = false}, SHIFT(1833),
  [3813] = {.count = 1, .reusable = false}, SHIFT(1832),
  [3815] = {.count = 1, .reusable = true}, SHIFT(1834),
  [3817] = {.count = 1, .reusable = false}, SHIFT(1834),
  [3819] = {.count = 1, .reusable = true}, SHIFT(1835),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1831),
  [3823] = {.count = 1, .reusable = true}, SHIFT(1836),
  [3825] = {.count = 1, .reusable = false}, SHIFT(1837),
  [3827] = {.count = 1, .reusable = true}, SHIFT(1838),
  [3829] = {.count = 1, .reusable = true}, SHIFT(1839),
  [3831] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1841),
  [3834] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [3836] = {.count = 1, .reusable = true}, SHIFT(1844),
  [3838] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1842),
  [3841] = {.count = 1, .reusable = true}, SHIFT(1843),
  [3843] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1840),
  [3846] = {.count = 1, .reusable = true}, SHIFT(1846),
  [3848] = {.count = 1, .reusable = true}, SHIFT(1848),
  [3850] = {.count = 1, .reusable = true}, SHIFT(1849),
  [3852] = {.count = 1, .reusable = true}, SHIFT(1853),
  [3854] = {.count = 1, .reusable = true}, SHIFT(1854),
  [3856] = {.count = 1, .reusable = true}, SHIFT(1856),
  [3858] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [3860] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [3862] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(1865),
  [3865] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [3867] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(1842),
  [3870] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(1864),
  [3873] = {.count = 1, .reusable = true}, SHIFT(1867),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1868),
  [3877] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(786),
  [3881] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [3884] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [3887] = {.count = 1, .reusable = true}, SHIFT(1870),
  [3889] = {.count = 1, .reusable = false}, SHIFT(1869),
  [3891] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3894] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3897] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym_predefined_type, 1),
  [3900] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym_predefined_type, 1),
  [3903] = {.count = 1, .reusable = false}, SHIFT(1871),
  [3905] = {.count = 1, .reusable = true}, SHIFT(1872),
  [3907] = {.count = 1, .reusable = false}, SHIFT(1873),
  [3909] = {.count = 1, .reusable = false}, SHIFT(1874),
  [3911] = {.count = 1, .reusable = false}, SHIFT(1875),
  [3913] = {.count = 1, .reusable = false}, SHIFT(1876),
  [3915] = {.count = 1, .reusable = false}, SHIFT(1877),
  [3917] = {.count = 1, .reusable = false}, SHIFT(1878),
  [3919] = {.count = 1, .reusable = false}, SHIFT(1880),
  [3921] = {.count = 1, .reusable = false}, SHIFT(1881),
  [3923] = {.count = 1, .reusable = false}, SHIFT(1882),
  [3925] = {.count = 1, .reusable = false}, SHIFT(1883),
  [3927] = {.count = 1, .reusable = false}, SHIFT(1884),
  [3929] = {.count = 1, .reusable = false}, SHIFT(1885),
  [3931] = {.count = 1, .reusable = false}, SHIFT(1886),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1885),
  [3935] = {.count = 1, .reusable = false}, SHIFT(1887),
  [3937] = {.count = 2, .reusable = false}, REDUCE(sym_this, 1), REDUCE(sym_this_type, 1),
  [3940] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(855),
  [3943] = {.count = 1, .reusable = false}, SHIFT(1893),
  [3945] = {.count = 1, .reusable = true}, SHIFT(1893),
  [3947] = {.count = 1, .reusable = true}, SHIFT(1898),
  [3949] = {.count = 1, .reusable = false}, SHIFT(1899),
  [3951] = {.count = 1, .reusable = true}, SHIFT(1899),
  [3953] = {.count = 1, .reusable = false}, SHIFT(1900),
  [3955] = {.count = 1, .reusable = true}, SHIFT(1900),
  [3957] = {.count = 1, .reusable = false}, SHIFT(1901),
  [3959] = {.count = 1, .reusable = true}, SHIFT(1901),
  [3961] = {.count = 1, .reusable = false}, SHIFT(1902),
  [3963] = {.count = 1, .reusable = true}, SHIFT(1902),
  [3965] = {.count = 1, .reusable = false}, SHIFT(1903),
  [3967] = {.count = 1, .reusable = true}, SHIFT(1903),
  [3969] = {.count = 1, .reusable = false}, SHIFT(1904),
  [3971] = {.count = 1, .reusable = true}, SHIFT(1904),
  [3973] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1034),
  [3976] = {.count = 1, .reusable = true}, SHIFT(1905),
  [3978] = {.count = 1, .reusable = true}, SHIFT(1906),
  [3980] = {.count = 1, .reusable = false}, SHIFT(1907),
  [3982] = {.count = 1, .reusable = true}, SHIFT(1907),
  [3984] = {.count = 1, .reusable = false}, SHIFT(1908),
  [3986] = {.count = 1, .reusable = true}, SHIFT(1908),
  [3988] = {.count = 1, .reusable = false}, SHIFT(1909),
  [3990] = {.count = 1, .reusable = true}, SHIFT(1909),
  [3992] = {.count = 1, .reusable = false}, SHIFT(1910),
  [3994] = {.count = 1, .reusable = true}, SHIFT(1910),
  [3996] = {.count = 1, .reusable = false}, SHIFT(1911),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1911),
  [4000] = {.count = 1, .reusable = false}, SHIFT(1912),
  [4002] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4004] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [4006] = {.count = 1, .reusable = false}, SHIFT(1913),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4014] = {.count = 1, .reusable = false}, SHIFT(1916),
  [4016] = {.count = 1, .reusable = false}, SHIFT(1921),
  [4018] = {.count = 1, .reusable = false}, SHIFT(1922),
  [4020] = {.count = 1, .reusable = false}, SHIFT(1923),
  [4022] = {.count = 1, .reusable = false}, SHIFT(1924),
  [4024] = {.count = 1, .reusable = false}, SHIFT(1925),
  [4026] = {.count = 1, .reusable = false}, SHIFT(1926),
  [4028] = {.count = 1, .reusable = false}, SHIFT(1927),
  [4030] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4032] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .alias_sequence_id = 8),
  [4034] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .alias_sequence_id = 8),
  [4036] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4038] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4040] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1933),
  [4043] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4045] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4047] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4049] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4051] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4053] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4055] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4057] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4059] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4061] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4063] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4065] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4067] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(1957),
  [4070] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4072] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4074] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4076] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4080] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4),
  [4082] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4086] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4088] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [4090] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [4092] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [4094] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(421),
  [4097] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4099] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4101] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4103] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4105] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4107] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4109] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .alias_sequence_id = 4),
  [4111] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .alias_sequence_id = 3),
  [4113] = {.count = 1, .reusable = false}, SHIFT(1974),
  [4115] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4117] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4),
  [4119] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4),
  [4121] = {.count = 1, .reusable = false}, SHIFT(1975),
  [4123] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4125] = {.count = 1, .reusable = false}, SHIFT(1976),
  [4127] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4129] = {.count = 1, .reusable = false}, SHIFT(1977),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4133] = {.count = 1, .reusable = false}, SHIFT(1978),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4137] = {.count = 1, .reusable = false}, SHIFT(1979),
  [4139] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4141] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1118),
  [4144] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4146] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4148] = {.count = 1, .reusable = false}, SHIFT(1982),
  [4150] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4152] = {.count = 1, .reusable = false}, SHIFT(1983),
  [4154] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4156] = {.count = 1, .reusable = false}, SHIFT(1984),
  [4158] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4160] = {.count = 1, .reusable = false}, SHIFT(1985),
  [4162] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4164] = {.count = 1, .reusable = false}, SHIFT(1986),
  [4166] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4168] = {.count = 1, .reusable = false}, SHIFT(1987),
  [4170] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4172] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4174] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4176] = {.count = 1, .reusable = false}, SHIFT(1990),
  [4178] = {.count = 1, .reusable = false}, SHIFT(1995),
  [4180] = {.count = 1, .reusable = false}, SHIFT(1996),
  [4182] = {.count = 1, .reusable = false}, SHIFT(1997),
  [4184] = {.count = 1, .reusable = false}, SHIFT(1998),
  [4186] = {.count = 1, .reusable = false}, SHIFT(1999),
  [4188] = {.count = 1, .reusable = false}, SHIFT(2000),
  [4190] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [4192] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [4194] = {.count = 1, .reusable = false}, SHIFT(2001),
  [4196] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4198] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4200] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(437),
  [4203] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4205] = {.count = 1, .reusable = false}, REDUCE(sym__type_reference, 1, .alias_sequence_id = 5),
  [4207] = {.count = 1, .reusable = false}, SHIFT(2006),
  [4209] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4211] = {.count = 1, .reusable = false}, SHIFT(2004),
  [4213] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4215] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4217] = {.count = 1, .reusable = false}, SHIFT(2009),
  [4219] = {.count = 1, .reusable = false}, SHIFT(2010),
  [4221] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4223] = {.count = 1, .reusable = false}, SHIFT(2011),
  [4225] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4227] = {.count = 1, .reusable = false}, SHIFT(96),
  [4229] = {.count = 1, .reusable = false}, SHIFT(2012),
  [4231] = {.count = 1, .reusable = false}, SHIFT(2013),
  [4233] = {.count = 1, .reusable = false}, SHIFT(2014),
  [4235] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4237] = {.count = 1, .reusable = false}, SHIFT(2015),
  [4239] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4241] = {.count = 1, .reusable = false}, SHIFT(2016),
  [4243] = {.count = 1, .reusable = false}, SHIFT(2017),
  [4245] = {.count = 1, .reusable = false}, SHIFT(2018),
  [4247] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4249] = {.count = 1, .reusable = false}, SHIFT(2020),
  [4251] = {.count = 1, .reusable = false}, SHIFT(2021),
  [4253] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4255] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4257] = {.count = 1, .reusable = false}, SHIFT(2022),
  [4259] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4261] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4263] = {.count = 1, .reusable = false}, SHIFT(2024),
  [4265] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [4267] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4269] = {.count = 1, .reusable = false}, SHIFT(2025),
  [4271] = {.count = 1, .reusable = false}, SHIFT(2026),
  [4273] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4275] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4277] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4279] = {.count = 1, .reusable = false}, SHIFT(2029),
  [4281] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4283] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .alias_sequence_id = 11),
  [4285] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .alias_sequence_id = 11),
  [4287] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [4289] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [4291] = {.count = 1, .reusable = true}, REDUCE(sym__enum_member, 1),
  [4293] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4295] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4297] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4299] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4301] = {.count = 1, .reusable = false}, SHIFT(2040),
  [4303] = {.count = 1, .reusable = false}, SHIFT(2041),
  [4305] = {.count = 1, .reusable = false}, SHIFT(2042),
  [4307] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4309] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4311] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class, 4, .alias_sequence_id = 16),
  [4313] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class, 4, .alias_sequence_id = 16),
  [4315] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4317] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4319] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4321] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4323] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4325] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4327] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4329] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [4331] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4333] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4335] = {.count = 1, .reusable = true}, SHIFT(498),
  [4337] = {.count = 1, .reusable = true}, SHIFT(1175),
  [4339] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [4341] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [4343] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4345] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [4347] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4349] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2),
  [4351] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4353] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [4355] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4357] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .alias_sequence_id = 17),
  [4359] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4361] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2),
  [4363] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [4365] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [4367] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4369] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4371] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4373] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4375] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4377] = {.count = 1, .reusable = false}, SHIFT(2078),
  [4379] = {.count = 1, .reusable = false}, SHIFT(2090),
  [4381] = {.count = 1, .reusable = false}, SHIFT(2079),
  [4383] = {.count = 1, .reusable = false}, SHIFT(2080),
  [4385] = {.count = 1, .reusable = false}, SHIFT(2081),
  [4387] = {.count = 1, .reusable = false}, SHIFT(2082),
  [4389] = {.count = 1, .reusable = false}, SHIFT(2083),
  [4391] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4393] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4395] = {.count = 1, .reusable = false}, SHIFT(2085),
  [4397] = {.count = 1, .reusable = false}, SHIFT(2086),
  [4399] = {.count = 1, .reusable = false}, SHIFT(2087),
  [4401] = {.count = 1, .reusable = false}, SHIFT(2088),
  [4403] = {.count = 1, .reusable = true}, SHIFT(2098),
  [4405] = {.count = 1, .reusable = false}, SHIFT(2096),
  [4407] = {.count = 1, .reusable = false}, SHIFT(2108),
  [4409] = {.count = 1, .reusable = false}, SHIFT(2097),
  [4411] = {.count = 1, .reusable = false}, SHIFT(2098),
  [4413] = {.count = 1, .reusable = false}, SHIFT(2099),
  [4415] = {.count = 1, .reusable = false}, SHIFT(2100),
  [4417] = {.count = 1, .reusable = false}, SHIFT(2101),
  [4419] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4421] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4423] = {.count = 1, .reusable = false}, SHIFT(2103),
  [4425] = {.count = 1, .reusable = false}, SHIFT(2104),
  [4427] = {.count = 1, .reusable = false}, SHIFT(2105),
  [4429] = {.count = 1, .reusable = false}, SHIFT(2106),
  [4431] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4433] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4435] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4437] = {.count = 1, .reusable = false}, SHIFT(2117),
  [4439] = {.count = 1, .reusable = true}, SHIFT(2116),
  [4441] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4443] = {.count = 1, .reusable = false}, SHIFT(2119),
  [4445] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4447] = {.count = 1, .reusable = false}, SHIFT(2120),
  [4449] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4451] = {.count = 1, .reusable = false}, SHIFT(2122),
  [4453] = {.count = 1, .reusable = true}, SHIFT(2122),
  [4455] = {.count = 1, .reusable = false}, SHIFT(2123),
  [4457] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4459] = {.count = 1, .reusable = false}, SHIFT(2125),
  [4461] = {.count = 1, .reusable = false}, SHIFT(2126),
  [4463] = {.count = 1, .reusable = false}, SHIFT(2127),
  [4465] = {.count = 1, .reusable = false}, SHIFT(2128),
  [4467] = {.count = 1, .reusable = false}, SHIFT(2129),
  [4469] = {.count = 1, .reusable = false}, SHIFT(2130),
  [4471] = {.count = 1, .reusable = false}, SHIFT(2131),
  [4473] = {.count = 1, .reusable = false}, SHIFT(2132),
  [4475] = {.count = 1, .reusable = false}, SHIFT(2133),
  [4477] = {.count = 1, .reusable = false}, SHIFT(2134),
  [4479] = {.count = 1, .reusable = false}, SHIFT(2135),
  [4481] = {.count = 1, .reusable = false}, SHIFT(2136),
  [4483] = {.count = 1, .reusable = true}, SHIFT(2141),
  [4485] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4487] = {.count = 1, .reusable = true}, SHIFT(2143),
  [4489] = {.count = 1, .reusable = false}, SHIFT(2145),
  [4491] = {.count = 1, .reusable = true}, SHIFT(2145),
  [4493] = {.count = 1, .reusable = false}, SHIFT(2147),
  [4495] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4497] = {.count = 1, .reusable = false}, SHIFT(2150),
  [4499] = {.count = 1, .reusable = true}, SHIFT(2153),
  [4501] = {.count = 1, .reusable = true}, SHIFT(2156),
  [4503] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(573),
  [4506] = {.count = 1, .reusable = true}, SHIFT(2157),
  [4508] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(2159),
  [4511] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4513] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(2160),
  [4516] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4518] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(2158),
  [4521] = {.count = 1, .reusable = true}, SHIFT(2164),
  [4523] = {.count = 1, .reusable = true}, SHIFT(2166),
  [4525] = {.count = 1, .reusable = true}, SHIFT(2167),
  [4527] = {.count = 1, .reusable = true}, SHIFT(2171),
  [4529] = {.count = 1, .reusable = true}, SHIFT(2172),
  [4531] = {.count = 1, .reusable = true}, SHIFT(2174),
  [4533] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(2183),
  [4536] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2160),
  [4539] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2182),
  [4542] = {.count = 1, .reusable = true}, SHIFT(2185),
  [4544] = {.count = 1, .reusable = true}, SHIFT(2186),
  [4546] = {.count = 1, .reusable = true}, SHIFT(2188),
  [4548] = {.count = 1, .reusable = false}, SHIFT(2187),
  [4550] = {.count = 1, .reusable = false}, SHIFT(2189),
  [4552] = {.count = 1, .reusable = true}, SHIFT(2190),
  [4554] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [4556] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [4558] = {.count = 1, .reusable = false}, SHIFT(2195),
  [4560] = {.count = 1, .reusable = true}, SHIFT(2195),
  [4562] = {.count = 1, .reusable = false}, SHIFT(2196),
  [4564] = {.count = 1, .reusable = true}, SHIFT(2196),
  [4566] = {.count = 1, .reusable = false}, SHIFT(2197),
  [4568] = {.count = 1, .reusable = true}, SHIFT(2197),
  [4570] = {.count = 1, .reusable = false}, SHIFT(2198),
  [4572] = {.count = 1, .reusable = true}, SHIFT(2198),
  [4574] = {.count = 1, .reusable = true}, SHIFT(2199),
  [4576] = {.count = 1, .reusable = false}, SHIFT(2200),
  [4578] = {.count = 1, .reusable = true}, SHIFT(2200),
  [4580] = {.count = 1, .reusable = false}, SHIFT(2201),
  [4582] = {.count = 1, .reusable = true}, SHIFT(2201),
  [4584] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1313),
  [4587] = {.count = 1, .reusable = true}, SHIFT(2202),
  [4589] = {.count = 1, .reusable = true}, SHIFT(2203),
  [4591] = {.count = 1, .reusable = false}, SHIFT(2204),
  [4593] = {.count = 1, .reusable = false}, SHIFT(2205),
  [4595] = {.count = 1, .reusable = true}, SHIFT(2205),
  [4597] = {.count = 1, .reusable = false}, SHIFT(2206),
  [4599] = {.count = 1, .reusable = true}, SHIFT(2206),
  [4601] = {.count = 1, .reusable = false}, SHIFT(2208),
  [4603] = {.count = 1, .reusable = true}, SHIFT(2208),
  [4605] = {.count = 1, .reusable = false}, SHIFT(2209),
  [4607] = {.count = 1, .reusable = true}, SHIFT(2209),
  [4609] = {.count = 1, .reusable = false}, SHIFT(2210),
  [4611] = {.count = 1, .reusable = true}, SHIFT(2210),
  [4613] = {.count = 1, .reusable = false}, SHIFT(2211),
  [4615] = {.count = 1, .reusable = true}, SHIFT(2211),
  [4617] = {.count = 1, .reusable = false}, SHIFT(2212),
  [4619] = {.count = 1, .reusable = true}, SHIFT(2216),
  [4621] = {.count = 1, .reusable = true}, SHIFT(2214),
  [4623] = {.count = 1, .reusable = true}, SHIFT(2213),
  [4625] = {.count = 1, .reusable = false}, SHIFT(2215),
  [4627] = {.count = 1, .reusable = false}, SHIFT(2220),
  [4629] = {.count = 1, .reusable = false}, SHIFT(2221),
  [4631] = {.count = 1, .reusable = false}, SHIFT(2222),
  [4633] = {.count = 1, .reusable = false}, SHIFT(2223),
  [4635] = {.count = 1, .reusable = false}, SHIFT(2224),
  [4637] = {.count = 1, .reusable = false}, SHIFT(2225),
  [4639] = {.count = 1, .reusable = false}, SHIFT(2226),
  [4641] = {.count = 1, .reusable = true}, SHIFT(2226),
  [4643] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [4645] = {.count = 1, .reusable = true}, SHIFT(2228),
  [4647] = {.count = 1, .reusable = false}, SHIFT(2229),
  [4649] = {.count = 1, .reusable = true}, SHIFT(2230),
  [4651] = {.count = 1, .reusable = true}, SHIFT(2235),
  [4653] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [4655] = {.count = 1, .reusable = true}, SHIFT(2239),
  [4657] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .alias_sequence_id = 11),
  [4659] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .alias_sequence_id = 11),
  [4661] = {.count = 1, .reusable = true}, SHIFT(2245),
  [4663] = {.count = 1, .reusable = false}, SHIFT(2246),
  [4665] = {.count = 1, .reusable = true}, SHIFT(2243),
  [4667] = {.count = 1, .reusable = true}, SHIFT(2247),
  [4669] = {.count = 1, .reusable = true}, SHIFT(2248),
  [4671] = {.count = 1, .reusable = false}, SHIFT(2244),
  [4673] = {.count = 1, .reusable = true}, SHIFT(2250),
  [4675] = {.count = 1, .reusable = true}, SHIFT(2249),
  [4677] = {.count = 1, .reusable = true}, SHIFT(2251),
  [4679] = {.count = 1, .reusable = false}, SHIFT(2252),
  [4681] = {.count = 1, .reusable = true}, SHIFT(2252),
  [4683] = {.count = 1, .reusable = false}, SHIFT(2253),
  [4685] = {.count = 1, .reusable = true}, SHIFT(2253),
  [4687] = {.count = 1, .reusable = false}, SHIFT(2254),
  [4689] = {.count = 1, .reusable = false}, SHIFT(2255),
  [4691] = {.count = 1, .reusable = false}, SHIFT(2256),
  [4693] = {.count = 1, .reusable = true}, SHIFT(2256),
  [4695] = {.count = 1, .reusable = false}, SHIFT(2257),
  [4697] = {.count = 1, .reusable = true}, SHIFT(2257),
  [4699] = {.count = 1, .reusable = false}, SHIFT(2258),
  [4701] = {.count = 1, .reusable = false}, SHIFT(2259),
  [4703] = {.count = 1, .reusable = false}, SHIFT(2260),
  [4705] = {.count = 1, .reusable = false}, SHIFT(2261),
  [4707] = {.count = 1, .reusable = false}, SHIFT(2262),
  [4709] = {.count = 1, .reusable = false}, SHIFT(2263),
  [4711] = {.count = 1, .reusable = true}, SHIFT(2263),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2264),
  [4715] = {.count = 1, .reusable = false}, SHIFT(2264),
  [4717] = {.count = 1, .reusable = false}, SHIFT(2265),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2266),
  [4721] = {.count = 1, .reusable = false}, SHIFT(2267),
  [4723] = {.count = 1, .reusable = false}, SHIFT(2266),
  [4725] = {.count = 1, .reusable = true}, SHIFT(2268),
  [4727] = {.count = 1, .reusable = true}, SHIFT(2269),
  [4729] = {.count = 1, .reusable = false}, SHIFT(2268),
  [4731] = {.count = 1, .reusable = true}, SHIFT(2270),
  [4733] = {.count = 1, .reusable = true}, SHIFT(2265),
  [4735] = {.count = 1, .reusable = true}, SHIFT(2271),
  [4737] = {.count = 1, .reusable = false}, SHIFT(2272),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2273),
  [4741] = {.count = 1, .reusable = true}, SHIFT(2274),
  [4743] = {.count = 1, .reusable = true}, SHIFT(2275),
  [4745] = {.count = 1, .reusable = true}, SHIFT(2276),
  [4747] = {.count = 1, .reusable = true}, SHIFT(2278),
  [4749] = {.count = 1, .reusable = false}, SHIFT(2279),
  [4751] = {.count = 1, .reusable = true}, SHIFT(2282),
  [4753] = {.count = 1, .reusable = true}, SHIFT(2280),
  [4755] = {.count = 1, .reusable = false}, SHIFT(2281),
  [4757] = {.count = 1, .reusable = false}, SHIFT(2283),
  [4759] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2),
  [4761] = {.count = 1, .reusable = true}, SHIFT(2284),
  [4763] = {.count = 1, .reusable = true}, SHIFT(2285),
  [4765] = {.count = 1, .reusable = false}, SHIFT(2288),
  [4767] = {.count = 1, .reusable = true}, SHIFT(2289),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2290),
  [4771] = {.count = 1, .reusable = true}, SHIFT(2291),
  [4773] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4775] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4777] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2),
  [4779] = {.count = 1, .reusable = true}, SHIFT(2295),
  [4781] = {.count = 1, .reusable = true}, SHIFT(2297),
  [4783] = {.count = 1, .reusable = false}, SHIFT(2299),
  [4785] = {.count = 1, .reusable = false}, SHIFT(2300),
  [4787] = {.count = 1, .reusable = false}, SHIFT(2301),
  [4789] = {.count = 1, .reusable = true}, SHIFT(2303),
  [4791] = {.count = 1, .reusable = true}, SHIFT(2302),
  [4793] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [4795] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [4797] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(619),
  [4800] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(618),
  [4803] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(195),
  [4806] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(620),
  [4809] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(621),
  [4812] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(622),
  [4815] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(623),
  [4818] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(624),
  [4821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(626),
  [4824] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(631),
  [4827] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(627),
  [4830] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(628),
  [4833] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(629),
  [4836] = {.count = 1, .reusable = true}, SHIFT(2304),
  [4838] = {.count = 1, .reusable = true}, SHIFT(1176),
  [4840] = {.count = 1, .reusable = true}, SHIFT(2316),
  [4842] = {.count = 1, .reusable = true}, SHIFT(2314),
  [4844] = {.count = 1, .reusable = false}, SHIFT(2315),
  [4846] = {.count = 1, .reusable = true}, SHIFT(2318),
  [4848] = {.count = 1, .reusable = true}, SHIFT(2317),
  [4850] = {.count = 1, .reusable = false}, SHIFT(2319),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2319),
  [4854] = {.count = 1, .reusable = false}, SHIFT(2320),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2320),
  [4858] = {.count = 1, .reusable = false}, SHIFT(2321),
  [4860] = {.count = 1, .reusable = false}, SHIFT(2322),
  [4862] = {.count = 1, .reusable = false}, SHIFT(2323),
  [4864] = {.count = 1, .reusable = true}, SHIFT(2323),
  [4866] = {.count = 1, .reusable = false}, SHIFT(2324),
  [4868] = {.count = 1, .reusable = true}, SHIFT(2324),
  [4870] = {.count = 1, .reusable = false}, SHIFT(2325),
  [4872] = {.count = 1, .reusable = false}, SHIFT(2326),
  [4874] = {.count = 1, .reusable = false}, SHIFT(2327),
  [4876] = {.count = 1, .reusable = false}, SHIFT(2328),
  [4878] = {.count = 1, .reusable = false}, SHIFT(2329),
  [4880] = {.count = 1, .reusable = false}, SHIFT(2330),
  [4882] = {.count = 1, .reusable = true}, SHIFT(2330),
  [4884] = {.count = 1, .reusable = true}, SHIFT(2315),
  [4886] = {.count = 1, .reusable = false}, SHIFT(2331),
  [4888] = {.count = 1, .reusable = true}, SHIFT(2332),
  [4890] = {.count = 1, .reusable = false}, SHIFT(2332),
  [4892] = {.count = 1, .reusable = true}, SHIFT(2334),
  [4894] = {.count = 1, .reusable = false}, SHIFT(2333),
  [4896] = {.count = 1, .reusable = false}, SHIFT(2334),
  [4898] = {.count = 1, .reusable = true}, SHIFT(2335),
  [4900] = {.count = 1, .reusable = true}, SHIFT(2336),
  [4902] = {.count = 1, .reusable = true}, SHIFT(2331),
  [4904] = {.count = 1, .reusable = false}, SHIFT(2337),
  [4906] = {.count = 1, .reusable = true}, SHIFT(2338),
  [4908] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .alias_sequence_id = 12),
  [4910] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .alias_sequence_id = 12),
  [4912] = {.count = 1, .reusable = false}, SHIFT(2340),
  [4914] = {.count = 1, .reusable = true}, SHIFT(2339),
  [4916] = {.count = 1, .reusable = true}, SHIFT(2340),
  [4918] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 3),
  [4920] = {.count = 1, .reusable = true}, SHIFT(2343),
  [4922] = {.count = 1, .reusable = true}, SHIFT(2346),
  [4924] = {.count = 1, .reusable = true}, SHIFT(2347),
  [4926] = {.count = 1, .reusable = false}, SHIFT(2348),
  [4928] = {.count = 1, .reusable = true}, SHIFT(2349),
  [4930] = {.count = 1, .reusable = true}, SHIFT(2350),
  [4932] = {.count = 1, .reusable = true}, SHIFT(2352),
  [4934] = {.count = 1, .reusable = true}, SHIFT(2353),
  [4936] = {.count = 1, .reusable = true}, SHIFT(2354),
  [4938] = {.count = 1, .reusable = true}, SHIFT(2355),
  [4940] = {.count = 1, .reusable = true}, SHIFT(2356),
  [4942] = {.count = 1, .reusable = false}, SHIFT(2360),
  [4944] = {.count = 1, .reusable = true}, SHIFT(2361),
  [4946] = {.count = 1, .reusable = false}, SHIFT(2363),
  [4948] = {.count = 1, .reusable = false}, SHIFT(2362),
  [4950] = {.count = 1, .reusable = true}, SHIFT(2367),
  [4952] = {.count = 1, .reusable = false}, SHIFT(2366),
  [4954] = {.count = 1, .reusable = true}, SHIFT(2368),
  [4956] = {.count = 1, .reusable = true}, SHIFT(2372),
  [4958] = {.count = 1, .reusable = false}, SHIFT(2373),
  [4960] = {.count = 1, .reusable = true}, SHIFT(2374),
  [4962] = {.count = 1, .reusable = false}, SHIFT(2375),
  [4964] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4967] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4970] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [4972] = {.count = 1, .reusable = true}, SHIFT(2376),
  [4974] = {.count = 1, .reusable = false}, SHIFT(2377),
  [4976] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [4978] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [4980] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [4982] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3),
  [4984] = {.count = 1, .reusable = true}, SHIFT(2378),
  [4986] = {.count = 1, .reusable = true}, SHIFT(2381),
  [4988] = {.count = 1, .reusable = false}, SHIFT(2379),
  [4990] = {.count = 1, .reusable = false}, SHIFT(2391),
  [4992] = {.count = 1, .reusable = false}, SHIFT(2380),
  [4994] = {.count = 1, .reusable = false}, SHIFT(2381),
  [4996] = {.count = 1, .reusable = false}, SHIFT(2382),
  [4998] = {.count = 1, .reusable = false}, SHIFT(2383),
  [5000] = {.count = 1, .reusable = false}, SHIFT(2384),
  [5002] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5004] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5006] = {.count = 1, .reusable = false}, SHIFT(2386),
  [5008] = {.count = 1, .reusable = false}, SHIFT(2387),
  [5010] = {.count = 1, .reusable = false}, SHIFT(2388),
  [5012] = {.count = 1, .reusable = false}, SHIFT(2389),
  [5014] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [5016] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [5018] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5020] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5022] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [5024] = {.count = 1, .reusable = true}, SHIFT(2402),
  [5026] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5028] = {.count = 1, .reusable = true}, SHIFT(2405),
  [5030] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5032] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5034] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5036] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3),
  [5038] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 6),
  [5040] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 6),
  [5042] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 14),
  [5044] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 14),
  [5046] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 15),
  [5048] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 15),
  [5050] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 1),
  [5052] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 1),
  [5054] = {.count = 1, .reusable = false}, SHIFT(2422),
  [5056] = {.count = 1, .reusable = true}, SHIFT(2423),
  [5058] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5060] = {.count = 1, .reusable = false}, SHIFT(2425),
  [5062] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5064] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [5066] = {.count = 1, .reusable = false}, SHIFT(2431),
  [5068] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5070] = {.count = 1, .reusable = false}, SHIFT(2432),
  [5072] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5074] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [5076] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [5078] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5080] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(2436),
  [5083] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(747),
  [5086] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5088] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5090] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(2438),
  [5093] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2445),
  [5096] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5098] = {.count = 1, .reusable = false}, SHIFT(2447),
  [5100] = {.count = 1, .reusable = false}, SHIFT(2448),
  [5102] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [5104] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [5106] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 18),
  [5108] = {.count = 1, .reusable = true}, SHIFT(2449),
  [5110] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5112] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 19),
  [5114] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5116] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 20),
  [5118] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5120] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5122] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 3),
  [5124] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 3),
  [5126] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 4),
  [5128] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 4),
  [5130] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4),
  [5132] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4),
  [5134] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .alias_sequence_id = 6),
  [5136] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .alias_sequence_id = 6),
  [5138] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5140] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4),
  [5142] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4),
  [5144] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [5146] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [5148] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5150] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2),
  [5152] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2),
  [5154] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2),
  [5156] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2),
  [5158] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4),
  [5160] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4),
  [5162] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [5164] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5166] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5168] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [5170] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5172] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5174] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5176] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5178] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5180] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5182] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5184] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5186] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5188] = {.count = 1, .reusable = true}, SHIFT(2483),
  [5190] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5192] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .alias_sequence_id = 16),
  [5194] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .alias_sequence_id = 16),
  [5196] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type, 3, .alias_sequence_id = 5),
  [5198] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5200] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5202] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5204] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [5206] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .alias_sequence_id = 5),
  [5208] = {.count = 1, .reusable = true}, SHIFT(2491),
  [5210] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5212] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5214] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5216] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5218] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5220] = {.count = 1, .reusable = true}, SHIFT(2500),
  [5222] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5224] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5226] = {.count = 1, .reusable = false}, SHIFT(2504),
  [5228] = {.count = 1, .reusable = true}, SHIFT(2507),
  [5230] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5232] = {.count = 1, .reusable = false}, SHIFT(2506),
  [5234] = {.count = 1, .reusable = false}, SHIFT(2508),
  [5236] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2),
  [5238] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5240] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [5242] = {.count = 1, .reusable = true}, SHIFT(2514),
  [5244] = {.count = 1, .reusable = false}, SHIFT(2515),
  [5246] = {.count = 1, .reusable = true}, SHIFT(2515),
  [5248] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5250] = {.count = 1, .reusable = true}, SHIFT(127),
  [5252] = {.count = 1, .reusable = true}, SHIFT(2518),
  [5254] = {.count = 1, .reusable = true}, SHIFT(175),
  [5256] = {.count = 1, .reusable = true}, SHIFT(2519),
  [5258] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5260] = {.count = 1, .reusable = true}, SHIFT(2522),
  [5262] = {.count = 1, .reusable = true}, SHIFT(2523),
  [5264] = {.count = 1, .reusable = false}, SHIFT(2524),
  [5266] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5268] = {.count = 1, .reusable = true}, SHIFT(2527),
  [5270] = {.count = 1, .reusable = true}, SHIFT(2528),
  [5272] = {.count = 1, .reusable = true}, SHIFT(2529),
  [5274] = {.count = 1, .reusable = true}, SHIFT(2530),
  [5276] = {.count = 1, .reusable = true}, SHIFT(2531),
  [5278] = {.count = 1, .reusable = true}, SHIFT(2532),
  [5280] = {.count = 1, .reusable = false}, SHIFT(2533),
  [5282] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5284] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5286] = {.count = 1, .reusable = false}, SHIFT(2536),
  [5288] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5290] = {.count = 1, .reusable = false}, SHIFT(2542),
  [5292] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [5294] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [5296] = {.count = 1, .reusable = true}, SHIFT(2546),
  [5298] = {.count = 1, .reusable = false}, SHIFT(2547),
  [5300] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5302] = {.count = 1, .reusable = true}, SHIFT(2553),
  [5304] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [5306] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [5308] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5310] = {.count = 1, .reusable = true}, SHIFT(2558),
  [5312] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5314] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5316] = {.count = 1, .reusable = false}, SHIFT(2563),
  [5318] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5320] = {.count = 1, .reusable = false}, SHIFT(2566),
  [5322] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(1634),
  [5325] = {.count = 1, .reusable = true}, SHIFT(2570),
  [5327] = {.count = 1, .reusable = false}, SHIFT(2571),
  [5329] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5331] = {.count = 1, .reusable = false}, SHIFT(2577),
  [5333] = {.count = 1, .reusable = false}, SHIFT(2582),
  [5335] = {.count = 1, .reusable = false}, SHIFT(2578),
  [5337] = {.count = 1, .reusable = false}, SHIFT(2579),
  [5339] = {.count = 1, .reusable = false}, SHIFT(2580),
  [5341] = {.count = 1, .reusable = true}, SHIFT(2582),
  [5343] = {.count = 1, .reusable = false}, SHIFT(2581),
  [5345] = {.count = 1, .reusable = false}, SHIFT(2583),
  [5347] = {.count = 1, .reusable = false}, SHIFT(2584),
  [5349] = {.count = 1, .reusable = false}, SHIFT(2585),
  [5351] = {.count = 1, .reusable = false}, SHIFT(2586),
  [5353] = {.count = 1, .reusable = false}, SHIFT(2587),
  [5355] = {.count = 1, .reusable = false}, SHIFT(2588),
  [5357] = {.count = 1, .reusable = true}, SHIFT(2590),
  [5359] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5361] = {.count = 1, .reusable = false}, SHIFT(2591),
  [5363] = {.count = 1, .reusable = false}, SHIFT(2593),
  [5365] = {.count = 1, .reusable = false}, SHIFT(2595),
  [5367] = {.count = 1, .reusable = true}, SHIFT(2596),
  [5369] = {.count = 1, .reusable = false}, SHIFT(2594),
  [5371] = {.count = 1, .reusable = false}, SHIFT(2597),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5375] = {.count = 1, .reusable = true}, SHIFT(2599),
  [5377] = {.count = 1, .reusable = false}, SHIFT(2603),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5381] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [5383] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [5385] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5387] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [5389] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [5391] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [5393] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [5395] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [5397] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [5399] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5401] = {.count = 1, .reusable = true}, SHIFT(2609),
  [5403] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(2610),
  [5406] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type, 3),
  [5408] = {.count = 1, .reusable = true}, SHIFT(2612),
  [5410] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [5412] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [5414] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [5416] = {.count = 1, .reusable = true}, SHIFT(2613),
  [5418] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2614),
  [5421] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [5423] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [5425] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [5427] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4),
  [5429] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4),
  [5431] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4),
  [5433] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4),
  [5435] = {.count = 1, .reusable = false}, SHIFT(2615),
  [5437] = {.count = 1, .reusable = true}, SHIFT(2616),
  [5439] = {.count = 1, .reusable = true}, SHIFT(2617),
  [5441] = {.count = 1, .reusable = false}, SHIFT(2618),
  [5443] = {.count = 1, .reusable = true}, SHIFT(2619),
  [5445] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4),
  [5447] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4),
  [5449] = {.count = 1, .reusable = true}, SHIFT(2626),
  [5451] = {.count = 1, .reusable = true}, SHIFT(2625),
  [5453] = {.count = 1, .reusable = true}, SHIFT(2629),
  [5455] = {.count = 1, .reusable = true}, SHIFT(2630),
  [5457] = {.count = 1, .reusable = true}, SHIFT(2632),
  [5459] = {.count = 1, .reusable = true}, SHIFT(2633),
  [5461] = {.count = 1, .reusable = true}, SHIFT(2634),
  [5463] = {.count = 1, .reusable = true}, SHIFT(2635),
  [5465] = {.count = 1, .reusable = false}, SHIFT(2636),
  [5467] = {.count = 1, .reusable = true}, SHIFT(2637),
  [5469] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(890),
  [5472] = {.count = 1, .reusable = true}, SHIFT(2638),
  [5474] = {.count = 1, .reusable = true}, SHIFT(2640),
  [5476] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(2639),
  [5479] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2646),
  [5482] = {.count = 1, .reusable = true}, SHIFT(2647),
  [5484] = {.count = 1, .reusable = true}, SHIFT(2649),
  [5486] = {.count = 1, .reusable = false}, SHIFT(2648),
  [5488] = {.count = 1, .reusable = false}, SHIFT(2650),
  [5490] = {.count = 1, .reusable = true}, SHIFT(2651),
  [5492] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4),
  [5494] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4),
  [5496] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [5498] = {.count = 1, .reusable = true}, SHIFT(2652),
  [5500] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .alias_sequence_id = 21),
  [5502] = {.count = 1, .reusable = true}, SHIFT(2654),
  [5504] = {.count = 1, .reusable = false}, SHIFT(2656),
  [5506] = {.count = 1, .reusable = true}, SHIFT(2656),
  [5508] = {.count = 1, .reusable = false}, SHIFT(2657),
  [5510] = {.count = 1, .reusable = true}, SHIFT(2657),
  [5512] = {.count = 1, .reusable = false}, SHIFT(2658),
  [5514] = {.count = 1, .reusable = true}, SHIFT(2658),
  [5516] = {.count = 1, .reusable = false}, SHIFT(2659),
  [5518] = {.count = 1, .reusable = true}, SHIFT(2659),
  [5520] = {.count = 1, .reusable = false}, SHIFT(2660),
  [5522] = {.count = 1, .reusable = true}, SHIFT(2660),
  [5524] = {.count = 1, .reusable = false}, SHIFT(2661),
  [5526] = {.count = 1, .reusable = true}, SHIFT(2661),
  [5528] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1776),
  [5531] = {.count = 1, .reusable = true}, SHIFT(2662),
  [5533] = {.count = 1, .reusable = true}, SHIFT(2663),
  [5535] = {.count = 1, .reusable = false}, SHIFT(2664),
  [5537] = {.count = 1, .reusable = true}, SHIFT(2664),
  [5539] = {.count = 1, .reusable = false}, SHIFT(2665),
  [5541] = {.count = 1, .reusable = true}, SHIFT(2665),
  [5543] = {.count = 1, .reusable = false}, SHIFT(2666),
  [5545] = {.count = 1, .reusable = true}, SHIFT(2666),
  [5547] = {.count = 1, .reusable = false}, SHIFT(2667),
  [5549] = {.count = 1, .reusable = true}, SHIFT(2667),
  [5551] = {.count = 1, .reusable = false}, SHIFT(2668),
  [5553] = {.count = 1, .reusable = true}, SHIFT(2668),
  [5555] = {.count = 1, .reusable = false}, SHIFT(2669),
  [5557] = {.count = 1, .reusable = true}, SHIFT(2673),
  [5559] = {.count = 1, .reusable = true}, SHIFT(2671),
  [5561] = {.count = 1, .reusable = true}, SHIFT(2670),
  [5563] = {.count = 1, .reusable = false}, SHIFT(2672),
  [5565] = {.count = 1, .reusable = false}, SHIFT(2677),
  [5567] = {.count = 1, .reusable = false}, SHIFT(2678),
  [5569] = {.count = 1, .reusable = false}, SHIFT(2679),
  [5571] = {.count = 1, .reusable = false}, SHIFT(2680),
  [5573] = {.count = 1, .reusable = false}, SHIFT(2681),
  [5575] = {.count = 1, .reusable = false}, SHIFT(2682),
  [5577] = {.count = 1, .reusable = false}, SHIFT(2683),
  [5579] = {.count = 1, .reusable = false}, SHIFT(2684),
  [5581] = {.count = 1, .reusable = true}, SHIFT(2678),
  [5583] = {.count = 1, .reusable = false}, SHIFT(2685),
  [5585] = {.count = 1, .reusable = false}, SHIFT(2686),
  [5587] = {.count = 1, .reusable = true}, SHIFT(2686),
  [5589] = {.count = 1, .reusable = true}, SHIFT(2687),
  [5591] = {.count = 1, .reusable = true}, SHIFT(2688),
  [5593] = {.count = 1, .reusable = true}, SHIFT(2690),
  [5595] = {.count = 1, .reusable = true}, SHIFT(2691),
  [5597] = {.count = 1, .reusable = true}, SHIFT(2692),
  [5599] = {.count = 1, .reusable = true}, SHIFT(2693),
  [5601] = {.count = 1, .reusable = true}, SHIFT(2694),
  [5603] = {.count = 1, .reusable = true}, SHIFT(2698),
  [5605] = {.count = 1, .reusable = true}, SHIFT(2699),
  [5607] = {.count = 1, .reusable = false}, SHIFT(2703),
  [5609] = {.count = 1, .reusable = false}, SHIFT(2702),
  [5611] = {.count = 1, .reusable = true}, SHIFT(2707),
  [5613] = {.count = 1, .reusable = false}, SHIFT(2706),
  [5615] = {.count = 1, .reusable = true}, SHIFT(2708),
  [5617] = {.count = 1, .reusable = true}, SHIFT(2712),
  [5619] = {.count = 1, .reusable = false}, SHIFT(2713),
  [5621] = {.count = 1, .reusable = true}, SHIFT(2714),
  [5623] = {.count = 1, .reusable = false}, SHIFT(2715),
  [5625] = {.count = 1, .reusable = true}, SHIFT(2716),
  [5627] = {.count = 1, .reusable = true}, SHIFT(2717),
  [5629] = {.count = 1, .reusable = true}, SHIFT(2720),
  [5631] = {.count = 1, .reusable = true}, SHIFT(1281),
  [5633] = {.count = 1, .reusable = true}, SHIFT(2722),
  [5635] = {.count = 1, .reusable = true}, SHIFT(2723),
  [5637] = {.count = 1, .reusable = false}, SHIFT(2724),
  [5639] = {.count = 1, .reusable = true}, SHIFT(2725),
  [5641] = {.count = 1, .reusable = true}, SHIFT(2730),
  [5643] = {.count = 1, .reusable = true}, SHIFT(2732),
  [5645] = {.count = 1, .reusable = false}, SHIFT(2735),
  [5647] = {.count = 1, .reusable = true}, SHIFT(2735),
  [5649] = {.count = 1, .reusable = false}, SHIFT(2736),
  [5651] = {.count = 1, .reusable = true}, SHIFT(2736),
  [5653] = {.count = 1, .reusable = false}, SHIFT(2737),
  [5655] = {.count = 1, .reusable = true}, SHIFT(2737),
  [5657] = {.count = 1, .reusable = false}, SHIFT(2738),
  [5659] = {.count = 1, .reusable = true}, SHIFT(2738),
  [5661] = {.count = 1, .reusable = false}, SHIFT(2739),
  [5663] = {.count = 1, .reusable = true}, SHIFT(2739),
  [5665] = {.count = 1, .reusable = false}, SHIFT(2740),
  [5667] = {.count = 1, .reusable = true}, SHIFT(2740),
  [5669] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1837),
  [5672] = {.count = 1, .reusable = true}, SHIFT(2741),
  [5674] = {.count = 1, .reusable = true}, SHIFT(2742),
  [5676] = {.count = 1, .reusable = false}, SHIFT(2743),
  [5678] = {.count = 1, .reusable = true}, SHIFT(2743),
  [5680] = {.count = 1, .reusable = false}, SHIFT(2744),
  [5682] = {.count = 1, .reusable = true}, SHIFT(2744),
  [5684] = {.count = 1, .reusable = false}, SHIFT(2745),
  [5686] = {.count = 1, .reusable = true}, SHIFT(2745),
  [5688] = {.count = 1, .reusable = false}, SHIFT(2746),
  [5690] = {.count = 1, .reusable = true}, SHIFT(2746),
  [5692] = {.count = 1, .reusable = false}, SHIFT(2747),
  [5694] = {.count = 1, .reusable = true}, SHIFT(2747),
  [5696] = {.count = 1, .reusable = false}, SHIFT(2748),
  [5698] = {.count = 1, .reusable = true}, SHIFT(2752),
  [5700] = {.count = 1, .reusable = true}, SHIFT(2750),
  [5702] = {.count = 1, .reusable = true}, SHIFT(2749),
  [5704] = {.count = 1, .reusable = false}, SHIFT(2751),
  [5706] = {.count = 1, .reusable = false}, SHIFT(2756),
  [5708] = {.count = 1, .reusable = false}, SHIFT(2757),
  [5710] = {.count = 1, .reusable = false}, SHIFT(2758),
  [5712] = {.count = 1, .reusable = false}, SHIFT(2759),
  [5714] = {.count = 1, .reusable = false}, SHIFT(2760),
  [5716] = {.count = 1, .reusable = false}, SHIFT(2761),
  [5718] = {.count = 1, .reusable = false}, SHIFT(2762),
  [5720] = {.count = 1, .reusable = true}, SHIFT(2762),
  [5722] = {.count = 1, .reusable = false}, SHIFT(2763),
  [5724] = {.count = 1, .reusable = true}, SHIFT(2763),
  [5726] = {.count = 1, .reusable = true}, SHIFT(2767),
  [5728] = {.count = 1, .reusable = true}, SHIFT(2770),
  [5730] = {.count = 1, .reusable = true}, SHIFT(2771),
  [5732] = {.count = 1, .reusable = true}, SHIFT(2773),
  [5734] = {.count = 1, .reusable = true}, SHIFT(2775),
  [5736] = {.count = 1, .reusable = true}, SHIFT(2777),
  [5738] = {.count = 1, .reusable = true}, SHIFT(2780),
  [5740] = {.count = 1, .reusable = true}, SHIFT(2783),
  [5742] = {.count = 1, .reusable = false}, SHIFT(2785),
  [5744] = {.count = 1, .reusable = true}, SHIFT(2788),
  [5746] = {.count = 1, .reusable = true}, SHIFT(2789),
  [5748] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [5752] = {.count = 1, .reusable = true}, SHIFT(2791),
  [5754] = {.count = 1, .reusable = false}, SHIFT(2790),
  [5756] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym_required_parameter, 1, .alias_sequence_id = 1), REDUCE(sym_predefined_type, 1),
  [5760] = {.count = 1, .reusable = true}, SHIFT(2792),
  [5762] = {.count = 1, .reusable = false}, SHIFT(2793),
  [5764] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(1671),
  [5767] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(1635),
  [5770] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(1678),
  [5773] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .alias_sequence_id = 16),
  [5775] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .alias_sequence_id = 16),
  [5777] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 4),
  [5779] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 4),
  [5781] = {.count = 1, .reusable = false}, SHIFT(2800),
  [5783] = {.count = 1, .reusable = true}, SHIFT(2800),
  [5785] = {.count = 1, .reusable = false}, SHIFT(2801),
  [5787] = {.count = 1, .reusable = true}, SHIFT(2801),
  [5789] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1034),
  [5792] = {.count = 1, .reusable = true}, SHIFT(2802),
  [5794] = {.count = 1, .reusable = true}, SHIFT(2804),
  [5796] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(2803),
  [5799] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2810),
  [5802] = {.count = 1, .reusable = true}, SHIFT(2811),
  [5804] = {.count = 1, .reusable = false}, SHIFT(2812),
  [5806] = {.count = 1, .reusable = false}, SHIFT(2813),
  [5808] = {.count = 1, .reusable = true}, SHIFT(2814),
  [5810] = {.count = 1, .reusable = true}, SHIFT(2815),
  [5812] = {.count = 1, .reusable = false}, SHIFT(2816),
  [5814] = {.count = 1, .reusable = true}, SHIFT(2817),
  [5816] = {.count = 1, .reusable = true}, SHIFT(2823),
  [5818] = {.count = 1, .reusable = true}, SHIFT(2826),
  [5820] = {.count = 1, .reusable = true}, SHIFT(2827),
  [5822] = {.count = 1, .reusable = true}, SHIFT(2829),
  [5824] = {.count = 1, .reusable = true}, SHIFT(2831),
  [5826] = {.count = 1, .reusable = true}, SHIFT(2832),
  [5828] = {.count = 1, .reusable = true}, SHIFT(2834),
  [5830] = {.count = 1, .reusable = true}, SHIFT(2837),
  [5832] = {.count = 1, .reusable = true}, SHIFT(2840),
  [5834] = {.count = 1, .reusable = true}, SHIFT(2842),
  [5836] = {.count = 1, .reusable = true}, SHIFT(2843),
  [5838] = {.count = 1, .reusable = false}, SHIFT(2844),
  [5840] = {.count = 1, .reusable = true}, SHIFT(2845),
  [5842] = {.count = 1, .reusable = true}, SHIFT(2850),
  [5844] = {.count = 1, .reusable = true}, SHIFT(2852),
  [5846] = {.count = 1, .reusable = false}, SHIFT(2855),
  [5848] = {.count = 1, .reusable = true}, SHIFT(2855),
  [5850] = {.count = 1, .reusable = false}, SHIFT(2856),
  [5852] = {.count = 1, .reusable = true}, SHIFT(2856),
  [5854] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1118),
  [5857] = {.count = 1, .reusable = true}, SHIFT(2857),
  [5859] = {.count = 1, .reusable = true}, SHIFT(2859),
  [5861] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(2858),
  [5864] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2865),
  [5867] = {.count = 1, .reusable = true}, SHIFT(2866),
  [5869] = {.count = 1, .reusable = false}, SHIFT(2867),
  [5871] = {.count = 1, .reusable = false}, SHIFT(2868),
  [5873] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [5875] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [5877] = {.count = 1, .reusable = false}, SHIFT(2869),
  [5879] = {.count = 1, .reusable = true}, SHIFT(2869),
  [5881] = {.count = 1, .reusable = false}, SHIFT(2870),
  [5883] = {.count = 1, .reusable = true}, SHIFT(2870),
  [5885] = {.count = 1, .reusable = false}, SHIFT(2871),
  [5887] = {.count = 1, .reusable = true}, SHIFT(2871),
  [5889] = {.count = 1, .reusable = false}, SHIFT(2872),
  [5891] = {.count = 1, .reusable = true}, SHIFT(2872),
  [5893] = {.count = 1, .reusable = false}, SHIFT(2873),
  [5895] = {.count = 1, .reusable = true}, SHIFT(2873),
  [5897] = {.count = 1, .reusable = false}, SHIFT(2874),
  [5899] = {.count = 1, .reusable = true}, SHIFT(2874),
  [5901] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2029),
  [5904] = {.count = 1, .reusable = true}, SHIFT(2875),
  [5906] = {.count = 1, .reusable = true}, SHIFT(2876),
  [5908] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [5910] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [5912] = {.count = 1, .reusable = false}, SHIFT(2877),
  [5914] = {.count = 1, .reusable = true}, SHIFT(2877),
  [5916] = {.count = 1, .reusable = false}, SHIFT(2878),
  [5918] = {.count = 1, .reusable = true}, SHIFT(2878),
  [5920] = {.count = 1, .reusable = false}, SHIFT(2879),
  [5922] = {.count = 1, .reusable = true}, SHIFT(2879),
  [5924] = {.count = 1, .reusable = false}, SHIFT(2880),
  [5926] = {.count = 1, .reusable = true}, SHIFT(2880),
  [5928] = {.count = 1, .reusable = false}, SHIFT(2881),
  [5930] = {.count = 1, .reusable = true}, SHIFT(2881),
  [5932] = {.count = 1, .reusable = false}, SHIFT(2882),
  [5934] = {.count = 1, .reusable = true}, SHIFT(2882),
  [5936] = {.count = 1, .reusable = false}, SHIFT(2883),
  [5938] = {.count = 1, .reusable = true}, SHIFT(2887),
  [5940] = {.count = 1, .reusable = true}, SHIFT(2885),
  [5942] = {.count = 1, .reusable = true}, SHIFT(2884),
  [5944] = {.count = 1, .reusable = false}, SHIFT(2886),
  [5946] = {.count = 1, .reusable = false}, SHIFT(2891),
  [5948] = {.count = 1, .reusable = false}, SHIFT(2892),
  [5950] = {.count = 1, .reusable = false}, SHIFT(2893),
  [5952] = {.count = 1, .reusable = false}, SHIFT(2894),
  [5954] = {.count = 1, .reusable = false}, SHIFT(2895),
  [5956] = {.count = 1, .reusable = false}, SHIFT(2896),
  [5958] = {.count = 1, .reusable = false}, SHIFT(2897),
  [5960] = {.count = 1, .reusable = true}, SHIFT(2897),
  [5962] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [5964] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .alias_sequence_id = 11),
  [5966] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .alias_sequence_id = 11),
  [5968] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2899),
  [5972] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [5974] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [5976] = {.count = 1, .reusable = true}, SHIFT(2901),
  [5978] = {.count = 1, .reusable = false}, SHIFT(2903),
  [5980] = {.count = 1, .reusable = false}, SHIFT(2905),
  [5982] = {.count = 1, .reusable = false}, SHIFT(2904),
  [5984] = {.count = 1, .reusable = true}, SHIFT(2909),
  [5986] = {.count = 1, .reusable = false}, SHIFT(2908),
  [5988] = {.count = 1, .reusable = true}, SHIFT(2910),
  [5990] = {.count = 1, .reusable = true}, SHIFT(2914),
  [5992] = {.count = 1, .reusable = false}, SHIFT(2915),
  [5994] = {.count = 1, .reusable = true}, SHIFT(2916),
  [5996] = {.count = 1, .reusable = false}, SHIFT(2917),
  [5998] = {.count = 1, .reusable = true}, SHIFT(2918),
  [6000] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [6002] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [6004] = {.count = 1, .reusable = true}, SHIFT(2919),
  [6006] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class, 5, .alias_sequence_id = 16),
  [6008] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class, 5, .alias_sequence_id = 16),
  [6010] = {.count = 1, .reusable = true}, SHIFT(2921),
  [6012] = {.count = 1, .reusable = false}, SHIFT(2922),
  [6014] = {.count = 1, .reusable = true}, SHIFT(2923),
  [6016] = {.count = 1, .reusable = true}, SHIFT(2928),
  [6018] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .alias_sequence_id = 11),
  [6020] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .alias_sequence_id = 11),
  [6022] = {.count = 1, .reusable = true}, SHIFT(2930),
  [6024] = {.count = 1, .reusable = true}, SHIFT(2933),
  [6026] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [6028] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [6030] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5),
  [6032] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5),
  [6034] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3),
  [6036] = {.count = 1, .reusable = true}, SHIFT(2935),
  [6038] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .alias_sequence_id = 17),
  [6040] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .alias_sequence_id = 17),
  [6042] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6044] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2937),
  [6047] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [6049] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6051] = {.count = 1, .reusable = true}, SHIFT(2939),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2940),
  [6055] = {.count = 1, .reusable = false}, SHIFT(2941),
  [6057] = {.count = 1, .reusable = true}, SHIFT(2941),
  [6059] = {.count = 1, .reusable = false}, SHIFT(2942),
  [6061] = {.count = 1, .reusable = true}, SHIFT(2942),
  [6063] = {.count = 1, .reusable = false}, SHIFT(2943),
  [6065] = {.count = 1, .reusable = true}, SHIFT(2943),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2946),
  [6069] = {.count = 1, .reusable = false}, SHIFT(2947),
  [6071] = {.count = 1, .reusable = true}, SHIFT(2944),
  [6073] = {.count = 1, .reusable = false}, SHIFT(2945),
  [6075] = {.count = 1, .reusable = true}, SHIFT(2949),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6079] = {.count = 1, .reusable = false}, SHIFT(2950),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6083] = {.count = 1, .reusable = false}, SHIFT(2951),
  [6085] = {.count = 1, .reusable = true}, SHIFT(2951),
  [6087] = {.count = 1, .reusable = false}, SHIFT(2952),
  [6089] = {.count = 1, .reusable = false}, SHIFT(2953),
  [6091] = {.count = 1, .reusable = false}, SHIFT(2954),
  [6093] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6095] = {.count = 1, .reusable = false}, SHIFT(2955),
  [6097] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6099] = {.count = 1, .reusable = false}, SHIFT(2956),
  [6101] = {.count = 1, .reusable = false}, SHIFT(2957),
  [6103] = {.count = 1, .reusable = false}, SHIFT(2958),
  [6105] = {.count = 1, .reusable = false}, SHIFT(2959),
  [6107] = {.count = 1, .reusable = false}, SHIFT(2960),
  [6109] = {.count = 1, .reusable = false}, SHIFT(2961),
  [6111] = {.count = 1, .reusable = true}, SHIFT(2961),
  [6113] = {.count = 1, .reusable = true}, SHIFT(2963),
  [6115] = {.count = 1, .reusable = false}, SHIFT(2963),
  [6117] = {.count = 1, .reusable = false}, SHIFT(2964),
  [6119] = {.count = 1, .reusable = true}, SHIFT(2967),
  [6121] = {.count = 1, .reusable = false}, SHIFT(2968),
  [6123] = {.count = 1, .reusable = true}, SHIFT(2969),
  [6125] = {.count = 1, .reusable = true}, SHIFT(2970),
  [6127] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6129] = {.count = 1, .reusable = false}, SHIFT(2974),
  [6131] = {.count = 1, .reusable = true}, SHIFT(2971),
  [6133] = {.count = 1, .reusable = false}, SHIFT(2972),
  [6135] = {.count = 1, .reusable = true}, SHIFT(2976),
  [6137] = {.count = 1, .reusable = true}, SHIFT(2975),
  [6139] = {.count = 1, .reusable = false}, SHIFT(2977),
  [6141] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6143] = {.count = 1, .reusable = false}, SHIFT(2978),
  [6145] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6147] = {.count = 1, .reusable = false}, SHIFT(2979),
  [6149] = {.count = 1, .reusable = false}, SHIFT(2980),
  [6151] = {.count = 1, .reusable = false}, SHIFT(2981),
  [6153] = {.count = 1, .reusable = true}, SHIFT(2981),
  [6155] = {.count = 1, .reusable = false}, SHIFT(2982),
  [6157] = {.count = 1, .reusable = true}, SHIFT(2982),
  [6159] = {.count = 1, .reusable = false}, SHIFT(2983),
  [6161] = {.count = 1, .reusable = false}, SHIFT(2984),
  [6163] = {.count = 1, .reusable = false}, SHIFT(2985),
  [6165] = {.count = 1, .reusable = false}, SHIFT(2986),
  [6167] = {.count = 1, .reusable = false}, SHIFT(2987),
  [6169] = {.count = 1, .reusable = false}, SHIFT(2988),
  [6171] = {.count = 1, .reusable = true}, SHIFT(2988),
  [6173] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6175] = {.count = 1, .reusable = false}, SHIFT(2989),
  [6177] = {.count = 1, .reusable = true}, SHIFT(2990),
  [6179] = {.count = 1, .reusable = false}, SHIFT(2991),
  [6181] = {.count = 1, .reusable = false}, SHIFT(2990),
  [6183] = {.count = 1, .reusable = true}, SHIFT(2992),
  [6185] = {.count = 1, .reusable = false}, SHIFT(2992),
  [6187] = {.count = 1, .reusable = true}, SHIFT(2993),
  [6189] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6191] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6193] = {.count = 1, .reusable = false}, SHIFT(2995),
  [6195] = {.count = 1, .reusable = true}, SHIFT(2996),
  [6197] = {.count = 1, .reusable = true}, SHIFT(2997),
  [6199] = {.count = 1, .reusable = false}, SHIFT(2998),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2998),
  [6203] = {.count = 1, .reusable = false}, SHIFT(3000),
  [6205] = {.count = 1, .reusable = true}, SHIFT(3000),
  [6207] = {.count = 1, .reusable = false}, SHIFT(3002),
  [6209] = {.count = 1, .reusable = true}, SHIFT(3002),
  [6211] = {.count = 1, .reusable = true}, SHIFT(3005),
  [6213] = {.count = 1, .reusable = true}, SHIFT(3006),
  [6215] = {.count = 1, .reusable = true}, SHIFT(3007),
  [6217] = {.count = 1, .reusable = true}, SHIFT(3008),
  [6219] = {.count = 1, .reusable = true}, SHIFT(3009),
  [6221] = {.count = 1, .reusable = true}, SHIFT(3010),
  [6223] = {.count = 1, .reusable = false}, SHIFT(3014),
  [6225] = {.count = 1, .reusable = true}, SHIFT(3014),
  [6227] = {.count = 1, .reusable = true}, SHIFT(3018),
  [6229] = {.count = 1, .reusable = true}, SHIFT(3021),
  [6231] = {.count = 1, .reusable = true}, SHIFT(3022),
  [6233] = {.count = 1, .reusable = true}, SHIFT(3024),
  [6235] = {.count = 1, .reusable = true}, SHIFT(3026),
  [6237] = {.count = 1, .reusable = true}, SHIFT(3028),
  [6239] = {.count = 1, .reusable = true}, SHIFT(3031),
  [6241] = {.count = 1, .reusable = true}, SHIFT(3034),
  [6243] = {.count = 1, .reusable = false}, SHIFT(3036),
  [6245] = {.count = 1, .reusable = true}, SHIFT(3037),
  [6247] = {.count = 1, .reusable = true}, SHIFT(3038),
  [6249] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 8), REDUCE(sym_nested_type_identifier, 3, .alias_sequence_id = 16),
  [6252] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 8), REDUCE(sym_nested_type_identifier, 3, .alias_sequence_id = 16),
  [6255] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .alias_sequence_id = 8),
  [6258] = {.count = 1, .reusable = false}, SHIFT(3041),
  [6260] = {.count = 1, .reusable = true}, SHIFT(3041),
  [6262] = {.count = 1, .reusable = false}, SHIFT(3042),
  [6264] = {.count = 1, .reusable = true}, SHIFT(3042),
  [6266] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [6268] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [6270] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1313),
  [6273] = {.count = 1, .reusable = true}, SHIFT(3043),
  [6275] = {.count = 1, .reusable = true}, SHIFT(3045),
  [6277] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(3044),
  [6280] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(3051),
  [6283] = {.count = 1, .reusable = true}, SHIFT(3052),
  [6285] = {.count = 1, .reusable = false}, SHIFT(3053),
  [6287] = {.count = 1, .reusable = false}, SHIFT(3054),
  [6289] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(1307),
  [6292] = {.count = 1, .reusable = true}, SHIFT(3057),
  [6294] = {.count = 1, .reusable = true}, SHIFT(3058),
  [6296] = {.count = 1, .reusable = true}, SHIFT(3060),
  [6298] = {.count = 1, .reusable = true}, SHIFT(3062),
  [6300] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1320),
  [6303] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .alias_sequence_id = 11),
  [6305] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .alias_sequence_id = 11),
  [6307] = {.count = 1, .reusable = false}, SHIFT(3064),
  [6309] = {.count = 1, .reusable = true}, SHIFT(3064),
  [6311] = {.count = 1, .reusable = false}, SHIFT(3065),
  [6313] = {.count = 1, .reusable = false}, SHIFT(3066),
  [6315] = {.count = 1, .reusable = false}, SHIFT(3067),
  [6317] = {.count = 1, .reusable = false}, SHIFT(3068),
  [6319] = {.count = 1, .reusable = false}, SHIFT(3069),
  [6321] = {.count = 1, .reusable = false}, SHIFT(3074),
  [6323] = {.count = 1, .reusable = false}, SHIFT(3070),
  [6325] = {.count = 1, .reusable = false}, SHIFT(3075),
  [6327] = {.count = 1, .reusable = true}, SHIFT(3075),
  [6329] = {.count = 1, .reusable = false}, SHIFT(3076),
  [6331] = {.count = 1, .reusable = true}, SHIFT(3076),
  [6333] = {.count = 1, .reusable = true}, SHIFT(270),
  [6335] = {.count = 1, .reusable = true}, SHIFT(3078),
  [6337] = {.count = 1, .reusable = false}, SHIFT(3079),
  [6339] = {.count = 1, .reusable = true}, SHIFT(3079),
  [6341] = {.count = 1, .reusable = false}, SHIFT(3080),
  [6343] = {.count = 1, .reusable = true}, SHIFT(3080),
  [6345] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2272),
  [6348] = {.count = 1, .reusable = true}, SHIFT(3082),
  [6350] = {.count = 1, .reusable = true}, SHIFT(3083),
  [6352] = {.count = 1, .reusable = true}, SHIFT(3074),
  [6354] = {.count = 1, .reusable = false}, SHIFT(3084),
  [6356] = {.count = 1, .reusable = true}, SHIFT(3084),
  [6358] = {.count = 1, .reusable = false}, SHIFT(3085),
  [6360] = {.count = 1, .reusable = true}, SHIFT(3085),
  [6362] = {.count = 1, .reusable = false}, SHIFT(3086),
  [6364] = {.count = 1, .reusable = true}, SHIFT(3086),
  [6366] = {.count = 1, .reusable = false}, SHIFT(3087),
  [6368] = {.count = 1, .reusable = true}, SHIFT(3087),
  [6370] = {.count = 1, .reusable = false}, SHIFT(3088),
  [6372] = {.count = 1, .reusable = true}, SHIFT(3088),
  [6374] = {.count = 1, .reusable = false}, SHIFT(3089),
  [6376] = {.count = 1, .reusable = true}, SHIFT(3093),
  [6378] = {.count = 1, .reusable = true}, SHIFT(3091),
  [6380] = {.count = 1, .reusable = true}, SHIFT(3090),
  [6382] = {.count = 1, .reusable = false}, SHIFT(3092),
  [6384] = {.count = 1, .reusable = false}, SHIFT(3097),
  [6386] = {.count = 1, .reusable = false}, SHIFT(3098),
  [6388] = {.count = 1, .reusable = false}, SHIFT(3099),
  [6390] = {.count = 1, .reusable = false}, SHIFT(3100),
  [6392] = {.count = 1, .reusable = false}, SHIFT(3101),
  [6394] = {.count = 1, .reusable = false}, SHIFT(3102),
  [6396] = {.count = 1, .reusable = false}, SHIFT(3103),
  [6398] = {.count = 1, .reusable = true}, SHIFT(3103),
  [6400] = {.count = 1, .reusable = true}, SHIFT(3104),
  [6402] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3),
  [6404] = {.count = 1, .reusable = true}, SHIFT(3109),
  [6406] = {.count = 1, .reusable = true}, SHIFT(3110),
  [6408] = {.count = 1, .reusable = true}, SHIFT(3112),
  [6410] = {.count = 1, .reusable = false}, SHIFT(3111),
  [6412] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3),
  [6414] = {.count = 1, .reusable = true}, SHIFT(3113),
  [6416] = {.count = 1, .reusable = true}, SHIFT(3114),
  [6418] = {.count = 1, .reusable = true}, SHIFT(3117),
  [6420] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3),
  [6422] = {.count = 1, .reusable = true}, SHIFT(3120),
  [6424] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3),
  [6426] = {.count = 1, .reusable = false}, SHIFT(3122),
  [6428] = {.count = 1, .reusable = true}, SHIFT(3123),
  [6430] = {.count = 1, .reusable = true}, SHIFT(3124),
  [6432] = {.count = 1, .reusable = false}, SHIFT(3125),
  [6434] = {.count = 1, .reusable = true}, SHIFT(3126),
  [6436] = {.count = 1, .reusable = false}, SHIFT(3131),
  [6438] = {.count = 1, .reusable = true}, SHIFT(3133),
  [6440] = {.count = 1, .reusable = false}, SHIFT(3132),
  [6442] = {.count = 1, .reusable = true}, SHIFT(3134),
  [6444] = {.count = 1, .reusable = true}, SHIFT(3135),
  [6446] = {.count = 1, .reusable = true}, SHIFT(3136),
  [6448] = {.count = 1, .reusable = false}, SHIFT(3137),
  [6450] = {.count = 1, .reusable = true}, SHIFT(3138),
  [6452] = {.count = 1, .reusable = true}, SHIFT(3139),
  [6454] = {.count = 1, .reusable = false}, SHIFT(3140),
  [6456] = {.count = 1, .reusable = true}, SHIFT(3141),
  [6458] = {.count = 1, .reusable = false}, SHIFT(3151),
  [6460] = {.count = 1, .reusable = true}, SHIFT(3151),
  [6462] = {.count = 1, .reusable = false}, SHIFT(3152),
  [6464] = {.count = 1, .reusable = true}, SHIFT(3152),
  [6466] = {.count = 1, .reusable = false}, SHIFT(3153),
  [6468] = {.count = 1, .reusable = true}, SHIFT(3153),
  [6470] = {.count = 1, .reusable = false}, SHIFT(3154),
  [6472] = {.count = 1, .reusable = true}, SHIFT(3154),
  [6474] = {.count = 1, .reusable = false}, SHIFT(3155),
  [6476] = {.count = 1, .reusable = true}, SHIFT(3155),
  [6478] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2337),
  [6481] = {.count = 1, .reusable = true}, SHIFT(3156),
  [6483] = {.count = 1, .reusable = true}, SHIFT(3157),
  [6485] = {.count = 1, .reusable = false}, SHIFT(3158),
  [6487] = {.count = 1, .reusable = true}, SHIFT(3158),
  [6489] = {.count = 1, .reusable = false}, SHIFT(3159),
  [6491] = {.count = 1, .reusable = true}, SHIFT(3159),
  [6493] = {.count = 1, .reusable = false}, SHIFT(3160),
  [6495] = {.count = 1, .reusable = true}, SHIFT(3160),
  [6497] = {.count = 1, .reusable = false}, SHIFT(3161),
  [6499] = {.count = 1, .reusable = true}, SHIFT(3161),
  [6501] = {.count = 1, .reusable = false}, SHIFT(3162),
  [6503] = {.count = 1, .reusable = true}, SHIFT(3162),
  [6505] = {.count = 1, .reusable = false}, SHIFT(3163),
  [6507] = {.count = 1, .reusable = true}, SHIFT(3167),
  [6509] = {.count = 1, .reusable = true}, SHIFT(3165),
  [6511] = {.count = 1, .reusable = true}, SHIFT(3164),
  [6513] = {.count = 1, .reusable = false}, SHIFT(3166),
  [6515] = {.count = 1, .reusable = false}, SHIFT(3171),
  [6517] = {.count = 1, .reusable = false}, SHIFT(3172),
  [6519] = {.count = 1, .reusable = false}, SHIFT(3173),
  [6521] = {.count = 1, .reusable = false}, SHIFT(3174),
  [6523] = {.count = 1, .reusable = false}, SHIFT(3175),
  [6525] = {.count = 1, .reusable = false}, SHIFT(3176),
  [6527] = {.count = 1, .reusable = false}, SHIFT(3177),
  [6529] = {.count = 1, .reusable = true}, SHIFT(3177),
  [6531] = {.count = 1, .reusable = true}, SHIFT(3178),
  [6533] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4),
  [6535] = {.count = 1, .reusable = true}, SHIFT(3182),
  [6537] = {.count = 1, .reusable = true}, SHIFT(3183),
  [6539] = {.count = 1, .reusable = true}, SHIFT(3185),
  [6541] = {.count = 1, .reusable = false}, SHIFT(3186),
  [6543] = {.count = 1, .reusable = false}, SHIFT(3187),
  [6545] = {.count = 1, .reusable = false}, SHIFT(3188),
  [6547] = {.count = 1, .reusable = true}, SHIFT(3192),
  [6549] = {.count = 1, .reusable = true}, SHIFT(3193),
  [6551] = {.count = 1, .reusable = true}, SHIFT(3196),
  [6553] = {.count = 1, .reusable = true}, SHIFT(3197),
  [6555] = {.count = 1, .reusable = true}, SHIFT(3198),
  [6557] = {.count = 1, .reusable = false}, SHIFT(3199),
  [6559] = {.count = 1, .reusable = true}, SHIFT(3199),
  [6561] = {.count = 1, .reusable = false}, SHIFT(3201),
  [6563] = {.count = 1, .reusable = true}, SHIFT(3201),
  [6565] = {.count = 1, .reusable = true}, SHIFT(3202),
  [6567] = {.count = 1, .reusable = true}, SHIFT(3203),
  [6569] = {.count = 1, .reusable = true}, SHIFT(3204),
  [6571] = {.count = 1, .reusable = false}, SHIFT(3206),
  [6573] = {.count = 1, .reusable = true}, SHIFT(3205),
  [6575] = {.count = 1, .reusable = true}, SHIFT(3206),
  [6577] = {.count = 1, .reusable = false}, SHIFT(3208),
  [6579] = {.count = 1, .reusable = true}, SHIFT(3208),
  [6581] = {.count = 1, .reusable = false}, SHIFT(3209),
  [6583] = {.count = 1, .reusable = true}, SHIFT(3209),
  [6585] = {.count = 1, .reusable = false}, SHIFT(3211),
  [6587] = {.count = 1, .reusable = true}, SHIFT(3211),
  [6589] = {.count = 1, .reusable = false}, SHIFT(3212),
  [6591] = {.count = 1, .reusable = true}, SHIFT(3212),
  [6593] = {.count = 1, .reusable = true}, SHIFT(3214),
  [6595] = {.count = 1, .reusable = false}, SHIFT(3215),
  [6597] = {.count = 1, .reusable = true}, SHIFT(3216),
  [6599] = {.count = 1, .reusable = true}, REDUCE(sym_object, 5),
  [6601] = {.count = 1, .reusable = false}, REDUCE(sym_object, 5),
  [6603] = {.count = 1, .reusable = true}, SHIFT(3219),
  [6605] = {.count = 1, .reusable = false}, SHIFT(3220),
  [6607] = {.count = 1, .reusable = true}, SHIFT(3217),
  [6609] = {.count = 1, .reusable = false}, SHIFT(3218),
  [6611] = {.count = 1, .reusable = true}, SHIFT(3222),
  [6613] = {.count = 1, .reusable = true}, SHIFT(3221),
  [6615] = {.count = 1, .reusable = false}, SHIFT(3223),
  [6617] = {.count = 1, .reusable = true}, SHIFT(3223),
  [6619] = {.count = 1, .reusable = false}, SHIFT(3224),
  [6621] = {.count = 1, .reusable = true}, SHIFT(3224),
  [6623] = {.count = 1, .reusable = false}, SHIFT(3225),
  [6625] = {.count = 1, .reusable = false}, SHIFT(3226),
  [6627] = {.count = 1, .reusable = false}, SHIFT(3227),
  [6629] = {.count = 1, .reusable = true}, SHIFT(3227),
  [6631] = {.count = 1, .reusable = false}, SHIFT(3228),
  [6633] = {.count = 1, .reusable = true}, SHIFT(3228),
  [6635] = {.count = 1, .reusable = false}, SHIFT(3229),
  [6637] = {.count = 1, .reusable = false}, SHIFT(3230),
  [6639] = {.count = 1, .reusable = false}, SHIFT(3231),
  [6641] = {.count = 1, .reusable = false}, SHIFT(3232),
  [6643] = {.count = 1, .reusable = false}, SHIFT(3233),
  [6645] = {.count = 1, .reusable = false}, SHIFT(3234),
  [6647] = {.count = 1, .reusable = true}, SHIFT(3234),
  [6649] = {.count = 1, .reusable = true}, SHIFT(3218),
  [6651] = {.count = 1, .reusable = false}, SHIFT(3235),
  [6653] = {.count = 1, .reusable = true}, SHIFT(3239),
  [6655] = {.count = 1, .reusable = true}, SHIFT(3236),
  [6657] = {.count = 1, .reusable = false}, SHIFT(3237),
  [6659] = {.count = 1, .reusable = true}, SHIFT(3238),
  [6661] = {.count = 1, .reusable = false}, SHIFT(3236),
  [6663] = {.count = 1, .reusable = false}, SHIFT(3238),
  [6665] = {.count = 1, .reusable = true}, SHIFT(3240),
  [6667] = {.count = 1, .reusable = true}, SHIFT(3235),
  [6669] = {.count = 1, .reusable = true}, SHIFT(3241),
  [6671] = {.count = 1, .reusable = false}, SHIFT(3242),
  [6673] = {.count = 1, .reusable = true}, SHIFT(3243),
  [6675] = {.count = 1, .reusable = true}, SHIFT(3244),
  [6677] = {.count = 1, .reusable = false}, SHIFT(3245),
  [6679] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [6681] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [6683] = {.count = 1, .reusable = false}, SHIFT(3246),
  [6685] = {.count = 1, .reusable = false}, SHIFT(3247),
  [6687] = {.count = 1, .reusable = false}, SHIFT(3248),
  [6689] = {.count = 1, .reusable = false}, SHIFT(3249),
  [6691] = {.count = 1, .reusable = false}, SHIFT(3250),
  [6693] = {.count = 1, .reusable = false}, SHIFT(3251),
  [6695] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [6697] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [6699] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [6701] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(1446),
  [6704] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(1444),
  [6707] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4),
  [6709] = {.count = 1, .reusable = true}, SHIFT(3254),
  [6711] = {.count = 1, .reusable = false}, SHIFT(3255),
  [6713] = {.count = 1, .reusable = true}, SHIFT(3256),
  [6715] = {.count = 1, .reusable = true}, SHIFT(3261),
  [6717] = {.count = 1, .reusable = true}, SHIFT(3263),
  [6719] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 6),
  [6721] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 6),
  [6723] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4),
  [6725] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 14),
  [6727] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 14),
  [6729] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 15),
  [6731] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 15),
  [6733] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 1),
  [6735] = {.count = 1, .reusable = true}, SHIFT(3271),
  [6737] = {.count = 1, .reusable = true}, SHIFT(3270),
  [6739] = {.count = 1, .reusable = true}, SHIFT(3274),
  [6741] = {.count = 1, .reusable = true}, SHIFT(3275),
  [6743] = {.count = 1, .reusable = true}, SHIFT(3277),
  [6745] = {.count = 1, .reusable = true}, SHIFT(3278),
  [6747] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3),
  [6749] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5),
  [6751] = {.count = 1, .reusable = false}, SHIFT(3279),
  [6753] = {.count = 1, .reusable = true}, SHIFT(3279),
  [6755] = {.count = 1, .reusable = true}, SHIFT(3282),
  [6757] = {.count = 1, .reusable = true}, SHIFT(3284),
  [6759] = {.count = 1, .reusable = false}, SHIFT(3287),
  [6761] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 18),
  [6763] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 18),
  [6765] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 19),
  [6767] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 19),
  [6769] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 20),
  [6771] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 20),
  [6773] = {.count = 1, .reusable = true}, SHIFT(3299),
  [6775] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 3),
  [6777] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 4),
  [6779] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5),
  [6781] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5),
  [6783] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5),
  [6785] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5),
  [6787] = {.count = 1, .reusable = true}, SHIFT(3300),
  [6789] = {.count = 1, .reusable = true}, SHIFT(3301),
  [6791] = {.count = 1, .reusable = false}, SHIFT(3302),
  [6793] = {.count = 1, .reusable = true}, SHIFT(3303),
  [6795] = {.count = 1, .reusable = true}, SHIFT(3308),
  [6797] = {.count = 1, .reusable = true}, SHIFT(3310),
  [6799] = {.count = 1, .reusable = true}, SHIFT(3313),
  [6801] = {.count = 1, .reusable = false}, SHIFT(3314),
  [6803] = {.count = 1, .reusable = true}, SHIFT(3315),
  [6805] = {.count = 1, .reusable = true}, SHIFT(3320),
  [6807] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4, .alias_sequence_id = 5),
  [6809] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4, .alias_sequence_id = 5),
  [6811] = {.count = 1, .reusable = true}, SHIFT(3322),
  [6813] = {.count = 1, .reusable = true}, SHIFT(3325),
  [6815] = {.count = 1, .reusable = true}, SHIFT(3327),
  [6817] = {.count = 1, .reusable = true}, SHIFT(3331),
  [6819] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [6821] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [6823] = {.count = 1, .reusable = true}, SHIFT(3332),
  [6825] = {.count = 1, .reusable = true}, SHIFT(3334),
  [6827] = {.count = 1, .reusable = true}, SHIFT(3335),
  [6829] = {.count = 1, .reusable = true}, SHIFT(3337),
  [6831] = {.count = 1, .reusable = true}, SHIFT(3338),
  [6833] = {.count = 1, .reusable = true}, SHIFT(3340),
  [6835] = {.count = 1, .reusable = false}, SHIFT(3339),
  [6837] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3),
  [6839] = {.count = 1, .reusable = true}, SHIFT(3341),
  [6841] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [6843] = {.count = 1, .reusable = true}, SHIFT(3344),
  [6845] = {.count = 1, .reusable = true}, SHIFT(3349),
  [6847] = {.count = 1, .reusable = true}, SHIFT(3350),
  [6849] = {.count = 1, .reusable = true}, SHIFT(3352),
  [6851] = {.count = 1, .reusable = true}, SHIFT(3353),
  [6853] = {.count = 1, .reusable = true}, SHIFT(3356),
  [6855] = {.count = 1, .reusable = true}, SHIFT(3357),
  [6857] = {.count = 1, .reusable = true}, SHIFT(3359),
  [6859] = {.count = 1, .reusable = true}, SHIFT(3360),
  [6861] = {.count = 1, .reusable = true}, SHIFT(3362),
  [6863] = {.count = 1, .reusable = true}, SHIFT(3363),
  [6865] = {.count = 1, .reusable = true}, SHIFT(1005),
  [6867] = {.count = 1, .reusable = false}, SHIFT(3364),
  [6869] = {.count = 1, .reusable = true}, SHIFT(3364),
  [6871] = {.count = 1, .reusable = true}, SHIFT(3366),
  [6873] = {.count = 1, .reusable = true}, SHIFT(3365),
  [6875] = {.count = 1, .reusable = true}, SHIFT(3369),
  [6877] = {.count = 1, .reusable = false}, SHIFT(3370),
  [6879] = {.count = 1, .reusable = true}, SHIFT(3372),
  [6881] = {.count = 1, .reusable = true}, SHIFT(3373),
  [6883] = {.count = 1, .reusable = false}, SHIFT(3374),
  [6885] = {.count = 1, .reusable = true}, SHIFT(3376),
  [6887] = {.count = 1, .reusable = false}, SHIFT(3375),
  [6889] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [6891] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(3377),
  [6894] = {.count = 1, .reusable = true}, SHIFT(3380),
  [6896] = {.count = 1, .reusable = true}, SHIFT(3381),
  [6898] = {.count = 1, .reusable = true}, SHIFT(3383),
  [6900] = {.count = 1, .reusable = true}, SHIFT(3385),
  [6902] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [6904] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [6906] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1629),
  [6909] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [6911] = {.count = 1, .reusable = false}, SHIFT(3388),
  [6913] = {.count = 1, .reusable = true}, SHIFT(3391),
  [6915] = {.count = 1, .reusable = true}, SHIFT(3392),
  [6917] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(2553),
  [6920] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(2558),
  [6923] = {.count = 1, .reusable = true}, SHIFT(3396),
  [6925] = {.count = 1, .reusable = true}, SHIFT(3397),
  [6927] = {.count = 1, .reusable = true}, SHIFT(3399),
  [6929] = {.count = 1, .reusable = false}, SHIFT(3400),
  [6931] = {.count = 1, .reusable = true}, SHIFT(3401),
  [6933] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .alias_sequence_id = 2), REDUCE(aux_sym_object_repeat1, 2, .alias_sequence_id = 12),
  [6936] = {.count = 1, .reusable = true}, SHIFT(3402),
  [6938] = {.count = 1, .reusable = true}, SHIFT(3404),
  [6940] = {.count = 1, .reusable = false}, SHIFT(3405),
  [6942] = {.count = 1, .reusable = true}, SHIFT(3408),
  [6944] = {.count = 1, .reusable = true}, SHIFT(3406),
  [6946] = {.count = 1, .reusable = false}, SHIFT(3407),
  [6948] = {.count = 1, .reusable = false}, SHIFT(3409),
  [6950] = {.count = 1, .reusable = true}, SHIFT(3410),
  [6952] = {.count = 1, .reusable = false}, SHIFT(3411),
  [6954] = {.count = 1, .reusable = false}, SHIFT(3412),
  [6956] = {.count = 1, .reusable = true}, SHIFT(3413),
  [6958] = {.count = 1, .reusable = false}, SHIFT(3414),
  [6960] = {.count = 1, .reusable = false}, SHIFT(3415),
  [6962] = {.count = 1, .reusable = false}, SHIFT(3416),
  [6964] = {.count = 1, .reusable = false}, SHIFT(3417),
  [6966] = {.count = 1, .reusable = false}, SHIFT(3418),
  [6968] = {.count = 1, .reusable = true}, SHIFT(3419),
  [6970] = {.count = 1, .reusable = false}, SHIFT(3420),
  [6972] = {.count = 1, .reusable = true}, SHIFT(3412),
  [6974] = {.count = 1, .reusable = false}, SHIFT(3421),
  [6976] = {.count = 1, .reusable = true}, SHIFT(3424),
  [6978] = {.count = 1, .reusable = false}, SHIFT(3426),
  [6980] = {.count = 1, .reusable = true}, SHIFT(3428),
  [6982] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [6984] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [6986] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [6988] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [6990] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [6992] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [6994] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [6996] = {.count = 1, .reusable = true}, SHIFT(3431),
  [6998] = {.count = 1, .reusable = true}, SHIFT(3430),
  [7000] = {.count = 1, .reusable = true}, SHIFT(3434),
  [7002] = {.count = 1, .reusable = true}, SHIFT(3435),
  [7004] = {.count = 1, .reusable = true}, SHIFT(3437),
  [7006] = {.count = 1, .reusable = true}, SHIFT(3438),
  [7008] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5),
  [7010] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5),
  [7012] = {.count = 1, .reusable = true}, SHIFT(3439),
  [7014] = {.count = 1, .reusable = false}, SHIFT(3440),
  [7016] = {.count = 1, .reusable = true}, SHIFT(3441),
  [7018] = {.count = 1, .reusable = true}, SHIFT(3446),
  [7020] = {.count = 1, .reusable = true}, SHIFT(3448),
  [7022] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [7025] = {.count = 1, .reusable = false}, SHIFT(3451),
  [7027] = {.count = 1, .reusable = true}, SHIFT(3451),
  [7029] = {.count = 1, .reusable = true}, SHIFT(3454),
  [7031] = {.count = 1, .reusable = true}, SHIFT(3456),
  [7033] = {.count = 1, .reusable = false}, SHIFT(3459),
  [7035] = {.count = 1, .reusable = true}, SHIFT(3460),
  [7037] = {.count = 1, .reusable = true}, SHIFT(3461),
  [7039] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .alias_sequence_id = 21),
  [7041] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .alias_sequence_id = 21),
  [7043] = {.count = 1, .reusable = true}, SHIFT(3462),
  [7045] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(3463),
  [7048] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [7050] = {.count = 1, .reusable = false}, SHIFT(3464),
  [7052] = {.count = 1, .reusable = true}, SHIFT(3464),
  [7054] = {.count = 1, .reusable = false}, SHIFT(3465),
  [7056] = {.count = 1, .reusable = true}, SHIFT(3465),
  [7058] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1776),
  [7061] = {.count = 1, .reusable = true}, SHIFT(3466),
  [7063] = {.count = 1, .reusable = true}, SHIFT(3468),
  [7065] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(3467),
  [7068] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(3474),
  [7071] = {.count = 1, .reusable = true}, SHIFT(3475),
  [7073] = {.count = 1, .reusable = true}, SHIFT(3477),
  [7075] = {.count = 1, .reusable = false}, SHIFT(3476),
  [7077] = {.count = 1, .reusable = false}, SHIFT(3478),
  [7079] = {.count = 1, .reusable = true}, SHIFT(3479),
  [7081] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [7083] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [7085] = {.count = 1, .reusable = true}, SHIFT(3481),
  [7087] = {.count = 1, .reusable = false}, SHIFT(3482),
  [7089] = {.count = 1, .reusable = false}, SHIFT(3483),
  [7091] = {.count = 1, .reusable = false}, SHIFT(3484),
  [7093] = {.count = 1, .reusable = true}, SHIFT(3488),
  [7095] = {.count = 1, .reusable = true}, SHIFT(3490),
  [7097] = {.count = 1, .reusable = true}, SHIFT(3493),
  [7099] = {.count = 1, .reusable = true}, SHIFT(3494),
  [7101] = {.count = 1, .reusable = true}, SHIFT(3495),
  [7103] = {.count = 1, .reusable = false}, SHIFT(3496),
  [7105] = {.count = 1, .reusable = true}, SHIFT(3496),
  [7107] = {.count = 1, .reusable = false}, SHIFT(3498),
  [7109] = {.count = 1, .reusable = true}, SHIFT(3498),
  [7111] = {.count = 1, .reusable = true}, SHIFT(3499),
  [7113] = {.count = 1, .reusable = true}, SHIFT(3500),
  [7115] = {.count = 1, .reusable = true}, SHIFT(3501),
  [7117] = {.count = 1, .reusable = false}, SHIFT(3503),
  [7119] = {.count = 1, .reusable = true}, SHIFT(3502),
  [7121] = {.count = 1, .reusable = true}, SHIFT(3503),
  [7123] = {.count = 1, .reusable = false}, SHIFT(3505),
  [7125] = {.count = 1, .reusable = true}, SHIFT(3505),
  [7127] = {.count = 1, .reusable = false}, SHIFT(3506),
  [7129] = {.count = 1, .reusable = true}, SHIFT(3506),
  [7131] = {.count = 1, .reusable = false}, SHIFT(3508),
  [7133] = {.count = 1, .reusable = true}, SHIFT(3508),
  [7135] = {.count = 1, .reusable = false}, SHIFT(3509),
  [7137] = {.count = 1, .reusable = true}, SHIFT(3509),
  [7139] = {.count = 1, .reusable = true}, SHIFT(3511),
  [7141] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5),
  [7143] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5),
  [7145] = {.count = 1, .reusable = true}, SHIFT(3516),
  [7147] = {.count = 1, .reusable = true}, SHIFT(3517),
  [7149] = {.count = 1, .reusable = true}, SHIFT(3519),
  [7151] = {.count = 1, .reusable = true}, SHIFT(3521),
  [7153] = {.count = 1, .reusable = false}, SHIFT(3523),
  [7155] = {.count = 1, .reusable = true}, SHIFT(3523),
  [7157] = {.count = 1, .reusable = false}, SHIFT(3524),
  [7159] = {.count = 1, .reusable = true}, SHIFT(3524),
  [7161] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1837),
  [7164] = {.count = 1, .reusable = true}, SHIFT(3525),
  [7166] = {.count = 1, .reusable = true}, SHIFT(3527),
  [7168] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(3526),
  [7171] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(3533),
  [7174] = {.count = 1, .reusable = true}, SHIFT(3534),
  [7176] = {.count = 1, .reusable = false}, SHIFT(3535),
  [7178] = {.count = 1, .reusable = false}, SHIFT(3536),
  [7180] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5),
  [7182] = {.count = 1, .reusable = false}, REDUCE(sym_mapped_type, 3, .alias_sequence_id = 5),
  [7184] = {.count = 1, .reusable = false}, SHIFT(1862),
  [7186] = {.count = 1, .reusable = false}, SHIFT(1861),
  [7188] = {.count = 1, .reusable = true}, SHIFT(3537),
  [7190] = {.count = 1, .reusable = true}, SHIFT(3538),
  [7192] = {.count = 1, .reusable = true}, SHIFT(3539),
  [7194] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .alias_sequence_id = 16),
  [7197] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [7199] = {.count = 1, .reusable = true}, SHIFT(3541),
  [7201] = {.count = 1, .reusable = true}, SHIFT(3542),
  [7203] = {.count = 1, .reusable = true}, SHIFT(3544),
  [7205] = {.count = 1, .reusable = true}, SHIFT(3546),
  [7207] = {.count = 1, .reusable = false}, REDUCE(sym_mapped_type, 3),
  [7209] = {.count = 1, .reusable = true}, SHIFT(3548),
  [7211] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [7213] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(2490),
  [7216] = {.count = 1, .reusable = true}, SHIFT(3552),
  [7218] = {.count = 1, .reusable = false}, SHIFT(3553),
  [7220] = {.count = 1, .reusable = false}, SHIFT(3554),
  [7222] = {.count = 1, .reusable = false}, SHIFT(3555),
  [7224] = {.count = 1, .reusable = false}, SHIFT(3556),
  [7226] = {.count = 1, .reusable = true}, SHIFT(3559),
  [7228] = {.count = 1, .reusable = true}, SHIFT(3560),
  [7230] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(2604),
  [7233] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(2606),
  [7236] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(2562),
  [7239] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .alias_sequence_id = 16),
  [7241] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .alias_sequence_id = 16),
  [7243] = {.count = 1, .reusable = false}, SHIFT(3563),
  [7245] = {.count = 1, .reusable = true}, SHIFT(3563),
  [7247] = {.count = 1, .reusable = true}, SHIFT(3566),
  [7249] = {.count = 1, .reusable = true}, SHIFT(3568),
  [7251] = {.count = 1, .reusable = false}, SHIFT(3571),
  [7253] = {.count = 1, .reusable = true}, SHIFT(3574),
  [7255] = {.count = 1, .reusable = true}, SHIFT(3575),
  [7257] = {.count = 1, .reusable = true}, SHIFT(3577),
  [7259] = {.count = 1, .reusable = true}, SHIFT(3578),
  [7261] = {.count = 1, .reusable = true}, SHIFT(3579),
  [7263] = {.count = 1, .reusable = true}, SHIFT(3580),
  [7265] = {.count = 1, .reusable = true}, SHIFT(3582),
  [7267] = {.count = 1, .reusable = true}, SHIFT(3583),
  [7269] = {.count = 1, .reusable = true}, SHIFT(3585),
  [7271] = {.count = 1, .reusable = true}, SHIFT(3586),
  [7273] = {.count = 1, .reusable = true}, SHIFT(3588),
  [7275] = {.count = 1, .reusable = true}, SHIFT(3590),
  [7277] = {.count = 1, .reusable = true}, SHIFT(3593),
  [7279] = {.count = 1, .reusable = true}, SHIFT(3594),
  [7281] = {.count = 1, .reusable = true}, SHIFT(3596),
  [7283] = {.count = 1, .reusable = true}, SHIFT(3598),
  [7285] = {.count = 1, .reusable = false}, SHIFT(3600),
  [7287] = {.count = 1, .reusable = true}, SHIFT(3600),
  [7289] = {.count = 1, .reusable = true}, SHIFT(3603),
  [7291] = {.count = 1, .reusable = true}, SHIFT(3605),
  [7293] = {.count = 1, .reusable = false}, SHIFT(3608),
  [7295] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3),
  [7297] = {.count = 1, .reusable = false}, REDUCE(sym__initializer, 2),
  [7299] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .alias_sequence_id = 1),
  [7301] = {.count = 1, .reusable = false}, SHIFT(3609),
  [7303] = {.count = 1, .reusable = true}, SHIFT(3609),
  [7305] = {.count = 1, .reusable = false}, SHIFT(3610),
  [7307] = {.count = 1, .reusable = true}, SHIFT(3610),
  [7309] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2029),
  [7312] = {.count = 1, .reusable = true}, SHIFT(3611),
  [7314] = {.count = 1, .reusable = true}, SHIFT(3613),
  [7316] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(3612),
  [7319] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(3619),
  [7322] = {.count = 1, .reusable = true}, SHIFT(3620),
  [7324] = {.count = 1, .reusable = false}, SHIFT(3621),
  [7326] = {.count = 1, .reusable = false}, SHIFT(3622),
  [7328] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(2023),
  [7331] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [7333] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [7335] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [7337] = {.count = 1, .reusable = true}, SHIFT(3623),
  [7339] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(3624),
  [7342] = {.count = 1, .reusable = true}, SHIFT(3625),
  [7344] = {.count = 1, .reusable = true}, SHIFT(3628),
  [7346] = {.count = 1, .reusable = true}, SHIFT(3629),
  [7348] = {.count = 1, .reusable = true}, SHIFT(3630),
  [7350] = {.count = 1, .reusable = false}, SHIFT(3631),
  [7352] = {.count = 1, .reusable = true}, SHIFT(3631),
  [7354] = {.count = 1, .reusable = false}, SHIFT(3633),
  [7356] = {.count = 1, .reusable = true}, SHIFT(3633),
  [7358] = {.count = 1, .reusable = true}, SHIFT(3634),
  [7360] = {.count = 1, .reusable = true}, SHIFT(3635),
  [7362] = {.count = 1, .reusable = true}, SHIFT(3636),
  [7364] = {.count = 1, .reusable = false}, SHIFT(3638),
  [7366] = {.count = 1, .reusable = true}, SHIFT(3637),
  [7368] = {.count = 1, .reusable = true}, SHIFT(3638),
  [7370] = {.count = 1, .reusable = false}, SHIFT(3640),
  [7372] = {.count = 1, .reusable = true}, SHIFT(3640),
  [7374] = {.count = 1, .reusable = false}, SHIFT(3641),
  [7376] = {.count = 1, .reusable = true}, SHIFT(3641),
  [7378] = {.count = 1, .reusable = false}, SHIFT(3643),
  [7380] = {.count = 1, .reusable = true}, SHIFT(3643),
  [7382] = {.count = 1, .reusable = false}, SHIFT(3644),
  [7384] = {.count = 1, .reusable = true}, SHIFT(3644),
  [7386] = {.count = 1, .reusable = true}, SHIFT(3646),
  [7388] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class, 6, .alias_sequence_id = 16),
  [7390] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class, 6, .alias_sequence_id = 16),
  [7392] = {.count = 1, .reusable = true}, SHIFT(3649),
  [7394] = {.count = 1, .reusable = true}, SHIFT(3650),
  [7396] = {.count = 1, .reusable = true}, SHIFT(3652),
  [7398] = {.count = 1, .reusable = true}, SHIFT(3654),
  [7400] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .alias_sequence_id = 11),
  [7402] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .alias_sequence_id = 11),
  [7404] = {.count = 1, .reusable = true}, SHIFT(3656),
  [7406] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4),
  [7408] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .alias_sequence_id = 17),
  [7410] = {.count = 1, .reusable = false}, SHIFT(3657),
  [7412] = {.count = 1, .reusable = true}, SHIFT(3657),
  [7414] = {.count = 1, .reusable = false}, SHIFT(3658),
  [7416] = {.count = 1, .reusable = true}, SHIFT(3658),
  [7418] = {.count = 1, .reusable = false}, SHIFT(3659),
  [7420] = {.count = 1, .reusable = true}, SHIFT(3659),
  [7422] = {.count = 1, .reusable = true}, SHIFT(3660),
  [7424] = {.count = 1, .reusable = true}, SHIFT(3661),
  [7426] = {.count = 1, .reusable = true}, SHIFT(3662),
  [7428] = {.count = 1, .reusable = false}, SHIFT(3663),
  [7430] = {.count = 1, .reusable = true}, SHIFT(3663),
  [7432] = {.count = 1, .reusable = false}, SHIFT(3664),
  [7434] = {.count = 1, .reusable = true}, SHIFT(3664),
  [7436] = {.count = 1, .reusable = false}, SHIFT(3665),
  [7438] = {.count = 1, .reusable = true}, SHIFT(3665),
  [7440] = {.count = 1, .reusable = false}, SHIFT(3666),
  [7442] = {.count = 1, .reusable = true}, SHIFT(3666),
  [7444] = {.count = 1, .reusable = false}, SHIFT(3667),
  [7446] = {.count = 1, .reusable = true}, SHIFT(3667),
  [7448] = {.count = 1, .reusable = false}, SHIFT(3668),
  [7450] = {.count = 1, .reusable = true}, SHIFT(3668),
  [7452] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2968),
  [7455] = {.count = 1, .reusable = true}, SHIFT(3669),
  [7457] = {.count = 1, .reusable = true}, SHIFT(3670),
  [7459] = {.count = 1, .reusable = true}, SHIFT(2945),
  [7461] = {.count = 1, .reusable = false}, SHIFT(2962),
  [7463] = {.count = 1, .reusable = true}, SHIFT(2965),
  [7465] = {.count = 1, .reusable = false}, SHIFT(2965),
  [7467] = {.count = 1, .reusable = true}, SHIFT(2966),
  [7469] = {.count = 1, .reusable = true}, SHIFT(2962),
  [7471] = {.count = 1, .reusable = false}, SHIFT(3671),
  [7473] = {.count = 1, .reusable = true}, SHIFT(3671),
  [7475] = {.count = 1, .reusable = false}, SHIFT(3672),
  [7477] = {.count = 1, .reusable = true}, SHIFT(3672),
  [7479] = {.count = 1, .reusable = false}, SHIFT(3673),
  [7481] = {.count = 1, .reusable = true}, SHIFT(3673),
  [7483] = {.count = 1, .reusable = false}, SHIFT(3674),
  [7485] = {.count = 1, .reusable = true}, SHIFT(3674),
  [7487] = {.count = 1, .reusable = false}, SHIFT(3675),
  [7489] = {.count = 1, .reusable = true}, SHIFT(3675),
  [7491] = {.count = 1, .reusable = false}, SHIFT(3676),
  [7493] = {.count = 1, .reusable = true}, SHIFT(3680),
  [7495] = {.count = 1, .reusable = true}, SHIFT(3678),
  [7497] = {.count = 1, .reusable = true}, SHIFT(3677),
  [7499] = {.count = 1, .reusable = false}, SHIFT(3679),
  [7501] = {.count = 1, .reusable = false}, SHIFT(3684),
  [7503] = {.count = 1, .reusable = false}, SHIFT(3685),
  [7505] = {.count = 1, .reusable = false}, SHIFT(3686),
  [7507] = {.count = 1, .reusable = false}, SHIFT(3687),
  [7509] = {.count = 1, .reusable = false}, SHIFT(3688),
  [7511] = {.count = 1, .reusable = false}, SHIFT(3689),
  [7513] = {.count = 1, .reusable = false}, SHIFT(3691),
  [7515] = {.count = 1, .reusable = true}, SHIFT(3691),
  [7517] = {.count = 1, .reusable = false}, SHIFT(3692),
  [7519] = {.count = 1, .reusable = true}, SHIFT(3692),
  [7521] = {.count = 1, .reusable = false}, SHIFT(3693),
  [7523] = {.count = 1, .reusable = true}, SHIFT(3693),
  [7525] = {.count = 1, .reusable = false}, SHIFT(3694),
  [7527] = {.count = 1, .reusable = true}, SHIFT(3694),
  [7529] = {.count = 1, .reusable = false}, SHIFT(3695),
  [7531] = {.count = 1, .reusable = true}, SHIFT(3695),
  [7533] = {.count = 1, .reusable = false}, SHIFT(3696),
  [7535] = {.count = 1, .reusable = true}, SHIFT(3696),
  [7537] = {.count = 1, .reusable = false}, SHIFT(3697),
  [7539] = {.count = 1, .reusable = true}, SHIFT(3697),
  [7541] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2995),
  [7544] = {.count = 1, .reusable = true}, SHIFT(3698),
  [7546] = {.count = 1, .reusable = true}, SHIFT(3699),
  [7548] = {.count = 1, .reusable = false}, SHIFT(3700),
  [7550] = {.count = 1, .reusable = true}, SHIFT(3700),
  [7552] = {.count = 1, .reusable = false}, SHIFT(3701),
  [7554] = {.count = 1, .reusable = true}, SHIFT(3701),
  [7556] = {.count = 1, .reusable = false}, SHIFT(3702),
  [7558] = {.count = 1, .reusable = true}, SHIFT(3702),
  [7560] = {.count = 1, .reusable = false}, SHIFT(3703),
  [7562] = {.count = 1, .reusable = true}, SHIFT(3703),
  [7564] = {.count = 1, .reusable = false}, SHIFT(3704),
  [7566] = {.count = 1, .reusable = true}, SHIFT(3704),
  [7568] = {.count = 1, .reusable = false}, SHIFT(3705),
  [7570] = {.count = 1, .reusable = true}, SHIFT(3709),
  [7572] = {.count = 1, .reusable = true}, SHIFT(3707),
  [7574] = {.count = 1, .reusable = true}, SHIFT(3706),
  [7576] = {.count = 1, .reusable = false}, SHIFT(3708),
  [7578] = {.count = 1, .reusable = false}, SHIFT(3713),
  [7580] = {.count = 1, .reusable = false}, SHIFT(3714),
  [7582] = {.count = 1, .reusable = false}, SHIFT(3715),
  [7584] = {.count = 1, .reusable = false}, SHIFT(3716),
  [7586] = {.count = 1, .reusable = false}, SHIFT(3717),
  [7588] = {.count = 1, .reusable = false}, SHIFT(3718),
  [7590] = {.count = 1, .reusable = false}, SHIFT(3720),
  [7592] = {.count = 1, .reusable = true}, SHIFT(3720),
  [7594] = {.count = 1, .reusable = true}, SHIFT(3721),
  [7596] = {.count = 1, .reusable = true}, SHIFT(3722),
  [7598] = {.count = 1, .reusable = true}, SHIFT(3723),
  [7600] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [7602] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [7604] = {.count = 1, .reusable = false}, SHIFT(2180),
  [7606] = {.count = 1, .reusable = false}, SHIFT(2179),
  [7608] = {.count = 1, .reusable = true}, SHIFT(3729),
  [7610] = {.count = 1, .reusable = true}, SHIFT(3730),
  [7612] = {.count = 1, .reusable = true}, SHIFT(3731),
  [7614] = {.count = 1, .reusable = true}, SHIFT(3733),
  [7616] = {.count = 1, .reusable = true}, SHIFT(3734),
  [7618] = {.count = 1, .reusable = true}, SHIFT(3736),
  [7620] = {.count = 1, .reusable = true}, SHIFT(3738),
  [7622] = {.count = 1, .reusable = true}, SHIFT(3740),
  [7624] = {.count = 1, .reusable = true}, SHIFT(3741),
  [7626] = {.count = 1, .reusable = false}, SHIFT(3743),
  [7628] = {.count = 1, .reusable = true}, SHIFT(3743),
  [7630] = {.count = 1, .reusable = true}, SHIFT(3746),
  [7632] = {.count = 1, .reusable = true}, SHIFT(3748),
  [7634] = {.count = 1, .reusable = false}, SHIFT(3751),
  [7636] = {.count = 1, .reusable = true}, SHIFT(3752),
  [7638] = {.count = 1, .reusable = true}, SHIFT(3754),
  [7640] = {.count = 1, .reusable = false}, SHIFT(3757),
  [7642] = {.count = 1, .reusable = false}, SHIFT(3758),
  [7644] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(2484),
  [7647] = {.count = 1, .reusable = true}, SHIFT(3762),
  [7649] = {.count = 1, .reusable = true}, SHIFT(3763),
  [7651] = {.count = 1, .reusable = false}, SHIFT(3764),
  [7653] = {.count = 1, .reusable = true}, SHIFT(3764),
  [7655] = {.count = 1, .reusable = false}, SHIFT(3765),
  [7657] = {.count = 1, .reusable = true}, SHIFT(3765),
  [7659] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2272),
  [7662] = {.count = 1, .reusable = true}, SHIFT(3766),
  [7664] = {.count = 1, .reusable = true}, SHIFT(3768),
  [7666] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(3767),
  [7669] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(3774),
  [7672] = {.count = 1, .reusable = true}, SHIFT(3775),
  [7674] = {.count = 1, .reusable = false}, SHIFT(3776),
  [7676] = {.count = 1, .reusable = false}, SHIFT(3777),
  [7678] = {.count = 1, .reusable = false}, SHIFT(3778),
  [7680] = {.count = 1, .reusable = true}, SHIFT(3779),
  [7682] = {.count = 1, .reusable = true}, SHIFT(3780),
  [7684] = {.count = 1, .reusable = false}, SHIFT(3781),
  [7686] = {.count = 1, .reusable = true}, SHIFT(3782),
  [7688] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 4),
  [7690] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4),
  [7692] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4),
  [7694] = {.count = 1, .reusable = true}, SHIFT(3789),
  [7696] = {.count = 1, .reusable = true}, SHIFT(3790),
  [7698] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4),
  [7700] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4),
  [7702] = {.count = 1, .reusable = true}, SHIFT(3794),
  [7704] = {.count = 1, .reusable = true}, SHIFT(3795),
  [7706] = {.count = 1, .reusable = true}, SHIFT(3796),
  [7708] = {.count = 1, .reusable = true}, SHIFT(3799),
  [7710] = {.count = 1, .reusable = true}, SHIFT(3800),
  [7712] = {.count = 1, .reusable = true}, SHIFT(3802),
  [7714] = {.count = 1, .reusable = true}, SHIFT(3803),
  [7716] = {.count = 1, .reusable = true}, SHIFT(3805),
  [7718] = {.count = 1, .reusable = false}, SHIFT(3804),
  [7720] = {.count = 1, .reusable = true}, SHIFT(3806),
  [7722] = {.count = 1, .reusable = true}, SHIFT(3807),
  [7724] = {.count = 1, .reusable = true}, SHIFT(3808),
  [7726] = {.count = 1, .reusable = false}, SHIFT(3810),
  [7728] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(101),
  [7731] = {.count = 1, .reusable = false}, SHIFT(3809),
  [7733] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .alias_sequence_id = 22),
  [7735] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .alias_sequence_id = 22),
  [7737] = {.count = 1, .reusable = true}, SHIFT(3814),
  [7739] = {.count = 1, .reusable = true}, SHIFT(3813),
  [7741] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(101),
  [7744] = {.count = 1, .reusable = false}, SHIFT(3816),
  [7746] = {.count = 1, .reusable = true}, SHIFT(3817),
  [7748] = {.count = 1, .reusable = false}, SHIFT(3819),
  [7750] = {.count = 1, .reusable = true}, SHIFT(3819),
  [7752] = {.count = 1, .reusable = false}, SHIFT(3820),
  [7754] = {.count = 1, .reusable = true}, SHIFT(3820),
  [7756] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2337),
  [7759] = {.count = 1, .reusable = true}, SHIFT(3821),
  [7761] = {.count = 1, .reusable = true}, SHIFT(3823),
  [7763] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(3822),
  [7766] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(3829),
  [7769] = {.count = 1, .reusable = true}, SHIFT(3830),
  [7771] = {.count = 1, .reusable = false}, SHIFT(3831),
  [7773] = {.count = 1, .reusable = false}, SHIFT(3832),
  [7775] = {.count = 1, .reusable = true}, SHIFT(3833),
  [7777] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5),
  [7779] = {.count = 1, .reusable = true}, SHIFT(3836),
  [7781] = {.count = 1, .reusable = false}, SHIFT(3837),
  [7783] = {.count = 1, .reusable = false}, SHIFT(3839),
  [7785] = {.count = 1, .reusable = false}, SHIFT(3838),
  [7787] = {.count = 1, .reusable = true}, SHIFT(3843),
  [7789] = {.count = 1, .reusable = false}, SHIFT(3842),
  [7791] = {.count = 1, .reusable = true}, SHIFT(3844),
  [7793] = {.count = 1, .reusable = true}, SHIFT(3848),
  [7795] = {.count = 1, .reusable = false}, SHIFT(3849),
  [7797] = {.count = 1, .reusable = true}, SHIFT(3850),
  [7799] = {.count = 1, .reusable = false}, SHIFT(3851),
  [7801] = {.count = 1, .reusable = true}, SHIFT(3852),
  [7803] = {.count = 1, .reusable = true}, SHIFT(3853),
  [7805] = {.count = 1, .reusable = true}, SHIFT(3854),
  [7807] = {.count = 1, .reusable = true}, SHIFT(3855),
  [7809] = {.count = 1, .reusable = false}, SHIFT(3856),
  [7811] = {.count = 1, .reusable = true}, SHIFT(3856),
  [7813] = {.count = 1, .reusable = false}, SHIFT(3857),
  [7815] = {.count = 1, .reusable = true}, SHIFT(3857),
  [7817] = {.count = 1, .reusable = false}, SHIFT(3858),
  [7819] = {.count = 1, .reusable = true}, SHIFT(3858),
  [7821] = {.count = 1, .reusable = true}, SHIFT(3859),
  [7823] = {.count = 1, .reusable = true}, SHIFT(3860),
  [7825] = {.count = 1, .reusable = false}, SHIFT(3861),
  [7827] = {.count = 1, .reusable = true}, SHIFT(3861),
  [7829] = {.count = 1, .reusable = false}, SHIFT(3863),
  [7831] = {.count = 1, .reusable = true}, SHIFT(3863),
  [7833] = {.count = 1, .reusable = false}, SHIFT(3865),
  [7835] = {.count = 1, .reusable = true}, SHIFT(3865),
  [7837] = {.count = 1, .reusable = true}, SHIFT(3867),
  [7839] = {.count = 1, .reusable = true}, SHIFT(3868),
  [7841] = {.count = 1, .reusable = true}, SHIFT(3869),
  [7843] = {.count = 1, .reusable = true}, SHIFT(3870),
  [7845] = {.count = 1, .reusable = true}, SHIFT(3871),
  [7847] = {.count = 1, .reusable = false}, SHIFT(3872),
  [7849] = {.count = 1, .reusable = true}, SHIFT(3873),
  [7851] = {.count = 1, .reusable = true}, SHIFT(3874),
  [7853] = {.count = 1, .reusable = false}, SHIFT(3875),
  [7855] = {.count = 1, .reusable = true}, SHIFT(3876),
  [7857] = {.count = 1, .reusable = true}, SHIFT(3881),
  [7859] = {.count = 1, .reusable = false}, SHIFT(3882),
  [7861] = {.count = 1, .reusable = true}, SHIFT(3882),
  [7863] = {.count = 1, .reusable = false}, SHIFT(3883),
  [7865] = {.count = 1, .reusable = true}, SHIFT(3883),
  [7867] = {.count = 1, .reusable = false}, SHIFT(3884),
  [7869] = {.count = 1, .reusable = true}, SHIFT(3884),
  [7871] = {.count = 1, .reusable = false}, SHIFT(3885),
  [7873] = {.count = 1, .reusable = true}, SHIFT(3885),
  [7875] = {.count = 1, .reusable = false}, SHIFT(3886),
  [7877] = {.count = 1, .reusable = true}, SHIFT(3886),
  [7879] = {.count = 1, .reusable = false}, SHIFT(3887),
  [7881] = {.count = 1, .reusable = true}, SHIFT(3887),
  [7883] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(3242),
  [7886] = {.count = 1, .reusable = true}, SHIFT(3888),
  [7888] = {.count = 1, .reusable = true}, SHIFT(3889),
  [7890] = {.count = 1, .reusable = false}, SHIFT(3890),
  [7892] = {.count = 1, .reusable = true}, SHIFT(3890),
  [7894] = {.count = 1, .reusable = false}, SHIFT(3891),
  [7896] = {.count = 1, .reusable = true}, SHIFT(3891),
  [7898] = {.count = 1, .reusable = false}, SHIFT(3892),
  [7900] = {.count = 1, .reusable = true}, SHIFT(3892),
  [7902] = {.count = 1, .reusable = false}, SHIFT(3893),
  [7904] = {.count = 1, .reusable = true}, SHIFT(3893),
  [7906] = {.count = 1, .reusable = false}, SHIFT(3894),
  [7908] = {.count = 1, .reusable = true}, SHIFT(3894),
  [7910] = {.count = 1, .reusable = false}, SHIFT(3895),
  [7912] = {.count = 1, .reusable = true}, SHIFT(3895),
  [7914] = {.count = 1, .reusable = false}, SHIFT(3896),
  [7916] = {.count = 1, .reusable = true}, SHIFT(3900),
  [7918] = {.count = 1, .reusable = true}, SHIFT(3898),
  [7920] = {.count = 1, .reusable = true}, SHIFT(3897),
  [7922] = {.count = 1, .reusable = false}, SHIFT(3899),
  [7924] = {.count = 1, .reusable = false}, SHIFT(3904),
  [7926] = {.count = 1, .reusable = false}, SHIFT(3905),
  [7928] = {.count = 1, .reusable = false}, SHIFT(3906),
  [7930] = {.count = 1, .reusable = false}, SHIFT(3907),
  [7932] = {.count = 1, .reusable = false}, SHIFT(3908),
  [7934] = {.count = 1, .reusable = false}, SHIFT(3909),
  [7936] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3),
  [7938] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3),
  [7940] = {.count = 1, .reusable = false}, SHIFT(3911),
  [7942] = {.count = 1, .reusable = true}, SHIFT(3911),
  [7944] = {.count = 1, .reusable = true}, SHIFT(3912),
  [7946] = {.count = 1, .reusable = true}, SHIFT(3914),
  [7948] = {.count = 1, .reusable = true}, SHIFT(3915),
  [7950] = {.count = 1, .reusable = true}, SHIFT(3916),
  [7952] = {.count = 1, .reusable = true}, SHIFT(3917),
  [7954] = {.count = 1, .reusable = true}, SHIFT(3918),
  [7956] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [7958] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [7960] = {.count = 1, .reusable = true}, SHIFT(3923),
  [7962] = {.count = 1, .reusable = true}, SHIFT(3926),
  [7964] = {.count = 1, .reusable = true}, SHIFT(3927),
  [7966] = {.count = 1, .reusable = true}, SHIFT(3929),
  [7968] = {.count = 1, .reusable = true}, SHIFT(3931),
  [7970] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 6),
  [7972] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5),
  [7974] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 14),
  [7976] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 15),
  [7978] = {.count = 1, .reusable = true}, SHIFT(3933),
  [7980] = {.count = 1, .reusable = false}, SHIFT(3934),
  [7982] = {.count = 1, .reusable = true}, SHIFT(3935),
  [7984] = {.count = 1, .reusable = true}, SHIFT(3940),
  [7986] = {.count = 1, .reusable = true}, SHIFT(3942),
  [7988] = {.count = 1, .reusable = false}, SHIFT(2443),
  [7990] = {.count = 1, .reusable = false}, SHIFT(2442),
  [7992] = {.count = 1, .reusable = true}, SHIFT(3946),
  [7994] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 18),
  [7996] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5, .alias_sequence_id = 18),
  [7998] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5),
  [8000] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 19),
  [8002] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5, .alias_sequence_id = 19),
  [8004] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 20),
  [8006] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5, .alias_sequence_id = 20),
  [8008] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6),
  [8010] = {.count = 1, .reusable = true}, SHIFT(3955),
  [8012] = {.count = 1, .reusable = true}, SHIFT(3956),
  [8014] = {.count = 1, .reusable = true}, SHIFT(3958),
  [8016] = {.count = 1, .reusable = true}, SHIFT(3960),
  [8018] = {.count = 1, .reusable = true}, SHIFT(3964),
  [8020] = {.count = 1, .reusable = true}, SHIFT(3965),
  [8022] = {.count = 1, .reusable = true}, SHIFT(3967),
  [8024] = {.count = 1, .reusable = true}, SHIFT(3969),
  [8026] = {.count = 1, .reusable = true}, SHIFT(3972),
  [8028] = {.count = 1, .reusable = true}, SHIFT(3974),
  [8030] = {.count = 1, .reusable = true}, SHIFT(3975),
  [8032] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [8034] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [8036] = {.count = 1, .reusable = true}, SHIFT(3976),
  [8038] = {.count = 1, .reusable = true}, SHIFT(3977),
  [8040] = {.count = 1, .reusable = true}, SHIFT(3978),
  [8042] = {.count = 1, .reusable = true}, SHIFT(3980),
  [8044] = {.count = 1, .reusable = true}, SHIFT(3981),
  [8046] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4),
  [8048] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [8050] = {.count = 1, .reusable = true}, SHIFT(3983),
  [8052] = {.count = 1, .reusable = true}, SHIFT(3986),
  [8054] = {.count = 1, .reusable = true}, SHIFT(3988),
  [8056] = {.count = 1, .reusable = true}, SHIFT(3989),
  [8058] = {.count = 1, .reusable = true}, SHIFT(3990),
  [8060] = {.count = 1, .reusable = true}, SHIFT(3992),
  [8062] = {.count = 1, .reusable = true}, SHIFT(3997),
  [8064] = {.count = 1, .reusable = true}, SHIFT(3998),
  [8066] = {.count = 1, .reusable = true}, SHIFT(4000),
  [8068] = {.count = 1, .reusable = false}, SHIFT(4001),
  [8070] = {.count = 1, .reusable = true}, SHIFT(4002),
  [8072] = {.count = 1, .reusable = true}, SHIFT(4007),
  [8074] = {.count = 1, .reusable = true}, SHIFT(4009),
  [8076] = {.count = 1, .reusable = true}, SHIFT(4013),
  [8078] = {.count = 1, .reusable = false}, SHIFT(4012),
  [8080] = {.count = 1, .reusable = true}, SHIFT(4014),
  [8082] = {.count = 1, .reusable = true}, SHIFT(4015),
  [8084] = {.count = 1, .reusable = true}, SHIFT(4017),
  [8086] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [8088] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(3383),
  [8091] = {.count = 1, .reusable = true}, SHIFT(4023),
  [8093] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(3385),
  [8096] = {.count = 1, .reusable = true}, SHIFT(4024),
  [8098] = {.count = 1, .reusable = true}, SHIFT(4026),
  [8100] = {.count = 1, .reusable = false}, SHIFT(4028),
  [8102] = {.count = 1, .reusable = false}, SHIFT(4029),
  [8104] = {.count = 1, .reusable = false}, SHIFT(4030),
  [8106] = {.count = 1, .reusable = false}, SHIFT(4031),
  [8108] = {.count = 1, .reusable = false}, SHIFT(4032),
  [8110] = {.count = 1, .reusable = false}, SHIFT(4033),
  [8112] = {.count = 1, .reusable = true}, SHIFT(4035),
  [8114] = {.count = 1, .reusable = true}, SHIFT(4036),
  [8116] = {.count = 1, .reusable = true}, SHIFT(4038),
  [8118] = {.count = 1, .reusable = false}, SHIFT(4037),
  [8120] = {.count = 1, .reusable = true}, SHIFT(4039),
  [8122] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1933),
  [8126] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(1934),
  [8129] = {.count = 1, .reusable = true}, SHIFT(4041),
  [8131] = {.count = 1, .reusable = false}, SHIFT(4040),
  [8133] = {.count = 1, .reusable = false}, SHIFT(4042),
  [8135] = {.count = 1, .reusable = true}, SHIFT(4043),
  [8137] = {.count = 1, .reusable = true}, SHIFT(4044),
  [8139] = {.count = 1, .reusable = true}, SHIFT(4045),
  [8141] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(3373),
  [8144] = {.count = 1, .reusable = false}, SHIFT(4049),
  [8146] = {.count = 1, .reusable = true}, SHIFT(4050),
  [8148] = {.count = 1, .reusable = true}, SHIFT(4051),
  [8150] = {.count = 1, .reusable = false}, SHIFT(4052),
  [8152] = {.count = 1, .reusable = true}, SHIFT(4053),
  [8154] = {.count = 1, .reusable = false}, SHIFT(4058),
  [8156] = {.count = 1, .reusable = true}, SHIFT(4060),
  [8158] = {.count = 1, .reusable = false}, SHIFT(4059),
  [8160] = {.count = 1, .reusable = true}, SHIFT(4062),
  [8162] = {.count = 1, .reusable = false}, SHIFT(4063),
  [8164] = {.count = 1, .reusable = true}, SHIFT(4064),
  [8166] = {.count = 1, .reusable = true}, SHIFT(4069),
  [8168] = {.count = 1, .reusable = true}, SHIFT(4071),
  [8170] = {.count = 1, .reusable = true}, SHIFT(4076),
  [8172] = {.count = 1, .reusable = true}, SHIFT(4077),
  [8174] = {.count = 1, .reusable = true}, SHIFT(4079),
  [8176] = {.count = 1, .reusable = true}, SHIFT(4081),
  [8178] = {.count = 1, .reusable = false}, SHIFT(2644),
  [8180] = {.count = 1, .reusable = false}, SHIFT(2643),
  [8182] = {.count = 1, .reusable = true}, SHIFT(4084),
  [8184] = {.count = 1, .reusable = true}, SHIFT(4086),
  [8186] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .alias_sequence_id = 21),
  [8188] = {.count = 1, .reusable = false}, SHIFT(4087),
  [8190] = {.count = 1, .reusable = true}, SHIFT(4087),
  [8192] = {.count = 1, .reusable = true}, SHIFT(4090),
  [8194] = {.count = 1, .reusable = true}, SHIFT(4092),
  [8196] = {.count = 1, .reusable = false}, SHIFT(4095),
  [8198] = {.count = 1, .reusable = true}, SHIFT(4096),
  [8200] = {.count = 1, .reusable = true}, SHIFT(4097),
  [8202] = {.count = 1, .reusable = true}, SHIFT(4098),
  [8204] = {.count = 1, .reusable = false}, SHIFT(4100),
  [8206] = {.count = 1, .reusable = false}, SHIFT(4099),
  [8208] = {.count = 1, .reusable = true}, SHIFT(4104),
  [8210] = {.count = 1, .reusable = false}, SHIFT(4103),
  [8212] = {.count = 1, .reusable = true}, SHIFT(4105),
  [8214] = {.count = 1, .reusable = true}, SHIFT(4109),
  [8216] = {.count = 1, .reusable = false}, SHIFT(4110),
  [8218] = {.count = 1, .reusable = true}, SHIFT(4111),
  [8220] = {.count = 1, .reusable = false}, SHIFT(4112),
  [8222] = {.count = 1, .reusable = true}, SHIFT(4113),
  [8224] = {.count = 1, .reusable = true}, SHIFT(4114),
  [8226] = {.count = 1, .reusable = true}, SHIFT(4115),
  [8228] = {.count = 1, .reusable = true}, SHIFT(4116),
  [8230] = {.count = 1, .reusable = false}, SHIFT(4117),
  [8232] = {.count = 1, .reusable = true}, SHIFT(4117),
  [8234] = {.count = 1, .reusable = false}, SHIFT(4118),
  [8236] = {.count = 1, .reusable = true}, SHIFT(4118),
  [8238] = {.count = 1, .reusable = false}, SHIFT(4119),
  [8240] = {.count = 1, .reusable = true}, SHIFT(4119),
  [8242] = {.count = 1, .reusable = true}, SHIFT(4120),
  [8244] = {.count = 1, .reusable = true}, SHIFT(4121),
  [8246] = {.count = 1, .reusable = false}, SHIFT(4122),
  [8248] = {.count = 1, .reusable = true}, SHIFT(4122),
  [8250] = {.count = 1, .reusable = false}, SHIFT(4124),
  [8252] = {.count = 1, .reusable = true}, SHIFT(4124),
  [8254] = {.count = 1, .reusable = false}, SHIFT(4126),
  [8256] = {.count = 1, .reusable = true}, SHIFT(4126),
  [8258] = {.count = 1, .reusable = true}, SHIFT(4128),
  [8260] = {.count = 1, .reusable = true}, SHIFT(4129),
  [8262] = {.count = 1, .reusable = true}, SHIFT(4130),
  [8264] = {.count = 1, .reusable = true}, SHIFT(4131),
  [8266] = {.count = 1, .reusable = true}, SHIFT(4132),
  [8268] = {.count = 1, .reusable = false}, SHIFT(4133),
  [8270] = {.count = 1, .reusable = true}, SHIFT(4134),
  [8272] = {.count = 1, .reusable = true}, SHIFT(4135),
  [8274] = {.count = 1, .reusable = false}, SHIFT(4136),
  [8276] = {.count = 1, .reusable = true}, SHIFT(4137),
  [8278] = {.count = 1, .reusable = true}, SHIFT(4142),
  [8280] = {.count = 1, .reusable = true}, SHIFT(4144),
  [8282] = {.count = 1, .reusable = false}, SHIFT(4147),
  [8284] = {.count = 1, .reusable = true}, SHIFT(4147),
  [8286] = {.count = 1, .reusable = true}, SHIFT(4150),
  [8288] = {.count = 1, .reusable = true}, SHIFT(4152),
  [8290] = {.count = 1, .reusable = false}, SHIFT(4155),
  [8292] = {.count = 1, .reusable = true}, SHIFT(4156),
  [8294] = {.count = 1, .reusable = true}, SHIFT(4157),
  [8296] = {.count = 1, .reusable = true}, SHIFT(4158),
  [8298] = {.count = 1, .reusable = true}, SHIFT(4159),
  [8300] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [8302] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [8304] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(3325),
  [8307] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(3327),
  [8310] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .alias_sequence_id = 8),
  [8313] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(3399),
  [8316] = {.count = 1, .reusable = true}, SHIFT(4165),
  [8318] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(3428),
  [8321] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .alias_sequence_id = 16),
  [8323] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .alias_sequence_id = 16),
  [8325] = {.count = 1, .reusable = false}, SHIFT(2808),
  [8327] = {.count = 1, .reusable = false}, SHIFT(2807),
  [8329] = {.count = 1, .reusable = true}, SHIFT(4167),
  [8331] = {.count = 1, .reusable = true}, SHIFT(4169),
  [8333] = {.count = 1, .reusable = true}, SHIFT(4171),
  [8335] = {.count = 1, .reusable = true}, SHIFT(4173),
  [8337] = {.count = 1, .reusable = true}, SHIFT(4174),
  [8339] = {.count = 1, .reusable = true}, SHIFT(4175),
  [8341] = {.count = 1, .reusable = true}, SHIFT(4176),
  [8343] = {.count = 1, .reusable = true}, SHIFT(4178),
  [8345] = {.count = 1, .reusable = true}, SHIFT(4180),
  [8347] = {.count = 1, .reusable = false}, SHIFT(2863),
  [8349] = {.count = 1, .reusable = false}, SHIFT(2862),
  [8351] = {.count = 1, .reusable = true}, SHIFT(4184),
  [8353] = {.count = 1, .reusable = false}, SHIFT(4186),
  [8355] = {.count = 1, .reusable = true}, SHIFT(4186),
  [8357] = {.count = 1, .reusable = true}, SHIFT(4189),
  [8359] = {.count = 1, .reusable = true}, SHIFT(4191),
  [8361] = {.count = 1, .reusable = false}, SHIFT(4194),
  [8363] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [8365] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [8367] = {.count = 1, .reusable = true}, SHIFT(4195),
  [8369] = {.count = 1, .reusable = true}, SHIFT(4196),
  [8371] = {.count = 1, .reusable = true}, SHIFT(4197),
  [8373] = {.count = 1, .reusable = false}, SHIFT(4198),
  [8375] = {.count = 1, .reusable = true}, SHIFT(4198),
  [8377] = {.count = 1, .reusable = false}, SHIFT(4199),
  [8379] = {.count = 1, .reusable = true}, SHIFT(4199),
  [8381] = {.count = 1, .reusable = false}, SHIFT(4200),
  [8383] = {.count = 1, .reusable = true}, SHIFT(4200),
  [8385] = {.count = 1, .reusable = true}, SHIFT(4201),
  [8387] = {.count = 1, .reusable = true}, SHIFT(4202),
  [8389] = {.count = 1, .reusable = false}, SHIFT(4203),
  [8391] = {.count = 1, .reusable = true}, SHIFT(4203),
  [8393] = {.count = 1, .reusable = false}, SHIFT(4205),
  [8395] = {.count = 1, .reusable = true}, SHIFT(4205),
  [8397] = {.count = 1, .reusable = false}, SHIFT(4207),
  [8399] = {.count = 1, .reusable = true}, SHIFT(4207),
  [8401] = {.count = 1, .reusable = true}, SHIFT(4209),
  [8403] = {.count = 1, .reusable = true}, SHIFT(4210),
  [8405] = {.count = 1, .reusable = true}, SHIFT(4211),
  [8407] = {.count = 1, .reusable = true}, SHIFT(4212),
  [8409] = {.count = 1, .reusable = true}, SHIFT(4213),
  [8411] = {.count = 1, .reusable = false}, SHIFT(4214),
  [8413] = {.count = 1, .reusable = true}, SHIFT(4215),
  [8415] = {.count = 1, .reusable = true}, SHIFT(4216),
  [8417] = {.count = 1, .reusable = false}, SHIFT(4217),
  [8419] = {.count = 1, .reusable = true}, SHIFT(4218),
  [8421] = {.count = 1, .reusable = true}, SHIFT(4223),
  [8423] = {.count = 1, .reusable = true}, SHIFT(4225),
  [8425] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [8427] = {.count = 1, .reusable = true}, SHIFT(4228),
  [8429] = {.count = 1, .reusable = true}, SHIFT(4229),
  [8431] = {.count = 1, .reusable = true}, SHIFT(4230),
  [8433] = {.count = 1, .reusable = false}, SHIFT(4234),
  [8435] = {.count = 1, .reusable = true}, SHIFT(4234),
  [8437] = {.count = 1, .reusable = false}, SHIFT(4235),
  [8439] = {.count = 1, .reusable = true}, SHIFT(4235),
  [8441] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2968),
  [8444] = {.count = 1, .reusable = true}, SHIFT(4236),
  [8446] = {.count = 1, .reusable = true}, SHIFT(4238),
  [8448] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(4237),
  [8451] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(4244),
  [8454] = {.count = 1, .reusable = true}, SHIFT(4245),
  [8456] = {.count = 1, .reusable = false}, SHIFT(4246),
  [8458] = {.count = 1, .reusable = false}, SHIFT(4247),
  [8460] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7),
  [8462] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7),
  [8464] = {.count = 1, .reusable = false}, SHIFT(4248),
  [8466] = {.count = 1, .reusable = true}, SHIFT(4248),
  [8468] = {.count = 1, .reusable = false}, SHIFT(4249),
  [8470] = {.count = 1, .reusable = true}, SHIFT(4249),
  [8472] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2995),
  [8475] = {.count = 1, .reusable = true}, SHIFT(4250),
  [8477] = {.count = 1, .reusable = true}, SHIFT(4252),
  [8479] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(4251),
  [8482] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(4258),
  [8485] = {.count = 1, .reusable = true}, SHIFT(4259),
  [8487] = {.count = 1, .reusable = false}, SHIFT(4260),
  [8489] = {.count = 1, .reusable = false}, SHIFT(4261),
  [8491] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7),
  [8493] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7),
  [8495] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [8497] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [8499] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 20),
  [8501] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 20),
  [8503] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 20),
  [8505] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 20),
  [8507] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 19),
  [8509] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 19),
  [8511] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 19),
  [8513] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 19),
  [8515] = {.count = 1, .reusable = true}, SHIFT(4265),
  [8517] = {.count = 1, .reusable = true}, SHIFT(4266),
  [8519] = {.count = 1, .reusable = true}, SHIFT(4267),
  [8521] = {.count = 1, .reusable = true}, SHIFT(4268),
  [8523] = {.count = 1, .reusable = false}, SHIFT(3049),
  [8525] = {.count = 1, .reusable = false}, SHIFT(3048),
  [8527] = {.count = 1, .reusable = true}, SHIFT(4271),
  [8529] = {.count = 1, .reusable = true}, SHIFT(4274),
  [8531] = {.count = 1, .reusable = false}, SHIFT(4276),
  [8533] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(3320),
  [8536] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(3322),
  [8539] = {.count = 1, .reusable = false}, SHIFT(4282),
  [8541] = {.count = 1, .reusable = true}, SHIFT(4282),
  [8543] = {.count = 1, .reusable = true}, SHIFT(4285),
  [8545] = {.count = 1, .reusable = true}, SHIFT(4287),
  [8547] = {.count = 1, .reusable = false}, SHIFT(4290),
  [8549] = {.count = 1, .reusable = true}, SHIFT(4292),
  [8551] = {.count = 1, .reusable = true}, SHIFT(4291),
  [8553] = {.count = 1, .reusable = true}, SHIFT(4295),
  [8555] = {.count = 1, .reusable = true}, SHIFT(4296),
  [8557] = {.count = 1, .reusable = true}, SHIFT(4298),
  [8559] = {.count = 1, .reusable = true}, SHIFT(4299),
  [8561] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5),
  [8563] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5),
  [8565] = {.count = 1, .reusable = true}, SHIFT(4302),
  [8567] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5),
  [8569] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5),
  [8571] = {.count = 1, .reusable = true}, SHIFT(4304),
  [8573] = {.count = 1, .reusable = false}, SHIFT(4305),
  [8575] = {.count = 1, .reusable = true}, SHIFT(4306),
  [8577] = {.count = 1, .reusable = true}, SHIFT(4311),
  [8579] = {.count = 1, .reusable = true}, SHIFT(4313),
  [8581] = {.count = 1, .reusable = true}, SHIFT(4316),
  [8583] = {.count = 1, .reusable = true}, SHIFT(4321),
  [8585] = {.count = 1, .reusable = true}, SHIFT(4323),
  [8587] = {.count = 1, .reusable = false}, SHIFT(4326),
  [8589] = {.count = 1, .reusable = true}, SHIFT(4326),
  [8591] = {.count = 1, .reusable = true}, SHIFT(4329),
  [8593] = {.count = 1, .reusable = true}, SHIFT(4331),
  [8595] = {.count = 1, .reusable = false}, SHIFT(4334),
  [8597] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6),
  [8599] = {.count = 1, .reusable = true}, SHIFT(4337),
  [8601] = {.count = 1, .reusable = true}, SHIFT(4340),
  [8603] = {.count = 1, .reusable = true}, SHIFT(4341),
  [8605] = {.count = 1, .reusable = true}, SHIFT(4342),
  [8607] = {.count = 1, .reusable = false}, SHIFT(4343),
  [8609] = {.count = 1, .reusable = true}, SHIFT(4343),
  [8611] = {.count = 1, .reusable = false}, SHIFT(4345),
  [8613] = {.count = 1, .reusable = true}, SHIFT(4345),
  [8615] = {.count = 1, .reusable = true}, SHIFT(4346),
  [8617] = {.count = 1, .reusable = true}, SHIFT(4347),
  [8619] = {.count = 1, .reusable = true}, SHIFT(4348),
  [8621] = {.count = 1, .reusable = false}, SHIFT(4350),
  [8623] = {.count = 1, .reusable = true}, SHIFT(4349),
  [8625] = {.count = 1, .reusable = true}, SHIFT(4350),
  [8627] = {.count = 1, .reusable = false}, SHIFT(4352),
  [8629] = {.count = 1, .reusable = true}, SHIFT(4352),
  [8631] = {.count = 1, .reusable = false}, SHIFT(4353),
  [8633] = {.count = 1, .reusable = true}, SHIFT(4353),
  [8635] = {.count = 1, .reusable = false}, SHIFT(4355),
  [8637] = {.count = 1, .reusable = true}, SHIFT(4355),
  [8639] = {.count = 1, .reusable = false}, SHIFT(4356),
  [8641] = {.count = 1, .reusable = true}, SHIFT(4356),
  [8643] = {.count = 1, .reusable = true}, SHIFT(4358),
  [8645] = {.count = 1, .reusable = false}, SHIFT(4359),
  [8647] = {.count = 1, .reusable = true}, SHIFT(4359),
  [8649] = {.count = 1, .reusable = false}, SHIFT(4360),
  [8651] = {.count = 1, .reusable = true}, SHIFT(4360),
  [8653] = {.count = 1, .reusable = false}, SHIFT(4361),
  [8655] = {.count = 1, .reusable = true}, SHIFT(4361),
  [8657] = {.count = 1, .reusable = true}, SHIFT(4362),
  [8659] = {.count = 1, .reusable = true}, SHIFT(4363),
  [8661] = {.count = 1, .reusable = true}, SHIFT(4364),
  [8663] = {.count = 1, .reusable = true}, SHIFT(4365),
  [8665] = {.count = 1, .reusable = true}, SHIFT(4366),
  [8667] = {.count = 1, .reusable = true}, SHIFT(4367),
  [8669] = {.count = 1, .reusable = false}, SHIFT(4369),
  [8671] = {.count = 1, .reusable = false}, SHIFT(4368),
  [8673] = {.count = 1, .reusable = true}, SHIFT(4373),
  [8675] = {.count = 1, .reusable = true}, SHIFT(4372),
  [8677] = {.count = 1, .reusable = false}, SHIFT(4375),
  [8679] = {.count = 1, .reusable = true}, SHIFT(4376),
  [8681] = {.count = 1, .reusable = true}, SHIFT(4377),
  [8683] = {.count = 1, .reusable = false}, SHIFT(4378),
  [8685] = {.count = 1, .reusable = true}, SHIFT(4378),
  [8687] = {.count = 1, .reusable = false}, SHIFT(4379),
  [8689] = {.count = 1, .reusable = true}, SHIFT(4379),
  [8691] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(3242),
  [8694] = {.count = 1, .reusable = true}, SHIFT(4380),
  [8696] = {.count = 1, .reusable = true}, SHIFT(4382),
  [8698] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(4381),
  [8701] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(4388),
  [8704] = {.count = 1, .reusable = true}, SHIFT(4389),
  [8706] = {.count = 1, .reusable = false}, SHIFT(4390),
  [8708] = {.count = 1, .reusable = false}, SHIFT(4391),
  [8710] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4),
  [8712] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4),
  [8714] = {.count = 1, .reusable = false}, SHIFT(4392),
  [8716] = {.count = 1, .reusable = false}, SHIFT(4393),
  [8718] = {.count = 1, .reusable = false}, SHIFT(4394),
  [8720] = {.count = 1, .reusable = false}, SHIFT(4395),
  [8722] = {.count = 1, .reusable = false}, SHIFT(4396),
  [8724] = {.count = 1, .reusable = false}, SHIFT(4397),
  [8726] = {.count = 1, .reusable = false}, SHIFT(4398),
  [8728] = {.count = 1, .reusable = true}, SHIFT(4401),
  [8730] = {.count = 1, .reusable = false}, SHIFT(4402),
  [8732] = {.count = 1, .reusable = false}, SHIFT(4403),
  [8734] = {.count = 1, .reusable = false}, SHIFT(4404),
  [8736] = {.count = 1, .reusable = true}, SHIFT(4408),
  [8738] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3245),
  [8741] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [8743] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3246),
  [8746] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3247),
  [8749] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3248),
  [8752] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3249),
  [8755] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3250),
  [8758] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3251),
  [8761] = {.count = 1, .reusable = true}, SHIFT(4409),
  [8763] = {.count = 1, .reusable = true}, SHIFT(4411),
  [8765] = {.count = 1, .reusable = true}, SHIFT(4416),
  [8767] = {.count = 1, .reusable = true}, SHIFT(4417),
  [8769] = {.count = 1, .reusable = true}, SHIFT(4419),
  [8771] = {.count = 1, .reusable = true}, SHIFT(4421),
  [8773] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6, .alias_sequence_id = 18),
  [8775] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6),
  [8777] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6, .alias_sequence_id = 19),
  [8779] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6, .alias_sequence_id = 20),
  [8781] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5),
  [8783] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5),
  [8785] = {.count = 1, .reusable = true}, SHIFT(4424),
  [8787] = {.count = 1, .reusable = true}, SHIFT(4426),
  [8789] = {.count = 1, .reusable = true}, SHIFT(4429),
  [8791] = {.count = 1, .reusable = true}, SHIFT(4431),
  [8793] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6),
  [8795] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6),
  [8797] = {.count = 1, .reusable = true}, SHIFT(4435),
  [8799] = {.count = 1, .reusable = true}, SHIFT(4437),
  [8801] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5),
  [8803] = {.count = 1, .reusable = true}, SHIFT(4439),
  [8805] = {.count = 1, .reusable = true}, SHIFT(4440),
  [8807] = {.count = 1, .reusable = true}, SHIFT(4442),
  [8809] = {.count = 1, .reusable = true}, SHIFT(4445),
  [8811] = {.count = 1, .reusable = true}, SHIFT(4447),
  [8813] = {.count = 1, .reusable = true}, SHIFT(4448),
  [8815] = {.count = 1, .reusable = true}, SHIFT(4451),
  [8817] = {.count = 1, .reusable = false}, SHIFT(4452),
  [8819] = {.count = 1, .reusable = true}, SHIFT(4454),
  [8821] = {.count = 1, .reusable = true}, SHIFT(4456),
  [8823] = {.count = 1, .reusable = true}, SHIFT(4458),
  [8825] = {.count = 1, .reusable = true}, SHIFT(4461),
  [8827] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(4015),
  [8830] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4017),
  [8833] = {.count = 1, .reusable = true}, SHIFT(4465),
  [8835] = {.count = 1, .reusable = false}, SHIFT(4467),
  [8837] = {.count = 1, .reusable = false}, SHIFT(4468),
  [8839] = {.count = 1, .reusable = true}, SHIFT(4470),
  [8841] = {.count = 1, .reusable = true}, SHIFT(4471),
  [8843] = {.count = 1, .reusable = false}, SHIFT(4472),
  [8845] = {.count = 1, .reusable = true}, SHIFT(4475),
  [8847] = {.count = 1, .reusable = true}, SHIFT(4476),
  [8849] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(4007),
  [8852] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4009),
  [8855] = {.count = 1, .reusable = true}, SHIFT(4478),
  [8857] = {.count = 1, .reusable = true}, SHIFT(4479),
  [8859] = {.count = 1, .reusable = true}, SHIFT(4482),
  [8861] = {.count = 1, .reusable = false}, SHIFT(4483),
  [8863] = {.count = 1, .reusable = true}, SHIFT(4485),
  [8865] = {.count = 1, .reusable = true}, SHIFT(4486),
  [8867] = {.count = 1, .reusable = true}, SHIFT(4488),
  [8869] = {.count = 1, .reusable = false}, SHIFT(4487),
  [8871] = {.count = 1, .reusable = true}, SHIFT(4489),
  [8873] = {.count = 1, .reusable = true}, SHIFT(4492),
  [8875] = {.count = 1, .reusable = true}, SHIFT(4493),
  [8877] = {.count = 1, .reusable = true}, SHIFT(4495),
  [8879] = {.count = 1, .reusable = true}, SHIFT(4497),
  [8881] = {.count = 1, .reusable = true}, SHIFT(4499),
  [8883] = {.count = 1, .reusable = true}, SHIFT(4501),
  [8885] = {.count = 1, .reusable = false}, SHIFT(3472),
  [8887] = {.count = 1, .reusable = false}, SHIFT(3471),
  [8889] = {.count = 1, .reusable = true}, SHIFT(4506),
  [8891] = {.count = 1, .reusable = true}, SHIFT(4508),
  [8893] = {.count = 1, .reusable = true}, SHIFT(4509),
  [8895] = {.count = 1, .reusable = true}, SHIFT(4512),
  [8897] = {.count = 1, .reusable = true}, SHIFT(4513),
  [8899] = {.count = 1, .reusable = true}, SHIFT(4514),
  [8901] = {.count = 1, .reusable = false}, SHIFT(4515),
  [8903] = {.count = 1, .reusable = true}, SHIFT(4515),
  [8905] = {.count = 1, .reusable = false}, SHIFT(4517),
  [8907] = {.count = 1, .reusable = true}, SHIFT(4517),
  [8909] = {.count = 1, .reusable = true}, SHIFT(4518),
  [8911] = {.count = 1, .reusable = true}, SHIFT(4519),
  [8913] = {.count = 1, .reusable = true}, SHIFT(4520),
  [8915] = {.count = 1, .reusable = false}, SHIFT(4522),
  [8917] = {.count = 1, .reusable = true}, SHIFT(4521),
  [8919] = {.count = 1, .reusable = true}, SHIFT(4522),
  [8921] = {.count = 1, .reusable = false}, SHIFT(4524),
  [8923] = {.count = 1, .reusable = true}, SHIFT(4524),
  [8925] = {.count = 1, .reusable = false}, SHIFT(4525),
  [8927] = {.count = 1, .reusable = true}, SHIFT(4525),
  [8929] = {.count = 1, .reusable = false}, SHIFT(4527),
  [8931] = {.count = 1, .reusable = true}, SHIFT(4527),
  [8933] = {.count = 1, .reusable = false}, SHIFT(4528),
  [8935] = {.count = 1, .reusable = true}, SHIFT(4528),
  [8937] = {.count = 1, .reusable = true}, SHIFT(4530),
  [8939] = {.count = 1, .reusable = false}, SHIFT(4531),
  [8941] = {.count = 1, .reusable = true}, SHIFT(4531),
  [8943] = {.count = 1, .reusable = false}, SHIFT(4532),
  [8945] = {.count = 1, .reusable = true}, SHIFT(4532),
  [8947] = {.count = 1, .reusable = false}, SHIFT(4533),
  [8949] = {.count = 1, .reusable = true}, SHIFT(4533),
  [8951] = {.count = 1, .reusable = true}, SHIFT(4534),
  [8953] = {.count = 1, .reusable = true}, SHIFT(4535),
  [8955] = {.count = 1, .reusable = true}, SHIFT(4536),
  [8957] = {.count = 1, .reusable = true}, SHIFT(4537),
  [8959] = {.count = 1, .reusable = true}, SHIFT(4538),
  [8961] = {.count = 1, .reusable = true}, SHIFT(4539),
  [8963] = {.count = 1, .reusable = true}, SHIFT(4541),
  [8965] = {.count = 1, .reusable = true}, SHIFT(4540),
  [8967] = {.count = 1, .reusable = true}, SHIFT(4544),
  [8969] = {.count = 1, .reusable = true}, SHIFT(4545),
  [8971] = {.count = 1, .reusable = true}, SHIFT(4547),
  [8973] = {.count = 1, .reusable = true}, SHIFT(4548),
  [8975] = {.count = 1, .reusable = true}, SHIFT(4550),
  [8977] = {.count = 1, .reusable = false}, SHIFT(3531),
  [8979] = {.count = 1, .reusable = false}, SHIFT(3530),
  [8981] = {.count = 1, .reusable = true}, SHIFT(4553),
  [8983] = {.count = 1, .reusable = true}, SHIFT(4555),
  [8985] = {.count = 1, .reusable = true}, SHIFT(4556),
  [8987] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [8989] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(3972),
  [8992] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(4024),
  [8995] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4026),
  [8998] = {.count = 1, .reusable = true}, SHIFT(4560),
  [9000] = {.count = 1, .reusable = true}, SHIFT(4562),
  [9002] = {.count = 1, .reusable = true}, SHIFT(4563),
  [9004] = {.count = 1, .reusable = true}, SHIFT(4565),
  [9006] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5),
  [9008] = {.count = 1, .reusable = false}, SHIFT(3617),
  [9010] = {.count = 1, .reusable = false}, SHIFT(3616),
  [9012] = {.count = 1, .reusable = true}, SHIFT(4569),
  [9014] = {.count = 1, .reusable = false}, SHIFT(4571),
  [9016] = {.count = 1, .reusable = true}, SHIFT(4571),
  [9018] = {.count = 1, .reusable = false}, SHIFT(4572),
  [9020] = {.count = 1, .reusable = true}, SHIFT(4572),
  [9022] = {.count = 1, .reusable = false}, SHIFT(4573),
  [9024] = {.count = 1, .reusable = true}, SHIFT(4573),
  [9026] = {.count = 1, .reusable = true}, SHIFT(4574),
  [9028] = {.count = 1, .reusable = true}, SHIFT(4575),
  [9030] = {.count = 1, .reusable = true}, SHIFT(4576),
  [9032] = {.count = 1, .reusable = true}, SHIFT(4577),
  [9034] = {.count = 1, .reusable = true}, SHIFT(4578),
  [9036] = {.count = 1, .reusable = true}, SHIFT(4579),
  [9038] = {.count = 1, .reusable = false}, SHIFT(4581),
  [9040] = {.count = 1, .reusable = false}, SHIFT(4580),
  [9042] = {.count = 1, .reusable = true}, SHIFT(4585),
  [9044] = {.count = 1, .reusable = true}, SHIFT(4584),
  [9046] = {.count = 1, .reusable = false}, SHIFT(4587),
  [9048] = {.count = 1, .reusable = true}, SHIFT(4588),
  [9050] = {.count = 1, .reusable = true}, SHIFT(4590),
  [9052] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8),
  [9054] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8),
  [9056] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 23),
  [9058] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 23),
  [9060] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 24),
  [9062] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 24),
  [9064] = {.count = 1, .reusable = false}, SHIFT(4595),
  [9066] = {.count = 1, .reusable = true}, SHIFT(4595),
  [9068] = {.count = 1, .reusable = true}, SHIFT(4598),
  [9070] = {.count = 1, .reusable = true}, SHIFT(4600),
  [9072] = {.count = 1, .reusable = false}, SHIFT(4603),
  [9074] = {.count = 1, .reusable = false}, SHIFT(4604),
  [9076] = {.count = 1, .reusable = true}, SHIFT(4604),
  [9078] = {.count = 1, .reusable = true}, SHIFT(4607),
  [9080] = {.count = 1, .reusable = true}, SHIFT(4609),
  [9082] = {.count = 1, .reusable = false}, SHIFT(4612),
  [9084] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8),
  [9086] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8),
  [9088] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 23),
  [9090] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 23),
  [9092] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 24),
  [9094] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 24),
  [9096] = {.count = 1, .reusable = true}, SHIFT(4613),
  [9098] = {.count = 1, .reusable = true}, SHIFT(4614),
  [9100] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(3967),
  [9103] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(3969),
  [9106] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [9108] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .alias_sequence_id = 6),
  [9110] = {.count = 1, .reusable = false}, SHIFT(3772),
  [9112] = {.count = 1, .reusable = false}, SHIFT(3771),
  [9114] = {.count = 1, .reusable = true}, SHIFT(4621),
  [9116] = {.count = 1, .reusable = true}, SHIFT(4623),
  [9118] = {.count = 1, .reusable = false}, SHIFT(4624),
  [9120] = {.count = 1, .reusable = true}, SHIFT(4625),
  [9122] = {.count = 1, .reusable = true}, SHIFT(4630),
  [9124] = {.count = 1, .reusable = true}, SHIFT(4632),
  [9126] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6),
  [9128] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6),
  [9130] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6),
  [9132] = {.count = 1, .reusable = true}, SHIFT(4639),
  [9134] = {.count = 1, .reusable = true}, SHIFT(4640),
  [9136] = {.count = 1, .reusable = true}, SHIFT(4642),
  [9138] = {.count = 1, .reusable = true}, SHIFT(4644),
  [9140] = {.count = 1, .reusable = true}, SHIFT(4646),
  [9142] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6),
  [9144] = {.count = 1, .reusable = true}, SHIFT(4649),
  [9146] = {.count = 1, .reusable = false}, SHIFT(3827),
  [9148] = {.count = 1, .reusable = false}, SHIFT(3826),
  [9150] = {.count = 1, .reusable = true}, SHIFT(4652),
  [9152] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7),
  [9154] = {.count = 1, .reusable = true}, SHIFT(4655),
  [9156] = {.count = 1, .reusable = true}, SHIFT(4656),
  [9158] = {.count = 1, .reusable = true}, SHIFT(4657),
  [9160] = {.count = 1, .reusable = false}, SHIFT(4658),
  [9162] = {.count = 1, .reusable = true}, SHIFT(4658),
  [9164] = {.count = 1, .reusable = false}, SHIFT(4659),
  [9166] = {.count = 1, .reusable = true}, SHIFT(4659),
  [9168] = {.count = 1, .reusable = false}, SHIFT(4660),
  [9170] = {.count = 1, .reusable = true}, SHIFT(4660),
  [9172] = {.count = 1, .reusable = true}, SHIFT(4661),
  [9174] = {.count = 1, .reusable = true}, SHIFT(4662),
  [9176] = {.count = 1, .reusable = false}, SHIFT(4663),
  [9178] = {.count = 1, .reusable = true}, SHIFT(4663),
  [9180] = {.count = 1, .reusable = false}, SHIFT(4665),
  [9182] = {.count = 1, .reusable = true}, SHIFT(4665),
  [9184] = {.count = 1, .reusable = false}, SHIFT(4667),
  [9186] = {.count = 1, .reusable = true}, SHIFT(4667),
  [9188] = {.count = 1, .reusable = true}, SHIFT(4669),
  [9190] = {.count = 1, .reusable = true}, SHIFT(4670),
  [9192] = {.count = 1, .reusable = true}, SHIFT(4671),
  [9194] = {.count = 1, .reusable = true}, SHIFT(4672),
  [9196] = {.count = 1, .reusable = true}, SHIFT(4673),
  [9198] = {.count = 1, .reusable = false}, SHIFT(4674),
  [9200] = {.count = 1, .reusable = true}, SHIFT(4675),
  [9202] = {.count = 1, .reusable = true}, SHIFT(4676),
  [9204] = {.count = 1, .reusable = false}, SHIFT(4677),
  [9206] = {.count = 1, .reusable = true}, SHIFT(4678),
  [9208] = {.count = 1, .reusable = true}, SHIFT(4683),
  [9210] = {.count = 1, .reusable = true}, SHIFT(4684),
  [9212] = {.count = 1, .reusable = true}, SHIFT(4685),
  [9214] = {.count = 1, .reusable = true}, SHIFT(4688),
  [9216] = {.count = 1, .reusable = true}, SHIFT(4690),
  [9218] = {.count = 1, .reusable = false}, SHIFT(4694),
  [9220] = {.count = 1, .reusable = true}, SHIFT(4694),
  [9222] = {.count = 1, .reusable = true}, SHIFT(4697),
  [9224] = {.count = 1, .reusable = true}, SHIFT(4699),
  [9226] = {.count = 1, .reusable = false}, SHIFT(4702),
  [9228] = {.count = 1, .reusable = true}, SHIFT(4703),
  [9230] = {.count = 1, .reusable = true}, SHIFT(4705),
  [9232] = {.count = 1, .reusable = true}, SHIFT(4706),
  [9234] = {.count = 1, .reusable = true}, SHIFT(4707),
  [9236] = {.count = 1, .reusable = true}, SHIFT(4708),
  [9238] = {.count = 1, .reusable = true}, SHIFT(4709),
  [9240] = {.count = 1, .reusable = false}, SHIFT(4713),
  [9242] = {.count = 1, .reusable = true}, SHIFT(4714),
  [9244] = {.count = 1, .reusable = false}, SHIFT(4716),
  [9246] = {.count = 1, .reusable = false}, SHIFT(4715),
  [9248] = {.count = 1, .reusable = true}, SHIFT(4720),
  [9250] = {.count = 1, .reusable = false}, SHIFT(4719),
  [9252] = {.count = 1, .reusable = true}, SHIFT(4721),
  [9254] = {.count = 1, .reusable = true}, SHIFT(4725),
  [9256] = {.count = 1, .reusable = false}, SHIFT(4726),
  [9258] = {.count = 1, .reusable = true}, SHIFT(4727),
  [9260] = {.count = 1, .reusable = false}, SHIFT(4728),
  [9262] = {.count = 1, .reusable = true}, SHIFT(4729),
  [9264] = {.count = 1, .reusable = true}, SHIFT(4731),
  [9266] = {.count = 1, .reusable = true}, SHIFT(4733),
  [9268] = {.count = 1, .reusable = true}, SHIFT(4735),
  [9270] = {.count = 1, .reusable = true}, SHIFT(4739),
  [9272] = {.count = 1, .reusable = true}, SHIFT(4742),
  [9274] = {.count = 1, .reusable = true}, SHIFT(4745),
  [9276] = {.count = 1, .reusable = true}, SHIFT(4746),
  [9278] = {.count = 1, .reusable = true}, SHIFT(4749),
  [9280] = {.count = 1, .reusable = true}, SHIFT(4750),
  [9282] = {.count = 1, .reusable = true}, SHIFT(4752),
  [9284] = {.count = 1, .reusable = true}, SHIFT(4755),
  [9286] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6),
  [9288] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4461),
  [9291] = {.count = 1, .reusable = false}, SHIFT(4758),
  [9293] = {.count = 1, .reusable = true}, SHIFT(4760),
  [9295] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(4454),
  [9298] = {.count = 1, .reusable = true}, SHIFT(4764),
  [9300] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4456),
  [9303] = {.count = 1, .reusable = true}, SHIFT(4765),
  [9305] = {.count = 1, .reusable = false}, SHIFT(4766),
  [9307] = {.count = 1, .reusable = true}, SHIFT(4767),
  [9309] = {.count = 1, .reusable = true}, SHIFT(4772),
  [9311] = {.count = 1, .reusable = true}, SHIFT(4774),
  [9313] = {.count = 1, .reusable = true}, SHIFT(4777),
  [9315] = {.count = 1, .reusable = true}, SHIFT(4778),
  [9317] = {.count = 1, .reusable = true}, SHIFT(4780),
  [9319] = {.count = 1, .reusable = true}, SHIFT(4784),
  [9321] = {.count = 1, .reusable = true}, SHIFT(4787),
  [9323] = {.count = 1, .reusable = true}, SHIFT(4788),
  [9325] = {.count = 1, .reusable = true}, SHIFT(4789),
  [9327] = {.count = 1, .reusable = false}, SHIFT(4790),
  [9329] = {.count = 1, .reusable = true}, SHIFT(4790),
  [9331] = {.count = 1, .reusable = false}, SHIFT(4791),
  [9333] = {.count = 1, .reusable = true}, SHIFT(4791),
  [9335] = {.count = 1, .reusable = false}, SHIFT(4792),
  [9337] = {.count = 1, .reusable = true}, SHIFT(4792),
  [9339] = {.count = 1, .reusable = true}, SHIFT(4793),
  [9341] = {.count = 1, .reusable = true}, SHIFT(4794),
  [9343] = {.count = 1, .reusable = false}, SHIFT(4795),
  [9345] = {.count = 1, .reusable = true}, SHIFT(4795),
  [9347] = {.count = 1, .reusable = false}, SHIFT(4797),
  [9349] = {.count = 1, .reusable = true}, SHIFT(4797),
  [9351] = {.count = 1, .reusable = false}, SHIFT(4799),
  [9353] = {.count = 1, .reusable = true}, SHIFT(4799),
  [9355] = {.count = 1, .reusable = true}, SHIFT(4801),
  [9357] = {.count = 1, .reusable = true}, SHIFT(4802),
  [9359] = {.count = 1, .reusable = true}, SHIFT(4803),
  [9361] = {.count = 1, .reusable = true}, SHIFT(4804),
  [9363] = {.count = 1, .reusable = true}, SHIFT(4805),
  [9365] = {.count = 1, .reusable = false}, SHIFT(4806),
  [9367] = {.count = 1, .reusable = true}, SHIFT(4807),
  [9369] = {.count = 1, .reusable = true}, SHIFT(4808),
  [9371] = {.count = 1, .reusable = false}, SHIFT(4809),
  [9373] = {.count = 1, .reusable = true}, SHIFT(4810),
  [9375] = {.count = 1, .reusable = true}, SHIFT(4815),
  [9377] = {.count = 1, .reusable = true}, SHIFT(4816),
  [9379] = {.count = 1, .reusable = true}, SHIFT(4817),
  [9381] = {.count = 1, .reusable = true}, SHIFT(4818),
  [9383] = {.count = 1, .reusable = false}, SHIFT(4819),
  [9385] = {.count = 1, .reusable = true}, SHIFT(4820),
  [9387] = {.count = 1, .reusable = true}, SHIFT(4825),
  [9389] = {.count = 1, .reusable = true}, SHIFT(4827),
  [9391] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4465),
  [9394] = {.count = 1, .reusable = true}, SHIFT(4835),
  [9396] = {.count = 1, .reusable = true}, SHIFT(4836),
  [9398] = {.count = 1, .reusable = true}, SHIFT(4837),
  [9400] = {.count = 1, .reusable = true}, SHIFT(4840),
  [9402] = {.count = 1, .reusable = true}, SHIFT(4842),
  [9404] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9),
  [9406] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9),
  [9408] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 25),
  [9410] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 25),
  [9412] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 26),
  [9414] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 26),
  [9416] = {.count = 1, .reusable = false}, SHIFT(4242),
  [9418] = {.count = 1, .reusable = false}, SHIFT(4241),
  [9420] = {.count = 1, .reusable = true}, SHIFT(4847),
  [9422] = {.count = 1, .reusable = false}, SHIFT(4256),
  [9424] = {.count = 1, .reusable = false}, SHIFT(4255),
  [9426] = {.count = 1, .reusable = true}, SHIFT(4850),
  [9428] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(4429),
  [9431] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4431),
  [9434] = {.count = 1, .reusable = true}, SHIFT(4856),
  [9436] = {.count = 1, .reusable = true}, SHIFT(4857),
  [9438] = {.count = 1, .reusable = true}, SHIFT(4859),
  [9440] = {.count = 1, .reusable = true}, SHIFT(4861),
  [9442] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7),
  [9444] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7),
  [9446] = {.count = 1, .reusable = true}, SHIFT(4864),
  [9448] = {.count = 1, .reusable = true}, SHIFT(4866),
  [9450] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7),
  [9452] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8),
  [9454] = {.count = 1, .reusable = false}, SHIFT(4872),
  [9456] = {.count = 1, .reusable = true}, SHIFT(4872),
  [9458] = {.count = 1, .reusable = false}, SHIFT(4873),
  [9460] = {.count = 1, .reusable = true}, SHIFT(4873),
  [9462] = {.count = 1, .reusable = false}, SHIFT(4874),
  [9464] = {.count = 1, .reusable = true}, SHIFT(4874),
  [9466] = {.count = 1, .reusable = true}, SHIFT(4875),
  [9468] = {.count = 1, .reusable = true}, SHIFT(4876),
  [9470] = {.count = 1, .reusable = true}, SHIFT(4877),
  [9472] = {.count = 1, .reusable = true}, SHIFT(4878),
  [9474] = {.count = 1, .reusable = true}, SHIFT(4879),
  [9476] = {.count = 1, .reusable = true}, SHIFT(4880),
  [9478] = {.count = 1, .reusable = false}, SHIFT(4882),
  [9480] = {.count = 1, .reusable = false}, SHIFT(4881),
  [9482] = {.count = 1, .reusable = true}, SHIFT(4886),
  [9484] = {.count = 1, .reusable = true}, SHIFT(4885),
  [9486] = {.count = 1, .reusable = false}, SHIFT(4888),
  [9488] = {.count = 1, .reusable = true}, SHIFT(4889),
  [9490] = {.count = 1, .reusable = true}, SHIFT(4891),
  [9492] = {.count = 1, .reusable = false}, SHIFT(4386),
  [9494] = {.count = 1, .reusable = false}, SHIFT(4385),
  [9496] = {.count = 1, .reusable = true}, SHIFT(4895),
  [9498] = {.count = 1, .reusable = true}, SHIFT(4898),
  [9500] = {.count = 1, .reusable = false}, SHIFT(4899),
  [9502] = {.count = 1, .reusable = false}, SHIFT(4900),
  [9504] = {.count = 1, .reusable = false}, SHIFT(4901),
  [9506] = {.count = 1, .reusable = true}, SHIFT(4905),
  [9508] = {.count = 1, .reusable = true}, SHIFT(4906),
  [9510] = {.count = 1, .reusable = true}, SHIFT(4909),
  [9512] = {.count = 1, .reusable = true}, SHIFT(4910),
  [9514] = {.count = 1, .reusable = true}, SHIFT(4911),
  [9516] = {.count = 1, .reusable = false}, SHIFT(4912),
  [9518] = {.count = 1, .reusable = true}, SHIFT(4912),
  [9520] = {.count = 1, .reusable = false}, SHIFT(4914),
  [9522] = {.count = 1, .reusable = true}, SHIFT(4914),
  [9524] = {.count = 1, .reusable = true}, SHIFT(4915),
  [9526] = {.count = 1, .reusable = true}, SHIFT(4916),
  [9528] = {.count = 1, .reusable = true}, SHIFT(4917),
  [9530] = {.count = 1, .reusable = false}, SHIFT(4919),
  [9532] = {.count = 1, .reusable = true}, SHIFT(4918),
  [9534] = {.count = 1, .reusable = true}, SHIFT(4919),
  [9536] = {.count = 1, .reusable = false}, SHIFT(4921),
  [9538] = {.count = 1, .reusable = true}, SHIFT(4921),
  [9540] = {.count = 1, .reusable = false}, SHIFT(4922),
  [9542] = {.count = 1, .reusable = true}, SHIFT(4922),
  [9544] = {.count = 1, .reusable = false}, SHIFT(4924),
  [9546] = {.count = 1, .reusable = true}, SHIFT(4924),
  [9548] = {.count = 1, .reusable = false}, SHIFT(4925),
  [9550] = {.count = 1, .reusable = true}, SHIFT(4925),
  [9552] = {.count = 1, .reusable = true}, SHIFT(4927),
  [9554] = {.count = 1, .reusable = true}, SHIFT(4930),
  [9556] = {.count = 1, .reusable = true}, SHIFT(4934),
  [9558] = {.count = 1, .reusable = true}, SHIFT(4936),
  [9560] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(4750),
  [9563] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4752),
  [9566] = {.count = 1, .reusable = true}, SHIFT(4943),
  [9568] = {.count = 1, .reusable = false}, SHIFT(4944),
  [9570] = {.count = 1, .reusable = true}, SHIFT(4946),
  [9572] = {.count = 1, .reusable = true}, SHIFT(4948),
  [9574] = {.count = 1, .reusable = true}, SHIFT(4950),
  [9576] = {.count = 1, .reusable = true}, SHIFT(4952),
  [9578] = {.count = 1, .reusable = false}, SHIFT(4955),
  [9580] = {.count = 1, .reusable = true}, SHIFT(4955),
  [9582] = {.count = 1, .reusable = false}, SHIFT(4956),
  [9584] = {.count = 1, .reusable = true}, SHIFT(4956),
  [9586] = {.count = 1, .reusable = false}, SHIFT(4957),
  [9588] = {.count = 1, .reusable = true}, SHIFT(4957),
  [9590] = {.count = 1, .reusable = true}, SHIFT(4958),
  [9592] = {.count = 1, .reusable = true}, SHIFT(4959),
  [9594] = {.count = 1, .reusable = true}, SHIFT(4960),
  [9596] = {.count = 1, .reusable = true}, SHIFT(4961),
  [9598] = {.count = 1, .reusable = true}, SHIFT(4962),
  [9600] = {.count = 1, .reusable = true}, SHIFT(4963),
  [9602] = {.count = 1, .reusable = true}, SHIFT(4965),
  [9604] = {.count = 1, .reusable = true}, SHIFT(4964),
  [9606] = {.count = 1, .reusable = true}, SHIFT(4968),
  [9608] = {.count = 1, .reusable = true}, SHIFT(4969),
  [9610] = {.count = 1, .reusable = true}, SHIFT(4971),
  [9612] = {.count = 1, .reusable = true}, SHIFT(4972),
  [9614] = {.count = 1, .reusable = true}, SHIFT(4975),
  [9616] = {.count = 1, .reusable = true}, SHIFT(4976),
  [9618] = {.count = 1, .reusable = true}, SHIFT(4978),
  [9620] = {.count = 1, .reusable = true}, SHIFT(4980),
  [9622] = {.count = 1, .reusable = true}, SHIFT(4983),
  [9624] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4742),
  [9627] = {.count = 1, .reusable = true}, SHIFT(4987),
  [9629] = {.count = 1, .reusable = true}, SHIFT(4989),
  [9631] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8),
  [9633] = {.count = 1, .reusable = true}, SHIFT(4993),
  [9635] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8),
  [9637] = {.count = 1, .reusable = true}, SHIFT(4996),
  [9639] = {.count = 1, .reusable = true}, SHIFT(4997),
  [9641] = {.count = 1, .reusable = true}, SHIFT(4998),
  [9643] = {.count = 1, .reusable = true}, SHIFT(5001),
  [9645] = {.count = 1, .reusable = true}, SHIFT(5003),
  [9647] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9),
  [9649] = {.count = 1, .reusable = false}, SHIFT(5008),
  [9651] = {.count = 1, .reusable = false}, SHIFT(5010),
  [9653] = {.count = 1, .reusable = false}, SHIFT(5009),
  [9655] = {.count = 1, .reusable = true}, SHIFT(5014),
  [9657] = {.count = 1, .reusable = false}, SHIFT(5013),
  [9659] = {.count = 1, .reusable = true}, SHIFT(5015),
  [9661] = {.count = 1, .reusable = true}, SHIFT(5019),
  [9663] = {.count = 1, .reusable = false}, SHIFT(5020),
  [9665] = {.count = 1, .reusable = true}, SHIFT(5021),
  [9667] = {.count = 1, .reusable = false}, SHIFT(5022),
  [9669] = {.count = 1, .reusable = true}, SHIFT(5023),
  [9671] = {.count = 1, .reusable = true}, SHIFT(5024),
  [9673] = {.count = 1, .reusable = true}, SHIFT(5025),
  [9675] = {.count = 1, .reusable = true}, SHIFT(5026),
  [9677] = {.count = 1, .reusable = false}, SHIFT(5027),
  [9679] = {.count = 1, .reusable = true}, SHIFT(5027),
  [9681] = {.count = 1, .reusable = false}, SHIFT(5028),
  [9683] = {.count = 1, .reusable = true}, SHIFT(5028),
  [9685] = {.count = 1, .reusable = false}, SHIFT(5029),
  [9687] = {.count = 1, .reusable = true}, SHIFT(5029),
  [9689] = {.count = 1, .reusable = true}, SHIFT(5030),
  [9691] = {.count = 1, .reusable = true}, SHIFT(5031),
  [9693] = {.count = 1, .reusable = false}, SHIFT(5032),
  [9695] = {.count = 1, .reusable = true}, SHIFT(5032),
  [9697] = {.count = 1, .reusable = false}, SHIFT(5034),
  [9699] = {.count = 1, .reusable = true}, SHIFT(5034),
  [9701] = {.count = 1, .reusable = false}, SHIFT(5036),
  [9703] = {.count = 1, .reusable = true}, SHIFT(5036),
  [9705] = {.count = 1, .reusable = true}, SHIFT(5038),
  [9707] = {.count = 1, .reusable = true}, SHIFT(5039),
  [9709] = {.count = 1, .reusable = true}, SHIFT(5040),
  [9711] = {.count = 1, .reusable = true}, SHIFT(5041),
  [9713] = {.count = 1, .reusable = true}, SHIFT(5042),
  [9715] = {.count = 1, .reusable = false}, SHIFT(5043),
  [9717] = {.count = 1, .reusable = true}, SHIFT(5044),
  [9719] = {.count = 1, .reusable = true}, SHIFT(5045),
  [9721] = {.count = 1, .reusable = false}, SHIFT(5046),
  [9723] = {.count = 1, .reusable = true}, SHIFT(5047),
  [9725] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4936),
  [9728] = {.count = 1, .reusable = true}, SHIFT(5054),
  [9730] = {.count = 1, .reusable = true}, SHIFT(5056),
  [9732] = {.count = 1, .reusable = true}, SHIFT(5061),
  [9734] = {.count = 1, .reusable = true}, SHIFT(5062),
  [9736] = {.count = 1, .reusable = true}, SHIFT(5063),
  [9738] = {.count = 1, .reusable = true}, SHIFT(5064),
  [9740] = {.count = 1, .reusable = false}, SHIFT(5065),
  [9742] = {.count = 1, .reusable = true}, SHIFT(5066),
  [9744] = {.count = 1, .reusable = true}, SHIFT(5071),
  [9746] = {.count = 1, .reusable = true}, SHIFT(5073),
  [9748] = {.count = 1, .reusable = true}, SHIFT(5076),
  [9750] = {.count = 1, .reusable = true}, SHIFT(5078),
  [9752] = {.count = 1, .reusable = true}, SHIFT(5083),
  [9754] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9),
  [9756] = {.count = 1, .reusable = true}, SHIFT(5087),
  [9758] = {.count = 1, .reusable = true}, SHIFT(5089),
  [9760] = {.count = 1, .reusable = true}, SHIFT(5092),
  [9762] = {.count = 1, .reusable = true}, SHIFT(5093),
  [9764] = {.count = 1, .reusable = true}, SHIFT(5094),
  [9766] = {.count = 1, .reusable = false}, SHIFT(5095),
  [9768] = {.count = 1, .reusable = true}, SHIFT(5095),
  [9770] = {.count = 1, .reusable = false}, SHIFT(5097),
  [9772] = {.count = 1, .reusable = true}, SHIFT(5097),
  [9774] = {.count = 1, .reusable = true}, SHIFT(5098),
  [9776] = {.count = 1, .reusable = true}, SHIFT(5099),
  [9778] = {.count = 1, .reusable = true}, SHIFT(5100),
  [9780] = {.count = 1, .reusable = false}, SHIFT(5102),
  [9782] = {.count = 1, .reusable = true}, SHIFT(5101),
  [9784] = {.count = 1, .reusable = true}, SHIFT(5102),
  [9786] = {.count = 1, .reusable = false}, SHIFT(5104),
  [9788] = {.count = 1, .reusable = true}, SHIFT(5104),
  [9790] = {.count = 1, .reusable = false}, SHIFT(5105),
  [9792] = {.count = 1, .reusable = true}, SHIFT(5105),
  [9794] = {.count = 1, .reusable = false}, SHIFT(5107),
  [9796] = {.count = 1, .reusable = true}, SHIFT(5107),
  [9798] = {.count = 1, .reusable = false}, SHIFT(5108),
  [9800] = {.count = 1, .reusable = true}, SHIFT(5108),
  [9802] = {.count = 1, .reusable = true}, SHIFT(5110),
  [9804] = {.count = 1, .reusable = false}, SHIFT(5111),
  [9806] = {.count = 1, .reusable = true}, SHIFT(5111),
  [9808] = {.count = 1, .reusable = false}, SHIFT(5112),
  [9810] = {.count = 1, .reusable = true}, SHIFT(5112),
  [9812] = {.count = 1, .reusable = false}, SHIFT(5113),
  [9814] = {.count = 1, .reusable = true}, SHIFT(5113),
  [9816] = {.count = 1, .reusable = true}, SHIFT(5114),
  [9818] = {.count = 1, .reusable = true}, SHIFT(5115),
  [9820] = {.count = 1, .reusable = true}, SHIFT(5116),
  [9822] = {.count = 1, .reusable = true}, SHIFT(5117),
  [9824] = {.count = 1, .reusable = true}, SHIFT(5118),
  [9826] = {.count = 1, .reusable = true}, SHIFT(5119),
  [9828] = {.count = 1, .reusable = false}, SHIFT(5121),
  [9830] = {.count = 1, .reusable = false}, SHIFT(5120),
  [9832] = {.count = 1, .reusable = true}, SHIFT(5125),
  [9834] = {.count = 1, .reusable = true}, SHIFT(5124),
  [9836] = {.count = 1, .reusable = false}, SHIFT(5127),
  [9838] = {.count = 1, .reusable = true}, SHIFT(5128),
  [9840] = {.count = 1, .reusable = true}, SHIFT(5130),
  [9842] = {.count = 1, .reusable = true}, SHIFT(5134),
  [9844] = {.count = 1, .reusable = true}, SHIFT(5135),
  [9846] = {.count = 1, .reusable = true}, SHIFT(5137),
  [9848] = {.count = 1, .reusable = true}, SHIFT(5139),
  [9850] = {.count = 1, .reusable = true}, SHIFT(5142),
  [9852] = {.count = 1, .reusable = true}, SHIFT(5146),
  [9854] = {.count = 1, .reusable = true}, SHIFT(5147),
  [9856] = {.count = 1, .reusable = true}, SHIFT(5148),
  [9858] = {.count = 1, .reusable = false}, SHIFT(5149),
  [9860] = {.count = 1, .reusable = true}, SHIFT(5149),
  [9862] = {.count = 1, .reusable = false}, SHIFT(5150),
  [9864] = {.count = 1, .reusable = true}, SHIFT(5150),
  [9866] = {.count = 1, .reusable = false}, SHIFT(5151),
  [9868] = {.count = 1, .reusable = true}, SHIFT(5151),
  [9870] = {.count = 1, .reusable = true}, SHIFT(5152),
  [9872] = {.count = 1, .reusable = true}, SHIFT(5153),
  [9874] = {.count = 1, .reusable = false}, SHIFT(5154),
  [9876] = {.count = 1, .reusable = true}, SHIFT(5154),
  [9878] = {.count = 1, .reusable = false}, SHIFT(5156),
  [9880] = {.count = 1, .reusable = true}, SHIFT(5156),
  [9882] = {.count = 1, .reusable = false}, SHIFT(5158),
  [9884] = {.count = 1, .reusable = true}, SHIFT(5158),
  [9886] = {.count = 1, .reusable = true}, SHIFT(5160),
  [9888] = {.count = 1, .reusable = true}, SHIFT(5161),
  [9890] = {.count = 1, .reusable = true}, SHIFT(5162),
  [9892] = {.count = 1, .reusable = true}, SHIFT(5163),
  [9894] = {.count = 1, .reusable = true}, SHIFT(5164),
  [9896] = {.count = 1, .reusable = false}, SHIFT(5165),
  [9898] = {.count = 1, .reusable = true}, SHIFT(5166),
  [9900] = {.count = 1, .reusable = true}, SHIFT(5167),
  [9902] = {.count = 1, .reusable = false}, SHIFT(5168),
  [9904] = {.count = 1, .reusable = true}, SHIFT(5169),
  [9906] = {.count = 1, .reusable = true}, SHIFT(5174),
  [9908] = {.count = 1, .reusable = true}, SHIFT(5175),
  [9910] = {.count = 1, .reusable = true}, SHIFT(5176),
  [9912] = {.count = 1, .reusable = true}, SHIFT(5179),
  [9914] = {.count = 1, .reusable = true}, SHIFT(5181),
  [9916] = {.count = 1, .reusable = true}, SHIFT(5185),
  [9918] = {.count = 1, .reusable = true}, SHIFT(5187),
  [9920] = {.count = 1, .reusable = false}, SHIFT(5191),
  [9922] = {.count = 1, .reusable = true}, SHIFT(5191),
  [9924] = {.count = 1, .reusable = false}, SHIFT(5192),
  [9926] = {.count = 1, .reusable = true}, SHIFT(5192),
  [9928] = {.count = 1, .reusable = false}, SHIFT(5193),
  [9930] = {.count = 1, .reusable = true}, SHIFT(5193),
  [9932] = {.count = 1, .reusable = true}, SHIFT(5194),
  [9934] = {.count = 1, .reusable = true}, SHIFT(5195),
  [9936] = {.count = 1, .reusable = true}, SHIFT(5196),
  [9938] = {.count = 1, .reusable = true}, SHIFT(5197),
  [9940] = {.count = 1, .reusable = true}, SHIFT(5198),
  [9942] = {.count = 1, .reusable = true}, SHIFT(5199),
  [9944] = {.count = 1, .reusable = false}, SHIFT(5201),
  [9946] = {.count = 1, .reusable = false}, SHIFT(5200),
  [9948] = {.count = 1, .reusable = true}, SHIFT(5205),
  [9950] = {.count = 1, .reusable = true}, SHIFT(5204),
  [9952] = {.count = 1, .reusable = false}, SHIFT(5207),
  [9954] = {.count = 1, .reusable = true}, SHIFT(5208),
  [9956] = {.count = 1, .reusable = true}, SHIFT(5210),
  [9958] = {.count = 1, .reusable = true}, SHIFT(5213),
  [9960] = {.count = 1, .reusable = true}, SHIFT(5215),
  [9962] = {.count = 1, .reusable = true}, SHIFT(5216),
  [9964] = {.count = 1, .reusable = true}, SHIFT(5217),
  [9966] = {.count = 1, .reusable = true}, SHIFT(5220),
  [9968] = {.count = 1, .reusable = true}, SHIFT(5222),
  [9970] = {.count = 1, .reusable = true}, SHIFT(5228),
};

void *tree_sitter_typescript_external_scanner_create();
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
  };
  return &language;
}
